   Subroutine vc_nl(nx,ny,nz,nfftx,nffty,nfftz,nspin,rhoxyz,Exc,univol,rinplw,vcnlxyz,ista,iend)

     use m_Crystal_Structure,  only : altv
     use m_Total_Energy,       only : m_TE_what_is_edeltb_now
     use m_Ionic_System,       only : natm2
     use m_IterationNumbers,   only : iteration

!$   use omp_lib

      Implicit None



!********************************* Note *******************************************
! This program calculates non-local exchange-correlation potential using the 
! van der Waals density functional (vdW-DF).
! The Algorism follows Thonhauser's self-consistent method.
!            (Reference; T.Thonhauser et al. PRB 76 (2007) 125112.)
! E_total = Ex_GGA + Ec_LDA + Ec_non-local
! v_total = vx_GGA + vc_LDA + vc_non-local
!
! Periodic systems are assumed.
! Only orthogonal corrdinates are applicable.
! Atomic unit (Hartree) is used.
!
!
!
! +++++++++++ Algorithm ++++++++++
!    ggaxcp0
! (m_XC_Potential.F90 in PHASE)
!
!      |
!      |
!      V 
!
!   vc_nl    --->   d_rho
!                  gauleg
!                 calPhi1  --->  d_q0
!                 calPhi2  --->  d_q0
!                 calPhi3  --->  d_q0
!                 calPhi4  --->  d_q0
!                    Phi1  --->  d_q0
!                    Phi2  --->  d_q0
!                    Phi3  --->  d_q0
!                    Phi4  --->  d_q0
!
!
!
! ++++++++ Input & Output ++++++++
! Input
!   rhoxyz(nx*ny*nz,nspin)  : Total density
!   nx,ny,nz                : Number of the grid points
!   nspin (dummy)           : Spin is not considered
!
! Output
!   vcnlxyz(nx*ny*nz,nspin) : Total Correlation potential
!     = vc(:,:,:) 
!     = vcnl + vcLDA
!         vcnl              : Non-local Correlation potential
!         vcLDA             : LDA Correlation potential
!
!
!
! ++++++ Internal parameters +++++
! Each internal parameter is set to restrict the error less than 10 meV.
!
! na(=nb) ( 30    )        : Gauss-Legendre integration is used.
! a2(=b2) ( 60    )        : Upper limit of the integral of dadb.
! etai    ( 1.3   )        : Radius of analytical integrating sphere (a.u.)
! eta1    ( 8     )        : Radius of numerical integrating sphere  (a.u.)
! eta2    ( 40    )        : Cutoff of asymptotic function     (unit cells)
! adj     ( 1     )        : Parameter to adjust error in Estimation Time
!
!
!
! ++++ Calculation procedure +++++
! 1. Calculate the coefficients of the asymptotic function.
!
! 2. Call d_rho and calculate differential of total density.
!     --- 7 points formula is used for differentiation.
!
! 3. Call Phi1 to Phi4 (and calPhi1 to calPhi4) to calculate
!             the functional derivative of the core function.
!
! 4. Calculate the local correlation potentail using LDA.
!
! 5. Output total correlation potential.
!     --- vcnlxyz = vc = vcnl + vcLDA
!
!
!
!                                              Written by Youky Ono 
!**********************************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  nx,ny,nz,nfftx,nffty,nfftz,nspin,nrxyz,iterstart
      Integer  ista,iend
      Real(8) da,db,a1,a2,ax,ay,az,rxyz,edel,sedel
      Integer  ci,cj,ck,ca,cb,na,nb,cD
      Parameter (sedel=1.e-4,iterstart=12)
      Parameter (na=30,a1=0,a2=60)

! Gauss-Legendre integration
      Real(8) xi(na),wi(na)

      Integer ndel,cdel,nphiD,cphiD,maxnphiD
      Real(8) ddel,del,phiD,phix,phiy,mphiD,maxD,minD,maxDii,minDii
      Parameter (ndel=20,nphiD=200,maxD=10,minD=0.1)
      Real(8), Allocatable :: &
&             phi1dD(:,:),phi2dD(:,:),phi3dD(:,:),phi4dD(:,:)

      Integer  cir,cix,ciy,ciz&
&             ,cjr,cjx,cjy,cjz&
&             ,ckr,ckx,cky,ckz&
&             ,cr ,cx ,cy ,cz,lcx,hcx,lcy,hcy,lcz,hcz
      Integer  c1x,c1y,c1z,c4x,c4y,c4z

      Real(8)  di,dj,dk,dx,dy,dz,dv,n,ni,nj,nk
      Integer  i,j,k,zxp,zxm,zyp,zym,zzp,zzm,tx,ty,tz

!!$      Real(8)  eta,etai,eta1,eta2
      Real(8)  eta,etai,eta1
      Integer eta2
      Parameter (eta=0.0000000001,etai=1.3,eta1=8,eta2=20)

      Real(8), Allocatable ::  C6(:,:,:)
      Real(8), Allocatable ::  dxrho(:,:,:), d2xrho(:,:,:) &
&                            , dyrho(:,:,:), d2yrho(:,:,:) &
&                            , dzrho(:,:,:), d2zrho(:,:,:) &
&                            , dxyrho(:,:,:),dxzrho(:,:,:),dyzrho(:,:,:)

      Real(8) rs,x,nnx,nny,nnz,nn2,r,zo
      Real(8) nxp,nxm,nyp,nym,nzp,nzm

      Real(8) rhoxyz(nfftx*nffty*nfftz,nspin),vcnlxyz(nfftx*nffty*nfftz,nspin)

      Real(8), Allocatable ::  rho(:,:,:) &
&               ,vcnl(:,:,:),vc(:,:,:),vcLDA(:,:,:)
      Real(8) Exc,univol,rinplw,Ecnl,Ecnl1,Ecnl2,Ecnl3,Ecl,rhomin
      Parameter (rhomin=1.e-6)

      Real(8)  kF,ecLDA,ecLDAd,pi,Zab,wp,wq,q,m,h,e,GxcLDA
      Real(8)  gamma,a,b,C,d,q0,q0i,q0k
      Real(8)  v1,v2,v3,v4
      Parameter (pi=3.1415926535897932)
      Parameter (e=1.0,m=1.0)
      Parameter (Zab=-0.8491)

      Real(8) T,W,phi,psi
      Real(8) naPhi1,naPhi2,naPhi3,naPhi4
      Real(8) n2nx,n2ny,n2nz,term1,term2,term3,term4,ns,excLDA,&
&      exLDAd,excLDAd,exc0,alfa1,alfa2,alfa3,alfa4,vcik,vcik1, &
&      vcik2,vcik3,q0dx,q0dy,q0dz,LD1,LD2,vii,vcii,v1d,v1dd,v2d,v2dd,&
&      v3d,v4d,Tv1,Tv2,Tv11,Tv22,Tv12,Tv13,Tv14,Tv23,Tv24,Td,  &
&      Tdd,Tddk,iv12,iv13,iv14,iv23,iv24,iv34

! Estimate running time
      Real(8) time
      Integer hh,mm,ss

!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------

      Allocate(C6(0:nx-1,0:ny-1,0:nz-1))
      Allocate(dxrho(nx,ny,nz))
      Allocate(d2xrho(nx,ny,nz))
      Allocate(dyrho(nx,ny,nz))
      Allocate(d2yrho(nx,ny,nz))
      Allocate(dzrho(nx,ny,nz))
      Allocate(d2zrho(nx,ny,nz))
      Allocate(dxyrho(nx,ny,nz))
      Allocate(dxzrho(nx,ny,nz))
      Allocate(dyzrho(nx,ny,nz))
      Allocate(rho(nx,ny,nz))
      Allocate(vcnl(nx,ny,nz))
      Allocate(vc(nx,ny,nz))
      Allocate(vcLDA(nx,ny,nz))

      Do cix = 1,nx
      Do ciy = 1,ny
      Do ciz = 1,nz
         vcnl(cix,ciy,ciz)=0
         vcLDA(cix,ciy,ciz)=0
         vc(cix,ciy,ciz)=0
         C6(0:cix-1,0:ciy-1,0:ciz-1)=0
         dxrho(cix,ciy,ciz)=0
         dyrho(cix,ciy,ciz)=0
         dzrho(cix,ciy,ciz)=0
         d2xrho(cix,ciy,ciz)=0
         d2yrho(cix,ciy,ciz)=0
         d2zrho(cix,ciy,ciz)=0
         dxyrho(cix,ciy,ciz)=0
         dxzrho(cix,ciy,ciz)=0
         dyzrho(cix,ciy,ciz)=0

      End Do
      End Do
      End Do
      rho=0
      vcnlxyz=0
      da=0
      nb = na
      db = da

      dx = altv(1,1)/Real(nx)
      dy = altv(2,2)/Real(ny)
      dz = altv(3,3)/Real(nz)
      dv = dx*dy*dz

      Do cix = 1,nx
      Do ciy = 1,ny
      Do ciz = 1,nz
         nrxyz=(ciz-1)*nffty*(nfftx)+(ciy-1)*(nfftx)+cix
         !!if(nrxyz<ista .or. nrxyz>iend) cycle
         rho(cix,ciy,ciz) = rhoxyz(nrxyz,1)
      End Do
      End Do
      End Do


!++++  Calculate the coefficients of the asymptotic function. ++++
      ax = dx*nx
      ay = dy*ny
      az = dz*nz

      Do cix = 1,nx
      Do ciy = 1,ny
      Do ciz = 1,nz
         C6(cix-1,ciy-1,ciz-1) = 0
      End Do
      End Do
      End Do

      Do ckx = 0,nx-1
      Do cky = 0,ny-1
      Do ckz = 0,nz-1
         Do tx=-1*eta2,eta2
         Do ty=-1*eta2,eta2
         Do tz=-1*eta2,eta2

            rxyz= &
&  ((ckx*dx+tx*ax)**2 + (cky*dy+ty*ay)**2 + (ckz*dz+tz*az)**2)**0.5

         If(rxyz.GT.eta1) Then
            C6(ckx,cky,ckz) = C6(ckx,cky,ckz) + (rxyz**(-6))
         End If

         End Do
         End Do
         End Do
      End Do
      End Do
      End Do
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


!########  Call d_rho and obtain differential of the rho #########
   Call d_rho(nx,ny,nz,dx,dy,dz,rho,dxrho,dyrho,dzrho&
&              ,d2xrho,d2yrho,d2zrho,dxyrho,dxzrho,dyzrho)
!#################################################################


!############## Call gauleg for Gauss-Legendre integral ##########
      Call gauleg(a1,a2,na,xi,wi)
!#################################################################


      Allocate(phi1dD(-ndel:ndel,-1:nphiD+1))
      Allocate(phi2dD(-ndel:ndel,-1:nphiD+1))
      Allocate(phi3dD(-ndel:ndel,-1:nphiD+1))
      Allocate(phi4dD(-ndel:ndel,-1:nphiD+1))

      Do cdel = -ndel,ndel
      Do cphiD = -1,nphiD+1
         phi1dD(cdel,cphiD) = 0
         phi2dD(cdel,cphiD) = 0
         phi3dD(cdel,cphiD) = 0
         phi4dD(cdel,cphiD) = 0
      End Do
      End Do

!######################  Call Phi1 to Phi4  ######################
  If(iteration.GE.1.AND.iteration.LT.iterstart) Then
  Else
   Call calPhi1(maxD,minD,etai,eta1,na,xi,wi,ndel,nphiD,phi1dD)
   Call calPhi2(maxD,minD,etai,eta1,na,xi,wi,ndel,nphiD,phi2dD)
   Call calPhi3(maxD,minD,etai,eta1,na,xi,wi,ndel,nphiD,phi3dD)
  End If
   Call calPhi4(maxD,minD,etai,eta1,na,xi,wi,ndel,nphiD,phi4dD)
!#################################################################

      Call CPU_TIME(time)
      ss=time
      hh=time/3600
      ss=Mod(ss,3600)
      mm=ss/60
      ss=Mod(ss,60)
      time=time-3600*hh-60*mm-ss

      Ecnl  = 0
!!!!!!!!!!!!!!!!! Hot Spot !!!!!!!!!!!!!!
!$OMP  PARALLEL DO &
!$OMP& DEFAULT(SHARED) &
!$OMP& PRIVATE(cix,ciy,ciz,ni,nb,db,gamma,dv,kF,rs,x,  &
!$OMP&  nnx,nny,nnz,nn2,n2nx,n2ny,n2nz,term1,term2,term3,term4,  &
!$OMP&  ns,exLDAd,ecLDAd,excLDAd,lcx,hcx,&
!$OMP&  lcy,hcy,lcz,hcz,ckx,cky,ckz,r,nk,di,dk,vcik,vcik1,vcik2, &
!$OMP&  cD,C,psi,maxDii,minDii,q0,q0i,q0k,q0dx,q0dy,q0dz,LD1,LD2,vii,vcii,alfa1,alfa2,alfa3,alfa4,  &
!$OMP&  a,b,h,v1,v1d,v1dd,v2,v2d,v2dd,v3,v3d,v4,naPhi1,naPhi2,naPhi3,naPhi4,   &
!$OMP&  v4d,W,Tv1,Tv2,Tv11,Tv22,Tv12,Tv13,Tv14,Tv23,Tv24,Td,Tdd, &
!$OMP&  Tddk,iv12,iv13,iv14,iv23,iv24,iv34,GxcLDA,excLDA,exc0,   &
!$OMP&  ddel,del,cdel,phiD,cphiD,phix,phiy,phi) &
!$OMP&  REDUCTION(+:Ecnl)
      Do cir = 1,nx*ny*nz
         cix = 1+(cir-MOD(cir-1+ny*nz,ny*nz)+1)/(ny*nz)
         ciy = 1+(cir-ny*nz*(cix-1)-(MOD(cir-1+nz,nz)+1))/nz
         ciz = (cir-ny*nz*(cix-1)-nz*(ciy-1))
         nrxyz=(ciz-1)*nffty*(nfftx)+(ciy-1)*(nfftx)+cix
         if(nrxyz<ista .or. nrxyz>iend) cycle

         naPhi1 = 0
         naPhi2 = 0
         naPhi3 = 0
         naPhi4 = 0

         ni = rho(cix,ciy,ciz)
         If(ni.GT.rhomin) Then

!######################  Call Phi1 to Phi4  ######################

   If(iteration.GE.0.AND.iteration.LT.iterstart) Then
   Else

   Call Phi1(maxD,minD,etai,eta1,na,xi,wi,nx,ny,nz,dx,dy,dz,rho,cix,ciy      &
&            ,ciz,dxrho,dyrho,dzrho,d2xrho,d2yrho,d2zrho,C6,ndel,nphiD,phi1dD,naPhi1)
   Call Phi2(maxD,minD,etai,eta1,na,xi,wi,nx,ny,nz,dx,dy,dz,rho,cix,ciy,ciz  &
&             ,dxrho,dyrho,dzrho,d2xrho,d2yrho,d2zrho                        &
&             ,dxyrho,dxzrho,dyzrho,C6,ndel,nphiD,phi2dD,naPhi2)
   Call Phi3(maxD,minD,etai,eta1,na,xi,wi,nx,ny,nz,dx,dy,dz,rho,cix,ciy,ciz  &
&             ,dxrho,dyrho,dzrho,d2xrho,d2yrho,d2zrho,C6,ndel,nphiD,phi3dD,naPhi3)
   End If

   If(iteration.GE.0.AND.iteration.LT.8) Then
   Else
   Call Phi4(maxD,minD,etai,eta1,na,xi,wi,nx,ny,nz,dx,dy,dz,rho,cix,ciy,ciz  &
&             ,dxrho,dyrho,dzrho,d2xrho,d2yrho,d2zrho,C6,ndel,nphiD,phi4dD,naPhi4)
   End If
!#################################################################

         vcnl(cix,ciy,ciz)= &
&           naPhi1 + naPhi2 + naPhi3 + naPhi4

         Ecnl = Ecnl + 0.5*ni*naPhi4

         End If
      End Do
!$OMP END PARALLEL DO
!!!!!!!!!!!!! End Hot Spot !!!!!!!!!!!!!!
      Ecnl = dv*Ecnl

      Call CPU_TIME(time)
      ss=time
      hh=time/3600
      ss=Mod(ss,3600)
      mm=ss/60
      ss=Mod(ss,60)
      time=time-3600*hh-60*mm-ss


!++++++++++++++++++++++  Calculate vcLDA  ++++++++++++++++++++++++
      Ecl = 0
      Do cjx = 1,nx
      Do cjy = 1,ny
      Do cjz = 1,nz
         nrxyz=(cjz-1)*nffty*(nfftx)+(cjy-1)*(nfftx)+cjx
         if(nrxyz<ista .or. nrxyz>iend) cycle

         nj = rho(cjx,cjy,cjz)

       If(nj.GT.rhomin) then

         rs = (3/(4*pi*nj))**0.3333333333333333
         x = rs/11.4

         term1 = (36*pi*(nj**4))**0.33333333333333333
         ecLDAd = -0.0333*(3*x*x*Log(1+1/x)-3*x+1.5-1/x)/(11.4*term1)

         GxcLDA = 0.5*((1+x**3)*Log(1+1/x)-x**2+x/2-1/3)
         ecLDA = -0.0666*GxcLDA

         vcLDA(cjx,cjy,cjz) = ecLDAd*nj + ecLDA
         Ecl = Ecl + dv*nj*ecLDA

       End If

      End Do
      End Do
      End Do
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      Exc = Exc + (Ecnl + Ecl)/(univol*rinplw)

      Do cix = 1,nx
      Do ciy = 1,ny
      Do ciz = 1,nz
         nrxyz = (ciz-1)*nffty*nfftx+(ciy-1)*nfftx+cix
         if(nrxyz<ista .or. nrxyz>iend) cycle
         vc(cix,ciy,ciz) = vcnl(cix,ciy,ciz) + vcLDA(cix,ciy,ciz)
         !vcnlxyz(nrxyz,1) = vcnlxyz(nrxyz,1) + vc(cix,ciy,ciz)
         vcnlxyz(nrxyz,1) = vc(cix,ciy,ciz)
      End Do
      End Do
      End Do


      Deallocate(C6)
      Deallocate(dxrho)
      Deallocate(d2xrho)
      Deallocate(dyrho)
      Deallocate(d2yrho)
      Deallocate(dzrho)
      Deallocate(d2zrho)
      Deallocate(dxyrho)
      Deallocate(dxzrho)
      Deallocate(dyzrho)
      Deallocate(rho)
      Deallocate(vcnl)
      Deallocate(vc)
      Deallocate(vcLDA)
      Deallocate(phi1dD)
      Deallocate(phi2dD)
      Deallocate(phi3dD)
      Deallocate(phi4dD)



   End Subroutine vc_nl



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
 
 
!** SUBROUTINE CPU_TIME ************************
      Subroutine CPU_TIME(time)
      Real(8) time
      Integer count,count_rate,hh,mm,ss
 
      Call System_clock(count,count_rate)
      If(count_rate.Eq.0) Then
         time=Real(count)/count_rate
      Else
         time=-1
      End If
 
      End Subroutine CPU_TIME
!** End SUBROUTINE CPU_TIME ********************





   Subroutine d_rho(nx,ny,nz,dx,dy,dz,rho,dxrho,dyrho,dzrho,d2xrho,d2yrho,d2zrho&
&                      ,dxyrho,dxzrho,dyzrho)
!$   use omp_lib
      Implicit None


!************************ Note *********************************
! This Algorism calculates the differential of the rho.
!
! Input
!   nx,ny,nz,dx,dy,dz,rho       : Information of the unit cell 
!                                 and the electron density.
!
! Output
!   drho,d2rho                  : 1st and 2nd order differential
!                                 of the rho.     
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  nx,ny,nz,cjx,cjy,cjz,i,j,k
      Real(8)  dx,dy,dz,nspin,dv,nj

      Real(8)  ::  rn(3,-3:3),rx(3,-3:3),ry(3,-3:3),rz(3,-3:3)
      Integer  ::  zx(-3:3),zy(-3:3),zz(-3:3)

      Real(8)  nxp,nxm,nyp,nym,nzp,nzm &
&             ,nxpyp,nxpym,nxmyp,nxmym &
&             ,nxpzp,nxpzm,nxmzp,nxmzm &
&             ,nypzp,nypzm,nymzp,nymzm 

      Real(8) :: rho(nx,ny,nz),dxrho(nx,ny,nz),d2xrho(nx,ny,nz) &
&                             ,dyrho(nx,ny,nz),d2yrho(nx,ny,nz) &
&                             ,dzrho(nx,ny,nz),d2zrho(nx,ny,nz) &
&           ,dxyrho(nx,ny,nz),dxzrho(nx,ny,nz),dyzrho(nx,ny,nz)
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      Do cjx = 1,nx
      Do cjy = 1,ny
      Do cjz = 1,nz

         Do j = -3,3
            zx(j) = MOD(2*nx+(cjx+j)-1,nx)+1
            zy(j) = MOD(2*ny+(cjy+j)-1,ny)+1
            zz(j) = MOD(2*nz+(cjz+j)-1,nz)+1

            rn(1,j) = rho(zx(j),cjy,cjz)
            rn(2,j) = rho(cjx,zy(j),cjz)
            rn(3,j) = rho(cjx,cjy,zz(j))
         End Do

         dxrho(cjx,cjy,cjz) = &
&           (rn(1,3)-9*rn(1,2)+45*rn(1,1)-45*rn(1,-1)+9*rn(1,-2)-rn(1,-3))/(60*dx)
         dyrho(cjx,cjy,cjz) = &
&           (rn(2,3)-9*rn(2,2)+45*rn(2,1)-45*rn(2,-1)+9*rn(2,-2)-rn(2,-3))/(60*dy)
         dzrho(cjx,cjy,cjz) = &
&           (rn(3,3)-9*rn(3,2)+45*rn(3,1)-45*rn(3,-1)+9*rn(3,-2)-rn(3,-3))/(60*dz)

      End Do
      End Do
      End Do



      Do cjx = 1,nx
      Do cjy = 1,ny
      Do cjz = 1,nz

         Do j = -3,3
            zx(j) = MOD(2*nx+(cjx+j)-1,nx)+1
            zy(j) = MOD(2*ny+(cjy+j)-1,ny)+1
            zz(j) = MOD(2*nz+(cjz+j)-1,nz)+1

            rn(1,j)  =  rho(zx(j),cjy,cjz)
            rn(2,j)  =  rho(cjx,zy(j),cjz)
            rn(3,j)  =  rho(cjx,cjy,zz(j))

            rx(1,j) = dxrho(zx(j),cjy,cjz)
            rx(2,j) = dxrho(cjx,zy(j),cjz)
            rx(3,j) = dxrho(cjx,cjy,zz(j))

            ry(1,j) = dyrho(zx(j),cjy,cjz)
            ry(2,j) = dyrho(cjx,zy(j),cjz)
            ry(3,j) = dyrho(cjx,cjy,zz(j))

            rz(1,j) = dzrho(zx(j),cjy,cjz)
            rz(2,j) = dzrho(cjx,zy(j),cjz)
            rz(3,j) = dzrho(cjx,cjy,zz(j))
         End Do

         d2xrho(cjx,cjy,cjz) = &
&           (rx(1,3)-9*rx(1,2)+45*rx(1,1)-45*rx(1,-1)+9*rx(1,-2)-rx(1,-3))/(60*dx)
         d2yrho(cjx,cjy,cjz) = &
&           (ry(2,3)-9*ry(2,2)+45*ry(2,1)-45*ry(2,-1)+9*ry(2,-2)-ry(2,-3))/(60*dy)
         d2zrho(cjx,cjy,cjz) = &
&           (rz(3,3)-9*rz(3,2)+45*rz(3,1)-45*rz(3,-1)+9*rz(3,-2)-rz(3,-3))/(60*dz)

         dxyrho(cjx,cjy,cjz) = &
&           (ry(1,3)-9*ry(1,2)+45*ry(1,1)-45*ry(1,-1)+9*ry(1,-2)-ry(1,-3))/(60*dx)
         dyzrho(cjx,cjy,cjz) = &
&           (rz(2,3)-9*rz(2,2)+45*rz(2,1)-45*rz(2,-1)+9*rz(2,-2)-rz(2,-3))/(60*dy)
         dxzrho(cjx,cjy,cjz) = &
&           (rx(3,3)-9*rx(3,2)+45*rx(3,1)-45*rx(3,-1)+9*rx(3,-2)-rx(3,-3))/(60*dz)

      End Do
      End Do
      End Do



   End Subroutine d_rho



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



   Subroutine gauleg(x1,x2,n,xi,wi)
!$   use omp_lib
      Implicit none

!************************ Note *********************************
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  m,j,i,n
      Real(8)  x1,x2,z1,z,xm,xl,pp,p3,p2,p1,pi,eta
      Parameter (pi=3.1415926535897932 , eta=0.0000000001)

      Real(8)  ::  xi(n),wi(n)
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      m=(n+1)/2
      xm=0.5*(x2+x1)
      xl=0.5*(x2-x1)
      z1=0.d0
      Do i=1,m
         z=COS(pi*(i-0.25)/(n+0.5))

         Do While (ABS(z-z1).GT.eta)
            p1=1.0
            p2=0.0

            Do j=1,n
               p3=p2
               P2=p1
               p1=((2.0*j-1.0)*z*p2-(j-1.0)*p3)/j
            End Do

            pp=n*(z*p1-p2)/(z*z-1.0)
            z1=z
            z=z1-p1/pp
            
         End Do

         xi(i) = xm-xl*z
         xi(n+1-i) = xm+xl*z
         wi(i) = 2.0*xl/((1.0-z*z)*pp*pp)
         wi(n+1-i) = wi(i)

      End Do


! End of Subroutine gauleg
   End Subroutine gauleg



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



   Subroutine calPhi1(maxD,minD,etai,eta1,na,xi,wi,ndel,nphiD,phi1dD)
!$   use omp_lib
      Implicit None


!************************ Note *********************************
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  ci,cj,ck,ca,cb,na,nb

! Gauss-Legendre integration
      Real(8) xi(na),wi(na)

      Real(8) ddel,dphiD,del,phiD,tmp,phix,phiy,maxD,minD,etai,eta1
      Integer ndel,cdel,nphiD,cphiD,cdelD
      Real(8) phi1dD(-ndel:ndel,-1:nphiD+1)

      Integer  cir,cix,ciy,ciz&
&             ,cjr,cjx,cjy,cjz&
&             ,ckr,ckx,cky,ckz&
&             ,cr ,cx ,cy ,cz,lcx,hcx,lcy,hcy,lcz,hcz
      Real(8)  di,dj,dk,dx,dy,dz,dv,n,ni,nj,nk,r
      Integer  i,j,k

      Real(8)  eta
      Parameter (eta=0.0000000001)

      Real(8)  kF,excLDAd,exLDAd,ecLDAd,pi,Zab,wp,wq,q,m,h,e
      Real(8)  gamma,a,b,C,d
      Real(8)  v1,v2,v3,v4,v1d,v2d
      Parameter (pi=3.1415926535897932)
      Parameter (e=1,m=1)
      Parameter (Zab=-0.8491)

      Real(8) T,W,phi,psi,Tv1,Tv2
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      gamma = 4*pi/9

! phi(del,phiD)
      ddel = 1/Real(ndel+1)
      dphiD = (maxD-minD)/(Real(nphiD))


!$OMP  PARALLEL DO &
!$OMP& DEFAULT(SHARED) &
!$OMP& PRIVATE(cdel,cphiD,del,phiD,di,dk,phi,ca,cb,a,b,  &
!$OMP&  h,v1,v1d,v2,v2d,v3,v4,W,Tv1,Tv2)

   Do cdel = -ndel,ndel
   Do cphiD = -1,nphiD+1

      del = Real(cdel)*ddel
      phiD = minD + Real(cphiD)*dphiD
      
      di = phiD*(1+del)
      dk = phiD*(1-del)

      phi = 0
      Do ca=1,na
      Do cb=1,na
         a = xi(ca)
         b = xi(cb)

         h = 1-Exp(-gamma*((a/di)**2)) 
         v1 = (a**2)/(2*h)
         v1d = -4*pi*(a**4)*(h-1)/(9*(di**3)*(h**2))

         h = 1-Exp(-gamma*((b/di)**2)) 
         v2 = (b**2)/(2*h)
         v2d = -4*pi*(b**4)*(h-1)/(9*(di**3)*(h**2))

         h = 1-Exp(-gamma*((a/dk)**2)) 
         v3 = (a**2)/(2*h)

         h = 1-Exp(-gamma*((b/dk)**2)) 
         v4 = (b**2)/(2*h)

         W = 2*((3-a*a)*b*Cos(b)*Sin(a) + (3-b*b)*a*Cos(a)*Sin(b)           &
&            + (a*a+b*b-3)*Sin(a)*Sin(b)                                    &
&            -3*a*b*Cos(a)*Cos(b))/((a*b)**3)

         Tv1 = ((1/((v1+v2)**2))*(1/((v1+v3)*(v2+v4))+1/((v1+v4)*(v2+v3)))  &
&              +(1/(v1+v2)+1/(v3+v4))                                       &
&              *(1/(((v1+v3)**2)*(v2+v4))+1/(((v1+v4)**2)*(v2+v3))))*(-0.5)

         Tv2 = ((1/((v1+v2)**2))*(1/((v1+v3)*(v2+v4))+1/((v1+v4)*(v2+v3)))  &
&              +(1/(v1+v2)+1/(v3+v4))                                       &
&              *(1/((v1+v3)*((v2+v4)**2))+1/((v1+v4)*((v2+v3)**2))))*(-0.5)

         phi = phi + &
&              wi(ca)*wi(cb)*((a*b)**2)*W*(Tv1*v1d+Tv2*v2d)

      End Do
      End Do

      phi = phi * 2*m*(e**4)/(pi**2)

      phi1dD(cdel,cphiD) = phi

   End Do
   End Do
!$OMP END PARALLEL DO

   End Subroutine calPhi1



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



   Subroutine calPhi2(maxD,minD,etai,eta1,na,xi,wi,ndel,nphiD,phi2dD)
!$   use omp_lib
      Implicit None


!************************ Note *********************************
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  ci,cj,ck,ca,cb,na,nb

! Gauss-Legendre integration
      Real(8) xi(na),wi(na)

      Real(8) ddel,dphiD,del,phiD,tmp,phix,phiy,maxD,minD,etai,eta1
      Integer ndel,cdel,nphiD,cphiD,cdelD
      Real(8) phi2dD(-ndel:ndel,-1:nphiD+1)

      Integer  cir,cix,ciy,ciz&
&             ,cjr,cjx,cjy,cjz&
&             ,ckr,ckx,cky,ckz&
&             ,cr ,cx ,cy ,cz,lcx,hcx,lcy,hcy,lcz,hcz
      Real(8)  di,dj,dk,dx,dy,dz,dv,n,ni,nj,nk,r
      Integer  i,j,k

      Real(8)  eta
      Parameter (eta=0.0000000001)

      Real(8)  kF,excLDAd,exLDAd,ecLDAd,pi,Zab,wp,wq,q,m,h,e
      Real(8)  gamma,a,b,C,d
      Parameter (pi=3.1415926535897932)
      Parameter (e=1.0,m=1.0)
      Parameter (Zab=-0.8491)

      Real(8) T,W,phi,psi,vcik,vcik1,vcik2,vcii,vii
      Real(8) Tv1,Tv2,Tv11,Tv22,Tv12,Tv13,Tv14,Tv23,Tv24,Tdd
      Real(8) v1,v2,v3,v4,v1d,v2d,v3d,v4d,v1dd,v2dd

      Real(8) term1,term2,term3,term4,ns
      Real(8) iv12,iv13,iv14,iv23,iv24,iv34
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      gamma = 4*pi/9

! phi(del,phiD)
      ddel = 1/Real(ndel+1)
      dphiD = (maxD-minD)/(Real(nphiD))


!$OMP  PARALLEL DO &
!$OMP& DEFAULT(SHARED) &
!$OMP& PRIVATE(cdel,cphiD,del,phiD,di,dk,phi,ca,cb,a,b,  &
!$OMP&  h,v1,v1d,v1dd,v2,v2d,v2dd,v3,v4,W,               &
!$OMP&  iv12,iv13,iv14,iv23,iv24,iv34,Tv1,Tv2,Tv11,Tv22,Tv12,Tdd)

   Do cdel = -ndel,ndel
   Do cphiD = -1,nphiD+1

      del = Real(cdel)*ddel
      phiD = minD + Real(cphiD)*dphiD
      
      di = phiD*(1+del)
      dk = phiD*(1-del)

      phi = 0
      Do ca=1,na
      Do cb=1,na
         a = xi(ca)
         b = xi(cb)

         h = 1-Exp(-gamma*((a/di)**2)) 
         v1 = (a**2)/(2*h)
         v1d = -4*pi*(a**4)*(h-1)/(9*(di**3)*(h**2))
         v1dd = 2*((4*pi*(a**3)/(9*(di**3)))**2)*(1-h)*(2-3*h)/(h**3)

         h = 1-Exp(-gamma*((b/di)**2)) 
         v2 = (b**2)/(2*h)
         v2d = -4*pi*(b**4)*(h-1)/(9*(di**3)*(h**2))
         v2dd = 2*((4*pi*(b**3)/(9*(di**3)))**2)*(1-h)*(2-3*h)/(h**3)

         h = 1-Exp(-gamma*((a/dk)**2)) 
         v3 = (a**2)/(2*h)

         h = 1-Exp(-gamma*((b/dk)**2)) 
         v4 = (b**2)/(2*h)

         W = 2*((3-a*a)*b*Cos(b)*Sin(a) + (3-b*b)*a*Cos(a)*Sin(b)           &
&            + (a*a+b*b-3)*Sin(a)*Sin(b)                                    &
&            -3*a*b*Cos(a)*Cos(b))/((a*b)**3)


         iv12 = 1/(v1+v2)
         iv13 = 1/(v1+v3)
         iv14 = 1/(v1+v4)
         iv23 = 1/(v2+v3)
         iv24 = 1/(v2+v4)
         iv34 = 1/(v3+v4)


         Tv1 = -(1/2)*(iv12**2)*(iv13*iv24+iv14*iv23)              &
&              -(1/2)*(iv12+iv34)*(iv13**2*iv24+iv14**2*iv23)


         Tv2 = -(1/2)*(iv12**2)*(iv13*iv24+iv14*iv23)              &
&              -(1/2)*(iv12+iv34)*(iv13*iv24**2+iv14*iv23**2)


         Tv11 = iv12**3*(iv13*iv24+iv14*iv23)                      &
&              +iv12**2*(iv13**2*iv24+iv14**2*iv23)                &
&              +(iv12+iv34)*(iv13**3*iv24+iv14**3*iv23)


         Tv22 = iv12**3*(iv13*iv24+iv14*iv23)                      &
&              +iv12**2*(iv13*iv24**2+iv14*iv23**2)                &
&              +(iv12+iv34)*(iv13*iv24**3+iv14*iv23**3)


         Tv12 = iv12**3*(iv13*iv24+iv14*iv23)                      &
&              +(1/2)*iv12**2*(iv13*iv24**2+iv14*iv23**2)          &
&              +(1/2)*iv12**2*(iv13**2*iv24+iv14**2*iv23)          &
&              +(iv12+iv34)*(iv13**2*iv24**2+iv14**2*iv23**2)


      Tdd = Tv11*v1d**2 + Tv1*v1dd + Tv22*v2d**2 + Tv2*v2dd + 2*Tv12*v1d*v2d


         phi = phi + &
&              wi(ca)*wi(cb)*((a*b)**2)*W*Tdd

      End Do
      End Do

      phi = phi * 2*m*(e**4)/(pi**2)

      phi2dD(cdel,cphiD) = phi

   End Do
   End Do
!$OMP END PARALLEL DO

   End Subroutine calPhi2



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



   Subroutine calPhi3(maxD,minD,etai,eta1,na,xi,wi,ndel,nphiD,phi3dD)
!$   use omp_lib
      Implicit None

!************************ Note *********************************
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  ci,cj,ck,ca,cb,na,nb

! Gauss-Legendre integration
      Real(8) xi(na),wi(na)

      Real(8) ddel,dphiD,del,phiD,tmp,phix,phiy,maxD,minD,etai,eta1
      Integer ndel,cdel,nphiD,cphiD,cdelD
      Real(8) phi3dD(-ndel:ndel,-1:nphiD+1)

      Integer  cir,cix,ciy,ciz&
&             ,cjr,cjx,cjy,cjz&
&             ,ckr,ckx,cky,ckz&
&             ,cr ,cx ,cy ,cz,lcx,hcx,lcy,hcy,lcz,hcz
      Real(8)  di,dj,dk,dx,dy,dz,dv,n,ni,nj,nk,r
      Integer  i,j,k

      Real(8)  eta
      Parameter (eta=0.0000000001)

      Real(8)  kF,excLDAd,exLDAd,ecLDAd,pi,Zab,wp,wq,q,m,h,e
      Real(8)  gamma,a,b,C,d
      Parameter (pi=3.1415926535897932)
      Parameter (e=1,m=1)
      Parameter (Zab=-0.8491)

      Real(8) T,W,phi,psi,vcik,vcik1,vcik2,vcii,vii
      Real(8) Tv1,Tv2,Tv11,Tv22,Tv12,Tv13,Tv14,Tv23,Tv24,Td,Tdd,Tddk
      Real(8) v1,v2,v3,v4,v1d,v2d,v3d,v4d,v1dd,v2dd

      Real(8) naPhi3,alfa3,term1,term2,term3,term4,ns
      Real(8) iv12,iv13,iv14,iv23,iv24,iv34
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      gamma = 4*pi/9

! phi(del,phiD)
      ddel = 1/Real(ndel+1)
      dphiD = (maxD-minD)/(Real(nphiD))


!$OMP  PARALLEL DO &
!$OMP& DEFAULT(SHARED) &
!$OMP& PRIVATE(cdel,cphiD,del,phiD,di,dk,phi,ca,cb,a,b,  &
!$OMP&  h,v1,v1d,v2,v2d,v3,v3d,v4,v4d,iv12,iv13,iv14,    &
!$OMP&  iv23,iv24,iv34,W,Tv1,Tv2,Tv11,Tv22,Tv12,Tv13,Tv14,Tv23,Tv24,Td,Tdd,Tddk)

   Do cdel = -ndel,ndel
   Do cphiD = -1,nphiD+1

      del = Real(cdel)*ddel
      phiD = minD + Real(cphiD)*dphiD

      di = phiD*(1+del)
      dk = phiD*(1-del)

      phi = 0
      Do ca=1,na
      Do cb=1,na
         a = xi(ca)
         b = xi(cb)

         h = 1-Exp(-gamma*((a/di)**2)) + eta
         v1 = (a**2)/(2*h)
         v1d = -4*pi*(a**4)*(h-1)/(9*(di**3)*(h**2))
         v1dd = 2*((4*pi*(a**3)/(9*(di**3)))**2)*(1-h)*(2-3*h)/(h**3)

         h = 1-Exp(-gamma*((b/di)**2)) + eta
         v2 = (b**2)/(2*h)
         v2d = -4*pi*(b**4)*(h-1)/(9*(di**3)*(h**2))
         v2dd = 2*((4*pi*(b**3)/(9*(di**3)))**2)*(1-h)*(2-3*h)/(h**3)

         h = 1-Exp(-gamma*((a/dk)**2)) + eta
         v3 = (a**2)/(2*h)
         v3d = -4*pi*(a**4)*(h-1)/(9*(di**3)*(h**2))

         h = 1-Exp(-gamma*((b/dk)**2)) + eta
         v4 = (b**2)/(2*h)
         v4d = -4*pi*(b**4)*(h-1)/(9*(di**3)*(h**2))

         W = 2*((3-a*a)*b*Cos(b)*Sin(a) + (3-b*b)*a*Cos(a)*Sin(b)           &
&            + (a*a+b*b-3)*Sin(a)*Sin(b)                                    &
&            -3*a*b*Cos(a)*Cos(b))/((a*b)**3)

         iv12 = 1/(v1+v2)
         iv13 = 1/(v1+v3)
         iv14 = 1/(v1+v4)
         iv23 = 1/(v2+v3)
         iv24 = 1/(v2+v4)
         iv34 = 1/(v3+v4)


         Tv1 = -(1/2)*(iv12**2)*(iv13*iv24 + iv14*iv23)              &
&              -(1/2)*(iv12 + iv34)*(iv13**2*iv24 + iv14**2*iv23)


         Tv2 = -(1/2)*(iv12**2)*(iv13*iv24 + iv14*iv23)              &
&              -(1/2)*(iv12 + iv34)*(iv13*iv24**2 + iv14*iv23**2)


         Tv11 = iv12**3*(iv13*iv24 + iv14*iv23)                      &
&              +iv12**2*(iv13**2*iv24 + iv14**2*iv23)                &
&              +(iv12 + iv34)*(iv13**3*iv24 + iv14**3*iv23)


         Tv22 = iv12**3*(iv13*iv24 + iv14*iv23)                      &
&              +iv12**2*(iv13*iv24**2 + iv14*iv23**2)                &
&              +(iv12 + iv34)*(iv13*iv24**3 + iv14*iv23**3)


         Tv12 = iv12**3*(iv13*iv24 + iv14*iv23)                      &
&              +(1/2)*iv12**2*(iv13*iv24**2 + iv14*iv23**2)          &
&              +(1/2)*iv12**2*(iv13**2*iv24 + iv14**2*iv23)          &
&              +(iv12 + iv34)*(iv13**2*iv24**2 + iv14**2*iv23**2)

         Tv13 = (1/2)*( iv12**2*(iv13**2*iv14 + iv14*iv23**2)        &
&              +iv34**2*(iv13**2*iv14 + iv14**2*iv23)                &
&              +(iv12 + iv34)*(2*iv13**3*iv14 + iv14**2*iv23**2) )


         Tv14 = (1/2)*( iv12**2*(iv13*iv14**2 + iv14**2*iv23)        &
&              +iv34**2*(iv13**2*iv14 + iv14**2*iv23)                &
&              +(iv12 + iv34)*(iv13**2*iv14**2 + 2*iv14**3*iv23) )


         Tv23 = (1/2)*( iv12**2*(iv13**2*iv14 + iv14*iv23**2)        &
&              +iv34**2*(iv13*iv14**2 + iv14*iv23**2)                &
&              +(iv12 + iv34)*(iv13**2*iv14**2 + 2*iv14*iv23**3) )


         Tv24 = (1/2)*( iv12**2*(iv13*iv14**2 + iv14**2*iv23)        &
&              +iv34**2*(iv13*iv14**2 + iv14*iv23**2)                &
&              +(iv12 + iv34)*(2*iv13*iv14**3 + iv14**2*iv23**2) )


      Td   = Tv1*v1d+Tv2*v2d
      Tdd  = Tv11*v1d**2 + Tv1*v1dd + Tv22*v2d**2 + Tv2*v2dd + 2*Tv12*v1d*v2d
      Tddk = Tv13*v3d*v1d + Tv14*v4d*v1d + Tv23*v3d*v2d + Tv14*v4d*v2d

         phi = phi + &
&              wi(ca)*wi(cb)*((a*b)**2)*W*(Td + di*Tdd + dk*Tddk)

      End Do
      End Do

      phi = phi * 2*m*(e**4)/(pi**2)

      phi3dD(cdel,cphiD) = phi

   End Do
   End Do
!$OMP END PARALLEL DO

   End Subroutine calPhi3



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



   Subroutine calPhi4(maxD,minD,etai,eta1,na,xi,wi,ndel,nphiD,phi4dD)
!$   use omp_lib
      Implicit None


!************************ Note *********************************
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  ci,cj,ck,ca,cb,na,nb

! Gauss-Legendre integration
      Real(8) xi(na),wi(na)

      Real(8) ddel,dphiD,del,phiD,tmp,phix,phiy,maxD,minD,etai,eta1
      Integer ndel,cdel,nphiD,cphiD,cdelD
      Real(8)  :: phi4dD(-ndel:ndel,-1:nphiD+1)

      Integer  cir,cix,ciy,ciz&
&             ,cjr,cjx,cjy,cjz&
&             ,ckr,ckx,cky,ckz&
&             ,cr ,cx ,cy ,cz,lcx,hcx,lcy,hcy,lcz,hcz
      Real(8)  di,dj,dk,dx,dy,dz,dv,n,ni,nj,nk,r
      Integer  i,j,k

      Real(8)  eta
      Parameter (eta=0.0000000001)

      Real(8)  kF,excLDAd,exLDAd,ecLDAd,pi,Zab,wp,wq,q,m,h,e
      Real(8)  gamma,a,b,C,d
      Parameter (pi=3.1415926535897932)
      Parameter (e=1.0,m=1.0)
      Parameter (Zab=-0.8491)

      Real(8) T,W,phi,psi,vcik,vcik1,vcik2,vcii,vii
      Real(8) Tv1,Tv2,Tv11,Tv22,Tv12,Tv13,Tv14,Tv23,Tv24,Tdd
      Real(8) v1,v2,v3,v4,v1d,v2d,v3d,v4d,v1dd,v2dd

      Real(8) term1,term2,term3,term4,ns
      Real(8) iv12,iv13,iv14,iv23,iv24,iv34
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++
      gamma = 4*pi/9

! phi(del,phiD)
      ddel = 1/Real(ndel+1)
      dphiD = (maxD-minD)/(Real(nphiD))


!$OMP  PARALLEL DO &
!$OMP& DEFAULT(SHARED) &
!$OMP& PRIVATE(cdel,cphiD,del,phiD,di,dk,phi,ca,cb,a,b,  &
!$OMP&  h,v1,v2,v3,v4,W,T)

   Do cdel = -ndel,ndel
   Do cphiD = -1,nphiD+1

      del = Real(cdel)*ddel
      phiD = minD + Real(cphiD)*dphiD
      
      di = phiD*(1+del)
      dk = phiD*(1-del)

      phi = 0
      Do ca=1,na
      Do cb=1,na
         a = xi(ca)
         b = xi(cb)

         h = 1-Exp(-gamma*((a/di)**2)) + eta
         v1 = (a**2)/(2*h)

         h = 1-Exp(-gamma*((b/di)**2)) + eta
         v2 = (b**2)/(2*h)

         h = 1-Exp(-gamma*((a/dk)**2)) + eta
         v3 = (a**2)/(2*h)

         h = 1-Exp(-gamma*((b/dk)**2)) + eta
         v4 = (b**2)/(2*h)

         W = 2*((3-a*a)*b*Cos(b)*Sin(a) + (3-b*b)*a*Cos(a)*Sin(b)&
&            + (a*a+b*b-3)*Sin(a)*Sin(b)&
&            -3*a*b*Cos(a)*Cos(b))/((a*b)**3)

         T = 0.5*(1/(v1+v2) + 1/(v3+v4) )&
&            *(1/((v1+v3)*(v2+v4)) + 1/((v1+v4)*(v2+v3)))

         phi = phi + &
&              wi(ca)*wi(cb)*((a*b)**2)*W*T

      End Do
      End Do

      phi = phi * 2*m*(e**4)/(pi**2)

      phi4dD(cdel,cphiD) = phi

   End Do
   End Do
!$OMP END PARALLEL DO

   End Subroutine calPhi4



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



   Subroutine d_q0(nx,ny,nz,n,nnx,nny,nnz,q0)
!$   use omp_lib
      Implicit None


!************************ Note *********************************
! This program calculates q0 and d.
!
! Input
!   rho(nrxyz,nsipn) : Total density
!
! Output
!   q0               : 
!
!
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  nx,ny,nz,nspin
      Double Precision n,rs,x,nnx,nny,nnz,nn2,r,term1,term2,term3

      Double precision  kF,exc0,exLDA,excLDA,pi,Zab,q0,m,h,e,GxcLDA,eta
      Parameter (pi=3.1415926535897932)
      Parameter (e=1.0,m=1.0)
      Parameter (Zab=-0.8491)

!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      nn2 = (nnx**2)+(nny**2)+(nnz**2)

      rs = (3/(4*pi*n))**0.3333333333333333

! Eq.(58), (59) (p.93-94) of Theory of the Inhomogeneous Electron gas.
! S.Lundqvist and N.H.March 1983 Plenum Press, NY
      x = rs/11.4
      GxcLDA = 0.5*((1+x**3)*Log(1+1/x)-x**2+x/2-1/3)
      excLDA = -0.458/rs-0.0666*GxcLDA

      kF = (3*pi*pi*n)**0.3333333333333333
      exLDA = -3*e*kF/(4*pi)

! Eq.(12) of Dion PRL92,246401
      term1 = exLDA*Zab*nn2/(6*kF*n)
      term2 = term1/(6*kF*n)

      exc0 = excLDA - term2


! Eq.(11) of Dion PRL92,246401
      q0 = exc0*kF/exLDA



   End Subroutine d_q0



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



   Subroutine Phi1(maxD,minD,etai,eta1,na,xi,wi,nx,ny,nz,dx,dy,dz,rho,cix,ciy &
&           ,ciz,dxrho,dyrho,dzrho,d2xrho,d2yrho,d2zrho,C6,ndel,nphiD,phi1dD,naPhi1)
!$   use omp_lib
      Implicit None

!************************ Note *********************************
!
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  nx,ny,nz,nspin
      Real(8) da,db,a1,a2
      Integer  ci,cj,ck,ca,cb,na,nb
      Parameter (a1=0,a2=60)

! Gauss-Legendre integration
      Real(8) xi(na),wi(na)

      Real(8) ddel,dphiD,del,phiD,phix,phiy,maxD,minD
      Integer ndel,cdel,nphiD,cphiD
      Real(8) phi1dD(-ndel:ndel,-1:nphiD+1)

      Integer  cir,cix,ciy,ciz&
&             ,cjr,cjx,cjy,cjz&
&             ,ckr,ckx,cky,ckz&
&             ,cr ,cx ,cy ,cz,lcx,hcx,lcy,hcy,lcz,hcz
      Real(8)  di,dj,dk,dx,dy,dz,dv,n,ni,nj,nk
      Integer  i,j,k,zxp,zxm,zyp,zym,zzp,zzm

      Real(8)  eta,etai,eta1
      Parameter (eta=0.0000000001)

      Real(8) rs,r,x,nnx,nny,nnz,nn2,n2nx,n2ny,n2nz
      Real(8) :: rho(nx,ny,nz),Eii(nx,ny,nz)
      Real(8) :: dxrho(nx,ny,nz),d2xrho(nx,ny,nz) &
&               ,dyrho(nx,ny,nz),d2yrho(nx,ny,nz) &
&               ,dzrho(nx,ny,nz),d2zrho(nx,ny,nz)
      Real(8) rhomin
      Parameter (rhomin=1.e-6)

      Real(8)  kF,excLDAd,exLDAd,ecLDAd,pi,Zab,wp,wq,q,m,h,e
      Real(8)  gamma,a,b,C,d,q0,q0i,q0k
      Real(8)  v1,v2,v3,v4
      Parameter (pi=3.1415926535897932)
      Parameter (e=1.0,m=1.0)
      Parameter (Zab=-0.8491)

      Real(8) :: C6(0:nx-1,0:ny-1,0:nz-1)

      Real(8) T,W,phi,psi,vcik,vcik1,vcik2,vcii,vii
      Real(8) Tv1,Tv2,Tv11,Tv22,Tv12,Tv13,Tv14,Tv23,Tv24
      Real(8) v1d,v2d,v3d,v4dd

      Real(8) naPhi1,alfa1,term1,term2,ns

      integer cD,nD
      parameter (nD=100)
      real(8) minDii,maxDii,LD1,LD2,PLD,LDxi(nD),LDwi(nD)
      parameter (minDii=0)
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      nb = na
      da=0
      db = da
      gamma = 4*pi/9

      dv = dx*dy*dz
      ni = rho(cix,ciy,ciz)
      kF = (3*pi*pi*ni)**0.3333333333333333
      rs = (3/(4*pi*ni))**0.3333333333333333
      x = rs/11.4

      vcik1=0
      If(ni.GT.rhomin) Then

      nnx = dxrho(cix,ciy,ciz)
      nny = dyrho(cix,ciy,ciz)      
      nnz = dzrho(cix,ciy,ciz)
      nn2 = (nnx**2)+(nny**2)+(nnz**2)

      Call d_q0(nx,ny,nz,ni,nnx,nny,nnz,q0i)

! Calculate the coefficient alfa1.
      n2nx = d2xrho(cix,ciy,ciz)
      n2ny = d2yrho(cix,ciy,ciz)      
      n2nz = d2zrho(cix,ciy,ciz)
      term1 = n2nx+n2ny+n2nz 
      term2 = ((((pi/(3*ni))**0.666666666666667)/kF)+(1/ni))*nn2
      ns = (term1-term2)/(2*kF*ni)
      term1 = (36*pi*(ni**4))**0.33333333333333333
      exLDAd = -0.458/((rs**2)*term1)
      ecLDAd = -0.0333*(3*x*x*Log(1+1/x)-3*x+1.5-1/x)/(11.4*term1)
      excLDAd = exLDAd + ecLDAd
      alfa1 = ((zab*ns/9)+(7*zab*nn2/(3*9*4*kF*ni*ni))-(4*pi*ni*excLDAd/3))/q0i

      lcx = cix - Nint(eta1/dx)
      hcx = cix + Nint(eta1/dx)
      lcy = ciy - Nint(eta1/dy)
      hcy = ciy + Nint(eta1/dy)
      lcz = ciz - Nint(eta1/dz)
      hcz = ciz + Nint(eta1/dz)

      Do ckx = lcx,hcx
      Do cky = lcy,hcy
      Do ckz = lcz,hcz
      r =                              &
&        ((REAL(cix-ckx)*dx)**2        &
&       + (REAL(ciy-cky)*dy)**2        &
&       + (REAL(ciz-ckz)*dz)**2)**0.5

   If(r.Lt.eta1.AND.r.Ge.etai) Then

         cx=MOD(20*nx+ckx-1,nx)+1
         cy=MOD(20*ny+cky-1,ny)+1
         cz=MOD(20*nz+ckz-1,nz)+1
         nk = rho(cx,cy,cz)
      If(nk.GT.rhomin) Then

      nnx = dxrho(cx,cy,cz)
      nny = dyrho(cx,cy,cz)      
      nnz = dzrho(cx,cy,cz)

      Call d_q0(nx,ny,nz,nk,nnx,nny,nnz,q0k)
      di = r*q0i + eta
      dk = r*q0k + eta

      ddel = 1/Real(ndel+1)
      del = ((di-dk)/(di+dk))
      cdel = AINT(del/ddel)
      phiD = (di+dk)/2

      If(phiD.LT.maxD.AND.phiD.GT.minD) then
         cphiD = AINT(REAL(nphiD)*(phiD-minD)/(maxD-minD))

         phix = del/ddel - REAL(cdel)
         phiy = REAL(nphiD)*(phiD-minD)/(maxD-minD) - REAL(cphiD)

         phi =  (1-phix)*(1-phiy) * phi1dD(cdel  ,cphiD  )  &
&              +   phix *(1-phiy) * phi1dD(cdel+1,cphiD  )  &
&              +(1-phix)*   phiy  * phi1dD(cdel  ,cphiD+1)  &
&              +   phix *   phiy  * phi1dD(cdel+1,cphiD+1)
      End If


! vcik1 is the non-local correlation potential 
! v_c^nl summated for (etai < rik < eta1).
      vcik1 = vcik1 + dv*alfa1*di*phi*nk

      End If

   End If

      End Do
      End Do
      End Do
         End If



   vcik2 = 0
   If(ni.GT.rhomin) Then
   C = 12*m*(e**4)*((4*pi/9)**3)

   Do ckx = 1,nx
   Do cky = 1,ny
   Do ckz = 1,nz
   nk = rho(ckx,cky,ckz)
   If(nk.GT.rhomin) Then

      nnx = dxrho(ckx,cky,ckz)
      nny = dyrho(ckx,cky,ckz)      
      nnz = dzrho(ckx,cky,ckz)
      Call d_q0(nx,ny,nz,nk,nnx,nny,nnz,q0k)

      psi = 2*(3*q0i**2+q0k**2)/(q0i**3*q0k**2*(q0i**2+q0k**2)**2)

! vcik2 is the non-local correlation potential 
! v_c^nl summated for ( eta1 < rik ).
      vcik2 = vcik2 + dv*alfa1*C*q0i*psi*nk &
&      *C6(ABS(cix-ckx),ABS(ciy-cky),ABS(ciz-ckz))

   End If

   End Do
   End Do
   End Do

   End If



   vcik = vcik1 + vcik2



   vii=0
   vcii=0
   cjx=cix
   cjy=ciy
   cjz=ciz
      n = rho(cix,ciy,ciz)
   If(n.GT.rhomin) Then

      nnx = dxrho(cjx,cjy,cjz)
      nny = dyrho(cjx,cjy,cjz)      
      nnz = dzrho(cjx,cjy,cjz)
      Call d_q0(nx,ny,nz,n,nnx,nny,nnz,q0k)
      q0 = q0k

      maxDii = q0*etai

      Call gauleg(minDii,maxDii,nD,LDxi,LDwi)
!      Call gauleg(a1,a2,na,xi,wi)
      
      Do cD=1,nD
         LD1 = LDxi(cD)
         LD2 = LD1

         di = LD1
         dk = LD2

      phi = 0

      Do ca=1,na
      Do cb=1,na

         a = xi(ca)
         b = xi(cb)

         h = 1-Exp(-gamma*((a/di)**2)) + eta
         v1 = (a**2)/(2*h)
         v1d = -4*pi*(a**4)*(h-1)/(9*(di**3)*(h**2))

         h = 1-Exp(-gamma*((b/di)**2)) + eta
         v2 = (b**2)/(2*h)
         v2d = -4*pi*(b**4)*(h-1)/(9*(di**3)*(h**2))

         h = 1-Exp(-gamma*((a/dk)**2)) + eta
         v3 = (a**2)/(2*h)

         h = 1-Exp(-gamma*((b/dk)**2)) + eta
         v4 = (b**2)/(2*h)

         W = 2*((3-a*a)*b*Cos(b)*Sin(a) + (3-b*b)*a*Cos(a)*Sin(b)           &
&            + (a*a+b*b-3)*Sin(a)*Sin(b)                                    &
&            -3*a*b*Cos(a)*Cos(b))/((a*b)**3)

         Tv1 = ((1/((v1+v2)**2))*(1/((v1+v3)*(v2+v4))+1/((v1+v4)*(v2+v3)))  &
&              +(1/(v1+v2)+1/(v3+v4))                                       &
&              *(1/(((v1+v3)**2)*(v2+v4))+1/(((v1+v4)**2)*(v2+v3))))*(-0.5)

         Tv2 = ((1/((v1+v2)**2))*(1/((v1+v3)*(v2+v4))+1/((v1+v4)*(v2+v3)))  &
&              +(1/(v1+v2)+1/(v3+v4))                                       &
&              *(1/((v1+v3)*((v2+v4)**2))+1/((v1+v4)*((v2+v3)**2))))*(-0.5)

         phi = phi + &
&              wi(ca)*wi(cb)*((a*b)**2)*W*(Tv1*v1d+Tv2*v2d)

      End Do
      End Do

      phi = phi * 2*m*(e**4)/(pi**2)

      vii = vii + LDwi(cD)*4*pi*(LD1**2)*phi

      End Do


! vcii is the non-local correlation potential 
! v_c^nl summated for ( rik < etai ).
      vcii = alfa1*n*vii/(q0**3)

   End If

   naPhi1 = vcik1 + vcik2 + vcii



! End of Phi1
   End Subroutine Phi1



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



   Subroutine Phi2(maxD,minD,etai,eta1,na,xi,wi,nx,ny,nz,dx,dy,dz,rho,cix,ciy,ciz  &
&                     ,dxrho,dyrho,dzrho,d2xrho,d2yrho,d2zrho               &
&                     ,dxyrho,dxzrho,dyzrho,C6,ndel,nphiD,phi2dD,naPhi2)
!$   use omp_lib
      Implicit None


!************************ Note *********************************
!
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  nx,ny,nz,nspin
      Real(8) da,db,a1,a2
      Integer  ci,cj,ck,ca,cb,na,nb
      Parameter (a1=0,a2=60)

! Gauss-Legendre integration
      Real(8) xi(na),wi(na)

      Real(8) ddel,dphiD,del,phiD,phix,phiy,maxD,minD
      Integer ndel,cdel,nphiD,cphiD
      Real(8) phi2dD(-ndel:ndel,-1:nphiD+1)

      Integer  cir,cix,ciy,ciz&
&             ,cjr,cjx,cjy,cjz&
&             ,ckr,ckx,cky,ckz&
&             ,cr ,cx ,cy ,cz,lcx,hcx,lcy,hcy,lcz,hcz
      Real(8)  di,dj,dk,dx,dy,dz,dv,n,ni,nj,nk
      Integer  i,j,k,zxp,zxm,zyp,zym,zzp,zzm

      Real(8)  eta,etai,eta1
      Parameter (eta=0.0000000001)

      Real(8) rs,r,x,nnx,nny,nnz,nn2,n2nx,n2ny,n2nz,nxy,nxz,nyz
      Real(8) ::      rho(nx,ny,nz),Eii(nx,ny,nz)
      Real(8) ::      dxrho(nx,ny,nz),d2xrho(nx,ny,nz) &
&                    ,dyrho(nx,ny,nz),d2yrho(nx,ny,nz) &
&                    ,dzrho(nx,ny,nz),d2zrho(nx,ny,nz) &
&  ,dxyrho(nx,ny,nz),dxzrho(nx,ny,nz),dyzrho(nx,ny,nz)

      Real(8) rhomin
      Parameter (rhomin=1.e-6)

      Real(8)  kF,GxcLDA,excLDA,excLDAd,exLDAd,ecLDAd,pi,Zab,wp,wq,q,m,h,e
      Real(8)  gamma,a,b,C,d,q0,q0i,q0k,q0dx,q0dy,q0dz
      Parameter (pi=3.1415926535897932)
      Parameter (e=1.0,m=1.0)
      Parameter (Zab=-0.8491)

      Real(8) :: C6(0:nx-1,0:ny-1,0:nz-1)

      Real(8) T,W,phi,psi,vcik,vcik1,vcik2,vcii,vii
      Real(8) Tv1,Tv2,Tv11,Tv22,Tv12,Tv13,Tv14,Tv23,Tv24,Tdd
      Real(8) v1,v2,v3,v4,v1d,v2d,v3d,v4d,v1dd,v2dd

      Real(8) naPhi2,alfa2,term1,term2,term3,term4,ns
      Real(8) iv12,iv13,iv14,iv23,iv24,iv34

      integer cD,nD
      parameter (nD=100)
      real(8) minDii,maxDii,LD1,LD2,PLD,LDxi(nD),LDwi(nD)
      parameter (minDii=0)
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      nb = na
      da=0
      db = da
      gamma = 4*pi/9

      dv = dx*dy*dz
      ni = rho(cix,ciy,ciz)
      kF = (3*pi*pi*ni)**0.3333333333333333
      rs = (3/(4*pi*ni))**0.3333333333333333
      x = rs/11.4

      vcik1=0
      If(ni.GT.rhomin) Then

      nnx = dxrho(cix,ciy,ciz)
      nny = dyrho(cix,ciy,ciz)      
      nnz = dzrho(cix,ciy,ciz)
      nn2 = (nnx**2)+(nny**2)+(nnz**2)

      Call d_q0(nx,ny,nz,ni,nnx,nny,nnz,q0i)



!********* Calculate the coefficient alfa2. *********
      n2nx = d2xrho(cix,ciy,ciz)
      n2ny = d2yrho(cix,ciy,ciz)      
      n2nz = d2zrho(cix,ciy,ciz)
      nxy = dxyrho(cix,ciy,ciz)
      nxz = dxzrho(cix,ciy,ciz)
      nyz = dyzrho(cix,ciy,ciz)

! Eq.(58), (59) (p.93-94) of Theory of the Inhomogeneous Electron gas.
! S.Lundqvist and N.H.March 1983 Plenum Press, NY
      GxcLDA = 0.5*((1+x**3)*Log(1+1/x)-x**2+x/2-1/3)
      excLDA = -0.458/rs-0.0666*GxcLDA
      
      term1 = (36*pi*(ni**4))**0.33333333333333333
      exLDAd = -0.458/((rs**2)*term1)
      ecLDAd = -0.0333*(3*x*x*Log(1+1/x)-3*x+1.5-1/x)/(11.4*term1)
      excLDAd = exLDAd + ecLDAd

! q0dx
      term1 = -nnx*(4*pi/3)*(excLDAd*ni+excLDA)
      term2 = nn2*nnx*(((pi*pi*ni/9)**0.33333333333333333)+2*kF)/(-4*(kF**2)*(ni**3))
      term3 = 2*( nnx*n2nx + nny*nxy + nnz*nxz )/(4*kF*(ni**2))
      term4 = -(Zab/9)*(term2+term3)
      q0dx = term1 + term4

! q0dy
      term1 = -nny*(4*pi/3)*(excLDAd*ni+excLDA)
      term2 = nn2*nny*(((pi*pi*ni/9)**0.33333333333333333)+2*kF)/(-4*(kF**2)*(ni**3))
      term3 = 2*( nnx*nxy + nny*n2ny + nnz*nyz )/(4*kF*(ni**2))
      term4 = -(Zab/9)*(term2+term3)
      q0dy = term1 + term4

! q0dz
      term1 = -nnz*(4*pi/3)*(excLDAd*ni+excLDA)
      term2 = nn2*nnz*(((pi*pi*ni/9)**0.33333333333333333)+2*kF)/(-4*(kF**2)*(ni**3))
      term3 = 2*( nnx*nxz + nny*nyz + nnz*n2nz )/(4*kF*(ni**2))
      term4 = -(Zab/9)*(term2+term3)
      q0dz = term1 + term4

      term1 = ( nnx*q0dx + nny*q0dy + nnz*q0dz )/(2*kF*ni)

      alfa2 = (Zab/9)*term1/(q0i**2)
!******** End Calculating coefficient alfa2. ********



      lcx = cix - Nint(eta1/dx)
      hcx = cix + Nint(eta1/dx)
      lcy = ciy - Nint(eta1/dy)
      hcy = ciy + Nint(eta1/dy)
      lcz = ciz - Nint(eta1/dz)
      hcz = ciz + Nint(eta1/dz)

      Do ckx = lcx,hcx
      Do cky = lcy,hcy
      Do ckz = lcz,hcz
      r = (((cix-ckx)*dx)**2 + ((ciy-cky)*dy)**2 + ((ciz-ckz)*dz)**2)**0.5

   If(r.LT.eta1.AND.r.GE.etai) Then

         cx=MOD(20*nx+ckx-1,nx)+1
         cy=MOD(20*ny+cky-1,ny)+1
         cz=MOD(20*nz+ckz-1,nz)+1
         nk = rho(cx,cy,cz)
      If(nk.GT.rhomin) Then

      nnx = dxrho(cx,cy,cz)
      nny = dyrho(cx,cy,cz)      
      nnz = dzrho(cx,cy,cz)

      Call d_q0(nx,ny,nz,nk,nnx,nny,nnz,q0k)
      di = r*q0i + eta
      dk = r*q0k + eta

      ddel = 1/Real(ndel+1)
      del = ((di-dk)/(di+dk))
      cdel = AINT(del/ddel)
      phiD = (di+dk)/2

      If(phiD.LT.maxD.AND.phiD.GT.minD) then
         cphiD = AINT(REAL(nphiD)*(phiD-minD)/(maxD-minD))

         phix = del/ddel - REAL(cdel)
         phiy = REAL(nphiD)*(phiD-minD)/(maxD-minD) - REAL(cphiD)

         phi =  (1-phix)*(1-phiy) * phi2dD(cdel  ,cphiD  )  &
&              +   phix *(1-phiy) * phi2dD(cdel+1,cphiD  )  &
&              +(1-phix)*   phiy  * phi2dD(cdel  ,cphiD+1)  &
&              +   phix *   phiy  * phi2dD(cdel+1,cphiD+1)
      End If

! vcik1 is the non-local correlation potential 
! v_c^nl summated for (etai < rik < eta1).
      vcik1 = vcik1 + dv*alfa2*(di**2)*phi*nk

      End If

   End If

      End Do
      End Do
      End Do
         End If



   vcik2 = 0
   If(ni.GT.rhomin) Then
   C = 12*m*(e**4)*((4*pi/9)**3)

   Do ckx = 1,nx
   Do cky = 1,ny
   Do ckz = 1,nz
   nk = rho(ckx,cky,ckz)
   If(nk.GT.rhomin) Then

      nnx = dxrho(ckx,cky,ckz)
      nny = dyrho(ckx,cky,ckz)      
      nnz = dzrho(ckx,cky,ckz)
      Call d_q0(nx,ny,nz,nk,nnx,nny,nnz,q0k)

      psi = -2*(15*q0i**4+10*(q0i*q0k)**2+3*q0k**4) &
&             /(q0i**4*q0k**2*(q0i**2+q0k**2)**3)

! vcik2 is the non-local correlation potential 
! v_c^nl summated for ( eta1 < rik ).
      vcik2 = vcik2 + dv*alfa2*C*(q0i**2)*psi*nk &
&      *C6(ABS(cix-ckx),ABS(ciy-cky),ABS(ciz-ckz))

   End If

   End Do
   End Do
   End Do

   End If



   vcik = vcik1 + vcik2



   vcii=0
   vii=0
   cjx=cix
   cjy=ciy
   cjz=ciz
      n = rho(cix,ciy,ciz)
   If(n.GT.rhomin) Then

      nnx = dxrho(cjx,cjy,cjz)
      nny = dyrho(cjx,cjy,cjz)      
      nnz = dzrho(cjx,cjy,cjz)
      Call d_q0(nx,ny,nz,n,nnx,nny,nnz,q0k)
      q0 = q0k

      maxDii = q0*etai

      Call gauleg(minDii,maxDii,nD,LDxi,LDwi)
!      Call gauleg(a1,a2,na,xi,wi)
      
      Do cD=1,nD
         LD1 = LDxi(cD)
         LD2 = LD1

         di = LD1
         dk = LD2

      phi = 0

      Do ca=1,na
      Do cb=1,na

         a = xi(ca)
         b = xi(cb)

         h = 1-Exp(-gamma*((a/di)**2)) + eta
         v1 = (a**2)/(2*h)
         v1d = -4*pi*(a**4)*(h-1)/(9*(di**3)*(h**2))
         v1dd = 2*((4*pi*(a**3)/(9*(di**3)))**2)*(1-h)*(2-3*h)/(h**3)

         h = 1-Exp(-gamma*((b/di)**2)) + eta
         v2 = (b**2)/(2*h)
         v2d = -4*pi*(b**4)*(h-1)/(9*(di**3)*(h**2))
         v2dd = 2*((4*pi*(b**3)/(9*(di**3)))**2)*(1-h)*(2-3*h)/(h**3)

         h = 1-Exp(-gamma*((a/dk)**2)) + eta
         v3 = (a**2)/(2*h)

         h = 1-Exp(-gamma*((b/dk)**2)) + eta
         v4 = (b**2)/(2*h)

         W = 2*((3-a*a)*b*Cos(b)*Sin(a) + (3-b*b)*a*Cos(a)*Sin(b)           &
&            + (a*a+b*b-3)*Sin(a)*Sin(b)                                    &
&            -3*a*b*Cos(a)*Cos(b))/((a*b)**3)


         iv12 = 1/(v1+v2)
         iv13 = 1/(v1+v3)
         iv14 = 1/(v1+v4)
         iv23 = 1/(v2+v3)
         iv24 = 1/(v2+v4)
         iv34 = 1/(v3+v4)


         Tv1 = -(1/2)*(iv12**2)*(iv13*iv24+iv14*iv23)              &
&              -(1/2)*(iv12+iv34)*(iv13**2*iv24+iv14**2*iv23)


         Tv2 = -(1/2)*(iv12**2)*(iv13*iv24+iv14*iv23)              &
&              -(1/2)*(iv12+iv34)*(iv13*iv24**2+iv14*iv23**2)


         Tv11 = iv12**3*(iv13*iv24+iv14*iv23)                      &
&              +iv12**2*(iv13**2*iv24+iv14**2*iv23)                &
&              +(iv12+iv34)*(iv13**3*iv24+iv14**3*iv23)


         Tv22 = iv12**3*(iv13*iv24+iv14*iv23)                      &
&              +iv12**2*(iv13*iv24**2+iv14*iv23**2)                &
&              +(iv12+iv34)*(iv13*iv24**3+iv14*iv23**3)


         Tv12 = iv12**3*(iv13*iv24+iv14*iv23)                      &
&              +(1/2)*iv12**2*(iv13*iv24**2+iv14*iv23**2)          &
&              +(1/2)*iv12**2*(iv13**2*iv24+iv14**2*iv23)          &
&              +(iv12+iv34)*(iv13**2*iv24**2+iv14**2*iv23**2)


         Tdd = Tv11*v1d**2 + Tv1*v1dd + Tv22*v2d**2 + Tv2*v2dd + 2*Tv12*v1d*v2d
         
         phi = phi + &
&              wi(ca)*wi(cb)*((a*b)**2)*W*Tdd

      End Do
      End Do

      phi = phi * 2*m*(e**4)/(pi**2)

      vii = vii + LDwi(cD)*4*pi*(LD1**2)*phi

      End Do


! vcii is the non-local correlation potential 
! v_c^nl summated for ( rik < etai ).
      vcii = alfa2*n*vii/(q0**3)

   End If

   naPhi2 = vcik1 + vcik2 + vcii



! End of Phi2
   End Subroutine Phi2



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



   Subroutine Phi3(maxD,minD,etai,eta1,na,xi,wi,nx,ny,nz,dx,dy,dz,rho,cix,ciy,ciz  &
&                     ,dxrho,dyrho,dzrho,d2xrho,d2yrho,d2zrho,C6,ndel,nphiD,phi3dD,naPhi3)
!$   use omp_lib
      Implicit None


!************************ Note *********************************
!
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  nx,ny,nz,nspin
      Real(8) da,db
      Integer  ci,cj,ck,ca,cb,na,nb

! Gauss-Legendre integration
      Real(8) xi(na),wi(na)

      Real(8) ddel,dphiD,del,phiD,phix,phiy,maxD,minD
      Integer ndel,cdel,nphiD,cphiD
      Real(8) phi3dD(-ndel:ndel,-1:nphiD+1)

      Integer  cir,cix,ciy,ciz&
&             ,cjr,cjx,cjy,cjz&
&             ,ckr,ckx,cky,ckz&
&             ,cr ,cx ,cy ,cz,lcx,hcx,lcy,hcy,lcz,hcz
      Real(8)  di,dj,dk,dx,dy,dz,dv,n,ni,nj,nk
      Integer  i,j,k,zxp,zxm,zyp,zym,zzp,zzm

      Real(8)  eta,etai,eta1
      Parameter (eta=0.0000000001)

      Real(8) rs,r,x,nnx,nny,nnz,nn2,n2nx,n2ny,n2nz,nxy,nxz,nyz
      Real(8) ::      rho(nx,ny,nz),Eii(nx,ny,nz)
      Real(8) ::      dxrho(nx,ny,nz),d2xrho(nx,ny,nz) &
&                    ,dyrho(nx,ny,nz),d2yrho(nx,ny,nz) &
&                    ,dzrho(nx,ny,nz),d2zrho(nx,ny,nz)

      Real(8) rhomin
      Parameter (rhomin=1.e-6)

      Real(8)  kF,GxcLDA,excLDA,excLDAd,exLDAd,ecLDAd,pi,Zab,wp,wq,q,m,h,e
      Real(8)  gamma,a,b,C,d,q0,q0i,q0k,q0dx,q0dy,q0dz
      Parameter (pi=3.1415926535897932)
      Parameter (e=1.0,m=1.0)
      Parameter (Zab=-0.8491)

      Real(8) :: C6(0:nx-1,0:ny-1,0:nz-1)

      Real(8) T,W,phi,psi,vcik,vcik1,vcik2,vcii,vii
      Real(8) Tv1,Tv2,Tv11,Tv22,Tv12,Tv13,Tv14,Tv23,Tv24,Td,Tdd,Tddk
      Real(8) v1,v2,v3,v4,v1d,v2d,v3d,v4d,v1dd,v2dd

      Real(8) naPhi3,alfa3,term1,term2,term3,term4,ns
      Real(8) iv12,iv13,iv14,iv23,iv24,iv34
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------
      nb = na
      da=0
      db = da
      gamma = 4*pi/9

      dv = dx*dy*dz
      ni = rho(cix,ciy,ciz)
      kF = (3*pi*pi*ni)**0.3333333333333333
      rs = (3/(4*pi*ni))**0.3333333333333333
      x = rs/11.4

      vcik1=0
      If(ni.GT.rhomin) Then

      nnx = dxrho(cix,ciy,ciz)
      nny = dyrho(cix,ciy,ciz)      
      nnz = dzrho(cix,ciy,ciz)
      nn2 = (nnx**2)+(nny**2)+(nnz**2)

      Call d_q0(nx,ny,nz,ni,nnx,nny,nnz,q0i)

      lcx = cix - Nint(eta1/dx)
      hcx = cix + Nint(eta1/dx)
      lcy = ciy - Nint(eta1/dy)
      hcy = ciy + Nint(eta1/dy)
      lcz = ciz - Nint(eta1/dz)
      hcz = ciz + Nint(eta1/dz)



      Do ckx = lcx,hcx
      Do cky = lcy,hcy
      Do ckz = lcz,hcz
      r =                              &
&        ((REAL(cix-ckx)*dx)**2        &
&       + (REAL(ciy-cky)*dy)**2        &
&       + (REAL(ciz-ckz)*dz)**2)**0.5

   If(r.LT.eta1.AND.r.GE.etai) Then


!********* Calculate the coefficient alfa3. *********
      term1 = (REAL(cix-ckx)*dx)*nnx
      term2 = (REAL(ciy-cky)*dy)*nny
      term3 = (REAL(ciz-ckz)*dz)*nnz
      alfa3 = (Zab/9)*(1/(2*kF*ni))*(term1+term2+term3)
!******** End Calculating coefficient alfa3. ********


         cx=MOD(20*nx+ckx-1,nx)+1
         cy=MOD(20*ny+cky-1,ny)+1
         cz=MOD(20*nz+ckz-1,nz)+1
         nk = rho(cx,cy,cz)
      If(nk.GT.rhomin) Then

      nnx = dxrho(cx,cy,cz)
      nny = dyrho(cx,cy,cz)      
      nnz = dzrho(cx,cy,cz)

      Call d_q0(nx,ny,nz,nk,nnx,nny,nnz,q0k)
      di = r*q0i + eta
      dk = r*q0k + eta

      ddel = 1/Real(ndel+1)
      del = ((di-dk)/(di+dk))
      cdel = AINT(del/ddel)
      phiD = (di+dk)/2

      If(phiD.LT.maxD.AND.phiD.GT.minD) then
         cphiD = AINT(REAL(nphiD)*(phiD-minD)/(maxD-minD))

         phix = del/ddel - REAL(cdel)
         phiy = REAL(nphiD)*(phiD-minD)/(maxD-minD) - REAL(cphiD)

         phi =  (1-phix)*(1-phiy) * phi3dD(cdel  ,cphiD  )  &
&              +   phix *(1-phiy) * phi3dD(cdel+1,cphiD  )  &
&              +(1-phix)*   phiy  * phi3dD(cdel  ,cphiD+1)  &
&              +   phix *   phiy  * phi3dD(cdel+1,cphiD+1)
      End If

! vcik1 is the non-local correlation potential 
! v_c^nl summated for (etai < rik < eta1).
      vcik1 = vcik1 + dv*alfa3*phi*nk

      End If

   End If

      End Do
      End Do
      End Do
         End If



   vcik2 = 0

   vcik = vcik1 + vcik2

   vcii=0

   naPhi3 = vcik1 + vcik2 + vcii



! End of Phi3
   End Subroutine Phi3



!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



   Subroutine Phi4(maxD,minD,etai,eta1,na,xi,wi,nx,ny,nz,dx,dy,dz,rho,cix,ciy,ciz  &
&                  ,dxrho,dyrho,dzrho,d2xrho,d2yrho,d2zrho,C6,ndel,nphiD,phi4dD,naPhi4)
!$   use omp_lib
      Implicit None

!************************ Note *********************************
!
!
!                            Written by Youky Ono
!***************************************************************



!++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
      Integer  nx,ny,nz,nspin
      Real(8) da,db,a1,a2
      Integer  ci,cj,ck,ca,cb,na,nb
      Parameter (a1=0,a2=60)

! Gauss-Legendre integration
      Real(8) xi(na),wi(na)

      Real(8) ddel,dphiD,del,phiD,phix,phiy,maxD,minD
      Integer ndel,cdel,nphiD,cphiD
      Real(8) :: phi4dD(-ndel:ndel,-1:nphiD+1)

      Integer  cir,cix,ciy,ciz&
&             ,cjr,cjx,cjy,cjz&
&             ,ckr,ckx,cky,ckz&
&             ,cr ,cx ,cy ,cz,lcx,hcx,lcy,hcy,lcz,hcz
      Real(8)  di,dj,dk,dx,dy,dz,dv,n,ni,nj,nk
      Integer  i,j,k,zxp,zxm,zyp,zym,zzp,zzm

      Real(8)  eta,etai,eta1
      Parameter (eta=0.0000000001)

      Real(8) rs,x,nnx,nny,nnz,nn2,r,zo
      Real(8) :: rho(nx,ny,nz),Eii(nx,ny,nz)
      Real(8) :: dxrho(nx,ny,nz),d2xrho(nx,ny,nz) &
&               ,dyrho(nx,ny,nz),d2yrho(nx,ny,nz) &
&               ,dzrho(nx,ny,nz),d2zrho(nx,ny,nz)
      Real(8) rhomin
      Parameter (rhomin=1.e-6)

      Real(8)  kF,exc0,exLDA,excLDA,pi,Zab,wp,wq,q,m,h,e,GxcLDA
      Real(8)  gamma,a,b,C,d,q0,q0i,q0k
      Real(8)  v1,v2,v3,v4
      Parameter (pi=3.1415926535897932)
      Parameter (e=1.0,m=1.0)
      Parameter (Zab=-0.8491)

      Real(8) :: C6(0:nx-1,0:ny-1,0:nz-1)

      Real(8) T,W,phi,psi,vcik,vcik1,vcik2,vcii,vii

      Real(8) naPhi4,alfa4

      integer cD,nD
      parameter (nD=100)
      real(8) minDii,maxDii,LD1,LD2,PLD,LDxi(nD),LDwi(nD)
      parameter (minDii=0)
!++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



!---------------------- Calculation Start ----------------------

      alfa4=1
      nb = na
      da=0
      db = da
      gamma = 4*pi/9

      dv = dx*dy*dz
      ni = rho(cix,ciy,ciz)

      vcik1=0
      If(ni.GT.rhomin) Then

      nnx = dxrho(cix,ciy,ciz)
      nny = dyrho(cix,ciy,ciz)      
      nnz = dzrho(cix,ciy,ciz)
      Call d_q0(nx,ny,nz,ni,nnx,nny,nnz,q0i)

      lcx = cix - Nint(eta1/dx)
      hcx = cix + Nint(eta1/dx)
      lcy = ciy - Nint(eta1/dy)
      hcy = ciy + Nint(eta1/dy)
      lcz = ciz - Nint(eta1/dz)
      hcz = ciz + Nint(eta1/dz)

!      Do ckx = cix,cix ! lcx,hcx
!      Do cky = ciy,ciy ! lcy,hcy
!      Do ckz = ciz,ciz ! lcz,hcz
      Do ckx = lcx,hcx
      Do cky = lcy,hcy
      Do ckz = lcz,hcz
      r = (((cix-ckx)*dx)**2 + ((ciy-cky)*dy)**2 + ((ciz-ckz)*dz)**2)**0.5

   If(r.LT.eta1.AND.r.GE.etai) Then

         cx=MOD(20*nx+ckx-1,nx)+1
         cy=MOD(20*ny+cky-1,ny)+1
         cz=MOD(20*nz+ckz-1,nz)+1
         nk = rho(cx,cy,cz)
      If(nk.GT.rhomin) Then

      nnx = dxrho(cx,cy,cz)
      nny = dyrho(cx,cy,cz)      
      nnz = dzrho(cx,cy,cz)
      Call d_q0(nx,ny,nz,nk,nnx,nny,nnz,q0k)
      di = r*q0i + eta
      dk = r*q0k + eta

      ddel = 1/Real(ndel+1)
      del = ((di-dk)/(di+dk))
      cdel = AINT(del/ddel)
      phiD = (di+dk)/2

      If(phiD.LT.maxD.AND.phiD.GT.minD) then
         cphiD = AINT(REAL(nphiD)*(phiD-minD)/(maxD-minD))

         phix = del/ddel - REAL(cdel)
         phiy = REAL(nphiD)*(phiD-minD)/(maxD-minD) - REAL(cphiD)

         phi =  (1-phix)*(1-phiy) * phi4dD(cdel  ,cphiD  )  &
&              +   phix *(1-phiy) * phi4dD(cdel+1,cphiD  )  &
&              +(1-phix)*   phiy  * phi4dD(cdel  ,cphiD+1)  &
&              +   phix *   phiy  * phi4dD(cdel+1,cphiD+1)
      End If


! vcik1 is the non-local correlation potential 
! v_c^nl summated for (etai < rik < eta1).
      vcik1 = vcik1 + dv*alfa4*phi*nk

      End If

   End If

      End Do
      End Do
      End Do
         End If



   vcik2 = 0
   If(ni.GT.rhomin) Then
   C = 12*m*(e**4)*((4*pi/9)**3)

   Do ckx = 1,nx
   Do cky = 1,ny
   Do ckz = 1,nz
   nk = rho(ckx,cky,ckz)
   If(nk.GT.rhomin) Then

      nnx = dxrho(ckx,cky,ckz)
      nny = dyrho(ckx,cky,ckz)      
      nnz = dzrho(ckx,cky,ckz)
      Call d_q0(nx,ny,nz,nk,nnx,nny,nnz,q0k)

      psi = (((q0i*q0k)**2)*(q0i**2+q0k**2))**(-1)

! vcik2 is the non-local correlation potential 
! v_c^nl summated for ( eta1 < rik ).
      vcik2 = vcik2 -1*dv*C*psi*nk &
&      *C6(ABS(cix-ckx),ABS(ciy-cky),ABS(ciz-ckz))

   End If

   End Do
   End Do
   End Do

   End If



!   vcik = vcik1 + vcik2



   vcii = 0
   vii=0
   cjx=cix
   cjy=ciy
   cjz=ciz
      n = rho(cix,ciy,ciz)
   If(n.GT.rhomin) Then

      nnx = dxrho(cjx,cjy,cjz)
      nny = dyrho(cjx,cjy,cjz)      
      nnz = dzrho(cjx,cjy,cjz)
      Call d_q0(nx,ny,nz,n,nnx,nny,nnz,q0k)
      q0 = q0k

      maxDii = q0*etai

      Call gauleg(minDii,maxDii,nD,LDxi,LDwi)
!      Call gauleg(a1,a2,na,xi,wi)
      
      Do cD=1,nD
         LD1 = LDxi(cD)
         LD2 = LD1

         di = LD1
         dk = LD2

      phi = 0
!      Do ca=1,nD
!      Do cb=1,nD

!         a = LDxi(ca)
!         b = LDxi(cb)

      Do ca=1,na
      Do cb=1,na

         a = xi(ca)
         b = xi(cb)

         h = 1-Exp(-gamma*((a/di)**2)) + eta
         v1 = (a**2)/(2*h)

         h = 1-Exp(-gamma*((b/di)**2)) + eta
         v2 = (b**2)/(2*h)

         h = 1-Exp(-gamma*((a/dk)**2)) + eta
         v3 = (a**2)/(2*h)

         h = 1-Exp(-gamma*((b/dk)**2)) + eta
         v4 = (b**2)/(2*h)

         W = 2*((3-a*a)*b*Cos(b)*Sin(a) + (3-b*b)*a*Cos(a)*Sin(b)&
&            + (a*a+b*b-3)*Sin(a)*Sin(b)&
&            -3*a*b*Cos(a)*Cos(b))/((a*b)**3)

         T = 0.5*(1/(v1+v2) + 1/(v3+v4) )&
&            *(1/((v1+v3)*(v2+v4)) + 1/((v1+v4)*(v2+v3)))

         phi = phi + &
&              wi(ca)*wi(cb)*((a*b)**2)*W*T

      End Do
      End Do

      phi = phi * 2*m*(e**4)/(pi**2)

      vii = vii + LDwi(cD)*4*pi*(LD1**2)*phi

      End Do


! vcii is the non-local correlation potential 
! v_c^nl summated for ( rik < etai ).
      vcii = 2*alfa4*n*vii/(q0**3)

   End If

   naPhi4 = vcik1 + vcik2 + vcii



! End of Phi4
   End Subroutine Phi4

C     ----------------------------------------------------------------------
C     This file contains the LBFGS algorithm and supporting routines
C
C     ****************
C     LBFGS SUBROUTINE
C     ****************
C
      SUBROUTINE LBFGS(N,M,X,F,G,DIAGCO,DIAG,IPRINT,EPS,XTOL,W,IFLAG)
C
      INTEGER N,M,IPRINT(2),IFLAG
      DOUBLE PRECISION X(N),G(N),DIAG(N),W(N*(2*M+1)+2*M)
      DOUBLE PRECISION F,EPS,XTOL
      LOGICAL DIAGCO
C
C        LIMITED MEMORY BFGS METHOD FOR LARGE SCALE OPTIMIZATION
C                          JORGE NOCEDAL
C                        *** July 1990 ***
C
C 
C     This subroutine solves the unconstrained minimization problem
C 
C                      min F(x),    x= (x1,x2,...,xN),
C
C      using the limited memory BFGS method. The routine is especially
C      effective on problems involving a large number of variables. In
C      a typical iteration of this method an approximation Hk to the
C      inverse of the Hessian is obtained by applying M BFGS updates to
C      a diagonal matrix Hk0, using information from the previous M steps.
C      The user specifies the number M, which determines the amount of
C      storage required by the routine. The user may also provide the
C      diagonal matrices Hk0 if not satisfied with the default choice.
C      The algorithm is described in "On the limited memory BFGS method
C      for large scale optimization", by D. Liu and J. Nocedal,
C      Mathematical Programming B 45 (1989) 503-528.
C 
C      The user is required to calculate the function value F and its
C      gradient G. In order to allow the user complete control over
C      these computations, reverse  communication is used. The routine
C      must be called repeatedly under the control of the parameter
C      IFLAG. 
C
C      The steplength is determined at each iteration by means of the
C      line search routine MCVSRCH, which is a slight modification of
C      the routine CSRCH written by More' and Thuente.
C 
C      The calling statement is 
C 
C          CALL LBFGS(N,M,X,F,G,DIAGCO,DIAG,IPRINT,EPS,XTOL,W,IFLAG)
C 
C      where
C 
C     N       is an INTEGER variable that must be set by the user to the
C             number of variables. It is not altered by the routine.
C             Restriction: N>0.
C 
C     M       is an INTEGER variable that must be set by the user to
C             the number of corrections used in the BFGS update. It
C             is not altered by the routine. Values of M less than 3 are
C             not recommended; large values of M will result in excessive
C             computing time. 3<= M <=7 is recommended. Restriction: M>0.
C 
C     X       is a DOUBLE PRECISION array of length N. On initial entry
C             it must be set by the user to the values of the initial
C             estimate of the solution vector. On exit with IFLAG=0, it
C             contains the values of the variables at the best point
C             found (usually a solution).
C 
C     F       is a DOUBLE PRECISION variable. Before initial entry and on
C             a re-entry with IFLAG=1, it must be set by the user to
C             contain the value of the function F at the point X.
C 
C     G       is a DOUBLE PRECISION array of length N. Before initial
C             entry and on a re-entry with IFLAG=1, it must be set by
C             the user to contain the components of the gradient G at
C             the point X.
C 
C     DIAGCO  is a LOGICAL variable that must be set to .TRUE. if the
C             user  wishes to provide the diagonal matrix Hk0 at each
C             iteration. Otherwise it should be set to .FALSE., in which
C             case  LBFGS will use a default value described below. If
C             DIAGCO is set to .TRUE. the routine will return at each
C             iteration of the algorithm with IFLAG=2, and the diagonal
C              matrix Hk0  must be provided in the array DIAG.
C 
C 
C     DIAG    is a DOUBLE PRECISION array of length N. If DIAGCO=.TRUE.,
C             then on initial entry or on re-entry with IFLAG=2, DIAG
C             it must be set by the user to contain the values of the 
C             diagonal matrix Hk0.  Restriction: all elements of DIAG
C             must be positive.
C 
C     IPRINT  is an INTEGER array of length two which must be set by the
C             user.
C 
C             IPRINT(1) specifies the frequency of the output:
C                IPRINT(1) < 0 : no output is generated,
C                IPRINT(1) = 0 : output only at first and last iteration,
C                IPRINT(1) > 0 : output every IPRINT(1) iterations.
C 
C             IPRINT(2) specifies the type of output generated:
C                IPRINT(2) = 0 : iteration count, number of function 
C                                evaluations, function value, norm of the
C                                gradient, and steplength,
C                IPRINT(2) = 1 : same as IPRINT(2)=0, plus vector of
C                                variables and  gradient vector at the
C                                initial point,
C                IPRINT(2) = 2 : same as IPRINT(2)=1, plus vector of
C                                variables,
C                IPRINT(2) = 3 : same as IPRINT(2)=2, plus gradient vector.
C 
C 
C     EPS     is a positive DOUBLE PRECISION variable that must be set by
C             the user, and determines the accuracy with which the solution
C             is to be found. The subroutine terminates when
C
C                         ||G|| < EPS max(1,||X||),
C
C             where ||.|| denotes the Euclidean norm.
C 
C     XTOL    is a  positive DOUBLE PRECISION variable that must be set by
C             the user to an estimate of the machine precision (e.g.
C             10**(-16) on a SUN station 3/60). The line search routine will
C             terminate if the relative width of the interval of uncertainty
C             is less than XTOL.
C 
C     W       is a DOUBLE PRECISION array of length N(2M+1)+2M used as
C             workspace for LBFGS. This array must not be altered by the
C             user.
C 
C     IFLAG   is an INTEGER variable that must be set to 0 on initial entry
C             to the subroutine. A return with IFLAG<0 indicates an error,
C             and IFLAG=0 indicates that the routine has terminated without
C             detecting errors. On a return with IFLAG=1, the user must
C             evaluate the function F and gradient G. On a return with
C             IFLAG=2, the user must provide the diagonal matrix Hk0.
C 
C             The following negative values of IFLAG, detecting an error,
C             are possible:
C 
C              IFLAG=-1  The line search routine MCSRCH failed. The
C                        parameter INFO provides more detailed information
C                        (see also the documentation of MCSRCH):
C
C                       INFO = 0  IMPROPER INPUT PARAMETERS.
C
C                       INFO = 2  RELATIVE WIDTH OF THE INTERVAL OF
C                                 UNCERTAINTY IS AT MOST XTOL.
C
C                       INFO = 3  MORE THAN 20 FUNCTION EVALUATIONS WERE
C                                 REQUIRED AT THE PRESENT ITERATION.
C
C                       INFO = 4  THE STEP IS TOO SMALL.
C
C                       INFO = 5  THE STEP IS TOO LARGE.
C
C                       INFO = 6  ROUNDING ERRORS PREVENT FURTHER PROGRESS. 
C                                 THERE MAY NOT BE A STEP WHICH SATISFIES
C                                 THE SUFFICIENT DECREASE AND CURVATURE
C                                 CONDITIONS. TOLERANCES MAY BE TOO SMALL.
C
C 
C              IFLAG=-2  The i-th diagonal element of the diagonal inverse
C                        Hessian approximation, given in DIAG, is not
C                        positive.
C           
C              IFLAG=-3  Improper input parameters for LBFGS (N or M are
C                        not positive).
C 
C
C
C    ON THE DRIVER:
C
C    The program that calls LBFGS must contain the declaration:
C
C                       EXTERNAL LB2
C
C    LB2 is a BLOCK DATA that defines the default values of several
C    parameters described in the COMMON section. 
C
C 
C 
C    COMMON:
C 
C     The subroutine contains one common area, which the user may wish to
C    reference:
C 
         COMMON /LB3/MP,LP,GTOL,STPMIN,STPMAX
C 
C    MP  is an INTEGER variable with default value 6. It is used as the
C        unit number for the printing of the monitoring information
C        controlled by IPRINT.
C 
C    LP  is an INTEGER variable with default value 6. It is used as the
C        unit number for the printing of error messages. This printing
C        may be suppressed by setting LP to a non-positive value.
C 
C    GTOL is a DOUBLE PRECISION variable with default value 0.9, which
C        controls the accuracy of the line search routine MCSRCH. If the
C        function and gradient evaluations are inexpensive with respect
C        to the cost of the iteration (which is sometimes the case when
C        solving very large problems) it may be advantageous to set GTOL
C        to a small value. A typical small value is 0.1.  Restriction:
C        GTOL should be greater than 1.D-04.
C 
C    STPMIN and STPMAX are non-negative DOUBLE PRECISION variables which
C        specify lower and uper bounds for the step in the line search.
C        Their default values are 1.D-20 and 1.D+20, respectively. These
C        values need not be modified unless the exponents are too large
C        for the machine being used, or unless the problem is extremely
C        badly scaled (in which case the exponents should be increased).
C 
C
C  MACHINE DEPENDENCIES
C
C        The only variables that are machine-dependent are XTOL,
C        STPMIN and STPMAX.
C 
C
C  GENERAL INFORMATION
C 
C    Other routines called directly:  DAXPY, DDOT, LB1, MCSRCH
C 
C    Input/Output  :  No input; diagnostic messages on unit MP and
C                     error messages on unit LP.
C 
C 
C     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
      DOUBLE PRECISION GTOL,ONE,ZERO,GNORM,DDOT,STP1,FTOL,STPMIN,
     .                 STPMAX,STP,YS,YY,SQ,YR,BETA,XNORM
      INTEGER MP,LP,ITER,NFUN,POINT,ISPT,IYPT,MAXFEV,INFO,
     .        BOUND,NPT,CP,I,NFEV,INMC,IYCN,ISCN
      LOGICAL FINISH
C
      SAVE
      DATA ONE,ZERO/1.0D+0,0.0D+0/
C
C     INITIALIZE
C     ----------
C
      IF(IFLAG.EQ.0) GO TO 10
      GO TO (172,100) IFLAG
  10  ITER= 0
      IF(N.LE.0.OR.M.LE.0) GO TO 196
      IF(GTOL.LE.1.D-04) THEN
        IF(LP.GT.0) WRITE(LP,245)
        GTOL=9.D-01
      ENDIF
      NFUN= 1
      POINT= 0
      FINISH= .FALSE.
      IF(DIAGCO) THEN
         DO 30 I=1,N
 30      IF (DIAG(I).LE.ZERO) GO TO 195
      ELSE
         DO 40 I=1,N
 40      DIAG(I)= 1.0D0
      ENDIF
C
C     THE WORK VECTOR W IS DIVIDED AS FOLLOWS:
C     ---------------------------------------
C     THE FIRST N LOCATIONS ARE USED TO STORE THE GRADIENT AND
C         OTHER TEMPORARY INFORMATION.
C     LOCATIONS (N+1)...(N+M) STORE THE SCALARS RHO.
C     LOCATIONS (N+M+1)...(N+2M) STORE THE NUMBERS ALPHA USED
C         IN THE FORMULA THAT COMPUTES H*G.
C     LOCATIONS (N+2M+1)...(N+2M+NM) STORE THE LAST M SEARCH
C         STEPS.
C     LOCATIONS (N+2M+NM+1)...(N+2M+2NM) STORE THE LAST M
C         GRADIENT DIFFERENCES.
C
C     THE SEARCH STEPS AND GRADIENT DIFFERENCES ARE STORED IN A
C     CIRCULAR ORDER CONTROLLED BY THE PARAMETER POINT.
C
      ISPT= N+2*M
      IYPT= ISPT+N*M     
      DO 50 I=1,N
 50   W(ISPT+I)= -G(I)*DIAG(I)
      GNORM= DSQRT(DDOT(N,G,1,G,1))
      STP1= ONE/GNORM
C
C     PARAMETERS FOR LINE SEARCH ROUTINE
C     
      FTOL= 1.0D-4
      MAXFEV= 20
C
      IF(IPRINT(1).GE.0) CALL LB1(IPRINT,ITER,NFUN,
     *                     GNORM,N,M,X,F,G,STP,FINISH)
C
C    --------------------
C     MAIN ITERATION LOOP
C    --------------------
C
 80   ITER= ITER+1
      INFO=0
      BOUND=ITER-1
      IF(ITER.EQ.1) GO TO 165
      IF (ITER .GT. M)BOUND=M
C
         YS= DDOT(N,W(IYPT+NPT+1),1,W(ISPT+NPT+1),1)
      IF(.NOT.DIAGCO) THEN
         YY= DDOT(N,W(IYPT+NPT+1),1,W(IYPT+NPT+1),1)
         DO 90 I=1,N
   90    DIAG(I)= YS/YY
      ELSE
         IFLAG=2
         RETURN
      ENDIF
 100  CONTINUE
      IF(DIAGCO) THEN
        DO 110 I=1,N
 110    IF (DIAG(I).LE.ZERO) GO TO 195
      ENDIF
C
C     COMPUTE -H*G USING THE FORMULA GIVEN IN: Nocedal, J. 1980,
C     "Updating quasi-Newton matrices with limited storage",
C     Mathematics of Computation, Vol.24, No.151, pp. 773-782.
C     ---------------------------------------------------------
C
      CP= POINT
      IF (POINT.EQ.0) CP=M
      W(N+CP)= ONE/YS
      DO 112 I=1,N
 112  W(I)= -G(I)
      CP= POINT
      DO 125 I= 1,BOUND
         CP=CP-1
         IF (CP.EQ. -1)CP=M-1
         SQ= DDOT(N,W(ISPT+CP*N+1),1,W,1)
         INMC=N+M+CP+1
         IYCN=IYPT+CP*N
         W(INMC)= W(N+CP+1)*SQ
         CALL DAXPY(N,-W(INMC),W(IYCN+1),1,W,1)
 125  CONTINUE
C
      DO 130 I=1,N
 130  W(I)=DIAG(I)*W(I)
C
      DO 145 I=1,BOUND
         YR= DDOT(N,W(IYPT+CP*N+1),1,W,1)
         BETA= W(N+CP+1)*YR
         INMC=N+M+CP+1
         BETA= W(INMC)-BETA
         ISCN=ISPT+CP*N
         CALL DAXPY(N,BETA,W(ISCN+1),1,W,1)
         CP=CP+1
         IF (CP.EQ.M)CP=0
 145  CONTINUE
C
C     STORE THE NEW SEARCH DIRECTION
C     ------------------------------
C
       DO 160 I=1,N
 160   W(ISPT+POINT*N+I)= W(I)
C
C     OBTAIN THE ONE-DIMENSIONAL MINIMIZER OF THE FUNCTION 
C     BY USING THE LINE SEARCH ROUTINE MCSRCH
C     ----------------------------------------------------
 165  NFEV=0
      STP=ONE
      IF (ITER.EQ.1) STP=STP1
      DO 170 I=1,N
 170  W(I)=G(I)
 172  CONTINUE
      CALL MCSRCH(N,X,F,G,W(ISPT+POINT*N+1),STP,FTOL,
     *            XTOL,MAXFEV,INFO,NFEV,DIAG)
      IF (INFO .EQ. -1) THEN
        IFLAG=1
        RETURN
      ENDIF
      IF (INFO .NE. 1) GO TO 190
      NFUN= NFUN + NFEV
C
C     COMPUTE THE NEW STEP AND GRADIENT CHANGE 
C     -----------------------------------------
C
      NPT=POINT*N
      DO 175 I=1,N
      W(ISPT+NPT+I)= STP*W(ISPT+NPT+I)
 175  W(IYPT+NPT+I)= G(I)-W(I)
      POINT=POINT+1
      IF (POINT.EQ.M)POINT=0
C
C     TERMINATION TEST
C     ----------------
C
      GNORM= DSQRT(DDOT(N,G,1,G,1))
      XNORM= DSQRT(DDOT(N,X,1,X,1))
      XNORM= DMAX1(1.0D0,XNORM)
      IF (GNORM/XNORM .LE. EPS) FINISH=.TRUE.
C
      IF(IPRINT(1).GE.0) CALL LB1(IPRINT,ITER,NFUN,
     *               GNORM,N,M,X,F,G,STP,FINISH)
      IF (FINISH) THEN
         IFLAG=0
         RETURN
      ENDIF
      GO TO 80
C
C     ------------------------------------------------------------
C     END OF MAIN ITERATION LOOP. ERROR EXITS.
C     ------------------------------------------------------------
C
 190  IFLAG=-1
      IF(LP.GT.0) WRITE(LP,200) INFO
      RETURN
 195  IFLAG=-2
      IF(LP.GT.0) WRITE(LP,235) I
      RETURN
 196  IFLAG= -3
      IF(LP.GT.0) WRITE(LP,240)
C
C     FORMATS
C     -------
C
 200  FORMAT(/' IFLAG= -1 ',/' LINE SEARCH FAILED. SEE'
     .          ' DOCUMENTATION OF ROUTINE MCSRCH',/' ERROR RETURN'
     .          ' OF LINE SEARCH: INFO= ',I2,/
     .          ' POSSIBLE CAUSES: FUNCTION OR GRADIENT ARE INCORRECT',/,
     .          ' OR INCORRECT TOLERANCES')
 235  FORMAT(/' IFLAG= -2',/' THE',I5,'-TH DIAGONAL ELEMENT OF THE',/,
     .       ' INVERSE HESSIAN APPROXIMATION IS NOT POSITIVE')
 240  FORMAT(/' IFLAG= -3',/' IMPROPER INPUT PARAMETERS (N OR M',
     .       ' ARE NOT POSITIVE)')
 245  FORMAT(/'  GTOL IS LESS THAN OR EQUAL TO 1.D-04',
     .       / ' IT HAS BEEN RESET TO 9.D-01')
      RETURN
      END
C
C     LAST LINE OF SUBROUTINE LBFGS
C
C
      SUBROUTINE LB1(IPRINT,ITER,NFUN,
     *                     GNORM,N,M,X,F,G,STP,FINISH)
C
C     -------------------------------------------------------------
C     THIS ROUTINE PRINTS MONITORING INFORMATION. THE FREQUENCY AND
C     AMOUNT OF OUTPUT ARE CONTROLLED BY IPRINT.
C     -------------------------------------------------------------
C
      INTEGER IPRINT(2),ITER,NFUN,LP,MP,N,M
      DOUBLE PRECISION X(N),G(N),F,GNORM,STP,GTOL,STPMIN,STPMAX
      LOGICAL FINISH
      COMMON /LB3/MP,LP,GTOL,STPMIN,STPMAX
C
      IF (ITER.EQ.0)THEN
           WRITE(MP,10)
           WRITE(MP,20) N,M
           WRITE(MP,30)F,GNORM
                 IF (IPRINT(2).GE.1)THEN
                     WRITE(MP,40)
                     WRITE(MP,50) (X(I),I=1,N)
                     WRITE(MP,60)
                     WRITE(MP,50) (G(I),I=1,N)
                  ENDIF
           WRITE(MP,10)
           WRITE(MP,70)
      ELSE
          IF ((IPRINT(1).EQ.0).AND.(ITER.NE.1.AND..NOT.FINISH))RETURN
              IF (IPRINT(1).NE.0)THEN
                   IF(MOD(ITER-1,IPRINT(1)).EQ.0.OR.FINISH)THEN
                         IF(IPRINT(2).GT.1.AND.ITER.GT.1) WRITE(MP,70)
                         WRITE(MP,80)ITER,NFUN,F,GNORM,STP
                   ELSE
                         RETURN
                   ENDIF
              ELSE
                   IF( IPRINT(2).GT.1.AND.FINISH) WRITE(MP,70)
                   WRITE(MP,80)ITER,NFUN,F,GNORM,STP
              ENDIF
              IF (IPRINT(2).EQ.2.OR.IPRINT(2).EQ.3)THEN
                    IF (FINISH)THEN
                        WRITE(MP,90)
                    ELSE
                        WRITE(MP,40)
                    ENDIF
                      WRITE(MP,50)(X(I),I=1,N)
                  IF (IPRINT(2).EQ.3)THEN
                      WRITE(MP,60)
                      WRITE(MP,50)(G(I),I=1,N)
                  ENDIF
              ENDIF
            IF (FINISH) WRITE(MP,100)
      ENDIF
C
 10   FORMAT('*************************************************')
 20   FORMAT('  N=',I5,'   NUMBER OF CORRECTIONS=',I2,
     .       /,  '       INITIAL VALUES')
 30   FORMAT(' F= ',1PD10.3,'   GNORM= ',1PD10.3)
 40   FORMAT(' VECTOR X= ')
 50   FORMAT(6(2X,1PD10.3))
 60   FORMAT(' GRADIENT VECTOR G= ')
 70   FORMAT(/'   I   NFN',4X,'FUNC',8X,'GNORM',7X,'STEPLENGTH'/)
 80   FORMAT(2(I4,1X),3X,3(1PD10.3,2X))
 90   FORMAT(' FINAL POINT X= ')
 100  FORMAT(/' THE MINIMIZATION TERMINATED WITHOUT DETECTING ERRORS.',
     .       /' IFLAG = 0')
C
      RETURN
      END
C     ******
C
C
C   ----------------------------------------------------------
C     DATA 
C   ----------------------------------------------------------
C
      BLOCK DATA LB2
      INTEGER LP,MP
      DOUBLE PRECISION GTOL,STPMIN,STPMAX
      COMMON /LB3/MP,LP,GTOL,STPMIN,STPMAX
      DATA MP,LP,GTOL,STPMIN,STPMAX/6,6,9.0D-01,1.0D-20,1.0D+20/
      END
C
C
C   ----------------------------------------------------------
C
C    ------------------------------------------------------------------
C
C     **************************
C     LINE SEARCH ROUTINE MCSRCH
C     **************************
C
      SUBROUTINE MCSRCH(N,X,F,G,S,STP,FTOL,XTOL,MAXFEV,INFO,NFEV,WA)
      INTEGER N,MAXFEV,INFO,NFEV
      DOUBLE PRECISION F,STP,FTOL,GTOL,XTOL,STPMIN,STPMAX
      DOUBLE PRECISION X(N),G(N),S(N),WA(N)
      COMMON /LB3/MP,LP,GTOL,STPMIN,STPMAX
      SAVE
C
C                     SUBROUTINE MCSRCH
C                
C     A slight modification of the subroutine CSRCH of More' and Thuente.
C     The changes are to allow reverse communication, and do not affect
C     the performance of the routine. 
C
C     THE PURPOSE OF MCSRCH IS TO FIND A STEP WHICH SATISFIES
C     A SUFFICIENT DECREASE CONDITION AND A CURVATURE CONDITION.
C
C     AT EACH STAGE THE SUBROUTINE UPDATES AN INTERVAL OF
C     UNCERTAINTY WITH ENDPOINTS STX AND STY. THE INTERVAL OF
C     UNCERTAINTY IS INITIALLY CHOSEN SO THAT IT CONTAINS A
C     MINIMIZER OF THE MODIFIED FUNCTION
C
C          F(X+STP*S) - F(X) - FTOL*STP*(GRADF(X)'S).
C
C     IF A STEP IS OBTAINED FOR WHICH THE MODIFIED FUNCTION
C     HAS A NONPOSITIVE FUNCTION VALUE AND NONNEGATIVE DERIVATIVE,
C     THEN THE INTERVAL OF UNCERTAINTY IS CHOSEN SO THAT IT
C     CONTAINS A MINIMIZER OF F(X+STP*S).
C
C     THE ALGORITHM IS DESIGNED TO FIND A STEP WHICH SATISFIES
C     THE SUFFICIENT DECREASE CONDITION
C
C           F(X+STP*S) .LE. F(X) + FTOL*STP*(GRADF(X)'S),
C
C     AND THE CURVATURE CONDITION
C
C           ABS(GRADF(X+STP*S)'S)) .LE. GTOL*ABS(GRADF(X)'S).
C
C     IF FTOL IS LESS THAN GTOL AND IF, FOR EXAMPLE, THE FUNCTION
C     IS BOUNDED BELOW, THEN THERE IS ALWAYS A STEP WHICH SATISFIES
C     BOTH CONDITIONS. IF NO STEP CAN BE FOUND WHICH SATISFIES BOTH
C     CONDITIONS, THEN THE ALGORITHM USUALLY STOPS WHEN ROUNDING
C     ERRORS PREVENT FURTHER PROGRESS. IN THIS CASE STP ONLY
C     SATISFIES THE SUFFICIENT DECREASE CONDITION.
C
C     THE SUBROUTINE STATEMENT IS
C
C        SUBROUTINE MCSRCH(N,X,F,G,S,STP,FTOL,XTOL, MAXFEV,INFO,NFEV,WA)
C     WHERE
C
C       N IS A POSITIVE INTEGER INPUT VARIABLE SET TO THE NUMBER
C         OF VARIABLES.
C
C       X IS AN ARRAY OF LENGTH N. ON INPUT IT MUST CONTAIN THE
C         BASE POINT FOR THE LINE SEARCH. ON OUTPUT IT CONTAINS
C         X + STP*S.
C
C       F IS A VARIABLE. ON INPUT IT MUST CONTAIN THE VALUE OF F
C         AT X. ON OUTPUT IT CONTAINS THE VALUE OF F AT X + STP*S.
C
C       G IS AN ARRAY OF LENGTH N. ON INPUT IT MUST CONTAIN THE
C         GRADIENT OF F AT X. ON OUTPUT IT CONTAINS THE GRADIENT
C         OF F AT X + STP*S.
C
C       S IS AN INPUT ARRAY OF LENGTH N WHICH SPECIFIES THE
C         SEARCH DIRECTION.
C
C       STP IS A NONNEGATIVE VARIABLE. ON INPUT STP CONTAINS AN
C         INITIAL ESTIMATE OF A SATISFACTORY STEP. ON OUTPUT
C         STP CONTAINS THE FINAL ESTIMATE.
C
C       FTOL AND GTOL ARE NONNEGATIVE INPUT VARIABLES. (In this reverse
C         communication implementation GTOL is defined in a COMMON
C         statement.) TERMINATION OCCURS WHEN THE SUFFICIENT DECREASE
C         CONDITION AND THE DIRECTIONAL DERIVATIVE CONDITION ARE
C         SATISFIED.
C
C       XTOL IS A NONNEGATIVE INPUT VARIABLE. TERMINATION OCCURS
C         WHEN THE RELATIVE WIDTH OF THE INTERVAL OF UNCERTAINTY
C         IS AT MOST XTOL.
C
C       STPMIN AND STPMAX ARE NONNEGATIVE INPUT VARIABLES WHICH
C         SPECIFY LOWER AND UPPER BOUNDS FOR THE STEP. (In this reverse
C         communication implementatin they are defined in a COMMON
C         statement).
C
C       MAXFEV IS A POSITIVE INTEGER INPUT VARIABLE. TERMINATION
C         OCCURS WHEN THE NUMBER OF CALLS TO FCN IS AT LEAST
C         MAXFEV BY THE END OF AN ITERATION.
C
C       INFO IS AN INTEGER OUTPUT VARIABLE SET AS FOLLOWS:
C
C         INFO = 0  IMPROPER INPUT PARAMETERS.
C
C         INFO =-1  A RETURN IS MADE TO COMPUTE THE FUNCTION AND GRADIENT.
C
C         INFO = 1  THE SUFFICIENT DECREASE CONDITION AND THE
C                   DIRECTIONAL DERIVATIVE CONDITION HOLD.
C
C         INFO = 2  RELATIVE WIDTH OF THE INTERVAL OF UNCERTAINTY
C                   IS AT MOST XTOL.
C
C         INFO = 3  NUMBER OF CALLS TO FCN HAS REACHED MAXFEV.
C
C         INFO = 4  THE STEP IS AT THE LOWER BOUND STPMIN.
C
C         INFO = 5  THE STEP IS AT THE UPPER BOUND STPMAX.
C
C         INFO = 6  ROUNDING ERRORS PREVENT FURTHER PROGRESS.
C                   THERE MAY NOT BE A STEP WHICH SATISFIES THE
C                   SUFFICIENT DECREASE AND CURVATURE CONDITIONS.
C                   TOLERANCES MAY BE TOO SMALL.
C
C       NFEV IS AN INTEGER OUTPUT VARIABLE SET TO THE NUMBER OF
C         CALLS TO FCN.
C
C       WA IS A WORK ARRAY OF LENGTH N.
C
C     SUBPROGRAMS CALLED
C
C       MCSTEP
C
C       FORTRAN-SUPPLIED...ABS,MAX,MIN
C
C     ARGONNE NATIONAL LABORATORY. MINPACK PROJECT. JUNE 1983
C     JORGE J. MORE', DAVID J. THUENTE
C
C     **********
      INTEGER INFOC,J
      LOGICAL BRACKT,STAGE1
      DOUBLE PRECISION DG,DGM,DGINIT,DGTEST,DGX,DGXM,DGY,DGYM,
     *       FINIT,FTEST1,FM,FX,FXM,FY,FYM,P5,P66,STX,STY,
     *       STMIN,STMAX,WIDTH,WIDTH1,XTRAPF,ZERO
      DATA P5,P66,XTRAPF,ZERO /0.5D0,0.66D0,4.0D0,0.0D0/
      IF(INFO.EQ.-1) GO TO 45
      INFOC = 1
C
C     CHECK THE INPUT PARAMETERS FOR ERRORS.
C
      IF (N .LE. 0 .OR. STP .LE. ZERO .OR. FTOL .LT. ZERO .OR.
     *    GTOL .LT. ZERO .OR. XTOL .LT. ZERO .OR. STPMIN .LT. ZERO
     *    .OR. STPMAX .LT. STPMIN .OR. MAXFEV .LE. 0) RETURN
C
C     COMPUTE THE INITIAL GRADIENT IN THE SEARCH DIRECTION
C     AND CHECK THAT S IS A DESCENT DIRECTION.
C
      DGINIT = ZERO
      DO 10 J = 1, N
         DGINIT = DGINIT + G(J)*S(J)
   10    CONTINUE
      IF (DGINIT .GE. ZERO) then
         write(LP,15)
   15    FORMAT(/'  THE SEARCH DIRECTION IS NOT A DESCENT DIRECTION')
         RETURN
         ENDIF
C
C     INITIALIZE LOCAL VARIABLES.
C
      BRACKT = .FALSE.
      STAGE1 = .TRUE.
      NFEV = 0
      FINIT = F
      DGTEST = FTOL*DGINIT
      WIDTH = STPMAX - STPMIN
      WIDTH1 = WIDTH/P5
      DO 20 J = 1, N
         WA(J) = X(J)
   20    CONTINUE
C
C     THE VARIABLES STX, FX, DGX CONTAIN THE VALUES OF THE STEP,
C     FUNCTION, AND DIRECTIONAL DERIVATIVE AT THE BEST STEP.
C     THE VARIABLES STY, FY, DGY CONTAIN THE VALUE OF THE STEP,
C     FUNCTION, AND DERIVATIVE AT THE OTHER ENDPOINT OF
C     THE INTERVAL OF UNCERTAINTY.
C     THE VARIABLES STP, F, DG CONTAIN THE VALUES OF THE STEP,
C     FUNCTION, AND DERIVATIVE AT THE CURRENT STEP.
C
      STX = ZERO
      FX = FINIT
      DGX = DGINIT
      STY = ZERO
      FY = FINIT
      DGY = DGINIT
C
C     START OF ITERATION.
C
   30 CONTINUE
C
C        SET THE MINIMUM AND MAXIMUM STEPS TO CORRESPOND
C        TO THE PRESENT INTERVAL OF UNCERTAINTY.
C
         IF (BRACKT) THEN
            STMIN = MIN(STX,STY)
            STMAX = MAX(STX,STY)
         ELSE
            STMIN = STX
            STMAX = STP + XTRAPF*(STP - STX)
            END IF
C
C        FORCE THE STEP TO BE WITHIN THE BOUNDS STPMAX AND STPMIN.
C
         STP = MAX(STP,STPMIN)
         STP = MIN(STP,STPMAX)
C
C        IF AN UNUSUAL TERMINATION IS TO OCCUR THEN LET
C        STP BE THE LOWEST POINT OBTAINED SO FAR.
C
         IF ((BRACKT .AND. (STP .LE. STMIN .OR. STP .GE. STMAX))
     *      .OR. NFEV .GE. MAXFEV-1 .OR. INFOC .EQ. 0
     *      .OR. (BRACKT .AND. STMAX-STMIN .LE. XTOL*STMAX)) STP = STX
C
C        EVALUATE THE FUNCTION AND GRADIENT AT STP
C        AND COMPUTE THE DIRECTIONAL DERIVATIVE.
C        We return to main program to obtain F and G.
C
         DO 40 J = 1, N
            X(J) = WA(J) + STP*S(J)
   40       CONTINUE
         INFO=-1
         RETURN
C
   45    INFO=0
         NFEV = NFEV + 1
         DG = ZERO
         DO 50 J = 1, N
            DG = DG + G(J)*S(J)
   50       CONTINUE
         FTEST1 = FINIT + STP*DGTEST
C
C        TEST FOR CONVERGENCE.
C
         IF ((BRACKT .AND. (STP .LE. STMIN .OR. STP .GE. STMAX))
     *      .OR. INFOC .EQ. 0) INFO = 6
         IF (STP .EQ. STPMAX .AND.
     *       F .LE. FTEST1 .AND. DG .LE. DGTEST) INFO = 5
         IF (STP .EQ. STPMIN .AND.
     *       (F .GT. FTEST1 .OR. DG .GE. DGTEST)) INFO = 4
         IF (NFEV .GE. MAXFEV) INFO = 3
         IF (BRACKT .AND. STMAX-STMIN .LE. XTOL*STMAX) INFO = 2
         IF (F .LE. FTEST1 .AND. ABS(DG) .LE. GTOL*(-DGINIT)) INFO = 1
C
C        CHECK FOR TERMINATION.
C
         IF (INFO .NE. 0) RETURN
C
C        IN THE FIRST STAGE WE SEEK A STEP FOR WHICH THE MODIFIED
C        FUNCTION HAS A NONPOSITIVE VALUE AND NONNEGATIVE DERIVATIVE.
C
         IF (STAGE1 .AND. F .LE. FTEST1 .AND.
     *       DG .GE. MIN(FTOL,GTOL)*DGINIT) STAGE1 = .FALSE.
C
C        A MODIFIED FUNCTION IS USED TO PREDICT THE STEP ONLY IF
C        WE HAVE NOT OBTAINED A STEP FOR WHICH THE MODIFIED
C        FUNCTION HAS A NONPOSITIVE FUNCTION VALUE AND NONNEGATIVE
C        DERIVATIVE, AND IF A LOWER FUNCTION VALUE HAS BEEN
C        OBTAINED BUT THE DECREASE IS NOT SUFFICIENT.
C
         IF (STAGE1 .AND. F .LE. FX .AND. F .GT. FTEST1) THEN
C
C           DEFINE THE MODIFIED FUNCTION AND DERIVATIVE VALUES.
C
            FM = F - STP*DGTEST
            FXM = FX - STX*DGTEST
            FYM = FY - STY*DGTEST
            DGM = DG - DGTEST
            DGXM = DGX - DGTEST
            DGYM = DGY - DGTEST
C
C           CALL CSTEP TO UPDATE THE INTERVAL OF UNCERTAINTY
C           AND TO COMPUTE THE NEW STEP.
C
            CALL MCSTEP(STX,FXM,DGXM,STY,FYM,DGYM,STP,FM,DGM,
     *                 BRACKT,STMIN,STMAX,INFOC)
C
C           RESET THE FUNCTION AND GRADIENT VALUES FOR F.
C
            FX = FXM + STX*DGTEST
            FY = FYM + STY*DGTEST
            DGX = DGXM + DGTEST
            DGY = DGYM + DGTEST
         ELSE
C
C           CALL MCSTEP TO UPDATE THE INTERVAL OF UNCERTAINTY
C           AND TO COMPUTE THE NEW STEP.
C
            CALL MCSTEP(STX,FX,DGX,STY,FY,DGY,STP,F,DG,
     *                 BRACKT,STMIN,STMAX,INFOC)
            END IF
C
C        FORCE A SUFFICIENT DECREASE IN THE SIZE OF THE
C        INTERVAL OF UNCERTAINTY.
C
         IF (BRACKT) THEN
            IF (ABS(STY-STX) .GE. P66*WIDTH1)
     *         STP = STX + P5*(STY - STX)
            WIDTH1 = WIDTH
            WIDTH = ABS(STY-STX)
            END IF
C
C        END OF ITERATION.
C
         GO TO 30
C
C     LAST LINE OF SUBROUTINE MCSRCH.
C
      END
      SUBROUTINE MCSTEP(STX,FX,DX,STY,FY,DY,STP,FP,DP,BRACKT,
     *                 STPMIN,STPMAX,INFO)
      INTEGER INFO
      DOUBLE PRECISION STX,FX,DX,STY,FY,DY,STP,FP,DP,STPMIN,STPMAX
      LOGICAL BRACKT,BOUND
C
C     SUBROUTINE MCSTEP
C
C     THE PURPOSE OF MCSTEP IS TO COMPUTE A SAFEGUARDED STEP FOR
C     A LINESEARCH AND TO UPDATE AN INTERVAL OF UNCERTAINTY FOR
C     A MINIMIZER OF THE FUNCTION.
C
C     THE PARAMETER STX CONTAINS THE STEP WITH THE LEAST FUNCTION
C     VALUE. THE PARAMETER STP CONTAINS THE CURRENT STEP. IT IS
C     ASSUMED THAT THE DERIVATIVE AT STX IS NEGATIVE IN THE
C     DIRECTION OF THE STEP. IF BRACKT IS SET TRUE THEN A
C     MINIMIZER HAS BEEN BRACKETED IN AN INTERVAL OF UNCERTAINTY
C     WITH ENDPOINTS STX AND STY.
C
C     THE SUBROUTINE STATEMENT IS
C
C       SUBROUTINE MCSTEP(STX,FX,DX,STY,FY,DY,STP,FP,DP,BRACKT,
C                        STPMIN,STPMAX,INFO)
C
C     WHERE
C
C       STX, FX, AND DX ARE VARIABLES WHICH SPECIFY THE STEP,
C         THE FUNCTION, AND THE DERIVATIVE AT THE BEST STEP OBTAINED
C         SO FAR. THE DERIVATIVE MUST BE NEGATIVE IN THE DIRECTION
C         OF THE STEP, THAT IS, DX AND STP-STX MUST HAVE OPPOSITE
C         SIGNS. ON OUTPUT THESE PARAMETERS ARE UPDATED APPROPRIATELY.
C
C       STY, FY, AND DY ARE VARIABLES WHICH SPECIFY THE STEP,
C         THE FUNCTION, AND THE DERIVATIVE AT THE OTHER ENDPOINT OF
C         THE INTERVAL OF UNCERTAINTY. ON OUTPUT THESE PARAMETERS ARE
C         UPDATED APPROPRIATELY.
C
C       STP, FP, AND DP ARE VARIABLES WHICH SPECIFY THE STEP,
C         THE FUNCTION, AND THE DERIVATIVE AT THE CURRENT STEP.
C         IF BRACKT IS SET TRUE THEN ON INPUT STP MUST BE
C         BETWEEN STX AND STY. ON OUTPUT STP IS SET TO THE NEW STEP.
C
C       BRACKT IS A LOGICAL VARIABLE WHICH SPECIFIES IF A MINIMIZER
C         HAS BEEN BRACKETED. IF THE MINIMIZER HAS NOT BEEN BRACKETED
C         THEN ON INPUT BRACKT MUST BE SET FALSE. IF THE MINIMIZER
C         IS BRACKETED THEN ON OUTPUT BRACKT IS SET TRUE.
C
C       STPMIN AND STPMAX ARE INPUT VARIABLES WHICH SPECIFY LOWER
C         AND UPPER BOUNDS FOR THE STEP.
C
C       INFO IS AN INTEGER OUTPUT VARIABLE SET AS FOLLOWS:
C         IF INFO = 1,2,3,4,5, THEN THE STEP HAS BEEN COMPUTED
C         ACCORDING TO ONE OF THE FIVE CASES BELOW. OTHERWISE
C         INFO = 0, AND THIS INDICATES IMPROPER INPUT PARAMETERS.
C
C     SUBPROGRAMS CALLED
C
C       FORTRAN-SUPPLIED ... ABS,MAX,MIN,SQRT
C
C     ARGONNE NATIONAL LABORATORY. MINPACK PROJECT. JUNE 1983
C     JORGE J. MORE', DAVID J. THUENTE
C
      DOUBLE PRECISION GAMMA,P,Q,R,S,SGND,STPC,STPF,STPQ,THETA
      INFO = 0
C
C     CHECK THE INPUT PARAMETERS FOR ERRORS.
C
      IF ((BRACKT .AND. (STP .LE. MIN(STX,STY) .OR.
     *    STP .GE. MAX(STX,STY))) .OR.
     *    DX*(STP-STX) .GE. 0.0 .OR. STPMAX .LT. STPMIN) RETURN
C
C     DETERMINE IF THE DERIVATIVES HAVE OPPOSITE SIGN.
C
      SGND = DP*(DX/ABS(DX))
C
C     FIRST CASE. A HIGHER FUNCTION VALUE.
C     THE MINIMUM IS BRACKETED. IF THE CUBIC STEP IS CLOSER
C     TO STX THAN THE QUADRATIC STEP, THE CUBIC STEP IS TAKEN,
C     ELSE THE AVERAGE OF THE CUBIC AND QUADRATIC STEPS IS TAKEN.
C
      IF (FP .GT. FX) THEN
         INFO = 1
         BOUND = .TRUE.
         THETA = 3*(FX - FP)/(STP - STX) + DX + DP
         S = MAX(ABS(THETA),ABS(DX),ABS(DP))
         GAMMA = S*SQRT((THETA/S)**2 - (DX/S)*(DP/S))
         IF (STP .LT. STX) GAMMA = -GAMMA
         P = (GAMMA - DX) + THETA
         Q = ((GAMMA - DX) + GAMMA) + DP
         R = P/Q
         STPC = STX + R*(STP - STX)
         STPQ = STX + ((DX/((FX-FP)/(STP-STX)+DX))/2)*(STP - STX)
         IF (ABS(STPC-STX) .LT. ABS(STPQ-STX)) THEN
            STPF = STPC
         ELSE
           STPF = STPC + (STPQ - STPC)/2
           END IF
         BRACKT = .TRUE.
C
C     SECOND CASE. A LOWER FUNCTION VALUE AND DERIVATIVES OF
C     OPPOSITE SIGN. THE MINIMUM IS BRACKETED. IF THE CUBIC
C     STEP IS CLOSER TO STX THAN THE QUADRATIC (SECANT) STEP,
C     THE CUBIC STEP IS TAKEN, ELSE THE QUADRATIC STEP IS TAKEN.
C
      ELSE IF (SGND .LT. 0.0) THEN
         INFO = 2
         BOUND = .FALSE.
         THETA = 3*(FX - FP)/(STP - STX) + DX + DP
         S = MAX(ABS(THETA),ABS(DX),ABS(DP))
         GAMMA = S*SQRT((THETA/S)**2 - (DX/S)*(DP/S))
         IF (STP .GT. STX) GAMMA = -GAMMA
         P = (GAMMA - DP) + THETA
         Q = ((GAMMA - DP) + GAMMA) + DX
         R = P/Q
         STPC = STP + R*(STX - STP)
         STPQ = STP + (DP/(DP-DX))*(STX - STP)
         IF (ABS(STPC-STP) .GT. ABS(STPQ-STP)) THEN
            STPF = STPC
         ELSE
            STPF = STPQ
            END IF
         BRACKT = .TRUE.
C
C     THIRD CASE. A LOWER FUNCTION VALUE, DERIVATIVES OF THE
C     SAME SIGN, AND THE MAGNITUDE OF THE DERIVATIVE DECREASES.
C     THE CUBIC STEP IS ONLY USED IF THE CUBIC TENDS TO INFINITY
C     IN THE DIRECTION OF THE STEP OR IF THE MINIMUM OF THE CUBIC
C     IS BEYOND STP. OTHERWISE THE CUBIC STEP IS DEFINED TO BE
C     EITHER STPMIN OR STPMAX. THE QUADRATIC (SECANT) STEP IS ALSO
C     COMPUTED AND IF THE MINIMUM IS BRACKETED THEN THE THE STEP
C     CLOSEST TO STX IS TAKEN, ELSE THE STEP FARTHEST AWAY IS TAKEN.
C
      ELSE IF (ABS(DP) .LT. ABS(DX)) THEN
         INFO = 3
         BOUND = .TRUE.
         THETA = 3*(FX - FP)/(STP - STX) + DX + DP
         S = MAX(ABS(THETA),ABS(DX),ABS(DP))
C
C        THE CASE GAMMA = 0 ONLY ARISES IF THE CUBIC DOES NOT TEND
C        TO INFINITY IN THE DIRECTION OF THE STEP.
C
         GAMMA = S*SQRT(MAX(0.0D0,(THETA/S)**2 - (DX/S)*(DP/S)))
         IF (STP .GT. STX) GAMMA = -GAMMA
         P = (GAMMA - DP) + THETA
         Q = (GAMMA + (DX - DP)) + GAMMA
         R = P/Q
         IF (R .LT. 0.0 .AND. GAMMA .NE. 0.0) THEN
            STPC = STP + R*(STX - STP)
         ELSE IF (STP .GT. STX) THEN
            STPC = STPMAX
         ELSE
            STPC = STPMIN
            END IF
         STPQ = STP + (DP/(DP-DX))*(STX - STP)
         IF (BRACKT) THEN
            IF (ABS(STP-STPC) .LT. ABS(STP-STPQ)) THEN
               STPF = STPC
            ELSE
               STPF = STPQ
               END IF
         ELSE
            IF (ABS(STP-STPC) .GT. ABS(STP-STPQ)) THEN
               STPF = STPC
            ELSE
               STPF = STPQ
               END IF
            END IF
C
C     FOURTH CASE. A LOWER FUNCTION VALUE, DERIVATIVES OF THE
C     SAME SIGN, AND THE MAGNITUDE OF THE DERIVATIVE DOES
C     NOT DECREASE. IF THE MINIMUM IS NOT BRACKETED, THE STEP
C     IS EITHER STPMIN OR STPMAX, ELSE THE CUBIC STEP IS TAKEN.
C
      ELSE
         INFO = 4
         BOUND = .FALSE.
         IF (BRACKT) THEN
            THETA = 3*(FP - FY)/(STY - STP) + DY + DP
            S = MAX(ABS(THETA),ABS(DY),ABS(DP))
            GAMMA = S*SQRT((THETA/S)**2 - (DY/S)*(DP/S))
            IF (STP .GT. STY) GAMMA = -GAMMA
            P = (GAMMA - DP) + THETA
            Q = ((GAMMA - DP) + GAMMA) + DY
            R = P/Q
            STPC = STP + R*(STY - STP)
            STPF = STPC
         ELSE IF (STP .GT. STX) THEN
            STPF = STPMAX
         ELSE
            STPF = STPMIN
            END IF
         END IF
C
C     UPDATE THE INTERVAL OF UNCERTAINTY. THIS UPDATE DOES NOT
C     DEPEND ON THE NEW STEP OR THE CASE ANALYSIS ABOVE.
C
      IF (FP .GT. FX) THEN
         STY = STP
         FY = FP
         DY = DP
      ELSE
         IF (SGND .LT. 0.0) THEN
            STY = STX
            FY = FX
            DY = DX
            END IF
         STX = STP
         FX = FP
         DX = DP
         END IF
C
C     COMPUTE THE NEW STEP AND SAFEGUARD IT.
C
      STPF = MIN(STPMAX,STPF)
      STPF = MAX(STPMIN,STPF)
      STP = STPF
      IF (BRACKT .AND. BOUND) THEN
         IF (STY .GT. STX) THEN
            STP = MIN(STX+0.66*(STY-STX),STP)
         ELSE
            STP = MAX(STX+0.66*(STY-STX),STP)
            END IF
         END IF
      RETURN
C
C     LAST LINE OF SUBROUTINE MCSTEP.
C
      END

!#define _DEBUG_WRITE_
!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 593 $)
!
!  SUBROUINE: Renewal_of_WaveFunctions, Renew_WF_by_lmSDorlmCG,
!             check_new_solver
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!                        J. Koga,  March/01/2010
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
#   define __TIMER_START_w_BARRIER(str,a)
#   define __TIMER_START(a)
#   define __TIMER_STOP(a)
subroutine Renewal_of_WaveFunctions()
! $Id: Renewal_of_WaveFunctions.F90 593 2019-06-20 03:47:31Z jkoga $
  use m_Control_Parameters,   only : m_CtrlP_solver_for_WFs_now &
       &                           , m_CtrlP_On_or_Off_precon_WFs &
       &                           , m_CtrlP_dtim_now &
       &                           , m_CtrlP_clear_nsolver_applied &
       &                           , m_CtrlP_push_SolverNameApplied &
       &                           , m_CtrlP_set_sw_MRCV_only &
       &                           , meg,damp,icond,iprievdff &
       &                           , intzaj,ipri,ipriwf,renew_wf_again_m_CtrlP &
       &                           , sw_ekzaj,ekmode,sw_hubbard &
       &                           , submat_before_renewal, sw_rsb &
       &                           , sw_hybrid_functional
  use m_Const_Parameters,     only : DP,SD,MSD,CG &
       &                           , lmSD, lmMSD, lmCG, lmeazyCG & ! , eazyCG
       &                           , RMM,RMM2,RMM2P,SUBMAT,MATRIXDIAGON &
       &                           , DAVIDSON, MDDAVIDSON, MDKOSUGI &
       &                           , YES, ON, OFF, NO &
       &                           , INITIAL, CONTINUATION, FIXED_CHARGE &
       &                           , FIXED_CHARGE_CONTINUATION &
       &                           , COORDINATE_CONTINUATION,INVERSE,DIRECT
  use m_IterationNumbers,     only : iteration, iteration_electronic, iteration_ionic &
       &                           , m_Iter_set_rmm_start
  use m_Files,                only : nfout
  use m_Ionic_System,         only : natm2
  use m_ES_WF_by_SDorCG,      only : m_ESsd_alloc_wfsd, m_ESsd_dealloc_wfsd 
  use m_ES_WF_by_RMM,         only : m_ESrmm_reset_ng_maxmin &
       &                           , m_ESrmm_reset_r_norm_flag
  use m_Electronic_Structure, only : m_ES_what_is_evdff_now,zaj_l
  use m_ES_IO,                only : m_ESIO_wd_WFs_standardout

  use m_Total_Energy,         only : m_TE_what_is_edeltb_now 
  use m_Charge_Density,       only : m_CD_cp_chgq_to_chgqo
  use m_Orbital_Population,   only : m_OP_cp_ommix_to_omold
  use m_ES_WF_by_submat,      only : m_ESsubmat_Renew_WF, m_ESsubmat_alloc, m_ESsubmat_utransform_wf, disable_utransform
#ifdef __TIMER__
  use m_Parallelization,      only : mpi_comm_group
#endif

#ifndef DISABLE_NONCL
! ================================ added by K. Tagami ================ 11.0
  use m_Control_Parameters,    only : noncol
  use m_ES_WF_by_submat,          only : m_ESsubmat_Renew_WF_noncl
! =================================================================== 11.0
#endif
! === KT_add ====== 13.0U3
  use m_Control_Parameters,   only : precon_hardpart, sw_wf_mixing, wf_mixing_is_active
  use m_ES_WF_mixing,         only : m_ES_WF_cp_zaj_to_zaj_prev
! ================= 13.0U3

  use m_ES_RSB, only : m_ES_RSB_doit,m_ES_RSB_alloc,m_ES_RSB_dealloc
  use m_Kpoints, only : kv3
  use m_ES_ExactExchange, only : m_ES_EXX_gather_valence_states
  use m_Electronic_Structure, only : m_ES_sort_eigen_values

  implicit none
  integer       :: what_is_the_core_solver
  integer       :: isolver, precon, previous_isolver = -100, sw_submat, isolver_core
  integer, save :: is_wfsd_allocated = NO
  real(kind=DP) :: dtim, edeltb_now
#ifdef __TIMER__
  integer :: ierr
#endif
  integer :: ik
  logical :: push_solver=.true.
  logical :: hybfunc=.false.

  !! For EXX test
  !! call m_ES_EXX_update(OFF)

  call m_CtrlP_clear_nsolver_applied()

  if(icond == INITIAL .or. icond == CONTINUATION .or. icond == COORDINATE_CONTINUATION .or. &
       & ((icond==FIXED_CHARGE.or.icond==FIXED_CHARGE_CONTINUATION)&
       &                             .and. ekmode == OFF)   ) then
     edeltb_now = m_TE_what_is_edeltb_now()/natm2
!!$     write(nfout,'(" edeltb_per_atom = ", d20.12)') edeltb_per_atom
  else
     edeltb_now = m_ES_what_is_evdff_now()
  end if
  
  if(iprievdff >= 2) write(nfout,'(" edeltb_now = ",d20.10)') edeltb_now

  isolver = m_CtrlP_solver_for_WFs_now(iteration_electronic,iteration_ionic,intzaj &
       &                              ,edeltb_now, sw_submat)
  call check_new_solver  ! -(contained here) comparing isolver with previous_isolver
  !                        Especially, important for the RMM operation.
!!$  previous_isolver = isolver
! === Merge modifications from phase@63 -> phase@64. 2011/10/18 ================
  precon  = m_CtrlP_On_or_Off_precon_WFs(iteration_electronic,iteration_ionic,isolver)
! ==============================================================================
  dtim = m_CtrlP_dtim_now(iteration_electronic,iteration_ionic)
  if(iprievdff >= 2) write(nfout,'(" iter_elec, dtim = ",i6,f10.4)') &
       & iteration_electronic, dtim

! === Merge modifications from phase@63 -> phase@64. 2011/10/18 ================
#ifdef _DEBUG_WRITE_
  if(ipri>=1) write(nfout,'(" !isolver, precon = ",2i8)') isolver, precon
#endif
! ==============================================================================

  isolver_core = what_is_the_core_solver(isolver) ! -(in this file)
  if(isolver_core == CG .and. is_wfsd_allocated == NO) then
     call m_ESsd_alloc_wfsd()
     is_wfsd_allocated = YES
  else if(isolver_core /= CG .and. is_wfsd_allocated == YES) then
     call m_ESsd_dealloc_wfsd()
     is_wfsd_allocated = NO
  end if

  !! for calc. of Berry phase at the Gamma point only
  !! providing that well converged wavefunctions are supplied from nfzaj file
  if(sw_ekzaj == ON .and. ekmode == ON) then
     if(ipri >= 1) write(nfout,*) &
	& '** Returning from Renewal_of_WaveFunctions for Berry phase calculation with samping the Gamma point only **'
     return
  end if

!!$   select case(isolver)
!!$     case (lmSD, lmMSD, lmCG, lmeazyCG)
!!$        if(iteration_electronic >= 10) then
!!$           if(incre_etot_in_1dsrch >= incre_etot_in_1dsrch_limit) then
!!$              call ReadCheckPointData()
!!$           else if (flag_wdcheckpointdata >= 0) 
!!$           end if
!!$        end if
!!$     end select

!!!!BRANCH_P ORG_Parallel
!!!  if(sw_rsb==ON)then
!!!    call m_ES_RSB_alloc()
!!!    call m_ES_RSB_doit(verbose=.false.)
!!!  endif
!!!!BRANCH_P_END ORG_Parallel

  if(sw_rsb==ON)then
    if(iteration_electronic==1) then
       push_solver=.false.
       call exec_submat_before_or_after()  ! contained here
       push_solver=.true.
    endif
    do ik=1,kv3
       call UnitaryTransform_WF(INVERSE,ik,zaj_l,.false.,.false.)
    enddo
    call m_ES_RSB_alloc()
    call m_ES_RSB_doit(verbose=.false.)
    call m_ES_EXX_gather_valence_states(nfout,.false.)
  endif


!!$ if(submat_before_renewal==ON.and.previous_isolver/=MATRIXDIAGON)then
  if(submat_before_renewal==ON)then
     if((sw_submat == ON .and. &
          & (isolver /= DAVIDSON .and. isolver /= SUBMAT .and.  &
          &  isolver /= MATRIXDIAGON .and. isolver/=MDDAVIDSON .and. isolver /= MDKOSUGI)) &
          & .or.renew_wf_again_m_CtrlP ) then
!!$        if(ipri>=1)write(nfout,'(" !solver doing subspace rotation before WF renewal")')
        call exec_submat_before_or_after()  ! contained here
     end if
  end if

! === KT_add === 13.0U3
  if ( precon_hardpart ) then
     if ( sw_wf_mixing == ON .and. wf_mixing_is_active ) then
        call m_ES_WF_cp_zaj_to_zaj_prev
     endif
  endif
! ============== 13.0U3

  if(hybfunc) sw_hybrid_functional=ON
  solver: select case(isolver)

     case (MATRIXDIAGON)
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,15)
        if(sw_hybrid_functional==ON.and.iteration==1) then
           hybfunc=.true.
           sw_hybrid_functional=OFF 
        endif
        call exec_matdiagon(isolver,iteration,iteration_electronic)
        call cp_chgq_to_chgqo()
                                                  __TIMER_STOP(15)
     case (SD,MSD)
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,12)
      call exec_sd(isolver,iteration,iteration_electronic,precon,dtim)
      call cp_chgq_to_chgqo()
                                                  __TIMER_STOP(12)
     case (lmSD, lmMSD, lmCG, lmeazyCG)
        call exec_lmm(isolver,previous_isolver,precon,dtim)

     case (RMM, RMM2, RMM2P)
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,18)
        call exec_rmm(isolver,previous_isolver,precon,dtim)
        call cp_chgq_to_chgqo()
                                                  __TIMER_STOP(18)

     case (SUBMAT)
        call exec_submat(isolver)
        call cp_chgq_to_chgqo()

     case (DAVIDSON)
        call exec_davidson(isolver,precon)
        call cp_chgq_to_chgqo()

     case (MDDAVIDSON)
        call m_CtrlP_set_sw_MRCV_only(ON)      ! sw_MRCV_only = ON
        call exec_mddavidson(isolver,precon)
        call cp_chgq_to_chgqo()

     case (MDKOSUGI)
        call m_CtrlP_set_sw_MRCV_only(OFF)     ! sw_MRCV_only = OFF
        call exec_mddavidson(isolver,precon)
        call cp_chgq_to_chgqo()

     case default
        if(ipri >= 1) write(6,'(" !! isolver = ",i5)') isolver
        call error
        stop ' error at (Renewal_of_WaveFunctions)'
  end select solver

  if(submat_before_renewal/=ON) then
     if((sw_submat == ON .and.  &
          & (isolver /= DAVIDSON .and. isolver /= SUBMAT .and.  &
          &  isolver /= MATRIXDIAGON .and. isolver/=MDDAVIDSON .and. isolver /= MDKOSUGI)) &
          & .or.renew_wf_again_m_CtrlP) then
        call exec_submat_before_or_after()  ! contained here
     end if
  end if

  previous_isolver = isolver

  call m_ESIO_wd_WFs_standardout(nfout,ipriwf)

contains
  subroutine exec_submat_before_or_after()
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,14)
    if(sw_rsb==ON) disable_utransform = .true.
    if(push_solver) call m_CtrlP_push_SolverNameApplied("SUBMAT",6)
    call m_ESsubmat_alloc()

#ifndef DISABLE_NONCL
! ====================================== modified by K. Tagami =============== 11.0
    if ( noncol ) then
       if ( isolver /= MDKOSUGI .and. isolver /= MDDAVIDSON ) then
          call m_ESsubmat_renew_WF_noncl(nfout,meg,damp)
       endif
    else
#endif
       call m_ESsubmat_renew_WF(nfout,meg,damp)
#ifndef DISABLE_NONCL
    endif
! ============================================================================ 11.0
#endif

    if(sw_rsb==ON) disable_utransform = .false.
                                                  __TIMER_STOP(14)
  end subroutine exec_submat_before_or_after

  subroutine cp_chgq_to_chgqo()
    if(icond == INITIAL .or. icond == CONTINUATION) then
       call m_CD_cp_chgq_to_chgqo()
       if(sw_hubbard == ON) call m_OP_cp_ommix_to_omold()
    end if
  end subroutine cp_chgq_to_chgqo

  subroutine check_new_solver
    ! If "isolver" is not "previous_isolver", the value of "isolver" is printed.
    ! And if "isolver" is RMM?*, "iteration_rmm_start" is set in the module m_IterationNumbers
    !
    if(isolver /= previous_isolver) then
       if(ipri>=2) write(nfout,*) ' isolver = ', isolver
       if(isolver == RMM .or. isolver == RMM2 .or. isolver == RMM2P) then
          call m_Iter_set_rmm_start     ! iteration_rmm_start = iteration_electronic
          if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) &
               &  call m_ESrmm_reset_ng_maxmin()
          if(ipri >= 2) write(nfout,'(" !! iteration_rmm_start is set")')
          call m_ESrmm_reset_r_norm_flag ! ->rr_is_over_or_under(= UNDER)
       end if
    end if
  end subroutine check_new_solver

end subroutine Renewal_of_WaveFunctions

function EigenValue(ilevel)
  use m_Const_Parameters, only     : DP, Hartree
  use m_Electronic_Structure, only : m_ES_get_energy
  real(kind=DP) ::       EigenValue
  integer, intent(in) :: ilevel

  EigenValue = m_ES_get_energy(ilevel)*Hartree  ! energy unit is eV
end function EigenValue

! === EXEC_MATDIAGON ==
subroutine exec_matdiagon(isolver,iteration,iteration_electronic)
  use m_Files,                only : nfout
#ifndef DISABLE_NONCL
  use m_Control_Parameters,   only : noncol
  use m_ES_WF_by_MatDiagon,   only : m_ESmat_solve_Hx_eq_eSx_noncl
#endif
  use m_ES_WF_by_MatDiagon,   only : m_ESmat_solve_Hx_eq_eSx
  implicit none
  integer, intent(in) :: isolver,iteration,iteration_electronic

  call push_solver_name_applied(isolver)

#ifndef DISABLE_NONCL
! ======================================= modified by K. Tagami ============== 11.0
  if ( noncol ) then
     call m_ESmat_solve_Hx_eq_eSx_noncl(nfout,iteration,iteration_electronic)
  else
#endif
     call m_ESmat_solve_Hx_eq_eSx(nfout,iteration,iteration_electronic)
#ifndef DISABLE_NONCL
  endif
#endif
! ============================================================================= 11.0
end subroutine exec_matdiagon

! === EXEC_SD ===
subroutine exec_sd(isolver,iteration,iteration_electronic,precon,dtim)
  use m_Const_Parameters,     only : DP,ON
  use m_Files,                only : nfout
#ifndef DISABLE_NONCL
  use m_Control_Parameters,   only : noncol,sw_rsb
  use m_ES_WF_by_SDorCG,      only : m_ESsd_renew_WF_by_SDorCG_noncl
  use m_Electronic_Structure, only : m_ES_sort_eigen_vals_noncl
#endif
  use m_Electronic_Structure, only : m_ES_sort_eigen_values
  use m_ES_WF_by_SDorCG,      only : m_ESsd_renew_WF_by_SDorCG
  implicit none
  integer, intent(in) :: isolver,precon,iteration,iteration_electronic
  real(kind=DP), intent(in)  :: dtim

  call push_solver_name_applied(isolver)
#ifndef DISABLE_NONCL
! ========================================= modified by K. Tagami ============== 11.0
!         call m_ESsd_renew_WF_by_SDorCG(nfout,isolver,precon,dtim)
!
  if ( noncol ) then
     call m_ESsd_renew_WF_by_SDorCG_noncl(nfout,isolver,precon,dtim)
  else
#endif
     call m_ESsd_renew_WF_by_SDorCG(nfout,isolver,precon,dtim)
#ifndef DISABLE_NONCL
  endif
! =============================================================================== 11.0
#endif

! ------------------- Revised by T. Yamasaki,  21 July 2009 --->>
#ifndef DISABLE_NONCL
! ================================= modified by K. Tagami ============= 11.0
  if ( noncol ) then
     if(sw_rsb/=ON) call m_ES_sort_eigen_vals_noncl()
  else
#endif
     if(sw_rsb/=ON) call m_ES_sort_eigen_values() ! -> neordr, nrvf_ordr
#ifndef DISABLE_NONCL
  endif
! ===================================================================== 11.0
#endif
! <----
end subroutine exec_sd

! === EXEC_LMM ===
subroutine exec_lmm(isolver,previous_isolver,precon,dtim)
  use m_Const_Parameters,     only : DP, DAVIDSON, ON
  use m_Files,                only : nfout
!!$  use m_Control_Parameters,   only : m_CtrlP_dtim_1dsearch_now
  use m_ES_WF_by_SDorCG,      only : m_ESsd_renew_WF_by_SDorCG, m_ESsd_evolve_WFs_again
#ifndef DISABLE_NONCL
  use m_Control_Parameters,   only : noncol, sw_rsb
  use m_ES_WF_by_SDorCG,      only : m_ESsd_renew_WF_by_SDorCG_noncl
  use m_Electronic_Structure, only : m_ES_sort_eigen_vals_noncl
  use m_ES_ortho,             only : m_ES_modified_gramschmidt_noncl
#endif
  use m_Electronic_Structure, only : m_ES_sort_eigen_values
#ifdef MEMORY_SAVE_ZAJ_OLD
  use m_Control_Parameters, only : RMM2P_is_specified
  use m_ES_WF_by_SDorCG,    only : m_ESsd_alloc_zaj_old, m_ESsd_dealloc_zaj_old
#endif
  implicit none
  integer, intent(in) :: isolver,previous_isolver,precon
  real(kind=DP), intent(in)  :: dtim

  call push_solver_name_applied(isolver)
!!$         if(icond == INITIAL .or. icond == CONTINUATION) then
#ifdef MEMORY_SAVE_ZAJ_OLD
  if(.not. RMM2P_is_specified) call m_ESsd_alloc_zaj_old()
#endif

#ifndef DISABLE_NONCL
! ========================================= modified by K. Tagami ============== 11.0
!        call Renew_WF_by_lmSDorlmCG(isolver,precon,dtim)       ! -(contained here)
!
  if ( noncol ) then
     if ( previous_isolver == DAVIDSON ) then
        call m_ES_modified_gramschmidt_noncl(nfout)
     endif
     call Renew_WF_by_lmSDorlmCG_noncl( isolver,precon,dtim )
  else
#endif
     call Renew_WF_by_lmSDorlmCG(isolver,precon,dtim)       ! -(contained here)
#ifndef DISABLE_NONCL
  endif
! ============================================================================== 11.0
#endif
#ifdef MEMORY_SAVE_ZAJ_OLD
  if(.not. RMM2P_is_specified) call m_ESsd_dealloc_zaj_old()
#endif

#ifndef DISABLE_NONCL
! ================================= modified by K. Tagami ============= 11.0
  if ( noncol ) then
     if(sw_rsb/=ON) call m_ES_sort_eigen_vals_noncl()
  else
#endif
     if(sw_rsb/=ON) call m_ES_sort_eigen_values() ! -> neordr, nrvf_ordr
#ifndef DISABLE_NONCL
  endif
! ===================================================================== 11.0
#endif
! <----
                                                  __TIMER_STOP(13)

end subroutine exec_lmm

#ifdef CG_PREVIOUS
subroutine Renew_WF_by_lmSDorlmCG(isolver,precon,dtim)
  use m_Const_Parameters,     only : DP, FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, BAND_ENERGY,CG &
       &                           , ORTHONORMALIZATION, CONTINUATION &
       &                           , TOTAL_ENERGY, MODIFIED_TOTAL_ENERGY, ON, INITIAL, OFF
  use m_Control_Parameters,   only : energy_evaluation, icond, sw_use_wfred, ipri &
       &                           , m_CtrlP_decide_dtim_1Dsearch, m_CtrlP_dtim_1Dsearch_now &
       &                           , sw_hybrid_functional,force_exx_energy1,sw_retard_eigval_evaluation &
       &                           , potential_update, m_CtrlP_set_in_line_minimization
  use m_Files,                only : nfout
  use m_Kpoints,              only : kv3
  use m_ES_WF_by_SDorCG,      only : m_ESsd_evolve_WFs_again &
       &                           , m_ESsd_alloc_wfred, m_ESsd_dealloc_wfred &
       &                           , m_ESsd_copy_zaj_to_zaj_old, m_ESsd_decide_CG_direction &
       &                           , m_ESsd_renew_WF_by_SDorCG   
  use m_Charge_Density,       only : m_CD_cp_chgq_to_chgqo
  use m_Total_Energy,         only : m_TE_tell_total_energy &
       &                           , m_TE_tell_total_energy0 &
       &                           , m_TE_tell_band_energy &
       &                           , m_TE_tell_extended_band_energy
  use m_ES_ExactExchange,     only : m_ES_EXX_store_wfv, m_ES_EXX_restore_wfv
  implicit none
  integer, intent(in)         :: isolver,precon
  real(kind=DP),intent(in)    :: dtim

  real(kind=DP), dimension(3) :: etotal
  real(kind=DP), parameter    :: factor = 2
  real(kind=DP)               :: dtim_new = 0.d0, dtim_msdv
  integer                     :: isolver_core, mode

  integer                     :: energy_evaluation_lmm
  integer                     :: what_is_the_core_solver
  integer                     :: ik

  energy_evaluation_lmm = energy_evaluation
  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) energy_evaluation_lmm = BAND_ENERGY
! <--

  isolver_core = what_is_the_core_solver(isolver) ! -(in this file)

  mode = ORTHONORMALIZATION

! ---------------- Added by T. Yamasaki, 28 June 2008, 31 Oct. 2008 ---
  if(sw_use_wfred == ON) call m_ESsd_alloc_wfred()
! ---------------------------------<<
  call m_ESsd_copy_zaj_to_zaj_old()

  call m_CtrlP_set_in_line_minimization(ON)
!!$  in_line_minimization = .true.

  if(energy_evaluation_lmm == TOTAL_ENERGY) then
     etotal(1) = m_TE_tell_total_energy()
  else if(energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
     etotal(1) = m_TE_tell_total_energy0() - m_TE_tell_band_energy(nfout,kv3) &
          &                                + m_TE_tell_extended_band_energy(nfout,kv3)
  else if(energy_evaluation_lmm == BAND_ENERGY) then
     etotal(1) = m_TE_tell_extended_band_energy(nfout,kv3)
  end if

! ==============================================================================
! === WARN!!! by tkato 2012/02/11                                            ===
! === Right after re-started, the value of "dtim_1Dsearch" is -1             ===
! === and "dtim_msdv" is over-written with "dtim" here.                      ===
! === "dtim_1Dsearch" should be stored into restart file???                  ===
! === -> Resloved on phaseUnif@97 by tkato 2012/02/18                        ===
! === Subroutine m_CtrlP_wd_dtim_previous and m_CtrlP_rd_dtim_previous       ===
! === have been added into m_Control_Parameters.F90.                         ===
! === They write/read "dtim_1Dsearch" to/from "dtim_previous" entry          ===
! === in continue.data.                                                      ===
! ==============================================================================
  dtim_msdv = m_CtrlP_dtim_1Dsearch_now(dtim)
! ==============================================================================
  if(ipri >= 2) write(nfout,'(" !! dtim_msdv = ",f8.4)') dtim_msdv

  if(isolver_core == CG) then
     call m_ESsd_decide_CG_direction(precon)  !  -> betacg
     !    ~~~~~~~~~~~~~~~~~~~~~~~~~~
     call m_ESsd_renew_WF_by_SDorCG(nfout,isolver_core,precon,dtim_msdv,iupdate=0)
     !    ~~~~~~~~~~~~~~~~~~~~~~~~~
  else
     call m_ESsd_renew_WF_by_SDorCG(nfout,isolver_core,precon,dtim_msdv,iupdate=0)
     !    ~~~~~~~~~~~~~~~~~~~~~~~~~
  end if

  if(energy_evaluation_lmm == TOTAL_ENERGY .or. energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
     call m_CD_cp_chgq_to_chgqo()
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,7)
     if(sw_hybrid_functional==ON) call m_ES_EXX_store_wfv()
     call ChargeDensity_Construction(1)
                                                  __TIMER_STOP(7)
     if(energy_evaluation_lmm == TOTAL_ENERGY) then
        etotal(2) = m_TE_tell_total_energy()
     else if(energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
        etotal(2) = m_TE_tell_total_energy0() -  m_TE_tell_band_energy(nfout,kv3) &
             &                                +  m_TE_tell_extended_band_energy(nfout,kv3)
     end if
  else if(energy_evaluation_lmm == BAND_ENERGY) then
     if(icond == INITIAL .or. icond == CONTINUATION) call m_CD_cp_chgq_to_chgqo()
     etotal(2) = m_TE_tell_extended_band_energy(nfout,kv3)
  end if

  call m_ESsd_evolve_WFs_again(nfout,isolver_core,mode,dtim_msdv,factor*dtim_msdv,iupdate=0)
  ! (msdv_grad)

  if(energy_evaluation_lmm == TOTAL_ENERGY .or. energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
     if(sw_hybrid_functional==ON) call m_ES_EXX_restore_wfv()
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,7)
     call ChargeDensity_Construction(1)
                                                  __TIMER_STOP(7)
     if(energy_evaluation_lmm == TOTAL_ENERGY) then
        etotal(3) = m_TE_tell_total_energy()
     else if(energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
        etotal(3) = m_TE_tell_total_energy0() - m_TE_tell_band_energy(nfout,kv3) &
             &                                + m_TE_tell_extended_band_energy(nfout,kv3)
     end if
  else if(energy_evaluation_lmm == BAND_ENERGY) then
     etotal(3) = m_TE_tell_extended_band_energy(nfout,kv3)
  end if

  if(iteration_electronic==1)then
     etotal(1) = etotal(2);etotal(2) = etotal(3)
     call m_ESsd_evolve_WFs_again(nfout,isolver_core,mode,dtim_msdv,factor*dtim_msdv,iupdate=0)
     call ChargeDensity_Construction(1)
     if(energy_evaluation_lmm == TOTAL_ENERGY .or. energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
        call ChargeDensity_Construction(1)
        if(energy_evaluation_lmm == TOTAL_ENERGY) then
           etotal(3) = m_TE_tell_total_energy()
        else if(energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
           etotal(3) = m_TE_tell_total_energy0() - m_TE_tell_band_energy(nfout,kv3) &
                &                                + m_TE_tell_extended_band_energy(nfout,kv3)
        end if
     else if(energy_evaluation_lmm == BAND_ENERGY) then
        etotal(3) = m_TE_tell_extended_band_energy(nfout,kv3)
     end if
  endif

  dtim_new = m_CtrlP_decide_dtim_1Dsearch(nfout,etotal,dtim_msdv,factor)
  if(ipri >= 2) write(nfout,'(" etotal(1:3) = ",3f15.6," dtim_msdv, dtim_new = ",2f15.6)') etotal(1:3), dtim_msdv, dtim_new
  mode = ORTHONORMALIZATION
  if(sw_retard_eigval_evaluation==ON.and.potential_update>0) force_exx_energy1=.true.
! ------------------- Revised by T. Yamasaki,  03 July 2008, 31 Oct 2008 --->>
  if(sw_use_wfred == ON) then
     call m_ESsd_evolve_WFs_again(nfout,isolver_core,mode,dtim_msdv,dtim_new,iupdate=0)
  else
     call m_ESsd_evolve_WFs_again(nfout,isolver_core,mode,factor*dtim_msdv,dtim_new,iupdate=0)
  end if

  call m_CtrlP_set_in_line_minimization(OFF)
!!$  in_line_minimization = .false.

! ------------------------------------------------------------<<
! ---------------- Added by T. Yamasaki, 28 June 2008, 31 Oct. 2008 ---
  if(sw_use_wfred == ON) call m_ESsd_dealloc_wfred()
! ------------------------------------------------------<<
end subroutine Renew_WF_by_lmSDorlmCG
#else

subroutine Renew_WF_by_lmSDorlmCG(isolver,precon,dtim)
  use m_Const_Parameters,     only : DP, FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, BAND_ENERGY &
       &                           , ORTHONORMALIZATION, INITIAL, CONTINUATION &
       &                           , TOTAL_ENERGY, MODIFIED_TOTAL_ENERGY, CG, MSD, ON, OFF

  use m_Control_Parameters,   only : m_CtrlP_decide_dtim_1Dsearch, m_CtrlP_dtim_1Dsearch_now &
       &                           , sw_hybrid_functional, ipri &
       &                           , energy_evaluation, icond, sw_use_wfred, sw_retard_eigval_evaluation &
       &                           , potential_update, force_exx_energy1, m_CtrlP_set_in_line_minimization
  use m_Files,                only : nfout
  use m_Kpoints,              only : kv3
  use m_ES_WF_by_SDorCG,      only : m_ESsd_evolve_WFs_again,  m_ESsd_decide_CG_direction &
       &                           , m_ESsd_alloc_wfred, m_ESsd_dealloc_wfred &
       &                           , m_ESsd_copy_zaj_to_zaj_old, m_ESsd_decide_CG_direction &
       &                           , m_ESsd_renew_WF_by_SDorCG   
  use m_Charge_Density,       only : m_CD_cp_chgq_to_chgqo
  use m_Total_Energy,         only : m_TE_tell_total_energy &
       &                           , m_TE_tell_total_energy0, m_TE_tell_band_energy &
       &                           , m_TE_tell_extended_band_energy
  use m_ES_ExactExchange,     only : m_ES_EXX_store_wfv, m_ES_EXX_restore_wfv
  use m_IterationNumbers,     only : iteration_electronic
  implicit none
  integer, intent(in)         :: isolver,precon
  real(kind=DP),intent(in)    :: dtim

  real(kind=DP), dimension(3) :: etotal
  real(kind=DP), parameter    :: factor = 2
  real(kind=DP)               :: dtim_new = 0.d0, dtim_msdv
  integer                     :: isolver_core, mode, isol
  integer                     :: energy_evaluation_lmm
  integer                     :: what_is_the_core_solver
  integer                     :: iupdate
  integer                     :: ispin,ik

  energy_evaluation_lmm = energy_evaluation
  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) energy_evaluation_lmm = BAND_ENERGY

  isolver_core = what_is_the_core_solver(isolver) ! -(in this file)
  isol = isolver_core
  if(isolver_core==CG) isol=MSD

  mode = ORTHONORMALIZATION
  dtim_msdv = m_CtrlP_dtim_1Dsearch_now(dtim)

  if(sw_use_wfred == ON) call m_ESsd_alloc_wfred()
  call m_ESsd_copy_zaj_to_zaj_old()

  call m_CtrlP_set_in_line_minimization(ON)
!!$  in_line_minimization = .true.

  if(energy_evaluation_lmm == TOTAL_ENERGY) then
     etotal(1) = m_TE_tell_total_energy()
  else if(energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
     etotal(1) = m_TE_tell_total_energy0() - m_TE_tell_band_energy(nfout,kv3) &
          &                                + m_TE_tell_extended_band_energy(nfout,kv3)
  else if(energy_evaluation_lmm == BAND_ENERGY) then
     etotal(1) = m_TE_tell_extended_band_energy(nfout,kv3)
  end if

  if(ipri >= 2) write(nfout,'(" !! dtim_msdv = ",f8.4)') dtim_msdv
  call m_ESsd_renew_WF_by_SDorCG(nfout,isol,precon,dtim_msdv,iupdate=0)

  if(energy_evaluation_lmm == TOTAL_ENERGY .or. energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
     call m_CD_cp_chgq_to_chgqo()
     if(sw_hybrid_functional==ON) call m_ES_EXX_store_wfv()
     call ChargeDensity_Construction(1)
     if(energy_evaluation_lmm == TOTAL_ENERGY) then
        etotal(2) = m_TE_tell_total_energy()
     else if(energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
        etotal(2) = m_TE_tell_total_energy0() -  m_TE_tell_band_energy(nfout,kv3) &
             &                                +  m_TE_tell_extended_band_energy(nfout,kv3)
     end if
  else if(energy_evaluation_lmm == BAND_ENERGY) then
     if(icond == INITIAL .or. icond == CONTINUATION) call m_CD_cp_chgq_to_chgqo()
     etotal(2) = m_TE_tell_extended_band_energy(nfout,kv3)
  end if

  call m_ESsd_evolve_WFs_again(nfout,isol,mode,dtim_msdv,factor*dtim_msdv,iupdate=0)
	 ! (msdv_grad)
  if(energy_evaluation_lmm == TOTAL_ENERGY .or. energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
     if(sw_hybrid_functional==ON.and.iteration_electronic/=1) call m_ES_EXX_restore_wfv()
     call ChargeDensity_Construction(1)
     if(energy_evaluation_lmm == TOTAL_ENERGY) then
        etotal(3) = m_TE_tell_total_energy()
     else if(energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
        etotal(3) = m_TE_tell_total_energy0() - m_TE_tell_band_energy(nfout,kv3) &
             &                                + m_TE_tell_extended_band_energy(nfout,kv3)
     end if
  else if(energy_evaluation_lmm == BAND_ENERGY) then
     etotal(3) = m_TE_tell_extended_band_energy(nfout,kv3)
  end if

  if(iteration_electronic==1)then
     etotal(1) = etotal(2);etotal(2) = etotal(3)
     call m_ESsd_evolve_WFs_again(nfout,isol,mode,dtim_msdv,factor*dtim_msdv,iupdate=0)

! === ASMS DEBUG === 2015/04/13
!     call ChargeDensity_Construction(1)
     if ( icond /= FIXED_CHARGE .and. icond /= FIXED_CHARGE_CONTINUATION ) then
        call ChargeDensity_Construction(1)
     endif
! ================== 2015/04/13

     if(energy_evaluation_lmm == TOTAL_ENERGY .or. energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
        if(sw_hybrid_functional==ON) call m_ES_EXX_restore_wfv()
        call ChargeDensity_Construction(1)
        if(energy_evaluation_lmm == TOTAL_ENERGY) then
           etotal(3) = m_TE_tell_total_energy()
        else if(energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
           etotal(3) = m_TE_tell_total_energy0() - m_TE_tell_band_energy(nfout,kv3) &
                &                                + m_TE_tell_extended_band_energy(nfout,kv3)
        end if
     else if(energy_evaluation_lmm == BAND_ENERGY) then
        etotal(3) = m_TE_tell_extended_band_energy(nfout,kv3)
     end if
  endif

  dtim_new = m_CtrlP_decide_dtim_1Dsearch(nfout,etotal,dtim_msdv,factor)
  if(ipri >= 2) write(nfout,'(" etotal(1:3) = ",3f15.6," dtim_msdv, dtim_new = ",2f15.6)') etotal(1:3), dtim_msdv, dtim_new

  mode = ORTHONORMALIZATION
  if(sw_retard_eigval_evaluation==ON.and.potential_update>0) force_exx_energy1=.true.
  if(sw_use_wfred == ON) then
     call m_ESsd_evolve_WFs_again(nfout,isol,mode,dtim_msdv,dtim_new,iupdate=0)
  else
     call m_ESsd_evolve_WFs_again(nfout,isol,mode,factor*dtim_msdv,dtim_new,iupdate=0)
  end if
  if(isolver_core == CG) then
     call m_ESsd_decide_CG_direction(precon)  !  -> betacg
     !    ~~~~~~~~~~~~~~~~~~~~~~~~~~
       !call m_ESsd_renew_WF_by_SDorCG(nfout,isolver_core,precon,dtim_msdv)
     call m_ESsd_renew_WF_by_SDorCG(nfout,isolver_core,precon,1.0d0)
     !    ~~~~~~~~~~~~~~~~~~~~~~~~~
  endif
  if(sw_use_wfred == ON) call m_ESsd_dealloc_wfred()
  call m_CtrlP_set_in_line_minimization(OFF)
!!$  in_line_minimization = .false.
end subroutine Renew_WF_by_lmSDorlmCG
#endif

#ifndef DISABLE_NONCL
! ===================================== added by K. Tagami =============== 11.0
subroutine Renew_WF_by_lmSDorlmCG_noncl(isolver,precon,dtim)
  use m_Const_Parameters,     only : DP, FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, BAND_ENERGY &
       &                           , ORTHONORMALIZATION &
       &                           , TOTAL_ENERGY, MODIFIED_TOTAL_ENERGY, ON, CG &
       &                           , INITIAL, CONTINUATION, OFF

  use m_Control_Parameters,   only : energy_evaluation, icond, sw_use_wfred, ipri&
       &                           , sw_hybrid_functional &
       &                           , m_CtrlP_decide_dtim_1Dsearch &
       &                           , m_CtrlP_dtim_1Dsearch_now, m_CtrlP_set_in_line_minimization
  use m_Files,                only : nfout
  use m_Kpoints,              only : kv3
  use m_ES_WF_by_SDorCG,      only : m_ESsd_evolve_WFs_again,  m_ESsd_decide_CG_direction &
       &                           , m_ESsd_alloc_wfred, m_ESsd_dealloc_wfred &
       &                           , m_ESsd_copy_zaj_to_zaj_old, m_ESsd_decide_CG_direction &
       &                           , m_ESsd_renew_WF_by_SDorCG   
  use m_ES_WF_by_SDorCG,      only : m_ESsd_renew_WF_by_SDorCG_noncl &
       &                           , m_ESsd_evolve_WFs_again_noncl &
       &                           , m_ESsd_decide_CG_direc_noncl
  use m_Charge_Density,       only : m_CD_cp_chgq_to_chgqo
  use m_Total_Energy,         only : m_TE_tell_total_energy &
       &                           , m_TE_tell_total_energy0, m_TE_tell_band_energy &
       &                           , m_TE_tell_extended_band_energy
  use m_ES_ExactExchange,     only : m_ES_EXX_store_wfv, m_ES_EXX_restore_wfv
  implicit none
  integer, intent(in)         :: isolver,precon
  real(kind=DP),intent(in)    :: dtim

  real(kind=DP), dimension(3) :: etotal
  real(kind=DP), parameter    :: factor = 2
  real(kind=DP)               :: dtim_new = 0.d0, dtim_msdv
  integer                     :: isolver_core, mode

  integer                     :: energy_evaluation_lmm
  integer                     :: what_is_the_core_solver

  energy_evaluation_lmm = energy_evaluation
  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) energy_evaluation_lmm = BAND_ENERGY

  isolver_core = what_is_the_core_solver(isolver) ! -(in this file)

  mode = ORTHONORMALIZATION

  if(sw_use_wfred == ON) call m_ESsd_alloc_wfred()
  call m_ESsd_copy_zaj_to_zaj_old()
  call m_CtrlP_set_in_line_minimization(ON)
!!$  in_line_minimization = .true.
  if(energy_evaluation_lmm == TOTAL_ENERGY) then
     etotal(1) = m_TE_tell_total_energy()
  else if(energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
     etotal(1) = m_TE_tell_total_energy0() - m_TE_tell_band_energy(nfout,kv3) &
          &                                + m_TE_tell_extended_band_energy(nfout,kv3)
  else if(energy_evaluation_lmm == BAND_ENERGY) then
     etotal(1) = m_TE_tell_extended_band_energy(nfout,kv3)
  end if

  dtim_msdv = m_CtrlP_dtim_1Dsearch_now(dtim)
  if(ipri >= 2) write(nfout,'(" !! dtim_msdv = ",f8.4)') dtim_msdv

  if(isolver_core == CG) then
     call m_ESsd_decide_CG_direc_noncl(precon)  !  -> betacg
     call m_ESsd_renew_WF_by_SDorCG_noncl(nfout,isolver_core,precon,dtim_msdv)
  else
     call m_ESsd_renew_WF_by_SDorCG_noncl(nfout,isolver_core,precon,dtim_msdv)
  end if

  if(energy_evaluation_lmm == TOTAL_ENERGY .or. energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
     call m_CD_cp_chgq_to_chgqo()
     if(sw_hybrid_functional==ON) call m_ES_EXX_store_wfv()
     call ChargeDensity_Construction(1)

     if(energy_evaluation_lmm == TOTAL_ENERGY) then
        etotal(2) = m_TE_tell_total_energy()
     else if(energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
        etotal(2) = m_TE_tell_total_energy0() -  m_TE_tell_band_energy(nfout,kv3) &
             &                                +  m_TE_tell_extended_band_energy(nfout,kv3)
     end if
  else if(energy_evaluation_lmm == BAND_ENERGY) then
     if(icond == INITIAL .or. icond == CONTINUATION) call m_CD_cp_chgq_to_chgqo()
     etotal(2) = m_TE_tell_extended_band_energy(nfout,kv3)
  end if

  call m_ESsd_evolve_WFs_again_noncl( nfout, isolver_core, mode, &
       &                               dtim_msdv, factor*dtim_msdv )
                                         ! (msdv_grad)

  if(energy_evaluation_lmm == TOTAL_ENERGY .or. energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
     if(sw_hybrid_functional==ON) call m_ES_EXX_restore_wfv()
     call ChargeDensity_Construction(1)
     if(energy_evaluation_lmm == TOTAL_ENERGY) then
        etotal(3) = m_TE_tell_total_energy()
     else if(energy_evaluation_lmm == MODIFIED_TOTAL_ENERGY) then
        etotal(3) = m_TE_tell_total_energy0() - m_TE_tell_band_energy(nfout,kv3) &
             &    + m_TE_tell_extended_band_energy(nfout,kv3)
     end if
  else if(energy_evaluation_lmm == BAND_ENERGY) then
     etotal(3) = m_TE_tell_extended_band_energy(nfout,kv3)
  end if

  dtim_new = m_CtrlP_decide_dtim_1Dsearch(nfout,etotal,dtim_msdv,factor)

  if(ipri >= 2) write(nfout,'(" etotal(1:3) = ",3f15.6," dtim_msdv, dtim_new = ",2f15.6)') etotal(1:3), dtim_msdv, dtim_new

  mode = ORTHONORMALIZATION

  if(sw_use_wfred == ON) then
     call m_ESsd_evolve_WFs_again_noncl( nfout, isolver_core, mode, &
          &                                  dtim_msdv, dtim_new )
  else
     call m_ESsd_evolve_WFs_again_noncl( nfout, isolver_core, mode, &
          &                                  factor*dtim_msdv, dtim_new )
  end if

  if(sw_use_wfred == ON) call m_ESsd_dealloc_wfred()
  call m_CtrlP_set_in_line_minimization(OFF)
!!$  in_line_minimization = .false.

end subroutine Renew_WF_by_lmSDorlmCG_noncl
! ===================================================================== 11.0
#endif

integer function what_is_the_core_solver(isolver)
  use m_Const_Parameters,     only : SD,MSD,CG &
       &                          , lmSD, lmMSD, lmCG, lmeazyCG, eazyCG
  implicit none
  integer, intent(in) :: isolver

  if(isolver == lmSD) then
     what_is_the_core_solver = SD
  else if(isolver == lmMSD) then
     what_is_the_core_solver = MSD
  else if(isolver == lmCG) then
     what_is_the_core_solver = CG
  else if(isolver == lmeazyCG) then
     what_is_the_core_solver = eazyCG
  else
     what_is_the_core_solver = MSD
  end if
end function what_is_the_core_solver

! === EXEC_RMM ===
subroutine exec_rmm(isolver,previous_isolver,precon,dtim)
  use m_Const_Parameters,     only : DP, DAVIDSON
  use m_Files,                only : nfout
#ifndef DISABLE_NONCL
  use m_Control_Parameters,   only : noncol
  use m_ES_ortho,             only : m_ES_modified_gramschmidt_noncl
  use m_ES_WF_by_RMM,          only : m_ESrmm_renew_WF_noncl
#endif
  use m_ES_WF_by_RMM,         only : m_ESrmm_renew_WF

#ifdef MEMORY_SAVE_ZAJ_OLD
  use m_Control_Parameters, only : RMM2P_is_specified
#endif
  implicit none
  integer, intent(in) :: isolver,previous_isolver,precon
  real(kind=DP), intent(in)  :: dtim

  call push_solver_name_applied(isolver)
#ifndef DISABLE_NONCL
! ================================= modified by K. Tagami ============= 11.0
!         call m_ESrmm_renew_WF(nfout,isolver,precon,dtim)
!
  if ( noncol ) then
     if ( previous_isolver == DAVIDSON ) then
        call m_ES_modified_gramschmidt_noncl(nfout)
     endif
     call m_ESrmm_renew_WF_noncl(nfout,isolver,precon,dtim)
  else
#endif
     call m_ESrmm_renew_WF(nfout,isolver,precon,dtim)

#ifndef DISABLE_NONCL
  endif
! ====================================================================== 11.0
#endif
end subroutine exec_rmm

! === EXEC_SUBMAT ===
subroutine exec_submat(isolver)
  use m_Files,                only : nfout
#ifndef DISABLE_NONCL
  use m_Control_Parameters,    only : noncol
  use m_ES_WF_by_submat,       only : m_ESsubmat_Renew_WF_noncl
#endif
  use m_Control_Parameters,    only : meg, damp
  use m_ES_WF_by_submat,       only : m_ESsubmat_Renew_WF, m_ESsubmat_alloc
  implicit none
  integer, intent(in) :: isolver
  
  call push_solver_name_applied(isolver)
  call m_ESsubmat_alloc()
#ifndef DISABLE_NONCL
! ============================================ modified by K. Tagami ======== 11.0
  if ( noncol ) then
     call m_ESsubmat_renew_WF_noncl(nfout,meg,damp)
  else
#endif
     call m_ESsubmat_renew_WF(nfout,meg,damp)
#ifndef DISABLE_NONCL
  endif
! =========================================================================== 11.0
#endif
end subroutine exec_submat

! === EXEC_DAVIDSON ===
subroutine exec_davidson(isolver,precon)
  use m_Files,                only : nfout
  use m_IterationNumbers,     only : iteration_electronic, iteration_ionic
#ifndef DISABLE_NONCL
  use m_Control_Parameters,    only : noncol
  use m_ES_WF_by_Davidson,     only : m_ESdavidson_Renew_WF_noncl 
  use m_ES_ortho,              only : m_ES_modified_gramschmidt_noncl
#endif
  use m_ES_WF_by_Davidson,    only : m_ESdavidson_Renew_WF
  use m_ES_ortho,             only : m_ES_modified_gram_schmidt
  implicit none
  integer, intent(in) :: isolver, precon

  call push_solver_name_applied(isolver)
#ifndef DISABLE_NONCL
! ============================== modified by K. Tagami ============== 11.0
!    if(iteration_electronic==1 .and. iteration_ionic>1) call m_ES_modified_gram_schmidt(nfout)
!     call m_ESdavidson_Renew_WF(nfout,precon)
  if ( noncol ) then
     if ( iteration_electronic==1 .and. iteration_ionic>1 ) then
        call m_ES_modified_gramschmidt_noncl(nfout)
     endif
     call m_ESdavidson_Renew_WF_noncl(nfout,precon)
  else
#endif

     if ( iteration_electronic==1 .and. iteration_ionic>1 ) then
        call m_ES_modified_gram_schmidt(nfout)
     endif
     call m_ESdavidson_Renew_WF(nfout,precon)
#ifndef DISABLE_NONCL
  endif
! ==================================================================== 11.0
#endif
end subroutine exec_davidson

subroutine exec_mddavidson(isolver,precon)
  use m_Const_Parameters,     only : ON, OFF
  use m_Control_Parameters,   only : m_CtrlP_push_SolverNameApplied &
       &                           , submat_before_renewal,meg,damp, submat_GE
  use m_Files,                only : nfout
  use m_IterationNumbers,     only : iteration_electronic, iteration_ionic
#ifndef DISABLE_NONCL
  use m_Control_Parameters,    only : noncol
  use m_ES_WF_by_ModifiedDavidson,only : m_ESmddavid_Subspace_Rot_noncl &
       &                            ,    m_ESmddavid_Renew_WF_noncl
  use m_ES_ortho,             only : m_ES_modified_gramschmidt_noncl
  use m_ES_WF_by_submat,      only : m_ESsubmat_Renew_WF_noncl
#endif
  use m_ES_WF_by_ModifiedDavidson,only : m_ESmddavid_Subspace_Rotation &
       &                            ,    m_ESmddavid_Renew_WF
  use m_ES_ortho,             only : m_ES_modified_gram_schmidt
  use m_ES_WF_by_submat,      only : m_ESsubmat_Renew_WF, m_ESsubmat_alloc
  implicit none
  integer, intent(in) :: isolver,precon

#ifndef DISABLE_NONCL
! ========================= modified by K. Tagami ================ 11.0
!     if(submat_before_renewal==ON) call m_ESmddavid_Subspace_Rotation(nfout)
!     if(iteration_electronic==1 .and. iteration_ionic>1) call m_ES_modified_gram_schmidt(nfout)
!     call m_ESmdkosugi_Renew_WF(nfout,precon)
!     if(submat_before_renewal/=ON) call m_ESmddavid_Subspace_Rotation(nfout)
 
  if ( noncol ) then
     if (submat_before_renewal==ON) then
        if ( submat_GE == OFF ) then
           call m_ES_modified_gramschmidt_noncl(nfout)
           call m_CtrlP_push_SolverNameApplied("SUBMAT",6)
           call m_ESsubmat_alloc()
           call m_ESsubmat_renew_WF_noncl(nfout,meg,damp)
        else
           call m_ESmddavid_Subspace_Rot_noncl(nfout)
        endif
     endif
     if(submat_GE /= OFF) then
        if (iteration_electronic==1 .and. iteration_ionic>1) then
           call m_ES_modified_gramschmidt_noncl(nfout)
        endif
     endif

     call push_solver_name_applied(isolver)
     call m_ESmddavid_Renew_WF_noncl(nfout,precon)

     if (submat_before_renewal/=ON) then
        if(submat_GE == OFF) then
           call m_ES_modified_gramschmidt_noncl(nfout)
           call m_CtrlP_push_SolverNameApplied("SUBMAT",6)
           call m_ESsubmat_alloc()
           call m_ESsubmat_renew_WF_noncl(nfout,meg,damp)
        else
           call m_ESmddavid_Subspace_Rot_noncl(nfout)
        end if
     endif
  else
#endif
     if(submat_before_renewal == ON) then
        if(submat_GE == OFF) then
           call m_ES_modified_gram_schmidt(nfout)
           call m_CtrlP_push_SolverNameApplied("SUBMAT",6)
           call m_ESsubmat_alloc()
           call m_ESsubmat_renew_WF(nfout,meg,damp)
        else
           call m_ESmddavid_Subspace_Rotation(nfout)
        end if
     end if
     if(submat_GE /= OFF) then
! === DEBUG by tkato 2012/11/05 ================================================
        if((iteration_electronic == 1 .and. iteration_ionic > 1)) then
           call m_ES_modified_gram_schmidt(nfout)
        end if
! ==============================================================================
     end if

     call push_solver_name_applied(isolver)
     call m_ESmddavid_Renew_WF(nfout,precon)
     if(submat_before_renewal /= ON) then
        if(submat_GE == OFF) then
           call m_ES_modified_gram_schmidt(nfout)
           call m_CtrlP_push_SolverNameApplied("SUBMAT",6)
           call m_ESsubmat_alloc()
           call m_ESsubmat_renew_WF(nfout,meg,damp)
        else
           call m_ESmddavid_Subspace_Rotation(nfout)
        end if
     end if
#ifndef DISABLE_NONCL
  endif
#endif
! ==================================================================== 11.0
end subroutine exec_mddavidson

subroutine push_solver_name_applied(isolver)
  use m_Const_Parameters,     only : MATRIXDIAGON, SD, MSD, lmSD, lmMSD, lmCG, lmeazyCG, RMM, RMM2 &
       &                           , RMM2P, SUBMAT, DAVIDSON, MDDAVIDSON, MDKOSUGI
  use m_Control_Parameters,   only : m_CtrlP_push_SolverNameApplied, len_solvername
  implicit none
  integer, intent(in) :: isolver
  character(len=len_solvername) :: solvername
  character*20 :: name
  integer :: len_char
  name = ""
  solver: select case(isolver)
  case (MATRIXDIAGON)
     name = "MATDIAGON"
  case (SD)
     name = "SD"
  case (MSD)
     name = "MSD"
  case (lmSD)
     name = "lmSD"
  case (lmMSD)
     name = "lmMSD"
  case (lmCG)
     name = "CG"
  case (lmeazyCG)
     name = "lmeazyCG"
  case (RMM)
     name = "RMM3"
  case (RMM2)
     name = "RMM2"
  case (RMM2P)
     name = "RMM2P"
  case (SUBMAT)
     name = "SUBMAT"   
  case (DAVIDSON)
     name = "DAVIDSON"
  case (MDDAVIDSON)
!!$     name = "MDDAVIDSON"
     name = "PKOSUGI"
  case (MDKOSUGI)
!!$     name = "MDKOSUGI"
     name = "PDAVIDSON"
  case default
     name = "notDefined"
  end select solver
  len_char = len_trim(name)
  solvername = ""
  solvername(1:min(len_char,len_solvername)) = name(1:min(len_char,len_solvername))
  call m_CtrlP_push_SolverNameApplied(solvername,min(len_char,len_solvername))
end subroutine push_solver_name_applied

subroutine wd_wfn()
  use m_FFT, only : m_FFT_alloc_WF_work,m_FFT_dealloc_WF_work
  use m_Control_Parameters, only : neg,nspin
  use m_Kpoints, only : kv3
  use m_Files, only : m_Files_open_nfwfk,nfwfk,nfout
  use m_ES_IO, only : m_ESIO_wd_WFn 
  implicit none
  integer :: ik,ib
  call m_FFT_alloc_WF_work
  do ik=1,kv3
     do ib=1,neg
        write(nfout,*) 'foobar'
        call flush(nfout)
        call m_Files_open_nfwfk(nspin,ik,ib)
        write(nfout,*) 'hoge'
        call flush(nfout)
        call m_ESIO_wd_WFn(nfout,nfwfk,ik,ib)
        write(nfout,*) 'bibi'
        call flush(nfout)
     end do
  end do
  call m_FFT_dealloc_WF_work
end subroutine wd_wfn

      SUBROUTINE DORG2L( M, N, K, A, LDA, TAU, WORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, LDA, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DORG2L generates an m by n real matrix Q with orthonormal columns,
*  which is defined as the last n columns of a product of k elementary
*  reflectors of order m
*
*        Q  =  H(k) . . . H(2) H(1)
*
*  as returned by DGEQLF.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix Q. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix Q. M >= N >= 0.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines the
*          matrix Q. N >= K >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the (n-k+i)-th column must contain the vector which
*          defines the elementary reflector H(i), for i = 1,2,...,k, as
*          returned by DGEQLF in the last k columns of its array
*          argument A.
*          On exit, the m by n matrix Q.
*
*  LDA     (input) INTEGER
*          The first dimension of the array A. LDA >= max(1,M).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DGEQLF.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument has an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, II, J, L
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARF, DSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 .OR. N.GT.M ) THEN
         INFO = -2
      ELSE IF( K.LT.0 .OR. K.GT.N ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORG2L', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.LE.0 )
     $   RETURN
*
*     Initialise columns 1:n-k to columns of the unit matrix
*
      DO 20 J = 1, N - K
         DO 10 L = 1, M
            A( L, J ) = ZERO
   10    CONTINUE
         A( M-N+J, J ) = ONE
   20 CONTINUE
*
      DO 40 I = 1, K
         II = N - K + I
*
*        Apply H(i) to A(1:m-k+i,1:n-k+i) from the left
*
         A( M-N+II, II ) = ONE
         CALL DLARF( 'Left', M-N+II, II-1, A( 1, II ), 1, TAU( I ), A,
     $               LDA, WORK )
         CALL DSCAL( M-N+II-1, -TAU( I ), A( 1, II ), 1 )
         A( M-N+II, II ) = ONE - TAU( I )
*
*        Set A(m-k+i+1:m,n-k+i) to zero
*
         DO 30 L = M - N + II + 1, M
            A( L, II ) = ZERO
   30    CONTINUE
   40 CONTINUE
      RETURN
*
*     End of DORG2L
*
      END

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 570 $)
!
!  SUBROUINE: Renewal_of_pPotential
!
!  AUTHOR(S): M. Saito, T. Yamasaki   November/04/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!
subroutine Renewal_of_pPotential()
! $Id: Renewal_of_pPotential.f90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Files,               only : nfout
!!  use m_ES_Intgr_VlhxcQlm,   only : m_ESiVQ_integrate_VlhxcQlm
  use m_Charge_Density,      only : chgq_l
  use m_epc_potential,       only : m_epc_alloc, m_epc_cal_potential, &
       &                            m_epc_ESlhxc_potential, vepc_l, &
       &                            m_epc_ESlhxc_potential_mod
  use m_Control_Parameters,  only : positron_method
  use m_Const_Parameters,    only : Positron_CONV

  implicit none

  call m_epc_alloc()
  call m_epc_cal_potential(nfout,chgq_l) ! chgq_l -> vepc_l, tchgq_l
                                              ! (xcfft) -> vxc_l

  if ( positron_method == Positron_CONV ) then
     call m_epc_ESlhxc_potential(nfout)     ! vepc_l, tchgq_l ->  vlhxc_l
  else
     call m_epc_ESlhxc_potential_mod(nfout)
  endif

!!  call m_ESiVQ_integrate_VlhxcQlm(nfout) ! (lclchh) -> vlhxcQ

end subroutine Renewal_of_pPotential

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 570 $)
!
!  SUBROUINE:  width2, wd_fermi_error1, wd_fermi_error2
!
!  AUTHOR(S): N. Hamada, T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine wd_fermi_error1(nfout,emin,emax,tot,totch)
! $Id: b_Fermi.F90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Const_Parameters, only : DP
  implicit none
  integer,       intent(in) :: nfout
  real(kind=DP), intent(in) :: emin, emax, tot, totch
  write(nfout,'(" emin = ",f10.4,"  emax = ",f10.4)') emin, emax
  write(nfout,'("  tot = ",f10.4," totch = ",f10.4)') tot, totch
  stop ' === stop in sub.fermi_parabolic (too few of states) =='
end subroutine wd_fermi_error1

subroutine wd_fermi_error2(nfout,e1,e2,efermi,emin,emax,tot,totch,neg,MAXITR)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in) :: nfout, neg, MAXITR
  real(kind=DP), intent(in) :: e1, e2,efermi, emin,emax, tot, totch
  
  write(nfout,'("     e1  = ", f10.5)') e1
  write(nfout,'("     e2  = ", f10.5)') e2
  write(nfout,'(" efermi  = ", f10.5)') efermi
  write(nfout,'("   emin  = ", f10.5, "  emax  = ",f10.5)') emin,emax
  write(nfout,'("    tot  = ", f10.5, " totch  = ",f10.5)') tot,totch
  write(nfout,'("  occup ( i = 1, ",i5,")")') neg
  write(nfout,'(" jcount exceeds MAXITR (= ",i8," (in FERMI)")') MAXITR
  stop ' stop at <wd_fermi_error2>'
end subroutine wd_fermi_error2

!!$C SUBROUTINE WIDTH2
!!$c                           @(#)width2.f 9.1 97/05/08 14:49:38 
!!$C
!!$C          1983/05/18 :   NORIAKI HAMADA
!!$C
!!$C----*----1----*----2----*----3----*----4----*----5----*----6----*----7
!!$C
subroutine width2( E,EFF,W, DOS,OCC  )
  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP), intent(in)  :: E, EFF, W
  real(kind=DP), intent(out) :: DOS, OCC
!!$C          EIGENENERGY IS BROADENED
!!$C
!!$C          E :  EIGENENERGY
!!$C          EF:  FERMI ENERGY
!!$C          W :  4*W IS BOTTOM LENGTH
!!$C          DOS    :  DENSITY OF STATES AT EF
!!$C          OCCUP :  OCUPATION FRACTION OF ELECTRON
  real(kind=DP) :: ee, ww

  if(w <= 0.0d0) STOP ' === STOP AT SUB.WIDTHE. (W<=0.0D0) ==='
#ifdef __TIMER_SUB__
!  call timer_sta(705)
#endif
  ee=(eff-e)/w
  ww=4.0d0*w
  if(ee <= -2.0d0) then
     dos    = 0.0d0
     occ  = 0.0d0
  else if(ee < -1.0d0) then
     dos    = (ee+2.0d0)**2/ww
     occ  = ((ee+2.0)**3)/(12.0d0)
  else if(ee < 1.0d0) then
     dos    = (2.0d0-ee**2)/ww
     occ  = (6.0d0+6.0d0*ee-(ee**3))/12.0d0
  else if(ee < 2.0d0) then
     dos    = ((ee-2.0d0)**2)/ww
     occ  = (12.0d0+(ee-2.0d0)**3)/12.0d0
  else
     dos    = 0.0d0
     occ  = 1.0d0
  end if
#ifdef __TIMER_SUB__
!  call timer_end(705)
#endif
end subroutine width2

! ============= KT_add =========================== 13.0E
subroutine width_fermi_dirac( ene, ef, width, dos, occ )
  use m_Const_Parameters, only : DP
  implicit none

  real(kind=DP), intent(in) :: ene, ef, width
  real(kind=DP), intent(out) :: dos, occ

  real(kind=DP) :: ee, c1, c2

  if ( width < 1.0D-10 ) stop "smearing width is too small"

  ee = ( ene -ef )/width
  if(ee.gt.100)then
     occ = 0.d0
     dos = 0.d0
  else if (ee.lt.-100)then
     occ = 1.d0
     dos = 0.d0
  else
  c1 = exp( ee );   c2 = cosh( ee/2.0D0 )
!
  occ = 1.0D0 / ( 1.0D0 +c1 )
  dos = 0.25D0 / c2**2 /width
  endif

end subroutine width_fermi_dirac
! ============================================== 13.0E

#ifdef JRCATFFT_WS
#define _INCLUDE_EXX_
#elif FFTW3
#define _INCLUDE_EXX_
#endif
!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 597 $)
!
!  SUBROUINE: Initial_Electronic_Structure, Initial_WaveFunctions_ek
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Initial_Electronic_Structure
! $Id: Initial_Electronic_Structure.F90 597 2019-07-26 03:08:56Z jkoga $
  use m_Const_Parameters,   only : Gauss_distrib_func, from_wave_functions&
       &                         , INITIAL, CONTINUATION, FIXED_CHARGE &
       &                         , FIXED_CHARGE_CONTINUATION, ON, OFF, EXECUT &
       &                         , COORDINATE_CONTINUATION &
       &                         , by_random_numbers, by_matrix_diagon, FILE &
       &                         , by_pseudo_atomic_orbitals &
       &                         , Valence_plus_PC_Charge, VXC_AND_EXC &
       &                         , ONE_BY_ONE, ALL_AT_ONCE, DP, YES &
       &                         , Partial_Core_Charge, PT_CONTROL
  use m_IterationNumbers,   only : iteration, nk_in_the_process
  use m_Files,              only : nfout,nfchgt,nfzaj,nfcntn_bin,nfeng,nfefermi &
       &                         , F_ZAJ_in_partitioned, F_CHGT_in_partitioned &
       &                         , F_CNTN_BIN_in_partitioned &
       &                         , nfchr &
       &                         , m_Files_open_nfchr &
       &                         , m_Files_open_nfcntn_bin &
       &                         , m_Files_skiptoend, m_Files_open_nfzaj, m_Files_open_nfchgt &
       &                         , m_Files_open_nfefermi, m_Files_close_nfefermi &
       &                         , nfcntn_bin_paw &
       &                         , file_existance_contfiles &
       &                         , m_Files_check_nfzaj_existance, m_Files_check_nfchgt_existance &
       &                         , m_Files_check_file_existance &
       &                         , m_Files_open_nfcntn_bin_paw,m_Files_close_nfcntn_bin_paw &
       &                         , m_Files_nfcntn_bin_paw_exists
  use m_Control_Parameters, only : ipri, iprichargedensity, initial_chg, icond, nspin, intzaj &
       &                         , evaluation_eko_diff &
       &                         , skip_alloc_phonon, sw_phonon, sw_calc_force, neg, neg_previous &
       &                         , delta_eigenvalue_cond_is_given, sw_dipole_correction, sw_hubbard &
       &                         , ekmode, fixed_charge_k_parallel, ipriparallel, printable &
       &                         , sw_initial_charge_rspace &
       &                         , m_CtrlP_set_neg_properly, m_CntrlP_set_neg, m_CntrlP_set_meg &
       &                         , m_Cntrlp_set_davidson_size &
       &                         , sw_hybrid_functional, sw_screening_correction &
       &                         , sw_external_potential, sw_fef, initial_occmat,kimg &
       &                         , sw_berry_phase, sw_rsb, sw_eval_epc_on_fftmesh &
       &                         , sw_initial_es, imdalg, sw_interpolate_charge, sw_interpolate_wfs
  use m_Kpoints,            only : kv3
  use m_PlaneWaveBasisSet,  only : kg1, m_pwBS_alloc_ylm_l,kgp,ngabc, kg1_prev, kgp_prev
  use m_PlaneWaveBasisSet,  only : m_pwBS_sphrp_l
  use m_PseudoPotential,    only : modnrm, m_PP_gfqwei, flg_paw, epc, m_PP_rd_PAW_parameters
  use m_Total_Energy,      only  : m_TE_set_etotal_old
  use m_Electronic_Structure,only: totch, m_ES_gtotch &
       &                         , m_ES_energy_eigen_values_ext &
       &                         , m_ES_alloc_vlhxc, m_ES_alloc_vlhxcQ &
       &                         , m_ES_alloc_zaj_etc &
       &                         , m_ES_alloc_eko_ek, m_ES_alloc_eko1 &
       &                         , m_ES_cpeko &
       &                         , m_ES_alloc_Dhub,vlhxc_l &
       &                         , m_ES_cp_zaj_prev_to_zaj &
       &                         , m_ES_gen_zaj_from_prev_zaj
  use m_ES_ortho,           only : m_ES_modified_gram_schmidt
  use m_ES_wf_extrpl,       only : m_ES_wf_extrpl_alloc
  use m_ES_nonlocal,        only : m_ES_betar_dot_WFs
  use m_ES_IO,              only : m_ESIO_rd_Efermi, m_ESIO_rd_EigenValues_etc, m_ESIO_rd_WFs
  use m_ES_Intgr_VlhxcQlm,  only : m_ESiVQ_integrate_VlhxcQlm
  use m_ES_initialWF,       only : m_ESIW_by_randomnumbers 
  use m_ES_initialWF,       only : m_ESIW_by_atomic_orbitals
  use m_ES_LHXC,            only : m_ESlhxc_potential
  use m_ES_WF_by_SDorCG,    only : m_ESsd_alloc_dzajn2, m_ESsd_alloc_zaj_old
  use m_Charge_Density,     only : chgq_l &
       &                         , m_CD_alloc_hsr &
       &                         , m_CD_rd_hsr &
       &                         , m_CD_initial_CD_by_Gauss_func &
       &                         , m_CD_wd_chgq_l_small_portion &
       &                         , m_CD_cp_chgq_to_chgqo &
       &                         , m_CD_softpart, m_CD_hardpart &
       &                         , m_CD_rd_chgq  &
       &                         , m_CD_initial_CD_by_file_rspace &
       &                         , m_CD_adjust_spindensity  &
       &                         , m_CD_cp_chgq_prev_to_chgq &
       &                         , m_CD_gen_chgq_from_prev_chgq
  use m_Crystal_Structure, only  : sw_fix_total_spin, sw_magnetic_constraint,  univol
! <--
  use m_XC_Potential,      only  : vxc_l, exc
  use m_XC_Potential,      only  : m_XC_cal_potential
  use m_Parallelization,   only  : m_Parallel_dealloc_mpi_elec, m_Parallel_init_mpi_elec &
                       &         , ista_kngp,iend_kngp,nrank_e,mype
  use m_Dipole,            only  : m_Dipole_vdip_alloc
  use m_Orbital_Population,only  : m_OP_rd_occ_mat, m_OP_mix_om, m_OP_occ_mat_init, m_OP_cp_ommix_to_omold
  use m_FiniteElectricField,only : m_FEF_Constract_of_ftq
!!$#ifdef FJ_TIMER
!!$  use m_Parallelization,      only : mpi_comm_group
!!$#endif
  use m_ES_ExactExchange,  only  : m_ES_EXX_gather_valence_states, m_ES_EXX_kernel &
       &                         , m_ES_EXX_occup,  m_ES_EXX_ngpt &
       &                         , m_ES_EXX_init &
#ifndef MEMORY_SAVE_EXX
       &                         , m_ES_EXX_update, m_ES_EXX_crotylm, m_ES_EXX_ylm
#else
       &                         , m_ES_EXX_update, m_ES_EXX_crotylm
#endif
! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
! ==============================================================================
  use m_External_Potential, only : m_EP_espot_by_external_charge
! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
! ==============================================================================
  use m_Ionic_System,      only  : zeta1,m_IS_natm_can_change

! ================================== added by K. Tagami =============== 11.0&13.0U
  use m_Control_Parameters,   only : noncol, ndim_spinor, ndim_magmom, &
       &                             import_collinear_spindensity, &
       &                             import_collinear_wavefunctions

  use m_Charge_Density,  only : m_CD_initCD_by_file_rsp_noncl, &
       &                        m_CD_adjust_spindensity_noncl, &
       &                        m_CD_initial_CD_by_Gauss_kt, &
       &                        m_CD_wd_chgq_l_portion_noncl
  use m_ES_LHXC,         only : m_ESlhxc_potential_noncl

  use m_Electronic_Structure,   only : m_ES_energy_eigen_vals_noncl, &
       &                               m_ES_energy_eigenvals_ext_noncl, &
       &                               m_ES_alloc_zaj_etc_noncl
  use m_ES_Ortho,               only : m_ES_modified_gramschmidt_noncl

  use m_Files,                  only : m_Files_open_nfchr_noncl
  use m_PseudoPotential,        only : m_PP_set_fqwei_noncl
  use m_ES_NonCollinear,        only :  m_ES_init_Mat_dion0_noncl, &
       &                                m_ES_set_Mat_q_noncl
!
  use m_ES_IO,                   only : m_ESIO_rd_WFs_import_frm_collin
  use m_Charge_Density,          only : m_CD_rd_chgq_import_frm_collin, &
       &                                m_CD_rd_chgq_noncl
  use m_CD_Mag_Moment,           only : m_CD_alloc_RhoMag_on_atom, &
       &                                m_CD_calc_ChgMagMom_in_sphere, &
       &                                sw_monitor_atomcharge
  use m_Orbital_Population,      only  : m_OP_rd_occ_mat_noncl
! ===================================================================== 11.0&13.0U

! ================================== added by K. Tagami =============== 11.0&13.0U
  use m_Control_Parameters,      only : SpinOrbit_mode
  use m_Const_Parameters,        only : Neglected, BuiltIn, ByProjector
  use m_SpinOrbit_Potential,     only : m_SO_alloc_dsoc, &
       &                                m_SO_set_Dsoc_potential1, &
       &                                m_SO_calc_MatLS_orb_s_to_f, &
       &                                m_SO_diagonalize_MatLS, &
       &                                m_SO_set_MatU_ylm_RC
  use m_ES_NonCollinear,         only : m_ES_alloc_factor_fss, &
       &                                 m_ES_set_factor_fss
!
  use m_ES_Mag_Constraint,       only : m_ES_add_MagConstraintPot_chgql, &
       &                                m_ES_add_MagConstraintPot_hsr
! ==================================================================== 11.0&13.0U

! ================================== added by K. Tagami =============== 11.0
  use m_Const_Parameters,        only : ByPawPot, ZeffApprox, ReadFromPP
  use m_SpinOrbit_Potential,    only : m_SO_alloc_Mat_SOC_strenth, &
       &                                m_SO_set_Dsoc_potential2
  use m_SpinOrbit_RadInt,       only : m_SO_calc_SOC_strength_pawpot, &
       &                               m_SO_calc_SOC_strength_zeff, &
       &                               m_SO_check_mode_Builtin, &
       &                               m_SO_check_mode_Pawpot, &
       &                               m_SO_check_mode_Zeff
  use m_SpinOrbit_FromFile,     only : m_SO_set_SOC_strength_from_PP
! ======================================================================= 11.0
   use m_FFT,                    only : fft_box_size_CD
   use m_Total_Energy,           only : ehartr

   use m_Control_Parameters,     only : m_CtrlP_set_init_status, read_charge_hardpart, &
        &                               use_metagga
#ifdef MEMORY_SAVE_ZAJ_OLD
   use m_Control_Parameters,     only : RMM2P_is_specified
#endif
   use m_ErrorMessages
! ===================== KT_Test ========================= 12.5Exp
   use m_Control_Parameters,    only : m_CtrlP_set_hybrid_parameters, xctype
   use m_ES_ExactExChange,      only : m_ES_EXX_set_nmax_G_hyb
! ======================================================= 12.5Exp

! ====================== KT_Test ========================= 12.5Exp
#ifdef USE_ZAJ_HISTORY
   use m_ES_wf_extrpl,      only :  m_ES_wf_rd_zaj_history
#endif
! ======================================================= 12.5Exp

  use m_BerryPhase,             only : m_BP_rd_cntn_data

! ============= KT_add ==================== 13.0D
  use m_Files,  only : m_Files_reopen_nfcntn_bin_paw
! ========================================= 13.0D

! ===== KT_add ======= 13.0U2&13.0U3
  use m_Control_Parameters,  only : sw_potential_mixing, &
       &                            sw_modified_TFW_functional, &
       &                            sw_spherical_averaged_nonlocal, &
       &                            use_averaged_nonlocal, sw_wf_mixing
  use m_Potential_Mixing,    only : m_Pot_alloc_array_vnonlocal
  use m_ThomasFermiW_Potential, only : m_TFW_normalize_psir_val, &
       &                               m_TFW_alloc_ChgDensityBasisFn_A, &
       &                               m_TFW_alloc_ChgDensityBasisFn_B, &
       &                               m_TFW_set_ChgDensityBasisFn_A, &
       &                               m_TFW_set_ChgDensityBasisFn_B, &
       &                               m_TFW_alloc_vnonlocal_avg, &
       &                               m_TFW_alloc_Vin_and_Vlda
  use m_ES_WF_mixing,      only :      m_ES_WF_alloc_zaj_prev
! ==================== 13.0U2&13.0U3
  use m_ES_RSB,            only : m_ES_RSB_alloc,m_ES_RSB_doit,m_ES_RSB_dealloc

! ==== KT_add  ==== 2014/08/29
  use m_Control_Parameters,  only : sw_use_add_proj, Orbital_decomp_mode, &
       &                            sw_use_contracted_psir
  use m_Charge_Density,  only : m_CD_alloc_hsr_add
  use m_CD_Mag_Moment,   only : m_CD_calc_product_psir_val, m_CD_alloc_product_psir_val
! ================= 2014/08/29
! ==== KT_add  ==== 2014/09/19
  use m_Control_Parameters,  only : sw_calc_ekin_density, use_symm_ekin_density, &
       &                            sw_rspace_ekin_density, use_asymm_ekin_density
  use m_KineticEnergy_Density,     only : m_KE_calc_kins_qrs_rspace, &
       &                                  m_KE_calc_kina_qrs_rspace
! ================= 2014/09/19


! ==== EXP_CELLOPT === 2015/09/24
  use m_IterationNumbers,     only : iteration_unit_cell,iteration_stress_correction
  use m_Control_Parameters,   only :  sw_read_nfchgt_prev_cell, sw_read_nfzaj_prev_cell
! ==================== 2015/09/24

  implicit none
  integer :: iloop
  logical, save :: is_charge_density_read = .false.
! <--
  integer :: neg_incre

! =========================== added by K. Tagami =================== 11.0
  integer :: ispin
! =================================================================== 11.0
  integer :: ierror

!!$#ifdef FJ_TIMER
!!$  integer :: ierr
!!$#endif

! -----> T. Yamasaki, 11 July 2008 ---- 
  real(kind=DP) :: zeta_sum
  logical :: initialization_required
  if(.not.initialization_required()) then
     call m_CD_softpart(nfout,kv3)
     call m_CD_hardpart(nfout,kv3)
     call m_CD_cp_chgq_to_chgqo()
     call m_PP_gfqwei(nfout)  ! -> modnrm, fqwei, nlmta1, nlmta2
     call m_CtrlP_set_init_status(.false.)
     call UpdateUeff()
     if(sw_hybrid_functional == ON) call EXX()
     return
  endif

  call UpdateUeff()

! ====================== KT_Test ========================= 12.5Exp
!  if(sw_hybrid_functional == ON) then
!     call m_CtrlP_set_hybrid_parameters
!     call m_ES_EXX_set_nmax_G_hyb
!  endif
! ======================================================== 12.5Exp

  if(sw_hybrid_functional == ON) call m_ES_EXX_update(ON)

  if(icond == INITIAL .or. icond==COORDINATE_CONTINUATION) then
     call m_ES_gtotch(nfout)
     if(icond == INITIAL) then
        if(totch >= neg*2.0) then
           if(ipri >= 1) then
              write(nfout,'(" ### Warning(1309): Number of bands(neg) is insufficient:")')
              write(nfout,'("                totch = ",f10.3," >= neg*2.0 = ",f10.3)') totch, neg*2.0
           end if
           if(dabs(sum(zeta1)) > 0.d0) then
              call m_CtrlP_set_neg_properly(1.3*totch) ! -> neg
           else
              call m_CtrlP_set_neg_properly(totch) ! -> neg
           end if
           call m_CntrlP_set_meg(neg)
           call m_CntrlP_set_neg(neg)
!           if(ipri >= 1) write(nfout,'(" neg (=num_bands) is enlarged ",i12)') neg
           if(ipri >= 1) write(nfout,'(" ### Warning(1309): Number of bands is enlarged",i12)') neg
           call m_CntrlP_set_davidson_size(neg) ! -> max_subspace_size
           call m_Parallel_dealloc_mpi_elec()

! ======================================== modified by K. Tagami ============== 11.0
!           call m_Parallel_init_mpi_elec(nfout,ipriparallel,printable,neg,kv3,nspin,kg1)
           if ( noncol ) then
              call m_Parallel_init_mpi_elec( nfout, ipriparallel, printable, neg, &
                   &                                   kv3, ndim_spinor, kg1 )
           else
              call m_Parallel_init_mpi_elec( nfout, ipriparallel, printable, neg, &    
                   &                                   kv3, nspin, kg1 )
           endif
! ============================================================================= 11.0

        end if
     end if
  else if(icond == CONTINUATION) then
     if(neg_previous > neg) then
        call m_CntrlP_set_neg(neg_previous)
        call m_CntrlP_set_meg(neg)
        call m_CntrlP_set_davidson_size(neg) ! -> max_subspace_size
        call m_Parallel_dealloc_mpi_elec()

! ======================================== modified by K. Tagami ============== 11.0
!        call m_Parallel_init_mpi_elec(nfout,ipriparallel,printable,neg,kv3,nspin,kg1)
        if ( noncol ) then
          call m_Parallel_init_mpi_elec( nfout, ipriparallel, printable, neg, & 
        &                                kv3, ndim_spinor, kg1 ) 
        else 
          call m_Parallel_init_mpi_elec( nfout, ipriparallel, printable, neg, &
        &                                kv3, nspin, kg1 )
        endif
! ============================================================================= 11.0

        if(ipri >= 1) write(nfout,'(" neg is enlarged ",f12.5)') neg
     end if
  end if
! <------

#ifdef _INCLUDE_EXX_
  if(sw_hybrid_functional == ON) call m_ES_EXX_init()
#endif

  if(nrank_e > neg) call phase_execution_error(PARALLELIZATION_INVALID_NE)

  if(.not.skip_alloc_phonon) then
     call m_CD_alloc_hsr()
     call m_ES_alloc_vlhxc()
     call m_ES_alloc_vlhxcQ()
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
                    call timer_sta(30)
#endif

     call m_SO_set_MatU_ylm_RC

     if ( sw_monitor_atomcharge == ON ) then
        call m_CD_alloc_RhoMag_on_atom
     endif
! ============================= KT_mod==================== 11.0Q&13.0U
!     if ( noncol ) then
!
! ========================================================= 11.0Q&13.0U

! ==== KT_add === 2014/08/29
     if ( sw_use_add_proj == ON .and. Orbital_decomp_mode == 2 ) then
        call m_CD_alloc_hsr_add()
     endif
     if ( sw_use_contracted_psir == ON ) then
        call m_CD_alloc_product_psir_val
     endif
! =============== 2014/08/29

! ==== KT_add ======= 13.0U2
     if ( sw_potential_mixing == ON ) call m_Pot_alloc_array_vnonlocal
! =================== 13.0U2

! ================================== modified by K. Tagami ================== 11.0
!     call m_ES_alloc_zaj_etc()
!
      if ( noncol ) then
        call m_ES_alloc_zaj_etc_noncl()
      else
        call m_ES_alloc_zaj_etc()
        call m_ES_wf_extrpl_alloc()

! =================== KT_TEST ============================ 12.5Exp
#ifdef USE_ZAJ_HISTORY
        if(icond == CONTINUATION) call m_ES_wf_rd_zaj_history
#endif
! ======================================================== 12.5Exp

      endif
! ============================================================================ 11.0


#ifdef FJ_TIMER
                    call timer_end(30)
#endif
#ifdef MEMORY_SAVE_ZAJ_OLD
     if(RMM2P_is_specified) then
#endif
     call m_ESsd_alloc_zaj_old()
#ifdef MEMORY_SAVE_ZAJ_OLD
     end if
#endif
     call m_ESsd_alloc_dzajn2()
     if(sw_hubbard == ON) call m_ES_alloc_Dhub()
     if(sw_hybrid_functional == ON) call m_ES_EXX_ngpt()
     if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
        if(ekmode == ON) then
           call m_ES_alloc_eko_ek()
        else if(ekmode == OFF .and. fixed_charge_k_parallel == ONE_BY_ONE) then
           call m_ES_alloc_eko_ek()
        end if

        if(evaluation_eko_diff == ON) then
           call m_ES_alloc_eko1()
        else if(delta_eigenvalue_cond_is_given) then
           call m_ES_alloc_eko1()
           call m_ES_cpeko()
        end if
     else
        if(delta_eigenvalue_cond_is_given) then
           call m_ES_alloc_eko1()
           call m_ES_cpeko()
        end if
     end if
     if(sw_dipole_correction == ON) then
        call m_Dipole_vdip_alloc()
     end if
  end if

! ========= KT_add ========== 13.0U3
  if ( sw_wf_mixing == ON ) call m_ES_WF_alloc_zaj_prev
! =========================== 13.0U3

  if(sw_phonon == ON .and. sw_calc_force == OFF) return

!!$  call m_PP_gfqwei(nfout)  ! -> modnrm, fqwei, nlmta1, nlmta2
!!$  if(modnrm == EXECUT .and. (icond == INITIAL .or. icond == CONTINUATION)) then
  if(.not.skip_alloc_phonon) then

! ==== KT_add === 2014/09/19
     if ( sw_calc_ekin_density == ON .and. sw_rspace_ekin_density == ON ) then
        if ( use_symm_ekin_density )  call m_KE_calc_kins_qrs_rspace
        if ( use_asymm_ekin_density ) call m_KE_calc_kina_qrs_rspace
     endif
! =============== 2014/09/19
! ==== KT_add === 2014/08/29
     if ( sw_use_contracted_psir == ON ) then
        call m_CD_calc_product_psir_val
     endif
! =============== 2014/08/29
! ===================================== added by K. Tagami ============ 11.0
     if ( noncol ) then

        call m_SO_check_mode_Builtin
        call m_SO_check_mode_Pawpot
        call m_SO_check_mode_Zeff

        if ( SpinOrbit_Mode /= Neglected ) then
           call m_SO_set_MatU_ylm_RC
           call m_SO_calc_MatLS_orb_s_to_f
           call m_SO_diagonalize_MatLS
!!!           call m_ES_set_paog_soc
        endif

        if ( SpinOrbit_Mode == BuiltIn ) then
           call m_ES_alloc_factor_fss
           call m_ES_set_factor_fss
        endif

        if ( SpinOrbit_Mode == ByPawPot ) then
           call m_SO_alloc_Mat_SOC_strenth
           call m_SO_calc_SOC_strength_pawpot
           call m_SO_alloc_Dsoc
           call m_SO_set_Dsoc_potential2
        endif

        if ( SpinOrbit_Mode == ZeffApprox ) then
           call m_SO_alloc_Mat_SOC_strenth
           call m_SO_calc_SOC_strength_zeff
           call m_SO_alloc_Dsoc
           call m_SO_set_Dsoc_potential2
        endif

        if ( SpinOrbit_Mode == ReadFromPP ) then
           call m_SO_alloc_Mat_SOC_strenth
           call m_SO_set_SOC_strength_from_PP
           call m_SO_alloc_Dsoc
           call m_SO_set_Dsoc_potential2
        endif

        if ( SpinOrbit_Mode == ByProjector ) then
           call m_SO_alloc_Dsoc
           call m_SO_set_Dsoc_potential1
        endif
        call m_ES_init_Mat_dion0_noncl
        call m_ES_set_Mat_q_noncl
     end if
! ======================================================================= 11.0

! ==================================== modified by K. Tagami ================ 11.0
!     call m_PP_gfqwei(nfout)  ! -> modnrm, fqwei, nlmta1, nlmta2

     if ( noncol ) then
        call m_PP_set_fqwei_noncl( nfout )
     else
        call m_PP_gfqwei(nfout)  ! -> modnrm, fqwei, nlmta1, nlmta2
     endif
! ======================================================================== 11.0

     if(modnrm == EXECUT ) then
        call m_pwBS_alloc_ylm_l()
        call m_pwBS_sphrp_l()                           ! -> ylm_l
     end if
  end if

  if(sw_fef==ON) call m_FEF_Constract_of_ftq()

! ==== ASMS ====
  if ( sw_hybrid_functional == ON ) sw_eval_epc_on_fftmesh = ON
  if ( xctype == 'vdwdf' ) sw_eval_epc_on_fftmesh = ON
  if ( sw_eval_epc_on_fftmesh == ON ) then
     call m_XC_cal_potential( nfout, Partial_Core_Charge, chgq_l, VXC_AND_EXC )
     epc = exc
  endif
! ==== ASMS ====

  if(iteration == 0) call m_TE_set_etotal_old()

  if(sw_screening_correction == ON) then
     call screening_potential
  end if
! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
! ==============================================================================
  if(sw_external_potential == ON) then
     call m_EP_espot_by_external_charge
  end if
! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
! ==============================================================================

  if(icond == INITIAL .or. icond == COORDINATE_CONTINUATION .or. &
       & (icond==FIXED_CHARGE .and. ekmode==OFF .and. fixed_charge_k_parallel == ALL_AT_ONCE)) then
     if(icond /= INITIAL) call m_ES_gtotch(nfout)
     if(icond == INITIAL) call check_neg()

     !---- set a charge density ----
     if(.not.is_charge_density_read.and.(initial_chg == FILE .or. (icond==FIXED_CHARGE.and.ekmode==OFF))) then
        call read_charge_density(condition=1)
        call read_efermi()
        if(icond==FIXED_CHARGE .and. ekmode == OFF) call copy_chgq_to_chgqo()
     else
        if ((iteration_unit_cell > 1.or. iteration_stress_correction>1) .and. sw_read_nfchgt_prev_cell == ON ) then
           write(6,'(" -- reading charge density (Initial_Electronic_Structure)")')
           call flush(6)
           call read_charge_density(condition=-4)
#ifdef FFTW3
        else if ((iteration_unit_cell > 1 .or. iteration_stress_correction>1) .and. &
        &  kgp_prev .eq. kgp .and. sw_interpolate_charge == ON) then
           call m_CD_cp_chgq_prev_to_chgq(nfout)
        else if ((iteration_unit_cell > 1 .or. iteration_stress_correction>1) .and. &
        &  kgp_prev .ne. kgp .and. sw_interpolate_charge == ON) then
           call m_CD_gen_chgq_from_prev_chgq(nfout)
#endif
        else
           call m_CD_initial_CD_by_Gauss_kt(nfout)   ! (intchg) -> chgq_l
        endif
        call m_CD_initial_CD_by_Gauss_kt(nfout)   ! (intchg) -> chgq_l
     end if

     !---- set wave functions ----
     if ( ((iteration_unit_cell > 1 .or. iteration_stress_correction>1) .and.  imdalg .ne. PT_CONTROL) .and. &
     &  (sw_read_nfzaj_prev_cell == ON .or. is_charge_density_read)) then
        call read_zaj( condition =-4 )
#ifdef FFTW3
     else if((iteration_unit_cell > 1 .or. iteration_stress_correction>1) .and. &
     &  kg1_prev .eq. kg1 .and. sw_interpolate_wfs == ON) then
        call m_ES_cp_zaj_prev_to_zaj()
     else if((iteration_unit_cell > 1 .or. iteration_stress_correction>1) .and. &
     &  kg1_prev .ne. kg1 .and. sw_interpolate_wfs == ON) then
        call m_ES_gen_zaj_from_prev_zaj(nfout)
#endif
     else if(intzaj == by_random_numbers) then
        call m_ESIW_by_randomnumbers(nfout,kv3,1,neg)      ! (rndzaj) -> zaj_l
     else if(intzaj == by_pseudo_atomic_orbitals) then
        call m_ESIW_by_atomic_orbitals(nfout,kv3,1,neg)    ! (paozaj) -> zaj_l
     else if(intzaj == by_matrix_diagon) then

     else if(intzaj == FILE) then
        call read_zaj( condition = 1 )
        call m_ES_betar_dot_WFs(nfout)         ! (fsrfsi)
        if(initial_chg == FILE .or. (icond==FIXED_CHARGE.and.ekmode==OFF)) then
        else
           call m_XC_cal_potential(nfout,Valence_plus_PC_Charge,chgq_l, VXC_AND_EXC) ! -> vxc_l
           call Local_Hartree_XC_potential()
           call m_ESiVQ_integrate_VlhxcQlm(nfout) ! (lclchh) -> vlhxcQ
           if ( noncol ) call Renewal_of_Potential()
           call energy_eigen_values()
           call ChargeDensity_Construction(1)
        end if
     endif

     !---- set a potential ----
     call m_XC_cal_potential(nfout,Valence_plus_PC_Charge,chgq_l, VXC_AND_EXC)  ! -> vxc_l
     call Local_Hartree_XC_potential()
     if(intzaj == by_random_numbers .or. intzaj == by_pseudo_atomic_orbitals .or. intzaj == FILE) then
!        if ( noncol ) then
!           call m_ES_add_MagConstraintPot_globl
!           call m_ES_add_MagConstraintPot_local
!        endif
        if ( sw_monitor_atomcharge == ON ) then
           call m_CD_calc_ChgMagMom_in_sphere
        endif
        if ( sw_magnetic_constraint == ON ) then
           call m_ES_add_MagConstraintPot_chgql
           call m_ES_add_MagConstraintPot_hsr
        endif
     end if
 
! === DEBUG by tkato 2014/08/14 ================================================
!    call modified_gramschmidt()
     if(intzaj /= by_matrix_diagon) call modified_gramschmidt()
! ==============================================================================
!     if(intzaj /= by_matrix_diagon) then
      if(sw_hybrid_functional == ON) call EXX()
!     end if
     call m_ESiVQ_integrate_VlhxcQlm(nfout) ! (lclchh) -> vlhxcQ
     if ( noncol ) call Renewal_of_Potential()
     if(intzaj /= by_matrix_diagon) call energy_eigen_values()

     if(iprichargedensity >= 2) call m_CD_wd_chgq_l_small_portion(nfout)
     if(icond==COORDINATE_CONTINUATION) icond = INITIAL

     if(sw_hubbard == ON) then
        if(intzaj==FILE)then
           if(initial_occmat == FILE .or. icond==FIXED_CHARGE .or.  iteration_unit_cell > 1) then
              call read_occ_mat() ! -> om
           else
              call ChargeDensity_Construction(1)
              call Renewal_of_OccMat(.false.,ON, .false.)
           endif
        else 
           if(initial_occmat == FILE .or. icond==FIXED_CHARGE .or.  iteration_unit_cell > 1) then
              call read_occ_mat() ! -> om
           else if (sw_initial_es==ON)then
              call ChargeDensity_Construction(1)
              call Renewal_of_OccMat(.false.,ON, .false.)
           else
              call m_OP_occ_mat_init(nfout) ! -> om
           end if
        endif
        call m_OP_mix_om(1.d0) ! om -> ommix
        call Renewal_of_Hubbard_Potential() ! ommix -> dhub
     end if
  else if(icond == CONTINUATION .or. &
       & (icond==FIXED_CHARGE_CONTINUATION .and. ekmode==OFF &
       & .and. fixed_charge_k_parallel == ALL_AT_ONCE)) then
     call m_Files_open_nfcntn_bin
     call m_ESIO_rd_EigenValues_etc(nfout,nfcntn_bin,F_CNTN_BIN_in_partitioned)
!!$     call m_ESIO_wd_EigenValues(nfout,2,nooccupation=NO)
     call m_Files_open_nfzaj()
     call m_ESIO_rd_WFs(nfout,nfzaj,F_ZAJ_in_partitioned)
     if(neg_previous < neg) then
        call m_ESIW_by_randomnumbers(nfout,kv3,neg_previous+1,neg)
     end if
     call read_charge_density(condition = 2)
     if(flg_paw) call m_CD_rd_hsr(nfcntn_bin_paw)
     if ( use_metagga ) call read_ekindens()

     if(icond /= CONTINUATION) call read_efermi()

     call m_ES_betar_dot_WFs(nfout)            ! (fsrfsi) ->fsr_l
     if(sw_hybrid_functional == ON) call EXX()
     if ( noncol ) call Renewal_of_Potential()

     if(neg_previous < neg) then
        call modified_gramschmidt()
        if ( noncol ) then
          call m_ES_energy_eigenvals_ext_noncl(nfout)
        else
          call m_ES_energy_eigen_values_ext(nfout)
        endif
     end if
     call Renewal_of_Potential()
     if(sw_hubbard == ON) then
        call read_occ_mat()    ! -> om
        call m_OP_mix_om(1.d0) ! om -> ommix
        call Renewal_of_Hubbard_Potential() ! ommix -> dhub
     end if
     if(icond==FIXED_CHARGE_CONTINUATION .and. ekmode == OFF) then
        call copy_chgq_to_chgqo()
        if(sw_hubbard == ON) call m_OP_cp_ommix_to_omold()
     end if
  else if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
! === Restart with phase ek-mode is supported. by tkato 2014/01/23 =============
     call m_Files_open_nfcntn_bin
! ==============================================================================
     call m_ES_gtotch(nfout)

     call read_charge_density(condition = 2)
     if(flg_paw.and.ekmode/=OFF) call m_CD_rd_hsr(nfcntn_bin_paw)
     if ( use_metagga ) call read_ekindens()

     call read_efermi()

     if(sw_hybrid_functional == ON) call EXX()
     call Renewal_of_Potential()
     if(sw_hubbard==ON) then
        call read_occ_mat() ! -> om
        call m_OP_mix_om(1.d0) ! om -> ommix
        call Renewal_of_Hubbard_Potential() ! ommix -> dhub
     end if
     if(icond == FIXED_CHARGE_CONTINUATION .and. nk_in_the_process >= 2) call m_Files_skiptoend(nfeng)
     if(icond == FIXED_CHARGE_CONTINUATION .and. sw_berry_phase == ON ) call m_BP_rd_cntn_data()
  endif
  call m_CtrlP_set_init_status(.false.)
contains
  subroutine read_charge_density(condition)
    use m_Files,              only : m_Files_open_nfchr
    use m_Charge_Density,     only : m_CD_rd_chgq &
         &                         , m_CD_initial_CD_by_file_rspace &
         &                         , m_CD_adjust_spindensity
    use m_Files,              only : m_Files_open_nfchr_noncl
    use m_Charge_Density,     only : m_CD_rd_chgq_noncl &
         &                         , m_CD_rd_chgq_import_frm_collin &
         &                         , m_CD_initCD_by_file_rsp_noncl &
         &                         , m_CD_adjust_spindensity_noncl &
         &                         , m_CD_import_chgq_prev_cell
    integer, intent(in) :: condition
    integer :: ispin
    integer :: iloop

    call m_Files_open_nfchgt()
!!$    write(6,'( " icond = ",i8, " condition = ", i8,"  (read_charge_density)")') icond,condition
    is_charge_density_read = .true.
    if(condition == 1) then
       if(sw_initial_charge_rspace == ON) then
          if ( noncol ) then
             do iloop = 1, ndim_magmom
                if ( import_collinear_spindensity == ON ) then
                   ispin = 0
                   if ( iloop == 1 ) ispin = 1
                   if ( iloop == ndim_magmom ) ispin = 2
                   if ( ispin == 0 ) cycle
                
                   call m_Files_open_nfchr( nspin,ispin )
                   call m_CD_initCD_by_file_rsp_noncl( iloop, nfout, nfchr )
                else
                   call m_Files_open_nfchr_noncl(iloop)
                   call m_CD_initCD_by_file_rsp_noncl( iloop, nfout, nfchr )
                endif
             end do
          else
             do iloop = 1, nspin
                call m_Files_open_nfchr(nspin,iloop)
                call m_CD_initial_CD_by_file_rspace(nspin,iloop,nfout,nfchr)
             end do
          endif
       else
          if ( noncol ) then
             if  ( import_collinear_spindensity == ON ) then
                call m_CD_rd_chgq_import_frm_collin( nfout, nfchgt, &
                     &                               F_CHGT_in_partitioned)
             else
                call m_CD_rd_chgq_noncl(nfout,nfchgt,F_CHGT_in_partitioned)
             endif
          else
             call m_CD_rd_chgq(nfout,nfchgt,F_CHGT_in_partitioned)
          endif
          if ( flg_paw .and. read_charge_hardpart == YES .and. m_Files_nfcntn_bin_paw_exists()) then
             call m_Files_open_nfcntn_bin_paw()
             call m_PP_rd_PAW_parameters(nfout,nfcntn_bin_paw)
             call m_CD_rd_hsr(nfcntn_bin_paw)
             call m_Files_close_nfcntn_bin_paw()
          endif
       end if

       if ( noncol ) then
          call m_CD_adjust_spindensity_noncl(nfout)
       else
          call m_CD_adjust_spindensity(nfout)
       endif

    else if(condition == 2) then
       if ( noncol ) then
          call m_CD_rd_chgq_noncl(nfout,nfchgt,F_CHGT_in_partitioned)
       else
          call m_CD_rd_chgq(nfout,nfchgt,F_CHGT_in_partitioned)
       endif
!!$       if ( flg_paw .and. ) then
!!$          call m_CD_rd_hsr(nfcntn_bin_paw)
!!$       endif

    else if(condition == -4) then      ! coordinate-continuation
!
       call m_CD_import_chgq_prev_cell(nfout,nfchgt, F_CHGT_in_partitioned)
       if ( flg_paw .and. read_charge_hardpart == YES .and.  m_Files_nfcntn_bin_paw_exists()) then
          call m_Files_open_nfcntn_bin_paw()
          call m_PP_rd_PAW_parameters(nfout,nfcntn_bin_paw)
          call m_CD_rd_hsr(nfcntn_bin_paw)
          call m_Files_close_nfcntn_bin_paw()
       endif

       if ( noncol ) then
          call m_CD_adjust_spindensity_noncl(nfout)
       else
          call m_CD_adjust_spindensity(nfout)
       endif
    end if

  end subroutine read_charge_density
 
  subroutine read_ekindens
    use m_Files,  only :  m_Files_open_nf_ekindens, m_Files_close_nf_ekindens
    use m_KineticEnergy_Density, only : m_KE_rd_ekindens

    call m_Files_open_nf_ekindens
    call m_KE_rd_ekindens()
    call m_Files_close_nf_ekindens

  end subroutine read_ekindens

  subroutine read_efermi()
    use m_Files,              only : nfout,m_Files_open_nfefermi, m_Files_close_nfefermi
    use m_ES_IO,              only : m_ESIO_rd_Efermi

    call m_Files_open_nfefermi()
    call m_ESIO_rd_Efermi(nfout,nfefermi)
    call m_Files_close_nfefermi()
  end subroutine read_efermi

  subroutine copy_chgq_to_chgqo()
    call m_CD_cp_chgq_to_chgqo()
  end subroutine copy_chgq_to_chgqo

  subroutine Local_Hartree_XC_potential()
    use m_ES_LHXC,            only : m_ESlhxc_potential, m_ESlhxc_potential_noncl
    if ( noncol ) then
       call m_ESlhxc_potential_noncl(nfout,chgq_l,vxc_l) ! (stlhxc) ->vlhxc_l
    else
       call m_ESlhxc_potential(nfout,chgq_l,vxc_l) ! (stlhxc) ->vlhxc_l
    endif
  end subroutine Local_Hartree_XC_potential

  subroutine energy_eigen_values()
    use m_Electronic_Structure,   only : m_ES_energy_eigen_values, m_ES_energy_eigen_vals_noncl
    if ( noncol ) then
       call m_ES_energy_eigen_vals_noncl(nfout)
    else
       call m_ES_energy_eigen_values(nfout)   ! (eigen0) -> eko_l,neordr
    endif
  end subroutine energy_eigen_values

  subroutine modified_gramschmidt()
    use m_ES_ortho,           only : m_ES_modified_gram_schmidt
    use m_ES_ortho,           only : m_ES_modified_gramschmidt_noncl
    if ( noncol ) then
       call m_ES_modified_gramschmidt_noncl(nfout)
    else
       call m_ES_modified_gram_schmidt(nfout) ! ->zaj_l, fsr_l,fsi_l
    endif
  end subroutine modified_gramschmidt

  subroutine EXX()
    use m_ES_ExactExchange,  only  : m_ES_EXX_gather_valence_states, m_ES_EXX_kernel &
         &                         , m_ES_EXX_occup  &
         &                         , sw_rspace_hyb, m_ES_EXX_init0 &
#ifndef MEMORY_SAVE_EXX
         &                         , m_ES_EXX_ylm, m_ES_EXX_crotylm
#else
         &                         , m_ES_EXX_crotylm
#endif
    call m_ES_EXX_init0()
    if(modnrm == EXECUT ) then
#ifndef MEMORY_SAVE_EXX
       if(sw_rspace_hyb==OFF) call m_ES_EXX_ylm()
#endif
       call m_ES_EXX_crotylm()
    end if
    if(sw_rsb==ON)then
       call m_ES_RSB_alloc()
       call m_ES_RSB_doit(verbose=.false.,fermi=.false.)
    endif
    call m_ES_EXX_occup(nfout)
    call m_ES_EXX_gather_valence_states(nfout)
    call m_ES_EXX_kernel(nfout)
  end subroutine EXX

  subroutine read_occ_mat()
    use m_Orbital_Population,      only  : m_OP_rd_occ_mat
    use m_Orbital_Population,      only  : m_OP_rd_occ_mat_noncl
    if ( noncol ) then
       call m_OP_rd_occ_mat_noncl(nfout)
    else
       call m_OP_rd_occ_mat(nfout) ! -> om
    endif
  end subroutine read_occ_mat

  subroutine read_zaj( condition )
    use m_ES_IO,                   only : m_ESIO_rd_WFs_import_frm_collin, &
         &                                m_ESIO_import_WFs_prev_cell
    integer, intent(in) :: condition

    call m_Files_open_nfzaj()

    if ( condition == 1 ) then
       if ( noncol .and. import_collinear_wavefunctions == ON ) then
          call m_ESIO_rd_WFs_import_frm_collin( nfout,nfzaj,F_ZAJ_in_partitioned )
       else
          call m_ESIO_rd_WFs(nfout,nfzaj,F_ZAJ_in_partitioned)
       endif

    else if ( condition == -4 ) then       ! coordinate-continuation
       call m_ESIO_import_WFs_prev_cell(nfout,nfzaj,F_ZAJ_in_partitioned)
    endif

  end subroutine read_zaj

  subroutine check_neg()
    if(totch >= neg*2.0) then
       if(ipri >= 1) write(nfout,'(" This job stops because totch = ",f12.5, " > neg*2.0 = ",f12.5)') &
            & totch, neg*2.0
       stop ' totch > neg*2.0'
    end if
  end subroutine check_neg
end subroutine Initial_Electronic_Structure

subroutine Initial_WaveFunctions_ek
!                           @(#)Initial_Electronic_Structure.f90 1.4 03/02/19 00:43:18
  use m_Const_Parameters,   only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION &
       &                         , by_random_numbers, by_matrix_diagon, YES, ON, OFF &
       &                         , by_pseudo_atomic_orbitals
  use m_IterationNumbers,   only : nk_in_the_process &
       &                         , first_kpoint_in_this_job &
       &                         , iteration_electronic &
       &                         , m_Iter_reset_iter_electronic
  use m_Control_Parameters, only : ekmode,icond,intzaj,evaluation_eko_diff &
       &                         , ipri,ipriekzaj, sw_ekzaj,neg, printable, numk_zajsaved &
       &                         , sw_hybrid_functional
  use m_Files,              only : nfout,nfzaj, m_Files_open_nfzaj, m_Files_open_nfzaj_append
  use m_Kpoints,            only : kv3
  use m_Electronic_Structure,only: m_ES_energy_eigen_values &
       &                         , m_ES_cpeko &
       &                         , m_ES_wd_zaj_small_portion0
  use m_ES_nonlocal,        only : m_ES_betar_dot_WFs
  use m_ES_ortho,           only : m_ES_modified_gram_schmidt
  use m_ES_initialWF,       only : m_ESIW_by_randomnumbers &
       &                         , m_ESIW_by_atomic_orbitals
  use m_ES_IO,              only : m_ESIO_rd_WFs_and_EVs_ek
  use m_ES_ExactExchange,  only  : m_ES_EXX_gather_valence_states, m_ES_EXX_kernel &
       &                         , m_ES_EXX_occup

! =========================================== added by K. Tagami ========== 11.0
  use m_Control_Parameters,   only : noncol, ndim_magmom
  use m_ES_Ortho,               only : m_ES_modified_gramschmidt_noncl
  use m_Electronic_Structure,   only : m_ES_energy_eigen_vals_noncl
! ========================================================================= 11.0

  implicit none

  if(printable) write(nfout,'("!! icond, nk_in_the_process, first_kpoint_in_this_job = ",3i8)') &
       & icond, nk_in_the_process, first_kpoint_in_this_job
  if(ekmode == ON) then
     if(icond == FIXED_CHARGE &
          & .or. (icond == FIXED_CHARGE_CONTINUATION &
          &         .and. nk_in_the_process /= first_kpoint_in_this_job) &
          & .or. (icond == FIXED_CHARGE_CONTINUATION &
          &         .and. iteration_electronic == 0) &
          & ) then
        if(sw_ekzaj == OFF) then
           if(intzaj == by_random_numbers .or. intzaj == by_pseudo_atomic_orbitals) then
              if(intzaj == by_random_numbers) then
                 call m_ESIW_by_randomnumbers(nfout,kv3,1,neg)! (rndzaj) -> zaj_l
              else
                 call m_ESIW_by_atomic_orbitals(nfout,kv3,1,neg)! (paozaj) -> zaj_l
              end if
              call m_ES_betar_dot_WFs(nfout)     ! (fsrfsi,sumset)

! ======================================= modified by K. Tagami ========== 11.0
!              call m_ES_modified_gram_schmidt(nfout) ! (grmsmd)
!
              if ( noncol ) then
                call m_ES_modified_gramschmidt_noncl(nfout) ! (grmsmd)
              else
                call m_ES_modified_gram_schmidt(nfout) ! (grmsmd)
              endif
! ======================================================================== 11.0

              if(sw_hybrid_functional == ON) then
                 call m_ES_EXX_occup(nfout)
                 call m_ES_EXX_gather_valence_states(nfout)
                 call m_ES_EXX_kernel(nfout)
              end if

! ======================================= modified by K. Tagami ========== 11.0
!              call m_ES_energy_eigen_values(nfout)   ! (eigen0) -> eko_l,neordr
!
              if ( noncol ) then
                 call m_ES_energy_eigen_vals_noncl(nfout)
              else
                 call m_ES_energy_eigen_values(nfout)   ! (eigen0) -> eko_l,neordr
              endif
! ======================================================================= 11.0

              if(intzaj == by_matrix_diagon) then

              end if
           end if
           if(icond == FIXED_CHARGE_CONTINUATION.and.iteration_electronic == 0) &
                & call m_Files_open_nfzaj_append()
        else
           call m_Files_open_nfzaj()
           call m_ESIO_rd_WFs_and_EVs_ek(nfout,nfzaj) ! -> zaj_l,eko_l,neordr
           call m_ES_betar_dot_WFs(nfout)     ! (fsrfsi,sumset)
        end if
     else if((icond == FIXED_CHARGE_CONTINUATION &
          & .and. nk_in_the_process == first_kpoint_in_this_job) &
          & .or.(icond == FIXED_CHARGE_CONTINUATION &
          &   .and. iteration_electronic /= 0)) then
        call m_Files_open_nfzaj()
        call m_ESIO_rd_WFs_and_EVs_ek(nfout,nfzaj)
        call m_ES_betar_dot_WFs(nfout)
     else
        stop ' icond is illegal (Initial_Electronic_Structure_ek)'
     end if
  else if(ekmode == OFF) then
     if(ipri>=1) write(nfout,'(" kv3 = ",i8)') kv3
     if(icond == FIXED_CHARGE_CONTINUATION .and. first_kpoint_in_this_job == nk_in_the_process) then
        if(ipri>=1) write(nfout,'("!! icond = ",i8)') icond
        call m_Files_open_nfzaj()
        call m_ESIO_rd_WFs_and_EVs_ek(nfout,nfzaj)
        if(nk_in_the_process+kv3-1 > numk_zajsaved) then
           call m_ESIW_by_randomnumbers(nfout,kv3,1,neg)
           call m_ES_betar_dot_WFs(nfout)     ! (fsrfsi,sumset)

! ================================ modified by K. Tagami ==================== 11.0
!          call m_ES_modified_gram_schmidt(nfout) ! (grmsmd)
           if ( noncol ) then
              call m_ES_modified_gramschmidt_noncl(nfout) ! (grmsmd)
           else
              call m_ES_modified_gram_schmidt(nfout) ! (grmsmd)
           endif
! ========================================================================== 11.0

           if(sw_hybrid_functional == ON) then
              call m_ES_EXX_occup(nfout)
              call m_ES_EXX_gather_valence_states(nfout)
              call m_ES_EXX_kernel(nfout)
           end if

! ================================= modified by K. Tagami =============== 11.0
!           call m_ES_energy_eigen_values(nfout)   ! (eigen0) -> eko_l,neordr
           if ( noncol ) then
             call m_ES_energy_eigen_vals_noncl(nfout)
           else
             call m_ES_energy_eigen_values(nfout)   ! (eigen0) -> eko_l,neordr
           endif
! ====================================================================== 11.0

        else
           call m_ES_betar_dot_WFs(nfout)
        end if
        call m_ES_wd_zaj_small_portion0(" -- Initial_WF_ek --",20)
     else
        if(icond==FIXED_CHARGE) then
           call m_Files_open_nfzaj()
        else
           call m_Files_open_nfzaj_append()
        end if
        if(intzaj == by_random_numbers .or. intzaj == by_pseudo_atomic_orbitals) then
           if(intzaj == by_random_numbers) then
              call m_ESIW_by_randomnumbers(nfout,kv3,1,neg)! (rndzaj) -> zaj_l
           else
              call m_ESIW_by_atomic_orbitals(nfout,kv3,1,neg)! (paozaj) -> zaj_l
           end if
           call m_ES_betar_dot_WFs(nfout)     ! (fsrfsi,sumset)

! =========================================== modified by K. Tagami =========== 11.0
!           call m_ES_modified_gram_schmidt(nfout) ! (grmsmd)
           if ( noncol ) then
              call m_ES_modified_gramschmidt_noncl(nfout) ! (grmsmd)
           else
              call m_ES_modified_gram_schmidt(nfout) ! (grmsmd)
           endif
! ============================================================================== 11.0

           if(sw_hybrid_functional == ON) then
              call m_ES_EXX_occup(nfout)
              call m_ES_EXX_gather_valence_states(nfout)
              call m_ES_EXX_kernel(nfout)
           end if

! ================================ modifie by K. Tagami ==================== 11.0
!           call m_ES_energy_eigen_values(nfout)   ! (eigen0) -> eko_l,neordr
           if ( noncol ) then
             call m_ES_energy_eigen_vals_noncl(nfout)   ! (eigen0) -> eko_l,neordr
           else
             call m_ES_energy_eigen_values(nfout)   ! (eigen0) -> eko_l,neordr
           endif
! ======================================================================== 11.0

        end if
        if(intzaj == by_matrix_diagon .or. ipriekzaj == 0) &
             & call m_Iter_reset_iter_electronic(nfout)
     end if
  end if
  if(evaluation_eko_diff == YES) call m_ES_cpeko()
end subroutine Initial_WaveFunctions_ek

subroutine Initial_EVs_ek
!                           @(#)Initial_Electronic_Structure.f90 1.4 03/02/19 00:43:18
  use m_Const_Parameters,   only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION &
       &                         , ON, OFF
  use m_IterationNumbers,   only : nk_in_the_process &
       &                         , first_kpoint_in_this_job &
       &                         , iteration_electronic &
       &                         , m_Iter_reset_iter_electronic
  use m_Control_Parameters, only : ekmode,icond &
       &                         , ipri, sw_ekzaj, printable &
       &                         , sw_hybrid_functional
  use m_Files,              only : nfout,nfzaj &
       &                         , m_Files_open_nfzaj
  use m_Kpoints,            only : kv3
  use m_ES_IO,              only : m_ESIO_rd_EVs_ek

  implicit none

  if(printable) write(nfout,'("!! icond, nk_in_the_process, first_kpoint_in_this_job = ",3i8)') &
       & icond, nk_in_the_process, first_kpoint_in_this_job
  if(ekmode == ON) then
     if(icond == FIXED_CHARGE &
          & .or. (icond == FIXED_CHARGE_CONTINUATION &
          &         .and. nk_in_the_process /= first_kpoint_in_this_job) &
          & .or. (icond == FIXED_CHARGE_CONTINUATION &
          &         .and. iteration_electronic == 0) &
          & ) then
        if(sw_ekzaj == OFF) then
        else
           call m_Files_open_nfzaj()
           call m_ESIO_rd_EVs_ek(nfout,nfzaj) ! -> eko_l,neordr
        end if
     else if((icond == FIXED_CHARGE_CONTINUATION &
          & .and. nk_in_the_process == first_kpoint_in_this_job) &
          & .or.(icond == FIXED_CHARGE_CONTINUATION &
          &   .and. iteration_electronic /= 0)) then
        call m_Files_open_nfzaj()
        call m_ESIO_rd_EVs_ek(nfout,nfzaj)
     else
        stop ' icond is illegal (Initial_Electronic_Structure_ek)'
     end if
  else if(ekmode == OFF) then
     if(ipri>=1) write(nfout,'(" kv3 = ",i8)') kv3
     if(icond == FIXED_CHARGE_CONTINUATION .and. first_kpoint_in_this_job == nk_in_the_process) then
        if(ipri>=1) write(nfout,'("!! icond = ",i8)') icond
        call m_Files_open_nfzaj()
        call m_ESIO_rd_EVs_ek(nfout,nfzaj)
     end if
  end if
end subroutine Initial_EVs_ek

module m_PS_opencore
  use m_Files,  only : nfpot, nfout, m_Files_open_ps_files, m_Files_close_ps_file
  use m_PseudoPotential,  only : nmesh, mmesh, radr_paw, radr, wos
  use m_NonLocal_Potential, only : new_radr_and_wos

  use m_PlaneWaveBasisSet,  only : gr_l
  use m_Parallelization,  only : npes, mype, ista_kngp, iend_kngp, ista_k
  use m_Const_Parameters,  only : DP
  use m_Crystal_Structure,  only : univol
  use m_Ionic_System,  only : ivan, ntyp, iatomn, natm, ityp
  use m_Control_Parameters,  only : noncol
  use m_CD_Mag_Moment,   only :  RhoMag_on_atom

  implicit none
  include 'mpif.h'
!
  integer, allocatable :: has_opencore(:)
  real(kind=DP), allocatable :: mag_opencore_pol(:,:)
  real(kind=DP), allocatable :: rmag_opencore(:,:)
  real(kind=DP), allocatable :: rmag_opencore_l(:,:)

contains

  subroutine m_PS_set_rmag_opencore
    integer :: it, ierr, nfp, i, ir
    integer :: num_core_ae_wfns
    integer, allocatable :: qnum_n_core_ae_wfns(:)
    integer, allocatable :: qnum_l_core_ae_wfns(:)
    real(kind=DP), allocatable :: psir_core_ae_wfns(:,:)
    real(kind=DP), allocatable :: enelevel_core_ae_wfns(:)
    real(kind=DP), allocatable :: focc_core_ae_wfns(:)
    real(kind=DP) :: weight

! == KT_DEBUG === 2015/06/15 == 
!    call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierr)  
!                                      ! this does not work properly by unknown reason.
    call m_Files_open_ps_files(ivan,iatomn,ntyp,ierr)
! =============== 2015/06/15

    if (ierr/=0) call mpi_stop(nfout)

    allocate( rmag_opencore(mmesh,ntyp) );   rmag_opencore = 0.0d0
    allocate( has_opencore(ntyp) );   has_opencore = 0.0d0

    Do it=1, ntyp
       nfp = nfpot(it)

       if ( mype == 0 ) call read_num_core_ae_wfns( nfp, num_core_ae_wfns, it )
       if ( npes > 1 ) then
          call mpi_bcast(  num_core_ae_wfns, 1, mpi_integer, 0, mpi_comm_world, ierr )
       endif
       
       if ( num_core_ae_wfns == 0 ) cycle
       
       allocate( qnum_n_core_ae_wfns( num_core_ae_wfns ) )
       allocate( qnum_l_core_ae_wfns( num_core_ae_wfns ) )
       allocate( psir_core_ae_wfns( nmesh(it),  num_core_ae_wfns ) )
       allocate( enelevel_core_ae_wfns( num_core_ae_wfns ) )
       allocate( focc_core_ae_wfns( num_core_ae_wfns ) )
       
       if ( mype == 0 ) then
          call read_data_core_ae_wfns( nfp, num_core_ae_wfns, nmesh(it), &
               &                       qnum_n_core_ae_wfns, qnum_l_core_ae_wfns, &
               &                       psir_core_ae_wfns, &
               &                       enelevel_core_ae_wfns, focc_core_ae_wfns )
       endif
       
       if ( npes > 1 ) then
          call mpi_bcast( qnum_n_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_integer, 0, mpi_comm_world, ierr )
          call mpi_bcast( qnum_l_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_integer, 0, mpi_comm_world, ierr )
          call mpi_bcast( enelevel_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_double_precision, 0, mpi_comm_world, ierr )
          call mpi_bcast( focc_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_double_precision, 0, mpi_comm_world, ierr )
          call mpi_bcast( psir_core_ae_wfns, nmesh(it)*num_core_ae_wfns, &
               &          mpi_double_precision, 0, mpi_comm_world, ierr )
       endif
!
       Do i=1, num_core_ae_wfns
          if ( qnum_l_core_ae_wfns(i) == 3 ) then
             if ( abs( focc_core_ae_wfns(i) -14.0 ) < 0.1 ) cycle

             has_opencore(it) = 1
             if ( focc_core_ae_wfns(i) <=7  ) then
                weight = focc_core_ae_wfns(i)
             else
                weight =  14.d0 -focc_core_ae_wfns(i)
             endif
             Do ir=1, nmesh(it)
                rmag_opencore(ir,it) = weight *psir_core_ae_wfns(ir,i) **2
             End Do
          endif
       End Do

       deallocate( qnum_n_core_ae_wfns )
       deallocate( qnum_l_core_ae_wfns )
       deallocate( psir_core_ae_wfns )
       deallocate( enelevel_core_ae_wfns )
       deallocate( focc_core_ae_wfns )

       call m_Files_close_ps_file(it)
    End Do
  end subroutine m_PS_set_rmag_opencore

  subroutine m_PS_set_pcc_opencore
    integer :: ierr, i, ir, n, it, ik
    real(kind=DP) :: gabs, fac
    real(kind=DP), allocatable :: wkx(:), wky(:)

    allocate( rmag_opencore_l( ista_kngp:iend_kngp, ntyp ) )
    rmag_opencore_l = 0.0d0

    allocate(wkx(mmesh)); wkx = 0.d0
    allocate(wky(mmesh)); wky = 0.d0
    allocate(wos(mmesh)); wos = 0

#if 1
    allocate( radr(mmesh)); radr = 0.0d0
#endif


    Do it=1, ntyp
#if 0
       call set_weight_exp( ierr, 1, nmesh(it), radr_paw(:,it), wos )
#else
       ik = ista_k
       call new_radr_and_wos(ik,it)
!       write(*,*) "wos", wos(1:5)
#endif

       if ( has_opencore(it) == 0 ) cycle
!       write(*,*) 'FFFF ', it
!       write(*,*) "FF2 ",  rmag_opencore(10,it)

       do i = ista_kngp, iend_kngp  !for mpi
          gabs = gr_l(i)
#if 0
          do n = 1, nmesh(it)
             wkx(n) = gabs * radr_paw(n,it)
          enddo
#else
          do n = 1, nmesh(it)
             wkx(n) = gabs * radr(n)
          enddo
#endif          
          call dsjnv(0,nmesh(it),wkx, wky)
          
          do  n = 1, nmesh(it)
             fac = wos(n) *rmag_opencore(n,it) /univol
             rmag_opencore_l(i,it) = rmag_opencore_l(i,it) + fac *wky(n)
          enddo
       end do
    End Do
    deallocate( wos )
    deallocate( wkx )
    deallocate( wky )
#if 1
    deallocate( radr )
#endif

  end subroutine m_PS_set_pcc_opencore

  subroutine m_PS_init_mag_opencore_pol
    integer :: ia, it

    if ( noncol ) then
       allocate( mag_opencore_pol(natm,3) )
    else
       allocate( mag_opencore_pol(natm,1) )
    endif
    mag_opencore_pol = 0.0d0

    Do ia=1, natm
       it = ityp(ia)
       if ( has_opencore(it) == 0 ) cycle
       if ( noncol ) then
!          mag_opencore_pol(ia,3) = -1.0d0    ! DOWN
          mag_opencore_pol(ia,3) = 1.0d0   
       else
!          mag_opencore_pol(ia,1) = -1.0d0    ! DOWN
          mag_opencore_pol(ia,1) = 1.0d0    
       endif
    End do
  end subroutine m_PS_init_mag_opencore_pol

  subroutine m_PS_set_mag_opencore_pol
    integer :: ia, it
    real(kind=DP) :: c1, c2

    Do ia=1, natm
       it = ityp(ia)
       if ( has_opencore(it) == 0 ) cycle

       if ( noncol ) then
          c1 = RhoMag_on_atom(ia,2)**2 +RhoMag_on_atom(ia,3)**2 +RhoMag_on_atom(ia,4)**2
          c2 = sqrt(c1)
          if ( c2 >1.0D-11 ) then
             mag_opencore_pol(ia,1) = RhoMag_on_atom(ia,2) /c2
             mag_opencore_pol(ia,2) = RhoMag_on_atom(ia,3) /c2
             mag_opencore_pol(ia,3) = RhoMag_on_atom(ia,4) /c2
          else
             mag_opencore_pol(ia,3) = 1.0d0
          endif
!          write(6000+mype,*) ia, mag_opencore_pol(ia,1:3)
       else
          c1 = RhoMag_on_atom(ia,1) - RhoMag_on_atom(ia,2)
          c2 = abs(c1)
          if ( c2 >1.0D-11 ) then
             mag_opencore_pol(ia,1) = c1 /c2
          else
             mag_opencore_pol(ia,1) = 1.0d0
          endif
       endif
    End Do
  end subroutine m_PS_set_mag_opencore_pol

  subroutine read_num_core_ae_wfns( nfp, nums, it )
    integer, intent(in) :: nfp, it
    integer, intent(out) :: nums

    integer :: length, ierr
    character(30) :: search_key

    nums = 0

    search_key = "CORE STATES";  length = len(search_key)
    call read_size_of_array_from_pp(nfp, nums, length, search_key, ierr)

    if ( ierr /= 0 ) then
       write(nfout,*) '----------------------'
       write(nfout,'(A,I2)') '!!! Keyword CORE STATES is not found in the PP', it
       write(nfout,*) '----------------------'
    endif

  end subroutine read_num_core_ae_wfns

  subroutine read_data_core_ae_wfns( nfp, num_core_ae_wfns, nmesh, &
       &                             qnum_n, qnum_l, psir_core, ene_level, focc )
    implicit none

    integer, intent(in) :: num_core_ae_wfns
    integer, intent(in) :: nmesh, nfp
    integer, intent(out) :: qnum_l(num_core_ae_wfns)
    integer, intent(out) :: qnum_n(num_core_ae_wfns)
    real(kind=8), intent(out) :: psir_core(nmesh, num_core_ae_wfns), &
         &                       ene_level(num_core_ae_wfns), focc(num_core_ae_wfns)

    integer :: i, n1, l1, k
    real(kind=DP) :: ene1, f1

    Do i=1, num_core_ae_wfns
       read(nfp,*) n1, l1, ene1, f1
       read(nfp,*) (psir_core(k,i),k=1,nmesh)
       !
       qnum_n(i) = n1;  qnum_l(i) = l1;  ene_level(i) = ene1;   focc(i) = f1
    End Do
  end subroutine read_data_core_ae_wfns

  subroutine read_size_of_array_from_pp( nfp, size_of_array, length, search_tag, ierr )
    implicit none

    integer, intent(in) :: nfp, length
    integer, intent(out) :: size_of_array, ierr
    character(length), intent(in) :: search_tag

    integer :: ifound
    character(30) :: line1

    size_of_array = 0;  ierr = 0

    Do while (.true.)
       read(nfp,'(a30)',end=10) line1
       ifound = index( line1, search_tag )
       if ( ifound /= 0 ) goto 20
    End do

10  ierr = 1; return

20  read(nfp,*) size_of_array

  end subroutine read_size_of_array_from_pp

end module m_PS_opencore

          SUBROUTINE MY_PDLAED0(N, HBW, D, E, LDE, Q, IQ, JQ,
!     $                 DESCQ, WORK, IWORK, LDQ, CQ, INFO)
     $                 DESCQ, WORK, IWORK, CP, CQ, INFO)
*
        IMPLICIT NONE
        
*  -- ScaLAPACK auxiliary routine (version 1.7) --
*     University of Tennessee, Knoxville, Oak Ridge National Laboratory,
*     and University of California, Berkeley.
*     December 31, 1998
*
*     .. Scalar Arguments ..
!      INTEGER            INFO, IQ, JQ, N, LDQ, CQ, HBW, LDE
      INTEGER            INFO, IQ, JQ, N, CP, CQ, HBW, LDE
      INTEGER :: LDQ
*     ..
*     .. Array Arguments ..
      INTEGER            DESCQ( * ), IWORK( * )
      DOUBLE PRECISION   D( * ), Q( * ), WORK( * )
      DOUBLE PRECISION   E( LDE, HBW )
*     ..
*
*  Purpose
*  =======
*
*  PDLAED0 computes all eigenvalues and corresponding eigenvectors of a
*  symmetric tridiagonal matrix using the divide and conquer method.
*
*
*  Arguments
*  =========
*
*  N       (global input) INTEGER
*          The order of the tridiagonal matrix T.  N >= 0.
*
*  D       (global input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, the diagonal elements of the tridiagonal matrix.
*          On exit, if INFO = 0, the eigenvalues in descending order.
*
*  E1      (global input/output) DOUBLE PRECISION array, dimension (N-1)
*          On entry, the subdiagonal elements of the tridiagonal matrix.
*          On exit, E has been destroyed.

*              (added by Phuong) 
*  E2          (global input) DOUBLE PRECISION array, dimention (N-2)
*          On entry, the second subdiagonal of the matrix
*          On exit, E has been destroyed(?)


*
*  Q       (local output) DOUBLE PRECISION array,
*          global dimension (N, N),
*          local dimension ( LLD_Q, LOCc(JQ+N-1))
*          Q  contains the orthonormal eigenvectors of the symmetric
*          tridiagonal matrix.
*          On output, Q is distributed across the P processes in block
*          cyclic format.
*
*  IQ      (global input) INTEGER
*          Q's global row index, which points to the beginning of the
*          submatrix which is to be operated on.
*
*  JQ      (global input) INTEGER
*          Q's global column index, which points to the beginning of
*          the submatrix which is to be operated on.
*
*  DESCQ   (global and local input) INTEGER array of dimension DLEN_.
*          The array descriptor for the distributed matrix Z.
*
*
*  WORK    (local workspace ) DOUBLE PRECISION array, dimension (LWORK)
*          LWORK = 6*N + 2*NP*NQ, with
*          NP = NUMROC( N, MB_Q, MYROW, IQROW, NPROW )
*          NQ = NUMROC( N, NB_Q, MYCOL, IQCOL, NPCOL )
*          IQROW = INDXG2P( IQ, NB_Q, MYROW, RSRC_Q, NPROW )
*          IQCOL = INDXG2P( JQ, MB_Q, MYCOL, CSRC_Q, NPCOL )
*
*  IWORK   (local workspace/output) INTEGER array, dimension (LIWORK)
*          LIWORK = 2 + 7*N + 8*NPCOL
*
*  INFO    (global output) INTEGER
*          = 0:  successful exit
*          < 0:  If the i-th argument is an array and the j-entry had
*                an illegal value, then INFO = -(i*100+j), if the i-th
*                argument is a scalar and had an illegal value, then
*                INFO = -i.
*          > 0:  The algorithm failed to compute the INFO/(N+1) th
*                eigenvalue while working on the submatrix lying in
*                global rows and columns mod(INFO,N+1).
*
*  =====================================================================
*
*     .. Parameters ..
*   
      INTEGER            BLOCK_CYCLIC_2D, DLEN_, DTYPE_, CTXT_, M_, N_,
     $                   MB_, NB_, RSRC_, CSRC_, LLD_
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1,
     $                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9  )
     $                     

*     ..
*     .. Local Scalars ..
      INTEGER            I, ID, IDCOL, IDROW, IID, IINFO, IIQ, IM1, IM2,
     $                   IPQ, IQCOL, IQROW, J, K, JJD, JJQ, MATSIZ,
     $                   MYCOL, MYROW, N1, NB, NBL, NBL1, NPCOL, NPROW,
     $                   SUBPBS, TSUBPBS
     $                   
      DOUBLE PRECISION   RHO
*       .. Local Arrays ..

        INTEGER          DESCZ( 50 )

       real(8) :: C(HBW,HBW), S(HBW), U(HBW,HBW), VVT(HBW, HBW),
     $            VT(HBW,HBW), UUT(HBW,HBW), V(HBW*HBW, HBW)
       real(8), pointer ::  W(:)
       real(8), pointer :: MA(:), AX(:), LAMDAX(:)
*     ..
*     .. External Subroutines ..
      EXTERNAL           BLACS_GRIDINFO, DGEBR2D, DGEBS2D, DGERV2D,
     $                   DGESD2D, DSTEQR, INFOG2L, MY_PDLAED1, PXERBLA, 
     $                   MY_PDLAEDZ
*     ..
*     .. External Functions ..
*     ..
      DOUBLE PRECISION               DNRM2
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MIN, MAX

      real(8) :: t1,t2
      integer :: MY_RANK
*     ..
*     .. Executable Statements ..
*
*       This is just to keep ftnchek and toolpack/1 happy
      IF( BLOCK_CYCLIC_2D*CSRC_*CTXT_*DLEN_*DTYPE_*LLD_*MB_*M_*NB_*N_*
     $    RSRC_.LT.0 )RETURN


*
*     Test the input parameters.
*
      CALL BLACS_GRIDINFO( DESCQ( CTXT_ ), NPROW, NPCOL, MYROW, MYCOL )


      INFO = 0
      IF( DESCQ( NB_ ).GT.N .OR. N.LT.2 )
     $   INFO = -1
   
      IF( INFO.NE.0 ) THEN
         CALL PXERBLA( DESCQ( CTXT_ ), 'PDLAED0', -INFO )
         RETURN
      END IF


*
*
      allocate( W(N) )
      NB = DESCQ( NB_ )
      LDQ = DESCQ( LLD_ )
      CALL INFOG2L( IQ, JQ, DESCQ, NPROW, NPCOL, MYROW, MYCOL, IIQ, JJQ,
     $              IQROW, IQCOL )

*
*     Determine the size and placement of the submatrices, and save in
*     the leading elements of IWORK.
*

      TSUBPBS = ( N-1 ) / NB + 1
      IWORK( 1 ) = TSUBPBS
      SUBPBS = 1
   10 CONTINUE
      IF( IWORK( SUBPBS ).GT.1 ) THEN
         DO 20 J = SUBPBS, 1, -1
            IWORK( 2*J ) = ( IWORK( J )+1 ) / 2
            IWORK( 2*J-1 ) = IWORK( J ) / 2
   20    CONTINUE
         SUBPBS = 2*SUBPBS
         GO TO 10
      END IF
      DO 30 J = 2, SUBPBS
         IWORK( J ) = IWORK( J ) + IWORK( J-1 )
   30 CONTINUE

*
*     Divide the matrix into TSUBPBS submatrices of size at most NB
*     using rank-1 modifications (cuts).
*


      DO 40 I = NB + 1, N, NB
          IM1 = I - 1
          
          C(1:HBW, 1:HBW) = 0

          DO J = 1, HBW
             DO K=1, J
                C(HBW+K-J, K) = E(IM1-J+K, J)
             END DO      
          END DO


*         SVD : C = U*S*VT
          CALL DGESVD('A', 'A', HBW, HBW, C, HBW, S, U, HBW,  
     $                VT, HBW, WORK, 7*HBW, IINFO)        ! WORK size should be much larger than 7HBW


          
          DO  J = 1, HBW
             DO  K = 1, HBW
                U(K, J)  = U(K, J)  * SQRT(S(J))
                VT(K,J) =  VT(K,J)  * SQRT(S(K))
             END DO
          END DO


          CALL DGEMM('N', 'T', HBW, HBW, HBW, 1.0D+0, U, HBW, U, 
     $          HBW, 0.0D+0, UUT, HBW)

          CALL DGEMM('T', 'N', HBW, HBW, HBW, 1.0D+0, VT, HBW, VT, 
     $          HBW, 0.0D+0, VVT, HBW)
          
         
          DO J = 1, HBW
            D(IM1-HBW+J) = D(IM1-HBW+J) - UUT(J, J)
            D(IM1+J)       = D(IM1+J)       - VVT(J, J)
          END DO
         
          DO J = 1, HBW-1
             DO  K = HBW-J, 1, -1
                E(IM1-K-J+1, J) = E(IM1-K-J+1, J) 
     $                - UUT(HBW-K+1, 1-K+HBW-J) 
                E(IM1+HBW-K-J+1,J) = E(IM1+HBW-K-J+1,J)
     $                             - VVT(HBW-K+1,1-K+HBW-J) 
               IF (MYROW.EQ.0 .AND. MYCOL.EQ.0) THEN

               ENDIF
             END DO
          END DO    


   40 CONTINUE

*
*     Solve each submatrix eigenproblem at the bottom of the divide and
*     conquer tree. D is the same on each process.
*


      DO 50 ID = 1, N, NB
         CALL INFOG2L( IQ-1+ID, JQ-1+ID, DESCQ, NPROW, NPCOL, MYROW,
     $                 MYCOL, IID, JJD, IDROW, IDCOL )
         MATSIZ = MIN( NB, N-ID+1 )
         IF( MYROW.EQ.IDROW .AND. MYCOL.EQ.IDCOL ) THEN
            IPQ = IID + ( JJD-1 )*LDQ
            
            CALL LAPACK_EIGEN2(N, MATSIZ, HBW, ID, D, 
     $                            E, LDE, Q( IPQ ), LDQ)
 
            IF( INFO.NE.0 ) THEN
               CALL PXERBLA( DESCQ( CTXT_ ), 'DSTEQR', -INFO )
               RETURN
            END IF
            IF( MYROW.NE.IQROW .OR. MYCOL.NE.IQCOL ) THEN
               CALL DGESD2D( DESCQ( CTXT_ ), MATSIZ, 1, D( ID ), MATSIZ,
     $                       IQROW, IQCOL )
            END IF
         ELSE IF( MYROW.EQ.IQROW .AND. MYCOL.EQ.IQCOL ) THEN
            CALL DGERV2D( DESCQ( CTXT_ ), MATSIZ, 1, D( ID ), MATSIZ,
     $                    IDROW, IDCOL )
         END IF
   50 CONTINUE
*            
            
            
      IF( MYROW.EQ.IQROW .AND. MYCOL.EQ.IQCOL ) THEN
         CALL DGEBS2D( DESCQ( CTXT_ ), 'A', ' ', N, 1, D, N )
      ELSE
         CALL DGEBR2D( DESCQ( CTXT_ ), 'A', ' ', N, 1, D, N, IQROW,
     $                 IQCOL )
      END IF

*
*     Successively merge eigensystems of adjacent submatrices
*     into eigensystem for the corresponding larger matrix.
*



*     while ( SUBPBS > 1 )
*
   60 CONTINUE
      IF( SUBPBS.GT.1 ) THEN       

         IM2 = SUBPBS - 2
         DO 80 I = 0, IM2, 2   
            IF( I.EQ.0 ) THEN
               NBL = IWORK( 2 )
               NBL1 = IWORK( 1 )
               IF( NBL1.EQ.0 )
     $            GO TO 70
               ID = 1
               MATSIZ = MIN( N, NBL*NB )
               N1 = NBL1*NB
            ELSE
               NBL = IWORK( I+2 ) - IWORK( I )
               NBL1 = NBL / 2
               IF( NBL1.EQ.0 )
     $            GO TO 70
               ID = IWORK( I )*NB + 1
               MATSIZ = MIN( NB*NBL, N-ID+1 )
               N1 = NBL1*NB
            END IF

        CALL DESCINIT( DESCZ, MATSIZ, 1, MATSIZ, 1, 0, 0, DESCQ(CTXT_), 
     $                        MATSIZ, IINFO)    

*
*     Merge lower order eigensystems (of size N1 and MATSIZ - N1)
*     into an eigensystem of size MATSIZ.
*
         IM1 =  ID+N1 - 1

          C(1:HBW, 1:HBW) = 0

          DO J = 1, HBW
             DO K=1, J
                C(HBW+K-J, K) = E(IM1-J+K, J)
               END DO
          END DO
          CALL DGESVD('A', 'A', HBW, HBW, C, HBW, S, U, HBW, VT,  
     $                HBW, WORK, 7*HBW, IINFO)
          DO J = 1, HBW
             DO K = 1, HBW
                U(K, J)  = U(K,J)  * SQRT(S(J))
                VT(K,J) = VT(K,J) * SQRT(S(K))
             END DO
          END DO

        DO K=1, HBW
          DO J = 1, HBW
            V(J,K) = U(J,K);   V(HBW+J, K) = VT(K,J);
          END DO
        ENDDO


        DO 61 K=1, HBW
           IF (K.EQ.1) THEN
              CALL MY_PDLAEDZ('H', HBW, MATSIZ, N1, ID, Q, IQ, JQ, LDQ, 
     $                    DESCQ, W, WORK (1 + N), V(1,K))
           ELSE
              CALL MY_PDLAEDZ('F', HBW, MATSIZ, N1, ID, Q, IQ, JQ, LDQ, 
     $                    DESCQ, W, WORK (1 + N), V(1,K))           
           END IF


           IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
              CALL DGEBS2D ( DESCQ( CTXT_ ), 'All', ' ', MATSIZ, 
     $              1,W,MATSIZ)
           ELSE
              CALL DGEBR2D ( DESCQ( CTXT_ ), 'All', ' ', MATSIZ, 
     $                1, W, MATSIZ, 0, 0)
           END IF
        
           RHO = DNRM2(MATSIZ, W, 1)
           IF(RHO .EQ. 0) GOTO 61
           CALL DSCAL( MATSIZ, 1/RHO, W, 1)
           RHO = RHO*RHO
           IF (K.EQ.1) THEN
              CALL MY_PDLAED1( MATSIZ, N1, D( ID ), ID, Q, IQ, JQ,  
     $        DESCQ, RHO, WORK, IWORK( SUBPBS+1 ), W, 1, IINFO )
           ELSE
              CALL MY_PDLAED1( MATSIZ, N1, D( ID ), ID, Q, IQ, JQ,  
     $        DESCQ, RHO, WORK, IWORK( SUBPBS+1 ), W, 2, IINFO )
           ENDIF
61      CONTINUE
    
           IF( IINFO.NE.0 ) THEN
               INFO = IINFO*( N+1 ) + ID
            END IF

   70       CONTINUE
            IWORK( I / 2+1 ) = IWORK( I+2 )
   80    CONTINUE
         SUBPBS = SUBPBS / 2

         GO TO 60

      END IF


*
*     end while
*
   90 CONTINUE

      deallocate( w )

      RETURN
*
*     End of PDLAED0
*
      END

!#========================================================================
!#                                                                       #
!# Software Name : UVSOR ver. 3.01                                       #
!#                                                                       #
!#      Sub Routine : WriteDownData_onto_Files_Eps                       #
!#                                                                       #
!#                                Written by T. Hamada 2006/4/28         #
!#                                                                       #
!#      Contact address :  IIS,The University of Tokyo RSS21 project     #
!#                                                                       #
!#"Multiscale Simulation System for Functional Analysis of Nanomaterials"#
!#                                                                       #
!#========================================================================
!
! $Id: WriteDownData_onto_Files_Epsilon.f90 593 2019-06-20 03:47:31Z jkoga $
subroutine WriteDownData_onto_Files_Eps
  use m_Epsilon_ek,           only : nlo, wd_eps, dealloc_m_Epsilon, &
       &                             kv3_in_the_ek_process
  use m_Files,                only : m_Files_close_nfeps, m_Files_close_nfepscont, &
       &                             m_Files_close_nfnlo
  use m_Kpoints,              only : kv3

  use m_Control_Parameters,   only : sw_corelevel_spectrum, sw_local_approx_trans_moment
  use m_Const_Parameters,     only : ON

  implicit none

  if ( sw_corelevel_spectrum == ON .and. sw_local_approx_trans_moment == ON ) then
     call dealloc_m_Epsilon
  else
     call wd_eps
     call dealloc_m_Epsilon
     call m_Files_close_nfeps
     call m_Files_close_nfepscont
  endif
  if(nlo/=0) call m_Files_close_nfnlo

end subroutine WriteDownData_onto_Files_Eps

#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)   call timer_sta(a)
#   define __TIMER_DO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif
#ifdef __TIMER_IODO__
#   define __TIMER_IODO_START(a)   call timer_sta(a)
#   define __TIMER_IODO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_IODO_START(a)
#   define __TIMER_IODO_STOP(a)
#endif
#ifdef __TIMER_COMM__
#   define __TIMER_COMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_COMM_START(a)       call timer_sta(a)
#   define __TIMER_COMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_COMM_START_w_BARRIER(str,a)
#   define __TIMER_COMM_START(a)
#   define __TIMER_COMM_STOP(a)
#endif
#ifdef __TIMER_IOCOMM__
#   define __TIMER_IOCOMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_IOCOMM_START(a)       call timer_sta(a)
#   define __TIMER_IOCOMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_IOCOMM_START_w_BARRIER(str,a)
#   define __TIMER_IOCOMM_START(a)
#   define __TIMER_IOCOMM_STOP(a)
#endif

module m_KineticEnergy_Density
  use m_Control_Parameters,  only : nspin, kimg, noncol, &
       &                            use_symm_ekin_density, use_asymm_ekin_density, &
       &                            af

  use m_KPoints,             only : kv3, vkxyz
  use m_Const_Parameters,    only : DP, DIRECT, OFF, ELECTRON, DELTA, BUCS, PAI2, NO, &
       &                            ANTIFERRO
  use m_PlaneWaveBasisSet,    only : kgp, kg1, ngabc, iba, nbase, igf, kg, gr_l, &
       &                             ngpt_l, ista_k, iend_k
  use m_Crystal_Structure,    only : rltv, univol, tau, nopr
  use m_Electronic_Structure, only : zaj_l, occup_l, m_ES_WF_in_Rspace1
  use m_FFT,                  only : m_FFT_alloc_WF_work, m_FFT_dealloc_WF_work, &
       &                             nfft, m_FFT_WF, fft_box_size_WF
  use m_Parallelization,      only : np_e, map_z, map_k, myrank_k, mpi_comm_group, &
       &                             npes, ista_kngp, iend_kngp, mype
  use m_Files,                only : nfout

! === KT_add === 2014/09/19
  use m_Const_Parameters,   only : YES, NO, EXECUT, SKIP, zi, SIMPLE_CUBIC, PAI, ON
  use m_Control_Parameters,  only : m_CtrlP_cachesize, ndim_magmom, nel_ylm, &
       &                            ekin_density_type, sw_rspace_ekin_density, &
       &                            sw_calc_ekin_density_hardpart, &
       &                            sw_add_ekin_hardpart_on_Gspace
  use m_Parallelization,      only : ista_fftph, iend_fftph, ista_fftp, iend_fftp, &
       &                             nel_fftp, idisp_fftp, ierr, &
       &                             ista_e, iend_e, istep_e
  use m_Ionic_System,           only : ntyp, ityp, natm, iwei, pos
  use m_Crystal_Structure,    only : nbztyp
  use m_PseudoPotential,    only :  kina_qitg_l, kins_qitg_l, modnrm, nqitg, &
       &                            m_PP_include_vanderbilt_pot, nlmt, dl2p, &
       &                            m_PP_find_maximum_l, &
       &                            m_PP_set_index_arrays1, m_PP_set_index_arrays2, &
       &                            mmesh, nmesh, xh, rmax, ilmt, ltp, mtp, taup, &
       &                            psirpw, phirpw
  use m_PlaneWaveBasisSet,    only : ylm_l,  m_pwBS_sphrp2, igfp_l
  use m_Charge_Density,       only : hsr

  use m_FFT,                  only : fft_box_size_CD, nfftp_nonpara, nfftp, &
       &                             m_FFT_CD_direct_c, m_FFT_alloc_CD_box, &
       &                             m_FFT_dealloc_CD_box
  use m_Realspace,            only : nmesh_rs_aug_max, nmesh_rs_aug, &
       &                             meshx_rs_aug, meshy_rs_aug, meshz_rs_aug, &
       &                             meshxyz_rs_aug, m_RS_R_minus_pos
! ============== 2014/09/19

  use m_Files,  only : nf_ekindens
  use m_Const_Parameters,   only : CMPLDP

  implicit none
  include 'mpif.h'

  real(kind=DP), allocatable, target :: ekins_l(:,:,:)  ! symmetric, positive definite
  real(kind=DP), allocatable, target :: ekina_l(:,:,:)  ! asymmetric

  real(kind=DP), allocatable, target :: ekins_old(:,:,:) 
  real(kind=DP), allocatable, target :: ekina_old(:,:,:) 

  real(kind=DP), allocatable :: kins_qrs_rspace(:,:,:,:) 
  real(kind=DP), allocatable :: kina_qrs_rspace(:,:,:,:) 

  real(kind=DP), public, pointer, dimension(:,:)        :: work

contains

  subroutine m_KE_alloc_ekin_density
    if ( use_symm_ekin_density ) then
       if ( noncol ) then
       else
          allocate( ekins_l(ista_kngp:iend_kngp,kimg,nspin) )
          allocate( ekins_old(ista_kngp:iend_kngp,kimg,nspin) )
       endif
       ekins_l = 0.0d0;   ekins_old = 0.0d0
    endif

    if ( use_asymm_ekin_density ) then
       if ( noncol ) then
       else
          allocate( ekina_l(ista_kngp:iend_kngp,kimg,nspin) )
          allocate( ekina_old(ista_kngp:iend_kngp,kimg,nspin) )
       endif
       ekina_l = 0.0d0;   ekina_old = 0.0d0
    endif
  end subroutine m_KE_alloc_ekin_density

  subroutine m_KE_dealloc_ekin_density
    if ( allocated( ekins_l ) ) deallocate( ekins_l )
    if ( allocated( ekina_l ) ) deallocate( ekina_l )
    if ( allocated( ekins_old ) ) deallocate( ekins_old )
    if ( allocated( ekina_old ) ) deallocate( ekina_old )

    if ( allocated( kins_qrs_rspace ) ) deallocate( kins_qrs_rspace )
  end subroutine m_KE_dealloc_ekin_density

  subroutine m_KE_cp_ekin_density_to_old
    if ( use_symm_ekin_density )  ekins_old = ekins_l
    if ( use_asymm_ekin_density ) ekina_old = ekina_l
  end subroutine m_KE_cp_ekin_density_to_old

  subroutine m_KE_calc_asymm_ekin_density
    ekina_l = 0.0d0

    call calc_local_part
    if ( sw_calc_ekin_density_hardpart == OFF ) return
    if ( sw_rspace_ekin_density == ON ) then
       if ( sw_add_ekin_hardpart_on_Gspace == OFF ) return
    endif

    if ( sw_rspace_ekin_density == ON ) then
       call add_hardpart_evaluated_rspace
    else
       call add_hardpart_to_ekinq_l( nfout, ndim_magmom, hsr, NO, .false. , &
            &                        kina_qitg_l, ekina_l )
    endif

  contains

    subroutine add_hardpart_evaluated_rspace
      integer :: is, ia, it, nma, ind, i
      integer :: lmt1, lmt2
      real(kind=DP) :: fac, fac0
      real(kind=DP), allocatable :: kina_tmp(:), ekina_hard(:,:)
      real(kind=DP), allocatable :: afft(:)

      call m_FFT_alloc_CD_box

      allocate( afft(ista_fftp:iend_fftp) ); afft = 0.0d0
      allocate( kina_tmp(nmesh_rs_aug_max)); kina_tmp = 0.0d0
      allocate( ekina_hard(ista_kngp:iend_kngp,kimg) ); ekina_hard = 0.0d0

      Do is=1, nspin
         afft = 0.0d0
         ekina_hard = 0.0d0

         Do ia=1, natm
            it = ityp(ia);   nma = nmesh_rs_aug(ia)        
            kina_tmp = 0.0d0

            Do lmt1=1, ilmt(it)
               Do lmt2=1, ilmt(it)
               
                  fac0=1.0d0
                  fac = hsr(ia,lmt1,lmt2,is) *fac0
                  Do i=1, nma
                     kina_tmp(i) = kina_tmp(i) &
                          &            +fac *kina_qrs_rspace(i,ia,lmt1,lmt2)
                  End do
               End do
            End do

            Do i=1, nma
               ind = meshxyz_rs_aug(i,ia)
               if ( ind >= ista_fftph .and. ind <= iend_fftph ) then
                  afft(2*ind-1) = afft(2*ind-1) +kina_tmp(i)
               endif
            End do
         End do

         afft = afft / univol

         call m_FFT_CD_direct_c( nfout, afft )         ! afft(R) -> afft(G)
         call extract_matrix_from_FFTcd_mesh( afft, ekina_hard(:,:) )
!
         ekina_l(:,:,is) = ekina_l(:,:,is) +ekina_hard(:,:)
      End Do

      call m_FFT_dealloc_CD_box
      deallocate( kina_tmp );  deallocate( afft )
      deallocate( ekina_hard )

    end subroutine add_hardpart_evaluated_rspace

    subroutine calc_local_part
      integer :: ispin, ik, ib, ixyz, ierr
      integer :: i, ig, ri, iend, i1
      real(kind=DP) :: fac, occupation, c1, c2
      real(kind=DP), allocatable :: qxyz(:,:), psi_l(:,:,:,:)
      real(kind=DP), allocatable :: afft(:), bfft(:), cfft(:)
      
      allocate(afft(nfft)); afft =0.0d0; 
      allocate(bfft(nfft)); bfft= 0.0d0
      allocate(cfft(nfft)); cfft= 0.0d0
      allocate( qxyz(kg1,3 ) ); qxyz = 0.0d0

      call m_FFT_alloc_WF_work()
    
      fac = 2.d0/(univol*kv3*product(fft_box_size_WF(1:3,1)))
      
      Do ispin=1, nspin
         afft = 0.0d0

         Do ik=ispin, kv3+ispin-nspin, nspin
            if ( map_k(ik) /= myrank_k ) cycle
            
            call k_plus_G_vectors_m( ik, kgp, kg1, kv3, iba, nbase, ngabc, rltv, &
                 &                   qxyz(:,1), qxyz(:,2), qxyz(:,3) )
            
            allocate( psi_l( kg1, np_e, ik:ik, kimg ) ); psi_l = 0.0d0
            
            Do ib = ista_e, iend_e, istep_e
               occupation = occup_l( map_z(ib),ik )
               if ( occupation < DELTA ) cycle
               
               call m_ES_WF_in_Rspace1( ista_k, iend_k, ik, ib, zaj_l, cfft )
               
               Do ig=1, iba(ik)
                  c1 = qxyz(ig,1)**2 + qxyz(ig,2)**2 + qxyz(ig,3)**2
                  psi_l(ig,map_z(ib),ik,1:2) = zaj_l(ig,map_z(ib),ik,1:2) *c1
               End Do
               call m_ES_WF_in_Rspace1( ik, ik, ik, ib, psi_l, bfft )
               
               Do i = 1, nfft-1, 2
                  c1 = bfft(i)*cfft(i)   +bfft(i+1)*cfft(i+1) 
                  c2 = bfft(i)*cfft(i+1) -bfft(i+1)*cfft(i) 
                  afft(i)   = afft(i)   + occupation *c1
                  afft(i+1) = afft(i+1) + occupation *c2
               End do
               
            End do
            deallocate( psi_l )
         End do
         !
         if ( npes > 1 ) then
            call mpi_allreduce( afft, bfft, nfft, mpi_double_precision, &
                 &              mpi_sum, mpi_comm_group, ierr )
            afft = bfft     
         end if
         call m_FFT_WF(ELECTRON,nfout,afft,DIRECT,OFF)
         !
         do ri = 1, kimg
            iend = iend_kngp
            if( iend_kngp > kg ) iend = kg
            if( ista_kngp <= iend ) then
               do i = ista_kngp, iend  !for mpi
                  i1 = kimg*igf(i) + (ri - kimg)
                  ekina_l(i,ri,ispin) = afft(i1)*fac
               end do
            endif
         end do
         
      End Do
      
      ekina_l = ekina_l /2.0d0
 
      call symmetrize_ekin( NO, ekina_l )

      deallocate( afft ); deallocate(bfft ); deallocate( cfft ); deallocate( qxyz )
      call m_FFT_dealloc_WF_work()

    end subroutine calc_local_part

  end subroutine m_KE_calc_asymm_ekin_density

  subroutine m_KE_calc_symm_ekin_density
    ekins_l = 0.0d0

    call calc_local_part

    if ( sw_calc_ekin_density_hardpart == OFF ) return

    if ( sw_rspace_ekin_density == ON ) then
       if ( sw_add_ekin_hardpart_on_Gspace == OFF ) return
    endif

    if ( sw_rspace_ekin_density == ON ) then
       call add_hardpart_evaluated_rspace
    else
       call add_hardpart_to_ekinq_l( nfout, ndim_magmom, hsr, NO, .false. , &
            &                        kins_qitg_l, ekins_l )
    endif

  contains

    subroutine add_hardpart_evaluated_rspace
      integer :: is, ia, it, nma, ind, i
      integer :: lmt1, lmt2
      real(kind=DP) :: fac, fac0
      real(kind=DP), allocatable :: kins_tmp(:), ekins_hard(:,:)
      real(kind=DP), allocatable :: afft(:)

      call m_FFT_alloc_CD_box

      allocate( afft(ista_fftp:iend_fftp) ); afft = 0.0d0
      allocate( kins_tmp(nmesh_rs_aug_max)); kins_tmp = 0.0d0
      allocate( ekins_hard(ista_kngp:iend_kngp,kimg) ); ekins_hard = 0.0d0

      Do is=1, nspin
         afft = 0.0d0
         ekins_hard = 0.0d0

         Do ia=1, natm
            it = ityp(ia);   nma = nmesh_rs_aug(ia)        
            kins_tmp = 0.0d0

            Do lmt1=1, ilmt(it)
               Do lmt2=lmt1, ilmt(it)
               
                  fac0=2.0d0
                  if (lmt1.eq.lmt2) fac0=1.d0

                  fac = hsr(ia,lmt1,lmt2,is) *fac0
                  Do i=1, nma
                     kins_tmp(i) = kins_tmp(i) &
                          &            +fac *kins_qrs_rspace(i,ia,lmt1,lmt2)
                  End do
               End do
            End do

            Do i=1, nma
               ind = meshxyz_rs_aug(i,ia)
               if ( ind >= ista_fftph .and. ind <= iend_fftph ) then
                  afft(2*ind-1) = afft(2*ind-1) +kins_tmp(i)
               endif
            End do
         End do

         afft = afft / univol

         call m_FFT_CD_direct_c( nfout, afft )         ! afft(R) -> afft(G)
         call extract_matrix_from_FFTcd_mesh( afft, ekins_hard(:,:) )
!
         ekins_l(:,:,is) = ekins_l(:,:,is) +ekins_hard(:,:)
      End Do

      call m_FFT_dealloc_CD_box
      deallocate( kins_tmp );  deallocate( afft )
      deallocate( ekins_hard )

    end subroutine add_hardpart_evaluated_rspace

    subroutine calc_local_part
      integer :: ispin, ik, ib, ixyz, ierr
      integer :: i, ig, ri, iend, i1
      real(kind=DP) :: fac, occupation
      real(kind=DP), allocatable :: qxyz(:,:), psi_l(:,:,:,:)
      real(kind=DP), allocatable :: afft(:), bfft(:)
      
      allocate(afft(nfft)); afft = 0.0d0
      allocate(bfft(nfft)); bfft= 0.0d0
      allocate( qxyz(kg1,3 ) ); qxyz = 0.0d0
    
      call m_FFT_alloc_WF_work()
    
      fac = 2.d0/(univol*kv3*product(fft_box_size_WF(1:3,1)))

      Do ispin=1, nspin
         afft = 0.0d0
       
         Do ik=1, kv3, nspin
            if ( map_k(ik) /= myrank_k ) cycle
            
            call k_plus_G_vectors_m( ik, kgp, kg1, kv3, iba, nbase, ngabc, rltv, &
                 &                   qxyz(:,1), qxyz(:,2), qxyz(:,3) )
          
            allocate( psi_l( kg1, np_e, ik:ik, kimg ) ); psi_l = 0.0d0

            Do ib = ista_e, iend_e, istep_e
               occupation = occup_l( map_z(ib),ik )
               if ( occupation < DELTA ) cycle
             
               Do ixyz=1, 3
                  psi_l = 0.0d0
                  if ( kimg == 1 ) then
                     stop "Not supported"
                  else
                     Do ig=1, iba(ik)
                        psi_l(ig,map_z(ib),ik,2) =  zaj_l(ig,map_z(ib),ik,1) &
                             &                       *qxyz(ig,ixyz)
                        psi_l(ig,map_z(ib),ik,1) = -zaj_l(ig,map_z(ib),ik,2) &
                             &                       *qxyz(ig,ixyz)
                     End do
                  endif
                
                  bfft = 0.0d0
                  call m_ES_WF_in_Rspace1( ik, ik, ik, ib, psi_l, bfft )
                
                  Do i = 1, nfft-1, 2
                     afft(i) = afft(i) + occupation*(bfft(i)**2+bfft(i+1)**2) ! MPI
                  End do
                  
               End Do
            End do
            deallocate( psi_l )
         End do
       !
         if ( npes > 1 ) then
            call mpi_allreduce( afft, bfft, nfft, mpi_double_precision, &
                 &              mpi_sum, mpi_comm_group, ierr )
            afft = bfft   
         end if
         call m_FFT_WF(ELECTRON,nfout,afft,DIRECT,OFF)
         !
         do ri = 1, kimg
            iend = iend_kngp
            if( iend_kngp > kg ) iend = kg
            if( ista_kngp <= iend ) then
               do i = ista_kngp, iend  !for mpi
                  i1 = kimg*igf(i) + (ri - kimg)
                  ekins_l(i,ri,ispin) = afft(i1)*fac
               end do
            endif
         end do

      End Do

      ekins_l = ekins_l /2.0d0

      call symmetrize_ekin( NO, ekins_l )

      deallocate( afft ); deallocate(bfft ); deallocate( qxyz )
      call m_FFT_dealloc_WF_work()

    end subroutine calc_local_part

  end subroutine m_KE_calc_symm_ekin_density


  subroutine extract_matrix_from_FFTcd_mesh( afft, matrix )
    real(kind=DP), intent(in) :: afft(ista_fftp:iend_fftp)
    real(kind=DP), intent(out) :: matrix(ista_kngp:iend_kngp,kimg)

    integer :: ik, i, ip
    real(kind=DP) :: rinplw
    real(kind=DP), allocatable :: afft_mpi1(:)

    matrix = 0.0d0

    allocate(afft_mpi1(nfftp))
    if ( npes >1 ) then
       call mpi_allgatherv( afft, nel_fftp(mype), mpi_double_precision, &  ! MPI
            &               afft_mpi1, nel_fftp, idisp_fftp, mpi_double_precision, &
            &               mpi_comm_group, ierr )
    else
       afft_mpi1 = afft
    end if

    rinplw = 1.d0 /product(fft_box_size_CD(1:3,1))
    do ik=1, kimg
       do i=ista_kngp, iend_kngp          !for mpi
          ip = (igfp_l(i)-1)*kimg + ik
          matrix(i,ik) = afft_mpi1(ip)*rinplw
       end do
    end do

  end subroutine extract_matrix_from_FFTcd_mesh

  subroutine k_plus_G_vectors_m(ik,kgp,kg1,knv3,iba,nbase,ngabc,rltv, &
       &                        qx,qy,qz)
    integer, intent(in)        :: ik, kgp,kg1,knv3,iba(knv3),nbase(kg1,knv3)
    integer, intent(in)        :: ngabc(kgp,3)
    real(kind=DP), intent(in)  :: rltv(3,3)
    real(kind=DP), intent(out) :: qx(kg1),qy(kg1),qz(kg1)

    integer :: i, ip
    real(kind=DP) :: ga, gb, gc

    do i = 1, iba(ik)
       ip = nbase(i,ik)
       ga = vkxyz(ik,1,BUCS) + real(ngabc(ip,1),kind=DP)
       gb = vkxyz(ik,2,BUCS) + real(ngabc(ip,2),kind=DP)
       gc = vkxyz(ik,3,BUCS) + real(ngabc(ip,3),kind=DP)
       qx(i)  = rltv(1,1)*ga + rltv(1,2)*gb + rltv(1,3)*gc
       qy(i)  = rltv(2,1)*ga + rltv(2,2)*gb + rltv(2,3)*gc
       qz(i)  = rltv(3,1)*ga + rltv(3,2)*gb + rltv(3,3)*gc
    end do
  end subroutine k_plus_G_vectors_m


  subroutine symmetrize_ekin(mode,ekin)
    integer,intent(in)           :: mode 
    real(kind=DP), intent(inout) :: ekin(ista_kngp:iend_kngp,kimg,nspin)

    integer ::       ispin, ng, no, ngp, no1, no2
    real(kind=DP) :: fi, tx,ty,tz, fp, fc, fs, zcr, zci
    real(kind=DP), allocatable :: work(:,:), work2(:,:)

    allocate(work(kgp,kimg)); work = 0.d0
    allocate(work2(ista_kngp:iend_kngp,kimg)); work2 = 0.d0

    if(mode == ANTIFERRO) then
       fi = 1.d0/af
       no1 = nopr + 1; no2 = nopr + af
    else
       fi = 1.d0/nopr
       no1 = 1; no2 = nopr
    end if

    do ispin = 1, nspin, af+1
       work = 0.0d0
       call cp_ekin_to_work(ispin,ekin)     ! ekin -> work
       work2 = 0.d0                          ! initialization

       do no = no1, no2
          tx = tau(1,no,BUCS)*PAI2
          ty = tau(2,no,BUCS)*PAI2
          tz = tau(3,no,BUCS)*PAI2
          if(kimg == 1) then
             do ng = ista_kngp, iend_kngp !for mpi
                ngp = ngpt_l(ng,no)
                fp = ngabc(ngp,1)*tx + ngabc(ngp,2)*ty + ngabc(ngp,3)*tz
                work2(ng,1)        = work2(ng,1) + dcos(fp)*work(ngp,1)
             end do
          else if(kimg == 2) then
             do ng = ista_kngp, iend_kngp !for mpi
                ngp= ngpt_l(ng,no)
                fp = ngabc(ngp,1)*tx + ngabc(ngp,2)*ty + ngabc(ngp,3)*tz
                fc = dcos(fp);     fs = dsin(fp)
                zcr= work(ngp,1);  zci= work(ngp,kimg)
                work2(ng,1)        = work2(ng,1) + fc*zcr - fs*zci
                work2(ng,2)        = work2(ng,2) + fc*zci + fs*zcr
             end do
          end if
       end do
       if(mode /= ANTIFERRO) ekin(:,:,ispin) = work2(:,:)*fi
    end do

    if(mode == ANTIFERRO) ekin(:,:,nspin) = work2(:,:)*fi

    deallocate( work )
    deallocate(work2)

  contains

    subroutine cp_ekin_to_work(ispin,ekin)
      integer, intent(in) :: ispin
      real(DP),intent(in),dimension(ista_kngp:iend_kngp,kimg,nspin) :: ekin
      
      integer :: ng,ri, ierr
      real(kind=DP), allocatable, dimension(:,:) :: work_mpi
      
      do ri = 1, kimg
         do ng = ista_kngp, iend_kngp  !for mpi
            work(ng,ri) = ekin(ng,ri,ispin)
         end do
      end do
      
      if(npes >= 2) then
         allocate(work_mpi(kgp,kimg)); work_mpi = 0.d0
         call mpi_allreduce( work, work_mpi, kgp*kimg, mpi_double_precision, &
              &              mpi_sum, mpi_comm_group, ierr )
         work = work_mpi
         deallocate(work_mpi)
      end if
      
    end subroutine cp_ekin_to_work
    
  end subroutine symmetrize_ekin


  subroutine m_KE_set_modeled_ekin_density( ista_rho, iend_rho, &
       &                                    rho, grad_rho, grad2_rho, ekin_dens )
    integer,intent(in) :: ista_rho, iend_rho
    real(kind=DP), intent(in) :: rho( ista_rho:iend_rho, nspin )
    real(kind=DP), intent(in) :: grad_rho( ista_rho:iend_rho, nspin )
    real(kind=DP), intent(in) :: grad2_rho( ista_rho:iend_rho, nspin )
    real(kind=DP), intent(out) :: ekin_dens( ista_rho:iend_rho, nspin )
    
    select case ( ekin_density_type )

    case (1)
       call calc_Abramov_ekin_density( rho, grad_rho, grad2_rho, ekin_dens )

    case (2)                        ! Thomas-Fermi von Weizsacker
       call calc_TF_vWeiz_ekin_density( rho, grad_rho, grad2_rho, &
         &                              1.0d0, 1.0d0, ekin_dens )

    case (3)                        ! extended Thomas-Fermi
       call calc_Extended_TF_ekin_density( rho, grad_rho, grad2_rho, ekin_dens )

    end select

  contains

    subroutine calc_extended_TF_ekin_density( rho, grad_rho, grad2_rho, &
         &                                    ekin_dens )
      real(kind=DP), intent(in) :: rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(in) :: grad_rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(in) :: grad2_rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(out) :: ekin_dens( ista_rho:iend_rho, nspin )

      integer :: is, i
      real(kind=DP) :: c1, c2, c3, kappa0, kappa2, kappa4, term1, term2, term3
      real(kind=DP), parameter :: delta1 = 1.0E-12

      c1 = (3.0d0*PAI**2)**(2.0d0/3.0d0)
      kappa0 = 3.0d0/5.0d0 *c1
      kappa2 = 1.0d0/36.0d0
      kappa4 = 1.0d0/6480.0d0/c1

      ekin_dens = 0.0d0

      Do is=1, nspin
         Do i=ista_rho, iend_rho
            c1 = rho(i,is)

            if ( c1 > delta1 ) then
               c2 =  grad_rho(i,is)/c1
               c3 = grad2_rho(i,is)/c1

               term1 = kappa0 *c1**(5.0d0/3.0d0)
               term2 = kappa2 *grad_rho(i,is)*c2
               term3 = kappa4 *c1**(1.0d0/3.0d0) &
                    &         *( 8.0d0 *c2**4 -27.0d0 *c2**2 *c3 +24.0d0 *c3**2 )

               ekin_dens(i,is) = term1 +term2 +term3
            endif
         End do
      End Do
      ekin_dens = ekin_dens /2.0d0

    end subroutine calc_extended_TF_ekin_density

    subroutine calc_TF_vWeiz_ekin_density( rho, grad_rho, grad2_rho, &
         &                                 weight_TF, weight_vWeiz, ekin_dens )
      real(kind=DP), intent(in) :: weight_TF,  weight_vWeiz
      real(kind=DP), intent(in) :: rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(in) :: grad_rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(in) :: grad2_rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(out) :: ekin_dens( ista_rho:iend_rho, nspin )

      integer :: is, i
      real(kind=DP) :: c1, coeff, term1, term2, term3
      real(kind=DP), parameter :: delta1 = 1.0E-12

      coeff = 3.0d0/10.0d0 *(3.0D0*PAI**2)**( 2.0d0/3.0d0 )

      ekin_dens = 0.0d0

      Do is=1, nspin
         Do i=ista_rho, iend_rho
            c1 = rho(i,is)

            if ( c1 > delta1 ) then
               term1 = coeff *c1**(5.0d0/3.0d0)
               term2 = grad_rho(i,is)**2 /c1 /8.0d0
               ekin_dens(i,is) = weight_TF *term1 + weight_vWeiz *term2
            endif

         End do
      End Do
    end subroutine calc_TF_vWeiz_ekin_density

    subroutine calc_Abramov_ekin_density( rho, grad_rho, grad2_rho, ekin_dens )
      real(kind=DP), intent(in) :: rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(in) :: grad_rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(in) :: grad2_rho( ista_rho:iend_rho, nspin )
      real(kind=DP), intent(out) :: ekin_dens( ista_rho:iend_rho, nspin )

      integer :: is, i
      real(kind=DP) :: c1, c2, coeff, term1, term2, term3
      real(kind=DP), parameter :: delta1 = 1.0E-15

      coeff = 3.0d0/10.0d0 *(3.0D0*PAI**2)**( 2.0d0/3.0d0 )

      ekin_dens = 0.0d0

      Do is=1, nspin
         Do i=ista_rho, iend_rho
            c1 = rho(i,is) *nspin
            term1 = coeff *c1**(5.0d0/3.0d0) /nspin

            if ( c1 > delta1 ) then
               c2 = grad_rho(i,is) *nspin
               term2 = c2**2 /c1 /8.0 /nspin

               term2 = term2 /9.0d0
            else
               term2 = 0.0d0
            endif

            term3 = grad2_rho(i,is) /6.0d0
            term3 = term3 *1.05

            ekin_dens(i,is) = term1 + term2 + term3
         End do
      End Do
    end subroutine calc_Abramov_ekin_density

  end subroutine m_KE_set_modeled_ekin_density

! =================================== modified by K. Tagami ============ 11.0
!!  subroutine add_hardpart_to_ekinq_l(nfout,kspin,hsr)
  subroutine add_hardpart_to_ekinq_l( nfout, kspin, hsr, singlemode, &
       &                              do_symmetrization, &
       &                              kin_qitg_l, ekinq_l )
! ===================================================================== 11.0
    !  The total operation number has been reduced not only for the gamma-point
    ! but also for other k-points by T. Yamasaki in April 2006.
    !  ----
    ! (Rev) T. Yamaskai, 31, Aug, 2007
    !     1. 'call set_index_arrays1' that included a bug is replaced
    !       by 'call m_PP_set_index_arrays1', whose bug is fixed.
    !     2. 'call set_index_arrays2' is also replaced by 'call
    !       m_PP_set_index_arrays2' that can be referred from other modules.
    !     3. contained subroutines, set_index_arrays1 and set_index_arrays2 were
    !       deleted.

    integer, intent(in) :: nfout, kspin, singlemode
    logical, intent(in) :: do_symmetrization
    
! ================================ modified by K. Tagami ================= 11.0
!    real(kind=DP), intent(in), dimension(natm,nlmt,nlmt,nspin):: hsr
    real(kind=DP), intent(in), dimension(natm,nlmt,nlmt,ndim_magmom):: hsr
! ======================================================================== 11.0

    real(kind=DP), intent(in) :: kin_qitg_l( ista_kngp:iend_kngp,nqitg )
    real(kind=DP), intent(out) :: ekinq_l(ista_kngp:iend_kngp,kimg,ndim_magmom)

    real(kind=DP), pointer, dimension(:)               :: ylm
    real(kind=DP), allocatable, target, dimension(:)   :: ylm_t
    real(kind=DP), allocatable, target, dimension(:,:) :: ylm_ext

    integer :: is,it,lmt1,lmt2,n,ia,mdvdb,il1,tau1,il2,tau2,ilm3,l3,iiqitg
    real(kind=DP) :: fac !, tpos(3)

    integer :: kngp_adj, n_ialist, n_ialist0, ia_start, ia_end, n_iagroup, n_ia, ia_g

    integer, allocatable, dimension(:)                :: il3

    real(kind=DP), allocatable, dimension(:,:) :: zfcos_x, zfsin_x
    real(kind=DP), allocatable, target, dimension(:) :: zfcos, zfsin
    real(kind=DP), allocatable, dimension(:) :: work(:,:)

    integer, allocatable, dimension(:) :: ia_list
#ifdef _VECTOR_TUNING_
    real(kind=DP), allocatable, dimension(:,:,:) :: shdg_x ! d(n_ialist0,maxm,nqitg)
#else
    real(kind=DP), allocatable, dimension(:,:) :: ylm_red, qitg_red
    real(kind=DP), allocatable, dimension(:) :: ylm_sum
    real(kind=DP), allocatable, dimension(:,:,:) :: ekinq_red
    real(kind=DP), allocatable, dimension(:,:) :: shdg  ! d(max,nqitg,nspin)
    integer ::          iqm, iqmmax
    real(kind=DP) :: zdga
#endif

    integer :: m, maxm, ip, np, iq, sw_spin
    integer, parameter :: mcritical = 4*2+1
    integer, allocatable, dimension(:) :: nqitg_sp, nqitg_sp0 !d(ntyp)
    integer, allocatable, dimension(:) :: iq2l3 ! d(nqitg)
    integer, allocatable, dimension(:,:) :: nc  ! d(maxm,nqitg)
    integer :: mc ! maxval(nc)
    integer, allocatable, dimension(:,:,:) :: nc2lmt1, nc2lmt2, nc2n ! d(mc,maxm,nqitg)
! NEC tune
    integer :: ibl1,ibl2,ibsize,ncache,iwidth

! =============================== added by K. Tagami ================ 11.0
    integer :: nspin_kt, ispi_start
! =================================================================== 11.0

! =============================== added by K. Tagami =============== 11.0
    if ( singlemode == YES ) then
       ispi_start = kspin
    else
       ispi_start = 1
    endif
! ================================================================== 11.0

!!!!    if(modnrm == EXECUT) then
       call m_PP_find_maximum_l(n)   !  n-1: maximum l
       n = (n-1) + (n-1) + 1
! =============================== Modified by K. Tagami =========
!       allocate(il3(n**2)); call substitute_il3(n**2,il3) ! -(b_Elec..)
       allocate(il3(n**2)); il3=0; call substitute_il3(n**2,il3) ! -(b_Elec..)
! ==============================================================

       allocate(nqitg_sp(ntyp)); allocate(nqitg_sp0(ntyp))
       allocate(iq2l3(nqitg))
       allocate(nc(mcritical,nqitg));nc=0
! =================================== Added by K. Tagami =======
	nqitg_sp = 0; nqitg_sp0 = 0; iq2l3 = 0
! ==============================================================
       call m_PP_set_index_arrays1(nfout,ntyp,nqitg,mcritical,n**2,il3 &
            & ,maxm,mc,nqitg_sp,nqitg_sp0,iq2l3,nc)
       allocate(nc2lmt1(mc,maxm,nqitg))
       allocate(nc2lmt2(mc,maxm,nqitg))
       allocate(nc2n(mc,maxm,nqitg))
! ==================================== Added by K. Tagami ======
       nc2lmt1 = 0;  nc2lmt2 = 0; nc2n = 0
! =============================================================
       call m_PP_set_index_arrays2(nfout,mc,maxm,nqitg,mcritical,n**2,il3,iq2l3 &
            & ,nc2lmt1,nc2lmt2,nc2n,nc) ! -> nc2lmt1, nc2lmt2, nc2n, nc

#ifdef _VECTOR_TUNING_

       n_ialist = 1
#ifdef HIUX
       n_ialist = 4
#endif
#ifdef VPP
       n_ialist = 8
#endif
#ifdef SX
       n_ialist = 8
#endif
       kngp_adj = iend_kngp - ista_kngp + 1
       if(mod(kngp_adj,2) == 0) kngp_adj = kngp_adj + 1
       allocate(zfcos_x(kngp_adj,n_ialist)); zfcos_x = 0.d0
       allocate(zfsin_x(kngp_adj,n_ialist)); zfsin_x = 0.d0
       allocate(ia_list(n_ialist)); ia_list = 0
! NEC tune
!       allocate(shdg_x(n_ialist))
       allocate(shdg_x(n_ialist,maxm,nqitg))
! ================================================ by K. Tagami =======
        shdg_x = 0.0d0
! ===================================================================

       if(n**2 > nel_Ylm) then
          allocate(ylm_ext(ista_kngp:iend_kngp,nel_Ylm+1:n**2)); ylm_ext = 0.d0
       end if
       allocate(ylm_t(ista_kngp:iend_kngp)); ylm_t = 0.d0
       do ilm3 = nel_Ylm+1, n**2
          call m_pwBS_sphrp2(ilm3,rltv,ista_kngp,iend_kngp,ylm_t)
          ylm_ext(:,ilm3) = ylm_t(:)
       end do

!!$       do is = 1, kspin, af+1
          do it = 1, ntyp
             mdvdb = m_PP_include_vanderbilt_pot(it)
!!!!!             if(mdvdb == SKIP) cycle

             n_ia = 0
             do ia = 1, natm
                if(ityp(ia) == it) n_ia = n_ia + 1
             end do

             if(n_ialist <=0) stop 'n_ialist is illegal <<m_Charge_Density.add_hardpart_to_ekinq_l>>'
             n_iagroup = n_ia/n_ialist + 1
             ia_start = 1

             do ia_g = 1, n_iagroup
                n_ialist0 = 0
                ia_list = 0
                AtomcountLoop: do ia = ia_start, natm
                   if(ityp(ia) == it) then
                      n_ialist0 = n_ialist0 + 1
                      ia_list(n_ialist0) = ia
                   end if
                   if(n_ialist0 >= n_ialist) exit AtomcountLoop
                end do AtomcountLoop
                ia_start = ia+1
                if(n_ialist0 >= 1 )then


! NEC tune ------------------------------------------------------------------->
!!$      ncache = (cachesize(3)*1024)*3/4
      ncache = (m_CtrlP_cachesize()*1024)*3/4
      if(ncache == 0) then
         ibsize = iend_kngp - ista_kngp + 1
      else

      iwidth = nqitg_sp(it) - nqitg_sp0(it)
      if(n_ialist0 == 1) then
         if(kimg == 1) then ! kin_qitg_l(i,iq)*ylm(iy)*zfsc1_1(iy)
           ibsize=ncache/(8*(2+iwidth))
         else ! kin_qitg_l(i,iq),ylm(iy),zfsc1_1(iy),zfsc2_1(iy)
           ibsize=ncache/(8*(3+iwidth))
         endif
      else if(n_ialist0 == 2) then
         if(kimg == 1) then ! kin_qitg_l(i,iq),ylm(iy),zfsc1_1(iy),zfsc1_2(iy)
           ibsize=ncache/(8*(3+iwidth))
         else ! kin_qitg_l(i,iq)
              ! ylm(iy),zfsc1_1(iy),zfsc1_2(iy),zfsc2_1(iy),zfsc2_2(iy)
           ibsize=ncache/(8*(5+iwidth))
         endif
      else if(n_ialist0 == 3) then
         if(kimg == 1) then ! kin_qitg_l(i,iq)
                            ! ylm(iy),zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy)
           ibsize=ncache/(8*(4+iwidth))
         else ! kin_qitg_l(i,iq),ylm(iy),zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy)
              !                      zfsc2_1(iy),zfsc2_2(iy),zfsc2_3(iy)
           ibsize=ncache/(8*(7+iwidth))
         endif
      else if(n_ialist0 == 4) then
         if(kimg == 1) then ! kin_qitg_l(i,iq)
                   ! ylm(iy),zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy),zfsc1_4(iy)
           ibsize=ncache/(8*(5+iwidth))
         else ! kin_qitg_l(i,iq),ylm(iy)
              ! zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy),zfsc1_4(iy)
              ! zfsc2_1(iy),zfsc2_2(iy),zfsc2_3(iy),zfsc2_4(iy)
           ibsize=ncache/(8*(9+iwidth))
         endif
      else if(n_ialist0 == 5) then
         if(kimg == 1) then ! kin_qitg_l(i,iq),ylm(iy)
               ! zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy),zfsc1_4(iy),zfsc1_5(iy))
           ibsize=ncache/(8*(6+iwidth))
         else ! kin_qitg_l(i,iq),ylm(iy)
              ! zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy),zfsc1_4(iy),zfsc1_5(iy)
              ! zfsc2_1(iy),zfsc2_2(iy),zfsc2_3(iy),zfsc2_4(iy),zfsc2_5(iy)
           ibsize=ncache/(8*(11+iwidth))
         endif
      else if(n_ialist0 == 6) then
         if(kimg == 1) then ! kin_qitg_l(i,iq),ylm(iy)
                 ! zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy),zfsc1_4(iy)
                 ! zfsc1_5(iy),zfsc1_6(iy)
           ibsize=ncache/(8*(7+iwidth))
         else ! kin_qitg_l(i,iq),ylm(iy)
              ! zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy),zfsc1_4(iy)
              ! zfsc1_5(iy),zfsc1_6(iy))
              ! zfsc2_1(iy),zfsc2_2(iy),zfsc2_3(iy),zfsc2_4(iy)
              ! zfsc2_5(iy),zfsc2_6(iy))
           ibsize=ncache/(8*(13+iwidth))
         endif
      else if(n_ialist0 == 7) then
         if(kimg == 1) then
             !  kin_qitg_l(i,iq),ylm(iy)
             !  zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy),zfsc1_4(iy)
             !  zfsc1_5(iy),zfsc1_6(iy),zfsc1_7(iy)
           ibsize=ncache/(8*(8+iwidth))
         else
             !  kin_qitg_l(i,iq),ylm(iy)
             !  zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy),zfsc1_4(iy)
             !  zfsc1_5(iy),zfsc1_6(iy),zfsc1_7(iy)
             !  zfsc2_1(iy),zfsc2_2(iy),zfsc2_3(iy),zfsc2_4(iy)
             !  zfsc2_5(iy),zfsc2_6(iy),zfsc2_7(iy)
           ibsize=ncache/(8*(15+iwidth))
         endif
      else if(n_ialist0 >= 8) then
         if(kimg == 1) then
             !  kin_qitg_l(i,iq),ylm(iy)
             !  zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy),zfsc1_4(iy)
             !  zfsc1_5(iy),zfsc1_6(iy),zfsc1_7(iy),zfsc1_8(iy)
           ibsize=ncache/(8*(9+iwidth))
         else
            !   kin_qitg_l(i,iq),ylm(iy)
            !   zfsc1_1(iy),zfsc1_2(iy),zfsc1_3(iy),zfsc1_4(iy)
            !   zfsc1_5(iy),zfsc1_6(iy),zfsc1_7(iy),zfsc1_8(iy)
            !   zfsc2_1(iy),zfsc2_2(iy),zfsc2_3(iy),zfsc2_4(iy)
            !   zfsc2_5(iy),zfsc2_6(iy),zfsc2_7(iy),zfsc2_8(iy)
           ibsize=ncache/(8*(17+iwidth))
         endif
      end if
      endif
! debug
!write(6,990) 'n_ialist0,kimg,ibsize,ista_kngp,iend_kngp,iwidth=',&
!n_ialist0,kimg,ibsize,ista_kngp,iend_kngp,iwidth
!990 format(a,i2,i2,4i8)
      call calc_phase_b(natm,pos,ia_list,n_ialist0,kgp,ngabc,ista_kngp,iend_kngp,1,kngp_adj,zfcos_x,zfsin_x)
      do ibl1=ista_kngp,iend_kngp,ibsize
        ibl2=ibl1+ibsize-1
        if(ibl2.gt.iend_kngp) ibl2=iend_kngp
! NEC tune <-------------------------------------------------------------------

!!$          do ia = 1, natm
!!$             it = ityp(ia)
!!$             mdvdb = m_PP_include_vanderbilt_pot(it)
!!$             if(mdvdb == SKIP) cycle
! NEC tune (move 1 line to up)
!                   call calc_phase_b(natm,pos,ia_list,n_ialist0,kgp,ngabc,ista_kngp,iend_kngp,1,kngp_adj,zfcos_x,zfsin_x)
!!$             call calc_phase2(natm,pos,ia,kgp,ngabc,ista_kngp,iend_kngp,zfcos,zfsin)
                   ! -(b_Elec.)  -> zfcos, zfsin

! =========================== modified by K. Tagami ============= 11.0
!                do is = 1, kspin, af+1
                do is = ispi_start, kspin, af+1
! =============================================================== 11.0

! NEC tune --------------------------------------------------->
                   do iq = nqitg_sp0(it), nqitg_sp(it)
                      l3 = iq2l3(iq)
                      do m = 1, 2*l3+1
                         call sum_hsr_dot_gauntc(is,it,iq,m) ! hsr, dl2p -> shdg_x(n_ialist0)
                      end do
                   end do
! NEC tune <---------------------------------------------------

                   do iq = nqitg_sp0(it), nqitg_sp(it)
                      l3 = iq2l3(iq)
                      do m = 1, 2*l3+1
                         ilm3 = l3*l3+m
! NEC tune
!                         call sum_hsr_dot_gauntc(is,it,iq,m) ! hsr, dl2p -> shdg_x(n_ialist0)
                         if(ilm3 <= nel_Ylm) then
                            ylm => ylm_l(ista_kngp:iend_kngp,ilm3)
                         else
                            ylm => ylm_ext(ista_kngp:iend_kngp,ilm3)
                         end if
                         call add_hardpart_to_ekinq_l_core4(iq) ! iq, shdg_x, exp(-iGR), kin_qitg_l, ylm -> ekinq_l
                         !    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                      end do
                   end do
! NEC tune
                end do
             end do ! ibl1
                end if
             end do! ia_g
          end do! it 
!!$       end do! is
       deallocate(ylm_t)
       if(allocated(ylm_ext)) deallocate(ylm_ext)
       deallocate(shdg_x)
       deallocate(ia_list,zfsin_x,zfcos_x,il3)
#else

       ncache = (m_CtrlP_cachesize()*1024)*3/4
       if(ncache == 0) then
          ibsize = iend_kngp - ista_kngp + 1
       else
          iwidth = 0.d0
          do it = 1, ntyp
             iwidth = max(iwidth,nqitg_sp(it)-nqitg_sp0(it)+1)
          end do
          if(kimg == 1) then ! kin_qitg_l(i,iq)*ylm(iy)*zfsc1_1(iy)
             ibsize=ncache/(8*(iwidth + 1))
          else ! kin_qitg_l(i,iq),ylm(iy),zfsc1_1(iy),zfsc2_1(iy)
             ibsize=ncache/(8*(iwidth + 2))
          endif
       end if

       allocate(zfcos(ibsize)); zfcos = 0.d0
       allocate(zfsin(ibsize)); zfsin = 0.d0
       allocate(qitg_red(ibsize,nqitg))
       allocate(ylm_red(ibsize,n**2))
       allocate(ylm_sum(ibsize))

! =========================== modified by K. Tagami =================== 11.0
!       if(kspin == 2 .and. af == 0) then
!          sw_spin = ON
!       else
!          sw_spin = OFF
!       end if
! ===================================================================== 11.0

! ============================== added by K. Tagami ================== 11.0
       if ( noncol ) then
          nspin_kt = kspin
       else
          nspin_kt = nspin /(af+1)
       endif
! ================================================================ 11.0

       iqmmax = 0
       do it = 1, ntyp
          iqm = 0
          do iq = nqitg_sp0(it), nqitg_sp(it)
             l3 = iq2l3(iq)
             do m = 1, 2*l3+1
                iqm = iqm+1
             end do
          end do
          if(iqmmax < iqm) iqmmax = iqm
       end do

! ===================== modified by K. Tagami ============== 11.0
!       if(sw_spin == ON) then
!          allocate(ekinq_red(ibsize,kimg,2))
!          allocate(shdg(iqmmax,2))
!       else if(sw_spin == OFF) then
!          allocate(ekinq_red(ibsize,kimg,1))
!          allocate(shdg(iqmmax,1))
!       end if
! ========================================================== 11.0
! ========================= added by K. Tagami =========== 11.0
       allocate( ekinq_red( ibsize, kimg, nspin_kt ))
       allocate( shdg( iqmmax,nspin_kt ))
! ========================================================= 11.0

       do ibl1=ista_kngp,iend_kngp,ibsize
          ibl2=ibl1+ibsize-1
          if(ibl2.gt.iend_kngp) ibl2=iend_kngp
          if(ibl2.gt.kgp) ibl2 = kgp

          ekinq_red = 0.d0
          call substitute_qitgred()  ! kin_qitg_l -> qitg_red
          call substitute_ylmred() ! ylm_l, ylm_ext -> ylm_red
          do ia = 1, natm
             it = ityp(ia)
             mdvdb = m_PP_include_vanderbilt_pot(it)
!!!!             if(mdvdb == SKIP) cycle

             call calc_phase_div(ia) ! -> zfsin, zfcos

!!$             iqm = 0
!!$             do iq = nqitg_sp0(it), nqitg_sp(it)
!!$                l3 = iq2l3(iq)
!!$                do m = 1, 2*l3+1
!!$                   iqm = iqm+1
!!$                   call sum_hsr_dot_gauntc0(it,ia,iq,m,iqm) ! hsr, dl2p -> shdg
!!$                end do
!!$             end do
!!$             iqmmax = iqm

! ================================= modified by K. Tagami ========== 11.0
!             do is = 1, kspin, af+1
             do is = ispi_start, kspin, af+1
! ================================================================== 11.0

                iqm = 0
                do iq = nqitg_sp0(it), nqitg_sp(it)
                   l3 = iq2l3(iq)
                   ylm_sum = 0.d0
                   do m = 1, 2*l3+1
                      ilm3 = l3*l3+m
                      iqm = iqm+1
                      call sum_hsr_dot_gauntc0(it,ia,iq,m,iqm) ! hsr, dl2p -> shdg
                      ylm_sum(:) = ylm_sum(:) + shdg(iqm,is)*ylm_red(:,ilm3)
                   end do
                   if(mod(l3,2) == 0) then
                      zdga = real(zi**(-l3))
                      call add_hardpart_to_ekinq_l_div0(zdga,iq) ! iq, shdg_x, exp(-iGR), kin_qitg_l, ylm -> ekinq_l
                   else
                      zdga = aimag(zi**(-l3))
                      call add_hardpart_to_ekinq_l_div1(zdga,iq) ! iq, shdg_x, exp(-iGR), kin_qitg_l, ylm -> ekinq_l
                   end if
!!$                   call add_hardpart_to_ekinq_l_div(iq) ! iq, shdg_x, exp(-iGR), kin_qitg_l, ylm -> ekinq_l
                   !    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                end do
             end do
          end do
          call cp_ekinqred2ekinq()
       end do
       deallocate(ylm_sum,ylm_red,qitg_red,shdg)
       deallocate(ekinq_red)
       deallocate(zfsin,zfcos)
#endif

       deallocate(nc2n,nc2lmt2,nc2lmt1,nc,iq2l3,nqitg_sp,nqitg_sp0)
!!!    endif

    if(nbztyp >= SIMPLE_CUBIC .or. af /=0 ) then
       allocate(work(kgp,kimg))
! =========================================== Added by K. Tagami ====
        work = 0.0d0
! ===================================================================

! ==================================== modified by K. Tagami ============== 11.0
      if(nbztyp >= SIMPLE_CUBIC .and. do_symmetrization ) then
         if ( noncol ) then
!!!            call symmetrize_ekin_noncl( NO,ekinq_l )
         else
            call symmetrize_ekin( NO,ekinq_l )
         endif
      endif
! ========================================================================== 11.0
      
       deallocate(work)
    end if

  contains

#ifdef _VECTOR_TUNING_
    subroutine sum_hsr_dot_gauntc(is,it,iq,m)
      integer, intent(in) :: is,it,iq,m
      integer :: ip, lmt1, lmt2, np
      real(kind=DP) :: fac
! NEC tune
!      shdg_x(1:n_ialist0) = 0.d0
      shdg_x(1:n_ialist0,m,iq) = 0.d0
      do ip = 1, nc(m,iq)
         lmt1 = nc2lmt1(ip,m,iq)
         lmt2 = nc2lmt2(ip,m,iq)
         np = nc2n(ip,m,iq)
         fac = 2.d0; if(lmt1 == lmt2) fac = 1.d0
         do ia = 1, n_ialist0
! NEC tune
!            shdg_x(ia) = shdg_x(ia) + &
            shdg_x(ia,m,iq) = shdg_x(ia,m,iq) + &
                 & fac*iwei(ia_list(ia))*hsr(ia_list(ia),lmt1,lmt2,is)*dl2p(lmt1,lmt2,np,it)
         end do
      end do
    end subroutine sum_hsr_dot_gauntc
    subroutine add_hardpart_to_ekinq_l_core4(iq)
      integer, intent(in) :: iq
      integer       :: i,iy, ia
!!$      real(kind=DP) :: dga, flekinq, f,f2
      real(kind=DP) :: flekinq, f,f2, flekinq_1, flekinq_2, flekinq_3, flekinq_4 &
           &                            , flekinq_5, flekinq_6, flekinq_7, flekinq_8, zdga
      real(kind=DP) :: qf1,qf2, qy
!!$      real(kind=DP), pointer, dimension(:) :: zfsc1,zfsc2
      real(kind=DP), pointer, dimension(:) :: zfsc1_1,zfsc2_1, zfsc1_2, zfsc2_2 &
           &         , zfsc1_3,zfsc2_3,zfsc1_4,zfsc2_4, zfsc1_5,zfsc2_5,zfsc1_6,zfsc2_6 &
           &         , zfsc1_7,zfsc2_7,zfsc1_8,zfsc2_8
!!$      real(kind=DP), allocatable, dimension(:) :: w_f ! d(ista_kngp:iend_kngp)
!!$      if(n_ialist == 1) allocate(w_f(ista_kngp:iend_kngp))
      if(mod(l3,2) == 0) then
         if(n_ialist0 >= 1) zdga = real(zi**(-l3))
         if(kimg == 1) then
!!$            zfsc1 => zfcos
            if(n_ialist0 >= 1) zfsc1_1 => zfcos_x(:,1)
            if(n_ialist0 >= 2) zfsc1_2 => zfcos_x(:,2)
            if(n_ialist0 >= 3) zfsc1_3 => zfcos_x(:,3)
            if(n_ialist0 >= 4) zfsc1_4 => zfcos_x(:,4)
            if(n_ialist0 >= 5) zfsc1_5 => zfcos_x(:,5)
            if(n_ialist0 >= 6) zfsc1_6 => zfcos_x(:,6)
            if(n_ialist0 >= 7) zfsc1_7 => zfcos_x(:,7)
            if(n_ialist0 >= 8) zfsc1_8 => zfcos_x(:,8)
         else
!!$            f2 = -1; zfsc1 => zfcos; zfsc2 => zfsin
            f2 = -1
            if(n_ialist0 >= 1) then
               zfsc1_1 => zfcos_x(:,1); zfsc2_1 => zfsin_x(:,1)
            end if
            if(n_ialist0 >= 2) then
               zfsc1_2 => zfcos_x(:,2); zfsc2_2 => zfsin_x(:,2)
            end if
            if(n_ialist0 >= 3) then
               zfsc1_3 => zfcos_x(:,3); zfsc2_3 => zfsin_x(:,3)
            end if
            if(n_ialist0 >= 4) then
               zfsc1_4 => zfcos_x(:,4); zfsc2_4 => zfsin_x(:,4)
            end if
            if(n_ialist0 >= 5) then
               zfsc1_5 => zfcos_x(:,5); zfsc2_5 => zfsin_x(:,5)
            end if
            if(n_ialist0 >= 6) then
               zfsc1_6 => zfcos_x(:,6); zfsc2_6 => zfsin_x(:,6)
            end if
            if(n_ialist0 >= 7) then
               zfsc1_7 => zfcos_x(:,7); zfsc2_7 => zfsin_x(:,7)
            end if
            if(n_ialist0 >= 8) then
               zfsc1_8 => zfcos_x(:,8); zfsc2_8 => zfsin_x(:,8)
            end if
         end if
      else
!!$         flekinq = fac*aimag(zi**(-l3))*dga*hsr(ia,lmt1,lmt2,is)
         if(n_ialist0 >= 1) zdga = aimag(zi**(-l3))
         if(kimg == 1) then
!!$            zfsc1 => zfsin
            if(n_ialist0 >= 1) zfsc1_1 => zfsin_x(:,1)
            if(n_ialist0 >= 2) zfsc1_2 => zfsin_x(:,2)
            if(n_ialist0 >= 3) zfsc1_3 => zfsin_x(:,3)
            if(n_ialist0 >= 4) zfsc1_4 => zfsin_x(:,4)
            if(n_ialist0 >= 5) zfsc1_5 => zfsin_x(:,5)
            if(n_ialist0 >= 6) zfsc1_6 => zfsin_x(:,6)
            if(n_ialist0 >= 7) zfsc1_7 => zfsin_x(:,7)
            if(n_ialist0 >= 8) zfsc1_8 => zfsin_x(:,8)
         else
!!$            f2 = 1; zfsc1 => zfsin; zfsc2 => zfcos
            f2 = 1
            if(n_ialist0 >= 1) then
               zfsc1_1 => zfsin_x(:,1); zfsc2_1 => zfcos_x(:,1)
            end if
            if(n_ialist0 >= 2) then
               zfsc1_2 => zfsin_x(:,2); zfsc2_2 => zfcos_x(:,2)
            end if
            if(n_ialist0 >= 3) then
               zfsc1_3 => zfsin_x(:,3); zfsc2_3 => zfcos_x(:,3)
            end if
            if(n_ialist0 >= 4) then
               zfsc1_4 => zfsin_x(:,4); zfsc2_4 => zfcos_x(:,4)
            end if
            if(n_ialist0 >= 5) then
               zfsc1_5 => zfsin_x(:,5); zfsc2_5 => zfcos_x(:,5)
            end if
            if(n_ialist0 >= 6) then
               zfsc1_6 => zfsin_x(:,6); zfsc2_6 => zfcos_x(:,6)
            end if
            if(n_ialist0 >= 7) then
               zfsc1_7 => zfsin_x(:,7); zfsc2_7 => zfcos_x(:,7)
            end if
            if(n_ialist0 >= 8) then
               zfsc1_8 => zfsin_x(:,8); zfsc2_8 => zfcos_x(:,8)
            end if
         end if
      end if
! NEC tune ---------------------------------------->
!      if(n_ialist0 >= 1) flekinq_1 = zdga*shdg_x(1)
!      if(n_ialist0 >= 2) flekinq_2 = zdga*shdg_x(2)
!      if(n_ialist0 >= 3) flekinq_3 = zdga*shdg_x(3)
!      if(n_ialist0 >= 4) flekinq_4 = zdga*shdg_x(4)
!      if(n_ialist0 >= 5) flekinq_5 = zdga*shdg_x(5)
!      if(n_ialist0 >= 6) flekinq_6 = zdga*shdg_x(6)
!      if(n_ialist0 >= 7) flekinq_7 = zdga*shdg_x(7)
!      if(n_ialist0 >= 8) flekinq_8 = zdga*shdg_x(8)
! NEC tune -----------------------------------------
      if(n_ialist0 >= 1) flekinq_1 = zdga*shdg_x(1,m,iq)
      if(n_ialist0 >= 2) flekinq_2 = zdga*shdg_x(2,m,iq)
      if(n_ialist0 >= 3) flekinq_3 = zdga*shdg_x(3,m,iq)
      if(n_ialist0 >= 4) flekinq_4 = zdga*shdg_x(4,m,iq)
      if(n_ialist0 >= 5) flekinq_5 = zdga*shdg_x(5,m,iq)
      if(n_ialist0 >= 6) flekinq_6 = zdga*shdg_x(6,m,iq)
      if(n_ialist0 >= 7) flekinq_7 = zdga*shdg_x(7,m,iq)
      if(n_ialist0 >= 8) flekinq_8 = zdga*shdg_x(8,m,iq)
! NEC tune <----------------------------------------

      if(n_ialist0 == 1) then
         if(kimg == 1) then
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp     !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) &
                    & +flekinq_1*kin_qitg_l(i,iq)*ylm(iy)*zfsc1_1(iy)
            end do
         else
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp   !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               f = flekinq_1*kin_qitg_l(i,iq)*ylm(iy)
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + f * zfsc1_1(iy)
               ekinq_l(i,2,is) = ekinq_l(i,2,is) + f2 * f * zfsc2_1(iy)
            end do
         end if
      else if(n_ialist0 == 2) then
         if(kimg == 1) then
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp     !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &         *( flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) )
            end do
         else
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp   !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &         *( flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) )
               ekinq_l(i,2,is) = ekinq_l(i,2,is) + f2 * kin_qitg_l(i,iq)*ylm(iy) &
                    &         *( flekinq_1*zfsc2_1(iy) + flekinq_2*zfsc2_2(iy) )
            end do
         end if
      else if(n_ialist0 == 3) then
         if(kimg == 1) then
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp     !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &     *( flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy) )
            end do
         else
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp   !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &     *( flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy))
               ekinq_l(i,2,is) = ekinq_l(i,2,is) + f2 * kin_qitg_l(i,iq)*ylm(iy) &
                    &     *( flekinq_1*zfsc2_1(iy) + flekinq_2*zfsc2_2(iy) + flekinq_3*zfsc2_3(iy))
            end do
         end if
      else if(n_ialist0 == 4) then
         if(kimg == 1) then
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp     !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &   *(flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy)+ flekinq_4*zfsc1_4(iy))
            end do
         else
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp   !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &   *( flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy) + flekinq_4*zfsc1_4(iy))
               ekinq_l(i,2,is) = ekinq_l(i,2,is) + f2 * kin_qitg_l(i,iq)*ylm(iy) &
                    &   *( flekinq_1*zfsc2_1(iy) + flekinq_2*zfsc2_2(iy) + flekinq_3*zfsc2_3(iy) + flekinq_4*zfsc2_4(iy))
            end do
         end if
      else if(n_ialist0 == 5) then
         if(kimg == 1) then
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp     !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &   *(flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy)+ flekinq_4*zfsc1_4(iy) &
                    &    +flekinq_5*zfsc1_5(iy))
            end do
         else
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp   !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &   *( flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy) + flekinq_4*zfsc1_4(iy)&
                    &     +flekinq_5*zfsc1_5(iy))
               ekinq_l(i,2,is) = ekinq_l(i,2,is) + f2 * kin_qitg_l(i,iq)*ylm(iy) &
                    &   *( flekinq_1*zfsc2_1(iy) + flekinq_2*zfsc2_2(iy) + flekinq_3*zfsc2_3(iy) + flekinq_4*zfsc2_4(iy)&
                    &     +flekinq_5*zfsc2_5(iy))
            end do
         end if
      else if(n_ialist0 == 6) then
         if(kimg == 1) then
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp     !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &   *(flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy)+ flekinq_4*zfsc1_4(iy) &
                    &    +flekinq_5*zfsc1_5(iy) + flekinq_6*zfsc1_6(iy))
            end do
         else
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp   !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &   *( flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy) + flekinq_4*zfsc1_4(iy)&
                    &     +flekinq_5*zfsc1_5(iy) + flekinq_6*zfsc1_6(iy))
               ekinq_l(i,2,is) = ekinq_l(i,2,is) + f2 * kin_qitg_l(i,iq)*ylm(iy) &
                    &   *( flekinq_1*zfsc2_1(iy) + flekinq_2*zfsc2_2(iy) + flekinq_3*zfsc2_3(iy) + flekinq_4*zfsc2_4(iy)&
                    &     +flekinq_5*zfsc2_5(iy) + flekinq_6*zfsc2_6(iy))
            end do
         end if
      else if(n_ialist0 == 7) then
         if(kimg == 1) then
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp     !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &   *(flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy) + flekinq_4*zfsc1_4(iy) &
                    &    +flekinq_5*zfsc1_5(iy) + flekinq_6*zfsc1_6(iy) + flekinq_7*zfsc1_7(iy))
            end do
         else
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp   !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &   *( flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy) + flekinq_4*zfsc1_4(iy)&
                    &     +flekinq_5*zfsc1_5(iy) + flekinq_6*zfsc1_6(iy) + flekinq_7*zfsc1_7(iy))
               ekinq_l(i,2,is) = ekinq_l(i,2,is) + f2 * kin_qitg_l(i,iq)*ylm(iy) &
                    &   *( flekinq_1*zfsc2_1(iy) + flekinq_2*zfsc2_2(iy) + flekinq_3*zfsc2_3(iy) + flekinq_4*zfsc2_4(iy)&
                    &     +flekinq_5*zfsc2_5(iy) + flekinq_6*zfsc2_6(iy) + flekinq_7*zfsc2_7(iy))
            end do
         end if
      else if(n_ialist0 >= 8) then
         if(kimg == 1) then
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp     !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &   *(flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy) + flekinq_4*zfsc1_4(iy) &
                    &    +flekinq_5*zfsc1_5(iy) + flekinq_6*zfsc1_6(iy) + flekinq_7*zfsc1_7(iy) + flekinq_8*zfsc1_8(iy))
            end do
         else
#ifdef HIUX
*POPTION PARALLEL
#endif
#ifdef NEC_TUNE_HARD
!CDIR PARALLEL DO PRIVATE(i,iy)
#endif
! NEC tune
!            do i = ista_kngp, iend_kngp   !for mpi
            do i = ibl1, ibl2
               iy = i - ista_kngp+1
               ekinq_l(i,1,is) = ekinq_l(i,1,is) + kin_qitg_l(i,iq)*ylm(iy) &
                    &   *( flekinq_1*zfsc1_1(iy) + flekinq_2*zfsc1_2(iy) + flekinq_3*zfsc1_3(iy) + flekinq_4*zfsc1_4(iy)&
                    &     +flekinq_5*zfsc1_5(iy) + flekinq_6*zfsc1_6(iy) + flekinq_7*zfsc1_7(iy) + flekinq_8*zfsc1_8(iy))
               ekinq_l(i,2,is) = ekinq_l(i,2,is) + f2 * kin_qitg_l(i,iq)*ylm(iy) &
                    &   *( flekinq_1*zfsc2_1(iy) + flekinq_2*zfsc2_2(iy) + flekinq_3*zfsc2_3(iy) + flekinq_4*zfsc2_4(iy)&
                    &     +flekinq_5*zfsc2_5(iy) + flekinq_6*zfsc2_6(iy) + flekinq_7*zfsc2_7(iy) + flekinq_8*zfsc2_8(iy))
            end do
         end if
      end if
!!$      if(n_ialist == 1) deallocate(w_f)
    end subroutine add_hardpart_to_ekinq_l_core4
#else
    subroutine substitute_qitgred()
      integer :: iq, i
      do iq = 1, nqitg
         do i = 1, ibl2-ibl1+1
            qitg_red(i, iq) = kin_qitg_l(i+ibl1-1,iq)
         end do
      end do
    end subroutine substitute_qitgred

    subroutine substitute_ylmred
      integer :: ilm, i

      do ilm = 1, nel_Ylm
         do i = 1, ibl2-ibl1+1
            ylm_red(i,ilm) = ylm_l(i+ibl1-1,ilm)
         end do
      end do

      if(n**2 > nel_Ylm) then
         allocate(ylm_t(ibl1:ibl2)); ylm_t = 0.d0
         do ilm = nel_ylm+1, n**2
            call m_pwBS_sphrp2(ilm,rltv,ibl1,ibl2,ylm_t)
            do i = 1, ibl2-ibl1+1
               ylm_red(i,ilm) = ylm_t(i+ibl1-1)
            end do
         end do
         deallocate(ylm_t)
      end if
    end subroutine substitute_ylmred

    subroutine sum_hsr_dot_gauntc0(it,ia,iq,m,iqm)
      integer, intent(in) :: it,ia,iq,m,iqm
      integer :: ip, lmt1, lmt2, np
      real(kind=DP) :: fac

! ========================= modified by K. Tagami ====================== 11.0
!      if(sw_spin == OFF) then
!         shdg(iqm,1) = 0.d0
!         do ip = 1, nc(m,iq)
!            lmt1 = nc2lmt1(ip,m,iq)
!            lmt2 = nc2lmt2(ip,m,iq)
!            np = nc2n(ip,m,iq)
!            fac = 2.d0; if(lmt1 == lmt2) fac = 1.d0
!            shdg(iqm,1) = shdg(iqm,1) + fac*iwei(ia)*hsr(ia,lmt1,lmt2,1)*dl2p(lmt1,lmt2,np,it)
!         end do
!      else if(sw_spin == ON) then
!         shdg(iqm,1) = 0.d0; shdg(iqm,2) = 0.d0
!         do ip = 1, nc(m,iq)
!            lmt1 = nc2lmt1(ip,m,iq)
!            lmt2 = nc2lmt2(ip,m,iq)
!            np = nc2n(ip,m,iq)
!            fac = 2.d0; if(lmt1 == lmt2) fac = 1.d0
!            shdg(iqm,1) = shdg(iqm,1) + fac*iwei(ia)*hsr(ia,lmt1,lmt2,1) &
!                           &           *dl2p(lmt1,lmt2,np,it)
!            shdg(iqm,2) = shdg(iqm,2) + fac*iwei(ia)*hsr(ia,lmt1,lmt2,2) &
!                           &          *dl2p(lmt1,lmt2,np,it)
!         end do
!      end if

      shdg(iqm,:) = 0.d0

      do ip = 1, nc(m,iq)
         lmt1 = nc2lmt1(ip,m,iq);    lmt2 = nc2lmt2(ip,m,iq)
         np = nc2n(ip,m,iq)
         fac = 2.d0; if(lmt1 == lmt2) fac = 1.d0
         shdg(iqm,:) = shdg(iqm,:) &
              &  + fac *iwei(ia) *hsr(ia,lmt1,lmt2,:) *dl2p(lmt1,lmt2,np,it)
      end do
! ============================================================== 11.0

    end subroutine sum_hsr_dot_gauntc0

    subroutine calc_phase_div(ia)
      integer, intent(in) :: ia
      real(kind=DP) :: fx, fy, fz, ph
      integer :: i, iy
      fx = pos(ia,1)*PAI2
      fy = pos(ia,2)*PAI2
      fz = pos(ia,3)*PAI2
      do i = 1, ibl2-ibl1+1
         iy = i + ibl1 - 1
         ph = ngabc(iy,1)*fx+ngabc(iy,2)*fy+ngabc(iy,3)*fz
         zfcos(i) = dcos(ph)
         zfsin(i) = dsin(ph)
      end do
    end subroutine calc_phase_div

    subroutine add_hardpart_to_ekinq_l_div(iq)
      integer, intent(in) :: iq
      integer       :: i,iy, iy2
      real(kind=DP) :: flekinq, f,f2,  zdga, flekinq_up, flekinq_dw, f_up, f_dw
      real(kind=DP), pointer, dimension(:) :: zfsc1,zfsc2

      if(mod(l3,2) == 0) then
         zdga = real(zi**(-l3))
         if(kimg == 1) then
            zfsc1 => zfcos
         else
            f2 = -1
            zfsc1 => zfcos; zfsc2 => zfsin
         end if
      else
         zdga = aimag(zi**(-l3))
         if(kimg == 1) then
            zfsc1 => zfsin
         else
            f2 = 1
            zfsc1 => zfsin; zfsc2 => zfcos
         end if
      end if

!!$      if(sw_spin == ON) then
!!$         flekinq_up = zdga*shdg(iqm,1)
!!$         flekinq_dw = zdga*shdg(iqm,2)
!!$      else if(sw_spin == OFF) then
!!$         flekinq = zdga*shdg(iqm,1)
!!$      end if

      if(kimg == 1) then
!!$         if(sw_spin == ON) then
!!$            do i = 1, ibl2-ibl1+1
!!$               f = qitg_red(i,iq)*ylm_sum(i)*zfsc1(i)
!!$               ekinq_red(i,1,1) = ekinq_red(i,1,1) +zdga*f
!!$               ekinq_red(i,1,2) = ekinq_red(i,1,2) +zdga*f
!!$            end do
!!$         else if(sw_spin == OFF) then
         do i = 1, ibl2-ibl1+1
            ekinq_red(i,1,is) = ekinq_red(i,1,is) +zdga*qitg_red(i,iq)*ylm_sum(i)*zfsc1(i)
         end do
!!$         end if
      else
!!$         if(sw_spin == ON) then
!!$            do i = 1, ibl2-ibl1+1
!!$               f = qitg_red(i,iq)*ylm_red(i,ilm3)
!!$               ekinq_red(i,1,1) = ekinq_red(i,1,1) +      flekinq_up*f * zfsc1(i)
!!$               ekinq_red(i,2,1) = ekinq_red(i,2,1) + f2 * flekinq_up*f * zfsc2(i)
!!$               ekinq_red(i,1,2) = ekinq_red(i,1,2) +      flekinq_dw*f * zfsc1(i)
!!$               ekinq_red(i,2,2) = ekinq_red(i,2,2) + f2 * flekinq_dw*f * zfsc2(i)
!!$            end do
!!$         else if(sw_spin == OFF) then
         do i = 1, ibl2-ibl1+1
            f = zdga*qitg_red(i,iq)*ylm_sum(i)
            ekinq_red(i,1,is) = ekinq_red(i,1,is) +      f * zfsc1(i)
            ekinq_red(i,2,is) = ekinq_red(i,2,is) + f2 * f * zfsc2(i)
         end do
!!$         end if
      end if
    end subroutine add_hardpart_to_ekinq_l_div

    subroutine add_hardpart_to_ekinq_l_div0(zdga,iq)
      real(kind=DP), intent(in) :: zdga
      integer, intent(in) :: iq
      integer       :: i
      real(kind=DP) :: f

      if(kimg == 1) then
         do i = 1, ibl2-ibl1+1
            ekinq_red(i,1,is) = ekinq_red(i,1,is) +zdga*qitg_red(i,iq)*ylm_sum(i)*zfcos(i)
         end do
      else
         do i = 1, ibl2-ibl1+1
            f = zdga*qitg_red(i,iq)*ylm_sum(i)
            ekinq_red(i,1,is) = ekinq_red(i,1,is) + f * zfcos(i)
            ekinq_red(i,2,is) = ekinq_red(i,2,is) - f * zfsin(i)
         end do
      end if
    end subroutine add_hardpart_to_ekinq_l_div0

    subroutine add_hardpart_to_ekinq_l_div1(zdga,iq)
      real(kind=DP), intent(in) :: zdga
      integer, intent(in) :: iq
      integer       :: i
      real(kind=DP) :: f

      if(kimg == 1) then
         do i = 1, ibl2-ibl1+1
            ekinq_red(i,1,is) = ekinq_red(i,1,is) +zdga*qitg_red(i,iq)*ylm_sum(i)*zfsin(i)
         end do
      else
         do i = 1, ibl2-ibl1+1
            f = zdga*qitg_red(i,iq)*ylm_sum(i)
            ekinq_red(i,1,is) = ekinq_red(i,1,is) +  f * zfsin(i)
            ekinq_red(i,2,is) = ekinq_red(i,2,is) +  f * zfcos(i)
         end do
      end if
    end subroutine add_hardpart_to_ekinq_l_div1

    subroutine cp_ekinqred2ekinq()
      integer :: i, ir

! =============================== modified by K. Tagami ============= 11.0
!      if(sw_spin == ON) then
!         do ir = 1, kimg
!            do i = ibl1, ibl2
!               ekinq_l(i,ir,1) = ekinq_l(i,ir,1) + ekinq_red(i-ibl1+1,ir,1)
!               ekinq_l(i,ir,2) = ekinq_l(i,ir,2) + ekinq_red(i-ibl1+1,ir,2)
!            end do
!         end do
!      else if(sw_spin == OFF) then
!         do ir = 1, kimg
!            do i = ibl1, ibl2
!               ekinq_l(i,ir,1) = ekinq_l(i,ir,1) + ekinq_red(i-ibl1+1,ir,1)
!            end do
!         end do
!      end if

      do ir = 1, kimg
         do i = ibl1, ibl2
            ekinq_l(i,ir,:) = ekinq_l(i,ir,:) + ekinq_red(i-ibl1+1,ir,:)
         end do
      end do
! ==================================================================== 11.0

    end subroutine cp_ekinqred2ekinq
#endif
  end subroutine add_hardpart_to_ekinq_l

  subroutine m_KE_calc_kins_qrs_rspace
    integer :: imesh
    integer :: ia, it, nma
    integer :: il1, il2, im1, im2, tau1, tau2, lmt1, lmt2
    integer :: nspher1, nspher2
    integer :: ier, ir

    real(kind=DP) :: ps1, ps2, dps1, dps2
    real(kind=DP) :: ph1, ph2, dph1, dph2
    real(kind=DP) :: cosx, cosy, cosz
    real(kind=DP) :: ctmp_psi1(3), ctmp_psi2(3)
    real(kind=DP) :: ctmp_phi1(3), ctmp_phi2(3)
    real(kind=DP) :: csum_psi, csum_phi
    real(kind=DP) :: hn, inl, inm, inn

    real(kind=DP), allocatable :: cx(:), cy(:), cz(:), rdiff(:)
    real(kind=DP), allocatable :: ylm1(:), ylm2(:), dylm1(:,:), dylm2(:,:)
    real(kind=DP), allocatable :: psi1(:), psi2(:), wk_psi1(:), wk_psi2(:)
    real(kind=DP), allocatable :: phi1(:), phi2(:), wk_phi1(:), wk_phi2(:)
    real(kind=DP), allocatable :: radr(:)

    inl = 1.d0/dble(fft_box_size_CD(1,1))
    inm = 1.d0/dble(fft_box_size_CD(2,1))
    inn = 1.d0/dble(fft_box_size_CD(3,1))
    
    allocate(cx(nmesh_rs_aug_max)); cx=0.d0
    allocate(cy(nmesh_rs_aug_max)); cy=0.d0
    allocate(cz(nmesh_rs_aug_max)); cz=0.d0
    allocate(rdiff(nmesh_rs_aug_max)); rdiff=0.d0
    
    allocate(ylm1(nmesh_rs_aug_max)); ylm1 = 0.d0
    allocate(ylm2(nmesh_rs_aug_max)); ylm2 = 0.d0
    allocate(dylm1(nmesh_rs_aug_max,3)); dylm1 = 0.d0
    allocate(dylm2(nmesh_rs_aug_max,3)); dylm2 = 0.d0
    
    allocate( psi1(mmesh) ); psi1 = 0.0d0
    allocate( psi2(mmesh) ); psi2 = 0.0d0
    allocate( phi1(mmesh) ); phi1 = 0.0d0
    allocate( phi2(mmesh) ); phi2 = 0.0d0
    allocate( wk_psi1(mmesh) ); wk_psi1 = 0.0d0
    allocate( wk_psi2(mmesh) ); wk_psi2 = 0.0d0
    allocate( wk_phi1(mmesh) ); wk_phi1 = 0.0d0
    allocate( wk_phi2(mmesh) ); wk_phi2 = 0.0d0
    allocate( radr(mmesh) ); radr = 0.0d0

!    write(*,*) 'nmesh_rs_aug_max = ', nmesh_rs_aug_max
    if ( nmesh_rs_aug_max == 0 ) return

    allocate( kins_qrs_rspace( nmesh_rs_aug_max,natm,nlmt,nlmt) )
    kins_qrs_rspace = 0.0d0

    Do ia=1, natm
       it = ityp(ia)
       nma = nmesh_rs_aug(ia)

       if ( nma == 0 ) cycle

       call rmeshs(nmesh(it),nmesh(it),xh(it),rmax(it),radr,hn) ! -(b_PP)
       call m_RS_R_minus_pos( pos, ia, nmesh_rs_aug_max, inl, inm, inn, &
            &                 cx, cy, cz, rdiff, &
            &                 meshx_rs_aug, meshy_rs_aug, meshz_rs_aug )
       
       Do lmt1 = 1, ilmt(it)
          il1 = ltp(lmt1,it); im1 = mtp(lmt1,it);  tau1 = taup(lmt1,it)
          nspher1 = ( il1 -1 )**2 +im1
          
          psi1(1:nmesh(it)) = psirpw(1:nmesh(it),il1,tau1,it) /radr(1:nmesh(it)) 
          phi1(1:nmesh(it)) = phirpw(1:nmesh(it),il1,tau1,it) /radr(1:nmesh(it)) 
 
          call sphr( nma, nspher1, cx(1:nma), cy(1:nma), cz(1:nma), ylm1(1:nma) )
          call sphr_diff( nma, nma, nspher1, cx(1:nma), cy(1:nma), cz(1:nma), &
               &          dylm1(1:nma,1:3) )
          call init_cubic_spline( nmesh(it), radr(1:nmesh(it)),&
               &                  psi1(1:nmesh(it)), wk_psi1(1:nmesh(it) ) )
          call init_cubic_spline( nmesh(it), radr(1:nmesh(it)),&
               &                  phi1(1:nmesh(it)), wk_phi1(1:nmesh(it) ) )

          Do lmt2=lmt1, ilmt(it)
             il2 = ltp(lmt2,it); im2 = mtp(lmt2,it);  tau2 = taup(lmt2,it)
             nspher2 = ( il2 -1 )**2 +im2
             
             psi2(1:nmesh(it)) = psirpw(1:nmesh(it),il2,tau2,it) /radr(1:nmesh(it))
             phi2(1:nmesh(it)) = phirpw(1:nmesh(it),il2,tau2,it) /radr(1:nmesh(it))
             
             call sphr( nma, nspher2, cx(1:nma), cy(1:nma), cz(1:nma), ylm2(1:nma) )
             call sphr_diff( nma, nma, nspher2, cx(1:nma), cy(1:nma), cz(1:nma), &
                  &          dylm2(1:nma,1:3) )
             call init_cubic_spline( nmesh(it), radr(1:nmesh(it)),&
                  &                  psi2(1:nmesh(it)), wk_psi2(1:nmesh(it) ) )
             call init_cubic_spline( nmesh(it), radr(1:nmesh(it)),&
                  &                  phi2(1:nmesh(it)), wk_phi2(1:nmesh(it) ) )
             
             do imesh=1,nma
                call cubic_spline( nmesh(it), radr, psi1(1:nmesh(it)),&
                     &             wk_psi1(1:nmesh(it)), rdiff(imesh), ps1, dps1 )
                call cubic_spline( nmesh(it), radr, psi2(1:nmesh(it)),&
                     &             wk_psi2(1:nmesh(it)), rdiff(imesh), ps2, dps2 )
                call cubic_spline( nmesh(it), radr, phi1(1:nmesh(it)),&
                     &             wk_phi1(1:nmesh(it)), rdiff(imesh), ph1, dph1 )
                call cubic_spline( nmesh(it), radr, phi2(1:nmesh(it)),&
                     &             wk_phi2(1:nmesh(it)), rdiff(imesh), ph2, dph2 )
                
                if (rdiff(imesh) < radr(2) ) cycle

                cosx = cx(imesh)/rdiff(imesh)
                cosy = cy(imesh)/rdiff(imesh)
                cosz = cz(imesh)/rdiff(imesh)
                
                ctmp_psi1(1) = cosx *dps1 *ylm1(imesh) +ps1 *dylm1(imesh,1)
                ctmp_psi1(2) = cosy *dps1 *ylm1(imesh) +ps1 *dylm1(imesh,2)
                ctmp_psi1(3) = cosz *dps1 *ylm1(imesh) +ps1 *dylm1(imesh,3)
                
                ctmp_psi2(1) = cosx *dps2 *ylm2(imesh) +ps2 *dylm2(imesh,1)
                ctmp_psi2(2) = cosy *dps2 *ylm2(imesh) +ps2 *dylm2(imesh,2)
                ctmp_psi2(3) = cosz *dps2 *ylm2(imesh) +ps2 *dylm2(imesh,3)
                
                ctmp_phi1(1) = cosx *dph1 *ylm1(imesh) +ph1 *dylm1(imesh,1)
                ctmp_phi1(2) = cosy *dph1 *ylm1(imesh) +ph1 *dylm1(imesh,2)
                ctmp_phi1(3) = cosz *dph1 *ylm1(imesh) +ph1 *dylm1(imesh,3)
                
                ctmp_phi2(1) = cosx *dph2 *ylm2(imesh) +ph2 *dylm2(imesh,1)
                ctmp_phi2(2) = cosy *dph2 *ylm2(imesh) +ph2 *dylm2(imesh,2)
                ctmp_phi2(3) = cosz *dph2 *ylm2(imesh) +ph2 *dylm2(imesh,3)

                csum_psi = ctmp_psi1(1) *ctmp_psi2(1) &
                     &      + ctmp_psi1(2) *ctmp_psi2(2) &
                     &      + ctmp_psi1(3) *ctmp_psi2(3) 
                csum_phi = ctmp_phi1(1) *ctmp_phi2(1) &
                     &      + ctmp_phi1(2) *ctmp_phi2(2) &
                     &      + ctmp_phi1(3) *ctmp_phi2(3)
                kins_qrs_rspace(imesh,ia,lmt1,lmt2) = ( csum_psi -csum_phi )/2.0d0
             End do
          End do
       End Do
    End Do

    deallocate( cx ); deallocate( cy ); deallocate( cz ); deallocate( rdiff )
    deallocate( ylm1 ); deallocate( ylm2 ); deallocate( dylm1 ); deallocate( dylm2 )
    deallocate( psi1 ); deallocate( psi2 ); deallocate( wk_psi1 ); deallocate( wk_psi2 )
    deallocate( phi1 ); deallocate( phi2 ); deallocate( wk_phi1 ); deallocate( wk_phi2 )
    deallocate( radr )

  end subroutine m_KE_calc_kins_qrs_rspace

  subroutine m_KE_calc_kina_qrs_rspace
    integer :: imesh
    integer :: ia, it, nma
    integer :: il1, il2, im1, im2, tau1, tau2, lmt1, lmt2
    integer :: nspher1, nspher2
    integer :: ier, ir

    real(kind=DP) :: ps1, ps2, dps1, dps2, ddps2
    real(kind=DP) :: ph1, ph2, dph1, dph2, ddph2
    real(kind=DP) :: csum_psi, csum_phi
    real(kind=DP) :: hn, inl, inm, inn

    real(kind=DP), allocatable :: cx(:), cy(:), cz(:), rdiff(:)
    real(kind=DP), allocatable :: ylm1(:), ylm2(:), dylm1(:,:), dylm2(:,:)
    real(kind=DP), allocatable :: psi1(:), psi2(:), wk_psi1(:), wk_psi2(:)
    real(kind=DP), allocatable :: phi1(:), phi2(:), wk_phi1(:), wk_phi2(:)
    real(kind=DP), allocatable :: dpsi2(:), dphi2(:), wk_dpsi2(:), wk_dphi2(:)
    real(kind=DP), allocatable :: radr(:)

    inl = 1.d0/dble(fft_box_size_CD(1,1))
    inm = 1.d0/dble(fft_box_size_CD(2,1))
    inn = 1.d0/dble(fft_box_size_CD(3,1))
    
    allocate(cx(nmesh_rs_aug_max)); cx=0.d0
    allocate(cy(nmesh_rs_aug_max)); cy=0.d0
    allocate(cz(nmesh_rs_aug_max)); cz=0.d0
    allocate(rdiff(nmesh_rs_aug_max)); rdiff=0.d0
    
    allocate(ylm1(nmesh_rs_aug_max)); ylm1 = 0.d0
    allocate(ylm2(nmesh_rs_aug_max)); ylm2 = 0.d0
    allocate(dylm1(nmesh_rs_aug_max,3)); dylm1 = 0.d0
    allocate(dylm2(nmesh_rs_aug_max,3)); dylm2 = 0.d0
    
    allocate( psi1(mmesh) ); psi1 = 0.0d0
    allocate( psi2(mmesh) ); psi2 = 0.0d0
    allocate( phi1(mmesh) ); phi1 = 0.0d0
    allocate( phi2(mmesh) ); phi2 = 0.0d0
    allocate( dpsi2(mmesh) ); dpsi2 = 0.0d0
    allocate( dphi2(mmesh) ); dphi2 = 0.0d0

    allocate( wk_psi1(mmesh) ); wk_psi1 = 0.0d0
    allocate( wk_psi2(mmesh) ); wk_psi2 = 0.0d0
    allocate( wk_phi1(mmesh) ); wk_phi1 = 0.0d0
    allocate( wk_phi2(mmesh) ); wk_phi2 = 0.0d0
    allocate( wk_dpsi2(mmesh) ); wk_dpsi2 = 0.0d0
    allocate( wk_dphi2(mmesh) ); wk_dphi2 = 0.0d0

    allocate( radr(mmesh) ); radr = 0.0d0

    allocate( kina_qrs_rspace( nmesh_rs_aug_max,natm,nlmt,nlmt) )
    kina_qrs_rspace = 0.0d0

    Do ia=1, natm
       it = ityp(ia)
       nma = nmesh_rs_aug(ia)

       call rmeshs(nmesh(it),nmesh(it),xh(it),rmax(it),radr,hn) ! -(b_PP)
       call m_RS_R_minus_pos( pos, ia, nmesh_rs_aug_max, inl, inm, inn, &
            &                 cx, cy, cz, rdiff, &
            &                 meshx_rs_aug, meshy_rs_aug, meshz_rs_aug )
       
       Do lmt1 = 1, ilmt(it)
          il1 = ltp(lmt1,it); im1 = mtp(lmt1,it);  tau1 = taup(lmt1,it)
          nspher1 = ( il1 -1 )**2 +im1
          
          psi1(1:nmesh(it)) = psirpw(1:nmesh(it),il1,tau1,it) /radr(1:nmesh(it)) 
          phi1(1:nmesh(it)) = phirpw(1:nmesh(it),il1,tau1,it) /radr(1:nmesh(it)) 
 
          call sphr( nma, nspher1, cx(1:nma), cy(1:nma), cz(1:nma), ylm1(1:nma) )

          call init_cubic_spline( nmesh(it), radr(1:nmesh(it)),&
               &                  psi1(1:nmesh(it)), wk_psi1(1:nmesh(it) ) )
          call init_cubic_spline( nmesh(it), radr(1:nmesh(it)),&
               &                  phi1(1:nmesh(it)), wk_phi1(1:nmesh(it) ) )

          Do lmt2=1, ilmt(it)
             il2 = ltp(lmt2,it); im2 = mtp(lmt2,it);  tau2 = taup(lmt2,it)
             nspher2 = ( il2 -1 )**2 +im2
             
             psi2(1:nmesh(it)) = psirpw(1:nmesh(it),il2,tau2,it) /radr(1:nmesh(it))
             phi2(1:nmesh(it)) = phirpw(1:nmesh(it),il2,tau2,it) /radr(1:nmesh(it))
             
             call calc_diff_exp( ier,5, nmesh(it), radr, psi2, dpsi2 )
             call calc_diff_exp( ier,5, nmesh(it), radr, phi2, dphi2 )

             call sphr( nma, nspher2, cx(1:nma), cy(1:nma), cz(1:nma), ylm2(1:nma) )
             
             call init_cubic_spline( nmesh(it), radr(1:nmesh(it)),&
                  &                  psi2(1:nmesh(it)), wk_psi2(1:nmesh(it) ) )
             call init_cubic_spline( nmesh(it), radr(1:nmesh(it)),&
                  &                  phi2(1:nmesh(it)), wk_phi2(1:nmesh(it) ) )
             call init_cubic_spline( nmesh(it), radr(1:nmesh(it)),&
                  &                  dpsi2(1:nmesh(it)), wk_dpsi2(1:nmesh(it) ) )
             call init_cubic_spline( nmesh(it), radr(1:nmesh(it)),&
                  &                  dphi2(1:nmesh(it)), wk_dphi2(1:nmesh(it) ) )
             
             do imesh=1,nma
                call cubic_spline( nmesh(it), radr, psi1(1:nmesh(it)),&
                     &             wk_psi1(1:nmesh(it)), rdiff(imesh), ps1, dps1 )
                call cubic_spline( nmesh(it), radr, psi2(1:nmesh(it)),&
                     &             wk_psi2(1:nmesh(it)), rdiff(imesh), ps2, dps2 )
                call cubic_spline( nmesh(it), radr, dpsi2(1:nmesh(it)),&
                     &             wk_dpsi2(1:nmesh(it)), rdiff(imesh), dps2, ddps2 )

                call cubic_spline( nmesh(it), radr, phi1(1:nmesh(it)),&
                     &             wk_phi1(1:nmesh(it)), rdiff(imesh), ph1, dph1 )
                call cubic_spline( nmesh(it), radr, phi2(1:nmesh(it)),&
                     &             wk_phi2(1:nmesh(it)), rdiff(imesh), ph2, dph2 )
                call cubic_spline( nmesh(it), radr, dphi2(1:nmesh(it)),&
                     &             wk_dphi2(1:nmesh(it)), rdiff(imesh), dph2, ddph2 )
                
                if (rdiff(imesh) < radr(2) ) cycle

                csum_psi = ps1 *( -ddps2 -2.0d0/rdiff(imesh) *dps2 &
                     &            +il2*(il2+1.0d0)/rdiff(imesh)**2 *ps2  )&
                     &         *ylm1(imesh) *ylm2(imesh)
                csum_phi = ph1 *( -ddph2 -2.0d0/rdiff(imesh) *dph2 &
                     &            +il2*(il2+1.0d0)/rdiff(imesh)**2 *ph2  )&
                     &         *ylm1(imesh) *ylm2(imesh)
                kina_qrs_rspace(imesh,ia,lmt1,lmt2) = ( csum_psi -csum_phi )/2.0d0
             End do
          End do
       End Do
    End Do

    deallocate( cx ); deallocate( cy ); deallocate( cz ); deallocate( rdiff )
    deallocate( ylm1 ); deallocate( ylm2 ); deallocate( dylm1 ); deallocate( dylm2 )
    deallocate( psi1 ); deallocate( psi2 ); deallocate( wk_psi1 ); deallocate( wk_psi2 )
    deallocate( phi1 ); deallocate( phi2 ); deallocate( wk_phi1 ); deallocate( wk_phi2 )
    deallocate( wk_dpsi2 ); deallocate( wk_dphi2 )

    deallocate( radr )

  end subroutine m_KE_calc_kina_qrs_rspace
   
  subroutine m_KE_add_ekindens_hard_rspace( ista_rho, iend_rho, ekin_dens )
    integer, intent(in) :: ista_rho, iend_rho
    real(kind=DP), intent(inout) :: ekin_dens( ista_rho:iend_rho, nspin )

    integer :: ia, it, nma
    integer :: lmt1, lmt2, is, i, ind

    real(kind=DP) :: fac0, fac

    real(kind=DP), allocatable :: kins_tmp(:,:)

!    return

!    write(*,*) 'nffp_nonp ', nfftp_nonpara
!    write(*,*) iend_fftph
!    stop

    allocate( kins_tmp(nmesh_rs_aug_max, nspin)); kins_tmp = 0.0d0

    Do ia=1, natm
       it = ityp(ia)
       nma = nmesh_rs_aug(ia)        
       
       kins_tmp = 0.0d0
       Do lmt1=1, ilmt(it)
          Do lmt2=lmt1, ilmt(it)
             
             fac0=2.0d0
             if (lmt1.eq.lmt2) fac0=1.d0
             
             Do is=1, nspin
                fac = hsr(ia,lmt1,lmt2,is) *fac0
                
                if ( use_symm_ekin_density ) then
                   Do i=1, nma
                      kins_tmp(i,is) = kins_tmp(i,is) &
                           &            +fac *kins_qrs_rspace(i,ia,lmt1,lmt2)

                   End do
                else if ( use_asymm_ekin_density ) then
                   Do i=1, nma
                      kins_tmp(i,is) = kins_tmp(i,is) &
                           &            +fac *kina_qrs_rspace(i,ia,lmt1,lmt2)

                   End do
                endif
             End do
           End do
        End do

!        kins_tmp = kins_tmp /univol**2

        Do i=1, nma
           ind = meshxyz_rs_aug(i,ia)
           if ( ind >= ista_rho .and. ind <= iend_rho ) then
              ekin_dens(ind,1:nspin) = ekin_dens(ind,1:nspin) +kins_tmp(i,1:nspin)

!              write(900+mype,*) ind, kins_tmp(i,1)
           endif
        End do
     End Do

     deallocate( kins_tmp )

   end subroutine m_KE_add_ekindens_hard_rspace


  subroutine m_KE_wd_ekindens
    real(kind=DP), allocatable :: wk_mpi1(:,:,:), wk_mpi2(:,:,:)

    if(mype==0) rewind nf_ekindens
    if(npes > 1) then
       allocate(wk_mpi1(kgp,kimg,nspin)); wk_mpi1 = 0.d0
       allocate(wk_mpi2(kgp,kimg,nspin)); wk_mpi2 = 0.d0

       if ( use_symm_ekin_density ) then
          wk_mpi1(ista_kngp:iend_kngp,:,:) = ekins_l(ista_kngp:iend_kngp,:,:)
       else if ( use_asymm_ekin_density ) then
          wk_mpi1(ista_kngp:iend_kngp,:,:) = ekina_l(ista_kngp:iend_kngp,:,:)
       endif
       call mpi_allreduce( wk_mpi1, wk_mpi2, kgp*kimg*nspin, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )

       if(mype==0) write(nf_ekindens) wk_mpi2

       deallocate(wk_mpi1); deallocate(wk_mpi2)
    else
       if ( use_symm_ekin_density ) then
          write(nf_ekindens) ekins_l
       else if ( use_asymm_ekin_density ) then
          write(nf_ekindens) ekina_l
       end if
    endif

  end subroutine m_KE_wd_ekindens

  subroutine m_KE_rd_ekindens
    real(kind=DP), allocatable :: wk_mpi1(:,:,:)

    if(mype==0) rewind nf_ekindens
    if(npes > 1) then
       allocate(wk_mpi1(kgp,kimg,ndim_magmom)); wk_mpi1 = 0.d0

       if ( mype==0 ) read(nf_ekindens) wk_mpi1
       call mpi_bcast( wk_mpi1, kgp*kimg*ndim_magmom, mpi_double_precision, &
            &          0, mpi_comm_group, ierr )

       if ( use_symm_ekin_density ) then
          ekins_l(ista_kngp:iend_kngp,:,:) = wk_mpi1(ista_kngp:iend_kngp,:,:)
       else if ( use_asymm_ekin_density ) then
          ekina_l(ista_kngp:iend_kngp,:,:) = wk_mpi1(ista_kngp:iend_kngp,:,:)
       endif
       deallocate(wk_mpi1)
    else
       if ( use_symm_ekin_density ) then
          read(nf_ekindens) ekins_l
       else if ( use_asymm_ekin_density ) then
          read(nf_ekindens) ekina_l
       end if
    endif
  end subroutine m_KE_rd_ekindens

end module m_KineticEnergy_Density

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 570 $)
!
!  MODULE: m_ES_initialWF
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_ES_initialWF
!    ( m_ESIW)
! $Id: m_ES_initialWF.F90 570 2017-04-21 20:34:50Z yamasaki $
!
! The original subroutine was "rndzaj", which was coded with
! referring to Dr. K. Kato's program on 2nd Jul. 1994.
!
! "rndzaj" was modified to improve the quality of random
! numbers by T. Yamasaki.    17th Oct. 1994
!
! "rndzaj" was translated into "m_ESIW_by_randomnumbers" by
! T. Yamasaki, in 1999.
!

  use m_Electronic_Structure,only : zaj_l, neordr, nrvf_ordr
  use m_ES_nonlocal         ,only : m_ES_PAO_WFs_3D
  use m_PlaneWaveBasisSet,   only : nmatsz, iba, kg1, kg_gamma, nbase_gamma
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,  only : kimg, neg, ipri
  use m_Const_Parameters,    only : DP, GAMMA, GAMMA_base_symmetrization
  use m_Kpoints,             only : k_symmetry
  use m_Parallelization,     only : mype,map_z,map_ek,myrank_k,map_k, ista_e, iend_e, istep_e   &
 &                                 , ista_k, iend_k , ista_g1k, iend_g1k, np_g1k, nrank_g, np_e


! ============================ added by K. Tagami ======================== 11.0
  use m_Control_Parameters,    only : noncol
!  use m_ES_nonlocal,           only : m_ES_PAO_WFs_noncl
! ========================================================================= 11.0

  implicit none

!  58. m_ESIW_by_randomnumbers    <-(Initial_Electronic_Structure)
contains

  subroutine m_ESIW_by_atomic_orbitals(nfout,kv3,ie_start,ie_end) !(paozaj)
    integer, intent(in) :: nfout,kv3,ie_start,ie_end
    call m_ESIW_by_randomnumbers_3D(nfout,kv3,ie_start,ie_end)
    call m_ES_PAO_WFs_3D(nfout)
  end subroutine m_ESIW_by_atomic_orbitals
!===============================================================================
  subroutine m_ESIW_by_randomnumbers_3D(nfout,kv3,ie_start, ie_end)   !(rndzaj)
!
!f
    use m_Parallelization,     only :  nbsn_sta, nbsn_end, neg_g, nbsn_num
    integer :: l_bl, n_sta, n_end
    integer, intent(in) :: nfout,kv3,ie_start,ie_end
    real(kind=DP), allocatable, dimension(:) :: zaj_t

#ifdef _DEBUG_INITIALIZATION_
    real(kind=DP)   :: a,b,p,xn
    data a,b,p/32771.d0,1234567891.d0,2147483648.d0/
#endif

    integer, allocatable, dimension(:) :: vlambda, vc, nlambda, nc, mlambda, mc

    integer :: iimg, ik, ieg, i, iegt, xp, ig1, ig2
    integer(kind=8) :: jump
    logical :: first

    integer :: id_sname = -1
    write(nfout,'(" <<< m_ESIW_by_randomnumbers_3D >>>")')
    call tstatc0_begin('m_ESIW_by_randomnumbers ',id_sname)

    if(ipri >= 2) then
       write(nfout,*)
       write(nfout,'(" <<< m_ESIW_by_randomnumbers >>>")')
       write(nfout,'(" !iba(1)        = ",i6)') iba(1)
    end if
!3D
   zaj_l = 0.0d0

    allocate(vlambda(0:1023), vc(0:1023), nlambda(0:1023), nc(0:1023), mlambda(0:1023), mc(0:1023))
    first = .true.

    do iimg = 1, kimg

       do ik = ista_k, iend_k              ! mpi
          if(iend_k > kv3) cycle
          if(k_symmetry(ik) == GAMMA .or. k_symmetry(ik) == GAMMA_base_symmetrization) then
!f             allocate(zaj_t(kg_gamma))
             allocate(zaj_t(np_g1k(ik)))
!modfy for block
#ifdef __TIMER_INIDO__
  call timer_sta(1345)
#endif
             do ieg = 1,np_e
!f             do ieg = ista_e,iend_e,istep_e   ! mpi
!!$                if(ista_e < ie_start) cycle
!!$                if(iend_e > ie_end)   cycle
                if(ieg < ie_start) cycle
                if(ieg > ie_end)   cycle
                xp = 0
!f                jump = kg_gamma*((ie_end-ie_start+1)*(kv3*(iimg-1_8) + (ik-1_8)) + (ieg-ie_start))
                jump = kg_gamma*((ie_end-ie_start+1)*(kv3*(iimg-1_8) + (ik-1_8)) + (neg_g(ieg)-ie_start)) + ista_g1k(ik) -1
!f                call pran0(xp,jump,kg_gamma,zaj_t)
                call pran0(xp,jump,np_g1k(ik),zaj_t)
                if(k_symmetry(ik) == GAMMA) then
!f                   zaj_l(1:kg_gamma,map_z(ieg),ik,iimg) = zaj_t(1:kg_gamma)
                   zaj_l(1:np_g1k(ik),ieg,ik,iimg) = zaj_t(1:np_g1k(ik))
                else if(k_symmetry(ik) == GAMMA_base_symmetrization) then
                   if(iimg == 1) then
!f                      do i = 2, kg_gamma
!f                         ig1 = nbase_gamma(i,1)
!f                         ig2 = nbase_gamma(i,2)
!f                         zaj_l(ig1,ieg,ik,iimg) = zaj_t(i)
!f                         zaj_l(ig2,ieg,ik,iimg) = zaj_t(i)
!f                      end do
!f                      zaj_l(1,ieg,ik,iimg) = zaj_t(1)
                      zaj_l(1:np_g1k(ik),ieg,ik,iimg) = zaj_t(1:np_g1k(ik))
                   else
!f                      do i = 2, kg_gamma
!f                         ig1 = nbase_gamma(i,1)
!f                         ig2 = nbase_gamma(i,2)
!f                         zaj_l(ig1,ieg,ik,iimg) =  zaj_t(i)
!f                         zaj_l(ig2,ieg,ik,iimg) = -zaj_t(i)
!f                      end do
!f                      zaj_l(1,ieg,ik,iimg) = 0.d0
                      zaj_l(1:np_g1k(ik),ieg,ik,iimg) = zaj_t(1:np_g1k(ik))
                   end if
                end if
                first = .false.
             end do
#ifdef __TIMER_INIDO__
  call timer_end(1345)
#endif
             deallocate(zaj_t)
          else
#ifdef __TIMER_INIDO__
  call timer_sta(1346)
#endif
             do ieg = 1,np_e
!f             do ieg = ista_e,iend_e,istep_e   ! mpi
                if(ieg < ie_start) cycle
                if(ieg > ie_end)   cycle
!!$             xn = 0.d0
!!$             jump = kg1*((ie_end-ie_start)*(kv3*(iimg-1) + (ik-1)) + (ieg-ie_start))
!!$             do i = 1, jump
!!$                xn = mod(xn*a+b,p)
!!$             end do
!!$             do i = 1, iba(ik)
!!$                xn = mod(xn*a+b,p)
!!$                zaj_l(i,map_z(ieg),ik,iimg) = xn/p ! MPI
!!$             end do
                xp = 0
!f                jump = kg1*((ie_end-ie_start+1)*(kv3*(iimg-1_8) + (ik-1_8)) + (ieg-ie_start))
!f                call pran0(xp,jump,iba(ik),zaj_l(1,map_z(ieg),ik,iimg))
                jump = kg1*((ie_end-ie_start+1)*(kv3*(iimg-1_8) + (ik-1_8)) + (neg_g(ieg)-ie_start)) + ista_g1k(ik) -1
                call pran0(xp,jump,np_g1k(ik),zaj_l(1,ieg,ik,iimg))
                first = .false.
             end do
#ifdef __TIMER_INIDO__
  call timer_end(1346)
#endif
          end if
       end do
!

    enddo

    deallocate(mc, mlambda, nc, nlambda, vc, vlambda)

    if(ipri >= 2) write(nfout,'(" initialization of neordr and nrvf_ordr")')
! Initialization

    do ik = 1, kv3
       if(map_k(ik) /= myrank_k) cycle ! MPI
!!$       do i = 1, neg
       do i = ie_start, ie_end
          neordr(i,ik)    = i
          nrvf_ordr(i,ik) = i
       end do
    end do

    call tstatc0_end(id_sname)

  contains
    subroutine pran0(iseed,nstep,n1,r)
!
!  AUTHOR: T.Kokubo   Jun/15/2005
!
      implicit none

      integer :: iseed,n1
      integer(kind=8) :: nstep
      real(kind=DP) :: r(n1)

      integer, PARAMETER :: lambda=32771,c=1234567891,m=2147483647
      real(kind=DP), PARAMETER :: Minv=1.0D+00/2147483648.d0

      integer :: k,j
      integer(kind=8) :: istep,jstep,ijmp,jjmp,ijmpm,jjmpm

      if(first) then
         vlambda(0)=lambda
         vc(0)=c
#ifdef SX
!cdir novector
#endif
#ifdef HIUX
*poption noparallel
#endif
         do k=1,1023
            vlambda(k)=lambda*vlambda(k-1)
            vc(k)=vc(k-1)+c*vlambda(k-1)
         enddo
         nlambda(0)=vlambda(1023)
         nc(0)=vc(1023)
#ifdef SX
!cdir novector
#endif
#ifdef HIUX
*poption noparallel
#endif
         do k=1,1023
            nlambda(k)=vlambda(1023)*nlambda(k-1)
            nc(k)=nc(k-1)+vc(1023)*nlambda(k-1)
         enddo
         mlambda(0)=nlambda(1023)
         mc(0)=nc(1023)
#ifdef SX
!cdir novector
#endif
#ifdef HIUX
*poption noparallel
#endif
         do k=1,1023
            mlambda(k)=nlambda(1023)*mlambda(k-1)
            mc(k)=mc(k-1)+nc(1023)*mlambda(k-1)
         enddo
!!$         first=.false.
      endif

      istep=nstep/1024_8
      jstep=nstep-istep*1024_8

      ijmp=istep/1024_8
      jjmp=istep-ijmp*1024_8

      ijmpm=ijmp/1024_8
      jjmpm=ijmp-ijmpm*1024_8

#ifdef SX
!cdir novector
#endif
#ifdef HIUX
*poption noparallel
#endif
      do j=1,ijmpm
         iseed=iseed*mlambda(1023)+mc(1023)
      enddo
      if(jjmpm.ne.0) then
         iseed=iseed*mlambda(jjmpm-1)+mc(jjmpm-1)
      endif
      if(jjmp.ne.0) then
         iseed=iseed*nlambda(jjmp-1)+nc(jjmp-1)
      endif
      if(jstep.ne.0) then
         iseed=iseed*vlambda(jstep-1)+vc(jstep-1)
      endif

      do j=1,n1,1024
#ifdef SX
!cdir nodep
#endif
#ifdef HIUX
*poption indep
#endif
         do k=0,min(1023,n1-j)
            r(j+k)=minv*iand(iseed*vlambda(k)+vc(k),m)
         enddo
         iseed=iseed*vlambda(k-1)+vc(k-1)
      enddo
    end subroutine pran0
  end subroutine m_ESIW_by_randomnumbers_3D
!----
  subroutine m_ESIW_by_randomnumbers0_3D(nfout,kv3,ie_start, ie_end)   !(rndzaj)
!3D
!f
    use m_Parallelization,     only :  nbsn_sta, nbsn_end, neg_g, nbsn_num
    integer :: l_bl, n_sta, n_end
    integer, intent(in) :: nfout,kv3,ie_start,ie_end
    real(kind=DP), allocatable, dimension(:) :: zaj_t
    real(kind=DP), allocatable, dimension(:) :: zaj_wk

#ifdef _DEBUG_INITIALIZATION_
    real(kind=DP)   :: a,b,p,xn
    data a,b,p/32771.d0,1234567891.d0,2147483648.d0/
#endif

    integer, allocatable, dimension(:) :: vlambda, vc, nlambda, nc, mlambda, mc

    integer :: iimg, ik, ieg, i, iegt, xp, ig1, ig2
    integer(kind=8) :: jump
    logical :: first

    integer :: id_sname = -1
    write(nfout,'(" <<< m_ESIW_by_randomnumbers0_3D >>>")')
    call tstatc0_begin('m_ESIW_by_randomnumbers ',id_sname)

    if(ipri >= 2) then
       write(nfout,*)
       write(nfout,'(" <<< m_ESIW_by_randomnumbers >>>")')
       write(nfout,'(" !iba(1)        = ",i6)') iba(1)
    end if
!3D
   allocate(zaj_wk(kg1))
   zaj_l = 0.0d0

    allocate(vlambda(0:1023), vc(0:1023), nlambda(0:1023), nc(0:1023), mlambda(0:1023), mc(0:1023))
    first = .true.

    do iimg = 1, kimg

       do ik = ista_k, iend_k              ! mpi
          if(iend_k > kv3) cycle
          if(k_symmetry(ik) == GAMMA .or. k_symmetry(ik) == GAMMA_base_symmetrization) then
             allocate(zaj_t(kg_gamma))
!modfy for block
             do ieg = 1,np_e
!f             do ieg = ista_e,iend_e,istep_e   ! mpi
!!$                if(ista_e < ie_start) cycle
!!$                if(iend_e > ie_end)   cycle
                if(ieg < ie_start) cycle
                if(ieg > ie_end)   cycle
                xp = 0
                zaj_wk = 0.0d0
!f                jump = kg_gamma*((ie_end-ie_start+1)*(kv3*(iimg-1_8) + (ik-1_8)) + (ieg-ie_start))
                jump = kg_gamma*((ie_end-ie_start+1)*(kv3*(iimg-1_8) + (ik-1_8)) + (neg_g(ieg)-ie_start))
                call pran0(xp,jump,kg_gamma,zaj_t)
                if(k_symmetry(ik) == GAMMA) then
!f                   zaj_l(1:kg_gamma,map_z(ieg),ik,iimg) = zaj_t(1:kg_gamma)
                   zaj_wk(1:kg_gamma) = zaj_t(1:kg_gamma)
                else if(k_symmetry(ik) == GAMMA_base_symmetrization) then
                   if(iimg == 1) then
                      do i = 2, kg_gamma
                         ig1 = nbase_gamma(i,1)
                         ig2 = nbase_gamma(i,2)
                         zaj_wk(ig1) = zaj_t(i)
                         zaj_wk(ig2) = zaj_t(i)
                      end do
                      zaj_wk(1) = zaj_t(1)
                   else
                      do i = 2, kg_gamma
                         ig1 = nbase_gamma(i,1)
                         ig2 = nbase_gamma(i,2)
                         zaj_wk(ig1) =  zaj_t(i)
                         zaj_wk(ig2) = -zaj_t(i)
                      end do
                      zaj_wk(1) = 0.d0
                   end if
                end if
                first = .false.
                do i = ista_g1k(ik),iend_g1k(ik)
                   zaj_l(i-ista_g1k(ik)+1,ieg,ik,iimg) = zaj_wk(i)
                end do
             end do
             deallocate(zaj_t)
          else
             do ieg = 1,np_e
!f             do ieg = ista_e,iend_e,istep_e   ! mpi
                if(ieg < ie_start) cycle
                if(ieg > ie_end)   cycle
!!$             xn = 0.d0
!!$             jump = kg1*((ie_end-ie_start)*(kv3*(iimg-1) + (ik-1)) + (ieg-ie_start))
!!$             do i = 1, jump
!!$                xn = mod(xn*a+b,p)
!!$             end do
!!$             do i = 1, iba(ik)
!!$                xn = mod(xn*a+b,p)
!!$                zaj_l(i,map_z(ieg),ik,iimg) = xn/p ! MPI
!!$             end do
                xp = 0
!f                jump = kg1*((ie_end-ie_start+1)*(kv3*(iimg-1_8) + (ik-1_8)) + (ieg-ie_start))
!f                call pran0(xp,jump,iba(ik),zaj_l(1,map_z(ieg),ik,iimg))
                jump = kg1*((ie_end-ie_start+1)*(kv3*(iimg-1_8) + (ik-1_8)) + (neg_g(ieg)-ie_start))
                zaj_wk = 0.0d0
                call pran0(xp,jump,iba(ik),zaj_wk)
                do i=ista_g1k(ik),iend_g1k(ik)
                   zaj_l(i-ista_g1k(ik)+1,ieg,ik,iimg) = zaj_wk(i)
                enddo
                first = .false.
             end do
          end if
       end do
!

    enddo

    deallocate(mc, mlambda, nc, nlambda, vc, vlambda)
    deallocate(zaj_wk)

    if(ipri >= 2) write(nfout,'(" initialization of neordr and nrvf_ordr")')
! Initialization

    do ik = 1, kv3
       if(map_k(ik) /= myrank_k) cycle ! MPI
!!$       do i = 1, neg
       do i = ie_start, ie_end
          neordr(i,ik)    = i
          nrvf_ordr(i,ik) = i
       end do
    end do

    call tstatc0_end(id_sname)

  contains
    subroutine pran0(iseed,nstep,n1,r)
!
!  AUTHOR: T.Kokubo   Jun/15/2005
!
      implicit none

      integer :: iseed,n1
      integer(kind=8) :: nstep
      real(kind=DP) :: r(n1)

      integer, PARAMETER :: lambda=32771,c=1234567891,m=2147483647
      real(kind=DP), PARAMETER :: Minv=1.0D+00/2147483648.d0

      integer :: k,j
      integer(kind=8) :: istep,jstep,ijmp,jjmp,ijmpm,jjmpm

      if(first) then
         vlambda(0)=lambda
         vc(0)=c
#ifdef SX
!cdir novector
#endif
#ifdef HIUX
*poption noparallel
#endif
         do k=1,1023
            vlambda(k)=lambda*vlambda(k-1)
            vc(k)=vc(k-1)+c*vlambda(k-1)
         enddo
         nlambda(0)=vlambda(1023)
         nc(0)=vc(1023)
#ifdef SX
!cdir novector
#endif
#ifdef HIUX
*poption noparallel
#endif
         do k=1,1023
            nlambda(k)=vlambda(1023)*nlambda(k-1)
            nc(k)=nc(k-1)+vc(1023)*nlambda(k-1)
         enddo
         mlambda(0)=nlambda(1023)
         mc(0)=nc(1023)
#ifdef SX
!cdir novector
#endif
#ifdef HIUX
*poption noparallel
#endif
         do k=1,1023
            mlambda(k)=nlambda(1023)*mlambda(k-1)
            mc(k)=mc(k-1)+nc(1023)*mlambda(k-1)
         enddo
!!$         first=.false.
      endif

      istep=nstep/1024_8
      jstep=nstep-istep*1024_8

      ijmp=istep/1024_8
      jjmp=istep-ijmp*1024_8

      ijmpm=ijmp/1024_8
      jjmpm=ijmp-ijmpm*1024_8

#ifdef SX
!cdir novector
#endif
#ifdef HIUX
*poption noparallel
#endif
      do j=1,ijmpm
         iseed=iseed*mlambda(1023)+mc(1023)
      enddo
      if(jjmpm.ne.0) then
         iseed=iseed*mlambda(jjmpm-1)+mc(jjmpm-1)
      endif
      if(jjmp.ne.0) then
         iseed=iseed*nlambda(jjmp-1)+nc(jjmp-1)
      endif
      if(jstep.ne.0) then
         iseed=iseed*vlambda(jstep-1)+vc(jstep-1)
      endif

      do j=1,n1,1024
#ifdef SX
!cdir nodep
#endif
#ifdef HIUX
*poption indep
#endif
         do k=0,min(1023,n1-j)
            r(j+k)=minv*iand(iseed*vlambda(k)+vc(k),m)
         enddo
         iseed=iseed*vlambda(k-1)+vc(k-1)
      enddo
    end subroutine pran0
  end subroutine m_ESIW_by_randomnumbers0_3D
!$$#endif
end module m_ES_initialWF

      implicit double precision (a-h,o-z)

      real(8), pointer ::
     &           a(:),z(:),w(:)
      integer, parameter :: NDIM = 2

!      real(8), parameter :: PAI = 3.141592653589794D0
      real(8), parameter :: ONE = 1D0
      real(8) :: PAI
!
      include 'mpif.h'
      include 'trd.h'
!
      PAI = 4*ATAN(ONE)
!
      call mpi_init(ierr)
      MPI_COMM_EIGEN=MPI_COMM_WORLD
      call mpi_comm_rank(mpi_comm_eigen,i$inod,ierr)
      call mpi_comm_size(mpi_comm_eigen,i$nnod,ierr)
*
      if(i$inod.eq.0)then
         open(10,file='IN')
      endif
*
      DO

         if(i$inod.eq.0)then
            read(10,*) n,m, nall, mtype
         endif

         call mpi_bcast(n,1,mpi_integer,0,MPI_COMM_EIGEN,ierr)
         if ( n < 1 .or. n > 400000 ) EXIT
         call mpi_bcast(m,1,mpi_integer,0,MPI_COMM_EIGEN,ierr)
         call mpi_bcast(nall,1,mpi_integer,0,MPI_COMM_EIGEN,ierr)
         call mpi_bcast(mtype,1,mpi_integer,0,MPI_COMM_EIGEN,ierr)


         call datacast_init(NDIM)
         NPROW = x_nnod
         NPCOL = y_nnod
! BLACS/PBLAS/SCALAPACK initialization
         CALL BLACS_PINFO( IAM, NPROCS )
         if ( NPROCS < 1 ) then
!  MPI group setup
            NPROCS = i$nnod
            IAM = i$inod
            CALL BLACS_SETUP( IAM, NPROCS )
         end if

         nx = ((n-1)/NPROW+1)
         call CSTAB_get_optdim(nx, 6, 16*4, 16*4*2, nm)
         if(i$inod.eq.0)then
            PRINT*,"N=",n, "NM=",nm
         endif
        call datacast_free(0)


!         NB  = 48
         NB  = 64+32
         nmz = ((n-1)/NPROW+1)
         nmz = ((nmz-1)/NB+1)*NB+1
         nmw = ((n-1)/NPCOL+1)
         nmw = ((nmw-1)/NB+1)*NB+1

         larray = MAX(nmz,nm)*nmw
         allocate(
     &               a(larray), z(larray),
     &               w(n),
     &               stat=istat)
         if(istat.ne.0) then
            print*,"Memory exhausted"
            call flush(6)
            EXIT
         endif
*
         call mat_set(n, a(1), nm, mtype, NDIM)
*-
         call eigen_s(n, a(1), nm, w(1), z(1), nm, m)
*-
         if(i$inod.eq.0)then
            ax=0D0
            do i=1,n
               j=n-i
               theta=PAI*(2*j+1)/(2*n+1)
               x=5D-1/(1D0-COS(theta))
               ax=MAX(ax,ABS(w(i)-x)/ABS(x))
            enddo
            print*,"max|w(i)-w(i).true|/|w|=",ax
         endif
         call flush(6)
*-
         if(IAND(nall,4)/=0)then
            call mat_set(n, a(1), nm, mtype, NDIM)
            call ev_test_2D(n, a(1), nm, w(1), z(1), nm, t)
         endif
*
         deallocate(a)
         deallocate(z)
         deallocate(w)

      ENDDO

      if(i$inod.eq.0)then
         close(10)
      endif
*
*
      call MPI_Finalize(ierr)
      end

      subroutine flush(i)
      end

!================================================
!  Software name : STM
!  Module : m_Const_Parameters
!  Author(s)     : Takahiro Yamasaki (June 7, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.

module m_Const_Parameters
! $Id: m_Const_Parameters.f90,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
  implicit none
  integer, parameter :: DP = kind(1.d0)
  integer, parameter :: SP = kind(1.0)
  integer, parameter :: CMPLDP = kind((1.d0, 0.d0))
  integer, parameter :: CMPLSP = kind((1.0 , 0.0 ))
  integer, parameter :: ON = 1, OFF = 0
  integer, parameter :: INVERSE = 1, DIRECT = 2
  integer, parameter :: BEGIN = 1, END = 2
  integer, parameter :: NODATA = 0, PUCV = 0, CARTS = 1, BUCS = 2
  integer, parameter :: CRDTYP = BUCS
  integer, parameter :: OLD = 0, NEW = 1, UNKNOWN = 2
  integer, parameter :: FORMATTED = 0, UNFORMATTED = 1
  integer, parameter :: check_file_name_on  = 1
  integer, parameter :: check_file_name_off = 0
  integer, parameter :: GENERAL = 100
  integer, parameter :: LOWER = 1, IN_BETWEEN = 0, HIGHER = 2
  integer, parameter :: NEGATIVE = -1
  real(kind=DP), parameter :: PAI  = 3.141592653589793238462D0
  real(kind=DP), parameter :: PAI2 = PAI*2.d0, PAI4 = PAI*4.d0
  real(kind=DP), parameter :: Hartree = 27.21139615d0
  real(kind=DP), parameter :: BOHR = 0.5291772480d0

end module m_Const_Parameters

module m_CLS_dipquad
  use m_Const_Parameters,  only : DP, CMPLDP, zi, ON, BUCS, PAI2, PAI, PAI4, &
       &                          MacroDielectric, PACS
  use m_PseudoPotential,    only : nlmt, nloc, ntau, radr_paw, iltpw, lppw, tppw, &
       &                           nmesh, mmesh, ltp, mtp, taup, phirpw, ilmt, psirpw, &
       &                           nlmt_add, ilmt_add, ltp_add, mtp_add, lpsmax, itau, &
       &                           lmta, lmta_add, nlmta
  use m_Ionic_System,   only :  ityp
  use m_CoreLevel_Spectrum,  only : qnum_l_to_probe, psir_core_ae_wfns, &
       &                            m_CLS_find_orb_index_to_probe, atom_to_probe, &
       &                            num_core_states, fsr_core_states, fsi_core_states, &
       &                            ene_core_states, mimic_soc_split_spectrum, &
       &                            ene_initial_state_splitting, qnum_n_to_probe

  use m_SpinOrbit_Potential,   only : MatU_ylm_RC_L0, MatU_ylm_RC_L1, &
       &                              MatU_ylm_RC_L2, MatU_ylm_RC_L3, &
       &                              MatU_ylm_RC_L4

  use m_Parallelization,    only : mype, np_e, myrank_k, map_k, map_z, &
       &                           ista_e, iend_e, istep_e, npes, mpi_comm_group, &
       &                           myrank_e, map_e

  use m_Control_Parameters, only : sw_use_add_proj, ndim_spinor, nspin, neg, noncol
  use m_Kpoints,            only : kv3_ek, kv3, qwgt_ek, num_star_of_k, star_of_k, &
       &                           iopr_k_fbz_to_ibz, trev_k_fbz_to_ibz, kv3_fbz
  use m_IterationNumbers,           only : nk_in_the_process
  use m_Electronic_Structure,  only : fsr_l, fsi_l, fsr_add_l, fsi_add_l, eko_ek, &
       &                              efermi
  use m_CS_Magnetic,         only : magmom_dir_inversion_opr_flag
  use m_Crystal_Structure,   only : op, tau, univol
  use m_Files,               only : nfepsout, m_Files_open_nfeps, m_Files_close_nfeps, &
       &                            nfout
  use m_ES_nonlocal,    only : m_ES_add_betar_dot_WFs

  implicit none
  include 'mpif.h'

  integer, private :: lmax = 4
  integer, private, parameter :: nsph_max = 25
  integer, private, parameter :: PARABOLIC_B = 1, L_TETRAHEDRON = 2, &
       &                         GAUSSIAN_B = 3, LORENTZIAN_B = 4

  real(kind=DP), parameter :: hartree_in_eV = 27.2113845d0
  real(kind=DP), parameter :: InvHyperFineConst = 137.035999679D0

  complex(kind=CMPLDP) :: rhat_cylm(nsph_max,nsph_max,3)
  real(kind=DP) :: rhat_rylm(nsph_max,nsph_max,3)
  real(kind=DP) :: rhat2_rylm(nsph_max,nsph_max,3,3)

  real(kind=DP), allocatable :: rdipole_val_core(:,:,:)
  real(kind=DP), allocatable :: rquadrupole_val_core(:,:,:,:)

  complex(kind=CMPLDP), allocatable :: trm_dipole(:,:,:,:)
  complex(kind=CMPLDP), allocatable :: trm_quadrupole(:,:,:,:,:)

contains

! fixed_charge version
  subroutine m_CLS_alloc_transmom_ek
    allocate( trm_dipole( np_e, num_core_states, kv3_ek, 3 ) )
    allocate( trm_quadrupole( np_e, num_core_states, kv3_ek, 3, 3 ) )
    trm_dipole = 0.0d0
    trm_quadrupole = 0.0d0
  end subroutine m_CLS_alloc_transmom_ek

  subroutine m_CLS_dealloc_transmom_ek
    deallocate( trm_dipole )
    deallocate( trm_quadrupole )
  end subroutine m_CLS_dealloc_transmom_ek

  subroutine m_CLS_wd_transmom_ek
    integer :: lun

    if ( mype == 0 ) then
       open( newunit=lun, file="trans_bin.data", form="unformatted", status="unknown")
    endif
    call write_trm_dipole(lun)
    call write_trm_quadrupole(lun)
    if ( mype == 0 )  close( lun )

  contains

    subroutine write_trm_dipole(lun)
      integer, intent(in) :: lun
      integer :: ik, ib1, ib2, nsize, ierr
      complex(kind=CMPLDP), allocatable :: zwk1(:,:,:,:)
      complex(kind=CMPLDP), allocatable :: zwk1_mpi(:,:,:,:)

      nsize = num_core_states *neg *kv3_ek *3
      allocate( zwk1(neg,num_core_states,kv3_ek,3) )
      zwk1 = 0.0d0

      Do ib2=1, num_core_states
         Do ik=1, kv3_ek
            Do ib1=1, neg
               if ( map_e(ib1) /= myrank_e ) cycle
               zwk1(ib1,ib2,ik,1:3) = trm_dipole(map_z(ib1),ib2,ik,1:3)
            End do
         End do
      End Do
      if ( npes > 1 ) then
         allocate( zwk1_mpi(neg,num_core_states,kv3_ek,3) )
         call mpi_allreduce( zwk1, zwk1_mpi, nsize*2, mpi_double_precision, &
              &              mpi_sum, mpi_comm_group, ierr )
         zwk1 = zwk1_mpi
         deallocate( zwk1_mpi )
      endif
      if ( mype == 0 ) then
         write(lun) 2
         write(lun) num_core_states, neg, kv3_ek
         write(lun) zwk1
      endif
      deallocate( zwk1 )
    end subroutine write_trm_dipole

    subroutine write_trm_quadrupole(lun)
      integer, intent(in) :: lun

      integer :: ik, ib1, ib2, nsize, ierr
      complex(kind=CMPLDP), allocatable :: zwk1(:,:,:,:,:)
      complex(kind=CMPLDP), allocatable :: zwk1_mpi(:,:,:,:,:)

      nsize = num_core_states *neg *kv3_ek *3 *3
      allocate( zwk1(neg,num_core_states,kv3_ek,3,3) )
      zwk1 = 0.0d0

      Do ib2=1, num_core_states
         Do ik=1, kv3_ek
            Do ib1=1, neg
               if ( map_e(ib1) /= myrank_e ) cycle
               zwk1(ib1,ib2,ik,1:3,1:3) = trm_quadrupole(map_z(ib1),ib2,ik,1:3,1:3)
            End do
         End do
      End Do
      if ( npes > 1 ) then
         allocate( zwk1_mpi(neg,num_core_states,kv3_ek,3,3) )
         call mpi_allreduce( zwk1, zwk1_mpi, nsize*2, mpi_double_precision, &
              &              mpi_sum, mpi_comm_group, ierr )
         zwk1 = zwk1_mpi
         deallocate( zwk1_mpi )
      endif
      if ( mype == 0 ) then
         write(lun) 4
         write(lun) num_core_states, neg, kv3_ek
         write(lun) zwk1
      endif
      deallocate( zwk1 )
    end subroutine write_trm_quadrupole

  end subroutine m_CLS_wd_transmom_ek

  subroutine m_CLS_rd_transmom_ek
    integer :: lun

    if ( mype == 0 ) then
       lun = get_unused_unitnumber() 
       open( lun, file="trans_bin.data", form="unformatted", status="old" )
!       open( newunit=lun, file="trans_bin.data", form="unformatted", status="old" )
    endif
    call read_trm_dipole(lun)
    call read_trm_quadrupole(lun)
    if ( mype == 0 )  close( lun )

  contains

    subroutine read_trm_dipole(lun)
      integer, intent(in) :: lun
      integer :: ik, ib1, ib2, nsize, n1, n2, n3, n4, ierr
      complex(kind=CMPLDP), allocatable :: zwk1(:,:,:,:)
      complex(kind=CMPLDP), allocatable :: zwk1_mpi(:,:,:,:)

      nsize = num_core_states *neg *kv3_ek *3
      allocate( zwk1(neg,num_core_states,kv3_ek,3) )

      if ( mype == 0 ) then
         read(lun) n1
         read(lun) n2, n3, n4
         if ( n1 /= 2 ) then
            stop "trans bin data (dipole) is different"
         endif
         if ( n2 /= num_core_states ) then
            stop "trans bin data (dipole) is different"
         endif
         if ( n3 /= neg ) then
            stop "trans bin data (dipole) is different"
         endif
         if ( n4 /= kv3_ek ) then
            stop "trans bin data (dipole) is different"
         endif
         read(lun) zwk1
      endif
      call mpi_bcast( zwk1, nsize*2, mpi_double_precision, 0, mpi_comm_group, ierr )

      Do ib2=1, num_core_states
         Do ik=1, kv3_ek
            Do ib1=1, neg
               if ( map_e(ib1) /= myrank_e ) cycle
               trm_dipole(map_z(ib1),ib2,ik,1:3) = zwk1(ib1,ib2,ik,1:3)
            End do
         End do
      End Do
      deallocate( zwk1 )
    end subroutine read_trm_dipole

    subroutine read_trm_quadrupole(lun)
      integer, intent(in) :: lun

      integer :: ik, ib1, ib2, nsize, n1, n2, n3, n4, ierr
      complex(kind=CMPLDP), allocatable :: zwk1(:,:,:,:,:)
      complex(kind=CMPLDP), allocatable :: zwk1_mpi(:,:,:,:,:)

      nsize = num_core_states *neg *kv3_ek *3 *3
      allocate( zwk1(neg,num_core_states,kv3_ek,3,3) )

      if ( mype == 0 ) then
         read(lun) n1
         read(lun) n2, n3, n4
         if ( n1 /= 4 ) then
            stop "trans bin data (quadrupole) is different"
         endif
         if ( n2 /= num_core_states ) then
            stop "trans bin data (quadrupole) is different"
         endif
         if ( n3 /= neg ) then
            stop "trans bin data (quadrupole) is different"
         endif
         if ( n4 /= kv3_ek ) then
            stop "trans bin data (quadrupole) is different"
         endif
         read(lun) zwk1
      endif
      call mpi_bcast( zwk1, nsize*2, mpi_double_precision, 0, mpi_comm_group, ierr )

      Do ib2=1, num_core_states
         Do ik=1, kv3_ek
            Do ib1=1, neg
               if ( map_e(ib1) /= myrank_e ) cycle
               trm_quadrupole(map_z(ib1),ib2,ik,1:3,1:3) = zwk1(ib1,ib2,ik,1:3,1:3)
            End do
         End do
      End Do
      deallocate( zwk1 )
    end subroutine read_trm_quadrupole

  end subroutine m_CLS_rd_transmom_ek

  subroutine m_CLS_calc_transmom_ek
    integer :: nlmt_core
    integer :: ia, it, ik, ik2, ib1, ib2
    integer :: lmt1, lmt2, lmta2
    complex(kind=CMPLDP) :: z1, wf1, wf2
    complex(kind=CMPLDP), allocatable :: wk_fsri(:)


    nlmt_core = 2*qnum_l_to_probe+1
    allocate( wk_fsri(nlmt_core) ); wk_fsri = 0.0d0
    

    if ( sw_use_add_proj == ON ) call m_ES_add_betar_dot_WFs(nfout)

    Do ia = atom_to_probe, atom_to_probe
       it = ityp(ia)
       
       Do ik=1, kv3
          if ( map_k(ik) /= myrank_k ) cycle
          ik2 = nk_in_the_process +ik -1


          Do ib1=1, num_core_states
             wk_fsri(:) = dcmplx( fsr_core_states( ib1,:,ik ), &
                  &               fsi_core_states( ib1,:,ik ) )
             
             DO ib2=1, np_e
                
                Do lmt2=1, ilmt(it)
                   lmta2 = lmta(lmt2,ia)
                   wf2 = dcmplx( fsr_l( ib2, lmta2, ik ), &
                        &        fsi_l( ib2, lmta2, ik ) )

                   Do lmt1=1, nlmt_core
                      wf1 = wk_fsri(lmt1)
                      z1 =  conjg(wf2) *wf1
                      trm_dipole( ib2, ib1, ik2, 1:3 ) &
                           &  = trm_dipole( ib2, ib1, ik2, 1:3 ) &
                           &    + z1 *rdipole_val_core( lmt2, lmt1, 1:3 )
                      trm_quadrupole( ib2, ib1, ik2, 1:3, 1:3 ) &
                           &  = trm_quadrupole( ib2, ib1, ik2, 1:3, 1:3 ) &
                           &    +z1 *rquadrupole_val_core( lmt2, lmt1, 1:3, 1:3 )
                   End do
                End Do
!
                if ( sw_use_add_proj == ON ) then
                   Do lmt2=1, ilmt_add(it)
                      lmta2 = lmta_add(lmt2,ia)
                      wf2 = dcmplx( fsr_add_l( ib2, lmta2, ik ), &
                           &        fsi_add_l( ib2, lmta2, ik ) )

                      Do lmt1=1, nlmt_core
                         wf1 = wk_fsri(lmt1)
                         z1 = conjg(wf2) *wf1
                         trm_dipole( ib2, ib1, ik2, 1:3 ) &
                              &  = trm_dipole( ib2, ib1, ik2, 1:3 ) &
                              &    + z1 *rdipole_val_core( lmt2+nlmt, lmt1, 1:3 )
                         trm_quadrupole( ib2, ib1, ik2, 1:3, 1:3 )&
                              &  = trm_quadrupole( ib2, ib1, ik2, 1:3, 1:3 ) &
                              &    + z1 *rquadrupole_val_core( lmt2+nlmt, lmt1, 1:3, 1:3 )
                      End do
                   End Do
                endif
                   
             End Do
          End DO
       End Do
    End Do
    deallocate( wk_fsri )
  end subroutine m_CLS_calc_transmom_ek

  subroutine m_CLS_calc_spectr_fn_l( nstep, evec, kvec, scissor, way_BZ_int, &
       &                             occup_l_ek, ene, e_step, width, spectrum_type )
    integer, intent(in) :: nstep, way_BZ_int, spectrum_type
    real(kind=DP), intent(in) :: evec(3), kvec(3), scissor, ene(nstep), e_step, width
    real(kind=DP), intent(in) :: occup_l_ek(neg,kv3_ek)

    integer :: i, ik, jk, iopr, trev
    integer :: ib1, ib2, is, ixyz1, ixyz2, ierr
    real(kind=DP) :: evec_rotated(3), kvec_rotated(3), weight
    real(kind=DP) :: ediff, odiff, occ1, occ2, txyz(3)
    real(kind=DP) :: Delta03 = 1.0D-3

    complex(kind=CMPLDP) :: zrho1, zrho2
    real(kind=DP) :: trm2_E1_E1, trm2_E2_E2, trm2_E1_E2
    real(kind=DP), allocatable :: work(:)
    real(kind=DP), allocatable :: spectr_E1_E1(:), spectr_E2_E2(:), spectr_E1_E2(:)

    real*8 :: fac1, fac2, wavenum_xray

    allocate( spectr_E1_E1(nstep) ); spectr_E1_E1 = 0.0d0
    allocate( spectr_E2_E2(nstep) ); spectr_E2_E2 = 0.0d0
    allocate( spectr_E1_E2(nstep) ); spectr_E1_E2 = 0.0d0

    Do ib1=1, num_core_states

       Do ik=1, kv3_ek, ndim_spinor
          weight = kv3_ek *qwgt_ek(ik) /dble(ndim_spinor)

          Do i=1, num_star_of_k(ik)
             jk = star_of_k(ik,i)
             iopr = iopr_k_fbz_to_ibz(jk)
             trev = trev_k_fbz_to_ibz(jk)
             
             evec_rotated = matmul( op(:,:,iopr), evec(:) )
             kvec_rotated = matmul( op(:,:,iopr), kvec(:) )
             if ( trev == 1 ) then
                evec_rotated = -evec_rotated
                kvec_rotated = -kvec_rotated
             endif

             txyz(1:3) = tau(1:3,iopr,BUCS)*PAI2

             Do ib2=ista_e, iend_e, istep_e
                occ2 = occup_l_ek(map_z(ib2),ik) /weight
                if ( 1.0D0 -occ2 < Delta03 ) cycle

!             if ( eko_ek(ib2,ik) < efermi ) cycle

                odiff = 1.0d0 -occ2

                ediff = eko_ek(ib2,ik) +scissor -ene_core_states(ib1)
                wavenum_xray = ediff /InvHyperFineConst
                fac1 = wavenum_xray /2.0d0
                fac2 = fac1 *fac1

                zrho1 = 0.0d0;      zrho2 = 0.0d0
                Do is=1, ndim_spinor
                   Do ixyz1=1, 3
                      zrho1 = zrho1 &
                           & + trm_dipole( map_z(ib2), ib1, ik+is-1, ixyz1 ) &
                           &   *evec_rotated(ixyz1)
                   End Do
                   Do ixyz1=1, 3
                      Do ixyz2=1, 3
                         zrho2 = zrho2 &
                              & + trm_quadrupole( map_z(ib2), ib1, ik+is-1,ixyz1,ixyz2 ) &
                              &   *evec_rotated(ixyz1) *kvec_rotated(ixyz2)
                      End Do
                   ENd Do
                End do

                zrho2 = zrho2 *zi

                trm2_E1_E1 = conjg( zrho1 ) *zrho1
                trm2_E2_E2 = conjg( zrho2 ) *zrho2 *fac2
                trm2_E1_E2 = ( conjg( zrho1  ) *zrho2 &
                     &         +conjg( zrho2  ) *zrho1 ) *fac1


                call add_spectral_function( ediff, odiff, trm2_E1_E1, &
                     &                      way_BZ_int, ene, e_step, width, &
                     &                      nstep, Spectr_E1_E1 )
                call add_spectral_function( ediff, odiff, trm2_E2_E2, &
                     &                      way_BZ_int, ene, e_step, width, &
                     &                      nstep, Spectr_E2_E2 )
                call add_spectral_function( ediff, odiff, trm2_E1_E2, &
                     &                      way_BZ_int, ene, e_step, width, &
                     &                      nstep, Spectr_E1_E2 )
             End do
          End Do
       End do
    End Do

    if ( npes > 1 ) then
       allocate( work(nstep ) ); work = 0.0d0
       call mpi_allreduce( Spectr_E1_E1, work, nstep, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       Spectr_E1_E1 = work

       work = 0.0d0
       call mpi_allreduce( Spectr_E2_E2, work, nstep, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       Spectr_E2_E2 = work

       work = 0.0d0
       call mpi_allreduce( Spectr_E1_E2, work, nstep, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       Spectr_E1_E2 = work
       deallocate( work )
    endif

    fac1 = PAI4 *PAI              ! latter : i pi delta

    Spectr_E1_E1 = Spectr_E1_E1 /dble(kv3_fbz/nspin) /univol *fac1
    Spectr_E2_E2 = Spectr_E2_E2 /dble(kv3_fbz/nspin) /univol *fac1
    Spectr_E1_E2 = Spectr_E1_E2 /dble(kv3_fbz/nspin) /univol *fac1
    if ( nspin == 1 ) then
       Spectr_E1_E1 = Spectr_E1_E1 *2.0d0
       Spectr_E2_E2 = Spectr_E2_E2 *2.0d0
       Spectr_E1_E2 = Spectr_E1_E2 *2.0d0
    endif

    if ( qnum_l_to_probe > 0 .and. mimic_soc_split_spectrum ) then
       if ( ene_initial_state_splitting /= 0.0d0 ) then
          allocate( work(nstep ) );
          work = 0.0d0
          call split_spectr_by_spinorb_real( nstep, e_step, Spectr_E1_E1, work )
          Spectr_E1_E1 = work

          work = 0.0d0
          call split_spectr_by_spinorb_real( nstep, e_step, Spectr_E2_E2, work )
          Spectr_E2_E2 = work

          work = 0.0d0
          call split_spectr_by_spinorb_real( nstep, e_step, Spectr_E1_E2, work )
          Spectr_E1_E2 = work
       endif
    end if

    if ( mype == 0 ) then
       call m_Files_open_nfeps( "E1_E1" )
       call write_data( nfepsout, nstep, ene, Spectr_E1_E1, "dipole-dipole" )
       call m_Files_close_nfeps

       call m_Files_open_nfeps( "E2_E2" )
       call write_data( nfepsout, nstep, ene, Spectr_E2_E2, &
            &           "quadrupole-quadrupole" )
       call m_Files_close_nfeps

       call m_Files_open_nfeps( "E1_E2" )
       call write_data( nfepsout, nstep, ene, Spectr_E1_E2, &
            &           "dipole-quadrupole" )
       call m_Files_close_nfeps
    endif

    deallocate( Spectr_E1_E1 ); deallocate( Spectr_E2_E2 ); deallocate( Spectr_E1_E2 )

  contains

    subroutine write_data( lun, nstep, e, spectr_in, word )
      integer, intent(in) :: lun, nstep
      real(kind=DP), intent(in) :: e(nstep)
      real(kind=DP), intent(in) :: spectr_in(nstep)
      character*(*), intent(in) :: word

      integer :: istep
      real(kind=DP) :: ene

      write(lun,'(A,A,A)') "# Core level spectrum ( ", trim(word), " )"
      write(lun,'(A,I4,A,I2,A,I2)') "#  atom:", atom_to_probe, &
           &                  ", orbital: n = ", qnum_n_to_probe, &
           &                           ", l =", qnum_l_to_probe
      write(lun,'(A)') "#"
      write(lun,'(A,3F10.5)') "# Polarization: ", evec(1:3)
      write(lun,'(A,3F10.5)') "# Wave vector : ", kvec(1:3)
      write(lun,'(A)') "#"
      write(lun,'(A)') "#    Energy [eV]      spectrum "
      write(lun,'(A)') "#"

      select case (spectrum_type)
      case (MacroDielectric)         ! epsilon
         Do istep=1, nstep
            ene = e(istep)
            write(lun,'(E18.10,E18.10E2)') ene*Hartree_in_eV, &
                 &                         spectr_in(istep)
         End Do
      case (PACS)         ! cross section
         Do istep=1, nstep
            ene = e(istep)
            write(lun,'(E18.10,E18.10E2)') ene*Hartree_in_eV, &
                 &                         spectr_in(istep) &
                 &                             *ene /InvHyperFineConst *univol
         End Do
      end select
    end subroutine write_data

  end subroutine m_CLS_calc_spectr_fn_l

  subroutine m_CLS_calc_spectr_fn_c( nstep, evec, evec2, kvec, scissor, way_BZ_int, &
       &                             occup_l_ek, ene, e_step, width, spectrum_type )
    integer, intent(in) :: nstep, way_BZ_int, spectrum_type
    real(kind=DP), intent(in) :: evec(3), kvec(3), scissor, ene(nstep), e_step, width
    real(kind=DP), intent(in) :: occup_l_ek(neg,kv3_ek)
    real(kind=DP), intent(in) :: evec2(3)

    integer :: i, ik, jk, iopr, trev
    integer :: ib1, ib2, is, ixyz1, ixyz2, ierr
    real(kind=DP) :: evec_rotated(3), kvec_rotated(3), weight
    real(kind=DP) :: evec2_rotated(3)
    real(kind=DP) :: ediff, odiff, occ1, occ2, txyz(3)
    real(kind=DP) :: Delta03 = 1.0D-3

    complex(kind=CMPLDP) :: zrho1p, zrho2p
    complex(kind=CMPLDP) :: zrho1m, zrho2m
    real(kind=DP) :: trm2p_E1_E1, trm2p_E2_E2, trm2p_E1_E2
    real(kind=DP) :: trm2m_E1_E1, trm2m_E2_E2, trm2m_E1_E2

    real(kind=DP), allocatable :: work(:,:)
    real(kind=DP), allocatable :: spectr_E1_E1(:,:), spectr_E2_E2(:,:), spectr_E1_E2(:,:)

    real*8 :: fac1, fac2, wavenum_xray

    allocate( spectr_E1_E1(nstep,2) ); spectr_E1_E1 = 0.0d0
    allocate( spectr_E2_E2(nstep,2) ); spectr_E2_E2 = 0.0d0
    allocate( spectr_E1_E2(nstep,2) ); spectr_E1_E2 = 0.0d0

    Do ib1=1, num_core_states
       Do ik=1, kv3_ek, ndim_spinor
          weight = kv3_ek *qwgt_ek(ik) /dble(ndim_spinor)
          
          Do i=1, num_star_of_k(ik)
             jk = star_of_k(ik,i)
             iopr = iopr_k_fbz_to_ibz(jk)
             trev = trev_k_fbz_to_ibz(jk)
             
             kvec_rotated = matmul( op(:,:,iopr), kvec(:) )
             evec_rotated = matmul( op(:,:,iopr), evec(:) )
             evec2_rotated = matmul( op(:,:,iopr), evec2(:) )
             if ( noncol .and. magmom_dir_inversion_opr_flag(iopr) == -1 ) then
                evec2_rotated = -evec2_rotated
             endif
             
             if ( trev == 1 ) then
                kvec_rotated = -kvec_rotated
                evec_rotated = -evec_rotated
                evec2_rotated = -evec2_rotated
             endif
             
             txyz(1:3) = tau(1:3,iopr,BUCS)*PAI2
             
             Do ib2=ista_e, iend_e, istep_e
                occ2 = occup_l_ek(map_z(ib2),ik) /weight
                if ( 1.0D0 -occ2 < Delta03 ) cycle
!             if ( eko_ek(ib2,ik) < efermi ) cycle

                odiff = 1.0d0 -occ2

                ediff = eko_ek(ib2,ik) +scissor -ene_core_states(ib1)
                wavenum_xray = ediff /InvHyperFineConst
                fac1 = wavenum_xray /2.0d0
                fac2 = fac1 *fac1

                zrho1p = 0.0d0;      zrho2p = 0.0d0
                zrho1m = 0.0d0;      zrho2m = 0.0d0
                Do is=1, ndim_spinor
                   Do ixyz1=1, 3
                      zrho1p  = zrho1p &
                           & + trm_dipole( map_z(ib2), ib1, ik+is-1, ixyz1 ) &
                           &   *( evec_rotated(ixyz1) +zi*evec2_rotated(ixyz1) )
                      zrho1m = zrho1m &
                           & + trm_dipole( map_z(ib2), ib1, ik+is-1, ixyz1 ) &
                           &   *( evec_rotated(ixyz1) -zi*evec2_rotated(ixyz1) )
                   End Do
                   Do ixyz1=1, 3
                      Do ixyz2=1, 3
                         zrho2p = zrho2p &
                              & + trm_quadrupole( map_z(ib2),ib1,ik+is-1,ixyz1,ixyz2 ) &
                              &   *(evec_rotated(ixyz1) +zi*evec2_rotated(ixyz1) ) &
                              &   *kvec_rotated(ixyz2)
                         zrho2m = zrho2m &
                              & + trm_quadrupole( map_z(ib2),ib1,ik+is-1,ixyz1,ixyz2 ) &
                              &   *(evec_rotated(ixyz1) -zi*evec2_rotated(ixyz1) ) &
                              &   *kvec_rotated(ixyz2)
                      End Do
                   ENd Do
                End do

                zrho2p = zrho2p *zi
                zrho2m = zrho2m *zi

                trm2p_E1_E1 = conjg( zrho1p ) *zrho1p/2.0d0
                trm2p_E2_E2 = conjg( zrho2p ) *zrho2p *fac2 /2.0d0
                trm2p_E1_E2 = ( conjg( zrho2p ) *zrho1p  &
                     &         +conjg( zrho1p ) *zrho2p ) *fac1 /2.0d0

                trm2m_E1_E1 = conjg( zrho1m ) *zrho1m /2.0d0
                trm2m_E2_E2 = conjg( zrho2m ) *zrho2m *fac2 /2.0d0
                trm2m_E1_E2 = ( conjg( zrho1m  ) *zrho2m &
                     &         +conjg( zrho2m  ) *zrho1m ) *fac1 /2.0d0

                call add_spectral_function( ediff, odiff, trm2m_E1_E1, way_BZ_int, &
                     &                      ene, e_step, width, &
                     &                      nstep, Spectr_E1_E1(:,1) )
                call add_spectral_function( ediff, odiff, trm2p_E1_E1, way_BZ_int, &
                     &                      ene, e_step, width, &
                     &                      nstep, Spectr_E1_E1(:,2) )

                call add_spectral_function( ediff, odiff, trm2m_E2_E2, way_BZ_int,&
                     &                      ene, e_step, width, &
                     &                      nstep, Spectr_E2_E2(:,1) )
                call add_spectral_function( ediff, odiff, trm2p_E2_E2, way_BZ_int,&
                     &                      ene, e_step, width, &
                     &                      nstep, Spectr_E2_E2(:,2) )

                call add_spectral_function( ediff, odiff, trm2m_E1_E2, way_BZ_int,&
                     &                      ene, e_step, width, &
                     &                      nstep, Spectr_E1_E2(:,1) )
                call add_spectral_function( ediff, odiff, trm2p_E1_E2, way_BZ_int,&
                     &                      ene, e_step, width, &
                     &                      nstep, Spectr_E1_E2(:,2) )
             End do
          End Do
       End do
    End Do

    if ( npes > 1 ) then
       allocate( work(nstep,2) ); work = 0.0d0
       call mpi_allreduce( Spectr_E1_E1, work, nstep*2, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       Spectr_E1_E1 = work

       work = 0.0d0
       call mpi_allreduce( Spectr_E2_E2, work, nstep*2, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       Spectr_E2_E2 = work

       work = 0.0d0
       call mpi_allreduce( Spectr_E1_E2, work, nstep*2, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       Spectr_E1_E2 = work
       deallocate( work )
    endif

    fac1 = PAI4 *PAI              ! latter : i pi delta

    Spectr_E1_E1 = Spectr_E1_E1 /dble(kv3_fbz/nspin) /univol *fac1
    Spectr_E2_E2 = Spectr_E2_E2 /dble(kv3_fbz/nspin) /univol *fac1
    Spectr_E1_E2 = Spectr_E1_E2 /dble(kv3_fbz/nspin) /univol *fac1
    if ( nspin == 1 ) then
       Spectr_E1_E1 = Spectr_E1_E1 *2.0d0
       Spectr_E2_E2 = Spectr_E2_E2 *2.0d0
       Spectr_E1_E2 = Spectr_E1_E2 *2.0d0
    endif

    if ( qnum_l_to_probe > 0 .and. mimic_soc_split_spectrum ) then
       if ( ene_initial_state_splitting /= 0.0d0 ) then
          allocate( work(nstep,2) );
          work = 0.0d0
          call split_spectr_by_spinorb_real( nstep, e_step, Spectr_E1_E1(:,1),work(:,1))
          call split_spectr_by_spinorb_real( nstep, e_step, Spectr_E1_E1(:,2),work(:,2))
          Spectr_E1_E1 = work

          work = 0.0d0
          call split_spectr_by_spinorb_real( nstep, e_step, Spectr_E2_E2(:,1),work(:,1))
          call split_spectr_by_spinorb_real( nstep, e_step, Spectr_E2_E2(:,2),work(:,2))
          Spectr_E2_E2 = work

          work = 0.0d0
          call split_spectr_by_spinorb_real( nstep, e_step, Spectr_E1_E2(:,1),work(:,1))
          call split_spectr_by_spinorb_real( nstep, e_step, Spectr_E1_E2(:,2),work(:,2))
          Spectr_E1_E2 = work
       endif
    end if

    if ( mype == 0 ) then
       call m_Files_open_nfeps( "E1_E1" )
       call write_data( nfepsout, nstep, ene, Spectr_E1_E1, "dipole-dipole" )
       call m_Files_close_nfeps

       call m_Files_open_nfeps( "E2_E2" )
       call write_data( nfepsout, nstep, ene, Spectr_E2_E2, &
            &           "quadrupole-quadrupole" )
       call m_Files_close_nfeps

       call m_Files_open_nfeps( "E1_E2" )
       call write_data( nfepsout, nstep, ene, Spectr_E1_E2, &
            &           "dipole-quadrupole" )
       call m_Files_close_nfeps
    endif

    deallocate( Spectr_E1_E1 ); deallocate( Spectr_E2_E2 ); deallocate( Spectr_E1_E2 )

  contains

    subroutine write_data( lun, nstep, e, spectr_in, word )
      integer, intent(in) :: lun, nstep
      real(kind=DP), intent(in) :: e(nstep)
      real(kind=DP), intent(in) :: spectr_in(nstep,2)
      character*(*), intent(in) :: word

      integer :: istep
      real(kind=DP) :: ene, c1

      write(lun,'(A,A,A)') "# Core level spectrum ( ", trim(word), " )"
      write(lun,'(A,I4,A,I2,A,I2)') "#  atom:", atom_to_probe, &
           &                  ", orbital: n = ", qnum_n_to_probe, &
           &                           ", l =", qnum_l_to_probe
      write(lun,'(A)') "#"
      write(lun,'(A,3F10.5)') "# Wave vector : ", kvec(1:3)
      write(lun,'(A)') "#"
      write(lun,'(A)') "#    Energy [eV]      spectrum (left,-)     (right,+)      (CD)"
      write(lun,'(A)') "#"

      select case (spectrum_type)
      case (MacroDielectric)         ! epsilon
         Do istep=1, nstep
            ene = e(istep)
            write(lun,'(E18.10,3E18.10E2)') ene*Hartree_in_eV, &
                 &                         spectr_in(istep,1:2), &
                 &                         spectr_in(istep,2) -spectr_in(istep,1)
         End Do
      case (PACS)         ! cross section
         Do istep=1, nstep
            ene = e(istep)
            c1 = ene /InvHyperFineConst *univol
            write(lun,'(E18.10,3E18.10E2)') ene*Hartree_in_eV, &
                 &                          c1 *spectr_in(istep,1:2), &
                 &                          c1 *(spectr_in(istep,2)-spectr_in(istep,1))
         End Do
      end select
    end subroutine write_data

  end subroutine m_CLS_calc_spectr_fn_c

  subroutine split_spectr_by_spinorb_real( nstep, e_step, spectr_in, spectr_out )
    integer, intent(in) :: nstep
    real(kind=DP), intent(in) :: e_step
    real(kind=DP), intent(in) :: spectr_in(nstep)
    real(kind=DP), intent(out) :: spectr_out(nstep)

    integer :: ngeta, istep, jstep
    real(kind=DP) :: c1, c2

    ngeta = nint( ene_initial_state_splitting /e_step )
    c1 = qnum_l_to_probe /( 2.0d0*qnum_l_to_probe +1.0d0 )
    c2 = 1.0d0 -c1

    spectr_out(:) = 0.0d0
    Do istep=1, nstep
       spectr_out(istep) = spectr_out(istep) + c2 *spectr_in(istep)
       jstep = istep +ngeta
       if ( jstep <=nstep ) then
          spectr_out(jstep) = spectr_out(jstep) + c1 *spectr_in(istep)
       endif
    End Do
  end subroutine split_spectr_by_spinorb_real

  subroutine add_spectral_function( e_center, weight, trm2, way_BZ_int, &
       &                            e, e_step, width, nstep, SpectrFn )
    integer, intent(in) :: nstep, way_BZ_int
    real(kind=DP), intent(in) :: e_center, weight, e_step, width
    real(kind=DP), intent(in) :: e(nstep)
    real(kind=DP), intent(in) :: trm2
    real(kind=DP), intent(inout) :: SpectrFn( nstep )

    real(kind=DP) :: e_low
    real(kind=DP) :: gaussian_extent = 4.0d0

    e_low = e(1)
    select case (way_BZ_int)
    case (PARABOLIC_B)
       call Parabolic_broadening      
!       stop "Does not work"
    case (L_TETRAHEDRON)
       stop "Does not work"
    case (GAUSSIAN_B)
       call Gaussian_broadening
    case (LORENTZIAN_B)
       call Lorentzian_broadening
    end select

  contains

    subroutine Parabolic_broadening      
      integer :: i
      real(kind=DP) :: c2, ctmp

      Do i=1, nstep
         call width2( e(i), e_center, width, c2, ctmp )
         SpectrFn(i) = SpectrFn(i) +weight *trm2 *c2
      End do
      
    end subroutine Parabolic_broadening

    subroutine Gaussian_broadening           ! width == sqrt(2)*sigma,
      integer :: istart, iend, i
      real(kind=DP) :: sigma, sig2, c1, c2, c3, e_min, e_max, e0

      sigma = width /sqrt(2.0d0)
      e0 = e_center -e_low
      e_min = e0 -sigma *gaussian_extent;
      e_max = e0 +sigma *gaussian_extent
      istart = nint( e_min /e_step ) +1;  iend = nint( e_max /e_step ) +1

      istart = max( 1, istart );      istart = min( nstep, istart )
      iend   = min( nstep, iend );    iend   = max( 1, iend )

      sig2 = sigma**2;   c1 = sqrt( PAI2 *sig2 )
      Do i=istart, iend
         c2 = ( e(i) -e_center )**2 /sig2 /2.0d0
         c3 = exp( -c2 ) /c1
         SpectrFn(i) = SpectrFn(i) +weight *trm2 *c3
      End do
      
    end subroutine Gaussian_broadening

    subroutine Lorentzian_broadening
      integer :: i
      real(kind=DP) :: e0, c1, c2, c3, eta
      
      eta = width /2.0d0
      !
      c3 = eta /PAI
!      e0 = e_center -e_low
      e0 = e_center

      Do i=1, nstep
         c1 = ( e(i) -e0 )**2 + eta**2
         c2 = c3 /c1
         SpectrFn(i) = SpectrFn(i) +weight *trm2 *c2
      End do
    end subroutine Lorentzian_broadening
    
  end subroutine add_spectral_function

  subroutine m_CLS_alloc_dipquad
    integer :: nlmt_val
    
    if ( sw_use_add_proj == ON ) then
       nlmt_val = nlmt +nlmt_add
    else
       nlmt_val = nlmt
    endif

    allocate( rdipole_val_core( nlmt_val, 2*qnum_l_to_probe+1, 3 ) )
    allocate( rquadrupole_val_core( nlmt_val, 2*qnum_l_to_probe+1,3,3) )
    rdipole_val_core = 0.0d0;   rquadrupole_val_core = 0.0d0;  

  end subroutine m_CLS_alloc_dipquad

  subroutine m_CLS_dealloc_dipquad
    deallocate( rdipole_val_core )
    deallocate( rquadrupole_val_core )
  end subroutine m_CLS_dealloc_dipquad

  subroutine m_CLS_set_dipquad_elements
    integer :: orb_index, it, ilt1, il1, tau1, ir, ierr
    integer :: ilmt2, il2, im2, tau2, nsph_core, nsph_val, im1
    real(kind=DP) :: c1, c2, ctmp
    real(kind=DP), allocatable :: RadIntegral_order(:,:,:), wos(:)
!
    call set_rhat_cylm
    call set_rhat_rylm
    call set_rhat2_rylm
!
    orb_index = m_CLS_find_orb_index_to_probe()
    it = ityp( atom_to_probe )
    allocate( RadIntegral_order(2,nloc,ntau) )
    allocate( wos(mmesh) )
    call set_weight_exp( ierr, 1, nmesh(it), radr_paw(:,it), wos )

    Do il1=1, lpsmax(it)
       Do tau1=1, itau(il1,it)
          c1 = 0.0d0;  c2 = 0.0d0
          Do ir=1, nmesh(it)
             ctmp = psir_core_ae_wfns(ir,orb_index) *psirpw(ir,il1,tau1,it)
             c1 = c1 +wos(ir) *ctmp *radr_paw(ir,it)
             c2 = c2 +wos(ir) *ctmp *radr_paw(ir,it)**2
          End do
          RadIntegral_order(1,il1,tau1) = c1
          RadIntegral_order(2,il1,tau1) = c2
       End Do
    End Do
          
    Do im1=1, 2*qnum_l_to_probe +1
       nsph_core = qnum_l_to_probe**2 +im1
       Do ilmt2=1, ilmt(it)        ! valence
          il2=ltp(ilmt2,it);  im2=mtp(ilmt2,it);   tau2=taup(ilmt2,it)
          nsph_val = (il2 -1)**2 +im2
          rdipole_val_core(ilmt2,im1,1:3) = RadIntegral_order(1,il2,tau2) &
               &               *rhat_rylm(nsph_val,nsph_core,1:3)
          rquadrupole_val_core(ilmt2,im1,1:3,1:3) = RadIntegral_order(2,il2,tau2) &
               &               *rhat2_rylm(nsph_val,nsph_core,1:3,1:3)
       End do
       if ( sw_use_add_proj == ON ) then
          Do ilmt2=1, ilmt_add(it)  
             il2=ltp_add(ilmt2,it);  im2=mtp_add(ilmt2,it);   tau2=1
             nsph_val = (il2 -1)**2 +im2
             rdipole_val_core(nlmt+ilmt2,im1,1:3) &
                  &              = RadIntegral_order(1,il2,tau2) &
                  &                 *rhat_rylm(nsph_val,nsph_core,1:3)
             rquadrupole_val_core(nlmt+ilmt2,im1,1:3,1:3) &
                  &              = RadIntegral_order(2,il2,tau2) &
                  &                 *rhat2_rylm(nsph_val,nsph_core,1:3,1:3)
          End do
       endif
    End Do

    deallocate( RadIntegral_order )
    deallocate( wos )
  end subroutine m_CLS_set_dipquad_elements

  subroutine set_rhat2_rylm
    integer :: ixyz1, ixyz2, i, j, k
    real(kind=DP) :: csum

    Do ixyz2=1, 3
       Do ixyz1=1, 3
          Do i=1, nsph_max
             Do j=1, nsph_max
                csum = 0.0d0
                Do k=1, nsph_max
                   csum = csum +rhat_rylm(i,k,ixyz1)*rhat_rylm(k,j,ixyz2)
                End Do
                rhat2_rylm(i,j,ixyz1,ixyz2) = csum
             End Do
          End Do
       ENd Do
    End Do
  end subroutine set_rhat2_rylm

  subroutine set_rhat_cylm         ! rhat = x^, y^, z^ ( x^=x/r )
    integer :: il, im, nsph1, nsph2, nsph3, ind1, ind2
    real(kind=DP) :: c1, c2, a1, a2, a3, a4, a5, a6
    integer :: get_nspher_cylm

    rhat_cylm = 0.0d0

    Do il=0, lmax
       c1 = (2*il+1)*(2*il+3)
       c2 = 0.0d0
       if ( il > 0 ) c2 = (2*il-1)*(2*il+1)

       Do im=-il, il
          nsph1 = get_nspher_cylm( il, im )

          if ( abs(im+1) <= il+1 ) then
             a1 =  -sqrt( (il+im+1)*(il+im+2)/c1 )
             nsph2 = get_nspher_cylm( il+1, im+1 )
             if ( nsph2 <= nsph_max ) then
                rhat_cylm(nsph2,nsph1,1) = a1 /2.0d0
                rhat_cylm(nsph2,nsph1,2) = -a1 /2.0d0 *zi
             endif
          endif

          if ( abs(im+1) <= il-1 ) then
             a2 = sqrt( (il-im-1)*(il-im)/c2 )
             nsph2 = get_nspher_cylm( il-1, im+1 )
             if ( nsph2 <= nsph_max ) then
                rhat_cylm(nsph2,nsph1,1) = a2 /2.0d0
                rhat_cylm(nsph2,nsph1,2) = -a2 /2.0d0 *zi
             endif
          endif

          if ( abs(im-1) <= il+1 ) then
             a3 =  sqrt( (il-im+1)*(il-im+2)/c1 )
             nsph2 = get_nspher_cylm( il+1, im-1 )
             if ( nsph2 <= nsph_max ) then
                rhat_cylm(nsph2,nsph1,1) = a3 /2.0d0
                rhat_cylm(nsph2,nsph1,2) = a3 /2.0d0 *zi
             endif
          endif

          if ( abs(im-1) <= il-1 ) then
             a4 =  -sqrt( (il+im-1)*(il+im)/c2 )
             nsph2 = get_nspher_cylm( il-1, im-1 )
             if ( nsph2 <= nsph_max ) then
                rhat_cylm(nsph2,nsph1,1) = a4 /2.0d0
                rhat_cylm(nsph2,nsph1,2) = a4 /2.0d0 *zi
             endif
          endif

          if ( abs(im) <= il+1 ) then
             a5 =  sqrt( (il-im+1)*(il+im+1)/c1 )
             nsph2 = get_nspher_cylm( il+1, im )
             if ( nsph2 <= nsph_max ) then
                rhat_cylm(nsph2,nsph1,3) = a5
             endif
          endif

          if ( abs(im) <= il-1 ) then
             a6 =  sqrt( (il-im)*(il+im)/c2 )
             nsph2 = get_nspher_cylm( il-1, im )
             if ( nsph2 <= nsph_max ) then
                rhat_cylm(nsph2,nsph1,3) = a6
             endif
          endif

       End Do
    End Do
  end subroutine set_rhat_cylm

  subroutine set_rhat_rylm
    integer :: il1, il2, im1, im2, im3, im4, ind1, ind2
    integer :: nsph3, nsph4
    integer :: get_nspher_cylm
!    external :: get_nspher_cylm

    complex(kind=CMPLDP) :: zsum(3), ztmp1, ztmp2

    Do il1=0, lmax
       Do im1=1, 2*il1 +1
          ind1 = il1**2 +im1
          
          Do il2=0, lmax
             Do im2=1, 2*il2 +1
                ind2 = il2**2 +im2
                zsum = 0.0d0
                
                Do im3=-il1, il1
                   if ( il1 == 0 ) then
                      ztmp1 = MatU_ylm_RC_L0(im1,im3)
                   else if ( il1 == 1  ) then
                      ztmp1 = MatU_ylm_RC_L1(im1,im3)
                   else if ( il1 == 2  ) then
                      ztmp1 = MatU_ylm_RC_L2(im1,im3)
                   else if ( il1 == 3  ) then
                      ztmp1 = MatU_ylm_RC_L3(im1,im3)
                   else if ( il1 == 4  ) then
                      ztmp1 = MatU_ylm_RC_L4(im1,im3)
                   endif
                   
                   Do im4=-il2, il2
                      if ( il2 == 0 ) then
                         ztmp2 = MatU_ylm_RC_L0(im2,im4)
                      else if ( il2 == 1  ) then
                         ztmp2 = MatU_ylm_RC_L1(im2,im4)
                      else if ( il2 == 2  ) then
                         ztmp2 = MatU_ylm_RC_L2(im2,im4)
                      else if ( il2 == 3  ) then
                         ztmp2 = MatU_ylm_RC_L3(im2,im4)
                      else if ( il2 == 4  ) then
                         ztmp2 = MatU_ylm_RC_L4(im2,im4)
                      endif

                      nsph3 = get_nspher_cylm( il1, im3 )
                      nsph4 = get_nspher_cylm( il2, im4 )

                      zsum(1) = zsum(1) +ztmp1 *rhat_cylm(nsph3,nsph4,1) *conjg(ztmp2)
                      zsum(2) = zsum(2) +ztmp1 *rhat_cylm(nsph3,nsph4,2) *conjg(ztmp2)
                      zsum(3) = zsum(3) +ztmp1 *rhat_cylm(nsph3,nsph4,3) *conjg(ztmp2)
                   End Do
                ENd Do
                rhat_rylm(ind1,ind2,1:3) = zsum(1:3)
             End Do
          End Do
       End Do
    End Do
  end subroutine set_rhat_rylm

  integer function get_unused_unitnumber()
    integer :: i
    logical :: op
    do i=500,9999
      inquire(unit=i,opened=op)
      if( .not.op ) then
        get_unused_unitnumber = i
        return
      endif
    enddo
    stop '  insufficient file handle'
  end function get_unused_unitnumber

end module m_CLS_dipquad

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 593 $)
!
!  SUBROUINE: constrained_dynamics
!
!  AUTHOR(S): J. Koga March/24/2009 
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!***************************************************************

! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
!!!!!BRANCH_P ORG_Parallel
#ifndef DISABLE_CONSTRAINTS
! ==============================================================================
subroutine constrained_dynamics()
  use m_velocity_verlet, only : m_vv_increment_md_step, m_vv_do_dynamics, &
   &  m_vv_get_curr_md_step
  use m_constraints, only : &
   &  m_cnstr_get_n_reac_coords, m_cnstr_set_reac_coord, &
   &  m_cnstr_get_reac_coords_s
  use m_Control_Parameters, only : printable, icond, icond_org
  use m_Files, only : nfout
  use m_Parallelization, only : nrank_conf, mype_conf, conf_para
  use m_Const_Parameters, only : STREVL_ITERATION,REAC_ITERATION
  use m_PseudoPotential, only : mmesh
  use m_Ionic_System,    only : natm
  use m_Parallelization, only : m_Parallel_init_mpi_paw_3D

  implicit none

  include 'mpif.h'

  integer :: stat
  integer :: ireac,istart,ierr
  logical :: initialization_required
  
  call Preparation                          ! Basis set, symmetry check etc.
  call Preparation_for_mpi(1)     ! mpi
  call PseudoPotential_Construction
  call m_Parallel_init_mpi_paw_3D(nfout,natm,mmesh)
#ifdef ENABLE_ESM_PACK
  if(initialization_required())then
     call Preparation_for_ESM
  endif
#endif
  call Ewald_and_Structure_Factor
  call Initial_Electronic_Structure

  call Initial_MD_Condition()

  icond=icond_org

!!$  call constrained_dynamics_init(nfout)

  istart=m_cnstr_get_reac_coords_s()
  if(conf_para) istart=1
  reaction_coordinate: do ireac=istart,m_cnstr_get_n_reac_coords()
    if(conf_para.and.mod(ireac-1,nrank_conf)/=mype_conf) cycle reaction_coordinate
    if(m_cnstr_set_reac_coord(ireac)) cycle reaction_coordinate
    md_step: do while(m_vv_increment_md_step())
      if(printable) write(nfout,'(a,i7)') 'entering MD step no. ',m_vv_get_curr_md_step()
      stat=0
      call m_vv_do_dynamics(stat)
      if (stat==1) then ! relaxation converged
        call postproc_md_step(printable,nfout)
        exit md_step
      else if(stat==2)then ! end of program
        call postproc_reac_coord(stat)
        exit reaction_coordinate
      endif
      call postproc_md_step(printable,nfout)
      if(printable) write(nfout,'(a,i7)') 'done MD step no.     ',m_vv_get_curr_md_step()
      call Checkpoint_File(STREVL_ITERATION)
    enddo md_step
    call Stress()
    call postproc_reac_coord(stat)
    call Checkpoint_File(REAC_ITERATION)
  enddo reaction_coordinate

  call mpi_barrier(mpi_comm_world, ierr)

  call finalize()

end subroutine constrained_dynamics

subroutine postproc_md_step(printable,nfout)
  use m_constraints, only : m_cnstr_print_status
  use m_velocity_verlet, only : m_vv_io_per_step,m_vv_get_curr_md_step
  use m_Control_Parameters, only : postproc_frequency
  implicit none
  logical,intent(in) :: printable
  integer, intent(in) :: nfout
  if(printable) write(nfout,'(a)') 'doing post-proc for each MD step'
  call m_cnstr_print_status()
  call m_vv_io_per_step()
  if(postproc_frequency<=0) return
  if(mod(m_vv_get_curr_md_step(),postproc_frequency)==0)then
     call Postprocessing(.true.)
  endif
end subroutine postproc_md_step

subroutine postproc_reac_coord(stat)
  use m_constraints, only : m_cnstr_pp_reac_coords
  implicit none
  integer,intent(in) :: stat
  call m_cnstr_pp_reac_coords(stat)
end subroutine postproc_reac_coord

subroutine finalize()
  use m_routines, only : close_all_opened_files
  implicit none
  call scf_finalize()
  call constrained_dynamics_finalize()
  call close_all_opened_files()
end subroutine finalize

subroutine constrained_dynamics_dump()
  use m_Files, only : F_CNTN, nfcntn
  use m_Parallelization, only : mype
  use m_velocity_verlet, only : m_vv_wd_vv_variables
  use m_constraints, only : m_cnstr_wd_constraints
  implicit none
  if (mype/=0) return
  open(nfcntn,&
& file=F_CNTN,status='unknown',position='append')
  call m_vv_wd_vv_variables(nfcntn)
  call m_cnstr_wd_constraints(nfcntn)
  close(nfcntn)
end subroutine constrained_dynamics_dump

subroutine constrained_dynamics_finalize()
  use m_velocity_verlet, only : m_vv_finalize
  use m_constraints, only : m_cnstr_finalize
  use m_variables_for_atoms, only : m_vfa_dealloc
  implicit none
  call constrained_dynamics_dump()
  call m_vv_finalize()
  call m_cnstr_finalize()
  call m_vfa_dealloc()
end subroutine constrained_dynamics_finalize

subroutine constrained_dynamics_init(nfout)
  use m_variables_for_atoms, only : m_vfa_alloc_atoms
  use m_variables_for_dynamics, only : m_vfd_init
  use m_Files, only :  F_ZAJ_in, F_CNTN_in, F_CNTN_BIN_in, F_CHGT_in &
 &   , F_ZAJ,F_CNTN,F_CNTN_BIN,F_CHGT, nfinp, F_INP, nfcntn, open0
  use m_Const_Parameters, only : QUENCHED_MD, T_CONTROL, VERLET, DAMPED_MD, CONTINUATION, INITIAL &
 &   , formatted, check_file_name_on, old, ON, VELOCITY_SCALING
  use m_constraints, only : m_cnstr_constraints_exist, m_cnstr_initialize, &
 &      m_cnstr_parse_input, m_cnstr_rd_constraints, &
 &      F_ZAJ_org, F_CNTN_BIN_org, F_CNTN_org, F_CHGT_org
  use m_velocity_verlet, only : m_vv_init, m_vv_parse_input, &
 &      m_vv_rd_vv_variables
  use m_Parallelization, only : conf_para, sw_wdir, workdir
  use m_Control_Parameters, only: icond,imdalg,printable
  implicit none
  integer, intent(in) :: nfout
  integer ::  f_selectTop, f_selectBlock, f_openInputFile, f_closeInputFile
  integer :: iiret,i
  logical :: ex,op
  logical, allocatable, dimension(:) :: ltmp
  logical, allocatable, dimension(:) :: ltmp0
  character(len=2) :: cid
  character(len=2) :: cid_tmp
  integer :: mpierr
  integer :: ifile
  integer :: nline
  logical :: statfile_exists
  integer :: ireac
  logical :: fin

  include 'mpif.h'

  call m_vfa_alloc_atoms()
  call m_vfd_init()

  inquire(unit=nfinp,opened=op)
  if(op)close(nfinp,status='keep')
  if(sw_wdir == ON) then
    iiret = f_openInputFile(trim(workdir)//F_INP)
  else
    iiret = f_openInputFile(F_INP)
  end if
  if( iiret < 0) then
    if(printable) write(nfout,'(" !!! Error in opening of inputfile: ",a32)') F_INP
    stop
  else if(iiret > 0) then
    if(printable) write(nfout,'(" !!! There is something wrong in the input file: ",a32)') F_INP
  end if

  iiret = f_selectTop()
  iiret = f_selectBlock('structure')

  call m_cnstr_parse_input()
  if(m_cnstr_constraints_exist()) call m_cnstr_initialize()


  call m_vv_init()
  call m_vv_parse_input()

  iiret = f_selectTop()

  if(imdalg.ne.QUENCHED_MD.and. &
  &  imdalg.ne.T_CONTROL  .and. &
  &  imdalg.ne.VERLET     .and. &
  &  imdalg.ne.DAMPED_MD  .and. &
  &  imdalg.ne.VELOCITY_SCALING) then
    if(printable) write(nfout,'(a,i5,a)') '**WARN imdalg :      ',imdalg, &
                  ' not implemented (yet) for the constraints driver'
    if(printable) write(nfout,'(a,i5)')   '**WARN defaults to : ',QUENCHED_MD
    imdalg = QUENCHED_MD
    !!$stop
  endif

  F_ZAJ_org      = F_ZAJ_in
  F_CNTN_org     = F_CNTN_in
  F_CNTN_BIN_org = F_CNTN_BIN_in
  F_CHGT_org     = F_CHGT_in

!  iiret = f_closeInputFile()
  call open0(nfinp, F_INP, 'F_INP     ',    old,   formatted,check_file_name_on)

  if(icond==CONTINUATION .and. .not. conf_para)then
    call m_vv_rd_vv_variables(nfcntn,.true.)
    call m_cnstr_rd_constraints(nfcntn)
  endif

end subroutine constrained_dynamics_init

subroutine prepare_continuation_of_reac(nfcntn,sk)
  use m_Files, only : m_Files_reopen_nfcntn
  use m_Ionic_System, only : m_IS_rd_pos_and_v
  use m_velocity_verlet, only : m_vv_rd_vv_variables
  use m_constraints, only : m_cnstr_rd_constraints
  use m_IterationNumbers, only : m_Iter_rd_iteration_numbers
  use m_Total_Energy, only : m_TE_rd_total_energy
  use m_Control_Parameters, only : m_CtrlP_rd_isolver,icond
  implicit none
  integer, intent(in) :: nfcntn
  logical, intent(in) :: sk
  integer :: i
  call m_Files_reopen_nfcntn()
  if(.not.sk)then
  call m_TE_rd_total_energy(nfcntn)
  call m_CtrlP_rd_isolver(nfcntn)
  call m_Iter_rd_iteration_numbers(nfcntn,icond)
  endif
  call m_IS_rd_pos_and_v(nfcntn)
  call m_vv_rd_vv_variables(nfcntn,sk)
  call m_cnstr_rd_constraints(nfcntn)
end subroutine prepare_continuation_of_reac
! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
#endif
!!!!!BRANCH_P_END ORG_Parallel
! ==============================================================================

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 570 $)
!
!  SUBROUINE: meta_dynamics, init_mtd
!
!  AUTHOR(S): J. Koga 2010
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!***************************************************************

! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
! ==============================================================================
#ifndef DISABLE_CONSTRAINTS
subroutine meta_dynamics()
  use m_velocity_verlet, only : m_vv_increment_md_step, m_vv_do_dynamics, m_vv_get_curr_md_step
  use m_meta_dynamics, only : m_mtd_update_bias, m_mtd_finalize
  use m_Const_Parameters, only : CONTINUATION
  use m_Control_Parameters, only : printable,icond
  use m_Files, only : nfout, F_CNTN, F_CNTN_BIN,F_CHGT,F_ZAJ,F_CNTN_bak,F_CNTN_BIN_bak,F_CHGT_bak,F_ZAJ_bak &
 &                  , F_CNTN_in, F_CNTN_BIN_in, F_CHGT_in, F_ZAJ_in &
 &                  , file_existance_contfiles, file_existance_3contfiles &
 &                  , m_Files_reopen_nfcntn, m_Files_reopen_nfcntn_bin, m_Files_reopen_nfzaj, m_Files_reopen_nfchgt
  use m_Parallelization, only : mype_conf,mpi_comm_group
#ifdef PAW3D
  use m_PseudoPotential, only : mmesh
  use m_Ionic_System,    only : natm
  use m_Parallelization, only : m_Parallel_init_mpi_paw_3D
#endif

  implicit none

  include 'mpif.h'

  integer :: stat, ierr
  character(len=256) :: to_string
  logical :: initialization_required

  call Preparation                          ! Basis set, symmetry check etc.
  call Preparation_for_mpi(1)     ! mpi
  call init_mtd()
  call PseudoPotential_Construction
#ifdef PAW3D
  call  m_Parallel_init_mpi_paw_3D(nfout,natm,mmesh)
#endif
#ifdef ENABLE_ESM_PACK
  if(initialization_required())then
     call Preparation_for_ESM
  endif
#endif
  call Ewald_and_Structure_Factor
  call Initial_Electronic_Structure
  call Initial_MD_Condition()

  if(mype_conf>0 .and. icond==CONTINUATION .and. .not. &
 &  (file_existance_contfiles.and.file_existance_3contfiles))then
    F_CNTN = trim(F_CNTN_bak)//'_conf'//trim(to_string(mype_conf,2))
    F_CNTN_BIN = trim(F_CNTN_BIN_bak)//'_conf'//trim(to_string(mype_conf,2))
    F_CHGT = trim(F_CHGT_bak)//'_conf'//trim(to_string(mype_conf,2))
    F_ZAJ = trim(F_ZAJ_bak)//'_conf'//trim(to_string(mype_conf,2))

    F_CNTN_in = trim(F_CNTN_bak)//'_conf'//trim(to_string(mype_conf,2))
    F_CNTN_BIN_in = trim(F_CNTN_BIN_bak)//'_conf'//trim(to_string(mype_conf,2))
    F_CHGT_in = trim(F_CHGT_bak)//'_conf'//trim(to_string(mype_conf,2))
    F_ZAJ_in = trim(F_ZAJ_bak)//'_conf'//trim(to_string(mype_conf,2))

    if(printable)then
      write(nfout,'(a)') 
      write(nfout,'(a)') 'restored continuation files'
      write(nfout,'(a)') '  F_CNTN     : '//trim(F_CNTN)
      write(nfout,'(a)') '  F_CNTN_BIN : '//trim(F_CNTN_BIN)
      write(nfout,'(a)') '  F_CHGT     : '//trim(F_CHGT)
      write(nfout,'(a)') '  F_ZAJ      : '//trim(F_ZAJ)
      write(nfout,'(a)') 
    endif

    call m_Files_reopen_nfcntn()
    call m_Files_reopen_nfcntn_bin()
    call m_Files_reopen_nfzaj()
    call m_Files_reopen_nfchgt()
  endif

  bias:do
    if(.not.m_mtd_update_bias())then 
      exit bias
    endif
    md_step: do while(m_vv_increment_md_step())
      if(printable) write(nfout,'(a,i7)') 'entering MD step no. ',m_vv_get_curr_md_step()
      stat=0
      call m_vv_do_dynamics(stat)
      if(stat==2)then
        exit bias
      endif
      call postproc_md_step_mtd(printable,nfout)
      if(printable) write(nfout,'(a,i7)') 'done MD step no.     ',m_vv_get_curr_md_step()
      if(printable) write(nfout,'(a)')    ''
    enddo md_step
    call postproc_bias()
  enddo bias

  call mpi_barrier(mpi_comm_group, ierr)
  call mpi_barrier(mpi_comm_world, ierr)

  call finalize_mtd()

end subroutine meta_dynamics

subroutine postproc_md_step_mtd(printable,nfout)
  use m_velocity_verlet, only : m_vv_io_per_step
  implicit none
  logical, intent(in) :: printable
  integer, intent(in) :: nfout
  if(printable) write(nfout,'(a)') 'doing post-proc for each MD step'
  call m_vv_io_per_step()
end subroutine postproc_md_step_mtd

subroutine postproc_bias()
end subroutine postproc_bias

subroutine finalize_mtd()
  use m_routines, only : close_all_opened_files
  implicit none
  call close_all_opened_files()
  call scf_finalize()
  call dump_mtd()
end subroutine finalize_mtd

subroutine dump_mtd()
  use m_Files, only : F_CNTN, nfcntn
  use m_Parallelization, only : mype
  use m_velocity_verlet, only : m_vv_wd_vv_variables
  use m_meta_dynamics, only : m_mtd_wd_mtd
  implicit none
  if(mype/=0)return
  open(nfcntn,&
& file=F_CNTN,status='unknown',position='append')
  call m_mtd_wd_mtd(nfcntn)
  call m_vv_wd_vv_variables(nfcntn)
  close(nfcntn)
end subroutine dump_mtd

subroutine init_mtd()
  use m_Const_Parameters, only : ON,old,check_file_name_on,formatted, CONTINUATION,INITIAL
  use m_Control_Parameters, only : printable, icond
  use m_variables_for_atoms, only : m_vfa_alloc_atoms
  use m_variables_for_dynamics, only : m_vfd_init
  use m_velocity_verlet, only : m_vv_init, m_vv_parse_input, m_vv_rd_vv_variables
  use m_meta_dynamics, only : m_mtd_parse_input, m_mtd_print_status, m_mtd_rd_mtd, m_mtd_gen_bias_mode &
  &                         , m_mtd_set_bias_gen_only, m_mtd_open_mtd_files,m_mtd_wd_bias_potential &
  &                         , m_mtd_finalize
  use m_Files, only : nfinp, F_INP, nfout, open0,nfcntn, F_ZAJ_in, F_CNTN_in, F_CNTN_BIN_in, F_CHGT_in &
  &                 , F_ZAJ, F_CNTN, F_CNTN_BIN, F_CHGT, m_Files_check_file_existance &
  &                 , file_existance_contfiles, file_existance_3contfiles, F_CNTN_bak
  use m_Parallelization, only : workdir,sw_wdir, mype_conf

  implicit none
  integer ::  f_selectTop, f_selectBlock, f_openInputFile, f_closeInputFile
  integer :: iiret
  logical :: ex,op

  if(printable) write(nfout,'(a)')
  if(printable) write(nfout,'(a)') 'start initialization of meta-dynamics'
  call m_vfa_alloc_atoms()
  call m_vfd_init()

  inquire(unit=nfinp,opened=op)
  if(op)close(nfinp,status='keep')
  if(sw_wdir == ON) then
    iiret = f_openInputFile(trim(workdir)//F_INP)
  else
    iiret = f_openInputFile(F_INP)
  end if
  if( iiret < 0) then
    if(printable) write(nfout,'(" !!! Error in opening of inputfile: ",a32)') F_INP
    stop
  else if(iiret > 0) then
    if(printable) write(nfout,'(" !!! There is something wrong in the input file: ",a32)') F_INP
  end if

  iiret = f_selectTop()

  call m_mtd_parse_input()

  if(m_mtd_gen_bias_mode())then
    call m_mtd_print_status()
    write(nfout,'(a)') ' -- generate and output the bias potential --'
    call m_mtd_wd_bias_potential()
    call m_mtd_finalize()
    write(nfout,'(a)') '... exiting.'
    stop
  else
    call m_vv_init()
    call m_vv_parse_input()

    iiret = f_selectTop()

    call m_mtd_print_status() 

!    iiret = f_closeInputFile()

    if(printable) write(nfout,'(a)') 'end initialization of meta-dynamics'
    if(printable) write(nfout,'(a)')

    if(icond==CONTINUATION)then
      if(printable) write(nfout,'(a)') 'loading continuation data for the meta-dynamics...'
      call m_vv_rd_vv_variables(nfcntn,.true.)
      call m_mtd_rd_mtd(nfcntn,file_existance_contfiles.and.file_existance_3contfiles)
      if(printable) write(nfout,'(a)') '...done'
    endif
  endif

end subroutine init_mtd
#endif
! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
! ==============================================================================

#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)   call timer_sta(a)
#   define __TIMER_DO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif
#ifdef __TIMER_COMM__
#   define __TIMER_COMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_st
a(a)
#   define __TIMER_COMM_STOP_w_BARRIER(str,a)    call timer_barrier(str) ;   call timer_en
d(a)
#   define __TIMER_COMM_START(a)       call timer_sta(a)
#   define __TIMER_COMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_COMM_START_w_BARRIER(str,a)
#   define __TIMER_COMM_STOP_w_BARRIER(str,a)
#   define __TIMER_COMM_START(a)
#   define __TIMER_COMM_STOP(a)
#endif

module m_KE_mixing
! $Id: m_KE_mixing.F90 285 2013-01-01 04:33:41Z ktagami $
!
  use m_Const_Parameters,    only : BUCS, DP, OFF &
       &                          , EXECUT,SIMPLE_CUBIC,BOHR,NO,ANTIFERRO &
       &                          , ANEW,RENEW,ON, SIMPLE,BROYD1,BROYD2,DFP,PULAY &
       &                          , OLD, NEXT, PAI, VTK &
       &                          , DELTA10 &
       &                          , unit_conv_byname, UMICRO, GAMMA, DELTA &
       &                          , ELECTRON, INVERSE, YES, CMPLDP
  use m_IterationNumbers,    only : iteration,iteration_for_cmix
  use m_Parallelization,     only : mpi_comm_group &
       &                          , ista_kngp,iend_kngp,is_kngp,ie_kngp,np_kngp,mp_kngp &
       &                          , npes,mype,ierr &
       &                          , is_kgpm,ie_kgpm,ista_kgpm,iend_kgpm,mp_kgpm &
       &                          , nis_fftp, nie_fftp, myrank_g, nrank_g

  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,  only : nspin,ipri,ipriwf, c_precon &
       &                          , amix,bmix,hownew,nbxmix,istrbr &
       &                          , kimg,af,neg,ipripulay &
       &                          , iprichargemixing &
       &                          , sw_recomposing, spin_density_mixfactor &
       &                          , amin, sw_precon_diff, sw_metric_diff,metric_ratio &
       &                          , sw_force_simple_mixing,printable, &
       &                            g0_wf_precon, amin_wf_precon

  use m_Crystal_Structure,   only : univol, sw_magnetic_constraint
  use m_PlaneWaveBasisSet,   only : kg,kgp,ngpt_l,ngabc,gr_l,kgpm


  use m_KineticEnergy_Density,  only : ekins_l, ekins_old, ekina_l, ekina_old

  use m_Control_Parameters,  only : sw_mix_bothspins_sametime, &
                                  & sw_recomposing_hsr, sw_force_simple_mixing_hsr, &
                                  & noncol, ndim_magmom

  use m_Ionic_System,        only : ityp, natm
  use m_PseudoPotential,     only : ilmt, nlmt

  use m_Control_Parameters,  only : sw_gradient_simplex, alpha_pulay, &
       &                            use_symm_ekin_density, use_asymm_ekin_density
  use m_CD_mixing,    only : ekinq_l, ekinqo_l
  
  implicit none

  real(kind=DP), allocatable, dimension(:):: rmxtrc ! d(nspin_m)
  real(kind=DP), allocatable, dimension(:,:,:) :: kinqstore_l, kinqostore_l

  real(kind=DP),private,pointer, dimension(:,:,:) ::       rho,rhoo  ! MPI
  !         rho => vlhxc_l, rhoo => vlhxco_l ( when kgpm == kgp)
  !         rho and rhoo is projected from vlhxc_l and vlhxco_l, respectively ( otherwise)

  real(kind=DP),private,allocatable,dimension(:,:,:,:) :: rhoj,Frhoj
  real(kind=DP),private,allocatable,dimension(:,:,:)   :: rhojo,Frhojo
  real(kind=DP),private,allocatable,dimension(:,:,:)   :: rhoj_vhsr,Frhoj_vhsr
  real(kind=DP),private,allocatable,dimension(:,:)   :: rhoj_vhsro,Frhoj_vhsro

! === DEBUG by tkato 2011/09/09 ================================================
! real(kind=DP),private, pointer, dimension(:,:)        :: work
! ==============================================================================

!!$  integer, private,parameter   :: n_ratio_q1 = 20
  integer, private             :: n_ratio_q1 = 20
  real(DP),private,parameter   :: q0_default = 1.5*BOHR
  real(DP),private             :: amix_cprec, bmix_cprec
  logical, private             :: param_cprecon_decided = .false.
  real(DP),private             :: q0 = -1.d0, q1 = -1.d0
  real(DP),private,save        :: fg2, frg2

! --> T. Yamasaki, 03rd Aug. 2009
!!  real(DP),private,pointer,dimension(:,:)     :: c_p !d(ista_kngp:iend_kngp,nspin/(af+1))
  real(DP),public,pointer,dimension(:,:)     :: c_p !d(ista_kngp:iend_kngp,nspin/(af+1))

  real(DP),private,pointer,dimension(:,:)     :: c_pm !d(ista_kgpm:iend_kgpm,nspin/(af+1))
! <--

  ! -- For Broyden and DFP mixing method --
  integer, private,parameter                :: iU = 1, iVD = 1, iW = 2, iY = 2, iV = 2
  integer, private                          :: nspin_m
  real(DP),private,allocatable,dimension(:) :: f_p !d(ista_kgpm:iend_kgpm)
  real(DP),private,allocatable,dimension(:,:,:) :: d0_l,u_l,v_l,w_l,dout,dd_l
  real(DP),private,pointer,dimension(:,:,:)         :: F_l
  real(DP),private,allocatable,target,dimension(:,:,:) :: din
  !                                             d(kgpm,kimg,nspin_m)
  real(DP),private,allocatable,dimension(:,:,:)     :: dF_l
  !     dF_l(deltaF):= \Delta \cal F^{m} = \cal F^{m} - \cal F^{m-1}
  !              = F[\rho^{m}] - F[\rho^{m-1}] - (\rho^{m} - \rho^{m-1})
  real(DP),private,allocatable,target,dimension(:,:,:,:,:) :: urec_l
  real(DP),private,allocatable,dimension(:,:,:)     :: f      !d(nbxmix,nbxmix,nspin)
  real(DP),private,allocatable,dimension(:)         :: g      !d(nbxmix)
  !    f and g are used only when hownew == RENEW
  integer, private,allocatable,dimension(:)         :: ncrspd !d(nbxmix)
  real(DP),private,allocatable,dimension(:,:,:)     :: uuf    !d(nbxmix,nspin,2),
                                                   !only for DFP method
  real(DP),private,allocatable,dimension(:,:)       :: uuf_p
  real(DP),private,allocatable,dimension(:,:)       :: g_p
  real(DP),private,allocatable,dimension(:)         :: prj_wk
#ifdef _CDMIX_USE_POINTER_
! Tsuyoshi Miyazaki tmp
  real(DP),private,pointer,dimension(:,:,:)         :: urec_l_3
  real(DP),private,pointer,dimension(:,:,:)         :: urec_l_3_2
#endif

  logical          :: force_dealloc = .false.
  integer, private :: previous_waymix = 0

  include 'mpif.h'
  integer istatus(mpi_status_size)

! ========================== adde by K. Tagami ========================== 5.0
  integer :: nsize_rho_vhsr
  integer, private, allocatable :: imap_vhsr(:)    ! d(nsize_rho_vhsr)
  real(kind=DP),private,allocatable, dimension(:,:) ::   rho_vhsr, rhoo_vhsr
                                                  ! d(nsize_rho_vhsr,nspin)

  real(DP),private,allocatable,dimension(:,:) :: d0_vhsr, u_vhsr, v_vhsr, w_vhsr, &
        &                                        dout_vhsr, dd_vhsr
  real(DP),private,pointer,dimension(:,:)         :: FF_vhsr
  real(DP),private,allocatable,target,dimension(:,:) :: din_vhsr
  !                                             d( nsize_rho_vhsr,nspin_m)
  real(DP),private,allocatable,dimension(:,:)     :: dF_vhsr
  real(DP),private,allocatable,target,dimension(:,:,:,:) :: urec_vhsr

  logical, save :: first = .true.

  real(kind=DP), allocatable :: rho_store(:,:), vhsr(:,:,:,:)
  real(kind=DP), allocatable :: rhoo_store(:,:), vhsro(:,:,:,:)
! ==============================================================

! ========================== adde by K. Tagami ========================== 11.0
  integer :: nsize_rho_vhsr_unit
!  integer :: sw_mix_imaginary_hardpart = OFF
!  integer :: sw_mix_imaginary_hardpart = ON
! ======================================================================= 11.0

! ==== 
  real(kind=DP), private, pointer :: kinq_l(:,:,:), kinqo_l(:,:,:)
! ===

! --- contained subroutines ---
!   7. m_KE_prepare_precon       <-(KE_Mixing)
!  10. m_KE_simple_mixing        <-(KE_Mixing)
!  22. precon_4_KE_mix       <-(@10), (@53),(@54),(@55),(@60)
!  23. precon_4_mult             <-(@37),(@45),(48)
!  24. iter_from_reset           <-(@53),(@54),(@55),(@60)
!  25. icrspd_is                 <-(@53),(@54),(@55)
!  26. mult1s                    <-(@49),(@50),(@51),(@53),(@54),(@55),(@60)
!  27. mult1s5                   <-(@53),(@55),(@60)
!  28. mult1s10                  <-(@60)
!  29. subtr_j_th_term           <-(@49),(@50),(@53),(@55)
!  30. store_to_urec2            <-(@53),(@55)
!  31. set_ncrspd_mxiter_etc     <-(@53),(@54),(@55)
!    - rotate_cmix_arrays
!  32. simple_mix1               <-(@53),(@54),(@55),(@60)
!  33. scatter_chg_onto_d        <-(@32),(@40),(@51)
!  34. scatter_cp_onto_cpm       <-(@23),(@40)
!  35. concentrate_d_to_chg      <-(@51),(@55),(@60)
!  36. mix_dealloc_previous      <-(@53),(@54),(@55),(@60)
!  37. mix_broyden_allocate      <-(@51),(@54)
!  38. mix_broyden_deallocate    <-(@36)
!  39. mix_broyden_alloc2        <-(@54)
!  40. alloc_rho_rhoo_and_cpm    <-(@39),(@43),(@46),(@58)
!  41. mix_broyden_dealloc2      <-(@54)
!  42. dealloc_rho_rhoo_and_cpm  <-(@41),(@44),(@47),(@59)
!  43. mix_broyden_alloc3        <-(@53)
!  44. mix_broyden_dealloc3      <-(@53)
!  45. mix_DFP_allocate          <-(@55)
!  46. mix_DFP_alloc2            <-(@55)
!  47. mix_DFP_dealloc2          <-(@55)
!  -x. devide_v_with_vdF
!  49. renew_u_br                <-(@53),(@54)
!  50. renew_d_br                <-(@53),(@54)
!  51. renew_d_last_br           <-(@53),(@54)
!  52. simple_mix_large_Gc       <-(@51),(@55),(@60)
!  53. m_KE_mix_broyden1         <-(KE_Mixing)
!    - dF_F_d0_u_v_and_dd - renew_v
!  54. m_KE_mix_broyden2         <-(KE_Mixing)
!    - dF_F_d0_u_and_v
!  55. m_KE_mix_DFP              <-(KE_Mixing)
!    - dF_F_d0_u_and_w - renew_w - renew_d - renew_d_last
!  56. mix_pulay_allocate        <-(@60)
!  57. mix_pulay_deallocate      <-(@36)
!  58. mix_pulay_alloc2          <-(@60)
!  59. mix_pulay_dealloc2        <-(@60)
!  60. m_KE_mix_pulay            <-(KE_Mixing)
!    - mix_pulay_alloc3 - mix_pulay_dealloc3
!    - Resid_and_dd_into_urec - Ri_dot_Rj - Rj_dot_d
!    - get_finv -get_matrix -renew_d_using_g

contains

! ------------------------------------

  subroutine m_KE_set_pointer_ekinq
    if ( use_symm_ekin_density ) then
       ekinq_l => ekins_l
       ekinqo_l => ekins_old
    else if ( use_asymm_ekin_density ) then
       ekinq_l => ekina_l
       ekinqo_l => ekina_old
    endif
  end subroutine m_KE_set_pointer_ekinq

  subroutine m_KE_set_pointer_ekinq_00
    if ( use_symm_ekin_density ) then
       kinq_l => ekins_l
       kinqo_l => ekins_old
    else if ( use_asymm_ekin_density ) then
       kinq_l => ekina_l
       kinqo_l => ekina_old
    endif
  end subroutine m_KE_set_pointer_ekinq_00

  subroutine alloc_kinqstore_recompos_kinq(rmxt,rmxtrc)
    real(kind=DP),intent(in) :: rmxt
    real(kind=DP),intent(out),dimension(nspin_m) :: rmxtrc
#ifdef __TIMER_SUB__
    call timer_sta(1104)
#endif
    allocate(kinqstore_l(ista_kngp:iend_kngp,kimg,nspin))
    allocate(kinqostore_l(ista_kngp:iend_kngp,kimg,nspin))
#ifdef __TIMER_DO__
    call timer_sta(1149)
#endif
    kinqstore_l = kinq_l
    kinqostore_l = kinqo_l

    kinq_l(:,:,1)  = kinqstore_l(:,:,1)  + kinqstore_l(:,:,2)
    kinq_l(:,:,2)  = kinqstore_l(:,:,1)  - kinqstore_l(:,:,2)
    kinqo_l(:,:,1) = kinqostore_l(:,:,1) + kinqostore_l(:,:,2)
    kinqo_l(:,:,2) = kinqostore_l(:,:,1) - kinqostore_l(:,:,2)

#ifdef __TIMER_DO__
  call timer_end(1149)
#endif
    rmxtrc(1) = rmxt
    rmxtrc(2) = rmxt*spin_density_mixfactor
#ifdef __TIMER_SUB__
    call timer_end(1104)
#endif
  end subroutine alloc_kinqstore_recompos_kinq

  subroutine compos_kinq_dealloc_kinqstore
#ifdef __TIMER_SUB__
    call timer_sta(1106)
#endif
#ifdef __TIMER_DO__
  call timer_sta(1153)
#endif
  kinqstore_l = kinq_l
  kinq_l(:,:,1) = 0.5d0*(kinqstore_l(:,:,1) + kinqstore_l(:,:,2))
  kinq_l(:,:,2) = 0.5d0*(kinqstore_l(:,:,1) - kinqstore_l(:,:,2))
  kinqo_l = kinqostore_l

#ifdef __TIMER_DO__
  call timer_end(1153)
#endif
    deallocate(kinqostore_l, kinqstore_l)
#ifdef __TIMER_SUB__
    call timer_end(1106)
#endif
  end subroutine compos_kinq_dealloc_kinqstore

  subroutine m_KE_prepare_precon(nfout,rmxt)
    integer, intent(in)      :: nfout
    real(kind=DP), intent(in):: rmxt
    real(kind=DP) :: G_longest, G_shortest, x, gg,gg_mpi
    integer       :: i, n
    real(kind=DP) :: G_longest_mpi, G_shortest_mpi
    integer       :: ist !mpi

    if(param_cprecon_decided) return
#ifdef __TIMER_SUB__
    call timer_sta(1102)
#endif

    if(iprichargemixing >= 2) write(nfout,*) ' << d_para_cprec >>'

!mpi    G_longest = maxval(gr_l)
!mpi    G_shortest = minval(gr_l(2:kgp))
    G_longest_mpi = maxval(gr_l(ista_kngp:iend_kngp))

    ist = ista_kngp
    if(ist == 1) ist = 2

    G_shortest_mpi = minval(gr_l(ist:iend_kngp))
    call mpi_allreduce(G_longest_mpi,G_longest,1 &
                   &  ,mpi_double_precision,mpi_max,mpi_comm_group,ierr)
    call mpi_allreduce(G_shortest_mpi,G_shortest,1 &
                   &  ,mpi_double_precision,mpi_min,mpi_comm_group,ierr)
    if(iprichargemixing >= 2) then
       write(nfout,*) ' G_longest = ', G_longest
       write(nfout,*) ' G_shortest = ', G_shortest
    end if
    amix_cprec = amix; bmix_cprec = bmix
    if(amix_cprec < 0.d0) then
       amix_cprec = rmxt
       if(iprichargemixing >= 2) write(nfout,*) ' amix_cprec = ', amix_cprec
    end if
    if(bmix_cprec < 0.d0) then
       q0 = q0_default
    else
       q0 = bmix_cprec*G_shortest
    end if
    q0 = q0*q0
    if(iprichargemixing >= 2) then
       write(nfout,*) ' bmix_cprec = ', bmix_cprec
       write(nfout,*) ' q0   = ', q0
    end if

    if (metric_ratio>0) n_ratio_q1 = metric_ratio

    x = G_longest**2  - n_ratio_q1*G_shortest**2
    if(x < 0.d0) then
       n = (G_longest/G_shortest)**2 - 1.d0
       if(n <= 0) n = 1
       x = G_longest**2 - n * G_shortest**2
    else
       n = n_ratio_q1
    end if
    if(iprichargemixing >= 2) write(nfout,*) ' n = ', n
    q1 = (n-1) * G_shortest**2 * G_longest**2/x
    q1 = dsqrt(q1)
    if(iprichargemixing >= 2) write(nfout,*) ' q1 = ', q1

    if(nspin == 2 .or. noncol ) then  
       i = 2
!!$       gg = gr_l(i)**2
       gg = 0.d0
       if(ista_kngp <= i .and. i <= iend_kngp) gg = gr_l(i)**2
       if(npes > 1) then
          call mpi_allreduce(gg,gg_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
          gg = gg_mpi
       end if

       if(iprichargemixing >= 2) write(nfout,'(" !! gg = ",d20.8)') gg

       if (amin<=0) then
          amin = 0.d0
       endif
       fg2 = max(gg/(gg+q0),amin)
       frg2 = 1.0d0 + q1**2/gg
       if(iprichargemixing >= 2) then
          write(nfout,*) ' ! amix_cprec = ', amix_cprec, ' fg2 = ', fg2
          write(nfout,*) ' ! amix_cprec*g_S**2/(g_S**2+q0) = ', amix_cprec*fg2
       end if
    else
       fg2 = 0.d0
       frg2 = 0.d0
    endif

    param_cprecon_decided = .true.
#ifdef __TIMER_SUB__
    call timer_end(1102)
#endif
  end subroutine m_KE_prepare_precon

  subroutine m_KE_force_dealloc()
    force_dealloc = .true.
  end subroutine m_KE_force_dealloc

  subroutine m_KE_simple_mixing(nfout,rmxt)
    integer ,intent(in)      :: nfout
    real(kind=DP),intent(in) :: rmxt

    integer       :: is, k
    integer       :: id_sname = -1
#ifdef __TIMER_SUB__
    call timer_sta(1103)
#endif

! ================================ modified by K. Tagami =============== 11.0
!!! --> T. Yamasaki  03 Aug. 2009
!!    nspin_m  = nspin/(af+1)
!!! <--
!
    if ( noncol ) then
       nspin_m = ndim_magmom
    else
       nspin_m  = nspin/(af+1)
    endif
! ====================================================================== 11.0

    call tstatc0_begin('m_KE_simple_mixing ',id_sname,1)

    if(previous_waymix /= SIMPLE.or.force_dealloc) then
       call mix_dealloc_previous()
! ------------------------------  ktDEBUG -------------------- 20121030
       call mix_dealloc_previous_vhsr()
! ------------------------------  ktDEBUG -------------------- 20121030
       force_dealloc = .false.
    end if

! ================================ modified by K. Tagami =============== 11.0
!! --> T. Yamasaki  03 Aug. 2009
!    allocate(rmxtrc(nspin_m))
!
!    if(sw_recomposing == YES .and. af == 0 .and. nspin == 2) then
!       call alloc_kinqstore_recompos_kinq(rmxt,rmxtrc) ! --> kinq_l, kinqo_l, rmxtrc
!    else
!       rmxtrc = rmxt
!    end if
!    if(ipri >= 2) write(nfout,'(" rmxt = ",d20.8)') rmxt
!! --> T. Yamasaki  03 Aug. 2009
!
!
    allocate(rmxtrc(nspin_m))

    if ( noncol ) then
       rmxtrc = rmxt
    else
       if(sw_recomposing == YES .and. af == 0 .and. nspin == 2) then
          call alloc_kinqstore_recompos_kinq(rmxt,rmxtrc) ! --> kinq_l, kinqo_l, rmxtrc
       else
          rmxtrc = rmxt
       endif
    end if
    if(ipri >= 2) write(nfout,'(" rmxt = ",d20.8)') rmxt
! ====================================================================== 11.0

!!$    allocate(c_p(ista_kngp:iend_kngp))
    allocate(c_p(ista_kngp:iend_kngp,nspin_m))
    c_p = 0.0d0                 ! ===== Adde by K. Tagami =========


! ================================ modified by K. Tagami =============== 11.0
!!    call precon_4_KE_mix(rmxtrc,c_p)
!
    if ( noncol ) then
       call precon_4_KE_mix_noncl(rmxtrc,c_p)
    else
       call precon_4_KE_mix(rmxtrc,c_p)
    endif
! ======================================================================= 11.0


#ifdef __TIMER_DO__
  call timer_sta(1148)
#endif
! ================================ modified by K. Tagami ================ 11.0
!!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ======================================================================= 11.0
       do k = 1, kimg
          kinq_l(:,k,is) = c_p(:,is)*kinq_l(:,k,is) &
               &  + (1.0d0-c_p(:,is))*kinqo_l(:,k,is)
       end do
    end do

#ifdef __TIMER_DO__
  call timer_end(1148)
#endif
    deallocate(c_p)

!
    if ( .not. noncol ) then
       if (sw_recomposing == YES .and. af == 0 .and. nspin == 2) then
          call compos_kinq_dealloc_kinqstore()
       end if
    endif
    deallocate(rmxtrc)

    previous_waymix = SIMPLE
    call tstatc0_end(id_sname)

#ifdef __TIMER_SUB__
    call timer_end(1103)
#endif
  end subroutine m_KE_simple_mixing

  subroutine precon_4_KE_mix(pmix,c_p)
    real(DP),intent(in),dimension(nspin_m)                       :: pmix
    real(DP),intent(out), dimension(ista_kngp:iend_kngp,nspin_m) :: c_p
    integer              :: i
    real(DP)             :: gg, agg, tmp
    integer              :: ist  !for mpi
    integer              :: is
#ifdef __TIMER_SUB__
    call timer_sta(1105)
#endif

    do is = 1, nspin, af+1
       c_p(:,is) = pmix(is)
    end do
    return


    if(iprichargemixing >= 2) write(6,'("! pmix(precon_4_KE_mix) = ",f8.4)') pmix
    if(c_precon) then
       ist = ista_kngp
       if(ist == 1) ist = 2
       if(nspin_m == 2) then
#ifdef __TIMER_DO__
  call timer_sta(1150)
#endif
          do i = ist, iend_kngp  !for mpi
             gg = gr_l(i)*gr_l(i)
             tmp = max(gg/(gg+q0),amin)
!!$             agg = amix_cprec*gg/(gg+q0)
             agg = amix_cprec*tmp
             c_p(i,1) = agg * pmix(1)
             if (sw_recomposing==ON .and. sw_precon_diff==NO)then
                c_p(i,2) = amix_cprec * pmix(2)
             else
                c_p(i,2) = agg * pmix(2)
             endif
          enddo
#ifdef __TIMER_DO__
  call timer_end(1150)
#endif
          if(mype == 0) then
             c_p(1,1) = amix_cprec*fg2 * pmix(1)
             if (sw_recomposing==ON .and. sw_precon_diff==NO)then
                c_p(1,2) = amix_cprec * pmix(2)
             else
                c_p(1,2) = amix_cprec*fg2 * pmix(2)
             endif
          end if
       else
#ifdef __TIMER_DO__
  call timer_sta(1151)
#endif
          do i = ist, iend_kngp  !for mpi
             gg = gr_l(i)*gr_l(i)
             tmp = max(gg/(gg+q0),amin)
!!$             c_p(i,1) = amix_cprec*gg/(gg+q0) * pmix(1)
             c_p(i,1) = amix_cprec* tmp * pmix(1)
          end do
#ifdef __TIMER_DO__
  call timer_end(1151)
#endif
          if(mype == 0) c_p(1,1) = amix_cprec*fg2 * pmix(1)
       end if
    else
#ifdef __TIMER_DO__
  call timer_sta(1152)
#endif
       do is = 1, nspin, af+1
          c_p(:,is) = pmix(is)
       end do
#ifdef __TIMER_DO__
  call timer_end(1152)
#endif
    endif
#ifdef __TIMER_SUB__
    call timer_end(1105)
#endif
  end subroutine precon_4_KE_mix

! ===================================== added by K. Tagami ================ 11.0
  subroutine precon_4_KE_mix_noncl(pmix,c_p)
    real(DP),intent(in),dimension(nspin_m)                       :: pmix
    real(DP),intent(out), dimension(ista_kngp:iend_kngp,nspin_m) :: c_p
    integer              :: i
    real(DP)             :: gg, agg, tmp
    integer              :: ist  !for mpi
    integer              :: is

    if(iprichargemixing >= 2) then
       write(6,'("! pmix(precon_4_KE_mix_noncl) = ",f8.4)') pmix
    end if

    if(c_precon) then
       ist = ista_kngp
       if(ist == 1) ist = 2

       do i = ist, iend_kngp  !for mpi
          gg = gr_l(i)*gr_l(i)
          tmp = max(gg/(gg+q0),amin)
!!$             agg = amix_cprec*gg/(gg+q0)
          agg = amix_cprec*tmp
          c_p(i,:) = agg * pmix(:)
       end do
       if (mype == 0) then
          c_p(1,:) = amix_cprec*fg2 * pmix(:)
       end if
    else
       do is = 1, ndim_magmom
          c_p(:,is) = pmix(is)
       end do
    endif

  end subroutine precon_4_KE_mix_noncl
! ============================================================== 11.0

  subroutine precon_4_mult(f_q)
    real(DP),intent(out), dimension(ista_kgpm:iend_kgpm)   :: f_q
    integer  :: i, ist      !mpi
    real(kind=DP), pointer, dimension(:) :: gr_l_m

    f_q = 0.d0
    if(c_precon ) then
       ist  = ista_kgpm
       if(ist == 1) ist = 2
       if(kgp == kgpm .or. npes == 1) then
          do i = ist, iend_kgpm  !for mpi
             f_q(i) = 1.0d0 + (q1/gr_l(i))**2
          end do
       else
          allocate(gr_l_m(ista_kngp:iend_kngp))
! ============================== by K. Tagami =============
        gr_l_m = 0.0d0
! ========================================================
          call scatter_cp_onto_cpm(gr_l,gr_l_m)
          do i = ist, iend_kgpm  !for mpi
             f_q(i) = 1.0d0 + (q1/gr_l_m(i))**2
          end do
          deallocate(gr_l_m)
       end if
       if(mype==0) f_q(1) = frg2
!mpi       f_q(2:kgpm) = 1 + (q1/gr_l(2:kgpm))**2
!mpi       f_q(1)       = frg2
    else
       f_q          = 1.d0
    end if

  end subroutine precon_4_mult

  function iter_from_reset()
    integer             :: n, nbox
    integer             :: iter_from_reset
    if(hownew ==  ANEW) then
       n = (iteration_for_cmix - istrbr - 1)/(nbxmix-1)
       if(n < 0) n = 0
       nbox = iteration_for_cmix - (n*(nbxmix-1) + istrbr +1) + 2
       iter_from_reset = nbox + istrbr - 1
    else
       iter_from_reset = iteration_for_cmix
    endif
  end function iter_from_reset

  function icrspd_is(iter)
    integer, intent(in) :: iter
    integer             :: icrspd_is
    if(iter-istrbr+1 < nbxmix) then
       icrspd_is = ncrspd(iter-istrbr+1)
    else
       icrspd_is = ncrspd(nbxmix)
    endif
  end function icrspd_is

  subroutine mult1s(u,v,f_q,fmult)
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm,kimg,nspin_m) :: u,v
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm):: f_q
    real(DP),intent(out),dimension(nspin_m)            :: fmult

    real(DP) :: p, p_mpi, fac
    integer  :: is,ik,i
#ifdef __TIMER_SUB__
    call timer_sta(1114)
#endif

    fmult = 0.d0

! ================================ modified by K. Tagami ============== 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ===================================================================== 11.0

       p = 0.d0
       fac=1.0d0
#ifdef __TIMER_DO__
  call timer_sta(1160)
#endif
       do ik = 1,kimg
          do i = ista_kgpm, iend_kgpm   ! mpi
! ========================================== modified by K. Tagami ======== 11.0
!             if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) fac=f_q(i)
!
             if ( noncol ) then
                fac=f_q(i)
             else
                if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) then
                   fac=f_q(i)
                endif
             endif
! ======================================================================== 11.0

!             p = p + f_q(i)*u(i,ik,is)*v(i,ik,is)
             p = p + fac*u(i,ik,is)*v(i,ik,is)
          end do
       end do
#ifdef __TIMER_DO__
  call timer_end(1160)
#endif
       if( npes >= 2) then
          call mpi_allreduce(p,p_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
          p = p_mpi
       end if
       fmult(is) = p*univol
    enddo
#ifdef __TIMER_SUB__
    call timer_end(1114)
#endif
  end subroutine mult1s

  subroutine mult1s_reduce_spin(u,v,f_q,fmult)
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm,kimg,nspin_m) :: u,v
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm):: f_q
!!$    real(DP),intent(out),dimension(nspin_m)            :: fmult
    real(DP),intent(out)            :: fmult

    real(DP) :: p, p_mpi, fac
    integer  :: is,ik,i

    fmult = 0.d0
    p = 0.d0

! ================================ modified by K. Tagami ============== 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ===================================================================== 11.0

!!$       p = 0.d0
       fac=1.0d0
       do ik = 1,kimg
          do i = ista_kgpm, iend_kgpm   ! mpi
! ========================================== modified by K. Tagami ======== 11.0
!             if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) fac=f_q(i)
!
             if ( noncol ) then
                fac=f_q(i)
             else
                if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) then
                   fac=f_q(i)
                endif
             endif
! ======================================================================== 11.0

!             p = p + f_q(i)*u(i,ik,is)*v(i,ik,is)
             p = p + fac*u(i,ik,is)*v(i,ik,is)
          end do
       end do
       if( npes >= 2) then
          call mpi_allreduce(p,p_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
          p = p_mpi
       end if
    enddo
    fmult = p
  end subroutine mult1s_reduce_spin

  subroutine mult1s5(u,mb,muv,j,iuv,v,f_q,fmult)
    integer,intent(in) :: mb,muv,j,iuv
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm,kimg,nspin_m,mb,muv) :: u
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm,kimg,nspin_m) :: v
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm):: f_q
    real(DP),intent(out),dimension(nspin_m)            :: fmult

    real(DP) :: p, p_mpi, fac
    integer  :: is,ik,i

#ifdef __TIMER_SUB__
    call timer_sta(1115)
#endif
    fmult = 0.d0
! ================================ modified by K. Tagami ============== 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ===================================================================== 11.0

       p = 0.d0
       fac=1.0d0
#ifdef __TIMER_DO__
  call timer_sta(1162)
#endif
       do ik = 1,kimg
          do i = ista_kgpm, iend_kgpm   ! mpi
! ========================================== modified by K. Tagami ======== 11.0
!             if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) fac=f_q(i)
!
             if ( noncol ) then
                fac=f_q(i)
             else
                if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) then
                   fac=f_q(i)
                endif
             end if
! ========================================================================= 11.0

             p = p + fac*u(i,ik,is,j,iuv)*v(i,ik,is)
          end do
       end do
#ifdef __TIMER_DO__
  call timer_end(1162)
#endif

       if( npes >= 2) then
          call mpi_allreduce(p,p_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
          p = p_mpi
       end if
       fmult(is) = p*univol
    enddo
#ifdef __TIMER_SUB__
    call timer_sta(1115)
#endif
  end subroutine mult1s5

  subroutine mult1s5_reduce_spin(u,mb,muv,j,iuv,v,f_q,fmult)
    integer,intent(in) :: mb,muv,j,iuv
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm,kimg,nspin_m,mb,muv) :: u
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm,kimg,nspin_m) :: v
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm):: f_q
!!$    real(DP),intent(out),dimension(nspin_m)            :: fmult
    real(DP),intent(out)            :: fmult

    real(DP) :: p, p_mpi, fac
    integer  :: is,ik,i

    fmult = 0.d0
    p = 0.d0

! ================================ modified by K. Tagami ============== 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ===================================================================== 11.0

!!$       p = 0.d0
       fac = 1.0d0
       do ik = 1,kimg
          do i = ista_kgpm, iend_kgpm   ! mpi
! ========================================== modified by K. Tagami ======== 11.0
!             if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) fac=f_q(i)
!
             if ( noncol ) then
                fac=f_q(i)
             else
                if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) then
                   fac=f_q(i)
                endif
             end if
! ========================================================================= 11.0

             p = p + fac*u(i,ik,is,j,iuv)*v(i,ik,is)
          end do
       end do
    enddo
    if( npes >= 2) then
       call mpi_allreduce(p,p_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       p = p_mpi
    end if
    fmult = p*univol
  end subroutine mult1s5_reduce_spin

  subroutine mult1s10(u,mb,muv,i,iu,v,j,iv,f_q,fmult)
    integer,intent(in) :: mb,muv,i,iu,j,iv
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm,kimg,nspin_m,mb,muv) :: u,v
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm):: f_q
    real(DP),intent(out),dimension(nspin_m)            :: fmult

    real(DP) :: p, p_mpi, fac
    integer  :: is,ik,ig
#ifdef __TIMER_SUB__
    call timer_sta(1137)
#endif

    fmult = 0.d0

! ====================================== modified by K. Tagami =========== 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ======================================================================== 11.0

       p = 0.d0
       fac = 1.0d0
#ifdef __TIMER_DO__
  call timer_sta(1186)
#endif
       do ik = 1,kimg
          do ig = ista_kgpm, iend_kgpm   ! mpi
! ====================================== modified by K. Tagami ============= 11.0
!!             if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) fac=f_q(ig)
!
             if ( noncol ) then
                fac=f_q(ig)
             else
                if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) then
                   fac=f_q(ig)
                endif
             end if
! ========================================================================== 11.0

             p = p + fac*u(ig,ik,is,i,iu)*v(ig,ik,is,j,iv)
          end do
       end do
#ifdef __TIMER_DO__
  call timer_end(1186)
#endif

       if( npes >= 2) then
          call mpi_allreduce(p,p_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
          p = p_mpi
       end if
       fmult(is) = p*univol
    enddo
#ifdef __TIMER_SUB__
    call timer_end(1137)
#endif
  end subroutine mult1s10

  subroutine mult1s10_reduce_spin(u,mb,muv,i,iu,v,j,iv,f_q,fmult)
    integer,intent(in) :: mb,muv,i,iu,j,iv
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm,kimg,nspin_m,mb,muv) :: u,v
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm):: f_q
    real(DP),intent(out)            :: fmult

    real(DP) :: p, p_mpi, fac
    integer  :: is,ik,ig

    fmult = 0.d0
    p = 0.d0

! ====================================== modified by K. Tagami =========== 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ======================================================================== 11.0

!!$       p = 0.d0
       fac = 1.0d0
       do ik = 1,kimg
          do ig = ista_kgpm, iend_kgpm   ! mpi

! ====================================== modified by K. Tagami ============= 11.0
!!             if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) fac=f_q(ig)
!
             if ( noncol ) then
                fac=f_q(ig)
             else
                if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) then
                   fac=f_q(ig)
                endif
             end if
! ========================================================================== 11.0

             p = p + fac*u(ig,ik,is,i,iu)*v(ig,ik,is,j,iv)
          end do
       end do
    enddo
    if( npes >= 2) then
       call mpi_allreduce(p,p_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       p = p_mpi
    end if
    fmult = p*univol
  end subroutine mult1s10_reduce_spin

  subroutine subtr_j_th_term(f,iuv,j,um)
! === DEBUG by tkato 2011/11/24 ================================================
!   real(DP), intent(in),   dimension(nspin) :: f
    real(DP), intent(in),   dimension(nspin_m) :: f
! ==============================================================================
    integer,  intent(in)                     :: iuv,j
    real(DP), intent(inout)                  :: um(ista_kgpm:iend_kgpm,kimg,nspin_m)
    integer :: is, ik, i, istart
#ifdef __TIMER_SUB__
    call timer_sta(1116)
#endif

    istart = ista_kgpm
    if(istart == 1) istart = 2
#ifdef __TIMER_DO__
  call timer_sta(1164)
#endif

! =============================== modified by K. Tagami =================== 11.0
!!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ========================================================================== 11.0

       do ik = 1, kimg
          do i = istart, iend_kgpm   ! mpi
             um(i,ik,is) = um(i,ik,is) - f(is)*urec_l(i,ik,is,j,iuv)
          end do
       end do
    end do
#ifdef __TIMER_DO__
  call timer_end(1164)
#endif
#ifdef __TIMER_SUB__
    call timer_end(1116)
#endif
  end subroutine subtr_j_th_term

  subroutine store_to_urec2(v,f,j,iuv)
    real(DP), intent(in)                     :: v(ista_kgpm:iend_kgpm,kimg,nspin_m)
! === DEBUG by tkato 2011/11/24 ================================================
!   real(DP), intent(in),  dimension(nspin)  :: f
    real(DP), intent(in),  dimension(nspin_m)  :: f
! ==============================================================================
    integer , intent(in)                     :: j,iuv

    real(DP)          :: dv
    integer           :: is
#ifdef __TIMER_SUB__
    call timer_sta(1119)
#endif

#ifdef __TIMER_DO__
  call timer_sta(1165)
#endif
! ====================================== modified by K. Tagami ============= 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ========================================================================== 11.0

       dv = 1.d0/f(is)
       urec_l(:,:,is,j,iuv) = v(:,:,is)*dv
    end do
#ifdef __TIMER_DO__
  call timer_end(1165)
#endif
#ifdef __TIMER_SUB__
    call timer_end(1119)
#endif
  end subroutine store_to_urec2

  subroutine set_ncrspd_mxiter_etc(iter,iuv,mxiter)
    integer, intent(in)  :: iuv,iter
    integer, intent(out) :: mxiter
#ifdef __TIMER_SUB__
    call timer_sta(1111)
#endif
    if(hownew == RENEW) then
       if((iter-istrbr+1) >= 3) then
          if((iter-istrbr+1) > nbxmix) then   ! When the box overflows
             call rotate_cmix_arrays          !-(contained here) ->mxiter,ncrspd,urec_l,f,g
          else
             mxiter = (iter-istrbr+1) - 1
             ncrspd(iter-istrbr+1) = iter-istrbr+1
          endif
       else
          mxiter = (iter-istrbr+1) - 1
          ncrspd(1) = 1
          ncrspd(2) = 2
       endif
    else ! if(hownew == ANEW)
       mxiter = (iter-istrbr+1) - 1
       ncrspd(iter-istrbr+1) = iter-istrbr+1
    endif

#ifdef __TIMER_SUB__
    call timer_end(1111)
#endif
  contains
    subroutine rotate_cmix_arrays
      integer :: is,j,i,icr,jcr,iwork
#ifdef __TIMER_SUB__
    call timer_sta(1112)
#endif

#ifdef __TIMER_DO__
  call timer_sta(1158)
#endif
! ======================================= modified by K. Tagami ========= 11.0
!      do is = 1, nspin, af+1
      do is = 1, ndim_magmom, af+1
! ======================================================================= 11.0

         do j = 3, nbxmix
            icr = ncrspd(2)
            jcr = ncrspd(j)
            g(j) = f(icr,jcr,is)
            do i = 3, j-1
               icr = ncrspd(i)
               g(j) = g(j) - f(icr,jcr,is)*g(i)
            enddo
            icr = ncrspd(2)
            urec_l(:,:,is,jcr,iuv) &
                 & = urec_l(:,:,is,jcr,iuv) + g(j)*urec_l(:,:,is,icr,iuv)
         enddo
      enddo
#ifdef __TIMER_DO__
  call timer_end(1158)
#endif
      mxiter = nbxmix-1
      iwork = ncrspd(2)
#ifdef __TIMER_DO__
  call timer_sta(1159)
#endif
      do i = 2, mxiter
         ncrspd(i)= ncrspd(i+1)
      end do
#ifdef __TIMER_DO__
  call timer_end(1159)
#endif
      ncrspd(mxiter+1) = iwork
#ifdef __TIMER_SUB__
    call timer_end(1112)
#endif
    end subroutine rotate_cmix_arrays
  end subroutine set_ncrspd_mxiter_etc

  subroutine simple_mix2(p)
    real(DP), intent(in), dimension(ista_kngp:iend_kngp,nspin_m) :: p
    integer  :: is,k

! ==================================== added by K. Tagami ============ 11.0
    if ( noncol ) return
! ===================================================================11.0

    if(nspin<2 .or. af==1) return

    if(kgpm == kgp .or. npes == 1) then
       do is = 2, 2
          din (ista_kgpm:iend_kgpm,:,is) = kinqo_l(ista_kgpm:iend_kgpm,:,is)
          dout(ista_kgpm:iend_kgpm,:,is) = kinq_l (ista_kgpm:iend_kgpm,:,is)
       end do
    else
       call scatter_chg_onto_d(kinqo_l,din )  ! -(m_C.D.)
       call scatter_chg_onto_d(kinq_l, dout)  ! -(m_C.D.)
    end if

    do is = 2,2
       do k = 1, kimg
          kinq_l(:,k,is) = p(:,is)*kinq_l(:,k,is) + (1.0d0-p(:,is))*kinqo_l(:,k,is)
       end do
    end do
  end subroutine simple_mix2

  subroutine simple_mix1(p)
    real(DP), intent(in), dimension(ista_kngp:iend_kngp,nspin_m) :: p
    integer  :: is,k
#ifdef __TIMER_SUB__
    call timer_sta(1108)
#endif

    if(kgpm == kgp .or. npes == 1) then
#ifdef __TIMER_DO__
  call timer_sta(1154)
#endif
! ========================= modified by K. Tagami ==================== 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! ==================================================================== 11.0

          din (ista_kgpm:iend_kgpm,:,is) = kinqo_l(ista_kgpm:iend_kgpm,:,is)
          dout(ista_kgpm:iend_kgpm,:,is) = kinq_l (ista_kgpm:iend_kgpm,:,is)
       end do
#ifdef __TIMER_DO__
  call timer_end(1154)
#endif
    else
       call scatter_chg_onto_d(kinqo_l,din )  ! -(m_C.D.)
       call scatter_chg_onto_d(kinq_l, dout)  ! -(m_C.D.)
    end if

#ifdef __TIMER_DO__
  call timer_sta(1155)
#endif
! ========================= modified by K. Tagami ==================== 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ==================================================================== 11.0
       do k = 1, kimg
          kinq_l(:,k,is) = p(:,is)*kinq_l(:,k,is) + (1.0d0-p(:,is))*kinqo_l(:,k,is)
       end do
    end do
#ifdef __TIMER_DO__
  call timer_end(1155)
#endif

#ifdef __TIMER_SUB__
    call timer_end(1108)
#endif
  end subroutine simple_mix1

  subroutine scatter_chg_onto_d(c,d)
! ================================== modified by K. Tagami ============= 11.0
!    real(DP),intent(in), dimension(ista_kngp:iend_kngp,kimg,nspin) :: c
!    real(DP),intent(out),dimension(ista_kgpm:iend_kgpm,kimg,nspin) :: d
!
    real(DP),intent(in), dimension(ista_kngp:iend_kngp,kimg,ndim_magmom) :: c
    real(DP),intent(out),dimension(ista_kgpm:iend_kgpm,kimg,ndim_magmom) :: d
! ======================================================================= 11.0

    integer :: ip,is,istart,iend,nelmnt,i,ik,ipbase
#ifdef __TIMER_SUB__
    call timer_sta(1121)
#endif

    nelmnt = mp_kngp*kimg*nspin_m
    prj_wk = 0.d0
    do ip = 0, npes - 1
       ! (1)  coping input data onto a work array, and broadcasting
       if(is_kngp(ip) > kgpm) exit
#ifdef __TIMER_DO__
  call timer_sta(1168)
#endif
       if(ip == mype) then

! =============================== modified by K. Tagami ============== 11.0
!          do is = 1, nspin, af+1
          do is = 1, ndim_magmom, af+1
! ==================================================================== 11.0

             do ik = 1, kimg
                ipbase = mp_kngp*(ik-1) + mp_kngp*kimg*(is-1)
                do i = 1, iend_kngp-ista_kngp+1
                   prj_wk(i + ipbase) = c(ista_kngp-1+i,ik,is)
!!$                   prj_wk(i,ik,is) = c(ista_kngp-1+i,ik,is)
                end do
             end do
          end do
       end if
#ifdef __TIMER_DO__
  call timer_end(1168)
#endif
       call mpi_bcast(prj_wk,nelmnt,mpi_double_precision,ip,mpi_comm_group,ierr)

       ! (2) projection
       istart = ista_kgpm; if(istart < is_kngp(ip)) istart = is_kngp(ip)
       iend   = iend_kgpm; if(iend   > ie_kngp(ip)) iend   = ie_kngp(ip)
       if(iend < istart) cycle
#ifdef __TIMER_DO__
  call timer_sta(1170)
#endif
! ====================================== modified by K. Tagami ============ 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! =========================================================================== 11.0

          do ik = 1, kimg
             ipbase = mp_kngp*(ik-1) + mp_kngp*kimg*(is-1)
             do i = istart, iend
                d(i,ik,is) = prj_wk(i + ipbase)
!!$                d(i,ik,is) = prj_wk(i - is_kngp(ip)+1,ik,is)
             end do
          end do
!!$          d(istart:iend,:,is) = prj_wk(istart-is_kngp(ip)+1:iend-is_kngp(ip)+1,:,is)
       end do
#ifdef __TIMER_DO__
  call timer_end(1170)
#endif
    end do
#ifdef __TIMER_SUB__
    call timer_end(1121)
#endif
  end subroutine scatter_chg_onto_d

  subroutine scatter_cp_onto_cpm(cp,cpm)
    real(DP),intent(in), dimension(ista_kngp:iend_kngp,nspin_m) :: cp
    real(DP),intent(out),dimension(ista_kgpm:iend_kgpm,nspin_m) :: cpm

    integer :: ip,istart,iend,i, is, ibase, nelmnt

! --> T. Yamasaki, 03rd Aug. 2009
    nelmnt = mp_kngp*nspin_m
! <--
!!$    print '(" -- scatter_cp_onto_cpm -- ")'
    do ip = 0, npes - 1
       ! (1)  coping input data onto a work array, and broadcasting
       if(is_kngp(ip) > kgpm) exit
       if(ip == mype) then
! --> T. Yamasaki, 03rd Aug. 2009

! ============================= modified by K. Tagami ================= 11.0
!          do is = 1, nspin, af+1
          do is = 1, ndim_magmom, af+1
! ==================================================================== 11.0

             ibase = mp_kngp*(is-1)
             do i = 1, iend_kngp-ista_kngp+1
                prj_wk(i+ibase) = cp(ista_kngp-1+i,is)
             end do
          end do
!!$          do i = 1, iend_kngp-ista_kngp+1
!!$             prj_wk(i)     = cp(ista_kngp-1+i)
!!$!!$             prj_wk(i,1,1) = cp(ista_kngp-1+i)
!!$          end do
       end if
!!$       call mpi_bcast(prj_wk,mp_kngp,mpi_double_precision,ip,mpi_comm_group,ierr)
       call mpi_bcast(prj_wk,mp_kngp*nspin_m,mpi_double_precision,ip,mpi_comm_group,ierr)
! <--
       ! (2) projection
       istart = ista_kgpm; if(istart < is_kngp(ip)) istart = is_kngp(ip)
       iend   = iend_kgpm; if(iend   > ie_kngp(ip)) iend   = ie_kngp(ip)
       if(iend < istart) cycle
! --> T. Yamasaki, 03rd Aug. 2009

! ==================================== modified by K. Tagami ============== 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! ========================================================================= 11.0
          ibase = mp_kngp*(is-1)
          do i = istart, iend
             cpm(i,is) = prj_wk(i + ibase)
          end do
       end do
!!$       do i = istart, iend
!!$          cpm(i) = prj_wk(i - is_kngp(ip)+1)
!!$!!$          cpm(i) = prj_wk(i -is_kngp(ip)+1,1,1)
!!$       end do
!!$!!$       cpm(istart:iend) = prj_wk(istart-is_kngp(ip)+1:iend-is_kngp(ip)+1,1,1)
! <--
    end do
  end subroutine scatter_cp_onto_cpm

  subroutine concentrate_d_to_chg(d,c)
! ============================= modified by K. Tagami ====================== 11.0
!    real(DP),intent(in),dimension(ista_kgpm:iend_kgpm,kimg,nspin) :: d
!    real(DP),intent(out), dimension(ista_kngp:iend_kngp,kimg,nspin) :: c
    real(DP),intent(in),dimension(ista_kgpm:iend_kgpm,kimg,ndim_magmom) :: d
    real(DP),intent(out), dimension(ista_kngp:iend_kngp,kimg,ndim_magmom) :: c
! =========================================================================== 11.0

    integer :: ip,is,istart,iend,nelmnt,ik,i,ip2,ipbase
!!$    integer :: istart_p, iend_p

#ifdef __TIMER_SUB__
    call timer_sta(1122)
#endif
    if(kgpm < kgp .and. npes /= 1) then
       nelmnt = mp_kgpm*kimg*nspin_m
       do ip = 0, npes - 1
          if(is_kngp(ip) > kgpm) exit
          do ip2 = 0, npes - 1
             istart = is_kgpm(ip2); if(istart < is_kngp(ip)) istart = is_kngp(ip)
             iend   = ie_kgpm(ip2); if(iend   > ie_kngp(ip)) iend   = ie_kngp(ip)
             if(iend < istart) cycle
             if(mype == ip2) then

#ifdef __TIMER_DO__
  call timer_sta(1171)
#endif
! ================================ modified by K. Tagami ================= 11.0
!                do is = 1, nspin, af+1
                do is = 1, ndim_magmom, af+1
! ======================================================================== 11.0
                   do ik = 1, kimg
                      ipbase = mp_kgpm*(ik-1) + mp_kgpm*kimg*(is-1) - istart + 1
                      do i = istart, iend
                         prj_wk(i+ipbase) = d(i,ik,is)
                      end do
                   end do
                end do
                                                  __TIMER_DO_STOP(1171)
                call mpi_send(prj_wk,nelmnt,mpi_double_precision,ip,1,mpi_comm_group,ierr)
             end if
             if(mype == ip) then
                call mpi_recv(prj_wk,nelmnt,mpi_double_precision,ip2,1,mpi_comm_group,istatus,ierr)
                                                  __TIMER_DO_START(1173)
! ================================ modified by K. Tagami ================= 11.0
!                do is = 1, nspin, af+1
                do is = 1, ndim_magmom, af+1
! ======================================================================== 11.0
                   do ik = 1, kimg
                      ipbase = mp_kgpm*(ik-1) + mp_kgpm*kimg*(is-1) - istart + 1
                      do i = istart, iend
                         c(i,ik,is) = prj_wk(i+ipbase)
                      end do
                   end do
                end do
                                                  __TIMER_DO_STOP(1173)
             end if
             call mpi_barrier(mpi_comm_group,ierr)
          end do
       end do
    end if
#ifdef __TIMER_SUB__
    call timer_end(1122)
#endif
  end subroutine concentrate_d_to_chg

  subroutine mix_dealloc_previous()
    if(previous_waymix == BROYD2) then
       call mix_broyden_deallocate()
    else if(previous_waymix == PULAY) then
       call mix_PULAY_deallocate()
    end if
  end subroutine mix_dealloc_previous

  subroutine mix_broyden_allocate
!!$    if(allocated(f_p)) return

! ========================= modified by K. Tagami =================== 11.0
!    nspin_m  = nspin/(af+1)
!
    if ( noncol ) then
       nspin_m  = ndim_magmom
    else
       nspin_m  = nspin/(af+1)
    endif
! ====================================================================== 11.0

! ================================ Modofied by K. Tagami ===========
!    allocate(f_p(ista_kgpm:iend_kgpm)); call precon_4_mult(f_p) !-(m_KE)
    allocate(f_p(ista_kgpm:iend_kgpm)); f_p = 0.0d0
    call precon_4_mult(f_p) !-(m_KE)
    f_p = 1.0d0
! ================================================================

    allocate(din(ista_kgpm:iend_kgpm,kimg,nspin_m))
    allocate(dout(ista_kgpm:iend_kgpm,kimg,nspin_m))
    allocate(dF_l(ista_kgpm:iend_kgpm,kimg,nspin_m))
    allocate(urec_l(ista_kgpm:iend_kgpm,kimg,nspin_m,nbxmix,2))
    allocate(prj_wk(mp_kngp*kimg*nspin_m))
! ======================================Added by K. Tagami ========
    din = 0.0d0; dout = 0.0d0; dF_l = 0.0d0; urec_l = 0.0d0; prj_wk = 0.0d0
! ==================================================================
    if(hownew == RENEW) then
! ============================= modified by K. Tagami =========== 11.0
!       allocate(f(nbxmix,nbxmix,nspin))
!
       if ( noncol ) then
          allocate(f(nbxmix,nbxmix,ndim_magmom))
       else
          allocate(f(nbxmix,nbxmix,nspin))
       endif
! =============================================================== 11.0
       allocate(g(nbxmix))
! ================================= Added by K. Tagami ==========
        f = 0.0d0; g = 0.0d0
! ==============================================================
    end if
    allocate(ncrspd(nbxmix))
! ================================= Added by K. Tagami ==========
        ncrspd = 0
! ==============================================================
  end subroutine mix_broyden_allocate

  subroutine mix_broyden_deallocate
    if(allocated(f_p)) deallocate(f_p)
    if(allocated(din)) deallocate(din)
    if(allocated(dout)) deallocate(dout)
    if(allocated(dF_l)) deallocate(dF_l)
    if(allocated(urec_l)) deallocate(urec_l)
    if(allocated(prj_wk)) deallocate(prj_wk)
    if(allocated(f)) deallocate(f)
    if(allocated(g)) deallocate(g)
    if(allocated(ncrspd)) deallocate(ncrspd)
  end subroutine mix_broyden_deallocate

  subroutine mix_broyden_alloc2
    allocate(d0_l(ista_kgpm:iend_kgpm,kimg,nspin_m))
    allocate(u_l(ista_kgpm:iend_kgpm,kimg,nspin_m))
    allocate(v_l(ista_kgpm:iend_kgpm,kimg,nspin_m))
! =========================================== Added by K. Tagami =======
    d0_l = 0; u_l = 0; v_l = 0
! =======================================================================
    call alloc_rho_rhoo_and_cpm
  end subroutine mix_broyden_alloc2

  subroutine alloc_rho_rhoo_and_cpm
    if(kgpm < kgp .and. npes /= 1 ) then
       allocate(rho(ista_kgpm:iend_kgpm,kimg,nspin_m))
       allocate(rhoo(ista_kgpm:iend_kgpm,kimg,nspin_m))
       allocate(c_pm(ista_kgpm:iend_kgpm,nspin_m))
! ============================================= Added by K. Tagami ======
       rho = 0.0d0; rhoo = 0.0d0 ; c_pm = 0.0d0
! =======================================================================
       call scatter_chg_onto_d(kinq_l,rho)
       call scatter_chg_onto_d(kinqo_l,rhoo)
       call scatter_cp_onto_cpm(c_p,c_pm)
    else
       rho => kinq_l; rhoo => kinqo_l; c_pm => c_p
    end if
  end subroutine alloc_rho_rhoo_and_cpm

  subroutine mix_broyden_dealloc2
    deallocate(d0_l); deallocate(u_l); deallocate(v_l)
    call dealloc_rho_rhoo_and_cpm
  end subroutine mix_broyden_dealloc2

  subroutine dealloc_rho_rhoo_and_cpm
    if(kgpm < kgp .and. npes /= 1) deallocate(rho)
    if(kgpm < kgp .and. npes /= 1) deallocate(rhoo)
    if(kgpm < kgp .and. npes /= 1) deallocate(c_pm)
  end subroutine dealloc_rho_rhoo_and_cpm

  subroutine mix_broyden_alloc3
#ifdef __TIMER_SUB__
    call timer_sta(1109)
#endif
    allocate(d0_l(ista_kgpm:iend_kgpm,kimg,nspin_m))
    allocate(u_l(ista_kgpm:iend_kgpm,kimg,nspin_m))
    allocate(v_l(ista_kgpm:iend_kgpm,kimg,nspin_m))
    allocate(dd_l(ista_kgpm:iend_kgpm,kimg,nspin_m))
! =========================================== Added by K. Tagami ===
    d0_l = 0.0d0; u_l = 0.0d0; v_l = 0.0d0; dd_l = 0.0d0
! =================================================================
    call alloc_rho_rhoo_and_cpm
#ifdef __TIMER_SUB__
    call timer_end(1109)
#endif
  end subroutine mix_broyden_alloc3

  subroutine mix_broyden_dealloc3
    deallocate(d0_l); deallocate(u_l); deallocate(v_l); deallocate(dd_l)
    call dealloc_rho_rhoo_and_cpm
  end subroutine mix_broyden_dealloc3

!!! ========================== added by K. Tagami ================ 5.0
  subroutine alloc_rhostore_recomp( rmxt, rmxtrc )
    real(kind=DP),intent(in) :: rmxt
    real(kind=DP),intent(out),dimension(nspin_m) :: rmxtrc

    allocate( rhoo_store( nsize_rho_vhsr,nspin) )
    allocate( rho_store( nsize_rho_vhsr,nspin) )

    rho_store = rho_vhsr;      rhoo_store = rhoo_vhsr

     rho_vhsr(:,1) =  rho_store(:,1) +  rho_store(:,2)
     rho_vhsr(:,2) =  rho_store(:,1) -  rho_store(:,2)
    rhoo_vhsr(:,1) = rhoo_store(:,1) + rhoo_store(:,2)
    rhoo_vhsr(:,2) = rhoo_store(:,1) - rhoo_store(:,2)
    rmxtrc(1) = rmxt;     rmxtrc(2) = rmxt*spin_density_mixfactor

  end subroutine alloc_rhostore_recomp

  subroutine compose_rho_dealloc_store
    rho_store = rho_vhsr

    rho_vhsr(:,1) = 0.5d0*( rho_store(:,1) + rho_store(:,2) )
    rho_vhsr(:,2) = 0.5d0*( rho_store(:,1) - rho_store(:,2) )

    rhoo_vhsr(:,1) = 0.5d0*( rhoo_store(:,1) + rhoo_store(:,2) )
    rhoo_vhsr(:,2) = 0.5d0*( rhoo_store(:,1) - rhoo_store(:,2) )

!    rhoo_vhsr = rhoo_store
    deallocate( rho_store, rhoo_store )

  end subroutine compose_rho_dealloc_store

 subroutine simple_mix_kt(rmx_this)
    real(kind=DP), intent(in) :: rmx_this(nspin_m)

    din_vhsr   = rhoo_vhsr ! kinqo
    dout_vhsr  = rho_vhsr  ! kinq
    rho_vhsr(:,1) = rmx_this(1) *dout_vhsr(:,1) + ( 1.0D0 - rmx_this(1) )* din_vhsr(:,1)
    if(nspin_m==2) rho_vhsr(:,2) = rmx_this(2) *dout_vhsr(:,2) + ( 1.0D0 - rmx_this(2) )* din_vhsr(:,2)

! ===================== added by K. Tagami ================================ 11.0
    if ( noncol ) then
       rho_vhsr(:,2) = rmx_this(2) *dout_vhsr(:,2) + ( 1.0D0 -rmx_this(2) )* din_vhsr(:,2)
       rho_vhsr(:,3) = rmx_this(3) *dout_vhsr(:,3) + ( 1.0D0 -rmx_this(3) )* din_vhsr(:,3)
       rho_vhsr(:,4) = rmx_this(4) *dout_vhsr(:,4) + ( 1.0D0 -rmx_this(4) )* din_vhsr(:,4)
    endif
! ========================================================================= 11.0

  end subroutine simple_mix_kt

  subroutine simple_mix2_kt(rmx_this)
    real(kind=DP), intent(in) :: rmx_this(nspin_m)

    if(nspin_m==2)then
        din_vhsr(:,2)  = rhoo_vhsr(:,2)         ! kinqo
       dout_vhsr(:,2)  =  rho_vhsr(:,2)          ! kinq
       rho_vhsr(:,2) = rmx_this(2) *dout_vhsr(:,2) + ( 1.0D0 - rmx_this(2) )* din_vhsr(:,2)
    endif
! ===================== added by K. Tagami ================================ 11.0
    if ( noncol ) then
       din_vhsr(:,2)  = rhoo_vhsr(:,2);     dout_vhsr(:,2)  =  rho_vhsr(:,2) 
       rho_vhsr(:,2) = rmx_this(2) *dout_vhsr(:,2) + ( 1.0D0 -rmx_this(2) )* din_vhsr(:,2)
       din_vhsr(:,3)  = rhoo_vhsr(:,3);     dout_vhsr(:,3)  =  rho_vhsr(:,3) 
       rho_vhsr(:,3) = rmx_this(3) *dout_vhsr(:,3) + ( 1.0D0 -rmx_this(3) )* din_vhsr(:,3)
       din_vhsr(:,4)  = rhoo_vhsr(:,4);     dout_vhsr(:,4)  =  rho_vhsr(:,4) 
       rho_vhsr(:,4) = rmx_this(4) *dout_vhsr(:,4) + ( 1.0D0 -rmx_this(4) )* din_vhsr(:,4)
    endif
! ========================================================================== 11.0

  end subroutine simple_mix2_kt

  subroutine mix_dealloc_previous_vhsr()
    if(previous_waymix == BROYD2) then
       call mix_broyden_deallocate_vhsr()
    else if(previous_waymix == PULAY) then
       call mix_PULAY_deallocate_vhsr()
    end if
  end subroutine mix_dealloc_previous_vhsr

  subroutine mix_broyden_allocate_vhsr
! ========================= modified by K. Tagami =================== 11.0
!    nspin_m  = nspin/(af+1)
!
    if ( noncol ) then
       nspin_m  = ndim_magmom
    else
       nspin_m  = nspin/(af+1)
    endif
! ====================================================================== 11.0
    allocate( din_vhsr(nsize_rho_vhsr,nspin_m) )
    allocate( dout_vhsr(nsize_rho_vhsr,nspin_m))
    allocate( dF_vhsr(nsize_rho_vhsr,nspin_m))
    allocate( urec_vhsr(nsize_rho_vhsr,nspin_m,nbxmix,2) )   	
!
    din_vhsr = 0.0d0; dout_vhsr = 0.0d0; dF_vhsr = 0.0d0; urec_vhsr = 0.0d0
!
  end subroutine mix_broyden_allocate_vhsr

  subroutine mix_broyden_deallocate_vhsr
    if(allocated(din_vhsr)) deallocate(din_vhsr)
    if(allocated(dout_vhsr)) deallocate(dout_vhsr)
    if(allocated(dF_vhsr)) deallocate(dF_vhsr)
    if(allocated(urec_vhsr)) deallocate(urec_vhsr)
  end subroutine mix_broyden_deallocate_vhsr

  subroutine mix_broyden_alloc2_vhsr
    allocate( d0_vhsr( nsize_rho_vhsr,nspin_m ) ); d0_vhsr = 0.0d0
    allocate(  u_vhsr( nsize_rho_vhsr,nspin_m ) );  u_vhsr = 0.0d0
    allocate(  v_vhsr( nsize_rho_vhsr,nspin_m ) );  v_vhsr = 0.0d0
  end subroutine mix_broyden_alloc2_vhsr

 subroutine mix_broyden_dealloc2_vhsr
    deallocate(d0_vhsr); deallocate(u_vhsr); deallocate(v_vhsr)
  end subroutine mix_broyden_dealloc2_vhsr

  subroutine mix_broyden_alloc3_vhsr
    allocate( d0_vhsr( nsize_rho_vhsr,nspin_m ) ); d0_vhsr = 0.0d0
    allocate(  u_vhsr( nsize_rho_vhsr,nspin_m ) );  u_vhsr = 0.0d0
    allocate(  v_vhsr( nsize_rho_vhsr,nspin_m ) );  v_vhsr = 0.0d0
    allocate( dd_vhsr( nsize_rho_vhsr,nspin_m ) ); dd_vhsr = 0.0d0
  end subroutine mix_broyden_alloc3_vhsr

  subroutine mix_broyden_dealloc3_vhsr
    deallocate(d0_vhsr); deallocate(u_vhsr); deallocate(v_vhsr); deallocate(dd_vhsr)
  end subroutine mix_broyden_dealloc3_vhsr

 subroutine mix_pulay_allocate_vhsr
! ========================= modified by K. Tagami =================== 11.0
!    nspin_m  = nspin/(af+1)
!
    if ( noncol ) then
       nspin_m  = ndim_magmom
    else
       nspin_m  = nspin/(af+1)
    endif
! ====================================================================== 11.0
    allocate(  din_vhsr( nsize_rho_vhsr,nspin_m ) );  din_vhsr = 0.0d0
    allocate( dout_vhsr( nsize_rho_vhsr,nspin_m ) ); dout_vhsr = 0.0d0
    allocate(   dF_vhsr( nsize_rho_vhsr,nspin_m ) );   dF_vhsr = 0.0d0
    allocate( urec_vhsr( nsize_rho_vhsr,nspin_m,nbxmix,2) ); urec_vhsr = 0.0d0
    if(sw_gradient_simplex==ON)then
       allocate(rhoj_vhsr(nsize_rho_vhsr,nspin_m,nbxmix));rhoj_vhsr=0.d0
       allocate(Frhoj_vhsr(nsize_rho_vhsr,nspin_m,nbxmix));Frhoj_vhsr=0.d0
       allocate(rhoj_vhsro(nsize_rho_vhsr,nspin_m));rhoj_vhsro=0.d0
       allocate(Frhoj_vhsro(nsize_rho_vhsr,nspin_m));Frhoj_vhsro=0.d0
    endif
  end subroutine mix_pulay_allocate_vhsr

  subroutine mix_pulay_deallocate_vhsr
    if ( allocated( din_vhsr)) deallocate( din_vhsr)
    if ( allocated(dout_vhsr)) deallocate(dout_vhsr)
    if ( allocated(  dF_vhsr)) deallocate(  dF_vhsr)
    if ( allocated(urec_vhsr)) deallocate(urec_vhsr)
    if ( allocated(rhoj_vhsr)) deallocate(rhoj_vhsr)
    if ( allocated(Frhoj_vhsr)) deallocate(Frhoj_vhsr)
    if ( allocated(rhoj_vhsro)) deallocate(rhoj_vhsro)
    if ( allocated(Frhoj_vhsro)) deallocate(Frhoj_vhsro)
  end subroutine mix_pulay_deallocate_vhsr

  subroutine mix_pulay_alloc2_vhsr
    allocate( d0_vhsr( nsize_rho_vhsr,nspin_m) ); d0_vhsr = 0.0d0
  end subroutine mix_pulay_alloc2_vhsr

  subroutine mix_pulay_dealloc2_vhsr
    deallocate(d0_vhsr)
  end subroutine mix_pulay_dealloc2_vhsr

! ===================================================================== 5.0

  integer function nspin_for_qnewton()
! ================================= modified by K. Tagami ============= 11.0
!     nspin_for_qnewton=nspin
!     if (sw_force_simple_mixing==ON .and. sw_recomposing==ON) nspin_for_qnewton=1
!
    if ( noncol ) then
       nspin_for_qnewton=ndim_magmom
    else
       nspin_for_qnewton=nspin
       if (sw_force_simple_mixing==ON .and. sw_recomposing==ON) nspin_for_qnewton=1
    endif
! ========================================================================== 11.0
  end function nspin_for_qnewton

  subroutine renew_u_br(j,i)
    integer, intent(in) :: j,i

! === DEBUG by tkato 2011/11/24 ================================================
!   real(DP)      :: v_dF(nspin)
    real(DP)      :: v_dF(nspin_m)
! ==============================================================================
#ifdef __TIMER_SUB__
    call timer_sta(1113)
#endif
#ifdef _CDMIX_USE_POINTER_
    urec_l_3 => urec_l(ista_kgpm:iend_kgpm,1:kimg,1:nspin_m,j,iV)
    call mult1s(urec_l_3,dF_l,f_p,v_dF)!-(m_KE);<v|dF> ->v_dF
#else
    call mult1s5(urec_l,nbxmix,2,j,iV,dF_l,f_p,v_dF)
#endif
    if ( nspin_m==2 .and. sw_mix_bothspins_sametime == YES ) then
      v_dF(1) = v_dF(1) + v_dF(2)
      v_df(2) = v_dF(1)
    endif

! ============================== added by K.Tagami ================= 11.0
    if ( noncol ) then
       v_dF(1) = sum( v_dF(:) )
       v_dF(:) = v_dF(1)
    endif
! ================================================================== 11.0

    call subtr_j_th_term(v_dF,iU,j,u_l)  !-(m_KE)

    !                        |u(m)> = |u(m)> - <v(j)|dF(m)>|u(j)>
! === DEBUG by tkato 2011/11/24 ================================================
!   if(hownew == RENEW) f(j,i,1:nspin) = v_dF(1:nspin)
    if(hownew == RENEW) f(j,i,1:nspin_m) = v_dF(1:nspin_m)
! ==============================================================================
#ifdef __TIMER_SUB__
    call timer_end(1113)
#endif
  end subroutine renew_u_br

  subroutine renew_d_br(j)
    integer, intent(in) :: j
! === DEBUG by tkato 2011/11/24 ================================================
!   real(DP)  :: vF(nspin)
    real(DP)  :: vF(nspin_m)
! ==============================================================================
#ifdef __TIMER_SUB__
    call timer_sta(1118)
#endif
#ifdef _CDMIX_USE_POINTER_
    urec_l_3 => urec_l(ista_kgpm:iend_kgpm,1:kimg,1:nspin_m,j,iV)
    call mult1s(urec_l_3,F_l,f_p,vF) !-(m_KE);<v|F>  ->vF
#else
    call mult1s5(urec_l,nbxmix,2,j,iV,F_l,f_p,vF) !-(m_KE);<v|F>  ->vF
#endif
! === DEBUG by tkato 2011/11/24 ================================================
!   if ( nspin==2 .and. sw_mix_bothspins_sametime == YES ) then
    if ( nspin_m==2 .and. sw_mix_bothspins_sametime == YES ) then
! ==============================================================================
      vF(1) = vF(1) + vF(2)
      vF(2) = vF(1)
    endif

! ================================= added by K. Tagami =============== 11.0
    if ( noncol ) then
       vF(1) = sum( vF(:) )
       vF(:) = vF(1)
    endif
! ===================================================================== 11.0

    call subtr_j_th_term(vF,iU,j,d0_l) !-(m_KE)
    !                        |d(m)> = |d(m)> - <v(j)|F(m)>|u(j)>
#ifdef __TIMER_SUB__
    call timer_end(1118)
#endif
  end subroutine renew_d_br

  subroutine renew_d_last_br(p)
    real(DP), intent(in), dimension(ista_kngp:iend_kngp) :: p
    integer   :: is, ik, i, ns
! === DEBUG by tkato 2011/11/24 ================================================
!   real(DP)  :: vF(nspin)
    real(DP)  :: vF(nspin_m)
! ==============================================================================
#ifdef __TIMER_SUB__
    call timer_sta(1120)
#endif

    call mult1s(v_l,F_l,f_p,vF)              !-(m_KE) <v|F> ->vF

! === DEBUG by tkato 2011/11/24 ================================================
!   if ( nspin==2 .and. sw_mix_bothspins_sametime == YES ) then
    if ( nspin_m==2 .and. sw_mix_bothspins_sametime == YES ) then
! ==============================================================================
      vF(1) = vF(1) + vF(2)
      vF(2) = vF(1)
    endif

! ============================ added by K.Tagami ====================== 11.0
    if ( noncol ) then
       vF(1) = sum( vF(:) )
       vF(:) = vF(1)
    endif
! ====================================================================== 11.0

    if(kgpm == kgp .or. npes == 1) then

#ifdef __TIMER_DO__
  call timer_sta(1166)
#endif
! ===================================== modified by K. Tagami ============== 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! ========================================================================== 11.0
          din (:,:,is) = kinqo_l(ista_kgpm:iend_kgpm,:,is)
          dout(:,:,is) = kinq_l (ista_kgpm:iend_kgpm,:,is)
       end do
#ifdef __TIMER_DO__
  call timer_end(1166)
#endif
    else
       call scatter_chg_onto_d(kinqo_l,din )  ! -(m_C.D.)
       call scatter_chg_onto_d(kinq_l, dout)  ! -(m_C.D.)
    end if

!!$    do is = 1, nspin, af+1
    ns = nspin_for_qnewton()
#ifdef __TIMER_DO__
  call timer_sta(1167)
#endif
    do is = 1, ns,af+1
       do ik = 1, kimg
          do i = ista_kgpm,iend_kgpm
             rho(i,ik,is) = d0_l(i,ik,is) - vF(is)*u_l(i,ik,is)
          end do
       end do
    end do
#ifdef __TIMER_DO__
  call timer_end(1167)
#endif

! ====================================== modified by K. Tagami ============ 11.0
!    if(sw_force_simple_mixing==ON .and. sw_recomposing==ON) call simple_mix2(c_p)
!
    if ( .not. noncol ) then
       if (sw_force_simple_mixing==ON .and. sw_recomposing==ON) then
          call simple_mix2(c_p)
       endif
    endif

! =========================================================================== 11.0

    if(kgpm < kgp) then
       call concentrate_d_to_chg(rho,kinq_l) !-(m_C.D.)
       call simple_mix_large_Gc(p)           !-(m_C.D.) kinq,kinqo,p ->kinq
    end if
#ifdef __TIMER_SUB__
    call timer_end(1120)
#endif
  end subroutine renew_d_last_br

! =========================== added by K. Tagami ================================== 5.0
  subroutine renew_u_br_with_vhsr(j,i)
    integer, intent(in) :: j,i

    integer       :: is
! === DEBUG by tkato 2011/11/24 ================================================
!   real(DP)      :: v_dF(nspin)
    real(DP)      :: v_dF(nspin_m)
! ==============================================================================

    v_dF = 0.d0

#ifdef _CDMIX_USE_POINTER_
    urec_l_3 => urec_l(ista_kgpm:iend_kgpm,1:kimg,1:nspin_m,j,iV)
    call mult1s(urec_l_3,dF_l,f_p,v_dF)!-(m_KE);<v|dF> ->v_dF
#else
    call mult1s5(urec_l,nbxmix,2,j,iV,dF_l,f_p,v_dF)
#endif

! =================================== modified by K. Tagami ============ 11.0
!       do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ======================================================================= 11.0
       v_dF(is) = v_dF(is) + sum( urec_vhsr(:,is,j,iV)*dF_vhsr(:,is) )
    End do
!
! === DEBUG by tkato 2011/11/24 ================================================
!   if ( nspin==2 .and. sw_mix_bothspins_sametime == YES ) then
    if ( nspin_m==2 .and. sw_mix_bothspins_sametime == YES ) then
! ==============================================================================
      v_dF(1) = v_dF(1) + v_dF(2)
      v_df(2) = v_dF(1)
    endif
!
! ======================== added by K. Tagami ==================== 11.0
    if ( noncol ) then
       v_dF(1) = sum( v_dF(:) )
       v_dF(:) = v_dF(1)
    endif
! ================================================================ 11.0

    call subtr_j_th_term(v_dF,iU,j,u_l)  !-(m_KE)
    !                        |u(m)> = |u(m)> - <v(j)|dF(m)>|u(j)>

! =================================== modified by K. Tagami ============ 11.0
!       do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ======================================================================= 11.0
       u_vhsr(:,is) = u_vhsr(:,is) - v_dF(is) *urec_vhsr(:,is,j,iU)
    End do
! === DEBUG by tkato 2011/11/24 ================================================
!   if(hownew == RENEW) f(j,i,1:nspin) = v_dF(1:nspin)
    if(hownew == RENEW) f(j,i,1:nspin_m) = v_dF(1:nspin_m)
! ==============================================================================

  end subroutine renew_u_br_with_vhsr

  subroutine renew_d_br_with_vhsr(j)
    integer, intent(in) :: j
! === DEBUG by tkato 2011/11/24 ================================================
!   real(DP)  :: vF(nspin)
    real(DP)  :: vF(nspin_m)
! ==============================================================================
    integer :: is

    vF = 0.d0

#ifdef _CDMIX_USE_POINTER_
    urec_l_3 => urec_l(ista_kgpm:iend_kgpm,1:kimg,1:nspin_m,j,iV)
    call mult1s(urec_l_3,F_l,f_p,vF) !-(m_KE);<v|F>  ->vF
#else
    call mult1s5(urec_l,nbxmix,2,j,iV,F_l,f_p,vF) !-(m_KE);<v|F>  ->vF
#endif

! =================================== modified by K. Tagami ============ 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! ======================================================================= 11.0
      vF(is) = vF(is) + sum( urec_vhsr(:,is,j,iV)*FF_vhsr(:,is) )
    End do

! === DEBUG by tkato 2011/11/24 ================================================
!   if ( nspin==2 .and. sw_mix_bothspins_sametime == YES ) then
    if ( nspin_m==2 .and. sw_mix_bothspins_sametime == YES ) then
! ==============================================================================
      vF(1) = vF(1) + vF(2)
      vF(2) = vF(1)
    endif

! ======================== added by K. Tagami ==================== 11.0
    if ( noncol ) then
       vF(1) = sum( vF(:) )
       vF(:) = vF(1)
    endif
! ================================================================ 11.0

    call subtr_j_th_term(vF,iU,j,d0_l) !-(m_KE)
    !                        |d(m)> = |d(m)> - <v(j)|F(m)>|u(j)>

! =================================== modified by K. Tagami ============ 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! ======================================================================= 11.0
       d0_vhsr(:,is) = d0_vhsr(:,is) - vF(is) *urec_vhsr(:,is,j,iU)
    end do
  end subroutine renew_d_br_with_vhsr

  subroutine renew_d_last_br_with_vhsr( p, rmxtrc_vhsr )
    real(DP), intent(in), dimension(ista_kngp:iend_kngp) :: p
    real(DP), intent(in) :: rmxtrc_vhsr(nspin_m)

    integer   :: is, ik, i, ns
! === DEBUG by tkato 2011/11/24 ================================================
!   real(DP)  :: vF(nspin)
    real(DP)  :: vF(nspin_m)
! ==============================================================================

    vF = 0.0d0
    call mult1s(v_l,F_l,f_p,vF)              !-(m_KE) <v|F> ->vF

! =================================== modified by K. Tagami ============ 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! ======================================================================= 11.0
       vF(is) = vF(is) + sum( v_vhsr(:,is)*FF_vhsr(:,is) )
    End do

! === DEBUG by tkato 2011/11/24 ================================================
!   if ( nspin==2 .and. sw_mix_bothspins_sametime == YES ) then
    if ( nspin_m==2 .and. sw_mix_bothspins_sametime == YES ) then
! ==============================================================================
      vF(1) = vF(1) + vF(2)
      vF(2) = vF(1)
    endif

! ========================== added by K. Tagami =============== 11.0
    if ( noncol ) then
       vF(1) = sum( vF(:) )
       vF(:) = vF(1)
    endif
! ============================================================= 11.0

    if(kgpm == kgp .or. npes == 1) then

! =================================== modified by K. Tagami ============ 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! ======================================================================= 11.0
          din (:,:,is) = kinqo_l(ista_kgpm:iend_kgpm,:,is)
          dout(:,:,is) = kinq_l (ista_kgpm:iend_kgpm,:,is)
       end do
    else
       call scatter_chg_onto_d(kinqo_l,din )  ! -(m_C.D.)
       call scatter_chg_onto_d(kinq_l, dout)  ! -(m_C.D.)
    end if

! =================================== modified by K. Tagami ============ 11.0
!     do is = 1, nspin, af+1
     do is = 1, ndim_magmom, af+1
! ======================================================================= 11.0
       din_vhsr (:,is) = rhoo_vhsr(:,is) ! kinqo
       dout_vhsr(:,is) = rho_vhsr (:,is) ! kinq
    end do

!!$    do is = 1, nspin, af+1
    ns = nspin_for_qnewton()
    do is = 1, ns,af+1
       do ik = 1, kimg
          do i = ista_kgpm,iend_kgpm
             rho(i,ik,is) = d0_l(i,ik,is) - vF(is)*u_l(i,ik,is)
          end do
       end do
    end do

    do is = 1, ns, af+1
       rho_vhsr(:,is) = d0_vhsr(:,is) - vF(is) *u_vhsr(:,is)
    end do

! ====================================== modified by K. Tagami ============ 11.0
!    if(sw_force_simple_mixing==ON .and. sw_recomposing==ON) call simple_mix2(c_p)
!
!    if ( sw_force_simple_mixing_hsr==ON .and. sw_recomposing_vhsr==ON ) then
!       call simple_mix2_kt( rmxtrc_vhsr )
!    endif

    if ( .not. noncol ) then
       if (sw_force_simple_mixing==ON .and. sw_recomposing==ON) then
          call simple_mix2(c_p)
       endif
       if ( sw_force_simple_mixing_hsr==ON .and. sw_recomposing_hsr==ON ) then
          call simple_mix2_kt( rmxtrc_vhsr )
       endif
    endif
! =========================================================================== 11.0

    if(kgpm < kgp) then
       call concentrate_d_to_chg(rho,kinq_l) !-(m_C.D.)
       call simple_mix_large_Gc(p)           !-(m_C.D.) kinq,kinqo,p ->kinq
    end if
  end subroutine renew_d_last_br_with_vhsr

! ============================================================================ 5.0

  subroutine simple_mix_large_Gc(p)
    real(kind=DP), intent(in), dimension(ista_kngp:iend_kngp) :: p

    integer :: istart, iend, is, ik, i
#ifdef __TIMER_SUB__
    call timer_sta(1123)
#endif
    istart = kgpm + 1; if(istart < ista_kngp) istart = ista_kngp
    iend   = kgp;      if(iend   > iend_kngp) iend   = iend_kngp
#ifdef __TIMER_DO__
  call timer_sta(1174)
#endif
    if(iend >= istart) then
! =================================== modified by K. Tagami ============ 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! ======================================================================= 11.0
          do ik = 1, kimg
             do i = istart, iend
                kinq_l(i,ik,is) = p(i)*kinq_l(i,ik,is) + (1.0d0-p(i))*kinqo_l(i,ik,is)
             end do
          end do
       end do
    end if
#ifdef __TIMER_DO__
  call timer_end(1174)
#endif
#ifdef __TIMER_SUB__
    call timer_end(1123)
#endif
  end subroutine simple_mix_large_Gc

! <<< Quasi-Newton Methods >>>
!  1. Broyden's 1st method
!  2. Broyden's 2nd method
!  3. DFP method
!
! In Quasi-Newton method, following set of equations are used.
!
!\begin{equation}
!\rho^{(m+1)}  = \rho^{(m)} - \lambda^{(m)} \left[ {\bf J} ^{(m)}\right]^{-1} {\cal F}^{(m)}
!\end{equation}
!
!\begin{equation}
!  \left[ {\bf J}^{(m+1)}\right]^{-1} \Delta {\cal F}^{(m+1)} = \Delta
!  \rho ^{(m+1)}
!\end{equation}
!
! $\lambda^{(m)}$ in the first euqation is a parameter of one
! dimensional search. And ${\bf J}^{(m+1)}$ is an approximate value of
! true Jacobian{\cal J}. In this program we fix this value of
! $\lambda^{(m)}$ to be 1.
! $\Delta {\cal F}^{(m+1)}$ and $\Delta \rho^{(m+1)}$ are definded as
! follows.
!
!\begin{equation}
!  \Delta {\cal F}^{(m+1)} = {\cal F}^{(m+1)} - {\cal F}^{(m)},
!\end{equation}
! where ${\cal F}^{(m)} = \rho^{out,(m)} - \rho^{in,(m)}$.
!
!\begin{equation}
!  \Delta \rho^{(m+1)} = \rho^{(m+1)} - \rho^{(m)}
!\end{equation}
!
! Three kinds of mixing ways implemented in this program,
! i.e. Broyden's 1st, Broyden's 2nd and DFP methods, differ in the
! way of approximation of the $\left[ {\bf J} ^{(m)}\right]^{-1}$. For
! combinience, we simply this description of the inverse of Jacobian
! as to be ${\bf J}^{-1(m)}$, hereafter.
!
! <<1>> Broyden's 1st method
!\begin{equation}
!{\bf J}^{-1(m)} = {\bf J}^{-1(m-1)} + \frac{\left[ | \Delta
!    \rho^{(m)}\rangle - {\bf J}^{-1(m-1)} | \Delta {\cal
!      F}^{(m)}\rangle \right] \otimes \langle \Delta \rho^{(m)} | {\bf
!    J}^{-1(m-1)}}{\langle\rho^{(m)}|{\bf J}^{-1(m-1)}| \Delta {\cal
!    F}^{(m)}\rangle}
!\end{equation}
!
! <<2>> Broyden's 2nd method
!\begin{equation}
!  {\bf J}^{-1(m)} = {\bf J}^{-1(m-1)} + \left[ |\Delta \rho^{(m)}
!    \rangle - {\bf J}^{-1(m-1)} | \Delta {\cal F}^{(m)} \right]
!  \otimes \frac{\langle \Delta {\cal F}^{(m)}|}{\| \Delta {\cal
!      F}^{(m)}\|^2}
!\end{equation}
!
! <<3>> DFP method
!DFP(Davidon-Fletcher-Powell) algorithm
!\begin{equation}
!  {\bf J}^{-1(m)} = {\bf J}^{-1(m-1)} + \frac{| \Delta
!    \rho^{(m)}\rangle \otimes \langle \Delta \rho^{(m)} |}
!   {\langle\rho^{(m)}|\Delta {\cal F}^{(m)}\rangle}
!   - \frac{|{\bf J}^{-1(m-1)}\Delta {\cal F}^{(m)}\rangle \otimes
!   \langle \Delta {\cal F}^{(m)}{\bf J}^{-1(m-1)}|}{\langle \Delta
!   {\cal F}^{(m)}|{\bf J}^{-1(m-1)}|\Delta {\cal F}^{(m)}\rangle}
!\end{equation}
!
! For reduction of memory space, we rewrite the Jacobian as linear
! combination of dyadic products.
!\begin{equation}
!  {\bf J}^{-1(m)} = -\alpha{\bf 1} + \sum_{i=2}^{m}|u^{(i)}\rangle
!  \otimes \langle v^{(i)}|
!\label{eq:JQN}
!\end{equation}
!Here, we used diagonal form for ${\bf J}^{-1(1)}$.
!\begin{equation}
!  {\bf J}^{-1(1)} = -\alpha {\bf 1}
!\end{equation}
!We can easily obtain $u^{(m)}$ and $v^{(m)}$ for the Broyden's 2nd
!method formula (eq.(\ref{eq:broyden2})).
!\begin{equation}
!  u^{(m)} = \Delta \rho^{(m)} + \alpha \Delta {\cal F}^{(m)} -
!  \sum_{i=2}^{m-1}\langle v^{(i)}|\Delta {\cal F}^{(m)}\rangle u^{(i)}
!\end{equation}
!\begin{equation}
!  v^{(m)} = \frac{1}{\parallel \Delta {\cal F}^{(m)}\parallel^2}
!  \Delta {\cal F}^{(m)}
!\end{equation}
!
!    a     : $\alpha$
!    d     : $\rho$
!    dd    : $\Delta \rho$
!    F     : $\cal F$
!    dF    : $\Delta F$
!

! dF_l   = dF  : $\Delta {\cal F}^{(m)}$
! d0_l    = d(m) + aF(m) - sum(i=2,m-1)<u(i)|F(m)>u(i)
! u_l      = u(m)
!          : $ u^{(m)} = \Delta \rho^{(m)} + \alpha \Delta {\cal F}^{(m)} -
!  \sum_{i=2}^{m-1}\langle v^{(i)}|\Delta {\cal F}^{(m)}\rangle u^{(i)}$
! v        = v(m)
!          : $ v^{(m)} = \frac{1}{\parallel \Delta {\cal F}^{(m)}\parallel^2}$
! din    = d(input,(m-1))   : $ \rho^{in, (m-1)}$ (:first and last),
!         or F(m)             : ${\cal F}^{(m)}$ (: as a transient array)
! dout    = d(output,(m-1))  : $ \rho^{out,(m-1)}$
!
!  J(m) = a + sum_{i=2}^m |u(i)><v(i)|
!  u(m) = dd(m) + a dF(m) - sum_{i=2}^{m-1} <v(i)|dF(m)>|u(i)>
!  v(m) = dF(m)/||dF(m)||
!
  subroutine m_KE_mix_broyden2(nfout,rmx)
    integer, intent(in) :: nfout
    real(DP),intent(in) :: rmx

    integer   :: iter,j,mxiter,icr,jcr
!!$    real(DP)  :: v_dF(nspin),vF(nspin)
    integer   :: id_sname = -1
! --> T. Yamasaki  03 Aug. 2009
    real(kind=DP), allocatable, dimension(:):: rmxtrc ! d(nspin_m)
!   real(kind=DP), allocatable, dimension(:,:,:) :: kinqstore_l, kinqostore_l
! <--
#ifdef __TIMER_SUB__
    call timer_sta(1124)
#endif
    call tstatc0_begin('m_KE_mix_broyden2 ',id_sname,1)

    if(previous_waymix /= BROYD2.or.force_dealloc) then
       call mix_dealloc_previous()
       call mix_broyden_allocate();    F_l => din
       force_dealloc = .false.
    end if

    allocate(rmxtrc(nspin_m))
    if ( noncol ) then
       rmxtrc(1:nspin_m) = rmx
    else
       if(sw_recomposing == YES .and. af == 0 .and. nspin == 2) then
          call alloc_kinqstore_recompos_kinq(rmx,rmxtrc) ! --> kinq_l, kinqo_l, rmxtrc
       else
          rmxtrc(1:nspin_m) = rmx
       end if
    endif
! ======================================================================== 11.0

! ====================== Modified by K. Tagami =========
!    allocate(c_p(ista_kngp:iend_kngp)); call precon_4_KE_mix(rmx,c_p)
! --> T. Yamasaki, 03rd Aug. 2009
!!$    allocate(c_p(ista_kngp:iend_kngp)); c_p = 0; call precon_4_KE_mix(rmx,c_p)
    allocate(c_p(ista_kngp:iend_kngp,nspin_m)); c_p = 0
! =======================================================


! ============================== modified by K. Tagami ================== 11.0
!    call precon_4_KE_mix(rmxtrc,c_p)
!
    if ( noncol ) then
       call precon_4_KE_mix_noncl(rmxtrc,c_p)
    else
       call precon_4_KE_mix(rmxtrc,c_p)
    endif
! ======================================================================== 11.0

    iter = iter_from_reset()                 !-(m_KE)

    if((iter-istrbr+1) <= 1) then
       call simple_mix1(c_p)                 !-(m_KE)
       !   din=kinqo_l; dout=kinq_l; (din,dout,c_p)->kinq_l
    else
!!$       stop ' -- iter-istrbr+1 > 1 (m_KE_mix_broyden2) --'
       call mix_broyden_alloc2   !-(m_KE) d0_l,u_l, and v_l are allocated
       call dF_F_d0_u_and_v      !-(c.h.)   dF_l, F_l, initial u_l,v_l,d0_l

       call set_ncrspd_mxiter_etc(iter,iU,mxiter) !-(m_KE) ->mxiter,ncrspd
       !                  when hownew == RENEW: f,g,ncrspd, and urec_l are reset.
       icr = icrspd_is(iter)                 !-(m_KE) function
       do j = 2, mxiter
          jcr = ncrspd(j)
          call renew_u_br(jcr,icr) !-(m_KE) |u(m)> = |u(m)> - <v(j)|dF(m)>|u(j)>
          call renew_d_br(jcr)     !-(m_KE) |d(m)> = |d(m)> - <v(j)|F(m)> |u(j)>
       enddo!j-loop

       urec_l(:,:,:,icr,iU) = u_l(:,:,:)  ! storing
       urec_l(:,:,:,icr,iV) = v_l(:,:,:)  ! storing

       call renew_d_last_br(c_p)       !-(m_KE) kinq_l(|d(m)>) = |d(m)>-<v(m)|F(m)>|u(m)>
       call mix_broyden_dealloc2                      !-(m_KE)
    endif

    if ( .not. noncol ) then
       if(sw_recomposing == YES .and. af == 0 .and. nspin == 2) then
          call compos_kinq_dealloc_kinqstore()
       end if
    endif
    deallocate(rmxtrc)

    deallocate(c_p)
    previous_waymix = BROYD2
    call tstatc0_end(id_sname)
#ifdef __TIMER_SUB__
    call timer_end(1124)
#endif
  contains
    subroutine dF_F_d0_u_and_v
      !   dF_l(=deltaF) = (rho - dout) - (rhoo - din)
      !   F_l = rho - rhoo (=\cal F^{m}); u_l  = (rhoo - din) + c_p*dF_l;
      !   d0_l = rhoo+c_p* F_l;              v_l = dF_l/( |dF_l| )

      integer                      :: is,k,i
      real(DP), dimension(nspin_m) :: fff
#ifdef __TIMER_SUB__
    call timer_sta(1125)
#endif
#ifdef __TIMER_DO__
  call timer_sta(1175)
#endif
! ======================================= modified by K. Tagami =========== 11.0
!      do is = 1, nspin, af+1
      do is = 1, ndim_magmom, af+1
! ========================================================================= 11.0

         do k = 1, kimg
            do i = ista_kgpm,iend_kgpm
!  Revised by T. Yamasaki, 2009/05/28 (Pointed out by Fukata-san (NEC))
!!$               dF_l(i,k,is) = (rho (i,k,is)-rhoo(i,k,is)) - (dout(i,k,is)-din(i,k,is))
!!$               d0_l(i,k,is) = rhoo(i,k,is) + c_pm(i)*(rho(i,k,is) - rhoo(i,k,is))
!!$               u_l(i,k,is)  = c_pm(i)*dF_l(i,k,is) + (rhoo(i,k,is) - din(i,k,is))
               dF_l(i,k,is) = (rho (i,k,is)-rhoo(i,k,is)) - (dout(i,k,is)-F_l(i,k,is))
               d0_l(i,k,is) = rhoo(i,k,is) + c_pm(i,is)*(rho(i,k,is) - rhoo(i,k,is))
               u_l(i,k,is)  = c_pm(i,is)*dF_l(i,k,is) + (rhoo(i,k,is) - F_l(i,k,is))
! ----
               F_l(i,k,is)  = rho(i,k,is) - rhoo(i,k,is)
            end do
            if(mype == 0) u_l(1,k,is) = 0.d0
         end do
      end do
#ifdef __TIMER_DO__
  call timer_end(1175)
#endif

      call mult1s(dF_l,dF_l,f_p,fff)
      if(sum(fff) < 1.d-40)  stop ' fmult is too small'

! === DEBUG by tkato 2011/11/24 ================================================
!     if ( nspin == 2 .and. sw_mix_bothspins_sametime == YES ) then
      if ( nspin_m == 2 .and. sw_mix_bothspins_sametime == YES ) then
! ==============================================================================
        fff(1) = fff(1) + fff(2)
        fff(2) = fff(1)
      endif

! ========================= added by K. Tagami =========================== 11.0
      if ( noncol ) then
         fff(1) = sum( fff(:) )
         fff(:) = fff(1)
      endif
! ======================================================================== 11.0

#ifdef __TIMER_DO__
  call timer_sta(1176)
#endif
! ========================================= modified by K. Tagami ========== 11.0
!      do is = 1, nspin, af+1
      do is = 1, ndim_magmom, af+1
! =========================================================================== 11.0
         v_l(:,:,is) = dF_l(:,:,is)/fff(is)
      end do
#ifdef __TIMER_DO__
  call timer_end(1176)
#endif

#ifdef __TIMER_SUB__
    call timer_end(1125)
#endif
    end subroutine dF_F_d0_u_and_v

  end subroutine m_KE_mix_broyden2

  subroutine mix_pulay_allocate
!!$    if(allocated(f_p)) return

! =============================== modified by K. Tagami ========== 11.0
!    nspin_m  = nspin/(af+1)
!
    if ( noncol ) then
       nspin_m  = ndim_magmom
    else
       nspin_m  = nspin/(af+1)
    endif
! ================================================================= 11.0

! =========================================== Modified by K. Tagami =========
!    allocate(f_p(ista_kgpm:iend_kgpm)); call precon_4_mult(f_p) !-(m_KE)
    allocate(f_p(ista_kgpm:iend_kgpm)); f_p = 0; call precon_4_mult(f_p) !-(m_KE)
! ============================================================================
    f_p = 1.0d0

    allocate(din(ista_kgpm:iend_kgpm,kimg,nspin_m))
    allocate(dout(ista_kgpm:iend_kgpm,kimg,nspin_m))
    allocate(urec_l(ista_kgpm:iend_kgpm,kimg,nspin_m,nbxmix,2))
    allocate(uuf_p(nbxmix,nspin_m))
    allocate(f(nbxmix,nbxmix,nspin_m))
    allocate(g_p(nbxmix,nspin_m))
    allocate(prj_wk(mp_kngp*kimg*nspin_m))
    allocate(ncrspd(nbxmix))

    if(sw_gradient_simplex==ON)then
       allocate(rhoj(ista_kgpm:iend_kgpm,kimg,nspin_m,nbxmix));rhoj=0.d0
       allocate(Frhoj(ista_kgpm:iend_kgpm,kimg,nspin_m,nbxmix));Frhoj=0.d0
       allocate(rhojo(ista_kgpm:iend_kgpm,kimg,nspin_m));rhojo=0.d0
       allocate(Frhojo(ista_kgpm:iend_kgpm,kimg,nspin_m));Frhojo=0.d0
    endif

! ======================================= Added by K. Tagami ===========
    din = 0.0d0; dout = 0.0d0; urec_l = 0.0d0; uuf_p = 0.0d0; f = 0.0d0
    g_p = 0.0d0; prj_wk = 0.0d0; ncrspd = 0
! ======================================================================
  end subroutine mix_pulay_allocate

  subroutine mix_pulay_deallocate
    if(allocated(f_p)) deallocate(f_p)
    if(allocated(din)) deallocate(din)
    if(allocated(dout)) deallocate(dout)
    if(allocated(urec_l)) deallocate(urec_l)
    if(allocated(uuf_p)) deallocate(uuf_p)
    if(allocated(f)) deallocate(f)
    if(allocated(g_p)) deallocate(g_p)
    if(allocated(prj_wk)) deallocate(prj_wk)
    if(allocated(ncrspd)) deallocate(ncrspd)
    if(allocated(rhoj)) deallocate(rhoj)
    if(allocated(Frhoj)) deallocate(Frhoj)
    if(allocated(rhojo)) deallocate(rhojo)
    if(allocated(Frhojo)) deallocate(Frhojo)
  end subroutine mix_pulay_deallocate

  subroutine mix_pulay_alloc2
    allocate(d0_l(ista_kgpm:iend_kgpm,kimg,nspin_m))
! =========================================== Added by K. Tagami ========
    d0_l = 0.0d0
! =======================================================================
    call alloc_rho_rhoo_and_cpm
  end subroutine mix_pulay_alloc2

  subroutine mix_pulay_dealloc2
    deallocate(d0_l)
    call dealloc_rho_rhoo_and_cpm
  end subroutine mix_pulay_dealloc2

  subroutine m_KE_mix_pulay(nfout,rmx)
    integer, parameter  :: iRho = 1, iResid = 2
    integer, intent(in) :: nfout
    real(DP),intent(in) :: rmx
    integer   :: iter, mxiter
    real(DP),pointer,dimension(:)  :: e_wk, f_wk, ww1, finv
    integer, pointer,dimension(:)  :: ip
! --> T. Yamasaki  03 Aug. 2009
    real(kind=DP), allocatable, dimension(:):: rmxtrc ! d(nspin_m)
!   real(kind=DP), allocatable, dimension(:,:,:) :: kinqstore_l, kinqostore_l
! <--
    integer   :: id_sname = -1
#ifdef __TIMER_SUB__
    call timer_sta(1131)
#endif
    call tstatc0_begin('m_KE_mix_pulay ',id_sname,1)

    if(previous_waymix /= PULAY.or.force_dealloc) then
       force_dealloc = .false.
       call mix_dealloc_previous()
       call mix_pulay_allocate()
    end if

    allocate(rmxtrc(nspin_m))
    if ( noncol ) then
       rmxtrc(1:nspin_m) = rmx
    else
       if(sw_recomposing == YES .and. af == 0 .and. nspin == 2) then
          call alloc_kinqstore_recompos_kinq(rmx,rmxtrc) ! --> kinq_l,kinqo_l, rmxtrc
       else
          rmxtrc(1:nspin_m) = rmx
       end if
    endif
! ========================================================================= 11.0

! ====================================== Modified by K. Tagami =========
!    allocate(c_p(ista_kngp:iend_kngp)); call precon_4_KE_mix(rmx,c_p)
! --> T. Yamasaki, 03rd Aug. 2009
!!$    allocate(c_p(ista_kngp:iend_kngp)); c_p = 0; call precon_4_KE_mix(rmx,c_p)
    allocate(c_p(ista_kngp:iend_kngp,nspin_m)); c_p = 0
! ========================================================================


! =================================== modified by K. Tagami =============== 11.0
!    call precon_4_KE_mix(rmxtrc,c_p)
!
    if ( noncol ) then
       call precon_4_KE_mix_noncl(rmxtrc,c_p)
    else
       call precon_4_KE_mix(rmxtrc,c_p)
    endif
! ========================================================================= 11.0

    iter = iter_from_reset()                 !-(m_KE)
    if((iter-istrbr+1) <= 1) then
       call simple_mix1(c_p)                 !-(m_KE)
       !   din=kinqo_l; dout=kinq_l; (din,dout,c_p)->kinq_l
    else
       call mix_pulay_alloc2   !-(m_KE) d0_l,u_l, and w_l are allocated
       call set_ncrspd_mxiter(nbxmix,iter-istrbr,mxiter) ! -> ncrspd, mxiter
!!$       call mix_pulay_alloc3(nbxmix,iter-istrbr)   !-(c.h.) e_wk,f_wk,ww1,finv,ip
       call mix_pulay_alloc3(mxiter)   !-(c.h.) e_wk,f_wk,ww1,finv,ip

!!$       call Resid_and_dd_into_urec(iter-istrbr) !-(c.h.)
!!$       !                               dF ->urec_l; dd ->urec_l; d0_l,din,dout
!!$       call Ri_dot_Rj(iter-istrbr)          !-(c.h.) <R(i)|R(j)>->f
!!$       call get_finv(nbxmix,iter-istrbr,f)  !-(c.h.) f -> f^{-1}= <R(i)|R(j)>^{-1}
!!$
!!$       call Rj_dot_d(iter-istrbr)           !-(c.h.) <R(j)|d>,(j=1,iter-istrb) -> uuf_p
!!$
!!$       call get_gmatrix(iter-istrbr)        !-(c.h.) (f,uuf_p)->g
!!$       call renew_d_using_g(iter-istrbr,c_pm)     !-(c.h.)
       call Resid_and_dd_into_urec(mxiter) !-(c.h.)
       !                               dF ->urec_l; dd ->urec_l; d0_l,din,dout
       call Ri_dot_Rj(mxiter)          !-(c.h.) <R(i)|R(j)>->f
!!$       call get_finv(nbxmix,mxiter,f)  !-(c.h.) f -> f^{-1}= <R(i)|R(j)>^{-1}
       call get_finv_lapack(nbxmix,mxiter,f)  !-(c.h.) f -> f^{-1}= <R(i)|R(j)>^{-1}

       call Rj_dot_d(mxiter)           !-(c.h.) <R(j)|d>,(j=1,iter-istrb) -> uuf_p

       call get_gmatrix(mxiter)        !-(c.h.) (f,uuf_p)->g
       call renew_d_using_g(mxiter,c_pm)     !-(c.h.)

       call mix_pulay_dealloc3                    !-(c.h.)
       call mix_pulay_dealloc2                    !-(m_KE)
    endif

    if ( .not. noncol ) then
       if(sw_recomposing == YES .and. af == 0 .and. nspin == 2) &
            & call compos_kinq_dealloc_kinqstore()
    endif
    deallocate(rmxtrc)

    deallocate(c_p)
    previous_waymix = PULAY
    call tstatc0_end(id_sname)
#ifdef __TIMER_SUB__
    call timer_end(1131)
#endif
  contains
    subroutine mix_pulay_alloc3(m)
      integer, intent(in) :: m
      allocate(e_wk(m*m)); allocate(f_wk(m*m)); allocate(ww1(m)); allocate(finv(m*m))
      allocate(ip(m))
! ===================================== Added by K. Tagami ============
      e_wk = 0; f_wk = 0; ww1 = 0; finv = 0; ip = 0
! =====================================================================
    end subroutine mix_pulay_alloc3

    subroutine set_ncrspd_mxiter(n,iter,m)
      integer, intent(in)  :: n, iter
      integer, intent(out) :: m
      integer :: i, nx
      if(hownew == ANEW) then
         m = iter
!!$         ncrspd(:) = (/(i,i=1,m)/)
         do i=1,iter
            ncrspd(i) = i
         end do
      else ! hownew == RENEW
         if(iter <= n) then
            m = iter
!!$            ncrspd(:) = (/(i,i=1,m)/)
            do i=1,iter
               ncrspd(i) = i
            end do
         else
            m = n
            nx = ncrspd(1)
            do i = 1, m-1
               ncrspd(i) = ncrspd(i+1)
            end do
            ncrspd(m) = nx
         end if
      end if
    end subroutine set_ncrspd_mxiter

    subroutine mix_pulay_dealloc3
      deallocate(e_wk); deallocate(f_wk); deallocate(ww1); deallocate(finv)
      deallocate(ip)
    end subroutine mix_pulay_dealloc3

    subroutine Resid_and_dd_into_urec(iter)
      integer, intent(in) :: iter
      integer             :: itc,itc0,itc1
      integer :: i,j,k,imix
#ifdef __TIMER_SUB__
    call timer_sta(1132)
#endif
      itc = ncrspd(iter)
      if(sw_gradient_simplex==ON)then
         do imix=2,iter-1
            itc0 = ncrspd(imix)
            itc1 = ncrspd(imix-1)
            do i=1,nspin_m
               do j=1,kimg
                  do k=ista_kgpm,iend_kgpm
                     urec_l(k,j,i,itc0,iResid) = rho(k,j,i)-rhoo(k,j,i)-(Frhoj(k,j,i,itc1)-rhoj(k,j,i,itc1))
                     urec_l(k,j,i,itc0,iRho  ) = rhoo(k,j,i)-rhoj(k,j,i,itc1)
                  enddo
               enddo
            enddo
         enddo
         do i=1,nspin_m
            do j=1,kimg
               do k=ista_kgpm,iend_kgpm
                  urec_l(k,j,i,itc,iResid) = rho(k,j,i)-rhoo(k,j,i)-(dout(k,j,i)-din(k,j,i))
                  urec_l(k,j,i,itc,iRho  ) = rhoo(k,j,i)-din(k,j,i)
                  rhoj(k,j,i,itc) = rhoo(k,j,i)
                  Frhoj(k,j,i,itc) = rho(k,j,i)
                  d0_l(k,j,i) = rho(k,j,i) - rhoo(k,j,i)
                  din(k,j,i)  = rhoo(k,j,i)
                  dout(k,j,i) = rho(k,j,i)
               enddo
            enddo
         enddo
      else
         do i=1,nspin_m
            do j=1,kimg
               do k=ista_kgpm,iend_kgpm
                  urec_l(k,j,i,itc,iResid) = rho(k,j,i) - rhoo(k,j,i) - (dout(k,j,i) - din(k,j,i)) ! =dF(=delta F^i)
                  urec_l(k,j,i,itc,iRho  ) = rhoo(k,j,i) - din(k,j,i)                ! =dd
                  d0_l(k,j,i) = rho(k,j,i) - rhoo(k,j,i)
                  din(k,j,i)  = rhoo(k,j,i)
                  dout(k,j,i) = rho(k,j,i)
               enddo
            enddo
         enddo
      endif
#ifdef __TIMER_SUB__
    call timer_end(1132)
#endif
    end subroutine Resid_and_dd_into_urec

    subroutine Ri_dot_Rj(n)
      integer, intent(in) :: n
      integer  :: it,jt,itc,jtc
! === DEBUG by tkato 2011/11/24 ================================================
!     real(DP) :: ff1(nspin),ff1tmp
      real(DP) :: ff1(nspin_m),ff1tmp
! ==============================================================================
#ifdef __TIMER_SUB__
    call timer_sta(1133)
#endif
#ifdef __TIMER_DO__
  call timer_sta(1179)
#endif
      do it = 1, n
         itc = ncrspd(it)
         do jt = it, n
            jtc = ncrspd(jt)
#ifdef _CDMIX_USE_POINTER_
            urec_l_3 => urec_l(ista_kgpm:iend_kgpm,1:kimg,1:nspin_m,itc,iResid)
            urec_l_3_2 => urec_l(ista_kgpm:iend_kgpm,1:kimg,1:nspin_m,jtc,iResid)
            call mult1s(urec_l_3,urec_l_3_2,f_p,ff1)   ! <delta F^i|delta F^j>
#else
            if(sw_mix_bothspins_sametime==ON .and. nspin_m>1)then
               call mult1s10_reduce_spin(urec_l,nbxmix,2,itc,iResid,urec_l,jtc,iResid,f_p,ff1tmp)   ! <delta F^i|delta F^j>
               ff1(1)=ff1tmp;ff1(2)=ff1tmp
            else
               call mult1s10(urec_l,nbxmix,2,itc,iResid,urec_l,jtc,iResid,f_p,ff1)   ! <delta F^i|delta F^j>
            endif

! ============================= added by K. Tagami ======================= 11.0
            if ( noncol ) then
               call mult1s10_reduce_spin( urec_l, nbxmix, 2, itc, iResid, &
                    &                     urec_l, jtc, iResid, f_p, ff1tmp )
                                                        ! <delta F^i|delta F^j>
               ff1(:) = ff1tmp
            endif
! ======================================================================== 11.0

#endif
            f(it,jt,1:nspin_m) = ff1(1:nspin_m)
            if(jt /= it) f(jt,it,1:nspin_m) = f(it,jt,1:nspin_m)
         end do
      end do
#ifdef __TIMER_DO__
  call timer_end(1179)
#endif
#ifdef __TIMER_SUB__
    call timer_end(1133)
#endif
    end subroutine Ri_dot_Rj

    subroutine Rj_dot_d(n)
      integer, intent(in) :: n
      integer  :: jt, jtc
! === DEBUG by tkato 2011/11/24 ================================================
!     real(DP) :: ff1(nspin),ff1tmp
      real(DP) :: ff1(nspin_m),ff1tmp
! ==============================================================================
#ifdef __TIMER_SUB__
    call timer_sta(1138)
#endif
      do jt = 1, n
         jtc = ncrspd(jt)
#ifdef _CDMIX_USE_POINTER_
         urec_l_3 => urec_l(ista_kgpm:iend_kgpm,1:kimg,1:nspin_m,jtc,iResid)
         call mult1s(urec_l_3,d0_l,f_p,ff1)
#else
         if(sw_mix_bothspins_sametime==ON .and. nspin_m>1)then
            call mult1s5_reduce_spin(urec_l,nbxmix,2,jtc,iResid,d0_l,f_p,ff1tmp)
            ff1(1) = ff1tmp;ff1(2)=ff1tmp
         else
            call mult1s5(urec_l,nbxmix,2,jtc,iResid,d0_l,f_p,ff1)
         endif

! ============================= added by K. Tagami ======================= 11.0
         if ( noncol ) then
            call mult1s5_reduce_spin(urec_l,nbxmix,2,jtc,iResid,d0_l,f_p,ff1tmp)
            ff1(:) = ff1tmp
         endif
! ======================================================================== 11.0

#endif
         uuf_p(jt,1:nspin_m) = ff1(1:nspin_m)
      end do
#ifdef __TIMER_SUB__
    call timer_end(1138)
#endif
    end subroutine Rj_dot_d

    subroutine get_finv_lapack(m,n,f)
      integer,intent(in)                             :: m,n
      real(DP),intent(inout),dimension(m,m,nspin_m) :: f
      real(DP), allocatable,dimension(:,:) :: fwork
      integer :: is,inf,it,jt,kt,nnspin
      real(DP) :: div,tmp
      allocate(fwork(n,n))
      nnspin = nspin
      if(sw_mix_bothspins_sametime==ON .or. af==1) nnspin=1

! ======================= added by K. Tagami ============= 11.0 
      if ( noncol ) then
         nnspin = 1
      end if
! ======================================================== 11.0

      do is=1,nnspin
         if(ipripulay >= 2) then
            write(nfout,600) n,(('(',it,jt,')',f(it,jt,is),jt=1,n),it=1,n)
600         format(//11x,"**input matrix**"/12x &
                 & ,"horder=",I5/(2x,4(1x,1a,i2,",",i2,1a,e14.6)))
         end if
         fwork=0
         do it=1,n
            do jt=1,n
               fwork(jt,it) = f(jt,it,is)
               if(it==jt) fwork(jt,it)=fwork(jt,it)+alpha_pulay
            enddo
         enddo
         call dpotrf('U',n,fwork,n,inf)
         call dpotri('U',n,fwork,n,inf)
         if(inf/=0)then
           if(printable) write(nfout,*) ' !** failed calculation of the inverse matrix for the pulay mixer'
           fwork=0
           do it=1,n
              do jt=1,n
                 fwork(jt,it) = f(jt,it,is)
                 if(it==jt) fwork(jt,it)=fwork(jt,it)+1.d-7
              enddo
           enddo
           call dpotrf('U',n,fwork,n,inf)
           call dpotri('U',n,fwork,n,inf)
         endif
         do it=1,n-1
            do jt=it+1,n
               fwork(jt,it) = fwork(it,jt)
            enddo
         enddo
         do it=1,n
            do jt=1,n
               f(jt,it,is) = fwork(jt,it)
            enddo
         enddo
         if(ipripulay >= 2) then
            write(nfout,630) (('(',it,jt,')',f(it,jt,is),it=1,n),jt=1,n)
630         format(/11x, "**inverse matrix**" &
                 & ,/(2x,4(1x,1a,i2,",",i2,1a,e14.6)))
         end if
      enddo
      if(sw_mix_bothspins_sametime==ON .and. nspin_m>1)then
         do it=1,n
            do jt=1,n
               f(jt,it,2) = f(jt,it,1)
            enddo
         enddo
      endif
! ============================== added by K. Tagami ========== 11.0
      if ( noncol ) then
         do it=1,n
            do jt=1,n
               f(jt,it,:) = f(jt,it,1)
            enddo
         end do
      endif
! ============================================================ 11.0
      deallocate(fwork)

    end subroutine get_finv_lapack

    subroutine get_finv(m,n,f)
      integer,intent(in)                             :: m,n
      real(DP),intent(inout),dimension(m,m,nspin_m) :: f

      integer                        :: icount,is,jt,it,icon
      real(DP)                       :: div
#ifdef __TIMER_SUB__
    call timer_sta(1134)
#endif

      e_wk = 0.d0
      do it = 1, n
         e_wk(it*it) = 1.d0
      end do

! ======================================= modified by K. Tagami =========== 11.0
!      do is = 1, nspin, af+1
      do is = 1, ndim_magmom, af+1
! ========================================================================== 11.0
         div = 1.d0/f(1,1,is)
         icount = 1
#ifdef __TIMER_DO__
  call timer_sta(1180)
#endif
         do jt = 1, n
            do it = 1, n
               f_wk(icount) = f(it,jt,is)*div
               icount = icount + 1
            end do
         end do
#ifdef __TIMER_DO__
  call timer_end(1180)
#endif
         if(ipripulay >= 1) then
            write(nfout,600) n,(('(',it,jt,')',f(it,jt,is)*div,jt=1,n),it=1,n)
600         format(//11x,"**input matrix**"/12x &
                 & ,"horder=",I5/(2x,4(1x,1a,i2,",",i2,1a,e14.6)))
         end if
         call rdecomp(n,f_wk,ww1,ip,icon)
         if(icon /= 0) then
            stop 'LU decomposition is impossible.'
         else
            call rsolve(n,n,f_wk,e_wk,finv,ip)
         endif

         icount = 1
#ifdef __TIMER_DO__
  call timer_sta(1181)
#endif
         do jt = 1, n
            do it = 1, n
               f(it,jt,is) = finv(icount)
               icount = icount + 1
            end do
         end do
#ifdef __TIMER_DO__
  call timer_end(1181)
#endif

         if(ipripulay >= 1) then
            write(nfout,630) (('(',it,jt,')',f(it,jt,is),it=1,n),jt=1,n)
630         format(/11x, "**inverse matrix**" &
                 & ,/(2x,4(1x,1a,i2,",",i2,1a,e14.6)))
         end if
      end do
#ifdef __TIMER_SUB__
    call timer_end(1134)
#endif
    end subroutine get_finv

    subroutine get_gmatrix(n)
      integer,intent(in) :: n
      integer :: is, it, jt, nnspin
#ifdef __TIMER_SUB__
    call timer_sta(1139)
#endif
      nnspin = nspin
      if(sw_mix_bothspins_sametime==ON .or. af==1) nnspin=1

! ============================ added by K. Tagami ============= 11.0
      if ( noncol ) nnspin = 1
! ============================================================== 11.0      

      g_p = 0.d0
      do is = 1, nnspin
#ifdef __TIMER_DO__
  call timer_sta(1188)
#endif
         do it = 1, n
            do jt = 1, n
               g_p(it,is) = g_p(it,is) - f(jt,it,is)*uuf_p(jt,is)
            end do
         end do
#ifdef __TIMER_DO__
  call timer_end(1188)
#endif
         if(ipripulay >= 2) then
            write(nfout,'(" -- g_p(1:",i3,") --")') n
            write(nfout,'(8f20.12)') (g_p(it,is),it=1,n)
         end if
      end do
      if(sw_mix_bothspins_sametime==ON .and. nspin_m>1)then
         do it = 1,n
            g_p(it,2) = g_p(it,1)
         enddo
      endif
! ============================== added by K. Tagami ============ 11.0
      if ( noncol ) then
         do it = 1,n
            g_p(it,:) = g_p(it,1)
         enddo
      endif
! ============================================================== 11.0

#ifdef __TIMER_SUB__
    call timer_end(1139)
#endif
    end subroutine get_gmatrix

    subroutine renew_d_using_g(n,p)
      integer, intent(in)                                :: n
      real(DP),intent(in),dimension(ista_kgpm:iend_kgpm,nspin_m) :: p
      integer    :: is, k, i, it, itc, ns
#ifdef __TIMER_SUB__
    call timer_sta(1140)
#endif

!!$      do is = 1, nspin, af+1
      ns = nspin_for_qnewton()
      do is = 1, ns,af+1
         do k = 1, kimg
#ifdef __TIMER_DO__
  call timer_sta(1189)
#endif
            do i = ista_kngp, iend_kngp
               rho(i,k,is)  = rhoo(i,k,is) + p(i,is)*d0_l(i,k,is)
            end do
#ifdef __TIMER_DO__
  call timer_end(1189)
#endif
#ifdef __TIMER_DO__
  call timer_sta(1190)
#endif
            do it = 1, n
               itc = ncrspd(it)
               do i = ista_kngp, iend_kngp
                  rho(i,k,is) = rho(i,k,is) + g_p(it,is)* &
                       &        (urec_l(i,k,is,itc,iRho) + p(i,is)*urec_l(i,k,is,itc,iResid))
               end do
            end do
#ifdef __TIMER_DO__
  call timer_end(1190)
#endif
         end do
      end do

! ============================== modified by K. Tagami ================ 11.0
!      if(sw_force_simple_mixing==ON .and. sw_recomposing==ON) call simple_mix2(c_p)
!
      if ( .not. noncol ) then
         if(sw_force_simple_mixing==ON .and. sw_recomposing==ON) then
            call simple_mix2(c_p)
         endif
      endif
! ===================================================================== 11.0

      if(kgpm < kgp) then
         call concentrate_d_to_chg(rho,kinq_l) !-(m_C.D.)
         call simple_mix_large_Gc(c_p)         !-(m_C.D.) kinq,kinqo,c_p ->kinq
      end if
#ifdef __TIMER_SUB__
    call timer_end(1140)
#endif
    end subroutine renew_d_using_g

  end subroutine m_KE_mix_pulay

  subroutine m_KE_simple_mixing_00( rmxt )
    real(kind=DP), intent(in) :: rmxt

    if ( use_symm_ekin_density ) then
       ekins_l = ekins_old + rmxt*( ekins_l -ekins_old )
    endif
    if ( use_asymm_ekin_density ) then
       ekina_l = ekina_old + rmxt*( ekina_l -ekina_old )
    endif
  end subroutine m_KE_simple_mixing_00

  subroutine m_KE_kerker_mixing( rmxt )
    real(kind=DP), intent(in) :: rmxt

    integer :: i, is, ri
    real(kind=DP) :: gg, q0, fac_min
    real(kind=DP) :: rmxtrc(nspin)
!
    real(kind=DP), allocatable :: c_p_ekin(:,:), dekin(:,:,:)

    allocate( c_p_ekin( ista_kngp:iend_kngp,nspin) );  c_p_ekin = 0.0d0
    allocate( dekin( ista_kngp:iend_kngp,kimg,nspin) );     dekin = 0.0d0

    q0 = 1.0d0
!    q0 = 5.0d0
!    q0 = 2.0d0

    q0 = g0_wf_precon **2
    fac_min = amin_wf_precon

    Do i=ista_kngp, iend_kngp
       gg = gr_l(i)*gr_l(i)
       Do is=1, nspin
          c_p_ekin(i,is) = max( gg/(gg+q0), fac_min )
!          write(1000+mype,*) i, is, c_p_ekin(i,is)
       End do
    End Do
!    stop

    c_p_ekin = c_p_ekin *rmxt

    if ( use_symm_ekin_density ) then
       dekin = ekins_l - ekins_old
       Do is=1, nspin
          Do ri=1, kimg
             Do i=ista_kngp, iend_kngp
                ekins_l(i,ri,is) = ekins_old(i,ri,is) &
                     &  +c_p_ekin(i,is) *dekin(i,ri,is) 
             End do
          End do
       End do
    endif
    if ( use_asymm_ekin_density ) then
       dekin = ekina_l - ekina_old
       Do is=1, nspin
          Do ri=1, kimg
             Do i=ista_kngp, iend_kngp
                ekina_l(i,ri,is) = ekina_old(i,ri,is) &
                     &  +c_p_ekin(i,is) *dekin(i,ri,is)
             End do
          End do
       End do
    endif

    deallocate( c_p_ekin)
    deallocate( dekin )

  end subroutine m_KE_kerker_mixing

end module m_KE_mixing

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 570 $)
!
!  MODULE: m_Const_Parameters
!
!  AUTHOR(S): T. Yamasaki and K. Mae   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
module m_ErrorMessages
! $Id: m_ErrorMessages.F90 570 2017-04-21 20:34:50Z yamasaki $
  implicit none

  integer,parameter :: NO_ERROR                   = 0
! ---
  integer,parameter :: FORMAT_ERROR               = 1101
  integer,parameter :: EOF_REACHED                = 1103
! ---
  integer,parameter :: FILE_NOT_EXIST             = 1200
  integer,parameter :: FILENAMES_NOT_EXIST        = 1201
  integer,parameter :: CONT_FILES_NOT_EXIST       = 1202
  integer,parameter :: F_POT_FILE_NOT_EXIST       = 1203
  integer,parameter :: F_ZAJ_FILE_NOT_EXIST       = 1206
  integer,parameter :: F_CHGT_FILE_NOT_EXIST      = 1207
  integer,parameter :: F_CNTN_FILE_NOT_EXIST      = 1208
  integer,parameter :: FILENAMES_FORMAT_ERROR     = 1209
  integer,parameter :: FILENAMES_FORMAT_ERROR_NEB = 1210
  integer,parameter :: ERROR_IN_INPUTFILE_OPENING = 1211
  integer,parameter :: F_CHGT_FILE_NOT_EXIST_EK   = 1212
  integer,parameter :: INVALID_CHARGE_MIXING      = 1302
  integer,parameter :: INVALID_ATOMIC_NUMBER      = 1401
  integer,parameter :: PARALLELIZATION_INVALID_2D = 2101
  integer,parameter :: PARALLELIZATION_INVALID_3D = 2102
  integer,parameter :: PARALLELIZATION_INVALID_NK = 2103
  integer,parameter :: PARALLELIZATION_INVALID_NE = 2104
! ---
  integer,parameter :: len_1101_error = 37
  character(len=len_1101_error) :: msg_format_error = "Input data format error when reading."
!!$                                                    12345678901234567890123456789012345678901234567890  
  integer,parameter :: len_1103_error = 31
  character(len=len_1103_error) :: msg_1103_error   = "Encounter the EOF when reading."
!!$                                                    12345678901234567890123456789012345678901234567890  
  integer,parameter :: len_1206_error = 48
  character(len=len_1206_error) :: msg_1204_error   = "The file for initial wavefunctions is not exist."
!!$                                                    12345678901234567890123456789012345678901234567890  
  integer,parameter :: len_1207_error = 49
  character(len=len_1207_error) :: msg_1205_error   = "The file for initial charge density is not exist."
!!$                                                    12345678901234567890123456789012345678901234567890  
  integer,parameter :: len_1211_error = 35
  character(len=len_1211_error) :: msg_1211_error   = "Error in opening of the inputfile: "
!!$                                                    12345678901234567890123456789012345678901234567890  
  integer,parameter :: len_1212_error = 46
  character(len=len_1212_error) :: msg_1212_error   = "Fixed_charge calc require charge-density file."
!!$                                                    12345678901234567890123456789012345678901234567890  
!  integer,parameter :: len_1208_error = 35
!  character(len=len_1208_error) :: msg_1208_error     = "Error in opening of the inputfile: "
! ---
  integer,parameter :: len_6100_error = 29
  character(len=len_6100_error) :: msg_6100_error     = "A CPP defintion is not proper"
  integer,parameter :: CPP_DEFINE_ERROR_1 = 6101
  integer,parameter :: len_6101_error = 31
  character(len=len_6101_error) :: msg_6101_error     = "TRANSPOSE_WITHOUT_REARRANGEMENT"
!!$                                                      1234567890123456789012345678901234567  

contains
  subroutine m_EMsg_abort01()
  end subroutine m_EMsg_abort01

  subroutine m_EMsg_Warning(iwarning, nfout)
    implicit none
    integer,intent(in) :: iwarning, nfout

    select case (iwarning)
    case (FILENAMES_NOT_EXIST)
       write(*,*) '### Warning(1201): "file_names.data" does not exist.'
       write(*,*) '                   A default set of file names is adapted.'
    case default
       write(nfout,*) '### Warning(9999)'
    end select
  end subroutine m_EMsg_Warning

end module m_ErrorMessages
  

!#define RCUT_SMOOTH

module m_Crystal_Field
  use m_Control_Parameters,   only : nspin, kimg, noncol
  use m_Const_Parameters, only : DP, PAI4, PAI
  use m_Crystal_Structure, only : univol, rltv
  use m_Ionic_System,     only : natm, ityp, pos, iatomn, ntyp, ivan, ival
  use m_PseudoPotential,  only : lpsmax, flg_paw, nmesh, mmesh, radr_paw, vlocr_pw, rhcorpw
  use m_Parallelization,   only : ista_kngp, iend_kngp, mpi_comm_group, ierr, ista_k, mype, npes, mype

  use m_Charge_Density,   only : chgq_l
  use m_PlaneWaveBasisSet,  only : kgp, ngabc, gr_l
  use m_Electronic_Structure,  only : vlhxc_l
  use m_XC_Potential,   only : vxc_l
!  use m_Nonlocal_Potential,  only : new_radr_and_wos
  use m_Files,  only : nfpot, nfout, m_Files_open_ps_files, m_Files_close_ps_file

  use m_CD_Mag_Moment,  only : rad_cov_default

  implicit none
  include 'mpif.h'

contains


  subroutine set_psir_f( has_open_forb, psir_f )
    integer, intent(out) :: has_open_forb(ntyp)
    real(kind=DP), intent(out) :: psir_f( mmesh, ntyp )
!    real(kind=DP), intent(out) :: rho_f( mmesh, ntyp )

    integer :: it, ierr, nfp, i, ir
    integer :: num_core_ae_wfns
    integer, allocatable :: qnum_n_core_ae_wfns(:)
    integer, allocatable :: qnum_l_core_ae_wfns(:)
    real(kind=DP), allocatable :: psir_core_ae_wfns(:,:)
    real(kind=DP), allocatable :: enelevel_core_ae_wfns(:)
    real(kind=DP), allocatable :: focc_core_ae_wfns(:)
    real(kind=DP) :: weight

! == KT_DEBUG === 2015/06/15 == 
!    call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierr)  
!                                      ! this does not work properly by unknown reason.
    call m_Files_open_ps_files(ivan,iatomn,ntyp,ierr)
! =============== 2015/06/15

    if (ierr/=0) call mpi_stop(nfout)

    has_open_forb = 0

    Do it=1, ntyp
       nfp = nfpot(it)

       if ( mype == 0 ) call read_num_core_ae_wfns( nfp, num_core_ae_wfns, it )
       if ( npes > 1 ) then
          call mpi_bcast(  num_core_ae_wfns, 1, mpi_integer, 0, mpi_comm_world, ierr )
       endif
       
       if ( num_core_ae_wfns == 0 ) cycle
       
       allocate( qnum_n_core_ae_wfns( num_core_ae_wfns ) )
       allocate( qnum_l_core_ae_wfns( num_core_ae_wfns ) )
       allocate( psir_core_ae_wfns( nmesh(it),  num_core_ae_wfns ) )
       allocate( enelevel_core_ae_wfns( num_core_ae_wfns ) )
       allocate( focc_core_ae_wfns( num_core_ae_wfns ) )
       
       if ( mype == 0 ) then
          call read_data_core_ae_wfns( nfp, num_core_ae_wfns, nmesh(it), &
               &                       qnum_n_core_ae_wfns, qnum_l_core_ae_wfns, &
               &                       psir_core_ae_wfns, &
               &                       enelevel_core_ae_wfns, focc_core_ae_wfns )
       endif
       
       if ( npes > 1 ) then
          call mpi_bcast( qnum_n_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_integer, 0, mpi_comm_world, ierr )
          call mpi_bcast( qnum_l_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_integer, 0, mpi_comm_world, ierr )
          call mpi_bcast( enelevel_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_double_precision, 0, mpi_comm_world, ierr )
          call mpi_bcast( focc_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_double_precision, 0, mpi_comm_world, ierr )
          call mpi_bcast( psir_core_ae_wfns, nmesh(it)*num_core_ae_wfns, &
               &          mpi_double_precision, 0, mpi_comm_world, ierr )
       endif

!
       Do i=1, num_core_ae_wfns
          if ( qnum_l_core_ae_wfns(i) == 3 ) then
             if ( focc_core_ae_wfns(i) > 0.1 .and. focc_core_ae_wfns(i) < 13.9 ) then
                has_open_forb(it) = 1
                Do ir=1, nmesh(it)
                   psir_f(ir,it) = psir_core_ae_wfns(ir,i)
                End Do
             endif
          endif
       End Do

       deallocate( qnum_n_core_ae_wfns )
       deallocate( qnum_l_core_ae_wfns )
       deallocate( psir_core_ae_wfns )
       deallocate( enelevel_core_ae_wfns )
       deallocate( focc_core_ae_wfns )

       call m_Files_close_ps_file(it)
    End Do
  end subroutine set_psir_f

  subroutine read_num_core_ae_wfns( nfp, nums, it )
    integer, intent(in) :: nfp, it
    integer, intent(out) :: nums

    integer :: length, ierr
    character(30) :: search_key

    nums = 0

    search_key = "CORE STATES";  length = len(search_key)
    call read_size_of_array_from_pp(nfp, nums, length, search_key, ierr)

    if ( ierr /= 0 ) then
       write(nfout,*) '----------------------'
       write(nfout,'(A,I2)') '!!! Keyword CORE STATES is not found in the PP', it
       write(nfout,*) '----------------------'
    endif

  end subroutine read_num_core_ae_wfns

  subroutine read_data_core_ae_wfns( nfp, num_core_ae_wfns, nmesh, &
       &                             qnum_n, qnum_l, psir_core, ene_level, focc )
    implicit none

    integer, intent(in) :: num_core_ae_wfns
    integer, intent(in) :: nmesh, nfp
    integer, intent(out) :: qnum_l(num_core_ae_wfns)
    integer, intent(out) :: qnum_n(num_core_ae_wfns)
    real(kind=8), intent(out) :: psir_core(nmesh, num_core_ae_wfns), &
         &                       ene_level(num_core_ae_wfns), focc(num_core_ae_wfns)

    integer :: i, n1, l1, k
    real(kind=DP) :: ene1, f1

    Do i=1, num_core_ae_wfns
       read(nfp,*) n1, l1, ene1, f1
       read(nfp,*) (psir_core(k,i),k=1,nmesh)
       !
       qnum_n(i) = n1;  qnum_l(i) = l1;  ene_level(i) = ene1;   focc(i) = f1
    End Do
  end subroutine read_data_core_ae_wfns

  subroutine read_size_of_array_from_pp( nfp, size_of_array, length, search_tag, ierr )
    implicit none

    integer, intent(in) :: nfp, length
    integer, intent(out) :: size_of_array, ierr
    character(length), intent(in) :: search_tag

    integer :: ifound
    character(30) :: line1

    size_of_array = 0;  ierr = 0

    Do while (.true.)
       read(nfp,'(a30)',end=10) line1
       ifound = index( line1, search_tag )
       if ( ifound /= 0 ) goto 20
    End do

10  ierr = 1; return

20  read(nfp,*) size_of_array

  end subroutine read_size_of_array_from_pp

  subroutine calc_vh( nmesh, rpos, rho, vh )
    integer, intent(in) :: nmesh
    real(kind=DP), intent(in) :: rpos(mmesh), rho(mmesh)
    real(kind=DP), intent(out) :: vh(mmesh)
    
    integer :: ir, ii, i0, is, j, jr, ier
    real(kind=DP) :: sum1, sum2
    real(kind=DP), allocatable :: wt(:)
    
    allocate( wt (nmesh) ); wt = 0.0d0
    
    do ir = 1,nmesh
       sum1 = 0.d0;  sum2 = 0.d0
       if (ir == 1) then
          sum1 = 0.d0
       else if ((ir >= 2).and.(ir <= 5)) then
          do ii = 2,ir
             i0 = ii-1; is = 1
             call set_open_weight_exp(ier,i0,is,rpos,wt)
             
             do j = 1,4
                sum1 = sum1 +rpos(i0+j*is)**2 *rho(i0+j*is) *wt(i0+j*is)
             end do
          end do
       else
          call set_weight_exp(ier,1,ir,rpos,wt)
          do jr = 1,ir
             sum1 = sum1 + rpos(jr)**2*rho(jr)*wt(jr)
          end do
       end if
       sum1 = sum1 *PAI4 /rpos(ir)
       
       if (ir == nmesh) then
          sum2 = 0.d0
       else if ((ir <= nmesh-1).and.(ir >= nmesh-4)) then
          do ii = ir,nmesh-1
             i0 = ii+1; is = -1
             call set_open_weight_exp(ier,i0,is,rpos,wt)
             do j = 1,4
                sum2 = sum2 -rpos(i0+j*is)**2 *rho(i0+j*is) *wt(i0+j*is)
             end do
          end do
       else
          call set_weight_exp(ier,ir,nmesh,rpos,wt)
          do jr = ir,nmesh
             sum2 = sum2 + rpos(jr)*rho(jr)*wt(jr)
          end do
       end if
       sum2 = sum2 *PAI4
       vh(ir) = sum1 + sum2
    end do
    
    deallocate( wt )
  end subroutine calc_vh

  subroutine m_CF_calc_CF_param
    integer if, ia, it, ik, is, ir, ig, ist
    integer nspher, il1, tau1, ismax
    integer ier

    real(kind=DP) :: fac, facr, csum, csum_mpi, c1, c2, csum2
    real(kind=DP) :: rcut

    integer, allocatable :: has_open_forb(:)
    real(kind=DP), allocatable :: qx(:), qy(:), qz(:), vlength(:), ylm(:), psir_f(:,:)
    real(kind=DP), allocatable :: wka(:), wkb(:), snl2(:), zfcos(:), zfsin(:), wos(:)
    real(kind=DP), allocatable :: vtot(:), work(:)

    if ( .not. flg_paw ) return

    ! ========= Assuming that f-electrons are core. ===
    allocate( psir_f(mmesh,ntyp) ); psir_f = 0.0d0
    allocate( has_open_forb(ntyp) );  has_open_forb = 0

    call set_psir_f( has_open_forb, psir_f )
!    write(2000+mype,*) has_open_forb
!    stop

#ifdef RCUT_SMOOTH
    call contract_f_orbital( has_open_forb, psir_f )
#endif

    allocate( qx(ista_kngp:iend_kngp) )
    allocate( qy(ista_kngp:iend_kngp) )
    allocate( qz(ista_kngp:iend_kngp) )
    allocate( vlength(ista_kngp:iend_kngp) )

    allocate( wka(ista_kngp:iend_kngp) )
    allocate( wkb(ista_kngp:iend_kngp) )
    allocate( ylm(ista_kngp:iend_kngp) )
    allocate( snl2(ista_kngp:iend_kngp) )
    allocate( zfcos(ista_kngp:iend_kngp) )
    allocate( zfsin(ista_kngp:iend_kngp) )
!    allocate( radr(mmesh) ); 
    allocate( wos(mmesh) )

!    fac = PAI4 /dsqrt(univol)
    fac = PAI4 

    Do ig=ista_kngp, iend_kngp
       qx(ig) = rltv(1,1)*ngabc(ig,1) +rltv(1,2)*ngabc(ig,2) +rltv(1,3)*ngabc(ig,3)
       qy(ig) = rltv(2,1)*ngabc(ig,1) +rltv(2,2)*ngabc(ig,2) +rltv(2,3)*ngabc(ig,3)
       qz(ig) = rltv(3,1)*ngabc(ig,1) +rltv(3,2)*ngabc(ig,2) +rltv(3,3)*ngabc(ig,3)
       vlength(ig) = sqrt( qx(ig)**2 + qy(ig)**2 + qz(ig)**2 )
    End do

! -----------
    Do ia=1, natm
       it = ityp(ia)
       if ( has_open_forb(it) == 0 ) cycle
       
       call set_weight_exp( ier, 1, nmesh(it), radr_paw(:,it), wos )

! ---
       nspher = 5           ! Y_20
       call sphr( iend_kngp -ista_kngp +1, nspher, &
            &     qx(ista_kngp:iend_kngp), &
            &     qy(ista_kngp:iend_kngp), &
            &     qz(ista_kngp:iend_kngp), ylm(ista_kngp:iend_kngp) )
!
       rcut = rad_cov_default( nint(iatomn(it)) )

       csum2 = 0.0d0
       do ir = 1,nmesh(it)
#ifdef RCUT_SMOOTH
          if ( radr_paw(ir,it) > rcut ) cycle
#endif
          facr = wos(ir) *psir_f(ir,it)**2 *radr_paw(ir,it)**2
          csum2 = csum2 +facr
       End do

       snl2 = 0.0d0
       do ir = 1,nmesh(it)
#ifdef RCUT_SMOOTH
          if ( radr_paw(ir,it) > rcut ) cycle
#endif
          facr = wos(ir) *psir_f(ir,it) *psir_f(ir,it) 

          Do ig=ista_kngp, iend_kngp
             wka(ig) = vlength(ig) *radr_paw(ir,it)
          End do

          call dsjnv( 2, iend_kngp -ista_kngp +1, &        
               &      wka(ista_kngp:iend_kngp), &
               &      wkb(ista_kngp:iend_kngp) ) 
                                                     ! -(bottom_Subr.)
          Do ig=ista_kngp, iend_kngp
             snl2(ig) = snl2(ig) + fac *facr *wkb(ig) *ylm(ig)
          End do
       end do
       snl2 = -snl2        ! i^2 = -1; where 2 <= Y_20

       call calc_phase2( natm, pos, ia, kgp, ngabc, ista_kngp, iend_kngp, zfcos, zfsin )

       csum = 0.0d0

       ist = ista_kngp
!       if(ist == 1) ist = 2

       if ( noncol ) then
          ismax = 1
          Do is=1, ismax
             Do ig=ist, iend_kngp
                c1 = vlhxc_l(ig,1,is)*zfcos(ig) -vlhxc_l(ig,2,is)*zfsin(ig)
                !                c1 = PAI4 *( chgq_l(ig,1,1) *zfcos(ig) -chgq_l(ig,2,1) *zfsin(ig) ) &
                !!                    & /gr_l(ig)**2
                csum = csum +c1 *snl2(ig)
             End do
          End do
       else
          ismax = nspin
          Do is=1, ismax
             if ( kimg ==2 ) then
                Do ig=ist, iend_kngp
!                   c1 = vlhxc_l(ig,1,is)*zfcos(ig) -vlhxc_l(ig,2,is)*zfsin(ig)
                   c1 = ( vlhxc_l(ig,1,is) -vxc_l(ig,1,is) ) *zfcos(ig) &
                        & -( vlhxc_l(ig,2,is) -vxc_l(ig,2,is) ) *zfsin(ig)
                   csum = csum +c1 *snl2(ig)
                End Do
             else
                Do ig=ist, iend_kngp
                   c1 = vlhxc_l(ig,1,is)*zfcos(ig)
                   csum = csum +c1 *snl2(ig)
                End Do
             endif
          End do
          csum = csum /dble(nspin)
       endif

       call mpi_allreduce( csum, csum_mpi, 1, mpi_double_precision, mpi_sum, &
            &              mpi_comm_group, ierr )


       if ( mype == 0 ) then
          write(*,*) "atom, A20<r2>[K]: ", ia, csum_mpi*sqrt(5./16./PAI)*3.1577513*1.0E5, &
               &     " <r2>[bohr2]: ", csum2
       endif
    End do

!    deallocate( radr ); 
    deallocate( wos )

    call mpi_barrier( mpi_comm_group, ierr )

  end subroutine m_CF_calc_CF_param

  subroutine contract_f_orbital( has_open_forb, psir )
    integer, intent(in) :: has_open_forb(ntyp)
    real(kind=DP), intent(inout) :: psir(mmesh,ntyp)

    integer :: ik, ilmt1, il1, tau1, ir, ier, it
    real(kind=DP) :: csum, factor, rcut, beta
    real(kind=DP), allocatable :: tmp_fn(:), wos(:)

    allocate( tmp_fn(mmesh) );  allocate( wos(mmesh) ); 
    beta = 0.5d0

    Do it=1, ntyp
       if ( has_open_forb(it) == 0 ) cycle

       rcut = rad_cov_default( nint(iatomn(it)) )
                    ! Revised according to a report from ASMS Co.ltd, 10 March 2016.

       call set_weight_exp( ier, 1, nmesh(it), radr_paw(:,it), wos )

       tmp_fn = 0.0d0
       Do ir=1, nmesh(it)
          tmp_fn(ir) = psir(ir,it) *exp( -radr_paw(ir,it)/rcut)
!          tmp_fn(ir) = psir(ir,it) /( 1.0d0 +exp( beta *(radr_paw(ir,it)-rcut) ) )
       End do
       
       csum = 0.0d0
       Do ir=1, nmesh(it)
          csum = csum + wos(ir) *tmp_fn(ir)**2
       End do
       
       factor = 1.0d0 /sqrt(csum)
       psir(:,it) = 0.0d0

       do ir = 1,nmesh(it)
          psir(ir,it) = tmp_fn(ir) *factor
       end do
    End Do
    call mpi_barrier( mpi_comm_group, ierr )
    deallocate(tmp_fn); deallocate(wos)

  end subroutine contract_f_orbital

#if 0
R: 4f atom no aru site
vh_lm(|r-R|) = int vh(r) Ylm(|r-R|)  
             = int sum_G vh(G)exp(iGr) Ylm(|r-R|)      ( r-R=r'; r = r'+R )
             =                exp(iGr') exp(iGR) Ylm(|r'|) 
             = sum_G vh(G) exp(iGR) Ylm(G) j_l(Gr') ?? 

vh(r) R4f(r-R)^2 (r-R)^2 dr
#endif

end module m_Crystal_Field

!=======================================================================
!
!  SOFTWARE NAME : PHASE (ver: 801)
!
!  MODULE: m_ES_nonlocal
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004, April/15/2006, September/02/2008
!  FURTHER MODIFICATION: T. Yamasaki, T. Uda and T. Ohno, September 2009 (MGS_DGEMM)
!  FURTHER MODIFICATION: T. Yamasaki and T. Yamamoto,   October 2009  (NONLOCAL_DGEMM)
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!

!   This module has been revised for the GAMMA point (k=(0,0,0)) by T. Yamasaki
!  in April 2006. Number of operations for the Gamma point have been tremendously
!  reduced in subroutines of m_ES_betar_dot_Wfs, m_ES_Vnonlocal_W, and
!  m_ES_modified_gram_schmidt.
!
#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DGEMM__
#   define __TIMER_DGEMM_START(a)  call timer_sta(a)
#   define __TIMER_DGEMM_STOP(a)   call timer_end(a)
#else
#   define __TIMER_DGEMM_START(a)
#   define __TIMER_DGEMM_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)   call timer_sta(a)
#   define __TIMER_DO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif
#ifdef __TIMER_COMM__
#   define __TIMER_COMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_COMM_START(a)       call timer_sta(a)
#   define __TIMER_COMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_COMM_START_w_BARRIER(str,a)
#   define __TIMER_COMM_START(a)
#   define __TIMER_COMM_STOP(a)
#endif

#ifndef SX
#define DGEMM__       DGEMM
#endif

#ifndef NO_NONLOCAL_DGEMM
#define NONLOCAL_DGEMM
#endif

module m_ES_nonlocal
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process &
       &                         , iteration, nkgroup
  use m_NonLocal_Potential, only : snl,snl_add,phig,paog, norm_phig &
!       &                         , nmesh_rs,nmesh_rs_max,meshx_rs,meshy_rs,meshz_rs,meshxyz_rs,snl_rs &
!       &                         , meshxyz_rs_conjg,nmesh_rs_h,meshxyz_rs_h,map_h,nmesh_rs_max_h,snl_rs_h
       &                         , snl_rs, snl_rs_h
  use m_Realspace,          only : nmesh_rs,nmesh_rs_max,meshx_rs,meshy_rs,meshz_rs,meshxyz_rs,meshxyz_rs_conjg &
       &                         , nmesh_rs_h,meshxyz_rs_h,map_h,nmesh_rs_max_h
  use m_PlaneWaveBasisSet,  only : ngabc,kg1,nbase,nbmx,iba,igf
  use m_PseudoPotential,    only : ilmt,nlmtt,nlmta,lmta,lmtt,ltp,mtp,q,dion,taup &
       &                         , ilmt_phi,nlmt_phi,nlmtt_phi,nlmta_phi &
       &                         , lmta_phi,lmtt_phi,ltp_phi, mtp_phi, taup_phi &
       &                         , ilmt_add,nlmt_add,nlmtt_add,nlmta_add &
       &                         , lmta_add,lmtt_add,ltp_add,mtp_add &
       &                         , ilmt_pao,nlmt_pao,nlmtt_pao,nlmta_pao &
       &                         , lmta_pao,lmtt_pao,ltp_pao,mtp_pao,ibpao &
       &                         , modnrm,nac,fqwei,nlmta1,nlmta2 &
       &                         , m_PP_include_vanderbilt_pot &
       &                         , ipaw, dion_paw, q_phirt_pw, ia2ia_symmtry_op_inv &
       &                         , irorb, nrorb, crorb
  use m_Crystal_Structure,  only : op, nopr, univol
  use m_Kpoints,            only : kv3, kv3_ek,k_symmetry,vkxyz
  use m_Ionic_System,       only : ntyp, natm, iwei, ityp, pos
  use m_FFT,                only : nfft &
       &                         , m_FFT_alloc_WF_work &
       &                         , m_FFT_dealloc_WF_work &
       &                         , fft_box_size_WF, m_FFT_WF
  use m_Files,              only : nfout
  use m_Timing,             only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters, only : nspin,ipri, ipribetar &
       &                         , kimg, neg, meg, af &
       &                         , m_CtrlP_cachesize &
       &                         , sw_use_add_proj &
       &                         , flag_mpi_g_dot_r, flag_mpi_g_dot_r_k &
       &                         , nblocksize_betar_dot_wfs_nlmta  &
       &                         , nblocksize_betar_nlmta_is_given &
       &                         , nblocksize_betar_dot_wfs, nblocksize_vnonlocal_w &
       &                         , nblocksize_betar_is_given &
       &                         , nblocksize_vnonlocal_is_given &
       &                         , nblocksize_betar_npe_is_given &
       &                         , nblocksize_betar_dot_wfs_npe  &
       &                         , sw_rspace,sw_save_memory, m_CtrlP_realspace_integ_OK &
       &                         , nblocksize_rspace_betar, sw_rspace_v &
       &                         , nblocksize_rspace_v
  use m_Const_Parameters,   only : DP, CMPLDP, SKIP, EXECUT, ON, OFF, PAI2 &
       &                         , GAMMA, MAPPED, NOTMAPPED, BUCS, DIRECT, ELECTRON, INVERSE
  use m_Parallelization,    only : mype &
       &                         , myrank_e,map_e,ista_e,iend_e,istep_e &
       &                         , map_z,np_e,myrank_k,map_k,ista_k,iend_k &
       &                         , ista_snl, iend_snl &
       &                         , ng_nbmx, ista_nbmx, mpi_nbmx_world &
       &                         , np_nbmx, mp_nbmx &
       &                         , ng_nbmx_k, ista_nbmx_k, mpi_nbmx_world_k &
!!$       &                         , np_nbmx_k, mp_nbmx_k &
       &                         , ista_kg1_k, np_kg1_k, mp_kg1_k &
       &                         , nbmx_ext, ierr, ista_atm,iend_atm
  use m_Electronic_Structure, only : zaj_l,  fsr_l, fsi_l , fsr_add_l, fsi_add_l &
       &                           , eko_l, vnlph_l, vlhxcQ, compr_l, compi_l    &
       &                           , fsr_l_2D_k, fsi_l_2D_k, neordr, nrvf_ordr

  use m_Control_Parameters,   only : nblocksize_vnonlocal_w_nlmta_is_given            &
 &                                 , nblocksize_vnonlocal_w_nlmta                     &
 &                                 , nblocksize_vnonlocal_w_f_is_given                &
 &                                 , nblocksize_vnonlocal_w_f
  use m_FFT,                  only : m_FFT_W_Vlocal_W_3D
  use m_Parallelization,      only : lrank, nbsn, nbsn_sta, nbsn_end, neg_g           &
 &                                 , nbs_num, nbsn_num, nbs_sta, nbs_end              &
 &                                 , mpi_kg_world, mpi_ke_world           &
 &                                 , myrank_g, nrank_g &
 &                                 , ista_g1k, iend_g1k, np_g1k, mp_g1k   &
 &                                 , nis_g1k, nie_g1k, nel_g1k               &
 &                                 , nis_e, nel_fs, nis_fs, np_fs        &
 &                                 , ista_fs, iend_fs     
  use m_PlaneWaveBasisSet,    only : m_pwBS_kinetic_energies_3D
  use m_Electronic_Structure, only : fsr_l_2D, fsi_l_2D         &
 &                                 , fsr_ball, fsi_ball         &
 &                                 , m_ES_gather_f_3d_to_2d_blk &
 &                                 , m_ES_alloc_fsr_l_2d        &
 &                                 , m_ES_alloc_fsi_l_2d        &
 &                                 , m_ES_dealloc_fsr_l_2d      &
 &                                 , m_ES_dealloc_fsi_l_2d
  use m_PlaneWaveBasisSet,   only : ngabc_kngp_l, ngabc_kngp_B_l
  use m_Electronic_Structure,only :  afft,bfft 

  use m_Electronic_Structure, only : m_ES_WF_in_Rspace_3D, m_ES_WF_2D_psi

!<<----

! ============================ added by K. Tagami =================== 11.0
  use m_Control_Parameters,   only : noncol, ndim_spinor, SpinOrbit_mode, sw_hubbard, &
       &                             orb_popu_method
  use m_PseudoPotential,      only : dion_scr_noncl, q_noncl, taup_pao
  use m_ES_NonCollinear,      only : m_ES_alloc_spinor_eigenwfn_0, &
       &                             m_ES_dealloc_spinor_eigenwfn_0, &
       &                             m_ES_set_spinor_eigenwfn_0, &
       &                             Spinor_EigenWfn0_atomtyp
  use m_SpinOrbit_Potential,  only : EigenWfns_MatLS_L0, &
       &                            EigenWfns_MatLS_L1, &
       &                            EigenWfns_MatLS_L2, &
       &                            EigenWfns_MatLS_L3
  use m_SpinOrbit_Potential,   only : EigenVals_MatLS_L0, &
       &                            EigenVals_MatLS_L1, &
       &                            EigenVals_MatLS_L2, &
       &                            EigenVals_MatLS_L3
  use m_Const_Parameters,    only : Neglected, BuiltIn, ByProjector, ByPawPot, &
       &                            ZeffApprox, ReadFromPP
! ================================================================== 11.0

  implicit none

! === DEBUG by tkato for restart!!! 2012/02/12 =================================
! integer                                             :: npesize
  integer                                             :: npesize = 0
! ==============================================================================

  real(kind=DP),        allocatable,dimension(:)      :: zfcos, zfsin  !d(nbmx_ext)
  real(kind=DP),        allocatable,dimension(:)      :: zfcos_mpi,zfsin_mpi !d(mp_nbmx)
!!$  real(kind=DP),        allocatable,dimension(:)      :: zfcos_mpi_k, zfsin_mpi_k !d(mp_nbmx_k)
  real(kind=DP),private,allocatable,dimension(:)      :: ar, ai

  real(kind=DP), allocatable, target, dimension(:)    :: sc, ss, qc, qs
  real(kind=DP), allocatable, target, dimension(:)    :: sc_l

  integer, private, parameter                         :: sw_timing_2ndlevel = ON

#ifdef NONLOCAL_DGEMM
  real(kind=DP),        allocatable,dimension(:,:)    :: wk_zfcos, wk_zfsin  !d(nbmx_ext)
!!$  integer      ,allocatable,dimension(:)              :: lmtt_tmp
  real(kind=DP),private,allocatable,dimension(:,:)    :: wk_ar,  wk_ai
  real(kind=DP),allocatable,dimension(:,:)            :: bp_tmp1,  bp_tmp2
!!$  real(kind=DP),allocatable,dimension(:)              :: ia_tmp
  logical :: DGEMM_DEBUG = .false.
#endif

  real(kind=DP),          allocatable, dimension(:,:) :: pre_sc_without, pre_ss_without

#ifdef SX
  integer,private                                     :: nb_vnonlocal_default = 5000  ! TY 26Aug2009
  integer,private                                     :: nb_betar_default     = 10000 ! TY
#else
  integer,private                                     :: nb_vnonlocal_default = 1000  ! TY 26Aug2009
  integer,private                                     :: nb_betar_default     = 32    ! TY
#endif

  integer, allocatable, dimension(:)                  :: full_to_dist,dist_to_full

  logical, allocatable, dimension(:)                  :: mapl
  integer                                             :: nonzero_fft_elements
  integer, allocatable, dimension(:)                  :: revmap
  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

  contains


  subroutine m_ES_alloc_scss_etc_3D()
    allocate(sc_l(1:maxval(np_g1k(:))))
  end subroutine m_ES_alloc_scss_etc_3D

  subroutine m_ES_dealloc_scss_etc()
    if(allocated(qs)) deallocate(qs)
    if(allocated(qc)) deallocate(qc)
    if(allocated(ss)) deallocate(ss)
    if(allocated(sc)) deallocate(sc)
    if(allocated(sc_l)) deallocate(sc_l)
    call m_FFT_dealloc_WF_work()
  end subroutine m_ES_dealloc_scss_etc


  subroutine m_ES_alloc_afft_scss_etc_3D()
! === DEBUG by tkato 2011/07/12 ================================================
!   allocate(afft(nfft))
!   allocate(bfft(nfft))
! Why are these lines comments???
    allocate(afft(nfft))
    allocate(bfft(nfft))
! ==============================================================================
    call m_ES_alloc_scss_etc_3D()
  end subroutine m_ES_alloc_afft_scss_etc_3D

  subroutine m_ES_dealloc_afft_scss_etc()
    call m_ES_dealloc_scss_etc()
    if(allocated(bfft)) deallocate(bfft)
    if(allocated(afft)) deallocate(afft)
  end subroutine m_ES_dealloc_afft_scss_etc

  subroutine alloc_zfsincos_mpi()
    if(flag_mpi_g_dot_r) then
       allocate(zfcos_mpi(mp_nbmx))
       allocate(zfsin_mpi(mp_nbmx))
    end if
  end subroutine alloc_zfsincos_mpi

  subroutine dealloc_zfsincos_mpi()
    if(flag_mpi_g_dot_r) deallocate(zfsin_mpi,zfcos_mpi)
  end subroutine dealloc_zfsincos_mpi

!!$  subroutine alloc_zfsincos_mpi_k()
!!$    if(flag_mpi_g_dot_r_k) then
!!$       allocate(zfcos_mpi_k(mp_nbmx_k))
!!$       allocate(zfsin_mpi_k(mp_nbmx_k))
!!$    end if
!!$  end subroutine alloc_zfsincos_mpi_k

!!$  subroutine dealloc_zfsincos_mpi_k
!!$    if(flag_mpi_g_dot_r_k) then
!!$       deallocate(zfcos_mpi_k)
!!$       deallocate(zfsin_mpi_k)
!!$    end if
!!$  end subroutine dealloc_zfsincos_mpi_k

  subroutine alloc_zfsincos(ibsize)
    integer, intent(in) :: ibsize
    allocate(zfsin(ibsize))
    allocate(zfcos(ibsize))
  end subroutine alloc_zfsincos

  subroutine dealloc_zfsincos
    deallocate(zfcos,zfsin)
  end subroutine dealloc_zfsincos


  subroutine dealloc_arai
    deallocate(ai,ar)
  end subroutine dealloc_arai

  subroutine m_ES_alloc_zfsincos(ik)
    integer, intent(in) :: ik
    if(ik == 0) then
! ============================== modified by K. Tagami =============== 11.0
!       if(kv3/nspin == 1) then
!          allocate(zfcos(iba(1)))
!          allocate(zfsin(iba(1)))
!       else
!          allocate(zfcos(nbmx_ext))
!          allocate(zfsin(nbmx_ext))
!       end if

       if ( noncol ) then
         if ( kv3/ndim_spinor == 1 ) then
            allocate(zfcos(iba(1)));  allocate(zfsin(iba(1)))
         else
            allocate(zfcos(nbmx_ext));  allocate(zfsin(nbmx_ext))
         endif
       else
         if ( kv3/nspin == 1 ) then
            allocate(zfcos(iba(1)));  allocate(zfsin(iba(1)))
         else
            allocate(zfcos(nbmx_ext));  allocate(zfsin(nbmx_ext))
         endif
       end if
! ==================================================================== 11.0
    else
       allocate(zfcos(iba(ik)))
       allocate(zfsin(iba(ik)))
    end if
! ================================= added by K. Tagami ============= 11.0
    zfcos = 0.0d0;  zfsin = 0.0d0
! ================================================================== 11.0
  end subroutine m_ES_alloc_zfsincos

  subroutine m_ES_dealloc_zfsincos()
    if(allocated(zfsin)) deallocate(zfsin)
    if(allocated(zfcos)) deallocate(zfcos)
  end subroutine m_ES_dealloc_zfsincos

  subroutine m_ES_alloc_arai_3D(ik)
    integer, intent(in) :: ik
    allocate(ar(maxval(np_g1k)))
    allocate(ai(maxval(np_g1k)))
  end subroutine m_ES_alloc_arai_3D

  subroutine m_ES_dealloc_arai_3D()
    deallocate(ar,ai)
  end subroutine m_ES_dealloc_arai_3D

#ifdef NONLOCAL_DGEMM
  subroutine alloc_wkzfsincos(ibsize)
    integer, intent(in) :: ibsize
    integer             :: ichkalloc
    allocate(wk_zfsin(ibsize,natm), stat=ichkalloc)
    allocate(wk_zfcos(ibsize,natm), stat=ichkalloc)
    if( ichkalloc /= 0 ) then
      write(nfout,*) 'could not allocate wk_zfsin or wk_zfcos in alloc_wkzfsincos', ibsize, natm
      stop
    endif
  end subroutine alloc_wkzfsincos

  subroutine alloc_wkzfsincos_red(ibsize,natmsize)
    integer, intent(in) :: ibsize, natmsize
    integer             :: ichkalloc
    allocate(wk_zfsin(ibsize,natmsize), stat=ichkalloc)
    allocate(wk_zfcos(ibsize,natmsize), stat=ichkalloc)
    if( ichkalloc /= 0 ) then
      write(nfout,*) 'could not allocate wk_zfsin or wk_zfcos in alloc_wkzfsincos_red', ibsize, natm
      stop
    endif
    wk_zfsin = 0.d0; wk_zfcos = 0.d0
  end subroutine alloc_wkzfsincos_red

  subroutine dealloc_wkzfsincos
    deallocate(wk_zfcos,wk_zfsin)
  end subroutine dealloc_wkzfsincos

  subroutine alloc_wkarai(ibsize,ibsize2)
    integer, intent(in) :: ibsize, ibsize2
    integer             :: ichkalloc
    allocate( wk_ar(ibsize,ibsize2),stat=ichkalloc )
    allocate( wk_ai(ibsize,ibsize2),stat=ichkalloc )
    if( ichkalloc /= 0 ) then
      write(nfout,*) ' could not allocate wk_ar or wk_ai in alloc_wkarai ', ibsize, ibsize2
      stop
    endif
    wk_ar=0.d0
    wk_ai=0.d0
  end subroutine alloc_wkarai

  subroutine dealloc_wkarai
    deallocate( wk_ai, wk_ar)
  end subroutine dealloc_wkarai

  subroutine alloc_wkbp(ik,LD11,LD12)
    integer , intent(in) :: ik,LD11,LD12
    integer             :: ichkalloc
    if(k_symmetry(ik) == GAMMA) then
       allocate( bp_tmp1(LD11,LD12)  ,stat=ichkalloc )
    else
       allocate( bp_tmp1(LD11,LD12)  ,stat=ichkalloc )
       allocate( bp_tmp2(LD11,LD12)  ,stat=ichkalloc )
    end if
    if( ichkalloc /= 0 ) then
      write(nfout,*) ' could not allocate bp_tmp in alloc_wkbp ', LD11, LD12
      stop
    endif
  end subroutine alloc_wkbp

  subroutine dealloc_wkbp(ik)
    integer, intent(in) :: ik
    if(k_symmetry(ik) == GAMMA) then
       deallocate( bp_tmp1)
    else
       deallocate( bp_tmp1,bp_tmp2)
    end if
  end subroutine dealloc_wkbp

!!$  subroutine alloc_wkother(icnt)
!!$    integer,intent(in) :: icnt
!!$    integer             :: ichkalloc
!!$    allocate(lmtt_tmp(icnt), stat=ichkalloc )
!!$    allocate(   ia_tmp(icnt), stat=ichkalloc )
!!$    if( ichkalloc /= 0 ) then
!!$      write(nfout,*) 'could not allocate work-array in alloc_wkother', icnt
!!$      stop
!!$    endif
!!$  end subroutine alloc_wkother

!!$  subroutine dealloc_wkother
!!$    deallocate( ia_tmp )
!!$    deallocate( lmtt_tmp)
!!$  end subroutine dealloc_wkother
#endif


#ifdef NONLOCAL_DGEMM

!------------------------------------------------------------------------------
!------------------------------------------------------------------------------

  subroutine m_ES_Vnonlocal_W_3D(ik,iksnl,ispin,switch_of_eko_part)
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
!
    integer, intent(in) :: ik,iksnl,ispin
    integer, intent(in) :: switch_of_eko_part

    integer :: mdvdb, it, ia, lmt2
    integer :: ibl1,ibl2,ibsize
    integer :: ichkalloc
    integer :: id_sname = -1
!!  real(kind=DP),allocatable,dimension(:,:) :: wk_sc_without,  wk_ss_without
    real(kind=DP),allocatable,dimension(:,:) :: wk_sc_with,     wk_ss_with,     wk_qc_with,     wk_qs_with
    real(kind=DP),allocatable,dimension(:,:) :: fsr_tmp_without, fsi_tmp_without
    real(kind=DP),allocatable,dimension(:,:) :: fsr_tmp_with   , fsi_tmp_with
    integer,allocatable,dimension(:) :: lmt2_tmp_without, ia_tmp_without, lmta2_tmp_without
    integer,allocatable,dimension(:) :: lmt2_tmp_with,    ia_tmp_with,    lmta2_tmp_with
    integer,allocatable,dimension(:) :: il2_tmp_without,  im2_tmp_without
    integer,allocatable,dimension(:) :: il2_tmp_with,     im2_tmp_with
    integer :: icnt_without  , icnt_with , icblk , icbl1 , icbl2
    logical :: mdvdb_EXECUT = .false.
    integer, save :: ibsize_print = OFF
    integer,save :: pre_proc_switch = 999
    integer,save :: pre_proc_ik     = 0
    logical :: chg_cond
!!  integer :: ist
    integer :: lnblck, lnsize, lnb1, lnb2
! === rspace on 3D_Parallel ==============================================================
    logical :: flag_in_realspace

    flag_in_realspace = .false.
    if(sw_rspace == ON) then
       if(m_CtrlP_realspace_integ_OK()) flag_in_realspace = .true.
    end if

    if(ipri >= 2 .and. sw_rspace == ON .and. .not. flag_in_realspace) write(nfout,&
       & '(" sw_rspace = ON, but the realspace integration is not installed in the solver now applied. ")')

    if(flag_in_realspace) then
       if(allocated(vnlph_l)) then
          if(size(vnlph_l,1) .ne. np_g1k(ik)) then
             deallocate(vnlph_l)
             allocate(vnlph_l(np_g1k(ik),np_e,kimg))
          end if
       else
          allocate(vnlph_l(np_g1k(ik),np_e,kimg))
       end if
       call Vnonlocal_W_in_realspace(ik,ispin,switch_of_eko_part)
    else
! ========================================================================================
    call tstatc0_begin('m_ES_Vnonlocal_W_3D ',id_sname,level=1)
! --> T. Yamasaki, 26th Aug. 2009
!!$    ibsize=5000
                                                                __TIMER_SUB_START(201)
    if(nblocksize_vnonlocal_is_given) then
       ibsize = nblocksize_vnonlocal_w
    else
       ibsize= nb_vnonlocal_default
       if(ipri >= 2 .and. ibsize_print == OFF) then
          write(nfout,'(" !ibsize(=nblocksize_vnonlocal_w) (m_ES_Vnonlocal_W) = ",i8)') ibsize
!!$             ibsize_print = ON
       end if
    end if
! <--
    if(nblocksize_vnonlocal_w_nlmta_is_given) then
       icblk = nblocksize_vnonlocal_w_nlmta
    else
       icblk = nlmta
       if(ipri >= 2 .and. ibsize_print == OFF) then
          write(nfout,'(" !icblk(=nblocksize_vnonlocal_w_nlmta) (m_ES_Vnonlocal_W) = ",i8)') icblk
       end if
    end if

#ifdef _NONLOCAL_MEMORY_KEEP_
    if ((pre_proc_switch .eq. switch_of_eko_part) .and. (pre_proc_ik .eq. ik)) then
       chg_cond = .false.
    else
       chg_cond = .true.
    endif
#else
    chg_cond = .true.
#endif
    if(nblocksize_vnonlocal_w_f_is_given) then
       lnblck = nblocksize_vnonlocal_w_f
       if(np_e < lnblck) then
          lnblck = np_e
       end if
       if(1 > lnblck) then
          lnblck = np_e
       end if
    else
       lnblck = np_e
       if(ipri >= 1 .and. ibsize_print == OFF) then
          write(nfout,'(" !lnblck(=nblocksize_vnonlocal_w_f) (m_ES_Vnonlocal_W) = ",i8)') lnblck
       end if
    end if

    icnt_without=0
    icnt_with=0

    allocate( lmt2_tmp_without(nlmta), stat=ichkalloc ) ;  lmt2_tmp_without=0
    allocate(   ia_tmp_without(nlmta), stat=ichkalloc ) ;    ia_tmp_without=0
    allocate(lmta2_tmp_without(nlmta), stat=ichkalloc ) ; lmta2_tmp_without=0
    allocate( lmt2_tmp_with(nlmta),    stat=ichkalloc ) ;     lmt2_tmp_with=0
    allocate(   ia_tmp_with(nlmta),    stat=ichkalloc ) ;       ia_tmp_with=0
    allocate(lmta2_tmp_with(nlmta),    stat=ichkalloc ) ;    lmta2_tmp_with=0
    allocate( il2_tmp_without(nlmta),  stat=ichkalloc ) ;   il2_tmp_without=0
    allocate( im2_tmp_without(nlmta),  stat=ichkalloc ) ;   im2_tmp_without=0
    allocate( il2_tmp_with(nlmta),     stat=ichkalloc ) ;      il2_tmp_with=0
    allocate( im2_tmp_with(nlmta),     stat=ichkalloc ) ;      im2_tmp_with=0
    if( ichkalloc /= 0 ) then
      write(nfout,*) 'could not allocate work-array in m_ES_Vnonlocal_W', nlmta
      stop
    endif

    call pre_m_ES_Vnonlocal_W( icnt_without, icnt_with )

    do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(switch_of_eko_part == OFF) mdvdb= SKIP
       if(mdvdb == EXECUT) then
         mdvdb_EXECUT = .true.
         exit
       endif
    end do

#ifdef _NONLOCAL_MEMORY_KEEP_
    if (chg_cond) then
       if (allocated(pre_sc_without)) deallocate(pre_sc_without)
       if (allocated(pre_ss_without)) deallocate(pre_ss_without)
       allocate( pre_sc_without(np_g1k(ik),icnt_without), stat=ichkalloc ) ;   pre_sc_without=0.d0
       allocate( pre_ss_without(np_g1k(ik),icnt_without), stat=ichkalloc ) ;   pre_ss_without=0.d0
       if( ichkalloc /= 0 ) then
         write(nfout,*) 'could not allocate work-array1 in m_ES_Vnonlocal_W', ibsize, icnt_without, icnt_with, np_e
         stop
       endif
    endif
#else
    allocate( pre_sc_without(np_g1k(ik),icnt_without), stat=ichkalloc ) ;   pre_sc_without=0.d0
    allocate( pre_ss_without(np_g1k(ik),icnt_without), stat=ichkalloc ) ;   pre_ss_without=0.d0
    if( ichkalloc /= 0 ) then
      write(nfout,*) 'could not allocate work-array1 in m_ES_Vnonlocal_W', ibsize, icnt_without, icnt_with, np_e
      stop
    endif
#endif

    if (ibsize .gt. np_g1k(ik)) then
       ibsize = np_g1k(ik)
    endif
    call alloc_wkzfsincos(ibsize)

!!  allocate( wk_sc_without(ibsize,icnt_without), stat=ichkalloc ) ;   wk_sc_without=0.d0
!!  allocate( wk_ss_without(ibsize,icnt_without), stat=ichkalloc ) ;   wk_ss_without=0.d0
!x  allocate( fsr_tmp_without(np_e,min(icblk,icnt_without)) ,stat=ichkalloc ) ; fsr_tmp_without=0.d0
    allocate( fsr_tmp_without(lnblck,min(icblk,icnt_without)) ,stat=ichkalloc ) ; fsr_tmp_without=0.d0
    allocate( wk_sc_with(ibsize,min(icblk,icnt_with)),       stat=ichkalloc ) ;      wk_sc_with=0.d0
    allocate( wk_ss_with(ibsize,min(icblk,icnt_with)),       stat=ichkalloc ) ;      wk_ss_with=0.d0
!x  allocate( fsr_tmp_with(np_e,min(icblk,icnt_with)),       stat=ichkalloc ) ;    fsr_tmp_with=0.d0
    allocate( fsr_tmp_with(lnblck,min(icblk,icnt_with)),       stat=ichkalloc ) ;    fsr_tmp_with=0.d0
!x  call m_ES_alloc_fsr_l_2d()
    call m_ES_alloc_fsr_l_2d(lnblck,nlmta)

    if( ichkalloc /= 0 ) then
       write(nfout,'(" ibsize, icblk, icnt_without, icnt_with = ", 4i8)') ibsize, icblk, icnt_without, icnt_with
       write(nfout,'(" np_e, nlmta = ", 2i8)') np_e, nlmta
      write(nfout,*) 'could not allocate work-array2 in m_ES_Vnonlocal_W', ibsize, icnt_without, icnt_with, np_e
      stop ' could not allocate work-array2 in m_ES_Vnonlocal_W (2)'
    endif

    if( k_symmetry(ik) /= GAMMA ) then
!x    allocate( fsi_tmp_without(np_e,icnt_without), stat=ichkalloc )
!x    allocate( fsi_tmp_with(np_e,min(icblk,icnt_with))      , stat=ichkalloc )
!x    call m_ES_alloc_fsi_l_2d()
      allocate( fsi_tmp_without(lnblck,icnt_without), stat=ichkalloc )
      allocate( fsi_tmp_with(lnblck,min(icblk,icnt_with))      , stat=ichkalloc )
      call m_ES_alloc_fsi_l_2d(lnblck,nlmta)
      fsi_tmp_without=0.d0
      fsi_tmp_with=0.d0
      if( ichkalloc /= 0 ) then
        write(nfout,*) 'could not allocate work-array3 in m_ES_Vnonlocal_W', np_e,icnt_without,icnt_with
        stop
      endif
    endif

    if(mdvdb_EXECUT) then
      allocate( wk_qc_with(ibsize,min(icblk,icnt_with)), stat=ichkalloc ) ; wk_qc_with=0.d0
      allocate( wk_qs_with(ibsize,min(icblk,icnt_with)), stat=ichkalloc ) ; wk_qs_with=0.d0
      if( ichkalloc /= 0 ) then
        write(nfout,*) 'could not allocate work-array4 in m_ES_Vnonlocal_W', icnt_without, icnt_with, natm
        stop
      endif
    endif
!
!
! Revised by T. Yamasaki, September 2008
!
   if(DGEMM_DEBUG) write(nfout,*)' DGEMM_debug Vnonlocal :', &
                   icnt_without,icnt_with, nlmta, ibsize, kimg, k_symmetry(ik), GAMMA
   if(ibsize_print == OFF .and. ipri >= 1) then
     write(nfout,*)'<<m_ES_Vnonlocal_W>>'
     write(nfout,'(" mype = ",i3, " ibsize, np_e, icnt_with, icnt_without, iba(ik)/ibsize = " &
    &   ,5i8," <<m_ES_Vnonlocal_W>>")') mype, ibsize, np_e, icnt_with, icnt_without, iba(ik)/ibsize
     write(nfout,*)'myrank_e=',myrank_e,'myrank_e=',myrank_e,'myrank_g=',myrank_g, &
    &             'ik=',ik,'ispin=',ispin,'switch_of_eko_part=',switch_of_eko_part
     write(nfout,*)'np_e=',np_e,'iba(ik)=',iba(ik),'ibsize=',ibsize,'nlmta=',nlmta,&
    &             'iksnl=',iksnl,'kimg=',kimg,' chg_cond=',chg_cond
     write(nfout,*)'ista_g1k(ik)=',ista_g1k(ik),'iend_g1k(ik)=',iend_g1k(ik), &
    &             'np_g1k(ik)=',np_g1k(ik),    'mp_g1k(ik)=',mp_g1k(ik)
     write(nfout,*)'ista_e=',ista_e,'iend_e=',iend_e, 'neg=',neg,' lnblck=',lnblck
     write(nfout,*)'icnt_with=',icnt_with,'icnt_without=',icnt_without,'icblk=',icblk, &
    &             'k_symmetry(ik)=',k_symmetry(ik),'GAMMA=',GAMMA,'iteration=',iteration
     ibsize_print = ON
   end if

!!   call gather_f_3d_to_2d(fsr_l_3D, fsr_l_2D)
!x   call m_ES_gather_f_3d_to_2d(fsr_l, fsr_l_2D, ik)
!x   if( k_symmetry(ik) /= GAMMA ) then
!!      call gather_f_3d_to_2d(fsi_l_3D, fsi_l_2D)
!x      call m_ES_gather_f_3d_to_2d(fsi_l, fsi_l_2D, ik)
!x   endif
     if (allocated(vnlph_l)) then
       if (size(vnlph_l,1) .ne. np_g1k(ik)) then
          deallocate(vnlph_l)   
          allocate(vnlph_l(np_g1k(ik),np_e,kimg))
       endif
     else
        allocate(vnlph_l(np_g1k(ik),np_e,kimg))
     endif

     vnlph_l = 0.0d0

  do lnb1 = 1, np_e, lnblck
     lnb2=min( lnb1+lnblck-1,np_e )
     lnsize = lnb2-lnb1 + 1

     call m_ES_gather_f_3d_to_2d_blk(fsr_l, fsr_l_2D, ik, lnblck, lnb1, lnsize)
     if( k_symmetry(ik) /= GAMMA ) then
        call m_ES_gather_f_3d_to_2d_blk(fsi_l, fsi_l_2D, ik, lnblck, lnb1, lnsize)
     endif

     do ibl1=ista_g1k(ik),iend_g1k(ik),ibsize
        ibl2=min( ibl1+ibsize-1,iend_g1k(ik) )
        call calc_phase_blk(ik,ibl1,ibl2)
        if( icnt_with .gt. 0 ) then
           do icbl1 = 1 , icnt_with , icblk
              icbl2 = min( icbl1+icblk-1,icnt_with )
              call Vnonlocal_W_part_with_blk_3D( ibl1,ibl2,icnt_with )
              call add_vnlph_l_with_eko_blk_3D(  ibsize,ibl1,ibl2,icnt_with, vnlph_l )
           enddo
        endif
        if( icnt_without .gt. 0 ) then
           do icbl1 = 1 , icnt_without , icblk
              icbl2 = min( icbl1+icblk-1,icnt_without )
              call Vnonlocal_W_part_without_blk_3D( ibl1,ibl2,icnt_without)
              call add_vnlph_l_without_eko_blk_3D(  ibsize,ibl1,ibl2,icnt_without,vnlph_l)
           enddo
        endif
     enddo

   enddo

    deallocate( lmt2_tmp_without,ia_tmp_without,lmta2_tmp_without,il2_tmp_without,im2_tmp_without )
    deallocate( lmt2_tmp_with,   ia_tmp_with,   lmta2_tmp_with,   il2_tmp_with,   im2_tmp_with    )
!!  deallocate( wk_sc_without,   wk_ss_without                   )
    deallocate( wk_sc_with,      wk_ss_with                      )
    deallocate( fsr_tmp_without, fsr_tmp_with )
    call m_ES_dealloc_fsr_l_2d()
    if(mdvdb_EXECUT) then
       deallocate( wk_qc_with,  wk_qs_with )
    endif
    if( k_symmetry(ik) /= GAMMA ) then
       deallocate( fsi_tmp_without, fsi_tmp_with )
       call m_ES_dealloc_fsi_l_2d()
    endif
    call dealloc_wkzfsincos()
#ifndef _NONLOCAL_MEMORY_KEEP_
    deallocate(pre_sc_without)
    deallocate(pre_ss_without)
#endif
    pre_proc_switch = switch_of_eko_part
    pre_proc_ik     = ik

    call tstatc0_end(id_sname)
                                                                __TIMER_SUB_STOP(201)
! === rspace on 3D_Parallel ==============================================================
    end if
! ========================================================================================
  contains
    subroutine pre_m_ES_Vnonlocal_W( icnt_without, icnt_with )
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
!
      integer,intent(inout) :: icnt_without, icnt_with
                                                                __TIMER_SUB_START(202)
                                                                __TIMER_DO_START(209)
      do ia = 1, natm
         it = ityp(ia)
         mdvdb = m_PP_include_vanderbilt_pot(it)
         if(switch_of_eko_part == OFF) mdvdb= SKIP
         if( mdvdb==SKIP ) then
            do lmt2 = 1, ilmt(it)
               icnt_without = icnt_without + 1
               lmt2_tmp_without(icnt_without)  = lmt2
               ia_tmp_without(icnt_without)    =   ia
               lmta2_tmp_without(icnt_without) = lmta(lmt2,ia)
               il2_tmp_without(icnt_without)   =  ltp(lmt2,it)
               im2_tmp_without(icnt_without)   =  mtp(lmt2,it)
            enddo
         elseif( mdvdb==EXECUT ) then
            do lmt2 = 1, ilmt(it)
               icnt_with = icnt_with + 1
               lmt2_tmp_with(icnt_with)  = lmt2
               ia_tmp_with(icnt_with)    =   ia
               lmta2_tmp_with(icnt_with) = lmta(lmt2,ia)
               il2_tmp_with(icnt_with)   =  ltp(lmt2,it)
               im2_tmp_with(icnt_with)   =  mtp(lmt2,it)
            enddo
         endif
      enddo
                                                                __TIMER_DO_STOP(209)
                                                                __TIMER_SUB_STOP(202)
    end subroutine pre_m_ES_Vnonlocal_W

    subroutine calc_phase_blk(ik,ibl1,ibl2)
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
!
      integer, intent(in) :: ik, ibl1, ibl2
      integer :: i, nb, ia
      real(kind=DP) :: ph, f1, f2, f3
      integer :: id_sname0 = -1
                                                                __TIMER_SUB_START(204)
      if(sw_timing_2ndlevel == ON) call tstatc0_begin('calc_phase_blk ',id_sname0)

!cdir outerunroll=16
                                                                __TIMER_DO_START(213)
!fj!OCL SERIAL
!OCL NOFLTLD
      do i = ibl1, ibl2
         nb = nbase(i,ik)
!fj!OCL PARALLEL
         do ia=1,natm
            f1 = pos(ia,1)*PAI2; f2 = pos(ia,2)*PAI2; f3 = pos(ia,3)*PAI2
            ph = ngabc(nb,1)*f1+ngabc(nb,2)*f2+ngabc(nb,3)*f3
            wk_zfcos(i-ibl1+1,ia) = dcos(ph)
            wk_zfsin(i-ibl1+1,ia) = dsin(ph)
         enddo
      enddo
                                                                __TIMER_DO_STOP(213)
      if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname0)
                                                                __TIMER_SUB_STOP(204)
    end subroutine calc_phase_blk

    subroutine Vnonlocal_W_part_without_blk_3D(iblk1,iblk2,icnt_without)
!
! (FUJITSU), December 2009
!

      integer, intent(in) :: iblk1,iblk2, icnt_without
      integer       :: lmt1, lmtt1, il1, im1, il11, mdl
      integer       :: ia, i, lmta2, il2, im2, lmt2, ic, iadd, icadd
      real(kind=DP) :: tmp
      integer :: id_sname = -1
                                                                __TIMER_SUB_START(207)
      call tstatc0_begin('Vnonlocal_W_part_without_blk_3D ',id_sname)

!!      wk_sc_without = 0.d0
!!      wk_ss_without = 0.d0

!!      do ic = 1, icnt_without
                                                                __TIMER_DO_START(226)
!$OMP PARALLEL DO SCHEDULE(RUNTIME) DEFAULT(none)    &
!$OMP             SHARED(icbl1,icbl2,ia_tmp_without,ityp,lmta2_tmp_without,il2_tmp_without,  &
!$OMP                    im2_tmp_without,lmt2_tmp_without,fsr_tmp_without,fsr_l_2D,k_symmetry, &
!$OMP                    ik,fsi_tmp_without,fsi_l_2D,lnsize,ilmt,lmtt,ltp,mtp,dion,dion_paw,vlhxcQ, &
!$OMP                    ispin,iwei,iblk1,iblk2,pre_sc_without,wk_zfcos,snl,iksnl,pre_ss_without, &
!$OMP                    wk_zfsin,ista_g1k,q,chg_cond,lnblck,np_e,lnb1,ipaw)   &
!$OMP             PRIVATE(ic,ia,it,lmta2,il2,im2,lmt2,icadd,lmt1,lmtt1,il1,im1,il11,  &
!$OMP                     mdl,tmp,i,iadd)
!OCL NOFLTLD
        do ic = icbl1, icbl2
           ia   = ia_tmp_without(ic)
           it   = ityp(ia)
           lmta2= lmta2_tmp_without(ic)
           il2  = il2_tmp_without(ic)
           im2  = im2_tmp_without(ic)
           lmt2 = lmt2_tmp_without(ic)
           icadd = ic-icbl1+1
!x         fsr_tmp_without(1:np_e,icadd) = fsr_l_2D(1:np_e,lmta2)
           fsr_tmp_without(1:lnsize,icadd) = fsr_l_2D(1:lnsize,lmta2)
           if(k_symmetry(ik) /= GAMMA) then
!x            fsi_tmp_without(1:np_e,icadd) = fsi_l_2D(1:np_e,lmta2)
              fsi_tmp_without(1:lnsize,icadd) = fsi_l_2D(1:lnsize,lmta2)
           endif

           if (.not. chg_cond) then
              cycle
           endif

!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
           if (lnblck /= np_e) then
              if (lnb1 /= 1) then
                 cycle
              end if
           end if
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

           do lmt1 = 1,ilmt(it)
              lmtt1 = lmtt(lmt1,it)
              il1   = ltp(lmt1,it)
              im1   = mtp(lmt1,it)
              il11  = il1 - 1
              mdl   = mod(il11,4)
              if(il1 == il2 .and. im1 == im2) then
! === DEBUG by tkato 2011/10/05 ================================================
!                tmp = dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)
                 if(ipaw(it)==0) then
                    tmp = dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)
                 else
                    tmp = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
                 endif
! ==============================================================================
              else
! === DEBUG by tkato 2011/10/05 ================================================
!                tmp = vlhxcQ(lmt1,lmt2,ia,ispin)
                 if(ipaw(it)==0) then
                    tmp = vlhxcQ(lmt1,lmt2,ia,ispin)
                 else
                    tmp = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
                 end if
! ==============================================================================
              endif
              tmp = tmp * iwei(ia)
              if(mdl == 2 .or. mdl == 3) tmp = -1*tmp
              if(mdl == 0 .or. mdl == 2) then
!fj                                                                __TIMER_DO_START(227)
                 do i =  iblk1, iblk2
!!                  wk_sc_without(i-iblk1+1,ic) = wk_sc_without(i-iblk1+1,ic) + tmp*wk_zfcos(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
!!                  wk_ss_without(i-iblk1+1,ic) = wk_ss_without(i-iblk1+1,ic) - tmp*wk_zfsin(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
                    iadd = i-ista_g1k(ik)+1
                    pre_sc_without(iadd,ic) = pre_sc_without(iadd,ic) + tmp*wk_zfcos(i-iblk1+1,ia)*snl(iadd,lmtt1,iksnl)
                    pre_ss_without(iadd,ic) = pre_ss_without(iadd,ic) - tmp*wk_zfsin(i-iblk1+1,ia)*snl(iadd,lmtt1,iksnl)
                 enddo
!fj                                                                __TIMER_DO_STOP(227)
              else if(mdl == 1 .or. mdl == 3) then
!fj                                                                __TIMER_DO_START(228)
                 do i =  iblk1, iblk2
!!                  wk_sc_without(i-iblk1+1,ic) = wk_sc_without(i-iblk1+1,ic) - tmp*wk_zfsin(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
!!                  wk_ss_without(i-iblk1+1,ic) = wk_ss_without(i-iblk1+1,ic) - tmp*wk_zfcos(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
                    iadd = i-ista_g1k(ik)+1
                    pre_sc_without(iadd,ic) = pre_sc_without(iadd,ic) - tmp*wk_zfsin(i-iblk1+1,ia)*snl(iadd,lmtt1,iksnl)
                    pre_ss_without(iadd,ic) = pre_ss_without(iadd,ic) - tmp*wk_zfcos(i-iblk1+1,ia)*snl(iadd,lmtt1,iksnl)
                 enddo
!fj                                                                __TIMER_DO_STOP(228)
              endif
           end do
        end do
                                                                __TIMER_DO_STOP(226)

!!$                                                                __TIMER_DO_START(227)
!!$                                                                __TIMER_DO_START(228)
!!$                                                                __TIMER_DO_STOP(228)
!!$                                                                __TIMER_DO_STOP(227)

        call tstatc0_end(id_sname)
                                                                __TIMER_SUB_STOP(207)
    end subroutine Vnonlocal_W_part_without_blk_3D

    subroutine Vnonlocal_W_part_with_blk_3D(iblk1,iblk2,icnt_with)
!
! (FUJITSU), December 2009
!

      integer, intent(in) :: iblk1,iblk2, icnt_with
      integer       :: lmt1, lmtt1, il1, im1, il11, mdl
      integer       :: ia, i, lmta2, il2, im2, lmt2, ic, icadd
      real(kind=DP) :: tmp
      integer :: id_sname = -1
                                                                __TIMER_SUB_START(205)
      call tstatc0_begin('Vnonlocal_W_part_with_blk_3D ',id_sname)

        wk_sc_with = 0.d0
        wk_ss_with = 0.d0
        wk_qc_with = 0.d0
        wk_qs_with = 0.d0

!!      do ic = 1, icnt_with
                                                                __TIMER_DO_START(214)
!#ifdef USE_PROF
!  call timer_sta(214)
!#endif
!$OMP PARALLEL DO SCHEDULE(RUNTIME) DEFAULT(none)    &
!$OMP             SHARED(icbl1,icbl2,ia_tmp_with,ityp,lmta2_tmp_with,il2_tmp_with,  &
!$OMP                    im2_tmp_with,lmt2_tmp_with,fsr_tmp_with,fsr_l_2D,k_symmetry, &
!$OMP                    ik,fsi_tmp_with,fsi_l_2D,lnsize,ilmt,lmtt,ltp,mtp,dion,dion_paw,ipaw,vlhxcQ, &
!$OMP                    ispin,iwei,iblk1,iblk2,wk_sc_with,wk_zfcos,snl,iksnl,wk_ss_with, &
!$OMP                    wk_zfsin,ista_g1k,q,wk_qc_with,wk_qs_with)   &
!$OMP             PRIVATE(ic,ia,it,lmta2,il2,im2,lmt2,icadd,lmt1,lmtt1,il1,im1,il11,  &
!$OMP                     mdl,tmp,i)
!OCL NOFLTLD
        do ic = icbl1, icbl2
           ia   = ia_tmp_with(ic)
           it   = ityp(ia)
           lmta2= lmta2_tmp_with(ic)
           il2  = il2_tmp_with(ic)
           im2  = im2_tmp_with(ic)
           lmt2 = lmt2_tmp_with(ic)
           icadd = ic-icbl1+1
!x         fsr_tmp_with(1:np_e,icadd) = fsr_l_2D(1:np_e,lmta2)
           fsr_tmp_with(1:lnsize,icadd) = fsr_l_2D(1:lnsize,lmta2)
           if(k_symmetry(ik) /= GAMMA) then
!x            fsi_tmp_with(1:np_e,icadd) = fsi_l_2D(1:np_e,lmta2)
              fsi_tmp_with(1:lnsize,icadd) = fsi_l_2D(1:lnsize,lmta2)
           endif

           do lmt1 = 1,ilmt(it)
              lmtt1 = lmtt(lmt1,it)
              il1   = ltp(lmt1,it)
              im1   = mtp(lmt1,it)
              il11  = il1 - 1
              mdl   = mod(il11,4)
              if(il1 == il2 .and. im1 == im2) then
! === DEBUG by tkato 2011/10/05 ================================================
!                tmp = dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)
                 if(ipaw(it)==0) then
                    tmp = dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)
                 else
                    tmp = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
                 endif
! ==============================================================================
              else
! === DEBUG by tkato 2011/10/05 ================================================
!                tmp = vlhxcQ(lmt1,lmt2,ia,ispin)
                 if(ipaw(it)==0) then
                    tmp = vlhxcQ(lmt1,lmt2,ia,ispin)
                 else
                    tmp = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
                 end if
! ==============================================================================
              endif
              tmp = tmp * iwei(ia)
              if(mdl == 2 .or. mdl == 3) tmp = -1*tmp
!fj                                                              __TIMER_DO_START(215)
              if(mdl == 0 .or. mdl == 2) then
                 do i =  iblk1, iblk2
                    wk_sc_with(i-iblk1+1,icadd) = wk_sc_with(i-iblk1+1,icadd) &
                     &+ tmp*wk_zfcos(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
                    wk_ss_with(i-iblk1+1,icadd) = wk_ss_with(i-iblk1+1,icadd) &
                     &- tmp*wk_zfsin(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
                 enddo
              else if(mdl == 1 .or. mdl == 3) then
                 do i =  iblk1, iblk2
                    wk_sc_with(i-iblk1+1,icadd) = wk_sc_with(i-iblk1+1,icadd) &
                     &- tmp*wk_zfsin(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
                    wk_ss_with(i-iblk1+1,icadd) = wk_ss_with(i-iblk1+1,icadd) &
                     &- tmp*wk_zfcos(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
                 enddo
              endif
!fj                                                              __TIMER_DO_STOP(215)
!fj                                                              __TIMER_DO_START(216)
              if( il1 == il2 .and. im1 == im2) then
                 tmp = q(lmt1,lmt2,it)*iwei(ia)
                 if(mdl == 2 .or. mdl == 3) tmp = -1*tmp
                 if(mdl == 0 .or. mdl == 2) then
                    do i =  iblk1, iblk2
                       wk_qc_with(i-iblk1+1,icadd) = wk_qc_with(i-iblk1+1,icadd) &
                     &+ tmp*wk_zfcos(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
                       wk_qs_with(i-iblk1+1,icadd) = wk_qs_with(i-iblk1+1,icadd) &
                     &- tmp*wk_zfsin(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
                    enddo
                 else if(mdl == 1 .or. mdl == 3) then
                    do i =  iblk1, iblk2
                       wk_qc_with(i-iblk1+1,icadd) = wk_qc_with(i-iblk1+1,icadd) &
                     &- tmp*wk_zfsin(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
                       wk_qs_with(i-iblk1+1,icadd) = wk_qs_with(i-iblk1+1,icadd) &
                     &- tmp*wk_zfcos(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
                    enddo
                 end if
              end if
!fj                                                              __TIMER_DO_STOP(216)
           end do
        end do
                                                                __TIMER_DO_STOP(214)

!!$                                                                __TIMER_DO_START(215)
!!$                                                                __TIMER_DO_START(216)
!!$                                                                __TIMER_DO_STOP(216)
!!$                                                                __TIMER_DO_STOP(215)
        call tstatc0_end(id_sname)
                                                                __TIMER_SUB_STOP(205)
    end subroutine Vnonlocal_W_part_with_blk_3D

    subroutine add_vnlph_l_with_eko_blk_3D(ibsize,ibl1,ibl2,icnt_with,vnlph)
!
! (FUJITSU), December 2009
!
      integer, intent(in) :: ibsize, ibl1, ibl2, icnt_with
      real(kind=DP), intent(inout), dimension(np_g1k(ik),np_e,kimg) :: vnlph
      integer          :: ic, ib
      integer       :: icsize , ista , icnt_size
      real(kind=DP) :: alpha, beta
      integer :: id_sname = -1
                                                                __TIMER_SUB_START(206)
      call tstatc0_begin('add_vnlph_l_with_eko_blk_3D ',id_sname)

      ista = ibl1-ista_g1k(ik)+1
      icnt_size = icbl2-icbl1+1

      if(kimg == 1) then
         icsize=ibl2-ibl1+1
         alpha= 1.d0;  beta= 1.d0

                                                                __TIMER_DGEMM_START(217)
!x       call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &              alpha,wk_sc_with,ibsize, fsr_tmp_with,np_e, beta,vnlph(ista,1,1),np_g1k(ik) )
         call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
        &              wk_sc_with,ibsize,fsr_tmp_with,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik) )

         alpha=-1.d0;  beta= 1.d0
!x       call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &              alpha,wk_ss_with,ibsize, fsi_tmp_with,np_e, beta,vnlph(ista,1,1),np_g1k(ik) )
         call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
        &              wk_ss_with,ibsize,fsi_tmp_with,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik) )
                                                                __TIMER_DGEMM_STOP(217)

!!       do ic = 1, icnt_with
                                                                __TIMER_DO_START(223)
         do ic = icbl1, icbl2
!x          do ib = 1, np_e                                           ! MPI
            do ib = 1, lnsize                                         ! MPI
!x             fsr_tmp_with(ib,ic-icbl1+1) = fsr_tmp_with(ib,ic-icbl1+1)*eko_l(ib,ik)
!x             fsi_tmp_with(ib,ic-icbl1+1) = fsi_tmp_with(ib,ic-icbl1+1)*eko_l(ib,ik)
               fsr_tmp_with(ib,ic-icbl1+1) = fsr_tmp_with(ib,ic-icbl1+1)*eko_l(ib+lnb1-1,ik)
               fsi_tmp_with(ib,ic-icbl1+1) = fsi_tmp_with(ib,ic-icbl1+1)*eko_l(ib+lnb1-1,ik)
            enddo
         enddo
                                                                __TIMER_DO_STOP(223)

         alpha=-1.d0;  beta= 1.d0
                                                                __TIMER_DGEMM_START(218)
!x       call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &              alpha,wk_qc_with,ibsize, fsr_tmp_with,np_e, beta,vnlph(ista,1,1),np_g1k(ik) )
         call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
        &              wk_qc_with,ibsize,fsr_tmp_with,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik) )
         alpha= 1.d0;  beta= 1.d0
!x       call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &              alpha,wk_qs_with,ibsize, fsi_tmp_with,np_e, beta,vnlph(ista,1,1),np_g1k(ik) )
         call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
        &              wk_qs_with,ibsize,fsi_tmp_with,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik) )
                                                                __TIMER_DGEMM_STOP(218)
      else if(kimg == 2) then
         if(k_symmetry(ik) == GAMMA) then
            icsize=ibl2-ibl1+1
            alpha= 1.d0;  beta= 1.d0
                                                                __TIMER_DGEMM_START(219)
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_sc_with,ibsize, fsr_tmp_with,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &             wk_sc_with,ibsize,fsr_tmp_with,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik))
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_ss_with,ibsize, fsr_tmp_with,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &             wk_ss_with,ibsize,fsr_tmp_with,lnblck,beta,vnlph(ista,lnb1,2),np_g1k(ik))
                                                                __TIMER_DGEMM_STOP(219)

!!          do ic = 1, icnt_with
                                                                __TIMER_DO_START(224)
!OCL NOFLTLD
            do ic = icbl1, icbl2
!x             do ib = 1, np_e                                           ! MPI
               do ib = 1, lnsize                                         ! MPI
!x                fsr_tmp_with(ib,ic-icbl1+1) = fsr_tmp_with(ib,ic-icbl1+1)*eko_l(ib,ik)
                  fsr_tmp_with(ib,ic-icbl1+1) = fsr_tmp_with(ib,ic-icbl1+1)*eko_l(ib+lnb1-1,ik)
               enddo
            enddo
                                                                __TIMER_DO_STOP(224)
            alpha=-1.d0;  beta= 1.d0
                                                                __TIMER_DGEMM_START(220)
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_qc_with,ibsize, fsr_tmp_with,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &              wk_qc_with,ibsize,fsr_tmp_with,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik))
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_qs_with,ibsize, fsr_tmp_with,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &              wk_qs_with,ibsize,fsr_tmp_with,lnblck,beta,vnlph(ista,lnb1,2),np_g1k(ik))
                                                                __TIMER_DGEMM_STOP(220)
         else
            icsize=ibl2-ibl1+1
            alpha= 1.d0;  beta= 1.d0
                                                                __TIMER_DGEMM_START(221)
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_sc_with,ibsize, fsr_tmp_with,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &              wk_sc_with,ibsize,fsr_tmp_with,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik))
            alpha=-1.d0;  beta= 1.d0
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_ss_with,ibsize, fsi_tmp_with,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &              wk_ss_with,ibsize,fsi_tmp_with,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik))
            alpha= 1.d0;  beta= 1.d0
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_sc_with,ibsize, fsi_tmp_with,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &              wk_sc_with,ibsize,fsi_tmp_with,lnblck,beta,vnlph(ista,lnb1,2),np_g1k(ik))
            alpha= 1.d0;  beta= 1.d0
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_ss_with,ibsize, fsr_tmp_with,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &              wk_ss_with,ibsize,fsr_tmp_with,lnblck,beta,vnlph(ista,lnb1,2),np_g1k(ik))
                                                                __TIMER_DGEMM_STOP(221)

!!          do ic = 1, icnt_with
                                                                __TIMER_DO_START(225)
            do ic = icbl1, icbl2
!x             do ib = 1, np_e                                           ! MPI
               do ib = 1, lnsize                                         ! MPI
!x                fsi_tmp_with(ib,ic-icbl1+1) = fsi_tmp_with(ib,ic-icbl1+1)*eko_l(ib,ik)
!x                fsr_tmp_with(ib,ic-icbl1+1) = fsr_tmp_with(ib,ic-icbl1+1)*eko_l(ib,ik)
                  fsi_tmp_with(ib,ic-icbl1+1) = fsi_tmp_with(ib,ic-icbl1+1)*eko_l(ib+lnb1-1,ik)
                  fsr_tmp_with(ib,ic-icbl1+1) = fsr_tmp_with(ib,ic-icbl1+1)*eko_l(ib+lnb1-1,ik)
               enddo
            enddo
                                                                __TIMER_DO_STOP(225)

            alpha=-1.d0;  beta= 1.d0
                                                                __TIMER_DGEMM_START(222)
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_qc_with,ibsize, fsr_tmp_with,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &              wk_qc_with,ibsize,fsr_tmp_with,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik))
            alpha= 1.d0;  beta= 1.d0
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_qs_with,ibsize, fsi_tmp_with,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &              wk_qs_with,ibsize,fsi_tmp_with,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik))
            alpha=-1.d0;  beta= 1.d0
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_qc_with,ibsize, fsi_tmp_with,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &              wk_qc_with,ibsize,fsi_tmp_with,lnblck,beta,vnlph(ista,lnb1,2),np_g1k(ik))
            alpha=-1.d0;  beta= 1.d0
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_qs_with,ibsize, fsr_tmp_with,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &              wk_qs_with,ibsize,fsr_tmp_with,lnblck,beta,vnlph(ista,lnb1,2),np_g1k(ik))
                                                                __TIMER_DGEMM_STOP(222)
         end if
      end if
      call tstatc0_end(id_sname)
                                                                __TIMER_SUB_STOP(206)
    end subroutine add_vnlph_l_with_eko_blk_3D

    subroutine add_vnlph_l_without_eko_blk_3D(ibsize,ibl1,ibl2,icnt_without,vnlph)
!
! (FUJITSU), December 2009
!
      integer, intent(in) :: ibsize, ibl1, ibl2, icnt_without
      real(kind=DP), intent(inout), dimension(np_g1k(ik),np_e,kimg) :: vnlph
      integer       :: icsize, ista, icnt_size
      real(kind=DP) :: alpha, beta
      integer :: id_sname = -1
      call tstatc0_begin('add_vnlph_l_without_eko_blk_3D ',id_sname)
                                                                __TIMER_SUB_START(208)

      ista = ibl1+1-ista_g1k(ik)
      icnt_size = icbl2-icbl1+1

!!    wk_sc_without(1:ibsize,1:icnt_without) = pre_sc_without(ista:ista+ibsize-1,1:icnt_without)
!!    wk_ss_without(1:ibsize,1:icnt_without) = pre_ss_without(ista:ista+ibsize-1,1:icnt_without)

      if(kimg == 1) then
         icsize=ibl2-ibl1+1
         alpha= 1.d0;  beta= 1.d0
                                                                __TIMER_DGEMM_START(229)
!!       call DGEMM__('N','T', icsize,np_e,icnt_without, &
!!      &              alpha,wk_sc_without,ibsize, fsr_tmp_without,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
!x       call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &              alpha,pre_sc_without(ista,icbl1),np_g1k(ik), fsr_tmp_without,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
         call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha,pre_sc_without(ista,icbl1), &
        &              np_g1k(ik),fsr_tmp_without,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik))

         alpha=-1.d0;  beta= 1.d0
!!       call DGEMM__('N','T', icsize,np_e,icnt_without, &
!!      &              alpha,wk_ss_without,ibsize, fsi_tmp_without,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
!x       call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &              alpha,pre_ss_without(ista,icbl1),np_g1k(ik), fsi_tmp_without,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
         call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha,pre_ss_without(ista,icbl1), &
        &              np_g1k(ik),fsi_tmp_without,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik))
                                                                __TIMER_DGEMM_STOP(229)
      else if(kimg == 2) then
         if(k_symmetry(ik) == GAMMA) then
            icsize=ibl2-ibl1+1
            alpha= 1.d0;  beta= 1.d0
                                                                __TIMER_DGEMM_START(230)
!!          call DGEMM__('N','T', icsize,np_e,icnt_without, &
!!      &                 alpha,wk_sc_without,ibsize, fsr_tmp_without,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &                 alpha,pre_sc_without(ista,icbl1),np_g1k(ik), fsr_tmp_without,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha,pre_sc_without(ista,icbl1), &
        &                 np_g1k(ik),fsr_tmp_without,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik))
!!          call DGEMM__('N','T', icsize,np_e,icnt_without, &
!!      &                 alpha,wk_ss_without,ibsize, fsr_tmp_without,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &                 alpha,pre_ss_without(ista,icbl1),np_g1k(ik), fsr_tmp_without,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha,pre_ss_without(ista,icbl1), &
        &                 np_g1k(ik),fsr_tmp_without,lnblck,beta,vnlph(ista,lnb1,2),np_g1k(ik))
                                                                __TIMER_DGEMM_STOP(230)
         else
            icsize=ibl2-ibl1+1
            alpha= 1.d0;  beta= 1.d0
                                                                __TIMER_DGEMM_START(231)
!!          call DGEMM__('N','T', icsize,np_e,icnt_without, &
!!      &                 alpha,wk_sc_without,ibsize, fsr_tmp_without,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &                 alpha,pre_sc_without(ista,icbl1),np_g1k(ik), fsr_tmp_without,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha,pre_sc_without(ista,icbl1), &
        &                 np_g1k(ik), fsr_tmp_without,lnblck, beta,vnlph(ista,lnb1,1),np_g1k(ik))
            alpha=-1.d0;  beta= 1.d0
!!          call DGEMM__('N','T', icsize,np_e,icnt_without, &
!!      &                 alpha,wk_ss_without,ibsize, fsi_tmp_without,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &                 alpha,pre_ss_without(ista,icbl1),np_g1k(ik), fsi_tmp_without,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha,pre_ss_without(ista,icbl1), &
        &                 np_g1k(ik), fsi_tmp_without,lnblck, beta,vnlph(ista,lnb1,1),np_g1k(ik))
            alpha= 1.d0;  beta= 1.d0
!!          call DGEMM__('N','T', icsize,np_e,icnt_without, &
!!      &                 alpha,wk_sc_without,ibsize, fsi_tmp_without,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &                 alpha,pre_sc_without(ista,icbl1),np_g1k(ik), fsi_tmp_without,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha,pre_sc_without(ista,icbl1), &
        &                 np_g1k(ik), fsi_tmp_without,lnblck, beta,vnlph(ista,lnb1,2),np_g1k(ik))
            alpha= 1.d0;  beta= 1.d0
!!          call DGEMM__('N','T', icsize,np_e,icnt_without, &
!!      &                 alpha,wk_ss_without,ibsize, fsr_tmp_without,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &                 alpha,pre_ss_without(ista,icbl1),np_g1k(ik), fsr_tmp_without,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha,pre_ss_without(ista,icbl1), &
        &                 np_g1k(ik), fsr_tmp_without,lnblck, beta,vnlph(ista,lnb1,2),np_g1k(ik))
                                                                __TIMER_DGEMM_STOP(231)
         end if
      end if
      call tstatc0_end(id_sname)
                                                                __TIMER_SUB_STOP(208)
    end subroutine add_vnlph_l_without_eko_blk_3D

  end subroutine m_ES_Vnonlocal_W_3D

!!! else NONLOCAL_DGEMM
#else

  subroutine m_ES_Vnonlocal_W_3D(ik,iksnl,ispin,switch_of_eko_part)
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
!

    integer, intent(in) :: ik,iksnl,ispin
    integer, intent(in) :: switch_of_eko_part

    print *,"ERROR : Not Support Multi Dimension Para on DGEM"
    MPI_ABORT(mpi_comm_world, 140, ik)

  end subroutine m_ES_Vnonlocal_W_3D
#endif
!! #ifdef NONLOCAL_DGEMM end



  subroutine m_ES_wd_fsr_fsi()
    integer :: ik
    if(ipri >= 2) then
       write(nfout,'(" --- fsr_l, fsi_l ---")')
       do ik = ista_k, iend_k                              ! MPI
          call wd_fsr_fsi_3D(ik)    ! MPI
       end do
    end if
  end subroutine m_ES_wd_fsr_fsi


  subroutine G_dot_R(ia,mapmode,ik)
    integer, intent(in) :: ia,mapmode
    integer, intent(in), optional :: ik
    integer :: i, i1, ip
    real(kind=DP) :: grt, f1, f2, f3
    integer :: id_sname = -1

    call tstatc0_begin('G_dot_R ',id_sname)
    f1 = pos(ia,1)*PAI2; f2 = pos(ia,2)*PAI2; f3 = pos(ia,3)*PAI2
    if(.not.allocated(nbase)) stop ' nbase is not allocated'
    if(mapmode == MAPPED) then
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
       do i = 1, np_g1k(ik)
          i1 = nbase(i+ista_g1k(ik)-1,ik)
          grt = ngabc(i1,1)*f1+ngabc(i1,2)*f2+ngabc(i1,3)*f3
          zfcos(i) = dcos(grt)
          zfsin(i) = dsin(grt)
       end do
    else
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
       do i = 1, np_nbmx
          ip = i + ista_nbmx -1
          grt = ngabc(ip,1)*f1+ngabc(ip,2)*f2+ngabc(ip,3)*f3
          zfcos(i) = dcos(grt)
          zfsin(i) = dsin(grt)
       end do
    end if
    call tstatc0_end(id_sname)
  end subroutine G_dot_R

  subroutine G_dot_R_map_div(ia,ik,ibl1,ibl2)
    integer, intent(in) :: ia,ik,ibl1,ibl2
    integer :: i, i1
    real(kind=DP) :: grt, f1, f2, f3
    integer :: id_sname = -1
    call tstatc0_begin('G_dot_R_map_div ',id_sname)

    f1 = pos(ia,1)*PAI2; f2 = pos(ia,2)*PAI2; f3 = pos(ia,3)*PAI2
    if(.not.allocated(nbase)) stop ' nbase is not allocated'
!!$    do i = 1, iba(ik)
    do i = 1, ibl2-ibl1+1
       i1 = nbase(i+ibl1-1,ik)
       grt = ngabc(i1,1)*f1+ngabc(i1,2)*f2+ngabc(i1,3)*f3
       zfcos(i) = dcos(grt)
       zfsin(i) = dsin(grt)
    end do
    call tstatc0_end(id_sname)
  end subroutine G_dot_R_map_div

#ifdef NONLOCAL_DGEMM
  subroutine G_dot_R_map_blk_3D(ik,ibl1,ibl2,ia1,ia2)
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
!

    integer, intent(in) :: ik,ibl1,ibl2, ia1,ia2
    integer :: ia, i, i1
    real(kind=DP) :: grt, f1, f2, f3
    integer :: id_sname = -1
                                                                __TIMER_SUB_START(410)

    if(.not.allocated(nbase)) stop ' nbase is not allocated'
    call tstatc0_begin('G_dot_R_map_blk ',id_sname)

!cdir outerunroll=16
    do i = ibl1, ibl2
!f       i1 = nbase(i,ik)
       i1 = nbase(i+ista_g1k(ik)-1,ik)
!!$       do ia=1,natm
       do ia=ia1,ia2
          f1 = pos(ia,1)*PAI2; f2 = pos(ia,2)*PAI2; f3 = pos(ia,3)*PAI2
          grt = ngabc(i1,1)*f1+ngabc(i1,2)*f2+ngabc(i1,3)*f3
          wk_zfcos(i-ibl1+1,ia-ia1+1) = dcos(grt)
          wk_zfsin(i-ibl1+1,ia-ia1+1) = dsin(grt)
       end do
    end do
    call tstatc0_end(id_sname)
                                                                __TIMER_SUB_STOP(410)
  end subroutine G_dot_R_map_blk_3D
#endif
!! #ifdef NONLOCAL_DGEMM end



!kukan 4
  subroutine m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik,dealloc_fs2d)
    integer, intent(in) :: nfout,ik
    logical, intent(in), optional :: dealloc_fs2d
    integer :: mod_ball = ON
    call m_ES_betar_dot_Psi_4_each_k_3D(nfout,zaj_l,ista_k,iend_k,ik,fsr_l,fsi_l,mod_ball,dealloc_fs2d)
  end subroutine m_ES_betar_dot_WFs_4_each_k_3D

#ifdef NONLOCAL_DGEMM
  subroutine m_ES_betar_dot_Psi_4_each_k_3D(nfout,psi_l,k1,k2,ik,bpr_l,bpi_l,mod_ball,dealloc_fs2d)
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
! Revised by T. Yamasaki, October 2009 : Mblock
!
    use m_Parallelization,only      : ball_buff, ball_addr
! === DEBUG by tkato 2014/08/08 ==========================================================
    use m_Electronic_Structure, only : m_ES_gather_f_3d_to_2d
! ========================================================================================

    integer, intent(in)    :: nfout, k1,k2,ik
    real(kind=DP),intent(in),dimension(maxval(np_g1k),np_e,k1:k2,kimg):: psi_l ! MPI
    real(kind=DP),intent(out),dimension(np_e,np_fs,k1:k2) :: bpr_l, bpi_l !MPI
    integer, intent(in), optional :: mod_ball
    logical, intent(in), optional :: dealloc_fs2d
    logical :: deallocfs2d

    integer :: iksnl, ibsize, iend
    integer :: datasize

    integer :: ia, it, lmt1, msize, msize_target, msizemax, msizesum, natm_redmax
    integer :: ibl1,ibl2, ia1, ia2
    integer :: LD11,  LD12
    logical :: tran1
!!$    integer, allocatable, dimension(:) :: mil
    real(kind=DP), allocatable, dimension(:,:,:) :: psi_ri
!f
!   real(kind=DP),allocatable, dimension(:,:) :: fsr_l_2D,fsi_l_2D
    real(kind=DP),allocatable, dimension(:,:) :: wk_fsr_l,wk_fsi_l
    real(kind=DP),allocatable, dimension(:,:) :: wk_fsr_ball,wk_fsi_ball
    real(kind=DP),allocatable, dimension(:,:) :: wk_fsr_2D,wk_fsi_2D
    real(kind=DP),allocatable, dimension(:,:) :: fsrt,fsit
    integer :: i, j, k, n

    integer :: id_sname = -1
! === rspace on 3D_Parallel ==============================================================
    logical :: flag_in_realspace


    flag_in_realspace = .false.
    if(sw_rspace == ON) then
       if(m_CtrlP_realspace_integ_OK()) flag_in_realspace = .true.
    end if

    if(flag_in_realspace) then
       allocate(fsrt(np_e,nlmta));fsrt=0.d0
!       if(k_symmetry(ik) /= GAMMA)then
          allocate(fsit(np_e,nlmta));fsit=0.d0
!       endif
       call betar_dot_Psi_4_each_k_in_rs(nfout,k1,k2,ik,psi_l,fsrt,fsit)
       do i=ista_fs,iend_fs
          bpr_l(1:np_e,i-ista_fs+1,ik) = fsrt(1:np_e,i)
          if(k_symmetry(ik) /= Gamma) then
             bpi_l(1:np_e,i-ista_fs+1,ik) = fsit(1:np_e,i)
          endif
       enddo
       deallocate(fsrt)
       !if(k_symmetry(ik) /= GAMMA) deallocate(fsit)
       deallocate(fsit)
       if(present(mod_ball) .and. mod_ball == ON) then
          allocate(wk_fsr_l(np_fs,np_e))
          allocate(wk_fsr_ball(np_fs,neg))
          if(k_symmetry(ik) /= GAMMA) then
             allocate(wk_fsi_l(np_fs,np_e))
             allocate(wk_fsi_ball(np_fs,neg))
          endif
          do i=1,np_e
            do j=1,np_fs
              wk_fsr_l(j,i)=bpr_l(i,j,ik)
              if(k_symmetry(ik) /= GAMMA) wk_fsi_l(j,i)=bpi_l(i,j,ik)
            enddo
          enddo
          call mpi_allgatherv(wk_fsr_l,np_fs*np_e,mpi_double_precision,wk_fsr_ball(1,1),ball_buff,&
          & ball_addr,mpi_double_precision,mpi_kg_world,ierr)
          if(k_symmetry(ik) /= GAMMA)call mpi_allgatherv(wk_fsi_l,np_fs*np_e,mpi_double_precision,&
                                 &wk_fsi_ball,ball_buff,ball_addr,mpi_double_precision,mpi_kg_world,ierr)
!OCL NOFLTLD
          do i=1,neg
            do j=1,np_fs
              fsr_ball(i,j,ik)=wk_fsr_ball(j,i)
              if(k_symmetry(ik) /= GAMMA) fsi_ball(i,j,ik)=wk_fsi_ball(j,i)
            enddo
          enddo
          deallocate(wk_fsr_l,wk_fsr_ball)
          !if(k_symmetry(ik) /= GAMMA) deallocate(wk_fsi_l,wk_fsi_ball)
          if(k_symmetry(ik) /= GAMMA) deallocate(wk_fsi_l,wk_fsi_ball)
       end if

       call m_ES_alloc_fsr_l_2d(np_e,nlmta)
       call m_ES_gather_f_3d_to_2d(fsr_l, fsr_l_2D, ik)

       if(k_symmetry(ik) /= GAMMA) then
         call m_ES_alloc_fsi_l_2d(np_e, nlmta)
         call m_ES_gather_f_3d_to_2d(fsi_l, fsi_l_2D, ik)
       endif
    else
! ========================================================================================
                                                                __TIMER_SUB_START(401)
    call tstatc0_begin('betar_dot_WFs ',id_sname,level=1)
    iksnl = (ik-1)/nspin + 1

!f    fsr_l(:,:,ik) = 0.d0
!f    if(k_symmetry(ik) /= GAMMA) fsi_l(:,:,ik) = 0.d0

!---
    if( nblocksize_betar_npe_is_given) then
       npesize = nblocksize_betar_dot_wfs_npe
       if( npesize > np_e) npesize = np_e
    else
       npesize = np_e
    end if

!FF    call m_ES_alloc_fsr_l_2d()
    if(allocated(fsr_l_2D)) deallocate(fsr_l_2D)
    call m_ES_alloc_fsr_l_2d(npesize,nlmta)
    allocate(wk_fsr_2D(npesize,np_fs))
    fsr_l_2D = 0.0d0
!----------

    allocate(wk_fsr_l(np_fs,np_e))
! === for np_fs == 0 ===========================================================
!   allocate(wk_fsr_ball(np_fs,neg))
    allocate(wk_fsr_ball(max(np_fs,1),neg))
! ==============================================================================
    if(k_symmetry(ik) /= GAMMA) then
!FF        call m_ES_alloc_fsi_l_2d()
    if(allocated(fsi_l_2D)) deallocate(fsi_l_2D)
    call m_ES_alloc_fsi_l_2d(npesize,nlmta)
    fsi_l_2D = 0.0d0
        allocate(wk_fsi_l(np_fs,np_e))
        allocate(wk_fsi_ball(np_fs,neg))
        allocate(wk_fsi_2D(npesize,np_fs))
    endif

    call set_msize() ! -> ibsize, msize_target, msizemax, natm_redmax

   do n = 1,np_e,npesize
    call alloc_wkzfsincos_red(ibsize,natm_redmax)
    call alloc_wkarai(ibsize,msizemax)
!!$    call alloc_wkother(msizemax)
!!$    allocate(mil(msizemax))
!FF    allocate(psi_ri(ibsize,np_e,kimg))
    allocate(psi_ri(ibsize,npesize,kimg))

!----
!   do ibl1 = 1, np_g1k(ik), ibsize
!          ibl2 = min( ibl1+ibsize-1, np_g1k(ik) )
!          call cpzaj_l_to_psi_ri(ibl1,ibl2)
!-----
    ia1 = 1
    msizesum = 0
    Mblock: do
       msize = ilmt(ityp(ia1))
       do ia = ia1+1, natm
          it = ityp(ia)
          msize = msize + ilmt(it)
          if(msize > msize_target) exit
       end do
       ia2 = ia-1

       call pre_lmta_k_blk(msize,LD11,LD12) !  -> msize, LD11, LD12
       call alloc_wkbp(ik,LD11,LD12)
       bp_tmp1=0.d0
       if(k_symmetry(ik) /= GAMMA) bp_tmp2=0.d0

       do ibl1 = 1, np_g1k(ik), ibsize
          ibl2 = min( ibl1+ibsize-1, np_g1k(ik) )
          call cppsi_l_to_psi_ri(ibl1,ibl2,n)
          call G_dot_R_map_blk_3D(ik,ibl1,ibl2, ia1,ia2) ! pos(ia,1:3), ngabc -> wk_zfcos,wk_zfsin
          call m_ES_betar_dot_WFs_4_lmta_k_blk_3D(ik,ibsize,ibl1,ibl2,psi_ri &
               & ,iksnl,snl, msize,LD11,tran1,ia1,ia2) !  --> bp_tmp1, bp_tmp2
       end do

! === DEBUG by tkato 2011/07/12 ================================================
!      call post_lmta_k_blk(ista_k,iend_k, fsr_l_2D,fsi_l_2D)
       if(k_symmetry(ik) /= GAMMA) then
          call post_lmta_k_blk(ista_k,iend_k,n,fsr_l_2D,fsi_l_2D)
       else
          call post_lmta_k_blk(ista_k,iend_k,n,fsr_l_2D)
       endif
! ==============================================================================
       msizesum = msizesum+msize

       call dealloc_wkbp(ik)
       ia1 = ia2+1
       if(ia1 > natm) exit Mblock
    end do Mblock
!----
!   end do
!----

    if(ipribetar >= 2) call wd_fsr_fsi_3D(ik)

    deallocate(psi_ri)
!!$    call dealloc_wkother()
    call dealloc_wkarai()
    call dealloc_wkzfsincos()


!f reduce_scatter f
!modify2010
   if(nrank_g > 1) then
                                                 __TIMER_COMM_START_w_BARRIER(mpi_ke_world,419)
!    call mpi_reduce_scatter(fsr_l_2D,fsr_l(n,1,ik),nel_fs*npesize,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
!    if(k_symmetry(ik) /= GAMMA) call mpi_reduce_scatter(fsi_l_2D,fsi_l(n,1,ik),nel_fs*npesize,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
    call mpi_reduce_scatter(fsr_l_2D,wk_fsr_2D,nel_fs*npesize,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
    if(k_symmetry(ik) /= GAMMA) call mpi_reduce_scatter(fsi_l_2D,wk_fsi_2D,nel_fs*npesize,&
                                    & mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
                                                 __TIMER_COMM_STOP(419)
     iend = n+npesize-1
     if(iend >= np_e) iend=np_e
!OCL NOFLTLD
     do i = n,iend
     do j = 1,np_fs
        bpr_l(i,j,ik) = wk_fsr_2D(i-n+1,j)
        if(k_symmetry(ik) /= GAMMA)bpi_l(i,j,ik) = wk_fsi_2D(i-n+1,j)
     enddo;enddo
   else
     iend = n+npesize-1
     if(iend >= np_e) iend=np_e
     do i = n,iend
     do j = 1,np_fs
        bpr_l(i,j,ik) = fsr_l_2D(i-n+1,j)
        if(k_symmetry(ik) /= GAMMA)bpi_l(i,j,ik) = fsi_l_2D(i-n+1,j)
     enddo;enddo
!     fsr_l(:,:,ik)=fsr_l_2D(:,:)
!     if(k_symmetry(ik) /= GAMMA) fsi_l(:,:,ik)=fsi_l_2D(:,:)
   endif

  enddo ! npesize

  call tstatc0_end(id_sname)

! for eigen value sort 
  if(present(mod_ball) .and. mod_ball == ON) then
                                                 __TIMER_COMM_START(420)
  do i=1,np_e
    do j=1,np_fs
      wk_fsr_l(j,i)=bpr_l(i,j,ik)
      if(k_symmetry(ik) /= GAMMA) wk_fsi_l(j,i)=bpi_l(i,j,ik)
    enddo
  enddo
                                                 __TIMER_COMM_STOP(420)
                                                 __TIMER_COMM_START_w_BARRIER(mpi_kg_world,421)
  call mpi_allgatherv(&
       & wk_fsr_l,np_fs*np_e,mpi_double_precision,wk_fsr_ball(1,1),ball_buff,ball_addr,mpi_double_precision,mpi_kg_world,ierr)
  if(k_symmetry(ik) /= GAMMA)call mpi_allgatherv(wk_fsi_l,np_fs*np_e,mpi_double_precision,&
! === DEBUG for -check all =====================================================
!                                 &wk_fsi_ball(1,1),ball_buff,ball_addr,mpi_double_precision,mpi_kg_world,ierr)
                                  &wk_fsi_ball,ball_buff,ball_addr,mpi_double_precision,mpi_kg_world,ierr)
! ==============================================================================
                                                 __TIMER_COMM_STOP(421)
                                                 __TIMER_COMM_START(422)
!OCL NOFLTLD
  do i=1,neg
    do j=1,np_fs
      fsr_ball(i,j,ik)=wk_fsr_ball(j,i)
      if(k_symmetry(ik) /= GAMMA) fsi_ball(i,j,ik)=wk_fsi_ball(j,i)
    enddo
  enddo
                                                 __TIMER_COMM_STOP(422)

   end if

   deallocate(wk_fsr_l,wk_fsr_ball)
   if(k_symmetry(ik) /= GAMMA) deallocate(wk_fsi_l,wk_fsi_ball)
   deallocfs2d = .true.
   if(present(dealloc_fs2d)) deallocfs2d = dealloc_fs2d

   if(deallocfs2d)then
    deallocate(fsr_l_2D)
    if(k_symmetry(ik) /= GAMMA) deallocate(fsi_l_2D)
   end if
                                                                __TIMER_SUB_STOP(401)
! === rspace on 3D_Parallel ==============================================================
    end if
! ========================================================================================

   contains
     subroutine cppsi_l_to_psi_ri(ibl1,ibl2,np)
       integer, intent(in) :: ibl1,ibl2,np
       integer :: ip, i, ri, iend
                                                                __TIMER_SUB_START(402)
                                                                __TIMER_DO_START(423)
       iend = np+npesize-1
       if(iend >= np_e ) iend = np_e
       do ri = 1, kimg
          do i = np, iend
             do ip = ibl1, ibl2
                psi_ri(ip-ibl1+1,i-np+1,ri) = psi_l(ip,i,ik,ri)
             end do
          end do
       end do
                                                                __TIMER_DO_STOP(423)
                                                                __TIMER_SUB_STOP(402)
     end subroutine cppsi_l_to_psi_ri

     subroutine set_msize()
       integer :: ncache, N, K, M, ia_i, ia_f, msize
       integer, save :: msize_print = OFF
                                                                __TIMER_SUB_START(403)

       if( nblocksize_betar_is_given) then
          ibsize = nblocksize_betar_dot_wfs
       else
          ibsize = nb_betar_default
          if(ipri >= 1 .and. msize_print == OFF) then
             write(nfout,'(" !ibsize(=nblocksize_betar_w) (m_ES_betar_dot_Psi_4_each_k_3D) = ",i8)') ibsize
          end if
       end if
!f
       if( ibsize == 0 ) ibsize = np_g1k(ik)
!f
!!$    ibsize=10000
    if( nblocksize_betar_nlmta_is_given) then
       M = nblocksize_betar_dot_wfs_nlmta
       if(M > nlmta) M = nlmta
    else
       ncache = (m_CtrlP_cachesize()*1024)*3/4
!F       if(ncache == 0) then
!F          M = nlmta
!F       else
          K = ibsize
          N = np_e
          if(kimg == 1) then
             if(k_symmetry(ik) == GAMMA) then
                M = (ncache - K*N*8)/((K+N)*8)
             else 
                M = (ncache - K*N*8)/((K+N)*16)
             endif
          else
             if(k_symmetry(ik) == GAMMA) then
                M = (ncache - K*N*16)/((2*K+N)*8)
             else
                M = (ncache - K*N*16)/((K+N)*16)
             end if
          endif
          if(M > nlmta) M = nlmta
!F       endif
!!$$!!$$!!
!F       M = nlmta
!!$$!!$$!!
    endif
       msize_target = M
       if(msize_target < ilmt(1)) msize_target = ilmt(1)
       if(ipri>=1) then
          if(msize_print == OFF) then
             write(nfout,'(" mype = ",i3, " np_e, msize_target, nlmta, ibsize, np_g1k(ik)/ibsize = ",5i8 &
                  & ," <<m_ES_betar_dot_Psi_4_each_k_3D>>")') &
                  & mype, np_e, msize_target, nlmta, ibsize, np_g1k(ik)/ibsize
          end if
       end if

!F       if(ncache == 0) then
!F          msizemax = nlmta
!F          natm_redmax = natm
!F       else
          natm_redmax = 0
          msizemax = 0
          ia_i = 1
!!$          if(msize_target < ilmt(1)) then
!!$             msize = nlmta
!!$             msizemax = msize
!!$          else
             Mblock: do
                msize = ilmt(ityp(ia_i))
                do ia = ia_i+1, natm
                   it = ityp(ia)
                   msize = msize + ilmt(it)
                   if(msize > msize_target) exit
                end do
                if(ia <= natm) then
                   msize = msize - ilmt(it)
                end if
                ia_f = ia - 1
                if(ia_f - ia_i + 1 > natm_redmax) natm_redmax = ia_f -ia_i + 1
                if(msize > msizemax) msizemax = msize
                if(ipri >= 1) then
                   if(msize_print == OFF) &
                        & write(nfout,'(" ia_i, ia_f, msize = ",3i8)') ia_i, ia_f, msize
                end if
                ia_i = ia_f+1
                if(ia_i > natm) exit Mblock
             end do Mblock
!!$          end if
          if(ipri>=1) then
             if(msize_print == OFF) &
                  & write(nfout,'(" mype = ",i3, " msizemax, natm_redmax = ",2i8)') mype, msizemax, natm_redmax
          end if
!F       end if
       msize_print = ON
!!$$!!$$!!
!F       msizemax = nlmta
!F       natm_redmax = natm
!!$$!!$$!!
                                                                __TIMER_SUB_STOP(403)
     end subroutine set_msize

     subroutine pre_lmta_k_blk(msize,LD11,LD12)
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
!
       integer,intent(out) :: msize,LD11, LD12
       integer :: icnt, ia, it, lmt1
                                                                __TIMER_SUB_START(404)

       icnt = 0
!!$       do ia = 1, natm
       do ia = ia1, ia2
          it = ityp(ia)
          do lmt1 = 1, ilmt(it)
             icnt = icnt+1
!!$             mil(icnt) = mod( ltp(lmt1,it),4)
!!$             lmtt_tmp(icnt) = lmtt(lmt1,it)
!!$             ia_tmp(icnt) = ia-ia1+1
          end do
       end do
       msize = icnt
       if(npesize .gt. msize) then
          LD11 = npesize ; LD12 = msize
          tran1 = .true.
       else
          LD11 = msize ; LD12 = npesize
          tran1 = .false.
       end if
#ifdef SX
       if( mod(LD11,2) .eq. 0) LD11 = LD11+1
#endif
                                                                __TIMER_SUB_STOP(404)
     end subroutine pre_lmta_k_blk

    subroutine post_lmta_k_blk( k1,k2,np,bpr_l,bpi_l)
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
! Revised by T. Yamasaki, Octover 2009 : multipication of i^L is removed
      integer,intent(in)  :: k1,k2,np
!f      real(kind=DP),intent(out),dimension(np_e,nlmta,k1:k2)  ::  bpr_l,bpi_l  ! MPI
! === DEBUG by tkato 2011/07/12 ================================================
!     real(kind=DP),intent(out),dimension(np_e,nlmta)  ::  bpr_l,bpi_l  ! MPI
      real(kind=DP),intent(out),dimension(npesize,nlmta)          :: bpr_l
      real(kind=DP),intent(out),dimension(npesize,nlmta),optional :: bpi_l
! ==============================================================================
      integer :: j,ib, iend
                                                                __TIMER_SUB_START(405)
                                                                __TIMER_DO_START(424)
       iend = np+npesize-1
       if(iend >= np_e ) iend = np_e

      if(k_symmetry(ik) == GAMMA) then  !! betar_dot_WFs_core2_blk
         if(tran1) then
!cdir nodep
            do j = 1, msize
               do ib = 1, npesize
!f                  bpr_l(ib,j+msizesum,ik) = bp_tmp1(ib,j)
                  bpr_l(ib,j+msizesum) = bp_tmp1(ib,j)
!!                  bpr_l(ib,j+msizesum) = bpr_l(ib,j+msizesum) + bp_tmp1(ib,j)
               enddo
            enddo
         else
!cdir nodep
            do j = 1, msize
               do ib = 1, npesize
!f                  bpr_l(ib,j+msizesum,ik) = bp_tmp1(j,ib)
                  bpr_l(ib,j+msizesum) = bp_tmp1(j,ib)
!!                  bpr_l(ib,j+msizesum) = bpr_l(ib,j+msizesum) + bp_tmp1(j,ib)
               enddo
            enddo
         endif
      else
         if(tran1) then
!cdir nodep
            do j = 1, msize
               do ib = 1, npesize
!f                  bpr_l(ib,j+msizesum,ik) =  bp_tmp1(ib,j)
!f                  bpi_l(ib,j+msizesum,ik) =  bp_tmp2(ib,j)
                  bpr_l(ib,j+msizesum) =  bp_tmp1(ib,j)
                  bpi_l(ib,j+msizesum) =  bp_tmp2(ib,j)
!!                  bpr_l(ib,j+msizesum) =  bpr_l(ib,j+msizesum) + bp_tmp1(ib,j)
!!                  bpi_l(ib,j+msizesum) =  bpi_l(ib,j+msizesum) + bp_tmp2(ib,j)
               end do
            end do
          else
!cdir nodep
            do j = 1, msize
               do ib = 1, npesize
!f                  bpr_l(ib,j+msizesum,ik) =  bp_tmp1(j,ib)
!f                  bpi_l(ib,j+msizesum,ik) =  bp_tmp2(j,ib)
                  bpr_l(ib,j+msizesum) =  bp_tmp1(j,ib)
                  bpi_l(ib,j+msizesum) =  bp_tmp2(j,ib)
!!                  bpr_l(ib,j+msizesum) =  bpr_l(ib,j+msizesum) + bp_tmp1(j,ib)
!!                  bpi_l(ib,j+msizesum) =  bpi_l(ib,j+msizesum) + bp_tmp2(j,ib)
               end do
            end do
          endif
       end if
                                                                __TIMER_DO_STOP(424)
                                                                __TIMER_SUB_STOP(405)
    end subroutine post_lmta_k_blk

  end subroutine m_ES_betar_dot_Psi_4_each_k_3D
#else
  subroutine m_ES_betar_dot_Psi_4_each_k_3D(nfout,ik)
    integer, intent(in)    :: nfout, ik
    integer :: ia, iksnl, mapmode

    print *,"ERROR : Not Support Multi Dimension Para on DGEM"
    MPI_ABORT(mpi_comm_world, 141, ik)

  end subroutine m_ES_betar_dot_Psi_4_each_k_3D
#endif
!! #ifdef NONLOCAL_DGEMM end


  subroutine m_ES_betar_dot_WFs_4_lmta_k_3D(k1,k2,ik,psi_l,ia,iksnl,snl_or_snld,bpr_l,bpi_l,mapmode)
    integer, intent(in)    :: k1,k2, ik, ia, iksnl, mapmode
    real(kind=DP),intent(in), dimension(maxval(np_g1k),np_e,k1:k2,kimg) :: psi_l ! MPI
!!$    real(kind=DP),intent(inout),dimension(np_e,nlmta,k1:k2) :: bpr_l,bpi_l ! MPI
!!$    real(kind=DP),intent(inout),dimension(np_e,np_fs,k1:k2) :: bpr_l,bpi_l ! MPI
    real(kind=DP),intent(inout),dimension(np_e,nlmta,k1:k2) :: bpr_l,bpi_l ! MPI
! === DEBUG by tkato 2011/08/31 ================================================
!   real(kind=DP),intent(in), dimension(kg1,nlmtt,ista_snl:iend_snl) :: snl_or_snld
    real(kind=DP),intent(in), dimension(maxval(np_g1k),nlmtt,ista_snl:iend_snl) :: snl_or_snld
! ==============================================================================

    integer                    ::it, lmt1, lmtt1, lmta1, il1
    integer :: id_sname = -1
#ifndef SX
! NEC tune ------------------------------->
    integer :: ibl1,ibl2,ibsize,ncache
    ncache = (m_CtrlP_cachesize()*1024)*3/4
    if(ncache == 0) then
       ibsize = iend_g1k(ik) - ista_g1k(ik) + 1
    else
    if(k_symmetry(ik) == GAMMA) then ! core2
      if(kimg == 1) then ! ar(i):1,psi_l(i,ib,ik,1):np_e or
                         ! ar(i):1,psi_l(i,ib,ik,2):np_e
        ibsize=ncache/(8*(np_e+1))
      else !  ar(i),ai(i):2,psi_l(i,ib,ik,1),psi_l(i,ib,ik,2):np_e*2  or
           !  ai(i),ar(i):2,psi_l(i,ib,ik,1),psi_l(i,ib,ik,2):np_e*2
        ibsize=ncache/(8*(2+np_e*2))
      endif
    else ! ar(i),ai(i):2,psi_l(i,ib,ik,1),psi_l(i,ib,ik,1):np_e*2
      ibsize=ncache/(8*(2+np_e*2))
    endif
    end if
! nec debug
!  write(6,887) 'ik=',ik,' np_e=',np_e,' iba(ik)=',iba(ik),' ibsize=',ibsize,&
!      ' ncache=',ncache
! 887 format(a,i3,a,i4,a,i6,a,i6,a,i8)
! NEC tune ------------------------------->
#endif

    call tstatc0_begin('m_ES_betar_dot_WFs_4_lmta_k_3D ',id_sname)

    it    = ityp(ia)
#ifndef SX
! NEC tune ------------------------------->
    do ibl1=ista_g1k(ik),iend_g1k(ik),ibsize
    ibl2=ibl1+ibsize-1
    if(ibl2.gt.iend_g1k(ik)) ibl2=iend_g1k(ik)
! nec debug
!  write(6,888) 'ibl1,ibl2=',ibl1,ibl2,' iba(ik)=',iba(ik)
! 888 format(a,2i6,a,i6)
! NEC tune <-------------------------------
#endif
    do lmt1 = 1, ilmt(it)
       lmtt1 = lmtt(lmt1,it)
       lmta1 = lmta(lmt1,ia)
       il1   = ltp(lmt1,it)
!!$       do so = 1, mso+1
!!$          lmtt1 = lmtt0*mso - (mso-so)
!!$          lmta1 = lmta1*mso - (mso-so)
!!$          lmtt1 = nlmtt*(so-1) + lmtt0
!!$          lmta1 = nlmta*(so-1) + lmta0
       call G_dot_R_mult_snl(snl_or_snld)   ! lmtt1, exp(iGR), zfcos,zfsin,snl_or_snld ->ar,ai
       if(k_symmetry(ik) == GAMMA) then
          call betar_dot_WFs_core2(il1,psi_l,bpr_l)  ! lmta1, ar,ai,psi_l -> bpr_l
       else
          call betar_dot_WFs_core(psi_l,bpr_l,bpi_l) ! lmta1, sum(c(k+G)exp(iGR)*snl() ,ar,ai,psi_l -> bpr_l,bpi_l
#ifdef SX
! NEC tune ------------------------------->
          call multiple_i_l()                 !   i**l*( )
#else
          if(ibl2.eq.iend_g1k(ik))then
            call multiple_i_l()                 !   i**l*( )
          endif
! NEC tune <-------------------------------
#endif
       end if
    end do
#ifndef SX
! NEC tune ------------------------------->
    end do
! NEC tune <-------------------------------
#endif
    call tstatc0_end(id_sname)
  contains
    subroutine G_dot_R_mult_snl(snl_or_snld)
! === DEBUG by tkato 2011/08/31 ================================================
!     real(kind=DP),intent(in), dimension(kg1,nlmtt,ista_snl:iend_snl) :: snl_or_snld
      real(kind=DP),intent(in), dimension(maxval(np_g1k),nlmtt,ista_snl:iend_snl) :: snl_or_snld
! ==============================================================================
      integer :: i, i1, iadd
#ifdef BETAR_GAMMA_TUNE
      integer :: mil
#endif
      integer :: id_sname = -1
      call tstatc0_begin('G_dot_R_mult_snl ',id_sname)

      if(kimg == 2 .or. (kimg ==1 .and. k_symmetry(ik) /= GAMMA) ) then
#ifdef BETAR_GAMMA_TUNE
         mil = mod(il1,4)
         if(mapmode == MAPPED) then
            if(kimg==2 .and. k_symmetry(ik) == GAMMA) then
               if(mil == 1 .or. mil == 3) then
                  if(ibl1.ne.1 .and. ibl2.eq.iend_g1k(ik) .and. ista_g1k(ik).eq.1)then
                     ar(1) = zfcos(1)*snl_or_snld(1,lmtt1,iksnl)
                  endif
                  do i = ibl1, ibl2
                     iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/08/31 ================================================
!                    ar(iadd) = zfcos(i)*snl_or_snld(i,lmtt1,iksnl)
!                    ai(iadd) = zfsin(i)*snl_or_snld(i,lmtt1,iksnl)
                     ar(iadd) = zfcos(i)*snl_or_snld(iadd,lmtt1,iksnl)
                     ai(iadd) = zfsin(i)*snl_or_snld(iadd,lmtt1,iksnl)
! ==============================================================================
                  end do
               else if(mil == 2 .or. mil == 0) then
                  if(ibl1.ne.1 .and. ibl2.eq.iend_g1k(ik) .and. ista_g1k(ik).eq.1)then
                     ar(1) = 0.d0
                  endif
                  do i = ibl1, ibl2
                     iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/08/31 ================================================
!                    ai(iadd) = -zfcos(i)*snl_or_snld(i,lmtt1,iksnl)
!                    ar(iadd) =  zfsin(i)*snl_or_snld(i,lmtt1,iksnl)
                     ai(iadd) = -zfcos(i)*snl_or_snld(iadd,lmtt1,iksnl)
                     ar(iadd) =  zfsin(i)*snl_or_snld(iadd,lmtt1,iksnl)
! ==============================================================================
                  end do
               end if
            else
               if(ibl1.ne.1 .and. ibl2.eq.iend_g1k(ik) .and. ista_g1k(ik).eq.1)then
                  ar(1) = zfcos(1)*snl_or_snld(1,lmtt1,iksnl)
               endif
               do i = ibl1, ibl2
                  iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/08/31 ================================================
!                 ar(iadd) = zfcos(i)*snl_or_snld(i,lmtt1,iksnl)
!                 ai(iadd) = zfsin(i)*snl_or_snld(i,lmtt1,iksnl)
                  ar(iadd) = zfcos(i)*snl_or_snld(iadd,lmtt1,iksnl)
                  ai(iadd) = zfsin(i)*snl_or_snld(iadd,lmtt1,iksnl)
! ==============================================================================
               end do
            end if
         else
            if(kimg==2 .and. k_symmetry(ik) == GAMMA) then
               if(mil == 1 .or. mil ==3) then
                  if(ibl1.ne.1 .and. ibl2.eq.iend_g1k(ik) .and. ista_g1k(ik).eq.1)then
                     i1    = nbase(1,ik)
                     ar(1) = zfcos(i1)*snl_or_snld(1,lmtt1,iksnl)
                  endif
                  do i = ibl1, ibl2
                     iadd = i - ista_g1k(ik) + 1
                     i1    = nbase(i,ik)
! === DEBUG by tkato 2011/08/31 ================================================
!                    ar(iadd) = zfcos(i1)*snl_or_snld(i,lmtt1,iksnl)
!                    ai(iadd) = zfsin(i1)*snl_or_snld(i,lmtt1,iksnl)
                     ar(iadd) = zfcos(i1)*snl_or_snld(iadd,lmtt1,iksnl)
                     ai(iadd) = zfsin(i1)*snl_or_snld(iadd,lmtt1,iksnl)
! ==============================================================================
                  end do
               else if(mil == 2 .or. mil == 0) then
                  if(ista_g1k(ik).eq.1)then
                     ar(1) = 0.d0
                  endif
                  do i = ibl1, ibl2
                     iadd = i - ista_g1k(ik) + 1
                     i1    = nbase(i,ik)
! === DEBUG by tkato 2011/08/31 ================================================
!                    ai(iadd) = -zfcos(i1)*snl_or_snld(i,lmtt1,iksnl)
!                    ar(iadd) =  zfsin(i1)*snl_or_snld(i,lmtt1,iksnl)
                     ai(iadd) = -zfcos(i1)*snl_or_snld(iadd,lmtt1,iksnl)
                     ar(iadd) =  zfsin(i1)*snl_or_snld(iadd,lmtt1,iksnl)
! ==============================================================================
                  end do
               else
               end if
            else
               if(ibl1.ne.1 .and. ibl2.eq.iend_g1k(ik) .and. ista_g1k(ik).eq.1)then
                  i1    = nbase(1,ik)
                  ar(1) = zfcos(i1)*snl_or_snld(1,lmtt1,iksnl)
               endif
               do i = ibl1, ibl2
                  iadd = i - ista_g1k(ik) + 1
                  i1    = nbase(i,ik)
! === DEBUG by tkato 2011/08/31 ================================================
!                 ar(iadd) = zfcos(i1)*snl_or_snld(i,lmtt1,iksnl)
!                 ai(iadd) = zfsin(i1)*snl_or_snld(i,lmtt1,iksnl)
                  ar(iadd) = zfcos(i1)*snl_or_snld(iadd,lmtt1,iksnl)
                  ai(iadd) = zfsin(i1)*snl_or_snld(iadd,lmtt1,iksnl)
! ==============================================================================
               end do
            end if
         end if
#else
         if(mapmode == MAPPED) then
#ifdef SX
! NEC tune ------------------------------->
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
            do i = ista_g1k(ik), iend_g1k(ik)
#else
            if(ibl1.ne.1 .and. ibl2.eq.iend_g1k(ik) .and. ista_g1k(ik).eq.1) then
               ar(1) = zfcos(1)*snl_or_snld(1,lmtt1,iksnl)
            endif
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
            do i = ibl1, ibl2
! NEC tune <-------------------------------
#endif
               iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/08/31 ================================================
!              ar(iadd) = zfcos(i)*snl_or_snld(i,lmtt1,iksnl)
!              ai(iadd) = zfsin(i)*snl_or_snld(i,lmtt1,iksnl)
               ar(iadd) = zfcos(i)*snl_or_snld(iadd,lmtt1,iksnl)
               ai(iadd) = zfsin(i)*snl_or_snld(iadd,lmtt1,iksnl)
! ==============================================================================
            end do
         else
#ifdef SX
! NEC tune ------------------------------->
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
            do i = ista_g1k(ik), iend_g1k(ik)
#else
            if(ibl1.ne.1 .and. ibl2.eq.iend_g1k(ik) .and. ista_g1k(ik).eq.1)then
               i1    = nbase(1,ik)
               ar(1) = zfcos(i1)*snl_or_snld(1,lmtt1,iksnl)
            endif
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
            do i = ibl1, ibl2
! NEC tune <-------------------------------
#endif
               iadd = i - ista_g1k(ik) + 1
               i1    = nbase(i,ik)
! === DEBUG by tkato 2011/08/31 ================================================
!              ar(iadd) = zfcos(i1)*snl_or_snld(i,lmtt1,iksnl)
!              ai(iadd) = zfsin(i1)*snl_or_snld(i,lmtt1,iksnl)
               ar(iadd) = zfcos(i1)*snl_or_snld(iadd,lmtt1,iksnl)
               ai(iadd) = zfsin(i1)*snl_or_snld(iadd,lmtt1,iksnl)
! ==============================================================================
            end do
         end if
#endif
         if(ipri>=3 ) then
            write(nfout,'(" --- ar --- <<G_dot_R_mult_snl>>")')
            write(nfout,'(5f20.10)') (ar(i),i=1,iend_g1k(ik)-ista_g1k(ik)+1)
            write(nfout,'(" --- ai --- <<G_dot_R_mult_snl>>")')
            write(nfout,'(5f20.10)') (ai(i),i=1,iend_g1k(ik)-ista_g1k(ik)+1)
         end if
      else  ! if(kimg == 1 .and. k_symmetry == GAMMA) then
         if(mapmode == MAPPED) then
#ifdef SX
! NEC tune ------------------------------->
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
            do i = ista_g1k(ik), iend_g1k(ik)
#else
            if(ibl1.ne.1 .and. ibl2.eq.iend_g1k(ik) .and. ista_g1k(ik).eq.1)then
               ar(1) = zfcos(1)*snl_or_snld(1,lmtt1,iksnl)
            endif
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
            do i = ibl1, ibl2
! NEC tune <-------------------------------
#endif
               iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/08/31 ================================================
!              ar(iadd) = zfcos(i)*snl_or_snld(i,lmtt1,iksnl)
               ar(iadd) = zfcos(i)*snl_or_snld(iadd,lmtt1,iksnl)
! ==============================================================================
            end do
         else
#ifdef SX
! NEC tune ------------------------------->
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
            do i = ista_g1k(ik), iend_g1k(ik)
#else
            if(ibl1.ne.1 .and. ibl2.eq.iend_g1k(ik) .and. ista_g1k(ik).eq.1)then
               i1    = nbase(1,ik)
               ar(1) = zfcos(i1)*snl_or_snld(1,lmtt1,iksnl)
            endif
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
            do i = ibl1, ibl2
! NEC tune <-------------------------------
#endif
               iadd = i - ista_g1k(ik) + 1
               i1    = nbase(i,ik)
! === DEBUG by tkato 2011/08/31 ================================================
!              ar(iadd) = zfcos(i1)*snl_or_snld(i,lmtt1,iksnl)
               ar(iadd) = zfcos(i1)*snl_or_snld(iadd,lmtt1,iksnl)
! ==============================================================================
            end do
         end if
      end if
      call tstatc0_end(id_sname)
    end subroutine G_dot_R_mult_snl

    subroutine betar_dot_WFs_core(psi_l,bpr_l,bpi_l)
      real(kind=DP),intent(in), dimension(maxval(np_g1k),np_e,k1:k2,kimg) :: psi_l ! MPI
!      real(kind=DP),intent(out),dimension(np_e,np_fs,k1:k2) :: bpr_l, bpi_l ! MPI
      real(kind=DP),intent(out),dimension(np_e,nlmta,k1:k2) :: bpr_l, bpi_l ! MPI
      real(kind=DP) :: bpr, bpi
      integer       :: ib, i, iadd

      integer :: id_sname = -1
      call tstatc0_begin('betar_dot_WFs_core ',id_sname)

#ifndef SX
! NEC tune --------------------------->
!      bpr_l(1:np_e,lmta1,ik) = 0.d0        ! MPI
!      bpi_l(1:np_e,lmta1,ik) = 0.d0        ! MPI
      if(ibl1.eq.ista_g1k(ik))then
         bpr_l(1:np_e,lmta1,ik) = 0.d0        ! MPI
         bpi_l(1:np_e,lmta1,ik) = 0.d0        ! MPI
      endif
! NEC tune <---------------------------
#endif

! nec debug
!      write(6,999) 'np_e=',np_e,' ik=',ik,' iba(ik)=',iba(ik),' k1,k2=',k1,&
!         ',',k2,' kimg=',kimg,' ibl1,ibl2=',ibl1,',',ibl2,' lmta1=',lmta1
! 999 format(a,i3,a,i1,a,i5,a,i1,a,i1,a,i1,a,i5,a,i5,a,i5)

      if(kimg == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
         do ib = 1, np_e ! MPI
#ifdef SX
! NEC tune ------------------------------------------>
            bpr = 0.d0; bpi = 0.d0
            do i = ista_g1k(ik), iend_g1k(ik)
#else
            bpr = bpr_l(ib,lmta1,ik)
            bpi = bpi_l(ib,lmta1,ik)
            do i = ibl1, ibl2
! NEC tune <------------------------------------------
#endif
               iadd = i - ista_g1k(ik) + 1
               bpr = bpr + ar(iadd)*psi_l(iadd,ib,ik,1)
               bpi = bpi + ai(iadd)*psi_l(iadd,ib,ik,1)
!!$               bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + ar(i)*psi_l(i,ib,ik,1)
!!$               bpi_l(ib,lmta1,ik) = bpi_l(ib,lmta1,ik) + ai(i)*psi_l(i,ib,ik,1)
            end do
            bpr_l(ib,lmta1,ik) = bpr
            bpi_l(ib,lmta1,ik) = bpi
         end do
#ifndef SX
         if(ibl2 .eq. iend_g1k(ik)) then
#endif
            call mpi_allreduce(MPI_IN_PLACE,bpr_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
            call mpi_allreduce(MPI_IN_PLACE,bpi_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
#ifndef SX
         endif
#endif
      else if(kimg == 2) then
!!$#ifdef _VECTOR_TUNING_
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
         do ib = 1, np_e ! MPI
#ifdef SX
! NEC tune ------------------------------------------>
            bpr = 0.d0; bpi = 0.d0
            do i = ista_g1k(ik), iend_g1k(ik)
#else
            bpr = bpr_l(ib,lmta1,ik)
            bpi = bpi_l(ib,lmta1,ik)
            do i = ibl1, ibl2
! NEC tune <------------------------------------------
#endif
               iadd = i - ista_g1k(ik) + 1
               bpr = bpr + ar(iadd)*psi_l(iadd,ib,ik,1)-ai(iadd)*psi_l(iadd,ib,ik,2)
               bpi = bpi + ai(iadd)*psi_l(iadd,ib,ik,1)+ar(iadd)*psi_l(iadd,ib,ik,2)
!!$               bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + ar(i)*psi_l(i,ib,ik,1)-ai(i)*psi_l(i,ib,ik,2)
!!$               bpi_l(ib,lmta1,ik) = bpi_l(ib,lmta1,ik) + ai(i)*psi_l(i,ib,ik,1)+ar(i)*psi_l(i,ib,ik,2)
            end do
            bpr_l(ib,lmta1,ik) = bpr
            bpi_l(ib,lmta1,ik) = bpi
         end do
#ifndef SX
         if(ibl2 .eq. iend_g1k(ik)) then
#endif
            call mpi_allreduce(MPI_IN_PLACE,bpr_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
            call mpi_allreduce(MPI_IN_PLACE,bpi_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
#ifndef SX
         endif
#endif
!$#else
!!$         do ib = 1, np_e                   ! MPI
!!$            bpr = 0.d0; bpi = 0.d0
!!$            do i = 1, iba(ik)
!!$               bpr = bpr + ar(i)*psi_l(i,ib,ik,1)
!!$               bpi = bpi + ai(i)*psi_l(i,ib,ik,1)
!!$            end do
!!$            do i = 1, iba(ik)
!!$               bpr = bpr - ai(i)*psi_l(i,ib,ik,2)
!!$               bpi = bpi + ar(i)*psi_l(i,ib,ik,2)
!!$            end do
!!$            bpr_l(ib,lmta1,ik) = bpr
!!$            bpi_l(ib,lmta1,ik) = bpi
!!$         end do
!!$#endif
      end if
      call tstatc0_end(id_sname)
    end subroutine betar_dot_WFs_core

    subroutine multiple_i_l
      integer mil, ib
      real(kind=DP) :: tempo

      mil = mod(il1,4)
      if(mil == 2) then
         do ib = 1, np_e ! MPI
            tempo = bpi_l(ib,lmta1,ik)
            bpi_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik)
            bpr_l(ib,lmta1,ik) = -tempo
         end do
      else if(mil == 3) then
         do ib = 1, np_e ! MPI
            bpr_l(ib,lmta1,ik) = -bpr_l(ib,lmta1,ik)
            bpi_l(ib,lmta1,ik) = -bpi_l(ib,lmta1,ik)
         end do
      else if(mil == 0) then
         do ib = 1, np_e ! MPI
            tempo = bpi_l(ib,lmta1,ik)
            bpi_l(ib,lmta1,ik) = -bpr_l(ib,lmta1,ik)
            bpr_l(ib,lmta1,ik) = tempo
         end do
      end if
    end subroutine multiple_i_l

    subroutine betar_dot_WFs_core2(il1,psi_l,bpr_l)
      integer, intent(in) :: il1
      real(kind=DP),intent(in), dimension(maxval(np_g1k),np_e,k1:k2,kimg) :: psi_l ! MPI
!!$      real(kind=DP),intent(out),dimension(np_e,nlmta,k1:k2) :: bpr_l ! MPI
!      real(kind=DP),intent(out),dimension(np_e,np_fs,k1:k2) :: bpr_l ! MPI
      real(kind=DP),intent(out),dimension(np_e,nlmta,k1:k2) :: bpr_l ! MPI
      integer       :: ib, i, mil, iadd
      real(kind=DP) :: bpr, fp

#ifndef SX
! NEC tune ------------------------------->
      integer :: ibl1_2
#endif
      integer :: id_sname = -1
      call tstatc0_begin('betar_dot_WFs_core2 ',id_sname)

#ifdef SX
      bpr_l(1:np_e,lmta1,ik) = 0.d0 ! MPI
#else
      if(ibl1.eq.1) then
        ibl1_2=2
      else
        ibl1_2=ibl1
      endif
      if(ibl1.eq.ista_g1k(ik))then
        bpr_l(1:np_e,lmta1,ik) = 0.d0 ! MPI
      endif
! NEC tune <-------------------------------
#endif
      mil = mod(il1,4)
      if(mil == 0 .or. mil == 1) then
         fp = 1.d0
      else if(mil == 2 .or. mil == 3) then
         fp = -1.d0
      end if
      if(kimg == 1) then
         if(mil == 1 .or. mil == 3) then ! l = 0, 4, 8, ... or 2, 6, 10, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
#ifdef SX
! NEC tune ------------------------------->
               bpr = 0.d0
               do i = max(2,ista_g1k(ik)), iend_g1k(ik)
#else
               bpr = bpr_l(ib,lmta1,ik)
               do i = ibl1_2, ibl2
! NEC tune <-------------------------------
#endif
                  iadd = i - ista_g1k(ik) + 1
                  bpr = bpr + ar(iadd)*psi_l(iadd,ib,ik,1)
               end do
#ifdef SX
! NEC tune ------------------------------->
               if(ista_g1k(ik) == 1) then
                  bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
               else
                  bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr)
               endif
#else
               if(ibl2.eq.iend_g1k(ik))then
                  if(ista_g1k(ik) == 1) then
                     bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
                  else
                     bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr)
                  endif
               else
                  bpr_l(ib,lmta1,ik) = bpr
               endif
! NEC tune <-------------------------------
#endif
            end do
#ifndef SX
            if(ibl2 .eq. iend_g1k(ik)) then
#endif
               call mpi_allreduce(MPI_IN_PLACE,bpr_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
#ifndef SX
            endif
#endif
         else if(mil == 2 .or. mil == 0) then ! l = 1, 5, 9, ... or 3, 7, 11, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
#ifdef SX
! NEC tune ------------------------------->
               bpr = 0.d0
               do i = max(2,ista_g1k(ik)), iend_g1k(ik)
#else
               bpr = bpr_l(ib,lmta1,ik)
               do i = ibl1_2, ibl2
! NEC tune <-------------------------------
#endif
                  iadd = i - ista_g1k(ik) + 1
                  bpr = bpr + ar(iadd)*psi_l(iadd,ib,ik,2)
               end do
#ifdef SX
! NEC tune ------------------------------->
               bpr_l(ib,lmta1,ik) = fp*2.d0*bpr
#else
               if(ibl2.eq.iend_g1k(ik))then
                  bpr_l(ib,lmta1,ik) = fp*2.d0*bpr
               else
                  bpr_l(ib,lmta1,ik) = bpr
               endif
! NEC tune <-------------------------------
#endif
            end do
#ifndef SX
            if(ibl2 .eq. iend_g1k(ik)) then
#endif
               call mpi_allreduce(MPI_IN_PLACE,bpr_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
#ifndef SX
            endif
#endif
         end if
      else if(kimg == 2) then
#ifdef BETAR_GAMMA_TUNE

            do ib = 1, np_e
               bpr = bpr_l(ib,lmta1,ik)
               do i = ibl1_2, ibl2
                  iadd = i - ista_g1k(ik) + 1
                  bpr = bpr + ar(iadd)*psi_l(iadd,ib,ik,1) - ai(iadd)*psi_l(iadd,ib,ik,2)
               end do
               if(ibl2.eq.iend_g1k(ik))then
                  if(ista_g1k(ik) == 1) then
                     bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
                  else
                     bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr)
                  endif
               else
                  bpr_l(ib,lmta1,ik) = bpr
               endif

            end do
            if(ibl2 .eq. iend_g1k(ik)) then
               call mpi_allreduce(MPI_IN_PLACE,bpr_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
            endif
#else
         if(mil == 1 .or. mil == 3) then ! l = 0, 4, 8, ... or 2, 6, 10, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
#ifdef SX
! NEC tune ------------------------------->
               bpr = 0.d0
               do i = max(2,ista_g1k(ik)), iend_g1k(ik)
#else
               bpr = bpr_l(ib,lmta1,ik)
               do i = ibl1_2, ibl2
! NEC tune <-------------------------------
#endif
                  iadd = i - ista_g1k(ik) + 1
                  bpr = bpr + ar(iadd)*psi_l(iadd,ib,ik,1) - ai(iadd)*psi_l(iadd,ib,ik,2)
               end do
#ifdef SX
! NEC tune ------------------------------->
               if(ista_g1k(ik) == 1) then
                  bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
               else
                  bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr)
               endif
#else
               if(ibl2.eq.iend_g1k(ik))then
                  if(ista_g1k(ik) == 1) then
                     bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
                  else
                     bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr)
                  endif
               else
                  bpr_l(ib,lmta1,ik) = bpr
               endif
! NEC tune <-------------------------------
#endif
            end do
#ifndef SX
            if(ibl2 .eq. iend_g1k(ik)) then
#endif
               call mpi_allreduce(MPI_IN_PLACE,bpr_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
#ifndef SX
            endif
#endif
         else if(mil == 2 .or. mil == 0) then ! l = 1, 5, 9, ... or 3, 7, 11, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
#ifdef SX
! NEC tune ------------------------------->
               bpr = 0.d0
               do i = max(2,ista_g1k(ik)), iend_g1k(ik)
#else
               bpr = bpr_l(ib,lmta1,ik)
               do i = ibl1_2, ibl2
! NEC tune <-------------------------------
#endif
                  iadd = i - ista_g1k(ik) + 1
                  bpr = bpr + ai(iadd)*psi_l(iadd,ib,ik,1) + ar(iadd)*psi_l(iadd,ib,ik,2)
               end do
#ifdef SX
! NEC tune ------------------------------->
               bpr_l(ib,lmta1,ik) = fp*2.d0*bpr
#else
               if(ibl2.eq.iend_g1k(ik))then
                  bpr_l(ib,lmta1,ik) = fp*2.d0*bpr
               else
                  bpr_l(ib,lmta1,ik) = bpr
               endif
! NEC tune <-------------------------------
#endif
            end do
#ifndef SX
            if(ibl2 .eq. iend_g1k(ik)) then
#endif
               call mpi_allreduce(MPI_IN_PLACE,bpr_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
#ifndef SX
            endif
#endif
         end if
#endif
      end if
      call tstatc0_end(id_sname)
    end subroutine betar_dot_WFs_core2
  end subroutine m_ES_betar_dot_WFs_4_lmta_k_3D

  subroutine m_ES_betar_dot_WFs_4_lmta_k_div(k1,k2,ik,ibsize,ibl1,ibl2,psi_l,ia,iksnl,snl_or_snld,bpr_l,bpi_l,mapmode)
    integer, intent(in)    :: k1,k2, ik, ibsize,ibl1,ibl2, ia, iksnl, mapmode
    real(kind=DP),intent(in), dimension(ibsize,np_e,kimg) ::  psi_l        ! MPI
    real(kind=DP),intent(out),dimension(np_e,nlmta,k1:k2) ::  bpr_l,bpi_l  ! MPI
    real(kind=DP),intent(in), dimension(kg1,nlmtt,ista_snl:iend_snl) :: snl_or_snld

    integer                    ::it, lmt1, lmtt1, lmta1, il1
    integer :: id_sname = -1
    call tstatc0_begin('m_ES_betar_dot_WFs_4_lmta_k_div ',id_sname)

    it    = ityp(ia)

    do lmt1 = 1, ilmt(it)
       lmtt1 = lmtt(lmt1,it)
       lmta1 = lmta(lmt1,ia)
       il1   = ltp(lmt1,it)
       call G_dot_R_mult_snl(snl_or_snld)   ! lmtt1, exp(iGR), zfcos,zfsin,snl_or_snld ->ar,ai
       if(k_symmetry(ik) == GAMMA) then
          call betar_dot_WFs_core2(il1,psi_l,bpr_l)  ! lmta1, ar,ai,psi_l -> bpr_l
       else
          call betar_dot_WFs_core(psi_l,bpr_l,bpi_l) ! lmta1, sum(c(k+G)exp(iGR)*snl() ,ar,ai,psi_l -> bpr_l,bpi_l
#ifndef BETAR_GAMMA_TUNE
          if(ibl2.eq.iba(ik))then
            call multiple_i_l()                 !   i**l*( )
          endif
#endif
       end if
    end do
    call tstatc0_end(id_sname)

  contains
    subroutine G_dot_R_mult_snl(snl_or_snld)
      real(kind=DP),intent(in), dimension(kg1,nlmtt,ista_snl:iend_snl) :: snl_or_snld
      integer :: i
#ifdef BETAR_GAMMA_TUNE
      integer :: mil
      real(kind=DP) :: fp
#endif
      integer :: id_sname = -1
      call tstatc0_begin('G_dot_R_mult_snl ',id_sname)

      if(mapmode /= MAPPED) then
         stop ' mapmode /= MAPPED <<G_dot_R_mult_snl in m_ES_betar_dot_WFs_4_lmta_k_div>>'
      end if

      if(kimg == 2 .or. (kimg ==1 .and. k_symmetry(ik) /= GAMMA) ) then
#ifdef BETAR_GAMMA_TUNE
         mil = mod(il1,4)
         if(k_symmetry(ik) == GAMMA) then
            if(mil == 0 .or. mil == 1) then
               fp = 2.d0
            else if(mil == 2 .or. mil == 3) then
               fp = -2.d0
            end if
            if(mil == 0 .or. mil == 2) then
               do i = 1, ibl2-ibl1+1
                  ar(i) = fp*zfsin(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
                  ai(i) = fp*zfcos(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
               end do
               if(ibl1 == 1) then
                  ar(1) = 0.d0; ai(1) = 0.d0
               end if
            else if(mil == 1 .or. mil == 3) then
               do i = 1, ibl2-ibl1+1
                  ar(i) = fp*zfcos(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
                  ai(i) = -fp*zfsin(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
               end do
               if(ibl1 == 1) then
                  ar(1) = ar(1)*0.5d0; ai(1) = 0.d0
               end if
            end if
         else
            if(mil == 0 .or. mil == 1) then
               fp = 1.d0
            else if(mil == 2 .or. mil == 3) then
               fp = -1.d0
            end if
            if(mil == 0 .or. mil == 2) then
               do i = 1, ibl2-ibl1+1
                  ar(i) =  fp*zfsin(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
                  ai(i) = -fp*zfcos(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
               end do
            else if(mil == 1 .or. mil == 3) then
               do i = 1, ibl2-ibl1+1
                  ar(i) = fp*zfcos(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
                  ai(i) = fp*zfsin(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
               end do
            end if
!!$            do i = 1, ibl2-ibl1+1
!!$               ar(i) = zfcos(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
!!$               ai(i) = zfsin(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
!!$            end do
         end if
#else
         do i = 1, ibl2-ibl1+1
            ar(i) = zfcos(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
            ai(i) = zfsin(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
         end do
#endif
      else  ! if(kimg == 1 .and. k_symmetry == GAMMA) then
         do i = 1, ibl2-ibl1+1
            ar(i) = zfcos(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
         end do
      end if
      call tstatc0_end(id_sname)
    end subroutine G_dot_R_mult_snl

    subroutine betar_dot_WFs_core(psi_l,bpr_l,bpi_l)
      real(kind=DP),intent(in), dimension(ibsize,np_e,kimg) :: psi_l        ! MPI
      real(kind=DP),intent(inout),dimension(np_e,nlmta,k1:k2) :: bpr_l,bpi_l  ! MPI
      real(kind=DP) :: bpr, bpi
      integer       :: ib, i
      integer :: id_sname = -1
      call tstatc0_begin('betar_dot_WFs_core ',id_sname)

      if(ibl1.eq.1)then
         bpr_l(1:np_e,lmta1,ik) = 0.d0        ! MPI
         bpi_l(1:np_e,lmta1,ik) = 0.d0        ! MPI
      endif

      if(kimg == 1) then
         do ib = 1, np_e                   ! MPI
            bpr = bpr_l(ib,lmta1,ik)
            bpi = bpi_l(ib,lmta1,ik)
            do i = 1, ibl2-ibl1+1
               bpr = bpr + ar(i)*psi_l(i,ib,1)
               bpi = bpi + ai(i)*psi_l(i,ib,1)
            end do
            bpr_l(ib,lmta1,ik) = bpr
            bpi_l(ib,lmta1,ik) = bpi
         end do
      else if(kimg == 2) then
         do ib = 1, np_e                   ! MPI
            bpr = bpr_l(ib,lmta1,ik)
            bpi = bpi_l(ib,lmta1,ik)
            do i = 1, ibl2-ibl1+1
               bpr = bpr + ar(i)*psi_l(i,ib,1)-ai(i)*psi_l(i,ib,2)
               bpi = bpi + ai(i)*psi_l(i,ib,1)+ar(i)*psi_l(i,ib,2)
            end do
            bpr_l(ib,lmta1,ik) = bpr
            bpi_l(ib,lmta1,ik) = bpi
         end do
      end if
      call tstatc0_end(id_sname)
    end subroutine betar_dot_WFs_core

    subroutine multiple_i_l
      integer mil, ib
      real(kind=DP) :: tempo
      integer :: id_sname = -1
      call tstatc0_begin('multiple_i_l ',id_sname)

      mil = mod(il1,4)
      if(mil == 2) then
         do ib = 1, np_e                 ! MPI
            tempo = bpi_l(ib,lmta1,ik)
            bpi_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik)
            bpr_l(ib,lmta1,ik) = -tempo
         end do
      else if(mil == 3) then
         do ib = 1, np_e                 ! MPI
            bpr_l(ib,lmta1,ik) = -bpr_l(ib,lmta1,ik)
            bpi_l(ib,lmta1,ik) = -bpi_l(ib,lmta1,ik)
         end do
      else if(mil == 0) then
         do ib = 1, np_e                 ! MPI
            tempo = bpi_l(ib,lmta1,ik)
            bpi_l(ib,lmta1,ik) = -bpr_l(ib,lmta1,ik)
            bpr_l(ib,lmta1,ik) = tempo
         end do
      end if
      call tstatc0_end(id_sname)
    end subroutine multiple_i_l

    subroutine betar_dot_WFs_core2(il1,psi_l,bpr_l)
      integer, intent(in) :: il1
      real(kind=DP),intent(in), dimension(ibsize,np_e,kimg) :: psi_l        ! MPI
      real(kind=DP),intent(inout),dimension(np_e,nlmta,k1:k2) :: bpr_l  ! MPI
      integer       :: ib, i, mil
      real(kind=DP) :: bpr, fp

      integer :: ibl1_2
      integer :: id_sname = -1
      call tstatc0_begin('betar_dot_WFs_core2 ',id_sname)

      if(ibl1.eq.1) then
         bpr_l(1:np_e,lmta1,ik) = 0.d0        ! MPI
      endif

#ifdef BETAR_GAMMA_TUNE
      if(kimg == 1) then
         do ib = 1, np_e
            bpr = 0.d0
            do i = 1, ibl2-ibl1+1
               bpr = bpr + ar(i)*psi_l(i,ib,1)
            end do
            bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + bpr
         end do
      else if(kimg == 2) then
         do ib = 1, np_e
            bpr = 0.d0
            do i = 1, ibl2-ibl1+1
               bpr = bpr + ar(i)*psi_l(i,ib,1) + ai(i)*psi_l(i,ib,2)
            end do
            bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + bpr
         end do
      end if
#else
      if(ibl1.eq.1) then
        ibl1_2=2
      else
        ibl1_2=1
      endif

      mil = mod(il1,4)
      if(mil == 0 .or. mil == 1) then
         fp = 1.d0
      else if(mil == 2 .or. mil == 3) then
         fp = -1.d0
      end if

      if(kimg == 1) then
         if(mil == 1 .or. mil == 3) then ! l = 0, 4, 8, ... or 2, 6, 10, ...
            do ib = 1, np_e
               bpr = 0.d0
               do i = ibl1_2, ibl2-ibl1+1
                  bpr = bpr + ar(i)*psi_l(i,ib,1)
               end do
               bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + fp*2.d0*bpr
               if(ibl1 == 1) bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + fp*psi_l(1,ib,1)*ar(1)
            end do
         else if(mil == 2 .or. mil == 0) then ! l = 1, 5, 9, ... or 3, 7, 11, ...
            do ib = 1, np_e
               bpr = 0.d0
               do i = ibl1_2, ibl2-ibl1+1
                  bpr = bpr + ar(i)*psi_l(i,ib,2)
               end do
               bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + fp*2.d0*bpr
            end do
         end if
      else if(kimg == 2) then
         if(mil == 1 .or. mil == 3) then ! l = 0, 4, 8, ... or 2, 6, 10, ...
            do ib = 1, np_e
               bpr = 0.d0
               do i = ibl1_2, ibl2-ibl1+1
                  bpr = bpr + ar(i)*psi_l(i,ib,1) - ai(i)*psi_l(i,ib,2)
               end do
               bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + fp*2.d0*bpr
               if(ibl1 == 1) bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + fp*psi_l(1,ib,1)*ar(1)
            end do
         else if(mil == 2 .or. mil == 0) then ! l = 1, 5, 9, ... or 3, 7, 11, ...
            do ib = 1, np_e
               bpr = bpr_l(ib,lmta1,ik)
               bpr = 0.d0
               do i = ibl1_2, ibl2-ibl1+1
                  bpr = bpr + ai(i)*psi_l(i,ib,1) + ar(i)*psi_l(i,ib,2)
               end do
               bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + fp*2.d0*bpr
            end do
         end if
      end if
#endif
      call tstatc0_end(id_sname)
    end subroutine betar_dot_WFs_core2
  end subroutine m_ES_betar_dot_WFs_4_lmta_k_div

#ifdef NONLOCAL_DGEMM

  subroutine m_ES_betar_dot_WFs_4_lmta_k_blk_3D(ik,ibsize,ibl1,ibl2,psi_l,iksnl,snl_or_snld &
       &                               ,msize,LD11, tran1, ia1, ia2 )
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
!
    integer, intent(in) :: ik, ibsize,ibl1,ibl2, iksnl
    integer, intent(in) :: msize,LD11,ia1,ia2
    logical, intent(in) :: tran1
    real(kind=DP),intent(in), dimension(ibsize,npesize,kimg) ::  psi_l
!f    real(kind=DP),intent(in), dimension(kg1,nlmtt,ista_snl:iend_snl) ::  snl_or_snld
    real(kind=DP),intent(in), dimension(maxval(np_g1k),nlmtt,ista_snl:iend_snl) ::  snl_or_snld
!    real(kind=DP),intent(in), dimension(np_g1k(ik),nlmtt,iksnl:iksnl) ::  snl_or_snld
!    real(kind=DP),intent(in), dimension(kg1,nlmtt,iksnl:iksnl) ::  snl_or_snld
    integer :: id_sname = -1
                                                                __TIMER_SUB_START(406)
!!$    integer :: id_sname2 = -1
    call tstatc0_begin('m_ES_betar_dot_WFs_4_lmta_k_blk ',id_sname)

!!$    if(npes > 1) then
!!$       call tstatc0_begin('mpi_barrier(betar_dot_WFs) ',id_sname2)
!!$       call mpi_barrier(mpi_k_world(myrank_k),ierr)
!!$       call tstatc0_end(id_sname2)
!!$    end if

       call G_dot_R_mult_snl_blk(snl_or_snld)      ! lmtt1, exp(iGR), zfcos,zfsin,snl_or_snld ->ar,ai
       if(k_symmetry(ik) == GAMMA) then
          call betar_dot_WFs_core2_blk(ibsize,tran1,psi_l )  ! lmta1, ar,ai,psi_l -> bp_tmp1
       else
          call betar_dot_WFs_core_blk (ibsize,tran1, psi_l )  ! lmta1, sum(c(k+G)exp(iGR)*snl() ,ar,ai,psi_l -> bp_tmp1, bp_tmp2
       end if

    call tstatc0_end(id_sname)
                                                                __TIMER_SUB_STOP(406)
  contains
    subroutine G_dot_R_mult_snl_blk(snl_or_snld)
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
! Revised by T. Yamasaki, Octover 2009 : mapping algorithm with the subroutine "post_lmta_k_blk"
!
!f      real(kind=DP),intent(in), dimension(kg1,nlmtt,ista_snl:iend_snl) :: snl_or_snld
      real(kind=DP),intent(in), dimension(maxval(np_g1k),nlmtt,ista_snl:iend_snl) :: snl_or_snld
!    real(kind=DP),intent(in), dimension(np_g1k(ik),nlmtt,iksnl:iksnl) ::  snl_or_snld
!    real(kind=DP),intent(in), dimension(kg1,nlmtt,iksnl:iksnl) ::  snl_or_snld
      integer :: j, i
      integer :: mil0, ia, it, lmt1, lt
      real(kind=DP) :: fp, fp0
      integer :: id_sname = -1
                                                                __TIMER_SUB_START(407)
      call tstatc0_begin('G_dot_R_mult_snl_blk ',id_sname)

      if(kimg == 2 .or. (kimg ==1 .and. k_symmetry(ik) /= GAMMA) ) then
         if(k_symmetry(ik) == GAMMA) then
            fp0 = 2.d0
         else
            fp0 = 1.d0
         end if

         j = 0
                                                                __TIMER_DO_START(425)
         do ia = 1, ia2-ia1+1
            it = ityp(ia+ia1-1)
            do lmt1 = 1, ilmt(it)
               j = j + 1
               mil0 = mod(ltp(lmt1,it),4)
               lt = lmtt(lmt1,it)
               if(mil0 == 0 .or. mil0 == 1) then
                  fp = fp0
               else if(mil0 == 2 .or. mil0 == 3) then
                  fp = -fp0
               end if
               if(k_symmetry(ik) == GAMMA) then
                  if(mil0 == 0 .or. mil0 == 2) then
                     do i = 1, ibl2-ibl1+1
                        wk_ar(i,j) = fp*wk_zfsin(i,ia)*snl_or_snld(i+ibl1-1,lt,iksnl)
                        wk_ai(i,j) = fp*wk_zfcos(i,ia)*snl_or_snld(i+ibl1-1,lt,iksnl)
                     end do
                     if(ibl1 == 1 .and. myrank_g == 0) then
                        wk_ar(1, j) = 0.d0; wk_ai(1, j) = 0.d0
                     end if
                  else if(mil0 == 1 .or. mil0 == 3) then
                     do i = 1, ibl2-ibl1+1
                        wk_ar(i,j) = fp*wk_zfcos(i,ia)*snl_or_snld(i+ibl1-1,lt,iksnl)
                        wk_ai(i,j) = -fp*wk_zfsin(i,ia)*snl_or_snld(i+ibl1-1,lt,iksnl)
                     end do
                     if(ibl1 == 1 .and. myrank_g == 0) then
                        wk_ar(1, j) = wk_ar(1,j)*0.5d0; wk_ai(1, j) = 0.d0
                     end if
                  end if
               else
                  if(mil0 == 0 .or. mil0 == 2) then
                     do i = 1, ibl2-ibl1+1
                        wk_ar(i,j) =  fp*wk_zfsin(i,ia)*snl_or_snld(i+ibl1-1,lt,iksnl)
                        wk_ai(i,j) = -fp*wk_zfcos(i,ia)*snl_or_snld(i+ibl1-1,lt,iksnl)
                     end do
                  else if(mil0 == 1 .or. mil0 == 3) then
                     do i = 1, ibl2-ibl1+1
                        wk_ar(i,j) = fp*wk_zfcos(i,ia)*snl_or_snld(i+ibl1-1,lt,iksnl)
                        wk_ai(i,j) = fp*wk_zfsin(i,ia)*snl_or_snld(i+ibl1-1,lt,iksnl)
                     end do
                  end if
               end if
            end do
         end do
                                                                __TIMER_DO_STOP(425)
      else ! if(kimg== 1 .and. k_symmetry(ik) == GAMMA) then
         j = 0
                                                                __TIMER_DO_START(426)
         do ia = 1, ia2-ia1+1
            it = ityp(ia+ia1-1)
            do lmt1 = 1, ilmt(it)
               j = j+1
               lt = lmtt(lmt1,it)
               do i = 1, ibl2-ibl1+1
                  wk_ar(i,j) = wk_zfcos(i,ia)*snl_or_snld(i+ibl1-1,lt,iksnl)
               end do
            end do
         end do
                                                                __TIMER_DO_STOP(426)
      end if
      call tstatc0_end(id_sname)
                                                                __TIMER_SUB_STOP(427)
    end subroutine G_dot_R_mult_snl_blk

    subroutine betar_dot_WFs_core_blk( ibsize, tran1,  psi_l )
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
!
      integer,intent(in)  :: ibsize
      logical, intent(in)  :: tran1
      real(kind=DP),intent(in), dimension(ibsize,npesize,kimg) :: psi_l
      integer       :: icsize, M, LDA, LDB
      integer :: id_sname = -1
                                                                __TIMER_SUB_START(408)
      call tstatc0_begin('betar_dot_WFs_core_blk ',id_sname)

      M = msize
      icsize = ibl2-ibl1+1
      LDA = ibsize;   LDB = ibsize
      if(kimg == 1) then
         if(tran1) then
                                                              __TIMER_DGEMM_START(411)
            call DGEMM__('T','N',npesize,M,icsize, 1.d0,psi_l(1,1,1),LDB,wk_ar,LDA,1.d0,bp_tmp1,LD11)
            call DGEMM__('T','N',npesize,M,icsize, 1.d0,psi_l(1,1,1),LDB,wk_ai,LDA,1.d0,bp_tmp2,LD11)
                                                              __TIMER_DGEMM_STOP(411)
         else
                                                              __TIMER_DGEMM_START(412)
            call DGEMM__('T','N',M,npesize,icsize, 1.d0,wk_ar,LDA,psi_l(1,1,1),LDB,1.d0,bp_tmp1,LD11)
            call DGEMM__('T','N',M,npesize,icsize, 1.d0,wk_ai,LDA,psi_l(1,1,1),LDB,1.d0,bp_tmp2,LD11)
                                                              __TIMER_DGEMM_STOP(412)
         end if
      else if(kimg == 2) then
         if(tran1) then
                                                              __TIMER_DGEMM_START(413)
            call DGEMM__('T','N',npesize,M,icsize, 1.d0,psi_l(1,1,1),LDB,wk_ar,LDA,1.d0,bp_tmp1,LD11)
            call DGEMM__('T','N',npesize,M,icsize,-1.d0,psi_l(1,1,2),LDB,wk_ai,LDA,1.d0,bp_tmp1,LD11)
            call DGEMM__('T','N',npesize,M,icsize, 1.d0,psi_l(1,1,1),LDB,wk_ai,LDA,1.d0,bp_tmp2,LD11)
            call DGEMM__('T','N',npesize,M,icsize, 1.d0,psi_l(1,1,2),LDB,wk_ar,LDA,1.d0,bp_tmp2,LD11)
                                                              __TIMER_DGEMM_STOP(413)
         else
                                                              __TIMER_DGEMM_START(414)
            call DGEMM__('T','N',M,npesize,icsize, 1.d0,wk_ar,LDA,psi_l(1,1,1),LDB,1.d0,bp_tmp1,LD11)
            call DGEMM__('T','N',M,npesize,icsize,-1.d0,wk_ai,LDA,psi_l(1,1,2),LDB,1.d0,bp_tmp1,LD11)
            call DGEMM__('T','N',M,npesize,icsize, 1.d0,wk_ai,LDA,psi_l(1,1,1),LDB,1.d0,bp_tmp2,LD11)
            call DGEMM__('T','N',M,npesize,icsize, 1.d0,wk_ar,LDA,psi_l(1,1,2),LDB,1.d0,bp_tmp2,LD11)
                                                              __TIMER_DGEMM_STOP(414)
         endif
      end if
      call tstatc0_end(id_sname)
                                                                __TIMER_SUB_STOP(408)
    end subroutine betar_dot_WFs_core_blk

    subroutine betar_dot_WFs_core2_blk( ibsize, tran1,  psi_l )
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
!
      integer, intent(in)  :: ibsize
      logical, intent(in)  :: tran1
      real(kind=DP),intent(in), dimension(ibsize,npesize,kimg) :: psi_l  ! MPI

      integer       :: icsize, M, LDA, LDB
      integer :: id_sname = -1
                                                                __TIMER_SUB_START(409)
      call tstatc0_begin('betar_dot_WFs_core2_blk ',id_sname)

      icsize = ibl2-ibl1+1
      M = msize
      LDA = ibsize; LDB = ibsize
      if(kimg == 1) then
         if(tran1) then
                                                              __TIMER_DGEMM_START(415)
            call DGEMM__('T','N',npesize,M,icsize,1.d0,psi_l(1,1,1),LDB,wk_ar,LDA,1.d0,bp_tmp1,LD11)
                                                              __TIMER_DGEMM_STOP(415)
         else
                                                              __TIMER_DGEMM_START(416)
            call DGEMM__('T','N',M,npesize,icsize,1.d0,wk_ar,LDA,psi_l(1,1,1),LDB,1.d0,bp_tmp1,LD11)
                                                              __TIMER_DGEMM_STOP(416)
         endif
      else if(kimg==2) then
         if(tran1) then
                                                              __TIMER_DGEMM_START(417)
            call DGEMM__('T','N',npesize,M,icsize,1.d0,psi_l(1,1,1),LDB,wk_ar,LDA,1.d0,bp_tmp1,LD11)
            call DGEMM__('T','N',npesize,M,icsize,1.d0,psi_l(1,1,2),LDB,wk_ai,LDA,1.d0,bp_tmp1,LD11)
                                                              __TIMER_DGEMM_STOP(417)
         else
                                                              __TIMER_DGEMM_START(418)
            call DGEMM__('T','N',M,npesize,icsize,1.d0,wk_ar,LDA,psi_l(1,1,1),LDB,1.d0,bp_tmp1,LD11)
            call DGEMM__('T','N',M,npesize,icsize,1.d0,wk_ai,LDA,psi_l(1,1,2),LDB,1.d0,bp_tmp1,LD11)
                                                              __TIMER_DGEMM_STOP(418)
         end if
      end if
      call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(409)
    end subroutine betar_dot_WFs_core2_blk
  end subroutine m_ES_betar_dot_WFs_4_lmta_k_blk_3D


#endif
!! #ifdef NONLOCAL_DGEMM end

  subroutine m_ES_add_betar_dot_WFs(nfout)
    integer, intent(in)    :: nfout

    integer ia, ik, iksnl, mapmode
    integer     :: id_sname = -1

    if(sw_use_add_proj == OFF) return

    call tstatc0_begin('m_ES_add_betar_dot_WFs ',id_sname,level=1)

    if(ipri >= 2) write(nfout,'(" -- m_ES_add_betar_dot_WFs --")')
    call m_ES_alloc_zfsincos(0)
    call m_ES_alloc_arai_3D(0)
    call alloc_zfsincos_mpi()
    do ia = 1, natm
! ================================== modified by K. Tagami ============= 11.0
!       if(kv3/nspin == 1) then
!          call G_dot_R_map(ia,1)
!          mapmode = MAPPED
!       else
!          call G_dot_R_mpi(ia) ! pos(ia,1:3), ngabc -> zfcos,zfsin
!          mapmode = NOTMAPPED
!       end if
          if ( kv3/nspin == 1) then
            mapmode = MAPPED
            call G_dot_R(ia,mapmode,1)
         else
            mapmode = NOTMAPPED
            call G_dot_R(ia,mapmode)
         end if
! ====================================================================== 11.0

       do ik = 1, kv3, af+1
          if(map_k(ik) /= myrank_k) cycle         ! MPI

! ================================= modified by K. Tagami ============== 11.0
!          iksnl = (ik-1)/nspin + 1
!
          if ( noncol ) then
            iksnl = ( ik-1 ) / ndim_spinor + 1
          else
            iksnl = (ik-1)/nspin + 1
          endif
! ====================================================================== 11.0

          call m_ES_add_betar_dot_WFs_4_lmta_k(ista_k,iend_k,ik,zaj_l,ia,iksnl,snl_add,fsr_add_l,fsi_add_l,mapmode)
       end do
    end do
    call dealloc_zfsincos_mpi()
    call m_ES_dealloc_arai_3D()
    call m_ES_dealloc_zfsincos()
    if(ipri >= 2) then
       write(nfout,'(" --- fsr_add_l, fsi_add_l ---")')
       do ik = ista_k, iend_k                              ! MPI
          call wd_fsr_fsi_add(ik)                          ! MPI
       end do
    end if
    call tstatc0_end(id_sname)
  end subroutine m_ES_add_betar_dot_WFs

  subroutine wd_fsr_fsi_add(ik)
    integer, intent(in) :: ik
    integer :: it, ia
    if(k_symmetry(ik) == GAMMA) then
       write(nfout,'(" -- fsr_add --")')
       do it = 1, neg
          if(map_e(it) /= myrank_e) cycle                  ! MPI
          write(nfout,'(" ik = ",i8," ib = ",i8)') ik, it
          write(nfout,'(6d12.4)') (fsr_add_l(map_z(it),ia,ik),ia=1,nlmta_add)
       end do
    else
       write(nfout,'(" -- fsr_add, fsi_add --")')
       do it = 1, neg
          if(map_e(it) /= myrank_e) cycle                  ! MPI
          write(nfout,'(" ik = ",i8," ib = ",i8)') ik, it
          write(nfout,'(6d12.4)') (fsr_add_l(map_z(it),ia,ik),fsi_add_l(map_z(it),ia,ik),ia=1,nlmta_add)!MPI
       end do
    end if
  end subroutine wd_fsr_fsi_add

  subroutine m_ES_add_betar_dot_WFs_4_lmta_k(k1,k2,ik,psi_l,ia,iksnl,snl_add,bpr_l,bpi_l,mapmode)
    integer, intent(in)    :: k1,k2, ik, ia, iksnl, mapmode
    real(kind=DP),intent(in), dimension(maxval(np_g1k),np_e,k1:k2,kimg) :: psi_l        ! MPI
    real(kind=DP),intent(out),dimension(np_e,nlmta_add,k1:k2) ::    bpr_l,bpi_l  ! MPI
    real(kind=DP),intent(in), dimension(maxval(np_g1k),nlmtt_add,ista_snl:iend_snl) :: snl_add

    integer                    ::it, lmt1, lmtt1, lmta1, il1

    it    = ityp(ia)
    do lmt1 = 1, ilmt_add(it)
       lmtt1 = lmtt_add(lmt1,it)
       lmta1 = lmta_add(lmt1,ia)
       il1   = ltp_add(lmt1,it)
       call G_dot_R_mult_snl()             ! exp(iGR)
       if(k_symmetry(ik) == GAMMA) then
          call betar_dot_WFS_core2(il1)
       else
          call betar_dot_WFs_core() ! sum(c(k+G)exp(iGR)*snl_add()
          call multiple_i_l()                 !   i**l*( )
       end if
    end do
  contains
    subroutine G_dot_R_mult_snl()
      integer :: i, i1, iadd

      if(kimg == 2 .or. (kimg ==1 .and. k_symmetry(ik) /= GAMMA)) then
         if(mapmode == MAPPED) then
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               ar(iadd) = zfcos(i)*snl_add(iadd,lmtt1,iksnl)
               ai(iadd) = zfsin(i)*snl_add(iadd,lmtt1,iksnl)
            end do
         else
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               i1 = nbase(i,ik)
               ar(iadd) = zfcos(i1)*snl_add(iadd,lmtt1,iksnl)
               ai(iadd) = zfsin(i1)*snl_add(iadd,lmtt1,iksnl)
            end do
         end if
      else ! if(kimg == 1 .and. k_symmetry(ik) == GAMMA) then
         if(mapmode == MAPPED) then
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               ar(iadd) = zfcos(i)*snl_add(iadd,lmtt1,iksnl)
            end do
         else
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               i1 = nbase(i,ik)
               ar(iadd) = zfcos(i1)*snl_add(iadd,lmtt1,iksnl)
            end do
         end if
      end if
    end subroutine G_dot_R_mult_snl

    subroutine betar_dot_WFs_core()
      integer       :: ib, i, iadd

      bpr_l(1:np_e,lmta1,ik) = 0.d0        ! MPI
      bpi_l(1:np_e,lmta1,ik) = 0.d0        ! MPI

      if(kimg == 1) then
         do ib = 1, np_e                   ! MPI
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + ar(iadd)*psi_l(iadd,ib,ik,1)
               bpi_l(ib,lmta1,ik) = bpi_l(ib,lmta1,ik) + ai(iadd)*psi_l(iadd,ib,ik,1)
            end do
         end do
      else if(kimg == 2) then
         do ib = 1, np_e                   ! MPI
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + ar(iadd)*psi_l(iadd,ib,ik,1)-ai(iadd)*psi_l(iadd,ib,ik,2)
               bpi_l(ib,lmta1,ik) = bpi_l(ib,lmta1,ik) + ai(iadd)*psi_l(iadd,ib,ik,1)+ar(iadd)*psi_l(iadd,ib,ik,2)
            end do
         end do
      end if
      call mpi_allreduce(MPI_IN_PLACE,bpr_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
      call mpi_allreduce(MPI_IN_PLACE,bpi_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
    end subroutine betar_dot_WFs_core

    subroutine multiple_i_l
      integer mil, ib
      real(kind=DP) :: tempo

      mil = mod(il1,4)
      if(mil == 2) then
         do ib = 1, np_e                 ! MPI
            tempo = bpi_l(ib,lmta1,ik)
            bpi_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik)
            bpr_l(ib,lmta1,ik) = -tempo
         end do
      else if(mil == 3) then
         do ib = 1, np_e                 ! MPI
            bpr_l(ib,lmta1,ik) = -bpr_l(ib,lmta1,ik)
            bpi_l(ib,lmta1,ik) = -bpi_l(ib,lmta1,ik)
         end do
      else if(mil == 0) then
         do ib = 1, np_e                 ! MPI
            tempo = bpi_l(ib,lmta1,ik)
            bpi_l(ib,lmta1,ik) = -bpr_l(ib,lmta1,ik)
            bpr_l(ib,lmta1,ik) = tempo
         end do
      end if
    end subroutine multiple_i_l

    subroutine betar_dot_WFs_core2(il1)
      integer, intent(in) :: il1

      integer       :: ib, i, mil
      real(kind=DP) :: bpr, fp

      bpr_l(1:np_e,lmta1,ik) = 0.d0        ! MPI

      mil = mod(il1,4)
      if(mil == 0 .or. mil == 1) then
         fp = 1.d0
      else if(mil == 2 .or. mil == 3) then
         fp = -1.d0
      end if
      if(kimg == 1) then
         if(mil == 1 .or. mil == 3) then ! l = 0, 4, 8, ... or 2, 6, 10, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
               bpr = 0.d0
               do i = 2, iba(ik)
                  bpr = bpr + ar(i)*psi_l(i,ib,ik,1)
               end do
               bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
            end do
         else if(mil == 2 .or. mil == 0) then ! l = 1, 5, 9, ... or 3, 7, 11, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
               bpr = 0.d0
               do i = 2, iba(ik)
                  bpr = bpr + ar(i)*psi_l(i,ib,ik,2)
               end do
               bpr_l(ib,lmta1,ik) = fp*2.d0*bpr
            end do
         end if
      else if(kimg == 2) then
         if(mil == 1 .or. mil == 3) then ! l = 0, 4, 8, ... or 2, 6, 10, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
               bpr = 0.d0
               do i = 2, iba(ik)
                  bpr = bpr + ar(i)*psi_l(i,ib,ik,1) - ai(i)*psi_l(i,ib,ik,2)
               end do
               bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
            end do
         else if(mil == 2 .or. mil == 0) then ! l = 1, 5, 9, ... or 3, 7, 11, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
               bpr = 0.d0
               do i = 2, iba(ik)
                  bpr = bpr + ai(i)*psi_l(i,ib,ik,1) + ar(i)*psi_l(i,ib,ik,2)
               end do
               bpr_l(ib,lmta1,ik) = fp*2.d0*bpr
            end do
         end if
      end if
    end subroutine betar_dot_WFs_core2
  end subroutine m_ES_add_betar_dot_WFs_4_lmta_k


  subroutine add_overlap_phirt_psirpw
    integer :: ik, ia, it, lmt1, lmt2, p, q, s
    integer :: il1, il2, im1, im2, t1, t2
    integer :: ikphig
    real(kind=DP) :: ctmp, c1

    Do ik=1, kv3
       if ( map_k(ik) /= myrank_k ) cycle

       ikphig = ( ik -1 )/nspin +1

       Do ia=1, natm
          it = ityp(ia)

          Do lmt1=1, ilmt_phi(it)
             il1=ltp_phi(lmt1,it);  im1 = mtp_phi(lmt1,it);  t1 = taup_phi(lmt1,it)
             p = lmta_phi(lmt1,ia);  s = lmtt_phi(lmt1,it)
             c1 = sqrt( norm_phig( s,ikphig ) )

             Do lmt2=1, ilmt(it)
                il2=ltp(lmt2,it);  im2 = mtp(lmt2,it);  t2 = taup(lmt2,it)
                if ( il1 /= il2 ) cycle
                if ( im1 /= im2 ) cycle

                q = lmta(lmt2,ia)
                ctmp = q_phirt_pw(il1,t1,t2,it) /c1

                if ( k_symmetry(ik) == GAMMA ) then
                   compr_l(:,p,1,ik) = compr_l(:,p,1,ik) &
                        &              +ctmp *fsr_l(:,q,ik) 
                else
                   compr_l(:,p,1,ik) = compr_l(:,p,1,ik) +ctmp *fsr_l(:,q,ik)
                   compi_l(:,p,1,ik) = compi_l(:,p,1,ik) +ctmp *fsi_l(:,q,ik)
                endif
             End Do
          End Do
       End Do
    End Do
  end subroutine add_overlap_phirt_psirpw

  subroutine set_compri_if_anfiferro
    integer :: ik, iorb, jorb, mm, iopr

    iopr = nopr +af

    Do ik=1, kv3, af+1
       if ( map_k(ik) /= myrank_k ) cycle

       compr_l( :,:,1,ik+1 ) = 0.d0
       compi_l( :,:,1,ik+1 ) = 0.d0

       if (k_symmetry(ik) == GAMMA) then
          do iorb=1,nlmta_phi
             do mm=1,nrorb(iorb,iopr)
                jorb = irorb(mm,iorb,iopr)
                compr_l( :,iorb,1,ik+1 ) = compr_l( :,iorb,1,ik+1 ) &
                     &                   + compr_l( :,jorb,1,ik )*crorb(mm,iorb,iopr)
             end do
          end do
       else
          do iorb=1,nlmta_phi
             do mm=1,nrorb(iorb,iopr)
                jorb=irorb(mm,iorb,iopr)
                compr_l( :,iorb,1,ik+1 ) = compr_l( :,iorb,1,ik+1 ) &
                     &                   + compr_l( :,jorb,1,ik )*crorb(mm,iorb,iopr)
                compi_l( :,iorb,1,ik+1 ) = compi_l( :,iorb,1,ik+1 ) &
                     &                   + compi_l( :,jorb,1,ik )*crorb(mm,iorb,iopr)
             end do
          end do
      endif
    end Do

  end subroutine set_compri_if_anfiferro

  subroutine wd_compr_compi(ik)
    integer, intent(in) :: ik
    integer :: it, ia
    if(k_symmetry(ik) == GAMMA) then
       write(nfout,'(" -- compr --")')
       do it = 1, neg
          if(map_e(it) /= myrank_e) cycle                  ! MPI
          write(nfout,'(" ik = ",i8," ib = ",i8)') ik, it
          write(nfout,'(6d12.4)') (compr_l(map_z(it),ia,1,ik),ia=1,nlmta_phi)!MPI
       end do
    else
       write(nfout,'(" -- compr, compi --")')
       do it = 1, neg
          if(map_e(it) /= myrank_e) cycle                  ! MPI
          write(nfout,'(" ik = ",i8," ib = ",i8)') ik, it
          write(nfout,'(6d12.4)') (compr_l(map_z(it),ia,1,ik),compi_l(map_z(it),ia,1,ik),ia=1,nlmta_phi)!MPI
       end do
    end if
  end subroutine wd_compr_compi
  subroutine m_ES_phir_dot_WFs_3D(nfout)
    integer, intent(in)    :: nfout

    integer ia, ik, ikphig, mapmode
    integer     :: id_sname = -1
    call tstatc0_begin('m_ES_phir_dot_WFs_3D ',id_sname,level=1)

    if(ipri >= 2) write(nfout,'(" -- m_ES_phir_dot_WFs_3D --")')
    call m_ES_alloc_zfsincos(0)
    call m_ES_alloc_arai_3D(0)
    call alloc_zfsincos_mpi()
    do ia = 1, natm
! ============================ modified by K. Tagami ================ 11.0
!       if(kv3/nspin == 1) then
!          call G_dot_R_map(ia,1)
!          mapmode = MAPPED
!       else
!          call G_dot_R_mpi(ia) ! pos(ia,1:3), ngabc -> zfcos,zfsin
!          mapmode = NOTMAPPED
!       end if
!
       if(kv3/nspin == 1) then
!!$          call G_dot_R_map(ia,1)
          mapmode = MAPPED
          call G_dot_R(ia,mapmode,1)
       else
!!$          call G_dot_R_mpi(ia) ! pos(ia,1:3), ngabc -> zfcos,zfsin
          mapmode = NOTMAPPED
          call G_dot_R(ia,mapmode)
       end if
! ====================================================================== 11.0

       do ik = 1, kv3, af+1
          if(map_k(ik) /= myrank_k) cycle         ! MPI
! ==================================== modified by K. Tagami ============ 11.0
!          ikphig = (ik-1)/nspin + 1
          if ( noncol ) then
            ikphig = (ik-1)/ndim_spinor + 1
          else
            ikphig = (ik-1)/nspin + 1
          endif
! ====================================================================== 11.0          

          call m_ES_phir_dot_WFs_4_lmta_k_3D( ista_k, iend_k, ik, zaj_l, ia, ikphig, &
               &                           phig, nopr, compr_l, compi_l, mapmode )
       end do
    end do

    call dealloc_zfsincos_mpi()
    call m_ES_dealloc_arai_3D()
    call m_ES_dealloc_zfsincos()

    if ( orb_popu_method == 2 )  call add_overlap_phirt_psirpw
    if ( af == 1 ) call set_compri_if_anfiferro

    if(ipri >= 2) then
       write(nfout,'(" --- compr_l, compi_l ---")')
       do ik = ista_k, iend_k                            ! MPI
          call wd_compr_compi(ik)                        ! MPI
       end do
    end if
    call tstatc0_end(id_sname)
  end subroutine m_ES_phir_dot_WFs_3D

  subroutine m_ES_phir_dot_WFs_4_lmta_k_3D( k1, k2, ik, psi_l, ia, ikphig, phig, &
       &                                 nopr, cr_l, ci_l, mapmode )
    integer, intent(in)    :: k1,k2, ik, ia, ikphig, mapmode, nopr
    real(kind=DP),intent(in), dimension(maxval(np_g1k),np_e,k1:k2,kimg) :: psi_l        ! MPI
    real(kind=DP),intent(out),dimension(np_e,nlmta_phi,nopr,k1:k2) ::    cr_l,ci_l  ! MPI
    real(kind=DP),intent(in), dimension(maxval(np_g1k),nlmtt_phi,ista_snl:iend_snl) :: phig

    integer                    ::it, lmt1, lmtt1, lmta1, il1, ierr

    it    = ityp(ia)
    do lmt1 = 1, ilmt_phi(it)
       lmtt1 = lmtt_phi(lmt1,it)
       lmta1 = lmta_phi(lmt1,ia)
       il1   = ltp_phi(lmt1,it)
       call G_dot_R_mult_phig()             ! exp(iGR)
       if(k_symmetry(ik) == GAMMA) then
          call phir_dot_WFs_core2(il1) ! sum(c(k+G)exp(iGR)*phig()
       else
          call phir_dot_WFs_core() ! sum(c(k+G)exp(iGR)*phig()
          call multiple_i_l()                 !   i**l*( )
       end if
    end do
  contains
    subroutine G_dot_R_mult_phig()
      integer :: i, i1, iadd

      if(kimg == 2 .or. (kimg ==1 .and. k_symmetry(ik) /= GAMMA) ) then
         if(mapmode == MAPPED) then
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
            do i = 1, np_g1k(ik)
               ar(i) = zfcos(i)*phig(i,lmtt1,ikphig)
               ai(i) = zfsin(i)*phig(i,lmtt1,ikphig)
            end do
         else
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
            do i = 1, np_g1k(ik)
               i1    = nbase(i+ista_g1k(ik)-1,ik)
               ar(i) = zfcos(i1)*phig(i,lmtt1,ikphig)
               ai(i) = zfsin(i1)*phig(i,lmtt1,ikphig)
            end do
         end if
      else  ! if(kimg == 1 .and. k_symmetry == GAMMA) then
         if(mapmode == MAPPED) then
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
            do i = 1, np_g1k(ik)
               ar(i) = zfcos(i)*phig(i,lmtt1,ikphig)
            end do
         else
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
            do i = 1, np_g1k(ik)
               i1    = nbase(i+ista_g1k(ik)-1,ik)
               ar(i) = zfcos(i1)*phig(i,lmtt1,ikphig)
            end do
         end if
      end if
    end subroutine G_dot_R_mult_phig

    subroutine phir_dot_WFs_core()
      integer       :: ib, i
      real(kind=DP), allocatable, dimension(:) :: cr,ci
      allocate(cr(np_e));cr=0.0d0
      allocate(ci(np_e));ci=0.d0
      cr_l(1:np_e,lmta1,1,ik) = 0.d0        ! MPI
      ci_l(1:np_e,lmta1,1,ik) = 0.d0        ! MPI

      if(kimg == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
         do ib = 1, np_e                   ! MPI
            do i = 1, np_g1k(ik)
               cr(ib) = cr(ib) + ar(i)*psi_l(i,ib,ik,1)
               ci(ib) = ci(ib) + ai(i)*psi_l(i,ib,ik,1)
            end do
         end do
      else if(kimg == 2) then
         if(k_symmetry(ik) == GAMMA) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
            do ib = 1, np_e                   ! MPI
               do i = 2, np_g1k(ik)
                  cr(ib) = cr(ib) + ar(i)*psi_l(i,ib,ik,1)-ai(i)*psi_l(i,ib,ik,2)
               end do
               cr(ib) = cr(ib)*2.d0 + ar(1)*psi_l(1,ib,ik,1)-ai(1)*psi_l(1,ib,ik,2)
            end do
         else
#ifdef VPP
*vocl loop, unroll(4)
#endif
            do ib = 1, np_e                   ! MPI
               do i = 1, np_g1k(ik)
                  cr(ib) = cr(ib) + ar(i)*psi_l(i,ib,ik,1)-ai(i)*psi_l(i,ib,ik,2)
                  ci(ib) = ci(ib) + ai(i)*psi_l(i,ib,ik,1)+ar(i)*psi_l(i,ib,ik,2)
               end do
            end do
         end if
      end if
      call mpi_allreduce(MPI_IN_PLACE,cr,np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
      call mpi_allreduce(MPI_IN_PLACE,ci,np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
      cr_l(1:np_e,lmta1,1,ik) = cr(1:np_e)
      ci_l(1:np_e,lmta1,1,ik) = ci(1:np_e)
      deallocate(cr,ci)
    end subroutine phir_dot_WFs_core

    subroutine multiple_i_l
      integer mil, ib
      real(kind=DP) :: tempo

      mil = mod(il1,4)
      if(mil == 2) then
         do ib = 1, np_e                 ! MPI
            tempo = ci_l(ib,lmta1,1,ik)
            ci_l(ib,lmta1,1,ik) = cr_l(ib,lmta1,1,ik)
            cr_l(ib,lmta1,1,ik) = -tempo
         end do
      else if(mil == 3) then
         do ib = 1, np_e                 ! MPI
            cr_l(ib,lmta1,1,ik) = -cr_l(ib,lmta1,1,ik)
            ci_l(ib,lmta1,1,ik) = -ci_l(ib,lmta1,1,ik)
         end do
      else if(mil == 0) then
         do ib = 1, np_e                 ! MPI
            tempo = ci_l(ib,lmta1,1,ik)
            ci_l(ib,lmta1,1,ik) = -cr_l(ib,lmta1,1,ik)
            cr_l(ib,lmta1,1,ik) = tempo
         end do
      end if
    end subroutine multiple_i_l

    subroutine phir_dot_WFs_core2(il1)
      integer, intent(in) :: il1
      integer       :: ib, i, mil
      real(kind=DP) :: bpr, fp
      real(kind=DP), allocatable, dimension(:) :: cr
      allocate(cr(np_e));cr=0.d0
      cr_l(1:np_e,lmta1,1,ik) = 0.d0        ! MPI

      mil = mod(il1,4)
      if(mil == 0 .or. mil == 1) then
         fp = 1.d0
      else if(mil == 2 .or. mil == 3) then
         fp = -1.d0
      end if
      if(kimg == 1) then
         if(mil == 1 .or. mil == 3) then ! l = 0, 4, 8, ... or 2, 6, 10, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e                   ! MPI
               bpr = 0.d0
               do i = 2, np_g1k(ik)
                  bpr = bpr + ar(i)*psi_l(i,ib,ik,1)
               end do
               cr(ib) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
            end do
         else if(mil == 2 .or. mil == 0) then ! l = 1, 5, 9, ... or 3, 7, 11, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
               bpr = 0.d0
               do i = 2, np_g1k(ik)
                  bpr = bpr + ar(i)*psi_l(i,ib,ik,2)
               end do
               cr(ib) = fp*2.d0*bpr
            end do
         end if
      else if(kimg == 2) then
         if(mil == 1 .or. mil == 3) then ! l = 0, 4, 8, ... or 2, 6, 10, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
               bpr = 0.d0
               do i = 2, np_g1k(ik)
                  bpr = bpr + ar(i)*psi_l(i,ib,ik,1) - ai(i)*psi_l(i,ib,ik,2)
               end do
               cr(ib) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
            end do
         else if(mil == 2 .or. mil == 0) then ! l = 1, 5, 9, ... or 3, 7, 11, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
               bpr = 0.d0
               do i = 2, np_g1k(ik)
                  bpr = bpr + ai(i)*psi_l(i,ib,ik,1) + ar(i)*psi_l(i,ib,ik,2)
               end do
               cr(ib) = fp*2.d0*bpr
            end do
         end if
      end if
      call mpi_allreduce(MPI_IN_PLACE,cr,np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
      cr_l(:,lmta1,1,ik) = cr(:)
      deallocate(cr)
    end subroutine phir_dot_WFs_core2
  end subroutine m_ES_phir_dot_WFs_4_lmta_k_3D

  subroutine m_ES_phir_dot_WFs_4_lmta_k( k1, k2, ik, psi_l, ia, ikphig, phig, &
       &                                 nopr, cr_l, ci_l, mapmode )
    integer, intent(in)    :: k1,k2, ik, ia, ikphig, mapmode, nopr
    real(kind=DP),intent(in), dimension(kg1,np_e,k1:k2,kimg) :: psi_l        ! MPI
    real(kind=DP),intent(out),dimension(np_e,nlmta_phi,nopr,k1:k2) ::    cr_l,ci_l  ! MPI
    real(kind=DP),intent(in), dimension(kg1,nlmtt_phi,ista_snl:iend_snl) :: phig

    integer                    ::it, lmt1, lmtt1, lmta1, il1

    it    = ityp(ia)
    do lmt1 = 1, ilmt_phi(it)
       lmtt1 = lmtt_phi(lmt1,it)
       lmta1 = lmta_phi(lmt1,ia)
       il1   = ltp_phi(lmt1,it)
       call G_dot_R_mult_phig()             ! exp(iGR)
       if(k_symmetry(ik) == GAMMA) then
          call phir_dot_WFs_core2(il1) ! sum(c(k+G)exp(iGR)*phig()
       else
          call phir_dot_WFs_core() ! sum(c(k+G)exp(iGR)*phig()
          call multiple_i_l()                 !   i**l*( )
       end if
    end do
  contains
    subroutine G_dot_R_mult_phig()
      integer :: i, i1

      if(kimg == 2 .or. (kimg ==1 .and. k_symmetry(ik) /= GAMMA) ) then
         if(mapmode == MAPPED) then
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
            do i = 1, iba(ik)
               ar(i) = zfcos(i)*phig(i,lmtt1,ikphig)
               ai(i) = zfsin(i)*phig(i,lmtt1,ikphig)
            end do
         else
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
            do i = 1, iba(ik)
               i1    = nbase(i,ik)
               ar(i) = zfcos(i1)*phig(i,lmtt1,ikphig)
               ai(i) = zfsin(i1)*phig(i,lmtt1,ikphig)
            end do
         end if
      else  ! if(kimg == 1 .and. k_symmetry == GAMMA) then
         if(mapmode == MAPPED) then
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
            do i = 1, iba(ik)
               ar(i) = zfcos(i)*phig(i,lmtt1,ikphig)
            end do
         else
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
            do i = 1, iba(ik)
               i1    = nbase(i,ik)
               ar(i) = zfcos(i1)*phig(i,lmtt1,ikphig)
            end do
         end if
      end if
    end subroutine G_dot_R_mult_phig

    subroutine phir_dot_WFs_core()
      integer       :: ib, i

      cr_l(1:np_e,lmta1,1,ik) = 0.d0        ! MPI
      ci_l(1:np_e,lmta1,1,ik) = 0.d0        ! MPI

      if(kimg == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
         do ib = 1, np_e                   ! MPI
            do i = 1, iba(ik)
               cr_l(ib,lmta1,1,ik) = cr_l(ib,lmta1,1,ik) + ar(i)*psi_l(i,ib,ik,1)
               ci_l(ib,lmta1,1,ik) = ci_l(ib,lmta1,1,ik) + ai(i)*psi_l(i,ib,ik,1)
            end do
         end do
      else if(kimg == 2) then
         if(k_symmetry(ik) == GAMMA) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
            do ib = 1, np_e                   ! MPI
               do i = 2, iba(ik)
                  cr_l(ib,lmta1,1,ik) = cr_l(ib,lmta1,1,ik) + ar(i)*psi_l(i,ib,ik,1)-ai(i)*psi_l(i,ib,ik,2)
               end do
               cr_l(ib,lmta1,1,ik) = cr_l(ib,lmta1,1,ik)*2.d0 + ar(1)*psi_l(1,ib,ik,1)-ai(1)*psi_l(1,ib,ik,2)
            end do
         else
#ifdef VPP
*vocl loop, unroll(4)
#endif
            do ib = 1, np_e                   ! MPI
               do i = 1, iba(ik)
                  cr_l(ib,lmta1,1,ik) = cr_l(ib,lmta1,1,ik) + ar(i)*psi_l(i,ib,ik,1)-ai(i)*psi_l(i,ib,ik,2)
                  ci_l(ib,lmta1,1,ik) = ci_l(ib,lmta1,1,ik) + ai(i)*psi_l(i,ib,ik,1)+ar(i)*psi_l(i,ib,ik,2)
               end do
            end do
         end if
      end if
    end subroutine phir_dot_WFs_core

    subroutine multiple_i_l
      integer mil, ib
      real(kind=DP) :: tempo

      mil = mod(il1,4)
      if(mil == 2) then
         do ib = 1, np_e                 ! MPI
            tempo = ci_l(ib,lmta1,1,ik)
            ci_l(ib,lmta1,1,ik) = cr_l(ib,lmta1,1,ik)
            cr_l(ib,lmta1,1,ik) = -tempo
         end do
      else if(mil == 3) then
         do ib = 1, np_e                 ! MPI
            cr_l(ib,lmta1,1,ik) = -cr_l(ib,lmta1,1,ik)
            ci_l(ib,lmta1,1,ik) = -ci_l(ib,lmta1,1,ik)
         end do
      else if(mil == 0) then
         do ib = 1, np_e                 ! MPI
            tempo = ci_l(ib,lmta1,1,ik)
            ci_l(ib,lmta1,1,ik) = -cr_l(ib,lmta1,1,ik)
            cr_l(ib,lmta1,1,ik) = tempo
         end do
      end if
    end subroutine multiple_i_l

    subroutine phir_dot_WFs_core2(il1)
      integer, intent(in) :: il1
      integer       :: ib, i, mil
      real(kind=DP) :: bpr, fp

      cr_l(1:np_e,lmta1,1,ik) = 0.d0        ! MPI

      mil = mod(il1,4)
      if(mil == 0 .or. mil == 1) then
         fp = 1.d0
      else if(mil == 2 .or. mil == 3) then
         fp = -1.d0
      end if
      if(kimg == 1) then
         if(mil == 1 .or. mil == 3) then ! l = 0, 4, 8, ... or 2, 6, 10, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e                   ! MPI
               bpr = 0.d0
               do i = 2, iba(ik)
                  bpr = bpr + ar(i)*psi_l(i,ib,ik,1)
               end do
               cr_l(ib,lmta1,1,ik) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
            end do
         else if(mil == 2 .or. mil == 0) then ! l = 1, 5, 9, ... or 3, 7, 11, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
               bpr = 0.d0
               do i = 2, iba(ik)
                  bpr = bpr + ar(i)*psi_l(i,ib,ik,2)
               end do
               cr_l(ib,lmta1,1,ik) = fp*2.d0*bpr
            end do
         end if
      else if(kimg == 2) then
         if(mil == 1 .or. mil == 3) then ! l = 0, 4, 8, ... or 2, 6, 10, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
               bpr = 0.d0
               do i = 2, iba(ik)
                  bpr = bpr + ar(i)*psi_l(i,ib,ik,1) - ai(i)*psi_l(i,ib,ik,2)
               end do
               cr_l(ib,lmta1,1,ik) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
            end do
         else if(mil == 2 .or. mil == 0) then ! l = 1, 5, 9, ... or 3, 7, 11, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
               bpr = 0.d0
               do i = 2, iba(ik)
                  bpr = bpr + ai(i)*psi_l(i,ib,ik,1) + ar(i)*psi_l(i,ib,ik,2)
               end do
               cr_l(ib,lmta1,1,ik) = fp*2.d0*bpr
            end do
         end if
      end if
    end subroutine phir_dot_WFs_core2
  end subroutine m_ES_phir_dot_WFs_4_lmta_k


  subroutine m_ES_PAO_WFs_3D(nfout)

    integer, intent(in)    :: nfout

    integer ia, ik, iksnl, mapmode
    integer     :: id_sname = -1

    call tstatc0_begin('m_ES_PAO_WFs ',id_sname,level=1)

    if(ipri >= 2) write(nfout,'(" -- m_ES_PAO_WFs --")')
    call m_ES_alloc_zfsincos(0)
    call alloc_zfsincos_mpi()
    do ia = 1, natm
       if(kv3/nspin == 1) then
!!$          call G_dot_R_map(ia,1)
          mapmode = MAPPED
          call G_dot_R(ia,mapmode,1)
       else
!!$          call G_dot_R_mpi(ia) ! pos(ia,1:3), ngabc -> zfcos,zfsin
          mapmode = NOTMAPPED
          call G_dot_R(ia,mapmode)
       end if
       do ik = 1, kv3, af+1
          if(map_k(ik) /= myrank_k) cycle         ! MPI
          iksnl = (ik-1)/nspin + 1
          call m_ES_PAO_WFs_4_lmta_k_3D(ista_k,iend_k,ik,ia,iksnl,paog,zaj_l,mapmode)
       end do
    end do
    call dealloc_zfsincos_mpi()
    call m_ES_dealloc_zfsincos()
    call tstatc0_end(id_sname)
  end subroutine m_ES_PAO_WFs_3D

  subroutine m_ES_PAO_WFs_4_lmta_k_3D(k1,k2,ik,ia,iksnl,paog,psi_l,mapmode)

    integer, intent(in)    :: k1,k2, ik, ia, iksnl, mapmode
    real(kind=DP),intent(in), dimension(maxval(np_g1k),nlmtt_pao,ista_snl:iend_snl) :: paog ! MPI
    real(kind=DP),intent(out), dimension(maxval(np_g1k),ista_e:iend_e,k1:k2,kimg) :: psi_l        ! MPI

    integer                    ::it, lmt1, lmtt1, lmta1, il1, ib, ib2

    it    = ityp(ia)
    do lmt1 = 1, ilmt_pao(it)
       lmtt1 = lmtt_pao(lmt1,it)
       lmta1 = lmta_pao(lmt1,ia)
       il1   = ltp_pao(lmt1,it)
       ib    = ibpao(lmta1)
       ib2   = 0
       if(ib < 0) then
          ib = abs(ib)
          ib2 = ib + 1
       end if
       if(ib >= ista_e .and. ib <= iend_e) then
          call G_dot_R_mult_paog(ib,.true.)             ! exp(iGR)
       end if
       if(ib2 >= ista_e .and. ib2 <= iend_e) then
          call G_dot_R_mult_paog(ib2,.false.)             ! exp(iGR)
       end if
    end do
  contains
    subroutine G_dot_R_mult_paog(ib,fcos)
      integer, intent(in) :: ib
      logical, intent(in) :: fcos
      integer :: i, i1, mil
      if(kimg==1) then
         if(fcos) then
            if(mapmode == MAPPED) then
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
               do i = 1, np_g1k(ik)
                  psi_l(i,ib,ik,1) = zfcos(i)*paog(i,lmtt1,iksnl)
               end do
            else
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
               do i = 1, np_g1k(ik)
                  i1    = nbase(i+ista_g1k(ik)-1,ik)
                  psi_l(i,ib,ik,1) = zfcos(i1)*paog(i,lmtt1,iksnl)
               end do
            end if
         else
            if(mapmode == MAPPED) then
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
               do i = 1, np_g1k(ik)
                  psi_l(i,ib,ik,1) = zfsin(i)*paog(i,lmtt1,iksnl)
               end do
            else
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
               do i = 1, np_g1k(ik)
                  i1    = nbase(i+ista_g1k(ik)-1,ik)
                  psi_l(i,ib,ik,1) = zfsin(i1)*paog(i,lmtt1,iksnl)
               end do
            end if
         end if
      else
         mil = mod(il1,4)
         if(mil == 1 .or. mil == 3) then
            if(mapmode == MAPPED) then
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
               do i = 1, np_g1k(ik)
                  psi_l(i,ib,ik,1) = zfcos(i)*paog(i,lmtt1,iksnl)
                  psi_l(i,ib,ik,2) = zfsin(i)*paog(i,lmtt1,iksnl)
               end do
            else
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
               do i = 1, np_g1k(ik)
                  i1    = nbase(i+ista_g1k(ik)-1,ik)
                  psi_l(i,ib,ik,1) = zfcos(i1)*paog(i,lmtt1,iksnl)
                  psi_l(i,ib,ik,2) = zfsin(i1)*paog(i,lmtt1,iksnl)
               end do
            end if
         else
            if(mapmode == MAPPED) then
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
               do i = 1, np_g1k(ik)
                  psi_l(i,ib,ik,1) = -zfsin(i)*paog(i,lmtt1,iksnl)
                  psi_l(i,ib,ik,2) =  zfcos(i)*paog(i,lmtt1,iksnl)
               end do
            else
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
               do i = 1, np_g1k(ik)
                  i1    = nbase(i+ista_g1k(ik)-1,ik)
                  psi_l(i,ib,ik,1) = -zfsin(i1)*paog(i,lmtt1,iksnl)
                  psi_l(i,ib,ik,2) =  zfcos(i1)*paog(i,lmtt1,iksnl)
               end do
            end if
         end if
      end if
    end subroutine G_dot_R_mult_paog

  end subroutine m_ES_PAO_WFs_4_lmta_k_3D

  subroutine wd_fsr_fsi_3D(ik)

    integer, intent(in) :: ik
    integer :: it, ia
    if(k_symmetry(ik) == GAMMA) then
       write(nfout,'(" -- fsr --")')
       do it = 1, neg
          if(map_e(it) /= myrank_e) cycle                  ! MPI
          write(nfout,'(" ik = ",i8," ib = ",i8)') ik, it
! === DEBUG by tkato 2013/08/28 ================================================
!         write(nfout,'(6d12.4)') (fsr_l(map_z(it),ia,ik),ia=1,nlmta)!MPI
          write(nfout,'(6d12.4)') (fsr_l(map_z(it),ia,ik),ia=1,np_fs)!MPI
! ==============================================================================
       end do
    else
       write(nfout,'(" -- fsr, fsi --")')
       do it = 1, neg
          if(map_e(it) /= myrank_e) cycle                  ! MPI
          write(nfout,'(" ik = ",i8," ib = ",i8)') ik, it
! === DEBUG by tkato 2013/08/28 ================================================
!         write(nfout,'(6d12.4)') (fsr_l(map_z(it),ia,ik),fsi_l(map_z(it),ia,ik),ia=1,nlmta)!MPI
          write(nfout,'(6d12.4)') (fsr_l(map_z(it),ia,ik),fsi_l(map_z(it),ia,ik),ia=1,np_fs)!MPI
! ==============================================================================
       end do
    end if
    call flush(nfout)
  end subroutine wd_fsr_fsi_3D

  subroutine m_ES_betar_dot_WFs_3D(nfout,ik)
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
! Revised by T. Yamasaki, October 2009 : Mblock
!
    use m_Parallelization,only      : ball_buff, ball_addr

    integer, intent(in)    :: nfout, ik
    integer :: iksnl, ibsize
    integer :: datasize

    integer :: ia, it, lmt1, msize, msize_target, msizemax, msizesum, natm_redmax
    integer :: ibl1,ibl2, ia1, ia2
    integer :: LD11,  LD12
    logical :: tran1
!!$    integer, allocatable, dimension(:) :: mil
    real(kind=DP), allocatable, dimension(:,:,:) :: psi_ri
!f
!   real(kind=DP),allocatable, dimension(:,:) :: fsr_l_2D,fsi_l_2D
    real(kind=DP),allocatable, dimension(:,:) :: wk_fsr_l,wk_fsi_l
    real(kind=DP),allocatable, dimension(:,:) :: wk_fsr_ball,wk_fsi_ball
    integer :: i, j, k 

    integer :: id_sname = -1
! === rspace on 3D_Parallel ==============================================================
    logical :: flag_in_realspace
    call m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik)
  end subroutine m_ES_betar_dot_WFs_3D

  subroutine build_fft_map(nfft,kimg)
    integer, intent(in) :: nfft,kimg
    integer :: ia,nma,im
    if(.not.allocated(mapl)) allocate(mapl(nfft/2))
    mapl = .false.
    do ia=ista_atm,iend_atm
       nma = nmesh_rs(ia) 
       do im=1,nma
          mapl(meshxyz_rs(im,ia)) = .true.
       enddo
    enddo
    nonzero_fft_elements = 0
    do ia=ista_atm,iend_atm
       nma = nmesh_rs(ia) 
       do im=1,nma
          if(mapl(meshxyz_rs(im,ia))) nonzero_fft_elements = nonzero_fft_elements + 1
       enddo
    enddo
    write(0,*) 'nfft, nonzero_fft_elements ',nfft,nonzero_fft_elements
  end subroutine build_fft_map

  subroutine allreduce_wf(lsize,kimg,nfft,ibsize,psi_l,bff)
    integer, intent(in) :: lsize,kimg,nfft,ibsize
    real(kind=DP), dimension(lsize*kimg,ibsize), intent(in) :: psi_l
    real(kind=DP), dimension(nfft,ibsize), intent(out) :: bff
    integer :: imesh,i,j,ierr,ib
    integer :: id_sname = -1
    call tstatc0_begin('allreduce_wf ',id_sname)
    bff = 0.d0
    do ib=1,ibsize
    do imesh=1,lsize
       i = 2*dist_to_full(imesh)
       j = 2*imesh
       bff(i-1,ib) = psi_l(j-1,ib)
       bff(i,ib)   = psi_l(j,ib)
    enddo
    enddo
    call mpi_allreduce(mpi_in_place,bff,nfft*ibsize,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
    call tstatc0_end(id_sname)
  end subroutine allreduce_wf

  subroutine betar_dot_Psi_4_each_k_in_rs(nfout,k1,k2,ik,psi_l,bpr_l,bpi_l)
    integer,intent(in) :: nfout 
    integer,intent(in) :: k1,k2,ik
    real(kind=DP),intent(in),dimension(maxval(np_g1k),np_e,k1:k2,kimg) :: psi_l
    real(kind=DP),intent(out),dimension(np_e,nlmta) :: bpr_l, bpi_l
    call betar_dot_Psi_4_each_k_in_rs0(nfout,k1,k2,ik,psi_l,bpr_l,bpi_l,nmesh_rs_max,snl_rs)
  end subroutine betar_dot_Psi_4_each_k_in_rs

  subroutine betar_dot_Psi_4_each_k_in_rs0(nfout,k1,k2,ik,psi_l,bprt,bpit,nsnl,snlsnl)
    use m_Parallelization,    only : nel_fft_z, nel_fft_y, nel_fft_x,ista_lmta,iend_lmta
    integer,intent(in) :: nfout 
    integer,intent(in) :: k1,k2,ik
    real(kind=DP),intent(in),dimension(maxval(np_g1k),np_e,k1:k2,kimg) :: psi_l
    real(kind=DP),intent(out),dimension(np_e,nlmta) :: bprt, bpit
    integer, intent(in) :: nsnl
    real(kind=DP), intent(in), dimension(nsnl,ista_lmta:iend_lmta) :: snlsnl
    integer :: ia,ib
    real(kind=DP),allocatable,dimension(:,:) :: cos_kr,sin_kr
#ifdef MULT_PHASE_RSPACE
    real(kind=DP),allocatable,dimension(:) :: cos_a,sin_a
#endif
    real(kind=DP), allocatable, dimension(:,:) :: bff
    real(kind=DP), allocatable, dimension(:,:) :: wk_bfft_l
    real(kind=DP), allocatable, dimension(:,:) :: rrr, iii
    integer :: id_sname = -1
    integer :: ib1, ib2, ibsize, isrsize, lsize, iesize, ierr,i,j
    logical, save :: initialized = .false.
    call tstatc0_begin('betar_dot_Psi_4_each_k_in_rs ',id_sname,level=1)
    if(.not.initialized)then
    call build_fft_map(nfft,kimg)
    initialized = .true.
    endif
    lsize = max(maxval(nel_fft_x(:)),maxval(nel_fft_y(:)),maxval(nel_fft_z(:)))
!    if(.not.initialized) then
!       call build_fft_map(lsize,nfft,kimg)
!       initialized = .true.
!    endif
    ibsize = nblocksize_rspace_betar
    if(ibsize<1) ibsize = 1
    if(ibsize>np_e) ibsize = np_e
!    if (nblocksize_fftw_is_given) then
!       ibsize = nblocksize_fftw
!       if(ibsize < 1) ibsize = 1
!    endif

    call alloc_work_arrays()
    call k_dot_r(ik,cos_kr,sin_kr)
#ifdef MULT_PHASE_RSPACE
    call k_dot_pos(ik,cos_a,sin_a)
#endif
    do ib1=1,np_e, ibsize
       !ib2 = min(ib1+ibsize-1,np_e)
       ib2 = min(ibsize,np_e+1-ib1)
       call m_ES_WF_2D_psi(ik,wk_bfft_l,psi_l,min(ibsize+ib1-1,np_e),ib1,k1,k2,ibsize,lsize,INVERSE,bff)
!       call m_ES_WF_in_Rspace_3D(k1,k2,ik,ib1,ib2,ibsize,lsize,psi_l,wk_bfft_l)
!       call allreduce_wf(lsize,kimg,nfft,ibsize,wk_bfft_l,bff)
       do ia=ista_atm,iend_atm
          call betar_dot_Psi_atm_band_pre(bff,ia)
          call betar_dot_Psi_atm_band(ia)
       enddo
    enddo
    
    if(nrank_g>1)then
       call mpi_allreduce(mpi_in_place,bprt,np_e*nlmta,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
       if(k_symmetry(ik) /= GAMMA) then
          call mpi_allreduce(mpi_in_place,bpit,np_e*nlmta,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
       endif
    endif

    call dealloc_work_arrays()
    call tstatc0_end(id_sname)

    !write(nfout,'(a)') 'fsr fsr '
    !do i=1,np_e
    !   write(nfout,'(a,i8)') 'band ',i
    !   write(nfout,'(5f20.10)') (bprt(i,j),j=1,nlmta)
    !enddo
    contains

    subroutine alloc_work_arrays()
       allocate(wk_bfft_l(lsize*kimg,ibsize))
       allocate(bff(nfft,ibsize));bff=0.d0
       allocate(cos_kr(nmesh_rs_max,natm));cos_kr=0.d0
       allocate(sin_kr(nmesh_rs_max,natm));sin_kr=0.d0
#ifdef MULT_PHASE_RSPACE
       allocate(cos_a(natm));cos_a=0.d0
       allocate(sin_a(natm));sin_a=0.d0
#endif
       allocate(rrr(nmesh_rs_max,ibsize)); rrr = 0.0d0
       allocate(iii(nmesh_rs_max,ibsize)); iii = 0.0d0
    end subroutine alloc_work_arrays

    subroutine dealloc_work_arrays()
       deallocate(wk_bfft_l)
       deallocate(bff)
       deallocate(cos_kr)
       deallocate(sin_kr)
#ifdef MULT_PHASE_RSPACE
       deallocate(cos_a)
       deallocate(sin_a)
#endif
       deallocate(rrr)
       deallocate(iii)
    end subroutine dealloc_work_arrays

    subroutine betar_dot_Psi_atm_band_pre(bff,iatm)
       real(kind=DP),dimension(nfft,ibsize),intent(in) :: bff
       integer,intent(in) :: iatm
       integer :: lmt1,i,lmta1,imesh,nma,it,ib
       real(kind=DP) :: s,bpr,bpi
       real(kind=DP) :: fac,cosa,sina,rr,ii,psr,psi
       real(kind=DP), allocatable, dimension(:) :: cos_krt,sin_krt
#ifdef USE_DDOT
       real(kind=DP) :: ddot
#endif
       integer :: id_sname=-1
       call tstatc0_begin('betar_dot_Psi_atm_band_pre ',id_sname,level=1)
       fac = dsqrt(univol)/dble(fft_box_size_WF(1,1)*fft_box_size_WF(2,1)*fft_box_size_WF(3,1))
       nma = nmesh_rs(iatm)
       it = ityp(iatm)
#ifdef MULT_PHASE_RSPACE
       cosa = cos_a(iatm)
       sina = sin_a(iatm)
#endif
       allocate(cos_krt(nma));cos_krt(:) = cos_kr(:,iatm)
       allocate(sin_krt(nma));sin_krt(:) = sin_kr(:,iatm)
!       do ib=ib1,ib2
       do ib=1,ib2
       if(kimg==1)then
          do i=1,nma
             imesh   = 2*meshxyz_rs(i,iatm)
#ifdef MULT_PHASE_RSPACE
             psr = bff(imesh-1,ib)
             psi = bff(imesh,ib)*meshxyz_rs_conjg(i,iatm)
             rr = psr*cosa-psi*sina
             ii = psi*cosa+psr*sina
#else
             rr = bff(imesh-1,ib)
             ii = bff(imesh,ib)*meshxyz_rs_conjg(i,iatm)
#endif
             rrr(i,ib) = rr*cos_krt(i)-ii*sin_krt(i) 
             iii(i,ib) = ii*cos_krt(i)+rr*sin_krt(i)
          enddo
       else
          do i=1,nma
             imesh   = 2*meshxyz_rs(i,iatm)
#ifdef MULT_PHASE_RSPACE
             psr = bff(imesh-1,ib)
             psi = bff(imesh,ib)
             rr = psr*cosa-psi*sina
             ii = psi*cosa+psr*sina
#else
             rr = bff(imesh-1,ib)
             ii = bff(imesh,ib)
#endif
             rrr(i,ib) = rr*cos_krt(i)-ii*sin_krt(i) 
             iii(i,ib) = ii*cos_krt(i)+rr*sin_krt(i)
          enddo
       endif
       enddo
       deallocate(cos_krt,sin_krt)
       call tstatc0_end(id_sname)
    end subroutine betar_dot_Psi_atm_band_pre

    subroutine betar_dot_Psi_atm_band(iatm)
       integer,intent(in) :: iatm
       integer :: lmt1,i,lmta1,imesh,nma,it,ib,iband
       real(kind=DP) :: s,bpr,bpi
       real(kind=DP) :: fac,cosa,sina,rr,ii,psr,psi
#ifdef USE_DDOT
       real(kind=DP) :: ddot
#endif
       integer :: id_sname=-1
       call tstatc0_begin('betar_dot_Psi_atm_band ',id_sname,level=1)
       fac = dsqrt(univol)/dble(fft_box_size_WF(1,1)*fft_box_size_WF(2,1)*fft_box_size_WF(3,1))
       nma = nmesh_rs(iatm)
       it = ityp(iatm)
#ifdef NO_DGEMM_RSPACE
       do ib=1,ib2
          iband = ib+ib1-1
          do lmt1=1,ilmt(it)
             lmta1 = lmta(lmt1,iatm)
#ifdef USE_DDOT
             bprt(iband,lmta1) = fac*ddot(nma,snlsnl(1:nma,lmta1),1,rrr(1:nma,ib),1)
#else
             bprt(iband,lmta1) = fac*dot_product(snlsnl(1:nma,lmta1),rrr(1:nma,ib))
#endif
          enddo
       enddo
#else
       call dgemm('T','N',ib2,ilmt(it),nma,fac,rrr,nmesh_rs_max,snlsnl(1:nma,lmta(1,iatm)) &
                     ,nmesh_rs_max,0.d0,bprt(ib1,lmta(1,iatm)),np_e)
#endif
       if(k_symmetry(ik) /= GAMMA)then
#ifdef NO_DGEMM_RSPACE
       do ib=1,ib2
          iband = ib+ib1-1
          do lmt1=1,ilmt(it)
             lmta1 = lmta(lmt1,iatm)
#ifdef USE_DDOT
             bpit(iband,lmta1) = fac*ddot(nma,snlsnl(1:nma,lmta1),1,iii(1:nma,ib),1)
#else
             bpit(iband,lmta1) = fac*dot_product(snlsnl(1:nma,lmta1),iii(1:nma,ib))
#endif
          enddo
       enddo
#else
       call dgemm('T','N',ib2,ilmt(it),nma,fac,iii,nmesh_rs_max,snlsnl(1:nma,lmta(1,iatm)) &
                     ,nmesh_rs_max,0.d0,bpit(ib1,lmta(1,iatm)),np_e)
#endif
       endif
       call tstatc0_end(id_sname)
    end subroutine betar_dot_Psi_atm_band

  end subroutine betar_dot_Psi_4_each_k_in_rs0

  subroutine Vnonlocal_W_in_realspace(ik,ispin,switch_of_eko_part)
    use m_Electronic_Structure, only : m_ES_gather_f_3d_to_2d
    integer, intent(in) :: ik,ispin
    integer, intent(in) :: switch_of_eko_part
    integer :: mdvdb, it, ia, lmt2, lmta2, il2, im2,nma
    real(kind=DP),allocatable,dimension(:,:) :: vnlr1d,vnli1d
    real(kind=DP),allocatable,dimension(:) :: sc,qc
    real(kind=DP),allocatable,dimension(:,:) :: sc_lmta,qc_lmta
    real(kind=DP),allocatable,dimension(:,:) :: cos_kr,sin_kr
#ifdef MULT_PHASE_RSPACE
    real(kind=DP),allocatable,dimension(:) :: cos_a,sin_a
#endif
    real(kind=DP),allocatable,dimension(:,:) :: bff
    real(kind=DP),allocatable,dimension(:,:) :: bffb,fsrt,fsit
    integer :: ib,ierr,ii,ib2
    integer :: ibl1,ibl2,nbsize,ibsize
    integer :: id_sname = -1,id_sname2=-1,id_sname3=-1
    call tstatc0_begin('Vnonlocal_W_in_realspace ',id_sname,level=1)
    do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(switch_of_eko_part == OFF) mdvdb= SKIP
       if(mdvdb == EXECUT) exit
    end do
    
    ibsize = nblocksize_rspace_v
    if(ibsize<1) ibsize = 1
    if(ibsize>np_e) ibsize = np_e
    call alloc_arrays()
    call m_ES_gather_f_3d_to_2d(fsr_l, fsrt, ik)
    if(k_symmetry(ik) /= GAMMA) then
      call m_ES_gather_f_3d_to_2d(fsi_l, fsit, ik)
    endif
    call k_dot_r(ik,cos_kr,sin_kr)
#ifdef MULT_PHASE_RSPACE
    call k_dot_pos(ik,cos_a,sin_a)
#endif
    Loop_natm0: do ia=ista_atm,iend_atm
       if(kimg==1)then
          nma = nmesh_rs_h(ia)
       else
          nma = nmesh_rs(ia)
       endif
       it = ityp(ia)
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(switch_of_eko_part == OFF) mdvdb= SKIP
       do lmt2 = 1, ilmt(it)
          lmta2 = lmta(lmt2,ia)
          il2   = ltp(lmt2,it)
          im2   = mtp(lmt2,it)
          call part_sum_over_lmt1_rs()
       enddo
    end do Loop_natm0

    do ib=1,np_e,ibsize
       bff=0.d0
       ib2 = min(ibsize,np_e+1-ib)
       Loop_natm1: do ia=ista_atm,iend_atm
          it = ityp(ia)
          mdvdb = m_PP_include_vanderbilt_pot(it)
          if(switch_of_eko_part == OFF) mdvdb= SKIP
          vnlr1d = 0.d0
          vnli1d = 0.d0
          if(kimg==1)then
             nma = nmesh_rs_h(ia)
          else
             nma = nmesh_rs(ia)
          endif
          if(mdvdb==SKIP)then
             call add_vnlph_l_without_eko_part_rs()
          else
             call add_vnlph_l_with_eko_part_rs()
          endif
          call multiply_phase()
          call map_vnl_to_bff()
       end do Loop_natm1
       if(nrank_g>1)then
         call mpi_allreduce(mpi_in_place,bff,nfft*ibsize,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
       endif
       call Vnonlocal_W_to_Gspace()
    enddo
    call dealloc_arrays()

    call tstatc0_end(id_sname)

    contains

    subroutine alloc_arrays()
       integer :: nmm
       nmm = nmesh_rs_max
       if(kimg==1) nmm = nmesh_rs_max_h
       allocate(vnlr1d(nmm,ibsize));vnlr1d=0.d0
       allocate(vnli1d(nmm,ibsize));vnli1d=0.d0
       allocate(sc_lmta(nmm,nlmta));sc_lmta=0.d0
       if(mdvdb==EXECUT)then
          allocate(qc_lmta(nmm,nlmta));qc_lmta=0.d0
       endif
       allocate(cos_kr(nmesh_rs_max,natm));cos_kr=0.d0
       allocate(sin_kr(nmesh_rs_max,natm));sin_kr=0.d0
#ifdef MULT_PHASE_RSPACE
       allocate(cos_a(natm));cos_a=0.d0
       allocate(sin_a(natm));sin_a=0.d0
#endif
       if(sw_save_memory==ON)then
          allocate(bff(nfft,ibsize));bff=0.d0
       else
          allocate(bffb(nfft,np_e));bffb=0.d0
       endif
       allocate(fsrt(np_e,nlmta));fsrt=0.d0
       allocate(fsit(np_e,nlmta));fsit=0.d0
    end subroutine alloc_arrays

    subroutine dealloc_arrays()
       deallocate(vnlr1d)
       deallocate(vnli1d)
       deallocate(sc_lmta)
       if(allocated(qc_lmta)) deallocate(qc_lmta)
       deallocate(bff)
       deallocate(cos_kr)
       deallocate(sin_kr)
#ifdef MULT_PHASE_RSPACE
       deallocate(cos_a)
       deallocate(sin_a)
#endif
       deallocate(fsrt)
       deallocate(fsit)
    end subroutine dealloc_arrays

    subroutine part_sum_over_lmt1_rs()
       integer       :: lmta1,lmt1, il1, im1, i
       real(kind=DP) :: tmp,rr,ii
       real(kind=DP),pointer,dimension(:,:) :: snlt
       integer :: id_sname = -1
       call tstatc0_begin('part_sum_over_lmt1_rs ',id_sname,level=1)
       if(sw_save_memory/=ON)then
          sc = 0.d0
          if(mdvdb == EXECUT) then
             qc = 0.d0
          endif
       else
          sc_lmta(:,lmta2) = 0.d0
          if(mdvdb == EXECUT) then
             qc_lmta(:,lmta2) = 0.d0
          endif
       endif
       if(kimg==1)then
          snlt => snl_rs_h
       else
          snlt => snl_rs
       endif
       do lmt1 = 1,ilmt(it)
          lmta1 = lmta(lmt1,ia)
          il1   = ltp(lmt1,it)
          im1   = mtp(lmt1,it)
          if(il1 == il2 .and. im1 == im2) then
             if(ipaw(it)==0) then
                 tmp = dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)
             else
                 tmp = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
             end if
          else
             if(ipaw(it)==0) then
                 tmp = vlhxcQ(lmt1,lmt2,ia,ispin)
             else
                 tmp = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
             end if
          endif
          do i=1,nma
             sc_lmta(i,lmta2) = sc_lmta(i,lmta2)+tmp*snlt(i,lmta1)
          enddo
          if(mdvdb == EXECUT .and. il1 == il2 .and. im1 == im2) then
             tmp = q(lmt1,lmt2,it)
             do i=1,nma
                qc_lmta(i,lmta2) = qc_lmta(i,lmta2) + tmp*snlt(i,lmta1)
             enddo
          end if
       end do

       call tstatc0_end(id_sname)
    end subroutine part_sum_over_lmt1_rs

    subroutine add_vnlph_l_with_eko_part_rs()
       integer :: i,iband,ib1,nmm
       real(kind=DP) :: fr,fi,e
       real(kind=DP), allocatable, dimension(:,:) :: fre,fie
       integer :: id_sname = -1
       call tstatc0_begin('add_vnlph_l_with_eko_part_rs ',id_sname,level=1)
#ifdef NO_DGEMM_RSPACE
       do ib1=1,ib2
       iband = ib+ib1-1
       do lmt2 = 1, ilmt(it)
          lmta2 = lmta(lmt2,ia)
          fr = fsrt(iband,lmta2)
          e = eko_l(iband,ik)
          do i=1,nma
             vnlr1d(i,ib1) = vnlr1d(i,ib1)+fr*(sc_lmta(i,lmta2)-e*qc_lmta(i,lmta2))
          enddo
          if(k_symmetry(ik)/=GAMMA) then
             fi = fsit(iband,lmta2)
             do i=1,nma
                vnli1d(i,ib1) = vnli1d(i,ib1)+fi*(sc_lmta(i,lmta2)-e*qc_lmta(i,lmta2))
             enddo
          endif
       enddo
       enddo
#else
       nmm = nmesh_rs_max
       if(kimg==1) nmm = nmesh_rs_max_h
       allocate(fre(ib2,ilmt(it)));fre=0.d0
       if(k_symmetry(ik) /= GAMMA) allocate(fie(ib2,ilmt(it)));fie=0.d0
       do ib1=1,ib2
          iband = ib+ib1-1
          do lmt2 = 1, ilmt(it)
             lmta2 = lmta(lmt2,ia)
             fre(ib1,lmt2) = -fsrt(iband,lmta2)*eko_l(iband,ik)
             if(k_symmetry(ik) /= GAMMA) fie(ib1,lmt2) = -fsit(iband,lmta2)*eko_l(iband,ik)
          enddo
       enddo
       call dgemm('N','T',nma,ib2,ilmt(it),1.d0,sc_lmta(1,lmta(1,ia)),nmesh_rs_max &
                     , fsrt(ib,lmta(1,ia)),np_e,0.d0,vnlr1d,nmm)
       call dgemm('N','T',nma,ib2,ilmt(it),1.d0,qc_lmta(1,lmta(1,ia)),nmesh_rs_max &
                     , fre,ib2,1.d0,vnlr1d,nmm)
       deallocate(fre)
       if(k_symmetry(ik) /= GAMMA) then
          call dgemm('N','T',nma,ib2,ilmt(it),1.d0,sc_lmta(1,lmta(1,ia)),nmesh_rs_max &
                     , fsit(ib,lmta(1,ia)),np_e,0.d0,vnli1d,nmm)
          call dgemm('N','T',nma,ib2,ilmt(it),1.d0,qc_lmta(1,lmta(1,ia)),nmesh_rs_max &
                     , fie,ib2,1.d0,vnli1d,nmm)
          deallocate(fie)
       endif
#endif
       call tstatc0_end(id_sname)
    end subroutine add_vnlph_l_with_eko_part_rs

    subroutine add_vnlph_l_without_eko_part_rs()
       real(kind=DP) :: fr,fi
       integer :: i,iband,ib1,nmm
       integer :: id_sname = -1
       call tstatc0_begin('add_vnlph_l_without_eko_part_rs ',id_sname,level=1)
#ifdef NO_DGEMM_RSPACE
       do ib1=1,ib2
       iband = ib1+ib-1
       do lmt2 = 1, ilmt(it)
          lmta2 = lmta(lmt2,ia)
          fr = fsrt(iband,lmta2)
          do i=1,nma
             vnlr1d(i,ib1) = vnlr1d(i,ib1)+fr*sc_lmta(i,lmta2)
          enddo
          if(k_symmetry(ik)/=GAMMA) then
             fi = fsit(iband,lmta2)
             do i=1,nma
                vnli1d(i,ib1) = vnli1d(i,ib1)+fi*sc_lmta(i,lmta2)
             enddo
          endif
       enddo
       enddo
#else
       nmm = nmesh_rs_max
       if(kimg==1) nmm = nmesh_rs_max_h
       call dgemm('N','T',nma,ib2,ilmt(it),1.d0,sc_lmta(1,lmta(1,ia)),nmesh_rs_max &
                     , fsrt(ib,lmta(1,ia)),np_e,0.d0,vnlr1d,nmm)
       if(k_symmetry(ik) /= GAMMA) then
          call dgemm('N','T',nma,ib2,ilmt(it),1.d0,sc_lmta(1,lmta(1,ia)),nmesh_rs_max &
                     , fsit(ib,lmta(1,ia)),np_e,0.d0,vnli1d,nmm)
       endif
#endif
       call tstatc0_end(id_sname)
    end subroutine add_vnlph_l_without_eko_part_rs

    subroutine multiply_phase()
       integer :: i,iband,ib1
       real(kind=DP) :: rr,ii
       real(kind=DP) :: cosa,sina,fac
       integer :: id_sname = -1
       call tstatc0_begin('multiply_phase ',id_sname,level=1)
       fac = dsqrt(univol)/dble(fft_box_size_WF(1,1)*fft_box_size_WF(2,1)*fft_box_size_WF(3,1))
#ifdef MULT_PHASE_RSPACE
       cosa =  cos_a(ia)
       sina = -sin_a(ia)
#endif

       if(kimg==1)then
          do ib1=1,ib2
          do i=1,nma
#ifdef MULT_PHASE_RSPACE
             rr = cosa*vnlr1d(i,ib1)-sina*vnli1d(i,ib1)
             ii = sina*vnlr1d(i,ib1)+cosa*vnli1d(i,ib1)
#else
             rr = vnlr1d(i,ib1)
             ii = vnli1d(i,ib1)
#endif
             vnlr1d(i,ib1) = (rr*cos_kr(map_h(i,ia),ia)+ii*sin_kr(map_h(i,ia),ia))*fac
             vnli1d(i,ib1) = (ii*cos_kr(map_h(i,ia),ia)-rr*sin_kr(map_h(i,ia),ia))*fac
          enddo
          enddo
       else
          do ib1=1,ib2
          do i=1,nma
#ifdef MULT_PHASE_RSPACE
             rr = cosa*vnlr1d(i,ib1)-sina*vnli1d(i,ib1)
             ii = sina*vnlr1d(i,ib1)+cosa*vnli1d(i,ib1)
#else
             rr = vnlr1d(i,ib1)
             ii = vnli1d(i,ib1)
#endif
             vnlr1d(i,ib1) = (rr*cos_kr(i,ia)+ii*sin_kr(i,ia))*fac
             vnli1d(i,ib1) = (ii*cos_kr(i,ia)-rr*sin_kr(i,ia))*fac
          enddo
          enddo
       endif
       call tstatc0_end(id_sname)
    end subroutine multiply_phase

    subroutine map_vnl_to_bff()
       integer :: i,i1,iband,ib1
       integer :: id_sname=-1
       call tstatc0_begin('map_vnl_to_bff ',id_sname,level=1)
       if(kimg==1)then 
          do ib1=1,ib2
          do i=1,nma
             i1 = 2*meshxyz_rs_h(i,ia)
             bff(i1-1,ib1) = bff(i1-1,ib1) + vnlr1d(i,ib1)
             bff(i1,ib1)   = bff(i1,ib1)   - vnli1d(i,ib1)
          enddo
          enddo
       else
          do ib1=1,ib2
          do i=1,nma
             i1 = 2*meshxyz_rs(i,ia)
             bff(i1-1,ib1) = bff(i1-1,ib1) + vnlr1d(i,ib1)
             bff(i1,ib1)   = bff(i1,ib1)   + vnli1d(i,ib1)
          enddo
          enddo
       endif
       call tstatc0_end(id_sname)
    end subroutine map_vnl_to_bff

    subroutine Vnonlocal_W_to_Gspace()
       integer :: i,i1,ri,iband,ib1
       integer :: id_sname = -1
       call tstatc0_begin('Vnonlocal_W_to_Gspace ',id_sname)
       do ib1=1,ib2
       iband = ib1+ib-1
       vnlph_l(:,iband,:) = 0.d0
       call m_FFT_WF(ELECTRON,nfout,bff(1:nfft,ib1),DIRECT,ON)
       do ri=1,kimg
          do i=ista_g1k(ik),iend_g1k(ik)
             i1 = kimg*igf(nbase(i,ik)) + (ri - kimg)
             vnlph_l(i-ista_g1k(ik)+1,iband,ri) = bff(i1,ib1)
          enddo
       enddo
       enddo
       call tstatc0_end(id_sname)
    end subroutine Vnonlocal_W_to_Gspace

  end subroutine Vnonlocal_W_in_realspace

  subroutine k_dot_r(ik,zc_ar,zs_ar)
    integer, intent(in) :: ik
    real(kind=DP),dimension(nmesh_rs_max,natm),intent(out) :: zc_ar,zs_ar
    integer :: ia,i
    real(kind=DP) :: inl,inm,inn
    real(kind=DP) :: rx,ry,rz,kdr
    integer :: id_sname = -1
    call tstatc0_begin('k_dot_r ',id_sname,level=1)
    inl = 1.d0/dble(fft_box_size_WF(1,1))
    inm = 1.d0/dble(fft_box_size_WF(2,1))
    inn = 1.d0/dble(fft_box_size_WF(3,1))
    do ia=ista_atm,iend_atm
       do i=1,nmesh_rs(ia)
          rx = dble(meshx_rs(i,ia))*inl
          ry = dble(meshy_rs(i,ia))*inm
          rz = dble(meshz_rs(i,ia))*inn
          kdr = (rx*vkxyz(ik,1,BUCS)+ry*vkxyz(ik,2,BUCS)+rz*vkxyz(ik,3,BUCS))*PAI2
          zc_ar(i,ia) = dcos(kdr)
          zs_ar(i,ia) = dsin(kdr)
       enddo
    enddo
  end subroutine k_dot_r

#ifdef MULT_PHASE_RSPACE
  subroutine k_dot_pos(ik,zc,zs)
    integer, intent(in) :: ik
    real(kind=DP),dimension(natm),intent(out) :: zc,zs
    real(kind=DP) :: kdp
    integer :: ia
    do ia=1,natm
       kdp = (pos(ia,1)*vkxyz(ik,1,BUCS)+pos(ia,2)*vkxyz(ik,2,BUCS)+pos(ia,3)*vkxyz(ik,3,BUCS))*PAI2
       zc(ia) =  dcos(kdp)
       zs(ia) = -dsin(kdp)
    enddo
  end subroutine k_dot_pos

#endif

end module m_ES_nonlocal

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 570 $)
!
!  SUBROUINE: Forces
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
subroutine Forces
! $Id: Forces_ep.f90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Control_Parameters, only : m_CtrlP_what_is_mdalg
  use m_Force,              only : forc_l, m_Force_stlweb
  use m_Ionic_System,       only : m_IS_evaluate_v_verlet
  implicit none
  integer :: mdalg

  call m_Force_stlweb()
  mdalg = m_CtrlP_what_is_mdalg()
  call m_IS_evaluate_v_verlet(mdalg,forc_l)
end subroutine Forces

module m_SpinOrbit_Potential
! $Id: m_SpinOrbit_Potential.F90 593 2019-06-20 03:47:31Z jkoga $
  use m_Control_Parameters,  only : noncol, ndim_spinor, ndim_chgpot, proj_attribute
  use m_Const_Parameters,    only : DP, CMPLDP, zi, ON
  use m_PseudoPotential,     only : nlmt, ltp, mtp, taup, prodphi, nlmta, ilmt, &
       &                            nloc, ntau
  use m_Ionic_System,        only : natm, itab_spinorbit_addition, ityp

! == KT_add === 13.2S
  use m_Crystal_Structure,  only : sw_fix_global_quantz_axis,  &
       &                           Global_Quantz_Axis_Fixed, &
       &                           sw_spinorbit_force_theorem
  use m_Files,  only : nfout
! ============= 13.2S

  implicit none
  include 'mpif.h'

! -----------------------------------
  complex(kind=CMPLDP) MatU_ylm_RC_L0( 2*0+1, -0:0 )
  complex(kind=CMPLDP) MatU_ylm_RC_L1( 2*1+1, -1:1 )
  complex(kind=CMPLDP) MatU_ylm_RC_L2( 2*2+1, -2:2 )
  complex(kind=CMPLDP) MatU_ylm_RC_L3( 2*3+1, -3:3 )
  complex(kind=CMPLDP) MatU_ylm_RC_L4( 2*4+1, -4:4 )
!
  complex(kind=CMPLDP) :: Mat_LS_with_cmplx_ylm_L0(  0:0, 0:0, 4 )
  complex(kind=CMPLDP) :: Mat_LS_with_cmplx_ylm_L1( -1:1,-1:1, 4 )
  complex(kind=CMPLDP) :: Mat_LS_with_cmplx_ylm_L2( -2:2,-2:2, 4 )
  complex(kind=CMPLDP) :: Mat_LS_with_cmplx_ylm_L3( -3:3,-3:3, 4 )
!
  complex(kind=CMPLDP) :: Mat_LS_with_real_ylm_L0( 1, 1, 4 )
  complex(kind=CMPLDP) :: Mat_LS_with_real_ylm_L1( 3, 3, 4 )
  complex(kind=CMPLDP) :: Mat_LS_with_real_ylm_L2( 5, 5, 4 )
  complex(kind=CMPLDP) :: Mat_LS_with_real_ylm_L3( 7, 7, 4 )
! -----------------------------------
  complex(kind=CMPLDP) :: EigenWfns_MatLS_L0( 1*2,1*2 )
  complex(kind=CMPLDP) :: EigenWfns_MatLS_L1( 3*2,3*2 )
  complex(kind=CMPLDP) :: EigenWfns_MatLS_L2( 5*2,5*2 )
  complex(kind=CMPLDP) :: EigenWfns_MatLS_L3( 7*2,7*2 )
! -----------------------------------
  real(kind=DP) :: EigenVals_MatLS_L0( 1*2 )
  real(kind=DP) :: EigenVals_MatLS_L1( 3*2 )
  real(kind=DP) :: EigenVals_MatLS_L2( 5*2 )
  real(kind=DP) :: EigenVals_MatLS_L3( 7*2 )
! -----
!
  Complex(kind=CMPLDP), allocatable  :: dsoc(:,:,:,:)

  real(kind=DP), allocatable :: Mat_SOC_Strength(:,:,:,:)

contains

! ============================================================
!!
!!!  Allocate and deallocate arrays
!!
!===============================================================-
  subroutine m_SO_alloc_Dsoc
    if (nlmt <= 0) stop ' nlmt <=  0 (in m_ES_alloc_Dsoc)'
    allocate( dsoc(nlmt,nlmt,natm,ndim_chgpot )); dsoc = 0.d0
  end subroutine m_SO_alloc_Dsoc

  subroutine m_SO_dealloc_Dsoc
    if (allocated(dsoc)) deallocate(dsoc)
  end subroutine m_SO_dealloc_Dsoc
  
  subroutine m_SO_alloc_Mat_SOC_Strenth
    allocate( Mat_SOC_Strength(nloc,ntau,ntau,natm) )
    Mat_SOC_Strength = 0.0d0
  end subroutine m_SO_alloc_Mat_SOC_Strenth

  subroutine m_SO_dealloc_Mat_SOC_Strenth
    if ( allocated( Mat_SOC_Strength) ) deallocate( Mat_SOC_Strength )
  end subroutine m_SO_dealloc_Mat_SOC_Strenth

! ========================================================================
!!
!!!   calc < Ylm Chi_s | L.S | Chi_s' Ylm' >, where Ylm is real spherical harmonics
!!
!=========================================================================
  subroutine m_SO_calc_MatLS_orb_s_to_f
    real(kind=DP) :: theta, phi
    
    theta = 0.0; phi = 0.0d0

    if ( noncol ) then
    else 
       if ( sw_spinorbit_force_theorem == ON &
            &     .and. sw_fix_global_quantz_axis == ON ) then
          theta = acos( Global_Quantz_Axis_Fixed(3))
          phi = atan2( Global_Quantz_Axis_Fixed(2), Global_Quantz_Axis_Fixed(1) )
!          write(nfout,*) "theta = ", theta, phi
       endif
    endif

    call m_SO_calc_MatLS_with_Cmplx_ylm( 0, theta, phi, &
         &                               Mat_LS_with_cmplx_ylm_L0 )
    call m_SO_calc_MatLS_with_Real_ylm( 0, MatU_ylm_RC_L0, &
         &                              Mat_LS_with_cmplx_ylm_L0, &
         &                              Mat_LS_with_real_ylm_L0 )
!
    call m_SO_calc_MatLS_with_Cmplx_ylm( 1, theta, phi, &
         &                               Mat_LS_with_cmplx_ylm_L1 )
    call m_SO_calc_MatLS_with_Real_ylm( 1, MatU_ylm_RC_L1, &
         &                              Mat_LS_with_cmplx_ylm_L1, &
         &                              Mat_LS_with_real_ylm_L1 )
!
    call m_SO_calc_MatLS_with_Cmplx_ylm( 2, theta, phi, &
         &                               Mat_LS_with_cmplx_ylm_L2 )
    call m_SO_calc_MatLS_with_Real_ylm( 2, MatU_ylm_RC_L2, &
         &                              Mat_LS_with_cmplx_ylm_L2, &
         &                              Mat_LS_with_real_ylm_L2 )
!
    call m_SO_calc_MatLS_with_Cmplx_ylm( 3, theta, phi, &
         &                            Mat_LS_with_cmplx_ylm_L3 )
    call m_SO_calc_MatLS_with_Real_ylm( 3, MatU_ylm_RC_L3, &
         &                              Mat_LS_with_cmplx_ylm_L3, &
         &                              Mat_LS_with_real_ylm_L3 )
  end subroutine m_SO_calc_MatLS_orb_s_to_f

  subroutine m_SO_diagonalize_MatLS
    integer :: my_l, lwork, info
    integer :: nsize, nsize0
    real(kind=DP), allocatable :: rwork(:), MatW(:)
    complex(kind=CMPLDP), allocatable :: work(:), MatA(:,:)

    Do my_l = 1, 3                 ! p-orbital to f-orbital
       nsize0 = 2 *my_l + 1
       nsize = nsize0 *ndim_spinor

       allocate( MatA( nsize, nsize ) ); allocate( MatW( nsize ) )
       MatA = 0.0d0

       call set_Mat_A( my_l )

       lwork = max( 1, 2*nsize -1 )
       allocate( rwork( max( 1, 3*nsize -2 ) )); rwork = 0.0d0
       allocate( work(  max( 1, lwork ) )); work = 0.0d0
!
       call zheev( 'V', 'U', nsize, MatA, nsize, MatW, &
            &       work, lwork, rwork, info )
!
       if ( my_l == 1 ) EigenVals_MatLS_L1 = MatW
       if ( my_l == 2 ) EigenVals_MatLS_L2 = MatW
       if ( my_l == 3 ) EigenVals_MatLS_L3 = MatW

!       Do m1=1, nsize
!          write(*,*) 'Eigen Val m1 ', m1, MatW(m1)
!          Do m2=1, nsize
!             write(*,*) m2, m1, MatA( m2,m1 )
!          End do
!       End do

       call get_eigenwfns_with_real_ylm( my_l )
       deallocate( rwork, work, MatA, MatW )

    End Do
! --
    EigenWfns_MatLS_L0(1,1) = 1.0d0;      EigenWfns_MatLS_L0(2,2) = 1.0d0
!    
  contains

    subroutine get_eigenwfns_with_real_ylm( my_l )
      integer, intent(in) :: my_l
      integer :: m1, m2, ma
      integer :: is1
      complex(kind=CMPLDP) :: z1

      Do m2=1, nsize
         Do is1=1, ndim_spinor
            Do m1=1, 2*my_l +1
               z1 = 0.0d0
               if ( my_l == 1 ) then
                  Do ma=-my_l, my_l
                     z1 = z1 +  MatU_ylm_RC_L1( m1, ma )  &
                          &    *MatA( nsize0*(is1-1)+ma+my_l +1, m2 )
                  End do
                  EigenWfns_MatLS_L1( nsize0*(is1-1) +m1, m2 ) = z1
               else if ( my_l == 2 ) then
                  Do ma=-my_l, my_l
                     z1 = z1 + MatU_ylm_RC_L2( m1, ma ) &
                          &    *MatA( nsize0*(is1-1)+ma+my_l +1, m2 )
                  End do
                  EigenWfns_MatLS_L2( nsize0*(is1-1) +m1, m2 ) = z1
               else if ( my_l == 3 ) then
                  Do ma=-my_l, my_l
                     z1 = z1 + MatU_ylm_RC_L3( m1,ma ) &
                          &    *MatA( nsize0*(is1-1)+ma+my_l +1, m2 )
                  End do
                  EigenWfns_MatLS_L3( nsize0*(is1-1) +m1, m2 ) = z1
               endif
            End do
         End do
      End Do
    end subroutine get_eigenwfns_with_real_ylm

    subroutine set_mat_A( my_l )
      integer, intent(in) :: my_l

      integer :: is1, is2, istmp
      integer :: m1, m2

      Do is1=1, ndim_spinor
         Do is2=1, ndim_spinor
            istmp = ( is1 -1 )*ndim_spinor + is2
            Do m1=1, nsize0
               Do m2=1, nsize0
                  
                  if ( my_l == 1 ) then
                     MatA( nsize0*(is1-1)+m1, nsize0*(is2-1)+m2 ) &
                          &    = Mat_LS_with_cmplx_ylm_L1( m1-my_l-1,m2-my_l-1,istmp )
                  else if ( my_l == 2 ) then
                     MatA( nsize0*(is1-1)+m1, nsize0*(is2-1)+m2 ) &
                          &    = Mat_LS_with_cmplx_ylm_L2( m1-my_l-1,m2-my_l-1,istmp )
                  else if ( my_l == 3 ) then
                     MatA( nsize0*(is1-1)+m1, nsize0*(is2-1)+m2 ) &
                          &    = Mat_LS_with_cmplx_ylm_L3( m1-my_l-1,m2-my_l-1,istmp )
                  endif
               End Do
            End Do
         End Do
      End do
    end subroutine set_mat_A

  end subroutine m_SO_diagonalize_MatLS

! ===================================================================
!!
!!!  set array "dsoc", zeta *< Ylm Chi_s | L.S | Chi_s' Ylm' > 
!!
!===================================================================
  subroutine m_SO_set_Dsoc_potential1     ! Dsoc  is hermitian.

    if ( noncol ) then
       call goto_noncollinear
    else
       stop 'Not supported: Spin-Orbit potential in the collinear case'
    end if

  contains 
    
    subroutine goto_noncollinear
      integer :: ia, ih, it, il, is
      integer :: iyy, ilmt1, ilmt2
      integer :: l1, l2, m1, m2, t1, t2

      real(kind=DP) :: LScoupling
      Complex(kind=CMPLDP) :: z1

      dsoc = 0.d0

      Do ia=1, natm
         ih = itab_spinorbit_addition(ia)
         if (ih == 0) cycle

         LScoupling = proj_attribute(ih)%LScoupling0 &
              &      *proj_attribute(ih)%LScoupling_scaling_factor

         it = proj_attribute(ih)%ityp
         il = proj_attribute(ih)%l
!
         Do ilmt1=1, ilmt(it)
            Do ilmt2=1, ilmt(it)
               l1 = ltp(ilmt1,it);  m1 = mtp(ilmt1,it);  t1 = taup(ilmt1,it)
               l2 = ltp(ilmt2,it);  m2 = mtp(ilmt2,it);  t2 = taup(ilmt2,it)

!!               if ( t1 /= 1 .or. t2 /= 1 ) cycle
!               if ( t1 /= t2 ) cycle

               if ( l1 == il+1 .and. l2 == l1 ) then

                  Do is=1, ndim_chgpot
                     if ( il == 0 ) then
                        z1 = Mat_LS_with_real_ylm_L0( m1, m2, is )
                     else if ( il == 1 ) then
                        z1 = Mat_LS_with_real_ylm_L1( m1, m2, is )
                     else if ( il == 2 ) then
                        z1 = Mat_LS_with_real_ylm_L2( m1, m2, is )
                     else if ( il == 3 ) then
                        z1 = Mat_LS_with_real_ylm_L3( m1, m2, is )
                     endif
                     dsoc( ilmt1,ilmt2, ia, is ) &
                          &   = LScoupling *prodphi( ih, t1, t2 ) *z1

!                     write(854,*) ilmt1, ilmt2, ia, is, dsoc( ilmt1, ilmt2, ia, is)
!                     write(855,*) ilmt1, ilmt2, ia, is, z1
                  End do
               endif
            End do
         End do
      End do

!      stop 'IIIIIIIIIIIII '

    end subroutine goto_noncollinear

  end subroutine m_SO_set_Dsoc_potential1

  subroutine m_SO_set_Dsoc_potential2
    integer :: ia, it
    integer :: ilmt1, ilmt2, l1, l2, t1, t2, m1, m2
    integer :: is, il
    complex(kind=CMPLDP) :: z1
    
    dsoc = 0.0d0
    
    Do ia=1, natm
       it = ityp(ia)
       
       Do ilmt1=1, ilmt(it)
          Do ilmt2=1, ilmt(it)
             l1 = ltp(ilmt1,it);  m1 = mtp(ilmt1,it);  t1 = taup(ilmt1,it)
             l2 = ltp(ilmt2,it);  m2 = mtp(ilmt2,it);  t2 = taup(ilmt2,it)
             
             if ( l1 /=l2  ) cycle
             il = l1 - 1
             
             Do is=1, ndim_chgpot
                if ( il == 0 ) then
                   z1 = Mat_LS_with_real_ylm_L0( m1, m2, is )
                else if ( il == 1 ) then
                   z1 = Mat_LS_with_real_ylm_L1( m1, m2, is )
                else if ( il == 2 ) then
                   z1 = Mat_LS_with_real_ylm_L2( m1, m2, is )
                else if ( il == 3 ) then
                   z1 = Mat_LS_with_real_ylm_L3( m1, m2, is )
                endif
                
                dsoc( ilmt1, ilmt2, ia, is ) &
                     &     = Mat_Soc_Strength( l1, t1, t2, ia ) *z1
             End do
          End do
       End Do
    End Do

  end subroutine m_SO_set_Dsoc_potential2

! ====================
!
!  calc < Ylm a | LS | Yl'm' b >
!
! =======================
  subroutine m_SO_calc_MatLS_with_Real_ylm( l_in, MatU_ylm_RC, &
       &                                    Mat_LS_with_cmplx_ylm, &
       &                                    Mat_LS_with_real_ylm )
    integer, intent(in) :: l_in
    Complex(kind=CMPLDP), intent(in) :: MatU_ylm_RC( 2*l_in+1, -l_in:l_in )
    complex(kind=CMPLDP), intent(in) :: &
         &    Mat_LS_with_cmplx_ylm( -l_in:l_in, -l_in:l_in, ndim_chgpot )
    complex(kind=CMPLDP), intent(out) :: &
         &    Mat_LS_with_real_ylm( 2*l_in+1, 2*l_in+1, ndim_chgpot )

    integer :: m_min, m_max
    !
    integer :: is
    integer :: m1, m2, ma, mb
!
    Complex(kind=CMPLDP) :: ztmp( ndim_chgpot )
    !
!
!    write(860,*) 'lin = ', l_in
!    write(860,*) Mat_LS_with_cmplx_ylm

    m_min = -l_in;  m_max = l_in
!
!    write(870,*) 'lin = ', l_in
!    Do m1=1, 2*l_in + 1
!       Do ma=m_min, m_max
!          write(870,*) m1, ma, MatU_ylm_RC( m1, ma )
!       End do
!    End do
!
    Do m1=1, 2 *l_in +1
       Do m2=1, 2 *l_in +1
          
          ztmp = 0.0d0
          
          Do ma = m_min, m_max
             Do mb = m_min, m_max
                Do is=1, ndim_chgpot
#if 0
                   ztmp(is) = ztmp(is) + conjg(MatU_ylm_RC( m1,ma ))&
                        &                *Mat_LS_with_cmplx_ylm( ma,mb,is ) &
                        &                *( MatU_ylm_RC( m2,mb ) )
#else
                   ztmp(is) = ztmp(is) + MatU_ylm_RC( m1,ma )&
                        &                *Mat_LS_with_cmplx_ylm( ma,mb,is ) &
                        &                *conjg( MatU_ylm_RC( m2,mb ) )
#endif

                End do
             End do
          End do
          Mat_LS_with_real_ylm( m1,m2,: ) = ztmp(:)
       End do
    End do
  end subroutine m_SO_calc_MatLS_with_Real_ylm
  
  subroutine m_SO_calc_MatLS_with_Cmplx_ylm( l_in, theta, phi, Mat_LS_term )
    integer, intent(in) :: l_in
    real(kind=DP), intent(in) :: theta, phi
    complex(kind=CMPLDP), intent(out) :: &
         &          Mat_LS_term( -l_in:l_in, -l_in:l_in, ndim_chgpot )
    
    real(kind=DP) :: cos_th, sin_th, cos2_th_h, sin2_th_h
    real(kind=DP) :: ctmp_m, ctmp_p, ctmp_0
    
    complex(kind=CMPLDP) :: zi_phi_p, zi_phi_m
    complex(kind=CMPLDP) :: ztmp1, ztmp2, ztmp3
    
    integer :: m1, m2
    
    cos_th = cos( theta );  sin_th = sin( theta )
    cos2_th_h = cos( theta/2.0d0 )**2
    sin2_th_h = 1.0d0 - cos2_th_h
    
    zi_phi_p = exp( zi*phi );    zi_phi_m = exp( -zi*phi )

    Do m1=-l_in, l_in
       Do m2=-l_in, l_in

          if ( m2 == m1 +1 ) then
             ctmp_m = sqrt( (l_in +m1 +1.0d0) *( l_in -m1 ) )
          else
             ctmp_m = 0.0d0
          endif

          if ( m2 == m1 -1 ) then
             ctmp_p = sqrt( (l_in -m1 +1.0d0) *( l_in +m1 ) )
          else
             ctmp_p = 0.0d0
          endif
          !
          if ( m1 == m2 ) then
             ctmp_0 = dble(m1)
          else
             ctmp_0 = 0.0d0
          endif

          !
          ztmp1 =  ctmp_0 *cos_th + ctmp_p *sin_th *zi_phi_m / 2.0d0 &
               &                  + ctmp_m *sin_th *zi_phi_p / 2.0d0 

          ztmp2 = -ctmp_0 *sin_th - ctmp_p *sin2_th_h *zi_phi_m &
               &                  + ctmp_m *cos2_th_h *zi_phi_p

          ztmp3 = -ctmp_0 *sin_th + ctmp_p *cos2_th_h *zi_phi_m &
               &                  - ctmp_m *sin2_th_h *zi_phi_p
          
          Mat_LS_term( m1,m2,1 ) =  ztmp1 /2.0d0         ! (11) component
          Mat_LS_term( m1,m2,4 ) = -ztmp1 /2.0d0         ! (22) 
          Mat_LS_term( m1,m2,2 ) =  ztmp2 /2.0d0         ! (12)
          Mat_LS_term( m1,m2,3 ) =  ztmp3 /2.0d0         ! (21)
       End do
    End Do
  end subroutine m_SO_calc_MatLS_with_Cmplx_ylm

! -------------------------------------
!
!            matrix U ( index1, index2 )  
!                           index1 : px, py, pz ....
!!                          index2 : -1, 0, 1 ....
!
!             px =  1/sqrt(2) [ |1,-1> - |1, 1> ]
!             py = zi/sqrt(2) [ |1,-1> + |1, 1> ]
!             pz =  1,0>
! ---------------------------------------
  subroutine m_SO_set_MatU_ylm_RC
    Real(kind=DP) :: ctmp
    Complex(kind=CMPLDP) :: ztmp
    !
    MatU_ylm_RC_L0 = 0.0d0
    MatU_ylm_RC_L1 = 0.0d0
    MatU_ylm_RC_L2 = 0.0d0
    MatU_ylm_RC_L3 = 0.0d0
    MatU_ylm_RC_L4 = 0.0d0
    ! -------
    ctmp = 1.0d0 / sqrt(2.0d0)

! ------------------------- ktDEBUG ------------ 2012/11/12
    ztmp = -ctmp * zi
!!    ztmp = ctmp * zi
! ------------------------- ktDEBUG ------------ 2012/11/12
    !
! s-orbital
    MatU_ylm_RC_L0(  1,0 ) = 1.0d0
! p-orbital
    MatU_ylm_RC_L1(  1,-1 ) =  ctmp;    MatU_ylm_RC_L1( 1,1 ) = -ctmp
    MatU_ylm_RC_L1(  2,-1 ) =  ztmp;    MatU_ylm_RC_L1( 2,1 ) =  ztmp
    MatU_ylm_RC_L1(  3, 0 ) = 1.0d0
! d-orbital
    MatU_ylm_RC_L2(  1, 0 ) = 1.0d0
    MatU_ylm_RC_L2(  2,-2 ) =  ctmp;    MatU_ylm_RC_L2( 2,2 ) =  ctmp
    MatU_ylm_RC_L2(  3,-2 ) =  ztmp;    MatU_ylm_RC_L2( 3,2 ) = -ztmp
    MatU_ylm_RC_L2(  4,-1 ) =  ztmp;    MatU_ylm_RC_L2( 4,1 ) =  ztmp
    MatU_ylm_RC_L2(  5,-1 ) =  ctmp;    MatU_ylm_RC_L2( 5,1 ) = -ctmp
! f-orbital
    MatU_ylm_RC_L3(  1, 0 ) = 1.0d0
    MatU_ylm_RC_L3(  2,-1 ) =  ctmp;   MatU_ylm_RC_L3( 2,1 ) = -ctmp
    MatU_ylm_RC_L3(  3,-1 ) =  ztmp;   MatU_ylm_RC_L3( 3,1 ) =  ztmp
    MatU_ylm_RC_L3(  4,-2 ) =  ctmp;   MatU_ylm_RC_L3( 4,2 ) =  ctmp
    MatU_ylm_RC_L3(  5,-2 ) =  ztmp;   MatU_ylm_RC_L3( 5,2 ) = -ztmp
    MatU_ylm_RC_L3(  6,-3 ) =  ctmp;   MatU_ylm_RC_L3( 6,3 ) = -ctmp
    MatU_ylm_RC_L3(  7,-3 ) =  ztmp;   MatU_ylm_RC_L3( 7,3 ) =  ztmp
! g-orbital
    MatU_ylm_RC_L4(  1, 0 ) = 1.0d0
    MatU_ylm_RC_L4(  2,-1 ) =  ctmp;   MatU_ylm_RC_L4( 2,1 ) = -ctmp
    MatU_ylm_RC_L4(  3,-1 ) =  ztmp;   MatU_ylm_RC_L4( 3,1 ) =  ztmp
    MatU_ylm_RC_L4(  4,-2 ) =  ctmp;   MatU_ylm_RC_L4( 4,2 ) =  ctmp
    MatU_ylm_RC_L4(  5,-2 ) =  ztmp;   MatU_ylm_RC_L4( 5,2 ) = -ztmp
    MatU_ylm_RC_L4(  6,-3 ) =  ctmp;   MatU_ylm_RC_L4( 6,3 ) = -ctmp
    MatU_ylm_RC_L4(  7,-3 ) =  ztmp;   MatU_ylm_RC_L4( 7,3 ) =  ztmp
    MatU_ylm_RC_L4(  8,-4 ) =  ctmp;   MatU_ylm_RC_L4( 8,4 ) =  ctmp
    MatU_ylm_RC_L4(  9,-4 ) =  ztmp;   MatU_ylm_RC_L4( 9,4 ) = -ztmp
  end subroutine m_SO_set_MatU_ylm_RC

end module m_SpinOrbit_Potential

#define VDW_ONESHOT_NEW

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 552 $)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  PROGRAM: vdW-Soler
!
!  AUTHOR(S): Y. Ono
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   The original version of this set of the computer programs "PHASE" was developed by 
!  the members of the Theory Group of Joint Research Center for Atom Technology 
!  (JRCAT), based in Tsukuba, in the period 1993-2001.  
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
#ifndef DISABLE_VDWDF
subroutine vdW_scf( nspin, ispin, nfft_div_size, na, nb, nc, chgr, grad_rho, ecnl, &
     &              dFdrho, dFddrho, version_no, vflag )

  use m_Control_Parameters, only : printable, sw_use_WuGygi_method
  use m_Const_Parameters, only : DP, EXC_ONLY, ON
  use m_Files, only : nfout
  use m_Timing, only : tstatc0_begin,tstatc0_end
  use m_vdWDF, only : initialize_vdwdf_scf,build_theta,vdWdf_core,corrections, &
       &              get_dFdrho_dFddrho,finalize_vdwdf,Ecnl_12,Ecnl_3,Ecnl_3s, &
       &              univol,rinplw, ecnl_vdwdf, oneshot
  implicit none

  integer, intent(in) :: nspin,ispin,nfft_div_size,na,nb,nc
  integer, intent(in) :: version_no
  integer, intent(in) :: vflag

  real(kind=DP), dimension(nfft_div_size), intent(in) :: chgr,grad_rho
  real(kind=DP), intent(out) :: ecnl
  real(kind=DP), dimension(nfft_div_size), intent(out) :: dFdrho,dFddrho
  integer :: i,i1,i2,i3
  logical, save :: initialized=.false.
  integer :: id_sname=-1

  call tstatc0_begin('vdW_scf ',id_sname,1)
  call initialize_vdwdf_scf( nspin, ispin, nfft_div_size, na, nb, nc, chgr, grad_rho, version_no )
  call build_theta()

  if ( vflag == EXC_ONLY ) oneshot = .true.
  call vdWdf_core()
  if ( vflag == EXC_ONLY ) oneshot = .false.

  if ( sw_use_WuGygi_method == ON ) then
     ecnl = Ecnl_12
  else
     call corrections()
     ecnl = Ecnl_12 + Ecnl_3 - Ecnl_3s
  endif

  ecnl_vdwdf = ecnl

  call get_dFdrho_dFddrho(dFdrho,dFddrho)
  call finalize_vdwdf()
  call tstatc0_end(id_sname)

end subroutine vdW_scf

subroutine vdW_scf_stress( nspin, ispin, nfft_div_size, na, nb, nc, chgr, grad_rho, cgrad_rho, &
     &                     version_no, input_charge )
  use m_Const_Parameters, only : DP, Partial_Core_Charge
  use m_Timing, only : tstatc0_begin, tstatc0_end
  use m_vdWDF, only : initialize_vdwdf_stress, build_theta, vdWdf_stress_tensor_core, &
       &              finalize_vdwdf, univol,rinplw, s_cnl1, s_cnl2, s_cnl1_pc, s_cnl2_pc
  use m_Files,  only : nfout

  implicit none
  integer, intent(in) :: nspin,ispin,nfft_div_size, na,nb,nc, input_charge, version_no
  real(kind=DP), intent(in) :: chgr(nfft_div_size), grad_rho(nfft_div_size)
  real(kind=DP), intent(in) :: cgrad_rho(nfft_div_size,3)

  integer :: i,i1,i2,i3
  logical, save :: initialized=.false.
  integer :: id_sname=-1

  call tstatc0_begin('vdW_scf_stress ',id_sname,1)
  call initialize_vdwdf_stress( nspin, ispin, nfft_div_size, na, nb, nc, chgr, grad_rho, cgrad_rho, &
       &                        version_no )
  call build_theta()
  call vdWdf_stress_tensor_core()
  call finalize_vdwdf()
!
  if ( input_charge == Partial_Core_Charge ) then
     s_cnl1_pc = s_cnl1
     s_cnl2_pc = s_cnl2
  endif
  call tstatc0_end(id_sname)

end subroutine vdW_scf_stress

#ifdef VDW_ONESHOT_NEW
subroutine vdW_oneshot()
  use m_Const_Parameters,  only : Valence_plus_PC_Charge, EXC_ONLY, VXC_AND_EXC
  use m_Control_Parameters, only : len_xctype, xctype, printable, oneshot
  use m_Files,   only : nfout
  use m_Charge_Density,  only : chgq_l
  use m_XC_Potential ,  only : m_XC_cal_potential_3D
  use m_Timing, only : tstatc0_begin,tstatc0_end
  use m_Parallelization, only : mype
  use m_Total_Energy, only : etotal
  use m_vdWDF, only:  ecnl_vdwdf

  implicit none

  integer :: id_sname = -1

  call tstatc0_begin('vdW_oneshot ',id_sname,1)
  if(mype==0) then
     write(nfout,*)
     write(nfout,'(a)')    "** 'oneshot' calculation of the vdW-interaction **"
  endif
  write(nfout,*)

  oneshot = .false.
  call m_XC_cal_potential_3D( nfout, Valence_plus_PC_Charge, chgq_l, EXC_ONLY )
  oneshot = .true.


  etotal = etotal + ecnl_vdwdf

  if(printable) then
     write(nfout,'(a,f20.10,a)') '--> total energy : ',etotal,' hartree'
  endif
  write(nfout,*)

  call tstatc0_end(id_sname)

end subroutine vdW_oneshot

#else
subroutine vdW_oneshot()
  use m_Const_Parameters, only : DP
  use m_Control_Parameters, only : printable,nspin
  use m_Files, only : nfout
  use m_Parallelization, only : mype
  use m_Timing, only : tstatc0_begin,tstatc0_end
  use m_Total_Energy, only : etotal
  use m_vdWDF, only: initialize_vdwdf_oneshot,build_theta,vdWdf_core,corrections,Ecnl_12,Ecnl_3,Ecnl_3s,finalize_vdwdf
  implicit none
  integer :: is
  integer :: id_sname = -1
  real(kind=DP) :: Ecnl
  call tstatc0_begin('vdW_oneshot ',id_sname,1)
  if(mype==0) then
     write(nfout,'(a)')    "** 'oneshot' calculation of the vdW-interaction **"
  endif
  Ecnl=0.d0
  is=1
  if(nspin>1) is=-1

  call initialize_vdwdf_oneshot(is)
  call build_theta()
  call vdWdf_core()
  Ecnl = Ecnl+Ecnl_12
  call corrections()
  Ecnl = Ecnl+Ecnl_3 - Ecnl_3s
  call finalize_vdwdf()
  etotal = etotal + Ecnl
  if(printable) then
     write(nfout,'(a,f20.10,a)') 'vdW energy       : ',Ecnl,  ' hartree'
     write(nfout,'(a,f20.10,a)') '--> total energy : ',etotal,' hartree'
  endif
  call tstatc0_end(id_sname)
end subroutine vdW_oneshot
#endif

#endif

module m_Excitation
!
  use m_Const_Parameters,   only :  ON, OFF, DP, CMPLDP, LOWER, FMAXVALLEN, zi, &
       &                            ELECTRON, DIRECT, BUCS, PAI2, PAI4
  use m_Control_Parameters,  only : sw_use_add_proj, kimg, neg, ndim_spinor, nspin, &
       &                            sw_excitation, noncol, ipri
  use m_Files,  only : nfout, nf_excitation_spectra, m_Files_open_nf_xi_spectra

  use m_PseudoPotential,    only :  nlmt, ilmt, nlmt_add, ilmt_add, itau, iloc, &
       &                            radr, wos, mmesh, nmesh, lpsmax, nloc, ntau, &
       &                            psirpw, phirpw, ltp, mtp, taup, ltp_add, mtp_add, &
       &                            nlmta, nlmta_add, lmta, lmta_add
  use m_NonLocal_Potential, only : new_radr_and_wos

  use m_Ionic_System,       only : ntyp, ityp, natm, pos
  use m_Crystal_Structure,   only : nopr, rltv, univol, op, tau
  use m_Kpoints,       only : kv3, vkxyz, qwgt, kv3_fbz, num_star_of_k, star_of_k, &
       &                      iopr_k_fbz_to_ibz, trev_k_fbz_to_ibz

  use m_PlaneWaveBasisSet,   only : kg1, kgp, ttr, ngabc, ngpt_l, iba, nbase, igf
  use m_Parallelization,     only : npes, ista_kngp, iend_kngp, mpi_comm_group, ierr, &
       &                            ista_k, iend_k, np_e, myrank_e, myrank_k, &
       &                            map_e, map_k, map_z, ista_e, iend_e, istep_e, &
       &                            mpi_k_world, mype, map_ek, mpi_e_world

  use m_Electronic_Structure,  only : eko_l, zaj_l, fsr_l, fsi_l, fsr_add_l, fsi_add_l, &
       &                              m_ES_WF_in_Rspace1, m_ES_WF_in_Rspace_kt, &
       &                              efermi, occup_l

  use m_FFT,                    only : nfft, fft_box_size_WF, m_FFT_WF, &
       &                               m_FFT_alloc_WF_work, m_FFT_dealloc_WF_work

  use m_ValenceBand_Spectrum,  only : dipole_dxyz_us, m_VBS_find_ptrans_index_ek

  use m_Corelevel_Spectrum,   only : sw_corelevel_spectrum, atom_to_probe, &
       &                             e_low_cls => e_low, e_high_cls => e_high, &
       &                             e_step_cls => e_step, &
       &                             qnum_n_to_probe, qnum_l_to_probe, &
       &                             psir_core_ae_wfns, &
       &                             dipole_dxyz_core2val, &
       &                             m_CLS_chk_sw_corelevel_spectrum, &
       &                             m_CLS_rd_n_main, &
       &                             m_CLS_find_orb_index_to_probe, &
       &                             m_CLS_find_ptrans_indx_core2val, &
       &                             num_core_states, ene_core_states, &
       &                             psig_core_states, &
       &                             fsr_core_states, fsi_core_states, &
       &                             eshift_corelevel_virtual

  implicit none
  include 'mpif.h'

! -- General --
  character(len("excitation")), private,parameter :: tag_excitation = "excitation"
  character(len("sw_excitation")), private,parameter :: &
       &                              tag_sw_excitation = "sw_excitation"
!
!!!  integer :: sw_excitation = OFF

! --- G expansion --
  character(len("G_expansion")), private,parameter :: &
       &                    tag_G_expansion = "G_expansion"
  character(len("nmax_G")),private,parameter :: tag_nmax_G_given = "nmax_G"
  character(len("sw_spin_decomposition")), parameter ::  &
       &            tag_sw_spin_decomposition = "sw_spin_decomposition"
  character(len("sw_spin_decomp")), parameter ::  &
       &            tag_sw_spin_decomp = "sw_spin_decomp"

  integer :: nmax_G_given = 100
  integer :: sw_spin_decomposition = OFF
!
  integer :: nspin_m
  integer :: nmax_G, nmax_G_spin

! --- Momentum transfer --
  character(len("sw_longwavelimit")),private,parameter :: &
       &           tag_sw_longwavelimit = "sw_longwavelimit"
  integer :: sw_LongWaveLimit = ON
  real(kind=DP) :: qvec(3) = (/0.0d0, 0.0d0, 1.0d-3/)

! -- band gap correction ---
  character(len("band_gap_correction")), parameter :: &
       &                     tag_band_gap_correction = "band_gap_correction"
  character(len("scissor_operator")), parameter ::  tag_scissor  = "scissor_operator"
  character(len("sw_scissor_renormalization")), parameter         :: &
       &           tag_sw_scissor_renormalization   = "sw_scissor_renormalization"
!
  real(kind=DP) :: scissor = 0.0d0
  integer :: sw_scissor_renormalization = OFF

! -- transtion moment ( G=0, q-> 0 )
  real(kind=DP) :: delta_omega = 1.0D-14

! --- Brillouin zone integral
  character(len("BZ_integration")), parameter ::  &
       &                  tag_BZ_integration  = "BZ_integration"
  character(len("method")), parameter ::  tag_method = "method"
  character(len("gaussian")), parameter ::  tag_gaussian = "gaussian"
  character(len("lorentzian")), parameter ::  tag_lorentzian = "lorentzian"

  character(len("g")), parameter ::  tag_g = "g"
  character(len("l")), parameter ::  tag_l = "l"

  character(len("width")), parameter ::  tag_width = "width"
  character(len("extent")), parameter ::  tag_extent = "extent"

  integer, parameter :: GAUSSIAN_B = 1, LORENTZIAN_B = 2
  integer :: way_BZ_integral = GAUSSIAN_B

  real(kind=DP) :: width = 0.0183745D0              ! 0.5 eV
!  real(kind=DP) :: gaussian_extent = 3.893d0
  real(kind=DP) :: gaussian_extent = 4.00d0

! -- Energy range --
  character(len("energy_range")), parameter ::  tag_erange = "energy_range"
  character(len("e_low")), parameter ::  tag_elow = "e_low"
  character(len("e_high")), parameter ::  tag_ehigh = "e_high"
  character(len("e_step")), parameter ::  tag_estep = "e_step"

  integer :: nstep = 500
  real(kind=DP) :: e_low = 0.0d0, e_high = 1.0d0, e_step = 0.002d0

  real(kind=DP), allocatable :: e(:)

! -- Spectrum --
  character(len("spectrum")), parameter ::  tag_spectrum = "spectrum"
  character(len("type")), parameter ::  tag_type = "type"
  character(len("optics")), parameter ::  tag_optics = "optics"
  character(len("eels")), parameter ::  tag_eels = "eels"

  integer, parameter :: OPTICS = 1, EELS = 2

  integer :: spectrum_type = OPTICS
  integer :: sw_calc_epsilon_indep_only = ON

! -- Interaction --
  complex(kind=CMPLDP), allocatable :: Kernel_Coulomb(:)

! -- LR-TDDFT --
  character(len("tddft")), parameter ::  tag_tddft = "tddft"
  character(len("sw_tddft")), parameter ::  tag_sw_tddft = "sw_tddft"
  character(len("sw_nlf")), parameter ::  tag_sw_nlf = "sw_nlf"

  character(len("xc_kernel")), parameter ::  tag_xc_kernel = "xc_kernel"
  character(len("rpa")), parameter ::  tag_rpa = "rpa"
  character(len("lrc")), parameter ::  tag_lrc = "lrc"
  character(len("lrc_scf")), parameter ::  tag_lrc_scf = "lrc_scf"
  character(len("alpha_lrc")), parameter ::  tag_alpha_lrc = "alpha_lrc"
  character(len("bootstrap")), parameter ::  tag_bootstrap = "bootstrap"

  integer :: sw_tddft = OFF
  integer :: sw_nlf = OFF

  integer, parameter :: RPA = 1, LRC = 5, LRC_scf = 6, BOOTSTRAP = 10
  integer :: kernel_xc_type = RPA
  real(kind=DP) :: alpha_LRC = 0.2d0

! -- MBPT Bethe-Salpeter --
  character(len("bse")), parameter ::  tag_bse = "bse"
  character(len("sw_bse")), parameter ::  tag_sw_bse = "sw_bse"

  integer :: sw_bse = OFF

  integer :: num_occ_bands, num_unocc_bands, matsize_bse, ista_matbse, iend_matbse
  complex(kind=CMPLDP), allocatable :: epsinv_omega0(:,:)
  complex(kind=CMPLDP), allocatable :: MatH_bse(:,:)

! -- variables --
! --
! valence <-> valence
!
  integer :: nqitg_XI_vv_sum
  integer, allocatable :: iqitg_XI_vv(:,:,:,:,:,:)
  integer, allocatable :: nqitg_XI_vv(:)
  real(kind=DP), allocatable :: qitg_XI_vv(:,:)
!
  integer, allocatable :: isph_XI_vv(:,:,:,:)
  integer, allocatable :: il2p_XI_vv(:,:,:)
  real(kind=DP), allocatable :: dl2p_XI_vv(:,:,:,:)
!
  real(kind=DP), allocatable :: Mat_dipole_corr_vv(:,:,:,:)
!
  complex(kind=CMPLDP), allocatable :: trm_vv(:,:,:,:)
  complex(kind=CMPLDP), allocatable :: RhoTilde_vv(:,:,:,:)
  complex(kind=CMPLDP), allocatable :: SpectrFn_vv(:,:,:)
  complex(kind=CMPLDP), allocatable :: SpectrTensor_vv(:,:,:,:)

! --
! core <-> valence
!
  integer :: nqitg_XI_vc
  integer, allocatable :: iqitg_XI_vc(:,:,:)
  real(kind=DP), allocatable :: qitg_XI_vc(:,:)
!
  integer, allocatable :: isph_XI_vc(:,:,:)
  integer, allocatable :: il2p_XI_vc(:,:)
  real(kind=DP), allocatable :: dl2p_XI_vc(:,:,:)
!
  real(kind=DP), allocatable :: Mat_dipole_corr_vc(:,:,:)

  complex(kind=CMPLDP), allocatable :: trm_vc(:,:,:,:)
  complex(kind=CMPLDP), allocatable :: RhoTilde_vc(:,:,:,:)
  complex(kind=CMPLDP), allocatable :: SpectrFn_vc(:,:,:)

! --
! core <-> core
!
  integer :: nqitg_XI_cc
  integer, allocatable :: iqitg_XI_cc(:,:,:)
  real(kind=DP), allocatable :: qitg_XI_cc(:,:)
!
  integer, allocatable :: isph_XI_cc(:,:,:)
  integer, allocatable :: il2p_XI_cc(:,:)
  real(kind=DP), allocatable :: dl2p_XI_cc(:,:,:)
!
  complex(kind=CMPLDP), allocatable :: trm_cc(:,:,:,:)
  complex(kind=CMPLDP), allocatable :: RhoTilde_cc(:,:,:,:)

! symmetry
  integer, allocatable :: ngpt_XI(:,:)

! others
  integer :: nlmt_val, nlmt_core
  integer, allocatable :: ilmt_val(:)

  integer, parameter :: lcmax = 4
  integer :: ipriexcitation = 2
  integer :: imple_method = 1       ! 1 : like gpaw, 2 :like yambo
!
contains

! --------------------------------------------------------
!    Parameter setting  
! --------------------------------------------------------

  subroutine m_XI_read_input
    integer :: f_selectBlock, f_getStringValue, f_getRealValue, f_getIntValue
    integer :: f_selectParentBlock, f_selectTop

    integer :: iret
    real(kind=DP) :: dret
    character(len=FMAXVALLEN) :: rstr

    iret = f_selectTop()
    if( f_selectBlock( tag_excitation ) == 0 ) then

      if ( f_getIntValue( tag_sw_excitation, iret ) == 0 ) then
         sw_excitation = iret
         write(nfout,*)
         write(nfout,*) "!** XI: sw_excitation is set to ", iret
      endif
      if ( sw_excitation == OFF ) return
!
      call m_CLS_chk_sw_corelevel_spectrum
      if ( sw_corelevel_spectrum == ON ) call m_CLS_rd_n_main
         
! ---
      call set_lr_tddft
      call set_mbpt_bse
      call set_nmax_G_for_expansion
      call set_scissor_operator
      call set_BZ_integration_method
      call set_energy_range
      call set_spectrum_type

      iret = f_selectParentBlock()      
    end if

  contains

    subroutine set_nmax_G_for_expansion
      integer :: f_getIntValue


      if ( f_selectBlock( tag_G_expansion ) == 0 ) then
         if ( f_getIntValue( tag_nmax_G_given, iret ) == 0 ) then
            if ( iret > 0 .and. iret < kg1 ) nmax_G_given = iret
         endif
         if ( f_getIntValue( tag_sw_spin_decomposition, iret ) == 0 ) then
            sw_spin_decomposition = iret
         endif
         if ( f_getIntValue( tag_sw_spin_decomp, iret ) == 0 ) then
            sw_spin_decomposition = iret
         endif

         iret = f_selectParentBlock()      
      endif
      write(nfout,*) "!** XI: sw_spin_decomp is set to ", sw_spin_decomposition
    end subroutine set_nmax_G_for_expansion

    subroutine set_scissor_operator
      integer :: f_getRealValue

      if ( f_selectBlock( tag_band_gap_correction ) == 0 ) then
         if ( f_getRealValue( tag_scissor, dret, 'hartree' ) == 0 ) then
            scissor = dret
         endif
         if ( f_getIntValue( tag_sw_scissor_renormalization, iret ) == 0 ) then
            sw_scissor_renormalization = iret
         endif
         iret = f_selectParentBlock()      
      endif
      write(nfout,*) "!** XI: scissor operator is set to ", scissor
      write(nfout,*) "!** XI: sw_scissor_renormalization is set to ", sw_scissor_renormalization
    end subroutine set_scissor_operator

    subroutine set_BZ_integration_method
      integer :: f_getRealValue, f_getStringValue
      logical :: tf

      if ( f_selectBlock(tag_BZ_integration) == 0 ) then
         if ( f_getStringValue( tag_method, rstr, LOWER ) == 0 ) then
            call strncmp0( tag_gaussian, trim(rstr), tf)
            if (tf) way_BZ_integral = Gaussian_B
            call strncmp0( tag_g, trim(rstr), tf)
            if (tf) way_BZ_integral = Gaussian_B

            call strncmp0( tag_lorentzian, trim(rstr), tf)
            if (tf) way_BZ_integral = Lorentzian_B
            call strncmp0( tag_l, trim(rstr), tf)
            if (tf) way_BZ_integral = Lorentzian_B
         endif

         if( f_getRealValue( tag_width, dret, 'hartree' ) == 0) then
            if ( dret > 0.0 ) width = dret
         endif
         if( f_getRealValue( tag_extent, dret, '' ) == 0) then
            if ( dret > 2.0 ) gaussian_extent = dret
         endif
         iret = f_selectParentBlock()      
      end if

      write(nfout,*) "!** XI: BZ integration method is set to ", way_BZ_integral
      write(nfout,*) "!** XI: width is set to ", width
      if ( way_BZ_integral == Gaussian_B ) then
         write(nfout,*) "!** XI: gaussian_extent is set to ", gaussian_extent
      endif

    end subroutine set_BZ_integration_method

    subroutine set_energy_range
      integer :: f_getRealValue

       if ( sw_corelevel_spectrum == ON ) then
          e_low  = e_low_CLS
          e_high = e_high_CLS
          e_step = e_step_CLS
       endif

      if ( f_selectBlock( tag_erange ) == 0 ) then
         if( f_getRealValue( tag_elow, dret, 'hartree' ) == 0) then
            if ( dret > 0.0 ) e_low = dret
         endif
         if( f_getRealValue( tag_ehigh, dret,'hartree' ) == 0) then
            if ( dret > 0.0 .and. dret > e_low ) e_high = dret
         endif
         if( f_getRealValue( tag_estep, dret,'hartree' ) == 0) then
            if ( dret > 0.0 ) e_step = dret
         endif
         iret = f_selectParentBlock()
       end if

       write(nfout,*) "!** XI: e_low  is ", e_low
       write(nfout,*) "!** XI: e_high is ", e_high
       write(nfout,*) "!** XI: e_step is ", e_step

       nstep = nint( ( e_high -e_low ) /e_step )

       write(nfout,*) "!** XI: number of energy steps is ", nstep

    end subroutine set_energy_range

    subroutine set_lr_tddft
      integer :: f_getIntValue, f_getStringValue, f_getRealValue
      logical :: tf

      if ( f_selectBlock( tag_tddft ) == 0 ) then
         if ( f_getIntValue( tag_sw_tddft, iret ) == 0 ) then
            sw_tddft = iret
         endif
         if ( f_getIntValue( tag_sw_nlf, iret ) == 0 ) then
            sw_nlf = iret
         endif
         if ( f_getStringValue( tag_xc_kernel, rstr, LOWER ) == 0 ) then
            call strncmp0( tag_rpa, trim(rstr), tf)
            if (tf) kernel_xc_type = RPA

            if (len_trim(rstr) == len_trim(tag_lrc_scf) ) then
               call strncmp0( tag_lrc_scf, trim(rstr), tf)
               if (tf) kernel_xc_type = LRC_scf
            endif

            if (len_trim(rstr) == len_trim(tag_lrc) ) then
               call strncmp0( tag_lrc, trim(rstr), tf)
               if (tf) kernel_xc_type = LRC
            endif

            call strncmp0( tag_bootstrap, trim(rstr), tf)
            if (tf) kernel_xc_type = BOOTSTRAP
         endif

100      continue

         if( f_getRealValue( tag_alpha_lrc, dret,'' ) == 0) then
            alpha_lrc = dret
         endif

         write(nfout,*) "!** XI: sw_tddft is ", sw_tddft
         if ( sw_tddft == ON ) then
            write(nfout,*) "!** XI: sw_nlf   is ", sw_nlf
            write(nfout,*) "!** XI: kernel_xc_type is ", kernel_xc_type
            if ( kernel_xc_type == LRC ) then
               write(nfout,*) "!** XI: alpha_LRC is ", alpha_LRC
            endif
         endif

         if ( sw_tddft == ON ) sw_calc_epsilon_indep_only = OFF

         iret = f_selectParentBlock()      
      endif
    end subroutine set_lr_tddft

    subroutine set_mbpt_bse
      integer :: f_getIntValue

      if ( f_selectBlock( tag_bse ) == 0 ) then
         if ( f_getIntValue( tag_sw_bse, iret ) == 0 ) then
            sw_bse = iret
         endif

         write(nfout,*) "!** XI: sw_bse is ", sw_bse
         if ( sw_bse == ON ) sw_calc_epsilon_indep_only = OFF

         iret = f_selectParentBlock()      
      endif
    end subroutine set_mbpt_bse

    subroutine set_spectrum_type
      integer :: f_getIntValue, f_getStringValue
      logical :: tf

      if ( f_selectBlock( tag_spectrum ) == 0 ) then
         if ( f_getStringValue( tag_type, rstr, LOWER ) == 0 ) then
            call strncmp0( tag_optics, trim(rstr), tf)
            if (tf) spectrum_type = OPTICS

            call strncmp0( tag_eels, trim(rstr), tf)
            if (tf) spectrum_type = EELS
         endif
         iret = f_selectParentBlock()      
      end if

      write(nfout,*) "!** XI: Spectrum type is set to ", spectrum_type

    end subroutine set_spectrum_type

  end subroutine m_XI_read_input

!  subroutine m_XI_set_value_nmax_G( nmax_G_given, nmax_G )
  subroutine m_XI_set_value_nmax_G
!    integer, intent(in) :: nmax_G_given
!    integer, intent(out) :: nmax_G
    
    integer :: i, count, ispin
    real(kind=DP) :: g1, g1_prev, dg
    
    if ( sw_spin_decomposition == ON ) then
       nspin_m = nspin
    else
       nspin_m = 1
    endif

    if ( sw_calc_epsilon_indep_only == ON ) then
       nmax_G = 1;  nmax_G_spin = nspin_m;  return
    endif

    count = 0
    do i = 1, kgp
       g1 = dsqrt( ttr(1)*ngabc(i,1)*ngabc(i,1) &
            &             + ttr(2)*ngabc(i,2)*ngabc(i,2) &
            &             + ttr(3)*ngabc(i,3)*ngabc(i,3) &
            &             + ttr(4)*ngabc(i,1)*ngabc(i,2) &
            &             + ttr(5)*ngabc(i,2)*ngabc(i,3) &
            &             + ttr(6)*ngabc(i,3)*ngabc(i,1))
       dg = abs( g1 -g1_prev )
       if ( dg < 1.0D-5 ) then
          count = count +1
       else
          if ( count > nmax_G_given ) exit
          count = count +1
       end if
       g1_prev = g1
    enddo
    nmax_G = count
    nmax_G_spin = nmax_G *nspin_m

    write(nfout,*) 
    write(nfout,*) "!** XI: nmax_G is set to ", nmax_G
    write(nfout,*) 

  end subroutine m_XI_set_value_nmax_G

! --------------------------------------------------------
!    Preparation of arrays for treating wfns
! --------------------------------------------------------

  subroutine m_XI_set_ilmt_val
    integer :: it

    allocate( ilmt_val(ntyp) )

    if ( sw_use_add_proj == ON ) then
       nlmt_val = nlmt +nlmt_add
       Do it=1, ntyp
          ilmt_val(it) = ilmt(it) +ilmt_add(it)
       End do
    else
       nlmt_val = nlmt
       Do it=1, ntyp
          ilmt_val(it) = ilmt(it)
       End do
    endif

  end subroutine m_XI_set_ilmt_val

  subroutine m_XI_set_ilmt_core
    nlmt_core = 2 *qnum_l_to_probe +1
  end subroutine m_XI_set_ilmt_core

  subroutine m_XI_set_ngpt_XI
    integer, allocatable :: ngpt_wk(:,:), ngpt_wk2(:,:)

    integer :: i

    allocate( ngpt_XI( nmax_G, nopr) ); ngpt_XI = 0

    if ( npes > 1 ) then
       allocate( ngpt_wk( kgp,nopr) ); ngpt_wk  = 0
       allocate( ngpt_wk2(kgp,nopr) ); ngpt_wk2 = 0
       ngpt_wk(ista_kngp:iend_kngp,:) = ngpt_l(ista_kngp:iend_kngp,:)

       call mpi_allreduce( ngpt_wk, ngpt_wk2, kgp*nopr, mpi_integer, mpi_sum, &
            &              mpi_comm_group, ierr )
       ngpt_XI( 1:nmax_G, 1:nopr ) = ngpt_wk2( 1:nmax_G, 1:nopr )
       deallocate( ngpt_wk ); deallocate( ngpt_wk2 )
    else
       ngpt_XI( 1:nmax_G, 1:nopr ) = ngpt_l( 1:nmax_G, 1:nopr )
    endif

  end subroutine m_XI_set_ngpt_XI

! --------------------------------------------------------
!    Preparation of arrays for transtion moments (val-val)
! --------------------------------------------------------

  subroutine m_XI_set_qitg_XI_vv
    allocate( nqitg_XI_vv(ntyp) ); nqitg_XI_vv = 0
    call set_size_qitg_XI_vv

    if ( ipriexcitation >=2 ) then
       write(nfout,*) '!** XI: nqitg_XI_vv_sum  = ',nqitg_XI_vv_sum
    endif

    allocate( iqitg_XI_vv( nloc, ntau, nloc, ntau, nloc**2, ntyp ) )
    allocate( qitg_XI_vv( nmax_G, nqitg_XI_vv_sum ) )
    iqitg_XI_vv = 0;  qitg_XI_vv = 0.0d0

    call set_array_qitg_XI_vv

  contains

    subroutine set_size_qitg_XI_vv
      integer :: it, il1, il2, tau1, tau2, tmin
      integer :: l3s, l3l, il3, mm_sum, mm

      mm_sum = 0

      Do it=1, ntyp
         mm = 0

         Loop_L1 : do il1 = 1, lpsmax(it)
            Loop_tau1 : do tau1 = 1, itau(il1,it)

               Loop_L2 : do il2 = il1, lpsmax(it)
                  tmin = 1
                  if(il1 == il2) tmin = tau1

                  Loop_tau2 : do tau2 = tmin, itau(il2,it)
                     l3s = abs(il1-il2); l3l = abs(il1+il2) - 2

                     Loop_L3 : do il3 = l3s+1, l3l+1, 2
                        if(il3-1 > lcmax ) cycle
                        mm = mm +1
                     End do Loop_L3

                  End do Loop_tau2
               End do Loop_L2

            End do Loop_tau1
         End do Loop_L1

         nqitg_XI_vv(it) = mm
         mm_sum = mm_sum +mm
      end Do

      nqitg_XI_vv_sum = mm_sum

    end subroutine set_size_qitg_XI_vv

    subroutine set_array_qitg_XI_vv
      integer :: it, il1, il2, tau1, tau2, tmin
      integer :: l3s, l3l, il3, mm_sum, mm
      integer :: i, ir

      real(kind=DP), allocatable :: qrs(:), gr_XI(:), wkx(:), wky(:)

      allocate( qrs( mmesh ) ); qrs = 0.d0
      allocate( wkx( mmesh ) ); wkx = 0.0d0
      allocate( wky( mmesh ) ); wky = 0.0d0
      allocate( gr_XI(nmax_G) ); gr_XI = 0.0d0

      allocate( radr(mmesh) );  allocate( wos(mmesh) )

      do i = 1, nmax_G
         gr_XI(i) =      dsqrt(ttr(1)*ngabc(i,1)*ngabc(i,1) &
              &             + ttr(2)*ngabc(i,2)*ngabc(i,2) &
              &             + ttr(3)*ngabc(i,3)*ngabc(i,3) &
              &             + ttr(4)*ngabc(i,1)*ngabc(i,2) &
              &             + ttr(5)*ngabc(i,2)*ngabc(i,3) &
              &             + ttr(6)*ngabc(i,3)*ngabc(i,1))
      enddo

      mm = 0
      Do it=1, ntyp
         call new_radr_and_wos(ista_k,it)

         Loop_L1 : do il1 = 1, lpsmax(it)
            Loop_tau1 : do tau1 = 1, itau(il1,it)

               Loop_L2 : do il2 = il1, lpsmax(it)
                  tmin = 1
                  if (il1 == il2) tmin = tau1

                  Loop_tau2 : do tau2 = tmin, itau(il2,it)
                     l3s = abs(il1-il2);  l3l = abs(il1+il2) - 2

                     Loop_L3 : do il3 = l3s+1, l3l+1, 2
                        if(il3-1 > lcmax ) cycle
                        mm = mm +1
                        iqitg_XI_vv( il1, tau1, il2, tau2, il3, it ) = mm
                        iqitg_XI_vv( il2, tau2, il1, tau1, il3, it ) = mm  !! ??

                        qrs = 0.0d0
                        Do ir=1, nmesh(it)
                           qrs( ir ) &
                                &   = ( psirpw(ir,il1,tau1,it) *psirpw(ir,il2,tau2,it) &
                                &     - phirpw(ir,il1,tau1,it) *phirpw(ir,il2,tau2,it) )
                        End do

                        call qitgft( 1, nmax_G, mmesh, nqitg_XI_vv_sum, nmesh(it), &
                             &       ipriexcitation, nfout, il3-1, radr, wos, &
                             &       qrs, gr_XI, &
                             &       1.d0, mm, qitg_XI_vv, wkx, wky )

                     End do Loop_L3

                  End do Loop_tau2
               End do Loop_L2

            End do Loop_tau1
         End do Loop_L1
      End Do

      deallocate( radr ); deallocate( wos );  deallocate( wkx ); deallocate( wky )
      deallocate( qrs ); deallocate( gr_XI )

    end subroutine set_array_qitg_XI_vv

  end subroutine m_XI_set_qitg_XI_vv

  subroutine m_XI_set_dl2p_XI_vv
    integer :: it, lmt1, lmt2, il1, im1, il2, im2, itmp
    integer :: nspher1, nspher2, n

    integer, allocatable :: isph2(:,:,:), mmt2(:,:)
    real(kind=DP), allocatable :: cr2(:,:,:)

    allocate( isph_XI_vv( nlmt_val, nlmt_val, 6, ntyp )); isph_XI_vv = 0
    allocate( il2p_XI_vv( nlmt_val, nlmt_val, ntyp ) );   il2p_XI_vv = 0
    allocate( dl2p_XI_vv( nlmt_val, nlmt_val, 6, ntyp));  dl2p_XI_vv = 0

    allocate( cr2(  16,16,6) ); cr2 = 0.0d0
    allocate( isph2(16,16,6) ); isph2 = 0.0d0
    allocate( mmt2( 16,16)   ); mmt2 = 0

    call sphset2( nfout, ipri, lcmax, cr2, isph2, mmt2 )

    Do it=1, ntyp
       Do lmt1=1, ilmt_val(it)
          if ( lmt1 <= ilmt(it) ) then
             il1 = ltp(lmt1,it);  im1 = mtp(lmt1,it)
          else
             itmp = lmt1 -ilmt(it)
             il1 = ltp_add(itmp,it);  im1 = mtp_add(itmp,it)
          endif
          nspher1 = ( il1 -1 )**2 +im1

          Do lmt2=1, ilmt_val(it)
             if ( lmt2 <= ilmt(it) ) then
                il2 = ltp(lmt2,it);  im2 = mtp(lmt2,it)
             else
                itmp = lmt2 -ilmt(it)
                il2 = ltp_add(itmp,it);  im2 = mtp_add(itmp,it)
             endif
             nspher2 = ( il2 -1 )**2 +im2

             il2p_XI_vv( lmt1, lmt2, it ) = mmt2( nspher1, nspher2 )
             Do n=1, il2p_XI_vv(lmt1,lmt2,it)
                isph_XI_vv( lmt1, lmt2, n, it ) = isph2( nspher1, nspher2, n )
                dl2p_XI_vv( lmt1, lmt2, n, it ) = cr2  ( nspher1, nspher2, n )
             End do
          End Do
       End Do
    End Do

  end subroutine m_XI_set_dl2p_XI_vv

  subroutine m_XI_set_mat_dipole_corr_vv
    integer :: it, lmt1, lmt2, il1, il2, im1, im2, tau1, tau2
    integer :: nspher1, nspher2, itmp, ifact, index

    allocate( Mat_Dipole_corr_vv( ntyp, nlmt_val, nlmt_val, 3 ) )
    Mat_Dipole_corr_vv = 0.0d0

    Do it=1, ntyp
       Do lmt1=1, ilmt_val(it)
          if ( lmt1 <= ilmt(it) ) then
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it); tau1 = taup(lmt1,it)
          else
             itmp = lmt1 -ilmt(it)
             il1 = ltp_add(itmp,it); im1 = mtp_add(itmp,it);  tau1 = 1
          endif
          nspher1 = ( il1 -1 )**2 +im1

          Do lmt2=1, ilmt_val(it)
             if ( lmt2 <= ilmt(it) ) then
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it); tau2 = taup(lmt2,it)
             else
                itmp = lmt2 -ilmt(it)
                il2 = ltp_add(itmp,it); im2 = mtp_add(itmp,it);  tau2 = 1
             endif
             nspher2 = ( il2 -1 )**2 +im2

             call m_VBS_find_ptrans_index_ek( it, nspher1, nspher2, tau1, tau2, &
                  &                           index, ifact )

             if ( index /= 0 ) then
                Mat_Dipole_Corr_vv( it, lmt1, lmt2, 1:3 ) &
                     &      = dipole_dxyz_us( it, index, 1:3 ) *ifact
             endif
          End do
       End Do
    End Do

  end subroutine m_XI_set_mat_dipole_corr_vv

! --------------------------------------------------------
!    Preparation of arrays for transtion moments (val-core)
! --------------------------------------------------------

  subroutine m_XI_set_qitg_XI_vc
    nqitg_XI_vc = 0
    call set_size_qitg_XI_vc

    if ( ipriexcitation >= 2 ) then
       write(nfout,*) '** nqitg_XI_vc_sum  = ',nqitg_XI_vc
    endif

    allocate( iqitg_XI_vc( nloc, ntau, nloc**2 ) )
    allocate( qitg_XI_vc( nmax_G, nqitg_XI_vc ) )

    iqitg_XI_vc = 0;  qitg_XI_vc = 0.0d0

    call set_array_qitg_XI_vc

  contains

    subroutine set_size_qitg_XI_vc
      integer :: mm_sum, mm
      integer :: it, il1, il2, tau1, tau2, tmin
      integer :: l3s, l3l, il3, atomtype_to_probe

      mm_sum = 0

      atomtype_to_probe = ityp( atom_to_probe )

      Do it = atomtype_to_probe, atomtype_to_probe
         mm = 0

         Loop_L1 : do il1 = 1, lpsmax(it)
            Loop_tau1 : do tau1 = 1, itau(il1,it)

               Loop_L2 : do il2 = qnum_l_to_probe+1, qnum_l_to_probe+1
                  tmin = 1
                  if(il1 == il2) tmin = tau1

                  Loop_tau2 : do tau2 = 1, 1
                     l3s = abs(il1-il2); l3l = abs(il1+il2) - 2

                     Loop_L3 : do il3 = l3s+1, l3l+1, 2
                        if(il3-1 > lcmax ) cycle
                        mm = mm +1
                     End do Loop_L3

                  End do Loop_tau2
               End do Loop_L2

            End do Loop_tau1
         End do Loop_L1

         nqitg_XI_vc = mm
         mm_sum = mm_sum +mm
      end Do

!      nqitg_XI_vc_sum = mm_sum

    end subroutine set_size_qitg_XI_vc

    subroutine set_array_qitg_XI_vc
      integer :: mm_sum, mm
      integer :: it, il1, il2, tau1, tau2, tmin
      integer :: l3s, l3l, il3
      integer :: i, ir, orb_index, atomtype_to_probe

      real(kind=DP), allocatable :: qrs(:), gr_XI(:), wkx(:), wky(:)

      allocate( qrs( mmesh ) ); qrs = 0.d0
      allocate( wkx( mmesh ) ); wkx = 0.0d0
      allocate( wky( mmesh ) ); wky = 0.0d0
      allocate( gr_XI(nmax_G) ); gr_XI = 0.0d0

      allocate( radr(mmesh) );  allocate( wos(mmesh) )

      do i = 1, nmax_G
         gr_XI(i) =      dsqrt(ttr(1)*ngabc(i,1)*ngabc(i,1) &
              &             + ttr(2)*ngabc(i,2)*ngabc(i,2) &
              &             + ttr(3)*ngabc(i,3)*ngabc(i,3) &
              &             + ttr(4)*ngabc(i,1)*ngabc(i,2) &
              &             + ttr(5)*ngabc(i,2)*ngabc(i,3) &
              &             + ttr(6)*ngabc(i,3)*ngabc(i,1))
      enddo

!      write(*,*) "psircore", allocated( psir_core_ae_wfns )

      orb_index = m_CLS_find_orb_index_to_probe()

      mm = 0

      atomtype_to_probe = ityp( atom_to_probe )

      Do it = atomtype_to_probe, atomtype_to_probe
         call new_radr_and_wos(ista_k,it)

         Loop_L1 : do il1 = 1, lpsmax(it)
            Loop_tau1 : do tau1 = 1, itau(il1,it)

               Loop_L2 : do il2 = qnum_l_to_probe+1, qnum_l_to_probe+1
                  tmin = 1
                  if (il1 == il2) tmin = tau1

                  Loop_tau2 : do tau2 = 1, 1
                     l3s = abs(il1-il2);  l3l = abs(il1+il2) - 2

                     Loop_L3 : do il3 = l3s+1, l3l+1, 2
                        if(il3-1 > lcmax ) cycle
                        mm = mm +1
                        iqitg_XI_vc( il1, tau1, il3 ) = mm

                        qrs = 0.0d0
                        Do ir=1, nmesh(it)
                           qrs( ir ) &
                                &   =  (  psirpw(ir,il1,tau1,it) &
                                &        -phirpw(ir,il1,tau1,it) ) &
                                &          *psir_core_ae_wfns(ir,orb_index)
                        End do

                        call qitgft( 1, nmax_G, mmesh, nqitg_XI_vc, nmesh(it), &
                             &       ipriexcitation, nfout, il3-1, radr, wos, &
                             &       qrs, gr_XI, &
                             &       1.d0, mm, qitg_XI_vc, wkx, wky )

                     End do Loop_L3

                  End do Loop_tau2
               End do Loop_L2

            End do Loop_tau1
         End do Loop_L1
      End Do

      deallocate( radr ); deallocate( wos );  deallocate( wkx ); deallocate( wky )
      deallocate( qrs ); deallocate( gr_XI )

    end subroutine set_array_qitg_XI_vc

  end subroutine m_XI_set_qitg_XI_vc

  subroutine m_XI_set_dl2p_XI_vc
    integer :: it, lmt1, lmt2, il1, im1, il2, im2, itmp
    integer :: nspher1, nspher2, n, atomtype_to_probe

    integer, allocatable :: isph2(:,:,:), mmt2(:,:)
    real(kind=DP), allocatable :: cr2(:,:,:)

    allocate( isph_XI_vc( nlmt_val, nlmt_core, 6 )); isph_XI_vc = 0
    allocate( il2p_XI_vc( nlmt_val, nlmt_core ) );   il2p_XI_vc = 0
    allocate( dl2p_XI_vc( nlmt_val, nlmt_core, 6 )); dl2p_XI_vc = 0

    allocate( cr2(  16,16,6) ); cr2 = 0.0d0
    allocate( isph2(16,16,6) ); isph2 = 0.0d0
    allocate( mmt2( 16,16)   ); mmt2 = 0

    call sphset2( nfout, ipri, lcmax, cr2, isph2, mmt2 )

    atomtype_to_probe = ityp( atom_to_probe )

    Do it = atomtype_to_probe, atomtype_to_probe
       Do lmt1=1, ilmt_val(it)
          if ( lmt1 <= ilmt(it) ) then
             il1 = ltp(lmt1,it);  im1 = mtp(lmt1,it)
          else
             itmp = lmt1 -ilmt(it)
             il1 = ltp_add(itmp,it);  im1 = mtp_add(itmp,it)
          endif
          nspher1 = ( il1 -1 )**2 +im1

          Do lmt2=1, nlmt_core
             il2 = qnum_l_to_probe +1;  im2 = lmt2
             nspher2 = ( il2 -1 )**2 +im2

             il2p_XI_vc( lmt1, lmt2 ) = mmt2( nspher1, nspher2 )
             Do n=1, il2p_XI_vc(lmt1,lmt2)
                isph_XI_vc( lmt1, lmt2, n ) = isph2( nspher1, nspher2, n )
                dl2p_XI_vc( lmt1, lmt2, n ) = cr2  ( nspher1, nspher2, n )
             End do
          End Do
       End Do
    End Do

  end subroutine m_XI_set_dl2p_XI_vc

  subroutine m_XI_set_mat_dipole_corr_vc
    integer :: it, lmt1, lmt2, il1, il2, im1, im2, tau1, tau2
    integer :: nspher1, nspher2, itmp, ifact, index, atomtype_to_probe

    allocate( Mat_Dipole_corr_vc( nlmt_val, nlmt_core, 3 ) )
    Mat_Dipole_corr_vc = 0.0d0

    atomtype_to_probe = ityp( atom_to_probe )

    Do it = atomtype_to_probe, atomtype_to_probe
       Do lmt1=1, ilmt_val(it)
          if ( lmt1 <= ilmt(it) ) then
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it); tau1 = taup(lmt1,it)
          else
             itmp = lmt1 -ilmt(it)
             il1 = ltp_add(itmp,it); im1 = mtp_add(itmp,it);  tau1 = 1
          endif
          nspher1 = ( il1 -1 )**2 +im1

          Do lmt2=1, nlmt_core
             il2 = qnum_l_to_probe +1;  im2 = lmt2;  tau2 = 1
             nspher2 = ( il2 -1 )**2 +im2

             call m_CLS_find_ptrans_indx_core2val( qnum_n_to_probe, nspher2, nspher1, &
                  &                                tau1, index )
             ifact = -1

             if ( index /= 0 ) then
                Mat_Dipole_Corr_vc( lmt1, lmt2, 1:3 ) &
                     &      = dipole_dxyz_core2val( index, 1:3 ) *dble(ifact)
             endif
          End do
       End Do
    End Do

  end subroutine m_XI_set_mat_dipole_corr_vc

! --------------------------------------------------------
!    Calculation of transtion moment/matrix (val-val)
! --------------------------------------------------------

  subroutine m_XI_calc_transition_moment_vv

    if ( allocated( trm_vv ) ) deallocate( trm_vv )
    allocate( trm_vv( np_e, neg, ista_k:iend_k, 3 ) );   trm_vv = 0.0d0

    call calc_soft_part
    call calc_hard_part
    call multiply_factor

  contains

    subroutine multiply_factor
      integer :: ik, ib1, ib2, is
      real(kind=DP) :: ediff
      real(kind=DP), allocatable :: eko_mpi(:), eko_wk(:)

      allocate( eko_wk( neg ) ); eko_wk = 0.0d0

      Do ik=1, kv3, ndim_spinor
         if ( map_k(ik) /= myrank_k ) cycle

         eko_wk = 0.0d0
         Do ib1=ista_e, iend_e, istep_e
            eko_wk(ib1) = eko_l( map_z(ib1),ik )
         End do
         if ( npes > 1 ) then
            allocate( eko_mpi( neg ) ); eko_mpi = 0.0d0
            call mpi_allreduce( eko_wk, eko_mpi, neg, mpi_double_precision, mpi_sum, &
                 &              mpi_k_world(myrank_k), ierr )
            eko_wk = eko_mpi
            deallocate( eko_mpi )
         endif

         Do ib2=1, neg
            Do ib1=ista_e, iend_e, istep_e
               ediff = eko_wk(ib2) -eko_l(map_z(ib1),ik)
!
               if ( ib2 == ib1 ) then
                  ediff = delta_omega
               else if ( abs(ediff) < delta_omega ) then
                  if ( ediff >= 0.0 ) then
                     ediff = delta_omega
                  else
                     ediff = -delta_omega
                  endif
               else
                  if ( sw_scissor_renormalization == ON ) then
                     if ( eko_wk(ib2) > efermi .and. eko_l(map_z(ib1),ik ) <= efermi ) then
                        ediff = ediff +scissor
                     endif
                     if ( eko_wk(ib2) <= efermi .and. eko_l(map_z(ib1),ik ) > efermi ) then
                        ediff = ediff -scissor
                     endif
                  endif
               endif

               Do is=1, ndim_spinor
                  trm_vv( map_z(ib1),ib2,ik+is-1,: ) &
                       &   = trm_vv( map_z(ib1),ib2,ik+is-1,: ) /ediff
               End do

            End Do
        End Do
      End Do

      deallocate( eko_wk )

    end subroutine multiply_factor

    subroutine calc_soft_part
      integer :: ik, ib1, ib2, ig
      real(kind=DP), allocatable :: qx(:), qy(:), qz(:)
      real(kind=DP), allocatable :: wk_zaj(:,:)
      real(kind=DP) :: c1, c2
      complex(kind=CMPLDP) :: z1, z2, zsum(3)

      allocate( wk_zaj( kg1, kimg ) ); wk_zaj = 0.0d0

      allocate( qx(kg1) );  allocate( qy(kg1) ); allocate( qz(kg1) );
      qx = 0.0d0;  qy = 0.0d0;  qz = 0.0d0

      Do ik=1, kv3
         if ( map_k(ik) /= myrank_k ) cycle

         call k_plus_G_vectors_m( ik, kgp, kg1, kv3, iba, nbase, vkxyz, ngabc, &
              &                   rltv, qx, qy, qz )

         Do ib2=1, neg
            wk_zaj = 0.0d0
            if ( map_e(ib2) == myrank_e ) then
               wk_zaj(1:iba(ik),1:kimg) = zaj_l(1:iba(ik),map_z(ib2),ik,1:kimg)
            endif
            call mpi_bcast( wk_zaj, kg1*kimg, mpi_double_precision, map_e(ib2), &
                 &          mpi_k_world(myrank_k), ierr )

            Do ib1=ista_e, iend_e, istep_e
               zsum = 0.0d0
               if ( kimg == 1 ) then
                  Do ig=1, kg1
                     c1 = zaj_l(ig,map_z(ib1),ik,1)
                     c2 = c1 *wk_zaj(ig,1)
                     zsum(1) = zsum(1) +c2 *qx(ig)
                     zsum(2) = zsum(2) +c2 *qy(ig)
                     zsum(3) = zsum(3) +c2 *qz(ig)
                  End do
               else
                  Do ig=1, kg1
                     z1 = dcmplx( zaj_l(ig,map_z(ib1),ik,1), zaj_l(ig,map_z(ib1),ik,2) )
                     z2 = conjg(z1) *dcmplx( wk_zaj(ig,1), wk_zaj(ig,2) )
                     zsum(1) = zsum(1) +z2 *qx(ig)
                     zsum(2) = zsum(2) +z2 *qy(ig)
                     zsum(3) = zsum(3) +z2 *qz(ig)
                  End do
               endif
               trm_vv( map_z(ib1), ib2, ik, 1:3 ) = zsum(1:3)
            End do
         End do
      End Do

      trm_vv = trm_vv *zi

      deallocate( wk_zaj )
      deallocate( qx ); deallocate( qy ); deallocate( qz )

    end subroutine calc_soft_part

    subroutine calc_hard_part
      integer :: ia, it, ik, ib1, ib2
      integer :: lmt1, lmt2, il1, il2, im1, im2, it1, it2, itmp
      integer :: lmta1, lmta2
      real(kind=DP) :: fac
      complex(kind=CMPLDP) :: z1, z2, wf1, wf2
      complex(kind=CMPLDP), allocatable :: wk_fsri(:)
      complex(kind=CMPLDP), allocatable :: wk_fsri_add(:)

      allocate( wk_fsri(nlmta) ); wk_fsri = 0.0d0
      if ( sw_use_add_proj == ON ) then
         allocate( wk_fsri_add(nlmta_add) ); wk_fsri_add = 0.0d0
      endif

      Do ia=1, natm
         it = ityp(ia)

         Do ik=1, kv3
            if ( map_k(ik) /= myrank_k ) cycle

            Do ib2=1, neg
               wk_fsri = 0.0d0
               if ( map_e(ib2) == myrank_e ) then
                  wk_fsri(:) = dcmplx( fsr_l( map_z(ib2),:,ik ), &
                       &               fsi_l( map_z(ib2),:,ik ) )
               endif
               call mpi_bcast( wk_fsri, 2*nlmta, mpi_double_precision, map_e(ib2), &
                    &          mpi_k_world(myrank_k), ierr )

               if ( sw_use_add_proj == ON ) then
                  wk_fsri_add = 0.0d0
                  if ( map_e(ib2) == myrank_e ) then
                     wk_fsri_add(:) = dcmplx( fsr_add_l( map_z(ib2),:,ik ), &
                          &                   fsi_add_l( map_z(ib2),:,ik ) )
                  endif
                  call mpi_bcast( wk_fsri_add, 2*nlmta_add, mpi_double_precision, &
                       &          map_e(ib2), mpi_k_world(myrank_k), ierr )
               endif

               DO ib1=ista_e, iend_e, istep_e

                  Do lmt1=1, ilmt_val(it)
                     if ( lmt1 <= ilmt(it) ) then
                        il1 = ltp(lmt1,it); it1 = taup(lmt1,it)
                        lmta1 = lmta( lmt1,ia )
                        wf1 = dcmplx( fsr_l( map_z(ib1), lmta1, ik ), &
                             &        fsi_l( map_z(ib1), lmta1, ik ) )
                     else
                        itmp = lmt1 -ilmt(it)

                        il1 = ltp_add(itmp,it); it1 = 1
                        lmta1 = lmta_add( itmp,ia )
                        wf1 = dcmplx( fsr_add_l( map_z(ib1), lmta1, ik ), &
                             &        fsi_add_l( map_z(ib1), lmta1, ik ) )
                     endif

                     Do lmt2=1, ilmt_val(it)
                        fac = 1.0d0

                        if ( lmt2 <= ilmt(it) ) then
                           il2 = ltp(lmt2,it); it2 = taup(lmt2,it)
                           lmta2 = lmta( lmt2,ia )
                           wf2 = wk_fsri(lmta2)
                        else
                           itmp = lmt2 -ilmt(it)

                           il2 = ltp_add( itmp,it); it2 = 1
                           lmta2 = lmta_add( itmp,ia )
                           wf2 = wk_fsri_add(lmta2)
                        endif

                        z1 = conjg(wf1) *wf2

                        trm_vv( map_z(ib1), ib2, ik, 1:3 ) &
                             &  = trm_vv( map_z(ib1), ib2, ik, 1:3 ) &
                             &    + z1 *Mat_Dipole_Corr_vv( it,lmt1,lmt2,1:3 )
                     End do
                  End Do
               End Do
            End DO
         End Do
      End Do

      deallocate( wk_fsri )
      if ( allocated( wk_fsri_add ) ) deallocate( wk_fsri_add )

    end subroutine calc_hard_part

  end subroutine m_XI_calc_transition_moment_vv

  subroutine m_XI_set_RhoTilde_vv

    allocate( RhoTilde_vv( nmax_G, np_e, neg, ista_k:iend_k ) )
    RhoTilde_vv = 0.0d0

    call calc_soft_part
    call calc_hard_part

  contains

    subroutine calc_soft_part
      integer :: ik, ib1, ib2, i, i1, ngrid
      real(kind=DP), allocatable :: afft(:), bfft(:), cfft(:)
      real(kind=DP), allocatable :: psi_l(:,:,:,:)

      allocate( afft(nfft) ); afft = 0.0d0
      allocate( bfft(nfft) ); bfft = 0.0d0
      allocate( cfft(nfft) ); cfft = 0.0d0

      call m_FFT_alloc_WF_work()
! --
      ngrid = product(fft_box_size_WF(1:3,1))

      Do ik=1, kv3
         if ( map_k(ik) /= myrank_k ) cycle

         allocate( psi_l( kg1, np_e, ik:ik, kimg ) ); psi_l = 0.0d0

         Do ib2=1, neg
            bfft = 0.0d0
            if ( map_e(ib2) == myrank_e ) then
               psi_l(1:iba(ik),map_z(ib2),ik,:) = zaj_l(1:iba(ik),map_z(ib2),ik,:)
               call m_ES_WF_in_Rspace1( ik, ik, ik, ib2, psi_l, bfft )
            endif
            call mpi_bcast( bfft, nfft, mpi_double_precision, map_e(ib2), &
                 &          mpi_k_world(myrank_k), ierr )

            Do ib1=ista_e, iend_e, istep_e
               psi_l(1:iba(ik),map_z(ib1),ik,:) = zaj_l(1:iba(ik),map_z(ib1),ik,:)
               call m_ES_WF_in_Rspace1( ik, ik, ik, ib1, psi_l, afft )

               cfft = 0.0d0
               if ( imple_method == 1 ) then
                  Do i=1, nfft, 2
                     cfft(i)   = afft(i)*bfft(i)   +afft(i+1)*bfft(i+1)
                     cfft(i+1) =-afft(i)*bfft(i+1) +afft(i+1)*bfft(i)
                  End Do
               else
                  Do i=1, nfft, 2
                     cfft(i)   = afft(i)*bfft(i)   +afft(i+1)*bfft(i+1)
                     cfft(i+1) = afft(i)*bfft(i+1) -afft(i+1)*bfft(i)
                  End do
               endif

               call m_FFT_WF( ELECTRON, nfout, cfft, DIRECT, OFF )    ! R-->G
               cfft = cfft /dble(ngrid)

               if ( kimg == 1 ) then
                  Do i=1, nmax_G
                     i1 = igf( nbase(i,ik) )
                     RhoTilde_vv( i, map_z(ib1), ib2, ik ) = cfft(i1)
                  End do
               else
                  if ( imple_method == 2  ) then
                     Do i=1, nmax_G
                        i1 =2*igf( nbase(i,ik) ) -1
                        RhoTilde_vv( i, map_z(ib1), ib2, ik ) &
                             &          = dcmplx( cfft(i1), -cfft(i1+1) )  
                     End do
                  else
                     Do i=1, nmax_G
                        i1 =2*igf( nbase(i,ik) ) -1
                        RhoTilde_vv( i, map_z(ib1), ib2, ik ) &
                             &          = dcmplx( cfft(i1), cfft(i1+1) )   
                     End do
                  endif
               endif
            End Do
         End Do

         deallocate( psi_l )
      End Do

      deallocate( afft ); deallocate( bfft ); deallocate( cfft )
      call m_FFT_dealloc_WF_work()

    end subroutine calc_soft_part

    subroutine calc_hard_part
      integer :: ik, ib1, ib2, ia, it, ig
      integer :: lmt1, lmt2, it1, it2, il1, il2, n
      integer :: lmta1, lmta2, ilm3, l3, iiqitg, mdvdb
      real(kind=DP) :: fac
      complex(kind=CMPLDP) :: wf1, wf2, z1, z2, zph

      integer, allocatable :: il3(:)
      real(kind=DP), allocatable :: zfsin(:), zfcos(:), qx(:), qy(:), qz(:), ylm(:)
      complex(kind=CMPLDP), allocatable :: wk_fsri(:), wk_fsri_add(:)

      integer :: j, itmp

! -- init
      allocate( zfcos( nmax_G ) ); zfcos = 0.0d0
      allocate( zfsin( nmax_G ) ); zfsin = 0.0d0

      n = nloc
      n=(n-1)+(n-1)+1

      allocate(il3(n**2));call substitute_il3(n**2,il3)

      allocate( qx(nmax_G) ); allocate( qy(nmax_G) ); allocate( qz(nmax_G) )
      allocate( ylm(nmax_G) )

      Do ig=1, nmax_G
         qx(ig) = rltv(1,1)*ngabc(ig,1) +rltv(1,2)*ngabc(ig,2) +rltv(1,3)*ngabc(ig,3)
         qy(ig) = rltv(2,1)*ngabc(ig,1) +rltv(2,2)*ngabc(ig,2) +rltv(2,3)*ngabc(ig,3)
         qz(ig) = rltv(3,1)*ngabc(ig,1) +rltv(3,2)*ngabc(ig,2) +rltv(3,3)*ngabc(ig,3)
      End do

      allocate( wk_fsri(nlmta) ); wk_fsri = 0.0d0
      if ( sw_use_add_proj == ON ) then
         allocate( wk_fsri_add(nlmta_add) ); wk_fsri_add = 0.0d0
      endif

! -- start
      Do ia=1, natm
         it = ityp(ia)

         call calc_phase2(natm,pos,ia,kgp,ngabc,1,nmax_G,zfcos,zfsin)

         Do ik=1, kv3
            if ( map_k(ik) /= myrank_k ) cycle

            Do ib2=1, neg
               wk_fsri = 0.0d0
               if ( map_e(ib2) == myrank_e ) then
                  wk_fsri(:) = dcmplx( fsr_l( map_z(ib2),:,ik ), &
                       &               fsi_l( map_z(ib2),:,ik ) )
               endif
               call mpi_bcast( wk_fsri, 2*nlmta, mpi_double_precision, map_e(ib2), &
                    &          mpi_k_world(myrank_k), ierr )

               if ( sw_use_add_proj == ON ) then
                  wk_fsri_add = 0.0d0
                  if ( map_e(ib2) == myrank_e ) then
                     wk_fsri_add(:) = dcmplx( fsr_add_l( map_z(ib2),:,ik ), &
                          &                   fsi_add_l( map_z(ib2),:,ik ) )
                  endif
                  call mpi_bcast( wk_fsri_add, 2*nlmta_add, mpi_double_precision, &
                       &          map_e(ib2), mpi_k_world(myrank_k), ierr )
               endif

               DO ib1=ista_e, iend_e, istep_e

                  Do lmt1=1, ilmt_val(it)
                     if ( lmt1 <= ilmt(it) ) then
                        il1 = ltp(lmt1,it); it1 = taup(lmt1,it)
                        lmta1 = lmta( lmt1,ia )
                        wf1 = dcmplx( fsr_l( map_z(ib1), lmta1, ik ), &
                             &        fsi_l( map_z(ib1), lmta1, ik ) )
                     else
                        itmp = lmt1 -ilmt(it)

                        il1 = ltp_add(itmp,it); it1 = 1
                        lmta1 = lmta_add( itmp,ia )
                        wf1 = dcmplx( fsr_add_l( map_z(ib1), lmta1, ik ), &
                             &        fsi_add_l( map_z(ib1), lmta1, ik ) )
                     endif

!#if 0
!                     Do lmt2=lmt1, ilmt(it)
!#else
                     Do lmt2=1, ilmt_val(it)
!#endif
                        if ( lmt2 <= ilmt(it) ) then
                           il2 = ltp(lmt2,it); it2 = taup(lmt2,it)
                           lmta2 = lmta( lmt2,ia )
                           wf2 = wk_fsri(lmta2)
                        else
                           itmp = lmt2 -ilmt(it)

                           il2 = ltp_add( itmp,it); it2 = 1
                           lmta2 = lmta_add( itmp,ia )
                           wf2 = wk_fsri_add(lmta2)
                        endif

!#if 0
!                        if ( lmt1 == lmt2 ) then
!                           fac = 1.0d0
!                        else
!                           fac = 2.0d0
!                        endif
!#else
                        fac = 1.0d0
!#endif
                        do n=1,il2p_XI_vv(lmt1,lmt2,it)

                           ilm3 = isph_XI_vv(lmt1,lmt2,n,it); l3=il3(ilm3)
                           iiqitg = iqitg_XI_vv(il1,it1,il2,it2,l3+1,it)

                           if(iiqitg == 0) cycle

                           call sphr( nmax_G, ilm3, qx, qy, qz, ylm )

!#if 0
!                           z1 = conjg(wf1) *wf2
!                           z2 = wf1 *conjg(wf2)
!                           z1 = ( z1+z2) /2.0d0 *zi**l3 *dl2p(lmt1,lmt2,n,it)
!#else
                           z1 = conjg(wf1) *wf2 *zi**l3 *dl2p_XI_vv(lmt1,lmt2,n,it)
!#endif
                           if ( imple_method == 1 ) then
                              Do ig=1, nmax_G
                                 z2 = qitg_XI_vv( ig,iiqitg ) *ylm(ig)
                                 zph = dcmplx( zfcos(ig), -zfsin(ig) )   

                                 RhoTilde_vv( ig, map_z(ib1), ib2, ik ) &
                                      & = RhoTilde_vv( ig, map_z(ib1), ib2, ik ) &
                                      &   + fac *z1 *z2 *zph
                              End do
                           else
                              Do ig=1, nmax_G
                                 z2 = qitg_XI_vv( ig,iiqitg ) *ylm(ig)
                                 zph = dcmplx( zfcos(ig), zfsin(ig) )     

                                 RhoTilde_vv( ig, map_z(ib1), ib2, ik ) &
                                      & = RhoTilde_vv( ig, map_z(ib1), ib2, ik ) &
                                      &   + fac *z1 *z2 *zph
                              End do
                           endif

                        End do
                     End do
                 End do
               End do
            End Do
         End DO
      End Do

      deallocate( il3 ); deallocate( ylm )
      deallocate( qx ); deallocate( qy ); deallocate( qz );
      deallocate( zfcos ); deallocate( zfsin )

      deallocate( wk_fsri )
      if ( allocated( wk_fsri_add ) ) deallocate( wk_fsri_add )

    end subroutine calc_hard_part

  end subroutine m_XI_set_RhoTilde_vv

! --------------------------------------------------------
!    Calculation of transtion moment/matrix (val-core)
! --------------------------------------------------------

  subroutine m_XI_calc_transition_moment_vc

    if ( allocated( trm_vc ) ) deallocate( trm_vc )
    allocate( trm_vc( np_e, num_core_states, ista_k:iend_k, 3 ) ); trm_vc = 0.0d0

    call calc_soft_part
    call calc_hard_part
    call multiply_factor

  contains

    subroutine multiply_factor
      integer :: ik, ib1, ib2, is
      real(kind=DP) :: ediff
      real(kind=DP), allocatable :: eko_mpi(:), eko_wk(:)

      allocate( eko_wk( num_core_states ) ); eko_wk = 0.0d0

      Do ik=1, kv3, ndim_spinor
         if ( map_k(ik) /= myrank_k ) cycle

         eko_wk = ene_core_states

         Do ib2=1, num_core_states
            Do ib1=ista_e, iend_e, istep_e
               ediff = eko_wk(ib2) -eko_l(map_z(ib1),ik)

               if ( abs(ediff) < delta_omega ) then
                  if ( ediff >= 0.0 ) then
                     ediff = delta_omega
                  else
                     ediff = -delta_omega
                  endif
               else
                  if ( sw_scissor_renormalization == ON ) then
                     if ( eko_l(map_z(ib1),ik ) > efermi ) then
                        ediff = ediff -scissor
                     endif
                  endif
               endif

               Do is=1, ndim_spinor
                  trm_vc( map_z(ib1),ib2,ik+is-1,: ) &
                       &   = trm_vc( map_z(ib1),ib2,ik+is-1,: ) /ediff
               End do

            End Do
         End Do
      End Do

      deallocate( eko_wk )

    end subroutine multiply_factor

    subroutine calc_soft_part
      integer :: ik, ib1, ib2, ig
      real(kind=DP), allocatable :: qx(:), qy(:), qz(:)
      real(kind=DP), allocatable :: wk_zaj(:,:)
      real(kind=DP) :: c1, c2
      complex(kind=CMPLDP) :: z1, z2, zsum(3)

      allocate( wk_zaj( kg1, kimg ) ); wk_zaj = 0.0d0

      allocate( qx(kg1) );  allocate( qy(kg1) ); allocate( qz(kg1) );
      qx = 0.0d0;  qy = 0.0d0;  qz = 0.0d0

      Do ik=1, kv3
         if ( map_k(ik) /= myrank_k ) cycle

         call k_plus_G_vectors_m( ik, kgp, kg1, kv3, iba, nbase, vkxyz, ngabc, &
              &                   rltv, qx, qy, qz )

         Do ib2=1, num_core_states
            wk_zaj(1:iba(ik),1:kimg) = psig_core_states(1:iba(ik),ib2,ik,1:kimg)

            Do ib1=ista_e, iend_e, istep_e
               zsum = 0.0d0
               if ( kimg == 1 ) then
                  Do ig=1, kg1
                     c1 = zaj_l(ig,map_z(ib1),ik,1)
                     c2 = c1 *wk_zaj(ig,1)
                     zsum(1) = zsum(1) +c2 *qx(ig)
                     zsum(2) = zsum(2) +c2 *qy(ig)
                     zsum(3) = zsum(3) +c2 *qz(ig)
                  End do
               else
                  Do ig=1, kg1
                     z1 = dcmplx( zaj_l(ig,map_z(ib1),ik,1), zaj_l(ig,map_z(ib1),ik,2) )
                     z2 = conjg(z1) *dcmplx( wk_zaj(ig,1), wk_zaj(ig,2) )
                     zsum(1) = zsum(1) +z2 *qx(ig)
                     zsum(2) = zsum(2) +z2 *qy(ig)
                     zsum(3) = zsum(3) +z2 *qz(ig)
                  End do
               endif
               trm_vc( map_z(ib1), ib2, ik, 1:3 ) = zsum(1:3)
            End do
         End do
      End Do

      trm_vc = trm_vc *zi

      deallocate( wk_zaj )
      deallocate( qx ); deallocate( qy ); deallocate( qz )

    end subroutine calc_soft_part

    subroutine calc_hard_part
      integer :: ia, it, ik, ib1, ib2
      integer :: lmt1, lmt2, il1, il2, im1, im2, it1, it2, itmp
      integer :: lmta1, lmta2, atomtype_to_probe
      real(kind=DP) :: fac
      complex(kind=CMPLDP) :: z1, z2, wf1, wf2
      complex(kind=CMPLDP), allocatable :: wk_fsri(:)
      complex(kind=CMPLDP), allocatable :: wk_fsri_add(:)

      allocate( wk_fsri(nlmt_core) ); wk_fsri = 0.0d0

      atomtype_to_probe = ityp( atom_to_probe )
      it = atomtype_to_probe

      Do ia = atom_to_probe, atom_to_probe
         it = ityp(ia)

         Do ik=1, kv3
            if ( map_k(ik) /= myrank_k ) cycle

            Do ib2=1, num_core_states
               wk_fsri(:) = dcmplx( fsr_core_states( ib2,:,ik ), &
                    &               fsi_core_states( ib2,:,ik ) )

               DO ib1=ista_e, iend_e, istep_e

                  Do lmt1=1, ilmt_val(it)
                     if ( lmt1 <= ilmt(it) ) then
                        il1 = ltp(lmt1,it); it1 = taup(lmt1,it)
                        lmta1 = lmta( lmt1,ia )
                        wf1 = dcmplx( fsr_l( map_z(ib1), lmta1, ik ), &
                             &        fsi_l( map_z(ib1), lmta1, ik ) )
                     else
                        itmp = lmt1 -ilmt(it)

                        il1 = ltp_add(itmp,it); it1 = 1
                        lmta1 = lmta_add( itmp,ia )
                        wf1 = dcmplx( fsr_add_l( map_z(ib1), lmta1, ik ), &
                             &        fsi_add_l( map_z(ib1), lmta1, ik ) )
                     endif

                     Do lmt2=1, nlmt_core
                        fac = 1.0d0

                        wf2 = wk_fsri(lmt2)
                        z1 = conjg(wf1) *wf2

                        trm_vc( map_z(ib1), ib2, ik, 1:3 ) &
                             &  = trm_vc( map_z(ib1), ib2, ik, 1:3 ) &
                             &    + z1 *Mat_Dipole_Corr_vc( lmt1,lmt2,1:3 )
                     End do
                  End Do
               End Do
            End DO
         End Do
      End Do

      deallocate( wk_fsri )

    end subroutine calc_hard_part

  end subroutine m_XI_calc_transition_moment_vc

  subroutine m_XI_set_RhoTilde_vc

    allocate( RhoTilde_vc( nmax_G, np_e, num_core_states, ista_k:iend_k ) )
    RhoTilde_vc = 0.0d0

    call calc_soft_part
    call calc_hard_part

  contains

    subroutine calc_soft_part
      integer :: ik, ib1, ib2, i, i1, ngrid
      real(kind=DP), allocatable :: afft(:), bfft(:), cfft(:)
      real(kind=DP), allocatable :: psi_l(:,:,:,:)

      allocate( afft(nfft) ); afft = 0.0d0
      allocate( bfft(nfft) ); bfft = 0.0d0
      allocate( cfft(nfft) ); cfft = 0.0d0

      call m_FFT_alloc_WF_work()
! --
      ngrid = product(fft_box_size_WF(1:3,1))

      Do ik=1, kv3
         if ( map_k(ik) /= myrank_k ) cycle

         allocate( psi_l( kg1, 1, ik:ik, kimg ) ); psi_l = 0.0d0

         Do ib2=1, num_core_states
            bfft = 0.0d0
            psi_l(1:iba(ik),1,ik,:) = psig_core_states(1:iba(ik),ib2,ik,:)
            call m_ES_WF_in_Rspace_kt( ik, ik, ik, psi_l, bfft )

            Do ib1=ista_e, iend_e, istep_e
               psi_l(1:iba(ik),1,ik,:) = zaj_l(1:iba(ik),map_z(ib1),ik,:)
               call m_ES_WF_in_Rspace_kt( ik, ik, ik, psi_l, afft )

               cfft = 0.0d0
               if ( imple_method == 1 ) then
                  Do i=1, nfft, 2
                     cfft(i)   = afft(i)*bfft(i)   +afft(i+1)*bfft(i+1)
                     cfft(i+1) =-afft(i)*bfft(i+1) +afft(i+1)*bfft(i)
                  End Do
               else
                  Do i=1, nfft, 2
                     cfft(i)   = afft(i)*bfft(i)   +afft(i+1)*bfft(i+1)
                     cfft(i+1) = afft(i)*bfft(i+1) -afft(i+1)*bfft(i)
                  End do
               endif

               call m_FFT_WF( ELECTRON, nfout, cfft, DIRECT, OFF )    ! R-->G
               cfft = cfft /dble(ngrid)

               if ( kimg == 1 ) then
                  Do i=1, nmax_G
                     i1 = igf( nbase(i,ik) )
                     RhoTilde_vc( i, map_z(ib1), ib2, ik ) = cfft(i1)
                  End do
               else
                  if ( imple_method == 1 ) then
                     Do i=1, nmax_G
                        i1 =2*igf( nbase(i,ik) ) -1
                        RhoTilde_vc( i, map_z(ib1), ib2, ik ) &
                             &          = dcmplx( cfft(i1), -cfft(i1+1) )  ! gpaw
                     End do
                  else
                     Do i=1, nmax_G
                        i1 =2*igf( nbase(i,ik) ) -1
                        RhoTilde_vc( i, map_z(ib1), ib2, ik ) &
                             &          = dcmplx( cfft(i1), cfft(i1+1) )
                     End do
                  endif
               endif
            End Do
         End Do

         deallocate( psi_l )
      End Do

      deallocate( afft ); deallocate( bfft ); deallocate( cfft )
      call m_FFT_dealloc_WF_work()

    end subroutine calc_soft_part

    subroutine calc_hard_part
      integer :: ik, ib1, ib2, ia, it, ig
      integer :: lmt1, lmt2, it1, it2, il1, il2, n
      integer :: lmta1, lmta2, ilm3, l3, iiqitg, mdvdb
      real(kind=DP) :: fac
      complex(kind=CMPLDP) :: wf1, wf2, z1, z2, zph

      integer, allocatable :: il3(:)
      real(kind=DP), allocatable :: zfsin(:), zfcos(:), qx(:), qy(:), qz(:), ylm(:)
      complex(kind=CMPLDP), allocatable :: wk_fsri(:)
      complex(kind=CMPLDP), allocatable :: wk_fsri_add(:)

      integer :: j, itmp

! -- init
      allocate( zfcos( nmax_G ) ); zfcos = 0.0d0
      allocate( zfsin( nmax_G ) ); zfsin = 0.0d0

      n = nloc
      n=(n-1)+(n-1)+1

      allocate(il3(n**2));call substitute_il3(n**2,il3)

      allocate( qx(nmax_G) ); allocate( qy(nmax_G) ); allocate( qz(nmax_G) )
      allocate( ylm(nmax_G) )

      Do ig=1, nmax_G
         qx(ig) = rltv(1,1)*ngabc(ig,1) +rltv(1,2)*ngabc(ig,2) +rltv(1,3)*ngabc(ig,3)
         qy(ig) = rltv(2,1)*ngabc(ig,1) +rltv(2,2)*ngabc(ig,2) +rltv(2,3)*ngabc(ig,3)
         qz(ig) = rltv(3,1)*ngabc(ig,1) +rltv(3,2)*ngabc(ig,2) +rltv(3,3)*ngabc(ig,3)
      End do

      allocate( wk_fsri(nlmt_core) ); wk_fsri = 0.0d0

! -- start
      Do ia=1, natm
         it = ityp(ia)

         call calc_phase2(natm,pos,ia,kgp,ngabc,1,nmax_G,zfcos,zfsin)

         Do ik=1, kv3
            if ( map_k(ik) /= myrank_k ) cycle

            Do ib2=1, num_core_states
               wk_fsri = 0.0d0
               wk_fsri(:) = dcmplx( fsr_core_states( ib2,:,ik ), &
                       &            fsi_core_states( ib2,:,ik ) )
               
               DO ib1=ista_e, iend_e, istep_e

                  Do lmt1=1, ilmt_val(it)
                     if ( lmt1 <= ilmt(it) ) then
                        il1 = ltp(lmt1,it); it1 = taup(lmt1,it)
                        lmta1 = lmta( lmt1,ia )
                        wf1 = dcmplx( fsr_l( map_z(ib1), lmta1, ik ), &
                             &        fsi_l( map_z(ib1), lmta1, ik ) )
                     else
                        itmp = lmt1 -ilmt(it)

                        il1 = ltp_add(itmp,it); it1 = 1
                        lmta1 = lmta_add( itmp,ia )
                        wf1 = dcmplx( fsr_add_l( map_z(ib1), lmta1, ik ), &
                             &        fsi_add_l( map_z(ib1), lmta1, ik ) )
                     endif

                     Do lmt2=1, nlmt_core
                        il2 = qnum_l_to_probe +1; it2 = 1
                        wf2 = wk_fsri(lmt2)

                        fac = 1.0d0

                        do n=1,il2p_XI_vc(lmt1,lmt2)

                           ilm3 = isph_XI_vc(lmt1,lmt2,n); l3=il3(ilm3)
                           iiqitg = iqitg_XI_vc(il1,it1,l3+1)

                           if(iiqitg == 0) cycle

                           call sphr( nmax_G, ilm3, qx, qy, qz, ylm )

!#if 0
!                           z1 = conjg(wf1) *wf2
!                           z2 = wf1 *conjg(wf2)
!                           z1 = ( z1+z2) /2.0d0 *zi**l3 *dl2p(lmt1,lmt2,n,it)
!#else
                           z1 = conjg(wf1) *wf2 *zi**l3 *dl2p_XI_vc(lmt1,lmt2,n)
!#endif
                           if ( imple_method == 1 ) then
                              Do ig=1, nmax_G
                                 z2 = qitg_XI_vc( ig,iiqitg ) *ylm(ig)
                                 zph = dcmplx( zfcos(ig), -zfsin(ig) )

                                 RhoTilde_vc( ig, map_z(ib1), ib2, ik ) &
                                      & = RhoTilde_vc( ig, map_z(ib1), ib2, ik ) &
                                      &   + fac *z1 *z2 *zph
                              End do
                           else
                              Do ig=1, nmax_G
                                 z2 = qitg_XI_vc( ig,iiqitg ) *ylm(ig)
                                 zph = dcmplx( zfcos(ig), zfsin(ig) ) 

                                 RhoTilde_vc( ig, map_z(ib1), ib2, ik ) &
                                      & = RhoTilde_vc( ig, map_z(ib1), ib2, ik ) &
                                      &   + fac *z1 *z2 *zph
                              End do
                           endif

                        End do
                     End do
                  End do
               End do
            End Do
         End DO
      End Do

      deallocate( il3 );  deallocate( ylm )
      deallocate( qx ); deallocate( qy ); deallocate( qz )
      deallocate( zfcos ); deallocate( zfsin )

      deallocate( wk_fsri )

    end subroutine calc_hard_part

  end subroutine m_XI_set_RhoTilde_vc

! --------------------------------------------------------
!    Calculation of transtion moment/matrix (core-core)
! --------------------------------------------------------
  subroutine m_XI_calc_transition_moment_cc
!
    if ( allocated( trm_cc ) ) deallocate( trm_cc )
    allocate( trm_cc( num_core_states, num_core_states, ista_k:iend_k, 3 ) );
    trm_cc = 0.0d0

    call calc_soft_part
    call multiply_factor

  contains

    subroutine multiply_factor
      integer :: ik, ib1, ib2, is
      real(kind=DP) :: ediff
      real(kind=DP), allocatable :: eko_mpi(:), eko_wk(:)

      Do ik=1, kv3, ndim_spinor
         if ( map_k(ik) /= myrank_k ) cycle

         Do ib2=1, num_core_states
            Do ib1=1, num_core_states

               ediff = ene_core_states(ib2) -ene_core_states(ib1)

               if ( ib2 == ib1 ) then
                  ediff = delta_omega
               else if ( abs(ediff) < delta_omega ) then
                  if ( ediff >= 0.0 ) then
                     ediff = delta_omega
                  else
                     ediff = -delta_omega
                  endif
               endif

               Do is=1, ndim_spinor
                  trm_cc( ib1,ib2,ik+is-1,: ) &
                       &   = trm_cc( ib1,ib2,ik+is-1,: ) /ediff
               End do

            End Do
         End Do
      End Do

    end subroutine multiply_factor

    subroutine calc_soft_part
      integer :: ik, ib1, ib2, ig
      real(kind=DP), allocatable :: qx(:), qy(:), qz(:)
      real(kind=DP), allocatable :: wk_zaj(:,:)
      real(kind=DP) :: c1, c2
      complex(kind=CMPLDP) :: z1, z2, zsum(3)

      allocate( qx(kg1) );  allocate( qy(kg1) ); allocate( qz(kg1) );
      qx = 0.0d0;  qy = 0.0d0;  qz = 0.0d0

      Do ik=1, kv3
         if ( map_k(ik) /= myrank_k ) cycle

         call k_plus_G_vectors_m( ik, kgp, kg1, kv3, iba, nbase, vkxyz, ngabc, &
              &                   rltv, qx, qy, qz )

         Do ib2=1, num_core_states

            Do ib1=1, num_core_states
               zsum = 0.0d0
               if ( kimg == 1 ) then
                  Do ig=1, kg1
                     c1 = psig_core_states(ig,ib1,ik,1)
                     c2 = c1 *psig_core_states(ig,ib2,ik,1)

                     zsum(1) = zsum(1) +c2 *qx(ig)
                     zsum(2) = zsum(2) +c2 *qy(ig)
                     zsum(3) = zsum(3) +c2 *qz(ig)
                  End do
               else
                  Do ig=1, kg1
                     z1 = dcmplx( psig_core_states(ig,ib1,ik,1), &
                          &       psig_core_states(ig,ib1,ik,2) )
                     z2 = conjg(z1) *dcmplx( psig_core_states(ig,ib2,ik,1), &
                          &                  psig_core_states(ig,ib2,ik,2) )

                     zsum(1) = zsum(1) +z2 *qx(ig)
                     zsum(2) = zsum(2) +z2 *qy(ig)
                     zsum(3) = zsum(3) +z2 *qz(ig)
                  End do
               endif
               trm_cc( ib1, ib2, ik, 1:3 ) = zsum(1:3)
            End do
         End do
      End Do
      trm_cc = trm_cc *zi

      deallocate( qx ); deallocate( qy ); deallocate( qz )

    end subroutine calc_soft_part

  end subroutine m_XI_calc_transition_moment_cc

  subroutine m_XI_set_RhoTilde_cc

    allocate( RhoTilde_cc( nmax_G, num_core_states, num_core_states, ista_k:iend_k ) )
    RhoTilde_cc = 0.0d0

    call calc_soft_part

  contains
    subroutine calc_soft_part
      integer :: ik, ib1, ib2, i, i1, ngrid
      real(kind=DP), allocatable :: afft(:), bfft(:), cfft(:)
      real(kind=DP), allocatable :: psi_l(:,:,:,:)

      allocate( afft(nfft) ); afft = 0.0d0
      allocate( bfft(nfft) ); bfft = 0.0d0
      allocate( cfft(nfft) ); cfft = 0.0d0

      call m_FFT_alloc_WF_work()
! --
      ngrid = product(fft_box_size_WF(1:3,1))

      Do ik=1, kv3
         if ( map_k(ik) /= myrank_k ) cycle

         allocate( psi_l( kg1, 1, ik:ik, kimg ) ); psi_l = 0.0d0

         Do ib2=1, num_core_states
            bfft = 0.0d0
            psi_l(1:iba(ik),1,ik,:) = psig_core_states(1:iba(ik),ib2,ik,:)
            call m_ES_WF_in_Rspace_kt( ik, ik, ik, psi_l, bfft )

            Do ib1=1, num_core_states
               psi_l(1:iba(ik),1,ik,:) = psig_core_states(1:iba(ik),ib1,ik,:)
               call m_ES_WF_in_Rspace_kt( ik, ik, ik, psi_l, afft )

               cfft = 0.0d0
               if ( imple_method == 1 ) then
                  Do i=1, nfft, 2
                     cfft(i)   = afft(i)*bfft(i)   +afft(i+1)*bfft(i+1)
                     cfft(i+1) =-afft(i)*bfft(i+1) +afft(i+1)*bfft(i)
                  End Do
               else
                  Do i=1, nfft, 2
                     cfft(i)   = afft(i)*bfft(i)   +afft(i+1)*bfft(i+1)
                     cfft(i+1) = afft(i)*bfft(i+1) -afft(i+1)*bfft(i)
                  End do
               endif

               call m_FFT_WF( ELECTRON, nfout, cfft, DIRECT, OFF )    ! R-->G
               cfft = cfft /dble(ngrid)

               if ( kimg == 1 ) then
                  Do i=1, nmax_G
                     i1 = igf( nbase(i,ik) )
                     RhoTilde_cc( i, ib1, ib2, ik ) = cfft(i1)
                  End do
               else
                  if ( imple_method == 1 ) then
                     Do i=1, nmax_G
                        i1 =2*igf( nbase(i,ik) ) -1
                        RhoTilde_cc( i, ib1, ib2, ik ) &
                             &          = dcmplx( cfft(i1), -cfft(i1+1) )  ! gpaw
                     End do
                  else
                     Do i=1, nmax_G
                        i1 =2*igf( nbase(i,ik) ) -1
                        RhoTilde_cc( i, ib1, ib2, ik ) &
                             &          = dcmplx( cfft(i1), cfft(i1+1) )
                     End do
                  endif

               endif
            End Do
         End Do

         deallocate( psi_l )
      End Do

      deallocate( afft ); deallocate( bfft ); deallocate( cfft )
      call m_FFT_dealloc_WF_work()

    end subroutine calc_soft_part

  end subroutine m_XI_set_RhoTilde_cc

! --------------------------------------------------------
!    Finalization
! --------------------------------------------------------

  subroutine m_XI_dealloc_arrays
    if ( allocated(ilmt_val) ) deallocate( ilmt_val )
    if ( allocated(ngpt_XI) ) deallocate( ngpt_XI )

! val-val
    if ( allocated( iqitg_XI_vv ) ) deallocate( iqitg_XI_vv )
    if ( allocated( nqitg_XI_vv ) ) deallocate( nqitg_XI_vv )
    if ( allocated(  qitg_XI_vv ) ) deallocate(  qitg_XI_vv )
    if ( allocated(  isph_XI_vv ) ) deallocate(  isph_XI_vv )
    if ( allocated(  il2p_XI_vv ) ) deallocate(  il2p_XI_vv )
    if ( allocated(  dl2p_XI_vv ) ) deallocate(  dl2p_XI_vv )
!
    if ( allocated( Mat_dipole_corr_vv ) ) deallocate( Mat_dipole_corr_vv )

    if ( allocated( trm_vv ) )  deallocate( trm_vv )
    if ( allocated( RhoTilde_vv ) ) deallocate( RhoTilde_vv )
    if ( allocated( SpectrFn_vv ) ) deallocate( SpectrFn_vv )
    if ( allocated( SpectrTensor_vv ) ) deallocate( SpectrTensor_vv )

! val-core
    if ( allocated( iqitg_XI_vc ) ) deallocate( iqitg_XI_vc )
    if ( allocated(  qitg_XI_vc ) ) deallocate(  qitg_XI_vc )
    if ( allocated(  isph_XI_vc ) ) deallocate(  isph_XI_vc )
    if ( allocated(  il2p_XI_vc ) ) deallocate(  il2p_XI_vc )
    if ( allocated(  dl2p_XI_vc ) ) deallocate(  dl2p_XI_vc )
!
    if ( allocated( Mat_dipole_corr_vc ) ) deallocate( Mat_dipole_corr_vc )

    if ( allocated( trm_vc ) )  deallocate( trm_vc )
    if ( allocated( RhoTilde_vc ) ) deallocate( RhoTilde_vc )
    if ( allocated( SpectrFn_vc ) ) deallocate( SpectrFn_vc )
    
! core-core
    if ( allocated( trm_cc ) )  deallocate( trm_cc )
    if ( allocated( RhoTilde_cc ) ) deallocate( RhoTilde_cc )

! Kernel
    if ( allocated( Kernel_Coulomb ) ) deallocate( Kernel_Coulomb )

  end subroutine m_XI_dealloc_arrays

! --------------------------------------------------------
!    Spectrum
! --------------------------------------------------------

  subroutine m_XI_init_spectrum
    real(kind=DP) :: emin

    if ( sw_bse == ON ) then
       allocate( epsinv_omega0( nmax_G, nmax_G ) ) ; epsinv_omega0 = 0.0d0
    endif
    call m_Files_open_nf_xi_spectra()

    if ( sw_corelevel_spectrum == ON ) then
       emin = efermi - maxval( ene_core_states ) +scissor
       e_low  = e_low +emin
       e_high = e_high +emin
    endif

#ifdef USE_ASMS_EXCITATION
    call ASMS_XI_setup( nspin, kv3_fbz, univol, nmax_G, qvec, &
         &              way_BZ_integral, width, gaussian_extent, &
         &              nstep, e_low, e_high, e_step, &
         &              nfout, nf_excitation_spectra, &
         &              npes, mype, mpi_comm_group, &
         &              sw_nlf, kernel_xc_type, alpha_LRC, spectrum_type, &
         &              sw_spin_decomposition )
#endif

  end subroutine m_XI_init_spectrum

! --------------------------------------------------------
!    Calculation of SpectrFn (val-val)
! --------------------------------------------------------

  subroutine m_XI_calc_spectr_fn_vv_spindec
    integer :: i, ik, jk, iopr, trev
    integer :: ig1, ig2, itmp, ib1, ib2, is1, is2, ispin
    complex(kind=CMPLDP), allocatable :: work(:,:,:)
    real(kind=DP) :: qvec_rotated(3), weight

    real(kind=DP) :: ediff, odiff, occ1, occ2, qv2, txyz(3), fp
    complex(kind=CMPLDP) :: zrho1, zrho2, ztmp, z1, zph

    real(kind=DP), allocatable :: eko_mpi(:), eko_wk(:)
    real(kind=DP), allocatable :: occ_mpi(:), occ_wk(:)
    complex(kind=CMPLDP), allocatable :: ztrm2(:,:)

    allocate( SpectrFn_vv( nmax_G_spin, nmax_G_spin, nstep ) );  SpectrFn_vv = 0.0d0
    allocate( ztrm2( nmax_G_spin, nmax_G_spin ) ); ztrm2 = 0.0d0

    allocate( eko_wk( neg ) ); eko_wk = 0.0d0
    allocate( occ_wk( neg ) ); occ_wk = 0.0d0

    Do ik=1, kv3, ndim_spinor
       if ( map_k(ik) /= myrank_k ) cycle

       eko_wk = 0.0d0
       Do ib1=ista_e, iend_e, istep_e
          eko_wk(ib1) = eko_l( map_z(ib1),ik )
       End do
       if ( npes > 1 ) then
          allocate( eko_mpi( neg ) ); eko_mpi = 0.0d0
          call mpi_allreduce( eko_wk, eko_mpi, neg, mpi_double_precision, mpi_sum, &
               &              mpi_k_world(myrank_k), ierr )
          eko_wk = eko_mpi
          deallocate( eko_mpi )
       endif

       occ_wk = 0.0d0
       Do ib1=ista_e, iend_e, istep_e
          occ_wk(ib1) = occup_l( map_z(ib1),ik )
       End do
       if ( npes > 1 ) then
          allocate( occ_mpi( neg ) ); occ_mpi = 0.0d0
          call mpi_allreduce( occ_wk, occ_mpi, neg, mpi_double_precision, mpi_sum, &
               &              mpi_k_world(myrank_k), ierr )
          occ_wk = occ_mpi
          deallocate( occ_mpi )
       endif

       weight = kv3 *qwgt(ik) /dble(ndim_spinor)

       ispin = 1
       if ( (.not. noncol) .and. nspin == 2 ) then
          ispin = mod( ik-1, 2 )+1
       endif

       Do i=1, num_star_of_k(ik)
          jk = star_of_k(ik,i)
          iopr = iopr_k_fbz_to_ibz(jk)
          trev = trev_k_fbz_to_ibz(jk)

          qvec_rotated = matmul( op(:,:,iopr), qvec(:) )
          if ( trev == 1 ) qvec_rotated = -qvec_rotated

          txyz(1:3) = tau(1:3,iopr,BUCS)*PAI2

          Do ib1=ista_e, iend_e, istep_e
             if ( eko_l( map_z(ib1),ik ) > efermi ) cycle

             Do ib2=1, neg
                if ( eko_wk(ib2) < efermi ) cycle

                ediff = eko_wk(ib2)   -eko_l(map_z(ib1),ik) +scissor
                occ1 = occup_l(map_z(ib1),ik) / weight
                occ2 = occ_wk(ib2) / weight

                if ( imple_method == 1 ) then
                   odiff = occ1 -occ2    
                else
                   odiff = occ1 *( 1.0d0 -occ2 )
                endif

                if ( ediff < 0.0d0 ) cycle

                Do is1=1, ndim_spinor
                   Do is2=1, ndim_spinor

                      Do ig1=1, nmax_G
                         if ( ig1 == 1 ) then
                            zrho1 = trm_vv( map_z(ib1),ib2,ik+is1-1,1 )*qvec_rotated(1) &
                                 & +trm_vv( map_z(ib1),ib2,ik+is1-1,2 )*qvec_rotated(2) &
                                 &+ trm_vv( map_z(ib1),ib2,ik+is1-1,3 )*qvec_rotated(3)
                            if ( imple_method == 1 ) then
                               zrho1 = -zrho1 *zi
                            else
                               zrho1 = zrho1 *zi
                            endif
                            
                         else
                            itmp = ngpt_XI( ig1, iopr )
                            zrho1 = 0.0d0
                            
                            fp = ngabc(itmp,1)*txyz(1) + ngabc(itmp,2)*txyz(2) &
                                 &                     + ngabc(itmp,3)*txyz(3)
                            if ( imple_method == 1 ) then
                               zph = dcmplx( cos(fp), -sin(fp) )
                            else
                               zph = dcmplx( cos(fp), sin(fp) )
                            endif
                            
                            z1 = RhoTilde_vv( itmp, map_z(ib1), ib2, ik+is1-1 )*zph
                            if ( trev == 1 ) then
                               zrho1 = zrho1 + conjg(z1)
                            else
                               zrho1 = zrho1 + z1
                            endif
                         end if

                         Do ig2=1, nmax_G
                            if ( ig2 == 1 ) then
                               zrho2 = trm_vv( map_z(ib1),ib2,ik+is2-1,1 ) &
                                    &                *qvec_rotated(1) &
                                    & +trm_vv( map_z(ib1),ib2,ik+is2-1,2 ) &
                                    &                *qvec_rotated(2) &
                                    & + trm_vv( map_z(ib1),ib2,ik+is2-1,3 ) &
                                    &                *qvec_rotated(3)
                               if ( imple_method == 1 ) then
                                  zrho2 = -zrho2 *zi
                               else
                                  zrho2 = zrho2 *zi
                               endif
                               
                            else
                               itmp = ngpt_XI( ig2, iopr )
                               zrho2 = 0.0d0
                               
                               fp = ngabc(itmp,1)*txyz(1) + ngabc(itmp,2)*txyz(2) &
                                    &                     + ngabc(itmp,3)*txyz(3)
                               if ( imple_method == 1 ) then
                                  zph = dcmplx( cos(fp), -sin(fp) )
                               else
                                  zph = dcmplx( cos(fp), sin(fp) )
                               endif
                         
                               z1 = RhoTilde_vv( itmp, map_z(ib1), ib2, ik+is2-1 )*zph
                               if ( trev == 1 ) then
                                  zrho2 = zrho2 + conjg(z1)
                               else
                                  zrho2 = zrho2 + z1
                               endif
                            endif
!
                            if ( noncol ) then
                               ztrm2( nmax_G*(is1-1)+ig1, nmax_G*(is2-1)+ig2 ) &
                                    &           = zrho1 *conjg( zrho2 )
                            else
                               ztrm2( nmax_G*(ispin-1)+ig1, nmax_G*(ispin-1)+ig2 ) &
                                    &           = zrho1 *conjg( zrho2 )
                            endif

                         End do  ! ig2
                      End Do  ! ig1
                   End do
                End Do
#ifdef USE_ASMS_EXCITATION
                call ASMS_XI_add_spectral_function( ediff, odiff, &
                     &                              ztrm2, SpectrFn_vv )
#endif
             End do
          End Do
       End do
    End Do

    if ( npes > 1 ) then
       allocate( work( nmax_G_spin, nmax_G_spin, nstep ) ); work = 0.0d0
       call mpi_allreduce( SpectrFn_vv, work, nmax_G_spin**2 *2 *nstep, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       SpectrFn_vv = work
       deallocate( work )
    endif

    SpectrFn_vv = SpectrFn_vv /dble(kv3_fbz) /univol
    if ( nspin == 1 ) SpectrFn_vv = SpectrFn_vv *2.0d0

#if 0
    Do i=1, nstep
       ztmp = 0.0d0
       Do is1=1, nspin_m
          Do is2=1, nspin_m
             ztmp = ztmp +SpectrFn_vv( nmax_G*(is1-1)+1, nmax_G*(is2-1)+1, i )
          End do
       End Do
       write(2550+mype,*) i*e_step*27.2116, real(ztmp), aimag(ztmp)
    End Do
#endif

  end subroutine m_XI_calc_spectr_fn_vv_spindec

  subroutine m_XI_calc_spectr_fn_vv
    integer :: i, ik, jk, iopr, trev
    integer :: ig1, ig2, itmp, ib1, ib2, is
    complex(kind=CMPLDP), allocatable :: work(:,:,:)
    real(kind=DP) :: qvec_rotated(3), weight

    real(kind=DP) :: ediff, odiff, occ1, occ2, qv2, txyz(3), fp
    complex(kind=CMPLDP) :: zrho1, zrho2, ztmp, z1, zph

    real(kind=DP), allocatable :: eko_mpi(:), eko_wk(:)
    real(kind=DP), allocatable :: occ_mpi(:), occ_wk(:)
    complex(kind=CMPLDP), allocatable :: ztrm2(:,:), zrho_work(:)

    allocate( SpectrFn_vv( nmax_G, nmax_G, nstep ) );  SpectrFn_vv = 0.0d0
    allocate( ztrm2(nmax_G,nmax_G) ); ztrm2 = 0.0d0

    allocate( eko_wk( neg ) ); eko_wk = 0.0d0
    allocate( occ_wk( neg ) ); occ_wk = 0.0d0
    allocate( zrho_work( nmax_G ) ); zrho_work = 0.0d0

    Do ik=1, kv3, ndim_spinor
       if ( map_k(ik) /= myrank_k ) cycle

       eko_wk = 0.0d0
       Do ib1=ista_e, iend_e, istep_e
          eko_wk(ib1) = eko_l( map_z(ib1),ik )
       End do
       if ( npes > 1 ) then
          allocate( eko_mpi( neg ) ); eko_mpi = 0.0d0
          call mpi_allreduce( eko_wk, eko_mpi, neg, mpi_double_precision, mpi_sum, &
               &              mpi_k_world(myrank_k), ierr )
          eko_wk = eko_mpi
          deallocate( eko_mpi )
       endif

       occ_wk = 0.0d0
       Do ib1=ista_e, iend_e, istep_e
          occ_wk(ib1) = occup_l( map_z(ib1),ik )
       End do
       if ( npes > 1 ) then
          allocate( occ_mpi( neg ) ); occ_mpi = 0.0d0
          call mpi_allreduce( occ_wk, occ_mpi, neg, mpi_double_precision, mpi_sum, &
               &              mpi_k_world(myrank_k), ierr )
          occ_wk = occ_mpi
          deallocate( occ_mpi )
       endif

       weight = kv3 *qwgt(ik) /dble(ndim_spinor)

       Do i=1, num_star_of_k(ik)
          jk = star_of_k(ik,i)
          iopr = iopr_k_fbz_to_ibz(jk)
          trev = trev_k_fbz_to_ibz(jk)

          qvec_rotated = matmul( op(:,:,iopr), qvec(:) )
          if ( trev == 1 ) qvec_rotated = -qvec_rotated

          txyz(1:3) = tau(1:3,iopr,BUCS)*PAI2

          Do ib1=ista_e, iend_e, istep_e
             if ( eko_l( map_z(ib1),ik ) > efermi ) cycle

             Do ib2=1, neg
                if ( eko_wk(ib2) < efermi ) cycle

                ediff = eko_wk(ib2)   -eko_l(map_z(ib1),ik) +scissor
                occ1 = occup_l(map_z(ib1),ik) / weight
                occ2 = occ_wk(ib2) / weight

                if ( imple_method == 1 ) then
                   odiff = occ1 -occ2    
                else
                   odiff = occ1 *( 1.0d0 -occ2 )
                endif

                if ( ediff < 0.0d0 ) cycle
! -----
                Do ig1=1, nmax_G
                   zrho1 = 0.0d0
                   if ( ig1 == 1 ) then
                      Do is=1, ndim_spinor
                         zrho1 = zrho1 &
                              & + trm_vv( map_z(ib1),ib2,ik+is-1,1 )*qvec_rotated(1) &
                              & + trm_vv( map_z(ib1),ib2,ik+is-1,2 )*qvec_rotated(2) &
                              & + trm_vv( map_z(ib1),ib2,ik+is-1,3 )*qvec_rotated(3)
                      End do
                      if ( imple_method == 1 ) then
                         zrho1 = -zrho1 *zi
                      else
                         zrho1 = zrho1 *zi
                      endif
                   else
                      itmp = ngpt_XI( ig1, iopr )
                      fp = ngabc(itmp,1)*txyz(1) + ngabc(itmp,2)*txyz(2) &
                           &                     + ngabc(itmp,3)*txyz(3)
                      if ( imple_method == 1 ) then
                         zph = dcmplx( cos(fp), -sin(fp) )
                      else
                         zph = dcmplx( cos(fp), sin(fp) )
                      endif

                      Do is=1, ndim_spinor
                         z1 = RhoTilde_vv( itmp, map_z(ib1), ib2, ik+is-1 )*zph
                         if ( trev == 1 ) then
                            zrho1 = zrho1 + conjg(z1)
                         else
                            zrho1 = zrho1 + z1
                         endif
                      End do
                   end if
                   zrho_work(ig1) = zrho1
                End Do
! -----
                Do ig1=1, nmax_G
                   zrho1 = zrho_work(ig1)
                   Do ig2=1, nmax_G
                      zrho2 = zrho_work(ig2)
                      ztrm2( ig1, ig2 ) = zrho1 *conjg( zrho2 )
                   End do  ! ig2
                End Do  ! ig1

#ifdef USE_ASMS_EXCITATION
                call ASMS_XI_add_spectral_function( ediff, odiff, ztrm2, &
                     &                              SpectrFn_vv )
#endif
             End do
          End Do
       End do
    End Do

    if ( npes > 1 ) then
       allocate( work(nmax_G, nmax_G, nstep ) ); work = 0.0d0
       call mpi_allreduce( SpectrFn_vv, work, nmax_G**2 *2 *nstep, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       SpectrFn_vv = work
       deallocate( work )
    endif

    deallocate( zrho_work ); deallocate( ztrm2 )
    deallocate( eko_wk ); deallocate( occ_wk )

    SpectrFn_vv = SpectrFn_vv /dble(kv3_fbz/nspin) /univol
    if ( nspin == 1 ) SpectrFn_vv = SpectrFn_vv *2.0d0

#if 0
    Do i=1, nstep
       ztmp = SpectrFn_vv(1,1,i)
       write(2450+mype,*) i*e_step*27.2116, real(ztmp), aimag(ztmp)
    End Do
#endif

  end subroutine m_XI_calc_spectr_fn_vv

  subroutine m_XI_calc_spectr_tensor_vv
    integer :: i, ik, jk, iopr, trev
    integer :: ig1, ig2, itmp, ib1, ib2, is, itns

    real(kind=DP) :: qv, qvec1(3), qvec2(3)
    real(kind=DP) :: qvec1_rotated(3), qvec2_rotated(3), weight
    real(kind=DP) :: ediff, odiff, occ1, occ2, txyz(3), fp
    complex(kind=CMPLDP) :: zrho1, zrho2, ztmp, z1, zph

    real(kind=DP), allocatable :: eko_mpi(:), eko_wk(:)
    real(kind=DP), allocatable :: occ_mpi(:), occ_wk(:)
    complex(kind=CMPLDP), allocatable :: work(:,:,:)
    complex(kind=CMPLDP), allocatable :: ztrm2(:,:)

    if ( allocated( SpectrTensor_vv ) ) deallocate( SpectrTensor_vv )
    allocate( SpectrTensor_vv( nmax_G, nmax_G, nstep, 6 ) );  SpectrTensor_vv = 0.0d0

    allocate( ztrm2(nmax_G,nmax_G) ); ztrm2 = 0.0d0
    allocate( eko_wk( neg ) ); eko_wk = 0.0d0
    allocate( occ_wk( neg ) ); occ_wk = 0.0d0
!
    qv = sqrt( qvec(1)**2 +qvec(2)**2 + qvec(3)**2 )

    Do itns=1, 6
       qvec1 = 0.d0;   qvec2 = 0.0d0
       select case (itns)
       case (1)
          qvec1(1) = qv;  qvec2(1) = qv
       case (2)
          qvec1(2) = qv;  qvec2(2) = qv
       case (3)
          qvec1(3) = qv;  qvec2(3) = qv
       case (4)
          qvec1(1) = qv;  qvec2(2) = qv
       case (5)
          qvec1(1) = qv;  qvec2(3) = qv
       case (6)
          qvec1(2) = qv;  qvec2(3) = qv
       end select

       Do ik=1, kv3, ndim_spinor
          if ( map_k(ik) /= myrank_k ) cycle
          
          eko_wk = 0.0d0
          Do ib1=ista_e, iend_e, istep_e
             eko_wk(ib1) = eko_l( map_z(ib1),ik )
          End do
          if ( npes > 1 ) then
             allocate( eko_mpi( neg ) ); eko_mpi = 0.0d0
             call mpi_allreduce( eko_wk, eko_mpi, neg, mpi_double_precision, mpi_sum, &
                  &              mpi_k_world(myrank_k), ierr )
             eko_wk = eko_mpi
             deallocate( eko_mpi )
          endif
          
          occ_wk = 0.0d0
          Do ib1=ista_e, iend_e, istep_e
             occ_wk(ib1) = occup_l( map_z(ib1),ik )
          End do
          if ( npes > 1 ) then
             allocate( occ_mpi( neg ) ); occ_mpi = 0.0d0
             call mpi_allreduce( occ_wk, occ_mpi, neg, mpi_double_precision, mpi_sum, &
                  &              mpi_k_world(myrank_k), ierr )
             occ_wk = occ_mpi
             deallocate( occ_mpi )
          endif

          weight = kv3 *qwgt(ik) /dble(ndim_spinor)

          Do i=1, num_star_of_k(ik)
             jk = star_of_k(ik,i)
             iopr = iopr_k_fbz_to_ibz(jk)
             trev = trev_k_fbz_to_ibz(jk)
             
             qvec1_rotated = matmul( op(:,:,iopr), qvec1(:) )
             qvec2_rotated = matmul( op(:,:,iopr), qvec2(:) )

             if ( trev == 1 ) qvec1_rotated = -qvec1_rotated
             if ( trev == 1 ) qvec2_rotated = -qvec2_rotated

             txyz(1:3) = tau(1:3,iopr,BUCS)*PAI2
             
             Do ib1=ista_e, iend_e, istep_e
                if ( eko_l( map_z(ib1),ik ) > efermi ) cycle
                
                Do ib2=1, neg
                   if ( eko_wk(ib2) < efermi ) cycle
                   
                   ediff = eko_wk(ib2)   -eko_l(map_z(ib1),ik) +scissor
                   occ1 = occup_l(map_z(ib1),ik) / weight
                   occ2 = occ_wk(ib2) / weight
                   
                   if ( imple_method == 1 ) then
                      odiff = occ1 -occ2    
                   else
                      odiff = occ1 *( 1.0d0 -occ2 )
                   endif
                   
                   if ( ediff < 0.0d0 ) cycle
                   
                   Do ig1=1, nmax_G
                      if ( ig1 == 1 ) then
                         zrho1 = 0.0d0
                         Do is=1, ndim_spinor
                            zrho1 = zrho1 &
                                 & + trm_vv(map_z(ib1),ib2,ik+is-1,1)*qvec1_rotated(1) &
                                 & + trm_vv(map_z(ib1),ib2,ik+is-1,2)*qvec1_rotated(2) &
                                 & + trm_vv(map_z(ib1),ib2,ik+is-1,3)*qvec1_rotated(3)
                         End do
                         if ( imple_method == 1 ) then
                            zrho1 = -zrho1 *zi
                         else
                            zrho1 = zrho1 *zi
                         endif
                         
                      else
                         itmp = ngpt_XI( ig1, iopr )
                         zrho1 = 0.0d0
                         
                         fp = ngabc(itmp,1)*txyz(1) + ngabc(itmp,2)*txyz(2) &
                              &                     + ngabc(itmp,3)*txyz(3)
                         if ( imple_method == 1 ) then
                            zph = dcmplx( cos(fp), -sin(fp) )
                         else
                            zph = dcmplx( cos(fp), sin(fp) )
                         endif

                         Do is=1, ndim_spinor
                            z1 = RhoTilde_vv( itmp, map_z(ib1), ib2, ik+is-1 )*zph
                            if ( trev == 1 ) then
                               zrho1 = zrho1 + conjg(z1)
                            else
                               zrho1 = zrho1 + z1
                            endif
                         End do
                         
                      endif
                      
                      Do ig2=1, nmax_G
                         if ( ig2 == 1 ) then
                            zrho2 = 0.0d0
                            Do is=1, ndim_spinor
                               zrho2 = zrho2 &
                                    & + trm_vv(map_z(ib1),ib2,ik+is-1,1) &
                                    &                   *qvec2_rotated(1) &
                                    & + trm_vv(map_z(ib1),ib2,ik+is-1,2) &
                                    &                   *qvec2_rotated(2) &
                                    & + trm_vv(map_z(ib1),ib2,ik+is-1,3) &
                                    &                   *qvec2_rotated(3)
                            End do
                            if ( imple_method == 1 ) then
                               zrho2 = -zrho2 *zi
                            else
                               zrho2 = zrho2 *zi
                            endif
                            
                         else
                            itmp = ngpt_XI( ig2, iopr )
                            zrho2 = 0.0d0
                            
                            fp = ngabc(itmp,1)*txyz(1) + ngabc(itmp,2)*txyz(2) &
                                 &                     + ngabc(itmp,3)*txyz(3)
                            if ( imple_method == 1 ) then
                               zph = dcmplx( cos(fp), -sin(fp) )
                            else
                               zph = dcmplx( cos(fp), sin(fp) )
                            endif
                            
                            Do is=1, ndim_spinor
                               z1 = RhoTilde_vv( itmp, map_z(ib1), ib2, ik+is-1 )*zph
                               if ( trev == 1 ) then
                                  zrho2 = zrho2 + conjg(z1)
                               else
                                  zrho2 = zrho2 + z1
                               endif
                            End do
                            
                         endif
                         
                         ztrm2( ig1, ig2 ) = zrho1 *conjg( zrho2 )

                      End do  ! ig2
                   End Do  ! ig1

#ifdef USE_ASMS_EXCITATION
                   call ASMS_XI_add_spectral_function( ediff, odiff, ztrm2, &
                        &                              SpectrTensor_vv(:,:,:,itns) )
#endif
                End do
             End Do
          End do
       End Do
       
       if ( npes > 1 ) then
          allocate( work(nmax_G, nmax_G, nstep ) ); work = 0.0d0
          call mpi_allreduce( SpectrTensor_vv(:,:,:,itns), work, nmax_G**2 *2 *nstep, &
               &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
          SpectrTensor_vv(:,:,:,itns) = work(:,:,:)
          deallocate( work )
       endif
    End Do

    SpectrTensor_vv = SpectrTensor_vv /dble(kv3_fbz/nspin) /univol
    if ( nspin == 1 ) SpectrTensor_vv = SpectrTensor_vv *2.0d0

#if 0
    Do i=1, nstep
       ztmp = SpectrTensor_vv(1,1,i,1)
       write(2450+mype,*) i*e_step*27.2116, real(ztmp), aimag(ztmp)
    End Do
#endif

    deallocate( ztrm2 ); deallocate( eko_wk ); deallocate( occ_wk )

  end subroutine m_XI_calc_spectr_tensor_vv

! --------------------------------------------------------
!    Calculation of SpectrFn (val-core)
! --------------------------------------------------------

  subroutine m_XI_calc_spectr_fn_vc
    integer :: i, ik, jk, iopr, trev
    integer :: ig1, ig2, itmp, ib1, ib2, is
    complex(kind=CMPLDP), allocatable :: work(:,:,:)
    real(kind=DP) :: qvec_rotated(3), weight

    real(kind=DP) :: ediff, odiff, occ1, occ2, qv2, txyz(3), fp
    complex(kind=CMPLDP) :: zrho1, zrho2, ztmp, z1, zph
    real(kind=DP) :: Delta03 = 1.0D-3

    real(kind=DP), allocatable :: eko_mpi(:), eko_wk(:)
    real(kind=DP), allocatable :: occ_mpi(:), occ_wk(:)
    complex(kind=CMPLDP), allocatable :: ztrm2(:,:)

    write(*,*) "nstep = ", nstep

    allocate( SpectrFn_vc( nmax_G, nmax_G, nstep ) );  SpectrFn_vc = 0.0d0
    allocate( ztrm2(nmax_G,nmax_G) ); ztrm2 = 0.0d0

    allocate( eko_wk( num_core_states ) ); eko_wk = 0.0d0

    Do ik=1, kv3, ndim_spinor
       if ( map_k(ik) /= myrank_k ) cycle

       eko_wk = 0.0d0
       eko_wk(:) = ene_core_states(:)

       weight = kv3 *qwgt(ik) /dble(ndim_spinor)

       Do i=1, num_star_of_k(ik)
          jk = star_of_k(ik,i)
          iopr = iopr_k_fbz_to_ibz(jk)
          trev = trev_k_fbz_to_ibz(jk)

          qvec_rotated = matmul( op(:,:,iopr), qvec(:) )
          if ( trev == 1 ) qvec_rotated = -qvec_rotated

          txyz(1:3) = tau(1:3,iopr,BUCS)*PAI2

          Do ib1=ista_e, iend_e, istep_e
             occ1 = occup_l(map_z(ib1),ik) / weight
             if ( 1.0D0 -occ1 < Delta03 ) cycle

             Do ib2=1, num_core_states

                ediff = eko_wk(ib2)   -eko_l(map_z(ib1),ik) -scissor
                occ2 = 1.0d0

                if ( imple_method == 1 ) then
                   odiff = occ1 -occ2
                else
                   odiff = occ1 *( 1.0d0 -occ2 )
                endif
                ediff = -ediff;    odiff = -odiff

                Do ig1=1, nmax_G
                   if ( ig1 == 1 ) then
                      zrho1 = 0.0d0
                      Do is=1, ndim_spinor
                         zrho1 = zrho1 &
                              & + trm_vc( map_z(ib1),ib2,ik+is-1,1 )*qvec_rotated(1) &
                              & + trm_vc( map_z(ib1),ib2,ik+is-1,2 )*qvec_rotated(2) &
                              & + trm_vc( map_z(ib1),ib2,ik+is-1,3 )*qvec_rotated(3)
                      End do
                      if ( imple_method == 1 ) then
                         zrho1 = -zrho1 *zi
                      else
                         zrho1 = zrho1 *zi
                      endif

                   else
                      itmp = ngpt_XI( ig1, iopr )
                      zrho1 = 0.0d0
                      fp = ngabc(itmp,1)*txyz(1) + ngabc(itmp,2)*txyz(2) &
                           &                     + ngabc(itmp,3)*txyz(3)
                      if ( imple_method == 1 ) then
                         zph = dcmplx( cos(fp), -sin(fp) )
                      else
                         zph = dcmplx( cos(fp), sin(fp) )
                      endif
                      Do is=1, ndim_spinor
                         z1 = RhoTilde_vc( itmp, map_z(ib1), ib2, ik+is-1 ) *zph
                         if ( trev == 1 ) then
                            zrho1 = zrho1 + conjg(z1)
                         else
                            zrho1 = zrho1 + z1
                         endif
                      End do
                   endif

                   Do ig2=1, nmax_G
                      if ( ig2 == 1 ) then
                         zrho2 = 0.0d0
                         Do is=1, ndim_spinor
                            zrho2 = zrho2 &
                                 & + trm_vc( map_z(ib1),ib2,ik+is-1,1 )*qvec_rotated(1) &
                                 & + trm_vc( map_z(ib1),ib2,ik+is-1,2 )*qvec_rotated(2) &
                                 & + trm_vc( map_z(ib1),ib2,ik+is-1,3 )*qvec_rotated(3)
                         End do
                         if ( imple_method == 1 ) then
                            zrho2 = -zrho2 *zi
                         else
                            zrho2 = zrho2 *zi
                         endif

                      else
                         itmp = ngpt_XI( ig2, iopr )
                         zrho2 = 0.0d0

                         fp = ngabc(itmp,1)*txyz(1) + ngabc(itmp,2)*txyz(2) &
                              &                     + ngabc(itmp,3)*txyz(3)
                         if ( imple_method == 1 ) then
                            zph = dcmplx( cos(fp), -sin(fp) )
                         else
                            zph = dcmplx( cos(fp), sin(fp) )
                         endif

                         Do is=1, ndim_spinor
                            z1 = RhoTilde_vc( itmp, map_z(ib1), ib2, ik+is-1 )*zph
                            if ( trev == 1 ) then
                               zrho2 = zrho2 + conjg(z1)
                            else
                               zrho2 = zrho2 + z1
                            endif

                         End do
                      endif

                      ztrm2( ig1, ig2 ) = zrho1 *conjg( zrho2 )

                   End do  ! ig2
                End Do  ! ig1

#ifdef USE_ASMS_EXCITATION
                call ASMS_XI_add_spectral_function( ediff, odiff, ztrm2, &
                     &                              SpectrFn_vc )
#endif
             End do
          End Do
       End do
    End Do

    if ( npes > 1 ) then
       allocate( work(nmax_G, nmax_G, nstep ) ); work = 0.0d0
       call mpi_allreduce( SpectrFn_vc, work, nmax_G**2 *2 *nstep, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       SpectrFn_vc = work
       deallocate( work )
    endif

    SpectrFn_vc = SpectrFn_vc /dble(kv3_fbz/nspin) /univol
    if ( nspin == 1 ) SpectrFn_vc = SpectrFn_vc *2.0d0

#if 0
    Do i=1, nstep
       ztmp = SpectrFn_vc(1,1,i)
       write(2400+mype,*) e(i)*27.2116, real(ztmp), aimag(ztmp)
    End do
#endif

  end subroutine m_XI_calc_spectr_fn_vc

! --------------------------------------------------------
! Coulomb Kernel
! --------------------------------------------------------
  subroutine m_XI_set_Kernel_Coulomb
    integer :: i
    real(kind=DP) :: g2, qv2

    allocate( Kernel_Coulomb(nmax_G) ); Kernel_Coulomb = 0.0d0

    Do i=2, nmax_G
       g2 = ttr(1)*ngabc(i,1)*ngabc(i,1) &
            &             + ttr(2)*ngabc(i,2)*ngabc(i,2) &
            &             + ttr(3)*ngabc(i,3)*ngabc(i,3) &
            &             + ttr(4)*ngabc(i,1)*ngabc(i,2) &
            &             + ttr(5)*ngabc(i,2)*ngabc(i,3) &
            &             + ttr(6)*ngabc(i,3)*ngabc(i,1)
       Kernel_Coulomb(i) = PAI4 / g2
    End do
    qv2 = qvec(1)**2 +qvec(2)**2 + qvec(3)**2
    Kernel_Coulomb(1) = PAI4 / qv2

  end subroutine m_XI_set_Kernel_Coulomb

  subroutine m_XI_calc_num_occupied_bands
    integer :: ik, ib1
    real(kind=DP) :: weight, c1
    real(kind=DP), allocatable :: occ_mpi(:), occ_wk(:)
    
    allocate( occ_wk( neg ) ); occ_wk = 0.0d0

    Do ik=1, kv3
       if ( map_k(ik) /= myrank_k ) cycle

       occ_wk = 0.0d0
       Do ib1=ista_e, iend_e, istep_e
          occ_wk(ib1) = occup_l( map_z(ib1),ik )
       End do
       if ( npes > 1 ) then
          allocate( occ_mpi( neg ) ); occ_mpi = 0.0d0
          call mpi_allreduce( occ_wk, occ_mpi, neg, mpi_double_precision, mpi_sum, &
               &              mpi_k_world(myrank_k), ierr )
          occ_wk = occ_mpi
          deallocate( occ_mpi )
       endif

       weight = kv3 *qwgt(ik) /dble(ndim_spinor)

       num_occ_bands = 0
       Do ib1=1, neg
          c1 = occ_wk(ib1) /weight
          if ( c1 > 0.5 ) num_occ_bands = num_occ_bands +1
       End do
    End Do

    num_unocc_bands = neg -num_occ_bands

    deallocate( occ_wk )

  end subroutine m_XI_calc_num_occupied_bands
    
  subroutine m_XI_set_matsize_bse
    integer :: i, ista, iend, n1, n2
    integer, allocatable :: matsize_bse_on_pe(:)

    if ( sw_corelevel_spectrum == ON ) then
       matsize_bse = num_core_states *num_unocc_bands *kv3_fbz
    else
       matsize_bse = num_occ_bands *num_unocc_bands *kv3_fbz
    endif
    matsize_bse = matsize_bse /dble(ndim_spinor)

    allocate( matsize_bse_on_pe( npes ) ); matsize_bse_on_pe = 0

    n1 = int( matsize_bse /npes );  n2 = matsize_bse -n1 *npes
    Do i=1, npes
       matsize_bse_on_pe(i) = n1
    End do
    Do i=1, n2
       matsize_bse_on_pe(i) = matsize_bse_on_pe(i) +1
    End do
!
    ista = 0;  iend = 0

    Do i=1, npes
       ista = iend +1
       iend = iend +matsize_bse_on_pe(i)
       if ( mype == i-1 ) then
          ista_matbse = ista;  iend_matbse = iend
       endif
    End Do
    deallocate( matsize_bse_on_pe )

  end subroutine m_XI_set_matsize_bse

  subroutine m_XI_alloc_Hamiltonian_bse
  end subroutine m_XI_alloc_Hamiltonian_bse

  subroutine m_XI_set_Hamiltonian_bse
    integer :: ista_band, jsta_band

    allocate( MatH_bse( ista_matbse:iend_matbse, matsize_bse ) )
    MatH_bse = 0.0d0

    ista_band = num_occ_bands +1
    jsta_band = ista_band

    if ( sw_corelevel_spectrum == ON ) then
       call set_diagonal_part
       call set_exchange_part_core2val
       call set_screened_coulomb_core2val
    else
    endif
  contains

    subroutine set_exchange_part_core2val       ! electron-hole exchange
      integer :: ik, jk, ib1, ib2, jb1, jb2
      integer :: i, j, is, ig
      integer :: ik_fbz, jk_fbz, iopr, jopr, trev_i, trev_j, ipos, jpos
      integer :: itmp1, itmp2, itmp3, jtmp1, jtmp2, jtmp3
      real(kind=DP) :: fp_i, fp_j, txyz_i(3), txyz_j(3)
      complex(kind=CMPLDP) :: zsum, zph_i, zph_j, z1, z2

      complex(kind=CMPLDP), allocatable :: work_i(:,:), work_j(:,:)

      allocate( work_i(nmax_G,num_core_states) ); work_i = 0.0d0
      allocate( work_j(nmax_G,num_core_states) ); work_j = 0.0d0

      Do ik=1, kv3, ndim_spinor
         Do ib1=ista_band, neg
            work_i = 0.0d0
            if ( map_ek(ib1,ik) == mype ) then
               Do ib2=1, num_core_states
                  Do is=1, ndim_spinor
                     work_i(:,ib2) = work_i(:,ib2) &
                          &        + RhoTilde_vc(:,map_z(ib1),ib2,ik+is-1)
                  End Do
               End Do
            endif
            call mpi_bcast( work_i, nmax_G *num_core_states, &
                 &          mpi_double_precision, &
                 &          map_ek(ib1,ik), mpi_comm_group, ierr )

            Do jk=1, kv3, ndim_spinor
               Do jb1=jsta_band, neg
                  work_j = 0.0d0
                  if ( map_ek(jb1,jk) == mype ) then
                     Do jb2=1, num_core_states
                        Do is=1, ndim_spinor
                           work_j(:,jb2) = work_j(:,jb2) &
                                &        + RhoTilde_vc(:,map_z(jb1),jb2,jk+is-1)
                        End Do
                     End Do
                  endif
                  call mpi_bcast( work_j, nmax_G *num_core_states, &
                       &          mpi_double_precision, &
                       &          map_ek(jb1,jk), mpi_comm_group, ierr )

                  Do i=1, num_star_of_k(ik)
                     ik_fbz = star_of_k(ik,i)
                     iopr = iopr_k_fbz_to_ibz(ik_fbz)
                     trev_i = trev_k_fbz_to_ibz(ik_fbz)
                     txyz_i(1:3) = tau(1:3,iopr,BUCS) *PAI2

                     Do j=1, num_star_of_k(jk)
                        jk_fbz = star_of_k(jk,j)
                        jopr = iopr_k_fbz_to_ibz(jk_fbz)
                        trev_j = trev_k_fbz_to_ibz(jk_fbz)
                        txyz_j(1:3) = tau(1:3,jopr,BUCS) *PAI2

                        Do ib2=1, num_core_states
                           Do jb2=1, num_core_states
                              itmp1 = ( neg -ista_band +1 )*num_core_states
                              itmp2 = ( ib1 -ista_band +1 )*num_core_states
                              ipos = ( ik_fbz -1 )*itmp1 +itmp2 +ib2

                              jtmp1 = ( neg -jsta_band +1 )*num_core_states
                              jtmp2 = ( jb1 -jsta_band +1 )*num_core_states
                              jpos = ( jk_fbz -1 )*jtmp1 +jtmp2 +jb2
                              !
                              if ( ipos >= ista_matbse .and. ipos <= iend_matbse ) then
                                 zsum = 0.0d0

                                 Do ig=2, nmax_G         ! assuming sw_longwavelimit
                                    itmp3 = ngpt_XI( ig,iopr )
                                    jtmp3 = ngpt_XI( ig,jopr )
                                    fp_i = ngabc(itmp3,1)*txyz_i(1) &
                                         &   + ngabc(itmp3,2)*txyz_i(2) &
                                         &   + ngabc(itmp3,3)*txyz_i(3)
                                    fp_j = ngabc(jtmp3,1)*txyz_j(1) &
                                         &   + ngabc(jtmp3,2)*txyz_j(2) &
                                         &   + ngabc(jtmp3,3)*txyz_j(3)
                                    
                                    if ( imple_method == 1 ) then
                                       zph_i = dcmplx( cos(fp_i), -sin(fp_i) )
                                       zph_j = dcmplx( cos(fp_j), -sin(fp_j) )
                                    else
                                       zph_i = dcmplx( cos(fp_i), sin(fp_i) )
                                       zph_j = dcmplx( cos(fp_j), sin(fp_j) )
                                    endif
                                    
                                    Do is=1, ndim_spinor
                                       if ( trev_i == 1 ) then
                                          z1 = conjg( work_i(ig,is) *zph_i )
                                       else
                                          z1 = work_i(ig,is) *zph_i
                                       endif
                                       if ( trev_j == 1 ) then
                                          z2 = conjg( work_j(ig,is) *zph_j )
                                       else
                                          z2 = work_j(ig,is) *zph_j
                                       endif
                                       zsum = zsum +z1 *conjg(z2) *kernel_Coulomb(ig)
                                    End Do
                                 End Do
                                 MatH_bse( ipos, jpos ) = MatH_bse( ipos, jpos ) &
                                      &                 + zsum /univol
                              endif
                           End Do
                        End Do
                     End Do
                  End Do
               End Do
            End Do
         End Do
      End Do

      deallocate( work_i ); deallocate( work_j )

    end subroutine set_exchange_part_core2val

    subroutine set_screened_coulomb_core2val
      integer :: ik, ib1, ib2, jb1, jb2
      integer :: i, is, ik_fbz, iopr, trev
      integer :: itmp1, itmp2, jtmp1, jtmp2, ipos, jpos
      integer :: ig1, ig2, itmp3
      real(kind=DP) :: qvec_rotated(3), txyz(3), fp
      complex(kind=CMPLDP) :: zsum, zrho1, zrho2, zph, z1, z2

      complex(kind=CMPLDP), allocatable :: work1_rho_vv(:,:), work1_trm_vv(:,:)
      complex(kind=CMPLDP), allocatable :: work2_rho_cc(:,:), work2_trm_cc(:,:)

      allocate( work1_rho_vv(nmax_G,neg) ); work1_rho_vv = 0.0d0
      allocate( work1_trm_vv(neg,3) );      work1_trm_vv = 0.0d0
      allocate( work2_rho_cc(nmax_G,num_core_states) ); work2_rho_cc = 0.0d0
      allocate( work2_trm_cc(num_core_states,3) );      work2_trm_cc = 0.0d0

      Do ik=1, kv3, ndim_spinor

         Do ib1=ista_band, neg
            work1_rho_vv = 0.0d0;  work1_trm_vv = 0.0d0
            if ( map_ek(ib1,ik) == mype ) then
               Do jb1=1, neg
                  Do is=1, ndim_spinor
                     work1_rho_vv(:,jb1) = work1_rho_vv(:,jb1) &
                          &              + RhoTilde_vv(:,map_z(ib1),jb1,ik+is-1)
                  End Do
               End Do
               Do jb1=1, neg
                  Do is=1, ndim_spinor
                     work1_trm_vv(jb1,1:3) = work1_trm_vv(jb1,1:3) &
                          &                + trm_vv(map_z(ib1),jb1,ik+is-1,1:3)
                  End Do
               End Do
            endif
            call mpi_bcast( work1_rho_vv, nmax_G *neg, mpi_double_precision, &
                 &          map_ek(ib1,ik), mpi_comm_group, ierr )
            call mpi_bcast( work1_trm_vv, neg*3, mpi_double_precision, &
                 &          map_ek(ib1,ik), mpi_comm_group, ierr )
            
            Do ib2=1, num_core_states
               work2_rho_cc = 0.0d0;    work2_trm_cc = 0.0d0
               if ( map_k(ik) == myrank_k ) then
                  Do jb2=1, num_core_states
                     Do is=1, ndim_spinor
                        work2_rho_cc(:,jb2) = work2_rho_cc(:,ib2) &
                             &                 + RhoTilde_cc(:,ib2,jb2,ik+is-1)
                     End Do
                  End Do
                  Do jb2=1, num_core_states
                     Do is=1, ndim_spinor
                        work2_trm_cc(jb2,1:3) = work2_trm_cc(jb2,1:3) &
                             &                + trm_cc(ib2,jb2,ik+is-1,1:3)
                     End Do
                  End Do
               endif
               call mpi_bcast( work2_rho_cc, nmax_G *num_core_states, &
                    &          mpi_double_precision, &
                    &          map_k(ik), mpi_e_world(myrank_e), ierr )
               call mpi_bcast( work2_trm_cc, num_core_states*3, &
                    &          mpi_double_precision, &
                    &          map_k(ik), mpi_e_world(myrank_e), ierr )
                  
               Do i=1, num_star_of_k(ik)
                  ik_fbz = star_of_k(ik,i)
                  iopr = iopr_k_fbz_to_ibz(ik_fbz)
                  trev = trev_k_fbz_to_ibz(ik_fbz)
                  
                  qvec_rotated = matmul( op(:,:,iopr), qvec(:) )
                  if ( trev == 1 ) qvec_rotated = -qvec_rotated
                  
                  txyz(1:3) = tau(1:3,iopr,BUCS)*PAI2

                  Do jb1=ista_band, neg
                     Do jb2=1, num_core_states
                        itmp1 = ( neg -ista_band +1 )*num_core_states
                        itmp2 = ( ib1 -ista_band +1 )*num_core_states
                        ipos = ( ik_fbz -1 )*itmp1 +itmp2 +ib2
                              !
                        jtmp1 = ( neg -jsta_band +1 )*num_core_states
                        jtmp2 = ( jb1 -jsta_band +1 )*num_core_states
                        jpos = ( ik_fbz -1 )*jtmp1 +jtmp2 +jb2
                              !
                        if ( ipos >= ista_matbse .and. ipos <= iend_matbse ) then
                           zsum = 0.0d0

                           Do ig1=1, nmax_G
                              if ( ig1 == 1 ) then
                                 zrho1 = 0.0d0
                                 Do is=1, ndim_spinor
                                    zrho1 = zrho1 &
                                         & + work1_trm_vv(jb1,1)*qvec_rotated(1) &
                                         & + work1_trm_vv(jb1,2)*qvec_rotated(2) &
                                         & + work1_trm_vv(jb2,3)*qvec_rotated(3)
                                 End do
                                 if ( imple_method == 1 ) then
                                    zrho1 = -zrho1 *zi
                                 else
                                    zrho1 = zrho1 *zi
                                 endif
                              else
                                 itmp3 = ngpt_XI( ig1, iopr )
                                 zrho1 = 0.0d0

                                 fp = ngabc(itmp3,1)*txyz(1) + ngabc(itmp3,2)*txyz(2) &
                                      &                      + ngabc(itmp3,3)*txyz(3)
                                 if ( imple_method == 1 ) then
                                    zph = dcmplx( cos(fp), -sin(fp) )
                                 else
                                    zph = dcmplx( cos(fp), sin(fp) )
                                 endif

                                 z1 = work1_rho_vv(itmp3,jb1) *zph
                                 if ( trev == 1 ) then
                                    zrho1 = zrho1 + conjg(z1)
                                 else
                                    zrho1 = zrho1 + z1
                                 endif
                              endif

                              Do ig2=1, nmax_G
                                 if ( ig2 == 1 ) then
                                    zrho2 = 0.0d0
                                    Do is=1, ndim_spinor
                                       zrho2 = zrho2 &
                                            & + work2_trm_cc(jb2,1)*qvec_rotated(1) &
                                            & + work2_trm_cc(jb2,2)*qvec_rotated(2) &
                                            & + work2_trm_cc(jb2,3)*qvec_rotated(3)
                                    End do
                                    if ( imple_method == 1 ) then
                                       zrho2 = -zrho2 *zi
                                    else
                                       zrho2 = zrho2 *zi
                                    endif
                                 else
                                    itmp3 = ngpt_XI( ig2, iopr )
                                    zrho2 = 0.0d0
                                    fp = ngabc(itmp3,1)*txyz(1) +ngabc(itmp3,2)*txyz(2) &
                                         &                      +ngabc(itmp3,3)*txyz(3)
                                    if ( imple_method == 1 ) then
                                       zph = dcmplx( cos(fp), -sin(fp) )
                                    else
                                       zph = dcmplx( cos(fp), sin(fp) )
                                    endif

                                    z1 = work2_rho_cc(itmp3,jb2) *zph
                                    if ( trev == 1 ) then
                                       zrho2 = zrho2 + conjg(z1)
                                    else
                                       zrho2 = zrho2 + z1
                                    endif
                                 endif
!
                                 zsum = zsum +zrho1 *conjg(zrho2) *kernel_Coulomb(ig1) &
                                      &             *epsinv_omega0(ig1,ig2)
                              End do
                           End Do
                           MatH_bse(ipos,jpos) = MatH_bse(ipos,jpos) &
                                &               - zsum /2.0d0 /univol
                        endif
                     End Do
                  End Do
               End Do
            End Do
         End Do
      End Do

      deallocate( work1_trm_vv ); deallocate( work1_rho_vv )
      deallocate( work2_trm_cc ); deallocate( work2_rho_cc )

    end subroutine set_screened_coulomb_core2val

    subroutine set_diagonal_part
      integer :: ik, ib1, ib2
      integer :: i, iopr, ik_fbz, trev
      integer :: itmp1, itmp2, ipos
      real(kind=DP) :: work1_eko_v, work1_eko_c, c1

      Do ik=1, kv3, ndim_spinor
         Do ib1=ista_band, neg
            work1_eko_v = 0.0d0
            if ( map_ek(ib1,ik) == mype ) then
               work1_eko_v = eko_l(map_z(ib1),ik)
            endif
            call mpi_bcast( work1_eko_v, 1, mpi_double_precision, &
                 &          map_ek(ib1,ik), mpi_comm_group, ierr )

            Do ib2=1, num_core_states
               work1_eko_c = ene_core_states(ib2)
               
               Do i=1, num_star_of_k(ik)
                  ik_fbz = star_of_k(ik,i)
                  iopr = iopr_k_fbz_to_ibz(ik_fbz)
                  trev = trev_k_fbz_to_ibz(ik_fbz)
               
                  itmp1 = ( neg -ista_band +1 )*num_core_states
                  itmp2 = ( ib1 -ista_band +1 )*num_core_states
                  ipos = ( ik_fbz -1 )*itmp1 +itmp2 +ib2

                  if ( ipos >= ista_matbse .and. ipos <= iend_matbse ) then
                     c1 = work1_eko_v -work1_eko_c
                     MatH_bse(ipos,ipos) = MatH_bse(ipos,ipos) +c1
                  endif
               End Do
            End Do
         End Do
      End Do
                     
    end subroutine set_diagonal_part

  end subroutine m_XI_set_Hamiltonian_bse

end module m_Excitation

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 581 $)
!
!  MODULE: m_ES_LHXC
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)   call timer_sta(a)
#   define __TIMER_DO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif

module m_ES_LHXC
! $Id: m_ES_LHXC.F90 581 2018-08-01 08:38:42Z jkoga $
  use m_Electronic_Structure, only : vlhxc_l, vloc_esm
  use m_PlaneWaveBasisSet,    only : kg,kgp,gr_l
  use m_PseudoPotential,      only : psc_l, ival
  use m_Ionic_System,         only : ntyp, zfm3_l
  use m_Timing,               only : tstatc0_begin, tstatc0_end
#ifdef ENABLE_ESM_PACK
  use m_Control_Parameters,   only : nspin, ipri,iprivlhxcq, kimg, sw_dipole_correction &
                                   , sw_screening_correction, sw_external_potential &
  &                                , sw_esm, convergence_criteria
#else
  use m_Control_Parameters,   only : nspin, ipri,iprivlhxcq, kimg, sw_dipole_correction &
                                   , sw_screening_correction, sw_external_potential, convergence_criteria
#endif
  use m_Const_Parameters,     only : DP, PAI4, UP, DOWN, ON, OFF, CMPLDP, DELTA_V
  use m_Parallelization,      only : ista_kngp, iend_kngp, mype, myrank_g, mpi_comm_group
  use m_Crystal_Structure,    only : univol
  use m_Dipole,               only : vdip_l, vext_l
  use m_Dipole,               only : m_Dipole_potential, m_Dipole_calc
  use m_Screening,            only : screening
  use m_External_Potential,   only : espot_g

! ========================== added by K. Tagami ===================== 11.0
  use m_Control_Parameters,   only : ndim_chgpot, ndim_magmom
! =================================================================== 11.0

  use m_Charge_Density,       only : chgq_l

  use m_FFT,                  only : fft_box_size_CD
  use m_PlaneWaveBasisSet,    only : igfp_l

! === POSITRON SCF === 2015/11/28
  use m_Control_Parameters,   only : sw_positron, positron_method
  use m_Const_Parameters,     only : positron_GGGC
  use m_Positron_Wave_Functions,        only :  pchg_l
! ==================== 2015/11/28

  implicit none
  real(kind=DP) :: vmax
  include 'mpif.h'
!  61. m_ESlhxc_potential
contains
  subroutine m_ESlhxc_potential(nfout,chg,vxc)
    integer, intent(in)       :: nfout
    real(kind=DP), intent(in) :: chg(ista_kngp:iend_kngp,kimg,nspin)
    real(kind=DP), intent(in) :: vxc(ista_kngp:iend_kngp,kimg,nspin)
    complex(kind=CMPLDP),allocatable :: vhar(:)
    complex(kind=CMPLDP),allocatable, dimension(:,:) :: chgc
    real(kind=DP) :: ehar
    integer :: is,ik,i,it
    integer :: ist,ip
    integer :: ig
    integer :: nfftcd,ierr
    integer :: id_sname = -1,id_sname2=-1

    call tstatc0_begin('m_ESlhxc_potential ',id_sname,1)
    vlhxc_l = 0.d0
    ist = ista_kngp
    if(ist == 1) ist = 2
#ifdef ENABLE_ESM_PACK
    if(sw_esm==ON) then
       nfftcd = fft_box_size_CD(1,0)*fft_box_size_CD(2,0)*fft_box_size_CD(3,0)
       allocate(vhar(nfftcd));vhar=(0.d0,0.d0)
!       allocate(chgc(iend_kngp-ista_kngp+1,nspin));chgc=(0.d0,0.d0)
       allocate(chgc(kgp,nspin));chgc=(0.d0,0.d0)
       if(kimg==1)then
          do ig=ista_kngp,iend_kngp
!             chgc(ig-ista_kngp+1,1:nspin) = dcmplx(chg(ig,1,1:nspin),0.d0)
             chgc(ig,1:nspin) = dcmplx(chg(ig,1,1:nspin),0.d0)
          enddo
       else
          do ig=ista_kngp,iend_kngp
!             chgc(ig-ista_kngp+1,1:nspin) = dcmplx(chg(ig,1,1:nspin),chg(ig,2,1:nspin))
             chgc(ig,1:nspin) = dcmplx(chg(ig,1,1:nspin),chg(ig,2,1:nspin))
          enddo
       endif
       call mpi_allreduce(mpi_in_place,chgc,kgp*nspin,mpi_double_complex,mpi_sum,mpi_comm_group,ierr)
       call tstatc0_begin('esm_hartree ',id_sname2,1)
       call esm_hartree(chgc,ehar,vhar)
       call tstatc0_end(id_sname2)
       vhar(:) = 0.5d0*vhar(:) !Ry -> Ha
       deallocate(chgc)
    endif
#endif
    do is = 1, nspin
       do ik = 1, kimg
          if(mype==0) vlhxc_l(1,ik,is)   = vxc(1,ik,is)
          if(mype==0 .and. sw_external_potential==ON) then
             vlhxc_l(1,ik,is) = vxc(1,ik,is) + espot_g(1,ik,is)
          end if
#ifdef ENABLE_ESM_PACK
          if(nspin == 1.and.sw_esm==OFF) then
#else
          if(nspin == 1) then
#endif
             do i = ist, iend_kngp  !for mpi
                vlhxc_l(i,ik,is) = vxc(i,ik,is) &
                     & +PAI4*chg(i,ik,is)/gr_l(i)**2
                if(sw_external_potential==ON) then
                   vlhxc_l(i,ik,is) = vxc(i,ik,is) + espot_g(i,ik,is) &
                        & +PAI4*chg(i,ik,is)/gr_l(i)**2
                end if
                if(sw_screening_correction==ON) then
                   vlhxc_l(i,ik,is) = vlhxc_l(i,ik,is) &
                        + chg(i,ik,is)*screening%phik(i)
                end if
             end do
#ifdef ENABLE_ESM_PACK
          else if(nspin == 2.and.sw_esm==OFF) then
#else
          else if(nspin == 2) then
#endif
             do i = ist, iend_kngp  !for mpi
                vlhxc_l(i,ik,is) = vxc(i,ik,is) &
                     & +PAI4*(chg(i,ik,UP)+chg(i,ik,DOWN))/gr_l(i)**2
                if(sw_external_potential==ON) then
                   vlhxc_l(i,ik,is) = vxc(i,ik,is) + espot_g(i,ik,is) &
                        & +PAI4*(chg(i,ik,UP)+chg(i,ik,DOWN))/gr_l(i)**2
                end if
                if(sw_screening_correction==ON) then
                   vlhxc_l(i,ik,is) = vlhxc_l(i,ik,is) &
                        + (chg(i,ik,UP)+chg(i,ik,DOWN))*screening%phik(i)
                end if
             end do
#ifdef ENABLE_ESM_PACK
          else if (sw_esm == ON)then
             do i = ist, iend_kngp  !for mpi
                vlhxc_l(i,ik,is) = vxc(i,ik,is) 
                if(sw_external_potential==ON) then
                   vlhxc_l(i,ik,is) = vxc(i,ik,is) + espot_g(i,ik,is) 
                end if
                if(sw_screening_correction==ON) then
                   vlhxc_l(i,ik,is) = vlhxc_l(i,ik,is) &
                        + chg(i,ik,is)*screening%phik(i)
                end if
             end do
#endif
          endif
          do it    = 1,ntyp
             do i = ista_kngp, iend_kngp  !for mpi
                vlhxc_l(i,ik,is) &
                     & = vlhxc_l(i,ik,is)+psc_l(i,it)*zfm3_l(i,it,ik)
                if(sw_screening_correction==ON) then
                  vlhxc_l(i,ik,is) &
                       & = vlhxc_l(i,ik,is) - ival(it)*screening%phik(i)/univol*zfm3_l(i,it,ik)
                end if
             end do
          end do
#ifdef ENABLE_ESM_PACK
          if(sw_esm==ON)then
             if(ik==1)then
                do i=ista_kngp,iend_kngp
                   vlhxc_l(i,1,is) = vlhxc_l(i,1,is)+dble(vhar(igfp_l(i)))+dble(vloc_esm(igfp_l(i)))
                enddo
             else if(ik==2) then
                do i=ista_kngp,iend_kngp
                   vlhxc_l(i,2,is) = vlhxc_l(i,2,is)+aimag(vhar(igfp_l(i)))+aimag(vloc_esm(igfp_l(i)))
                enddo
             endif
          endif
#endif
       end do
    end do
#ifdef ENABLE_ESM_PACK
    if(sw_esm==ON) then
       deallocate(vhar)
    endif
#endif
    if(sw_dipole_correction==ON) then
       call m_Dipole_calc(nfout)
       call m_Dipole_potential(nfout,chg)
       do is = 1, nspin
          do ik = 1, kimg
             do i = ista_kngp, iend_kngp  !for mpi
                vlhxc_l(i,ik,is) = vlhxc_l(i,ik,is) + vdip_l(i,ik) + vext_l(i,ik)
             end do
          end do
       end do
    end if

! === POSITRON SCF === 2015/11/28
    if ( sw_positron /= OFF ) then
       if ( positron_method == Positron_GGGC ) then
          if ( nspin == 2 ) stop "UUU"
          do is = 1, nspin
             do ik = 1, kimg
                if(nspin == 1) then
                   do i = ist, iend_kngp  !for mpi
                      vlhxc_l(i,ik,is) = vlhxc_l(i,ik,is) &
                           &             -PAI4*pchg_l(i,ik)/gr_l(i)**2
                   end do
                end if
             end do
          end do
       end if
    endif
! ============== 2015/11/28

    if(iprivlhxcq >= 2) call m_ESlhxc_wd_vlhxc(nfout)
    call tstatc0_end(id_sname)
  end subroutine m_ESlhxc_potential

! ================================ addd by K. Tagami ================= 11.0
  subroutine m_ESlhxc_potential_noncl(nfout,chg,vxc)
    integer, intent(in)       :: nfout
    real(kind=DP), intent(in) :: chg(ista_kngp:iend_kngp,kimg,ndim_magmom)
    real(kind=DP), intent(in) :: vxc(ista_kngp:iend_kngp,kimg,ndim_magmom)

    integer :: is,ik,i,it
    integer :: ist
    integer :: id_sname = -1

    call tstatc0_begin('m_ESlhxc_potential_noncl ',id_sname)
    vlhxc_l = 0.d0

!    goto 200

!    goto 120                ! neglect vxc part

! *********** Vxc part *******************
    do is = 1, ndim_magmom
      do ik = 1, kimg
         do i = ista_kngp, iend_kngp              !for mpi
            vlhxc_l(i,ik,is) = vxc(i,ik,is)
         End do
      End do
    End do

120 continue
!    goto 200
!    goto 300

! ***********  Hartree part *************

    ist = ista_kngp
    if(ist == 1) ist = 2
    Do ik = 1, kimg
       do i = ist, iend_kngp  !for mpi
          vlhxc_l(i,ik,1) = vlhxc_l(i,ik,1) &
               &           +PAI4* chg(i,ik,1) /gr_l(i)**2
       end do
    End do
!--- screening correction ----
    if (sw_screening_correction==ON) then
       Do ik = 1, kimg
          do i = ist, iend_kngp  !for mpi
             vlhxc_l(i,ik,1) = vlhxc_l(i,ik,1) &
                  &           + chg(i,ik,1) *screening%phik(i)
          end do
       End do
    endif

200 continue
! *********** local pot *****************
    Do ik = 1, kimg
       do it = 1,ntyp
          do i = ista_kngp, iend_kngp  !for mpi
             vlhxc_l(i,ik,1) = vlhxc_l(i,ik,1) &
                  &           + psc_l(i,it)*zfm3_l(i,it,ik)
          end do
       end do
    end do
!--- screening correction ----
    if (sw_screening_correction==ON) then
       Do ik = 1, kimg
          do it = 1,ntyp
             do i = ista_kngp, iend_kngp  !for mpi
                vlhxc_l(i,ik,1) = vlhxc_l(i,ik,1) &
                     &          -ival(it) *screening%phik(i) /univol &
                     &                    *zfm3_l(i,it,ik)
             end do
          end do
       end do
    endif

300 continue

! --------------------------- The followings are uncertain .... ----
    if(sw_dipole_correction==ON) then
       call m_Dipole_calc(nfout)
       call m_Dipole_potential(nfout,chg)

       do ik = 1, kimg
          do i = ista_kngp, iend_kngp  !for mpi
             vlhxc_l(i,ik,1) = vlhxc_l(i,ik,1) + vdip_l(i,ik) + vext_l(i,ik)
          end do
       end do
    end if
! =---------------------------------------------------------------
    if(iprivlhxcq >= 2) call m_ESlhxc_wd_vlhxc_noncl(nfout)

    call tstatc0_end(id_sname)

  end subroutine m_ESlhxc_potential_noncl
! ========================================================================= 11.0

  subroutine m_ESlhxc_wd_vlhxc(nfout)

    integer, intent(in) :: nfout
    integer :: ispin, i, is, ie, ri
    is = ista_kngp
    ie = min(is+20, iend_kngp)
    do ispin = 1, nspin
       if(nspin == 2) write(nfout,'(" !lhxc ispin = ",i5)') ispin
       write(nfout,'(" vlhxc_l")')
       do ri = 1, kimg
          if(kimg == 1 .and. ri == 1) write(nfout,*) '       real part'
          if(ri == 2)                 write(nfout,*) '       imaginary part'
          write(nfout,'(" ",4d20.12)') (vlhxc_l(i,ri,ispin),i=is,ie) ! MPI
       end do
    end do
  end subroutine m_ESlhxc_wd_vlhxc

! ========================= added by K. Tagami ==================== 11.0
  subroutine m_ESlhxc_wd_vlhxc_noncl(nfout)
    integer, intent(in) :: nfout
    integer :: ispin, i, is, ie, ri

    is = ista_kngp
    ie = min(is+20, iend_kngp)

    do ispin = 1, ndim_magmom
       if(nspin == 2) write(nfout,'(" !lhxc ispin = ",i5)') ispin
       write(nfout,'(" vlhxc_l")')
       do ri = 1, kimg
          if(kimg == 1 .and. ri == 1) write(nfout,*) '       real part'
          if(ri == 2)                 write(nfout,*) '       imaginary part'
          write(nfout,'(" ",4d20.12)') (vlhxc_l(i,ri,ispin),i=is,ie) ! MPI
       end do
    end do

  end subroutine m_ESlhxc_wd_vlhxc_noncl
! ================================================================= 11.0


end module m_ES_LHXC

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 574 $)
!
!  SUBROUINE: Renewal_of_Potential
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Renewal_of_Potential()
! $Id: Renewal_of_Potential.F90 574 2017-05-31 03:00:48Z jkoga $
  use m_ES_Intgr_VlhxcQlm,   only : m_ESiVQ_integrate_VlhxcQlm
  use m_ES_LHXC,             only : m_ESlhxc_potential
  use m_Charge_Density,      only : chgq_l
  use m_XC_Potential,        only : m_XC_cal_potential, vxc_l
  use m_Control_Parameters,  only : icond
  use m_Const_Parameters,    only : Valence_plus_PC_Charge, VXC_AND_EXC &
       &                          , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION &
       &                          , ON
  use m_Files,               only : nfout
  use m_PAW_Hartree,         only : m_PAWH_get_dion_hartree
  use m_PAW_XC_Potential,    only : m_PAW_XC_cal_potential &
                                    ,m_PAW_XC_cal_potential_sphex2 &
                                    ,m_PAW_XC_get_dion_vxc &
!!$                                    ,m_PAW_XC_cal_potential_sym &
                                    ,m_PAW_XC_get_dion_vxc_dbg
  use m_PAW_ChargeDensity,   only : calcGaussLegendreIntegration &
                                    ,calcSphericalHarmonicsExpansion
  use m_PseudoPotential,     only : m_PP_get_dion_paw,flg_symmtry, flg_paw

! ================================= added by K. Tagami =============== 11.0&13.0U
  use m_Control_Parameters,   only : noncol
  use m_Electronic_Structure,  only : vlhxcQ,vlhxc_l
  use m_Parallelization,       only : ista_kngp,iend_kngp
  use m_ES_NonCollinear,      only : m_ES_set_Mat_dion_scr_noncl, &
       &                             m_ES_update_Mat_dion0_noncl
  use m_ES_LHXC,              only : m_ESlhxc_potential_noncl
!
  use m_ES_Mag_Constraint,    only : m_ES_add_MagConstraintPot_chgql, &
       &                             m_ES_add_MagConstraintPot_hsr
  use m_PAW_XC_Potential,    only : m_PAW_XC_get_dion_vxc_noncl, &
       &                             m_PAW_XC_get_dion_vxc_noncl2, &
       &                             m_PAW_XC_get_dion_vxc_noncl3
  use m_PseudoPotential,     only : m_PP_get_dion_paw_noncl
  use m_IterationNumbers,    only : iteration_electronic
  use m_Crystal_Structure,   only : level_of_projection_paw_charge,&
       &                            sw_magnetic_constraint
! ==================================================================== 11.0&13.0U

! ================================= added by K. Tagami =============== 11.0
  use m_Control_Parameters,   only : SpinOrbit_mode, ekmode, sw_hubbard
  use m_SpinOrbit_Potential,  only : m_SO_set_Dsoc_potential2
  use m_Const_Parameters,    only : ByPawPot, ON, OFF
  use m_SpinOrbit_RadInt,    only : m_SO_calc_SOC_strength_pawpot
! ==================================================================== 11.0

  implicit none

!!$  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) return

  call m_XC_cal_potential(nfout,Valence_plus_PC_Charge,chgq_l,VXC_AND_EXC)
                                              ! (xcfft) -> vxc_l
! ====================== added by K. Tagami ================= 11.0
  if ( noncol ) then
     if ( ekmode==OFF .and. iteration_electronic < 1 ) goto 100
  endif
! ========================================================== 11.0

  if(calcSphericalHarmonicsExpansion) then
    call m_PAW_XC_cal_potential_sphex2(nfout,VXC_AND_EXC)
#ifdef _MEMORY_CONSUMPTION_CHECK_
     call memsize(nfout)
#endif
!    call m_PAW_XC_cal_potential_sphex3(nfout,VXC_AND_EXC)
  end if
  if(calcGaussLegendreIntegration)then
!!!$  if(flg_paw) then
     call m_PAW_XC_cal_potential(nfout,VXC_AND_EXC,flg_symmtry)
!!!$  if(flg_symmtry) then
!!!$    call m_PAW_XC_cal_potential_sym(nfout,VXC_AND_EXC)
!!!$  else
!!!$    call m_PAW_XC_cal_potential(nfout,VXC_AND_EXC)
!!!$  end if
  end if

! ============================= modified by K. Tagami ============= 11.0
!  if(flg_paw) call m_PAW_XC_get_dion_vxc(nfout)
  if (flg_paw) then

     if ( noncol ) then
        select case(level_of_projection_paw_charge)
        case (1)
           call m_PAW_XC_get_dion_vxc_noncl(nfout)
        case (2)
           call m_PAW_XC_get_dion_vxc_noncl2(nfout)
        case (3)
           call m_PAW_XC_get_dion_vxc_noncl3(nfout)
        end select

     else
        call m_PAW_XC_get_dion_vxc(nfout)
     endif
  endif
! ================================================================= 11.0

! =================== added by K. Tagami ================== 11.0
100 continue
! ========================================================= 11.0

#ifdef _MEMORY_CONSUMPTION_CHECK_
     call memsize(nfout)
#endif

!! if(flg_paw) call m_PAW_XC_get_dion_vxc(nfout)
!! call m_PAW_XC_get_dion_vxc_dbg(nfout)

! ================================ modified by K. Tagami ============== 11.0
!!  call m_ESlhxc_potential(nfout,chgq_l,vxc_l) ! (stlhxc) -> vlhxc_l

  if ( noncol ) then
     call m_ESlhxc_potential_noncl(nfout,chgq_l,vxc_l)
  else
     call m_ESlhxc_potential(nfout,chgq_l,vxc_l) ! (stlhxc) -> vlhxc_l
  endif
! ====================================================================== 11.0

! ================================ added by K. Tagami ============== 11.0&13.0U
!
  if ( sw_magnetic_constraint == ON .and. ekmode == OFF ) then
     call m_ES_add_MagConstraintPot_chgql
  endif
!
! ================================================================= 11.0&13.0U

  call m_ESiVQ_integrate_VlhxcQlm(nfout) ! (lclchh) -> vlhxcQ

! ======================== modified by K. Tagami =============== 11.0
!  if(flg_paw)then
!     call m_PAWH_get_dion_hartree(nfout)
!     call m_PP_get_dion_paw(nfout)
!  endif

  if (flg_paw) then
     if ( noncol ) then
        if ( iteration_electronic >= 1 .or. ekmode == ON ) then
           call m_PAWH_get_dion_hartree(nfout)
           call m_PP_get_dion_paw_noncl(nfout)

           if ( SpinOrbit_Mode == ByPawPot ) then
              call m_SO_calc_SOC_strength_pawpot
              call m_SO_set_Dsoc_potential2
           endif
        endif

     else
        call m_PAWH_get_dion_hartree(nfout)
        call m_PP_get_dion_paw(nfout)
     endif
  endif
! ============================================================ 11.0

! ================================ added by K. Tagami ============== 11.0&13.0U
  if ( sw_magnetic_constraint == ON .and. ekmode == OFF ) then
     call m_ES_add_MagConstraintPot_hsr
  endif
! ================================================================= 11.0&13.0U

! ================================= added by K. Tagami ================ 11.0
  if ( noncol ) then
     if ( flg_paw ) then
        if ( ekmode==ON .or. iteration_electronic >= 1 ) then 
           call m_ES_update_Mat_dion0_noncl
        endif
     endif
     if ( sw_hubbard == OFF ) call m_ES_set_Mat_dion_scr_noncl( VlhxcQ )
  endif
! ===================================================================== 11.0

end subroutine Renewal_of_Potential

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 570 $)
!
!  SUBROUTINE: sphrp2_for_Berry
!
!  AUTHOR(S): T. Yamamoto   May/01/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
  subroutine sphrp2_for_Berry(is,gv,ylm)
! $ID: $
    use m_Const_Parameters,    only : DP, PAI, PAI4
    integer, intent(in) :: is
    real(kind=DP), intent(in), dimension(3)  :: gv
    real(kind=DP), intent(out) :: ylm
!!$C spherical harmonics.
!!$c     Some lines are rewitted by T.Yamasaki according to Y.Morikawa's
!!$c   e-mail. at 4th May 1994

    real(kind=DP) :: a,b,c,d,e,f,g
    real(kind=DP) :: gx,gy,gz,gr
    real(kind=DP), parameter :: g_minimum = 1.d-10

    gx = gv(1); gy = gv(2); gz = gv(3); gr = dsqrt(gx**2+gy**2+gz**2)
    
    if(gr < g_minimum) then
      ylm = dsqrt(1.d0/PAI4)
      return
    end if

    if(is == 1) then
       a = dsqrt(1.d0/PAI4)
       ylm = a
    else if(is == 2) then
       a = dsqrt(3.d0/PAI4)
       ylm = a*gx/gr
    else if(is == 3) then
       a = dsqrt(3.d0/PAI4)
       ylm = a*gy/gr
    else if(is == 4) then
       a = dsqrt(3.d0/PAI4)
       ylm = a*gz/gr
    else if(is == 5) then
       a = dsqrt(5.d0/(16*PAI))
       d = gz**2
       e = gx**2+gy**2+d
       ylm = a*(3*d-e)/e
    else if(is == 6) then
       a = dsqrt(15.d0/(16*PAI))
       b = gx**2
       c = gy**2
       e = b+c+gz**2
       ylm = a*(b-c)/e
    else if(is == 7) then
       a = dsqrt(15.d0/PAI4)
       e = gr**2
       ylm = a*gx*gy/e
    else if(is == 8) then
       a = dsqrt(15.d0/PAI4)
       e = gr**2
       ylm = a*gy*gz/e
    else if(is == 9) then
       a = dsqrt(15.d0/PAI4)
       e = gr**2
       ylm = a*gz*gx/e
    else if(is == 10) then
       a = dsqrt(7.d0/(16*PAI))
       d = gz**2
       e = gr**2
       f = e * gr
       ylm = a*gz*(5*d-3*e)/f
    else if(is == 11) then
       a = dsqrt(21.d0/(32*PAI))
       d = gz**2
       e = gr**2
       f = e * gr
       ylm = a*gx*(5*d-e)/f
    else if(is == 12) then
       a = dsqrt(21.d0/(32*PAI))
       d = gz**2
       e = gr**2
       f = e * gr
       ylm = a*gy*(5*d-e)/f
    else if(is == 13) then
       a = dsqrt(105.d0/(16*PAI))
       b = gx**2
       c = gy**2
       e = gr**2
       f = e * gr
       ylm = a*gz*(b-c)/f
    else if(is == 14) then
       a = dsqrt(105.d0/PAI4)
       f = gr**3
       ylm = a*gx*gy*gz/f
    else if(is == 15) then
       a = dsqrt(35.d0/(32*PAI))
       b = gx**2
       c = gy**2
       f = gr**3
       ylm = a*gx*(b-3*c)/f
    else if(is == 16) then
       a = dsqrt(35.d0/(32*pai))
       b = gx**2
       c = gy**2
       f = gr**3
       ylm = a*gy*(3*b-c)/f
    else if(is == 17) then
       a = 3.d0/8.d0/dsqrt(PAI4)
       d = gz**2
       e = gr**2
       f = e**2
       ylm = a*(5*d*(7*d-6*e)/f+3.d0)
    else if(is == 18) then
       a = 15.d0/4.d0/dsqrt(10*PAI)
       d = gz**2
       e = gr**2
       f = e**2
       ylm = a*gz*gx*(7*d-3*e)/f
    else if(is == 19) then
       a = 15.d0/4.d0/dsqrt(10.d0*PAI)
       d = gz**2
       e = gr**2
       f = e**2
       ylm = a*gy*gz*(7*d-3*e)/f
    else if(is == 20) then
       a = 15.d0/8.d0/dsqrt(5*PAI)
       b = gx**2
       c = gy**2
       d = gz**2
       e = b+c+d
       f = e**2
       ylm = a*(7*d-e)*(b-c)/f
    else if(is == 21) then
       a = 15.d0/4.d0/dsqrt(5*PAI)
       d = gz**2
       e = gr**2
       f = e**2
       ylm = a*(7*d-e)*gx*gy/f
    else if(is == 22) then
       a = 105.d0/4.d0/dsqrt(70*pai)
       b = gx**2
       c = gy**2
       f = (b+c+gz**2)**2
       ylm = a*(b-3*c)*gz*gx/f
    else if(is == 23) then
       a = 105.d0/4.d0/dsqrt(70*PAI)
       b = gx**2
       c = gy**2
       f = (b+c+gz**2)**2
       ylm = a*(3.d0*b-c)*gy*gz/f
    else if(is == 24) then
       a = 105.d0/16.d0/dsqrt(35*PAI)
       b = gx**2
       c = gy**2
       f = (b+c+gz**2)**2
       ylm = a*((b-c)**2-4*b*c)/f
    else if(is == 25) then
       a = 105.d0/4.d0/dsqrt(35*PAI)
       b = gx**2
       c = gy**2
       f = (b+c+gz**2)**2
       ylm = a*(b-c)*gx*gy/f
    else if(is == 26) then
       a = dsqrt(11.d0/PAI)/16.d0
       b = gz*gz
       c = gx*gx+gy*gy+b
       f = gr**5
       ylm = a*gz*(63.d0*b*b-70.d0*b*c+15.d0*c*c)/f
    else if(is == 27) then
       a = dsqrt(165.d0/PAI)/16.d0
       b = gz*gz
       c = gx*gx+gy*gy+b
       f = gr**5
       ylm = a*gx*(21.d0*b*b-14.d0*b*c+c*c)/f
    else if(is == 28) then
       a = dsqrt(165.d0/PAI)/16.d0
       b = gz*gz
       c = gx*gx+gy*gy+b
       f = gr**5
       ylm = a*gy*(21.d0*b*b-14.d0*b*c+c*c)/f
    else if(is == 29) then
       a = dsqrt(1155.d0/(64*PAI))
       b = gz*gz
       c = gx*gx
       d = gy*gy
       e = c+d
       f = gr**5
       ylm = a*gz*(2.d0*b-e)*(c-d)/f
    else if(is == 30) then
       a = dsqrt(1155.d0/(16.d0*PAI))
       b = gz*gz
       c = gx*gx
       d = gy*gy
       e = c+d
       f = gr**5
       ylm = a*gx*gy*gz*(2.d0*b-e)/f
    else if(is == 31) then
       a = dsqrt(385.d0/(512.d0*PAI))
       b = gz*gz
       c = gx*gx
       d = gy*gy
       e = c+d
       f = gr**5
       ylm = a*gx*(8.d0*b-e)*(c-3.d0*d)/f
    else if(is == 32) then
       a = dsqrt(385.d0/(512.d0*PAI))
       b = gz*gz
       c = gx*gx
       d = gy*gy
       e = c+d
       f = gr**5
       ylm = a*gy*(8.d0*b-e)*(3.d0*c-d)/f
    else if(is == 33) then
       a = dsqrt(385.d0/(256.d0*PAI))*3.d0
       b = gx*gx
       c = gy*gy
       f = gr**5
       ylm = a*gz*(b*b-6.d0*b*c+c*c)/f
    else if(is == 34) then
       a = dsqrt(385.d0/(16.d0*PAI))*3.d0
       b = gx*gx-gy*gy
       f = gr**5
       ylm = a*gx*gy*gz*b/f
    else if(is == 35) then
       a = dsqrt(693.d0/(512.d0*PAI))
       b = gx*gx
       c = gy*gy
       f = gr**5
       ylm = a*gx*(b*b-10.d0*b*c+5.d0*c*c)/f
    else if(is == 36) then
       a = dsqrt(693.d0/(512.d0*PAI))
       b = gy*gy
       c = gx*gx
       f = gr**5
       ylm = a*gy*(b*b-10.d0*b*c+5.d0*c*c)/f
    else if(is == 37) then
       a = dsqrt(13.d0/1024.d0*PAI)
       b = gz*gz
       c = b*b
       d = c*b
       e = gx*gx+gy*gy+b
       c = c*e
       f = e*e
       b = b*f
       f = f*e
       ylm = a*((231.d0*d-315.d0*c+105.d0*b)/f-5.d0)
    else if(is == 38) then
       a = dsqrt(273.d0/(256.d0*PAI))
       b = gz*gz
       c = b*b
       e = gx*gx+gy*gy+b
       b = b*e
       d = e*e
       f = d*e
       ylm = a*gz*gx*(33.d0*c-30.d0*b+5.d0*d)/f
    else if(is == 39) then
       a = dsqrt(273.d0/(256.d0*PAI))
       b = gz*gz
       c = b*b
       e = gx*gx+gy*gy+b
       b = b*e
       d = e*e
       f = d*e
       ylm = a*gy*gz*(33.d0*c-30.d0*b+5.d0*d)/f
    else if(is == 40) then
       a = dsqrt(1365.d0/(2048.d0*PAI))
       b = gz*gz
       c = b*b
       d = gx*gx
       f = gy*gy
       e = d+f+b 
       d = d-f
       b = b*e
       g = e*e
       f = g*e
       ylm = a*d*(33.d0*c-18.d0*b+g)/f
    else if(is == 41) then
       a = dsqrt(1365.d0/(512.d0*PAI))
       b = gz*gz
       c = b*b
       e = gx*gx+gy*gy+b 
       b = b*e
       g = e*e
       f = g*e
       ylm = a*gx*gy*(33.d0*c-18.d0*b+g)/f
    else if(is == 42) then
       a = dsqrt(1365.d0/(512.d0*PAI))
       b = gz*gz
       c = gx*gx
       d = gy*gy
       e = c+d+b 
       f = e**3
       ylm = a*gz*gx*(11.d0*b-3.d0*e)*(c-3.d0*d)/f
    else if(is == 43) then
       a = dsqrt(1365.d0/(512.d0*PAI))
       b = gz*gz
       c = gy*gy
       d = gx*gx
       e = d+c+b 
       f = e**3
       ylm = a*gy*gz*(11.d0*b-3.d0*e)*(3.d0*d-c)/f
    else if(is == 44) then
       a = dsqrt(819.d0/(1024d0*PAI))
       b = gx*gx
       c = gy*gy
       d = gz*gz
       e = b+c+d
       f = e**3
       ylm = a*(11.d0*d-e)*(b*b-6.d0*b*c+c*c)/f
    else if(is == 45) then
       a = dsqrt(819.d0/(64.d0*PAI))
       b = gx*gx
       c = gy*gy
       d = gz*gz
       e = b+c+d
       f = e**3
       ylm = a*gx*gy*(11.d0*d-e)*(b-c)/f
    else if(is == 46) then
       a = dsqrt(9009.d0/(512.d0*PAI))
       b = gx*gx
       c = gy*gy
       d = gz*gz
       e = b+c+d
       f = e**3
       ylm = a*gz*gx*(b*b-10.d0*b*c+5.d0*c*c)/f
    else if(is == 47) then
       a = dsqrt(9009.d0/(512.d0*PAI))
       b = gy*gy
       c = gx*gx
       e = c+b+gz*gz
       f = e**3
       ylm = a*gy*gz*(b*b-10.d0*b*c+5.d0*c*c)/f
    else if(is == 48) then
       a = dsqrt(3003.d0/(2048.d0*PAI))
       b = gx*gx
       c = gy*gy
       e = b+c+gz*gz
       f = e**3
       ylm = a*(b-c)*(b*b-14.d0*b*c+c*c)/f
    else if(is == 49) then
       a = dsqrt(3003.d0/(2048.d0*PAI))
       b = gx*gx
       c = gy*gy
       d = b+c
       e = b+c+gz*gz
       f = e**3
       ylm = a*gx*gy*(6.d0*d*d-32.d0*b*c)/f
    end if
  end subroutine sphrp2_for_Berry

module m_OP_Moment
! $Id: m_OP_Moment.F90 479 2016-03-12 12:30:51Z ktagami $

! =========== Contributions ===================================
!
! Through the courtesy of contributors, the following functions are added.
!
! Company:  ASMS Co.,Ltd.
!       Calculation of Orbital Moment
!
! Note:
!       In order to work the whole functions, LIB_ASMS_INTEGRAL is required.
!
! =============================================================

  use m_Control_Parameters,  only : proj_attribute, proj_group, num_proj_elems, &
       &                            max_projs, ndim_spinor, ndim_magmom, ndim_chgpot, &
       &                            iprimagmom

  use m_Const_Parameters,     only : DP, CMPLDP, zi
  use m_Ionic_System,         only : natm, iproj_group

  use m_SpinOrbit_Potential,  only :  MatU_ylm_RC_L0,  MatU_ylm_RC_L1, &
       &                              MatU_ylm_RC_L2,  MatU_ylm_RC_L3
  use m_Orbital_Population,   only :  om, om_aimag, ommix, ommix_aimag, i2lp
  use m_Parallelization,       only : mype

  use m_ES_NonCollinear,       only :  m_ES_MagMom_To_DensMat_porb, &
       &                               m_ES_set_Pauli_Matrix
  use m_Files,                 only : nfout

! ==== KT_add === 2014/08/26
  use m_KPoints,           only : kv3, vkxyz
  use m_Const_Parameters,   only : PAI4, CARTS, ON
  use m_Control_Parameters,  only : kimg, noncol, neg, sw_mix_charge_hardpart, &
       &                            sw_use_add_proj, sw_use_contracted_psir
  use m_PseudoPotential,    only : ltp, mtp, taup, nlmt, isph, il2p, dl2p, ilmt, &
       &                            q, q_noncl, nlmta, lmta, nmesh, mmesh, radr, wos, &
       &                            flg_paw, ia2ia_symmtry_op_inv, &
       &                            crotylm_paw, nylm_paw, iylm_paw, wf_mnrc, &
       &                            psir_val, &
       &                            nloc, ntau, lpsmax, itau, &
       &                            ilmt_add, nlmt_add, ltp_add, mtp_add, &
       &                            lmta_add, nlmta_add
  use m_PlaneWaveBasisSet,    only : ngabc, kgp, kg1, iba, nbase
  use m_Parallelization,    only : ista_kngp, iend_kngp, npes, mpi_comm_group, ierr, &
       &                           map_k, map_e, map_z, myrank_k, myrank_e, np_e, &
       &                           ista_k, iend_k
  use m_NonLocal_Potential, only : new_radr_and_wos
  use m_Ionic_System,        only : ityp, pos, cps, iatomn, ntyp, speciesname
  use m_Crystal_Structure,   only : rltv, univol, nopr, op
  use m_CS_Magnetic,     only : magmom_dir_inversion_opr_flag
  use m_Charge_Density,      only : hsr, hsi, hsr_add, hsi_add
  use m_CD_Mag_Moment,        only : rad_cov, rad_cov_default, product_psir_val
  use m_ES_NonCollinear,     only : m_ES_MagMom_to_DensMat_Gspace, &
       &                            m_ES_MagMom_To_DensMat_hsr, &
       &                            m_ES_DensMat_To_MagMom_hsr
  use m_Electronic_Structure,  only : zaj_l, occup_l
! =============== 2014/08/26

  implicit none
  include 'mpif.h'

  complex(kind=CMPLDP) :: Mat_L_with_cmplx_ylm_L0(  0:0, 0:0, 3 )
  complex(kind=CMPLDP) :: Mat_L_with_cmplx_ylm_L1( -1:1,-1:1, 3 )
  complex(kind=CMPLDP) :: Mat_L_with_cmplx_ylm_L2( -2:2,-2:2, 3 )
  complex(kind=CMPLDP) :: Mat_L_with_cmplx_ylm_L3( -3:3,-3:3, 3 )
!
  complex(kind=CMPLDP) :: Mat_L_with_real_ylm_L0( 1, 1, 3 )
  complex(kind=CMPLDP) :: Mat_L_with_real_ylm_L1( 3, 3, 3 )
  complex(kind=CMPLDP) :: Mat_L_with_real_ylm_L2( 5, 5, 3 )
  complex(kind=CMPLDP) :: Mat_L_with_real_ylm_L3( 7, 7, 3 )

! ==== KT_add === 2014/08/26
  real(kind=DP), allocatable :: OrbMag_on_atom(:,:)
  real(kind=DP), allocatable :: rho_ylm1_ylm2_r(:,:,:,:), rho_ylm1_ylm2_i(:,:,:,:)
  complex(kind=CMPLDP), allocatable :: wfn_sph_decomposed(:,:,:)
! =============== 2014/08/26

contains

  subroutine m_OP_calc_orbmom_from_OCC           ! From occupation marix
    integer :: ia, it, i, ig, ie, ip, l, m1, m2
    integer :: is1, is2, istmp, size1
!
    real(kind=DP) :: orbmom(3), spinmom(3)
    complex(kind=CMPLDP) :: ztmp(3)
    complex(kind=CMPLDP) :: PauliMatrix( ndim_magmom, ndim_spinor, ndim_spinor )
!
    real(kind=DP), allocatable :: dmmat_r_magmom( :,:,: )
    real(kind=DP), allocatable :: dmmat_i_magmom( :,:,: )
    complex(kind=CMPLDP), allocatable :: dmmat_ssrep( :,:,: )

    logical :: FirstFlag = .true.
    logical :: print_header
! -----------
    if ( iprimagmom < 3 ) return

    if ( FirstFlag ) then
       call m_OP_calc_MatL_orb_s_to_f
       FirstFlag = .false.
    endif
    print_header = .true.

    call m_ES_set_Pauli_Matrix( PauliMatrix )

    do ia=1, natm
       ig = iproj_group(ia)
       if ( ig <1 ) cycle

       do i=1,num_proj_elems(ig)
          ip = proj_group(i,ig)
          it = proj_attribute(ip)%ityp
          ie = proj_attribute(ip)%ielem
          l  = proj_attribute(ip)%l

          size1 = i2lp(ip)
          allocate( dmmat_r_magmom(size1,size1,ndim_magmom) ); dmmat_r_magmom = 0.0d0
          allocate( dmmat_i_magmom(size1,size1,ndim_magmom) ); dmmat_i_magmom = 0.0d0
          allocate( dmmat_ssrep(size1,size1,ndim_chgpot) );  dmmat_ssrep = 0.0d0

!          dmmat_r_magmom(:,:,:) = om(:,:,ie,ia,:)
!          dmmat_i_magmom(:,:,:) = om_aimag(:,:,ie,ia,:)
          dmmat_r_magmom(:,:,:) = ommix(:,:,ie,ia,:)
          dmmat_i_magmom(:,:,:) = ommix_aimag(:,:,ie,ia,:)

          call m_ES_MagMom_To_DensMat_porb( size1**2, dmmat_r_magmom, dmmat_i_magmom, &
               &                            dmmat_ssrep )

          orbmom = 0.0d0; spinmom = 0.0d0

          Do is1=1, ndim_spinor
             Do is2=1, ndim_spinor
                if ( is1 /= is2 ) cycle

                istmp = ( is1 -1 )*ndim_spinor + is2

                Do m1=1, size1
                   Do m2=1, size1
                      ztmp = 0.0d0
                      if ( l == 1 ) then
                         ztmp(:) = Mat_L_with_real_ylm_L1( m2, m1, : )
                      else if ( l == 2 ) then
                         ztmp(:) = Mat_L_with_real_ylm_L2( m2, m1, : )
                      else if ( l == 3 ) then
                         ztmp(:) = Mat_L_with_real_ylm_L3( m2, m1, : )
                      endif

                      orbmom(1) = orbmom(1) +dmmat_ssrep(m1,m2,istmp) *ztmp(1)
                      orbmom(2) = orbmom(2) +dmmat_ssrep(m1,m2,istmp) *ztmp(2)
                      orbmom(3) = orbmom(3) +dmmat_ssrep(m1,m2,istmp) *ztmp(3)
                   End do
                End do
             End do
          End do

          Do is1=1, ndim_spinor
             Do is2=1, ndim_spinor
                istmp = ( is1 -1 )*ndim_spinor + is2
                Do m1=1, size1
                   Do m2=1, size1
                      if ( m1 /= m2 ) cycle

                      spinmom(1) = spinmom(1) +dmmat_ssrep(m1,m2,istmp) &
                           &                  *PauliMatrix(2,is2,is1)
                      spinmom(2) = spinmom(2) +dmmat_ssrep(m1,m2,istmp) &
                           &                  *PauliMatrix(3,is2,is1)
                      spinmom(3) = spinmom(3) +dmmat_ssrep(m1,m2,istmp) &
                           &                  *PauliMatrix(4,is2,is1)
                   End do
                End do
             End do
          End do
!
          deallocate( dmmat_r_magmom ); deallocate( dmmat_i_magmom )
          deallocate( dmmat_ssrep )
! --
          call  print_spin_orb_mom_local( ia, l, spinmom, orbmom, print_header )
          print_header = .false.
       end do
    End do

  contains

    subroutine print_spin_orb_mom_local( ia, l, spinmom, orbmom, print_header )
      integer, intent(in) :: ia, l
      real(kind=DP), intent(in) :: spinmom(3), orbmom(3)
      logical, intent(in) :: print_header

      if (print_header) then
         write(nfout,*) '! ------------ Local Momemnt ( occmat )  --- '
      endif

      write(nfout,*) '!   ia   l   type          mx             my             mz  '
!
      write(nfout,'(I7,I4,3X,A5,3F15.8)') ia, l, &
           &                              "spin ", spinmom(1), spinmom(2), spinmom(3)
      write(nfout,'(14X,     A5,3F15.8)') &
           &                              "orb  ", orbmom(1), orbmom(2), orbmom(3)
!
      write(nfout,*) '! ------ '

    end subroutine print_spin_orb_mom_local

  end subroutine m_OP_calc_orbmom_from_OCC


! ------------------
  subroutine m_OP_calc_MatL_orb_s_to_f
    real(kind=DP) :: theta, phi

    theta = 0.0; phi = 0.0d0
    call m_OP_calc_MatL_with_Cmplx_ylm( 0, theta, phi, &
         &                              Mat_L_with_cmplx_ylm_L0 )
    call m_OP_calc_MatL_with_Real_ylm( 0, MatU_ylm_RC_L0, &
         &                             Mat_L_with_cmplx_ylm_L0, &
         &                             Mat_L_with_real_ylm_L0 )
!
    call m_OP_calc_MatL_with_Cmplx_ylm( 1, theta, phi, &
         &                              Mat_L_with_cmplx_ylm_L1 )
    call m_OP_calc_MatL_with_Real_ylm( 1, MatU_ylm_RC_L1, &
         &                             Mat_L_with_cmplx_ylm_L1, &
         &                             Mat_L_with_real_ylm_L1 )
!
    call m_OP_calc_MatL_with_Cmplx_ylm( 2, theta, phi, &
         &                              Mat_L_with_cmplx_ylm_L2 )
    call m_OP_calc_MatL_with_Real_ylm( 2, MatU_ylm_RC_L2, &
         &                              Mat_L_with_cmplx_ylm_L2, &
         &                              Mat_L_with_real_ylm_L2 )
!
    call m_OP_calc_MatL_with_Cmplx_ylm( 3, theta, phi, &
         &                              Mat_L_with_cmplx_ylm_L3 )
    call m_OP_calc_MatL_with_Real_ylm( 3, MatU_ylm_RC_L3, &
         &                             Mat_L_with_cmplx_ylm_L3, &
         &                             Mat_L_with_real_ylm_L3 )
  end subroutine m_OP_calc_MatL_orb_s_to_f


  subroutine m_OP_calc_MatL_with_Real_ylm( l_in, MatU_ylm_RC, &
       &                                   Mat_L_with_cmplx_ylm, &
       &                                   Mat_L_with_real_ylm )
    integer, intent(in) :: l_in
    Complex(kind=CMPLDP), intent(in) :: MatU_ylm_RC( 2*l_in+1, -l_in:l_in )
    complex(kind=CMPLDP), intent(in) :: &
         &    Mat_L_with_cmplx_ylm( -l_in:l_in, -l_in:l_in, 3 )
    complex(kind=CMPLDP), intent(out) :: &
         &    Mat_L_with_real_ylm( 2*l_in+1, 2*l_in+1, 3 )

    integer :: m_min, m_max
    !
    integer :: ixyz
    integer :: m1, m2, ma, mb
!
    Complex(kind=CMPLDP) :: ztmp( 3 )
!
    m_min = -l_in;  m_max = l_in
!
    Do m1=1, 2 *l_in +1
       Do m2=1, 2 *l_in +1

          ztmp = 0.0d0

          Do ma = m_min, m_max
             Do mb = m_min, m_max
                Do ixyz=1, 3
#if 1
                   ztmp(ixyz) = ztmp(ixyz) + conjg(MatU_ylm_RC( m1,ma ))&
                        &                *Mat_L_with_cmplx_ylm( ma,mb,ixyz ) &
                        &                *( MatU_ylm_RC( m2,mb ) )
#else
!                   ztmp(is) = ztmp(is) + MatU_ylm_RC( m1,ma )&
!                        &                *Mat_LS_with_cmplx_ylm( ma,mb,is ) &
!                        &                *conjg( MatU_ylm_RC( m2,mb ) )
#endif

                End do
             End do
          End do
          Mat_L_with_real_ylm( m1,m2,: ) = ztmp(:)
       End do
    End do
  end subroutine m_OP_calc_MatL_with_Real_ylm

  subroutine m_OP_calc_MatL_with_Cmplx_ylm( l_in, theta, phi, Mat_L_term )
    integer, intent(in) :: l_in
    real(kind=DP), intent(in) :: theta, phi
    complex(kind=CMPLDP), intent(out) :: &
         &          Mat_L_term( -l_in:l_in, -l_in:l_in, 3 )

    real(kind=DP) :: cos_th, sin_th, cos2_th_h, sin2_th_h
    real(kind=DP) :: ctmp_m, ctmp_p, ctmp_0

    integer :: m1, m2

    Do m1=-l_in, l_in
       Do m2=-l_in, l_in

          if ( m2 == m1 +1 ) then
             ctmp_m = sqrt( (l_in +m1 +1.0d0) *( l_in -m1 ) )
          else
             ctmp_m = 0.0d0
          endif

          if ( m2 == m1 -1 ) then
             ctmp_p = sqrt( (l_in -m1 +1.0d0) *( l_in +m1 ) )
          else
            ctmp_p = 0.0d0
          endif
          !
          if ( m1 == m2 ) then
             ctmp_0 = dble(m1)
          else
             ctmp_0 = 0.0d0
          endif

          Mat_L_term( m1,m2,1 ) =  ( ctmp_p +ctmp_m ) /2.0d0
          Mat_L_term( m1,m2,2 ) =  ( ctmp_p -ctmp_m ) /2.0d0 /zi
          Mat_L_term( m1,m2,3 ) =  ctmp_0

       End do
    End Do

  end subroutine m_OP_calc_MatL_with_Cmplx_ylm

! ==== KT_add === 2014/08/26
  subroutine m_OP_calc_OrbMagMom_in_sphere
    logical :: FirstFlag = .true.

    if ( FirstFlag ) then
       call m_OP_calc_MatL_orb_s_to_f
       FirstFlag = .false.
    endif

    if ( kimg == 1 ) return
    if ( .not. noncol ) return

    call alloc_arrays

#ifdef USE_ASMS_INTEGRAL
    call calc_ylm_dot_wfns_fast
#else
    call calc_ylm_dot_wfns_exact
#endif

    call calc_rho_ylm1_ylm2
    if ( flg_paw .or. sw_mix_charge_hardpart == ON ) then
       call symmetrz_rho_ylm1_ylm2
    endif

    allocate( OrbMag_on_atom(natm,3) );  OrbMag_on_atom = 0.0d0

    call calc_soft_part_contrib
    call calc_hard_part_contrib

    call print_orb_mom

    call dealloc_arrays
    deallocate( OrbMag_on_atom )
    
  contains

    subroutine alloc_arrays
      allocate( wfn_sph_decomposed( np_e, nlmta, ista_k:iend_k ) )
      wfn_sph_decomposed = 0.0d0

      allocate( rho_ylm1_ylm2_r( natm, nlmt, nlmt, ndim_magmom ) )
      allocate( rho_ylm1_ylm2_i( natm, nlmt, nlmt, ndim_magmom ) )
      rho_ylm1_ylm2_r = 0.0d0;  rho_ylm1_ylm2_i = 0.0d0

    end subroutine alloc_arrays

    subroutine dealloc_arrays
      deallocate( wfn_sph_decomposed )
      deallocate( rho_ylm1_ylm2_r );  deallocate( rho_ylm1_ylm2_i )
    end subroutine dealloc_arrays

    subroutine calc_ylm_dot_wfns_exact
      integer :: ia, it, ik, ib, ie, ig
      integer :: lmt1, il1, im1, it1, ilmta
      integer :: nspher, ir
      real(kind=DP) :: rad1, c1, facr
      complex(kind=CMPLDP) :: zfac1, zsum, z2

      real(kind=DP), allocatable :: qx(:), qy(:), qz(:), vlength(:)
      real(kind=DP), allocatable :: ylm(:), wka(:), wkb(:)
      real(kind=DP), allocatable :: rwork(:)
      complex(kind=CMPLDP), allocatable :: zph(:)

      allocate( radr(mmesh) );  allocate( wos(mmesh) )

      allocate( qx(kg1) ); allocate( qy(kg1) ); allocate( qz(kg1) );
      allocate( vlength(kg1) ); allocate( ylm(kg1) )
      allocate( wka(kg1) ); allocate( wkb(kg1) )

      allocate( zph(kg1) ); allocate( rwork(kg1) )

      Do ia=1, natm
         it = ityp(ia);  rad1 = rad_cov(ia)

         call new_radr_and_wos(ista_k,it)

         do lmt1=1,ilmt(it)
            il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
            ilmta = lmta(lmt1,ia)

            nspher = (il1-1)**2 + im1
            zfac1 = zi **(il1-1)

            Do ik=1, kv3
               if ( map_k(ik) /= myrank_k ) cycle

               call k_plus_G_vectors_3D( ik, kgp, kg1, kv3, iba, nbase, vkxyz, &
                    &                 ngabc, rltv, qx, qy, qz, vlength )
               call sphr( iba(ik), nspher, qx, qy, qz, ylm )

               Do ig=1, iba(ik)
                  c1 = qx(ig)*cps(ia,1) +qy(ig)*cps(ia,2) +qz(ig)*cps(ia,3)
                  zph(ig) = dcmplx( cos(c1), sin(c1) )
               End do

               rwork = 0.0d0

               Do ir=1, nmesh(it)
                  if ( radr(ir) > rad_cov(ia) ) exit
!!                  if ( ir > wf_mnrc(it) ) exit

                  facr = wos(ir) *radr(ir)**2

                  Do ig=1, iba(ik)
                     wka(ig) = vlength(ig) *radr(ir)
                  End do
                  call dsjnv( il1-1, iba(ik), wka, wkb )

                  Do ig=1, iba(ik)
                     rwork(ig) = rwork(ig) + facr *wkb(ig) *ylm(ig)
                  End do
               End do
!
               Do ib=1, neg
                  if ( map_e(ib) /= myrank_e ) cycle
                  ie = map_z(ib)

                  zsum = 0.0d0
                  Do ig=1, iba(ik)
                     z2 = dcmplx( zaj_l(ig,ie,ik,1), zaj_l(ig,ie,ik,kimg) )
                     zsum = zsum + z2 *zph(ig) *rwork(ig)
                  End do
                  wfn_sph_decomposed(ie,ilmta,ik) = zsum *zfac1
               End do
            End Do
         End do
      End Do
!
      wfn_sph_decomposed = wfn_sph_decomposed *PAI4 /sqrt(univol)

      deallocate( zph ); deallocate( radr ); deallocate( wos )
      deallocate( qx ); deallocate( qy ); deallocate( qz ); deallocate( vlength )
      deallocate( ylm )
      deallocate( wka ); deallocate( wkb )
    end subroutine calc_ylm_dot_wfns_exact

#ifdef USE_ASMS_INTEGRAL
    subroutine calc_ylm_dot_wfns_fast
      interface
         real(8) function ASMS_integ_spherical_bessel_j(a,b,c)
           integer :: a
           real(8) :: b, c
         end function ASMS_integ_spherical_bessel_j
      end interface

      integer :: ia, it, ik, ib, ie, ig
      integer :: lmt1, il1, im1, it1, ilmta
      integer :: nspher, ir
      real(kind=DP) :: rad1, c1, facr, bfact
      complex(kind=CMPLDP) :: zfac1, zsum, z2

      real(kind=DP), allocatable :: qx(:), qy(:), qz(:), vlength(:)
      real(kind=DP), allocatable :: ylm(:)
      real(kind=DP), allocatable :: sph_besselj_integ(:)
      complex(kind=CMPLDP), allocatable :: zph(:)

      allocate( qx(kg1) ); allocate( qy(kg1) ); allocate( qz(kg1) ); 
      allocate( vlength(kg1) ); 
      allocate( ylm(kg1) );     allocate( zph(kg1) ); 
      allocate( sph_besselj_integ(kg1) )

      Do ia=1, natm
         it = ityp(ia);  rad1 = rad_cov(ia)

         do lmt1=1,ilmt(it)
            il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
            ilmta = lmta(lmt1,ia)

            nspher = (il1-1)**2 + im1
            zfac1 = zi **(il1-1)
            
            Do ik=1, kv3
               if ( map_k(ik) /= myrank_k ) cycle

               call k_plus_G_vectors_3D( ik, kgp, kg1, kv3, iba, nbase, vkxyz, &
                    &                 ngabc, rltv, qx, qy, qz, vlength )
               call sphr( iba(ik), nspher, qx, qy, qz, ylm )     

               Do ig=1, iba(ik)
                  c1 = qx(ig)*cps(ia,1) +qy(ig)*cps(ia,2) +qz(ig)*cps(ia,3)
                  zph(ig) = dcmplx( cos(c1), sin(c1) )

                  sph_besselj_integ(ig) &
                       &   = ASMS_integ_spherical_bessel_j( il1 -1, vlength(ig), rad1 )
               End do

               Do ib=1, neg
                  if ( map_e(ib) /= myrank_e ) cycle
                  ie = map_z(ib)

                  zsum = 0.0d0
                  Do ig=1, iba(ik)
                     z2 = dcmplx( zaj_l(ig,ie,ik,1), zaj_l(ig,ie,ik,kimg) )
                     zsum = zsum + z2 *zph(ig) *ylm(ig) *sph_besselj_integ(ig)
                  End do
                  wfn_sph_decomposed(ie,ilmta,ik) = zsum *zfac1
               End do
            End Do
         End do
      End Do
!
      wfn_sph_decomposed = wfn_sph_decomposed *PAI4 /sqrt(univol)

      deallocate( qx ); deallocate( qy ); deallocate( qz ); deallocate( vlength )
      deallocate( ylm );deallocate( zph );
      deallocate( sph_besselj_integ )

    end subroutine calc_ylm_dot_wfns_fast
#endif

    subroutine calc_soft_part_contrib
      integer :: ia, it, lmt1, lmt2, is1, is2, istmp
      integer :: il1, il2, im1, im2, it1, it2
      real(kind=DP), allocatable :: hsr_ssrep(:,:,:,:), hsi_ssrep(:,:,:,:)
      real(kind=DP) :: orbmom(3)
      complex(kind=CMPLDP) :: ztmp(3), z1, z2

      allocate( hsr_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsr_ssrep = 0.0d0
      allocate( hsi_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsi_ssrep = 0.0d0
      
      call m_ES_MagMom_To_DensMat_hsr( natm, nlmt, rho_ylm1_ylm2_r, rho_ylm1_ylm2_i, &
           &                           hsr_ssrep, hsi_ssrep )

      Do ia=1, natm
         it = ityp(ia)

         orbmom = 0.0d0

         Do is1=1, ndim_spinor
            Do is2=1, ndim_spinor
               if ( is1 /= is2 ) cycle
               istmp = (is1 -1)*ndim_spinor +is2

               do lmt1=1,ilmt(it)
                  il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
                  if ( it1 > 1 ) cycle
                  if ( il1 <= 1 .or. il1 >4 ) cycle

                  do lmt2=1,ilmt(it)
                     il2=ltp(lmt2,it);  im2=mtp(lmt2,it); it2=taup(lmt2,it)
                     if ( it2 > 1 ) cycle
                     if ( il1 /= il2 ) cycle

                     ztmp = 0.0d0
                     if ( il1 == 2 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L1( im2, im1, : )
                     else if ( il1 == 3 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L2( im2, im1, : )
                     else if ( il1 == 4 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L3( im2, im1, : )
                     endif
                     
                     z1 = dcmplx( hsr_ssrep(ia,lmt1,lmt2,istmp), &
                          &       hsi_ssrep(ia,lmt1,lmt2,istmp) )

                     orbmom(1) = orbmom(1) +z1*ztmp(1)
                     orbmom(2) = orbmom(2) +z1*ztmp(2)
                     orbmom(3) = orbmom(3) +z1*ztmp(3)
                  End do
               End Do
!
            End do
         End do

         OrbMag_on_atom(ia,1) = OrbMag_on_atom(ia,1) +orbmom(1)
         OrbMag_on_atom(ia,2) = OrbMag_on_atom(ia,2) +orbmom(2)
         OrbMag_on_atom(ia,3) = OrbMag_on_atom(ia,3) +orbmom(3)
      End Do
      deallocate( hsr_ssrep, hsi_ssrep )
    end subroutine calc_soft_part_contrib

    subroutine calc_hard_part_contrib  
      integer :: ia, it, lmt1, lmt2, is1, is2, istmp
      integer :: il1, il2, im1, im2, it1, it2
      real(kind=DP), allocatable :: hsr_ssrep(:,:,:,:), hsi_ssrep(:,:,:,:)
      real(kind=DP) :: orbmom(3)
      complex(kind=CMPLDP) :: ztmp(3), z1, z2

      allocate( hsr_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsr_ssrep = 0.0d0
      allocate( hsi_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsi_ssrep = 0.0d0
      
      call m_ES_MagMom_To_DensMat_hsr( natm, nlmt, hsr, hsi, hsr_ssrep, hsi_ssrep )

      Do ia=1, natm
         it = ityp(ia)

         orbmom = 0.0d0

         Do is1=1, ndim_spinor
            Do is2=1, ndim_spinor
               if ( is1 /= is2 ) cycle
               istmp = (is1 -1)*ndim_spinor +is2

               do lmt1=1,ilmt(it)
                  il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
                  do lmt2=1,ilmt(it)
                     il2=ltp(lmt2,it);  im2=mtp(lmt2,it); it2=taup(lmt2,it)

                     if ( il1 <= 1 .or. il1 >4 ) cycle
                     if ( il1 /= il2 ) cycle

                     ztmp = 0.0d0
                     if ( il1 == 2 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L1( im2, im1, : )
                     else if ( il1 == 3 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L2( im2, im1, : )
                     else if ( il1 == 4 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L3( im2, im1, : )
                     endif
                     
                     z1 = dcmplx( hsr_ssrep(ia,lmt1,lmt2,istmp), &
                          &       hsi_ssrep(ia,lmt1,lmt2,istmp) )
                     z2 = z1 *q_noncl(lmt1,lmt2,istmp,it)
!                     z2 = z1 *q(lmt1,lmt2,it)

                     orbmom(1) = orbmom(1) +z2*ztmp(1)
                     orbmom(2) = orbmom(2) +z2*ztmp(2)
                     orbmom(3) = orbmom(3) +z2*ztmp(3)
                  End do
               End Do
!
            End do
         End do
         OrbMag_on_atom(ia,1) = OrbMag_on_atom(ia,1) +orbmom(1)
         OrbMag_on_atom(ia,2) = OrbMag_on_atom(ia,2) +orbmom(2)
         OrbMag_on_atom(ia,3) = OrbMag_on_atom(ia,3) +orbmom(3)
      End Do
      deallocate( hsr_ssrep, hsi_ssrep )

    end subroutine calc_hard_part_contrib

    subroutine print_orb_mom
      integer :: ia, it, k

      if ( mype /= 0 ) return
      
      write(nfout,*) &
           & '! ------------ Local Orbital Momemnt (in sphere) at this scf step --- '

       write(nfout,*) &
            & '!   id   atom no.        mx             my             mz'
       Do ia=1, natm
          it = ityp(ia)
          write(nfout,'(I7,F10.4,3F15.8)') ia, iatomn(it), &
               &                          OrbMag_on_atom(ia,1), &
               &                          OrbMag_on_atom(ia,2), &
               &                          OrbMag_on_atom(ia,3)
       End Do
       write(nfout,*) '! ---------------------------------------------'

    end subroutine print_orb_mom

  end subroutine m_OP_calc_OrbMagMom_in_sphere

  subroutine m_OP_calc_OrbMagMom_method1
    logical :: FirstFlag = .true.

    if ( FirstFlag ) then
       call m_OP_calc_MatL_orb_s_to_f
       FirstFlag = .false.
    endif

    if ( kimg == 1 ) return
    if ( .not. noncol ) return

    call alloc_arrays

    call calc_psir_ylm_dot_wfns

    call calc_rho_ylm1_ylm2
    if ( flg_paw .or. sw_mix_charge_hardpart == ON ) then
       call symmetrz_rho_ylm1_ylm2
    endif

    allocate( OrbMag_on_atom(natm,3) );  OrbMag_on_atom = 0.0d0

    call calc_soft_part_contrib
    call calc_hard_part_contrib

    call print_orb_mom

    call dealloc_arrays
    deallocate( OrbMag_on_atom )

  contains

    subroutine alloc_arrays
      allocate( wfn_sph_decomposed( np_e, nlmta, ista_k:iend_k ) )
      wfn_sph_decomposed = 0.0d0

      allocate( rho_ylm1_ylm2_r( natm, nlmt, nlmt, ndim_magmom ) )
      allocate( rho_ylm1_ylm2_i( natm, nlmt, nlmt, ndim_magmom ) )
      rho_ylm1_ylm2_r = 0.0d0;  rho_ylm1_ylm2_i = 0.0d0

    end subroutine alloc_arrays

    subroutine dealloc_arrays
      deallocate( wfn_sph_decomposed )
      deallocate( rho_ylm1_ylm2_r );  deallocate( rho_ylm1_ylm2_i )
    end subroutine dealloc_arrays

    subroutine calc_psir_ylm_dot_wfns
      integer :: ia, it, ik, ib, ie, ig
      integer :: lmt1, il1, im1, it1, ilmta
      integer :: nspher, ir
      real(kind=DP) :: rad1, c1, facr
      complex(kind=CMPLDP) :: zfac1, zsum, z2

      real(kind=DP), allocatable :: qx(:), qy(:), qz(:), vlength(:)
      real(kind=DP), allocatable :: ylm(:), wka(:), wkb(:)
      real(kind=DP), allocatable :: rwork(:)
      complex(kind=CMPLDP), allocatable :: zph(:)

      allocate( radr(mmesh) );  allocate( wos(mmesh) )

      allocate( qx(kg1) ); allocate( qy(kg1) ); allocate( qz(kg1) );
      allocate( vlength(kg1) ); allocate( ylm(kg1) )
      allocate( wka(kg1) ); allocate( wkb(kg1) )

      allocate( zph(kg1) ); allocate( rwork(kg1) )

      Do it=1, ntyp
         call new_radr_and_wos(ista_k,it)
         rad1 = rad_cov_default( nint(iatomn(it)) ) ! Revised according to a report from ASMS Co.ltd, 10 March 2016.

         do lmt1=1,ilmt(it)
            il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
            
            nspher = (il1-1)**2 +im1;  
            zfac1 = zi **(il1-1)

            Do ik=1, kv3
               if ( map_k(ik) /= myrank_k ) cycle
         
               call k_plus_G_vectors_3D( ik, kgp, kg1, kv3, iba, nbase, vkxyz, &
                    &                 ngabc, rltv, qx, qy, qz, vlength )
               call sphr( iba(ik), nspher, qx, qy, qz, ylm )

               rwork = 0.0d0

               Do ir=1, nmesh(it)
!                  if ( ir > wf_mnrc(it) ) exit
                  if ( radr(ir) > rad1 ) exit

!                  facr = wos(ir) *psirpw(ir,il1,it1,it) *radr(ir)
                  facr = wos(ir) *psir_val(ir,il1,it1,it) *radr(ir)
!                  facr = wos(ir) *phirpw(ir,il1,it1,it) *radr(ir)

                  Do ig=1, iba(ik)
                     wka(ig) = vlength(ig) *radr(ir)
                  End do
                  call dsjnv( il1-1, iba(ik), wka, wkb )

                  Do ig=1, iba(ik)
                     rwork(ig) = rwork(ig) + facr *wkb(ig) *ylm(ig)
                  End do
               End do

               Do ia=1, natm
                  if ( ityp(ia) /= it ) cycle
                  ilmta = lmta(lmt1,ia)

                  Do ig=1, iba(ik)
                     c1 = qx(ig)*cps(ia,1) +qy(ig)*cps(ia,2) +qz(ig)*cps(ia,3)
                     zph(ig) = dcmplx( cos(c1), sin(c1) )
                  End do

!
                  Do ib=1, neg
                     if ( map_e(ib) /= myrank_e ) cycle
                     ie = map_z(ib)

                     zsum = 0.0d0
                     Do ig=1, iba(ik)
                        z2 = dcmplx( zaj_l(ig,ie,ik,1), zaj_l(ig,ie,ik,kimg) )
                        zsum = zsum + z2 *zph(ig) *rwork(ig)
                     End do
                     wfn_sph_decomposed(ie,ilmta,ik) = zsum *zfac1
                  End do
               End do
            End Do
         End do
      End Do
!
      wfn_sph_decomposed = wfn_sph_decomposed *PAI4 /sqrt(univol)

      deallocate( zph ); deallocate( radr ); deallocate( wos )
      deallocate( qx ); deallocate( qy ); deallocate( qz ); deallocate( vlength )
      deallocate( ylm )
      deallocate( wka ); deallocate( wkb )
    end subroutine calc_psir_ylm_dot_wfns

    subroutine calc_soft_part_contrib
      integer :: ia, it, lmt1, lmt2, is1, is2, istmp
      integer :: il1, il2, im1, im2, it1, it2
      real(kind=DP), allocatable :: hsr_ssrep(:,:,:,:), hsi_ssrep(:,:,:,:)
      real(kind=DP) :: orbmom(3)
      complex(kind=CMPLDP) :: ztmp(3), z1, z2

      allocate( hsr_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsr_ssrep = 0.0d0
      allocate( hsi_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsi_ssrep = 0.0d0
      
      call m_ES_MagMom_To_DensMat_hsr( natm, nlmt, rho_ylm1_ylm2_r, rho_ylm1_ylm2_i, &
           &                           hsr_ssrep, hsi_ssrep )

      Do ia=1, natm
         it = ityp(ia)

         orbmom = 0.0d0

         Do is1=1, ndim_spinor
            Do is2=1, ndim_spinor
               if ( is1 /= is2 ) cycle
               istmp = (is1 -1)*ndim_spinor +is2

               do lmt1=1,ilmt(it)
                  il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
                  if ( il1 <= 1 .or. il1 >4 ) cycle
!                  if (it1 >1 ) cycle

                  do lmt2=1,ilmt(it)
                     il2=ltp(lmt2,it);  im2=mtp(lmt2,it); it2=taup(lmt2,it)
                     if ( il1 /= il2 ) cycle
!                     if (it2 >1 ) cycle

                     ztmp = 0.0d0
                     if ( il1 == 2 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L1( im2, im1, : )
                     else if ( il1 == 3 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L2( im2, im1, : )
                     else if ( il1 == 4 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L3( im2, im1, : )
                     endif
                     
                     z1 = dcmplx( hsr_ssrep(ia,lmt1,lmt2,istmp), &
                          &       hsi_ssrep(ia,lmt1,lmt2,istmp) )
                     z1 = z1 *product_psir_val(il1,it1,it2,it)

                     orbmom(1) = orbmom(1) +z1*ztmp(1)
                     orbmom(2) = orbmom(2) +z1*ztmp(2)
                     orbmom(3) = orbmom(3) +z1*ztmp(3)
                  End do
               End Do
!
            End do
         End do

         OrbMag_on_atom(ia,1) = OrbMag_on_atom(ia,1) +orbmom(1)
         OrbMag_on_atom(ia,2) = OrbMag_on_atom(ia,2) +orbmom(2)
         OrbMag_on_atom(ia,3) = OrbMag_on_atom(ia,3) +orbmom(3)
      End Do
      deallocate( hsr_ssrep, hsi_ssrep )
    end subroutine calc_soft_part_contrib

    subroutine calc_hard_part_contrib  
      integer :: ia, it, lmt1, lmt2, is1, is2, istmp
      integer :: il1, il2, im1, im2, it1, it2
      real(kind=DP), allocatable :: hsr_ssrep(:,:,:,:), hsi_ssrep(:,:,:,:)
      real(kind=DP) :: orbmom(3)
      complex(kind=CMPLDP) :: ztmp(3), z1, z2

      allocate( hsr_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsr_ssrep = 0.0d0
      allocate( hsi_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsi_ssrep = 0.0d0
      
      call m_ES_MagMom_To_DensMat_hsr( natm, nlmt, hsr, hsi, hsr_ssrep, hsi_ssrep )

      Do ia=1, natm
         it = ityp(ia)

         orbmom = 0.0d0

         Do is1=1, ndim_spinor
            Do is2=1, ndim_spinor
               if ( is1 /= is2 ) cycle
               istmp = (is1 -1)*ndim_spinor +is2

               do lmt1=1,ilmt(it)
                  il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
                  do lmt2=1,ilmt(it)
                     il2=ltp(lmt2,it);  im2=mtp(lmt2,it); it2=taup(lmt2,it)

                     if ( il1 <= 1 .or. il1 >4 ) cycle
                     if ( il1 /= il2 ) cycle

                     ztmp = 0.0d0
                     if ( il1 == 2 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L1( im2, im1, : )
                     else if ( il1 == 3 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L2( im2, im1, : )
                     else if ( il1 == 4 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L3( im2, im1, : )
                     endif
                     
                     z1 = dcmplx( hsr_ssrep(ia,lmt1,lmt2,istmp), &
                          &       hsi_ssrep(ia,lmt1,lmt2,istmp) )
                     z2 = z1 *q_noncl(lmt1,lmt2,istmp,it)
!                     z2 = z1 *q(lmt1,lmt2,it)

                     orbmom(1) = orbmom(1) +z2*ztmp(1)
                     orbmom(2) = orbmom(2) +z2*ztmp(2)
                     orbmom(3) = orbmom(3) +z2*ztmp(3)
                  End do
               End Do
!
            End do
         End do
         OrbMag_on_atom(ia,1) = OrbMag_on_atom(ia,1) +orbmom(1)
         OrbMag_on_atom(ia,2) = OrbMag_on_atom(ia,2) +orbmom(2)
         OrbMag_on_atom(ia,3) = OrbMag_on_atom(ia,3) +orbmom(3)
      End Do
      deallocate( hsr_ssrep, hsi_ssrep )

    end subroutine calc_hard_part_contrib

    subroutine print_orb_mom
      integer :: ia, it, k

      if ( mype /= 0 ) return
      
      write(nfout,*) &
           & '! ------------ Local Orbital Momemnt (method1) at this scf step --- '

       write(nfout,*) &
            & '!   id   atom no.        mx             my             mz'
       Do ia=1, natm
          it = ityp(ia)
          write(nfout,'(I7,F10.4,3F15.8)') ia, iatomn(it), &
               &                          OrbMag_on_atom(ia,1), &
               &                          OrbMag_on_atom(ia,2), &
               &                          OrbMag_on_atom(ia,3)
       End Do
       write(nfout,*) '! ---------------------------------------------'

    end subroutine print_orb_mom

  end subroutine m_OP_calc_OrbMagMom_method1

  subroutine m_OP_calc_OrbMagMom_method2
    logical :: FirstFlag = .true.

    if ( iprimagmom < 3 ) return

    if ( FirstFlag ) then
       call m_OP_calc_MatL_orb_s_to_f
       FirstFlag = .false.
    endif

    if ( kimg == 1 ) return
    if ( .not. noncol ) return

    allocate( OrbMag_on_atom(natm,3) );  OrbMag_on_atom = 0.0d0

    call hardpart_contrib
    if ( sw_use_add_proj == ON ) call hardpart_contrib_add_proj

    call print_orb_mom

    deallocate( OrbMag_on_atom )
    
  contains

    subroutine hardpart_contrib
      integer :: ia, it, lmt1, lmt2, is1, is2, istmp
      integer :: il1, il2, im1, im2, it1, it2
      real(kind=DP), allocatable :: hsr_ssrep(:,:,:,:), hsi_ssrep(:,:,:,:)
      real(kind=DP) :: orbmom(3)
      complex(kind=CMPLDP) :: ztmp(3), z1, z2

      allocate( hsr_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsr_ssrep = 0.0d0
      allocate( hsi_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsi_ssrep = 0.0d0

      call m_ES_MagMom_To_DensMat_hsr( natm, nlmt, hsr, hsi, hsr_ssrep, hsi_ssrep )

      Do ia=1, natm
         it = ityp(ia)

         orbmom = 0.0d0

         Do is1=1, ndim_spinor
            Do is2=1, ndim_spinor
               if ( is1 /= is2 ) cycle
               istmp = (is1 -1)*ndim_spinor +is2

               do lmt1=1,ilmt(it)
                  il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
                  do lmt2=1,ilmt(it)
                     il2=ltp(lmt2,it);  im2=mtp(lmt2,it); it2=taup(lmt2,it)

                     if ( il1 <= 1 .or. il1 >4 ) cycle
                     if ( il1 /= il2 ) cycle

                     ztmp = 0.0d0
                     if ( il1 == 2 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L1( im2, im1, : )
                     else if ( il1 == 3 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L2( im2, im1, : )
                     else if ( il1 == 4 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L3( im2, im1, : )
                     endif

                     z1 = dcmplx( hsr_ssrep(ia,lmt1,lmt2,istmp), &
                          &       hsi_ssrep(ia,lmt1,lmt2,istmp) )
                     if ( sw_use_contracted_psir == ON ) then
                        z1 = z1 *product_psir_val( il1, it1, it2, it )
                     endif

                     orbmom(1) = orbmom(1) +z1*ztmp(1)
                     orbmom(2) = orbmom(2) +z1*ztmp(2)
                     orbmom(3) = orbmom(3) +z1*ztmp(3)
                  End do
               End Do
!
            End do
         End do

         OrbMag_on_atom(ia,1) = OrbMag_on_atom(ia,1) +orbmom(1)
         OrbMag_on_atom(ia,2) = OrbMag_on_atom(ia,2) +orbmom(2)
         OrbMag_on_atom(ia,3) = OrbMag_on_atom(ia,3) +orbmom(3)
      End Do
      deallocate( hsr_ssrep, hsi_ssrep )

    end subroutine hardpart_contrib

    subroutine hardpart_contrib_add_proj
      integer :: ia, it, lmt1, lmt2, is1, is2, istmp
      integer :: il1, il2, im1, im2, it1, it2
      real(kind=DP), allocatable :: hsr_ssrep(:,:,:,:), hsi_ssrep(:,:,:,:)
      real(kind=DP) :: orbmom(3)
      complex(kind=CMPLDP) :: ztmp(3), z1, z2

      allocate( hsr_ssrep( natm, nlmt_add, nlmt_add, ndim_chgpot ) ); hsr_ssrep = 0.0d0
      allocate( hsi_ssrep( natm, nlmt_add, nlmt_add, ndim_chgpot ) ); hsi_ssrep = 0.0d0

      call m_ES_MagMom_To_DensMat_hsr( natm, nlmt_add, hsr_add, hsi_add, &
           &                           hsr_ssrep, hsi_ssrep )

      Do ia=1, natm
         it = ityp(ia)

         orbmom = 0.0d0

         Do is1=1, ndim_spinor
            Do is2=1, ndim_spinor
               if ( is1 /= is2 ) cycle
               istmp = (is1 -1)*ndim_spinor +is2

               do lmt1=1,ilmt_add(it)
                  il1=ltp_add(lmt1,it); im1=mtp_add(lmt1,it); it1=1
                  do lmt2=1,ilmt_add(it)
                     il2=ltp_add(lmt2,it);  im2=mtp_add(lmt2,it); it2=1

                     if ( il1 <= 1 .or. il1 >4 ) cycle
                     if ( il1 /= il2 ) cycle

                     ztmp = 0.0d0
                     if ( il1 == 2 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L1( im2, im1, : )
                     else if ( il1 == 3 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L2( im2, im1, : )
                     else if ( il1 == 4 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L3( im2, im1, : )
                     endif

                     z1 = dcmplx( hsr_ssrep(ia,lmt1,lmt2,istmp), &
                          &       hsi_ssrep(ia,lmt1,lmt2,istmp) )

                     orbmom(1) = orbmom(1) +z1*ztmp(1)
                     orbmom(2) = orbmom(2) +z1*ztmp(2)
                     orbmom(3) = orbmom(3) +z1*ztmp(3)
                  End do
               End Do
!
            End do
         End do

         OrbMag_on_atom(ia,1) = OrbMag_on_atom(ia,1) +orbmom(1)
         OrbMag_on_atom(ia,2) = OrbMag_on_atom(ia,2) +orbmom(2)
         OrbMag_on_atom(ia,3) = OrbMag_on_atom(ia,3) +orbmom(3)
      End Do
      deallocate( hsr_ssrep, hsi_ssrep )

    end subroutine hardpart_contrib_add_proj

    subroutine print_orb_mom
      integer :: ia, it, k

      if ( mype /= 0 ) return
      
      write(nfout,*) &
           & '! ------------ Local Orbital Momemnt (method2) at this scf step --- '
       write(nfout,*) &
            & '    id      name          mx             my             mz'
       Do ia=1, natm
          it = ityp(ia)
          write(nfout,'(I7,6X,A5,3F15.8)') ia, speciesname(it), &
               &                          OrbMag_on_atom(ia,1), &
               &                          OrbMag_on_atom(ia,2), &
               &                          OrbMag_on_atom(ia,3)
       End Do

       write(nfout,*) 

    end subroutine print_orb_mom

  end subroutine m_OP_calc_OrbMagMom_method2

  subroutine calc_rho_ylm1_ylm2
    integer         :: ia, is, k, i, lmt1, lmt2, p, q, it
    integer :: is1, is2, is_tmp, k1, k2

    real(kind=DP)   :: w_n, d_factor
    complex(kind=CMPLDP) :: z1
    
    real(kind=DP), allocatable, dimension(:,:,:,:) :: hsr_or_hsi_mpi
    real(kind=DP), allocatable, dimension(:,:,:,:) :: hsr_ssrep
    real(kind=DP), allocatable, dimension(:,:,:,:) :: hsi_ssrep
!
! ---------------------- kt : uncertain ---------
!!!!!    d_factor = 2.d0/ ( kv3 /ndim_spinor )
!
    d_factor = 1.d0/ ( kv3 /ndim_spinor )
! -------------------------------------------

    allocate( hsr_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsr_ssrep = 0.0d0
    allocate( hsi_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsi_ssrep = 0.0d0
    
    do ia = 1, natm
       it = ityp(ia)
       
       do is1 = 1, ndim_spinor
          do is2 = 1, ndim_spinor
             is_tmp = ( is1 -1 )*ndim_spinor + is2
             do i = 1, np_e                                  ! MPI
                
                do k = 1, kv3, ndim_spinor
                   if ( map_k(k) /= myrank_k ) cycle            ! MPI
                   w_n = occup_l(i,k) *d_factor
                   
                   k1 = k + is1 -1;  k2 = k + is2 -1
                   do lmt1 = 1, ilmt(it)
                      p = lmta(lmt1,ia)
                      do lmt2 = 1, ilmt(it)
                         q = lmta(lmt2,ia)
                         z1 = wfn_sph_decomposed(i,p,k1) &
                              &      *conjg( wfn_sph_decomposed(i,q,k2) )
                         
                         hsr_ssrep(ia,lmt1,lmt2,is_tmp) &
                              &  = hsr_ssrep(ia,lmt1,lmt2,is_tmp) &
                              &    + w_n * real(z1)
                         hsi_ssrep(ia,lmt1,lmt2,is_tmp) &
                              &  = hsi_ssrep(ia,lmt1,lmt2,is_tmp) &
                              &    + w_n * aimag(z1)
                      end do! lmt2
                   end do! lmt1
                end do! k
             end do! i
          end do! is2
       end do! is1
    end do! ia
!
    if (npes >= 2) then
       allocate(hsr_or_hsi_mpi(natm,nlmt,nlmt,ndim_chgpot))
       hsr_or_hsi_mpi = 0.0d0
       
       call mpi_allreduce( hsr_ssrep, hsr_or_hsi_mpi, natm*nlmt*nlmt*ndim_chgpot, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       hsr_ssrep = hsr_or_hsi_mpi
       
       call mpi_allreduce( hsi_ssrep, hsr_or_hsi_mpi, natm*nlmt*nlmt*ndim_chgpot, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       hsi_ssrep = hsr_or_hsi_mpi
       
       deallocate(hsr_or_hsi_mpi)
    end if
    call m_ES_DensMat_To_MagMom_hsr( natm, nlmt, hsr_ssrep, hsi_ssrep, &
         &                           rho_ylm1_ylm2_r, rho_ylm1_ylm2_i )
      !-
    deallocate( hsr_ssrep, hsi_ssrep )
!
  end subroutine calc_rho_ylm1_ylm2

  subroutine symmetrz_rho_ylm1_ylm2
    integer         :: ia, is, iopr, i, lmt1, lmt2, lmt3, lmt4, it
    real(kind=DP), allocatable, dimension(:,:,:,:) :: hsr_tmp
    real(kind=DP), allocatable, dimension(:,:,:,:) :: hsi_tmp
    
    integer :: il1,im1,it1,il2,im2,it2,il3,im3,it3,il4,im4,it4
    integer :: ii,jj,kk,ll,n,m,iii,jjj
    integer :: ja
    
    integer :: ixyz1, ixyz2, is_tmp
    real(kind=DP) :: ctmp1, weight, ctmp2, weight2, determinant
      
    allocate(hsr_tmp(natm,nlmt,nlmt,ndim_magmom)); hsr_tmp = 0.0d0
    allocate(hsi_tmp(natm,nlmt,nlmt,ndim_magmom)); hsi_tmp = 0.0d0
!
    hsr_tmp = rho_ylm1_ylm2_r;  hsi_tmp = rho_ylm1_ylm2_i

    do ia=1,natm
       it=ityp(ia)
       do is =1, ndim_magmom
          do lmt2=1,ilmt(it)
             do lmt1=lmt2+1,ilmt(it)
                hsr_tmp(ia,lmt1,lmt2,is) =  hsr_tmp(ia,lmt2,lmt1,is)
                hsi_tmp(ia,lmt1,lmt2,is) = -hsi_tmp(ia,lmt2,lmt1,is)
             end do
          end do
       end do
    end do
    
    rho_ylm1_ylm2_r = 0.d0; rho_ylm1_ylm2_i = 0.0d0
    
    do iopr=1,nopr
       if ( magmom_dir_inversion_opr_flag(iopr) == -1 ) then
          weight = -1.0d0
       else
          weight = 1.0d0
       endif
       
       call calc_determinant( op(:,:,iopr), determinant )
       if ( determinant > 0 ) then
          weight2 = 1.0d0
       else
          weight2 = -1.0d0
       endif

       do ia = 1, natm
          it = ityp(ia)
          ja=abs(ia2ia_symmtry_op_inv(ia,iopr))
          
          do lmt1 = 1, ilmt(it)
             il1=ltp(lmt1,it)
             im1=mtp(lmt1,it)
             it1=taup(lmt1,it)
             ii=(il1-1)**2+im1
             
             do lmt2 = lmt1, ilmt(it)
!             do lmt2 = 1, ilmt(it)
                il2=ltp(lmt2,it)
                im2=mtp(lmt2,it)
                it2=taup(lmt2,it)
                jj=(il2-1)**2+im2
                
                do n=1,nylm_paw(ii,iopr,ia)
                   iii=iylm_paw(n,ii,iopr,ia)
                   do m=1,nylm_paw(jj,iopr,ia)
                      jjj=iylm_paw(m,jj,iopr,ia)
                      
                      do lmt3=1,ilmt(it)
                         il3=ltp(lmt3,it)
                         im3=mtp(lmt3,it)
                         it3=taup(lmt3,it)
                         kk=(il3-1)**2+im3
                         
                         if(kk.ne.iii .or. it1.ne.it3) cycle
                         
                         do lmt4=1,ilmt(it)
                            il4=ltp(lmt4,it)
                            im4=mtp(lmt4,it)
                            it4=taup(lmt4,it)
                            ll=(il4-1)**2+im4
                            if(ll.ne.jjj .or. it2.ne.it4) cycle
                            
                            rho_ylm1_ylm2_r(ia,lmt1,lmt2,1) = &
                                 rho_ylm1_ylm2_r(ia,lmt1,lmt2,1) + &
                                 hsr_tmp(ja,lmt3,lmt4,1)* &
                                 crotylm_paw(n,ii,iopr,ia)* &
                                 crotylm_paw(m,jj,iopr,ia)
                            rho_ylm1_ylm2_i(ia,lmt1,lmt2,1) = &
                                 rho_ylm1_ylm2_i(ia,lmt1,lmt2,1) + &
                                 weight * weight2 * &
                                 hsi_tmp(ja,lmt3,lmt4,1)* &
                                 crotylm_paw(n,ii,iopr,ia)* &
                                 crotylm_paw(m,jj,iopr,ia)
                            
                            Do ixyz1=1, 3
                               Do ixyz2=1, 3
                                  ctmp1 = op(ixyz2, ixyz1, iopr) *weight
                                  ctmp2 = op(ixyz2, ixyz1, iopr) *weight2

                                  rho_ylm1_ylm2_r(ia,lmt1,lmt2,ixyz2+1) &
                                       & = rho_ylm1_ylm2_r(ia,lmt1,lmt2,ixyz2+1)  &
                                       &  + ctmp1 &
                                       &    *hsr_tmp(ja,lmt3,lmt4,ixyz1+1) &
                                       &    *crotylm_paw(n,ii,iopr,ia)  &
                                       &    *crotylm_paw(m,jj,iopr,ia)
                                  rho_ylm1_ylm2_i(ia,lmt1,lmt2,ixyz2+1) &
                                       & = rho_ylm1_ylm2_i(ia,lmt1,lmt2,ixyz2+1)  &
                                       &  + ctmp2 &
                                       &    *hsi_tmp(ja,lmt3,lmt4,ixyz1+1) &
                                       &    *crotylm_paw(n,ii,iopr,ia)  &
                                       &    *crotylm_paw(m,jj,iopr,ia)
                               End do
                            End do
                            
                         end do! lmt4
                      end do! lmt3
                      
                   end do! jjj
                end do! iii
                
             end do! lmt2
          end do! lmt1
       end do! ia
    end do! iopr
      
    rho_ylm1_ylm2_r = rho_ylm1_ylm2_r/nopr; rho_ylm1_ylm2_i = rho_ylm1_ylm2_i/nopr; 
      
    do ia=1,natm
       it=ityp(ia)
       do is =1, ndim_magmom
          do lmt2=1,ilmt(it)
             do lmt1=lmt2+1,ilmt(it)
                rho_ylm1_ylm2_r(ia,lmt1,lmt2,is) = rho_ylm1_ylm2_r(ia,lmt2,lmt1,is)
                rho_ylm1_ylm2_i(ia,lmt1,lmt2,is) =-rho_ylm1_ylm2_i(ia,lmt2,lmt1,is)
             end do
          end do
       end do
    end do
    
    deallocate(hsr_tmp);  deallocate(hsi_tmp)
      
  contains
    subroutine calc_determinant( a, determinant )
      real(kind=DP), intent(in) :: a(3,3)
      real(kind=DP), intent(out) :: determinant

      determinant = a(1,1)*( a(2,2)*a(3,3) -a(2,3)*a(3,2) ) &
           &       -a(1,2)*( a(2,1)*a(3,3) -a(2,3)*a(3,1) ) &
           &       +a(1,3)*( a(2,1)*a(3,2) -a(2,2)*a(3,1) )

    end subroutine calc_determinant

  end subroutine symmetrz_rho_ylm1_ylm2
! ============= 2014/08/26

! ====== KT_add === 2014/09/01
  subroutine m_OP_orb_decomposed_orb_magmom
    logical :: FirstFlag = .true.
    
    real(kind=DP), allocatable :: orb_magmom_orb_decomposed(:,:)
    real(kind=DP), allocatable :: orb_magmom_orb_decomposed_add(:,:)

    if ( FirstFlag ) then
       call m_OP_calc_MatL_orb_s_to_f
       FirstFlag = .false.
    endif

    if ( kimg == 1 ) return
    if ( .not. noncol ) return

    allocate( orb_magmom_orb_decomposed( nlmta, 3 ) )
    orb_magmom_orb_decomposed = 0.0d0
    if ( sw_use_add_proj == ON ) then
       allocate( orb_magmom_orb_decomposed_add( nlmta_add, 3 ) )
       orb_magmom_orb_decomposed_add = 0.0d0
    endif

    call contrib_hardpart
    if ( sw_use_add_proj == ON ) call contrib_hardpart_add_proj

    write(nfout,*) &
         &   "! --------- Orbital decomposed orbital magnetic moment (method2) ------"
    write(nfout,*) "< Detail >"
    call print_orb_decomposed_orb_mag_1

    write(nfout,*) "< Summed over m >"
    call print_orb_decomposed_orb_mag_2

    write(nfout,*) "< Summed over l,m >"
    call print_orb_decomposed_orb_mag_3
    write(nfout,*) 

    deallocate( orb_magmom_orb_decomposed )
    if ( sw_use_add_proj == ON ) then
       deallocate( orb_magmom_orb_decomposed_add )
    endif
    
  contains

    subroutine contrib_hardpart
      integer :: ia, it, lmt1, lmt2, is1, is2, istmp
      integer :: il1, il2, im1, im2, it1, it2, ilmta
      real(kind=DP), allocatable :: hsr_ssrep(:,:,:,:), hsi_ssrep(:,:,:,:)
      real(kind=DP) :: ctmp(3)
      complex(kind=CMPLDP) :: ztmp(3), z1, z2

      allocate( hsr_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsr_ssrep = 0.0d0
      allocate( hsi_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsi_ssrep = 0.0d0
      
      call m_ES_MagMom_To_DensMat_hsr( natm, nlmt, hsr, hsi, hsr_ssrep, hsi_ssrep )
      
      Do ia=1, natm
         it = ityp(ia)
         
         Do is1=1, ndim_spinor
            Do is2=1, ndim_spinor
               if ( is1 /= is2 ) cycle
               istmp = (is1 -1)*ndim_spinor +is2
               
               do lmt1=1,ilmt(it)
                  il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
                  ilmta = lmta(lmt1,ia)
                  
                  do lmt2=1,ilmt(it)
                     il2=ltp(lmt2,it);  im2=mtp(lmt2,it); it2=taup(lmt2,it)
                     
                     if ( il1 <= 1 .or. il1 >4 ) cycle
                     if ( il1 /= il2 ) cycle
                     
                     ztmp = 0.0d0
                     if ( il1 == 2 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L1( im2, im1, : )
                     else if ( il1 == 3 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L2( im2, im1, : )
                     else if ( il1 == 4 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L3( im2, im1, : )
                     endif
                     
                     z1 = dcmplx( hsr_ssrep(ia,lmt1,lmt2,istmp), &
                          &       hsi_ssrep(ia,lmt1,lmt2,istmp) )
                     if ( sw_use_contracted_psir == ON ) then
                        z1 = z1 *product_psir_val( il1, it1, it2, it )
                     endif
                     
                     ctmp(:) = z1*ztmp(:)
                     
                     orb_magmom_orb_decomposed( ilmta,: ) &
                             & = orb_magmom_orb_decomposed( ilmta,: ) +ctmp(:)
                  End do
               End Do
            End do
         End do
      End Do
      deallocate( hsr_ssrep, hsi_ssrep )

    end subroutine contrib_hardpart

    subroutine contrib_hardpart_add_proj
      integer :: ia, it, lmt1, lmt2, is1, is2, istmp
      integer :: il1, il2, im1, im2, it1, it2, ilmta
      real(kind=DP), allocatable :: hsr_ssrep(:,:,:,:), hsi_ssrep(:,:,:,:)
      real(kind=DP) :: ctmp(3)
      complex(kind=CMPLDP) :: ztmp(3), z1, z2

      allocate( hsr_ssrep( natm, nlmt_add, nlmt_add, ndim_chgpot ) ); hsr_ssrep = 0.0d0
      allocate( hsi_ssrep( natm, nlmt_add, nlmt_add, ndim_chgpot ) ); hsi_ssrep = 0.0d0

      call m_ES_MagMom_To_DensMat_hsr( natm, nlmt_add, hsr_add, hsi_add, &
           &                           hsr_ssrep, hsi_ssrep )

      Do ia=1, natm
         it = ityp(ia)

         Do is1=1, ndim_spinor
            Do is2=1, ndim_spinor
               if ( is1 /= is2 ) cycle
               istmp = (is1 -1)*ndim_spinor +is2

               do lmt1=1,ilmt_add(it)
                  il1=ltp_add(lmt1,it); im1=mtp_add(lmt1,it); it1=1
                  ilmta = lmta_add(lmt1,ia)
                  do lmt2=1,ilmt_add(it)
                     il2=ltp_add(lmt2,it);  im2=mtp_add(lmt2,it); it2=1

                     if ( il1 <= 1 .or. il1 >4 ) cycle
                     if ( il1 /= il2 ) cycle

                     ztmp = 0.0d0
                     if ( il1 == 2 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L1( im2, im1, : )
                     else if ( il1 == 3 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L2( im2, im1, : )
                     else if ( il1 == 4 ) then
                        ztmp(:) = Mat_L_with_real_ylm_L3( im2, im1, : )
                     endif

                     z1 = dcmplx( hsr_ssrep(ia,lmt1,lmt2,istmp), &
                          &       hsi_ssrep(ia,lmt1,lmt2,istmp) )
                     ctmp(:) = z1*ztmp(:)

                     orb_magmom_orb_decomposed_add( ilmta,: ) &
                          & = orb_magmom_orb_decomposed_add( ilmta,: ) +ctmp(:)

                  End do
               End Do
            End do
         End do
      End Do
      deallocate( hsr_ssrep, hsi_ssrep )

    end subroutine contrib_hardpart_add_proj

    subroutine print_orb_decomposed_orb_mag_1
      integer :: ia, it, il1, im1, it1, lmt1, ilmta
      integer :: nspher
      real(kind=DP), allocatable :: orb_magmom_ylm(:,:)

      if ( mype /= 0 ) return

      allocate( orb_magmom_ylm(25,3) )

      write(nfout,'(A,5X,A)') &
           &         '    id      name     l    m', &
           &         '    mx             my             mz'

      Do ia=1, natm
         it = ityp(ia)
         orb_magmom_ylm = 0.0d0

         Do lmt1=1, ilmt(it)
            il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
            ilmta = lmta(lmt1,ia)

            nspher = ( il1 -1 )**2 +im1
            orb_magmom_ylm( nspher,: ) = orb_magmom_ylm( nspher,: ) &
                 &                     + orb_magmom_orb_decomposed( ilmta,: )
         End do
         if ( sw_use_add_proj == ON ) then
            Do lmt1=1, ilmt_add(it)
               il1=ltp_add(lmt1,it); im1=mtp_add(lmt1,it); it1=1
               ilmta = lmta_add(lmt1,ia)

               nspher = ( il1 -1 )**2 +im1
               orb_magmom_ylm( nspher,: ) = orb_magmom_ylm( nspher,: ) &
                    &                     + orb_magmom_orb_decomposed_add( ilmta,: )
            End do
         endif
         Do il1=1, lpsmax(it)
            Do im1=1, 2*il1 -1
               nspher = ( il1 -1 )**2 +im1
               write(nfout,'(I6,6X,A5,2I5,3F15.8)') &
                    &              ia, speciesname(it), il1 -1, im1, &
                    &              orb_magmom_ylm(nspher,1:3)
            End do
         End do
      End do

      deallocate( orb_magmom_ylm )

    end subroutine print_orb_decomposed_orb_mag_1

    subroutine print_orb_decomposed_orb_mag_2
      integer :: ia, it, il1, im1, it1, lmt1, ilmta
      integer :: nspher
      real(kind=DP) :: csum(3)
      real(kind=DP), allocatable :: orb_magmom_ylm(:,:)

      if ( mype /= 0 ) return

      allocate( orb_magmom_ylm(25,3) )

      write(nfout,'(A,5X,A)') &
           & '    id      name     l    ', &
           & '     mx             my             mz'

      Do ia=1, natm
         it = ityp(ia)
         orb_magmom_ylm = 0.0d0

         Do lmt1=1, ilmt(it)
            il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
            ilmta = lmta(lmt1,ia)

            nspher = ( il1 -1 )**2 +im1
            orb_magmom_ylm( nspher,: ) = orb_magmom_ylm( nspher,: ) &
                 &                     + orb_magmom_orb_decomposed( ilmta,: )
         End do
         if ( sw_use_add_proj == ON ) then
            Do lmt1=1, ilmt_add(it)
               il1=ltp_add(lmt1,it); im1=mtp_add(lmt1,it); it1=1
               ilmta = lmta_add(lmt1,ia)

               nspher = ( il1 -1 )**2 +im1
               orb_magmom_ylm( nspher,: ) = orb_magmom_ylm( nspher,: ) &
                    &                     + orb_magmom_orb_decomposed_add( ilmta,: )
            End do
         endif
         Do il1=1, lpsmax(it)
            csum = 0.0d0
            Do im1=1, 2*il1 -1
               nspher = ( il1 -1 )**2 +im1
               csum(:) = csum(:) +orb_magmom_ylm(nspher,:)
            End do
!
            write(nfout,'(I6,6X,A5,I5,5X,3F15.8)') &
                 &              ia, speciesname(it), il1 -1, &
                 &              csum(1:3)
         End do
      End do

      deallocate( orb_magmom_ylm )

    end subroutine print_orb_decomposed_orb_mag_2

    subroutine print_orb_decomposed_orb_mag_3
      integer :: ia, it, il1, im1, it1, lmt1, ilmta
      integer :: nspher
      real(kind=DP) :: csum(3)
      real(kind=DP), allocatable :: orb_magmom_ylm(:,:)

      if ( mype /= 0 ) return

      allocate( orb_magmom_ylm(25,3) )

      write(nfout,'(A,5X,A)') &
           & '    id      name          ', &
           & '     mx             my             mz'

      Do ia=1, natm
         it = ityp(ia)
         orb_magmom_ylm = 0.0d0

         Do lmt1=1, ilmt(it)
            il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
            ilmta = lmta(lmt1,ia)

            nspher = ( il1 -1 )**2 +im1
            orb_magmom_ylm( nspher,: ) = orb_magmom_ylm( nspher,: ) &
                 &                     + orb_magmom_orb_decomposed( ilmta,: )
         End do
         if ( sw_use_add_proj == ON ) then
            Do lmt1=1, ilmt_add(it)
               il1=ltp_add(lmt1,it); im1=mtp_add(lmt1,it); it1=1
               ilmta = lmta_add(lmt1,ia)

               nspher = ( il1 -1 )**2 +im1
               orb_magmom_ylm( nspher,: ) = orb_magmom_ylm( nspher,: ) &
                    &                     + orb_magmom_orb_decomposed_add( ilmta,: )
            End do
         endif

         csum = 0.0d0
         Do il1=1, lpsmax(it)
            Do im1=1, 2*il1 -1
               nspher = ( il1 -1 )**2 +im1
               csum(:) = csum(:) +orb_magmom_ylm(nspher,:)
            End do
         End do
!
         write(nfout,'(I6,6X,A5,10X,3F15.8)') &
              &              ia, speciesname(it), &
              &              csum(1:3)
      End do

      deallocate( orb_magmom_ylm )

    end subroutine print_orb_decomposed_orb_mag_3

  end subroutine m_OP_orb_decomposed_orb_magmom
! ==================== 2014/09/01

end module m_OP_Moment

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 570 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a module for setting arrays used in the BS-like equation 
!  for the LR-TDDFT .
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.  
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

module m_LinearResponse_BS

  use m_Const_Parameters,   only : ON, OFF, DP, CMPLDP, PAI, PAI4, Bohr, &
       &                           TETRAHEDRON, PARABOLIC, DELTA

  use m_LinearResponse_Control,   only :  sw_NODA
  use m_LinearResponse_NonInt,   only : nband_LR, band_start_LR, band_end_LR
  use m_Parallelization,      only : mype, ierr, npes, &
       &                  ista_fftp, iend_fftp, &
       &                  ista_fftph, iend_fftph, &
       &                  np_e, ista_k, iend_k, map_e, map_z, myrank_e, &
       &                  mpi_comm_group

  use m_Control_Parameters,  only : Num_q_Points, way_of_smearing, neg, &
       &                            ipri, nspin, printable, xctype, kimg

 use m_FFT,                  only : fft_box_size_CD, fft_box_size_CD_c, &
       &                             nfft, nfftp, &
       &                             m_FFT_CD_inverse_c, &
       &                             m_FFT_check_of_negative_CD, &
       &                             m_FFT_CD_direct_c, &
       &                             m_FFT_alloc_CD_box, &
       &                             m_FFT_dealloc_CD_box
  use m_Files,                 only : nfout
  use m_Electronic_Structure,       only : eko_ek
  use m_Crystal_Structure,    only :  rltv, univol
  use m_PlaneWaveBasisSet,    only : ngabc, igf, kg1,kg, igfp_l, kgp

  use m_LinearResponse_tools,  only  : occup_k, occup_kmq, &
       &                                  eko_k, &
       &                                    fsval_k, fsval_kmq, &
       &                                    wfn_k, wfn_kmq, &
       &                                    map_z_k, map_z_kmq, &
       &                                   nbase_k, nbase_kmq, &
       &                                   igf_k, igf_kmq, iba_k, iba_kmq

  use m_Kpoints,                    only : kv3_ek, kv3, vkxyz_ek, qwgt_ek, &
       &                                   k_symmetry, np0, np2
  use m_LinearResponse_ALDA,   only : ker_cr, igfp_LR
  use m_LinearResponse_Density,  only : RhoTilde, occup_lkt_ek

  use m_LinearResponse_Control,     only  : nrd_efermi, nstep, e, nmax_G_LR, &
       &                                    vqxyz,  &
       &                                    xc_kernel_type, RPA, ALDA_R, & 
       &                                    scissor, eta, &
       &                                    sw_LongWaveLimit

  use m_LinearResponse_Kernel,       only : Kernel_Coulomb

  use m_Timing,                     only : tstatc0_begin, tstatc0_end
  use m_LinearResponse_tools,  only  : Get_WF_in_Rspace, Get_WF_in_Rspace_CD

  implicit none
  include 'mpif.h'

! ------------------------------------------ BS && ALDA_R --
  Complex(kind=CMPLDP), allocatable :: MatV(:,:), MatK(:,:), MatXi(:,:)
  Complex(kind=CMPLDP), allocatable :: MatL0(:,:,:)

contains

!------------------------------------------------------------------
!!
!!!            Alloc and Dealloc in the case of BS && ALDA_R
!!
!-------------------------------------------------------------------
 subroutine m_LR_alloc_MatK_ALDA
    integer :: matsize
    matsize = nband_LR**2

    if ( mype == 0 ) then
       allocate( MatK(matsize, matsize) ); MatK = 0.0D0
    endif
  end subroutine m_LR_alloc_MatK_ALDA

  subroutine m_LR_dealloc_MatK_ALDA
    if ( mype == 0 ) deallocate( MatK )
  end subroutine m_LR_dealloc_MatK_ALDA

  subroutine m_LR_alloc_MatV
    integer :: matsize
    matsize = nband_LR **2

    if ( mype == 0 ) then
       allocate( MatV(matsize, matsize) ); MatV = 0.0D0
    endif
  end subroutine m_LR_alloc_MatV

  subroutine m_LR_dealloc_MatV
    if ( mype == 0 ) deallocate( MatV )
  end subroutine m_LR_dealloc_MatV

  subroutine m_LR_Alloc_MatXi
    integer :: matsize
    matsize = nband_LR **2

    if ( mype == 0 ) then
       allocate( MatXi(matsize, matsize) ); MatXi = 0.0D0
    endif
  end subroutine m_LR_Alloc_MatXi

  subroutine m_LR_dealloc_MatXi
    if ( mype == 0 ) deallocate( MatXi )
  end subroutine m_LR_dealloc_MatXi

  subroutine m_LR_alloc_MatL0
    if ( mype == 0 ) then
       allocate( MatL0( nband_LR, nband_LR, nspin ) );  MatL0 = 0.0D0
    endif
  end subroutine m_LR_alloc_MatL0

  subroutine m_LR_dealloc_MatL0
    if ( mype == 0 ) deallocate( MatL0 )
  end subroutine m_LR_dealloc_MatL0

!--------------------------------------------------------
!!
!!!           Matrix K, V, Xi      for   BS && ALDA_R
!!
!---------------------------------------------------------
  subroutine Calc_MatK_ALDA
    Real(kind=DP), allocatable :: wf1_tmp(:), wf2_tmp(:), wf3_tmp(:), wf4_tmp(:)
    Real(kind=DP), allocatable ::  chg1r(:), chg1i(:)
    Real(kind=DP), allocatable ::  chg2r(:), chg2i(:)
    Real(kind=DP), allocatable :: Wfns_on_Rspace(:,:)

    integer ib1, ib2, ib3, ib4
    integer ix1, ix2

    integer ik, jk
    integer ngrid
    integer matsize
! ---------------------------------- start ---------------------
    matsize = nband_LR**2
    ngrid = product(fft_box_size_CD(1:3,1))
    ik = 1; jk = 1

    call m_FFT_alloc_CD_box()
    call set_work_arrays
! ----------------------------- main ---------------------
    Do ix1=1, matsize
       ib1 = ( ix1-1 ) /nband_LR +1
       ib2 = mod( ix1-1,nband_LR ) + 1
!
       ib1 = ib1 + band_start_LR - 1;    ib2 = ib2 + band_start_LR - 1

       if ( mype == 0 ) then
          write( nfout,* ) 'Matrix K for ', ix1, '-th element is set'
       endif
       call set_chg1
! ---
       Do ix2=1, matsize
          if ( sw_NODA == ON .and. ix1 /= ix2 ) cycle

          ib3 = ( ix2-1 ) /nband_LR +1
          ib4 = mod( ix2-1,nband_LR ) + 1

          ib3 = ib3 + band_start_LR - 1;      ib4 = ib4 + band_start_LR - 1

          call set_chg2
          call set_each_element_in_MatK
       End do
    End do
! ----------------------------- end ------------
    if ( mype == 0 ) then
       MatK = MatK * univol / dble(ngrid) 
!!!!!!!!!!!!!!!!!!!!!!!       MatK = MatK*2.0d0        ! ???? bug ??
    endif
! --
    call unset_work_arrays
    call m_FFT_dealloc_CD_box()

  contains

    subroutine set_work_arrays
      integer jj
      Real*8 c1
      allocate( wf1_tmp(ista_fftp:iend_fftp) ); wf1_tmp = 0.0d0
      allocate( wf2_tmp(ista_fftp:iend_fftp) ); wf2_tmp = 0.0d0
!
      allocate( chg1r(ista_fftph:iend_fftph) ); chg1r = 0.0d0
      allocate( chg1i(ista_fftph:iend_fftph) ); chg1i = 0.0d0
      allocate( chg2r(ista_fftph:iend_fftph) ); chg2r = 0.0d0
      allocate( chg2i(ista_fftph:iend_fftph) ); chg2i = 0.0d0
!
      allocate( Wfns_on_Rspace( ista_fftp:iend_fftp, band_start_LR: band_end_LR ) ); 
      Wfns_on_Rspace = 0.0d0
      Do ib1 = band_start_LR, band_end_LR
         Call  Get_WF_in_Rspace_CD( ik, ib1, wfn_k, wf1_tmp, &
              &                     nbase_k, iba_k, igfp_LR, map_z_k )
         Wfns_on_Rspace( ista_fftp:iend_fftp, ib1 ) = wf1_tmp( ista_fftp:iend_fftp )
      End do
      Wfns_on_Rspace = Wfns_on_Rspace / sqrt( univol )
! ----
!      c1 = 0.0d0
!      DO jj=ista_fftph,iend_fftph
!         c1 = c1 + Wfns_on_Rspace( 2*jj-1, band_start_LR )**2 &
!              &  + Wfns_on_Rspace( 2*jj,   band_start_LR )**2 
!      End do
!      write(*,*) 'c1 = ', c1, c1 / dble(iend_fftph-ista_fftph+1), c1 * univol, c1 * univol /dble(iend_fftph-ista_fftph+1)           ! c1/(iend-isa+1) == 1 deshita.
! ---------------
!             wfns_on_rspace niha sqrt(V) ga kakatteiru
!      stop
! --
    end subroutine set_work_arrays

    subroutine unset_work_arrays
      deallocate( wf1_tmp, wf2_tmp );
      deallocate( chg1r, chg1i ); deallocate( chg2r, chg2i )
      deallocate( Wfns_On_Rspace )
    end subroutine unset_work_arrays
    
    subroutine set_chg1
      integer ::i, ip
      
      wf1_tmp( ista_fftp:iend_fftp ) = Wfns_on_Rspace( ista_fftp:iend_fftp, ib1 )
      wf2_tmp( ista_fftp:iend_fftp ) = Wfns_on_Rspace( ista_fftp:iend_fftp, ib2 )
      Do i=ista_fftph, iend_fftph
         ip = 2*i-1
         chg1r(i) = wf1_tmp(ip) *wf2_tmp(ip)   + wf1_tmp(ip+1) *wf2_tmp(ip+1)
         chg1i(i) = wf1_tmp(ip) *wf2_tmp(ip+1) - wf1_tmp(ip+1) *wf2_tmp(ip)
      End do
    end subroutine set_chg1
     
    subroutine set_chg2
      integer ::i, ip
      
      wf1_tmp( ista_fftp:iend_fftp ) = Wfns_on_Rspace( ista_fftp:iend_fftp, ib3 )
      wf2_tmp( ista_fftp:iend_fftp ) = Wfns_on_Rspace( ista_fftp:iend_fftp, ib4 )
      Do i=ista_fftph, iend_fftph
         ip = 2*i-1
         chg2r(i) = wf1_tmp(ip) *wf2_tmp(ip)   + wf1_tmp(ip+1) *wf2_tmp(ip+1)
         chg2i(i) = wf1_tmp(ip) *wf2_tmp(ip+1) - wf1_tmp(ip+1) *wf2_tmp(ip)
      End do
    end subroutine set_chg2

    subroutine set_each_element_in_MatK
      integer :: i
      Complex(kind=CMPLDP) :: z1, ztmp, zsum
      Real(kind=DP) :: c1, c2

      ztmp = 0.0D0
      Do i=ista_fftph, iend_fftph
         c1 = chg1r(i)*chg2r(i) + chg1i(i)*chg2i(i)
         c2 = chg1i(i)*chg2r(i) - chg1r(i)*chg2i(i)
         z1 = dcmplx( c1,c2 )
         ztmp = ztmp + z1*ker_cr( i,ik,jk )
      End do
      if ( npes > 1 ) then
         call mpi_allreduce( ztmp, zsum, 2, MPI_DOUBLE_PRECISION, &
              &              MPI_SUM, mpi_comm_group, ierr )
         ztmp = zsum
      endif
      if ( mype==0 ) MatK(ix1,ix2) = ztmp
    end subroutine set_each_element_in_MatK

  end subroutine Calc_MatK_ALDA

  subroutine Calc_MatV
    Complex(kind=CMPLDP), allocatable :: rho1_tmp(:,:), rho2_tmp(:,:)
    Complex(kind=CMPLDP), allocatable :: rho2_tmp_mpi(:,:)

    integer ib1, ib2, ib3, ib4
    integer ix1, ix2
    integer matsize
!
    real(kind=DP) :: ttr(6)
! ------------------------------------ start- -------
    matsize = nband_LR**2
    call set_work_arrays
    Call getttr (rltv,ttr)
! --
!!    write(*,*) 'nband_LR = ', nband_LR
!!    write(*,*) 'nmax_G_LR = ', nmax_G_LR
! --------------------------- main ----------
    Do ix1=1, matsize
       ib1 = ( ix1-1 ) /nband_LR +1
       ib2 = mod( ix1-1,nband_LR ) + 1

       ib1 = ib1 + band_start_LR - 1;     ib2 = ib2 + band_start_LR - 1

       if ( mype == 0 ) then
          write( nfout,* ) 'Matrix V for ', ix1, '-th element is set'
       endif

       call set_rho1_tmp
       
       Do ix2=1, matsize
          if ( sw_NODA == ON .and. ix1 /= ix2 ) cycle

          ib3 = ( ix2-1 ) /nband_LR +1
          ib4 = mod( ix2-1,nband_LR ) + 1
          
          ib3 = ib3 + band_start_LR - 1;     ib4 = ib4 + band_start_LR - 1

          call set_rho2_tmp
          call set_each_element_in_MatV
       End do
    End do
! -------------------------- end -----------------
    if ( mype== 0 ) then
       MatV = MatV / univol
    endif
    call unset_work_arrays
  contains

    subroutine set_work_arrays
      allocate( rho1_tmp( kg1, kv3_ek ) ); rho1_tmp = 0.0d0
      allocate( rho2_tmp( kg1, kv3_ek ) ); rho2_tmp = 0.0d0
    end subroutine set_work_arrays

    subroutine unset_work_arrays
      deallocate( rho1_tmp, rho2_tmp )
    end subroutine unset_work_arrays

    subroutine set_rho1_tmp
      integer :: jb2

      if ( map_e(ib2) == myrank_e ) then
         jb2 = map_z(ib2)
         rho1_tmp( 1:kg1, 1:kv3_ek ) = RhoTilde( 1:kg1, ib1, jb2, 1:kv3_ek )
      endif
      if ( npes > 1 ) then
         call mpi_bcast( rho1_tmp, 2*kg1*kv3_ek, MPI_DOUBLE_PRECISION, &
              &         map_e(ib2), mpi_comm_group, ierr )
      endif
    end subroutine set_rho1_tmp

    subroutine set_rho2_tmp
      integer :: jb4

      if ( map_e(ib4) == myrank_e ) then
         jb4 = map_z(ib4)
         rho2_tmp( 1:kg1, 1:kv3_ek ) = RhoTilde( 1:kg1, ib3, jb4, 1:kv3_ek )
      endif
      if ( npes > 1 ) then
         call mpi_bcast( rho2_tmp, 2*kg1*kv3_ek, MPI_DOUBLE_PRECISION, &
              &         map_e(ib4), mpi_comm_group, ierr )
      endif
    end subroutine set_rho2_tmp

    subroutine set_each_element_in_MatV
      integer     :: i, ig
      Real(kind=DP) :: ga, gb, gc, g2
      Complex(kind=CMPLDP) :: z1, z2, ztmp
! -
      if ( mype /= 0 ) return
!
      ztmp = 0.0d0
      Do i=2, nmax_G_LR
         z1 = rho1_tmp( i,1 );  z2 = rho2_tmp( i,1 )
         ztmp = ztmp + z1* conjg(z2) * Kernel_Coulomb(i)
      End Do
      MatV( ix1,ix2 ) = ztmp
    end subroutine set_each_element_in_MatV

  end subroutine Calc_MatV

  subroutine Calc_MatXi
    if ( mype == 0 )  then
       select case( xc_kernel_type )
       case( RPA )
          MatXi = -MatV
       case ( ALDA_R )
          MatXi = -MatK - MatV
       end select
    endif
  end subroutine Calc_MatXi

!--------------------------------------------------------
!!
!!!        Matrix L0    for   BS && ALDA_R,   LongWaveLimit 
!!
!---------------------------------------------------------
  subroutine Calc_MatL0( e_value )
    real(kind=DP), intent(in) :: e_value

    real(kind=DP)         :: occ1, occ2
    complex(kind=CMPLDP)  :: omega1, omega2

    integer               :: i,j, k, ispin
    integer               :: ik1, ik2, ik3, ib1, ib2
    integer               :: k_max, nq_max
    integer :: id_sname = -1
! ------------------------------- start ------------
    if ( mype /= 0 ) return
    nq_max = 0
    call set_value_kmax
    omega1 = cmplx( e_value, eta );  omega2 = cmplx( e_value, -eta );
!
    MatL0 = 0.0d0
! -------------------------------- main -------------
    Do ispin=1, nspin
       Do k=1, k_max
          ik1 = ( nq_max +1 )*nspin*(k-1) + ispin
          ik2 = ik1 + nspin
          ik3 =  nspin*(k-1) + ispin
          !
          Do ib1=band_start_LR, band_end_LR           ! unoccpuied state
             occ1 = Occup_lkt_ek( ib1, ik1 );

             Do ib2=band_start_LR, band_end_LR          ! occupied state
                occ2 = Occup_lkt_ek( ib2, ik1 )
                call set_each_element_in_MatL0
             End do
          End do
       End do
    End do
    if ( nspin==1 ) MatL0 = MatL0 *2.0d0
! --------------------------------- end -------------
    call tstatc0_end(id_sname)

  contains

    subroutine set_value_kmax
      if ( way_of_smearing == TETRAHEDRON ) then
         k_max = np2
      else
         k_max = kv3_ek / ( nspin*( nq_max + 1 ))
      endif
    end subroutine set_value_kmax

    subroutine set_each_element_in_MatL0
      integer ::  itmp1, itmp2
      Real(kind=DP) :: ebi, ebj, ediff, c1
      Complex(kind=CMPLDP) :: zd1, zd2, z1, z2, gfn

      ebi = Eko_ek( ib1,ik1 );  ebj = Eko_ek( ib2,ik1 )
      ediff = ebi - ebj + scissor

      zd1 = omega1 - ediff;  zd2 = omega2 + ediff
      gfn = 1.0d0 / zd1 - 1.0d0 / zd2

      itmp1 = ib1 - band_start_LR +1; itmp2 = ib2 - band_start_LR +1

      c1 = ( 1.0D0 - occ1 ) *occ2
      MatL0( itmp1,itmp2,ispin ) = c1*gfn *cmplx( 0.0D0, 1.0D0 )
    end subroutine set_each_element_in_MatL0

  end subroutine Calc_MatL0

!!!!!!!!!!!!!!! DEBUG -
  subroutine Check_Charge_on_mesh
    Real(kind=DP), allocatable :: wf1_tmp(:), wf2_tmp(:), wf3_tmp(:), wf4_tmp(:)
    Real(kind=DP), allocatable :: Wfns_on_Rspace(:,:)

    Real(kind=DP) :: c1
    integer :: ik, jk
    real(kind=DP)         :: occ1
    complex(kind=CMPLDP)  :: ztmp, z1

    integer :: ngrid, nfftph
    integer               :: i, ib1
    integer :: id_sname = -1

    ngrid = product(fft_box_size_CD(1:3,1))
    nfftph = nfftp / 2
    ik = 1; jk = 1

    call m_FFT_alloc_CD_box()
    call set_work_arrays
! ----------------------------- main ---------------------
    Do i=1, nfftph
       ztmp = 0.0d0
       Do ib1=1, neg
          occ1 = Occup_lkt_ek( ib1, ik );
          if ( occ1 < Delta ) cycle
          z1 = cmplx( Wfns_On_Rspace( 2*i-1,ib1 ), Wfns_On_Rspace( 2*i,ib1 ) )
          ztmp = ztmp + occ1 *z1 *conjg(z1)
       End do
!
       if ( ker_cr(i,1,1) > 1.0E-4 ) then
          c1 = 2.0 *real(ztmp) / ker_cr(i,1,1)
          write(*,*) i, ker_cr(i,1,1), c1
       endif
    End do
! --
    call unset_work_arrays
    call m_FFT_dealloc_CD_box()

  contains

    subroutine set_work_arrays
      allocate( wf1_tmp(ista_fftp:iend_fftp) ); wf1_tmp = 0.0d0
      allocate( Wfns_on_Rspace( ista_fftp:iend_fftp, 1:neg ) ); 
      Wfns_on_Rspace = 0.0d0
      Do ib1 = 1, neg
         Call  Get_WF_in_Rspace_CD( ik, ib1, wfn_k, wf1_tmp, &
              &                     nbase_k, iba_k, igfp_LR, map_z_k )
         Wfns_on_Rspace( ista_fftp:iend_fftp, ib1 ) = wf1_tmp( ista_fftp:iend_fftp )
      End do
      Wfns_on_Rspace = Wfns_on_Rspace / sqrt( univol )
    end subroutine set_work_arrays

    subroutine unset_work_arrays
      deallocate( wf1_tmp )
      deallocate( Wfns_On_Rspace )
    end subroutine unset_work_arrays
    
  End subroutine Check_Charge_on_mesh

  subroutine Check_Exc_energy
    Real(kind=DP), allocatable :: wf1_tmp(:), wf2_tmp(:), wf3_tmp(:), wf4_tmp(:)
    Real(kind=DP), allocatable :: Wfns_on_Rspace(:,:)

    Real(kind=DP) :: c1, weight
    integer :: ik, jk
    real(kind=DP)         :: occ1
    complex(kind=CMPLDP)  :: ztmp, z1

    integer :: ngrid, nfftph
    integer               :: i, ib1
    integer :: id_sname = -1

    ngrid = product(fft_box_size_CD(1:3,1))
    nfftph = nfftp / 2
    ik = 1; jk = 1

    call m_FFT_alloc_CD_box()
    call set_work_arrays
! ----------------------------- main ---------------------
    ztmp = 0.0d0
    Do i=1, nfftph
       Do ib1=1, neg
          occ1 = Occup_lkt_ek( ib1, ik );
          if ( occ1 < Delta ) cycle
          z1 = cmplx( Wfns_On_Rspace( 2*i-1,ib1 ), Wfns_On_Rspace( 2*i,ib1 ) )
          weight = ker_cr( i,1,1 )
          ztmp = ztmp + occ1 *z1 *conjg(z1) *weight
       End do
    End do
    ! --
    write(*,*) 'Exc = ', ztmp *univol / dble(ngrid) * 2.0d0            ! OK
! ----------------------------------------------- 2.0 : spin degeneracy
! --
    call unset_work_arrays
    call m_FFT_dealloc_CD_box()

  contains

    subroutine set_work_arrays
      allocate( wf1_tmp(ista_fftp:iend_fftp) ); wf1_tmp = 0.0d0
      allocate( Wfns_on_Rspace( ista_fftp:iend_fftp, 1:neg ) ); 
      Wfns_on_Rspace = 0.0d0
      Do ib1 = 1, neg
         Call  Get_WF_in_Rspace_CD( ik, ib1, wfn_k, wf1_tmp, &
              &                     nbase_k, iba_k, igfp_LR, map_z_k )
         Wfns_on_Rspace( ista_fftp:iend_fftp, ib1 ) = wf1_tmp( ista_fftp:iend_fftp )
      End do
      Wfns_on_Rspace = Wfns_on_Rspace / sqrt( univol )
    end subroutine set_work_arrays

    subroutine unset_work_arrays
      deallocate( wf1_tmp )
      deallocate( Wfns_On_Rspace )
    end subroutine unset_work_arrays
    
  End subroutine Check_Exc_energy

! --
  subroutine Print_MatK
    integer ib1, ib2, ib3, ib4
    integer ix1, ix2
    integer matsize
!
    matsize = nband_LR**2
! --------------------------- main ----------
    Do ix1=1, matsize
       ib1 = ( ix1-1 ) /nband_LR +1
       ib2 = mod( ix1-1,nband_LR ) + 1

       ib1 = ib1 + band_start_LR - 1;     ib2 = ib2 + band_start_LR - 1

!!!!       if ( ib1 == band_start_LR .and. ib2 == band_end_LR ) then
          if ( mype == 0 ) then
             write(*,*) 'K element = ', ib1, ib2, MatK( ix1,ix1 )
          endif
!!!       endif
    End do
   if ( npes > 1 ) call mpi_barrier( mpi_comm_group,ierr )
  end subroutine Print_MatK

  subroutine Print_MatV
    integer ib1, ib2, ib3, ib4
    integer ix1, ix2
    integer matsize
!
    matsize = nband_LR**2
! --------------------------- main ----------
    Do ix1=1, matsize
       ib1 = ( ix1-1 ) /nband_LR +1
       ib2 = mod( ix1-1,nband_LR ) + 1

       ib1 = ib1 + band_start_LR - 1;     ib2 = ib2 + band_start_LR - 1

!!       if ( ib1 == band_start_LR .and. ib2 == band_end_LR ) then
          if ( mype == 0 ) then
             write(*,*) 'V element = ', ib1, ib2, MatV( ix1,ix1 )
          endif
!!!!       endif
    End do
    if ( npes > 1 ) call mpi_barrier( mpi_comm_group,ierr )
  end subroutine Print_MatV
! -----------------
end module m_LinearResponse_BS

!=======================================================================
!
!  SOFTWARE NAME : PHASE ($Revision: 597 $)
!
!  MODULE: m_Phonon
!
!  AUTHOR(S): T. Yamamoto   May/01/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_Phonon
  ! $Id: m_Phonon.F90 597 2019-07-26 03:08:56Z jkoga $
  use m_Const_parameters,   only : DP, ON, OFF, NOCONV, FMAXVALLEN, PAI, PAI2, PAI4 &
       &     , PHONON_GAMMA, PHONON_BAND, PHONON_DOS &
       &     , LOWER, CARTS, UNIT_PIEZO_CONST &
       &     , CRDTYP, FILE, FERMI_DIRAC
  use m_Control_Parameters, only : sw_phonon, sw_calc_force, sw_calc_force_all &
       &     , sw_vibrational_modes, sw_lo_to_splitting &
       &     , sw_lattice_dielectric_tensor &
       &     , sw_dielectric_function &
       &     , sw_correct_force_constants &
       &     , sw_polynomial_fit, norder &
       &     , sw_int_strain_piezo_tensor, sw_phonon_oneshot &
       &     , phonon_method, num_phonon_calc_mode &
       &     , ipriphonon, printable, way_of_smearing, width, width_tetra
  use m_Crystal_Structure,  only : altv,rltv,altv_super,rltv_super,nlpnt,lpnt,nbztyp_spg
  use m_Ionic_System,       only : num_force_data, phonon_atom &
       &, phonon_displacement &
       &,displaced_atom, displacement &
       &,input_coordinate_system,u &
       &,natm,ionic_mass,speciesname,ityp,ntyp &
       &,istart_phonon,iend_phonon &
       &,natm_prim,natm_super &
       &,pos,cps
  use m_BP_Properties,      only : zeff
  use m_Files,              only : nfout,nfkpoint,nfmatbp,m_Files_open_kpoint_files
  use m_Parallelization,    only : mype,npes,ierr, mpi_comm_group

  ! === KT_add === 13.1R
  use m_Control_Parameters,  only : sw_phonon_with_epsilon
  use m_Raman,               only : m_Raman_read_nfinp, m_Raman_initialize, &
       &                            m_Raman_print_param, m_Raman_calc_susceptibility, &
       &                            dielectric_read_from_file => dielectric
  ! ============== 13.1R

  use m_Kpoints,             only : itrs

  implicit none
  include 'mpif.h'

  real(kind=DP),allocatable,dimension(:,:,:) :: force_data ! dim(natm_super,3,num_force_data)
  real(kind=DP),allocatable,dimension(:,:,:) :: forces ! dim(natm_super*3,natm_prim*3,norder*2)
  real(kind=DP),allocatable,dimension(:) :: force0 ! dim(natm_super*3)
  real(kind=DP) :: dielectric(3,3) = 0.d0
  real(kind=DP) :: kvec_dir(3) = 0.d0
  character(len=3), allocatable, dimension(:) :: point_group ! dim(nqvec)
  character(len=3) :: pg_gamma = ''
  integer :: nlat(3) ! lattice size
  real(kind=DP),allocatable,dimension(:,:) :: qvec ! dim(nqvec,3)
  real(kind=DP),allocatable,dimension(:,:) :: qvin ! dim(nqvec,3)
  real(kind=DP),allocatable,dimension(:)   :: wght ! dim(nqvec)
  real(kind=DP),allocatable,dimension(:,:) :: qdir ! dim(nqvec,3)
  integer :: nsp = 1
  real(kind=DP),allocatable,dimension(:,:) :: spcpnt ! dim(nsp,3)
  character(len=3), allocatable, dimension(:)  :: pg_spcpnt ! dim(nsp)
  integer :: nsl = 1
  integer,allocatable,dimension(:,:) :: symln  ! dim(nsl,2)
  integer,allocatable,dimension(:) :: ndiv     ! dim(nsl)
  character(len=3), allocatable, dimension(:)  :: pg_symln ! dim(nsl)
  logical, allocatable, dimension(:,:) :: fksym ! dim(48,nqvec)
  real(kind=DP) :: rho_loto = 1.4d0
  ! strain force coupling const.
  real(kind=DP),allocatable         :: strfrc(:,:,:)   !d(3,natm,6)
  real(kind=DP) :: piezoelectric(3,6) = 0.d0

  ! energy range for dielectric function
  real(kind=DP), private :: max_energy = 0.01d0
  real(kind=DP), private :: min_energy = 0.d0
  integer, private :: num_division = 100
  real(kind=DP), private :: damping_factor = 1.d-2

  ! Phonon DOS
  integer, private :: phonon_dos_mesh(3)
  integer                           :: np0,np1,np2
  integer,allocatable, dimension(:) :: ip20,ip10,ip02,ip12
  integer,allocatable, dimension(:) :: ip01,ip21,iu21,iv21,iwt,ip2cub
  integer, dimension(3)             :: nxyz_tetra
  real(kind=DP)                     :: DeltaE_dos = 1.d-5


  ! calculated
  integer :: nmodes ! = 3*natm
  integer :: nqvec = 1
  integer :: qvec_from_file = ON
  real(kind=DP), allocatable,dimension(:,:,:) :: dynmat  ! dim(3*natm,3*natm,nlpnt)
  complex(kind=DP), allocatable,dimension(:,:,:) :: dynmatq ! dim(3*natm,3*natm,nqvec)
  real(kind=DP), allocatable,dimension(:,:)   :: omega   ! dim(3*natm,nqvec)
  complex(kind=DP), allocatable,dimension(:,:,:) :: modes   ! dim(3*natm,3*natm,nqvec)
  character(len=3), allocatable,dimension(:,:) :: mode_irr_rep ! dim(3*natm,nqvec)
  character(len=4), allocatable,dimension(:,:) :: mode_active  ! dim(3*natm,nqvec)
  real(kind=DP), allocatable,dimension(:)   :: msqinv     ! dim(3*natm)
  real(kind=DP), allocatable,dimension(:,:) :: zeff_mode  ! dim(3,nmodes)
  real(kind=DP) :: static_dielectric(3,3) ! static dielectric tensor 
  real(kind=DP) :: lattice_dielectric(3,3) ! lattice dielectric tensor 
  real(kind=DP), allocatable,dimension(:,:) :: strphcpl  ! dim(6,nmodes)

  ! Ewald sum
  real(kind=DP) :: deteps ! Det(epsilon)
  real(kind=DP), dimension(3,3) :: epsinv ! (epsilon)^-1

  ! Tags
  character(len("phonon")),private,parameter :: tag_phonon = "phonon"
  character(len("sw_phonon")),private,parameter :: tag_sw_phonon = "sw_phonon"
  character(len("sw_calc_force")),private,parameter :: tag_sw_calc_force = "sw_calc_force"
  character(len("sw_calc_force_all")),private,parameter :: tag_sw_calc_force_all = "sw_calc_force_all"
  character(len("sw_polynomial_fit")),private,parameter :: tag_sw_polynomial_fit = "sw_polynomial_fit"
  character(len("sw_phonon_oneshot")),private,parameter :: tag_sw_phonon_oneshot = "sw_phonon_oneshot"
  character(len("num_phonon_calc_mode")),private,parameter :: tag_num_phonon_calc_mode = "num_phonon_calc_mode"
  character(len("norder")),private,parameter :: tag_norder = "norder"
  character(len("displacement")),private,parameter :: tag_displacement = "displacement"
  character(len("force_calc")),private,parameter :: tag_force_calc = "force_calc"
  character(len("start")),private,parameter :: tag_start = "start"
  character(len("end")),private,parameter :: tag_end = "end"

  character(len("sw_vibrational_modes")),private,parameter :: tag_sw_vibrational_modes = "sw_vibrational_modes"
  character(len("sw_correct_force_constants")),private,parameter :: tag_sw_correct_force_constants = "sw_correct_force_constants"
  character(len("point_group")),private,parameter :: tag_point_group = "point_group"
  character(len("sw_lo_to_splitting")),private,parameter :: tag_sw_lo_to_splitting = "sw_lo_to_splitting"
  character(len("electronic_dielectric_constant")),private,parameter :: &
       & tag_electronic_dielectric_cnst = "electronic_dielectric_constant"
  character(len("exx")),private,parameter :: tag_exx = "exx"
  character(len("eyy")),private,parameter :: tag_eyy = "eyy"
  character(len("ezz")),private,parameter :: tag_ezz = "ezz"
  character(len("exy")),private,parameter :: tag_exy = "exy"
  character(len("eyz")),private,parameter :: tag_eyz = "eyz"
  character(len("ezx")),private,parameter :: tag_ezx = "ezx"
  character(len("k_vector")),private,parameter :: tag_k_vector = "k_vector"
  character(len("kx")),private,parameter :: tag_kx = "kx"
  character(len("ky")),private,parameter :: tag_ky = "ky"
  character(len("kz")),private,parameter :: tag_kz = "kz"

  character(len("sw_lattice_dielectric_tensor")),private,parameter :: & 
       & tag_sw_lattice_dielec_tensor = "sw_lattice_dielectric_tensor"
  character(len("sw_internal_strain_piezoelectric_tensor")),private,parameter :: & 
       & tag_sw_int_strain_piezo_tensor = "sw_internal_strain_piezoelectric_tensor"

  character(len("sw_dielectric_function")),private,parameter :: tag_sw_dielectric_function = "sw_dielectric_function"
  character(len("energy_range")),private,parameter :: tag_energy_range = "energy_range"
  character(len("min_energy")),private,parameter :: tag_min_energy = "min_energy"
  character(len("max_energy")),private,parameter :: tag_max_energy = "max_energy"
  character(len("division_number")),private,parameter :: tag_division_number = "division_number"
  character(len("damping_factor")),private,parameter :: tag_damping_factor = "damping_factor"


  character(len("lattice")),private,parameter :: tag_lattice = "lattice"
  character(len("l1")),private,parameter :: tag_l1 = "l1"
  character(len("l2")),private,parameter :: tag_l2 = "l2"
  character(len("l3")),private,parameter :: tag_l3 = "l3"

  character(len("no")),private,parameter :: tag_no = "no"
  character(len("id")),private,parameter :: tag_id = "id"
  character(len("special_points")),private,parameter :: tag_special_points = "special_points"
  character(len("symmetry_lines")),private,parameter :: tag_symmetry_lines = "symmetry_lines"
  character(len("k1")),private,parameter :: tag_k1 = "k1"
  character(len("k2")),private,parameter :: tag_k2 = "k2"
  character(len("k3")),private,parameter :: tag_k3 = "k3"
  character(len("num_division")),private,parameter :: tag_num_division = "num_division"

  character(len("method")),private,parameter :: tag_method = "method"
  character(len("calc_type")),private,parameter :: tag_calc_type = "calc_type"
  character(len("gamma")),private,parameter  :: tag_gamma  = "gamma"
  character(len("zone_center")),private,parameter :: tag_zone_center = "zone_center"
  character(len("band")),private,parameter   :: tag_band   = "band"
  character(len("dispersion")),private,parameter :: tag_dispersion = "dispersion"
  character(len("dos")),private,parameter    :: tag_dos    = "dos"

  character(len("mesh")),private,parameter   :: tag_mesh   = "mesh"
  character(len("nx")),private,parameter     :: tag_nx     = "nx"
  character(len("ny")),private,parameter     :: tag_ny     = "ny"
  character(len("nz")),private,parameter     :: tag_nz     = "nz"
  character(len("deltae")),private,parameter :: tag_deltae = "deltae"

  character(len("rho")),private,parameter :: tag_rho = "rho"

  character(len("qvec_from_file")),private, parameter :: tag_qvec_from_file = "qvec_from_file"

contains

  subroutine m_Phonon_rd_param(nfout)

    integer, intent(in) :: nfout

    integer :: iret, f_selectBlock, f_getIntValue, f_getRealValue, f_getStringValue
    integer :: f_selectParentBlock, f_selectTop
    real(kind=DP) :: dret
    character(len=FMAXVALLEN) :: cret
    real(kind=DP) :: dnorm

    iret = f_selectTop()
    if( f_selectBlock( tag_phonon) == 0) then
       if( f_getIntValue( tag_sw_phonon, iret) == 0) sw_phonon = iret
       if(sw_phonon == ON) then
          sw_calc_force = ON
          if( f_getStringValue( tag_method, cret,LOWER) == 0) then
             call set_phonon_method(cret) ! -> phonon_method
          else if( f_getStringValue( tag_calc_type, cret,LOWER) == 0) then
             call set_phonon_method(cret) ! -> phonon_method
          end if
          if( f_getIntValue( tag_sw_calc_force, iret) == 0) sw_calc_force = iret
          if( f_getIntValue( tag_sw_calc_force_all, iret) == 0) sw_calc_force_all = iret
          if( f_getIntValue( tag_sw_polynomial_fit, iret) == 0) sw_polynomial_fit = iret
          if( f_getIntValue( tag_norder, iret) == 0) norder = iret
          if( f_getRealValue( tag_displacement, dret, 'bohr') == 0) then
             u = dret   
          else
             u = 0.1d0 ! default value
          end if
          if( f_getRealValue( tag_damping_factor, dret, '') == 0) damping_factor = dret
          damping_factor = abs(damping_factor)
          if( f_getIntValue( tag_sw_vibrational_modes, iret) == 0) sw_vibrational_modes = iret
          if( f_getIntValue( tag_sw_correct_force_constants, iret) == 0) sw_correct_force_constants = iret
          if( f_getStringValue( tag_point_group, cret, NOCONV) == 0) then
             pg_gamma = cret(1:3)
          else
             pg_gamma = '' ! default value
          end if

          if( f_getIntValue( tag_sw_phonon_oneshot, iret)==0) sw_phonon_oneshot = iret
          if( f_getIntValue( tag_num_phonon_calc_mode,iret)==0) num_phonon_calc_mode = iret

          ! ==== KT_add ==== 13.1R
          call m_Raman_read_nfinp
          ! =============== 13.1R

          if( f_getIntValue( tag_sw_lattice_dielec_tensor, iret) == 0) & 
               &  sw_lattice_dielectric_tensor = iret
          if( f_getIntValue( tag_sw_int_strain_piezo_tensor, iret) == 0) & 
               &  sw_int_strain_piezo_tensor = iret

          if( f_getIntValue( tag_sw_dielectric_function, iret) == 0) sw_dielectric_function = iret

          if( f_getIntValue( tag_sw_lo_to_splitting, iret) == 0) sw_lo_to_splitting = iret
          if(sw_lo_to_splitting == ON) then
             if( f_getRealValue( tag_rho, dret, '') == 0) rho_loto = dret
          end if
          if( f_selectBlock( tag_force_calc) == 0) then
             if( f_getIntValue( tag_start, iret) == 0) istart_phonon = iret
             if( f_getIntValue( tag_end, iret) == 0) iend_phonon = iret
             iret = f_selectParentBlock()
          end if
          if( f_selectBlock( tag_electronic_dielectric_cnst) == 0) then
             if( f_getRealValue( tag_exx, dret, '') == 0) dielectric(1,1) = dret
             if( f_getRealValue( tag_eyy, dret, '') == 0) dielectric(2,2) = dret
             if( f_getRealValue( tag_ezz, dret, '') == 0) dielectric(3,3) = dret
             if( f_getRealValue( tag_exy, dret, '') == 0) dielectric(1,2) = dret
             dielectric(2,1) = dielectric(1,2)
             if( f_getRealValue( tag_eyz, dret, '') == 0) dielectric(2,3) = dret
             dielectric(3,2) = dielectric(2,3)
             if( f_getRealValue( tag_ezx, dret, '') == 0) dielectric(3,1) = dret
             dielectric(1,3) = dielectric(3,1)
             iret = f_selectParentBlock()
          end if
          if( f_selectBlock( tag_energy_range ) == 0) then
             if( f_getRealValue( tag_min_energy, dret, 'hartree') == 0) min_energy = dret
             if( f_getRealValue( tag_max_energy, dret, 'hartree') == 0) max_energy = dret
             if( f_getIntValue( tag_division_number, iret) == 0) num_division = iret
             iret = f_selectParentBlock()
          end if

          if( f_getIntValue(tag_qvec_from_file,iret)==0) qvec_from_file = iret

          ! ==== KT_add ====== 13.1R
          if( phonon_method == PHONON_GAMMA ) qvec_from_file = OFF
          ! ================== 13.1R

          if(qvec_from_file==OFF)then
             if( f_selectBlock( tag_k_vector) == 0) then
                if( f_getRealValue( tag_kx, dret, '') == 0) kvec_dir(1) = dret
                if( f_getRealValue( tag_ky, dret, '') == 0) kvec_dir(2) = dret
                if( f_getRealValue( tag_kz, dret, '') == 0) kvec_dir(3) = dret
                iret = f_selectParentBlock()
                dnorm = sqrt(sum(kvec_dir(1:3)**2))
                if(abs(dnorm) < 1.d-10) then
                   kvec_dir(1:2)=0.d0
                   kvec_dir(3)=1.d0
                   dnorm = 1.d0
                end if
                kvec_dir(1:3) = kvec_dir(1:3)/dnorm
                iret = f_selectParentBlock()
             else
                kvec_dir(3) = 1.d0  ! default value
             end if
          endif

          ! === KT_add === 13.1R
          if ( sw_phonon_with_epsilon == ON ) then
             call m_Raman_initialize( kvec_dir )
             dielectric = dielectric_read_from_file
          endif
          ! ================ 13.1R

          if( phonon_method /= PHONON_GAMMA) then
             if( f_selectBlock( tag_lattice) == 0) then
                if( f_getIntValue( tag_l1, iret) == 0) nlat(1) = iret
                if( f_getIntValue( tag_l2, iret) == 0) nlat(2) = iret
                if( f_getIntValue( tag_l3, iret) == 0) nlat(3) = iret
                iret = f_selectParentBlock()
             else
                nlat(1:3) = 2
             end if
          else
             nlat(1:3) = 0
          end if

          if( phonon_method == PHONON_BAND) then
             call rd_spcpnt_and_symln()
          else if( phonon_method == PHONON_DOS) then
             phonon_dos_mesh(1:3) = 4 ! default values
             if( f_selectBlock( tag_dos) == 0) then
                if( f_selectBlock( tag_mesh) == 0) then
                   if( f_getIntValue( tag_nx, iret) == 0) phonon_dos_mesh(1) = iret
                   if( f_getIntValue( tag_ny, iret) == 0) phonon_dos_mesh(2) = iret
                   if( f_getIntValue( tag_nz, iret) == 0) phonon_dos_mesh(3) = iret
                   iret = f_selectParentBlock()
                end if
                if( f_getRealValue( tag_deltae, dret, '') == 0) DeltaE_dos = dret
                iret = f_selectParentBlock()
             end if
          end if

          iret = f_selectParentBlock()
       end if

       iret = f_selectParentBlock()
    end if

    if(sw_lattice_dielectric_tensor == ON) then
       phonon_method = PHONON_GAMMA
       sw_lo_to_splitting = OFF
    end if

    if(ipriphonon >= 1) then
       write(nfout,*) '!** sw_phonon = ',sw_phonon
       if(sw_phonon == ON) then
          write(nfout,*) '!** sw_calc_force = ',sw_calc_force
          write(nfout,*) '!** sw_calc_force_all = ',sw_calc_force_all
          write(nfout,*) '!** istart_phonon = ',istart_phonon
          write(nfout,*) '!** iend_phonon   = ',iend_phonon
          write(nfout,*) '!** displacement (Phonon) = ',u
          write(nfout,*) '!** sw_vibrational_modes = ',sw_vibrational_modes
          write(nfout,*) '!** sw_polynomial_fit = ',sw_polynomial_fit
          write(nfout,*) '!** norder = ',norder
          write(nfout,*) '!** nlat = ',nlat
          write(nfout,*) '!** sw_correct_force_constants = ',sw_correct_force_constants
          write(nfout,*) '!** point_group = ',pg_gamma
          write(nfout,*) '!** sw_lo_to_splitting = ',sw_lo_to_splitting
          write(nfout,'(" !**           [",3(1x,f10.5),1x,"]")') dielectric(1:3,1)
          write(nfout,'(" !** epsilon = [",3(1x,f10.5),1x,"]")') dielectric(1:3,2)
          write(nfout,'(" !**           [",3(1x,f10.5),1x,"]")') dielectric(1:3,3)
          write(nfout,'(" !** k_vector =",3(1x,f10.5))') kvec_dir(1:3)
          write(nfout,*) '!** sw_lattice_dielectric_tensor = ',sw_lattice_dielectric_tensor
          write(nfout,*) '!** sw_dielectric_function = ',sw_dielectric_function
          write(nfout,*) '!** energy_range = ',min_energy,max_energy,num_division
          write(nfout,*) '!** damping_factor = ',damping_factor
          write(nfout,*) '!** sw_internal_strain_piezoelectric_tensor = ',sw_int_strain_piezo_tensor
          if( phonon_method == PHONON_DOS) then
             write(nfout,*) '!** phonon_dos_mesh = ',phonon_dos_mesh(1:3)
          end if
          write(nfout,*) '!** sw_phonon_oneshot = ', sw_phonon_oneshot 
          if(sw_phonon_oneshot == ON) then
             write(nfout,*) '!** num_phonon_calc_mode = ',num_phonon_calc_mode
          end if
          ! ====== KT_add ==== 13.1R
          if ( sw_phonon_with_epsilon == ON ) call m_Raman_print_param
          ! ================== 13.1R
       end if
    end if

  contains
    subroutine rd_spcpnt_and_symln()
      integer :: num

      call read_spcpnt(.true.,nsp,num)  ! paramset = .true.  -> nsp
      nsp = num
      allocate(spcpnt(nsp,3))
      allocate(pg_spcpnt(nsp))
      call read_spcpnt(.false.,nsp,num) ! paramset = .false. -> spcpnt,pg_spcpnt

      call read_symln(.true.,nsl,num)  ! paramset = .true.  -> nsl
      nsl = num
      allocate(symln(nsl,3))
      allocate(ndiv(nsl))
      allocate(pg_symln(nsl))
      call read_symln(.false.,nsl,num) ! paramset = .false. -> symln,ndiv,pg_symln
    end subroutine rd_spcpnt_and_symln

    subroutine read_spcpnt(paramset,num,icounted)
      logical, intent(in) :: paramset
      integer, intent(in) ::  num
      integer, intent(out) :: icounted

      integer :: i, no, iret
      integer :: f_selectFirstTableLine,f_selectNextTableLine,f_getRealValue,f_getIntValue
      real(kind=dP) :: dret
      character(len=FMAXVALLEN) :: cret

      i = 1
      if( f_selectBlock( tag_special_points) == 0) then
         do
            if(i == 1) then
               if( f_selectFirstTableLine() /= 0 ) then
                  exit
               end if
            else
               if( f_selectNextTableLine() /= 0 ) then
                  exit
               end if
            end if
            if(.not.paramset) then
               if(i > num) exit
               no = i
               if(f_getIntValue(tag_no, iret) == 0) then
                  no = iret
               else if(f_getIntValue(tag_id, iret) == 0) then
                  no = iret
               end if
               if(no <= num) then
                  if(f_getRealValue(tag_k1,dret,'') == 0) spcpnt(no,1) = dret
                  if(f_getRealValue(tag_k2,dret,'') == 0) spcpnt(no,2) = dret
                  if(f_getRealValue(tag_k3,dret,'') == 0) spcpnt(no,3) = dret
                  if( f_getStringValue( tag_point_group, cret, NOCONV) == 0) then
                     pg_spcpnt(no) = cret(1:3)
                  else
                     pg_spcpnt(no) = '' ! default value
                  end if
               end if
            end if
            i = i+1
         end do
         iret = f_selectParentBlock()
      end if
      icounted = i - 1

    end subroutine read_spcpnt

    subroutine read_symln(paramset,num,icounted)
      logical, intent(in) :: paramset
      integer, intent(in) ::  num
      integer, intent(out) :: icounted

      integer :: i, no, iret
      integer :: f_selectFirstTableLine,f_selectNextTableLine,f_getRealValue,f_getIntValue
      character(len=FMAXVALLEN) :: cret

      i = 1
      if( f_selectBlock( tag_symmetry_lines) == 0) then
         do
            if(i == 1) then
               if( f_selectFirstTableLine() /= 0 ) then
                  exit
               end if
            else
               if( f_selectNextTableLine() /= 0 ) then
                  exit
               end if
            end if
            if(.not.paramset) then
               if(i > num) exit
               no = i
               if(f_getIntValue(tag_no, iret) == 0) then
                  no = iret
               else if(f_getIntValue(tag_id, iret) == 0) then
                  no = iret
               end if
               if(no <= num) then
                  if(f_getIntValue(tag_k1,iret) == 0) symln(no,1) = iret
                  if(f_getIntValue(tag_k2,iret) == 0) symln(no,2) = iret
                  if( f_getStringValue( tag_point_group, cret, NOCONV) == 0) then
                     pg_symln(no) = cret(1:3)
                  else
                     pg_symln(no) = '' ! default value
                  end if
                  if(f_getIntValue(tag_num_division,iret) == 0) ndiv(no) = iret
                  if(iret <= 0) ndiv(no) = 1 
               end if
            end if
            i = i+1
         end do
         iret = f_selectParentBlock()
      end if
      icounted = i - 1

    end subroutine read_symln

    subroutine set_phonon_method(rstr)
      character(len=FMAXVALLEN),intent(in) :: rstr
      logical :: tf
      call strncmp2(rstr, FMAXVALLEN, tag_gamma, len(tag_gamma), tf)
      if(.not.tf) &
           & call strncmp2(rstr, FMAXVALLEN, tag_zone_center, len(tag_zone_center), tf)
      if(tf) then
         phonon_method = PHONON_GAMMA
         goto 1001
      end if
      call strncmp2(rstr, FMAXVALLEN, tag_band, len(tag_band), tf)
      if(.not.tf) &
           & call strncmp2(rstr, FMAXVALLEN, tag_dispersion, len(tag_dispersion), tf)
      if(tf) then
         phonon_method = PHONON_BAND
         goto 1001
      end if
      call strncmp2(rstr, FMAXVALLEN, tag_dos, len(tag_dos), tf)
      if(tf) then
         phonon_method = PHONON_DOS
         goto 1001
      end if
1001  continue
    end subroutine set_phonon_method

  end subroutine m_Phonon_rd_param

  subroutine m_Phonon_alloc_qvec()
    integer :: isl,ishf
    real(kind=DP),allocatable,dimension(:,:,:) :: vkxyz_t
    real(kind=DP),allocatable,dimension(:) :: qwgt_t
    integer :: qnv3
    if(phonon_method == PHONON_GAMMA) then
       nqvec = 1
    else if(phonon_method == PHONON_BAND) then
       if(qvec_from_file==OFF)then
          nqvec = 0
          do isl=1,nsl
             ishf = 0
             if(isl/=nsl.and.symln(isl,2)==symln(isl+1,1)) ishf = 1
             nqvec = nqvec + ndiv(isl) + 1 - ishf
          end do
       else
          allocate(vkxyz_t(1,1,1))
          allocate(qwgt_t(1))
          qnv3=0
          call m_Files_open_kpoint_files(FILE,nbztyp_spg)
          call readk0(.true.,nfout,ipriphonon,qnv3,rltv,nfkpoint,nfmatbp &
               & ,nqvec,vkxyz_t,qwgt_t)
          write(nfout,'(a,i5)') ' !** number of k-points for the phonon-band calculation : ',nqvec
          deallocate(vkxyz_t)
          deallocate(qwgt_t)
       endif
    else if(phonon_method == PHONON_DOS) then
       call make_qpoint_set(0,nqvec,.true.) ! ipri=0, paramset = .true.
       allocate(wght(nqvec))
    end if

    allocate(qvec(nqvec,3))
    allocate(qvin(nqvec,3))
    allocate(qdir(nqvec,3))
    allocate(point_group(nqvec)); point_group = ''
    allocate(fksym(48,nqvec)); fksym = .false.
  end subroutine m_Phonon_alloc_qvec

  subroutine m_Phonon_set_qvec(nfout)
    integer, intent(in) :: nfout

    call set_qvec(nfout)
    call set_qvec_point_group(nfout)
    call wd_qvec(nfout)
  contains
    subroutine set_qvec(nfout)
      integer,intent(in) :: nfout

      integer :: k1,k2
      integer :: i,isl,ishf,iqvec
      real(kind=DP) :: q1(3),q2(3),dq(3)
      real(kind=DP), allocatable, dimension(:,:,:) :: qvec_t
      real(kind=DP), allocatable, dimension(:) :: qw_t
      if(phonon_method == PHONON_GAMMA) then
         nqvec = 1
         qvec(nqvec,1:3) = 0.d0
         qvin(nqvec,1:3) = 0.d0
         qdir(nqvec,1:3) = kvec_dir(1:3)
         point_group(nqvec) = pg_gamma
      else if(phonon_method == PHONON_BAND) then
         if(qvec_from_file==OFF)then
            nqvec = 0
            do isl=1,nsl
               k1 = symln(isl,1)
               k2 = symln(isl,2)
               q1(1:3) = rltv(1:3,1)*spcpnt(k1,1) &
                    & + rltv(1:3,2)*spcpnt(k1,2) &
                    & + rltv(1:3,3)*spcpnt(k1,3)
               q2(1:3) = rltv(1:3,1)*spcpnt(k2,1) &
                    & + rltv(1:3,2)*spcpnt(k2,2) &
                    & + rltv(1:3,3)*spcpnt(k2,3)
               dq(1:3) = (q2(1:3)-q1(1:3))/ndiv(isl)  
               ishf = 0
               if(isl/=nsl.and.symln(isl,2)==symln(isl+1,1)) ishf = 1
               iqvec = nqvec + 1
               do i=0,ndiv(isl)-ishf
                  nqvec = nqvec + 1
                  qvec(nqvec,1:3) = i*dq(1:3)+q1(1:3)
                  qdir(nqvec,1:3) = dq(1:3)
                  point_group(nqvec) = pg_symln(isl)
               end do
               point_group(iqvec) = pg_spcpnt(k1)
               if(ishf==0) point_group(nqvec) = pg_spcpnt(k2)
            end do
         else
            allocate(qvec_t(nqvec,3,CRDTYP));qvec_t=0.d0
            allocate(qw_t(nqvec));qw_t=1.d0
            call readk0(.false.,nfout,ipriphonon,nqvec,rltv,nfkpoint,nfmatbp &
                 & , nqvec, qvec_t, qw_t)
            qdir=0.d0
            do i=1,nqvec
               qvec(i,1:3) = qvec_t(i,1:3,CARTS)
            enddo
            do i=1,nqvec-1
               qdir(i,1) = qvec(i+1,1)-qvec(i,1)
               qdir(i,2) = qvec(i+1,2)-qvec(i,2)
               qdir(i,3) = qvec(i+1,3)-qvec(i,3)
            enddo
            if(nqvec>1) qdir(nqvec,:) = qdir(nqvec-1,:)
         endif
         do iqvec=1,nqvec
            do i=1,3
               qvin(iqvec,i) = sum(altv(1:3,i)*qvec(iqvec,1:3))/PAI2
            end do
         end do
      else if(phonon_method == PHONON_DOS) then
         call make_qpoint_set(1,nqvec,.false.) ! ipri=1, paramset = .false.
         do iqvec=1,nqvec
            do i=1,3
               qvin(iqvec,i) = sum(altv(1:3,i)*qvec(iqvec,1:3))/PAI2
            end do
            qdir(iqvec,1:3) = rltv(1:3,1)+rltv(1:3,2)+rltv(1:3,3)
         end do
      end if
    end subroutine set_qvec

    subroutine set_qvec_point_group(nfout)
      use m_Const_Parameters,  only: AUTOMATIC
      use m_Crystal_Structure, only: nopr,op,ig01,il,symmetry_method
      use m_CS_SpaceGroup,     only: lattice_system, &
           & get_kpoint_symmetry,get_point_group_name
      integer,intent(in) :: nfout

      integer :: i,j
      integer :: nopro,ig01o(48)
      integer :: nopro2,ig01o2(48)
      real(kind=DP) :: kvec(3)
      character(len=3) :: pg_name
      character(len=5) :: pg_name_i
      character(len=9) :: system

      if(symmetry_method==AUTOMATIC) then
         system = lattice_system
      else
         if(il>0) then
            system = 'cubic'
         else
            system = 'hexagonal'
         end if
      end if

      do i=1,nqvec
         if(point_group(i) == '') then
            kvec = qvec(i,1:3)
            call get_kpoint_symmetry(nopr,ig01,op,kvec,nopro,ig01o,nopro2,ig01o2)
            do j=1,nopro2
               fksym(ig01o2(j),i) = .true.
            end do
            call get_point_group_name(nfout,system,nopro,ig01o,pg_name,pg_name_i)
            point_group(i) = pg_name
         else
            fksym(1:nopr,i) = .true.
         end if
      end do
    end subroutine set_qvec_point_group

    subroutine wd_qvec(nfout)
      integer,intent(in) :: nfout

      integer :: i
      if(ipriphonon > 0) then
         write(nfout,'("=== q-vectors ===")')
         write(nfout,'("number of q-vectors = ",i5)') nqvec
         write(nfout,'(4x,"i",5x,"qvec(3)",26x,"qvin(3)",22x,"point_group")')
         do i=1,nqvec
            write(nfout,'(i5,3(1x,f10.5),3(1x,f10.5),1x,a3)') i,qvec(i,1:3),qvin(i,1:3),point_group(i)
         end do
      end if
    end subroutine wd_qvec

  end subroutine m_Phonon_set_qvec

  subroutine make_qpoint_set(ipri,nqvec,paramset)
    use m_Crystal_Structure, only: il,inv,ngen,igen,jgen,a,b,c,ca,cb,cc
    integer, intent(in) :: ipri
    integer, intent(inout) :: nqvec
    logical, intent(in) :: paramset

    integer :: nx1,ny1,nz1
    integer :: nx,ny,nz
    integer :: nxx,nyy,nzz
    integer :: nd, lmnp0, lmnp1, lmnp2
    real(kind=DP), pointer, dimension(:,:) :: pa0,pb0,pb 
    integer,       pointer, dimension(:,:) :: ka0,ka2
    integer,       pointer, dimension(:,:) :: ip2cub_wk
    integer,       pointer, dimension(:)   :: nstar2
    integer                                :: i
    real(kind=DP) :: nv(3),trmat(3,3)

    nx = phonon_dos_mesh(1)
    ny = phonon_dos_mesh(2)
    nz = phonon_dos_mesh(3)
    call nskma0(il,nx,ny,nz,nxx,nyy,nzz,nx1,ny1,nz1,nd)

    lmnp0=(nxx+1)*(nyy+1)*(nzz+1)
    lmnp1=lmnp0
    lmnp2=lmnp0

    nxyz_tetra = 0
    allocate(ip10(lmnp0))  ; ip10 = 0        
    if(paramset) allocate(ip20(lmnp0))
    ip20 = 0        
    allocate(ip01(lmnp1))    ; ip01 = 0
    allocate(ip02(lmnp2))    ; ip02 = 0
    allocate(ip21(lmnp1))    ; ip21 = 0
    allocate(ip12(lmnp2))    ; ip12 = 0
    allocate(iu21(lmnp1))    ; iu21 = 0
    allocate(iv21(lmnp1))    ; iv21 = 0
    allocate(nstar2(lmnp2))  ; nstar2 = 0
    allocate(pa0(3,lmnp0))  ; pa0 = 0
    allocate(pb0(3,lmnp0))  ; pb0 = 0
    allocate(pb(3,lmnp2))  ; pb = 0
    allocate(ka0(4,lmnp0))  ; ka0 = 0
!!$  allocate(ka2(4,lmnp2))  ; ka2 = 0

    call setkp0_default_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
         &               ,nx,ny,nz &
         &               ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
         &               ,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3)&
         &               ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
         &               ,nstar2,pa0,pb0,pb,ka0 &
         &               ,ipri,itrs)

    if(.not.paramset) then
       call get_trmat1  !-(contained here) ->(trmat)
       do i=1,nqvec
          nv(1:3) = dble(ka0(1:3,ip02(i)))/dble(ka0(4,ip02(i)))
          qvec(i,1:3) = matmul(trmat,nv)
          wght(i)     = dble(nstar2(i))/dble(np1)
       end do
    else
       nqvec = np2
    end if

    deallocate(ip10)
    deallocate(ip01)
    deallocate(ip02)
    deallocate(ip21)
    deallocate(ip12)
    deallocate(iu21)
    deallocate(iv21)
    deallocate(nstar2)
    deallocate(pa0)
    deallocate(pb0)
    deallocate(pb)
    deallocate(ka0)
!!$  deallocate(ka2)

    if(paramset) return

    allocate(iwt(np2)) ; iwt = 0
    allocate(ip2cub(np1)) ; ip2cub = 0

    allocate(ip2cub_wk(9,nxyz_tetra(1)*nxyz_tetra(2)*nxyz_tetra(3))) 
    ip2cub_wk = 0.d0
    call wtetra &
         &  (nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3),np0,np2,ip20 &
         &  ,iwt,ip2cub &
         &  ,ip2cub_wk)
    deallocate(ip2cub_wk)
  contains
    subroutine get_trmat1
      real(kind=DP), dimension(3,3) :: trbp,trpb,mat1,mat2
      !    make translation matrix  trpb (P -> B)

      call getspgtab(trbp)  ! spg+tetra

      call inver3n(3,trbp,trpb)

      mat1 = transpose(trpb)
      call inver3n(3,mat1,mat2)
      call matpr3(rltv,mat2,trmat)

    end subroutine get_trmat1
  end subroutine make_qpoint_set

  subroutine m_Phonon_write_forces()
    use m_IterationNumbers, only : iteration_ionic, iteration_electronic
    use m_Files, only : nfforce, m_Files_open_nfforce
    use m_Ionic_system, only : natm,num_force_calc,iconf
    use m_Control_Parameters, only : num_phonon_calc_mode
    use m_Force, only : forc_l
#ifdef WINDOWS
    use ifport
#endif

    ! local variables
    integer :: i,ic

    if(.not.allocated(force_data)) allocate(force_data(natm_super,3,num_force_data))
    ic = iconf(iteration_ionic)
    force_data(1:natm_super,1:3,ic) = forc_l(1:natm_super,1:3)

    if(mype /= 0) return

    if(iteration_ionic == 1) then
       call m_Files_open_nfforce(.false.)  ! new file (asms)
       if(istart_phonon == 1) then
          if(sw_phonon_oneshot == ON) then
             write(nfforce,'(4(1x,i7),"  : num_force_calc, norder, sw_polynomial_fit, num_phonon_calc_mode")') &
                  & num_force_calc,  norder, sw_polynomial_fit, num_phonon_calc_mode
          else
             write(nfforce,'(3(1x,i7),"  : num_force_calc, norder, sw_polynomial_fit")') &
                  & num_force_calc, norder, sw_polynomial_fit
          end if
       end if
    else
       call m_Files_open_nfforce(.true.)  ! append (asms)
    end if
    write(nfforce,'(i4,3(1x,e25.12),2i6,"  : displaced_atom, displacement(1:3), iteration_ionic,iteration_electronic")') &
         & displaced_atom,displacement(1:3),iteration_ionic,iteration_electronic
    do i=1,natm_super
       write(nfforce,'(i4,3(1x,e25.12))') i,forc_l(i,1:3)
    end do
    call flush(nfforce)

  end subroutine m_Phonon_write_forces

  ! ==== KT_add == 13.1R
  subroutine m_Phonon_print_Raman_susc
    call m_Raman_calc_susceptibility( nmodes, omega, modes, &
         &                            mode_active, mode_irr_rep )
  end subroutine m_Phonon_print_Raman_susc
  ! =============== 13.1R

  function m_Phonon_Check_iteration(iteration_ionic)
    use m_Control_Parameters, only : skip_alloc_phonon
    use m_Crystal_Structure, only : m_CS_phonon_symmetry
    use m_Ionic_System, only : m_IS_phonon_equilibrium, m_IS_cps_to_pos &
         & , istart_phonon, iend_phonon, num_force_calc &
         & , iconf
    logical :: m_Phonon_Check_iteration
    integer, intent(in) :: iteration_ionic
    integer :: id

    if(ipriphonon>=1) then
       id = iteration_ionic+istart_phonon-1
       write(nfout,*) 'PHONON: num_force_calc  = ',num_force_calc
       write(nfout,*) 'PHONON: istart, iend = ',istart_phonon, iend_phonon
       write(nfout,*) 'PHONON: id = ',id
       write(nfout,*) 'PHONON: iconf = ',iconf(id)
       write(nfout,*) 'PHONON: iteration_ionic = ',iteration_ionic
    end if

    if(iteration_ionic >= iend_phonon-istart_phonon+1 ) then
       m_Phonon_Check_iteration = .true.
       call m_IS_phonon_equilibrium()
       call m_IS_cps_to_pos()
       call m_CS_phonon_symmetry(ON)
    else 
       m_Phonon_Check_iteration = .false.
    end if
    skip_alloc_phonon = .true.

  end function m_Phonon_Check_iteration

  subroutine m_Phonon_read_forces()
    use m_Files,        only : m_Files_open_nfforce, nfforce
    use m_Ionic_System, only : num_force_calc, napt_phonon, iequconf &
         &                    , iopr_equconf, iconf
    use m_Crystal_Structure, only : op
#ifdef WINDOWS
    use ifport
#endif
    implicit none

    ! local variables
    integer :: n,i,ia,ja,ind,j,ic,iopr
    integer :: istart,idummy
    character(len=5) :: num

    if(ipriphonon>=1) write(nfout,*) '<< m_Phonon_read_forces >>: Reading forces'
    call flush(nfout)

    nmodes = natm_prim*3
    allocate(forces(3*natm_super,nmodes,norder*2))
    allocate(force0(3*natm_super))

    !if(sw_calc_force == OFF) then
    !   if(ipriphonon>=2) write(nfout,'(" sw_calc_force = OFF")')

    num_force_data = nmodes*norder*2
    if(sw_polynomial_fit == ON) num_force_data = num_force_data + 1
    if(.not.allocated(force_data)) allocate(force_data(natm_super,3,num_force_data))

    if(mype == 0) then
       call m_Files_open_nfforce(.false.)
       rewind nfforce
       read(nfforce,*) num_force_calc, norder, sw_polynomial_fit
       do i=1,num_force_calc
          read(nfforce,*) displaced_atom,displacement(1:3)
          ic = iconf(i)
          do ia=1,natm_super
             read(nfforce,*) idummy,force_data(ia,1:3,ic)
          end do
       end do
    end if

    !else
    !   if(ipriphonon>=2) write(nfout,'(" sw_calc_force = ON")')
    !end if

    if(ipriphonon>=2) write(nfout,'(" num_force_data = ",i8)') num_force_data
    do i=1,num_force_data
       ic = iequconf(i)
       if(ipriphonon>=2) write(nfout,'(" i, ic = ",2i8)') i, ic
       if(ic >= 0) cycle
       ic = abs(ic)
       iopr = iopr_equconf(i)
       if(ipriphonon>=2) write(nfout,'(" i, ic, iopr = ",3i8)') i, ic,iopr
       do ia=1,natm_super
          ja = napt_phonon(ia,i)
          do j=1,3
             force_data(ia,j,ic) = (force_data(ia,j,ic) + dot_product(op(1:3,j,iopr),force_data(ja,1:3,i)))*0.5d0
          end do
       end do
    end do

    if(ipriphonon>=2) write(nfout,'(" num_force_data = ",i8)') num_force_data
    do i=1,num_force_data
       ic = iequconf(i)
       if(ic == 0) cycle
       ic = abs(ic)
       iopr = iopr_equconf(i)
       if(ipriphonon>=2) write(nfout,'(" i, ic, iopr = ",3i8)') i, ic,iopr
       do ia=1,natm_super
          ja = napt_phonon(ia,i)
          do j=1,3
             force_data(ja,j,i) =  dot_product(op(j,1:3,iopr),force_data(ia,1:3,ic))
          end do
       end do
    end do

    if(sw_polynomial_fit == ON) then
       ind=1
       do ia=1,natm_super
          istart = 3*(ia-1)+1
          force0(istart:istart+2) = force_data(ia,1:3,ind)
       end do
    else
       ind=0
    end if
    do i=1,nmodes
       do n=1,norder*2
          ind = ind+1
          do ia=1,natm_super
             istart = 3*(ia-1)+1
             forces(istart:istart+2,i,n) = force_data(ia,1:3,ind)
          end do
       end do
    end do

    if(npes>1) then
       call mpi_bcast(forces,3*natm_super*nmodes*norder*2,mpi_double_precision,0,mpi_comm_group,ierr) ! MPI
       call mpi_bcast(force0,3*natm_super,mpi_double_precision,0,mpi_comm_group,ierr) ! MPI
    end if

    if(ipriphonon>=1) write(nfout,*) '<< m_Phonon_read_forces >>: Forces are read.'
    call flush(nfout)

    ! check sum of force
    !!if(ipriphonon>=0) then
    if(ipriphonon>=2) then
       write(nfout,*) "check sum of force"
       do i=1,num_force_data
          do j=1,3
             write(nfout,*) i,j,sum(force_data(1:natm_super,j,i))
          end do
       end do
    end if

    return
  end subroutine m_Phonon_read_forces


  subroutine m_Phonon_calc_dynamical_matrix()
    use m_Crystal_Structure, only : univol, altv
    implicit none

    ! local variables
    integer :: i,j,k
    integer :: istart
    real(kind=DP) :: mi,ui

    real(kind=DP) :: coefna
    complex(kind=DP), allocatable :: nadynmat(:,:,:) ! dim(nmodes,nmodes,nqvec)
    complex(kind=DP), allocatable :: nafd(:,:,:) ! dim(3,3,natm)
    real(kind=DP) :: sum_rule(nmodes,3)
    integer :: na,ia,ja,ir,jr,ira,jra,n
    real(kind=DP) :: ae,ai,amelem
    integer :: icell,nre,jas
    real(kind=DP) :: r(3),re(3,8)
    real(kind=DP) :: ph,w
    complex(kind=DP) :: expqr
    integer :: ii,jj,iu,ju
    integer :: iq
    real(kind=DP) :: s(3)
    integer :: ng,nr
    real(kind=DP), allocatable :: gv(:,:),rv(:,:)
    real(kind=DP) :: g2bz

    real(kind=DP), parameter :: eps = 1.d-6

    allocate(dynmat(nmodes,nmodes,nlpnt))
    allocate(dynmatq(nmodes,nmodes,nqvec))
    allocate(msqinv(nmodes))

    call m_Phonon_force_constant_matrix(dynmat)

    deallocate(forces)
    deallocate(force0)

    if(ipriphonon >=2) then
       ! output
       write(nfout,*) 'calculated force constants:'
       call write_dynmat(dynmat)
    end if

    ! symmetrized force constants in Real space
    call symmetrize_force_const_Real(dynmat)
    if(ipriphonon >=2) then
       ! output
       write(nfout,*) 'symmetrized force constants:'
       call write_dynmat(dynmat)
    end if

    ! check sum rule of force constants
    if(ipriphonon >=2) &
         & write(nfout,*) 'j ir sum_of_force_constants'
    do ia=1,natm_prim
       do ir=1,3
          i = (ia-1)*3+ir
          do jr=1,3
             sum_rule(i,jr)=0
             do n=1,nlpnt
                do ja=1,natm_prim
                   j=(ja-1)*3+jr
                   if(n==1.and.ia==ja) cycle
                   sum_rule(i,jr) = sum_rule(i,jr) + dynmat(i,j,n) 
                end do
             end do
             if(ipriphonon >=2) then
                j=(ia-1)*3+jr
                write(nfout,*) i,jr,sum_rule(i,jr)+dynmat(i,j,1)
             end if
          end do
       end do
    end do
    ! correct force constants
    if(sw_correct_force_constants == ON) then
       do i=1,nmodes
          ia = (i+2)/3
          do jr=1,3
             j=(ia-1)*3+jr
             dynmat(i,j,1) = - sum_rule(i,jr)
          end do
       end do
    end if

    ! output
    if(sw_correct_force_constants == ON) then
       if(printable) write(nfout,*) '*** Force constants were corrected. ***'
       if(ipriphonon >=2) then
          write(nfout,*) 'Corrected force constants:'
          call write_dynmat(dynmat)
       end if
    else
       if(printable) write(nfout,*) '*** Force constants were NOT corrected. ***'
    end if

    ! Fourier transform of force constants
    dynmatq(:,:,:) = dcmplx(0.d0,0.d0)
    do n=1,nqvec
!!$write(nfout,*) 'qvin=',qvin(n,1:3)
!!$write(nfout,*) 'qvec=',qvec(n,1:3)
       do icell=1,nlpnt
          do j=1,nmodes
             ja = (j-1)/3 + 1
!!$ju = mod(j-1,3)
             jas = ja + (icell-1)*natm
             do i=1,nmodes
                ia = (i-1)/3 + 1
!!$iu = mod(i-1,3)
!!$r(1:3) = cps(jas,1:3)-cps(ia,1:3)
                r(1:3) = cps(ia,1:3)-cps(jas,1:3)
                call get_pos_in_extcell(r,nre,re)
                expqr = dcmplx(0.d0,0.d0)
                do k=1,nre
                   ph = sum(qvec(n,1:3)*re(1:3,k))
                   expqr = expqr + dcmplx(cos(ph),sin(ph))
                end do
                expqr = expqr/dble(nre)
!!$write(nfout,*) 'ia,ja,i,j=',ia,ja,i,j
!!$write(nfout,'("r =",3f10.5)') r(1:3)
!!$do k=1,nre
!!$   write(nfout,'("k,re =",i3,3f10.5)') k,re(1:3,k)
!!$end do
!!$write(nfout,*) 'ph,expqr=',ph,expqr

                dynmatq(i,j,n) = dynmatq(i,j,n)+dynmat(i,j,icell)*expqr
!!$ii = (ja-1)*3 + iu + 1
!!$jj = (ia-1)*3 + ju + 1
!!$dynmatq(ii,jj,n) = dynmatq(ii,jj,n)+dynmat(i,j,icell)*expqr
             end do
          end do
       end do
    end do
    deallocate(dynmat)

    if(ipriphonon >=2) then
       ! output
       write(nfout,*) 'Force constant matrix in Fourier space:'
       call write_dynmatq(dynmatq)
    end if

    ! symmetrized force constants in Fourier space
    call symmetrize_force_const_Fourier(dynmatq)

    if(ipriphonon >=2) then
       ! output
       write(nfout,*) 'Symmetrized force constants Fourier space:'
       call write_dynmatq(dynmatq)
    end if


    if(ipriphonon >=2) then
       ! output
       write(nfout,*) 'Dynamical matrix in Fourier space:'
       call write_dynmatq(dynmatq)
    end if

    ! non-analytic part
    if(sw_lo_to_splitting == ON) then
       allocate(nadynmat(nmodes,nmodes,nqvec))
       call get_g2bz(g2bz)
       do iq=1,nqvec
          s = qvin(iq,1:3)
          call mod1(s)
          if(abs(sum(s(1:3)**2)) < eps) then
             ! Gamma point
             call calc_napart_gamma(iq,nadynmat(1,1,iq))
          else
             call calc_napart_parlinski(iq,nadynmat(1,1,iq),g2bz)
          end if
       end do

       if(ipriphonon >=2) then
          ! output
          write(nfout,*) 'Non-analytic part of force constant matrix in Fourier space:'
          call write_dynmatq(nadynmat)
       end if

       do iq=1,nqvec
          do j=1,nmodes
             do i=1,nmodes
                dynmatq(i,j,iq) = dynmatq(i,j,iq) + nadynmat(i,j,iq)
             end do
          end do
       end do

       if(ipriphonon >=2) then
          ! output
          write(nfout,*) 'Total force constant matrix in Fourier space:'
          call write_dynmatq(dynmatq)
       end if

       deallocate(nadynmat)

    end if

    ! calculate 1/sqrt(mass)
    do i=1,natm_prim
       istart=3*(i-1)+1
       mi = 1.d0/sqrt(ionic_mass(i))
       msqinv(istart) = mi
       msqinv(istart+1) = mi
       msqinv(istart+2) = mi
    end do
    if(ipriphonon > 1) then
       do i=1,nmodes
          write(nfout,*) 'debug: i= ',i,' msqinv = ',msqinv(i)
       end do
    end if

    ! calculate dynamical matrix in Fourier space
    do n=1,nqvec
       do j=1,nmodes
          do i=1,nmodes
             dynmatq(i,j,n) = dynmatq(i,j,n)*msqinv(i)*msqinv(j)
          end do
       end do
    end do


    do iq=1,nqvec
       !search the absolute maximum element
       amelem = abs(dynmatq(1,1,iq))
       do i=1,nmodes
          do j=i,nmodes
             ae = abs(dynmatq(i,j,iq))
             if(ae > amelem) amelem = ae
          end do
       end do
       if(ipriphonon >=2) then
          write(nfout,*) 'amelem = ',amelem
       end if
       do i=1,nmodes
          do j=1,nmodes
             ae = dble(dynmatq(i,j,iq))
             ai = dimag(dynmatq(i,j,iq))
             if(abs(ae) < amelem*1.d-14) ae = 0.d0
             if(abs(ai) < amelem*1.d-14) ai = 0.d0
             dynmatq(i,j,iq) = dcmplx(ae,ai)
          end do
       end do
    end do
    if(ipriphonon >=2) then
       ! output
       write(nfout,*) 'Dynamical matrix after removing small elements:'
       call write_dynmatq(dynmatq)
    end if

    return

  contains
    subroutine get_pos_in_extcell(r,nre,re)
      real(kind=DP), intent(in) :: r(3)
      integer, intent(out) :: nre
      real(kind=DP), intent(out) :: re(3,8)

      integer :: i,j,k,n(3),l
      real(kind=DP) :: s(3),p(3)
      real(kind=DP) :: eps = 1.d-6

      do i=1,3
         s(i) = sum(rltv_super(1:3,i)*r(1:3))/PAI2
      end do
      call mod1(s)
      do i=1,3
         n(i) = 1
         if(abs(s(i)-0.5d0)<eps) n(i) = 2
      end do
      do i=1,3
         if(s(i)>0.5d0-eps) s(i) = s(i) - 1.d0
      end do
      nre = 0
      do k=1,n(3)
         do j=1,n(2)
            do i=1,n(1)
               nre = nre + 1
               p(1) = s(1)+i-1
               p(2) = s(2)+j-1
               p(3) = s(3)+k-1
               do l=1,3
                  re(l,nre) = sum(altv_super(l,1:3)*p(1:3))
               end do
            end do
         end do
      end do
    end subroutine get_pos_in_extcell

    subroutine mod1(t)
      real(kind=DP), intent(inout) :: t(3)
      real(kind=DP), parameter :: eps = 1.d-6
      integer :: k
      t(1:3) = mod(t(1:3),1.d0)
      do k=1,3
         if(t(k) < -eps) t(k) = t(k) + 1.d0
         if(t(k) > 1.d0 - eps) t(k) = t(k) - 1.d0
      end do
    end subroutine mod1

    subroutine symmetrize_force_const_Real(fc)
      use m_Crystal_Structure, only : nopr,op,tau
      real(kind=DP), intent(inout) :: fc(nmodes,nmodes,nlpnt)
      ! local variables
      integer :: i,j,icell,jcell,kcell,irc,jrc
      integer :: nr(natm,nlpnt),l(3,nlpnt),lx(3),ll(3)
      integer :: lr(natm,nlpnt),llr(nlpnt,nlpnt)
!!$  real(kind=DP) :: nonsym_fc(nmodes,nmodes,nlpnt)
      real(kind=DP),allocatable,dimension(:,:,:) :: nonsym_fc
      real(kind=DP) :: tensor(3,3)
      real(kind=DP) :: x(3),y(3)
      real(kind=DP) :: aa(3,3)
      real(kind=DP) :: eps = 1.d-6
      allocate(nonsym_fc(nmodes,nmodes,nlpnt));nonsym_fc=0.d0
      nonsym_fc(1:nmodes,1:nmodes,1:nlpnt) = fc(1:nmodes,1:nmodes,1:nlpnt)
      fc(1:nmodes,1:nmodes,1:nlpnt) = 0.d0

      do icell=1,nlpnt
         l(1:3,icell) = nint(matmul(transpose(rltv),lpnt(icell,1:3))/PAI2)
      end do

      aa = matmul(transpose(rltv_super),altv)/PAI2
      do icell=1,nlpnt
         do jcell=1,nlpnt
            ll = l(1:3,jcell)-l(1:3,icell)
            do kcell=1,nlpnt
               x = matmul(aa,ll-l(1:3,kcell))
               if(sum(abs(x-nint(x)))<eps) then
                  llr(icell,jcell) = kcell
                  exit
               end if
            end do
         end do
      end do

      do n=1,nopr
         do icell=1,nlpnt
            ATOM: do i=1,natm
               x(1:3) = cps(i,1:3) + lpnt(icell,1:3)
               y = matmul(op(1:3,1:3,n),x) + tau(1:3,n,CARTS)
               do j=1,natm
                  x = y-cps(j,1:3)
                  x = matmul(transpose(rltv),x)/PAI2
                  lx = nint(x(1:3))
                  if(sum(abs(x-lx))<eps) then
                     nr(i,icell) = j
                     do jcell=1,nlpnt
                        ll = lx-l(1:3,jcell)
                        x = matmul(aa,ll)
                        if(sum(abs(x-nint(x)))<eps) then
                           lr(i,icell) = jcell
                           exit
                        end if
                     end do
                     cycle ATOM
                  end if
               end do
               write(nfout,'("No equivalent atom for the atom ",i5," in the cell ",i5)') i,icell
               stop 'No equivalent atom'
            end do ATOM
         end do
         icell = 1
         do jcell=1,nlpnt
            do j=1,natm 
               ja=3*(j-1)+1
               jr=nr(j,jcell)
               jra=3*(jr-1)+1
               jrc = lr(j,jcell)
               do i=1,natm
                  ia=3*(i-1)+1
                  ir=nr(i,icell)
                  ira=3*(ir-1)+1
                  irc = lr(i,icell)
                  kcell = llr(irc,jrc)
                  tensor(1:3,1:3)=nonsym_fc(ia:ia+2,ja:ja+2,jcell)
                  call rotate_tensor(tensor,n)
                  fc(ira:ira+2,jra:jra+2,kcell)= &
                       & fc(ira:ira+2,jra:jra+2,kcell) + tensor(1:3,1:3)
               end do
            end do
         end do
      end do
      fc(1:nmodes,1:nmodes,1:nlpnt) = fc(1:nmodes,1:nmodes,1:nlpnt)/nopr
      deallocate(nonsym_fc)
    end subroutine symmetrize_force_const_Real

    subroutine rotate_tensor(tensor,n)
      use m_Crystal_Structure, only : op
      real(kind=DP), intent(inout) :: tensor(3,3)
      integer, intent(in) :: n ! index of rotation

      ! local variables
      integer :: i,j,k,l
      real(kind=DP) :: tnew(3,3)

      tnew(1:3,1:3)=0.d0

      do l=1,3
         do i=1,3
            do k=1,3
               do j=1,3
!!$tnew(i,l)=tnew(i,l)+op(j,i,n)*tensor(j,k)*op(k,l,n)
                  tnew(i,l)=tnew(i,l)+op(i,j,n)*tensor(j,k)*op(l,k,n)
               end do
            end do
         end do
      end do

      tensor(1:3,1:3)=tnew(1:3,1:3)
    end subroutine rotate_tensor

    subroutine symmetrize_force_const_Fourier(fcq)
      use m_Ionic_System, only : napt
      use m_Crystal_Structure, only : nopr,op
      complex(kind=DP), intent(inout) :: fcq(nmodes,nmodes,nqvec)
      ! local variables
      integer :: i,j,nop,iq
!!$  complex(kind=DP) :: nonsym_fcq(nmodes,nmodes,nqvec)
      complex(kind=DP),allocatable,dimension(:,:,:) :: nonsym_fcq
      complex(kind=DP) :: tensor(3,3)
      complex(kind=DP) :: expgr
      real(kind=DP) :: ph,g(3)

      allocate(nonsym_fcq(nmodes,nmodes,nqvec));nonsym_fcq=0.d0
      nonsym_fcq(1:nmodes,1:nmodes,1:nqvec) = fcq(1:nmodes,1:nmodes,1:nqvec)
      fcq(1:nmodes,1:nmodes,1:nqvec) = 0.d0

      do iq=1,nqvec
         nop = 0
         do n=1,nopr
            if(.not.fksym(n,iq)) cycle
            nop = nop + 1
            g = matmul(op(1:3,1:3,n),qvec(iq,1:3)) - qvec(iq,1:3)
            do j=1,natm
               ja=3*(j-1)+1
               jr=napt(j,n)
               jra=3*(jr-1)+1
               do i=1,natm
                  ia=3*(i-1)+1
                  ir=napt(i,n)
                  ira=3*(ir-1)+1
                  ph = dot_product(g,cps(j,1:3)-cps(i,1:3))
                  expgr = dcmplx(cos(ph),sin(ph))
                  tensor(1:3,1:3)=nonsym_fcq(ira:ira+2,jra:jra+2,iq)
                  call rotate_complex_tensor(tensor,n)
                  fcq(ia:ia+2,ja:ja+2,iq)= &
                       & fcq(ia:ia+2,ja:ja+2,iq) + tensor(1:3,1:3)*expgr
               end do
            end do
         end do
         fcq(1:nmodes,1:nmodes,iq) = fcq(1:nmodes,1:nmodes,iq)/nop
      end do
      deallocate(nonsym_fcq)
      do iq=1,nqvec
         do j=1,nmodes
            do i=1,j
               fcq(i,j,iq)=(fcq(i,j,iq)+dconjg(fcq(j,i,iq)))*0.5d0
               fcq(j,i,iq)=dconjg(fcq(i,j,iq))
            end do
         end do
      end do

    end subroutine symmetrize_force_const_Fourier


    subroutine rotate_complex_tensor(tensor,n)
      use m_Crystal_Structure, only : op
      complex(kind=DP), intent(inout) :: tensor(3,3)
      integer, intent(in) :: n ! index of rotation

      ! local variables
      integer :: i,j,k,l
      complex(kind=DP) :: tnew(3,3)

      tnew(1:3,1:3)=0.d0

      do l=1,3
         do i=1,3
            do k=1,3
               do j=1,3
                  tnew(i,l)=tnew(i,l)+op(j,i,n)*tensor(j,k)*op(k,l,n)
               end do
            end do
         end do
      end do

      tensor(1:3,1:3)=tnew(1:3,1:3)
    end subroutine rotate_complex_tensor

    subroutine write_dynmat(dynmat)
      real(kind=DP), intent(in) :: dynmat(nmodes,nmodes,nlpnt)
      integer :: icell,l1,l2,l3,n
      do icell=1,nlpnt
         l1 = nint(sum(rltv(1:3,1)*lpnt(icell,1:3))/PAI2)
         l2 = nint(sum(rltv(1:3,2)*lpnt(icell,1:3))/PAI2)
         l3 = nint(sum(rltv(1:3,3)*lpnt(icell,1:3))/PAI2)
         write(nfout,'("icell=",i4," l1=",i3," l2=",i3," l3=",i3," lp=",3f10.5)') icell,l1,l2,l3,lpnt(icell,1:3)
         do n=1,nmodes
            write(nfout,'(50(1x,e12.5))') dynmat(n,1:nmodes,icell)
         end do
      end do
    end subroutine write_dynmat

    subroutine write_dynmatq(dynmatq)
      complex(kind=DP), intent(in) :: dynmatq(nmodes,nmodes,nqvec)
      integer :: iq
      do iq=1,nqvec
         write(nfout,'(i4," q=(",f8.3,",",f8.3,",",f8.3,")")') iq,qvin(iq,1:3)
         write(nfout,'("=== Real part ===")') 
         do n=1,nmodes
            write(nfout,'(50(1x,e12.5))') dble(dynmatq(n,1:nmodes,iq))
         end do
         write(nfout,'("=== Imag part ===")') 
         do n=1,nmodes
            write(nfout,'(50(1x,e12.5))') dimag(dynmatq(n,1:nmodes,iq))
         end do
      end do
    end subroutine write_dynmatq

    subroutine calc_napart_gamma(iq,nafc)
      integer, intent(in) :: iq
      complex(kind=DP), intent(out) :: nafc(nmodes,nmodes)

      real(kind=DP) :: coefna,kzeff(nmodes)
      integer :: i,j,na,ia

      coefna = 0.d0
      do j=1,3
         do i=1,3
            coefna = coefna + qdir(iq,i)*dielectric(i,j)*qdir(iq,j)
         end do
      end do
      coefna = PAI4/(univol*coefna)
      i=0
      do na=1,natm
         do ia=1,3
            i=i+1
            kzeff(i) = sum(qdir(iq,1:3)*zeff(1:3,ia,na))
         end do
      end do
      do j=1,nmodes
         do i=1,nmodes
            nafc(i,j) = coefna*kzeff(i)*kzeff(j)
         end do
      end do

    end subroutine calc_napart_gamma

    subroutine calc_napart_parlinski(iq,nafc,g2bz)
      integer, intent(in) :: iq
      complex(kind=DP), intent(out) :: nafc(nmodes,nmodes)
      real(kind=DP), intent(in) :: g2bz

      real(kind=DP) :: coefna,kzeff(nmodes)
      real(kind=DP) :: expk,rho2
      integer :: i,j,na,ia

      rho2 = rho_loto**2*g2bz*0.25d0

      coefna = 0.d0
      do j=1,3
         do i=1,3
            coefna = coefna + qvec(iq,i)*dielectric(i,j)*qvec(iq,j)
         end do
      end do
      coefna = PAI4/(univol*coefna)
      i=0
      do na=1,natm
         do ia=1,3
            i=i+1
            kzeff(i) = sum(qvec(iq,1:3)*zeff(1:3,ia,na))
         end do
      end do
      expk = exp(-PAI**2*sum(qvec(iq,1:3)**2)/rho2)
      do j=1,nmodes
         do i=1,nmodes
            nafc(i,j) = coefna*kzeff(i)*kzeff(j)*expk
         end do
      end do

    end subroutine calc_napart_parlinski

    subroutine get_g2bz(g2)
      real(kind=DP), intent(out) :: g2

      integer :: i,j,k
      real(kind=DP) :: g(3),gg

      g2 = dot_product(rltv(1:3,1),rltv(1:3,1))
      do i=-2,2
         do j=-2,2
            do k=-2,2
               g(1:3) = i*rltv(1:3,1)+j*rltv(1:3,2)+k*rltv(1:3,3)
               gg = dot_product(g,g)
               if(abs(gg) > eps .and. gg < g2) then
                  g2 = gg
               end if
            end do
         end do
      end do
    end subroutine get_g2bz

  end subroutine m_Phonon_calc_dynamical_matrix

  subroutine m_Phonon_force_constant_matrix(force_const_mat)
    implicit none

    real(kind=DP), intent(out) :: force_const_mat(nmodes,nmodes,nlpnt)

    ! local variables
    integer :: is,nc,ind,i,j,jj,ic,icell
    real(kind=DP) :: ui,x
    real(kind=DP), allocatable :: cmat(:,:) !dim(nc,nc)
    real(kind=DP), allocatable :: fvec(:) !dim(nc)

    if(sw_polynomial_fit == ON) then
       nc = norder*2+1
       allocate(cmat(nc,nc)); cmat = 0.d0
       allocate(fvec(nc))
       cmat(1:nc,1) = 1.d0
       ind = 1
       do is = -norder,norder
          if(is==0) cycle
          ind=ind+1
          x = u/dble(is)
          do i=2,nc
             cmat(ind,i) = x**(i-1)
          end do
       end do
       do ic=1,nlpnt
          do j=1,nmodes
             jj = nmodes*(ic-1)+j
             do i=1,nmodes
                fvec(1) = force0(jj)
                fvec(2:nc) = forces(jj,i,1:nc-1)
                force_const_mat(i,j,ic) = -polyfit_diff(nc,cmat,fvec)
             end do
          end do
       end do
    else
       ui=dble(norder)/u
       if(printable .and. ipriphonon>=2) then
          write(nfout,*) 'u=',u
          write(nfout,*) 'ui= norder/u =',ui
       endif
       if(norder == 1) then
          ui = -0.5d0*ui
          do ic=1,nlpnt
             do j=1,nmodes
                jj = nmodes*(ic-1)+j
                do i=1,nmodes
                   force_const_mat(i,j,ic) = (forces(jj,i,2)-forces(jj,i,1))*ui
                end do
             end do
          end do
       else if(norder == 2) then
          ui = -ui/12.d0
          do ic=1,nlpnt
             do j=1,nmodes
                jj = nmodes*(ic-1)+j
                do i=1,nmodes
                   force_const_mat(i,j,ic) = (-8.d0*forces(jj,i,1)+forces(jj,i,2) &
                        &  -forces(jj,i,3)+8.d0*forces(jj,i,4))*ui
                end do
             end do
          end do
       else
          stop 'Your inputed norder is not supported for the differencial approximation.'
       end if
    end if

  contains

    function polyfit_diff(nd,mat,vec)
      implicit none

      real(kind=DP) :: polyfit_diff

      integer, intent(in) :: nd
      real(kind=DP), intent(in) :: mat(nd,nd)
      real(kind=DP), intent(in) :: vec(nd)

      ! local variables
      integer :: ipiv(nd),info,i
      real(kind=DP) :: a(nd,nd),b(nd)
      real(kind=DP) :: x0,df
      real(kind=DP) :: xold
      real(kind=DP) :: eps = 1.d-10

      real(kind=DP) :: ux

      ! debug
      !  write(nfout,*) '<<polyfit_diff>>'
      !  call flush(nfout)
      ! end debug

      a = mat
      b = vec

      !debug
      !do i=1,nd
      !  write(nfout,*) 'a=',a(i,1:nd)
      !end do
      !do i=1,nd
      !  write(nfout,*) 'b=',b(i)
      !end do
      !  call flush(nfout)
      !end debug

      call dgesv(nd,1,a,nd,ipiv,b,nd,info)
      if(info .ne. 0 ) then
         if(printable) write(nfout,*) 'LAPACK routine DGETRS failure: info=',info
         stop 'LAPACK routine DGETRS failure'
      end if
      ! debug
      !  do i=1,nd
      !    print *,'i=',i,' b=',b(i)
      !  end do
      !  write(nfout,'("ux="f10.5," f=",2(1x,f15.10))') ux,vec(1),polyfunc(nd,b,0.d0)
      !  i=0
      !  do is=-norder,norder
      !    if(is==0) cycle
      !    i=i+1
      !    ux = u/dble(is) 
      !    write(nfout,'("ux="f10.5," f=",2(1x,f15.10))') ux,vec(i+1),polyfunc(nd,b,ux)
      !  end do
      !  call flush(nfout)
      ! end debug

      x0 = 0.d0
      df = diff_polyfunc(nd,b,x0)
      ! debug
      !print *,'df=',df
      ! end debug
      polyfit_diff = df

    end function polyfit_diff

    function polyfunc(nd,b,x)
      implicit none

      real(kind=DP) :: polyfunc

      integer, intent(in) :: nd
      real(kind=DP), intent(in) :: b(nd),x

      integer :: i
      real(kind=DP) :: f

      f = b(1)
      do i=2,nd
         f = f + b(i)*x**(i-1)
      end do
      polyfunc = f

    end function polyfunc

    function diff_polyfunc(nd,b,x)
      implicit none

      real(kind=DP) :: diff_polyfunc

      integer, intent(in) :: nd
      real(kind=DP), intent(in) :: b(nd),x

      integer :: i
      real(kind=DP) :: df

      df = b(2)
      do i=3,nd
         df = df + b(i)*dble(i-1)*x**(i-2)
      end do
      diff_polyfunc = df

    end function diff_polyfunc

  end subroutine m_Phonon_force_constant_matrix


  subroutine m_Phonon_calc_vib_modes()
    implicit none

    ! local variables
    integer :: i,j
!!$real(DP) :: eps=1.d-8
    real(DP) :: eps=1.d-16
    real(DP) :: norm

    allocate(omega(nmodes,nqvec),modes(nmodes,nmodes,nqvec))

    write(nfout,*) 'calc_vib_modes is started.'

    do j=1,nqvec
       write(nfout,'(i4," q=(",f8.3,",",f8.3,",",f8.3,")")') j,qvin(j,1:3)
       call solve_eigenproblem(dynmatq(1,1,j) ,omega(1,j),modes(1,1,j))
       do i=1,nmodes
          if(ipriphonon>=2) &
               & write(nfout,*) 'omega**2 = ',omega(i,j)  
          if(abs(omega(i,j)) < eps) omega(i,j)=0.d0
          if(omega(i,j) > 0.d0) then
             omega(i,j)=sqrt(omega(i,j))
          else
             omega(i,j)=-sqrt(abs(omega(i,j))) ! for the soft mode
          end if
          if(ipriphonon >=2) &
               & write(nfout,*) '==> omega = ',omega(i,j)  
       end do
    end do

    deallocate(dynmatq)

  contains
    subroutine solve_eigenproblem(dynmat,omega,modes)
      complex(kind=DP), intent(inout) :: dynmat(nmodes,nmodes)
      real(kind=DP), intent(out)      :: omega(nmodes)
      complex(kind=DP), intent(out)   :: modes(nmodes,nmodes)

      real(kind=DP) :: abstol
      integer :: lcwork,lrwork,liwork
      complex(kind=DP), allocatable :: cwork(:) ! dim(lcwork)
      real(kind=DP), allocatable :: rwork(:) ! dim(lrwork)
      integer, allocatable :: iwork(:) ! dim(liwork)
      integer, allocatable :: ifail(:) ! dim(nmodes)
      integer :: info
      integer :: m
      integer :: il,iu
      real(DP) :: vl,vu

      real(DP), external :: dlamch

      abstol=2*dlamch('S')
      !abstol=4.45014771701440D-308
      !print *,'abstol=',abstol
!!$lwork=8*nmodes
      lcwork=4*nmodes
      lrwork=7*nmodes
      liwork=5*nmodes
!!$allocate(work(lwork))
      allocate(cwork(lcwork))
      allocate(rwork(lrwork))
      allocate(iwork(liwork),ifail(nmodes))
      lcwork=-1
      call zheevx('V','A','U',nmodes,dynmat,nmodes,vl,vu,il,iu,abstol, &
           &      m,omega,modes,nmodes,cwork,lcwork,rwork,iwork,ifail,info)
!!$call dsyevx('V','A','U',nmodes,dynmat,nmodes,vl,vu,il,iu, &
!!$ &      abstol,m,omega,modes,nmodes,work,lwork,iwork, &
!!$ &      ifail,info)
      lcwork = cwork(1)
      !print *,'lwork=',lwork
      !print *,'info=',info
      deallocate(cwork)
      allocate(cwork(lcwork))
      call zheevx('V','A','U',nmodes,dynmat,nmodes,vl,vu,il,iu,abstol, &
           &      m,omega,modes,nmodes,cwork,lcwork,rwork,iwork,ifail,info)
!!$call dsyevx('V','A','U',nmodes,dynmat,nmodes,vl,vu,il,iu, &
!!$ &      abstol,m,omega,modes,nmodes,work,lwork,iwork, &
!!$ &      ifail,info)
      !print *,'info=',info
      !print *,'ifail=',ifail(1:nmodes)
      deallocate(cwork,rwork,iwork,ifail)
    end subroutine solve_eigenproblem
  end subroutine m_Phonon_calc_vib_modes

  subroutine m_Phonon_det_irr_rep()
    use m_Representation, only : get_irr_rep
    use m_Crystal_Structure, only : nopr
    implicit none

    ! local variabes
    integer :: i,j,ia,ja,ist,n
    real(DP) :: norm
    real(DP) :: eir(3),ejr(3),xir(1:nmodes)
    real(DP) :: eii(3),eji(3),xii(1:nmodes)
    integer :: nrep,nsym
    integer :: rep(48,12)
    character(len=3) :: symbol_irrep(12)
    character(len=4) :: active_rep(12)
    real(DP) :: eps = 1.d-1
    integer :: iq

    write(nfout,*) '** Representation **'

    allocate(mode_irr_rep(nmodes,nqvec))
    allocate(mode_active(nmodes,nqvec))
    do iq=1,nqvec
       write(nfout,'(i4," q=(",f8.3,",",f8.3,",",f8.3,")")') iq,qvin(iq,1:3)
       call get_irr_rep(point_group(iq),nsym,nrep,rep,symbol_irrep,active_rep)

       if(printable)  then
          write(nfout,'("Character table:",a3)') point_group(iq)
          do j=1,nrep
             write(nfout,'(a3,1x,48i3)') symbol_irrep(j), rep(1:nsym,j)
          end do
       end if
       ! debug
       !write(nfout,'("Product table:",a3)') point_group
       !do j=1,nrep
       !  write(nfout,'(a3,1x,48i3)') symbol_irrep(j),(sum(rep(1:nopr,j)*rep(1:nopr,i)),i=1,nrep)
       !end do
       ! end debug

       if ( printable ) then
          write(nfout,*) '** mode  repr. active **'
       endif

       do i=1,nmodes
          ! debug
          !        write(nfout,*) 'index of the mode =',i
          !        write(nfout,*) 'norm =',sum(dble(modes(1:nmodes,i,iq))**2+dimag(modes(1:nmodes,i,iq))**2)
          ! end debug
          mode_irr_rep(i,iq)='NON'
          Representation: do j=1,nrep
             xir(1:nmodes)=0.d0
             xii(1:nmodes)=0.d0
             do n=1,nopr
                do ia=1,natm
                   ist = 3*(ia-1)+1
                   eir(1:3) = dble(modes(ist:ist+2,i,iq))
                   eii(1:3) = dimag(modes(ist:ist+2,i,iq))
                   call rotate_eigenvector(n,ia,ja,eir,ejr)
                   call rotate_eigenvector(n,ia,ja,eii,eji)
                   ist = 3*(ja-1)+1
                   xir(ist:ist+2)=xir(ist:ist+2)+rep(n,j)*ejr(1:3)
                   xii(ist:ist+2)=xii(ist:ist+2)+rep(n,j)*eji(1:3)
                   ! debug
                   !        write(nfout,*) 'j =',j
                   !        write(nfout,*) 'n =',n
                   !        write(nfout,*) 'ia=',ia
                   !        write(nfout,*) 'eir=',eir(1:3)
                   !        write(nfout,*) 'eii=',eii(1:3)
                   !        write(nfout,*) 'ja=',ja
                   !        write(nfout,*) 'ejr=',ejr(1:3)
                   !        write(nfout,*) 'eji=',eji(1:3)
                   ! end debug
                end do
             end do
             !xi(1:nmodes) = xi(1:nmodes)/nopr 
             norm = sum(xir(1:nmodes)**2+xii(1:nmodes)**2)
             ! debug
             !write(nfout,*) 'j=',j,' norm=',norm
             ! end debug
             if(norm > eps) then
                mode_irr_rep(i,iq)= symbol_irrep(j)
                mode_active(i,iq) = active_rep(j)
                ! exit Representation
             end if
          end do Representation

          if(printable) then
             write(nfout,'(1x,i5,5x,a3,4x,a4)') i,mode_irr_rep(i,iq),mode_active(i,iq)
          endif
       end do
    end do ! q loop

  contains

    subroutine rotate_eigenvector(n,ia,ja,ei,ej)
      use m_Ionic_System, only : napt
      use m_Crystal_Structure, only : op
      integer, intent(in) :: n, ia
      integer, intent(out) :: ja
      real(kind=DP), intent(in) :: ei(3)
      real(kind=DP), intent(out) :: ej(3)

      ! local variables
      integer :: i

      ja = napt(ia,n)

      do i=1,3
         ej(i) = sum(op(i,1:3,n)*ei(1:3))
      end do

    end subroutine rotate_eigenvector

  end subroutine m_Phonon_det_irr_rep


  subroutine m_Phonon_calc_static_dielectric()
    use m_Crystal_Structure, only : univol
    implicit none

    real(DP), parameter :: ha2ev = 27.211383411 ! 1 Ha = 27.211383411 eV
    real(DP), parameter :: ev2cminv = 1.d0/1.23984185d-4 ! 1 cm^-1 = 1.233984185e-4 eV

    ! local variables
    integer :: im,i,na,ia,j
    real(DP) :: zsum
    real(DP) :: coef

    if(sw_lo_to_splitting == ON) return
    if(nqvec/=1) return

    allocate(zeff_mode(3,nmodes))
    do im=1,nmodes
       do i=1,3
          zsum = 0.d0
          j=0
          do na=1,natm
             do ia=1,3
                j=j+1
                zsum = zsum + zeff(i,ia,na)*dble(modes(j,im,nqvec))*msqinv(j)
             end do
          end do
          zeff_mode(i,im) = zsum
       end do
    end do

    coef = 16.d0*atan(1.d0)/univol
    lattice_dielectric(1:3,1:3) = 0.d0

    if (printable) then
       write(nfout,*) "*** Contribution to diagonal sum of dielectric tensor ***"
       write(nfout,'(A,15X,A)') '  mode   Repr. Active            Freq [cm-1]', &
            &                  ' Contrib.'
    endif

    do im=1,nmodes
       if(omega(im,nqvec)>1.d-10) then
          do j=1,3
             do i=1,3
                lattice_dielectric(i,j) = lattice_dielectric(i,j) +  &
                     & zeff_mode(i,im)*zeff_mode(j,im)/omega(im,nqvec)**2
             end do
          end do
          if(printable) write(nfout,'("im=",i6,1x,a3,1x,a4,2(1x,f25.10))')  &
               &  im,mode_irr_rep(im,nqvec),mode_active(im,nqvec) &
               & ,omega(im,nqvec)*ha2ev *ev2cminv &
               & ,coef*sum(zeff_mode(1:3,im)**2)/omega(im,nqvec)**2
       end if
    end do
    lattice_dielectric(1:3,1:3) = coef*lattice_dielectric(1:3,1:3)

    static_dielectric(1:3,1:3) =  &
         & lattice_dielectric(1:3,1:3) + dielectric(1:3,1:3)

  end subroutine m_Phonon_calc_static_dielectric


  subroutine m_Phonon_write_vib_modes()
    use m_Files, only : m_Files_open_nfmode, nfmode
    use m_Ionic_System, only : cps
    use m_Crystal_Structure, only : altv
    implicit none

    ! local variabes
    real(DP), parameter :: amu = 1822.88847974 ! 1 amu = 1822.88847974 Me
    real(DP), parameter :: ha2ev = 27.211383411 ! 1 Ha = 27.211383411 eV
    real(DP), parameter :: ev2cminv = 1.d0/1.23984185d-4 ! 1 cm^-1 = 1.233984185e-4 eV
    integer :: i,j,istart,iq
    real(DP) :: omega_ev,omega_cm 
    real(DP) :: zamu(3),znorm
    real(DP) :: x,hbarW,free_e

    call  m_Files_open_nfmode()

    if(mype /= 0) return

    write(nfmode,'(1x,"--- primitive lattice vectors ---")') 
    do i=1,3
       write(nfmode,'(1x,3(f14.10,1x))') altv(1:3,i)
    end do
    write(nfmode,'(1x,"--- Equilibrium position and mass of each atom---")') 
    write(nfmode,'(1x,"Natom=",i5)') natm
    do i=1,natm
       write(nfmode,'(1x,i5,3(1x,f14.10),1x,f14.5,1x,a4)') &
            &                      i,cps(i,1:3),ionic_mass(i),speciesname(ityp(i))
    end do
    write(nfmode,'(1x,"--- Vibrational modes ---")') 
    if(phonon_method == PHONON_GAMMA) then
       write(nfmode,'(1x,"Nmode=",i5," Natom=",i5)') nmodes,natm
    else
       write(nfmode,'(1x,"Nmode=",i5," Natom=",i5," Nqvec",i5)') nmodes,natm,nqvec
    end if
    if(phonon_method==PHONON_DOS .and. way_of_smearing==FERMI_DIRAC) free_e=0.d0
    do iq=1,nqvec
       if(phonon_method == PHONON_DOS) then
          write(nfmode,'(1x,"iq=",i5," q=(",f15.10,",",f15.10,",",f15.10,") (",f15.10,",",f15.10,",",f15.10,")",1x,f15.10)') &
               & iq,qvin(iq,1:3),qvec(iq,1:3),wght(iq)
       else if(phonon_method /= PHONON_GAMMA) then
          write(nfmode,'(1x,"iq=",i5," q=(",f15.10,",",f15.10,",",f15.10,") (",f15.10,",",f15.10,",",f15.10,")")') &
               & iq,qvin(iq,1:3),qvec(iq,1:3)
       end if
       do i=1,nmodes
          omega_ev = omega(i,iq)*ha2ev
          omega_cm = omega_ev*ev2cminv 
          write(nfmode,'(1x,"n= ",i5,1x,a3,1x,a4, &
               &                  /5x,"hbarW= ",e15.8," Ha = ",e15.8," eV; nu= ",e15.8," cm^-1")') &
               &                  i,mode_irr_rep(i,iq),mode_active(i,iq),omega(i,iq),omega_ev,omega_cm
          do j=1,natm
             istart = 3*(j-1)+1
             write(nfmode,'(1x,i5,1x,3f14.10)') j,dble(modes(istart:istart+2,i,iq))
          end do
          if(nqvec>1) then
             do j=1,natm
                istart = 3*(j-1)+1
                write(nfmode,'(1x,i5,1x,3f14.10)') j,dimag(modes(istart:istart+2,i,iq))
             end do
          end if
          if(phonon_method == PHONON_GAMMA.and.sw_lattice_dielectric_tensor == ON) then
             write(nfmode,'(3x,"Mode effective charge and its norm:")')
             zamu(1:3)=zeff_mode(1:3,i)*sqrt(amu)
             znorm = sqrt(sum(zamu(1:3)**2)) 
             write(nfmode,'(3x,"Z=",3(f14.10,1x),"Norm=",f14.10)') zamu(1:3),znorm
          end if
          if(phonon_method == PHONON_DOS.and.way_of_smearing==FERMI_DIRAC)then
             hbarW = omega(i,iq)
             x = hbarW/width
             if(x.gt.1.d-10) free_e = free_e + wght(iq)*(0.5d0*hbarW+width*log(1.d0-exp(-x)))
          endif
       end do
    end do
    if(phonon_method == PHONON_GAMMA.and.sw_lattice_dielectric_tensor == ON) then
       write(nfmode,'(1x,"--- Lattice and static dielectric tensors ---")') 
       do i=1,3
          write(nfmode,'(1x,"[",3(1x,f10.4)," ]",2x,"[",3(1x,f10.4)," ]")') &
               & lattice_dielectric(i,1:3), static_dielectric(i,1:3)
       end do
    end if
    if(way_of_smearing==FERMI_DIRAC.and.phonon_method==PHONON_DOS.and.printable)then
       write(nfout,'(a,f15.10,a)') '!** Free energy due to lattice vibration : ',free_e,' hartree/cell'
    endif

    return
  end subroutine m_Phonon_write_vib_modes

  subroutine m_Phonon_write_epsilon()
    use m_Crystal_Structure, only : univol
    use m_Files, only : m_Files_open_nfepsilon, nfepsilon
    implicit none

    ! local variables
    real(DP), parameter :: ha2ev = 27.211383411 ! 1 Ha = 27.211383411 eV
    integer :: n,im,i,j
    real(kind=DP) :: e,de,e2,e3,e4
    real(kind=DP) :: coef
    real(kind=DP) :: epsilon(3,3,2,0:num_division)

    if(nqvec /= 1) return

    coef = 16.d0*atan(1.d0)/univol
    de = (max_energy-min_energy)/num_division

    do n=0,num_division
       e = min_energy + de * n
       epsilon(1:3,1:3,1:2,n) = 0.d0
       do im=1,nmodes
          if(omega(im,nqvec)>1.d-5) then
             e2 = omega(im,nqvec)**2-e**2
             e3 = e*omega(im,nqvec)*damping_factor
             e4 = e2**2+e3**2
             if(abs(damping_factor) < 1.d-10) then
                if(abs(omega(im,nqvec)-e) < 1.d-10) then
                   if(e2 > 0.d0) then
                      e2 = 1.d-10   
                   else
                      e2 = -1.d-10
                   end if
                end if
                do j=1,3
                   do i=1,j
                      epsilon(i,j,1,n) = epsilon(i,j,1,n) + zeff_mode(i,im)*zeff_mode(j,im)/e2
                      epsilon(i,j,2,n) = 0.d0
                   end do
                end do
             else
                do j=1,3
                   do i=1,j
                      epsilon(i,j,1,n) = epsilon(i,j,1,n) + zeff_mode(i,im)*zeff_mode(j,im)*e2/e4
                      epsilon(i,j,2,n) = epsilon(i,j,2,n) + zeff_mode(i,im)*zeff_mode(j,im)*e3/e4
                   end do
                end do
             end if
          end if
       end do
       epsilon(1:3,1:3,1,n)=dielectric(1:3,1:3)+coef*epsilon(1:3,1:3,1,n)
       epsilon(1:3,1:3,2,n)=coef*epsilon(1:3,1:3,2,n)
    end do

    call m_Files_open_nfepsilon()
    if(mype /= 0) return
    write(nfepsilon,'("Energy(eV) E1xx E1yy E1zz E1yz E1zx E1xy E2xx E2yy E2zz E2yz E2zx E2xy")')
    do n=0,num_division
       e = (min_energy + de * n) * ha2ev
       write(nfepsilon,'(13(1x,e25.10))') &
            & e, ((epsilon(i,i,j,n),i=1,3),epsilon(2,3,j,n),epsilon(1,3,j,n),epsilon(1,2,j,n),j=1,2)
    end do

  end subroutine m_Phonon_write_epsilon

  subroutine m_Phonon_set_supercell
    use m_Crystal_Structure, only: m_CS_supercell_on
    integer :: n1,n2,n3
    n1 = nlat(1)
    n2 = nlat(2)
    n3 = nlat(3)
    if(n1==0.and.n2==0.and.n3==0) then
       n1 = 1; n2 = 1; n3 = 1
       call m_CS_supercell_on(nfout,1,n1,n2,n3) ! 1: PRIMITIVE
    else
       call m_CS_supercell_on(nfout,0,n1,n2,n3) ! 0: BRAVAIS
    end if
  end subroutine m_Phonon_set_supercell

  subroutine m_Phonon_calc_dos()
    integer :: idim = 3
    integer :: iq,im,ie
    integer :: newin
    real(kind=DP) :: emin,emax
    !  real(kind=DP), dimension(np2,nmodes) :: omega2
    !  real(kind=DP), dimension(np0) :: eawk, cdwk, cswk
    real(kind=DP), allocatable, dimension(:,:) :: omega2 ! dim(np2,nmodes)      <ASMS>
    real(kind=DP), allocatable, dimension(:)   :: eawk, cdwk, cswk ! dim(np0)   <ASMS>
    real(kind=DP), allocatable, dimension(:,:,:) :: cdos,cind ! dim(np2,nmodes,0:newin)
    real(kind=DP), allocatable, dimension(:) :: e,dos,sumdos ! dim(0:newin)

    allocate(omega2(np2,nmodes))                     ! <ASMS>
    allocate(eawk(np0),cdwk(np0),cswk(np0))          ! <ASMS>
    eawk=0.d0
    cdwk=0.d0
    cswk=0.d0

    do iq=1,np2
       do im=1,nmodes 
          omega2(iq,im) = omega(im,iq) * 1.0d3
       end do
    end do

    emin = minval(omega2) - 0.0005 ! (mhartree)
    emax = maxval(omega2) + 0.0005 ! (mhartree)
    newin = (emax - emin)/(DeltaE_dos*1.0d3) + 1

    allocate(cdos(np2,nmodes,0:newin)); cdos = 0.d0
    allocate(cind(np2,nmodes,0:newin)); cind = 0.d0

    allocate(e(0:newin))
    allocate(dos(0:newin)); dos=0.d0
    allocate(sumdos(0:newin)); sumdos=0.d0
    e(0:newin) = (/(emin + (DeltaE_dos*1.0d3)*ie,ie=0,newin)/)

    call nstt3i(idim,newin,e,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3) &
         &  ,np2,np2,nmodes,omega2 &
         &  ,ip20,np0,eawk,cdwk,cswk,np2,nmodes,cdos,cind,width_tetra )

    do iq=1,np2
       do im=1,nmodes
          do ie=0,newin
             dos(ie)    = dos(ie)    + cdos(iq,im,ie)
             sumdos(ie) = sumdos(ie) + cind(iq,im,ie)
          end do
       end do
    end do
    deallocate(cdos)
    deallocate(cind)

    call write_dos(newin,e,dos,sumdos)

    deallocate(e)
    deallocate(dos)
    deallocate(sumdos)
  contains

    subroutine write_dos(newin,e,dos,sumdos)
      use m_Files, only : m_Files_open_nfphdos, nfphdos
      integer, intent(in) :: newin
      real(kind=DP), intent(in) :: e(0:newin), dos(0:newin), sumdos(0:newin)
      integer :: ie
      real(DP), parameter :: ha2ev = 27.211383411 ! 1 Ha = 27.211383411 eV
      real(DP), parameter :: ev2cminv = 1.d0/1.23984185d-4 ! 1 cm^-1 = 1.233984185e-4 eV
      real(DP) :: eev, ecminv, dosev, doscminv

      if(mype /= 0) return
      call m_Files_open_nfphdos()

      write(nfphdos,'("# Index Omega(mHa) Omega(eV) Omega(cm-1) DOS(States/mHa) DOS(States/eV) DOS(States/cm-1) IntDOS(States)")') 
      do ie = 0, newin
         eev = e(ie)*ha2ev/1.0d3  ! Hartree
         ecminv = eev*ev2cminv
         dosev = dos(ie)/ha2ev*1.0d3 ! Hartree
         doscminv = dosev/ev2cminv
         write(nfphdos,'(i7,7(1x,f15.8))') ie,e(ie), eev, ecminv, dos(ie), dosev, doscminv, sumdos(ie)
      end do
    end subroutine write_dos
  end subroutine m_Phonon_calc_dos

  subroutine m_Phonon_read_strain_forces
    use m_Files, only : nfout, nfstrfrc, m_Files_open_nfstrfrc
    integer :: i, ia, num_force, istr, ipm
    real(kind=DP) :: str, force(3,natm,6,2), strain(6,2), eps(3,3)
    logical :: present(6)

    strain = 0.d0
    present = .false.

    allocate(strfrc(3,natm,6))
    strfrc = 0.d0

    call m_Files_open_nfstrfrc()
    read(nfstrfrc,*) num_force
    do i=1,num_force
       read(nfstrfrc,*) istr, str
       if(str>0.d0) then
          ipm = 1
       else
          ipm = 2
       end if
       strain(istr,ipm) = str
       do ia=1,natm
          read(nfstrfrc,*) force(1:3,ia,istr,ipm)
       end do
    end do

    do istr=1,6
       if(strain(istr,1) > 1.d-8 .and. strain(istr,2) < -1.d-8 &
            & .and. abs(abs(strain(istr,1))-abs(strain(istr,2))) < 1.d-10) then
          present(istr) = .true.
       end if
    end do

    write(nfout,*) 'present strain : ',present

    do istr=1,6
       if(.not.present(istr)) cycle
       str = strain(istr,1)-strain(istr,2)
       eps = 0.d0
       if(istr==1) then
          eps(1,1) = 0.5d0
       else if(istr==2) then
          eps(2,2) = 0.5d0
       else if(istr==3) then
          eps(3,3) = 0.5d0
       else if(istr==4) then
          eps(2,3) = 0.25d0
          eps(3,2) = 0.25d0
       else if(istr==5) then
          eps(3,1) = 0.25d0
          eps(1,3) = 0.25d0
       else if(istr==6) then
          eps(1,2) = 0.25d0
          eps(2,1) = 0.25d0
       end if
       do ia=1,natm
          strfrc(1:3,ia,istr) = (force(1:3,ia,istr,1)-force(1:3,ia,istr,2))/str &
               & + matmul(eps,force(1:3,ia,istr,1)+force(1:3,ia,istr,2))
       end do
    end do

    write(nfout,*) '=== Strain-force coupling constants ==='
    do istr=1,6
       if(.not.present(istr)) cycle
       write(nfout,'("Strain : ",i1)') istr
       do ia=1,natm
          Write(nfout,'(i5,3(1x,f15.5))') ia,strfrc(1:3,ia,istr)
       end do
    end do

  end subroutine m_Phonon_read_strain_forces


  subroutine m_Phonon_calc_int_strain_piezo
    use m_Crystal_Structure, only : univol
    implicit none

    ! local variables
    integer :: im,i,na,ia,j
    real(DP) :: zsum,csum
    real(DP) :: coef

    if(sw_lo_to_splitting == ON) return
    if(nqvec/=1) return

    allocate(zeff_mode(3,nmodes))
    allocate(strphcpl(6,nmodes))
    do im=1,nmodes
       do i=1,3
          zsum = 0.d0
          j=0
          do na=1,natm
             do ia=1,3
                j=j+1
                zsum = zsum + zeff(i,ia,na)*dble(modes(j,im,nqvec))*msqinv(j)
             end do
          end do
          zeff_mode(i,im) = zsum
       end do
       do i=1,6
          csum = 0.d0
          j=0
          do na=1,natm
             do ia=1,3
                j=j+1
                csum = csum + strfrc(ia,na,i)*dble(modes(j,im,nqvec))*msqinv(j)
             end do
          end do
          strphcpl(i,im) = csum
       end do
    end do

    coef = 1.d0/univol
    piezoelectric(1:3,1:6) = 0.d0
    do j=1,6
       do i=1,3
          write(nfout,'("Direction:",i1," Strain:",i1)') i,j
          do im=1,nmodes
             if(omega(im,nqvec)>1.d-10) then
                piezoelectric(i,j) = piezoelectric(i,j) +  &
                     & zeff_mode(i,im)*strphcpl(j,im)/omega(im,nqvec)**2
                if(printable) write(nfout,'("im=",i4,1x,a3,1x,a4,3(1x,f25.10))')  &
                     &  im,mode_irr_rep(im,nqvec),mode_active(im,nqvec) &
                     & ,omega(im,nqvec)*27.211383411/1.23984185d-4 &
                     & ,coef*zeff_mode(i,im)*strphcpl(j,im)/omega(im,nqvec)**2
             end if
          end do
       end do
    end do
    piezoelectric(1:3,1:6) = coef*piezoelectric(1:3,1:6)

    if(printable) then
       write(nfout,*) '=== Internal-strain piezoelectric tensor (a.u.) ==='
       do j=1,6
          write(nfout,'(i5,3(1x,f18.10))') j, piezoelectric(1:3,j)
       end do
       write(nfout,*) '=== Internal-strain piezoelectric tensor (C/m^2) ==='
       do j=1,6
          write(nfout,'(i5,3(1x,f18.10))') j, piezoelectric(1:3,j)*UNIT_PIEZO_CONST
       end do
    end if

  end subroutine m_Phonon_calc_int_strain_piezo

end module m_Phonon

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 570 $)
!
!  SUBROUINE: Renewal_of_pPotential
!
!  AUTHOR(S): M. Saito, T. Yamasaki   November/04/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!
subroutine Renewal_of_pPotential()

end subroutine Renewal_of_pPotential

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 593 $)
!
!  SUBROUINE: scf_initialize, scf_do_scf_and_force, scf_finalize
!
!  AUTHOR(S): J. Koga March/24/2009 
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!***************************************************************
! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
!!!!!BRANCH_P ORG_Parallel
! ==============================================================================
subroutine scf_initialize()
  implicit none
  call Initialization()
  call InputData_Analysis()
  call Preparation()                 ! Basis set, symmetry check etc.
  call Preparation_for_mpi(1)         ! mpi
  call PseudoPotential_Construction()
  call Ewald_and_Structure_Factor()
  call Initial_Electronic_Structure()
  call Initial_MD_Condition()
end subroutine scf_initialize

subroutine scf_do_scf_and_force(exi,skip_ewald)
  implicit none
  logical, intent(out) :: exi
  logical, intent(in)  :: skip_ewald
  logical  :: ChargeDensity_is_Converged, TotalEnergy_is_Divergent
  logical  :: Already_Converged, Already_Converged2
  logical  :: Positron_bulk, Positron_defect
  logical  :: Hubbard_model
  logical  :: Ending_Time
  logical  :: tor
  exi = .false.
  if(.not.skip_ewald) call Ewald_and_Structure_Factor()
  ChargeDensity:    do
    call IterationNumber_Setting()
    call Renewal_of_WaveFunctions()
    call ChargeDensity_Construction(1)
    call ChargeDensity_Mixing()
    if(Ending_Time()) then
      exi = .true.
      return
    endif
    if(TotalEnergy_is_Divergent()) then
      exi = .true.
      return
    endif
    call Renewal_of_Potential()
    if(Hubbard_model()) then
      call Renewal_of_Hubbard_Potential()
    end if
    if(ChargeDensity_is_Converged())  then
      call Forces()
      call post_force()
      call MDIterationNumber_Setting()
      return
    endif
  enddo ChargeDensity
end subroutine scf_do_scf_and_force

subroutine post_force()
end subroutine post_force

subroutine scf_finalize()
  implicit none
  call Postprocessing(.false.)
  call WriteDownData_onto_Files(.true.)
  !call Finalization_of_mpi()          ! mpi
end subroutine scf_finalize

subroutine scf_rd_wf_and_chg(logi)
  use m_Files, only : nfout,nfzaj,nfchgt,F_ZAJ_in_partitioned &
 &                  , F_CHGT_in_partitioned, m_Files_reopen_nfchgt, m_Files_reopen_nfzaj &
 &                  , nfefermi, m_Files_open_nfefermi, m_Files_close_nfefermi,F_ZAJ,F_CHGT
  use m_ES_IO, only : m_ESIO_rd_WFs, m_ESIO_rd_Efermi
! === DEBUG by tkato 2011/11/09 ================================================
! use m_Electronic_Structure, only : m_ES_betar_dot_WFs, m_ES_energy_eigen_values
  use m_Electronic_Structure, only : m_ES_energy_eigen_values
  use m_ES_nonlocal,          only : m_ES_betar_dot_WFs
! ==============================================================================
  use m_Charge_Density, only : m_CD_rd_chgq, m_CD_wd_chgq_l_small_portion, chgq_l
  use m_XC_Potential, only: m_XC_cal_potential, vxc_l
  use m_Orbital_Population, only : m_OP_rd_occ_mat, m_OP_mix_om
  use m_Const_Parameters, only : ON, Valence_plus_PC_Charge, VXC_AND_EXC
  use m_Control_Parameters, only : printable, sw_hubbard
  use m_ES_LHXC, only : m_ESlhxc_potential
  use m_ES_Intgr_VlhxcQlm,  only : m_ESiVQ_integrate_VlhxcQlm

  logical, intent(out) :: logi
  logical :: exi
  logi = .true.
  inquire(file=trim(F_CHGT),exist=exi)
  if(.not.exi) then
    logi=.false.
    return
  endif
  inquire(file=trim(F_ZAJ),exist=exi)
  if(.not.exi)then
    logi=.false.
    return
  endif
  
  call m_Files_reopen_nfzaj()
  call m_ESIO_rd_WFs(nfout,nfzaj,F_ZAJ_in_partitioned)
  call m_Files_reopen_nfchgt()
  call m_CD_rd_chgq(nfout,nfchgt,F_CHGT_in_partitioned)

  call m_Files_open_nfefermi()
  call m_ESIO_rd_Efermi(nfout,nfefermi)
  call m_Files_close_nfefermi()

  call m_ES_betar_dot_WFs(nfout)            ! (fsrfsi) ->fsr_l

  call m_CD_wd_chgq_l_small_portion(nfout)
  call m_XC_cal_potential(nfout,Valence_plus_PC_Charge,chgq_l, VXC_AND_EXC) ! -> vxc_l
  call m_ESlhxc_potential(nfout,chgq_l,vxc_l) ! (stlhxc) ->vlhxc_l
  call m_ESiVQ_integrate_VlhxcQlm(nfout) ! (lclchh) -> vlhxcQ
  call m_ES_energy_eigen_values(nfout)   ! (eigen0) -> eko_l,neordr

  if(sw_hubbard == ON) then
     !!$call Renewal_of_OccMat(.true.) ! -> om
     call m_OP_rd_occ_mat(nfout) ! -> om
     call m_OP_mix_om(1.d0) ! om -> ommix
     call Renewal_of_Hubbard_Potential() ! ommix -> dhub
  end if

end subroutine scf_rd_wf_and_chg
! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
!!!!BRANCH_P_END ORG_Parallel
! ==============================================================================

!================================================
!  Software name : STM
!  Module : m_Kpoints
!  Subroutine(s) : m_Kp_rd_kv3, m_Kp_alloc, m_Kp_rd
!  Author(s)     : Takahiro Yamasaki (June 7, 2004)
!
!  FURTHER MODIFICATION: Junichiro  Koga (June 24, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.

module m_Kpoints
! $Id: m_Kpoints.f90,v 1.1.1.1 2004/06/26 11:21:37 yamasaki Exp $
  use m_ArraySize_Parameters, only : knv3
  use m_Const_Parameters, only     : DP, CARTS, BUCS, CRDTYP
  use m_Timing,             only : tstatc0_begin, tstatc0_end

  implicit none

  integer                                      :: kv3   ! #sampling k-points
  integer                                      :: nspin ! nspin( 1 or 2 )
  real(kind=DP), allocatable, dimension(:,:,:) :: vkxyz ! sampling k-points

contains
  subroutine m_Kp_rd_kv3(nfinp)
    integer, intent(in) :: nfinp

    read(nfinp,*) kv3, nspin
    print *, ' kv3, nspin =', kv3, nspin
  end subroutine m_Kp_rd_kv3

  subroutine m_Kp_alloc
    allocate(vkxyz(kv3,3,CRDTYP))
  end subroutine m_Kp_alloc

  subroutine m_Kp_rd_kpoints(nfinp)
    integer, intent(in) :: nfinp
    integer             :: i, j, k

    do i = 1, kv3 * nspin
      read(nfinp,*) j, (vkxyz(i,k,CARTS),k=1,3),(vkxyz(i, k, BUCS), k=1,3)
      print *, ' k, kx, ky, kz =', i, (vkxyz(i,k,BUCS),k=1,3)
    end do
  end subroutine m_Kp_rd_kpoints

end module m_Kpoints

      SUBROUTINE DLAED1X( N, D, Q, LDQ, INDXQ, RHO, CUTPNT, WORK, IWORK,
     $                   INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      INTEGER            CUTPNT, INFO, LDQ, N
      DOUBLE PRECISION   RHO
*     ..
*     .. Array Arguments ..
      INTEGER            INDXQ( * ), IWORK( * )
      DOUBLE PRECISION   D( * ), Q( LDQ, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DLAED1X computes the updated eigensystem of a diagonal
*  matrix after modification by a rank-one symmetric matrix.  This
*  routine is used only for the eigenproblem which requires all
*  eigenvalues and eigenvectors of a tridiagonal matrix.  DLAED7 handles
*  the case in which eigenvalues only or eigenvalues and eigenvectors
*  of a full symmetric matrix (which was reduced to tridiagonal form)
*  are desired.
*
*    T = Q(in) ( D(in) + RHO * Z*Z' ) Q'(in) = Q(out) * D(out) * Q'(out)
*
*     where Z = Q'u, u is a vector of length N with ones in the
*     CUTPNT and CUTPNT + 1 th elements and zeros elsewhere.
*
*     The eigenvectors of the original matrix are stored in Q, and the
*     eigenvalues are in D.  The algorithm consists of three stages:
*
*        The first stage consists of deflating the size of the problem
*        when there are multiple eigenvalues or if there is a zero in
*        the Z vector.  For each such occurence the dimension of the
*        secular equation problem is reduced by one.  This stage is
*        performed by the routine DLAED2.
*
*        The second stage consists of calculating the updated
*        eigenvalues. This is done by finding the roots of the secular
*        equation via the routine DLAED4X (as called by DLAED3X).
*        This routine also calculates the eigenvectors of the current
*        problem.
*
*        The final stage consists of computing the updated eigenvectors
*        directly using the updated eigenvalues.  The eigenvectors for
*        the current problem are multiplied with the eigenvectors from
*        the overall problem.
*
*  Arguments
*  =========
*
*  N      (input) INTEGER
*         The dimension of the symmetric tridiagonal matrix.  N >= 0.
*
*  D      (input/output) DOUBLE PRECISION array, dimension (N)
*         On entry, the eigenvalues of the rank-1-perturbed matrix.
*         On exit, the eigenvalues of the repaired matrix.
*
*  Q      (input/output) DOUBLE PRECISION array, dimension (LDQ,N)
*         On entry, the eigenvectors of the rank-1-perturbed matrix.
*         On exit, the eigenvectors of the repaired tridiagonal matrix.
*
*  LDQ    (input) INTEGER
*         The leading dimension of the array Q.  LDQ >= max(1,N).
*
*  INDXQ  (input/output) INTEGER array, dimension (N)
*         On entry, the permutation which separately sorts the two
*         subproblems in D into ascending order.
*         On exit, the permutation which will reintegrate the
*         subproblems back into sorted order,
*         i.e. D( INDXQ( I = 1, N ) ) will be in ascending order.
*
*  RHO    (input) DOUBLE PRECISION
*         The subdiagonal entry used to create the rank-1 modification.
*
*  CUTPNT (input) INTEGER
*         The location of the last eigenvalue in the leading sub-matrix.
*         min(1,N) <= CUTPNT <= N/2.
*
*  WORK   (workspace) DOUBLE PRECISION array, dimension (4*N + N**2)
*
*  IWORK  (workspace) INTEGER array, dimension (4*N)
*
*  INFO   (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  if INFO = 1, an eigenvalue did not converge
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Jeff Rutter, Computer Science Division, University of California
*     at Berkeley, USA
*  Modified by Francoise Tisseur, University of Tennessee.
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            COLTYP, I, IDLMDA, INDX, INDXC, INDXP, IQ2, IS,
     $                   IW, IZ, K, N1, N2, ZPP1
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DLAED2, DLAED3X, DLAMRG, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( LDQ.LT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( MIN( 1, N / 2 ).GT.CUTPNT .OR. ( N / 2 ).LT.CUTPNT ) THEN
         INFO = -7
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DLAED1X', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     The following values are integer pointers which indicate
*     the portion of the workspace
*     used by a particular array in DLAED2 and DLAED3X.
*
      IZ = 1
      IDLMDA = IZ + N
      IW = IDLMDA + N
      IQ2 = IW + N
*
      INDX = 1
      INDXC = INDX + N
      COLTYP = INDXC + N
      INDXP = COLTYP + N
*
*
*     Form the z-vector which consists of the last row of Q_1 and the
*     first row of Q_2.
*
      CALL DCOPY( CUTPNT, Q( CUTPNT, 1 ), LDQ, WORK( IZ ), 1 )
      ZPP1 = CUTPNT + 1
      CALL DCOPY( N-CUTPNT, Q( ZPP1, ZPP1 ), LDQ, WORK( IZ+CUTPNT ), 1 )
*
*     Deflate eigenvalues.
*
      CALL DLAED2( K, N, CUTPNT, D, Q, LDQ, INDXQ, RHO, WORK( IZ ),
     $             WORK( IDLMDA ), WORK( IW ), WORK( IQ2 ),
     $             IWORK( INDX ), IWORK( INDXC ), IWORK( INDXP ),
     $             IWORK( COLTYP ), INFO )

!       do iii=1,n
!          print*,"Q(",iii,")="
!          print*,Q(1:n,iii)
!       enddo
*
      IF( INFO.NE.0 )
     $   GO TO 20
*
*     Solve Secular Equation.
*
      IF( K.NE.0 ) THEN
         IS = ( IWORK( COLTYP )+IWORK( COLTYP+1 ) )*CUTPNT +
     $        ( IWORK( COLTYP+1 )+IWORK( COLTYP+2 ) )*( N-CUTPNT ) + IQ2
         CALL DLAED3X( K, N, CUTPNT, D, Q, LDQ, RHO, WORK( IDLMDA ),
     $                WORK( IQ2 ), IWORK( INDXC ), IWORK( COLTYP ),
     $                WORK( IW ), WORK( IS ), INFO )
         IF( INFO.NE.0 )
     $      GO TO 20
!       do iii=1,n
!          print*,"Q(",iii,")="
!          print*,Q(1:n,iii)
!       enddo
*
*     Prepare the INDXQ sorting permutation.
*
         N1 = K
         N2 = N - K
         CALL DLAMRG( N1, N2, D, 1, -1, INDXQ )
      ELSE
         DO 10 I = 1, N
            INDXQ( I ) = I
   10    CONTINUE
      END IF
*
   20 CONTINUE
      RETURN
*
*     End of DLAED1X
*
      END

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 581 $)
!
!  PROGRAM: EPSMAIN
!
!  AUTHOR(S): T. Hamada   MAY/8/2007
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!
program EPSMAIN
! $Id: epsmain.f90 581 2018-08-01 08:38:42Z jkoga $
!
  implicit none
! === DEBUG by tkato 2013/10/16 ================================================
! logical  :: EigenValues_are_Converged, AllKpoints_are_Calculated
  logical  :: EigenValues_are_Converged, AllKpoints_are_Calculated2
! ==============================================================================
  logical  :: Already_Converged
  logical  :: Ending_Time

  logical  :: all_conv = .true.
! === DEBUG by tkato 2013/10/16 ================================================
  integer :: nk = 0
! ==============================================================================

  call Initialization_set_ekmode_ON  ! set `ekmode' ON in m_Control_Parameters
  call Initialization(1)             ! Initialization of mpi and file-setting
  call InputData_Analysis
  call Preparation                   ! Basis set, symmetry check etc.
  call Preparation_for_mpi(1)        ! mpi
  call PseudoPotential_Construction
  call Ewald_and_Structure_Factor    ! Calculate Structure Factor
  call Initial_Electronic_Structure()! read Charge Density, (lclchh)
  call Initialization_Epsilon(0)     ! Epsilon
  call Shift_Kpoint                  ! for Effective mass calculation  ! Epsilon

  KPOINTS: do
! === DEBUG by tkato 2013/10/16 ================================================
!    call KpointNumber_Setting()
     call KpointNumber_Setting2()
! ==============================================================================
     call Preparation_ek             ! (basnum)
     call Preparation_for_mpi_ek     ! mpi  -> np_g1k, mp_g1k
     call PseudoPotential_ek_Epsilon ! (kbint)                         ! Epsilon
     call Initial_WaveFunctions_ek   ! (rndzaj|rdzaj),(fsrfsi),(lclchh)
     if(.not.Already_Converged()) then
        all_conv = .false.
        SolveWaveFunctions: do
           if(Ending_Time())                 exit KPOINTS
           call IterationNumber_Setting()
           call Renewal_of_WaveFunctions()
           if(EigenValues_are_Converged()) then                        ! Epsilon
              call Transition_moment_Epsilon                           ! Epsilon
              call Dealloc_Radr_and_Wos_Epsilon                        ! Epsilon
              exit SolveWaveFunctions
           end if
       enddo SolveWaveFunctions
! === DEBUG by tkato 2013/10/16 ================================================
!       if(AllKpoints_are_Calculated())  then
        if(AllKpoints_are_Calculated2(nk))  then
! ==============================================================================
           all_conv = .true.
           exit KPOINTS
        end if
     else
        exit KPOINTS
     end if
  enddo KPOINTS
!!$  else
!!$     write(6,'(" Already_Converged")')
!!$     call KpointNumber_Setting()
!!$     call Preparation_ek             ! (basnum)
!!$     call PseudoPotential_ek         ! (kbint)
!!$     call Initial_WaveFunctions_ek   ! (rndzaj|rdzaj),(fsrfsi),(lclchh)
!!$  end if

  call Postprocessing(.false.)
  if(all_conv) then
     call Reset_Kpoint                                                   ! Epsilon
     call Prep_for_Calc_Epsilon                                          ! Epsilon
     call Calc_Epsilon                                                   ! Epsilon
     call Calc_Nonlinear_optics                                          ! Epsilon
     call WriteDownData_onto_Files_Eps                                   ! Epsilon
  end if
  call WriteDownData_onto_Files_ek()
  call Finalization_of_mpi           ! mpi
end program EPSMAIN

      SUBROUTINE DOPMTR( SIDE, UPLO, TRANS, M, N, AP, TAU, C, LDC, WORK,
     $                   INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS, UPLO
      INTEGER            INFO, LDC, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   AP( * ), C( LDC, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DOPMTR overwrites the general real M-by-N matrix C with
*
*                  SIDE = 'L'     SIDE = 'R'
*  TRANS = 'N':      Q * C          C * Q
*  TRANS = 'T':      Q**T * C       C * Q**T
*
*  where Q is a real orthogonal matrix of order nq, with nq = m if
*  SIDE = 'L' and nq = n if SIDE = 'R'. Q is defined as the product of
*  nq-1 elementary reflectors, as returned by DSPTRD using packed
*  storage:
*
*  if UPLO = 'U', Q = H(nq-1) . . . H(2) H(1);
*
*  if UPLO = 'L', Q = H(1) H(2) . . . H(nq-1).
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply Q or Q**T from the Left;
*          = 'R': apply Q or Q**T from the Right.
*
*  UPLO    (input) CHARACTER*1
*          = 'U': Upper triangular packed storage used in previous
*                 call to DSPTRD;
*          = 'L': Lower triangular packed storage used in previous
*                 call to DSPTRD.
*
*  TRANS   (input) CHARACTER*1
*          = 'N':  No transpose, apply Q;
*          = 'T':  Transpose, apply Q**T.
*
*  M       (input) INTEGER
*          The number of rows of the matrix C. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C. N >= 0.
*
*  AP      (input) DOUBLE PRECISION array, dimension
*                               (M*(M+1)/2) if SIDE = 'L'
*                               (N*(N+1)/2) if SIDE = 'R'
*          The vectors which define the elementary reflectors, as
*          returned by DSPTRD.  AP is modified by the routine but
*          restored on exit.
*
*  TAU     (input) DOUBLE PRECISION array, dimension (M-1) if SIDE = 'L'
*                                     or (N-1) if SIDE = 'R'
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DSPTRD.
*
*  C       (input/output) DOUBLE PRECISION array, dimension (LDC,N)
*          On entry, the M-by-N matrix C.
*          On exit, C is overwritten by Q*C or Q**T*C or C*Q**T or C*Q.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension
*                                   (N) if SIDE = 'L'
*                                   (M) if SIDE = 'R'
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            FORWRD, LEFT, NOTRAN, UPPER
      INTEGER            I, I1, I2, I3, IC, II, JC, MI, NI, NQ
      DOUBLE PRECISION   AII
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARF, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LEFT = LSAME( SIDE, 'L' )
      NOTRAN = LSAME( TRANS, 'N' )
      UPPER = LSAME( UPLO, 'U' )
*
*     NQ is the order of Q
*
      IF( LEFT ) THEN
         NQ = M
      ELSE
         NQ = N
      END IF
      IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) ) THEN
         INFO = -3
      ELSE IF( M.LT.0 ) THEN
         INFO = -4
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -9
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DOPMTR', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 )
     $   RETURN
*
      IF( UPPER ) THEN
*
*        Q was determined by a call to DSPTRD with UPLO = 'U'
*
         FORWRD = ( LEFT .AND. NOTRAN ) .OR.
     $            ( .NOT.LEFT .AND. .NOT.NOTRAN )
*
         IF( FORWRD ) THEN
            I1 = 1
            I2 = NQ - 1
            I3 = 1
            II = 2
         ELSE
            I1 = NQ - 1
            I2 = 1
            I3 = -1
            II = NQ*( NQ+1 ) / 2 - 1
         END IF
*
         IF( LEFT ) THEN
            NI = N
         ELSE
            MI = M
         END IF
*
         DO 10 I = I1, I2, I3
            IF( LEFT ) THEN
*
*              H(i) is applied to C(1:i,1:n)
*
               MI = I
            ELSE
*
*              H(i) is applied to C(1:m,1:i)
*
               NI = I
            END IF
*
*           Apply H(i)
*
            AII = AP( II )
            AP( II ) = ONE
            CALL DLARF( SIDE, MI, NI, AP( II-I+1 ), 1, TAU( I ), C, LDC,
     $                  WORK )
            AP( II ) = AII
*
            IF( FORWRD ) THEN
               II = II + I + 2
            ELSE
               II = II - I - 1
            END IF
   10    CONTINUE
      ELSE
*
*        Q was determined by a call to DSPTRD with UPLO = 'L'.
*
         FORWRD = ( LEFT .AND. .NOT.NOTRAN ) .OR.
     $            ( .NOT.LEFT .AND. NOTRAN )
*
         IF( FORWRD ) THEN
            I1 = 1
            I2 = NQ - 1
            I3 = 1
            II = 2
         ELSE
            I1 = NQ - 1
            I2 = 1
            I3 = -1
            II = NQ*( NQ+1 ) / 2 - 1
         END IF
*
         IF( LEFT ) THEN
            NI = N
            JC = 1
         ELSE
            MI = M
            IC = 1
         END IF
*
         DO 20 I = I1, I2, I3
            AII = AP( II )
            AP( II ) = ONE
            IF( LEFT ) THEN
*
*              H(i) is applied to C(i+1:m,1:n)
*
               MI = M - I
               IC = I + 1
            ELSE
*
*              H(i) is applied to C(1:m,i+1:n)
*
               NI = N - I
               JC = I + 1
            END IF
*
*           Apply H(i)
*
            CALL DLARF( SIDE, MI, NI, AP( II ), 1, TAU( I ),
     $                  C( IC, JC ), LDC, WORK )
            AP( II ) = AII
*
            IF( FORWRD ) THEN
               II = II + NQ - I + 1
            ELSE
               II = II - NQ + I - 2
            END IF
   20    CONTINUE
      END IF
      RETURN
*
*     End of DOPMTR
*
      END

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 593 $)
!
!  SUBROUINE:  Move_Ions, wd_cps_and_forces
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!
!  FURTHER MODIFICATION: T. Yamasaki   January/13/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Move_Ions
! $Id: Move_Ions.F90 593 2019-06-20 03:47:31Z jkoga $
  use m_Control_Parameters, only : iprimd, c_iteration2GDIIS &
       &                         , m_CtrlP_what_is_mdalg &
       &                         , m_CtrlP_set_gdiisoptmode &
       &                         , sw_charge_predictor,sw_wf_predictor,sw_rspace,af &
       &                         , sw_fcp
  use m_Const_Parameters, only   : DP, TEMPERATURE_CONTROL, VERLET &
       &, BLUEMOON, QUENCHED_CONSTRAINT, QUENCHED_MD, NORMAL_MODE_ANALYSIS &
       &, HYPERPLANE_ADAPTIVE_COORDINATE, HAC, T_CONTROL, GDIIS, ORDINA &
       &, PHONON_FORCE, CG_STROPT, STEEPEST_DESCENT, BFGS, ON, CG_STROPT2 &
       &, PT_CONTROL, P_CONTROL, L_BFGS
  use m_Files,        only : nfenf, nfdynm,nfout
  use m_Total_Energy, only : etotal
  use m_Ionic_System, only : natm,ekina,ega,m_IS_wd_cpo_and_forc &
       &                   , m_IS_md_thermo, m_IS_md_bluem, m_IS_md_cnstr &
       &                   , m_IS_gdiis, m_IS_wd_forc, m_IS_md, m_IS_cps_to_pos &
       &                   , m_IS_cp_cps2cpo,m_IS_wd_pos_and_v &
       &                   , m_IS_phonon_force, m_IS_cg, m_IS_cg2 &
       &                   , m_IS_evaluate_v_verlet &
       &                   , m_IS_update_cps_history &
       &                   , m_IS_force_af_symmetry
!!$       &                   , forcmx_constraint_quench, almda, mdmode &
  use m_Force,        only : forc_l, forcmx
  use m_IterationNumbers, only : iteration_ionic,iteration
  use m_Parallelization,    only : mype
#ifdef __TIMER__
  use m_Parallelization,    only : mpi_comm_group
#endif

  use m_Realspace,          only : m_RS_resolve_mesh_soft
  use m_NonLocal_Potential, only : m_NLP_build_snl_in_rspace
  use m_PseudoPotential,    only : m_PP_alloc_radr,m_PP_dealloc_radr

! ================================ KT_add =================== 13.0B
  use m_Ionic_System,       only : m_IS_symmetrize_atom_pos
  use m_Control_Parameters,  only : sw_keep_symmetry_strict
! =========================================================== 13.0B

! === KT_add === 2014/06/10
  use m_Ionic_System,  only : sw_change_temperature_by_step, m_IS_reassgin_thermog
! ============== 2014/06/10

  use m_Fcp, only : m_Fcp_md_thermo, m_Fcp_cg, m_Fcp_cg2, m_Fcp_md, m_Fcp_gdiis &
  &               , m_Fcp_print_status

  use m_UnitCell, only : m_UnitCell_md

  implicit none

  integer :: mdalg
  integer, save ::                optmode = QUENCHED_MD
  real(kind=DP),parameter :: c_forc2GDIIS = 0.0050d0
  integer, save ::                 iter_f = 0

#ifdef __TIMER__
  integer :: ierr
  call mpi_barrier(mpi_comm_group, ierr)
  call timer_sta(20)
#endif

  if(sw_charge_predictor==ON.or.sw_wf_predictor==ON) call m_IS_update_cps_history()

  mdalg = m_CtrlP_what_is_mdalg()

  if(mdalg == VERLET) call m_IS_evaluate_v_verlet(mdalg,forc_l)
  call wd_forces_cps_etotal_and_etc(mdalg,.true.) ! nfdynm  ! (Convergence_Check)
  if(mdalg /= T_CONTROL .and. mdalg /= BLUEMOON) then
     call wd_forces_cps_etotal_and_etc(mdalg,.false.) ! nfefn  ! (Convergence_Check)
  end if

! === KT_add === 2014/06/10
  if ( sw_change_temperature_by_step == ON ) then
     call m_IS_reassgin_thermog
  endif
! ============== 2014/06/10

  call m_IS_cp_cps2cpo()                 ! -> cpo_l
  mdalgorithm: select case(mdalg)
     case (GDIIS,BFGS,L_BFGS)
        optmode = m_CtrlP_set_gdiisoptmode(iteration_ionic,forcmx)
        if(optmode == QUENCHED_MD .or. optmode == STEEPEST_DESCENT) then
           call m_IS_md(optmode,forc_l)
           if(sw_fcp == ON ) call m_Fcp_md(optmode)
        else if(optmode == CG_STROPT) then
           call m_IS_cg(forc_l,etotal)
           if(sw_fcp == ON ) call m_Fcp_cg()
        else if(optmode == CG_STROPT2) then
           call m_IS_cg2(forc_l,etotal)
           if(sw_fcp == ON ) call m_Fcp_cg2()
        else
           call m_IS_gdiis(forc_l,forcmx,etotal)
           if(sw_fcp == ON ) call m_Fcp_gdiis()
!!$           if(mdmode == CNSTRA) call m_CtrlP_reset_optmode()
!!$     else if(mdalg == HAC) then
!!$        call me_nebm2(nfout,forc_l)
        end if
     case (CG_STROPT)
        call m_IS_cg(forc_l,etotal)
        if(sw_fcp == ON ) call m_Fcp_cg()
     case (CG_STROPT2)
        call m_IS_cg2(forc_l,etotal)
        if(sw_fcp == ON ) call m_Fcp_cg2()
     case (VERLET, QUENCHED_MD,STEEPEST_DESCENT)
        call m_IS_md(mdalg,forc_l) 
        if(sw_fcp == ON ) call m_Fcp_md(mdalg)
     case (T_CONTROL)
        call m_IS_md_thermo(forc_l)
        if(sw_fcp == ON ) call m_Fcp_md_thermo()
     case (BLUEMOON)
        call m_IS_md_bluem(forc_l)
     case (QUENCHED_CONSTRAINT)
        call m_IS_md_cnstr(forc_l)
     case (PHONON_FORCE)
        call m_IS_wd_forc(forc_l)
        call m_IS_phonon_force()
     case (PT_CONTROL,P_CONTROL)
        continue
     case default
        stop ' mdalg error at (Move_Ions)'
  end select mdalgorithm

  if(sw_fcp == ON) call m_Fcp_print_status()

  if(mdalg == T_CONTROL .or. mdalg == BLUEMOON) then
     call wd_forces_cps_etotal_and_etc(mdalg,.false.) ! nfefn  ! (Convergence_Check)
  end if

!!$  call wd_etotal_etc                           ! -(contained here)
!!$  call wd_cps_and_forces()                        ! -(contained here)
  call m_IS_cps_to_pos()
  
! ================================== KT_add  =================== 13.0B
  if ( sw_keep_symmetry_strict == ON ) then
     call m_IS_symmetrize_atom_pos(nfout)        ! -> cps,pos
  endif
! ============================================================== 13.0B

  if (af/=0) call m_IS_force_af_symmetry(nfout)

  if(iprimd >= 2) call m_IS_wd_forc(forc_l)

  if(sw_rspace==ON)then
     call m_PP_alloc_radr()
     call m_RS_resolve_mesh_soft(nfout)
     call m_NLP_build_snl_in_rspace(nfout)
     call m_PP_dealloc_radr()
  endif

#ifdef __TIMER__
  call timer_end(20)
#endif
contains
!!$  subroutine wd_cps_and_forces()
!!$
!!$    if(flag_wd_nfdynm == 0) then
!!$       call m_IS_wd_speciesname_etc(nfdynm)
!!$       flag_wd_nfdynm = 1
!!$    end if
!!$    if(mype == 0) then
!!$       if(mdmode == CNSTRA) then
!!$          write(nfdynm,'(" cps and forc at (iter_ion, iter_total = " &
!!$               & ,i5,i8," ) converged_in_a_plane")') iteration_ionic, iteration
!!$       else
!!$          write(nfdynm,'(" cps and forc at (iter_ion, iter_total = " &
!!$               & ,i5,i8," )")') iteration_ionic, iteration
!!$       end if
!!$    end if
!!$
!!$    call m_IS_wd_cpo_and_forc(nfdynm,forc_l)
!!$
!!$  end subroutine wd_cps_and_forces

  integer function set_optmode()
    set_optmode = optmode
    if(optmode == QUENCHED_MD .and. forcmx <= c_forc2GDIIS) then
       if(iter_f >= 3) then
          set_optmode = GDIIS
       else
          set_optmode = QUENCHED_MD
       end if
    end if
    iter_f = iter_f + 1
  end function set_optmode

end subroutine Move_Ions

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 570 $)
!
!  SUBROUINE:  crngabc4, setglist4, zf_list_s, calc_phase2, calc_phase
!              substitute_il3
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! $Id: b_Electronic_Structure.F90 570 2017-04-21 20:34:50Z yamasaki $
subroutine substitute_il3(n,il3)
  implicit none
  integer, intent(in)               :: n
  integer, intent(out), dimension(n) :: il3

  integer i, l
  l = 0
  do i = 1, n
     if(i > (l+1)**2) l = l + 1
     il3(i) = l
  end do
end subroutine substitute_il3

subroutine calc_phase(ia,natm,pos,kgp,ibaik,ngabc,kg1,nbase,kd,zfcos,zfsin)
  use m_Const_Parameters, only : PAI2, DP
  implicit none
  integer, intent(in)                          :: ia   ! #atom
  integer, intent(in)                          :: natm ! 1st dim. of pos
  real(kind=DP), intent(in), dimension(natm,3) :: pos  ! positions of atoms
  integer, intent(in)                          :: kgp  ! 1st dim. of ngabc
  integer, intent(in)                          :: ibaik! range of operation
  integer, intent(in), dimension(kgp,3)        :: ngabc! g-vectors
  integer, intent(in)                          :: kg1  ! 1st dim. of nbase
  integer, intent(in), dimension(kg1)          :: nbase! pointer to a G-vector set
  integer, intent(in)                          :: kd   ! dim. of zfcos, zfsin
  real(kind=DP), intent(out), dimension(kd)    :: zfcos, zfsin ! phase

  integer       :: i, nb
  real(kind=DP) ::  fx, fy, fz, ph
  fx = pos(ia,1)*PAI2
  fy = pos(ia,2)*PAI2
  fz = pos(ia,3)*PAI2
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
  do i = 1,ibaik
     nb = nbase(i)
     ph = ngabc(nb,1)*fx+ngabc(nb,2)*fy+ngabc(nb,3)*fz
     zfcos(i) = dcos(ph)
     zfsin(i) = dsin(ph)
  end do
end subroutine calc_phase

!$$#ifdef PARA3D
subroutine calc_phasek_b_3D(natm,pos,n_ialist0,ia_list,kgp,ist,ien,ngabc,kg1,nbase,kd_adj,zfcos_x,zfsin_x)
  use m_Const_Parameters, only : PAI2, DP
  implicit none
  integer, intent(in)                          :: natm       ! 1st dim. of pos
  real(kind=DP), intent(in), dimension(natm,3) :: pos        ! positions of atoms
  integer, intent(in)                          :: n_ialist0  ! #atom
  integer, intent(in), dimension(n_ialist0)    :: ia_list
  integer, intent(in)                          :: kgp        ! 1st dim. of ngabc
  integer, intent(in)                          :: ist, ien   ! range of operation
  integer, intent(in), dimension(kgp,3)        :: ngabc      ! g-vectors
  integer, intent(in)                          :: kg1        ! 1st dim. of nbase
  integer, intent(in), dimension(kg1)          :: nbase      ! pointer to a G-vector set
  integer, intent(in)                          :: kd_adj     ! dim. of zfcos, zfsin
  real(kind=DP), intent(out), dimension(kd_adj,n_ialist0)   :: zfcos_x, zfsin_x ! phase

  integer       :: i, nb, ia,iap, iadd
  real(kind=DP) ::  fx, fy, fz, ph

#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption parallel
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
  do iap = 1, n_ialist0
     ia = ia_list(iap)
     fx = pos(ia,1)*PAI2
     fy = pos(ia,2)*PAI2
     fz = pos(ia,3)*PAI2
     do i = ist, ien
        iadd = i - ist + 1
        nb = nbase(i)
        ph = ngabc(nb,1)*fx+ngabc(nb,2)*fy+ngabc(nb,3)*fz
        zfcos_x(iadd,iap) = dcos(ph)
        zfsin_x(iadd,iap) = dsin(ph)
     end do
   end do
end subroutine calc_phasek_b_3D
!$$#endif

subroutine calc_phase2(natm,pos,ia,kgp,ngabc,ista_kngp,iend_kngp,zfcos,zfsin)
  use m_Const_Parameters, only : PAI2, DP
  implicit none
  integer, intent(in)                          :: natm ! 1st dim. of pos
  real(kind=DP), intent(in), dimension(natm,3) :: pos  ! positions of atoms
  integer, intent(in)                          :: ia   ! #atom
  integer, intent(in)                          :: kgp  ! range of operation
!  integer, intent(in), dimension(kgp,3)        :: ngabc! g-vectors
  integer, intent(in), dimension(ista_kngp:iend_kngp,3)        :: ngabc! g-vectors
  integer, intent(in)                          :: ista_kngp, iend_kngp
  real(kind=DP),intent(out),dimension(ista_kngp:iend_kngp) :: zfcos, zfsin ! phase

  integer       ::  i
  real(kind=DP) :: fx, fy, fz, ph
  integer       ::  iend  !mpi
  fx = pos(ia,1)*PAI2
  fy = pos(ia,2)*PAI2
  fz = pos(ia,3)*PAI2
  iend = iend_kngp
  if( iend_kngp > kgp ) iend = kgp
  if( ista_kngp <= iend ) then
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
     do i = ista_kngp, iend  !for mp
        ph = ngabc(i,1)*fx+ngabc(i,2)*fy+ngabc(i,3)*fz
        zfcos(i) = dcos(ph)
        zfsin(i) = dsin(ph)
     end do
  endif
!xocl end spread
end subroutine calc_phase2

subroutine calc_phase_b(natm,pos,ia_list,n_ialist,kgp,ngabc,ista_kngp,iend_kngp,ista_kngp_adj,iend_kngp_adj,zfcos_x,zfsin_x)
  use m_Const_Parameters, only : PAI2, DP
  implicit none
  integer, intent(in) ::                          natm ! 1st dim. of pos
  real(kind=DP), intent(in), dimension(natm,3) :: pos  ! positions of atoms
  integer, intent(in) ::                          n_ialist ! #atom
  integer, intent(in), dimension(n_ialist) ::     ia_list(n_ialist) ! list of #atom
  integer, intent(in) ::                          kgp  ! range of operation
  integer, intent(in), dimension(kgp,3)        :: ngabc! g-vectors
  integer, intent(in)                          :: ista_kngp, iend_kngp, ista_kngp_adj, iend_kngp_adj
  real(kind=DP),intent(out),dimension(ista_kngp_adj:iend_kngp_adj,n_ialist) :: zfcos_x, zfsin_x ! phase

  integer       ::  i, ia, ip, is
  real(kind=DP) :: fx_1, fy_1, fz_1, ph_1, fx_2, fy_2, fz_2, ph_2, fx_3, fy_3, fz_3, ph_3, fx_4, fy_4, fz_4, ph_4
  integer       ::  iend  !mpi
  if(n_ialist >= 1) then
     fx_1 = pos(ia_list(1),1)*PAI2
     fy_1 = pos(ia_list(1),2)*PAI2
     fz_1 = pos(ia_list(1),3)*PAI2
  end if
  if(n_ialist >= 2) then
     fx_2 = pos(ia_list(2),1)*PAI2
     fy_2 = pos(ia_list(2),2)*PAI2
     fz_2 = pos(ia_list(2),3)*PAI2
  end if
  if(n_ialist >= 3) then
     fx_3 = pos(ia_list(3),1)*PAI2
     fy_3 = pos(ia_list(3),2)*PAI2
     fz_3 = pos(ia_list(3),3)*PAI2
  end if
  if(n_ialist >= 4) then
     fx_4 = pos(ia_list(4),1)*PAI2
     fy_4 = pos(ia_list(4),2)*PAI2
     fz_4 = pos(ia_list(4),3)*PAI2
  end if

  iend = iend_kngp
  if( iend_kngp > kgp ) iend = kgp
  if( ista_kngp <= iend ) then
     is = ista_kngp_adj - ista_kngp
     if(n_ialist == 1) then
!cdir parallel do private(i,ph_1,ip)
        do i = ista_kngp, iend  !for mp
           ph_1 = ngabc(i,1)*fx_1+ngabc(i,2)*fy_1+ngabc(i,3)*fz_1
           ip = i + is
           zfcos_x(ip,1) = dcos(ph_1)
           zfsin_x(ip,1) = dsin(ph_1)
        end do
     else if(n_ialist == 2) then
!cdir parallel do private(i,ph_1,ph_2,ip)
        do i = ista_kngp, iend  !for mp
           ph_1 = ngabc(i,1)*fx_1+ngabc(i,2)*fy_1+ngabc(i,3)*fz_1
           ph_2 = ngabc(i,1)*fx_2+ngabc(i,2)*fy_2+ngabc(i,3)*fz_2
           ip = i + is
           zfcos_x(ip,1) = dcos(ph_1)
           zfsin_x(ip,1) = dsin(ph_1)
           zfcos_x(ip,2) = dcos(ph_2)
           zfsin_x(ip,2) = dsin(ph_2)
        end do
     else if(n_ialist == 3) then
!cdir parallel do private(i,ph_1,ph_2,ph_3,ip)
        do i = ista_kngp, iend  !for mp
           ph_1 = ngabc(i,1)*fx_1+ngabc(i,2)*fy_1+ngabc(i,3)*fz_1
           ph_2 = ngabc(i,1)*fx_2+ngabc(i,2)*fy_2+ngabc(i,3)*fz_2
           ph_3 = ngabc(i,1)*fx_3+ngabc(i,2)*fy_3+ngabc(i,3)*fz_3
           ip = i + is
           zfcos_x(ip,1) = dcos(ph_1)
           zfsin_x(ip,1) = dsin(ph_1)
           zfcos_x(ip,2) = dcos(ph_2)
           zfsin_x(ip,2) = dsin(ph_2)
           zfcos_x(ip,3) = dcos(ph_3)
           zfsin_x(ip,3) = dsin(ph_3)
        end do
     else if(n_ialist >= 4) then
!cdir parallel do private(i,ph_1,ph_2,ph_3,ph_4,ip)
        do i = ista_kngp, iend  !for mp
           ph_1 = ngabc(i,1)*fx_1+ngabc(i,2)*fy_1+ngabc(i,3)*fz_1
           ph_2 = ngabc(i,1)*fx_2+ngabc(i,2)*fy_2+ngabc(i,3)*fz_2
           ph_3 = ngabc(i,1)*fx_3+ngabc(i,2)*fy_3+ngabc(i,3)*fz_3
           ph_4 = ngabc(i,1)*fx_4+ngabc(i,2)*fy_4+ngabc(i,3)*fz_4
           ip = i + is
           zfcos_x(ip,1) = dcos(ph_1)
           zfsin_x(ip,1) = dsin(ph_1)
           zfcos_x(ip,2) = dcos(ph_2)
           zfsin_x(ip,2) = dsin(ph_2)
           zfcos_x(ip,3) = dcos(ph_3)
           zfsin_x(ip,3) = dsin(ph_3)
           zfcos_x(ip,4) = dcos(ph_4)
           zfsin_x(ip,4) = dsin(ph_4)
        end do
     end if
     if(n_ialist > 4 ) then
        do ia = 5, n_ialist
           fx_1 = pos(ia_list(ia),1)*PAI2
           fy_1 = pos(ia_list(ia),2)*PAI2
           fz_1 = pos(ia_list(ia),3)*PAI2
!cdir parallel do private(i,ph_1,ip)
           do i = ista_kngp, iend   !MPI
              ph_1 = ngabc(i,1)*fx_1+ngabc(i,2)*fy_1+ngabc(i,3)*fz_1
              ip = i + is
              zfcos_x(ip,ia) = dcos(ph_1)
              zfsin_x(ip,ia) = dsin(ph_1)
           end do
        end do
     end if
  endif
!xocl end spread
end subroutine calc_phase_b

subroutine zf_list_s(n_min,n_max,matm,natm,f,ia,zfcos,zfsin)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)      :: n_min,n_max,matm,natm
  real(kind=DP),intent(in) :: f
  integer, intent(in)      :: ia
  real(DP),intent(out),dimension(n_min:n_max,matm+1:natm)::zfcos,zfsin

  integer :: i
  do i = n_min, n_max
     zfcos(i,ia) = dcos(i*f)
     zfsin(i,ia) = dsin(i*f)
  end do
end subroutine zf_list_s

subroutine setglist4(n_min1,n_max1,n_min2,n_max2,n_min3,n_max3 &
     &     ,nbase,ngabc,kgp,iiba, nglist)
  implicit none
  integer,intent(in) :: n_min1,n_max1,n_min2,n_max2,n_min3,n_max3
  integer,intent(in) :: kgp,iiba,nbase(*),ngabc(kgp,3)
  integer,intent(out):: nglist(n_min1:n_max1,n_min2:n_max2,n_min3:n_max3)

  integer :: i, nb, nb1,nb2,nb3

  nglist = -1

  do i = 1, iiba
     nb = nbase(i)
     nb1 = ngabc(nb,1)
     nb2 = ngabc(nb,2)
     nb3 = ngabc(nb,3)
     nglist(nb1,nb2,nb3) = i
  enddo
end subroutine setglist4


subroutine crngabc4(n_min1,n_max1,n_min2,n_max2,n_min3,n_max3 &
     &     ,nglist,kg1,nngabc,newp)
  implicit none
  integer, intent(in) :: n_min1,n_max1,n_min2,n_max2,n_min3,n_max3 &
       &, nglist(n_min1:n_max1,n_min2:n_max2,n_min3:n_max3), kg1
  integer, intent(out) :: nngabc(kg1,3),newp(kg1)
  
  integer :: ngcount, jcount,kcount,jp,kp,ip

  ngcount = 0
  do jcount = n_min2, n_max2
     jp = jcount
     do kcount = n_min3, n_max3
        kp = kcount
        do ip = n_min1, n_max1
           if(nglist(ip,jp,kp) /= -1) then
              ngcount = ngcount + 1
              nngabc(ngcount,1) = ip
              nngabc(ngcount,2) = jp
              nngabc(ngcount,3) = kp
              newp(ngcount) = nglist(ip,jp,kp)
           endif
           jp = jp + 1
           if(jp.eq.n_max2+1) jp = n_min2
           kp = kp + 1
           if(kp.eq.n_max3+1) kp = n_min3
        enddo
     enddo
  enddo
end subroutine crngabc4

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 577 $)
!
!  SUBROUINE: Stress
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Stress
!$$#ifndef PARA3D
! $Id: Stress.F90 577 2017-12-15 05:26:08Z jkoga $
  use m_Stress,           only : hsrd &
       &                       , m_Stress_alloc          , m_Stress_dealloc &
       &                       , m_Stress_alloc_grinv_g  , m_Stress_dealloc_grinv_g &
       &                       , m_Stress_ke             , m_Stress_hsr_diff &
       &                       , m_Stress_lclchg_diff    , m_Stress_xc &
       &                       , m_Stress_loc            , m_Stress_h &
       &                       , m_Stress_nl             , m_Stress_ew &
       &                       , m_Stress_or             , m_Stress_sum &
       &                       , m_Stress_check_g12
  use m_XC_Potential,     only : m_XC_alloc_s_gga,m_XC_dealloc_s_gga ,m_XC_cal_potential
  use m_Charge_Density,   only : chgsoft, chgq_l, hsr
  use m_Kpoints,          only : kv3, vkxyz
  use m_Files,            only : nfout
  use m_Control_Parameters,only: istress
  use m_Const_Parameters, only : Valence_plus_PC_Charge,STRESS_, CRDTYP

! ================================ Added by K. Tagami ============ p1100
  use m_Stress,           only : m_Stress_Hub
! ================================================================ p1100

! ================= added by K. Tagami ==================== 11.0
  use m_Const_Parameters,       only : ON
  use m_Control_Parameters,    only : sw_hubbard, noncol
  use m_Stress,                only : m_Stress_ke_noncl, &
       &                              m_Stress_hsr_diff_noncl, &
       &                              m_Stress_lclchg_diff_noncl, &
       &                              m_Stress_xc_noncl, &
       &                              m_Stress_nl_nonclA, &
       &                              m_Stress_or_nonclA, &
       &                              m_Stress_nl_nonclB, &
       &                              m_Stress_or_nonclB, &
       &                              m_Stress_Hub_nonclA, &
       &                              m_Stress_Hub_nonclB
! ========================================================= 11.0

! =================================== KT_add ============== 13.0B
  use m_Control_Parameters,    only : sw_vdw_correction, xctype
#ifndef DISABLE_VDWDF
  use m_Stress,                only : m_Stress_vdw,m_Stress_vdwdf
#else
  use m_Stress,                only : m_Stress_vdw
#endif
 
! ========================================================= 13.0B

  implicit none

  if (istress == 0) return

  if ( noncol ) then
     call case_noncollinear
  else
     call case_collinear
  endif


! ============================ added by K. Tagami ============= 11.0
contains

  subroutine case_collinear
    call m_Stress_alloc()
    call m_XC_alloc_s_gga
    call m_Stress_ke(nfout,kv3,CRDTYP,vkxyz)
    call m_Stress_hsr_diff(nfout,kv3)
!!$  call m_M_Stress_xcfft_diff(nfout)

    call m_XC_cal_potential(nfout,Valence_plus_PC_Charge,chgq_l,STRESS_ &
         &   ,chgsoft,hsr,hsrd)
    call m_Stress_check_g12(nfout)
    call m_Stress_alloc_grinv_g()
    call m_Stress_lclchg_diff(nfout)
    call m_Stress_xc(nfout)
    call m_Stress_loc(nfout)
    call m_Stress_h(nfout)
    call m_Stress_dealloc_grinv_g()
    call m_Stress_nl(nfout)
    call m_Stress_ew(nfout)
    call m_Stress_or(nfout)

! =============================== Added by K. Tagami ============ p1100
    if ( sw_hubbard == ON ) call m_Stress_Hub(nfout)
! =============================================================== p1100

! =================================== KT_add ============== 13.0B
    if ( sw_vdw_correction == ON ) call m_Stress_vdw(nfout)
! ========================================================= 13.0B

#ifndef DISABLE_VDWDF
    if ( xctype == "vdwdf" ) call m_Stress_vdwdf(nfout)
#endif

    call m_Stress_sum(nfout)
    call m_Stress_dealloc()
    call m_XC_dealloc_s_gga()

  end subroutine case_collinear

  subroutine case_noncollinear
    call m_Stress_alloc()
    call m_XC_alloc_s_gga

    call m_Stress_ke_noncl( nfout, kv3, CRDTYP, vkxyz )
    call m_Stress_hsr_diff_noncl( nfout, kv3 )

    call m_XC_cal_potential( nfout, Valence_plus_PC_Charge, chgq_l, STRESS_,  &
         &                   chgsoft, hsr, hsrd )
    call m_Stress_check_g12(nfout)

    call m_Stress_alloc_grinv_g()

    call m_Stress_lclchg_diff_noncl(nfout)
    call m_Stress_xc_noncl(nfout)

    call m_Stress_loc(nfout)
    call m_Stress_h(nfout)

    call m_Stress_dealloc_grinv_g()

!!    call m_Stress_nl_nonclA(nfout)
    call m_Stress_nl_nonclB(nfout)

    call m_Stress_ew(nfout)

!!    call m_Stress_or_nonclA(nfout)
    call m_Stress_or_nonclB(nfout)

    if ( sw_hubbard == ON ) call m_Stress_Hub_nonclB(nfout)

! =================================== KT_add ============== 13.0B
    if ( sw_vdw_correction == ON ) call m_Stress_vdw(nfout)
! ========================================================= 13.0B

    call m_Stress_sum(nfout)
    call m_Stress_dealloc()
    call m_XC_dealloc_s_gga()

  end subroutine case_noncollinear

!$$#endif
end subroutine Stress

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 590 $)
!
!  MODULE: m_UnitCell
!
!  AUTHOR(S): J. KOGA @ asms   
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! *************************************************************
! 
! =========== Contributions ===================================
!
! Through the courtesy of contributors, the following functions are added.
!
! Company:  ASMS Co.,Ltd.  
! Functions:  [Identifier: 13.0B]  
!                 cell optimizations with angles fixed is available
!                 ( external_stress is included in the stress term )
!
! =============================================================

module m_UnitCell
! $Id: m_UnitCell.f90 590 2018-11-06 04:20:58Z jkoga $

use m_Const_Parameters, only : DP,QUENCHED_MD,STEEPEST_DESCENT,BFGS,OFF,PAI,CONST_kB, &
                             & PT_CONTROL,P_CONTROL,VELOCITY_SCALING
use m_Stress, only : m_Stress_get_stressmx,m_Stress_get_curr_stress,m_Stress_set_stressmx
use m_IterationNumbers, only : iteration_unit_cell,iteration_ionic
use m_Control_Parameters, only : nhistory_stress,printable,delta_stress,lattice_optimization_method &
                                ,max_stress,ipri,eigenvalue_threshold,sw_uniform,ipriunitcell,external_stress &
                                ,dtio,imdalg
use m_Files, only : nfout,nfdynm, nflatconst, nfmetric, m_Files_flush_pcontrol_files
use m_Ionic_System, only : altv,pos,natm,cps,m_baro,target_pressure,cpd_l,qmass,tkb,ityp,amion &
                         & ,t_ctrl_method,scale_velocity, mobility_cell, control_pressure
use m_Crystal_Structure, only : m_CS_altv_2_rltv,p2bmat,a,b,c,ca,cb,cc,il,kt_iuctype,rltv,univol,rvol, b2pmat
use m_Parallelization, only : mype,npes,mpi_comm_group

! ====================================== KT_add ============= 13.0B &13.1AS
use m_Control_Parameters,  only : sw_fix_lattice_angles, fix_angle_alpha, &
     &                            fix_angle_beta, fix_angle_gamma, &
     &                            sw_fix_lattice_lengths, fix_length_a, &
     &                            fix_length_b, fix_length_c, &
     &                            sw_neglect_stress_offdiagonal
  use m_Const_Parameters,   only : ON
! =========================================================== 13.0B &13.1AS

use m_Total_Energy, only : etotal

implicit none
include 'mpif.h'

real(kind=DP), private, dimension(3,3) :: stress_forc
real(kind=DP), private, dimension(3,3) :: stress_forc_old
real(kind=DP), private, dimension(3,3) :: stress_velocity
real(kind=DP), private, allocatable, dimension(:,:,:) :: cellvec_history
real(kind=DP), private, allocatable, dimension(:,:,:) :: stress_forc_history
real(kind=DP), private, allocatable, dimension(:) :: volume_history
real(kind=DP), private, allocatable, dimension(:) :: volume_forc_history
logical,private :: first_call = .true.
logical,private :: H0_has_been_set = .false.
character(len('unit_cell_optimization')),private,parameter :: tag_unit_cell_optimization='unit_cell_optimization'
character(len("lattice_vector")),private,parameter :: tag_lattice_vector = "lattice_vector"
character(len("pressure_control")), private, parameter :: tag_pressure_control='pressure_control'
real(kind=DP) :: maxoptforc_old=1000.d0
real(kind=DP) :: univolo

! for NPT and NPH simulation based on the metric tensor
real(kind=DP), allocatable, dimension(:,:) :: p_l
real(kind=DP), allocatable, dimension(:,:) :: p_l_lattice
real(kind=DP) :: target_temperature
real(kind=DP) :: s_thermo,p_thermo,m_thermo
real(kind=DP), dimension(3,3) :: altv_inv,metric,metric_inv,dudmetric
real(kind=DP), dimension(3,3) :: p_baro, p_baro_tmp
real(kind=DP), dimension(3,3) :: factor
real(kind=DP) :: gfree
real(kind=DP), allocatable, dimension(:,:) :: forc_l_lattice
real(kind=DP), allocatable, dimension(:,:) :: p_l_metric

integer :: nmax = 1000
real(kind=DP) :: eps = 1.d-8
real(kind=DP) :: H0

contains

function get_volume(avec,bvec,cvec) result(vol)
  real(kind=DP), dimension(3), intent(in) :: avec,bvec,cvec
  real(kind=DP), dimension(3) :: tmpvec
  real(kind=DP) :: vol
  tmpvec(1) = bvec(2)*cvec(3)-bvec(3)*cvec(2)
  tmpvec(2) = bvec(3)*cvec(1)-bvec(1)*cvec(3)
  tmpvec(3) = bvec(1)*cvec(2)-bvec(2)*cvec(1)
  vol = dot_product(avec,tmpvec)
end function get_volume

logical function m_UC_converged()
  integer :: i,j
  real(kind=DP) :: maxs,astress
  real(kind=DP), dimension(3,3) :: stress_tensor, stress_work
  real(kind=DP), dimension(3,3) :: altv_brav

  if(imdalg == PT_CONTROL .or. imdalg == P_CONTROL)then
    m_UC_converged = .false.
    return;
  endif
  stress_tensor = m_Stress_get_curr_stress()
  maxs = 0.d0

  if(sw_uniform==OFF)then
    do i=1,3
      do j=1,3
! ============ KT mod ============================= 13.0B
!         astress = abs(stress_tensor(i,j)-external_stress(i,j))
         astress = abs(stress_tensor(i,j))
! ================================================= 13.0B
         if(astress>maxs) maxs = astress
      enddo
    enddo
  else
! ============ KT mod ============================= 13.0B
!       maxs = maxs+abs(stress_tensor(i,i)-external_stress(i,i))
!       maxs = maxs+abs(stress_tensor(i,i))
    maxs = abs(stress_tensor(1,1)+stress_tensor(2,2)+stress_tensor(3,3))/3.0d0
! ================================================= 13.0B
  endif

! === KT_add === 13.1AS
  if ( sw_neglect_stress_offdiagonal == ON ) then
     stress_work = 0.0d0;
     stress_work(1,1) = stress_tensor(1,1)
     stress_work(2,2) = stress_tensor(2,2)
     stress_work(3,3) = stress_tensor(3,3)

     maxs = 0.0d0
     do i=1,3
        astress = sqrt( stress_work(i,1)**2 +stress_work(i,2)**2 +stress_work(i,3)**2 )
        if(astress>maxs) maxs = astress
     enddo
  endif

  if ( sw_fix_lattice_angles==ON .or. sw_fix_lattice_lengths == ON ) then
     call get_latvec_from_prim_to_brav( p2bmat, altv, altv_brav )

     stress_work = projected_stress_along_latvecs( altv_brav, stress_tensor )
     maxs = 0.0d0

     if ( sw_fix_lattice_angles == ON ) then
        stress_work = constrain_on_force_type1( altv_brav, stress_work )
     endif
     if ( sw_fix_lattice_lengths==ON ) then
        stress_work = constrain_on_force_type2( altv_brav, stress_work )
     endif
     
     do i=1,3
        astress = sqrt( stress_work(i,1)**2 +stress_work(i,2)**2 +stress_work(i,3)**2 )
        if(astress>maxs) maxs = astress
     enddo
  endif
! ========= 13.1AS

  m_UC_converged = max_stress>maxs
  if(printable) then
    write(nfout,'(a)')         '!**'
    write(nfout,'(a)')         '!** checking convergence of the stress tensor ...'
    write(nfout,'(a,2f20.10)') '!** max(stress-external_stress), tolerance : ',maxs,max_stress
    write(nfout,'(a,l2)')      '!** convergence : ',m_UC_converged
    write(nfout,'(a)')         '!**'
  endif
end function m_UC_converged

subroutine m_UC_init()
   stress_forc = 0.0d0
   stress_forc_old = 0.0d0
   stress_velocity = 0.0d0
   allocate(cellvec_history(3,3,nhistory_stress));cellvec_history=0.d0
   allocate(stress_forc_history(3,3,nhistory_stress));stress_forc_history=0.0d0
   allocate(volume_history(nhistory_stress));volume_history=0.d0
   allocate(volume_forc_history(nhistory_stress));volume_forc_history=0.d0
end subroutine m_UC_init

subroutine m_UC_wd_cntn_data(nfcntn)
   integer,intent(in) :: nfcntn
   integer :: i,nbox
   if(iteration_unit_cell-1<=nhistory_stress)then
      nbox = iteration_unit_cell-1
   else
      nbox = nhistory_stress
   endif
   if(first_call.or.nbox==0) return
   if(mype==0)then
      write(nfcntn,*) tag_unit_cell_optimization
      write(nfcntn,*) 'history of the unit cell'
      do i=1,nbox
         if(sw_uniform==OFF)then
            write(nfcntn,'(3f25.15)') cellvec_history(1,1,i),cellvec_history(1,2,i),cellvec_history(1,3,i)
            write(nfcntn,'(3f25.15)') cellvec_history(2,1,i),cellvec_history(2,2,i),cellvec_history(2,3,i)
            write(nfcntn,'(3f25.15)') cellvec_history(3,1,i),cellvec_history(3,2,i),cellvec_history(3,3,i)
         else
            write(nfcntn,'(f25.15)') volume_history(i)
         endif
      enddo
      write(nfcntn,*) 'history of the force acting on the unit cell'
      do i=1,nbox
         if(sw_uniform==OFF)then
            write(nfcntn,'(3f25.15)') stress_forc_history(1,1,i),stress_forc_history(1,2,i),stress_forc_history(1,3,i)
            write(nfcntn,'(3f25.15)') stress_forc_history(2,1,i),stress_forc_history(2,2,i),stress_forc_history(2,3,i)
            write(nfcntn,'(3f25.15)') stress_forc_history(3,1,i),stress_forc_history(3,2,i),stress_forc_history(3,3,i)
         else
            write(nfcntn,'(f25.15)') volume_forc_history(i)
         endif
      enddo
      write(nfcntn,*) 'max. stress'
      write(nfcntn,'(f25.15)') m_Stress_get_stressmx()
      write(nfcntn,*) 'maxoptforc'
      write(nfcntn,'(f25.15)') maxoptforc_old
   endif
end subroutine m_UC_wd_cntn_data

subroutine m_UC_rd_cntn_data(nfcntn)
   integer, intent(in) :: nfcntn
   integer :: i,nbox,ierr
   logical             :: tag_is_found, EOF_reach
   integer,      parameter   :: len_str = 132
   character(len=len_str)       :: str
   real(kind=DP) :: strmx
   if(first_call) then
      call m_UC_init()
      first_call = .false.
   endif
   first_call = .false.
   if(mype==0)then
      if(iteration_unit_cell-1<=nhistory_stress)then
         nbox = iteration_unit_cell-1
      else
         nbox = nhistory_stress
      endif
      call rewind_to_tag0(nfcntn,len(tag_unit_cell_optimization), &
            &  tag_unit_cell_optimization & 
            &, EOF_reach, tag_is_found, str,len_str)
      if(tag_is_found)then
         read(nfcntn,*) 
         do i=1,nbox
            if(sw_uniform==OFF)then
               read(nfcntn,*) cellvec_history(1,1,i),cellvec_history(1,2,i),cellvec_history(1,3,i)
               read(nfcntn,*) cellvec_history(2,1,i),cellvec_history(2,2,i),cellvec_history(2,3,i)
               read(nfcntn,*) cellvec_history(3,1,i),cellvec_history(3,2,i),cellvec_history(3,3,i)
            else
               read(nfcntn,*) volume_history(i)
            endif
         enddo
         read(nfcntn,*)
         do i=1,nbox
            if(sw_uniform==OFF)then
               read(nfcntn,*) stress_forc_history(1,1,i),stress_forc_history(1,2,i),stress_forc_history(1,3,i)
               read(nfcntn,*) stress_forc_history(2,1,i),stress_forc_history(2,2,i),stress_forc_history(2,3,i)
               read(nfcntn,*) stress_forc_history(3,1,i),stress_forc_history(3,2,i),stress_forc_history(3,3,i)
            else
               read(nfcntn,*) volume_forc_history(i)
            endif
         enddo
         read(nfcntn,*)
         read(nfcntn,*) strmx
         read(nfcntn,*)
         read(nfcntn,*) maxoptforc_old
      endif
      call rewind_to_tag0(nfcntn,len(tag_lattice_vector),tag_lattice_vector &
           &,  EOF_reach, tag_is_found, str, len_str)
      if(tag_is_found)then
         read(nfcntn,*) altv(1,1),altv(2,1),altv(3,1)
         read(nfcntn,*) altv(1,2),altv(2,2),altv(3,2)
         read(nfcntn,*) altv(1,3),altv(2,3),altv(3,3)
      endif
   endif
   if(npes>1)then
      call mpi_bcast(tag_is_found,1,mpi_logical,0,mpi_comm_group,ierr)
      if(tag_is_found)then
         if(sw_uniform==OFF)then
            call mpi_bcast(cellvec_history,9*nhistory_stress,mpi_double_precision,0,mpi_comm_group,ierr)
            call mpi_bcast(stress_forc_history,9*nhistory_stress,mpi_double_precision,0,mpi_comm_group,ierr)
         else
            call mpi_bcast(volume_history,nhistory_stress,mpi_double_precision,0,mpi_comm_group,ierr)
            call mpi_bcast(volume_forc_history,nhistory_stress,mpi_double_precision,0,mpi_comm_group,ierr)
         endif
         call mpi_bcast(strmx,1,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(maxoptforc_old,1,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(altv,9,mpi_double_precision,0,mpi_comm_group,ierr)
      endif
   endif
   call m_CS_altv_2_rltv()
   call m_Stress_set_stressmx(strmx)
end subroutine m_UC_rd_cntn_data

function get_averaged_cell_forc(stress_tensor) result(res)
   real(kind=DP), dimension(:,:), intent(in) :: stress_tensor
   real(kind=DP) :: stav,exstav
   real(kind=DP) :: res
   stav = stress_tensor(1,1)+stress_tensor(2,2)+stress_tensor(3,3)
! ================ KT_mod ================= 13.0B
!   exstav = external_stress(1,1)+external_stress(2,2)+external_stress(3,3)
!   res = (stav-exstav)/3.0d0
!
   res = stav /3.0d0
! ========================================= 13.0B
end function get_averaged_cell_forc

subroutine m_UC_doit()
   integer :: i
   real(kind=DP), dimension(3,3) :: stress_tensor,stress_tensor_p
   real(kind=DP), dimension(3,3) :: stress_tensor_tmp
   real(kind=DP), dimension(3,3) :: work
   real(kind=DP), dimension(3,3) :: altv_brav
   real(kind=DP), dimension(3) :: avec,bvec,cvec
   real(kind=DP) :: vol,dv,factor,mstress
   if(first_call)then
      call m_UC_init()
      first_call = .false.
   endif
   if(printable) write(nfout,'(a)')      ' -- lattice optimization --'
   stress_tensor = m_Stress_get_curr_stress()
   stress_tensor_p = 0.0d0

   stress_forc = get_force( altv, stress_tensor )

! ================================= KT_add ================== 13.0B &13.1AS
   if ( sw_neglect_stress_offdiagonal == ON ) then
      stress_tensor_tmp = 0.0d0
      stress_tensor_tmp(1,1) = stress_tensor(1,1)
      stress_tensor_tmp(2,2) = stress_tensor(2,2)
      stress_tensor_tmp(3,3) = stress_tensor(3,3)

      stress_forc = get_force( altv, stress_tensor_tmp )
   endif
   if ( sw_fix_lattice_angles==ON .or. sw_fix_lattice_lengths == ON ) then
      call get_latvec_from_prim_to_brav( p2bmat, altv, altv_brav )
      stress_forc = get_force( altv_brav, stress_tensor )

     if ( sw_fix_lattice_angles==ON ) then
        stress_forc = constrain_on_force_type1( altv_brav, stress_forc )
     endif
     if ( sw_fix_lattice_lengths==ON ) then
        stress_forc = constrain_on_force_type2( altv_brav, stress_forc )
     endif
  endif
! =========================================================== 13.0B &13.1AS

   mstress = m_Stress_get_stressmx()
   if(printable)then
      write(nfout,'(a)')
      write(nfout,'(a)')         ' -- current lattice --'
      write(nfout,'(a,3f20.10)') '    a_vector ',altv(1,1),altv(2,1),altv(3,1)
      write(nfout,'(a,3f20.10)') '    b_vector ',altv(1,2),altv(2,2),altv(3,2)
      write(nfout,'(a,3f20.10)') '    c_vector ',altv(1,3),altv(2,3),altv(3,3)
      write(nfout,'(a)')

      write(nfout,'(a)')         ' -- current volume --'
      write(nfout,'(a,f22.12)')  '    univol ', univol
      write(nfout,'(a)')

      write(nfout,'(a,i8,a)')    ' -- stress tensor obtained from iteration_unit_cell ',iteration_unit_cell-1,' --'
      do i=1,3
         write(nfout,'(3f20.10)') stress_tensor(i,1),stress_tensor(i,2),stress_tensor(i,3)
      enddo
      write(nfout,'(a)')         ' -- current cps and pos --'
      do i=1,natm
         write(nfout,'(6f20.10)') cps(i,1),cps(i,2),cps(i,3),pos(i,1),pos(i,2),pos(i,3)
      enddo
      write(nfout,'(a,f20.10,a)') ' -- max. stress : ',mstress,' --'
      write(nfout,'(a)')
      write(nfout,'(a)')          ' -- force acting on the unit cell --'
      write(nfout,'(a,3f20.10)')  '    a_vector ',stress_forc(1,1),stress_forc(1,2),stress_forc(1,3)
      write(nfout,'(a,3f20.10)')  '    b_vector ',stress_forc(2,1),stress_forc(2,2),stress_forc(2,3)
      write(nfout,'(a,3f20.10)')  '    c_vector ',stress_forc(3,1),stress_forc(3,2),stress_forc(3,3)
      if(lattice_optimization_method==QUENCHED_MD)then
         write(nfout,'(a)')          ' -- velocity of the unit cell --'
         write(nfout,'(a,3f20.10)')  '    a_vector ',stress_velocity(1,1),stress_velocity(1,2),stress_velocity(1,3)
         write(nfout,'(a,3f20.10)')  '    b_vector ',stress_velocity(2,1),stress_velocity(2,2),stress_velocity(2,3)
         write(nfout,'(a,3f20.10)')  '    c_vector ',stress_velocity(3,1),stress_velocity(3,2),stress_velocity(3,3)
      endif
   endif

   if ( sw_fix_lattice_angles==ON .or. sw_fix_lattice_lengths == ON ) then
      altv = altv_brav
   endif

   if(sw_uniform==OFF)then
      call store_cell_and_stress()
      if(lattice_optimization_method==QUENCHED_MD .or. &
      &  lattice_optimization_method==STEEPEST_DESCENT) then
         call update_lattice()
         call update_velocities()
      else if (lattice_optimization_method==BFGS) then
         call update_lattice_by_bfgs()
      endif
   else
      avec=altv(:,1)
      bvec=altv(:,2)
      cvec=altv(:,3)
      vol = get_volume(avec,bvec,cvec)
      dv = get_averaged_cell_forc(stress_tensor)
      call store_volume(vol,dv)
      call update_volume_by_bfgs()
   endif

   if ( sw_fix_lattice_angles==ON .or. sw_fix_lattice_lengths == ON ) then
      altv_brav = altv
      call get_latvec_from_brav_to_prim( b2pmat, altv_brav, altv )
   endif

   stress_forc_old = stress_forc
   univolo = univol
   call altv_2_rltv(altv,rltv,univol,rvol)  ! in b_CS
   call change_of_coordinate_system(altv,pos,natm,natm,cps) !-(b_I.S.) pos -> cps
   call primitive2bravais(nfout,p2bmat,altv(:,1),altv(:,2),altv(:,3),a,b,c,ca,cb,cc,il) ! in b_CS

   if(printable)then
      write(nfout,'(a)')         ' -- new lattice --'
      write(nfout,'(a,3f20.10)') '    a_vector ',altv(1,1),altv(2,1),altv(3,1)
      write(nfout,'(a,3f20.10)') '    b_vector ',altv(1,2),altv(2,2),altv(3,2)
      write(nfout,'(a,3f20.10)') '    c_vector ',altv(1,3),altv(2,3),altv(3,3)
      write(nfout,'(a)')
      write(nfout,'(a)')         ' -- new volume --'
      write(nfout,'(a,f22.12)')  '    univol ', univol
      write(nfout,'(a)')
      write(nfout,'(a)')         ' -- new cps and pos --'
      do i=1,natm
         write(nfout,'(6f20.10)') cps(i,1),cps(i,2),cps(i,3),pos(i,1),pos(i,2),pos(i,3)
      enddo
!
      if ( kt_iuctype == 0 .and. ipriunitcell >=2 ) then   ! bravias
         write(nfout,'(a)')
         write(nfout,'(a)') ' --- new lattice (bravais) ---- '
         write(nfout,'(3(a,f18.12))')  '  a     = ', a, '  b    = ', b, '  c     = ', c
         write(nfout,'(3(a,f18.12))')  '  alpha = ', acos(ca)/PAI*180.0d0, &
              &                           '  beta = ', acos(cb)/PAI*180.0d0, &
              &                           '  gamma = ', acos(cc)/PAI*180.0d0
         write(nfout,'(a)')

         work(1,:) = altv(:,1);    work(2,:) = altv(:,2);    work(3,:) = altv(:,3)
         work = matmul( p2bmat, work )
         write(nfout,'(a,3f20.10)') '    avec = ',work(1,1:3)
         write(nfout,'(a,3f20.10)') '    bvec = ',work(2,1:3)
         write(nfout,'(a,3f20.10)') '    cvec = ',work(3,1:3)
         write(nfout,'(a)') ' ----------------------------- '
      endif

   endif

end subroutine m_UC_doit

function m_UC_get_univol_old() result(res)
   real(kind=DP) :: res
   res = univolo
end function m_UC_get_univol_old

subroutine get_bfgs_force(nfree,nbox,coord,forc,forc_bfgs,forc_bfgs_max)
   integer, intent(in) :: nfree
   real(kind=DP),intent(in),dimension(nfree,nbox) :: coord,forc
   real(kind=DP),intent(out),dimension(nfree) :: forc_bfgs
   real(kind=DP),intent(out) :: forc_bfgs_max
   integer :: nbox,i,j,k,info
   real(kind=DP),dimension(nfree) :: xdelta,gdelta,gdotinvh
   real(kind=DP),dimension(nfree,nfree) :: ihess
   real(kind=DP),dimension(nfree*(nfree+1)/2) :: amat
   real(kind=DP),dimension(nfree) :: eigv
   real(kind=DP),dimension(nfree,nfree) :: eigvec
   real(kind=DP),dimension(nfree*3) :: workar
   real(kind=DP) :: xgi,gihg
   logical :: corrected_eig

   ihess=0.0d0
   do i=1,nfree
      ihess(i,i)=1.0d0
   enddo
   do i=2,nbox 
      do j=1,nfree
         xdelta(j) = coord(j,i) - coord(j,i-1)
         gdelta(j) = -forc(j,i) + forc(j,i-1)
      enddo
      xgi = 1.0d0/dot_product(xdelta,gdelta)
      if(xgi<0)then
         if(printable)then
            write(nfout,'(a,i3)') '!** WARNING dx dot dg is negative for history ',i
            write(nfout,'(a)') 'skipping this update.'
         endif
         cycle
      endif
      do j=1,nfree
         gdotinvh(j)=dot_product(ihess(j,:),gdelta(:))
      enddo
      gihg = dot_product(gdelta,gdotinvh)
      do j=1,nfree
         do k=1,nfree
            ihess(j,k) = ihess(j,k)+xgi*xgi*(1.0d0/xgi+gihg)*xdelta(j)*xdelta(k) &
  &                    - (gdotinvh(j)*xdelta(k)+gdotinvh(k)*xdelta(j))*xgi
         enddo
      enddo
   enddo

!  correct bad eigenvalues present in the Hessian
!  we will always do this, since the matrix size is fixed & small
   corrected_eig=.false.
   amat=0.0d0;eigv=0.0d0;eigvec=0.0d0;workar=0.0d0
   do i=1,nfree
      do j=i,nfree
         amat(i + (j-1)*j/2) = ihess(i,j)
      enddo
   enddo
   call dspev('V','U',nfree,amat,eigv,eigvec,nfree,workar,info)
   if(printable .and. ipriunitcell>=2) write(nfout,'(a)') '--- eigenvalues for the approximate Hessian ---'
   do i=1,nfree
      if(printable.and.ipriunitcell>=2) write(nfout,'(i8,f20.10)') i,1.0d0/eigv(i)
      if (1.0d0/eigv(i)<eigenvalue_threshold)then
         eigv(i) = 1.0d0/eigenvalue_threshold
         if(printable.and.ipriunitcell>=2) write(nfout,'(a,i8,a,f20.10)') &
         &  'corrected the eigenvalue for the ',i,'-th element to : ',1.0d0/eigv(i)
         corrected_eig=.true.
      endif
   enddo
   if(corrected_eig)then
      ihess=0.d0
      do i=1,nfree
         do j=1,nfree
            do k=1,nfree
               ihess(i,j) = ihess(i,j)+eigvec(i,k)*eigvec(j,k)*eigv(k)
            enddo
         enddo
      enddo
   endif

   forc_bfgs=0.0d0
   forc_bfgs_max=0.0d0
   do i=1,nfree
      do j=1,nfree
         forc_bfgs(i) = forc_bfgs(i)+ihess(i,j)*forc(j,nbox)
      enddo
      if(abs(forc_bfgs(i))>forc_bfgs_max) forc_bfgs_max = abs(forc_bfgs(i))
   enddo

end subroutine get_bfgs_force

subroutine update_volume_by_bfgs()
   integer :: nbox 
   real(kind=DP),dimension(1) :: forc_bfgs
   real(kind=DP) :: forc_bfgs_max,factor
   if(iteration_unit_cell-1<=nhistory_stress)then
      nbox = iteration_unit_cell-1
   else
      nbox = nhistory_stress
   endif
   call get_bfgs_force(1,nbox,volume_history,volume_forc_history,forc_bfgs,forc_bfgs_max)
   if(printable) write(nfout,*) 'max. bfgs force : ',forc_bfgs_max
   if(maxoptforc_old*10<forc_bfgs_max)then
      if (printable) write(nfout,'(a)') &
      & 'the estimated force acting on the cell seems to be very large; &
      & update will be done by the steepest-descent method'
      factor = (1+volume_forc_history(nbox)*delta_stress)**(1.d0/3.d0)
   else
      factor = (1+forc_bfgs(1))**(1.d0/3.d0)
   endif
   altv(:,:) = altv(:,:)*factor
   maxoptforc_old = forc_bfgs_max
end subroutine update_volume_by_bfgs

subroutine update_lattice_by_bfgs()
   integer :: nbox,i,j,k,icount
   real(kind=DP),dimension(3,3) :: tmpforc
   real(kind=DP),allocatable,dimension(:,:) :: coord,forc
   real(kind=DP),dimension(9) :: forc_bfgs
   real(kind=DP) :: forc_bfgs_max
   if(iteration_unit_cell-1<=nhistory_stress)then
      nbox = iteration_unit_cell-1
   else
      nbox = nhistory_stress
   endif
   allocate(coord(9,nbox))
   allocate(forc(9,nbox))
   do i=1,nbox
      icount=0
      do j=1,3
         do k=1,3
            icount = icount + 1
            coord(icount,i) = cellvec_history(j,k,i)
            forc(icount,i)  = stress_forc_history(k,j,i)
         enddo
      enddo
   enddo

   call get_bfgs_force(9,nbox,coord,forc,forc_bfgs,forc_bfgs_max)

   tmpforc=0.0d0
   icount=0
   do i=1,3
      do j=1,3
         icount=icount+1
         tmpforc(j,i) = forc_bfgs(icount)
      enddo
   enddo
   if(printable)then
      write(nfout,'(a)') ' -- BFGS force acting on the unit cell --'
      write(nfout,'(a,3f20.10)')  '    a_vector ',tmpforc(1,1),tmpforc(1,2),tmpforc(1,3)
      write(nfout,'(a,3f20.10)')  '    b_vector ',tmpforc(2,1),tmpforc(2,2),tmpforc(2,3)
      write(nfout,'(a,3f20.10)')  '    c_vector ',tmpforc(3,1),tmpforc(3,2),tmpforc(3,3)
      write(nfout,'(a,f20.10)')   '    max: ',forc_bfgs_max
   endif
   if(maxoptforc_old*10<forc_bfgs_max)then
      if (printable) write(nfout,'(a)') &
      & 'the estimated force acting on the cell seems to be very large; &
      & update will be done by the steepest-descent method'
      do i=1,3
         do j=1,3
            altv(i,j) = altv(i,j) + stress_forc_history(j,i,nbox)*delta_stress
         enddo
      enddo
   else
      do i=1,3
         do j=1,3
            altv(i,j) = altv(i,j) + tmpforc(j,i)
         enddo
      enddo
   endif
   maxoptforc_old = forc_bfgs_max
   deallocate(coord)
   deallocate(forc)
end subroutine update_lattice_by_bfgs

subroutine update_velocities()
   integer :: i,j
   if(lattice_optimization_method==QUENCHED_MD)then
      stress_velocity(:,:) = stress_velocity(:,:) + 0.5*delta_stress * (stress_forc(:,:) + stress_forc_old(:,:))
      do i=1,3
         do j=1,3
            if(stress_velocity(j,i)*stress_forc(j,i)<0) then
               stress_velocity(j,i) = 0.0d0 ! quench
               if(printable) write(nfout,'(a,2i2)') 'quenched stress component : ',j,i
            endif
         enddo
      enddo
   endif
end subroutine update_velocities

subroutine store_volume(vol,dv)
   real(kind=DP),intent(in) :: vol
   real(kind=DP),intent(in) :: dv
   integer :: i
   if(iteration_unit_cell-1<=nhistory_stress)then
      volume_history(iteration_unit_cell-1) = vol
      volume_forc_history(iteration_unit_cell-1) = dv
   else
      do i=2,nhistory_stress
         volume_history(i-1) = volume_history(i)
         volume_forc_history(i-1) = volume_forc_history(i)
      enddo
      volume_history(nhistory_stress) = vol
      volume_forc_history(nhistory_stress) = dv
   endif
end subroutine store_volume

subroutine store_cell_and_stress()
   integer :: ihist,i,nn
   if(iteration_unit_cell-1<=nhistory_stress)then
      cellvec_history(:,:,iteration_unit_cell-1) = altv(:,:)
      stress_forc_history(:,:,iteration_unit_cell-1) = stress_forc(:,:)
      nn = iteration_unit_cell-1
   else
      do i=2,nhistory_stress
         cellvec_history(:,:,i-1) = cellvec_history(:,:,i)
         stress_forc_history(:,:,i-1) = stress_forc_history(:,:,i)
      enddo
      cellvec_history(:,:,nhistory_stress) = altv(:,:)
      stress_forc_history(:,:,nhistory_stress) = stress_forc(:,:)
      nn = nhistory_stress
   endif
   if(printable.and.ipriunitcell>=2) then
      write(nfout,'(a)') 'cellvec history'
      do i=1,nn
         write(nfout,'(a,i5)') 'step no ',i
         write(nfout,'(a,3f20.10)') 'avec ',cellvec_history(1,1,i),cellvec_history(2,1,i),cellvec_history(3,1,i)
         write(nfout,'(a,3f20.10)') 'bvec ',cellvec_history(1,2,i),cellvec_history(2,2,i),cellvec_history(3,2,i)
         write(nfout,'(a,3f20.10)') 'cvec ',cellvec_history(1,3,i),cellvec_history(2,3,i),cellvec_history(3,3,i)
      enddo
   endif
end subroutine store_cell_and_stress

subroutine update_lattice()
   integer :: i,j
   if(lattice_optimization_method==QUENCHED_MD)then
      do i=1,3
         do j=1,3
            altv(i,j) = altv(i,j) + delta_stress*stress_velocity(j,i) + 0.5*stress_forc(j,i)*delta_stress*delta_stress
         enddo
      enddo
   else if (lattice_optimization_method==STEEPEST_DESCENT)then
      do i=1,3
         do j=1,3
            altv(i,j) = altv(i,j) + stress_forc(j,i)*delta_stress
         enddo
      enddo
   endif
end subroutine update_lattice

function get_force(altv_in,stress) result(ret)
   real(kind=DP), dimension(3,3), intent(in) :: stress, altv_in
   real(kind=DP), dimension(3,3) :: ret
   integer :: i
   ret = 0.0d0
   do i=1,3
! =========================== KT_mod ================== 13.0B
!      ret(1,i) = dot_product(stress(i,:)-external_stress(i,:),altv(:,1)) ! a-vec
!      ret(2,i) = dot_product(stress(i,:)-external_stress(i,:),altv(:,2)) ! b-vec
!      ret(3,i) = dot_product(stress(i,:)-external_stress(i,:),altv(:,3)) ! c-vec
!
      ret(1,i) = dot_product(stress(i,:),altv_in(:,1)) ! a-vec
      ret(2,i) = dot_product(stress(i,:),altv_in(:,2)) ! b-vec
      ret(3,i) = dot_product(stress(i,:),altv_in(:,3)) ! c-vec
! ====================================================== 13.0B
   enddo
end function get_force

function get_max(stress) result(res)
   real(kind=DP), dimension(3,3), intent(in) :: stress
   integer :: i,j
   real(kind=DP) :: res
   res=dabs(stress(1,1))
   do i=1,3
      do j=1,3
         if(dabs(stress(j,i))>res) res = dabs(stress(j,i))
      enddo
   enddo
end function get_max

! === KT_add ==== 13.1AS
function projected_stress_along_latvecs(altv_in,stress) result(ret)
  real(kind=DP), dimension(3,3), intent(in) :: stress, altv_in
  real(kind=DP), dimension(3,3) :: ret

  integer :: i
  real(kind=DP) :: normalized_lat_vec(3,3), c1
!
  Do i=1, 3
     c1 = sqrt( altv_in(1,i)**2 +altv_in(2,i)**2 + altv_in(3,i)**2 )
     normalized_lat_vec(:,i) = altv_in(:,i) / c1
  End do

  ret = 0.0d0

  do i=1,3
     ret(1,i) = dot_product(stress(i,:),normalized_lat_vec(:,1)) ! a-vec
     ret(2,i) = dot_product(stress(i,:),normalized_lat_vec(:,2)) ! b-vec
     ret(3,i) = dot_product(stress(i,:),normalized_lat_vec(:,3)) ! c-vec
  enddo
end function projected_stress_along_latvecs

! =========================== KT_add ======================== 13.0B &13.1AS
function constrain_on_force_type1(altv_in,f_in) result(f_out)
  real(kind=DP), intent(in) :: f_in(3,3), altv_in(3,3)
  real(kind=DP) :: f_out(3,3)

  integer :: i
  real(kind=DP) :: c1, c2, c3
  real(kind=DP) :: normalized_lat_vec(3,3), vectmp(3), vectmp2(3)
!
  f_out = f_in
!
  Do i=1, 3
     c1 = sqrt( altv_in(1,i)**2 +altv_in(2,i)**2 + altv_in(3,i)**2 )
     normalized_lat_vec(:,i) = altv_in(:,i) / c1
  End do

! -----------------------------------
  if ( fix_angle_alpha .and. fix_angle_beta .and. fix_angle_gamma ) then
     Do i=1, 3
        c1 = dot_product( f_out(i,:), normalized_lat_vec(:,i) )
        f_out(i,:) = c1 *normalized_lat_vec(:,i)
     End do
     return
  endif

! -----------------------------------
  if ( fix_angle_alpha ) then
     vectmp(:) = normalized_lat_vec(:,2) + normalized_lat_vec(:,3)

     Do i=2, 3
        c1 = dot_product( vectmp(:), normalized_lat_vec(:,i) )
        vectmp2(:) = vectmp(:) - c1*normalized_lat_vec(:,i)

        c2 = sqrt( vectmp2(1)**2 + vectmp2(2)**2 + vectmp2(3)**2 )
        vectmp2 = vectmp2 /c2

        c3 = dot_product( f_out(i,:), vectmp2(:) )
        f_out(i,:) = f_out(i,:) - c3 *vectmp2(:)
     End do
  endif

! -----------------------------------
  if ( fix_angle_beta ) then
     vectmp(:) = normalized_lat_vec(:,1) + normalized_lat_vec(:,3)

     Do i=1, 3, 2
        c1 = dot_product( vectmp(:), normalized_lat_vec(:,i) )
        vectmp2(:) = vectmp(:) - c1*normalized_lat_vec(:,i)

        c2 = sqrt( vectmp2(1)**2 + vectmp2(2)**2 + vectmp2(3)**2 )
        vectmp2 = vectmp2 /c2

        c3 = dot_product( f_out(i,:), vectmp2(:) )
        f_out(i,:) = f_out(i,:) - c3 *vectmp2(:)
     End do
  endif

! -----------------------------------
  if ( fix_angle_gamma ) then
     vectmp(:) = normalized_lat_vec(:,1) + normalized_lat_vec(:,2)

     Do i=1, 2
        c1 = dot_product( vectmp(:), normalized_lat_vec(:,i) )
        vectmp2(:) = vectmp(:) - c1*normalized_lat_vec(:,i)

        c2 = sqrt( vectmp2(1)**2 + vectmp2(2)**2 + vectmp2(3)**2 )
        vectmp2 = vectmp2 /c2

        c3 = dot_product( f_out(i,:), vectmp2(:) )
        f_out(i,:) = f_out(i,:) - c3 *vectmp2(:)
     End do

  endif

end function constrain_on_force_type1
! ================================================================ 13.0B

! === KT_add === 13.1AS
function constrain_on_force_type2(altv_in,f_in) result(f_out)
  real(kind=DP), intent(in) :: f_in(3,3), altv_in(3,3)
  real(kind=DP) :: f_out(3,3)

  integer :: i
  real(kind=DP) :: c1, c2, c3
  real(kind=DP) :: normalized_lat_vec(3,3), vectmp(3), vectmp2(3)
!
  f_out = f_in
!
  Do i=1, 3
     c1 = sqrt( altv_in(1,i)**2 +altv_in(2,i)**2 + altv_in(3,i)**2 )
     normalized_lat_vec(:,i) = altv_in(:,i) / c1
  End do

! -----------------------------------
  if ( fix_length_a ) then
     c1 = dot_product( f_out(1,:), normalized_lat_vec(:,1) )
     f_out(1,:) = f_out(1,:) -c1 *normalized_lat_vec(:,1)
  endif
  if ( fix_length_b ) then
     c1 = dot_product( f_out(2,:), normalized_lat_vec(:,2) )
     f_out(2,:) = f_out(2,:) -c1 *normalized_lat_vec(:,2)
  endif
  if ( fix_length_c ) then
     c1 = dot_product( f_out(3,:), normalized_lat_vec(:,3) )
     f_out(3,:) = f_out(3,:) -c1 *normalized_lat_vec(:,3)
  endif
end function constrain_on_force_type2
! ====== 13.1AS

subroutine m_UnitCell_init_md()
  integer :: i,j
  real(kind=DP), dimension(3) :: avec,bvec,cvec
  if(.not.first_call) return
  metric = matmul(transpose(altv),altv)
  call m_UnitCell_init_md_per_step()
  m_thermo = qmass(1)
  s_thermo = 1.d0
  p_thermo = 0.d0
  p_baro = 0.d0
  p_baro_tmp = 0.d0
  target_temperature = tkb(1)/CONST_kB
!  gfree = 3*(natm-1)
  gfree = 3*(natm)
  allocate(p_l(natm,3));p_l = 0.d0
  do i=1,natm
     p_l(i,:) = amion(ityp(i)) * cpd_l(i,:) * s_thermo
  enddo
  allocate(p_l_lattice(natm,3));p_l_lattice = 0.d0
  call convert_coords(natm,p_l,altv,p_l_lattice)
  allocate(forc_l_lattice(natm,3));forc_l_lattice = 0.d0
  allocate(p_l_metric(natm,3));p_l_metric = 0.d0
  do i=1,3
     do j=1,3
        factor(j,i) = 1.d0
        if(i.eq.j) factor(j,i) = 0.5d0
     enddo
  enddo
  first_call = .false.
end subroutine m_UnitCell_init_md

subroutine build_dudmetric()
  real(kind=DP), dimension(3,3) :: stress_tensor
  stress_tensor = m_Stress_get_curr_stress()
  dudmetric = -univol * 0.5d0 * matmul(altv_inv,matmul(stress_tensor,transpose(altv_inv)))
end subroutine build_dudmetric

subroutine convert_coords(natm,inar,cmat,outar)
  integer, intent(in) :: natm
  real(kind=DP), intent(in) :: inar(natm,3)
  real(kind=DP), intent(in) :: cmat(3,3)
  real(kind=DP), intent(out) :: outar(natm,3) 
  integer :: i,j
  outar = 0.d0
  do i=1,3
     do j=1,natm
        outar(j,i)  = dot_product(cmat(i,:),inar(j,:))
     enddo
  enddo
end subroutine convert_coords

function get_kinetic_atom(natm,p_atm, mat) result(ret)
  integer, intent(in) :: natm
  real(kind=DP), intent(in), dimension(natm,3) :: p_atm
  real(kind=DP), intent(in), dimension(3,3) :: mat
  real(kind=DP) :: ret
  real(kind=DP),dimension(3) :: tmpp
  integer :: i,j
  ret = 0.d0
  do i=1,natm
     do j=1,3
        tmpp(j) = dot_product(mat(j,:),p_atm(i,:))
     enddo
     ret = ret + dot_product(p_atm(i,:),tmpp(:))/amion(ityp(i))
  enddo
  ret = 0.5d0 * ret/(s_thermo*s_thermo)
end function get_kinetic_atom

function get_kinetic_thermo(p_thermo) result (ret)
  real(kind=DP), intent(in) :: p_thermo
  real(kind=DP) :: ret
  ret = 0.5d0 * p_thermo * p_thermo /m_thermo
end function get_kinetic_thermo

function get_kinetic_baro(p_baro) result(ret)
  real(kind=DP), intent(in), dimension(3,3) :: p_baro
  real(kind=DP) :: ret 
  integer :: i
  ret = 0.d0
  do i=1,3
     ret = ret + dot_product(p_baro(i,:),p_baro(:,i))
  enddo
  ret = 0.5d0 * ret/(m_baro * univol * univol)
end function get_kinetic_baro

function get_potential_baro() result(ret)
  real(kind=DP) :: ret
  ret = target_pressure * univol
end function get_potential_baro

subroutine m_UnitCell_init_md_per_step()
  call inver3n(3,metric,metric_inv)
  call inver3n(3,altv,altv_inv)
  call build_dudmetric()
end subroutine m_UnitCell_init_md_per_step

function tensor_rank2_equals(t1,t2) result(ret)
  real(kind=DP), dimension(3,3) :: t1,t2
  logical :: ret
  integer :: i,j
  do i=1,3
     do j=1,3
        if(abs(t1(j,i)-t2(j,i)).gt.eps) then
           ret = .false.
           return
        endif
     enddo
  enddo
  ret = .true.
end function tensor_rank2_equals

subroutine metric_to_altv()
  real(kind=DP) :: r1,r2,r3,cosa,cosb,cosc,sina,sinb,sinc
  
  altv = 0.d0
  r1=dsqrt(metric(1,1))
  r2=dsqrt(metric(2,2))
  r3=dsqrt(metric(3,3))
  
  cosa=metric(2,3)/(r2*r3)
  sina=dsqrt(dabs(1.d0-cosa**2))
  cosb=metric(1,3)/(r1*r3)
  sinb=dsqrt(dabs(1d0-cosb**2))
  cosc=metric(1,2)/(r1*r2)
  sinc=dsqrt(dabs(1d0-cosc**2))

  altv(3,3)=r3
  altv(3,2)=r2*cosa
  altv(2,2)=r2*sina
  altv(3,1)=r1*cosb
  altv(2,1)=(metric(1,2)-r1*r2*cosa*cosb)/(r2*sina)
  altv(1,1)=dsqrt(dabs(metric(1,1)-altv(2,1)**2-altv(3,1)**2))

end subroutine metric_to_altv

function m_UC_get_hamiltonian() result(res)
  real(kind=DP) :: res
  real(kind=DP) :: k_atm,k_baro,k_thermo,pot_baro,pot_thermo
  logical, save :: first_call = .true.
  call m_UnitCell_init_md()
  k_atm = get_kinetic_atom(natm,p_l_lattice,metric_inv)
  k_baro = get_kinetic_baro(matmul(metric,p_baro))
  pot_baro = get_potential_baro()
  if(control_pressure == OFF) then
    k_baro = 0.d0
    pot_baro = 0.d0
  endif
  if(imdalg == PT_CONTROL .and. t_ctrl_method /= VELOCITY_SCALING)then
     k_thermo = get_kinetic_thermo(p_thermo)
     pot_thermo = gfree * target_temperature * CONST_kB * log(s_thermo)
  else if (imdalg == P_CONTROL .or. (imdalg == PT_CONTROL .and. t_ctrl_method == VELOCITY_SCALING)) then
     k_thermo = 0.d0
     pot_thermo = 0.d0
  endif
!  res = s_thermo * (k_atm + etotal + k_thermo + pot_thermo + k_baro + pot_baro)
  res = k_atm + etotal + k_thermo + pot_thermo + k_baro + pot_baro
  if(.not.H0_has_been_set)then
    H0 = res
    H0_has_been_set = .true.
  endif
  res = res-H0
end function m_UC_get_hamiltonian

function m_UC_get_curr_pressure() result(res)
  real(kind=DP) :: curr_pressure, res
  integer :: i
  real(kind=DP), dimension(3,3) :: stress
  curr_pressure = 2.d0 * get_kinetic_atom(natm,p_l_lattice,metric_inv)
  do i=1,3
    curr_pressure = curr_pressure - 2.d0 * dudmetric(i,i) * altv(i,i) * altv(i,i)
  enddo
  res = curr_pressure/3.d0/univol
end function m_UC_get_curr_pressure

function m_UC_get_curr_temperature() result(res)
  integer :: i
  real(kind=DP) :: ke,res
  ke = 2.d0 * get_kinetic_atom(natm,p_l_lattice,metric_inv)
  res = ke/gfree/CONST_kB
end function m_UC_get_curr_temperature

subroutine m_UC_rd_md_cnth_data(nfcntn)
   integer, intent(in) :: nfcntn  
   integer :: i,ierr
   logical             :: tag_is_found, EOF_reach
   integer,      parameter   :: len_str = 132
   character(len=len_str)       :: str
   call m_UnitCell_init_md()
   if(mype==0)then
      call rewind_to_tag0(nfcntn,len(tag_pressure_control), &
            &  tag_pressure_control, & 
            &  EOF_reach, tag_is_found, str,len_str)
      if(tag_is_found)then
         read(nfcntn,*)
         read(nfcntn,*) s_thermo
         read(nfcntn,*)
         read(nfcntn,*) p_thermo
         read(nfcntn,*)
         read(nfcntn,*) H0
         call read_33('altv',altv)      
         call read_33('altv_inv',altv_inv)
         call read_33('metric',metric)
         call read_33('metric_inv',metric_inv)
         call read_33('dudmetric',dudmetric)
         call read_33('p_baro',p_baro)
         call read_33('p_baro_tmp',p_baro_tmp)
         call read_natm3('forc_l_lattice',forc_l_lattice)
         call read_natm3('p_l',p_l)
         call read_natm3('p_l_lattice',p_l_lattice)
         call read_natm3('p_l_metric',p_l_metric)
      endif
   endif

   if(npes>1)then
      call mpi_bcast(tag_is_found,1,mpi_logical,0,mpi_comm_group,ierr)
      if(tag_is_found) then
         call mpi_bcast(s_thermo,1,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(p_thermo,1,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(H0,1,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(altv,9,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(altv_inv,9,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(metric,9,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(metric_inv,9,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(p_baro,9,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(p_baro_tmp,9,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(forc_l_lattice,natm*3,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(p_l,natm*3,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(p_l_lattice,natm*3,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(p_l_metric,natm*3,mpi_double_precision,0,mpi_comm_group,ierr)
         call altv_2_rltv(altv,rltv,univol,rvol)  ! in b_CS
         call change_of_coordinate_system(altv,pos,natm,natm,cps) !-(b_I.S.) pos -> cps
         call primitive2bravais(nfout,p2bmat,altv(:,1),altv(:,2),altv(:,3),a,b,c,ca,cb,cc,il) ! in b_CS
         H0_has_been_set = .true.
      endif
   endif

   contains

   subroutine read_33(key,tensor)
      character(len=*), intent(in) :: key
      real(kind=DP), intent(out), dimension(3,3) :: tensor
      read(nfcntn,*) 
      read(nfcntn,*) tensor(1,1),tensor(2,1),tensor(3,1)
      read(nfcntn,*) tensor(1,2),tensor(2,2),tensor(3,2)
      read(nfcntn,*) tensor(1,3),tensor(2,3),tensor(3,3)
   end subroutine read_33

   subroutine read_natm3(key,ar)
      character(len=*), intent(in) :: key
      real(kind=DP), intent(out), dimension(natm,3) :: ar
      integer :: i
      read(nfcntn,*)
      do i=1,natm
         read(nfcntn,*) ar(i,1),ar(i,2),ar(i,3)
      enddo
   end subroutine read_natm3

end subroutine m_UC_rd_md_cnth_data

subroutine m_UC_wd_md_cntn_data(nfcntn)
   integer, intent(in) :: nfcntn
   integer :: i
   if(mype==0)then
      write(nfcntn,*) tag_pressure_control
      write(nfcntn,*) 's_thermo'
      write(nfcntn,'(3f25.15)') s_thermo
      write(nfcntn,*) 'p_thermo'
      write(nfcntn,'(3f25.15)') p_thermo
      write(nfcntn,*) 'H0'
      write(nfcntn,'(3f25.15)') H0
      call dump_33('altv',altv)
      call dump_33('altv_inv',altv_inv)
      call dump_33('metric',metric)
      call dump_33('metric_inv',metric_inv)
      call dump_33('dudmetric',dudmetric)
      call dump_33('p_baro',p_baro)
      call dump_33('p_baro_tmp',p_baro_tmp)
      call dump_natm3('forc_l_lattice',forc_l_lattice)
      call dump_natm3('p_l',p_l)
      call dump_natm3('p_l_lattice',p_l_lattice)
      call dump_natm3('p_l_metric',p_l_metric)
   endif

   contains

   subroutine dump_33(key,tensor)
      character(len=*), intent(in) :: key
      real(kind=DP), intent(in), dimension(3,3) :: tensor
      write(nfcntn,*) key
      write(nfcntn,'(3f25.15)') tensor(1,1),tensor(2,1),tensor(3,1)
      write(nfcntn,'(3f25.15)') tensor(1,2),tensor(2,2),tensor(3,2)
      write(nfcntn,'(3f25.15)') tensor(1,3),tensor(2,3),tensor(3,3)
   end subroutine dump_33

   subroutine dump_natm3(key,ar)
      character(len=*), intent(in) :: key
      real(kind=DP), intent(in), dimension(natm,3) :: ar
      integer :: i
      write(nfcntn,*) key
      do i=1,natm
         write(nfcntn,'(3f25.15)') ar(i,1),ar(i,2),ar(i,3)
      enddo
   end subroutine dump_natm3

end subroutine m_UC_wd_md_cntn_data

! perform npt-md based on the metric tensor and Nose-Poincare thermostat
! original theory from I. Souza and J. L. Martins PRB 55 8733
! formulation from E. Herna´ndez JCP 115 10282
subroutine m_UnitCell_md(forc_l)
  real(kind=DP), intent(in), dimension(natm,3) :: forc_l
  real(kind=DP), dimension(3,3) :: p33,p_baro33,p_baro33_2,p_baro_tmp_m,p_baro_tmp2
  real(kind=DP), dimension(3,3) :: metric_tmp,metric_tmp2
  integer :: i,j
  real(kind=DP) :: k_baro,k_atm,pot_s,pot_baro,a,b,c,k_baro2,uvol2t,s_thermo_tmp,k_thermo,pot_thermo
  real(kind=DP), external :: deter3

  call m_UnitCell_init_md()

  call m_UnitCell_init_md_per_step()
  call second_half()
  call first_half()

  call post()

  contains

  subroutine post()
    integer :: i,j
    real(kind=DP),dimension(3,3) :: stress
    call convert_coords(natm,p_l_lattice,altv_inv,p_l)
    do i=1,natm 
       cpd_l(i,:) = p_l(i,:)/amion(ityp(i))/s_thermo
    enddo
  end subroutine post

  subroutine first_half()

    if(imdalg == PT_CONTROL .and. t_ctrl_method == VELOCITY_SCALING) then
      call convert_coords(natm,p_l_lattice,altv_inv,p_l)
      do i=1,natm 
         cpd_l(i,:) = p_l(i,:)/amion(ityp(i))/s_thermo
      enddo
      call scale_velocity()
      do i=1,natm
         p_l(i,:) = amion(ityp(i)) * cpd_l(i,:) * s_thermo
      enddo
      call convert_coords(natm,p_l,altv,p_l_lattice)
    endif

    ! eq(18a)
    p_l_lattice(:,:) = p_l_lattice(:,:) + 0.5d0 * dtio * s_thermo * forc_l_lattice(:,:)
    ! eq(18b)
    call convert_coords(natm,p_l_lattice,metric_inv,p_l_metric)
    if(control_pressure == ON) then
    do i=1,3
       do j=1,3
          p33(j,i) = 0.5d0 * dot_product(p_l_metric(:,j),p_l_metric(:,i)/amion(ityp(:))/(s_thermo*s_thermo))
       enddo
    enddo
    p_baro_tmp = p_baro
    do i=1,nmax
       p_baro_tmp_m = matmul(metric,p_baro_tmp)
       p_baro33 = matmul(p_baro_tmp,p_baro_tmp_m)/(m_baro * univol * univol)
       k_baro = get_kinetic_baro(p_baro_tmp_m)
       pot_baro = 0.5d0 * get_potential_baro()
       p_baro_tmp2(:,:) = p_baro(:,:) - 0.5d0 * dtio * s_thermo *        &
       & (dudmetric(:,:) + 2.d0 * factor(:,:)*(-p33(:,:)+p_baro33(:,:) + &
       &  metric_inv(:,:)*(pot_baro - k_baro)))
       if(tensor_rank2_equals(p_baro_tmp,p_baro_tmp2)) then
          p_baro_tmp = p_baro_tmp2
          exit
       endif
       p_baro_tmp = p_baro_tmp2
       if(i .eq. nmax) then
          write(nfout,'(a)') 'failed to reach convergence for the iteration of the barostat momentum'
          call flush(nfout)
          stop
       endif
    enddo
    endif

    !eq(18c,d)
    if(imdalg == PT_CONTROL .and. t_ctrl_method /= VELOCITY_SCALING) then
       k_atm = get_kinetic_atom(natm,p_l_lattice,metric_inv)
       p_baro_tmp_m = matmul(metric,p_baro_tmp)
       k_baro = get_kinetic_baro(p_baro_tmp_m)
       pot_baro = get_potential_baro()
       if(control_pressure == OFF) then
           k_baro = 0.d0
           pot_baro = 0.d0
       endif
       pot_thermo = (1.d0+log(s_thermo)) * gfree * target_temperature * CONST_kB
       a = 0.25d0 * dtio/m_thermo
       b = 1.d0
       c = 0.5 * dtio * (-k_atm + pot_thermo + etotal + k_baro + pot_baro-H0) - p_thermo
       p_thermo = (-b+dsqrt(b*b-4.d0*a*c))/(2.d0*a)
       s_thermo_tmp = s_thermo * (1.d0+0.5d0*dtio*p_thermo/m_thermo)/(1.d0-0.5d0*dtio*p_thermo/m_thermo)
    else if (imdalg == P_CONTROL .or. (imdalg == PT_CONTROL .and. t_ctrl_method == VELOCITY_SCALING)) then
       s_thermo_tmp = 1.d0
       p_thermo = 0.d0
    endif

    if(control_pressure ==  ON)then
    !eq(18e)
    metric_tmp = metric
    p_baro33 = matmul(metric,matmul(p_baro_tmp,metric))/(m_baro*univol * univol)
    do i=1,nmax 
       uvol2t = dabs(deter3(metric_tmp))
       p_baro33_2 = matmul(metric_tmp,matmul(p_baro_tmp,metric_tmp))/(m_baro*uvol2t)
       metric_tmp2(:,:) = metric(:,:) + mobility_cell(:,:)*factor(:,:)*dtio &
       &                *(s_thermo*p_baro33(:,:) +s_thermo_tmp * p_baro33_2(:,:))
       if(tensor_rank2_equals(metric_tmp2,metric_tmp)) then
          metric_tmp = metric_tmp2
          exit
       endif
       metric_tmp = metric_tmp2
       if(i .eq. nmax) then
          write(nfout,'(a)') 'failed to reach convergence for the metric iteration'
          call flush(nfout)
          stop
       endif
    enddo
    metric = metric_tmp
    endif

    !eq(18f)
    do i=1,natm
       pos(i,:) = pos(i,:) + 0.5d0*dtio*(p_l_metric(i,:)/(amion(ityp(i))*s_thermo) +  &
                &                        p_l_metric(i,:)/(amion(ityp(i))*s_thermo_tmp))
    enddo

    s_thermo = s_thermo_tmp
    if(control_pressure==ON)then
    call metric_to_altv()
    call inver3n(3,metric,metric_inv)
    call inver3n(3,altv,altv_inv)
    call altv_2_rltv(altv,rltv,univol,rvol)  ! in b_CS
    call change_of_coordinate_system(altv,pos,natm,natm,cps) !-(b_I.S.) pos -> cps
    call primitive2bravais(nfout,p2bmat,altv(:,1),altv(:,2),altv(:,3),a,b,c,ca,cb,cc,il) ! in b_CS
    endif
    if(mype==0)then
      write(nflatconst,'(i10,7f20.10)') iteration_unit_cell,a,b,c, &
      &     acos(ca)/PAI*180.d0,acos(cb)/PAI*180.d0,acos(cc)/PAI*180.d0,univol
      write(nfmetric,'(i10)')     iteration_unit_cell
      write(nfmetric,'(3f20.10)') metric(1,1),metric(1,2),metric(1,3)
      write(nfmetric,'(3f20.10)') metric(2,1),metric(2,2),metric(2,3)
      write(nfmetric,'(3f20.10)') metric(3,1),metric(3,2),metric(3,3)
      call m_Files_flush_pcontrol_files()
    endif
  end subroutine first_half

  subroutine second_half()
    !eq(18g)
    if(imdalg == PT_CONTROL)then
       k_atm = get_kinetic_atom(natm,p_l_lattice,metric_inv)
       p_baro_tmp_m = matmul(metric,p_baro_tmp)
       k_baro = get_kinetic_baro(p_baro_tmp_m)
       pot_baro = get_potential_baro()
       if(control_pressure == OFF) then
          k_baro = 0.d0
          pot_baro = 0.d0
       endif
       pot_thermo = (1.d0+log(s_thermo)) * gfree * target_temperature * CONST_kB
       k_thermo = get_kinetic_thermo(p_thermo)
       p_thermo = p_thermo + 0.5d0*dtio*(k_atm - etotal - k_thermo - pot_thermo - k_baro - pot_baro + H0)
    endif

    if(control_pressure == ON)then
    !eq(18h)
    do i=1,3
       do j=1,3
          p33(j,i) = 0.5d0*dot_product(p_l_metric(:,i),p_l_metric(:,j)/amion(ityp(:))/(s_thermo*s_thermo))
       enddo
    enddo
    p_baro_tmp_m = matmul(metric,p_baro_tmp)
    p_baro33 = matmul(p_baro_tmp,p_baro_tmp_m)/(m_baro*univol * univol)
    k_baro = get_kinetic_baro(p_baro_tmp_m)
    pot_baro = 0.5d0 * get_potential_baro()
    p_baro(:,:) = p_baro_tmp(:,:) - 0.5d0 * dtio * s_thermo *            &
    & (dudmetric(:,:) + 2.d0 * factor(:,:)*(-p33(:,:)+p_baro33(:,:) +   &
    &  metric_inv(:,:)*(pot_baro - k_baro)))
    endif

    !eq(18i)
    call convert_coords(natm,forc_l,altv,forc_l_lattice)
    p_l_lattice(:,:) = p_l_lattice(:,:) + 0.5d0 * dtio * s_thermo * forc_l_lattice(:,:)
  end subroutine second_half

end subroutine m_UnitCell_md

end module m_UnitCell

logical function unitcell_can_change()
  use m_Control_Parameters, only : sw_optimize_lattice,imdalg
  use m_Const_Parameters, only : ON,P_CONTROL, PT_CONTROL
  use m_Stress, only : m_Stress_in_correction
  implicit none
  if(imdalg == P_CONTROL .or. imdalg == PT_CONTROL) then
     unitcell_can_change = .true.
     return
  endif
  if(m_Stress_in_correction()) then
     unitcell_can_change = .true.
     return
  endif
  unitcell_can_change = sw_optimize_lattice==ON
end function unitcell_can_change

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 581 $)
!
!  MODULE: m_PAW_ChargeDensity
!
!  AUTHOR(S): T. Yamasaki, T. Yamamoto and T. Ohno November/2009
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_PAW_ChargeDensity
  use m_db,                   only : getIntDB,getStringDB_TB,getIntDB_TB
  use m_Const_Parameters,     only : DP,PAI2,PAI4,BUCS,SphericalHarmonicsExpansion, GaussLegendre, LOWER, Bohr &
       &                           , FMAXVALLEN,NOCONV
  use m_Control_Parameters,   only : kimg,nspin,af,ipripaw,ipriinputfile,printable
  use m_Files,                only : nfout
  use m_Ionic_System,         only : ityp,natm,ntyp,pos,iwei, speciesname, amion, surface_integral_method_paw
  use m_Charge_Density,       only : hsr,chgq_l,chgsoft
  use m_PlaneWaveBasisSet,    only : igfp_l
  use m_PseudoPotential,      only : psirpw,phirpw,qrspspw &
       &                            ,rhcorpw,rhpcrpw &
       &                            ,ilmt,ltp,mtp,taup,radr_paw &
       &                            ,il2p,isph,dl2p,iqitg &
       &                            ,m_PP_find_maximum_l &
       &                            ,ipaw,wf_mnrc,flg_symmtry &
       &                            ,mmesh, nmesh
  use m_FFT,                  only : fft_box_size_CD,fft_box_size_CD_c, nfftp &
       , m_FFT_CD_inverse0 &
       , m_FFT_check_of_negative_CD &
       , m_FFT_cp_afft_CD &
       , m_FFT_alloc_CD_box &
       , m_FFT_dealloc_CD_box
  use m_Parallelization,      only : ista_kngp,iend_kngp,npes,mype,ierr &
       , ista_fftp,iend_fftp &
       , nis_fftp,nie_fftp,mp_fftp &
       , npes_cdfft, ista_fftph, iend_fftph &
       , mpi_comm_group
  use m_Crystal_Structure,    only : altv,rltv,nopr,m_CS_op_in_PUCD,tau,op
  use m_PAW_Tecplot,          only : unusedUnit,output_box_tecplot
  use m_PlaneWaveBasisSet,    only : ngabc,kgp, kgp_reduced
  use m_Timing,               only : tstatc0_begin, tstatc0_end

! ============================ added by K. Tagami =============== 11.0
  use m_Control_Parameters,    only : ndim_magmom, noncol
  use m_Parallelization,      only : ista_atm, iend_atm
  use m_ES_NonCollinear,     only :  Global_Quantz_Axis_now
! =============================================================== 11.0


  implicit none
  include 'mpif.h'
    
  private
  
  integer:: ntheta,nphi
  real(DP),pointer,dimension(:)                 :: cos_theta
  real(DP),pointer,dimension(:)                 :: omg_wght
  real(DP),pointer,dimension(:,:,:)             :: ylm,dylm_dth,dylm_dph
  integer,pointer,dimension(:,:)               :: ia2ia_symmtry_op
  real(kind=DP), allocatable,dimension(:,:,:)  :: op_pr
!!$    character(len=64),pointer,dimension(:)       :: surface_integral_method_char
  integer,allocatable,dimension(:)             :: surface_integral_method
  
  real(kind=DP), pointer, dimension(:,:,:)      :: paw_cr2
  integer, pointer, dimension(:,:,:)           :: paw_isph2
  integer, pointer, dimension(:,:)             :: paw_mmt2
  integer, pointer, dimension(:)               :: paw_dnr
  
  character(len("paw_one_center_integral")),private,parameter :: tag_paw_integral="paw_one_center_integral"
  character(len("element_list")),private,parameter :: tag_element_list="element_list"
  character(len("element")),private,parameter :: tag_element = "element"
  character(len("surface_integral_method")),private,parameter :: tag_surface_integral_method="surface_integral_method"
  character(len("dnr")),private,parameter ::  tag_dnr = "dnr"
  character(len("SphericalHarmonicsExpansion")),private,parameter :: tag_Sphex ="sphericalharmonicsexpansion"
  character(len("SphericalHarmonics"))         ,private,parameter :: tag_Sphex2="sphericalharmonics"
  character(len("Sphex"))                      ,private,parameter :: tag_Sphex3="sphex"
  character(len("GaussLegendre"))              ,private,parameter :: tag_GL ="gausslegendre"
  character(len("GL"))                         ,private,parameter :: tag_GL2="gl"
  
  logical:: calcGaussLegendreIntegration = .false.
  logical:: calcSphericalHarmonicsExpansion = .false.
  
  public:: ntheta,nphi,omg_wght
  public:: m_PAWCD_rd_ntheta_nphi
  public:: m_PAWCD_init_surf_integration
  public:: m_PAWCD_set_ae_cd
  public:: m_PAWCD_set_ae_cd_sym
  public:: m_PAWCD_set_ae_der_cd
  public:: m_PAWCD_set_ae_der_cd_sym
  public:: m_PAWCD_set_ps_cd
  public:: m_PAWCD_set_ps_cd_sym
  public:: m_PAWCD_set_ps_der_cd
  public:: m_PAWCD_set_ps_der_cd_sym
  public:: ylm,dylm_dth,dylm_dph
  public:: cos_theta
  public:: m_PAWCD_dealloc
  public:: m_PAWCD_wd_cd
  
  public:: m_PAWCD_wd_number_of_state
  public:: surface_integral_method


! ======================== added by K. Tagami ================= 11.0
  integer max_sph_expansion
  parameter( max_sph_expansion = 25 )

  integer, parameter :: project_on_local_quantz_axis = 10
  integer, parameter :: project_on_global_quantz_axis = 15
!
  integer :: mode_of_projection = project_on_local_quantz_axis
!
  public :: m_PAWCD_ae_cd_sphex2_nonclA
  public :: m_PAWCD_ps_cd_sphex2_nonclA
  public :: max_sph_expansion
! ============================================================== 11.0
    
!!$    public:: m_PAWCD_set_ae_cd_sphex
  public:: m_PAWCD_set_ae_cd_sphex2
!!$    public:: m_PAWCD_set_ae_cd_sphex3
!!$    public:: m_PAWCD_set_ps_cd_sphex
  public:: m_PAWCD_set_ps_cd_sphex2
!!$    public:: m_PAWCD_set_ps_cd_sphex3
!!$    public:: m_PAWCD_set_sq_der_cd_sdphex
  public:: m_PAWCD_set_sq_der_cd_sdphex2
!!$    public:: m_PAWCD_set_sq_der_cd_sphex3
  public:: m_PAWCD_set_cr2_isph2_mmt2
  
  public:: m_PAW_dealloc
  public:: paw_cr2,paw_isph2,paw_mmt2,paw_dnr
  public:: calcGaussLegendreIntegration
  public:: calcSphericalHarmonicsExpansion
  
  public :: m_PAWCD_calc_contact_density

contains

  subroutine m_PAW_dealloc()
    call dealloc_integral_method_etc()
  end subroutine m_PAW_dealloc

  subroutine alloc_integral_method_etc
    allocate(surface_integral_method(ntyp));  surface_integral_method = SphericalHarmonicsExpansion
    allocate(paw_dnr(ntyp)); paw_dnr = 1
  end subroutine alloc_integral_method_etc

  subroutine dealloc_integral_method_etc()
    if(allocated(surface_integral_method)) deallocate(surface_integral_method)
    deallocate(paw_dnr)
  end subroutine dealloc_integral_method_etc

  subroutine m_PAWCD_rd_ntheta_nphi
    call getIntDB("paw surface_integration ntheta",ntheta,10)
    call getIntDB("paw surface_integration nphi",nphi,10)
    call alloc_integral_method_etc()
    surface_integral_method(:) = surface_integral_method_paw(:)
    deallocate(surface_integral_method_paw)
    call rd_surface_integral_method
    return
  end subroutine m_PAWCD_rd_ntheta_nphi

  subroutine rd_surface_integral_method
    integer :: i,j, npt, itr
    integer :: f_selectBlock, f_selectParentBlock
    integer :: f_selectFirstTableLine, f_selectNextTableLine, f_getStringValue, f_getIntValue
    logical :: found, tf
    character(len=FMAXVALLEN) :: rstr
            
    if(f_selectBlock(tag_paw_integral) == 0) then

       if(ipriinputfile >=2)  write(nfout,'(" !** -- tag_paw_one_center_integral --")')
       if( f_selectBlock(tag_element_list) == 0) then
          i = 1
          do while(.true.)
             if(i==1) then
                if( f_selectFirstTableLine() /= 0) then
                   exit
                end if
             else
                if( f_selectNextTableLine() /= 0) then
                   exit
                end if
             end if
             if(i > ntyp) exit
             found = .false.
             if(f_getStringValue(tag_element,rstr,NOCONV) == 0) then
                do j = 1, ntyp
                   if(trim(rstr).eq.trim(speciesname(j))) then
                      found = .true.
                      npt = j
                      exit
                   end if
                end do
             end if
             if(found) then
                if(npt >=1 .and. npt <=ntyp) then
                   if(f_getStringValue(tag_surface_integral_method,rstr,LOWER) == 0) then
                      call strncmp0(tag_Sphex,trim(rstr),tf)
                      if(.not.tf) call strncmp0(tag_Sphex2,trim(rstr),tf)
                      if(.not.tf) call strncmp0(tag_Sphex3,trim(rstr),tf)
                      if(tf) surface_integral_method(npt) = SphericalHarmonicsExpansion
                      call strncmp0(tag_GL,trim(rstr),tf)
                      if(.not.tf) call strncmp0(tag_GL2,trim(rstr),tf)
                      if(tf) surface_integral_method(npt) = GaussLegendre
                   end if
                   if(f_getIntValue(tag_dnr,itr) == 0) then
                      paw_dnr(npt) = itr
                   end if
                end if
             end if
             i = i+1
          end do
          itr = f_selectParentBlock()
       end if
       itr = f_selectParentBlock()
    end if
    if(ipriinputfile>=1) then
       write(nfout,*)
       write(nfout,*) '<***   PAW one center integral   ***>'
       do i=1,ntyp
          if(surface_integral_method(i) == SphericalHarmonicsExpansion) then
             write(nfout,'(i2,a,a,a,a,a,i2)') i,'-th element : ',trim(speciesname(i)) &
                  & ,' : ',trim(tag_Sphex),' : dnr = ',paw_dnr(i)
          else if(surface_integral_method(i) == GaussLegendre) then
             write(nfout,'(i2,a,a,a,a,a,i2)') i,'-th element : ',trim(speciesname(i)) &
                  & ,' : ',trim(tag_GL),' : dnr = ',paw_dnr(i)
          end if
          if(surface_integral_method(i) .ne. SphericalHarmonicsExpansion .and. &
               surface_integral_method(i) .ne. GaussLegendre) then
             write(nfout,*) 'Error in rd_surface_integral_method !'
             stop 'Error in rd_surface_integral_method !'
          end if
       end do
    end if
    
  end subroutine rd_surface_integral_method

  subroutine m_PAWCD_init_surf_integration
!integer:: i,j
!real(8):: sum
    logical:: doGaussLegendre
    doGaussLegendre=.false.
    call setDoGaussLegendre(doGaussLegendre)
    calcGaussLegendreIntegration=doGaussLegendre
    call setDoSphHarmonicsExpansion(calcSphericalHarmonicsExpansion)
    !        if(.not.doGaussLegendre) return
    allocate(cos_theta(ntheta));cos_theta=0
    allocate(omg_wght(ntheta));omg_wght=0
    call GaussLeg(-1.d0,1.d0,ntheta,cos_theta,omg_wght)
    omg_wght=omg_wght/2.d0/dble(nphi)
!sum=0.d0
!do i=1,ntheta
!do j=1,nphi
!sum=sum+cos_theta(i)**4*omg_wght(i)
!end do
!end do
!print *,sum
!stop
    call m_PAWCD_set_ylms(25)
    allocate(ia2ia_symmtry_op(natm,nopr+af))
    ia2ia_symmtry_op=0
    call set_ia2ia_symmtry_op
    return
  end subroutine m_PAWCD_init_surf_integration
    
  subroutine setDoGaussLegendre(flg)
    logical,intent(out):: flg
    integer:: i
    
    flg=.false.
    do i=1,ntyp
       if(ipaw(i)/=1) cycle
!!$            if(surface_integral_method(i) .eq. "GaussLegendre") then
       if(surface_integral_method(i) .eq. GaussLegendre) then
          flg=.true.
          exit
       end if
    end do
    return
  end subroutine setDoGaussLegendre

  subroutine setDoSphHarmonicsExpansion(flg)
    logical,intent(out):: flg
    integer:: i
    
    flg=.false.
    do i=1,ntyp
       if(ipaw(i)/=1) cycle
!!$            if(surface_integral_method(i) .eq. "SphericalHarmonicsExpansion") then
       if(surface_integral_method(i) .eq. SphericalHarmonicsExpansion) then
          flg=.true.
          exit
       end if
    end do
    return
  end subroutine setDoSphHarmonicsExpansion
    
  subroutine m_PAWCD_set_ylms(ilmax)
    integer,intent(in):: ilmax
    
    real(DP):: cos_the,sin_the
    real(DP):: phi,rr
    integer:: it,ip,itp,is
    real(DP),pointer,dimension(:)     :: gx,gy,gz,tylm
    real(DP),pointer,dimension(:,:)   :: tdylm
        
    allocate(gx(ntheta*nphi))
    allocate(gy(ntheta*nphi))
    allocate(gz(ntheta*nphi))
    allocate(tylm(ntheta*nphi))
    allocate(tdylm(ntheta*nphi,3))
    
    allocate(ylm(ntheta,nphi,ilmax))
    allocate(dylm_dth(ntheta,nphi,ilmax))
    allocate(dylm_dph(ntheta,nphi,ilmax))
    
    itp=0
    do it=1,ntheta
       cos_the=cos_theta(it)
       sin_the=sqrt(1.d0-cos_the*cos_the)
       do ip=1,nphi
          itp=itp+1
          phi=PAI2/dble(nphi)*dble(ip-1)
          gx(itp)=sin_the*cos(phi)
          gy(itp)=sin_the*sin(phi)
          gz(itp)=cos_the
       end do
    end do
    
    do is=1,ilmax
       call sphr(ntheta*nphi,is,gx,gy,gz,tylm)
       itp=0
       do it=1,ntheta
          do ip=1,nphi
             itp=itp+1
             ylm(it,ip,is)=tylm(itp)
          end do
       end do
    end do
        
    do is=1,ilmax
       call sphr_diff(ntheta*nphi,ntheta*nphi,is,gx,gy,gz,tdylm)
       itp=0
       do it=1,ntheta
          do ip=1,nphi
             itp=itp+1
!                    ylm(it,ip,is)=tylm(itp)
             rr=sqrt(gx(itp)**2+gy(itp)**2)
             dylm_dth(it,ip,is)= gz(itp)*gx(itp)/rr*tdylm(itp,1)+ &
                  gy(itp)*gz(itp)/rr*tdylm(itp,2)- &
                  rr*tdylm(itp,3)
             dylm_dph(it,ip,is)=-gy(itp)*tdylm(itp,1)+ &
                  gx(itp)*tdylm(itp,2)
          end do
       end do
    end do
        
!it=2;ip=3;is=2
!cos_the=cos_theta(it)
!sin_the=sqrt(1.d0-cos_the*cos_the)
!phi=PAI2/dble(nphi)*dble(ip-1)
!print *,'is=',is
!print *,sin_the*cos(phi),sin_the*sin(phi),cos_the
!print *,ylm(it,ip,is),dylm_dth(it,ip,is),dylm_dph(it,ip,is)
    
    deallocate(gx,gy,gz,tylm,tdylm)
    return
  end subroutine m_PAWCD_set_ylms
    
  subroutine m_PAWCD_dealloc
! ======================= ASMS_DEBUG ================= 2013/02/07
    if (.not. associated(cos_theta)) return 
                               !   sw_phonon == on .and. sw_calc_force == off
! ======================= ASMS_DEBUG ================= 2013/02/07
    deallocate(cos_theta)
    deallocate(omg_wght)
    deallocate(ylm,dylm_dth,dylm_dph)
    deallocate(ia2ia_symmtry_op)
    return
  end subroutine m_PAWCD_dealloc
    
  subroutine m_PAWCD_set_ae_cd(ith,iph,ia,nspin,nrc,n1nc)
    integer,intent(in) :: ith,iph,ia,nspin,nrc
    real(8),intent(out):: n1nc(nrc,nspin)
    
    real(8):: n1(nrc,nspin),sum,fac
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj
    
    it=ityp(ia)
    n1nc=0.d0
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1   
       do lmt2=lmt1,ilmt(it)
          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2  
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
          
          do is=1,nspin
             sum=fac*hsr(ia,lmt1,lmt2,is)* &
                  ylm(ith,iph,ii)* &
                  ylm(ith,iph,jj)
             do ir=1,nrc 
                n1nc(ir,is)=n1nc(ir,is)+sum* &
                     psirpw(ir,il1,it1,it)* &
                     psirpw(ir,il2,it2,it)
             end do
          end do
       end do
    end do
            
    do is=1,nspin
       do ir=1,nrc
          n1nc(ir,is)=(n1nc(ir,is)+rhcorpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it) 
       end do
    end do
    
    return
  end subroutine m_PAWCD_set_ae_cd

  subroutine m_PAWCD_set_ae_cd2(ith,iph,ia,nspin,nrc,n1nc)
    integer,intent(in) :: ith,iph,ia,nspin,nrc
    real(8),intent(out):: n1nc(nrc,nspin)
    
    real(8):: n1(nrc,nspin),sum,fac
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj
    
    it=ityp(ia)
    do is=1,nspin
       do ir=1,nrc
          sum=0.d0
          do lmt1=1,ilmt(it)
             il1=ltp(lmt1,it)
             im1=mtp(lmt1,it)
             it1=taup(lmt1,it)
             ii=(il1-1)**2+im1   
             do lmt2=lmt1,ilmt(it)
                il2=ltp(lmt2,it)
                im2=mtp(lmt2,it)
                it2=taup(lmt2,it)
                jj=(il2-1)**2+im2  
                fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                sum=sum+fac*hsr(ia,lmt1,lmt2,is)* &
                     psirpw(ir,il1,it1,it)* &
                     psirpw(ir,il2,it2,it)* &
                     ylm(ith,iph,ii)* &
                     ylm(ith,iph,jj)
             end do
          end do
          n1nc(ir,is)=(sum+rhcorpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it) 
       end do
    end do
    
    return
  end subroutine m_PAWCD_set_ae_cd2
    
  subroutine m_PAWCD_set_ae_cd_sym2(vec0,ia,nspin,nrc,n1nc)
    integer,intent(in) :: ia,nspin,nrc
    real(DP),intent(in) :: vec0(3) 
    real(8),intent(out):: n1nc(nrc,nspin)
    
    real(8):: n1(nrc,nspin),sum,fac,sum2
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj
    integer:: ja,iopr
    real(DP),pointer,dimension(:,:):: ylm_sym
    
    allocate(ylm_sym(nopr+af,25))
    ylm_sym=0.d0
    call set_ylms_symmtry_op(ia,25,vec0,ylm_sym)
    
    it=ityp(ia)
    do is=1,nspin
       do ir=1,nrc
          sum=0.d0
          do lmt1=1,ilmt(it)
             il1=ltp(lmt1,it)
             im1=mtp(lmt1,it)
             it1=taup(lmt1,it)
             ii=(il1-1)**2+im1   
             do lmt2=lmt1,ilmt(it)
                il2=ltp(lmt2,it)
                im2=mtp(lmt2,it)
                it2=taup(lmt2,it)
                jj=(il2-1)**2+im2  
                fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                
                sum2=0.d0
                do iopr=1,nopr
                   ja=abs(ia2ia_symmtry_op(ia,iopr))
                   sum2=sum2+hsr(ja,lmt1,lmt2,is)* &
                        ylm_sym(iopr,ii)* &
                        ylm_sym(iopr,jj)
                end do
                sum2=sum2/dble(nopr)
                
                sum=sum+fac* &
                     psirpw(ir,il1,it1,it)* &
                     psirpw(ir,il2,it2,it)* &
                     sum2
             end do
          end do
          n1nc(ir,is)=(sum+rhcorpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it) 
       end do
    end do
    
    deallocate(ylm_sym)
    return
  end subroutine m_PAWCD_set_ae_cd_sym2
    
  subroutine m_PAWCD_set_ae_cd_sym(vec0,ia,nspin,nrc,n1nc)
    integer,intent(in) :: ia,nspin,nrc
    real(DP),intent(in) :: vec0(3) 
    real(8),intent(out):: n1nc(nrc,nspin)
    
    real(8):: n1(nrc,nspin),sum,fac,sum2
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj
    integer:: ja,iopr
    real(DP),pointer,dimension(:,:):: ylm_sym
    integer :: id_sname = -1
    call tstatc0_begin('m_PAWCD_set_ae_cd_sym ',id_sname)
    
    allocate(ylm_sym(nopr+af,25))
    ylm_sym=0.d0
    call set_ylms_symmtry_op(ia,25,vec0,ylm_sym)
    
    it=ityp(ia)
        
    n1nc=0.d0
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1   
       do lmt2=lmt1,ilmt(it)
          if(nspin==1 .and.dabs(hsr(ia,lmt1,lmt2,1)) < 1.d-10) cycle
          if(nspin==2 .and.dabs(hsr(ia,lmt1,lmt2,1))+dabs(hsr(ia,lmt1,lmt2,2))<1.d-10) cycle
          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2  
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                
          do is=1,nspin
             sum2=0.d0
             do iopr=1,nopr
                ja=abs(ia2ia_symmtry_op(ia,iopr))
                sum2=sum2+hsr(ja,lmt1,lmt2,is)* &
                     ylm_sym(iopr,ii)* &
                     ylm_sym(iopr,jj)
             end do
             sum2=sum2/dble(nopr)
             
             do ir=1,nrc
                n1nc(ir,is)=n1nc(ir,is)+fac* &
                     psirpw(ir,il1,it1,it)* &
                     psirpw(ir,il2,it2,it)* &
                     sum2
             end do
          end do
          
       end do
    end do
    
    do is=1,nspin
       do ir=1,nrc
          n1nc(ir,is)=(n1nc(ir,is)+rhcorpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it) 
       end do
    end do
    deallocate(ylm_sym)
    call tstatc0_end(id_sname)
    return
  end subroutine m_PAWCD_set_ae_cd_sym
    
  subroutine m_PAWCD_set_ae_vd_sym(vec0,ia,nspin,nrc,n1nc)
    integer,intent(in) :: ia,nspin,nrc
    real(DP),intent(in) :: vec0(3) 
    real(8),intent(out):: n1nc(nrc,nspin)
    
    real(8):: n1(nrc,nspin),sum,fac,sum2
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj
    integer:: ja,iopr
    real(DP),pointer,dimension(:,:):: ylm_sym
    
    allocate(ylm_sym(nopr+af,25))
    ylm_sym=0.d0
    call set_ylms_symmtry_op(ia,25,vec0,ylm_sym)
    
    it=ityp(ia)
    
    n1nc=0.d0
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1   
       do lmt2=lmt1,ilmt(it)
          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2  
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
          
          do is=1,nspin
             sum2=0.d0
             do iopr=1,nopr
                ja=abs(ia2ia_symmtry_op(ia,iopr))
                sum2=sum2+hsr(ja,lmt1,lmt2,is)* &
                     ylm_sym(iopr,ii)* &
                     ylm_sym(iopr,jj)
             end do
             sum2=sum2/dble(nopr)
             
             do ir=1,nrc
                n1nc(ir,is)=n1nc(ir,is)+fac* &
                     psirpw(ir,il1,it1,it)* &
                     psirpw(ir,il2,it2,it)* &
                     sum2
             end do
          end do
          
       end do
    end do
    
    do is=1,nspin
       do ir=1,nrc
          n1nc(ir,is)=n1nc(ir,is)/radr_paw(ir,it)/radr_paw(ir,it) 
       end do
    end do
    deallocate(ylm_sym)
    return
  end subroutine m_PAWCD_set_ae_vd_sym
  
  subroutine m_PAWCD_set_ae_der_cd(ith,iph,ia,nspin,nrc,dn1_dth,dn1_dph)
    integer,intent(in) :: ith,iph,ia,nspin,nrc
    real(8),intent(out):: dn1_dth(nrc,nspin)
    real(8),intent(out):: dn1_dph(nrc,nspin)
    
    real(8):: n1(nrc,nspin),sum1,sum2,fac,bb
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj
    real(8):: sin_theta
    integer :: id_sname = -1
    call tstatc0_begin('m_PAWCD_set_ae_der_cd ',id_sname)
    
    sin_theta=sqrt(1.d0-cos_theta(ith)**2)
        
    it=ityp(ia)
    dn1_dth=0.d0
    dn1_dph=0.d0
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1   
       do lmt2=lmt1,ilmt(it)
          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2  
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
          sum1=   dylm_dth(ith,iph,ii)* &
               ylm(ith,iph,jj)+ &
               ylm(ith,iph,ii)* &
               dylm_dth(ith,iph,jj)
          sum2=   dylm_dph(ith,iph,ii)* &
               ylm(ith,iph,jj)+ &
               ylm(ith,iph,ii)* &
               dylm_dph(ith,iph,jj)
          do is=1,nspin
             bb=fac*hsr(ia,lmt1,lmt2,is)
             do ir=1,nrc
                dn1_dth(ir,is)=dn1_dth(ir,is)+bb*sum1* &
                     psirpw(ir,il1,it1,it)* &
                     psirpw(ir,il2,it2,it)
                dn1_dph(ir,is)=dn1_dph(ir,is)+bb*sum2* &
                     psirpw(ir,il1,it1,it)* &
                     psirpw(ir,il2,it2,it)
             end do
          end do
       end do
    end do
    do is=1,nspin
       do ir=1,nrc
          dn1_dth(ir,is)=dn1_dth(ir,is)/radr_paw(ir,it)**3
          dn1_dph(ir,is)=dn1_dph(ir,is)/radr_paw(ir,it)**3
       end do
    end do
    dn1_dph=dn1_dph/sin_theta
    
    call tstatc0_end(id_sname)
    return
  end subroutine m_PAWCD_set_ae_der_cd
  
  subroutine m_PAWCD_set_ae_der_cd2(ith,iph,ia,nspin,nrc,dn1_dth,dn1_dph)
    integer,intent(in) :: ith,iph,ia,nspin,nrc
    real(8),intent(out):: dn1_dth(nrc,nspin)
    real(8),intent(out):: dn1_dph(nrc,nspin)
    
    real(8):: n1(nrc,nspin),sum1,sum2,fac,bb
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj
    real(8):: sin_theta
    
    sin_theta=sqrt(1.d0-cos_theta(ith)**2)
    
    it=ityp(ia)
    do is=1,nspin
       do ir=1,nrc
          sum1=0.d0
          sum2=0.d0
          do lmt1=1,ilmt(it)
             il1=ltp(lmt1,it)
             im1=mtp(lmt1,it)
             it1=taup(lmt1,it)
             ii=(il1-1)**2+im1   
             do lmt2=lmt1,ilmt(it)
                il2=ltp(lmt2,it)
                im2=mtp(lmt2,it)
                it2=taup(lmt2,it)
                jj=(il2-1)**2+im2  
                fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                
                bb=fac*hsr(ia,lmt1,lmt2,is)* &
                     psirpw(ir,il1,it1,it)* &
                     psirpw(ir,il2,it2,it)
                sum1=sum1+bb* &
                     (dylm_dth(ith,iph,ii)* &
                     ylm(ith,iph,jj)+ &
                     ylm(ith,iph,ii)* &
                     dylm_dth(ith,iph,jj))
                sum2=sum2+bb* &
                     (dylm_dph(ith,iph,ii)* &
                     ylm(ith,iph,jj)+ &
                     ylm(ith,iph,ii)* &
                     dylm_dph(ith,iph,jj))
             end do
          end do
          dn1_dth(ir,is)=sum1/radr_paw(ir,it)**3
          dn1_dph(ir,is)=sum2/radr_paw(ir,it)**3
       end do
    end do
    dn1_dph=dn1_dph/sin_theta
    
    return
  end subroutine m_PAWCD_set_ae_der_cd2
  
  subroutine m_PAWCD_set_ae_der_cd_sym(vec0,ith,iph,ia,nspin,nrc,&
       &                               dn1_dth,dn1_dph)
    real(8),intent(in) :: vec0(3)
    integer,intent(in) :: ith,iph,ia,nspin,nrc
    real(8),intent(out):: dn1_dth(nrc,nspin)
    real(8),intent(out):: dn1_dph(nrc,nspin)
    
    real(8):: n1(nrc,nspin),fac,bb,bb1,bb2
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj
    real(8):: sin_theta
    integer:: ja,iopr,n
    real(DP),pointer,dimension(:,:):: ylm_sym
    real(DP),pointer,dimension(:,:):: dylm_dth_sym
    real(DP),pointer,dimension(:,:):: dylm_dph_sym
    integer :: id_sname = -1
    call tstatc0_begin('m_PAWCD_set_ae_der_cd_sym ',id_sname)
    
    call m_PP_find_maximum_l(n)
    n=(n-1)+(n-1)+1
    
    allocate(ylm_sym(nopr+af,n**2))
    allocate(dylm_dth_sym(nopr+af,n**2))
    allocate(dylm_dph_sym(nopr+af,n**2))
    ylm_sym=0.d0
    dylm_dth_sym=0.d0
    dylm_dph_sym=0.d0
    call set_diff_ylms_symmtry_op(ia,n**2,vec0,ylm_sym &
         ,dylm_dth_sym &
         ,dylm_dph_sym)
    
    sin_theta=sqrt(1.d0-cos_theta(ith)**2)
    
    it=ityp(ia)
    dn1_dth=0.d0
    dn1_dph=0.d0
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1   
       do lmt2=lmt1,ilmt(it)
          if(nspin==1 .and.dabs(hsr(ia,lmt1,lmt2,1)) < 1.d-10) cycle
          if(nspin==2 .and.dabs(hsr(ia,lmt1,lmt2,1))+dabs(hsr(ia,lmt1,lmt2,2))<1.d-10) cycle
          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2  
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                
          do is=1,nspin
!                    bb1= fac*hsr(ia,lmt1,lmt2,is)* &
!                               (dylm_dth(ith,iph,ii)* &
!                                ylm(ith,iph,jj)+ &
!                                ylm(ith,iph,ii)* &
!                                dylm_dth(ith,iph,jj))
!                    bb2= fac*hsr(ia,lmt1,lmt2,is)*&
!                               (dylm_dph(ith,iph,ii)* &
!                                ylm(ith,iph,jj)+ &
!                                ylm(ith,iph,ii)* &
!                                dylm_dph(ith,iph,jj))
                                
             bb1=0.d0
             do iopr=1,nopr
                ja=abs(ia2ia_symmtry_op(ia,iopr))
                bb1=bb1+hsr(ja,lmt1,lmt2,is)* &
                     (dylm_dth_sym(iopr,ii)* &
                     ylm_sym(iopr,jj)+ &
                     ylm_sym(iopr,ii)* &
                     dylm_dth_sym(iopr,jj))
             end do
             bb1=bb1/dble(nopr)*fac
             
             bb2=0.d0
             do iopr=1,nopr
                ja=abs(ia2ia_symmtry_op(ia,iopr))
                bb2=bb2+hsr(ja,lmt1,lmt2,is)* &
                     (dylm_dph_sym(iopr,ii)* &
                     ylm_sym(iopr,jj)+ &
                     ylm_sym(iopr,ii)* &
                     dylm_dph_sym(iopr,jj))
             end do
             bb2=bb2/dble(nopr)*fac
             
             do ir=1,nrc
                bb= psirpw(ir,il1,it1,it)* &
                     psirpw(ir,il2,it2,it)
                dn1_dth(ir,is)=dn1_dth(ir,is)+bb*bb1
                dn1_dph(ir,is)=dn1_dph(ir,is)+bb*bb2
             end do
          end do
          
       end do
    end do
    
    do is=1,nspin
       do ir=1,nrc
          dn1_dth(ir,is)=dn1_dth(ir,is)/radr_paw(ir,it)**3
          dn1_dph(ir,is)=dn1_dph(ir,is)/radr_paw(ir,it)**3
       end do
    end do
    dn1_dph=dn1_dph/sin_theta
     
    deallocate(ylm_sym,dylm_dth_sym,dylm_dph_sym)
    call tstatc0_end(id_sname)
    return
  end subroutine m_PAWCD_set_ae_der_cd_sym
   
  subroutine m_PAWCD_set_ps_cd(ith,iph,ia,nspin,nrc,nps)
    integer,intent(in) :: ith,iph,ia,nspin,nrc
    real(8),intent(out):: nps(nrc,nspin)
        
    real(8):: sum,fac
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2,l3
    integer:: ii,jj,n,ilm3,iiqitg
    integer,pointer,dimension(:):: il3
    real(8),pointer,dimension(:):: qsum
    
    call m_PP_find_maximum_l(n)
    n=(n-1)+(n-1)+1
    allocate(il3(n**2));call substitute_il3(n**2,il3)
    allocate(qsum(nrc))
    
    it=ityp(ia)
    nps=0.d0
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1   
       do lmt2=lmt1,ilmt(it)
          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2  
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
          qsum=0.d0
          do n=1,il2p(lmt1,lmt2,it)
             ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
             iiqitg=iqitg(il1,it1,il2,it2,l3+1,it)
             if(iiqitg==0) cycle
             do ir=1,nrc
                qsum(ir)=qsum(ir)+qrspspw(ir,iiqitg)* &
                     dl2p(lmt1,lmt2,n,it)* &
                     ylm(ith,iph,ilm3)
             end do
          end do
          do is=1,nspin
             do ir=1,nrc
                nps(ir,is)=nps(ir,is)+fac*hsr(ia,lmt1,lmt2,is)* &
                     (phirpw(ir,il1,it1,it)* &
                     phirpw(ir,il2,it2,it)* &
                     ylm(ith,iph,ii)* &
                     ylm(ith,iph,jj)+qsum(ir))
             end do
          end do
       end do
    end do
    do is=1,nspin
       do ir=1,nrc
          nps(ir,is)=(nps(ir,is)+rhpcrpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it) 
          if(nps(ir,is).lt.0.d0) nps(ir,is)=0.d0
       end do
    end do
    
    deallocate(il3,qsum)
    return
  end subroutine m_PAWCD_set_ps_cd
  
  subroutine m_PAWCD_set_ps_cd2(ith,iph,ia,nspin,nrc,nps)
    integer,intent(in) :: ith,iph,ia,nspin,nrc
    real(8),intent(out):: nps(nrc,nspin)
    
    real(8):: sum,fac,qsum
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2,l3
    integer:: ii,jj,n,ilm3,iiqitg
    integer,pointer,dimension(:):: il3
    
    call m_PP_find_maximum_l(n)
    n=(n-1)+(n-1)+1
    allocate(il3(n**2));call substitute_il3(n**2,il3)
    
    it=ityp(ia)
    do is=1,nspin
       do ir=1,nrc
          sum=0.d0
          do lmt1=1,ilmt(it)
             il1=ltp(lmt1,it)
             im1=mtp(lmt1,it)
             it1=taup(lmt1,it)
             ii=(il1-1)**2+im1   
             do lmt2=lmt1,ilmt(it)
                il2=ltp(lmt2,it)
                im2=mtp(lmt2,it)
                it2=taup(lmt2,it)
                jj=(il2-1)**2+im2  
                fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                qsum=0.d0
                do n=1,il2p(lmt1,lmt2,it)
                   ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
                   iiqitg=iqitg(il1,it1,il2,it2,l3+1,it)
                   if(iiqitg==0) cycle
                   qsum=qsum+qrspspw(ir,iiqitg)* &
                        dl2p(lmt1,lmt2,n,it)* &
                        ylm(ith,iph,ilm3)
                end do
                sum=sum+fac*hsr(ia,lmt1,lmt2,is)* &
                     (phirpw(ir,il1,it1,it)* &
                     phirpw(ir,il2,it2,it)* &
                     ylm(ith,iph,ii)* &
                     ylm(ith,iph,jj)+qsum)
             end do
          end do
          nps(ir,is)=(sum+rhpcrpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it)
          if(nps(ir,is).lt.0.d0) nps(ir,is)=0.d0
       end do
    end do
    
    deallocate(il3)
    return
  end subroutine m_PAWCD_set_ps_cd2
    
  subroutine m_PAWCD_set_ps_cd_sym(vec0,ia,nspin,nrc,nps)
    integer,intent(in) :: ia,nspin,nrc
    real(DP),intent(in):: vec0(3)
    real(8),intent(out):: nps(nrc,nspin)
    
    real(8):: sum,fac,sum2,sum3
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2,l3
    integer:: ii,jj,n,ilm3,iiqitg
    integer,pointer,dimension(:):: il3
    real(DP),pointer,dimension(:):: qsum
    integer:: ja,iopr
    real(DP),pointer,dimension(:,:):: ylm_sym
    integer :: id_sname = -1
    call tstatc0_begin('m_PAWCD_set_ps_cd_sym ',id_sname)
    
    call m_PP_find_maximum_l(n)
    n=(n-1)+(n-1)+1
    allocate(il3(n**2));call substitute_il3(n**2,il3)
        
    allocate(ylm_sym(nopr+af,n**2))
    ylm_sym=0.d0
    call set_ylms_symmtry_op(ia,n**2,vec0,ylm_sym)
    
    allocate(qsum(nrc))
    
    it=ityp(ia)
    sum=0.d0
    nps=0.d0
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1   
       do lmt2=lmt1,ilmt(it)
          if(nspin==1 .and.dabs(hsr(ia,lmt1,lmt2,1)) < 1.d-10) cycle
          if(nspin==2 .and.dabs(hsr(ia,lmt1,lmt2,1))+dabs(hsr(ia,lmt1,lmt2,2))<1.d-10) cycle
          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2  
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
          
          do is=1,nspin
             
             sum2=0.d0
             do iopr=1,nopr
                ja=abs(ia2ia_symmtry_op(ia,iopr))
                sum2=sum2+hsr(ja,lmt1,lmt2,is)* &
                     ylm_sym(iopr,ii)* &
                     ylm_sym(iopr,jj)
             end do
             sum2=sum2/dble(nopr)
             
             qsum=0.d0
             do n=1,il2p(lmt1,lmt2,it)
                ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
                iiqitg=iqitg(il1,it1,il2,it2,l3+1,it)
                if(iiqitg==0) cycle
                
                sum3=0.d0
                do iopr=1,nopr
                   ja=abs(ia2ia_symmtry_op(ia,iopr))
                   sum3=sum3+hsr(ja,lmt1,lmt2,is)* &
                        ylm_sym(iopr,ilm3)
                end do
                sum3=sum3/dble(nopr)
                
                do ir=1,nrc
                   qsum(ir)=qsum(ir)+qrspspw(ir,iiqitg)* &
                        dl2p(lmt1,lmt2,n,it)* &
                        sum3
                end do
             end do
             
             do ir=1,nrc
                nps(ir,is)=nps(ir,is)+fac* &
                     phirpw(ir,il1,it1,it)* &
                     phirpw(ir,il2,it2,it)* &
                     sum2 + &
                     fac*qsum(ir)
                
             end do
          end do
                        
       end do
    end do
    
    do is=1,nspin
       do ir=1,nrc
          nps(ir,is)=(nps(ir,is)+rhpcrpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it)
          if(nps(ir,is).lt.0.d0) nps(ir,is)=0.d0
       end do
    end do
    
    deallocate(il3,ylm_sym,qsum)
    call tstatc0_end(id_sname)
    return
  end subroutine m_PAWCD_set_ps_cd_sym
    
  subroutine m_PAWCD_set_ps_cd_sym2(vec0,ia,nspin,nrc,nps)
    integer,intent(in) :: ia,nspin,nrc
    real(DP),intent(in):: vec0(3)
    real(8),intent(out):: nps(nrc,nspin)
    
    real(8):: sum,fac,qsum,sum2,sum3
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2,l3
    integer:: ii,jj,n,ilm3,iiqitg
    integer,pointer,dimension(:):: il3
    integer:: ja,iopr
    real(DP),pointer,dimension(:,:):: ylm_sym
    
    call m_PP_find_maximum_l(n)
    n=(n-1)+(n-1)+1
    allocate(il3(n**2));call substitute_il3(n**2,il3)
    
    allocate(ylm_sym(nopr+af,25))
    ylm_sym=0.d0
    call set_ylms_symmtry_op(ia,25,vec0,ylm_sym)
    
    it=ityp(ia)
    do is=1,nspin
       do ir=1,nrc
          sum=0.d0
          do lmt1=1,ilmt(it)
             il1=ltp(lmt1,it)
             im1=mtp(lmt1,it)
             it1=taup(lmt1,it)
             ii=(il1-1)**2+im1   
             do lmt2=lmt1,ilmt(it)
                il2=ltp(lmt2,it)
                im2=mtp(lmt2,it)
                it2=taup(lmt2,it)
                jj=(il2-1)**2+im2  
                fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                
                sum2=0.d0
                do iopr=1,nopr
                   ja=abs(ia2ia_symmtry_op(ia,iopr))
                   sum2=sum2+hsr(ja,lmt1,lmt2,is)* &
                        ylm_sym(iopr,ii)* &
                        ylm_sym(iopr,jj)
                end do
                sum2=sum2/dble(nopr)
                
                qsum=0.d0
                do n=1,il2p(lmt1,lmt2,it)
                   ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
                   iiqitg=iqitg(il1,it1,il2,it2,l3+1,it)
                   if(iiqitg==0) cycle
                   
                   sum3=0.d0
                   do iopr=1,nopr
                      ja=abs(ia2ia_symmtry_op(ia,iopr))
                      sum3=sum3+hsr(ja,lmt1,lmt2,is)* &
                           ylm_sym(iopr,ilm3)
                   end do
                   sum3=sum3/dble(nopr)
                   
                   qsum=qsum+qrspspw(ir,iiqitg)* &
                        dl2p(lmt1,lmt2,n,it)* &
                        sum3
                end do
                
                sum=sum+fac* &
                     phirpw(ir,il1,it1,it)* &
                     phirpw(ir,il2,it2,it)* &
                     sum2 + &
                     fac*qsum
                
             end do
          end do
          nps(ir,is)=(sum+rhpcrpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it) 
          if(nps(ir,is).lt.0.d0) nps(ir,is)=0.d0
       end do
    end do
    
    deallocate(il3,ylm_sym)
    return
  end subroutine m_PAWCD_set_ps_cd_sym2
    
  subroutine m_PAWCD_set_ps_der_cd(ith,iph,ia,nspin,nrc,dnps_dth,dnps_dph)
    integer,intent(in) :: ith,iph,ia,nspin,nrc
    real(8),intent(out):: dnps_dth(nrc,nspin)
    real(8),intent(out):: dnps_dph(nrc,nspin)
    
    real(8):: sum1,sum2,fac,qc,sin_theta
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2,l3
    integer:: ii,jj,n,ilm3,iiqitg
    integer,pointer,dimension(:):: il3
    real(8),pointer,dimension(:):: qsum1,qsum2
    
    allocate(qsum1(nrc))
    allocate(qsum2(nrc))
    
    call m_PP_find_maximum_l(n)
    n=(n-1)+(n-1)+1
    allocate(il3(n**2));call substitute_il3(n**2,il3)
    
    sin_theta=sqrt(1.d0-cos_theta(ith)**2)
    
    it=ityp(ia)
    dnps_dth=0.d0
    dnps_dph=0.d0
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1   
       do lmt2=lmt1,ilmt(it)
          if(nspin==1 .and.dabs(hsr(ia,lmt1,lmt2,1)) < 1.d-10) cycle
          if(nspin==2 .and.dabs(hsr(ia,lmt1,lmt2,1))+dabs(hsr(ia,lmt1,lmt2,2))<1.d-10) cycle
          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2  
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
          qsum1=0.d0
          qsum2=0.d0
          do n=1,il2p(lmt1,lmt2,it)
             ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
             iiqitg=iqitg(il1,it1,il2,it2,l3+1,it)
             if(iiqitg==0) cycle
             do ir=1,nrc
                qc=qrspspw(ir,iiqitg)* &
                     dl2p(lmt1,lmt2,n,it)
                qsum1(ir)=qsum1(ir)+qc*dylm_dth(ith,iph,ilm3)
                qsum2(ir)=qsum2(ir)+qc*dylm_dph(ith,iph,ilm3)
             end do
          end do
          sum1=dylm_dth(ith,iph,ii)* &
               ylm(ith,iph,jj)+ &
               ylm(ith,iph,ii)* &
               dylm_dth(ith,iph,jj)
          sum2=dylm_dph(ith,iph,ii)* &
               ylm(ith,iph,jj)+ &
               ylm(ith,iph,ii)* &
               dylm_dph(ith,iph,jj)
          do is=1,nspin
             do ir=1,nrc
                dnps_dth(ir,is)=dnps_dth(ir,is)+fac*hsr(ia,lmt1,lmt2,is)* &
                     (phirpw(ir,il1,it1,it)* &
                     phirpw(ir,il2,it2,it)* &
                                                    sum1+qsum1(ir))
                dnps_dph(ir,is)=dnps_dph(ir,is)+fac*hsr(ia,lmt1,lmt2,is)* &
                     (phirpw(ir,il1,it1,it)* &
                     phirpw(ir,il2,it2,it)* &
                     sum2+qsum2(ir))
             end do
          end do
       end do
    end do
    do is=1,nspin
       do ir=1,nrc
          dnps_dth(ir,is)=dnps_dth(ir,is)/radr_paw(ir,it)**3 
          dnps_dph(ir,is)=dnps_dph(ir,is)/radr_paw(ir,it)**3 
       end do
    end do
    
    dnps_dph=dnps_dph/sin_theta
        
    deallocate(il3,qsum1,qsum2)
    return
  end subroutine m_PAWCD_set_ps_der_cd
    
  subroutine m_PAWCD_set_ps_der_cd2(ith,iph,ia,nspin,nrc,dnps_dth,dnps_dph)
    integer,intent(in) :: ith,iph,ia,nspin,nrc
    real(8),intent(out):: dnps_dth(nrc,nspin)
    real(8),intent(out):: dnps_dph(nrc,nspin)
    
    real(8):: sum1,sum2,fac,qsum1,qsum2,qc,sin_theta
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2,l3
    integer:: ii,jj,n,ilm3,iiqitg
    integer,pointer,dimension(:):: il3
    
    call m_PP_find_maximum_l(n)
    n=(n-1)+(n-1)+1
    allocate(il3(n**2));call substitute_il3(n**2,il3)
    
    sin_theta=sqrt(1.d0-cos_theta(ith)**2)
    
    it=ityp(ia)
    do is=1,nspin
       do ir=1,nrc
          sum1=0.d0
          sum2=0.d0
          do lmt1=1,ilmt(it)
             il1=ltp(lmt1,it)
             im1=mtp(lmt1,it)
             it1=taup(lmt1,it)
             ii=(il1-1)**2+im1   
             do lmt2=lmt1,ilmt(it)
                il2=ltp(lmt2,it)
                im2=mtp(lmt2,it)
                it2=taup(lmt2,it)
                jj=(il2-1)**2+im2  
                fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                qsum1=0.d0
                qsum2=0.d0
                do n=1,il2p(lmt1,lmt2,it)
                   ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
                   iiqitg=iqitg(il1,it1,il2,it2,l3+1,it)
                   if(iiqitg==0) cycle
                   qc=qrspspw(ir,iiqitg)* &
                        dl2p(lmt1,lmt2,n,it)
                   qsum1=qsum1+qc*dylm_dth(ith,iph,ilm3)
                   qsum2=qsum2+qc*dylm_dph(ith,iph,ilm3)
                end do
                sum1=sum1+fac*hsr(ia,lmt1,lmt2,is)* &
                     (phirpw(ir,il1,it1,it)* &
                     phirpw(ir,il2,it2,it)* &
                     (dylm_dth(ith,iph,ii)* &
                     ylm(ith,iph,jj)+ &
                     ylm(ith,iph,ii)* &
                     dylm_dth(ith,iph,jj))+qsum1)
                sum2=sum2+fac*hsr(ia,lmt1,lmt2,is)* &
                     (phirpw(ir,il1,it1,it)* &
                     phirpw(ir,il2,it2,it)* &
                     (dylm_dph(ith,iph,ii)* &
                     ylm(ith,iph,jj)+ &
                     ylm(ith,iph,ii)* &
                            dylm_dph(ith,iph,jj))+qsum2)
             end do
          end do
          dnps_dth(ir,is)=sum1/radr_paw(ir,it)**3 
          dnps_dph(ir,is)=sum2/radr_paw(ir,it)**3 
       end do
    end do
        
    dnps_dph=dnps_dph/sin_theta
        
    deallocate(il3)
    return
  end subroutine m_PAWCD_set_ps_der_cd2
    
  subroutine m_PAWCD_set_ps_der_cd_sym(vec0,ith,iph,ia,nspin,nrc,&
       &                               dnps_dth,dnps_dph)
    real(8),intent(in) :: vec0(3)
    integer,intent(in) :: ith,iph,ia,nspin,nrc
    real(8),intent(out):: dnps_dth(nrc,nspin)
    real(8),intent(out):: dnps_dph(nrc,nspin)
    
    real(8):: fac,qc,bb1,bb2,sin_theta,cc1,cc2
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2,l3
    integer:: ii,jj,n,ilm3,iiqitg
    integer,pointer,dimension(:):: il3
    real(DP),pointer,dimension(:):: qsum1,qsum2
    integer:: ja,iopr
    real(DP),pointer,dimension(:,:):: ylm_sym
    real(DP),pointer,dimension(:,:):: dylm_dth_sym
    real(DP),pointer,dimension(:,:):: dylm_dph_sym
    integer :: id_sname = -1
    call tstatc0_begin('m_PAWCD_set_ps_der_cd_sym ',id_sname)
        
    call m_PP_find_maximum_l(n)
    n=(n-1)+(n-1)+1
    allocate(il3(n**2));call substitute_il3(n**2,il3)
    
    allocate(ylm_sym(nopr+af,n**2))
    allocate(dylm_dth_sym(nopr+af,n**2))
    allocate(dylm_dph_sym(nopr+af,n**2))
    ylm_sym=0.d0
    dylm_dth_sym=0.d0
    dylm_dph_sym=0.d0
    call set_diff_ylms_symmtry_op(ia,n**2,vec0,ylm_sym &
         ,dylm_dth_sym &
         ,dylm_dph_sym)
    
    allocate(qsum1(nrc))
    allocate(qsum2(nrc))
    
    sin_theta=sqrt(1.d0-cos_theta(ith)**2)
    
    it=ityp(ia)
    dnps_dth=0.d0
    dnps_dph=0.d0
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1   
       do lmt2=lmt1,ilmt(it)
          if(nspin==1 .and.dabs(hsr(ia,lmt1,lmt2,1)) < 1.d-10) cycle
          if(nspin==2 .and.dabs(hsr(ia,lmt1,lmt2,1))+dabs(hsr(ia,lmt1,lmt2,2))<1.d-10) cycle
          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2  
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
          
          if(ipripaw >= 2) then
             iiqitg = 0
             do n=1,il2p(lmt1,lmt2,it)
                ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
                if(iqitg(il1,it1,il2,it2,l3+1,it)>0) iiqitg=iiqitg+1
             end do
             write(nfout,'(" it, lmt1, lmt2, il2p iiqitg/=0 = ",5i8)') it, lmt1, lmt2,il2p(lmt1,lmt2,it),iiqitg
             if(iiqitg > 0) then
                do n=1,il2p(lmt1,lmt2,it)
                   ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
!                         write(nfout,'("        il1,im1,it1, il2,im2,it2, n, iiqitg = ",8i6)') il1,im1,it1,il2,im2,it2, n, iqitg(il1,it1,il2,it2,l3+1,it)
                end do
             end if
          end if
          
          do is=1,nspin
!                    bb1=fac*hsr(ia,lmt1,lmt2,is)*( &
!                                dylm_dth(ith,iph,ii)* &
!                                ylm(ith,iph,jj)+ &
!                                ylm(ith,iph,ii)* &
!                                dylm_dth(ith,iph,jj))

             bb1=0.d0
             do iopr=1,nopr
                ja=abs(ia2ia_symmtry_op(ia,iopr))
                bb1=bb1+hsr(ja,lmt1,lmt2,is)*( &
                     dylm_dth_sym(iopr,ii)* &
                     ylm_sym(iopr,jj)+ &
                     ylm_sym(iopr,ii)* &
                     dylm_dth_sym(iopr,jj))
             end do
             bb1=bb1/dble(nopr)*fac
             
!                    bb2=fac*hsr(ia,lmt1,lmt2,is)*( &
!                                dylm_dph(ith,iph,ii)* &
!                                ylm(ith,iph,jj)+ &
!                                ylm(ith,iph,ii)* &
!                                dylm_dph(ith,iph,jj))

             bb2=0.d0
             do iopr=1,nopr
                ja=abs(ia2ia_symmtry_op(ia,iopr))
                bb2=bb2+hsr(ja,lmt1,lmt2,is)*( &
                     dylm_dph_sym(iopr,ii)* &
                     ylm_sym(iopr,jj)+ &
                     ylm_sym(iopr,ii)* &
                     dylm_dph_sym(iopr,jj))
             end do
             bb2=bb2/dble(nopr)*fac
             
             qsum1=0.d0
             qsum2=0.d0
             do n=1,il2p(lmt1,lmt2,it)
                ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
                iiqitg=iqitg(il1,it1,il2,it2,l3+1,it)
                if(iiqitg==0) cycle
                
                cc1=0.d0
                do iopr=1,nopr
                   ja=abs(ia2ia_symmtry_op(ia,iopr))
                   cc1=cc1+dylm_dth_sym(iopr,ilm3)*hsr(ja,lmt1,lmt2,is)
                end do
                cc1=cc1/dble(nopr)*dl2p(lmt1,lmt2,n,it)
                
                cc2=0.d0
                do iopr=1,nopr
                   ja=abs(ia2ia_symmtry_op(ia,iopr))
                   cc2=cc2+dylm_dph_sym(iopr,ilm3)*hsr(ja,lmt1,lmt2,is)
                end do
                cc2=cc2/dble(nopr)*dl2p(lmt1,lmt2,n,it)
                        
                do ir=1,nrc
                   qc=qrspspw(ir,iiqitg)
                   qsum1(ir)=qsum1(ir)+qc*cc1
                   qsum2(ir)=qsum2(ir)+qc*cc2
                end do
             end do
             qsum1=qsum1*fac
             qsum2=qsum2*fac
             
             do ir=1,nrc
!                        qsum1=0.d0
!                        qsum2=0.d0
!                        do n=1,il2p(lmt1,lmt2,it)
!                            ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
!                            iiqitg=iqitg(il1,it1,il2,it2,l3+1,it)
!                            if(iiqitg==0) cycle
!                            qc=qrspspw(ir,iiqitg)* &
!                                        dl2p(lmt1,lmt2,n,it)
!                            qsum1=qsum1+qc*dylm_dth(ith,iph,ilm3)*hsr(ia,lmt1,lmt2,is)
!                            qsum2=qsum2+qc*dylm_dph(ith,iph,ilm3)*hsr(ia,lmt1,lmt2,is)
!                        end do
!                        qsum1=qsum1*fac
!                        qsum2=qsum2*fac
!                        dnps_dth(ir,is)=dnps_dth(ir,is)+ &
!                                fac*hsr(ia,lmt1,lmt2,is)* &
!                                (phirpw(ir,il1,it1,it)* &
!                                phirpw(ir,il2,it2,it)* &
!                                (dylm_dth(ith,iph,ii)* &
!                                ylm(ith,iph,jj)+ &
!                                ylm(ith,iph,ii)* &
!                                dylm_dth(ith,iph,jj))+qsum1)
                                
                dnps_dth(ir,is)=dnps_dth(ir,is)+ &
                     bb1*phirpw(ir,il1,it1,it)* &
                     phirpw(ir,il2,it2,it)+ &
                     qsum1(ir)
                                
!                        dnps_dph(ir,is)=dnps_dph(ir,is)+ &
!                                fac*hsr(ia,lmt1,lmt2,is)* &
!                                (phirpw(ir,il1,it1,it)* &
!                                phirpw(ir,il2,it2,it)* &
!                                (dylm_dph(ith,iph,ii)* &
!                                ylm(ith,iph,jj)+ &
!                                ylm(ith,iph,ii)* &
!                                dylm_dph(ith,iph,jj))+qsum2)

                dnps_dph(ir,is)=dnps_dph(ir,is)+ &
                     bb2*phirpw(ir,il1,it1,it)* &
                     phirpw(ir,il2,it2,it)+ &
                     qsum2(ir)
                
             end do
          end do
          
       end do
    end do
            
    do is=1,nspin
       do ir=1,nrc
          dnps_dth(ir,is)=dnps_dth(ir,is)/radr_paw(ir,it)**3 
          dnps_dph(ir,is)=dnps_dph(ir,is)/radr_paw(ir,it)**3 
       end do
    end do
    
    dnps_dph=dnps_dph/sin_theta
    
    deallocate(il3,qsum1,qsum2)
    deallocate(ylm_sym,dylm_dth_sym,dylm_dph_sym)
    call tstatc0_end(id_sname)
    return
  end subroutine m_PAWCD_set_ps_der_cd_sym
    
  subroutine m_PAWCD_wd_cd(nfout)
    integer,intent(in):: nfout
    integer:: unit
    integer:: iloop !,ie,je,ke
    integer:: idp,nlp,nmp,nnp
    real(DP),allocatable,dimension(:) :: afft
    real(DP),pointer,dimension(:)      :: afft_mpi1  
    real(DP),pointer,dimension(:)      :: afft_mpi2
    real(DP),pointer,dimension(:)      :: afft_mpi3
    real(DP),pointer,dimension(:,:,:)  :: chg_rs
    logical:: flg_wrtn(natm)
        
    call m_FFT_alloc_CD_box()
    allocate(afft(ista_fftp:iend_fftp))
    allocate(afft_mpi1(nfftp))
    if(npes >= 2) then
       allocate(afft_mpi2(mp_fftp))
       allocate(afft_mpi3(mp_fftp))
    end if
    if(mype==0) then
       flg_wrtn=.false.
!            ie=fft_box_size_CD(1)
!            je=fft_box_size_CD(2)
!            ke=fft_box_size_CD(3)
!!$            idp = fft_box_size_CD(0)
!!$            nlp = fft_box_size_CD(1)
!!$            nmp = fft_box_size_CD(2)
!!$            nnp = fft_box_size_CD(3)
#ifdef _MPIFFT_
       idp  = fft_box_size_CD_c(1,0)
#else
       idp  = fft_box_size_CD(1,0)
#endif
       nlp  = fft_box_size_CD(1,1)
       nmp  = fft_box_size_CD(2,1)
       nnp  = fft_box_size_CD(3,1)
!            allocate(chg_rs(0:ie,0:je,0:ke))
       allocate(chg_rs(0:nlp,0:nmp,0:nnp))
       chg_rs=0.d0
       unit=unusedUnit()
       open(unit,file='nfchgt_paw.data',status='unknown',form='formatted')
    end if
        
    do iloop=1,nspin
       call map_charge_onto_a_fft_box_paw('soft')
       call m_FFT_CD_inverse0(nfout,afft)
!!$            call m_FFT_check_of_negative_CD(afft,nfout,nspin,iloop)
!!$            call m_FFT_check_of_negative_CD(npes,ista_fftp,iend_fftp&
!!$               & ,ista_fftph,iend_fftph,afft,nfout,nspin,iloop)
       if(mype == 0) then
          call m_FFT_cp_afft_CD(afft_mpi1)
          call get_cd_in_rspace
       end if
    end do
!call tmp
!stop        
    if(mype==0) then      
       call output_box_tecplot(chg_rs,altv,'chgsoft','cd',unit,0)
       deallocate(chg_rs)
    end if
    
    call m_FFT_dealloc_CD_box()
    deallocate(afft)
!!$deallocate(afft_mpi1)
    if(npes >= 2) then
       deallocate(afft_mpi2);deallocate(afft_mpi3)
    end if
    
    if(mype==0) then
!            call wd_ae_cd(unit)
!            call wd_averaged_ae_cd(unit)
!            call wd_ps_cd(unit)
!            call wd_averaged_ps_cd(unit)
!            call wd_valence_cd(unit)
!            call wd_averaged_valence_cd(unit)
       if(flg_symmtry) then
          call wd_averaged_ps_cd(unit) 
!                call wd_averaged_valence_cd(unit) 
       else
          call wd_ps_cd(unit)
!                call wd_valence_cd(unit)
       end if
       close(unit)
    end if
    
    return

  contains
    
    subroutine map_charge_onto_a_fft_box_paw(s_or_a)
      character(len=*),intent(in):: s_or_a 
      integer:: i,j,ip, ilast
      
      ilast = min(iend_kngp,kgp_reduced)
      afft_mpi1=0.d0
      select case(s_or_a)
      case('all')
         do j=1,kimg
!!$                    do i=ista_kngp,iend_kngp
            do i=ista_kngp,ilast
               ip=(igfp_l(i)-1)*kimg+j
               afft_mpi1(ip)=afft_mpi1(ip)+chgq_l(i,j,iloop)
            end do
         end do
      case('soft')
         do j=1,kimg
!!$                    do i=ista_kngp,iend_kngp
            do i=ista_kngp,ilast
               ip=(igfp_l(i)-1)*kimg+j
               afft_mpi1(ip)=afft_mpi1(ip)+chgsoft(i,j,iloop)
            end do
         end do
      case('hard')
         do j=1,kimg
!!$                    do i=ista_kngp,iend_kngp
            do i=ista_kngp,ilast
               ip=(igfp_l(i)-1)*kimg+j
               afft_mpi1(ip)=afft_mpi1(ip)+chgq_l(i,j,iloop)-chgsoft(i,j,iloop)
            end do
         end do
      case default
         write(6,*) 'Error in map_charge_onto_a_fft_box_paw !'
         write(6,*) 'Unknown a_or_s : ',s_or_a
         stop 
      end select
      
      if(npes >= 2) then
         call mpi_barrier(mpi_comm_group,ierr)
         do j=0,npes-1
            do i=nis_fftp(j),nie_fftp(j)
               afft_mpi2(i-nis_fftp(j)+1) = afft_mpi1(i)
            end do
            call mpi_allreduce(afft_mpi2,afft_mpi3,mp_fftp &
                 ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
            if(j==mype) then
               do i=ista_fftp,iend_fftp
                  afft(i)=afft_mpi3(i-ista_fftp+1)
               end do
            end if
         end do
      else
         afft=afft_mpi1
      end if
    end subroutine map_charge_onto_a_fft_box_paw
    
    subroutine get_cd_in_rspace
      integer:: i,j,k,ip
      integer:: ii,jj,kk
!real(8):: vec(3)            
!            do k=1,ke
!                do j=1,je
!	                do i=1,ie       
      do k=1,nnp
         do j=1,nmp
            do i=1,nlp
!                        ip = (ie+1)*je*(k-1) + (ie+1)*(j-1) + i
               ii=i
               jj=j
               kk=k
               if(kimg==1) then
                  if(2*(i-1).le.nlp) then
                     ii=2*i-1
                  else
                     ii=2*(-i+nlp+2)-1
                     jj=-j+nmp+2;if(j.eq.1) jj=1
                     kk=-k+nnp+2;if(k.eq.1) kk=1
                  end if
               end if
               ip = idp*nmp*(kk-1) + idp*(jj-1) + ii
               chg_rs(i-1,j-1,k-1) = chg_rs(i-1,j-1,k-1)+ &
                    afft_mpi1(ip*kimg+1-kimg)
!                                                afft_mpi1(2*ip-1)
!vec=(/dble(i)/dble(ie),dble(j)/dble(je),dble(k)/dble(ke)/)
!chg_rs(i-1,j-1,k-1)=getFFTValue(vec)
            end do
         end do
      end do
!            chg_rs(ie,:,:)=chg_rs(0,:,:)
!            chg_rs(:,je,:)=chg_rs(:,0,:)
!            chg_rs(:,:,ke)=chg_rs(:,:,0)
      chg_rs(nlp,:,:)=chg_rs(0,:,:)
      chg_rs(:,nmp,:)=chg_rs(:,0,:)
      chg_rs(:,:,nnp)=chg_rs(:,:,0)
      return
    end subroutine get_cd_in_rspace
        
    subroutine tmp
      integer:: idp,nlp,nmp,nnp
      integer:: i,j,k,n,nn
        
        
!!$            idp = fft_box_size_CD(0)
!!$            nlp = fft_box_size_CD(1)
!!$            nmp = fft_box_size_CD(2)
!!$            nnp = fft_box_size_CD(3)
#ifdef _MPIFFT_
      idp  = fft_box_size_CD_c(1,0)
#else
      idp  = fft_box_size_CD(1,0)
#endif
      nlp  = fft_box_size_CD(1,1)
      nmp  = fft_box_size_CD(2,1)
      nnp  = fft_box_size_CD(3,1)

      do n = 1,nfftp
         nn = (n+kimg-1)/kimg
         i  = mod(nn,idp)
         j  = mod((nn-1)/idp,nmp) + 1
         k  = (nn - (j-1)*idp - i)/(idp*nmp) + 1
!!$                print *,i,j,k,n,afft_mpi1(n)
      end do
      return
    end subroutine tmp
        
    function getFFTValue(vec,mode)
      real(8):: getFFTValue
      real(8),dimension(3),intent(inout):: vec
      character(len=*),intent(in):: mode
      integer:: i,is
      real(8):: value,phi,kk1,kk2,kk3
      
      value=0.d0
      select case(mode)
      case('soft')
         if(kimg==1) then
            do i=1,kgp
               kk1=dble(ngabc(i,1))
               kk2=dble(ngabc(i,2))
               kk3=dble(ngabc(i,3))
               phi=PAI2*(kk1*vec(1)+ &
                    kk2*vec(2)+ &
                    kk3*vec(3))
               do is=1,nspin
                  value=value+chgsoft(i,1,is)*cos(phi)
               end do
            end do
         else if(kimg==2) then
            do i=1,kgp
               kk1=dble(ngabc(i,1))
               kk2=dble(ngabc(i,2))
               kk3=dble(ngabc(i,3))
               phi=PAI2*(kk1*vec(1)+ &
                    kk2*vec(2)+ &
                    kk3*vec(3))
               do is=1,nspin
                  value=value+chgsoft(i,1,is)*cos(phi)- &
                       chgsoft(i,2,is)*sin(phi)
               end do
            end do
         end if
      end select
      getFFTValue=value
      return
    end function getFFTValue
      
    subroutine wd_ae_cd(unit)
      integer,intent(in):: unit
      integer:: ia,it,ith,iph,nrc,ir,is,ip
      integer:: lmt1,lmt2,il1,il2,im1,im2,it1,it2,ii,jj
      real(DP):: sint,cost,phi
      real(DP):: x0,y0,z0,xorg,yorg,zorg,pos1,pos2,pos3
      real(DP):: sum,fac,rr
      character(len=32):: title
      do ia=1,natm
         it=ityp(ia)
         if(ipaw(it)/=1) cycle
         nrc=wf_mnrc(it)
         pos1=pos(ia,1);if(pos1<0) pos1=pos1+1.d0
         pos2=pos(ia,2);if(pos2<0) pos2=pos2+1.d0
         pos3=pos(ia,3);if(pos3<0) pos3=pos3+1.d0
         xorg=altv(1,1)*pos1+altv(1,2)*pos2+altv(1,3)*pos3
         yorg=altv(2,1)*pos1+altv(2,2)*pos2+altv(2,3)*pos3
         zorg=altv(3,1)*pos1+altv(3,2)*pos2+altv(3,3)*pos3
         write(title,'("nae",i4.4)') ia
         write(unit,'(3a,i6,a,i6,a,i6,a)') &
              'ZONE T=',trim(title),'  I=',nrc &
              ,', J=',nphi+1 &
              ,', K=',ntheta &
              ,', F=POINT'
         do ith=1,ntheta
            cost=cos_theta(ith)
            sint=sqrt(1.d0-cost**2)
            do ip=1,nphi+1
               iph=ip
               if(ip.eq.nphi+1) iph=1
               phi=PAI2/dble(nphi)*dble(iph-1)
               x0=sint*cos(phi)
               y0=sint*sin(phi)
               z0=cost
               
               do ir=1,nrc
                  sum=0.d0
                  do is=1,nspin
                     do lmt1=1,ilmt(it)
                        il1=ltp(lmt1,it)
                        im1=mtp(lmt1,it)
                        it1=taup(lmt1,it)
                        ii=(il1-1)**2+im1   
                        do lmt2=lmt1,ilmt(it)
                           il2=ltp(lmt2,it)
                           im2=mtp(lmt2,it)
                           it2=taup(lmt2,it)
                           jj=(il2-1)**2+im2  
                           fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                           sum=sum+fac*hsr(ia,lmt1,lmt2,is)* &
                                psirpw(ir,il1,it1,it)* &
                                psirpw(ir,il2,it2,it)* &
                                ylm(ith,iph,ii)* &
                                ylm(ith,iph,jj)
                        end do
                     end do
                  end do
                  rr=radr_paw(ir,it)
                  write(unit,'(4e19.6)') xorg+x0*rr, &
                       yorg+y0*rr, &
                       zorg+z0*rr,sum/rr/rr
               end do
            end do
         end do
      end do
      
      return
    end subroutine wd_ae_cd
        
    subroutine wd_ps_cd(unit)
      integer,intent(in):: unit
      integer:: ia,it,ith,iph,nrc,ir,is,ip
      integer:: lmt1,lmt2,il1,il2,im1,im2,it1,it2,ii,jj
      real(DP):: sint,cost,phi
      real(DP):: x0,y0,z0,xorg,yorg,zorg,pos1,pos2,pos3
      real(DP):: sum,fac,rr
      character(len=32):: title
      do ia=1,natm
         it=ityp(ia)
         if(ipaw(it)/=1) cycle
         nrc=wf_mnrc(it)
         pos1=pos(ia,1);if(pos1<0) pos1=pos1+1.d0
         pos2=pos(ia,2);if(pos2<0) pos2=pos2+1.d0
         pos3=pos(ia,3);if(pos3<0) pos3=pos3+1.d0
         xorg=altv(1,1)*pos1+altv(1,2)*pos2+altv(1,3)*pos3
         yorg=altv(2,1)*pos1+altv(2,2)*pos2+altv(2,3)*pos3
         zorg=altv(3,1)*pos1+altv(3,2)*pos2+altv(3,3)*pos3
         write(title,'("nps",i4.4)') ia
         write(unit,'(3a,i6,a,i6,a,i6,a)') &
              'ZONE T=',trim(title),'  I=',nrc &
              ,', J=',nphi+1 &
              ,', K=',ntheta &
              ,', F=POINT'
         do ith=1,ntheta
            cost=cos_theta(ith)
            sint=sqrt(1.d0-cost**2)
            do ip=1,nphi+1
               iph=ip
               if(ip.eq.nphi+1) iph=1
               phi=PAI2/dble(nphi)*dble(iph-1)
               x0=sint*cos(phi)
               y0=sint*sin(phi)
               z0=cost
               
               do ir=1,nrc
                  sum=0.d0
                  do is=1,nspin
                     do lmt1=1,ilmt(it)
                        il1=ltp(lmt1,it)
                        im1=mtp(lmt1,it)
                        it1=taup(lmt1,it)
                        ii=(il1-1)**2+im1   
                        do lmt2=lmt1,ilmt(it)
                           il2=ltp(lmt2,it)
                           im2=mtp(lmt2,it)
                           it2=taup(lmt2,it)
                           jj=(il2-1)**2+im2  
                           fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                           sum=sum+fac*hsr(ia,lmt1,lmt2,is)* &
                                phirpw(ir,il1,it1,it)* &
                                phirpw(ir,il2,it2,it)* &
                                ylm(ith,iph,ii)* &
                                ylm(ith,iph,jj)
                        end do
                     end do
                  end do
                  rr=radr_paw(ir,it)
                  write(unit,'(4e19.6)') xorg+x0*rr, &
                       yorg+y0*rr, &
                       zorg+z0*rr,sum/rr/rr
               end do
            end do
         end do
      end do
      
      return
    end subroutine wd_ps_cd
        
    subroutine wd_valence_cd(unit)
      integer,intent(in):: unit
      integer:: ia,it,ith,iph,nrc,ir,is,ip
      integer:: lmt1,lmt2,il1,il2,im1,im2,it1,it2,ii,jj
      real(DP):: sint,cost,phi
      real(DP):: x0,y0,z0,xorg,yorg,zorg,pos1,pos2,pos3
      real(DP):: sum1,sum2,fac,rr,vec(3)
      character(len=32):: title
      do ia=1,natm
         it=ityp(ia)
         if(ipaw(it)/=1) cycle
         nrc=wf_mnrc(it)
         pos1=pos(ia,1);if(pos1<0) pos1=pos1+1.d0
         pos2=pos(ia,2);if(pos2<0) pos2=pos2+1.d0
         pos3=pos(ia,3);if(pos3<0) pos3=pos3+1.d0
         xorg=altv(1,1)*pos1+altv(1,2)*pos2+altv(1,3)*pos3
         yorg=altv(2,1)*pos1+altv(2,2)*pos2+altv(2,3)*pos3
         zorg=altv(3,1)*pos1+altv(3,2)*pos2+altv(3,3)*pos3
         write(title,'("chgval",i4.4)') ia
         write(unit,'(3a,i6,a,i6,a,i6,a)') &
              'ZONE T=',trim(title),'  I=',nrc &
              ,', J=',nphi+1 &
              ,', K=',ntheta &
              ,', F=POINT'
         do ith=1,ntheta
            cost=cos_theta(ith)
            sint=sqrt(1.d0-cost**2)
            do ip=1,nphi+1
               iph=ip
               if(ip.eq.nphi+1) iph=1
               phi=PAI2/dble(nphi)*dble(iph-1)
               x0=sint*cos(phi)
               y0=sint*sin(phi)
               z0=cost
               
               do ir=1,nrc
                  sum1=0.d0
                  sum2=0.d0
                  do is=1,nspin
                     do lmt1=1,ilmt(it)
                        il1=ltp(lmt1,it)
                        im1=mtp(lmt1,it)
                        it1=taup(lmt1,it)
                        ii=(il1-1)**2+im1   
                        do lmt2=lmt1,ilmt(it)
                           il2=ltp(lmt2,it)
                           im2=mtp(lmt2,it)
                           it2=taup(lmt2,it)
                           jj=(il2-1)**2+im2  
                           fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                           sum1=sum1+fac*hsr(ia,lmt1,lmt2,is)* &
                                psirpw(ir,il1,it1,it)* &
                                psirpw(ir,il2,it2,it)* &
                                ylm(ith,iph,ii)* &
                                ylm(ith,iph,jj)
                           sum2=sum2+fac*hsr(ia,lmt1,lmt2,is)* &
                                phirpw(ir,il1,it1,it)* &
                                phirpw(ir,il2,it2,it)* &
                                ylm(ith,iph,ii)* &
                                ylm(ith,iph,jj)
                        end do
                     end do
                  end do
                  rr=radr_paw(ir,it)
                  vec=(/xorg+x0*rr,yorg+y0*rr,zorg+z0*rr/)
                  vec=matmul(rltv,vec)/PAI2
                  write(unit,'(4e19.6)') xorg+x0*rr, &
                       yorg+y0*rr, &
                       zorg+z0*rr, &
                       (sum1-sum2)/rr/rr+ &
                       getFFTValue(vec,'soft')
               end do
            end do
         end do
      end do
      
      return
    end subroutine wd_valence_cd
        
    subroutine wd_averaged_ae_cd(unit)
      integer,intent(in):: unit
      integer:: ia,it,ith,iph,nrc,ir,is,ip,iopr,ja
      integer:: lmt1,lmt2,il1,il2,im1,im2,it1,it2,ii,jj
      real(DP):: sint,cost,phi
      real(DP):: x0,y0,z0,xorg,yorg,zorg,pos1,pos2,pos3
      real(DP):: sum,fac,rr,vec0(3),sum2
      real(DP),pointer,dimension(:,:):: ylm_sym
      character(len=32):: title
      
      allocate(ylm_sym(nopr+af,25))
      ylm_sym=0.d0
      
      do ia=1,natm
         it=ityp(ia)
         if(ipaw(it)/=1) cycle
         nrc=wf_mnrc(it)
         pos1=pos(ia,1);if(pos1<0) pos1=pos1+1.d0
         pos2=pos(ia,2);if(pos2<0) pos2=pos2+1.d0
         pos3=pos(ia,3);if(pos3<0) pos3=pos3+1.d0
         xorg=altv(1,1)*pos1+altv(1,2)*pos2+altv(1,3)*pos3
         yorg=altv(2,1)*pos1+altv(2,2)*pos2+altv(2,3)*pos3
         zorg=altv(3,1)*pos1+altv(3,2)*pos2+altv(3,3)*pos3
         write(title,'("nae_sym",i4.4)') ia
         write(unit,'(3a,i6,a,i6,a,i6,a)') &
              'ZONE T=',trim(title),'  I=',nrc &
              ,', J=',nphi+1 &
              ,', K=',ntheta &
              ,', F=POINT'
         do ith=1,ntheta
            cost=cos_theta(ith)
            sint=sqrt(1.d0-cost**2)
            do ip=1,nphi+1
               iph=ip
               if(ip.eq.nphi+1) iph=1
               phi=PAI2/dble(nphi)*dble(iph-1)
               x0=sint*cos(phi)
               y0=sint*sin(phi)
               z0=cost
               vec0(1)=x0
               vec0(2)=y0
               vec0(3)=z0
               call set_ylms_symmtry_op(ia,25,vec0,ylm_sym)
                        
               do ir=1,nrc
                  sum=0.d0
                  do is=1,nspin
                     do lmt1=1,ilmt(it)
                        il1=ltp(lmt1,it)
                        im1=mtp(lmt1,it)
                        it1=taup(lmt1,it)
                        ii=(il1-1)**2+im1   
                        do lmt2=lmt1,ilmt(it)
                           il2=ltp(lmt2,it)
                           im2=mtp(lmt2,it)
                           it2=taup(lmt2,it)
                           jj=(il2-1)**2+im2  
                           fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                           
                           sum2=0.d0
                           do iopr=1,nopr
                              ja=abs(ia2ia_symmtry_op(ia,iopr))
                              sum2=sum2+hsr(ja,lmt1,lmt2,is)* &
                                   ylm_sym(iopr,ii)* &
                                   ylm_sym(iopr,jj)
                           end do
                           sum2=sum2/dble(nopr)
                           
                           sum=sum+fac* &
                                psirpw(ir,il1,it1,it)* &
                                psirpw(ir,il2,it2,it)* &
                                sum2
                        end do
                     end do
                  end do
                  rr=radr_paw(ir,it)
                  write(unit,'(4e19.6)') xorg+x0*rr, &
                       yorg+y0*rr, &
                       zorg+z0*rr,sum/rr/rr
               end do
            end do
         end do
      end do
      
      deallocate(ylm_sym)
      
      return
    end subroutine wd_averaged_ae_cd
        
    subroutine wd_averaged_ps_cd(unit)
      integer,intent(in):: unit
      integer:: ia,it,ith,iph,nrc,ir,is,ip,iopr,ja
      integer:: lmt1,lmt2,il1,il2,im1,im2,it1,it2,ii,jj
      real(DP):: sint,cost,phi
      real(DP):: x0,y0,z0,xorg,yorg,zorg,pos1,pos2,pos3
      real(DP):: sum,fac,rr,vec0(3),sum2
      real(DP),pointer,dimension(:,:):: ylm_sym
      character(len=32):: title
      
      allocate(ylm_sym(nopr+af,25))
      ylm_sym=0.d0
      
      do ia=1,natm
         it=ityp(ia)
         if(ipaw(it)/=1) cycle
         nrc=wf_mnrc(it)
         pos1=pos(ia,1);if(pos1<0) pos1=pos1+1.d0
         pos2=pos(ia,2);if(pos2<0) pos2=pos2+1.d0
         pos3=pos(ia,3);if(pos3<0) pos3=pos3+1.d0
         xorg=altv(1,1)*pos1+altv(1,2)*pos2+altv(1,3)*pos3
         yorg=altv(2,1)*pos1+altv(2,2)*pos2+altv(2,3)*pos3
         zorg=altv(3,1)*pos1+altv(3,2)*pos2+altv(3,3)*pos3
         write(title,'("nps_sym",i4.4)') ia
         write(unit,'(3a,i6,a,i6,a,i6,a)') &
              'ZONE T=',trim(title),'  I=',nrc &
              ,', J=',nphi+1 &
              ,', K=',ntheta &
              ,', F=POINT'
         do ith=1,ntheta
            cost=cos_theta(ith)
            sint=sqrt(1.d0-cost**2)
            do ip=1,nphi+1
               iph=ip
               if(ip.eq.nphi+1) iph=1
               phi=PAI2/dble(nphi)*dble(iph-1)
               x0=sint*cos(phi)
               y0=sint*sin(phi)
               z0=cost
               vec0(1)=x0
               vec0(2)=y0
               vec0(3)=z0
               call set_ylms_symmtry_op(ia,25,vec0,ylm_sym)
               
               do ir=1,nrc
                  sum=0.d0
                  do is=1,nspin
                     do lmt1=1,ilmt(it)
                        il1=ltp(lmt1,it)
                        im1=mtp(lmt1,it)
                        it1=taup(lmt1,it)
                        ii=(il1-1)**2+im1   
                        do lmt2=lmt1,ilmt(it)
                           il2=ltp(lmt2,it)
                           im2=mtp(lmt2,it)
                           it2=taup(lmt2,it)
                           jj=(il2-1)**2+im2  
                           fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                           
                           sum2=0.d0
                           do iopr=1,nopr
                              ja=abs(ia2ia_symmtry_op(ia,iopr))
                              sum2=sum2+hsr(ja,lmt1,lmt2,is)* &
                                   ylm_sym(iopr,ii)* &
                                   ylm_sym(iopr,jj)
                           end do
                           sum2=sum2/dble(nopr)
                           
                           sum=sum+fac* &
                                phirpw(ir,il1,it1,it)* &
                                phirpw(ir,il2,it2,it)* &
                                sum2
                        end do
                     end do
                  end do
                  rr=radr_paw(ir,it)
                  write(unit,'(4e19.6)') xorg+x0*rr, &
                       yorg+y0*rr, &
                       zorg+z0*rr,sum/rr/rr
               end do
            end do
         end do
      end do
      
      deallocate(ylm_sym)
      return
    end subroutine wd_averaged_ps_cd
    
    subroutine wd_averaged_valence_cd(unit)
      integer,intent(in):: unit
      integer:: ia,it,ith,iph,nrc,ir,is,ip,iopr,ja
      integer:: lmt1,lmt2,il1,il2,im1,im2,it1,it2,ii,jj
      real(DP):: sint,cost,phi
      real(DP):: x0,y0,z0,xorg,yorg,zorg,pos1,pos2,pos3
      real(DP):: sum1,sum2,fac,rr,vec(3),vec0(3),sum3
      real(DP),pointer,dimension(:,:):: ylm_sym
      character(len=32):: title
      
      allocate(ylm_sym(nopr+af,25))
      ylm_sym=0.d0
      
      do ia=1,natm
         it=ityp(ia)
         if(ipaw(it)/=1) cycle
         nrc=wf_mnrc(it)
         pos1=pos(ia,1);if(pos1<0) pos1=pos1+1.d0
         pos2=pos(ia,2);if(pos2<0) pos2=pos2+1.d0
         pos3=pos(ia,3);if(pos3<0) pos3=pos3+1.d0
         xorg=altv(1,1)*pos1+altv(1,2)*pos2+altv(1,3)*pos3
         yorg=altv(2,1)*pos1+altv(2,2)*pos2+altv(2,3)*pos3
         zorg=altv(3,1)*pos1+altv(3,2)*pos2+altv(3,3)*pos3
         write(title,'("chgval_sym",i4.4)') ia
         write(unit,'(3a,i6,a,i6,a,i6,a)') &
              'ZONE T=',trim(title),'  I=',nrc &
              ,', J=',nphi+1 &
              ,', K=',ntheta &
              ,', F=POINT'
         do ith=1,ntheta
            cost=cos_theta(ith)
            sint=sqrt(1.d0-cost**2)
            do ip=1,nphi+1
               iph=ip
               if(ip.eq.nphi+1) iph=1
               phi=PAI2/dble(nphi)*dble(iph-1)
               x0=sint*cos(phi)
               y0=sint*sin(phi)
               z0=cost
               vec0(1)=x0
               vec0(2)=y0
               vec0(3)=z0
               call set_ylms_symmtry_op(ia,25,vec0,ylm_sym)
               
               do ir=1,nrc
                  sum1=0.d0
                  sum2=0.d0
                  do is=1,nspin
                     do lmt1=1,ilmt(it)
                        il1=ltp(lmt1,it)
                        im1=mtp(lmt1,it)
                        it1=taup(lmt1,it)
                        ii=(il1-1)**2+im1   
                        do lmt2=lmt1,ilmt(it)
                           il2=ltp(lmt2,it)
                           im2=mtp(lmt2,it)
                           it2=taup(lmt2,it)
                           jj=(il2-1)**2+im2  
                           fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                           
                           sum3=0.d0
                           do iopr=1,nopr
                              ja=abs(ia2ia_symmtry_op(ia,iopr))
                              sum3=sum3+hsr(ja,lmt1,lmt2,is)* &
                                   ylm_sym(iopr,ii)* &
                                   ylm_sym(iopr,jj)
                           end do
                           sum3=sum3/dble(nopr)
                           
                           sum1=sum1+fac* &
                                psirpw(ir,il1,it1,it)* &
                                psirpw(ir,il2,it2,it)* &
                                sum3
                           sum2=sum2+fac* &
                                phirpw(ir,il1,it1,it)* &
                                phirpw(ir,il2,it2,it)* &
                                sum3
                        end do
                     end do
                  end do
                  rr=radr_paw(ir,it)
                  vec=(/xorg+x0*rr,yorg+y0*rr,zorg+z0*rr/)
                  vec=matmul(rltv,vec)/PAI2
                  write(unit,'(4e19.6)') xorg+x0*rr, &
                       yorg+y0*rr, &
                       zorg+z0*rr, &
                       (sum1-sum2)/rr/rr+ &
                       getFFTValue(vec,'soft')
               end do
            end do
         end do
      end do
      
      return
    end subroutine wd_averaged_valence_cd
    
  end subroutine m_PAWCD_wd_cd
    
  subroutine set_ia2ia_symmtry_op
    integer:: ia,it,no,ja,jt
    integer:: i,j,k
    real(DP):: pos0(3),pos1(3),pos2(3),pos3(3)
    real(DP):: distance
    
    allocate(op_pr(3,3,nopr+af))
    call m_CS_op_in_PUCD(nfout,op_pr,nopr+af)
    
    do ia=1,natm
       it=ityp(ia)
       if(ipaw(it)/=1) cycle
       pos0(1:3)=pos(ia,1:3)
!print *,'pos0=',pos0
       pos0(:) = pos0(:) - floor(pos0(:))
       do no=1,nopr
          pos1(:)=matmul(op_pr(:,:,no),pos0(:))+tau(:,no,BUCS)
!print *,'pos1=',pos1
          pos1(:) = pos1(:) - floor(pos1(:))
          KLoop: do k=-1,1
             do j=-1,1
                do i=-1,1
                   do ja=1,natm
                      jt=ityp(ja)
                      if(it/=jt) cycle
                      pos3(1:3) = pos(ja,1:3) 
                      pos3(:) = pos3(:) - floor(pos3(:))
                      pos2(1:3)=pos3(1:3)+(/dble(i),dble(j),dble(k)/)
!print *,'pos2=',pos2                             
                      distance=abs(pos1(1)-pos2(1))+abs(pos1(2)-pos2(2)) &
                           +abs(pos1(3)-pos2(3))
                      if(distance < 1.d-5) then
                         ia2ia_symmtry_op(ia,no)=ja
!print *,ia,no,ja
                         exit KLoop
!!$                                else
!!$                                   if(ipripaw >=1) then
!!$                                      write(nfout,'(" ia, no = ",2i8)') ia, no
!!$                                      write(nfout,'(" i, j, k = ",3i8)') i,j,k
!!$                                      write(nfout,'("pos(ia)  = ",3f10.4)') pos(ia,1:3)
!!$                                      write(nfout,'("pos1(ia) = ",3f10.4)') pos1(1:3)
!!$                                      write(nfout,'("distance = ",d20.4)') distance
!!$                                   end if
                      end if
                        
                      if(kimg==1 .and. iwei(ja)==2) then
                         pos2(1:3)=-pos3(1:3)+(/dble(i),dble(j),dble(k)/)
                         distance=abs(pos1(1)-pos2(1))+abs(pos1(2)-pos2(2)) &
                              +abs(pos1(3)-pos2(3))
                         if(distance < 1.d-5) then
                            ia2ia_symmtry_op(ia,no)=-ja
!print *,ia,no,-ja
                            exit KLoop
                         end if
                      end if
                                
                      if(i.eq.1 .and. j.eq.1 .and. k.eq.1 .and. ja==natm) then
                         write(nfout,*) 'Error in set_ia2ia_symmtry_op (in m_PAW_ChargeDensity) !'
                         write(nfout,*) 'ia,no =', ia,no
                         write(nfout,'(" pos(ia)                     = ",3f10.4)') pos(ia,1:3)
                         write(nfout,'(" pos1(ia) = op*pos(ia)+tau   = ",3f10.4)') pos1(1:3)
                         stop
                      end if
                      
                   end do
                end do
             end do
          end do KLoop
       end do
    end do
    
    deallocate(op_pr) 
    return
  end subroutine set_ia2ia_symmtry_op
    
  subroutine set_ylms_symmtry_op(ia,ilmax,vec0,ylm_sym)
    integer,intent(in):: ia,ilmax
    real(DP),intent(in):: vec0(3)
    real(DP),intent(out):: ylm_sym(nopr+af,ilmax)
    
    integer:: is,iopr
    real(DP),pointer,dimension(:)     :: gx,gy,gz,tylm
    real(DP):: vec(3)
    
    allocate(gx(nopr+af))
    allocate(gy(nopr+af))
    allocate(gz(nopr+af))
    allocate(tylm(nopr+af))
    
    do iopr=1,nopr
       vec(:)=matmul(op(:,:,iopr),vec0(:))
       if(ia2ia_symmtry_op(ia,iopr) < 0) vec=-vec
       gx(iopr)=vec(1)
       gy(iopr)=vec(2)
       gz(iopr)=vec(3)
    end do
    
    do is=1,ilmax
       call sphr(nopr,is,gx(1:nopr),gy(1:nopr),gz(1:nopr),tylm(1:nopr))
       do iopr=1,nopr
          ylm_sym(iopr,is)=tylm(iopr)
       end do
    end do
        
!it=2;ip=3;is=2
!cos_the=cos_theta(it)
!sin_the=sqrt(1.d0-cos_the*cos_the)
!phi=PAI2/dble(nphi)*dble(ip-1)
!print *,'is=',is
!print *,sin_the*cos(phi),sin_the*sin(phi),cos_the
!print *,ylm(it,ip,is),dylm_dth(it,ip,is),dylm_dph(it,ip,is)
    
    deallocate(gx,gy,gz,tylm)
    return
  end subroutine set_ylms_symmtry_op
    
  subroutine set_diff_ylms_symmtry_op(ia,ilmax,vec0,ylm_sym,dylm_dth_sym,dylm_dph_sym)
    integer,intent(in):: ia,ilmax
    real(DP),intent(in):: vec0(3)
    real(DP),intent(out):: ylm_sym(nopr+af,ilmax)
    real(DP),intent(out):: dylm_dth_sym(nopr+af,ilmax)
    real(DP),intent(out):: dylm_dph_sym(nopr+af,ilmax)
    
    integer:: is,iopr
    real(DP),pointer,dimension(:)     :: gx,gy,gz,tylm
    real(DP),pointer,dimension(:,:)   :: tdylm
    real(DP):: vec(3),rr,vec1(3),vec2(3)
    
    allocate(gx(nopr+af))
    allocate(gy(nopr+af))
    allocate(gz(nopr+af))
    allocate(tylm(nopr+af))
    allocate(tdylm(nopr+af,3))
    
    do iopr=1,nopr
       vec(:)=matmul(op(:,:,iopr),vec0(:))
       if(ia2ia_symmtry_op(ia,iopr) < 0) vec=-vec
       gx(iopr)=vec(1)
       gy(iopr)=vec(2)
       gz(iopr)=vec(3)
    end do
    
    do is=1,ilmax
       call sphr(nopr,is,gx(1:nopr),gy(1:nopr),gz(1:nopr),tylm(1:nopr))
       do iopr=1,nopr
          ylm_sym(iopr,is)=tylm(iopr)
       end do
    end do
    
    rr=sqrt(vec0(1)**2+vec0(2)**2)
    vec1(1)=vec0(3)*vec0(1)/rr
    vec1(2)=vec0(2)*vec0(3)/rr
    vec1(3)=-rr
    vec2(1)=-vec0(2)
    vec2(2)=vec0(1)
    vec2(3)=0.d0
        
    do is=1,ilmax
       call sphr_diff(nopr,nopr,is,gx(1:nopr),gy(1:nopr),gz(1:nopr),tdylm(1:nopr,1:3))
       do iopr=1,nopr
          vec=matmul(op(:,:,iopr),vec1(:))
          dylm_dth_sym(iopr,is)=  tdylm(iopr,1)*vec(1)+ &
               tdylm(iopr,2)*vec(2)+ &
               tdylm(iopr,3)*vec(3)
          vec=matmul(op(:,:,iopr),vec2(:))
          dylm_dph_sym(iopr,is)=  tdylm(iopr,1)*vec(1)+ &
               tdylm(iopr,2)*vec(2)+ &
               tdylm(iopr,3)*vec(3)
          
          if(ia2ia_symmtry_op(ia,iopr) < 0) then
             dylm_dth_sym(iopr,is)=-dylm_dth_sym(iopr,is)
             dylm_dph_sym(iopr,is)=-dylm_dph_sym(iopr,is)
          end if
          !                ylm_sym(iopr,is)=tylm(iopr)
       end do
    end do
        
!it=2;ip=3;is=2
!cos_the=cos_theta(it)
!sin_the=sqrt(1.d0-cos_the*cos_the)
!phi=PAI2/dble(nphi)*dble(ip-1)
!print *,'is=',is
!print *,sin_the*cos(phi),sin_the*sin(phi),cos_the
!print *,ylm(it,ip,is),dylm_dth(it,ip,is),dylm_dph(it,ip,is)
    
    deallocate(gx,gy,gz,tylm,tdylm)
    return
  end subroutine set_diff_ylms_symmtry_op
    
  subroutine m_PAWCD_wd_number_of_state(nfout)
    integer,intent(in):: nfout
    
    integer:: ia,ja,it,ith,iph
    integer:: ir,is,ier,nrc
    real(DP):: costh,sinth,phi,dvec(3)
    real(DP),pointer,dimension(:,:):: nae
    real(DP),pointer,dimension(:):: wos
    real(DP),pointer,dimension(:,:):: nsae
    logical,pointer,dimension(:):: flg_done
    
    allocate(nae(mmesh,nspin))
    allocate(wos(mmesh));wos=0.d0
    allocate(nsae(natm,nspin))    
    if(af /= 0) then
       allocate(flg_done(natm))
       flg_done=.false.
    end if
    nsae=0.d0
        
    do ia=1,natm
       if(af /= 0) then
          if(flg_done(ia)) cycle
       end if
       it=ityp(ia)
       if(ipaw(it)/=1) cycle
       nrc=wf_mnrc(it)
       call set_weight_exp(ier,1,nrc,radr_paw(:,it),wos)
       do ir=1,nrc
          wos(ir)=wos(ir)*radr_paw(ir,it)**2
       end do
!            wos=wos*iwei(ia)
       do ith=1,ntheta
          costh=cos_theta(ith)
          sinth=sqrt(1.d0-costh**2)
          do iph=1,nphi
             phi=PAI2/dble(nphi)*dble(iph-1)
             dvec(1)=sinth*cos(phi)
             dvec(2)=sinth*sin(phi)
             dvec(3)=costh
             call m_PAWCD_set_ae_vd_sym &
                  (dvec,ia,nspin,nrc,nae(1:nrc,1:nspin))
!call m_PAWCD_set_ae_cd(ith,iph,ia,nspin,nrc,nae(1:nrc,1:nspin))
!nae=1.d0
!print *,radr_paw(nrc,it),PAI4/3.d0*radr_paw(nrc,it)**3

             do is=1,nspin			
                do ir=1,nrc
                   nsae(ia,is)=nsae(ia,is)+ &
                        nae(ir,is)*omg_wght(ith)*wos(ir)
                end do
             end do
          end do
       end do
       
       if(af /= 0) then
          ja=ia2ia_symmtry_op(ia,nopr+af)  
          flg_done(ja)=.true.
       end if
    end do
    nsae=nsae*PAI4
    
    if(printable)then
       write(nfout,*) 'Site-decomposed number of states below the Fermi energy.'
       write(nfout,*) '      Site        Spin-up            Spin-down'
    endif

    flg_done=.false.
    
    do ia=1,natm
       if(af /= 0) then
          if(flg_done(ia)) cycle
       end if
       it=ityp(ia)
       if(ipaw(it)/=1) cycle
       if(nspin.eq.2) then
          if(printable) write(nfout,'(i10,2f19.6)')  ia,nsae(ia,1),nsae(ia,2)
       else
          if(printable) write(nfout,'(i10,2f19.6)')  ia,nsae(ia,1)/2.d0,nsae(ia,1)/2.d0
       end if
       if(af /= 0) then
          ja=ia2ia_symmtry_op(ia,nopr+af) 
          if(printable) write(nfout,'(i10,2f19.6)')  ja,nsae(ia,2),nsae(ia,1)
          flg_done(ja)=.true.
       end if
    end do
    
    if(printable) write(nfout,*)
    
    deallocate(nae)
    deallocate(wos)
    deallocate(nsae)
    if(af /= 0) deallocate(flg_done)
	 
  end subroutine m_PAWCD_wd_number_of_state
    
  subroutine m_PAWCD_set_ae_cd_sphex2( ia,nspin,nrc,dnr &
       &                              ,msph,n1nc,msphmx &
       &                              ,num_isph,isph_chg )
    integer,intent(in) :: ia,nspin,nrc,dnr,msph
    real(8),intent(out):: n1nc(nrc,nspin,25)
    integer,intent(out):: msphmx
    integer,intent(out):: num_isph,isph_chg(25)
    
    real(8):: n1(nrc,nspin),sum,fac,isqrt4pi,eps,abshsr
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj,n,isp
    logical:: flg_isph(25)
    
    it=ityp(ia)
    n1nc=0.d0
    msphmx=0
    eps=1.d-10
    flg_isph=.false.
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1   
       do lmt2=lmt1,ilmt(it)
          abshsr=abs(hsr(ia,lmt1,lmt2,1))
          if(nspin.eq.2) abshsr=abshsr+abs(hsr(ia,lmt1,lmt2,2))
          if(abshsr .lt. eps) cycle
          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2  
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
          do n=1,il2p(lmt1,lmt2,it)
             isp=isph(lmt1,lmt2,n,it)
             if(isp.gt.msphmx) msphmx=isp
             flg_isph(isp)=.true.
!if(isp.eq.5) then
!print *,il1,it1,il2,it2,fac,fac*hsr(ia,lmt1,lmt2,1)*dl2p(lmt1,lmt2,n,it)
!end if
             do is=1,nspin
                sum=fac*hsr(ia,lmt1,lmt2,is)*dl2p(lmt1,lmt2,n,it)
!print '(e19.6,4i4,2e19.6)',sum,ii,jj,isp,il2p(lmt1,lmt2,it),hsr(ia,lmt1,lmt2,is),dl2p(lmt1,lmt2,n,it)
                do ir=1,nrc,dnr
                   n1nc(ir,is,isp)=n1nc(ir,is,isp)+sum* &
                        psirpw(ir,il1,it1,it)* &
                        psirpw(ir,il2,it2,it)
                end do
             end do
          end do
       end do
    end do
    

!    write(851,*) n1nc(1:nrc,1,1)
!    write(852,*) n1nc(1:nrc,2,1)

!    write(855,*) hsr
!    write(856,*) dl2p
!    write(857,*) psirpw

!    stop

    num_isph=0
    isph_chg=0
    do isp=1,25
       if(flg_isph(isp)) then
          num_isph=num_isph+1
          isph_chg(num_isph)=isp
       end if
    end do
    
    isqrt4pi=1.d0/sqrt(PAI4)
    do is=1,nspin
       do ir=1,nrc,dnr
          n1nc(ir,is,1)=(n1nc(ir,is,1)*isqrt4pi+rhcorpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it) 
       end do
    end do
        
!        do n=2,msph
    do isp=2,num_isph
       n=isph_chg(isp)
       do is=1,nspin
          do ir=1,nrc,dnr
             n1nc(ir,is,n)=n1nc(ir,is,n)/radr_paw(ir,it)/radr_paw(ir,it) 
          end do
       end do
    end do
!            
!do ir=1,nrc
!print '(11e19.6)', radr_paw(ir,it),n1nc(ir,1,11:20)
!end do
!stop    
    return
  end subroutine m_PAWCD_set_ae_cd_sphex2

! ============================ added by K. Tagami ========== 11.0
  subroutine m_PAWCD_ae_cd_sphex2_nonclA( ia, nspin, nrc, dnr,  &
       &                                  msph, n1nc, msphmx, &
       &                                  num_isph, isph_chg, wos, &
       &                                  level_of_projection, &
       &                                  magmom_avg_spherical, rho_rad )
    integer, intent(in) :: ia,nspin,nrc,dnr,msph
    integer, intent(out):: msphmx
    integer, intent(out):: num_isph,isph_chg(max_sph_expansion)
    integer, intent(in) :: level_of_projection

    real(kind=DP), intent(out):: n1nc( nrc, nspin, max_sph_expansion )
    real(kind=DP), intent(in) :: wos(mmesh)
    real(kind=DP), intent(out) :: magmom_avg_spherical(3,max_sph_expansion)
    real(kind=DP), intent(out) :: rho_rad( nrc, ndim_magmom, max_sph_expansion )

    real(kind=DP) :: sum,fac,isqrt4pi,eps,abshsr
    
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj,n,isp
    logical:: flg_isph( max_sph_expansion )

    it=ityp(ia)
    n1nc=0.d0; rho_rad = 0.0d0

    msphmx=0
    eps=1.d-10
    flg_isph=.false.

    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it);  im1=mtp(lmt1,it);   it1=taup(lmt1,it)

       ii=(il1-1)**2+im1

       do lmt2=lmt1,ilmt(it)
          abshsr = abs(hsr(ia,lmt1,lmt2,1))
          if(abshsr .lt. eps) cycle

          il2=ltp(lmt2,it); im2=mtp(lmt2,it);  it2=taup(lmt2,it)
          jj=(il2-1)**2+im2

          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0

          do n=1,il2p(lmt1,lmt2,it)
             isp = isph(lmt1,lmt2,n,it)
             if (isp.gt.msphmx ) msphmx=isp
             flg_isph(isp)=.true.

             do is=1,ndim_magmom
                sum = fac*hsr(ia,lmt1,lmt2,is)*dl2p(lmt1,lmt2,n,it)
                do ir=1,nrc,dnr
                   rho_rad(ir,is,isp) = rho_rad(ir,is,isp) &
                        &         +sum * psirpw(ir,il1,it1,it) &
                        &              * psirpw(ir,il2,it2,it)
                end do
             end do
          end do
       end do
    end do

    num_isph=0;   isph_chg=0

    do isp=1,max_sph_expansion
       if (flg_isph(isp)) then
          num_isph=num_isph+1
          isph_chg(num_isph)=isp
       end if
    end do

    if ( mode_of_projection == project_on_local_quantz_axis ) then
!
       select case( level_of_projection )
       case (1)
          call get_magmom_spherical( ia, nrc, dnr, rho_rad, wos, &
               &                     magmom_avg_spherical(:,1) )
          call radial_chg_along_LocalQuanzAxis( nrc, dnr, rho_rad, &
               &                                magmom_avg_spherical(:,1), n1nc )

       case(2,3)
          call get_magmom_spherical2( ia, nrc, dnr, rho_rad, wos, magmom_avg_spherical )
          call radial_chg_along_LocalQuanzAxis( nrc, dnr, rho_rad, &
               &                                magmom_avg_spherical(:,1), n1nc )

       case(4)
          call get_magmom_spherical( ia, nrc, dnr, rho_rad, wos, &
               &                     magmom_avg_spherical(:,1) )
          call radial_chg_alng_LocalQuanzAxis2( nrc, dnr, rho_rad, n1nc )

       end select

    else
       stop 'kt : under conctruction '
    end if
!
    isqrt4pi=1.d0/sqrt(PAI4)
    do is=1,nspin
       do ir=1,nrc,dnr
          n1nc(ir,is,1) = (n1nc(ir,is,1)*isqrt4pi+rhcorpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it)
       end do
    end do

!        do n=2,msph
    do isp=2,num_isph
       n=isph_chg(isp)
       do is=1,nspin
          do ir=1,nrc,dnr
             n1nc(ir,is,n)=n1nc(ir,is,n)/radr_paw(ir,it)/radr_paw(ir,it)
          end do
       end do
    end do

    return

  end subroutine m_PAWCD_ae_cd_sphex2_nonclA
! =========================================================== 11.0

! ============================== added by K. Tagami ================== 11.0
  subroutine radial_chg_along_LocalQuanzAxis( nrc, dnr, rho_rad, &
       &                                      magmom_avg_spherical, &
       &                                      rho_rad_along_quantz_axis )
! --
    integer, intent(in) :: nrc, dnr
    real(kind=DP), intent(in) :: rho_rad( nrc, ndim_magmom, max_sph_expansion )
    real(kind=DP), intent(in) :: magmom_avg_spherical( 3 )
    real(kind=DP), intent(out) :: &
         &                rho_rad_along_quantz_axis( nrc, nspin, max_sph_expansion )

    real(kind=DP) :: c_mx, c_my, c_mz, m_norm
    real(kind=DP) :: mmx, mmy, mmz

    real(kind=DP) :: c1, c2, d1, d2, ctmp2
    integer :: ir, isp
!    real(kind=DP) :: m_norm_criteria = 1.0D-20
    real(kind=DP) :: m_norm_criteria = 1.0D-18

    c_mx = magmom_avg_spherical(1)
    c_my = magmom_avg_spherical(2)
    c_mz = magmom_avg_spherical(3)
    m_norm = sqrt( c_mx**2 + c_my**2 + c_mz**2 )
!
    if ( m_norm > m_norm_criteria ) then
       mmx = c_mx / m_norm
       mmy = c_my / m_norm
       mmz = c_mz / m_norm
    else
       mmx = 0.0d0;  mmy = 0.0d0;  mmz = 1.0d0
       mmx = 0.0d0;  mmy = 0.0d0;  mmz = 0.0d0

!       ctmp2 =  c_mx *Global_Quantz_Axis_now(1) &
!            &  +c_my *Global_Quantz_Axis_now(2) &
!            &  +c_mz *Global_Quantz_Axis_now(3)
!
!       if ( ctmp2 > 0.0 ) then
!          mmx = Global_Quantz_Axis_now(1)
!          mmy = Global_Quantz_Axis_now(2)
!          mmz = Global_Quantz_Axis_now(3)
!       else
!          mmx = -Global_Quantz_Axis_now(1)
!          mmy = -Global_Quantz_Axis_now(2)
!          mmz = -Global_Quantz_Axis_now(3)
!       endif
    endif

    Do ir=1, nrc, dnr
       c1 = rho_rad(ir,1,1);
       c2 = rho_rad(ir,2,1) *mmx + rho_rad(ir,3,1) *mmy + rho_rad(ir,4,1) *mmz
       d1 = ( c1 + c2 ) /2.0d0;
       d2 = ( c1 - c2 ) /2.0d0;

       rho_rad_along_quantz_axis(ir,1,1) = d1
       rho_rad_along_quantz_axis(ir,2,1) = d2
    End do

    Do isp=2, max_sph_expansion
       Do ir=1, nrc, dnr
          c1 = rho_rad(ir,1,isp);
          c2 = rho_rad(ir,2,isp) *mmx +rho_rad(ir,3,isp) *mmy +rho_rad(ir,4,isp) *mmz
          d1 = ( c1 + c2 ) /2.0d0;
          d2 = ( c1 - c2 ) /2.0d0;

          rho_rad_along_quantz_axis(ir,1,isp) = d1
          rho_rad_along_quantz_axis(ir,2,isp) = d2
       End do
    End do
!
  end subroutine radial_chg_along_LocalQuanzAxis

  subroutine radial_chg_alng_LocalQuanzAxis2( nrc, dnr, rho_rad, &
       &                                      rho_rad_along_quantz_axis )
! --
    integer, intent(in) :: nrc, dnr
    real(kind=DP), intent(in) :: rho_rad( nrc, ndim_magmom, max_sph_expansion )
    real(kind=DP), intent(out) :: &
         &                rho_rad_along_quantz_axis( nrc, nspin, max_sph_expansion )

    real(kind=DP) :: c_mx, c_my, c_mz, m_norm
    real(kind=DP) :: mmx, mmy, mmz

    real(kind=DP) :: c1, c2, d1, d2, ctmp2, c3
    integer :: ir, isp
!    real(kind=DP) :: m_norm_criteria = 1.0D-20
    real(kind=DP) :: m_norm_criteria = 1.0D-18

    Do ir=1, nrc, dnr
       c1 = rho_rad(ir,1,1);
       c2 = sqrt( rho_rad(ir,2,1)**2 + rho_rad(ir,3,1)**2 + rho_rad(ir,4,1)**2 )

       d1 = ( c1 + c2 ) /2.0d0;
       d2 = ( c1 - c2 ) /2.0d0;

       rho_rad_along_quantz_axis(ir,1,1) = d1
       rho_rad_along_quantz_axis(ir,2,1) = d2

       Do isp=2, max_sph_expansion
          c1 = rho_rad(ir,1,isp);

          if ( c2 > m_norm_criteria ) then
             mmx = rho_rad(ir,2,1) / c2
             mmy = rho_rad(ir,3,1) / c2
             mmz = rho_rad(ir,4,1) / c2
          else
             mmx = 0.0;  mmy = 0.0;  mmz = 0.0
          endif

          c3 = rho_rad(ir,2,isp) *mmx +rho_rad(ir,3,isp) *mmy +rho_rad(ir,4,isp) *mmz

          d1 = ( c1 + c3 ) /2.0d0;
          d2 = ( c1 - c3 ) /2.0d0;

          rho_rad_along_quantz_axis(ir,1,isp) = d1
          rho_rad_along_quantz_axis(ir,2,isp) = d2
       End do
    End do
!
  end subroutine radial_chg_alng_LocalQuanzAxis2

  subroutine get_magmom_spherical( ia, nrc, dnr, rho_rad, wos, magmom_avg_spherical )
    integer, intent(in) :: nrc, ia, dnr
    real(kind=DP), intent(in) :: rho_rad(nrc,ndim_magmom,max_sph_expansion)
    real(kind=DP), intent(in) :: wos(nrc)
    real(kind=DP), intent(out) :: magmom_avg_spherical(3)

    integer :: is, ir
    real(kind=DP) :: csum

    Do is=2, ndim_magmom
       csum = 0.0d0
       Do ir=1, nrc, dnr
          csum = csum + rho_rad(ir,is,1) *wos(ir)
       End do
       magmom_avg_spherical( is-1 ) = csum
    End do
  end subroutine get_magmom_spherical

  subroutine get_magmom_spherical2( ia, nrc, dnr, rho_rad, wos, magmom_avg_spherical )
    integer, intent(in) :: nrc, ia, dnr
    real(kind=DP), intent(in) :: rho_rad(nrc,ndim_magmom,max_sph_expansion)
    real(kind=DP), intent(in) :: wos(nrc)
    real(kind=DP), intent(out) :: magmom_avg_spherical(3,max_sph_expansion)

    integer :: is, ir, ii
    real(kind=DP) :: csum

    magmom_avg_spherical = 0.0d0
    Do ii=1, max_sph_expansion
       Do is=2, ndim_magmom
          csum = 0.0d0
          Do ir=1, nrc, dnr
             csum = csum + rho_rad(ir,is,ii) *wos(ir)
          End do
          magmom_avg_spherical( is-1, ii ) = csum
       End do
    End do
  end subroutine get_magmom_spherical2
! ============================================================= 11.0

  subroutine m_PAWCD_set_ps_cd_sphex2( ia,nspin,nrc,dnr &
       &                               ,msph,nps,msphmx &
       &                               ,num_isph,isph_chg )
    integer,intent(in) :: ia,nspin,nrc,dnr,msph
    real(8),intent(out):: nps(nrc,nspin,25)
    integer,intent(out):: msphmx
    integer,intent(out):: num_isph,isph_chg(25)
    
    real(8):: sum,fac,isqrt4pi,eps,abshsr
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2,l3
    integer:: ii,jj,n,ilm3,iiqitg
    integer,pointer,dimension(:):: il3
    logical:: flg_isph(25)
!        real(8),pointer,dimension(:):: qsum
        
    call m_PP_find_maximum_l(n)
    n=(n-1)+(n-1)+1
    allocate(il3(25));call substitute_il3(25,il3)
!        allocate(qsum(nrc))
    it=ityp(ia)
    nps=0.d0
    msphmx=0
    eps=1.d-10
    flg_isph=.false.
    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it)
       im1=mtp(lmt1,it)
       it1=taup(lmt1,it)
       ii=(il1-1)**2+im1   
       do lmt2=lmt1,ilmt(it)
          abshsr=abs(hsr(ia,lmt1,lmt2,1))
          if(nspin.eq.2) abshsr=abshsr+abs(hsr(ia,lmt1,lmt2,2))
          if(abshsr .lt. eps) cycle
          il2=ltp(lmt2,it)
          im2=mtp(lmt2,it)
          it2=taup(lmt2,it)
          jj=(il2-1)**2+im2  
          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
!                qsum=0.d0
          do n=1,il2p(lmt1,lmt2,it)
             ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
             iiqitg=iqitg(il1,it1,il2,it2,l3+1,it)
!!$                    if(iiqitg == 0) cycle
             if(ilm3.gt.msphmx) msphmx=ilm3
             flg_isph(ilm3)=.true.
             do is=1,nspin
                sum=fac*hsr(ia,lmt1,lmt2,is)*dl2p(lmt1,lmt2,n,it)
                do ir=1,nrc,dnr
                   nps(ir,is,ilm3)=nps(ir,is,ilm3) + sum* &
                        & (phirpw(ir,il1,it1,it)*phirpw(ir,il2,it2,it) &
                        &  +qrspspw(ir,iiqitg))
                end do
             end do
          end do
       end do
    end do
    
    num_isph=0
    isph_chg=0
    do ilm3=1,25
       if(flg_isph(ilm3)) then
          num_isph=num_isph+1
          isph_chg(num_isph)=ilm3
       end if
    end do
    
    isqrt4pi=1.d0/sqrt(PAI4)
    do is=1,nspin
       do ir=1,nrc,dnr
          nps(ir,is,1)=(nps(ir,is,1)*isqrt4pi+rhpcrpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it) 
!            if(nps(ir,is,1).lt.0.d0) nps(ir,is,1)=0.d0
       end do
    end do
     
!        do n=2,msph
    do ilm3=2,num_isph
       n=isph_chg(ilm3)
       do is=1,nspin
          do ir=1,nrc,dnr
             nps(ir,is,n)=nps(ir,is,n)/radr_paw(ir,it)/radr_paw(ir,it) 
!            if(nps(ir,is,n).lt.0.d0) nps(ir,is,n)=0.d0
          end do
       end do
    end do
    
!do ir=1,nrc
!print '(17e19.6)', radr_paw(ir,it),nps(ir,1,10:25)
!end do
!stop    
    
    deallocate(il3)
    return
  end subroutine m_PAWCD_set_ps_cd_sphex2

! ===================== added by K. Tagami ==================== 11.0
  subroutine m_PAWCD_ps_cd_sphex2_nonclA( ia, nspin, nrc, dnr, &
       &                                  msph, nps, msphmx, &
       &                                  num_isph, isph_chg, wos, &
       &                                  level_of_projection, &
       &                                  magmom_avg_spherical, rho_rad )

    integer, intent(in) :: ia,nspin,nrc,dnr,msph
    integer, intent(in) :: level_of_projection
    integer, intent(out):: msphmx
    integer, intent(out):: num_isph,isph_chg(max_sph_expansion)

    real(kind=DP), intent(out):: nps( nrc, nspin, max_sph_expansion )
    real(kind=DP), intent(in) :: wos(mmesh)
    real(kind=DP), intent(out) :: magmom_avg_spherical(3,max_sph_expansion)
    real(kind=DP), intent(out) :: rho_rad( nrc, ndim_magmom, max_sph_expansion )

    real(kind=DP) :: sum,fac,isqrt4pi,eps,abshsr

    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2,l3
    integer:: ii,jj,n,ilm3,iiqitg
    integer,pointer,dimension(:):: il3

    logical:: flg_isph( max_sph_expansion )

    call m_PP_find_maximum_l(n)
    n=(n-1)+(n-1)+1
    allocate(il3(max_sph_expansion))
    call substitute_il3(max_sph_expansion,il3)

    it=ityp(ia)
    nps=0.d0; rho_rad = 0.0d0

    msphmx=0
    eps=1.d-10
    flg_isph=.false.

    do lmt1=1,ilmt(it)
       il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
       ii=(il1-1)**2+im1

       do lmt2=lmt1,ilmt(it)
          abshsr =abs(hsr(ia,lmt1,lmt2,1))
          if(abshsr .lt. eps) cycle

          il2=ltp(lmt2,it);  im2=mtp(lmt2,it); it2=taup(lmt2,it)
          jj=(il2-1)**2+im2

          fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0

          do n=1,il2p(lmt1,lmt2,it)
             ilm3=isph(lmt1,lmt2,n,it);l3=il3(ilm3)
             iiqitg=iqitg(il1,it1,il2,it2,l3+1,it)

             if(ilm3.gt.msphmx) msphmx=ilm3
             flg_isph(ilm3)=.true.

             do is=1, ndim_magmom
                sum=fac*hsr(ia,lmt1,lmt2,is)*dl2p(lmt1,lmt2,n,it)
                do ir=1,nrc,dnr
                   rho_rad(ir,is,ilm3) = rho_rad(ir,is,ilm3) &
                        &               + sum* ( phirpw(ir,il1,it1,it) &
                        &                       *phirpw(ir,il2,it2,it) &
                        &                        +qrspspw(ir,iiqitg) )
                end do
             end do
          end do
       end do
    end do

    num_isph=0; isph_chg=0

    do ilm3=1,max_sph_expansion
       if(flg_isph(ilm3)) then
          num_isph=num_isph+1
          isph_chg(num_isph)=ilm3
       end if
    end do

    if ( mode_of_projection == project_on_local_quantz_axis ) then

       select case( level_of_projection )
       case (1)
          call get_magmom_spherical( ia, nrc, dnr, rho_rad, wos, &
               &                     magmom_avg_spherical(:,1) )
          call radial_chg_along_LocalQuanzAxis( nrc, dnr, rho_rad, &
               &                                magmom_avg_spherical(:,1), nps )

       case(2,3)
          call get_magmom_spherical2( ia, nrc, dnr, rho_rad, wos, magmom_avg_spherical )
          call radial_chg_along_LocalQuanzAxis( nrc, dnr, rho_rad, &
               &                                magmom_avg_spherical(:,1), nps )

       case(4)
          call get_magmom_spherical( ia, nrc, dnr, rho_rad, wos, &
               &                     magmom_avg_spherical(:,1) )
          call radial_chg_alng_LocalQuanzAxis2( nrc, dnr, rho_rad, nps )

       end select

    else
       stop 'kt : under conctruction '
    end if

    isqrt4pi=1.d0/sqrt(PAI4)
    do is=1,nspin
       do ir=1,nrc,dnr
          nps(ir,is,1) = (nps(ir,is,1)*isqrt4pi+rhpcrpw(ir,it)/PAI4/dble(nspin)) &
               /radr_paw(ir,it)/radr_paw(ir,it)
       end do
    end do

    do ilm3=2,num_isph
       n=isph_chg(ilm3)
       do is=1,nspin
          do ir=1,nrc,dnr
             nps(ir,is,n)=nps(ir,is,n)/radr_paw(ir,it)/radr_paw(ir,it)
          end do
       end do
    end do

    deallocate(il3)
    return
  end subroutine m_PAWCD_ps_cd_sphex2_nonclA
! ================================================================= 11.0

  subroutine m_PAWCD_set_cr2_isph2_mmt2()
    integer:: lcmax
    logical,save:: initialized=.false.
    if(.not.initialized) then
       lcmax=4
       allocate(paw_cr2(25,25,6))
       allocate(paw_isph2(25,25,6))
       allocate(paw_mmt2(25,25))
       call sphset3(nfout,ipripaw,paw_cr2,paw_isph2,paw_mmt2)
       initialized=.true.
    end if
    return
  end subroutine m_PAWCD_set_cr2_isph2_mmt2
  
  subroutine m_PAWCD_set_sq_der_cd_sdphex2( ia,nspin,nrc,dnr &
       &                                    ,msphmx, num_isph_chg &
       &                                    ,isph_chg, nae_sph &
       &                                    ,dnae_dr_sph, grad_nae2 &
       &                                    ,grad_tnae2, msphmx_grd &
       &                                    ,num_isph_grd ,isph_grd )
    integer,intent(in) :: ia,nspin,nrc,dnr,msphmx,num_isph_chg,isph_chg(25)
    real(8),intent(in) :: nae_sph(nrc,nspin,25)
    real(8),intent(in) :: dnae_dr_sph(nrc,nspin,25)
    real(8),intent(out):: grad_nae2(nrc,nspin,25)
    real(8),intent(out):: grad_tnae2(nrc,25)
    integer,intent(out):: msphmx_grd,num_isph_grd
    integer,intent(out):: isph_grd(25)
    
    real(8):: n1(nrc,nspin),fac,bb
    integer:: ir,it,is,lmt1,lmt2
    integer:: il1,il2,it1,it2,im1,im2
    integer:: ii,jj
    real(8):: sum1(nrc,nspin),sum2(nrc,nspin,25),sum3(nrc),sum4(nrc,25)
    real(8):: dl,dl1,dl2,dl3,cijk
    integer:: isp,isp2,isp3,lcmax,n
    integer:: nsp,nsp2,nsp3
    logical:: flg_isp(25)
    integer,pointer,dimension(:):: il3
    logical,save:: initialized=.false.
    
    if(.not.initialized) then
       lcmax=4
!            allocate(paw_cr2(16,16,6))
!            allocate(paw_isph2(16,16,6))
!            allocate(paw_mmt2(16,16))
!            call sphset2(nfout,ipri,lcmax,paw_cr2,paw_isph2,paw_mmt2)
       allocate(paw_cr2(25,25,6))
       allocate(paw_isph2(25,25,6))
       allocate(paw_mmt2(25,25))
       call sphset3(nfout,ipripaw,paw_cr2,paw_isph2,paw_mmt2)
       initialized=.true.
    end if
          
    allocate(il3(25));call substitute_il3(25,il3)
    it=ityp(ia)
    grad_nae2=0.d0
    grad_tnae2=0.d0
    sum1=0.d0
    sum3=0.d0
    flg_isp=.false.
!        do isp=2,msphmx
    do nsp=2,num_isph_chg
       isp=isph_chg(nsp)
       dl=dble(il3(isp))
       dl=dl*(dl+1.d0)
       do is=1,nspin
          do ir=1,nrc,dnr
             sum1(ir,is)=sum1(ir,is) + &
                  dnae_dr_sph(ir,is,isp)**2 + &
                  dl*nae_sph(ir,is,isp)**2/radr_paw(ir,it)/radr_paw(ir,it) 
          end do
       end do
       if(nspin.eq.2) then
          do ir=1,nrc,dnr
             sum3(ir)=sum3(ir) + &
                  (dnae_dr_sph(ir,1,isp)+dnae_dr_sph(ir,2,isp))**2 + &
                  dl*(nae_sph(ir,1,isp)+nae_sph(ir,2,isp))**2/radr_paw(ir,it)/radr_paw(ir,it) 
          end do
       end if
    end do
    do ir=1,nrc,dnr
       do is=1,nspin
          grad_nae2(ir,is,1)=dnae_dr_sph(ir,is,1)**2 + sum1(ir,is)/PAI4
       end do
       if(nspin.eq.2) then
          grad_tnae2(ir,1)=(dnae_dr_sph(ir,1,1)+dnae_dr_sph(ir,2,1))**2+sum3(ir)/PAI4
       end if
    end do
    flg_isp(1)=.true.
      
    sum2=0.d0
    sum4=0.d0
    msphmx_grd=0
!        do isp2=2,min(16,msphmx)                                ! sphset2
!        do isp2=2,msphmx                                        ! sphset3
    do nsp2=2,num_isph_chg
       isp2=isph_chg(nsp2)
       dl2=dble(il3(isp2))
       dl2=dl2*(dl2+1.d0)
!            do isp3=isp2,min(16,msphmx)                         ! sphset2
!            do isp3=isp2,msphmx                                 ! sphset3
       do nsp3=nsp2,num_isph_chg
          isp3=isph_chg(nsp3)
          dl3=dble(il3(isp3))
          dl3=dl3*(dl3+1.d0)
          fac=2.d0;if(isp2.eq.isp3) fac=1.d0
          do n=1,paw_mmt2(isp2,isp3)
             isp=paw_isph2(isp2,isp3,n)
             if(isp.eq.1) cycle
             if(isp.gt.msphmx_grd) msphmx_grd=isp
             flg_isp(isp)=.true.
             cijk=paw_cr2(isp2,isp3,n)
             dl=dble(il3(isp))
             dl=dl*(dl+1.d0)
!print *,isp,isp2,isp3
!print '(5e19.6)', fac, 0.5d0*(dl2+dl3-dl),dl,dl2,dl3
             do is=1,nspin
                do ir=1,nrc,dnr
                   sum2(ir,is,isp)=sum2(ir,is,isp) + &
                        fac*( &
                        dnae_dr_sph(ir,is,isp2)*dnae_dr_sph(ir,is,isp3) + &
                        0.5d0*(dl2+dl3-dl)*nae_sph(ir,is,isp2)*nae_sph(ir,is,isp3)/ &
                        radr_paw(ir,it)/radr_paw(ir,it) &
                        )*cijk
                end do
             end do
                    
             if(nspin.eq.2) then
                do ir=1,nrc,dnr
                   sum4(ir,isp)=sum4(ir,isp) + &
                        fac*( &
                        (dnae_dr_sph(ir,1,isp2)+dnae_dr_sph(ir,2,isp2)) * &
                        (dnae_dr_sph(ir,1,isp3)+dnae_dr_sph(ir,2,isp3)) + &
                        0.5d0*(dl2+dl3-dl) * &
                        (nae_sph(ir,1,isp2)+nae_sph(ir,2,isp2)) * &
                        (nae_sph(ir,1,isp3)+nae_sph(ir,2,isp3))/ &
                        radr_paw(ir,it)/radr_paw(ir,it) &
                        )*cijk
                end do
             end if
             
          end do
       end do
    end do
    
    num_isph_grd=0
    isph_grd=0
    do isp=1,25
       if(flg_isp(isp)) then
          num_isph_grd=num_isph_grd+1
          isph_grd(num_isph_grd)=isp
       end if
    end do
    
!        do isp=2,msphmx_grd
    do nsp=2,num_isph_grd
       isp=isph_grd(nsp)
       do is=1,nspin
          do ir=1,nrc,dnr
             grad_nae2(ir,is,isp)=2.d0*dnae_dr_sph(ir,is,1)*dnae_dr_sph(ir,is,isp) &
                  & + sum2(ir,is,isp)
!if(isnan(grad_nae2(ir,is,isp))) then
!print '(i4,3e19.6)',isp,dnae_dr_sph(ir,is,1),dnae_dr_sph(ir,is,isp),sum2(ir,is,isp)
!stop
!end if
          end do
       end do
       
       if(nspin.eq.2) then
          do ir=1,nrc,dnr
             grad_tnae2(ir,isp)=2.d0*(dnae_dr_sph(ir,1,1)+dnae_dr_sph(ir,2,1)) * &
                  &               (dnae_dr_sph(ir,1,isp)+dnae_dr_sph(ir,2,isp))  &
                         &                + sum4(ir,isp)
!if(isnan(grad_nae2(ir,is,isp))) then
!print '(i4,3e19.6)',isp,dnae_dr_sph(ir,is,1),dnae_dr_sph(ir,is,isp),sum2(ir,is,isp)
!stop
!end if
          end do
       end if
       
    end do
        
    if(nspin.eq.1) then
!            do isp=1,msphmx_grd
       do nsp=1,num_isph_grd
          isp=isph_grd(nsp)
          do ir=1,nrc,dnr
             grad_tnae2(ir,isp)=grad_nae2(ir,1,isp)
          end do
       end do
    end if
    
    deallocate(il3)
    
    return
  end subroutine m_PAWCD_set_sq_der_cd_sdphex2
  
  subroutine m_PAWCD_calc_contact_density
                                   ! AE hard part density at nuclear radius
                                   ! assuming only s-orbital contributes

    integer :: ia, it, is, ir_nucl
    integer :: il1, il2, im1, im2, it1, it2, lmt1, lmt2
    integer :: n, isp
    real(kind=DP)  :: csum, ctmp, c1, c2, fac
    real(kind=DP), allocatable :: contact_charge_density(:)

    allocate( contact_charge_density(natm) ); contact_charge_density = 0.0d0

#if 1
    Do it=1, ntyp
       call calc_nuclear_radius( it, ir_nucl )

       Do ia=1, natm
          if ( ityp(ia) /= it ) cycle

          csum = 0.0d0

          do lmt1=1,ilmt(it)
             il1 = ltp(lmt1,it);  im1 = mtp(lmt1,it);   it1 = taup(lmt1,it)

             do lmt2=lmt1,ilmt(it)
                il2 = ltp(lmt2,it);   im2 = mtp(lmt2,it);    it2 = taup(lmt2,it)

                c1 = psirpw( ir_nucl, il1, it1, it )
                c2 = psirpw( ir_nucl, il2, it2, it )

                fac=2.d0; if( lmt1.eq.lmt2 ) fac=1.d0

                do n=1,il2p(lmt1,lmt2,it)
                   isp = isph(lmt1,lmt2,n,it)
                   if ( isp > 1 ) cycle

                   if ( noncol ) then
                      ctmp = hsr(ia,lmt1,lmt2,1)
                   else
                      ctmp = 0.0d0
                      Do is=1, nspin
                         ctmp = ctmp +hsr(ia,lmt1,lmt2,is)
                      End Do
                   endif

                   csum = csum + fac *ctmp *dl2p(lmt1,lmt2,n,it) *c1 *c2 /sqrt(PAI4)
                end do
             end do
          end do
          csum = csum + rhcorpw(ir_nucl,it)/PAI4

          contact_charge_density(ia) = csum /radr_paw( ir_nucl,it )**2
       end do
    end do

#else
    Do it=1, ntyp
       call calc_nuclear_radius( it, ir_nucl )

       Do ia=1, natm
          if ( ityp(ia) /= it ) cycle

          csum = 0.0d0

          Do lmt1=1, ilmt(it)
             il1 = ltp(lmt1,it);  im1 = mtp(lmt1,it);  it1 = taup(lmt1,it)
             if ( il1 > 1 ) cycle

             Do lmt2=1, ilmt(it)
                il2 = ltp(lmt2,it);  im2 = mtp(lmt2,it);  it2 = taup(lmt2,it)
                if ( il2 > 1 ) cycle

                if ( noncol ) then
                   ctmp = hsr(ia,lmt1,lmt2,1)
                else
                   ctmp = 0.0d0
                   Do is=1, nspin
                      ctmp = ctmp +hsr(ia,lmt1,lmt2,is)
                   End Do
                endif
                c1 = psirpw( ir_nucl, il1, it1, it )
                c2 = psirpw( ir_nucl, il2, it2, it )
                !
                ctmp = ctmp *c1 *c2 /sqrt(PAI4) + rhcorpw(ir_nucl,it)/PAI4
                csum = csum +ctmp /radr_paw( ir_nucl,it )**2
             End Do
          End Do
          contact_charge_density(ia) = csum
       End Do
    End Do
#endif
!
    write(nfout,*)
    write(nfout,*) '------------  MOSSB  ---------------'
    write(nfout,*) '!** contact charge density at nuclear radius '
    write(nfout,*) '!** ia,    density **'
    Do ia=1, natm
       write(nfout,'(I5,F25.12)') ia, contact_charge_density(ia)
    End Do
    write(nfout,*) '----------------------------------------'
    write(nfout,*)

    deallocate( contact_charge_density )

  contains

    subroutine calc_nuclear_radius( it, ir_nucl )
      integer, intent(in) :: it
      integer, intent(out):: ir_nucl

      integer :: ir
      real(kind=DP) :: r0, coeff, mass_no, r_nucl

      r0 = 1.20d0 *1.0D-5/ Bohr                    ! in bohr

      coeff = 1.66053d-27 /9.1093897d-31
      mass_no = amion(it) /coeff

      r_nucl = r0 *( mass_no )**(1.0d0/3.d0)

      Do ir=1, nmesh(it)
         if ( radr_paw(ir,it) > r_nucl ) exit
      End Do
      ir_nucl = ir
    end subroutine calc_nuclear_radius

  end subroutine m_PAWCD_calc_contact_density


end module m_PAW_ChargeDensity

!=======================================================================
!
!  SOFTWARE NAME : PHASE ($Revision: 593 $)
!
!  SUBROUINE:  ex_ggapw91, cr_ggapw91, ex_ggapbe, cr_ggapbe, xclda, ggabek, 
!            ggaprd, xcpotf_wigner, xcpotf_pzold, xcpotf_xalfa, xcpotf_pz,
!            xcpotf_vwn, xcpotf_mjw_bh_gl, cpden, gdiffs, gtgrad, wdcoef,
!            gcoef1, gcoef2, ggrade, cnggrd1, cpval, cpval_abs, getroh, 
!            getroh2, cnggrd, mkprdc, 
!
!  AUTHOR(S): T. Yamasaki, K. Kato   August/20/2003
!  
!  FURTHER MODIFICATION: M. Saito, T. Yamasaki, December/01/2003
!  FURTHER MODIFICATION: T. Yamasaki, June/03/2010
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! $Id: b_XC_Potential.F90 593 2019-06-20 03:47:31Z jkoga $
!!====================================================================
!!        modified  by T.Yamasaki  94/11/14
!!
!!        Modified for Spin polrarized GGA by K. Kato 1995/1/18 
!!
! === xclda etc. are necessary to make 3D_Parallel, too!!! by tkato ============
!!BRANCH_P ORG_Parallel
! ==============================================================================
!$$#ifndef PARA3D
subroutine ex_ggapw91(nspin,ispin,ista_r,iend_r,chgrhr_l,grad_rho,wos,exc &
     &                    ,dFx_drho,dFx_dgradrho, ien)
!!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : PAI,DP
  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  integer,intent(in),optional :: ien
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)  :: grad_rho(ista_r:iend_r,nspin)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)  
  real(kind=DP),intent(out) :: exc
  real(kind=DP),intent(out) :: dFx_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(out) :: dFx_dgradrho(ista_r:iend_r,nspin)


  integer :: is, i, iend_true
  real(kind=DP) :: exc1,facw,d,dd,fk,s,fac,s2,s3,s4&
       & ,p0,p1,p2,p3,p4,p5,p6,f,ex,fs,exd,exdd,exc0,excd,excdd

  real(kind=DP), parameter :: a1 = 0.19645d0
  real(kind=DP), parameter :: a2 = 0.27430d0
  real(kind=DP), parameter :: a3 = 0.15084d0
  real(kind=DP), parameter :: a4 = 100.0d0

! === KT_mod === 2014/11/25
!!!  real(kind=DP), parameter :: ax = -0.7385588d0
       real(kind=DP), parameter ::  ax = -0.7385587663820224d0
!=============== 2014/11/25

  real(kind=DP), parameter :: a  =  7.7956d0
  real(kind=DP), parameter :: b1 =  0.004d0

! === KT_mod === 2014/11/25
!  real(kind=DP), parameter :: thrd   = 0.33333333333d0
!  real(kind=DP), parameter :: thrd4  = 1.333333333333333d0
  real(kind=DP), parameter :: thrd   = 0.33333333333333333333333d0
  real(kind=DP), parameter :: thrd4  = 1.33333333333333333333333d0
!=============== 2014/11/25

  real(kind=DP), parameter :: thpith = 3.0936677262801d0

  iend_true = iend_r
  if(present(ien)) iend_true = min(iend_r,ien)

!---- Spin dependency

  facw = ispin
  exc = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  do is = 1, ispin
     exc1 = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
     do i = ista_r, iend_true       ! MPI
        d  = facw * chgrhr_l(i, is)
        dd = facw * grad_rho(i, is)
        fk = (3.d0*PAI*PAI*d)**thrd
        if(d > 1.d-05) then
           s = dd/(d*fk*2.d0)
        else
           s = 0.d0
        endif

        fac = ax*d**thrd
        s2  = s*s
        s3  = s2*s
        s4  = s2*s2
        p0  = 1.d0/(dsqrt(1.d0+a*a*s2))
        p1  = dlog(a*s+1.d0/p0)
        p2  = dexp(-a4*s2)
        p3  = 1.d0/(1.d0+a1*s*p1+b1*s4)
        p4  = 1.d0 + a1*s*p1 + (a2-a3*p2)*s2
        f   = p3*p4
        ex  = fac*f*d
        p5  = 2.d0 *(s*(a2-a3*p2)+a3*a4*s3*p2 - 2.d0*b1*s3)
        p6  = (a1*(p1+a*s*p0)+4.d0*b1*s3)*((a2-a3*p2)*s2-b1*s4)
        fs  = (p5*p3-p6*p3*p3)
        exd = thrd4*fac*(f-s*fs)
        exdd = ax*fs*0.5d0/thpith

        exc0 = ex / facw
        excd = exd
        dFx_drho(i, is) = excd 
        excdd = exdd
!!$c gradient of charge density 95/12/3 H.S.
        if(dabs(grad_rho(i, is)) > 1.d-9) then
           dFx_dgradrho(i, is) = excdd / grad_rho(i, is)
        else
           dFx_dgradrho(i, is) = 0.d0
        endif
        exc1 = exc1 + exc0*wos(i)
     end do
     exc = exc + exc1
  end do
end subroutine ex_ggapw91


!!===================================================================
!!        modified  by T.Yamasaki  94/11/15
!!
!!        The original is modified and Spin polrarized GGA programs
!!        are added in this subroutine
!!                                                      by K. Kato 1995/1/18 
!!
subroutine cr_ggapw91(nspin,ispin,ista_r,iend_r,chgrhr_l,grad_trho,wos,exc,dF_drho,ien)
!!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : PAI,DP
  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  integer,intent(in),optional :: ien
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(inout) :: grad_trho(ista_r:iend_r)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)  
  real(kind=DP),intent(inout) :: exc
  real(kind=DP),intent(inout) :: dF_drho(ista_r:iend_r,nspin)

  real(kind=DP), parameter :: zeta_minimum    = 1.d-4
  real(kind=DP), parameter :: zeta_minimum2   = 1.d-6
  real(kind=DP), parameter :: density_minimum = 1.d-20
  real(kind=DP), parameter :: density_minimum2= 1.d-5

  real(kind=DP), parameter :: a  = 0.0310907d0,     a1   = 0.21370d0
  real(kind=DP), parameter :: b1 = 7.5957d0,        b2n  = 3.5876d0
  real(kind=DP), parameter :: b3 = 1.6382d0,        b4   = 0.49294d0
  real(kind=DP), parameter :: p  = 1.00d0,          p1   = p+1.d0
  real(kind=DP), parameter :: ap  = 0.015545d0,     a1p  = 0.20548d0
  real(kind=DP), parameter :: b1p = 14.1189d0,      b2np = 6.1977d0
  real(kind=DP), parameter :: b3p = 3.3662d0,       b4p = 0.62517d0
! vwn 95/12/2 Y.M
  real(kind=DP), parameter :: aq  = 0.016887d0,     a1q = 0.11125d0
  real(kind=DP), parameter :: b1q = 10.3570d0,      b2nq = 3.6231d0
  real(kind=DP), parameter :: b3q = 0.88026d0,      b4q = 0.49671d0
! vwn 95/12/2 Y.M

  real(kind=DP), parameter :: xnu = 15.75592d0,     cc0 =  0.004235d0
  real(kind=DP), parameter :: cx  = -0.001667212d0, alf =  0.09d0
  real(kind=DP), parameter :: c1  =  0.002568d0,    c2  =  0.023266d0
  real(kind=DP), parameter :: c3  =  7.389d-6,      c4  =  8.723d0
  real(kind=DP), parameter :: c5  =  0.472d0,       c6  =  7.389d-2
  real(kind=DP), parameter :: a4  = 100.d0

! ==== KT_mod ==== 2014/11/25
!  real(kind=DP), parameter :: thrd   = 0.333333333333d0
!  real(kind=DP), parameter :: sixth7 = 1.1666666666666666d0
  real(kind=DP), parameter :: thrd   = 0.3333333333333333333333d0
  real(kind=DP), parameter :: sixth7 = 1.1666666666666666666666d0
! ================= 2014/11/25

  integer       :: is,i,iend_true
  real(kind=DP) :: facw,bet,delt,exc1,g,g3,g4,facpon,d,dd,rs,fk,sk,t,s&
       & , q0,rs12,rs32,rsp,q1,q2,eu,q3,eurs,ecd,pon,b,b2,t2,s2,t4,t6 &
       & , rs2,rs3,q4,q5,q6,q7,cc,r0,r1,coeff,r2,r3,a4ms,h0,h1,h,q8 &
       & , h0t,h0b,h0rs,h1t,ccrs,r1rs,h1rs,ht,hrs &
       & , ec1,ec1d,ec1dd,exc0,excd,excdd &
       & , thrd2,thrd4,zeta,q0p,q1p,q2p,q3p,q0q,q1q,q2q,q3q,fzd,fzdd,fz&
       & , euzt,zetadxd,bzt,h0zt,h1zt,gzt &
       & , onpzeta, onmzeta, onzt4 

! ==== kT_add ===== 2014/11/25
  real(kind=DP), parameter  :: eta = 1.d-12
  real(kind=DP), parameter  :: sixthm = -0.16666666666666666666d0
! ================= 2014/11/25

  facw = ispin

! === KT_mod === 2014/11/25
!  bet = xnu*cc0
  bet=0.06672455060314922d0
! ============== 2014/11/25

  delt = 2.d0*alf/bet

  iend_true = iend_r
  if(present(ien)) iend_true = min(iend_r,ien)

!---- Spin dependency

#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  do is=1, ispin
     exc1 = 0.d0
     if ( ispin == 1 ) then
        g = 1.d0
        g3  = g**3
        g4  = g3*g
        facpon = -delt/(g3*bet)

#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
        do i = ista_r, iend_true  ! MPI
           d = facw*chgrhr_l(i, 1)
           if(d < density_minimum) cycle
! gradient of charge density 95/12/3 H.S.
           dd =facw* grad_trho(i)
           rs = (0.75d0/(PAI*d))**thrd
           fk = (3.d0*PAI*PAI*d)**thrd
           sk = dsqrt(4.d0*fk/PAI)
           if(d > density_minimum2 ) then
              t = dd/(d*sk*2.d0)
              s = dd/(d*fk*2.d0)
           else
              t = 0.d0
              s = 0.d0
           endif

           q0 = -2.d0 *a*(1.d0+a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2.d0*a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log(1.d0 + 1.d0/q1)
           eu = q0*q2
           q3 = a*(b1/rs12 +2.d0*b2n +3.d0*b3*rs12 +2.d0*b4*p1*rsp)
           eurs = -2.d0 *a*a1*q2 - q0*q3/(q1**2 + q1)
           ecd = eu-thrd*rs*eurs
           pon = facpon*eu
           b   = delt/(dexp(pon)-1.d0)
           b2  = b*b
           t2  = t*t
           s2  = s*s
           t4  = t2*t2
           t6  = t4*t2
           rs2 = rs*rs
           rs3 = rs2*rs
           q4  = 1.d0+b*t2
           q5  = 1.d0+b*t2+b2*t4
           q6  = c1+c2*rs+c3*rs2
           q7  = 1.d0+c4*rs+c5*rs2+c6*rs3
           cc  = -cx + q6/q7
           r0  = (sk/fk)**2
           r1  = a4*r0*g4
           coeff = cc-cc0-3.d0*cx/7.d0
           r2  = xnu*coeff*g3
           a4ms = -a4*g4*s2
           r3  = dexp(a4ms)
           h0  = g3*(bet/delt)*dlog(1.d0+delt*q4*t2/q5)
           h1  = r3*r2*t2
           h   = h0+h1
!======================================================
           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2.d0*bet*t*( 1.d0 +2.d0*b*t2 )/q8 * g3
           h0b = -bet*t6*( 2.d0*b +b2*t2 )/q8 * g3
           h0rs = h0b*b*eurs*(b+delt)/ bet / g3
           h1t  = 2.d0*r3*r2*t*(1.d0-r1*t2)
           ccrs = ( c2 +2.d0*c3*rs )/q7 -q6*( c4 +2*c5*rs +3.d0*c6*rs2 )/q7**2
           r1rs = 100.d0 *r0/rs
           h1rs = xnu*t2*r3*(ccrs - coeff*t2*r1rs) * g3
           ht   = h0t +h1t
           hrs  = h0rs +h1rs
           ec1  = d*h/facw
           ec1d = h -thrd*rs*hrs -sixth7*t*ht
           ec1dd = 0.5d0*ht/sk

!---------------------------------------------------
           exc0 = eu*d/facw + ec1
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(dabs(grad_trho(i)) > 1.0d-9) then
              grad_trho(i) = excdd / grad_trho(i)
           else
              grad_trho(i) = 0.d0
           endif
!!$           exec1 = eu*d/facw
           exc1 = exc1 + exc0*wos(i)
        end do

     else if ( ispin  == 2 ) then
        thrd2 = thrd * 2.0d0
        thrd4 = thrd * 4.0d0
        fzdd = 8.d0 /(9.d0*(2.d0**thrd4-2.d0))

        do i = ista_r, iend_r      ! MPI
           d = chgrhr_l(i, 1) + chgrhr_l(i, ispin)
           if(d.lt.density_minimum) cycle
           zeta = ( chgrhr_l(i, 1) - chgrhr_l(i, ispin) ) / d
           onpzeta = 2.d0*chgrhr_l(i,1)     / d
           onmzeta = 2.d0*chgrhr_l(i,ispin) / d
           g  = ( onpzeta**thrd2 + onmzeta**thrd2) * 0.5d0
!!$           g  = ( (1+zeta)**thrd2 + (1-zeta)**thrd2 ) * 0.5

           if(dabs(zeta) < zeta_minimum) then
              fz = 4.d0/9.d0 * zeta*zeta*(1.d0 + 5.d0/54.d0 * zeta*zeta&
                   &                 *(1.d0 +44.d0/133.d0* zeta*zeta ))&
                   &    /(2.d0**thrd4-2.d0)
           else
              fz = ( (1.d0+zeta)**thrd4+(1.d0-zeta)**thrd4-2.d0)/(2.d0**thrd4-2.d0)
           end if

           g3  = g**3
           g4  = g3*g
           facpon = -delt/(g3*bet)

           if(d < density_minimum) cycle
! gradient of charge density 95/12/3 H.S.
           dd = grad_trho(i)
!!$c        dd = grad_rho(i, 1) + grad_rho(i, 2)
! gradient of charge density 95/12/3 H.S.
           rs = (0.75d0/(PAI*d))**thrd
           fk = (3.d0*PAI*PAI*d)**thrd
           sk = dsqrt(4.d0*fk/PAI)

           if(d > density_minimum2) then
! --> check if this is correct or not
!!$              t = dd/(d*sk*2.d0)
              t = dd/(d*sk*2.d0)/g  ! 2011/04/26 revised according to a Katsumata-san's comment.
! <--
              s = dd/(d*fk*2.d0)
           else
              t = 0.d0
              s = 0.d0
           endif

           q0 = -2.d0 *a*(1.d0+a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2.d0*a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log(1.d0+1.d0/q1)
           q3 = a*( b1/rs12 +2.d0*b2n +3.d0*b3*rs12 +2.d0*b4*p1*rsp )

           q0p = -2.d0*ap*(1.d0+a1p*rs)
           q1p =  2.d0*ap*(b1p*rs12+b2np*rs+b3p*rs32+b4p*rs*rsp)
           q2p = log(1.d0+1.d0/q1p)
           q3p = ap*(b1p/rs12+2.d0*b2np+3.d0*b3p*rs12+2.d0*b4p*p1*rsp)
! vwn 95/12/2 Y.M
           q0q = -2.d0 *aq*(1.d0+a1q*rs)
           q1q =  2.d0 *aq*(b1q*rs12+b2nq*rs+b3q*rs32+b4q*rs*rsp)
           q2q = log(1.d0 +1.d0/q1q)
           q3q = aq*(b1q/rs12+2.d0*b2nq+3.d0*b3q*rs12+2.d0*b4q*p1*rsp)

           if(dabs(zeta) < zeta_minimum) then
              fzd = 8.d0/(9.d0*(2.d0**thrd4 - 2.d0 )) &
                   &     *zeta *( 1.d0 + 5.d0/27.d0 *zeta*zeta &
                   &           *( 1.d0 +22.d0/45.d0 *zeta*zeta ))
           else
              fzd = (4.d0/3.d0)/(2.d0**thrd4-2.d0)*(onpzeta**thrd-onmzeta**thrd )
           end if

           onzt4 = onmzeta*onpzeta * (1.d0 + zeta*zeta)
           eu = q0*q2 + ( q0p * q2p - q0 * q2 ) * fz * zeta**4 &
                &        -   q0q * q2q * fz / fzdd * onzt4
           eurs = (-2.d0*a*a1*q2 - q0*q3/(q1**2+q1)) * (1.d0-fz*zeta**4) &
                &+(-2.d0*ap*a1p*q2p-q0p*q3p/(q1p**2+q1p))*fz*zeta**4 &
                &-(-2.d0*aq*a1q*q2q-q0q*q3q/(q1q**2+q1q))*fz/fzdd*onzt4
           euzt = -q0q*q2q/fzdd*(fzd*(1.d0-zeta**4)-4.d0*fz*zeta**3) &
                &+(q0p*q2p-q0*q2)*(fzd*zeta +4.d0*fz )*zeta**3
! vwn 95/12/2 Y.M
           zetadxd = - 2.d0 * chgrhr_l(i, 3-is) * (-1.d0)**is / d
           ecd = eu - thrd*rs*eurs + euzt * zetadxd
!
! ==== KT_mod ==== 2014/11/25
!           if(onpzeta < zeta_minimum2 .or. onmzeta < zeta_minimum2) then
!              ec1 = 0.d0; ec1d = 0.d0; ec1dd= 0.d0
!              goto 10
!           end if
! ================= 2014/11/25

           pon = facpon*eu
           b   = delt/(dexp(pon)-1.d0)
           b2  = b*b
           t2  = t*t
           s2  = s*s
           t4  = t2*t2
           t6  = t4*t2
           rs2 = rs*rs
           rs3 = rs2*rs
           q4  = 1.d0+b*t2
           q5  = 1.d0+b*t2+b2*t4
           q6  = c1+c2*rs+c3*rs2
           q7  = 1.d0+c4*rs+c5*rs2+c6*rs3
           cc  = -cx + q6/q7
           r0  = (sk/fk)**2
           r1  = a4*r0*g4
           coeff = cc-cc0-3.d0*cx/7.d0
           r2  = xnu*coeff*g3
! --> Check if this is correct or not
!!$           a4ms = -a4*g4*s2
           a4ms = -r1*t2   ! 2011/04/26 revised according to a Katsumata-san's comment.
! <--
           r3  = dexp(a4ms)
           h0  = g3*(bet/delt)*dlog(1.d0+delt*q4*t2/q5)
           h1  = r3*r2*t2
           h   = h0+h1

           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2*bet*t*(1.d0+2*b*t2)/q8 * g3
           h0b = -bet*t6*(2*b+b2*t2)/q8 * g3
! --> Check if this is correct or not
!!$           h0rs = h0b * b2 * eurs / bet / g3
           h0rs = h0b * b * eurs * (b+delt) / bet / g3   ! 2011/04/26 revised according to a Katsumata-san's comment.
! <--
           h1t  = 2*r3*r2*t*(1.d0-r1*t2)
           ccrs = (c2+2*c3*rs)/q7-q6*(c4+2*c5*rs+3*c6*rs2)/q7**2
! --> Check if this is correct or not
!!$           r1rs = 100*r0/rs
           r1rs = r1/rs  ! 2011/04/26 revised according to a Katsumata-san's comment.
! <--
           h1rs = xnu*t2*r3*(ccrs - coeff*t2*r1rs) * g3
           ht   = h0t+h1t
           hrs  = h0rs + h1rs

           if(dabs(zeta) < zeta_minimum) then
              gzt = -2.d0/9.d0*zeta *( 1.d0 +14.d0/27.d0 *zeta*zeta &
                   &                *( 1.d0 +13.d0/18.d0 *zeta*zeta ))
           else
! ==== KT_mod ==== 2014/11/25
!!!              gzt = ( 1.d0/onpzeta**thrd -1.d0/onmzeta**thrd )/3.d0
	      gzt = ( (onpzeta**2+eta)**sixthm - (onmzeta**2+eta)**sixthm)/3.d0
! ================ 2014/11/25
           end if

! --> Check if this is correct or not
!!$           bzt = pon*b**2 * (euzt-3*eu*gzt/g) / ( bet * g3 ) 
           bzt = b * (b+delt) * (euzt-3*eu*gzt/g) / ( bet * g3 )  ! 2011/04/26 revised according to a Katsumata-san's comment.
! <--
           h0zt = 3*gzt*h0/g + h0b*bzt
! --> Check if this is correct or not
!!$           h1zt =(3*gzt + 4*gzt*a4ms ) * h1 / g
           h1zt =(3.d0 + 4.d0*a4ms ) * h1 * gzt/ g   ! 2011/04/26 revised according to a Katsumata-san's comment.
! <--
           
           ec1  = d*h * 0.5d0

! --> Check if this is correct or not
!!$           ec1d = h-thrd*rs*hrs-sixth7*t*ht + (h0zt+h1zt) * zetadxd
           ec1d = h-thrd*rs*hrs-sixth7*t*ht + (h0zt+h1zt-gzt*ht/g) * zetadxd    ! 2011/04/26 revised according to a Katsumata-san's comment.
!!$           ec1dd = 0.5*ht/sk
           ec1dd = 0.5d0*ht/sk/g     ! 2011/04/26 revised according to a Katsumata-san's comment.
! <--

10         continue
           exc0 = eu*d * 0.5d0 + ec1
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(is == 2) then
              if(dabs(grad_trho(i)) > 1.0d-9) then
                 grad_trho(i) = excdd / grad_trho(i)
              else
                 grad_trho(i) = 0.d0
              endif
           endif
! gradient of charge density 95/12/3 H.S.
!!$           exec1 = eu*d * 0.5d0
           exc1 = exc1 + exc0*wos(i)
        end do
     end if
     exc = exc + exc1
  end do
end subroutine cr_ggapw91

#ifndef PREV_EX_GGAPBE
!!$====================================================================
!!$        modified  by T.Yamasaki  94/11/14
!!$
!!$        Modified for Spin polrarized GGA by K. Kato 1995/1/18 
!!$
!!$        Modified to Perdew-Burke-Ernzerhof(PBE) GGA by K. Kato 1999/4/1 
!!$
subroutine ex_ggapbe(nspin,ispin,ista_r,iend_r,chgrhr_l,grad_rho,wos,exc,dFx_drho,dFx_dgradrho,revPBE,ien)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : DP,PAI
  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  integer,intent(in),optional :: ien
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)  :: grad_rho(ista_r:iend_r,nspin)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)  
  real(kind=DP),intent(out) :: exc
  real(kind=DP),intent(out) :: dFx_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(out) :: dFx_dgradrho(ista_r:iend_r,nspin)
  logical, intent(in),optional :: revPBE

!!  real(kind=DP), parameter :: ax = -0.7385588d0
  real(kind=DP), parameter :: ax = -0.7385587663820224d0 !! ax = -(3/4)*(3/PI)^(1/3)
  real(kind=DP), parameter :: thrd = 0.33333333333d0, thrd4 = 1.333333333333333d0
  real(kind=DP), parameter :: thpith = 3.0936677262801d0
!!  real(kind=DP), parameter :: cupa = 0.804, yum = 0.21951
!!  real(kind=DP), parameter :: cupa = 0.8040d0, yum = 0.2195149727645171d0
  real(kind=DP), parameter ::  yum = 0.2195149727645171d0
  real(kind=DP) :: cupa

  real(kind=DP) :: facw,d,dd,fk,s,fac,s2,yums2,f,ex,fs,exd,exdd,exc0,excd,excdd,exc1
  integer       :: is,i,iend_true
  logical       :: repbe

  repbe = .false.
  if(present(revPBE)) repbe = revPBE
  cupa = 0.8040d0
  if(repbe) cupa = 1.245d0

  iend_true = iend_r
  if(present(ien)) iend_true = min(iend_r,ien)

!---- Spin dependency

  facw = ispin
  exc  = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  do is = 1, ispin
     exc1 = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
     do i = ista_r, iend_true  ! MPI
        d  = facw * chgrhr_l(i, is)
        dd = facw * grad_rho(i, is)
        fk = (3.d0*PAI*PAI*d)**thrd
!!$        sk = dsqrt(4*fk/PAI)
        if(d > 1.d-05) then
           s = dd/(d*fk*2.d0)
        else
           s = 0.d0
        endif
!-------------------------------------
        fac = ax*d**thrd
        s2  = s*s
        yums2 = yum * s2
        f = 1.d0 + cupa * yums2 / ( cupa + yums2 )
        ex  = fac*f*d
        fs = 2.d0 * cupa ** 2 * yum * s / ( cupa + yums2 ) ** 2
        exd = thrd4*fac*(f-s*fs)
        exdd = ax*fs*0.5d0/thpith
!------------------------------------------     
        exc0 = ex / facw
        excd = exd
        dFx_drho(i, is) = excd 
        excdd = exdd
! gradient of charge density 95/12/3 H.S.
        if(dabs(grad_rho(i, is)) > 1.d-9) then
           dFx_dgradrho(i, is) = excdd / grad_rho(i, is)
        else
           dFx_dgradrho(i, is) = 0.d0
        endif
! gradient of charge density 95/12/3 H.S.
        exc1 = exc1 + exc0*wos(i)
     end do
     exc = exc + exc1
  end do
end subroutine ex_ggapbe
#else
!!$====================================================================
!!$        modified  by T.Yamasaki  94/11/14
!!$
!!$        Modified for Spin polrarized GGA by K. Kato 1995/1/18 
!!$
!!$        Modified to Perdew-Burke-Ernzerhof(PBE) GGA by K. Kato 1999/4/1 
!!$
! ==== DEBUG! ==================================================================
#if 1
subroutine ex_ggapbe(nspin,ispin,ista_r,iend_r,chgrhr_l,grad_rho,wos,exc,dFx_drho,dFx_dgradrho,ien)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : DP,PAI
  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  integer,intent(in),optional :: ien
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)  :: grad_rho(ista_r:iend_r,nspin)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)  
  real(kind=DP),intent(out) :: exc
  real(kind=DP),intent(out) :: dFx_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(out) :: dFx_dgradrho(ista_r:iend_r,nspin)

#ifndef PREV_EX_GGAPBE
  real(kind=DP), parameter :: ax = -0.7385587663820224d0 !! ax = -(3/4)*(3/PI)^(1/3)
#else
  real(kind=DP), parameter :: ax = -0.7385588d0
#endif
  real(kind=DP), parameter :: thrd = 0.33333333333d0, thrd4 = 1.333333333333333d0
  real(kind=DP), parameter :: thpith = 3.0936677262801d0
#ifndef PREV_EX_GGAPBE
  real(kind=DP), parameter :: cupa = 0.8040d0, yum = 0.2195149727645171d0
#else
  real(kind=DP), parameter :: cupa = 0.804, yum = 0.21951
#endif

  real(kind=DP) :: facw,d,dd,fk,s,fac,s2,yums2,f,ex,fs,exd,exdd,exc0,excd,excdd,exc1
  integer       :: is,i,iend_true

  iend_true = iend_r
  if(present(ien)) iend_true = min(iend_r,ien)
!---- Spin dependency

  facw = ispin
  exc  = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  do is = 1, ispin
     exc1 = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
     do i = ista_r, iend_true
        d  = facw * chgrhr_l(i, is)
        dd = facw * grad_rho(i, is)
        fk = (3*PAI*PAI*d)**thrd
!!$        sk = dsqrt(4*fk/PAI)
        if(d > 1.d-05) then
           s = dd/(d*fk*2)
        else
           s = 0.d0
        endif
!-------------------------------------
        fac = ax*d**thrd
        s2  = s*s
        yums2 = yum * s2
        f = 1 + cupa * yums2 / ( cupa + yums2 )
        ex  = fac*f*d
        fs = 2 * cupa ** 2 * yum * s / ( cupa + yums2 ) ** 2
        exd = thrd4*fac*(f-s*fs)
        exdd = ax*fs*0.5d0/thpith
!------------------------------------------     
        exc0 = ex / facw
        excd = exd
        dFx_drho(i, is) = excd 
        excdd = exdd
! gradient of charge density 95/12/3 H.S.
        if(dabs(grad_rho(i, is)) > 1.d-9) then
           dFx_dgradrho(i, is) = excdd / grad_rho(i, is)
        else
           dFx_dgradrho(i, is) = 0.d0
        endif
! gradient of charge density 95/12/3 H.S.
        exc1 = exc1 + exc0*wos(i)
     end do
     exc = exc + exc1
  end do
end subroutine ex_ggapbe
#else
subroutine ex_ggapbe(nspin,ispin,chgrhr_l,grad_rho,f2or1,exc,dFx_drho,dFx_dgradrho)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : DP,PAI
  use m_Parallelization,   only : ista_fftph, iend_fftph
  implicit none

  integer,intent(in)        :: nspin,ispin
  real(kind=DP),intent(in)  :: chgrhr_l(ista_fftph:iend_fftph,ispin)
  real(kind=DP),intent(in)  :: grad_rho(ista_fftph:iend_fftph,nspin)
  real(kind=DP),intent(in)  :: f2or1(ista_fftph:iend_fftph)  
  real(kind=DP),intent(out) :: exc
  real(kind=DP),intent(out) :: dFx_drho(ista_fftph:iend_fftph,nspin)
  real(kind=DP),intent(out) :: dFx_dgradrho(ista_fftph:iend_fftph,nspin)

#ifndef PREV_EX_GGAPBE
  real(kind=DP), parameter :: ax = -0.7385587663820224d0 !! ax = -(3/4)*(3/PI)^(1/3)
#else
  real(kind=DP), parameter :: ax = -0.7385588d0
#endif
  real(kind=DP), parameter :: thrd = 0.33333333333d0, thrd4 = 1.333333333333333d0
  real(kind=DP), parameter :: thpith = 3.0936677262801d0
#ifndef PREV_EX_GGAPBE
  real(kind=DP), parameter :: cupa = 0.8040d0, yum = 0.2195149727645171d0
#else
  real(kind=DP), parameter :: cupa = 0.804, yum = 0.21951
#endif

  real(kind=DP) :: facw,d,dd,fk,s,fac,s2,yums2,f,ex,fs,exd,exdd,exc0,excd,excdd,exc1
  integer       :: is,i

!---- Spin dependency

  facw = ispin
  exc  = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  do is = 1, ispin
     exc1 = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
     do i = ista_fftph, iend_fftph
        d  = facw * chgrhr_l(i, is)
        dd = facw * grad_rho(i, is)
        fk = (3*PAI*PAI*d)**thrd
!!$        sk = dsqrt(4*fk/PAI)
        if(d > 1.d-05) then
           s = dd/(d*fk*2)
        else
           s = 0.d0
        endif
!-------------------------------------
        fac = ax*d**thrd
        s2  = s*s
        yums2 = yum * s2
        f = 1 + cupa * yums2 / ( cupa + yums2 )
        ex  = fac*f*d
        fs = 2 * cupa ** 2 * yum * s / ( cupa + yums2 ) ** 2
        exd = thrd4*fac*(f-s*fs)
        exdd = ax*fs*0.5d0/thpith
!------------------------------------------     
        exc0 = ex / facw
        excd = exd
        dFx_drho(i, is) = excd 
        excdd = exdd
! gradient of charge density 95/12/3 H.S.
        if(dabs(grad_rho(i, is)) > 1.d-9) then
           dFx_dgradrho(i, is) = excdd / grad_rho(i, is)
        else
           dFx_dgradrho(i, is) = 0.d0
        endif
! gradient of charge density 95/12/3 H.S.
        exc1 = exc1 + exc0*f2or1(i)
     end do
     exc = exc + exc1
  end do
end subroutine ex_ggapbe
#endif
! ==== DEBUG! ==================================================================
#endif

#ifndef PREV_CR_GGAPBE
!!$===================================================================
!!$        modified  by T.Yamasaki  94/11/15
!!$
!!$        The original is modified and Spin polrarized GGA programs
!!$        are added in this subroutine
!!$                                                      by K. Kato 1995/1/18 
!!$
!!$        Modified to Perdew-Burke-Ernzerhof(PBE) GGA by K. Kato 1999/4/1 
!!$
subroutine cr_ggapbe(nspin,ispin,ista_r,iend_r,chgrhr_l,grad_trho,wos,exc,dF_drho,ecor,ien)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : PAI,DP
  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  integer,intent(in),optional :: ien
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(inout) :: grad_trho(ista_r:iend_r)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)  
  real(kind=DP),intent(inout) :: exc
  real(kind=DP),intent(inout) :: dF_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(out),optional :: ecor
  real(kind=DP), parameter :: zeta_minimum    = 1.d-4
  real(kind=DP), parameter :: zeta_minimum2   = 1.d-6
  real(kind=DP), parameter :: density_minimum = 1.d-20
  real(kind=DP), parameter :: density_minimum2= 1.d-5

  real(kind=DP), parameter  :: a  = 0.0310907d0,    a1   = 0.21370d0
  real(kind=DP), parameter  :: b1 = 7.5957d0,       b2n  = 3.5876d0
  real(kind=DP), parameter  :: b3 = 1.6382d0,       b4   = 0.49294d0
  real(kind=DP), parameter  :: p  = 1.00d0,         p1   = p+1.d0
!Fix!  real(kind=DP), parameter  :: ap  = 0.015545d0,    a1p  = 0.20548d0
  real(kind=DP), parameter  :: ap  = 0.01554535d0,    a1p  = 0.20548d0
  real(kind=DP), parameter  :: b1p = 14.1189d0,     b2np = 6.1977d0
  real(kind=DP), parameter  :: b3p = 3.3662d0,      b4p  = 0.62517d0
! vwn 95/12/2 Y.M
!Fix!  real(kind=DP), parameter  :: aq  = 0.016887d0,    a1q  = 0.11125d0
  real(kind=DP), parameter  :: aq  = 0.0168869d0,    a1q  = 0.11125d0
  real(kind=DP), parameter  :: b1q = 10.3570d0,     b2nq = 3.6231d0
  real(kind=DP), parameter  :: b3q = 0.88026d0,     b4q  = 0.49671d0
! vwn 95/12/2 Y.M
  !Fix!real(kind=DP), parameter  :: gamma = 0.031091
  real(kind=DP), parameter  :: gamma = 0.03109069086965489503494086371273d0
!--------------------------
!Fix!  real(kind=DP), parameter  :: xnu = 15.75592d0, cc0 = 0.004235d0
  real(kind=DP), parameter  :: bet=0.06672455060314922d0
  real(kind=DP), parameter  :: delt=bet/gamma
  real(kind=DP), parameter  :: thrd = 0.333333333333d0, sixth7 = 1.1666666666666666d0

!Fix! T.Yamatomto 2011/06/29
  real(kind=DP), parameter  :: eta = 1.d-12
  real(kind=DP), parameter  :: sixthm = -0.16666666666666d0
!Fix! T.Yamatomto 2011/06/29


  integer       :: is,i,iend_true
  real(kind=DP) :: facw,exc1,g,g3,facpon,d,dd,rs,fk,sk,t,q0 &
       &         , rs12,rs32,rsp,q1,q2,eu,q3,eurs,ecd,pon &
       &         , b,b2,t2,t4,t6,q4,q5,h0,h,q8,h0t,h0b,h0rs,ht,hrs &
       &         , ec1,ec1d,ec1dd,exc0,excd,excdd &
       &         , thrd2,thrd4,fzdd,zeta,onpzeta,onmzeta,fz,zetadxd &
       &         , q0p,q1p,q2p,q3p,q0q,q1q,q2q,q3q,fzd,onzt4,gzt,bzt,h0zt,euzt

  facw = ispin

  iend_true = iend_r
  if(present(ien)) iend_true = min(iend_r,ien)
!Fix!  bet = xnu*cc0
!Fix!  delt = bet / gamma
!---- Spin dependency
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  if(present(ecor)) ecor = 0.d0
  do is = 1, ispin
     exc1 = 0.d0
     if ( ispin == 1 ) then
        g   = 1.d0
        g3  = g**3
!!$        g4  = g3*g
        facpon = -delt/(g3*bet)

#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
        do i = ista_r,iend_true ! MPI
           d  = facw*chgrhr_l(i, 1)
           if(d < density_minimum) cycle
! gradient of charge density 95/12/3 H.S.
           dd = facw* grad_trho(i)
           !Fix!rs = (0.75/(PAI*d))**thrd
           rs = (0.75d0/(PAI*d))**thrd
           fk = (3.d0*PAI*PAI*d)**thrd
           sk = dsqrt(4.d0*fk/PAI)
           if(d > density_minimum2) then
              t = dd/(d*sk*2.d0)
!!$              s = dd/(d*fk*2)
           else
              t = 0.d0
!!$              s = 0.d0
           endif

           q0 = -2.d0 *a*(1.d0 + a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2.d0 *a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log( 1.d0 + 1.d0/q1)
           eu = q0*q2
           q3 = a*(b1/rs12 +2.d0*b2n +3.d0*b3*rs12 +2.d0*b4*p1*rsp)
           eurs = -2.d0 *a*a1*q2 - q0*q3/(q1**2 + q1)
           ecd = eu-thrd*rs*eurs
           pon = facpon*eu
           b   = delt/(dexp(pon)-1.d0)
           b2  = b*b
           t2  = t*t
!!$           s2  = s*s
           t4  = t2*t2
           t6  = t4*t2
           q4  = 1.d0 + b*t2
           q5  = 1.d0 + b*t2+b2*t4
           h0  = g3*(bet/delt)*dlog(1d0+delt*q4*t2/q5)
           h   = h0
           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2.d0 *bet*t*( 1.d0 +2d0 *b*t2)/q8 * g3
           h0b = -bet*t6*( 2.d0 *b+b2*t2)/q8 * g3
           h0rs = h0b*b*eurs*(b+delt)/ bet / g3
           ht   = h0t
           hrs  = h0rs
           ec1  = d*h/facw
           ec1d = h-thrd*rs*hrs-sixth7*t*ht
           !Fix!ec1dd = 0.5*ht/sk
           ec1dd = 0.5d0*ht/sk

           exc0 = eu*d/facw + ec1
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(dabs(grad_trho(i)) > 1.0d-9) then
              grad_trho(i) = excdd / grad_trho(i)
           else
              grad_trho(i) = 0.d0
           endif
! gradient of charge density 95/12/3 H.S.
!!$           exec1 = eu*d/facw
           exc1 = exc1 + exc0*wos(i)
        end do

     else if ( ispin ==  2 ) then
        thrd2 = thrd * 2.d0
        thrd4 = thrd * 4.d0
        fzdd = 8.d0 /(9.d0*(2.d0**thrd4 - 2.d0 ))

        do i = ista_r,iend_r
           d = chgrhr_l(i, 1) + chgrhr_l(i, ispin)
           if(d < density_minimum ) cycle
           zeta = ( chgrhr_l(i, 1) - chgrhr_l(i, 2) ) / d
           onpzeta = 2.d0 *chgrhr_l(i, 1) / d
           onmzeta = 2.d0 *chgrhr_l(i, 2) / d
           g = ( onpzeta**thrd2 + onmzeta**thrd2 )/2.d0
           if(dabs(zeta) < zeta_minimum ) then
              fz= 4.d0/9.d0 *zeta*zeta*(1.d0 + 5.d0/54.d0 *zeta*zeta &
                   &               *(1.d0 +44.d0/135.d0*zeta*zeta )) &
                   &       /(2.d0**thrd4 -2.d0)
           else
              fz = (onpzeta**thrd4 + onmzeta**thrd4 -2.d0) / (2.d0**thrd4 - 2.d0)
           end if
           g3  = g**3
!!$           g4  = g3*g
           facpon = -delt/(g3*bet)
           if(d < density_minimum) cycle
           dd = grad_trho(i)
           rs = (0.75d0/(PAI*d))**thrd
           fk = (3.d0*PAI*PAI*d)**thrd
           sk = dsqrt(4.d0*fk/PAI)

           if(d > density_minimum2) then
!Fix!              t = dd/(d*sk*2)
              t = dd/(d*sk*2.d0*g)
!!$              s = dd/(d*fk*2)
           else
              t = 0.d0
!!$              s = 0.d0
           endif

           q0 = -2.d0 *a*(1.d0+a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2.d0 *a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log( 1.d0 +1.d0/q1 )
           q3 = a*(b1/rs12 +2.d0*b2n +3.d0*b3*rs12 +2.d0*b4*p1*rsp)

           q0p = -2.d0 *ap*(1.d0+a1p*rs)
           q1p = 2.d0*ap*(b1p*rs12+b2np*rs+b3p*rs32+b4p*rs*rsp)
           q2p = log(1.d0 +1.d0/q1p)
           q3p = ap*(b1p/rs12 +2.d0*b2np +3.d0*b3p*rs12 +2.d0*b4p*p1*rsp)
! vwn 95/12/2 Y.M
           q0q = -2.d0*aq*(1.d0+a1q*rs)
           q1q =  2.d0*aq*(b1q*rs12+b2nq*rs+b3q*rs32+b4q*rs*rsp)
           q2q = log(1.d0 +1.d0/q1q)
           q3q = aq*(b1q/rs12 +2.d0*b2nq +3.d0*b3q*rs12 +2.d0*b4q*p1*rsp)
           if(dabs(zeta) < zeta_minimum) then
              fzd = 8.d0/9.d0 /( 2.d0**thrd4 -2.d0 ) &
                   &     *zeta *( 1.d0 + 5.d0/27.d0 *zeta*zeta &
                   &           *( 1.d0 +22.d0/45.d0 *zeta*zeta ))
           else
              fzd = 4.d0/3.d0 /( 2.d0**thrd4 -2.d0) &
                   &     *( onpzeta**thrd -onmzeta**thrd )
           end if
           onzt4= onmzeta*onpzeta *( 1.d0 + zeta*zeta )
           eu = q0*q2 + ( q0p * q2p - q0 * q2 ) * fz * zeta**4 &
                &             -   q0q * q2q * fz / fzdd * onzt4
           eurs = ( -2.d0*a*a1*q2 -q0*q3/(q1**2 +q1 )) * ( 1.d0 -fz*zeta**4 )&
                &+( -2.d0*ap*a1p*q2p -q0p*q3p/( q1p**2 +q1p )) *fz*zeta**4 &
                &-( -2.d0*aq*a1q*q2q -q0q*q3q/( q1q**2 +q1q )) *fz/fzdd*onzt4
           euzt =  -q0q*q2q /fzdd *( fzd*onzt4 -4.d0*fz*zeta**3 )&
                &        +( q0p*q2p -q0*q2 )*(fzd*zeta +4.d0*fz )*zeta**3 
! vwn 95/12/2 Y.M

           zetadxd = - 2.d0 * chgrhr_l(i, 3-is) * (-1.d0)**is / d
           ecd = eu-thrd*rs*eurs + euzt * zetadxd 

!Fix!           if(onpzeta < zeta_minimum2 .or. onmzeta < zeta_minimum2) then
!Fix!              ec1  = 0.d0;    ec1d = 0.d0;     ec1dd= 0.d0
!Fix!              go to 10
!Fix!           end if
           pon = facpon*eu
           b   = delt/(dexp(pon)-1.d0)
           b2  = b*b
           t2  = t*t
!!$           s2  = s*s
           t4  = t2*t2
           t6  = t4*t2
           q4  = 1.d0 +b*t2
           q5  = 1.d0 +b*t2+b2*t4
           h0  = g3*(bet/delt)*dlog(1.d0+delt*q4*t2/q5)
           h   = h0

           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2.d0 *bet*t*(1.d0 +2.d0*b*t2)/q8 * g3
           h0b = -bet*t6*( 2.d0*b +b2*t2)/q8 * g3
           h0rs = h0b * b * eurs * (b+delt) / bet / g3
           ht   = h0t
           hrs  = h0rs

           if(dabs(zeta) < zeta_minimum) then
              gzt = -2.d0/9.d0*zeta *( 1.d0 +14.d0/27.d0 *zeta*zeta &
                   &             *( 1.d0 +13.d0/18.d0 *zeta*zeta ))
           else
!Fix!              gzt = ( 1.d0/onpzeta**thrd -1.d0/onmzeta**thrd )/3.d0
              gzt = ( (onpzeta**2+eta)**sixthm - (onmzeta**2+eta)**sixthm)/3.d0
           end if
           bzt = b * ( b+delt) * ( euzt - 3.d0*eu*gzt/g ) / ( bet * g3 ) 
           h0zt = 3.d0 * gzt * h0 / g + h0b * bzt

           !Fix!ec1  = d*h * 0.5
           ec1  = d*h * 0.5d0
! --> revised by Kato-san,  1999Jul16
!!$           ec1d = h-thrd*rs*hrs-sixth7*t*ht  + h0zt * zetadxd
           ec1d = h-thrd*rs*hrs-sixth7*t*ht  + (h0zt-gzt*t*h0t/g) * zetadxd
           !Fix!ec1dd = 0.5*ht/sk / g
           ec1dd = 0.5d0*ht/sk / g

10         continue
           !Fix!exc0 = eu*d * 0.5 + ec1
           exc0 = eu*d * 0.5d0 + ec1
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(is ==  2) then
              if(dabs(grad_trho(i)) > 1.0d-9) then
                 grad_trho(i) = excdd / grad_trho(i)
              else
                 grad_trho(i) = 0.d0
              endif
           endif
! gradient of charge density 95/12/3 H.S.
!!$           exec1 = eu*d * 0.5
           exc1 = exc1 + exc0*wos(i)
        end do
     end if
     exc = exc + exc1
     if(present(ecor)) ecor = ecor + exc1
  end do
end subroutine cr_ggapbe
#else
!!$===================================================================
!!$        modified  by T.Yamasaki  94/11/15
!!$
!!$        The original is modified and Spin polrarized GGA programs
!!$        are added in this subroutine
!!$                                                      by K. Kato 1995/1/18 
!!$
!!$        Modified to Perdew-Burke-Ernzerhof(PBE) GGA by K. Kato 1999/4/1 
!!$
! ==== DEBUG! ==================================================================
#if 1
subroutine cr_ggapbe(nspin,ispin,ista_r,iend_r,chgrhr_l,grad_trho,wos,exc,dF_drho,ien)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : PAI,DP
  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  integer,intent(in),optional :: ien
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(inout) :: grad_trho(ista_r:iend_r)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)  
  real(kind=DP),intent(inout) :: exc
  real(kind=DP),intent(inout) :: dF_drho(ista_r:iend_r,nspin)

  real(kind=DP), parameter :: zeta_minimum    = 1.d-4
  real(kind=DP), parameter :: zeta_minimum2   = 1.d-6
  real(kind=DP), parameter :: density_minimum = 1.d-20
  real(kind=DP), parameter :: density_minimum2= 1.d-5

  real(kind=DP), parameter  :: a  = 0.0310907d0,    a1   = 0.21370d0
  real(kind=DP), parameter  :: b1 = 7.5957d0,       b2n  = 3.5876d0
  real(kind=DP), parameter  :: b3 = 1.6382d0,       b4   = 0.49294d0
  real(kind=DP), parameter  :: p  = 1.00d0,         p1   = p+1.d0
#ifndef PREV_CR_GGAPBE
  real(kind=DP), parameter  :: ap  = 0.01554535d0,    a1p  = 0.20548d0
#else
  real(kind=DP), parameter  :: ap  = 0.015545d0,    a1p  = 0.20548d0
#endif
  real(kind=DP), parameter  :: b1p = 14.1189d0,     b2np = 6.1977d0
  real(kind=DP), parameter  :: b3p = 3.3662d0,      b4p  = 0.62517d0
! vwn 95/12/2 Y.M
#ifndef PREV_CR_GGAPBE
  real(kind=DP), parameter  :: aq  = 0.0168869d0,    a1q  = 0.11125d0
#else
  real(kind=DP), parameter  :: aq  = 0.016887d0,    a1q  = 0.11125d0
#endif
  real(kind=DP), parameter  :: b1q = 10.3570d0,     b2nq = 3.6231d0
  real(kind=DP), parameter  :: b3q = 0.88026d0,     b4q  = 0.49671d0
! vwn 95/12/2 Y.M
#ifndef PREV_CR_GGAPBE
  real(kind=DP), parameter  :: gamma = 0.03109069086965489503494086371273d0
#else
  real(kind=DP), parameter  :: gamma = 0.031091
#endif
!--------------------------
#ifndef PREV_CR_GGAPBE
  real(kind=DP), parameter  :: bet=0.06672455060314922d0
  real(kind=DP), parameter  :: delt=bet/gamma
#else
  real(kind=DP), parameter  :: xnu = 15.75592d0, cc0 = 0.004235d0
#endif
  real(kind=DP), parameter  :: thrd = 0.333333333333d0, sixth7 = 1.1666666666666666d0

#ifndef PREV_CR_GGAPBE
!Fix! T.Yamatomto 2011/06/29
  real(kind=DP), parameter  :: eta = 1.d-12
  real(kind=DP), parameter  :: sixthm = -0.16666666666666d0
!Fix! T.Yamatomto 2011/06/29
#endif

  integer       :: is,i,iend_true
#ifndef PREV_CR_GGAPBE
  real(kind=DP) :: facw,exc1,g,g3,facpon,d,dd,rs,fk,sk,t,q0 &
#else
  real(kind=DP) :: facw,bet,delt,exc1,g,g3,facpon,d,dd,rs,fk,sk,t,q0 &
#endif
       &         , rs12,rs32,rsp,q1,q2,eu,q3,eurs,ecd,pon &
       &         , b,b2,t2,t4,t6,q4,q5,h0,h,q8,h0t,h0b,h0rs,ht,hrs &
       &         , ec1,ec1d,ec1dd,exc0,excd,excdd &
       &         , thrd2,thrd4,fzdd,zeta,onpzeta,onmzeta,fz,zetadxd &
       &         , q0p,q1p,q2p,q3p,q0q,q1q,q2q,q3q,fzd,onzt4,gzt,bzt,h0zt,euzt

  facw = ispin

  iend_true = iend_r
  if(present(ien)) iend_true = min(iend_r,ien)

#ifdef PREV_CR_GGAPBE
  bet = xnu*cc0
  delt = bet / gamma
#endif
!---- Spin dependency
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  do is = 1, ispin
     exc1 = 0.d0
     if ( ispin == 1 ) then
        g   = 1.d0
        g3  = g**3
!!$        g4  = g3*g
        facpon = -delt/(g3*bet)

#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
        do i = ista_r,iend_true ! MPI
           d  = facw*chgrhr_l(i, 1)
           if(d < density_minimum) cycle
! gradient of charge density 95/12/3 H.S.
           dd = facw* grad_trho(i)
#ifndef PREV_CR_GGAPBE
           rs = (0.75d0/(PAI*d))**thrd
#else
           rs = (0.75/(PAI*d))**thrd
#endif
           fk = (3*PAI*PAI*d)**thrd
           sk = dsqrt(4*fk/PAI)
           if(d > density_minimum2) then
              t = dd/(d*sk*2)
!!$              s = dd/(d*fk*2)
           else
              t = 0.d0
!!$              s = 0.d0
           endif

           q0 = -2*a*(1 + a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2*a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log(1 + 1.d0/q1)
           eu = q0*q2
           q3 = a*(b1/rs12+2*b2n+3*b3*rs12+2*b4*p1*rsp)
           eurs = -2*a*a1*q2 - q0*q3/(q1**2 + q1)
           ecd = eu-thrd*rs*eurs
           pon = facpon*eu
           b   = delt/(dexp(pon)-1)
           b2  = b*b
           t2  = t*t
!!$           s2  = s*s
           t4  = t2*t2
           t6  = t4*t2
           q4  = 1 + b*t2
           q5  = 1 + b*t2+b2*t4
           h0  = g3*(bet/delt)*dlog(1+delt*q4*t2/q5)
           h   = h0
           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2*bet*t*(1+2*b*t2)/q8 * g3
           h0b = -bet*t6*(2*b+b2*t2)/q8 * g3
           h0rs = h0b*b*eurs*(b+delt)/ bet / g3
           ht   = h0t
           hrs  = h0rs
           ec1  = d*h/facw
           ec1d = h-thrd*rs*hrs-sixth7*t*ht
#ifndef PREV_CR_GGAPBE
           ec1dd = 0.5d0*ht/sk
#else
           ec1dd = 0.5*ht/sk
#endif
           exc0 = eu*d/facw + ec1
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(dabs(grad_trho(i)) > 1.0d-9) then
              grad_trho(i) = excdd / grad_trho(i)
           else
              grad_trho(i) = 0.d0
           endif
! gradient of charge density 95/12/3 H.S.
!!$           exec1 = eu*d/facw
           exc1 = exc1 + exc0*wos(i)
        end do
     else if ( ispin ==  2 ) then
        thrd2 = thrd * 2
        thrd4 = thrd * 4
        fzdd = 8/(9*(2**thrd4 - 2 ))

        do i = ista_r,iend_r
           d = chgrhr_l(i, 1) + chgrhr_l(i, ispin)
           if(d < density_minimum ) cycle
           zeta = ( chgrhr_l(i, 1) - chgrhr_l(i, 2) ) / d
           onpzeta = 2*chgrhr_l(i, 1) / d
           onmzeta = 2*chgrhr_l(i, 2) / d
           g = ( onpzeta**thrd2 + onmzeta**thrd2 )/2
           if(dabs(zeta) < zeta_minimum ) then
              fz= 4.d0/9 *zeta*zeta*(1 + 5.d0/54 *zeta*zeta &
                   &               *(1 +44.d0/135*zeta*zeta )) &
                   &       /(2**thrd4 -2)
           else
              fz = (onpzeta**thrd4 + onmzeta**thrd4 -2) / (2**thrd4 - 2)
           end if
           g3  = g**3
!!$           g4  = g3*g
           facpon = -delt/(g3*bet)
           if(d < density_minimum) cycle
           dd = grad_trho(i)
           rs = (0.75d0/(PAI*d))**thrd
           fk = (3*PAI*PAI*d)**thrd
           sk = dsqrt(4*fk/PAI)

           if(d > density_minimum2) then
#ifndef PREV_CR_GGAPBE
              t = dd/(d*sk*2*g)
#else
              t = dd/(d*sk*2)
#endif
           else
              t = 0.d0
           endif

           q0 = -2*a*(1+a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2*a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log(1+1/q1)
           q3 = a*(b1/rs12+2*b2n+3*b3*rs12+2*b4*p1*rsp)

           q0p = -2*ap*(1+a1p*rs)
           q1p = 2*ap*(b1p*rs12+b2np*rs+b3p*rs32+b4p*rs*rsp)
           q2p = log(1+1/q1p)
           q3p = ap*(b1p/rs12+2*b2np+3*b3p*rs12+2*b4p*p1*rsp)
! vwn 95/12/2 Y.M
           q0q = -2*aq*(1+a1q*rs)
           q1q =  2*aq*(b1q*rs12+b2nq*rs+b3q*rs32+b4q*rs*rsp)
           q2q = log(1+1/q1q)
           q3q = aq*(b1q/rs12+2*b2nq+3*b3q*rs12+2*b4q*p1*rsp)
           if(dabs(zeta) < zeta_minimum) then
              fzd = 8.d0/9.d0 /( 2.d0**thrd4 -2 ) &
                   &     *zeta *( 1 + 5.d0/27 *zeta*zeta &
                   &           *( 1 +22.d0/45 *zeta*zeta ))
           else
              fzd = 4.d0/3.d0 /( 2.d0**thrd4 -2) &
                   &     *( onpzeta**thrd -onmzeta**thrd )
           end if
           onzt4= onmzeta*onpzeta *( 1 + zeta*zeta )
           eu = q0*q2 + ( q0p * q2p - q0 * q2 ) * fz * zeta**4 &
                &             -   q0q * q2q * fz / fzdd * onzt4
           eurs = ( -2*a*a1*q2 -q0*q3/(q1**2 +q1 )) * ( 1 -fz*zeta**4 )&
                &+( -2*ap*a1p*q2p -q0p*q3p/( q1p**2 +q1p )) *fz*zeta**4 &
                &-( -2*aq*a1q*q2q -q0q*q3q/( q1q**2 +q1q )) *fz/fzdd*onzt4
           euzt =  -q0q*q2q /fzdd *( fzd*onzt4 -4*fz*zeta**3 )&
                &        +( q0p*q2p -q0*q2 )*(fzd*zeta +4*fz )*zeta**3 
! vwn 95/12/2 Y.M

           zetadxd = - 2 * chgrhr_l(i, 3-is) * (-1.d0)**is / d
           ecd = eu-thrd*rs*eurs + euzt * zetadxd 

#ifdef NEC_TUNE_MXCP
           if(onpzeta < zeta_minimum2 .or. onmzeta < zeta_minimum2) then
              ec1  = 0.d0;    ec1d = 0.d0;     ec1dd= 0.d0
              go to 10
           end if
#endif
           pon = facpon*eu
           b   = delt/(dexp(pon)-1)
           b2  = b*b
           t2  = t*t
!!$           s2  = s*s
           t4  = t2*t2
           t6  = t4*t2
           q4  = 1+b*t2
           q5  = 1+b*t2+b2*t4
           h0  = g3*(bet/delt)*dlog(1+delt*q4*t2/q5)
           h   = h0

           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2*bet*t*(1+2*b*t2)/q8 * g3
           h0b = -bet*t6*(2*b+b2*t2)/q8 * g3
           h0rs = h0b * b * eurs * (b+delt) / bet / g3
           ht   = h0t
           hrs  = h0rs

           if(dabs(zeta) < zeta_minimum) then
              gzt = -2.d0/9*zeta *( 1 +14.d0/27 *zeta*zeta &
                   &             *( 1 +13.d0/18 *zeta*zeta ))
           else
#ifndef PREV_CR_GGAPBE
              gzt = ( (onpzeta**2+eta)**sixthm - (onmzeta**2+eta)**sixthm)/3.d0
#else              
              gzt = ( 1.d0/onpzeta**thrd -1.d0/onmzeta**thrd )/3.d0
#endif
           end if
           bzt = b * ( b+delt) * ( euzt - 3*eu*gzt/g ) / ( bet * g3 ) 
           h0zt = 3 * gzt * h0 / g + h0b * bzt

#ifndef PREV_CR_GGAPBE
           ec1  = d*h * 0.5d0
#else
           ec1  = d*h * 0.5
#endif
! --> revised by Kato-san,  1999Jul16
!!$           ec1d = h-thrd*rs*hrs-sixth7*t*ht  + h0zt * zetadxd
           ec1d = h-thrd*rs*hrs-sixth7*t*ht  + (h0zt-gzt*t*h0t/g) * zetadxd
           ec1dd = 0.5*ht/sk / g

10         continue
#ifndef PREV_CR_GGAPBE
           exc0 = eu*d * 0.5d0 + ec1
#else
           exc0 = eu*d * 0.5 + ec1
#endif
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(is ==  2) then
              if(dabs(grad_trho(i)) > 1.0d-9) then
                 grad_trho(i) = excdd / grad_trho(i)
              else
                 grad_trho(i) = 0.d0
              endif
           endif
! gradient of charge density 95/12/3 H.S.
!!$           exec1 = eu*d * 0.5
           exc1 = exc1 + exc0*wos(i)
        end do
     end if
     exc = exc + exc1
  end do
end subroutine cr_ggapbe
#else
subroutine cr_ggapbe(nspin,ispin,chgrhr_l,grad_trho,f2or1,exc,dF_drho)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : PAI,DP
  use m_Parallelization,   only : ista_fftph, iend_fftph
  implicit none

  integer,intent(in)        :: nspin,ispin
  real(kind=DP),intent(in)  :: chgrhr_l(ista_fftph:iend_fftph,ispin)
  real(kind=DP),intent(inout) :: grad_trho(ista_fftph:iend_fftph)
  real(kind=DP),intent(in)  :: f2or1(ista_fftph:iend_fftph)  
  real(kind=DP),intent(inout) :: exc
  real(kind=DP),intent(inout) :: dF_drho(ista_fftph:iend_fftph,nspin)

  real(kind=DP), parameter :: zeta_minimum    = 1.d-4
  real(kind=DP), parameter :: zeta_minimum2   = 1.d-6
  real(kind=DP), parameter :: density_minimum = 1.d-20
  real(kind=DP), parameter :: density_minimum2= 1.d-5

  real(kind=DP), parameter  :: a  = 0.0310907d0,    a1   = 0.21370d0
  real(kind=DP), parameter  :: b1 = 7.5957d0,       b2n  = 3.5876d0
  real(kind=DP), parameter  :: b3 = 1.6382d0,       b4   = 0.49294d0
  real(kind=DP), parameter  :: p  = 1.00d0,         p1   = p+1.d0
  real(kind=DP), parameter  :: ap  = 0.015545d0,    a1p  = 0.20548d0
  real(kind=DP), parameter  :: b1p = 14.1189d0,     b2np = 6.1977d0
  real(kind=DP), parameter  :: b3p = 3.3662d0,      b4p  = 0.62517d0
! vwn 95/12/2 Y.M
  real(kind=DP), parameter  :: aq  = 0.016887d0,    a1q  = 0.11125d0
  real(kind=DP), parameter  :: b1q = 10.3570d0,     b2nq = 3.6231d0
  real(kind=DP), parameter  :: b3q = 0.88026d0,     b4q  = 0.49671d0
! vwn 95/12/2 Y.M
  real(kind=DP), parameter  :: gamma = 0.031091
!--------------------------
  real(kind=DP), parameter  :: xnu = 15.75592d0, cc0 = 0.004235d0
  real(kind=DP), parameter  :: thrd = 0.333333333333d0, sixth7 = 1.1666666666666666d0

  integer       :: is,i
  real(kind=DP) :: facw,bet,delt,exc1,g,g3,facpon,d,dd,rs,fk,sk,t,q0 &
       &         , rs12,rs32,rsp,q1,q2,eu,q3,eurs,ecd,pon &
       &         , b,b2,t2,t4,t6,q4,q5,h0,h,q8,h0t,h0b,h0rs,ht,hrs &
       &         , ec1,ec1d,ec1dd,exc0,excd,excdd &
       &         , thrd2,thrd4,fzdd,zeta,onpzeta,onmzeta,fz,zetadxd &
       &         , q0p,q1p,q2p,q3p,q0q,q1q,q2q,q3q,fzd,onzt4,gzt,bzt,h0zt,euzt

  facw = ispin
  bet = xnu*cc0
  delt = bet / gamma
!---- Spin dependency
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  do is = 1, ispin
     exc1 = 0.d0
     if ( ispin == 1 ) then
        g   = 1.d0
        g3  = g**3
!!$        g4  = g3*g
        facpon = -delt/(g3*bet)

#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
        do i = ista_fftph,iend_fftph ! MPI
           d  = facw*chgrhr_l(i, 1)
           if(d < density_minimum) cycle
! gradient of charge density 95/12/3 H.S.
           dd = facw* grad_trho(i)
           rs = (0.75/(PAI*d))**thrd
           fk = (3*PAI*PAI*d)**thrd
           sk = dsqrt(4*fk/PAI)
           if(d > density_minimum2) then
              t = dd/(d*sk*2)
!!$              s = dd/(d*fk*2)
           else
              t = 0.d0
!!$              s = 0.d0
           endif

           q0 = -2*a*(1 + a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2*a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log(1 + 1.d0/q1)
           eu = q0*q2
           q3 = a*(b1/rs12+2*b2n+3*b3*rs12+2*b4*p1*rsp)
           eurs = -2*a*a1*q2 - q0*q3/(q1**2 + q1)
           ecd = eu-thrd*rs*eurs
           pon = facpon*eu
           b   = delt/(dexp(pon)-1)
           b2  = b*b
           t2  = t*t
!!$           s2  = s*s
           t4  = t2*t2
           t6  = t4*t2
           q4  = 1 + b*t2
           q5  = 1 + b*t2+b2*t4
           h0  = g3*(bet/delt)*dlog(1+delt*q4*t2/q5)
           h   = h0
           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2*bet*t*(1+2*b*t2)/q8 * g3
           h0b = -bet*t6*(2*b+b2*t2)/q8 * g3
           h0rs = h0b*b*eurs*(b+delt)/ bet / g3
           ht   = h0t
           hrs  = h0rs
           ec1  = d*h/facw
           ec1d = h-thrd*rs*hrs-sixth7*t*ht
           ec1dd = 0.5*ht/sk

           exc0 = eu*d/facw + ec1
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(dabs(grad_trho(i)) > 1.0d-9) then
              grad_trho(i) = excdd / grad_trho(i)
           else
              grad_trho(i) = 0.d0
           endif
! gradient of charge density 95/12/3 H.S.
!!$           exec1 = eu*d/facw
           exc1 = exc1 + exc0*f2or1(i)
        end do
     else if ( ispin ==  2 ) then
        thrd2 = thrd * 2
        thrd4 = thrd * 4
        fzdd = 8/(9*(2**thrd4 - 2 ))

        do i = ista_fftph,iend_fftph
           d = chgrhr_l(i, 1) + chgrhr_l(i, ispin)
           if(d < density_minimum ) cycle
           zeta = ( chgrhr_l(i, 1) - chgrhr_l(i, 2) ) / d
           onpzeta = 2*chgrhr_l(i, 1) / d
           onmzeta = 2*chgrhr_l(i, 2) / d
           g = ( onpzeta**thrd2 + onmzeta**thrd2 )/2
           if(dabs(zeta) < zeta_minimum ) then
              fz= 4.d0/9 *zeta*zeta*(1 + 5.d0/54 *zeta*zeta &
                   &               *(1 +44.d0/135*zeta*zeta )) &
                   &       /(2**thrd4 -2)
           else
              fz = (onpzeta**thrd4 + onmzeta**thrd4 -2) / (2**thrd4 - 2)
           end if
           g3  = g**3
!!$           g4  = g3*g
           facpon = -delt/(g3*bet)
           if(d < density_minimum) cycle
           dd = grad_trho(i)
           rs = (0.75d0/(PAI*d))**thrd
           fk = (3*PAI*PAI*d)**thrd
           sk = dsqrt(4*fk/PAI)

           if(d > density_minimum2) then
! --> Check if this is correct or not
              ! 2011/04/26 revised according to a Katsumata-san's comment.
!!$              t = dd/(d*sk*2)
              t = dd/(d*sk*2)
              t = t/g
! <--
!!$              s = dd/(d*fk*2)
           else
              t = 0.d0
!!$              s = 0.d0
           endif

           q0 = -2*a*(1+a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2*a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log(1+1/q1)
           q3 = a*(b1/rs12+2*b2n+3*b3*rs12+2*b4*p1*rsp)

           q0p = -2*ap*(1+a1p*rs)
           q1p = 2*ap*(b1p*rs12+b2np*rs+b3p*rs32+b4p*rs*rsp)
           q2p = log(1+1/q1p)
           q3p = ap*(b1p/rs12+2*b2np+3*b3p*rs12+2*b4p*p1*rsp)
! vwn 95/12/2 Y.M
           q0q = -2*aq*(1+a1q*rs)
           q1q =  2*aq*(b1q*rs12+b2nq*rs+b3q*rs32+b4q*rs*rsp)
           q2q = log(1+1/q1q)
           q3q = aq*(b1q/rs12+2*b2nq+3*b3q*rs12+2*b4q*p1*rsp)
           if(dabs(zeta) < zeta_minimum) then
              fzd = 8.d0/9.d0 /( 2.d0**thrd4 -2 ) &
                   &     *zeta *( 1 + 5.d0/27 *zeta*zeta &
                   &           *( 1 +22.d0/45 *zeta*zeta ))
           else
              fzd = 4.d0/3.d0 /( 2.d0**thrd4 -2) &
                   &     *( onpzeta**thrd -onmzeta**thrd )
           end if
           onzt4= onmzeta*onpzeta *( 1 + zeta*zeta )
           eu = q0*q2 + ( q0p * q2p - q0 * q2 ) * fz * zeta**4 &
                &             -   q0q * q2q * fz / fzdd * onzt4
           eurs = ( -2*a*a1*q2 -q0*q3/(q1**2 +q1 )) * ( 1 -fz*zeta**4 )&
                &+( -2*ap*a1p*q2p -q0p*q3p/( q1p**2 +q1p )) *fz*zeta**4 &
                &-( -2*aq*a1q*q2q -q0q*q3q/( q1q**2 +q1q )) *fz/fzdd*onzt4
           euzt =  -q0q*q2q /fzdd *( fzd*onzt4 -4*fz*zeta**3 )&
                &        +( q0p*q2p -q0*q2 )*(fzd*zeta +4*fz )*zeta**3 
! vwn 95/12/2 Y.M

           zetadxd = - 2 * chgrhr_l(i, 3-is) * (-1.d0)**is / d
           ecd = eu-thrd*rs*eurs + euzt * zetadxd 

           if(onpzeta < zeta_minimum2 .or. onmzeta < zeta_minimum2) then
              ec1  = 0.d0;    ec1d = 0.d0;     ec1dd= 0.d0
              go to 10
           end if
           pon = facpon*eu
           b   = delt/(dexp(pon)-1)
           b2  = b*b
           t2  = t*t
!!$           s2  = s*s
           t4  = t2*t2
           t6  = t4*t2
           q4  = 1+b*t2
           q5  = 1+b*t2+b2*t4
           h0  = g3*(bet/delt)*dlog(1+delt*q4*t2/q5)
           h   = h0

           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2*bet*t*(1+2*b*t2)/q8 * g3
           h0b = -bet*t6*(2*b+b2*t2)/q8 * g3
           h0rs = h0b * b * eurs * (b+delt) / bet / g3
           ht   = h0t
           hrs  = h0rs

           if(dabs(zeta) < zeta_minimum) then
              gzt = -2.d0/9*zeta *( 1 +14.d0/27 *zeta*zeta &
                   &             *( 1 +13.d0/18 *zeta*zeta ))
           else
              gzt = ( 1.d0/onpzeta**thrd -1.d0/onmzeta**thrd )/3.d0
           end if
           bzt = b * ( b+delt) * ( euzt - 3*eu*gzt/g ) / ( bet * g3 ) 
           h0zt = 3 * gzt * h0 / g + h0b * bzt

           ec1  = d*h * 0.5
! --> revised by Kato-san,  1999Jul16
!!$           ec1d = h-thrd*rs*hrs-sixth7*t*ht  + h0zt * zetadxd
           ec1d = h-thrd*rs*hrs-sixth7*t*ht  + (h0zt-gzt*t*h0t/g) * zetadxd
           ec1dd = 0.5*ht/sk / g

10         continue
           exc0 = eu*d * 0.5 + ec1
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(is ==  2) then
              if(dabs(grad_trho(i)) > 1.0d-9) then
                 grad_trho(i) = excdd / grad_trho(i)
              else
                 grad_trho(i) = 0.d0
              endif
           endif
! gradient of charge density 95/12/3 H.S.
!!$           exec1 = eu*d * 0.5
           exc1 = exc1 + exc0*f2or1(i)
        end do
     end if
     exc = exc + exc1
  end do
end subroutine cr_ggapbe
#endif
! ==== DEBUG! ==================================================================
#endif

!!$c===================================================================
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
!!$     1994/11/24 coded by T.Yamasaki
!!$
subroutine xclda(nspin,ispin,ista_r,iend_r,chgrhr_l,wos,exc,dF_drho,ien)
  use m_Const_Parameters,  only : DP, PAI
  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  integer,intent(in),optional :: ien
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)  
  real(kind=DP),intent(out) :: exc
!!$  real(kind=DP),intent(inout) :: dF_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(out) :: dF_drho(ista_r:iend_r,nspin)

  integer :: is, i, iend_true
  real(kind=DP) :: co2,d,rs,exclds
  real(kind=DP), parameter :: thrd = 0.333333333333333333d0

  co2 = (0.75d0/PAI)**thrd
  exc = 0.d0

  iend_true = iend_r
  if(present(ien)) iend_true = min(iend_r,ien)

  is = 1
  if(ispin == 2)  stop '!Sorry, ispin == 2 is not supported now'

  do i = ista_r, iend_true
     d = chgrhr_l(i,is)
     if(d < 1.d-40) then
        dF_drho(i,is) = 0.d0
        cycle
     endif
     rs = co2*(1.d0/d)**thrd
     if(rs >= 1.d0) then
        dF_drho(i,is) = &
             &   (-0.61093d0/rs - (0.1423d0+0.1759d0*dsqrt(rs) &
             &    + 0.06366d0*rs)&
             &   /(1 + 1.0529d0*dsqrt(rs) + 0.3334d0*rs)**2 )
        exclds = -0.61093d0*0.75d0/rs &
             &   -0.1423d0/(1 + 1.0529d0*dsqrt(rs) + 0.3334d0*rs)
     else
        dF_drho(i,is) =  &
             &  ( -0.61093d0/rs - 0.05837d0 - 0.0084d0*rs &
             &   + 0.0311d0*log(rs) + 0.00133d0*rs*dlog(rs) )
        exclds = -0.61093d0*0.75d0/rs &
             &  - 0.048d0 -0.0116*rs &
             &  + 0.0311d0*dlog(rs) + 0.0020d0*rs*dlog(rs)
     end if
     exc = exc + exclds*wos(i)*d
  end do
end subroutine xclda

!!$c ---------------------------------------
!!$c       1994/11/24 coded by T. Yamasaki
!!$c       1994/12/22 modified by T. Yamasaki
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
subroutine ggabek(nspin,ispin,ista_r,iend_r,chgrhr_l,grad_rho,wos,exc,dF_drho,dF_dgradrho,ien)
  use m_Const_Parameters,  only : DP
  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  integer,intent(in),optional :: ien
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)  :: grad_rho(ista_r:iend_r,nspin)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)  
  real(kind=DP),intent(out) :: exc
  real(kind=DP),intent(inout) :: dF_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(out) :: dF_dgradrho(ista_r:iend_r,nspin)

  integer        :: i, iend_true
  real(kind=DP)  :: fac,tthrd,fac_t,d,dd,dthrd,dthrd4,x,x2,p0,x2ovp0&
       &, y,f,vxc1,exgga

  real(kind=DP), parameter ::    b = 0.0042d0
  real(kind=DP), parameter :: thrd = 0.333333333333333333d0
        
  iend_true = iend_r
  if(present(ien)) iend_true = min(iend_r,ien)

  fac = 4*thrd * b
  tthrd = 2.d0**thrd
  fac_t  = 1.d0/tthrd
  do i = ista_r, iend_true
     d = chgrhr_l(i,1)
     dd = grad_rho(i,1)
     if(d < 1.d-10 .or. dd > 1.d10) then
        dF_dgradrho(i,1) = 0.d0
        cycle
     endif
     dthrd  = d**thrd
     dthrd4 = dthrd*d
     x = tthrd*dd/dthrd4
     x2 = x*x
     p0 = dsqrt(1+x2)
     x2ovp0 = 6*b*x2/p0
     if(x < 1.d-40) then
        y = 0.d0
     else
        y = dlog(x + p0)
     endif
     f  = 1.d0/(1.d0+6.d0*b*x*y)
     vxc1    = x2*f*f*(1.d0-x2ovp0)
     dF_drho(i,1) = dF_drho(i,1) + fac*dthrd*vxc1*fac_t
     dF_dgradrho(i,1) = fac*dthrd*(vxc1 + x2*f)*fac_t

     exgga  = -b * dthrd4 * x2 * f * fac_t
     exc      = exc      + exgga*wos(i)
  end do
end subroutine ggabek

!!$c ---------------------------------------
!!$c     1994/11/24 coded by T.Yamasaki
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
subroutine ggaprd(nspin,ispin,ista_r,iend_r,chgrhr_l,grad_rho,wos,exc,dF_drho,dF_dgradrho,ien)
  use m_Const_Parameters,  only : PAI,DP
  implicit none

  integer,intent(in)         :: nspin,ispin,ista_r,iend_r
  integer,intent(in),optional :: ien
  real(kind=DP),intent(in)   :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)   :: grad_rho(ista_r:iend_r,nspin)
  real(kind=DP),intent(in)   :: wos(ista_r:iend_r)  
  real(kind=DP),intent(out)  :: exc
  real(kind=DP),intent(inout):: dF_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(inout)  :: dF_dgradrho(ista_r:iend_r,nspin)

  real(kind=DP) :: cinfin,d,ovd,thrd4,sixth7,co2,dd,rs,dthrd,dthrd4&
       &, x, cdenom,c,phi,expphi,ecgga,dcdrs,dcdrho
  integer       :: i, iend_true

  real(kind=DP), parameter :: alpha = 0.023266d0
  real(kind=DP), parameter ::  beta = 7.389d-6
  real(kind=DP), parameter :: gamma = 8.723d0
  real(kind=DP), parameter :: delta = 0.472d0
  real(kind=DP), parameter ::fchird = 0.11
  real(kind=DP), parameter :: thrd  = 0.333333333333333333d0
  real(kind=DP), parameter :: c0    = 0.001667d0
  real(kind=DP), parameter :: c1    = 0.002568d0

  iend_true = iend_r
  if(present(ien)) iend_true = min(iend_r,ien)

  cinfin = c0 + c1
  d = 1.d0
  ovd = 1.d0/d
  thrd4 = 4*thrd
  sixth7 = 7.d0/6.d0

  co2 = (0.75d0/PAI)**thrd
  do i = ista_r, iend_true
     d = chgrhr_l(i,1)
     dd = grad_rho(i,1)
     if(d < 1.d-40) cycle
     rs = co2*(1.d0/d)**thrd
     dthrd  = d**thrd
     dthrd4 = dthrd*d
     x = dd/dthrd4
     cdenom = 1.d0/(1 + rs*(gamma + rs*(delta + 1.d+4*beta*rs)))
     c = c0 + (c1 + rs*(alpha + beta*rs))*cdenom
     phi = 1.745d0 * fchird * cinfin/c * x *dsqrt(dthrd)
     expphi = dexp(-phi)
     ecgga = ovd*expphi*c*dd*x

     dcdrs = cdenom * ((alpha + 2*beta*rs) &
          &         - cdenom * (c1+rs*(alpha+beta*rs)) &
          &       * (gamma+rs*(2*delta + 3.d+4*beta*rs)))
     dcdrho = -thrd*(rs/d)*dcdrs
     dF_drho(i,1) = dF_drho(i,1) + ovd*(dcdrho*(phi+1) &
          &       +(sixth7*phi - thrd4)*c)*expphi*x*dd
     dF_dgradrho(i,1) = dF_dgradrho(i,1) + ovd*expphi*c*x*(2 - phi)

     exc = exc + ecgga*wos(i)
  end do
end subroutine ggaprd

subroutine cr_lda(nspin,ispin,ista_r,iend_r,chgrhr_l,exc,dF_drho,ien)
  use m_Const_Parameters,  only : PAI,DP
  integer, intent(in)        :: nspin,ispin,ista_r,iend_r
  integer,intent(in),optional :: ien
  real(kind=DP), intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP), intent(inout) :: exc
  real(kind=DP), intent(inout) :: dF_drho(ista_r:iend_r,ispin)
  real(kind=DP) :: rhomin = 1.d-9
  integer :: i, iend_true
  real(kind=DP) :: n,rs,x,ec,dedx,dxdr
  iend_true = iend_r
  if(present(ien)) iend_true = min(iend_r,ien)
  ec = 0.d0
  do i=ista_r,iend_true
     n = chgrhr_l(i,ispin)
!     if(n<rhomin) n = rhomin
     if(n<rhomin) cycle
     
     rs = ((3.d0/(4.d0*PAI*n))**(1.d0/3.d0))
     x = rs/11.4d0
     ec = -0.0666d0*0.5d0*((1.d0+x**3)*DLOG(1.d0+1.d0/x)-x**2+x/2.d0-1.d0/3.d0)
     exc = exc+ec*n

     dxdr = -(3.d0/(4.d0*PAI))**(1.d0/3.d0)/11.4d0/3.d0*n**(-4.d0/3.d0)
     dedx = -0.0333d0*(3*x*x*dlog(1.d0+1.d0/x)-(1+x**3)/(x*(x+1))-2*x+0.5d0)
     dF_drho(i,ispin) = dF_drho(i,ispin) + dedx*dxdr*n+ec
  enddo
end subroutine cr_lda

subroutine xcpotf_wigner(ispin,ista_r,iend_r,input_charge,DELTA,chgrhr_l,wos,exc)
!*****<<< WIGNER INTERPOLATION >>>
  use m_Const_Parameters,  only : DP,UP,DOWN,PAI,Valence_plus_PC_Charge
  implicit none

  integer,intent(in)         :: ispin,ista_r,iend_r,input_charge
  real(kind=DP),intent(in)   :: DELTA
  real(kind=DP),intent(inout):: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)   :: wos(ista_r:iend_r)  
  real(kind=DP),intent(inout):: exc

  real(kind=DP) :: rho,rs,zeta,vxc,tmp,WX0,CO2
  integer       :: i, icount
  real(kind=DP), parameter :: C13 = 1.d0/3.d0
  real(kind=DP), parameter :: CO3 = 4.d0/3.d0

  CO2 = (0.75d0/PAI)**C13
  WX0 =  3*(((9*PAI)/4)**C13)/(2*PAI)

  if(ispin == 2 .and. input_charge == Valence_plus_PC_Charge) then
     icount = 0
     do i = ista_r, iend_r
        rho    = chgrhr_l(i,UP) + chgrhr_l(i,DOWN)
        rs     = CO2*( 1.0d0/rho  )**C13
        if(rho < DELTA) cycle
        zeta = (chgrhr_l(i,UP) - chgrhr_l(i,DOWN))/rho
        if(dabs(zeta) > DELTA) icount = icount + 1
        tmp    = - WX0/2.d0*CO3/RS -(0.440d0*CO3*RS + 3.432d0)/(RS+7.8D0)**2
        chgrhr_l(i,UP  ) = tmp
        chgrhr_l(i,DOWN) = tmp
        vxc    = -(WX0/2.d0/RS+0.44d0/(RS+7.8d0))
        exc    = exc + vxc*rho*wos(i)
     end do
     if(icount >= 1) then
        write(6,*)' WIGNER XC-ENERGY and POTENTIAL are not' &
             &         , ' appropriate for Spin-Polarized calculation'
        stop 'WIGNER'
     endif
  else
     do i = ista_r, iend_r
        rho    = chgrhr_l(i,1)
        rs     = CO2*( 1.0d0/rho  )**C13
        chgrhr_l(i,1)   = - WX0/2.d0*CO3/rs &
             &           -(0.440d0*CO3*rs + 3.432d0)/(rs+7.8d0)**2
        vxc    = -(WX0/2.d0/rs+0.44d0/(rs+7.8d0))
        exc    = exc + vxc*rho*wos(i)
     end do
  endif
end subroutine xcpotf_wigner

subroutine xcpotf_pzold(ispin,ista_r,iend_r,input_charge,DELTA,chgrhr_l,wos,exc)
  use m_Const_Parameters,  only : DP,UP,DOWN,PAI,Valence_plus_PC_Charge
  implicit none

  integer,intent(in)         :: ispin,ista_r,iend_r,input_charge
  real(kind=DP),intent(in)   :: DELTA
  real(kind=DP),intent(inout):: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)   :: wos(ista_r:iend_r)  
  real(kind=DP),intent(inout):: exc

  real(kind=DP) :: B1P01,B1P02,CP00,CP01,CP02,OVC213,OVC243 &
       &         , B1F01,B1F02,CF00,CF01,CF02
  real(kind=DP) :: rho,ovn,rs,denmp,denmf,wcp,wcf,vcp,vcf,zeta,f00,f2up,f2down &
       &         , t1,wxp,wxf,vxp,x,t2,vxc
  integer       :: i

  real(kind=DP), parameter   :: C13   =  1.d0/3.d0
  real(kind=DP), parameter   :: C43   =  4.d0/3.d0
  real(kind=DP) :: CO2, WX0, C213

  real(kind=DP), parameter :: GAMP   = -0.1423d0, GAMF   = -0.0843d0 &
       &                    , BETA1P =  1.0529d0, BETA2P =  0.3334d0 &
       &                    , BETA1F =  1.3981d0, BETA2F =  0.2611d0 &
       &                    , AP     =  0.0311d0, BP     = -0.0480d0 &
       &                    , AF     =  0.01555d0,BF     = -0.0269d0 &
       &                    , CP     =  0.0020d0, DPx    = -0.0116d0 &
       &                    , CF     =  0.00070d0,DF     = -0.0048d0

  CO2   = (0.75d0/PAI)**C13
  WX0   =  3*(((9*PAI)/4)**C13)/(2*PAI)
  C213  = 2.d0**C13

  B1P01 = 7.d0*BETA1P/6.d0
  B1P02 = 4.d0*BETA2P/3.d0

  CP00 = BP - AP/3.d0
  CP01 = (2*DPx - CP)/3.d0
  CP02 = 2*CP/3.d0

  if(ispin == 2 .and. input_charge == Valence_plus_PC_Charge) then
     OVC213 = 1.D0/(C213 - 1)
     OVC243 = 1.D0/(2.D0**C43 - 2)

     B1F01 = 7.D0*BETA1F/6.D0
     B1F02 = 4.D0*BETA2F/3.D0
     CF00 = BF - AF/3.D0
     CF01 = (2*DF - CF)/3.D0
     CF02 = 2*CF/3.D0

     do i = ista_r, iend_r   ! MPI
        rho    = chgrhr_l(i, UP) + chgrhr_l(i,DOWN)
        if(rho <= DELTA) then
           chgrhr_l(i,UP  ) = 0.D0
           chgrhr_l(i,DOWN) = 0.D0
           cycle
        endif
        ovn = 1.d0/rho
        rs     = CO2*ovn**C13
        if(rs >= 1.d0) then
           denmp = 1 + BETA1P*sqrt(rs) + BETA2P*rs
           denmf = 1 + BETA1F*sqrt(rs) + BETA2F*rs
           wcp = GAMP/denmp
           wcf = GAMF/denmf
           vcp = wcp*(1+B1P01*sqrt(rs)+B1P02*rs)/denmp
           vcf = wcf*(1+B1F01*sqrt(rs)+B1F02*RS)/denmf
        else
           wcp = AP*dlog(rs) + BP + CP*rs*dlog(rs) + DPx*rs
           wcf = AF*dlog(rs) + BF + CF*rs*dlog(rs) + DF*rs
           vcp = (AP+CP02*RS)*dLOG(RS) + CP00 + CP01*RS
           vcf = (AF+CF02*RS)*dLOG(RS) + CF00 + CF01*RS
        end if
        zeta   = (chgrhr_l(i,UP) - chgrhr_l(i,DOWN))*ovn
        f00    = ((1+zeta)**C43 + (1-zeta)**C43 - 2)*OVC243
        f2up   = ((1+zeta)**C13 - 1)*OVC213
        f2down = ((1-zeta)**C13 - 1)*OVC213
        t1 = vcf - vcp - C43*(wcf - wcp)
        wxp = -WX0*0.5d0/rs
        wxf = wxp * C213
        vxp = wxp * C43
        x = vxp + vcp + t1*f00
        t2 = C43 * ((WXF - WXP) + ( WCF - WCP ))
        chgrhr_l(i,UP  ) = x + t2*f2up
        chgrhr_l(i,DOWN) = x + t2*f2down

        vxc = wxp + wcp + ((wxf - wxp) + (wcf - wcp))*f00
        exc = exc + vxc*rho*wos(i)
     end do
  else
     do i = ista_r, iend_r
        rho    = chgrhr_l(i,1)
        if(rho < DELTA) then
           chgrhr_l(i,1) = 0.d0
           cycle
        endif
        ovn    = 1.d0/rho
        rs     = CO2*ovn**C13
        wxp    = -WX0*0.5d0/rs
        if(rs >= 1.d0) then
           denmp = 1 + BETA1P*sqrt(rs) + BETA2P*rs
           wcp = GAMP/denmp
           vcp = wcp*(1.D0+B1P01*SQRT(rs)+B1P02*rs)/denmp
        else
           wcp = AP*dlog(rs) + BP + CP*rs*log(rs) + DPx*rs
           vcp = (AP+CP02*rs)*log(rs) + CP00 + CP01*rs
        end if

        wxp = -WX0*0.5D0/rs
        wxf = WXP * C213
        vxp = WXP * C43
        x = vxp + vcp
        chgrhr_l(i,1  ) = x
        vxc = wxp + wcp
        exc = exc + vxc*rho*wos(i)
     end do
  endif
end subroutine xcpotf_pzold

subroutine xcpotf_xalfa(ispin,ista_r,iend_r,input_charge,DELTA,chgrhr_l,wos,exc)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : DP,UP,DOWN,PAI,Valence_plus_PC_Charge
  implicit none

  integer,intent(in)         :: ispin,ista_r,iend_r,input_charge
  real(kind=DP),intent(in)   :: DELTA
  real(kind=DP),intent(inout):: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)   :: wos(ista_r:iend_r)  
  real(kind=DP),intent(inout):: exc

  real(kind=DP), parameter   :: C13   =  1.d0/3.d0
  real(kind=DP), parameter   :: ALPHA = 0.7d0
  real(kind=DP)              :: CO1, CO2
  real(kind=DP)              :: rho,tmp,vxc
  integer                    :: i

  CO1   = 1.5d0*ALPHA*(3.D0/PAI)**C13
  CO2   = (0.75d0/PAI)**C13

  if(ispin == 2 .and. input_charge == Valence_plus_PC_Charge) then
     do i = ista_r, iend_r
        rho    = chgrhr_l(i,UP) + chgrhr_l(i,DOWN)
!!$        rs     = CO2*( 1.0D0/rho  )**C13
        tmp    = - CO1*(rho**C13)
        chgrhr_l(i,UP)   = tmp
        chgrhr_l(i,DOWN) = tmp
        vxc = 0.25d0*CO1*(rho**C13)
        exc = exc+vxc*rho*wos(i)
     end do
  else
     do i = ista_r, iend_r
        rho    = chgrhr_l(i,1)
!!$        rs     = CO2*( 1.0d0/rho  )**C13
        chgrhr_l(i,1)   = - CO1*(rho**C13)
        vxc = 0.25d0*CO1*(rho**C13)
        exc = exc+vxc*rho*wos(i)
     end do
  endif
end subroutine xcpotf_xalfa

subroutine xcpotf_pz(ispin,ista_r,iend_r,input_charge,DELTA,chgrhr_l,wos,exc)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : DP,UP,DOWN,PAI,Valence_plus_PC_Charge
  implicit none

  integer,intent(in)         :: ispin,ista_r,iend_r,input_charge
  real(kind=DP),intent(in)   :: DELTA
  real(kind=DP),intent(inout):: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)   :: wos(ista_r:iend_r)  
  real(kind=DP),intent(inout):: exc

  real(kind=DP), parameter :: C13   =  1.d0/3.d0,  C23   =  2.d0/3.d0,  C43   =  4.d0/3.d0
  real(kind=DP), parameter :: GAMP   = -0.1423d0, GAMF   = -0.0843d0 &
       &                    , BETA1P =  1.0529d0, BETA2P =  0.3334d0 &
       &                    , BETA1F =  1.3981d0, BETA2F =  0.2611d0 &
       &                    , AP     =  0.0311d0, BP     = -0.0480d0 &
       &                    , CP     =  0.0020d0, DPx    = -0.0116d0 &
       &                    , AF     =  0.01555d0,BF     = -0.0269d0 &
       &                    , CF     =  0.00070d0,DF     = -0.0048d0

  real(kind=DP)  :: B1P01,B1P02,CP00,CP01,CP02,C243 &
       &          , B1F01,B1F02,CF00,CF01,CF02
  real(kind=DP)  :: CO2, WX0, C213
  real(kind=DP)  :: rho,ovn,rs,zeta,wxp,f00,wx,vx1,vx2,denmp,denmf,wcp,wcf &
       &          , vcp,vcf,wc,t1,f11,t2,vc1,vc2,vxc,vxp
  integer        :: i

  CO2   = (0.75d0/PAI)**C13
  WX0   =  3*(((9*PAI)/4)**C13)/(2*PAI)
  B1P01 = 7*BETA1P/6.d0
  B1P02 = 4*BETA2P/3.d0
  CP00 = BP - AP/3.D0
  CP01 = (2*DPx - CP)/3.D0
  CP02 = 2*CP/3.D0

  if(ispin == 2 .and. input_charge == Valence_plus_PC_Charge) then
     C213 = 2.d0**C13 - 1
!!$     OVC213 = 1.d0/C213
     C243   = 2*C213
!           ovc243 = 1.d0/(2.d0**C43 - 2)

     B1F01 = 7*BETA1F/6.d0
     B1F02 = 4*BETA2F/3.d0
     CF00 = BF - AF/3.d0
     CF01 = (2*DF - CF)/3.d0
     CF02 = 2*CF/3.d0

     do i = ista_r, iend_r
        rho    = chgrhr_l(i, UP) + chgrhr_l(i,DOWN)
        if(rho <= DELTA) then
           chgrhr_l(i,UP  ) = 0.D0
           chgrhr_l(i,DOWN) = 0.D0
           cycle
        end if
        ovn = 1.d0/rho
        rs     = CO2*ovn**C13
        zeta   = (chgrhr_l(i,UP) - chgrhr_l(i,DOWN))*ovn
        wxp    = -WX0*0.5d0/rs
        f00 = ( (1+zeta)**C43 + (1-zeta)**C43 - 2 ) / c243
        wx  = wxp*(1+C213*f00)
        vx1 = c43*wxp*(1+zeta)**c13
        vx2 = c43*wxp*(1-zeta)**c13
        if(rs >= 1.d0) then
           denmp = 1.d0 + BETA1P*sqrt(rs) + BETA2P*rs
           denmf = 1.D0 + BETA1F*sqrt(rs) + BETA2F*rs
           wcp = GAMP/denmp
           wcf = GAMF/denmf
           vcp = wcp*(1.d0+B1P01*sqrt(rs)+B1P02*rs)/denmp
           vcf = wcf*(1.D0+B1F01*sqrt(rs)+B1F02*rs)/denmf
        else
           wcp = AP*dlog(rs) + BP + CP*rs*dlog(rs) + DPx*rs
           wcf = AF*dlog(rs) + BF + CF*rs*dlog(rs) + DF*rs
           vcp = (AP+CP02*rs)*dLOG(rs) + CP00 + CP01*rs
           vcf = (AF+CF02*rs)*dLOG(rs) + CF00 + CF01*rs
        end if
        wc     = wcp + f00*(wcf - wcp)
        t1     = vcp + f00*(vcf - vcp)
        f11    = C23/C213*((1+zeta)**c13-(1-zeta)**c13)
        t2     = f11*(wcf-wcp)
        vc1    = t1+t2*(1-zeta)
        vc2    = t1-t2*(1+zeta)

        chgrhr_l(i,UP  ) = vx1 + vc1
        chgrhr_l(i,DOWN) = vx2 + vc2

        vxc    = wx + wc
        exc = exc + vxc*rho*wos(i)
     end do
  else
     do i = ista_r, iend_r
        rho    = chgrhr_l(i, 1)
        if(rho <= DELTA) then
           chgrhr_l(i,UP  ) = 0.D0
           cycle
        end if
        ovn = 1.d0/rho
        rs     = CO2*ovn**C13
        wxp    = -WX0*0.5d0/rs
        vxp = C43*wxp
        if(rs >= 1.d0) then
           denmp = 1 + BETA1P*sqrt(rs) + BETA2P*rs
           wcp = GAMP/denmp
           vcp = wcp*(1+B1P01*sqrt(rs)+B1P02*rs)/denmp
        else
           wcp = AP*dlog(rs) + BP + CP*rs*dlog(rs) + DPx*rs
           vcp = (AP+CP02*rs)*dLOG(rs) + CP00 + CP01*rs
        end if
        wc     = wcp
        chgrhr_l(i,1   ) = vxp + vcp

        vxc    = wxp + wcp
        exc = exc + vxc*rho*wos(i)
     end do
  endif
end subroutine xcpotf_pz

subroutine xcpotf_vwn(ispin,ista_r,iend_r,input_charge,DELTA,chgrhr_l,wos,exc)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : DP,UP,DOWN,PAI,Valence_plus_PC_Charge
  implicit none

  integer,intent(in)         :: ispin,ista_r,iend_r,input_charge
  real(kind=DP),intent(in)   :: DELTA
  real(kind=DP),intent(inout):: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)   :: wos(ista_r:iend_r)  
  real(kind=DP),intent(inout):: exc

  real(kind=DP), parameter :: B1 = 1.13107d0,    C1 = 13.0045d0 &
       &                    , D1 = -0.0047584d0 &
       &                    , A2 =  0.0621814d0, B2 =  3.72744d0 &
       &                    , C2 = 12.9352d0   , D2 = -0.10498d0 &
       &                    , A3 =  0.0310907d0, B3 =  7.06042d0 &
       &                    , C3 = 18.0578d0,    D3 = -0.32500d0
  real(kind=DP), parameter :: C13   =  1.d0/3.d0,  C43   =  4.d0/3.d0
  real(kind=DP) :: CO2, WX0, C213

  real(kind=DP) :: F20,A1,Q1,P01,Q2,P02,Q3,P03,C243
  real(kind=DP) :: rho,ovn,zeta,f00,wx,vx1,vx2,x,p,r,h00,h10,h0p,h1p,h0f,h1f &
       &         , z4,h000,wc,vc,g00,vc0,vc1,vc2,rs,wxp,vxc
  integer       :: i

  CO2   = (0.75d0/PAI)**C13
  WX0   =  3*(((9*PAI)/4)**C13)/(2*PAI)
  C213 = 2**C13 - 1

  F20   = 4/(9*C213)
  A1   = -1/(3*PAI*PAI)
  Q1   = dsqrt(4*C1-B1**2)
  P01  = D1**2 + B1*D1 + C1

  Q2   = dsqrt(4*C2-B2**2)
  P02  = D2**2 + B2*D2 + C2

  Q3   = dsqrt(4*C3-B3**2)
  P03  = D3**2 + B3*D3 + C3

  if(ispin ==  2 .and. input_charge == Valence_plus_PC_Charge) then
!!$     OVC213 = 1.d0/C213
     C243   = 2*C213
!           ovc243 = 1.d0/(2.d0**c43 - 2)

     do i = ista_r, iend_r
        rho    = chgrhr_l(i, UP) + chgrhr_l(i,DOWN)
        if(rho <= DELTA) then
           chgrhr_l(i,UP  ) = 0.D0
           chgrhr_l(i,DOWN) = 0.D0
           cycle
        end if
        ovn = 1.d0/rho
        rs     = CO2*ovn**C13
        if(rs <= DELTA) then
           chgrhr_l(i, UP)   = 0.d0  
           chgrhr_l(i, DOWN) = 0.d0
           cycle
        end if
        zeta   = (chgrhr_l(i,UP) - chgrhr_l(i,DOWN))*ovn
        wxp    = -WX0*0.5d0/rs
        f00 = ( (1+zeta)**C43 + (1-zeta)**C43 - 2 ) / C243
        wx  = wxp*(1+C213*f00)
        vx1 = C43*wxp*(1+zeta)**C13
        vx2 = C43*wxp*(1-zeta)**C13
        x   = dsqrt(rs)
        p   = x**2 + B1*x + C1
        r   = datan(Q1/(2*x+B1))
        h00= (A1/F20) * ( dlog((x**2)/p)+2*B1*r/Q1 &
             &       -B1*D1*(dlog(((x-D1)**2)/p)+2*(B1+2*D1)*r/Q1)/P01 )
        h10= (A1/F20) * ( 2/x - (1-B1*D1/P01)*(2*x+B1)/p - 2*B1*D1/((x-D1)*P01) &
             &                 - 4*B1*(1-(B1+2*D1)*D1/P01)/(Q1**2+(2*x+B1)**2) )

        p   = x**2 + B2*x + C2
        r   = datan(Q2/(2*x+B2))
        h0p= A2 * ( dlog((x**2)/p)+2*B2*r/Q2 &
             &        -B2*D2*(dlog(((x-D2)**2)/p)+2*(B2+2*D2)*r/Q2)/P02 )
        h1p= A2 * ( 2/x - (1-B2*D2/P02)*(2*x+B2)/p - 2*B2*D2/((x-D2)*P02) &
             &        -4*B2*(1-(B2+2*D2)*D2/P02)/(Q2**2+(2*x+B2)**2) )

        p   = x**2 + B3*x + C3
        r   = datan(Q3/(2*x+B3))
        h0f = A3 * ( dlog((x**2)/p)+2*B3*r/Q3 &
             &       -B3*D3*(dlog(((x-D3)**2)/p)+2*(B3+2*D3)*r/Q3)/P03 )
        h1f = A3 * ( 2/x - (1-B3*D3/P03)*(2*x+B3)/p - 2*B3*D3/((x-D3)*P03) &
             &         - 4*B3*(1-(B3+2*D3)*D3/P03)/(Q3**2+(2*x+B3)**2) )

        z4   = zeta**4
        h000 = h0f - h0p - h00
        wc=h0p+h00*f00+h000*z4*f00
        vc=wc-x*((1-z4*f00)*h1p+z4*f00*h1f+(1-z4)*f00*h10)/6
        g00 = 4*((1+zeta)**c13-(1-zeta)**c13) / (6*c213)
        vc0 = 4* h000*(zeta**3)*f00 + (h000*z4+h00)*g00
        vc1=vc+(1-zeta)*vc0
        vc2=vc-(1+zeta)*vc0

        wc  = wc*0.5d0
        vc1 = vc1*0.5d0
        vc2 = vc2*0.5d0

        chgrhr_l(i,UP  ) = vx1 + vc1
        chgrhr_l(i,DOWN) = vx2 + vc2

        vxc    = wx + wc
        exc = exc + vxc*rho*wos(i)
     end do
  else
!!$     OVC213 = 1.d0/C213
     C243   = 2*C213

     do i = ista_r, iend_r
        rho    = chgrhr_l(i, 1)
        if(rho <= DELTA) then
           chgrhr_l(i,1  ) = 0.D0
           cycle
        end if
        ovn = 1.d0/rho
        rs     = CO2*ovn**C13
        wxp    = -WX0*0.5d0/rs
        f00 = 0.d0
        wx  = wxp
        vx1 = c43*wxp

        x   = dsqrt(rs)
        p   = x**2 + B2*x + C2
        r   = datan(Q2/(2*x+B2))
        h0p= a2 * ( dlog((x**2)/p)+2*b2*r/q2 &
             &       -b2*d2*(dlog(((x-d2)**2)/p)+2*(b2+2*d2)*r/q2)/p02 )
        h1p= a2 * ( 2/x - (1-b2*d2/p02)*(2*x+b2)/p - 2*b2*d2/((x-d2)*p02) &
             &           - 4*b2*(1-(b2+2*d2)*d2/p02)/(q2**2+(2*x+b2)**2) )

        wc  = h0p
        vc1 = wc-x*h1p/6

        wc  = wc*0.5d0
        vc1 = vc1*0.5d0

        chgrhr_l(i,1  ) = vx1 + vc1
        vxc    = wx + wc
        exc = exc + vxc*rho*wos(i)
     end do
  endif
end subroutine xcpotf_vwn

subroutine xcpotf_mjw_bh_gl(len_xctype,xctype,ispin,ista_r,iend_r,input_charge,DELTA,chgrhr_l,wos,exc)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : DP,UP,DOWN,PAI,Valence_plus_PC_Charge
  implicit none

  integer,intent(in)         :: len_xctype,ispin,ista_r,iend_r,input_charge
  character(len=len_xctype)  :: xctype
  real(kind=DP),intent(in)   :: DELTA
  real(kind=DP),intent(inout):: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)   :: wos(ista_r:iend_r)  
  real(kind=DP),intent(inout):: exc

  real(kind=DP), parameter ::  CP    =  0.0020d0,  CF     =  0.00070d0
  real(kind=DP), parameter ::  C13   =  1.d0/3.d0, C43   =  4.d0/3.d0

  real(kind=DP) :: CO2, WX0, C213
  real(kind=DP) :: C243, CPX, RP, CFX, RF
  real(kind=DP) :: rho,ovn,rs,zeta,wxp,f00,wx,vx1,vx2,rsp,rsf,aap,aaf &
       &         , wcp,wcf,vcp,vcf,t1,t2,f11,f12,wc,vc1,vc2,vxc
  integer       :: i

  CO2   = (0.75d0/PAI)**C13
  WX0   =  3*(((9*PAI)/4)**C13)/(2*PAI)
  C213 = 2**C13 - 1
  if(xctype ==  'mjw    ') then
! --*   moruzzi-janak-williams; Phys.Rev.12(1975)1257.  
     CPX=0.0450d0
     RP=21.0d0
  else if(xctype == 'bh     ') then                                    
! --*   von barth-hedin; J.Phys.C:Solid State Phys.5(1972)1629.  
     CPX=0.0504d0
     RP=30.0d0
  else if(xctype == 'gl     ') then                                    
! --*   gunnarsson-lundqvist; Phys.Rev.B13(1976)4274. 
     CPX=0.0666d0
     RP=11.4d0
  end if
  if(ispin ==  2 .and. input_charge == Valence_plus_PC_Charge) then
     if(xctype ==  'mjw    ') then
        CFX=cp/2
        RF=RP*(2.d0**C43)
     else if(xctype ==  'bh     ') then                                    
        CFX=0.0254d0
        RF=75.0d0
     else if(xctype ==  'gl     ') then                                    
        CFX=0.0406d0
        RF=15.9d0
     end if

     C243   = 2*C213
     do i = ista_r, iend_r
        rho    = chgrhr_l(i, UP) + chgrhr_l(i,DOWN)
        if(rho <= DELTA) then
           chgrhr_l(i,UP  ) = 0.D0
           chgrhr_l(i,DOWN) = 0.D0
           cycle
        end if
        ovn = 1.d0/rho
        rs     = CO2*ovn**C13
        if(rs <= DELTA) then
           chgrhr_l(i, UP  ) = 0.d0
           chgrhr_l(i, DOWN) = 0.d0
           cycle
        end if
        zeta   = (chgrhr_l(i,UP) - chgrhr_l(i,DOWN))*ovn
        wxp    = -WX0*0.5d0/rs
        f00 = ( (1+zeta)**C43 + (1-zeta)**C43 - 2 ) / C243
        wx  = wxp*(1+C213*f00)
        vx1 = C43*wxp*(1+zeta)**C13
        vx2 = C43*wxp*(1-zeta)**C13
        rsp = rs/RP
        rsf = rs/RF
        aap = dlog(1+1/rsp)                                      
        aaf = dlog(1+1/rsf)                                      
        wcp = - CPX * ((1+rsp**3)*aap - rsp**2 + rsp/2 - C13)
        wcf = - CFX * ((1+rsf**3)*aaf - rsf**2 + rsf/2 - C13)
        vcp = - CP * aap
        vcf = - CF * aaf

        t1  = vcf - vcp - C43*(wcf-wcp) 
        t2  = C43 * (wcf-wcp)

        f11= ( (1+zeta)**C13 -1 ) / C213
        f12= ( (1-zeta)**C13 -1 ) / C213
        wc=wcp + (wcf - wcp)*f00
        vc1=vcp + t1*f00 + t2*f11
        vc2=vcp + t1*f00 + t2*f12

        wc = wc*0.5d0
        vc1 = vc1*0.5d0
        vc2 = vc2*0.5d0

        chgrhr_l(i,UP  ) = vx1 + vc1
        chgrhr_l(i,DOWN) = vx2 + vc2

        vxc    = wx + wc
        exc = exc + vxc*rho*wos(i)
     end do
  else
     c243   = 2*C213
     do i = ista_r, iend_r
        rho    = chgrhr_l(i, 1)
        if(rho <= DELTA) then
           chgrhr_l(i,1   ) = 0.D0
           cycle
        end if
        ovn = 1.d0/rho
        rs     = CO2*ovn**C13
        if(rs <= DELTA) then
           chgrhr_l(i, 1   ) = 0.d0
           cycle
        end if
        zeta   = 0.d0
        wxp    = -WX0*0.5d0/rs
        wx  = wxp
        vx1 = c43*wxp
        vx2 = c43*wxp

        rsp = rs/RP
        aap = dlog(1+1/rsp)                                      
        wcp = - CPX * ((1+rsp**3)*aap - rsp**2 + rsp/2 - C13)
        vcp = - CP * aap

        wc=wcp * 0.5d0
        vc1=vcp * 0.5d0

        chgrhr_l(i,1   ) = vx1 + vc1

        vxc    = wx + wc
        exc = exc + vxc*rho*wos(i)
     end do
  endif
end subroutine xcpotf_mjw_bh_gl
!$$#endif
! === xclda etc. are necessary to make 3D_Parallel, too!!! by tkato ============
!!BRANCH_P_END ORG_Parallel
! ==============================================================================

!! --- ggasubs ---
!! -------------------------------------------
subroutine cpden(rh,kmesh,mesh,lfp,rad,rho,fdiff)
!      30th Oct. 1994
!             by T.Yamasaki
!
  use m_Const_Parameters, only : DP,PAI4
  implicit none
  integer, intent(in)                          :: kmesh,mesh,lfp
  real(kind=DP),intent(in), dimension(kmesh,2) :: rh
  real(kind=DP),intent(in), dimension(kmesh)   :: rad
  real(kind=DP),intent(out),dimension(kmesh,2) :: rho
  real(kind=DP),intent(out),dimension(kmesh)   :: fdiff

  real(kind=DP)  :: ovpi4

  ovpi4 = 1.d0/PAI4
  if(lfp == 1) then
     rho(:,1) = rh(:,1)*ovpi4/(rad(:)*rad(:))
     rho(:,2) = rh(:,2)*ovpi4/(rad(:)*rad(:))
     fdiff(:) = rho(:,1) + rho(:,2)
  else
     rho(:,1) = rh(:,1)*ovpi4/(rad(:)*rad(:))
     fdiff(:) = rho(:,1)
  end if
end subroutine cpden

! ------------------------------------------------------
subroutine gdiffs(h,rad,fdiff,kmesh,mmesh,mddiff,nddiff)
!             8th Aug. 1992
!                 by T.Yamasaki
!           revised by T.Yamasaki on 30th Oct. 1994
!
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)          :: kmesh,mmesh,mddiff,nddiff
  real(kind=DP), intent(in)    :: h, rad(kmesh)
  real(kind=DP), intent(inout) :: fdiff(kmesh,0:mddiff)

  integer       :: id,j
  real(kind=DP) :: alpha

  if(nddiff > mddiff) write(6,*) ' *** nddiff > mddiff *** '
  do id = 1, nddiff
     alpha = 1.d0/(dexp(h*id)-1.d0)
     do j = 1, mmesh - id
        fdiff(j,id) = (fdiff(j+1,id-1) - fdiff(j,id-1)) * alpha/rad(j)
     end do
  end do
end subroutine gdiffs

! ------------------------------------------------------
!             8th Aug. 1992
!                 by T.Yamasaki
subroutine gtgrad(h,rad,fdiff,kmesh,mmesh,nddiff,nddriv &
     &     ,npcntr,coeff,mddiff,grad,modeex)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters, only : DP
  implicit none
  integer,      intent(in) :: kmesh,mmesh,nddiff,nddriv,npcntr,mddiff,modeex
  real(kind=DP),intent(in) :: h,rad(kmesh),fdiff(kmesh,nddiff)
  real(kind=DP)            :: coeff(0:mddiff,nddriv:mddiff)
  real(kind=DP),intent(out):: grad(kmesh)

  integer, parameter :: EXECUT = 2

  if(npcntr > nddiff) then
     write(6,*) ' *** npcntr should be smaller than nddiff ***'
     write(6,*) ' *** (npcntr, nddiff) = (',npcntr,',',nddiff,') ***'
     stop
  endif
  if(nddriv == 1) then
     call gcoef1(h,coeff,mddiff,nddiff)
  else if(nddriv == 2) then
     call gcoef2(h,coeff,mddiff,nddiff)
  else
     write(6,*) ' *** nddriv = ', nddriv, ' ***'
     stop ' *** nddriv should be smaller than 3 ***'
  endif
#ifdef DEBUG_WRITE
  call wdcoef(coeff,mddiff,nddiff,nddriv)
#endif
  if(modeex == EXECUT) then
     call ggrade(coeff,mddiff,nddiff,nddriv,rad,fdiff,kmesh,mmesh,npcntr,grad)
  endif
end subroutine gtgrad

#ifdef DEBUG_WRITE
! --------------------------------------------------------------
subroutine wdcoef(coeff,mddiff,nddiff,nddriv)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)       :: mddiff,nddiff,nddriv
  real(kind=DP), intent(in) :: coeff(0:mddiff,nddriv:mddiff)

  integer :: i

  write(6,*) ' ++++ nddriv = ', nddriv, ' ++++'
  do i = nddriv, nddiff
     write(6,*) ' ++++ i(alpha) = ', i ,' ++++'
     write(6,'(10f8.4)') (coeff(j,i),j = 0, nddiff)
  end do
end subroutine wdcoef
#endif

! --------------------------------------------------------------
subroutine gcoef1(h,coeff,mddiff,nddiff)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)      :: mddiff,nddiff
  real(kind=DP),intent(in) :: h
  real(kind=DP),intent(out):: coeff(0:mddiff,mddiff)

  integer       :: i,npd,ip,j,isum,imul,ipp
  real(kind=DP) :: x, y
  coeff(:,1) = 1.d0

#ifdef SX
!cdir skip
#endif
  do npd = 2, nddiff
#ifdef SX
!cdir skip
#endif
     do i = 0, npd-1
        ip = -i
        x = 1.d0
#ifdef SX
!cdir skip
#endif
        do j = 1, npd - 1
           if(ip == 0) ip = 1
           x = x*(1.d0 - dexp(h*ip))
           ip = ip + 1
        end do
        coeff(i,npd) = x
     end do
#ifdef SX
!cdir skip
#endif
     do i = npd, nddiff
        ip = -i
        y = 0.d0
#ifdef SX
!cdir skip
#endif
        do isum = 1, npd
           ipp = ip
           x = 1.d0
#ifdef SX
!cdir skip
#endif
           do imul = 1, npd
              if(imul /= isum)  x = x*(1.d0 - dexp(h*ipp))
!                    x = x*(0 - ipp*h)
              ipp = ipp + 1
           end do
           y = y + x
        end do
        coeff(i, npd) = y
     end do
  end do
end subroutine gcoef1

! --------------------------------------------------------------------
subroutine gcoef2(h,coeff,mddiff,nddiff)
  use m_Const_Parameters, only : DP
  implicit none

  integer, intent(in) :: mddiff, nddiff
  real(kind=DP), intent(in)  :: h
  real(kind=DP), intent(out) :: coeff(0:mddiff,2:mddiff)

  integer       :: i, npd,isum,imul,ip,ipp,jsum
  real(kind=DP) :: x, y

  coeff(:,2) = 2.d0

#ifdef SX
!cdir skip
#endif
  do npd = 3, nddiff
#ifdef SX
!cdir skip
#endif
     do i = 0, npd-1
        ip = -i
        y = 0.d0
#ifdef SX
!cdir skip
#endif
        do isum = 1, npd-1
           ipp = ip
           x = 1.d0
#ifdef SX
!cdir skip
#endif
           do imul = 1, npd-1
              if(ipp == 0) ipp = 1
              if(imul /= isum)   x = x*(1 - dexp(h*ipp))
!                    x = x*(0.d0 - ipp*h)
              ipp = ipp + 1
           end do
           y = y + x
        end do
        coeff(i,npd) = 2.d0*y
     end do
#ifdef SX
!cdir skip
#endif
     do i = npd, nddiff
        ip = -i
        y = 0.d0
#ifdef SX
!cdir skip
#endif
        do isum = 1, npd-1
           do jsum = isum+1, npd
              ipp = ip
              x = 1.d0
#ifdef SX
!cdir skip
#endif
              do imul = 1, npd
                 if(isum /= imul .and. jsum /= imul)  x = x*(1 - dexp(h*ipp))
!                       x = x*(0.d0 - ipp*h)
                 ipp = ipp + 1
              end do
              y = y + x
           end do
        end do
        coeff(i, npd) = 2.d0*y
     end do
  end do
end subroutine gcoef2

! --------------------------------------------------------------------
subroutine ggrade(coeff,mddiff,nddiff,nddriv,rad,fdiff,kmesh,mmesh,npcntr,grad)
  use m_Const_Parameters, only : DP
  implicit none

  integer, intent(in) :: mddiff,nddiff,nddriv,kmesh,mmesh,npcntr
  real(DP),intent(in) :: coeff(0:mddiff,nddriv:mddiff),rad(0:kmesh-1),fdiff(0:kmesh-1,mddiff)
  real(DP),intent(out):: grad(0:kmesh-1)

  integer :: j,ipcntr,idf,iddiff,id

  grad = 0.d0

  ipcntr = -1
  idf  = nddiff - (npcntr+1)*2
  do j = 0, npcntr - 1
     ipcntr = ipcntr + 1
     idf = idf + 2
     if(idf < nddriv+1) then
        iddiff = nddriv + 1
     else
        iddiff = idf
     endif
     do id = iddiff, nddriv+1, -1
        grad(j) = (grad(j) + coeff(ipcntr,id)*fdiff(j-ipcntr,id))*rad(j)
     end do
  end do

  do id = nddiff, nddriv+1, -1
     do j = npcntr, mmesh-1-nddiff+npcntr
        grad(j) = (grad(j) + coeff(npcntr,id)*fdiff(j-npcntr,id))*rad(j)
     end do
  end do

  ipcntr = npcntr
  iddiff = nddiff
  do j = mmesh-nddiff+npcntr,mmesh-1
     iddiff = iddiff - 2
     if(iddiff < nddriv+1) then
        iddiff = nddriv + 1
        ipcntr = ipcntr + 1
     else
        ipcntr = ipcntr - 1
     endif
     do id = iddiff, nddriv + 1, -1
        grad(j) = (grad(j) + coeff(ipcntr,id)*fdiff(j-ipcntr,id))*rad(j)
     end do
  end do

  ipcntr = -1
  idf = nddiff - (npcntr + 1)*2
  do j = 0, npcntr-1
     ipcntr = ipcntr + 1
     idf = idf + 2
     if(idf < nddriv+1) then
        iddiff = nddriv+1
     else
        iddiff = idf
     endif
     grad(j) = grad(j) + coeff(j,nddriv)*fdiff(j-ipcntr,nddriv)
  end do

  do j = npcntr, mmesh-nddiff+npcntr-1
     grad(j) = grad(j) + coeff(npcntr,nddriv)*fdiff(j-npcntr,nddriv)
  end do

  ipcntr = npcntr
  iddiff = nddiff
  do j = mmesh-nddiff+npcntr, mmesh-1
     iddiff = iddiff - 2
     if(iddiff < nddriv+1) then
        iddiff = nddriv + 1
        ipcntr = ipcntr + 1
     else
        ipcntr = ipcntr - 1
     endif
     grad(j) = grad(j) + coeff(ipcntr,nddriv)*fdiff(j-ipcntr,nddriv)
  end do

end subroutine ggrade

! ----------------------------------------
!       14th Aug. 1992 by T.Yamasaki
!    Revised by T.Yamasaki on 30th Oct. 1994
subroutine cnggrd1(grdnts,kmesh,mmesh)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)         :: kmesh,mmesh
  real(kind=DP),intent(inout) :: grdnts(kmesh,1)

  integer       :: i
  real(kind=DP) :: fac

  do i = 1, mmesh
     fac = 1.d0
     if(grdnts(i,1) < 0.d0) fac = -1.d0
     grdnts(i,1) = grdnts(i,1)*grdnts(i,1)
     grdnts(i,1) = dsqrt(grdnts(i,1))*fac
  end do
end subroutine cnggrd1

! -------------------------------------------
!      15TH AUG. 1992
!             BY T.YAMASAKI
!
subroutine cpval(a,mel,nel,cpmod,nmode,b)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)      :: mel,nel,cpmod,nmode
  real(kind=DP),intent(in) :: a(mel,nmode)
  real(kind=DP),intent(out):: b(mel)

  integer, parameter :: ABSLUT = 1, NORMAL = 2

  if(cpmod == NORMAL) then
     if(nmode == 1) then
        b(1:nel) = a(1:nel,1)
     else if(nmode ==  2) then
        b(1:nel) = a(1:nel,1) + a(1:nel,2)
     endif
  else if(cpmod == ABSLUT) then
     if(nmode == 1) then
        b(1:nel) = dsqrt(a(1:nel,1)*a(1:nel,1))
     else if(nmode == 2) then
        b(1:nel) = dsqrt(a(1:nel,1)*a(1:nel,1) + a(1:nel,2)*a(1:nel,2))
     endif
  else
     write(6,*) ' !D invalid value of (cpmod = ',cpmod,')'
  endif

end subroutine cpval

! -------------------------------------------
!      30TH Nov. 1994
!             BY T.YAMASAKI
!
subroutine cpval_abs(a,mel,nel,nmode,b)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)       :: mel, nel, nmode
  real(kind=DP), intent(in) :: a(mel,nmode)
  real(kind=DP), intent(out):: b(mel)

  if(nmode == 1) then
     b(1:nel) = dsqrt(a(1:nel,1)*a(1:nel,1))
  else if(nmode == 2) then
     b(1:nel) = dsqrt(a(1:nel,1)*a(1:nel,1) + a(1:nel,2)*a(1:nel,2))
  end if
end subroutine cpval_abs

! -------------------------------------------
!      15TH AUG. 1992
!             BY T.YAMASAKI
!      1st DEC. 1994
!           Revised by T.Yamasaki 
!
subroutine getroh(rh,kmesh,mesh,rad,rho)
  use m_Const_Parameters, only : DP,PAI4
  implicit none
  integer, intent(in) :: kmesh,mesh
  real(DP),intent(in) :: rh(kmesh),rad(kmesh)
  real(DP),intent(out):: rho(kmesh)

  real(DP) :: ovpi4

  ovpi4 = 1.d0/PAI4
  rho(1:mesh) = rh(1:mesh)*ovpi4/(rad(1:mesh)*rad(1:mesh))
end subroutine getroh

! -------------------------------------------
!      1ST DEC. 1994
!             BY T.YAMASAKI
!
subroutine getroh2(rh,rhpc,kmesh,mesh,rad,rho)
  use m_Const_Parameters, only : DP,PAI4
  implicit none
  integer, intent(in) :: kmesh,mesh
  real(DP),intent(in) :: rh(kmesh),rhpc(kmesh),rad(kmesh)
  real(DP),intent(out):: rho(kmesh)

  real(DP) :: ovpi4

  ovpi4 = 1.d0/PAI4
  rho(1:mesh) = (rh(1:mesh)+rhpc(1:mesh))*ovpi4/(rad(1:mesh)*rad(1:mesh))
end subroutine getroh2

! ----------------------------------------
!       14TH AUG. 1992 BY T.YAMASAKI
!       1ST DEC.  1994  Revised by T.Yamasaki
!       3rd DEC.  1994  Revised by Y.Morikawa
!
subroutine cnggrd(grdnts,rad,kmesh,mesh)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)   :: kmesh,mesh
  real(DP),intent(in)   :: rad(kmesh)
  real(DP),intent(inout):: grdnts(kmesh,3)

  integer :: i
!!$cccc  changed by Y.M
  do  i = 1, mesh
     grdnts(i,3) = grdnts(i,2)
     grdnts(i,2) = grdnts(i,2) + 2*grdnts(i,1)/rad(i)
  end do
!!$cccc  changed by Y.M

  grdnts(1:mesh,1) = dabs(grdnts(1:mesh,1))

end subroutine cnggrd

! ----------------------------------------
!       15TH AUG. 1992 BY T.YAMASAKI
!
subroutine mkprdc(a,b,c,m,n,ndeg)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in) :: m,n,ndeg
  real(DP),intent(in) :: a(m,ndeg),b(m,ndeg)
  real(DP),intent(out):: c(m)

  integer :: ideg,ip
  c = 0.d0

  do ideg = 1, ndeg
     do ip = 1, n
        c(ip) = c(ip) + a(ip,ideg)*b(ip,ideg)
     end do
  end do
end subroutine mkprdc

subroutine  epcor_0(nspin,DELTA,tchgr_l,f2or1,epc)
  ! Electron-positron correlation, 0-density limit
  ! Coded by Dr. Mineo Saito, 15th Nov. 2003
  use m_Const_Parameters,  only : PAI,DP
  use m_Parallelization,   only : ista_sfftph, iend_sfftph
  implicit none

 integer,intent(in)        :: nspin
 real(kind=DP),intent(in)  :: DELTA
 real(kind=DP),intent(inout)  :: tchgr_l(ista_sfftph:iend_sfftph,nspin)
 real(kind=DP),intent(in)  :: f2or1(ista_sfftph:iend_sfftph) 
 real(kind=DP),intent(out)  :: epc 
 
 real*8 rs,facw,d,alog,e_density,epc_derivative,epc_energy, HARTREE
 integer i_derive,is,i

  HARTREE = 1.d0/2.d0
  epc=0.d0
  facw = nspin
  do is = 1, nspin
   do i = ista_sfftph, iend_sfftph 
     d  = facw * tchgr_l(i, is)
     rs=1.d0/((4.d0/3.d0*PAI*d)**(1.d0/3.d0))  
     if(rs.le.0.d0) stop 'error epxc'
     i_derive=0
	 if(rs.lt.0.302d0)then
	  alog=log(rs)
	  epc_energy=-1.56d0/dsqrt(rs)+(0.051d0*alog-0.081d0)*alog+1.14d0
	  epc_derivative=1.56d0/2/rs**1.5d0+(0.051d0*alog-0.081d0)/rs+0.051d0*alog/rs
         elseif(rs.lt.0.56d0)then
	  epc_energy=-0.92305d0-0.05459d0/rs/rs
	  epc_derivative=0.05459*2/rs**3
         elseif(rs.lt.8.0)then
	  epc_energy=-13.15111d0/(rs+2.5d0)**2+2.8655d0/(rs+2.5)-0.6298d0
	  epc_derivative=13.15111*2/(rs+2.5d0)**3-2.8655d0/(rs+2.5d0)**2
	 else
          e_density=1.d0/(3.14159265358d0*4.d0/3.d0*rs*rs*rs) 
	  epc_energy=-179856.2768*e_density*e_density+186.4207*e_density-0.524d0
	  epc_derivative=-179856.2768*3*e_density**2+186.4207d0*2*e_density-0.524d0
	  i_derive=1
	endif 
!       tchgr_l(i,is)=(epc_energy-rs/3.d0*epc_derivative)*HARTREE
       tchgr_l(i,is)=epc_energy*HARTREE
!	    if(i_derive.eq.1) tchgr_l(i,is)=epc_derivative*HARTREE
!		epc=epc+tchgr_l(i,is)*f2or1(i)*HARTREE
		epc=epc+tchgr_l(i,is)*f2or1(i)
    enddo
  enddo
end subroutine epcor_0  
subroutine  epcor_00(DELTA,tchgr_l,nnmesh)
  ! Electron-positron correlation, 0-density limit
  ! Coded by Dr. Mineo Saito, 15th Nov. 2003
  use m_Const_Parameters,  only : PAI,DP
  implicit none

real(kind=DP),intent(in)  :: DELTA
 real(kind=DP),intent(inout)  :: tchgr_l(nnmesh)
 
real(kind=DP)  :: epc 
real*8 rs,d,alog,e_density,epc_derivative,epc_energy,HARTREE
 integer i_derive,i,nnmesh
 
HARTREE=1.d0/2.d0
  epc=0.d0
  do i = 1, nnmesh 
     d  = tchgr_l(i)
     rs=1.d0/((4.d0/3.d0*PAI*d)**(1.d0/3.d0))  
     if(rs.le.0.d0) stop 'error epxc'
     i_derive=0
	 if(rs.lt.0.302d0)then
	  alog=log(rs)
	  epc_energy=-1.56d0/dsqrt(rs)+(0.051d0*alog-0.081d0)*alog+1.14d0
	  epc_derivative=1.56d0/2/rs**1.5d0+(0.051d0*alog-0.081d0)/rs+0.051d0*alog/rs
         elseif(rs.lt.0.56d0)then
	  epc_energy=-0.92305d0-0.05459d0/rs/rs
	  epc_derivative=0.05459*2/rs**3
         elseif(rs.lt.8.0)then
	  epc_energy=-13.15111d0/(rs+2.5d0)**2+2.8655d0/(rs+2.5)-0.6298d0
	  epc_derivative=13.15111*2/(rs+2.5d0)**3-2.8655d0/(rs+2.5d0)**2
	 else
          e_density=1.d0/(3.14159265358d0*4.d0/3.d0*rs*rs*rs) 
	  epc_energy=-179856.2768*e_density*e_density+186.4207*e_density-0.524d0
	  epc_derivative=-179856.2768*3*e_density**2+186.4207d0*2*e_density-0.524d0
	  i_derive=1
	endif 
!       tchgr_l(i)=(epc_energy-rs/3.d0*epc_derivative)*HARTREE
       tchgr_l(i)=epc_energy*HARTREE
!	    if(i_derive.eq.1) tchgr_l(i)=epc_derivative*HARTREE
!		epc=epc+tchgr_l(i)*HARTREE
		epc=epc+tchgr_l(i)
    enddo
 end subroutine epcor_00 
subroutine enhance_0(e_density,enhance)
  use m_Const_Parameters,  only : PAI,DP
  real*8 rs,e_density,DEL,enhance
  DEL=1.d-8
  if(e_density.gt.DEL)then
     rs=1.d0/((4.d0/3.d0*PAI*e_density)**(1.d0/3.d0))  
     enhance=1.d0+1.23d0*rs+0.9889d0*rs**1.5d0 &
          -1.4820d0*rs**2+0.3956d0*rs**2.5d0+rs**3/6.d0
  else
     enhance=0.d0
  endif
end subroutine enhance_0

subroutine enhance_01(e_density,enhance,epsilon_ele)
 use m_Const_Parameters,  only : PAI,DP
 real*8 rs,e_density,DEL,enhance,epsilon_ele
 DEL=1.d-8
!  epsilon=6.34466667d0
 if(e_density.gt.DEL)then
    rs=1.d0/((4.d0/3.d0*PAI*e_density)**(1.d0/3.d0))
!!$    enhance=1.d0+1.23d0*rs+0.8295d0*rs**1.5d0 &
!!$         -1.26d0*rs**2+0.3286d0*rs**2.5d0+(rs**3)/6.d0*(1.d0-1.d0/epsilon_ele)
    enhance=1.d0+1.23d0*rs+0.9889d0*rs**1.5d0 &
         -1.4820d0*rs**2+0.3956d0*rs**2.5d0+(rs**3)/6.d0*(1.d0-1.d0/epsilon_ele)
 else
    enhance=0.d0
 endif
end subroutine enhance_01

subroutine enhance_gga_0(e_density,gradient,enhance)
  use m_Const_Parameters,  only : PAI,DP
  real*8 rs,e_density,DEL,enhance,gradient,fermi_momentum,Thomas_length,enhance_lda,e_param
  DEL=1.d-8
  if(e_density.gt.DEL)then
     rs=1.d0/((4.d0/3.d0*PAI*e_density)**(1.d0/3.d0))  
     enhance_lda=1.d0+1.23d0*rs-0.0742d0*rs**2.d0+rs**3.d0/6.d0
	 fermi_momentum=1.92d0/rs
	 Thomas_length=(4.d0/PAI*fermi_momentum)**(0.5d0)
	 e_param=(gradient/(e_density*Thomas_length))**2.d0
	 enhance=1.d0+(enhance_lda-1.d0)*exp(-0.22d0*e_param)
  else
     enhance=0.d0
  endif
end subroutine enhance_gga_0

subroutine epcor_finite(nspin,DELTA,etchgr_l,ptchgr_l,f2or1,epc)
    use m_Const_Parameters,  only : PAI,DP
    use m_Parallelization,   only : ista_sfftph, iend_sfftph
	implicit none

    integer,intent(in)        :: nspin
    real(kind=DP),intent(in)  :: DELTA
    real(kind=DP),intent(inout)  :: etchgr_l(ista_sfftph:iend_sfftph,nspin)
    real(kind=DP),intent(inout)  :: ptchgr_l(ista_sfftph:iend_sfftph,nspin)
    real(kind=DP),intent(in)  :: f2or1(ista_sfftph:iend_sfftph) 
    real(kind=DP),intent(out)  :: epc
    real*8 facw
    integer is,i
	
	real*8 rs_e,rs_p,epcor_inverse,epcor,ed,pd
	real*8 a_rs,b_rs,c_rs,e_energy_ap,p_energy_ap,p_ap_derivative
	real*8 e_ap_derivative,epc_ne_derivative,epc_np_derivative
	real*8 a_derivative,b_derivative,c_derivative
	epc=0.d0
	facw=nspin
	do is=1,nspin
        do i = ista_sfftph, iend_sfftph 
			ed=facw*etchgr_l(i,is)
			pd=facw*ptchgr_l(i,is)
			rs_e=1.d0/((4.d0/3.d0*PAI*ed)**(1.d0/3.d0))
			rs_p=1.d0/((4.d0/3.d0*PAI*pd)**(1.d0/3.d0))
			if(rs_e.le.0.d0) stop 'error epxc'
			call epcor_abc(rs_e,a_rs,b_rs,c_rs,a_derivative,b_derivative,c_derivative)
			call cal_energy_ap(rs_e,e_energy_ap,e_ap_derivative)
			call cal_energy_ap(rs_p,p_energy_ap,p_ap_derivative)
			epcor_inverse=a_rs+b_rs*rs_p+c_rs*rs_p**2.d0+(4.d0*PAI/3.d0)*(rs_p**3.d0) &
								/e_energy_ap+(4.d0*PAI/3.d0)*(rs_e**3.d0)/p_energy_ap
			epcor=1.d0/epcor_inverse
			epc_ne_derivative=-(a_derivative+b_derivative*rs_p+c_derivative*rs_p**2.d0 &
								-4.d0*PAI/3.d0*e_ap_derivative*rs_p*rs_p*rs_p/(e_energy_ap &
								*e_energy_ap)+(4.d0*PAI*rs_e*rs_e/p_energy_ap)* &
								(-4.d0*PAI/9.d0*rs_e**4.d0))*(epcor*epcor)
			epc_np_derivative=-((b_rs+2.d0*c_rs*rs_p+4.d0*PAI*rs_p*rs_p/e_energy_ap)* &
								(-4.d0*PAI/9.d0*rs_p**4.d0)-4.d0*PAI/3.d0*p_ap_derivative* &
								rs_e*rs_e*rs_e/(p_energy_ap*p_energy_ap))*(epcor*epcor)
			etchgr_l(i,is)=epc_ne_derivative
			ptchgr_l(i,is)=epc_np_derivative
			epc=epc+epcor*f2or1(i)
		end do
	end do
      end subroutine epcor_finite

subroutine cal_energy_ap(rs,energy_ap,ap_derivative)
    use m_Const_Parameters,  only : PAI
	implicit none
	real*8 rs,log,density,energy_ap,ap_derivative
	integer i_derive
	i_derive=0
	if(rs.lt.0.302d0)then
		log=dlog(rs)
		energy_ap=-1.56d0/dsqrt(rs)+(0.051d0*log-0.081d0)*log+1.14d0
		ap_derivative=1.56d0/2.d0/rs**1.5d0+(0.051d0*log-0.081d0)/rs &
						+0.051d0*log/rs
	elseif(rs.lt.0.56d0)then
		energy_ap=-0.92305d0-0.05459d0/rs/rs
		ap_derivative=0.05459*2.d0/rs**3.d0
	elseif(rs.lt.8.0)then
		energy_ap=-13.15111d0/(rs+2.5d0)**2+2.8655d0/(rs+2.5)-0.6298d0
		ap_derivative=13.15111*2.d0/(rs+2.5d0)**3.d0-2.8655d0/(rs+2.5d0)**2.d0
	else
		density=3.d0/(4.d0*PAI*rs**3.d0)
		energy_ap=-179856.2768*density*density+186.4207*density-0.524d0
		ap_derivative=-179856.2768*2.d0*density+186.4207d0
		i_derive=1
	end if
	if(i_derive.eq.0)   ap_derivative=ap_derivative*(-4.d0*PAI/9.d0*rs**4.d0)
end subroutine cal_energy_ap

subroutine epcor_abc(rs_e,a_rs,b_rs,c_rs,a_derivative,b_derivative,c_derivative)
    use m_Const_Parameters,  only : PAI
	implicit none
	real*8 rs_e,a_rs,b_rs,c_rs,a_derivative,b_derivative,c_derivative
	a_rs=69.7029d0-107.4927d0*rs_e+23.7182d0*rs_e**2.d0
	a_derivative=(-107.4927d0+23.7182d0*2.d0*rs_e)*(-4.d0*PAI/9.d0*rs_e**4.d0)
	b_rs=-107.4927d0+141.8458d0*rs_e-33.6472d0*rs_e**2.d0
	b_derivative=(141.8458d0-33.6472d0*2.d0*rs_e)*(-4.d0*PAI/9.d0*rs_e**4.d0)
	c_rs=23.7182d0-33.6472d0*rs_e+5.21152d0*rs_e**2.d0
	c_derivative=(-33.6472d0+5.21152d0*2.d0*rs_e)*(-4.d0*PAI/9.d0*rs_e**4.d0)
end subroutine epcor_abc

!$$#ifdef PARA3D

!===============================================================================

!!====================================================================
!!        modified  by T.Yamasaki  94/11/14
!!
!!        Modified for Spin polrarized GGA by K. Kato 1995/1/18 
!!
subroutine ex_ggapw91_3D(nspin,ispin,chgrhr_l,grad_rho,f2or1,exc,dFx_drho,dFx_dgradrho,nfft_y)
!!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : PAI,DP
  implicit none

  integer,intent(in)        :: nspin,ispin,nfft_y
  real(kind=DP),intent(in)  :: chgrhr_l(1:nfft_y,ispin)
  real(kind=DP),intent(in)  :: grad_rho(1:nfft_y,nspin)
  real(kind=DP),intent(in)  :: f2or1(1:nfft_y)  
  real(kind=DP),intent(out) :: exc
  real(kind=DP),intent(out) :: dFx_drho(1:nfft_y,nspin)
  real(kind=DP),intent(out) :: dFx_dgradrho(1:nfft_y,nspin)


  integer :: is, i
  real(kind=DP) :: exc1,facw,d,dd,fk,s,fac,s2,s3,s4&
       & ,p0,p1,p2,p3,p4,p5,p6,f,ex,fs,exd,exdd,exc0,excd,excdd

  real(kind=DP), parameter :: a1 = 0.19645d0
  real(kind=DP), parameter :: a2 = 0.27430d0
  real(kind=DP), parameter :: a3 = 0.15084d0
  real(kind=DP), parameter :: a4 = 100.0d0
  real(kind=DP), parameter :: ax = -0.7385588d0
  real(kind=DP), parameter :: a  =  7.7956d0
  real(kind=DP), parameter :: b1 =  0.004d0
  real(kind=DP), parameter :: thrd   = 0.33333333333d0
  real(kind=DP), parameter :: thrd4  = 1.333333333333333d0
  real(kind=DP), parameter :: thpith = 3.0936677262801d0

!---- Spin dependency
#ifdef __TIMER_SUB__
    call timer_sta(764)
#endif

  facw = ispin
  exc = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
#ifdef __TIMER_DO__
  call timer_sta(898)
#endif
  do is = 1, ispin
     exc1 = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
     do i = 1, nfft_y       ! MPI
        d  = facw * chgrhr_l(i, is)
        dd = facw * grad_rho(i, is)
        fk = (3*PAI*PAI*d)**thrd
        if(d > 1.d-05) then
           s = dd/(d*fk*2)
        else
           s = 0.d0
        endif

        fac = ax*d**thrd
        s2  = s*s
        s3  = s2*s
        s4  = s2*s2
        p0  = 1.d0/(dsqrt(1+a*a*s2))
        p1  = dlog(a*s+1/p0)
        p2  = dexp(-a4*s2)
        p3  = 1.d0/(1+a1*s*p1+b1*s4)
        p4  = 1 + a1*s*p1 + (a2-a3*p2)*s2
        f   = p3*p4
        ex  = fac*f*d
        p5  = 2*(s*(a2-a3*p2)+a3*a4*s3*p2 - 2*b1*s3)
        p6  = (a1*(p1+a*s*p0)+4*b1*s3)*((a2-a3*p2)*s2-b1*s4)
        fs  = (p5*p3-p6*p3*p3)
        exd = thrd4*fac*(f-s*fs)
        exdd = ax*fs*0.5/thpith

        exc0 = ex / facw
        excd = exd
        dFx_drho(i, is) = excd 
        excdd = exdd
!!$c gradient of charge density 95/12/3 H.S.
        if(dabs(grad_rho(i, is)) > 1.d-9) then
           dFx_dgradrho(i, is) = excdd / grad_rho(i, is)
        else
           dFx_dgradrho(i, is) = 0.d0
        endif
        exc1 = exc1 + exc0*f2or1(i)
     end do
     exc = exc + exc1
  end do
#ifdef __TIMER_DO__
  call timer_end(898)
#endif
#ifdef __TIMER_SUB__
    call timer_end(764)
#endif
end subroutine ex_ggapw91_3D

!===============================================================================

!!===================================================================
!!        modified  by T.Yamasaki  94/11/15
!!
!!        The original is modified and Spin polrarized GGA programs
!!        are added in this subroutine
!!                                                      by K. Kato 1995/1/18 
!!
subroutine cr_ggapw91_3D(nspin,ispin,chgrhr_l,grad_trho,f2or1,exc,dF_drho,nfft_y)
!!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : PAI,DP
  implicit none

  integer,intent(in)        :: nspin,ispin,nfft_y
  real(kind=DP),intent(in)  :: chgrhr_l(1:nfft_y,ispin)
  real(kind=DP),intent(inout) :: grad_trho(1:nfft_y)
  real(kind=DP),intent(in)  :: f2or1(1:nfft_y)  
  real(kind=DP),intent(inout) :: exc
  real(kind=DP),intent(inout) :: dF_drho(1:nfft_y,nspin)

  real(kind=DP), parameter :: zeta_minimum    = 1.d-4
  real(kind=DP), parameter :: zeta_minimum2   = 1.d-6
  real(kind=DP), parameter :: density_minimum = 1.d-20
  real(kind=DP), parameter :: density_minimum2= 1.d-5

  real(kind=DP), parameter :: a  = 0.0310907d0,     a1   = 0.21370d0
  real(kind=DP), parameter :: b1 = 7.5957d0,        b2n  = 3.5876d0
  real(kind=DP), parameter :: b3 = 1.6382d0,        b4   = 0.49294d0
  real(kind=DP), parameter :: p  = 1.00d0,          p1   = p+1.d0
  real(kind=DP), parameter :: ap  = 0.015545d0,     a1p  = 0.20548d0
  real(kind=DP), parameter :: b1p = 14.1189d0,      b2np = 6.1977d0
  real(kind=DP), parameter :: b3p = 3.3662d0,       b4p = 0.62517d0
! vwn 95/12/2 Y.M
  real(kind=DP), parameter :: aq  = 0.016887d0,     a1q = 0.11125d0
  real(kind=DP), parameter :: b1q = 10.3570d0,      b2nq = 3.6231d0
  real(kind=DP), parameter :: b3q = 0.88026d0,      b4q = 0.49671d0
! vwn 95/12/2 Y.M

  real(kind=DP), parameter :: xnu = 15.75592d0,     cc0 =  0.004235d0
  real(kind=DP), parameter :: cx  = -0.001667212d0, alf =  0.09d0
  real(kind=DP), parameter :: c1  =  0.002568d0,    c2  =  0.023266d0
  real(kind=DP), parameter :: c3  =  7.389d-6,      c4  =  8.723d0
  real(kind=DP), parameter :: c5  =  0.472d0,       c6  =  7.389d-2
  real(kind=DP), parameter :: a4  = 100.d0

  real(kind=DP), parameter :: thrd   = 0.333333333333d0
  real(kind=DP), parameter :: sixth7 = 1.1666666666666666d0

  integer       :: is,i
  real(kind=DP) :: facw,bet,delt,exc1,g,g3,g4,facpon,d,dd,rs,fk,sk,t,s&
       & , q0,rs12,rs32,rsp,q1,q2,eu,q3,eurs,ecd,pon,b,b2,t2,s2,t4,t6 &
       & , rs2,rs3,q4,q5,q6,q7,cc,r0,r1,coeff,r2,r3,a4ms,h0,h1,h,q8 &
       & , h0t,h0b,h0rs,h1t,ccrs,r1rs,h1rs,ht,hrs &
       & , ec1,ec1d,ec1dd,exc0,excd,excdd &
       & , thrd2,thrd4,zeta,q0p,q1p,q2p,q3p,q0q,q1q,q2q,q3q,fzd,fzdd,fz&
       & , euzt,zetadxd,bzt,h0zt,h1zt,gzt &
       & , onpzeta, onmzeta, onzt4 

#ifdef __TIMER_SUB__
    call timer_sta(765)
#endif
  facw = ispin
  bet = xnu*cc0
  delt = 2.d0*alf/bet

!---- Spin dependency

#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
#ifdef __TIMER_DO__
  call timer_sta(899)
#endif
  do is=1, ispin
     exc1 = 0.d0
     if ( ispin == 1 ) then
        g = 1.d0
        g3  = g**3
        g4  = g3*g
        facpon = -delt/(g3*bet)

#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
        do i = 1, nfft_y  ! MPI
           d = facw*chgrhr_l(i, 1)
           if(d < 1.d-20) cycle
! gradient of charge density 95/12/3 H.S.
           dd =facw* grad_trho(i)
           rs = (0.75/(PAI*d))**thrd
           fk = (3*PAI*PAI*d)**thrd
           sk = dsqrt(4*fk/PAI)
           if(d > 1.d-05) then
              t = dd/(d*sk*2)
              s = dd/(d*fk*2)
           else
              t = 0.d0
              s = 0.d0
           endif

           q0 = -2*a*(1+a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2.d0*a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log(1 + 1/q1)
           eu = q0*q2
           q3 = a*(b1/rs12+2*b2n+3*b3*rs12+2*b4*p1*rsp)
           eurs = -2*a*a1*q2 - q0*q3/(q1**2 + q1)
           ecd = eu-thrd*rs*eurs
           pon = facpon*eu
           b   = delt/(dexp(pon)-1.d0)
           b2  = b*b
           t2  = t*t
           s2  = s*s
           t4  = t2*t2
           t6  = t4*t2
           rs2 = rs*rs
           rs3 = rs2*rs
           q4  = 1.d0+b*t2
           q5  = 1.d0+b*t2+b2*t4
           q6  = c1+c2*rs+c3*rs2
           q7  = 1.d0+c4*rs+c5*rs2+c6*rs3
           cc  = -cx + q6/q7
           r0  = (sk/fk)**2
           r1  = a4*r0*g4
           coeff = cc-cc0-3*cx/7
           r2  = xnu*coeff*g3
           a4ms = -a4*g4*s2
           r3  = dexp(a4ms)
           h0  = g3*(bet/delt)*dlog(1+delt*q4*t2/q5)
           h1  = r3*r2*t2
           h   = h0+h1
!======================================================
           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2.d0*bet*t*(1.d0+2.d0*b*t2)/q8 * g3
           h0b = -bet*t6*(2.d0*b+b2*t2)/q8 * g3
           h0rs = h0b*b*eurs*(b+delt)/ bet / g3
           h1t  = 2.d0*r3*r2*t*(1.d0-r1*t2)
           ccrs = (c2+2*c3*rs)/q7-q6*(c4+2*c5*rs+3*c6*rs2)/q7**2
           r1rs = 100*r0/rs
           h1rs = xnu*t2*r3*(ccrs - coeff*t2*r1rs) * g3
           ht   = h0t+h1t
           hrs  = h0rs + h1rs
           ec1  = d*h/facw
           ec1d = h-thrd*rs*hrs-sixth7*t*ht
           ec1dd = 0.5*ht/sk

!---------------------------------------------------
           exc0 = eu*d/facw + ec1
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(dabs(grad_trho(i)) > 1.0d-9) then
              grad_trho(i) = excdd / grad_trho(i)
           else
              grad_trho(i) = 0.d0
           endif
!!$           exec1 = eu*d/facw
           exc1 = exc1 + exc0*f2or1(i)
        end do
     else if ( ispin  == 2 ) then
        thrd2 = thrd * 2.0d0
        thrd4 = thrd * 4.0d0
        fzdd = 8/(9*(2**thrd4-2))

        do i = 1, nfft_y      ! MPI
           d = chgrhr_l(i, 1) + chgrhr_l(i, ispin)
           if(d.lt.1.d-20) cycle
           zeta = ( chgrhr_l(i, 1) - chgrhr_l(i, ispin) ) / d
           onpzeta = 2*chgrhr_l(i,1)     / d
           onmzeta = 2*chgrhr_l(i,ispin) / d
           g  = ( onpzeta**thrd2 + onmzeta**thrd2) * 0.5
!!$           g  = ( (1+zeta)**thrd2 + (1-zeta)**thrd2 ) * 0.5
           if(dabs(zeta) < zeta_minimum) then
              fz = 4.d0/9 * zeta*zeta*(1 + 5.d0/54 * zeta*zeta&
                   &                 *(1 +44.d0/133* zeta*zeta ))&
                   &    /(2**thrd4-2)
           else
              fz = ( (1+zeta)**thrd4+(1-zeta)**thrd4-2)/(2**thrd4-2)
           end if
           g3  = g**3
           g4  = g3*g
           facpon = -delt/(g3*bet)
           if(d < density_minimum) cycle
! gradient of charge density 95/12/3 H.S.
           dd = grad_trho(i)
!!$c        dd = grad_rho(i, 1) + grad_rho(i, 2)
! gradient of charge density 95/12/3 H.S.
           rs = (0.75d0/(PAI*d))**thrd
           fk = (3*PAI*PAI*d)**thrd
           sk = dsqrt(4*fk/PAI)

           if(d > density_minimum2) then
              t = dd/(d*sk*2.d0)
              s = dd/(d*fk*2.d0)
           else
              t = 0.d0
              s = 0.d0
           endif

           q0 = -2*a*(1+a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2*a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log(1+1/q1)
           q3 = a*(b1/rs12+2*b2n+3*b3*rs12+2*b4*p1*rsp)

           q0p = -2*ap*(1+a1p*rs)
           q1p =  2*ap*(b1p*rs12+b2np*rs+b3p*rs32+b4p*rs*rsp)
           q2p = log(1+1/q1p)
           q3p = ap*(b1p/rs12+2*b2np+3*b3p*rs12+2*b4p*p1*rsp)
! vwn 95/12/2 Y.M
           q0q = -2*aq*(1+a1q*rs)
           q1q =  2*aq*(b1q*rs12+b2nq*rs+b3q*rs32+b4q*rs*rsp)
           q2q = log(1+1/q1q)
           q3q = aq*(b1q/rs12+2*b2nq+3*b3q*rs12+2*b4q*p1*rsp)
           if(dabs(zeta) < zeta_minimum) then
              fzd = 8/(9*(2**thrd4 - 2 )) &
                   &     *zeta *( 1 + 5.d0/27.d0 *zeta*zeta &
                   &           *( 1 +22.d0/45.d0 *zeta*zeta ))
           else
              fzd = (4.d0/3)/(2**thrd4-2)*(onpzeta**thrd-onmzeta**thrd )
           end if
           onzt4 = onmzeta*onpzeta * (1 + zeta*zeta)
           eu = q0*q2 + ( q0p * q2p - q0 * q2 ) * fz * zeta**4 &
                &        -   q0q * q2q * fz / fzdd * onzt4
           eurs = (-2*a*a1*q2 - q0*q3/(q1**2+q1)) * (1-fz*zeta**4) &
                &+(-2*ap*a1p*q2p-q0p*q3p/(q1p**2+q1p))*fz*zeta**4 &
                &-(-2*aq*a1q*q2q-q0q*q3q/(q1q**2+q1q))*fz/fzdd*onzt4
           euzt = -q0q*q2q/fzdd*(fzd*(1-zeta**4)-4*fz*zeta**3) &
                &+(q0p*q2p-q0*q2)*(fzd*zeta +4*fz )*zeta**3
! vwn 95/12/2 Y.M
           zetadxd = - 2 * chgrhr_l(i, 3-is) * (-1.d0)**is / d
           ecd = eu - thrd*rs*eurs + euzt * zetadxd

           if(onpzeta < zeta_minimum2 .or. onmzeta < zeta_minimum2) then
              ec1 = 0.d0; ec1d = 0.d0; ec1dd= 0.d0
              goto 10
           end if
           pon = facpon*eu
           b   = delt/(dexp(pon)-1.d0)
           b2  = b*b
           t2  = t*t
           s2  = s*s
           t4  = t2*t2
           t6  = t4*t2
           rs2 = rs*rs
           rs3 = rs2*rs
           q4  = 1.d0+b*t2
           q5  = 1.d0+b*t2+b2*t4
           q6  = c1+c2*rs+c3*rs2
           q7  = 1.d0+c4*rs+c5*rs2+c6*rs3
           cc  = -cx + q6/q7
           r0  = (sk/fk)**2
           r1  = a4*r0*g4
           coeff = cc-cc0-3.d0*cx/7.d0
           r2  = xnu*coeff*g3
           a4ms = -a4*g4*s2
           r3  = dexp(a4ms)
           h0  = g3*(bet/delt)*dlog(1.d0+delt*q4*t2/q5)
           h1  = r3*r2*t2
           h   = h0+h1

           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2*bet*t*(1+2*b*t2)/q8 * g3
           h0b = -bet*t6*(2*b+b2*t2)/q8 * g3
           h0rs = h0b * b2 * eurs / bet / g3
           h1t  = 2*r3*r2*t*(1.d0-r1*t2)
           ccrs = (c2+2*c3*rs)/q7-q6*(c4+2*c5*rs+3*c6*rs2)/q7**2
           r1rs = 100*r0/rs
           h1rs = xnu*t2*r3*(ccrs - coeff*t2*r1rs) * g3
           ht   = h0t+h1t
           hrs  = h0rs + h1rs

           if(dabs(zeta) < zeta_minimum) then
              gzt = -2.d0/9*zeta *( 1+14.d0/27 *zeta*zeta &
                   &             *( 1+13.d0/18 *zeta*zeta ))
           else
              gzt = ( 1.d0/onpzeta**thrd -1.d0/onmzeta**thrd )/3.d0
           end if
           bzt = pon*b**2 * (euzt-3*eu*gzt/g) / ( bet * g3 ) 
           h0zt = 3*gzt*h0/g + h0b*bzt
           h1zt =(3*gzt + 4*gzt*a4ms ) * h1 / g
           
           ec1  = d*h * 0.5
           ec1d = h-thrd*rs*hrs-sixth7*t*ht + (h0zt+h1zt) * zetadxd
           ec1dd = 0.5*ht/sk

10         continue
           exc0 = eu*d * 0.5 + ec1
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(is == 2) then
              if(dabs(grad_trho(i)) > 1.0d-9) then
                 grad_trho(i) = excdd / grad_trho(i)
              else
                 grad_trho(i) = 0.d0
              endif
           endif
! gradient of charge density 95/12/3 H.S.
!!$           exec1 = eu*d * 0.5d0
           exc1 = exc1 + exc0*f2or1(i)
        end do
     end if
     exc = exc + exc1
  end do
#ifdef __TIMER_DO__
  call timer_end(899)
#endif
#ifdef __TIMER_SUB__
    call timer_end(765)
#endif
end subroutine cr_ggapw91_3D

!===============================================================================

!!$====================================================================
!!$        modified  by T.Yamasaki  94/11/14
!!$
!!$        Modified for Spin polrarized GGA by K. Kato 1995/1/18 
!!$
!!$        Modified to Perdew-Burke-Ernzerhof(PBE) GGA by K. Kato 1999/4/1 
!!$
subroutine ex_ggapbe_3D(nspin,ispin,chgrhr_l,grad_rho,f2or1,exc,dFx_drho,dFx_dgradrho,nfft_y,iteration,revPBE)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : DP,PAI
  implicit none

  integer,intent(in)        :: nspin,ispin,nfft_y,iteration
  real(kind=DP),intent(in)  :: chgrhr_l(1:nfft_y,ispin)
  real(kind=DP),intent(in)  :: grad_rho(1:nfft_y,nspin)
  real(kind=DP),intent(in)  :: f2or1(1:nfft_y)  
  real(kind=DP),intent(out) :: exc
  real(kind=DP),intent(out) :: dFx_drho(1:nfft_y,nspin)
  real(kind=DP),intent(out) :: dFx_dgradrho(1:nfft_y,nspin)
  logical, intent(in),optional :: revPBE

#ifndef PREV_EX_GGAPBE
  real(kind=DP), parameter :: ax = -0.7385587663820224d0 !! ax = -(3/4)*(3/PI)^(1/3)
#else
  real(kind=DP), parameter :: ax = -0.7385588d0
#endif
  real(kind=DP), parameter :: thrd = 0.33333333333d0, thrd4 = 1.333333333333333d0
  real(kind=DP), parameter :: thpith = 3.0936677262801d0
#ifndef PREV_EX_GGAPBE
!  real(kind=DP), parameter :: cupa = 0.8040d0, yum = 0.2195149727645171d0
  real(kind=DP), parameter :: yum = 0.2195149727645171d0
#else
  real(kind=DP), parameter :: yum = 0.21951
#endif
  real(kind=DP) :: cupa
  real(kind=DP) :: facw,d,dd,fk,s,fac,s2,yums2,f,ex,fs,exd,exdd,exc0,excd,excdd,exc1
  real(kind=DP) :: tmp
  integer       :: is,i
  logical       :: repbe

!---- Spin dependency
  repbe = .false.
  if(present(revPBE)) repbe = revPBE
  cupa = 0.8040d0
  if(repbe) cupa = 1.245d0

#ifdef __TIMER_SUB__
    call timer_sta(766)
#endif
  facw = ispin
  exc  = 0.d0
#ifdef __TIMER_DO__
  call timer_sta(900)
#endif
  do is = 1, ispin
     exc1 = 0.d0
     do i = 1, nfft_y
        d  = facw * chgrhr_l(i, is)
        dd = facw * grad_rho(i, is)
        fk = (3*PAI*PAI*d)**thrd
        if(d > 1.d-05) then
           s = dd/(d*fk*2)
        else
           s = 0.d0
        endif
!-------------------------------------
!       fac = ax*d**thrd
        tmp = d**thrd
        fac = ax*tmp
        s2  = s*s
        yums2 = yum * s2
        f = 1 + cupa * yums2 / ( cupa + yums2 )
        ex  = fac*f*d
        fs = 2 * cupa ** 2 * yum * s / ( cupa + yums2 ) ** 2
        exd = thrd4*fac*(f-s*fs)
        exdd = ax*fs*0.5d0/thpith
!------------------------------------------     
        exc0 = ex / facw
        excd = exd
        dFx_drho(i, is) = excd 
        excdd = exdd
! gradient of charge density 95/12/3 H.S.
        if(dabs(grad_rho(i, is)) > 1.d-9) then
           dFx_dgradrho(i, is) = excdd / grad_rho(i, is)
        else
           dFx_dgradrho(i, is) = 0.d0
        endif
! gradient of charge density 95/12/3 H.S.
        exc1 = exc1 + exc0*f2or1(i)
     end do
     exc = exc + exc1
  end do
#ifdef __TIMER_DO__
  call timer_end(900)
#endif
#ifdef __TIMER_SUB__
    call timer_end(766)
#endif
end subroutine ex_ggapbe_3D

!===============================================================================

!!$===================================================================
!!$        modified  by T.Yamasaki  94/11/15
!!$
!!$        The original is modified and Spin polrarized GGA programs
!!$        are added in this subroutine
!!$                                                      by K. Kato 1995/1/18 
!!$
!!$        Modified to Perdew-Burke-Ernzerhof(PBE) GGA by K. Kato 1999/4/1 
!!$
subroutine cr_ggapbe_3D(nspin,ispin,chgrhr_l,grad_trho,f2or1,exc,dF_drho,nfft_y)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : PAI,DP
  implicit none

  integer,intent(in)        :: nspin,ispin,nfft_y
  real(kind=DP),intent(in)  :: chgrhr_l(1:nfft_y,ispin)
  real(kind=DP),intent(inout) :: grad_trho(1:nfft_y)
  real(kind=DP),intent(in)  :: f2or1(1:nfft_y)  
  real(kind=DP),intent(inout) :: exc
  real(kind=DP),intent(inout) :: dF_drho(1:nfft_y,nspin)

  real(kind=DP), parameter :: zeta_minimum    = 1.d-4
  real(kind=DP), parameter :: zeta_minimum2   = 1.d-6
  real(kind=DP), parameter :: density_minimum = 1.d-20
  real(kind=DP), parameter :: density_minimum2= 1.d-5

  real(kind=DP), parameter  :: a  = 0.0310907d0,    a1   = 0.21370d0
  real(kind=DP), parameter  :: b1 = 7.5957d0,       b2n  = 3.5876d0
  real(kind=DP), parameter  :: b3 = 1.6382d0,       b4   = 0.49294d0
  real(kind=DP), parameter  :: p  = 1.00d0,         p1   = p+1.d0
#ifndef PREV_CR_GGAPBE
  real(kind=DP), parameter  :: ap  = 0.01554535d0,    a1p  = 0.20548d0
#else
  real(kind=DP), parameter  :: ap  = 0.015545d0,    a1p  = 0.20548d0
#endif
  real(kind=DP), parameter  :: b1p = 14.1189d0,     b2np = 6.1977d0
  real(kind=DP), parameter  :: b3p = 3.3662d0,      b4p  = 0.62517d0
! vwn 95/12/2 Y.M
#ifndef PREV_CR_GGAPBE
  real(kind=DP), parameter  :: aq  = 0.0168869d0,    a1q  = 0.11125d0
#else
  real(kind=DP), parameter  :: aq  = 0.016887d0,    a1q  = 0.11125d0
#endif
  real(kind=DP), parameter  :: b1q = 10.3570d0,     b2nq = 3.6231d0
  real(kind=DP), parameter  :: b3q = 0.88026d0,     b4q  = 0.49671d0
! vwn 95/12/2 Y.M
#ifndef PREV_CR_GGAPBE
  real(kind=DP), parameter  :: gamma = 0.03109069086965489503494086371273d0
#else
  real(kind=DP), parameter  :: gamma = 0.031091
#endif
!--------------------------
#ifndef PREV_CR_GGAPBE
  real(kind=DP), parameter  :: bet=0.06672455060314922d0
  real(kind=DP), parameter  :: delt=bet/gamma
#else
  real(kind=DP), parameter  :: xnu = 15.75592d0, cc0 = 0.004235d0
#endif
  real(kind=DP), parameter  :: thrd = 0.333333333333d0, sixth7 = 1.1666666666666666d0

#ifndef PREV_CR_GGAPBE
!Fix! T.Yamatomto 2011/06/29
  real(kind=DP), parameter  :: eta = 1.d-12
  real(kind=DP), parameter  :: sixthm = -0.16666666666666d0
!Fix! T.Yamatomto 2011/06/29
#endif

  integer       :: is,i
#ifndef PREV_CR_GGAPBE
  real(kind=DP) :: facw,exc1,g,g3,facpon,d,dd,rs,fk,sk,t,q0 &
#else
  real(kind=DP) :: facw,bet,delt,exc1,g,g3,facpon,d,dd,rs,fk,sk,t,q0 &
#endif
       &         , rs12,rs32,rsp,q1,q2,eu,q3,eurs,ecd,pon &
       &         , b,b2,t2,t4,t6,q4,q5,h0,h,q8,h0t,h0b,h0rs,ht,hrs &
       &         , ec1,ec1d,ec1dd,exc0,excd,excdd &
       &         , thrd2,thrd4,fzdd,zeta,onpzeta,onmzeta,fz,zetadxd &
       &         , q0p,q1p,q2p,q3p,q0q,q1q,q2q,q3q,fzd,onzt4,gzt,bzt,h0zt,euzt

#ifdef __TIMER_SUB__
    call timer_sta(767)
#endif
  facw = ispin
#ifdef PREV_CR_GGAPBE
  bet = xnu*cc0
  delt = bet / gamma
#endif
!---- Spin dependency
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
#ifdef __TIMER_DO__
  call timer_sta(1001)
#endif
  do is = 1, ispin
     exc1 = 0.d0
     if ( ispin == 1 ) then
        g   = 1.d0
        g3  = g**3
        facpon = -delt/(g3*bet)

        do i = 1,nfft_y ! MPI
           d  = facw*chgrhr_l(i, 1)
           if(d < density_minimum) cycle
! gradient of charge density 95/12/3 H.S.
           dd = facw* grad_trho(i)
#ifndef PREV_CR_GGAPBE
           rs = (0.75d0/(PAI*d))**thrd
#else
           rs = (0.75/(PAI*d))**thrd
#endif
           fk = (3*PAI*PAI*d)**thrd
           sk = dsqrt(4*fk/PAI)
           if(d > density_minimum2) then
              t = dd/(d*sk*2)
           else
              t = 0.d0
           endif

           q0 = -2*a*(1 + a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2*a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log(1 + 1.d0/q1)
           eu = q0*q2
           q3 = a*(b1/rs12+2*b2n+3*b3*rs12+2*b4*p1*rsp)
           eurs = -2*a*a1*q2 - q0*q3/(q1**2 + q1)
           ecd = eu-thrd*rs*eurs
           pon = facpon*eu
           b   = delt/(dexp(pon)-1)
           b2  = b*b
           t2  = t*t
           t4  = t2*t2
           t6  = t4*t2
           q4  = 1 + b*t2
           q5  = 1 + b*t2+b2*t4
           h0  = g3*(bet/delt)*dlog(1+delt*q4*t2/q5)
           h   = h0
           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2*bet*t*(1+2*b*t2)/q8 * g3
           h0b = -bet*t6*(2*b+b2*t2)/q8 * g3
           h0rs = h0b*b*eurs*(b+delt)/ bet / g3
           ht   = h0t
           hrs  = h0rs
           ec1  = d*h/facw
           ec1d = h-thrd*rs*hrs-sixth7*t*ht
#ifndef PREV_CR_GGAPBE
           ec1dd = 0.5d0*ht/sk
#else
           ec1dd = 0.5*ht/sk
#endif
           exc0 = eu*d/facw + ec1
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(dabs(grad_trho(i)) > 1.0d-9) then
              grad_trho(i) = excdd / grad_trho(i)
           else
              grad_trho(i) = 0.d0
           endif
! gradient of charge density 95/12/3 H.S.
           exc1 = exc1 + exc0*f2or1(i)
        end do
     else if ( ispin ==  2 ) then
        thrd2 = thrd * 2
        thrd4 = thrd * 4
        fzdd = 8/(9*(2**thrd4 - 2 ))

        do i = 1,nfft_y
           d = chgrhr_l(i, 1) + chgrhr_l(i, ispin)
           if(d < density_minimum ) cycle
           zeta = ( chgrhr_l(i, 1) - chgrhr_l(i, 2) ) / d
           onpzeta = 2*chgrhr_l(i, 1) / d
           onmzeta = 2*chgrhr_l(i, 2) / d
           g = ( onpzeta**thrd2 + onmzeta**thrd2 )/2
           if(dabs(zeta) < zeta_minimum ) then
              fz= 4.d0/9 *zeta*zeta*(1 + 5.d0/54 *zeta*zeta &
                   &               *(1 +44.d0/135*zeta*zeta )) &
                   &       /(2**thrd4 -2)
           else
              fz = (onpzeta**thrd4 + onmzeta**thrd4 -2) / (2**thrd4 - 2)
           end if
           g3  = g**3
           facpon = -delt/(g3*bet)
           if(d < density_minimum) cycle
           dd = grad_trho(i)
           rs = (0.75d0/(PAI*d))**thrd
           fk = (3*PAI*PAI*d)**thrd
           sk = dsqrt(4*fk/PAI)

           if(d > density_minimum2) then
#ifndef PREV_CR_GGAPBE
              t = dd/(d*sk*2*g)
#else
              t = dd/(d*sk*2)
#endif
           else
              t = 0.d0
           endif

           q0 = -2*a*(1+a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2*a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log(1+1/q1)
           q3 = a*(b1/rs12+2*b2n+3*b3*rs12+2*b4*p1*rsp)

           q0p = -2*ap*(1+a1p*rs)
           q1p = 2*ap*(b1p*rs12+b2np*rs+b3p*rs32+b4p*rs*rsp)
           q2p = log(1+1/q1p)
           q3p = ap*(b1p/rs12+2*b2np+3*b3p*rs12+2*b4p*p1*rsp)
! vwn 95/12/2 Y.M
           q0q = -2*aq*(1+a1q*rs)
           q1q =  2*aq*(b1q*rs12+b2nq*rs+b3q*rs32+b4q*rs*rsp)
           q2q = log(1+1/q1q)
           q3q = aq*(b1q/rs12+2*b2nq+3*b3q*rs12+2*b4q*p1*rsp)
           if(dabs(zeta) < zeta_minimum) then
              fzd = 8.d0/9.d0 /( 2.d0**thrd4 -2 ) &
                   &     *zeta *( 1 + 5.d0/27 *zeta*zeta &
                   &           *( 1 +22.d0/45 *zeta*zeta ))
           else
              fzd = 4.d0/3.d0 /( 2.d0**thrd4 -2) &
                   &     *( onpzeta**thrd -onmzeta**thrd )
           end if
           onzt4= onmzeta*onpzeta *( 1 + zeta*zeta )
           eu = q0*q2 + ( q0p * q2p - q0 * q2 ) * fz * zeta**4 &
                &             -   q0q * q2q * fz / fzdd * onzt4
           eurs = ( -2*a*a1*q2 -q0*q3/(q1**2 +q1 )) * ( 1 -fz*zeta**4 )&
                &+( -2*ap*a1p*q2p -q0p*q3p/( q1p**2 +q1p )) *fz*zeta**4 &
                &-( -2*aq*a1q*q2q -q0q*q3q/( q1q**2 +q1q )) *fz/fzdd*onzt4
           euzt =  -q0q*q2q /fzdd *( fzd*onzt4 -4*fz*zeta**3 )&
                &        +( q0p*q2p -q0*q2 )*(fzd*zeta +4*fz )*zeta**3 
! vwn 95/12/2 Y.M

           zetadxd = - 2 * chgrhr_l(i, 3-is) * (-1.d0)**is / d
           ecd = eu-thrd*rs*eurs + euzt * zetadxd 

           if(onpzeta < zeta_minimum2 .or. onmzeta < zeta_minimum2) then
              ec1  = 0.d0;    ec1d = 0.d0;     ec1dd= 0.d0
              go to 10
           end if
           pon = facpon*eu
           b   = delt/(dexp(pon)-1)
           b2  = b*b
           t2  = t*t
           t4  = t2*t2
           t6  = t4*t2
           q4  = 1+b*t2
           q5  = 1+b*t2+b2*t4
           h0  = g3*(bet/delt)*dlog(1+delt*q4*t2/q5)
           h   = h0

           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2*bet*t*(1+2*b*t2)/q8 * g3
           h0b = -bet*t6*(2*b+b2*t2)/q8 * g3
           h0rs = h0b * b * eurs * (b+delt) / bet / g3
           ht   = h0t
           hrs  = h0rs

           if(dabs(zeta) < zeta_minimum) then
              gzt = -2.d0/9*zeta *( 1 +14.d0/27 *zeta*zeta &
                   &             *( 1 +13.d0/18 *zeta*zeta ))
           else
#ifndef PREV_CR_GGAPBE
              gzt = ( (onpzeta**2+eta)**sixthm - (onmzeta**2+eta)**sixthm)/3.d0
#else              
              gzt = ( 1.d0/onpzeta**thrd -1.d0/onmzeta**thrd )/3.d0
#endif
           end if
           bzt = b * ( b+delt) * ( euzt - 3*eu*gzt/g ) / ( bet * g3 ) 
           h0zt = 3 * gzt * h0 / g + h0b * bzt

#ifndef PREV_CR_GGAPBE
           ec1  = d*h * 0.5d0
#else
           ec1  = d*h * 0.5
#endif
! --> revised by Kato-san,  1999Jul16
           ec1d = h-thrd*rs*hrs-sixth7*t*ht  + (h0zt-gzt*t*h0t/g) * zetadxd
           ec1dd = 0.5*ht/sk / g

10         continue
#ifndef PREV_CR_GGAPBE
           exc0 = eu*d * 0.5d0 + ec1
#else
           exc0 = eu*d * 0.5 + ec1
#endif
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(is ==  2) then
              if(dabs(grad_trho(i)) > 1.0d-9) then
                 grad_trho(i) = excdd / grad_trho(i)
              else
                 grad_trho(i) = 0.d0
              endif
           endif
! gradient of charge density 95/12/3 H.S.
           exc1 = exc1 + exc0*f2or1(i)
        end do
     end if
     exc = exc + exc1
  end do
#ifdef __TIMER_DO__
  call timer_end(1001)
#endif
#ifdef __TIMER_SUB__
    call timer_end(767)
#endif
end subroutine cr_ggapbe_3D

!===============================================================================

!!$c===================================================================
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
!!$     1994/11/24 coded by T.Yamasaki
!!$
subroutine xclda_3D(nspin,ispin,chgrhr_l,f2or1,exc,dF_drho,nfft_y)
  use m_Const_Parameters,  only : DP, PAI
  implicit none

  integer, intent(in)       :: nspin,ispin,nfft_y
  real(kind=DP),intent(in)  :: chgrhr_l(1:nfft_y,ispin)
  real(kind=DP),intent(in)  :: f2or1(1:nfft_y)  
  real(kind=DP),intent(out) :: exc
  real(kind=DP),intent(inout) :: dF_drho(1:nfft_y,nspin)

  integer :: is, i
  real(kind=DP) :: co2,d,rs,exclds
  real(kind=DP), parameter :: thrd = 0.333333333333333333d0

#ifdef __TIMER_SUB__
    call timer_sta(768)
#endif
  co2 = (0.75d0/PAI)**thrd
  exc = 0.d0

  is = 1
  if(ispin == 2)  stop '!Sorry, ispin == 2 is not supported now'

#ifdef __TIMER_DO__
  call timer_sta(1002)
#endif
  do i = 1, nfft_y
     d = chgrhr_l(i,is)
     if(d < 1.d-40) then
        dF_drho(i,is) = 0.d0
        cycle
     endif
     rs = co2*(1.d0/d)**thrd
     if(rs >= 1.d0) then
        dF_drho(i,is) = &
             &   (-0.61093d0/rs - (0.1423d0+0.1759d0*dsqrt(rs) &
             &    + 0.06366d0*rs)&
             &   /(1 + 1.0529d0*dsqrt(rs) + 0.3334d0*rs)**2 )
        exclds = -0.61093d0*0.75d0/rs &
             &   -0.1423d0/(1 + 1.0529d0*dsqrt(rs) + 0.3334d0*rs)
     else
        dF_drho(i,is) =  &
             &  ( -0.61093d0/rs - 0.05837d0 - 0.0084d0*rs &
             &   + 0.0311d0*log(rs) + 0.00133d0*rs*dlog(rs) )
        exclds = -0.61093d0*0.75d0/rs &
             &  - 0.048d0 -0.0116*rs &
             &  + 0.0311d0*dlog(rs) + 0.0020d0*rs*dlog(rs)
     end if
     exc = exc + exclds*f2or1(i)*d
  end do
#ifdef __TIMER_DO__
  call timer_end(1002)
#endif
#ifdef __TIMER_SUB__
    call timer_end(768)
#endif
end subroutine xclda_3D

!===============================================================================

!!$c ---------------------------------------
!!$c       1994/11/24 coded by T. Yamasaki
!!$c       1994/12/22 modified by T. Yamasaki
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
subroutine ggabek_3D(nspin,ispin,chgrhr_l,grad_rho,f2or1,exc,dF_drho,dF_dgradrho,nfft_y)
  use m_Const_Parameters,  only : DP
  implicit none

  integer,intent(in)        :: nspin,ispin,nfft_y
  real(kind=DP),intent(in)  :: chgrhr_l(1:nfft_y,ispin)
  real(kind=DP),intent(in)  :: grad_rho(1:nfft_y,nspin)
  real(kind=DP),intent(in)  :: f2or1(1:nfft_y)  
  real(kind=DP),intent(out) :: exc
  real(kind=DP),intent(inout) :: dF_drho(1:nfft_y,nspin)
  real(kind=DP),intent(out) :: dF_dgradrho(1:nfft_y,nspin)

  integer        :: i
  real(kind=DP)  :: fac,tthrd,fac_t,d,dd,dthrd,dthrd4,x,x2,p0,x2ovp0&
       &, y,f,vxc1,exgga

  real(kind=DP), parameter ::    b = 0.0042d0
  real(kind=DP), parameter :: thrd = 0.333333333333333333d0
        
#ifdef __TIMER_SUB__
    call timer_sta(769)
#endif
  fac = 4*thrd * b
  tthrd = 2.d0**thrd
  fac_t  = 1.d0/tthrd
#ifdef __TIMER_DO__
  call timer_sta(1003)
#endif
  do i = 1, nfft_y
     d = chgrhr_l(i,1)
     dd = grad_rho(i,1)
     if(d < 1.d-10 .or. dd > 1.d10) then
        dF_dgradrho(i,1) = 0.d0
        cycle
     endif
     dthrd  = d**thrd
     dthrd4 = dthrd*d
     x = tthrd*dd/dthrd4
     x2 = x*x
     p0 = dsqrt(1+x2)
     x2ovp0 = 6*b*x2/p0
     if(x < 1.d-40) then
        y = 0.d0
     else
        y = dlog(x + p0)
     endif
     f  = 1.d0/(1.d0+6.d0*b*x*y)
     vxc1    = x2*f*f*(1.d0-x2ovp0)
     dF_drho(i,1) = dF_drho(i,1) + fac*dthrd*vxc1*fac_t
     dF_dgradrho(i,1) = fac*dthrd*(vxc1 + x2*f)*fac_t

     exgga  = -b * dthrd4 * x2 * f * fac_t
     exc      = exc      + exgga*f2or1(i)
  end do
#ifdef __TIMER_DO__
  call timer_end(1003)
#endif
#ifdef __TIMER_SUB__
    call timer_end(769)
#endif
end subroutine ggabek_3D

!===============================================================================

!!$c ---------------------------------------
!!$c     1994/11/24 coded by T.Yamasaki
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
subroutine ggaprd_3D(nspin,ispin,chgrhr_l,grad_rho,f2or1,exc,dF_drho,dF_dgradrho,nfft_y)
  use m_Const_Parameters,  only : PAI,DP
  implicit none

  integer,intent(in)         :: nspin,ispin,nfft_y
  real(kind=DP),intent(in)   :: chgrhr_l(1:nfft_y,ispin)
  real(kind=DP),intent(in)   :: grad_rho(1:nfft_y,nspin)
  real(kind=DP),intent(in)   :: f2or1(1:nfft_y)  
  real(kind=DP),intent(out)  :: exc
  real(kind=DP),intent(inout):: dF_drho(1:nfft_y,nspin)
  real(kind=DP),intent(out)  :: dF_dgradrho(1:nfft_y,nspin)

  real(kind=DP) :: cinfin,d,ovd,thrd4,sixth7,co2,dd,rs,dthrd,dthrd4&
       &, x, cdenom,c,phi,expphi,ecgga,dcdrs,dcdrho
  integer       :: i

  real(kind=DP), parameter :: alpha = 0.023266d0
  real(kind=DP), parameter ::  beta = 7.389d-6
  real(kind=DP), parameter :: gamma = 8.723d0
  real(kind=DP), parameter :: delta = 0.472d0
  real(kind=DP), parameter ::fchird = 0.11
  real(kind=DP), parameter :: thrd  = 0.333333333333333333d0
  real(kind=DP), parameter :: c0    = 0.001667d0
  real(kind=DP), parameter :: c1    = 0.002568d0

#ifdef __TIMER_SUB__
    call timer_sta(770)
#endif
  cinfin = c0 + c1
  d = 1.d0
  ovd = 1.d0/d
  thrd4 = 4*thrd
  sixth7 = 7.d0/6.d0

  co2 = (0.75d0/PAI)**thrd
#ifdef __TIMER_DO__
  call timer_sta(1004)
#endif
  do i = 1, nfft_y          ! MPI
     d = chgrhr_l(i,1)
     dd = grad_rho(i,1)
     if(d < 1.d-40) cycle
     rs = co2*(1.d0/d)**thrd
     dthrd  = d**thrd
     dthrd4 = dthrd*d
     x = dd/dthrd4
     cdenom = 1.d0/(1 + rs*(gamma + rs*(delta + 1.d+4*beta*rs)))
     c = c0 + (c1 + rs*(alpha + beta*rs))*cdenom
     phi = 1.745d0 * fchird * cinfin/c * x *dsqrt(dthrd)
     expphi = dexp(-phi)
     ecgga = ovd*expphi*c*dd*x

     dcdrs = cdenom * ((alpha + 2*beta*rs) &
          &         - cdenom * (c1+rs*(alpha+beta*rs)) &
          &       * (gamma+rs*(2*delta + 3.d+4*beta*rs)))
     dcdrho = -thrd*(rs/d)*dcdrs
     dF_drho(i,1) = dF_drho(i,1) + ovd*(dcdrho*(phi+1) &
          &       +(sixth7*phi - thrd4)*c)*expphi*x*dd
     dF_dgradrho(i,1) = dF_dgradrho(i,1) + ovd*expphi*c*x*(2 - phi)

     exc = exc + ecgga*f2or1(i)
  end do
#ifdef __TIMER_DO__
  call timer_end(1004)
#endif
#ifdef __TIMER_SUB__
    call timer_end(770)
#endif
end subroutine ggaprd_3D

!===============================================================================

subroutine xcpotf_wigner_3D(nspin,ispin,input_charge,DELTA,chgrhr_l,f2or1,exc,nfft_y)
!*****<<< WIGNER INTERPOLATION >>>
  use m_Const_Parameters,  only : DP,UP,DOWN,PAI,Valence_plus_PC_Charge
  implicit none

  integer,intent(in)         :: nspin,ispin,input_charge,nfft_y
  real(kind=DP),intent(in)   :: DELTA
  real(kind=DP),intent(inout):: chgrhr_l(1:nfft_y,ispin)
  real(kind=DP),intent(in)   :: f2or1(1:nfft_y)  
  real(kind=DP),intent(inout):: exc

  real(kind=DP) :: rho,rs,zeta,vxc,tmp,WX0,CO2
  integer       :: i, icount
  real(kind=DP), parameter :: C13 = 1.d0/3.d0
  real(kind=DP), parameter :: CO3 = 4.d0/3.d0

#ifdef __TIMER_SUB__
    call timer_sta(778)
#endif
  CO2 = (0.75d0/PAI)**C13
  WX0 =  3*(((9*PAI)/4)**C13)/(2*PAI)

  if(ispin == 2 .and. input_charge == Valence_plus_PC_Charge) then
     icount = 0
#ifdef __TIMER_DO__
  call timer_sta(1013)
#endif
     do i = 1, nfft_y
        rho    = chgrhr_l(i,UP) + chgrhr_l(i,DOWN)
        rs     = CO2*( 1.0d0/rho  )**C13
        if(rho < DELTA) cycle
        zeta = (chgrhr_l(i,UP) - chgrhr_l(i,DOWN))/rho
        if(dabs(zeta) > DELTA) icount = icount + 1
        tmp    = - WX0/2.d0*CO3/RS -(0.440d0*CO3*RS + 3.432d0)/(RS+7.8D0)**2
        chgrhr_l(i,UP  ) = tmp
        chgrhr_l(i,DOWN) = tmp
        vxc    = -(WX0/2.d0/RS+0.44d0/(RS+7.8d0))
        exc    = exc + vxc*rho*f2or1(i)
     end do
#ifdef __TIMER_DO__
  call timer_end(1013)
#endif
     if(icount >= 1) then
        write(6,*)' WIGNER XC-ENERGY and POTENTIAL are not' &
             &         , ' appropriate for Spin-Polarized calculation'
        stop 'WIGNER'
     endif
  else
#ifdef __TIMER_DO__
  call timer_sta(1014)
#endif
     do i = 1, nfft_y
        rho    = chgrhr_l(i,1)
        rs     = CO2*( 1.0d0/rho  )**C13
        chgrhr_l(i,1)   = - WX0/2.d0*CO3/rs &
             &           -(0.440d0*CO3*rs + 3.432d0)/(rs+7.8d0)**2
        vxc    = -(WX0/2.d0/rs+0.44d0/(rs+7.8d0))
        exc    = exc + vxc*rho*f2or1(i)
     end do
#ifdef __TIMER_DO__
  call timer_end(1014)
#endif
  endif
#ifdef __TIMER_SUB__
    call timer_end(778)
#endif
end subroutine xcpotf_wigner_3D

!===============================================================================

subroutine xcpotf_pzold_3D(nspin,ispin,input_charge,DELTA,chgrhr_l,f2or1,exc,nfft_y)
  use m_Const_Parameters,  only : DP,UP,DOWN,PAI,Valence_plus_PC_Charge
  implicit none

  integer,intent(in)         :: nspin,ispin,input_charge,nfft_y
  real(kind=DP),intent(in)   :: DELTA
  real(kind=DP),intent(inout):: chgrhr_l(1:nfft_y,ispin)
  real(kind=DP),intent(in)   :: f2or1(1:nfft_y)  
  real(kind=DP),intent(inout):: exc

  real(kind=DP) :: B1P01,B1P02,CP00,CP01,CP02,OVC213,OVC243 &
       &         , B1F01,B1F02,CF00,CF01,CF02
  real(kind=DP) :: rho,ovn,rs,denmp,denmf,wcp,wcf,vcp,vcf,zeta,f00,f2up,f2down &
       &         , t1,wxp,wxf,vxp,x,t2,vxc
  integer       :: i

  real(kind=DP), parameter   :: C13   =  1.d0/3.d0
  real(kind=DP), parameter   :: C43   =  4.d0/3.d0
  real(kind=DP) :: CO2, WX0, C213

  real(kind=DP), parameter :: GAMP   = -0.1423d0, GAMF   = -0.0843d0 &
       &                    , BETA1P =  1.0529d0, BETA2P =  0.3334d0 &
       &                    , BETA1F =  1.3981d0, BETA2F =  0.2611d0 &
       &                    , AP     =  0.0311d0, BP     = -0.0480d0 &
       &                    , AF     =  0.01555d0,BF     = -0.0269d0 &
       &                    , CP     =  0.0020d0, DPx    = -0.0116d0 &
       &                    , CF     =  0.00070d0,DF     = -0.0048d0

#ifdef __TIMER_SUB__
    call timer_sta(779)
#endif
  CO2   = (0.75d0/PAI)**C13
  WX0   =  3*(((9*PAI)/4)**C13)/(2*PAI)
  C213  = 2.d0**C13

  B1P01 = 7.d0*BETA1P/6.d0
  B1P02 = 4.d0*BETA2P/3.d0

  CP00 = BP - AP/3.d0
  CP01 = (2*DPx - CP)/3.d0
  CP02 = 2*CP/3.d0

#ifdef __TIMER_DO__
  call timer_sta(1015)
#endif
  if(ispin == 2 .and. input_charge == Valence_plus_PC_Charge) then
     OVC213 = 1.D0/(C213 - 1)
     OVC243 = 1.D0/(2.D0**C43 - 2)

     B1F01 = 7.D0*BETA1F/6.D0
     B1F02 = 4.D0*BETA2F/3.D0
     CF00 = BF - AF/3.D0
     CF01 = (2*DF - CF)/3.D0
     CF02 = 2*CF/3.D0

     do i = 1, nfft_y   ! MPI
        rho    = chgrhr_l(i, UP) + chgrhr_l(i,DOWN)
        if(rho <= DELTA) then
           chgrhr_l(i,UP  ) = 0.D0
           chgrhr_l(i,DOWN) = 0.D0
           cycle
        endif
        ovn = 1.d0/rho
        rs     = CO2*ovn**C13
        if(rs >= 1.d0) then
           denmp = 1 + BETA1P*sqrt(rs) + BETA2P*rs
           denmf = 1 + BETA1F*sqrt(rs) + BETA2F*rs
           wcp = GAMP/denmp
           wcf = GAMF/denmf
           vcp = wcp*(1+B1P01*sqrt(rs)+B1P02*rs)/denmp
           vcf = wcf*(1+B1F01*sqrt(rs)+B1F02*RS)/denmf
        else
           wcp = AP*dlog(rs) + BP + CP*rs*dlog(rs) + DPx*rs
           wcf = AF*dlog(rs) + BF + CF*rs*dlog(rs) + DF*rs
           vcp = (AP+CP02*RS)*dLOG(RS) + CP00 + CP01*RS
           vcf = (AF+CF02*RS)*dLOG(RS) + CF00 + CF01*RS
        end if
        zeta   = (chgrhr_l(i,UP) - chgrhr_l(i,DOWN))*ovn
        f00    = ((1+zeta)**C43 + (1-zeta)**C43 - 2)*OVC243
        f2up   = ((1+zeta)**C13 - 1)*OVC213
        f2down = ((1-zeta)**C13 - 1)*OVC213
        t1 = vcf - vcp - C43*(wcf - wcp)
        wxp = -WX0*0.5d0/rs
        wxf = wxp * C213
        vxp = wxp * C43
        x = vxp + vcp + t1*f00
        t2 = C43 * ((WXF - WXP) + ( WCF - WCP ))
        chgrhr_l(i,UP  ) = x + t2*f2up
        chgrhr_l(i,DOWN) = x + t2*f2down

        vxc = wxp + wcp + ((wxf - wxp) + (wcf - wcp))*f00
        exc = exc + vxc*rho*f2or1(i)
     end do
  else
     do i = 1, nfft_y
        rho    = chgrhr_l(i,1)
        if(rho < DELTA) then
           chgrhr_l(i,1) = 0.d0
           cycle
        endif
        ovn    = 1.d0/rho
        rs     = CO2*ovn**C13
        wxp    = -WX0*0.5d0/rs
        if(rs >= 1.d0) then
           denmp = 1 + BETA1P*sqrt(rs) + BETA2P*rs
           wcp = GAMP/denmp
           vcp = wcp*(1.D0+B1P01*SQRT(rs)+B1P02*rs)/denmp
        else
           wcp = AP*dlog(rs) + BP + CP*rs*log(rs) + DPx*rs
           vcp = (AP+CP02*rs)*log(rs) + CP00 + CP01*rs
        end if

        wxp = -WX0*0.5D0/rs
        wxf = WXP * C213
        vxp = WXP * C43
        x = vxp + vcp
        chgrhr_l(i,1  ) = x
        vxc = wxp + wcp
        exc = exc + vxc*rho*f2or1(i)
     end do
  endif
#ifdef __TIMER_DO__
  call timer_end(1015)
#endif
#ifdef __TIMER_SUB__
    call timer_end(779)
#endif
end subroutine xcpotf_pzold_3D

!===============================================================================

subroutine xcpotf_xalfa_3D(nspin,ispin,input_charge,DELTA,chgrhr_l,f2or1,exc,nfft_y)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : DP,UP,DOWN,PAI,Valence_plus_PC_Charge
  implicit none

  integer,intent(in)         :: nspin,ispin,input_charge,nfft_y
  real(kind=DP),intent(in)   :: DELTA
  real(kind=DP),intent(inout):: chgrhr_l(1:nfft_y,ispin)
  real(kind=DP),intent(in)   :: f2or1(1:nfft_y)  
  real(kind=DP),intent(inout):: exc

  real(kind=DP), parameter   :: C13   =  1.d0/3.d0
  real(kind=DP), parameter   :: ALPHA = 0.7d0
  real(kind=DP)              :: CO1, CO2
  real(kind=DP)              :: rho,tmp,vxc
  integer                    :: i
#ifdef __TIMER_SUB__
    call timer_sta(780)
#endif

  CO1   = 1.5d0*ALPHA*(3.D0/PAI)**C13
  CO2   = (0.75d0/PAI)**C13

#ifdef __TIMER_DO__
  call timer_sta(1016)
#endif
  if(ispin == 2 .and. input_charge == Valence_plus_PC_Charge) then
     do i = 1, nfft_y
        rho    = chgrhr_l(i,UP) + chgrhr_l(i,DOWN)
!!$        rs     = CO2*( 1.0D0/rho  )**C13
        tmp    = - CO1*(rho**C13)
        chgrhr_l(i,UP)   = tmp
        chgrhr_l(i,DOWN) = tmp
        vxc = 0.25d0*CO1*(rho**C13)
        exc = exc+vxc*rho*f2or1(i)
     end do
  else
     do i = 1, nfft_y
        rho    = chgrhr_l(i,1)
!!$        rs     = CO2*( 1.0d0/rho  )**C13
        chgrhr_l(i,1)   = - CO1*(rho**C13)
        vxc = 0.25d0*CO1*(rho**C13)
        exc = exc+vxc*rho*f2or1(i)
     end do
  endif
#ifdef __TIMER_DO__
  call timer_end(1016)
#endif
#ifdef __TIMER_SUB__
    call timer_end(780)
#endif
end subroutine xcpotf_xalfa_3D

!===============================================================================

subroutine xcpotf_pz_3D(nspin,ispin,input_charge,DELTA,chgrhr_l,f2or1,exc,nfft_y)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : DP,UP,DOWN,PAI,Valence_plus_PC_Charge
  implicit none

  integer,intent(in)         :: nspin,ispin,input_charge,nfft_y
  real(kind=DP),intent(in)   :: DELTA
  real(kind=DP),intent(inout):: chgrhr_l(1:nfft_y,ispin)
  real(kind=DP),intent(in)   :: f2or1(1:nfft_y)  
  real(kind=DP),intent(inout):: exc

  real(kind=DP), parameter :: C13   =  1.d0/3.d0,  C23   =  2.d0/3.d0,  C43   =  4.d0/3.d0
  real(kind=DP), parameter :: GAMP   = -0.1423d0, GAMF   = -0.0843d0 &
       &                    , BETA1P =  1.0529d0, BETA2P =  0.3334d0 &
       &                    , BETA1F =  1.3981d0, BETA2F =  0.2611d0 &
       &                    , AP     =  0.0311d0, BP     = -0.0480d0 &
       &                    , CP     =  0.0020d0, DPx    = -0.0116d0 &
       &                    , AF     =  0.01555d0,BF     = -0.0269d0 &
       &                    , CF     =  0.00070d0,DF     = -0.0048d0

  real(kind=DP)  :: B1P01,B1P02,CP00,CP01,CP02,C243 &
       &          , B1F01,B1F02,CF00,CF01,CF02
  real(kind=DP)  :: CO2, WX0, C213
  real(kind=DP)  :: rho,ovn,rs,zeta,wxp,f00,wx,vx1,vx2,denmp,denmf,wcp,wcf &
       &          , vcp,vcf,wc,t1,f11,t2,vc1,vc2,vxc,vxp
  integer        :: i
#ifdef __TIMER_SUB__
    call timer_sta(781)
#endif

  CO2   = (0.75d0/PAI)**C13
  WX0   =  3*(((9*PAI)/4)**C13)/(2*PAI)
  B1P01 = 7*BETA1P/6.d0
  B1P02 = 4*BETA2P/3.d0
  CP00 = BP - AP/3.D0
  CP01 = (2*DPx - CP)/3.D0
  CP02 = 2*CP/3.D0

#ifdef __TIMER_DO__
  call timer_sta(1017)
#endif
  if(ispin == 2 .and. input_charge == Valence_plus_PC_Charge) then
     C213 = 2.d0**C13 - 1
!!$     OVC213 = 1.d0/C213
     C243   = 2*C213
!           ovc243 = 1.d0/(2.d0**C43 - 2)

     B1F01 = 7*BETA1F/6.d0
     B1F02 = 4*BETA2F/3.d0
     CF00 = BF - AF/3.d0
     CF01 = (2*DF - CF)/3.d0
     CF02 = 2*CF/3.d0

     do i = 1, nfft_y
        rho    = chgrhr_l(i, UP) + chgrhr_l(i,DOWN)
        if(rho <= DELTA) then
           chgrhr_l(i,UP  ) = 0.D0
           chgrhr_l(i,DOWN) = 0.D0
           cycle
        end if
        ovn = 1.d0/rho
        rs     = CO2*ovn**C13
        zeta   = (chgrhr_l(i,UP) - chgrhr_l(i,DOWN))*ovn
        wxp    = -WX0*0.5d0/rs
        f00 = ( (1+zeta)**C43 + (1-zeta)**C43 - 2 ) / c243
        wx  = wxp*(1+C213*f00)
        vx1 = c43*wxp*(1+zeta)**c13
        vx2 = c43*wxp*(1-zeta)**c13
        if(rs >= 1.d0) then
           denmp = 1.d0 + BETA1P*sqrt(rs) + BETA2P*rs
           denmf = 1.D0 + BETA1F*sqrt(rs) + BETA2F*rs
           wcp = GAMP/denmp
           wcf = GAMF/denmf
           vcp = wcp*(1.d0+B1P01*sqrt(rs)+B1P02*rs)/denmp
           vcf = wcf*(1.D0+B1F01*sqrt(rs)+B1F02*rs)/denmf
        else
           wcp = AP*dlog(rs) + BP + CP*rs*dlog(rs) + DPx*rs
           wcf = AF*dlog(rs) + BF + CF*rs*dlog(rs) + DF*rs
           vcp = (AP+CP02*rs)*dLOG(rs) + CP00 + CP01*rs
           vcf = (AF+CF02*rs)*dLOG(rs) + CF00 + CF01*rs
        end if
        wc     = wcp + f00*(wcf - wcp)
        t1     = vcp + f00*(vcf - vcp)
        f11    = C23/C213*((1+zeta)**c13-(1-zeta)**c13)
        t2     = f11*(wcf-wcp)
        vc1    = t1+t2*(1-zeta)
        vc2    = t1-t2*(1+zeta)

        chgrhr_l(i,UP  ) = vx1 + vc1
        chgrhr_l(i,DOWN) = vx2 + vc2

        vxc    = wx + wc
        exc = exc + vxc*rho*f2or1(i)
     end do
  else
     do i = 1, nfft_y
        rho    = chgrhr_l(i, 1)
        if(rho <= DELTA) then
           chgrhr_l(i,UP  ) = 0.D0
           cycle
        end if
        ovn = 1.d0/rho
        rs     = CO2*ovn**C13
        wxp    = -WX0*0.5d0/rs
        vxp = C43*wxp
        if(rs >= 1.d0) then
           denmp = 1 + BETA1P*sqrt(rs) + BETA2P*rs
           wcp = GAMP/denmp
           vcp = wcp*(1+B1P01*sqrt(rs)+B1P02*rs)/denmp
        else
           wcp = AP*dlog(rs) + BP + CP*rs*dlog(rs) + DPx*rs
           vcp = (AP+CP02*rs)*dLOG(rs) + CP00 + CP01*rs
        end if
        wc     = wcp
        chgrhr_l(i,1   ) = vxp + vcp

        vxc    = wxp + wcp
        exc = exc + vxc*rho*f2or1(i)
     end do
  endif
#ifdef __TIMER_DO__
  call timer_end(1017)
#endif
#ifdef __TIMER_SUB__
    call timer_end(781)
#endif
end subroutine xcpotf_pz_3D

!===============================================================================

subroutine xcpotf_vwn_3D(nspin,ispin,input_charge,DELTA,chgrhr_l,f2or1,exc,nfft_y)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : DP,UP,DOWN,PAI,Valence_plus_PC_Charge
  implicit none

  integer,intent(in)         :: nspin,ispin,input_charge,nfft_y
  real(kind=DP),intent(in)   :: DELTA
  real(kind=DP),intent(inout):: chgrhr_l(1:nfft_y,ispin)
  real(kind=DP),intent(in)   :: f2or1(1:nfft_y)  
  real(kind=DP),intent(inout):: exc

  real(kind=DP), parameter :: B1 = 1.13107d0,    C1 = 13.0045d0 &
       &                    , D1 = -0.0047584d0 &
       &                    , A2 =  0.0621814d0, B2 =  3.72744d0 &
       &                    , C2 = 12.9352d0   , D2 = -0.10498d0 &
       &                    , A3 =  0.0310907d0, B3 =  7.06042d0 &
       &                    , C3 = 18.0578d0,    D3 = -0.32500d0
  real(kind=DP), parameter :: C13   =  1.d0/3.d0,  C43   =  4.d0/3.d0
  real(kind=DP) :: CO2, WX0, C213

  real(kind=DP) :: F20,A1,Q1,P01,Q2,P02,Q3,P03,C243
  real(kind=DP) :: rho,ovn,zeta,f00,wx,vx1,vx2,x,p,r,h00,h10,h0p,h1p,h0f,h1f &
       &         , z4,h000,wc,vc,g00,vc0,vc1,vc2,rs,wxp,vxc
  integer       :: i

#ifdef __TIMER_SUB__
    call timer_sta(782)
#endif
  CO2   = (0.75d0/PAI)**C13
  WX0   =  3*(((9*PAI)/4)**C13)/(2*PAI)
  C213 = 2**C13 - 1

  F20   = 4/(9*C213)
  A1   = -1/(3*PAI*PAI)
  Q1   = dsqrt(4*C1-B1**2)
  P01  = D1**2 + B1*D1 + C1

  Q2   = dsqrt(4*C2-B2**2)
  P02  = D2**2 + B2*D2 + C2

  Q3   = dsqrt(4*C3-B3**2)
  P03  = D3**2 + B3*D3 + C3

#ifdef __TIMER_DO__
  call timer_sta(1018)
#endif
  if(ispin ==  2 .and. input_charge == Valence_plus_PC_Charge) then
!!$     OVC213 = 1.d0/C213
     C243   = 2*C213
!           ovc243 = 1.d0/(2.d0**c43 - 2)

     do i = 1, nfft_y
        rho    = chgrhr_l(i, UP) + chgrhr_l(i,DOWN)
        if(rho <= DELTA) then
           chgrhr_l(i,UP  ) = 0.D0
           chgrhr_l(i,DOWN) = 0.D0
           cycle
        end if
        ovn = 1.d0/rho
        rs     = CO2*ovn**C13
        if(rs <= DELTA) then
           chgrhr_l(i, UP)   = 0.d0  
           chgrhr_l(i, DOWN) = 0.d0
           cycle
        end if
        zeta   = (chgrhr_l(i,UP) - chgrhr_l(i,DOWN))*ovn
        wxp    = -WX0*0.5d0/rs
        f00 = ( (1+zeta)**C43 + (1-zeta)**C43 - 2 ) / C243
        wx  = wxp*(1+C213*f00)
        vx1 = C43*wxp*(1+zeta)**C13
        vx2 = C43*wxp*(1-zeta)**C13
        x   = dsqrt(rs)
        p   = x**2 + B1*x + C1
        r   = datan(Q1/(2*x+B1))
        h00= (A1/F20) * ( dlog((x**2)/p)+2*B1*r/Q1 &
             &       -B1*D1*(dlog(((x-D1)**2)/p)+2*(B1+2*D1)*r/Q1)/P01 )
        h10= (A1/F20) * ( 2/x - (1-B1*D1/P01)*(2*x+B1)/p - 2*B1*D1/((x-D1)*P01) &
             &                 - 4*B1*(1-(B1+2*D1)*D1/P01)/(Q1**2+(2*x+B1)**2) )

        p   = x**2 + B2*x + C2
        r   = datan(Q2/(2*x+B2))
        h0p= A2 * ( dlog((x**2)/p)+2*B2*r/Q2 &
             &        -B2*D2*(dlog(((x-D2)**2)/p)+2*(B2+2*D2)*r/Q2)/P02 )
        h1p= A2 * ( 2/x - (1-B2*D2/P02)*(2*x+B2)/p - 2*B2*D2/((x-D2)*P02) &
             &        -4*B2*(1-(B2+2*D2)*D2/P02)/(Q2**2+(2*x+B2)**2) )

        p   = x**2 + B3*x + C3
        r   = datan(Q3/(2*x+B3))
        h0f = A3 * ( dlog((x**2)/p)+2*B3*r/Q3 &
             &       -B3*D3*(dlog(((x-D3)**2)/p)+2*(B3+2*D3)*r/Q3)/P03 )
        h1f = A3 * ( 2/x - (1-B3*D3/P03)*(2*x+B3)/p - 2*B3*D3/((x-D3)*P03) &
             &         - 4*B3*(1-(B3+2*D3)*D3/P03)/(Q3**2+(2*x+B3)**2) )

        z4   = zeta**4
        h000 = h0f - h0p - h00
        wc=h0p+h00*f00+h000*z4*f00
        vc=wc-x*((1-z4*f00)*h1p+z4*f00*h1f+(1-z4)*f00*h10)/6
        g00 = 4*((1+zeta)**c13-(1-zeta)**c13) / (6*c213)
        vc0 = 4* h000*(zeta**3)*f00 + (h000*z4+h00)*g00
        vc1=vc+(1-zeta)*vc0
        vc2=vc-(1+zeta)*vc0

        wc  = wc*0.5d0
        vc1 = vc1*0.5d0
        vc2 = vc2*0.5d0

        chgrhr_l(i,UP  ) = vx1 + vc1
        chgrhr_l(i,DOWN) = vx2 + vc2

        vxc    = wx + wc
        exc = exc + vxc*rho*f2or1(i)
     end do
  else
!!$     OVC213 = 1.d0/C213
     C243   = 2*C213

     do i = 1, nfft_y
        rho    = chgrhr_l(i, 1)
        if(rho <= DELTA) then
           chgrhr_l(i,1  ) = 0.D0
           cycle
        end if
        ovn = 1.d0/rho
        rs     = CO2*ovn**C13
        wxp    = -WX0*0.5d0/rs
        f00 = 0.d0
        wx  = wxp
        vx1 = c43*wxp

        x   = dsqrt(rs)
        p   = x**2 + B2*x + C2
        r   = datan(Q2/(2*x+B2))
        h0p= a2 * ( dlog((x**2)/p)+2*b2*r/q2 &
             &       -b2*d2*(dlog(((x-d2)**2)/p)+2*(b2+2*d2)*r/q2)/p02 )
        h1p= a2 * ( 2/x - (1-b2*d2/p02)*(2*x+b2)/p - 2*b2*d2/((x-d2)*p02) &
             &           - 4*b2*(1-(b2+2*d2)*d2/p02)/(q2**2+(2*x+b2)**2) )

        wc  = h0p
        vc1 = wc-x*h1p/6

        wc  = wc*0.5d0
        vc1 = vc1*0.5d0

        chgrhr_l(i,1  ) = vx1 + vc1
        vxc    = wx + wc
        exc = exc + vxc*rho*f2or1(i)
     end do
  endif
#ifdef __TIMER_DO__
  call timer_end(1018)
#endif
#ifdef __TIMER_SUB__
    call timer_end(782)
#endif
end subroutine xcpotf_vwn_3D

!===============================================================================

subroutine xcpotf_mjw_bh_gl_3D(len_xctype,xctype,nspin,ispin,input_charge,DELTA,chgrhr_l,f2or1,exc,nfft_y)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : DP,UP,DOWN,PAI,Valence_plus_PC_Charge
  implicit none

  integer,intent(in)         :: len_xctype,nspin,ispin,input_charge,nfft_y
  character(len=len_xctype)  :: xctype
  real(kind=DP),intent(in)   :: DELTA
  real(kind=DP),intent(inout):: chgrhr_l(1:nfft_y,ispin)
  real(kind=DP),intent(in)   :: f2or1(1:nfft_y)  
  real(kind=DP),intent(inout):: exc

  real(kind=DP), parameter ::  CP    =  0.0020d0,  CF     =  0.00070d0
  real(kind=DP), parameter ::  C13   =  1.d0/3.d0, C43   =  4.d0/3.d0

  real(kind=DP) :: CO2, WX0, C213
  real(kind=DP) :: C243, CPX, RP, CFX, RF
  real(kind=DP) :: rho,ovn,rs,zeta,wxp,f00,wx,vx1,vx2,rsp,rsf,aap,aaf &
       &         , wcp,wcf,vcp,vcf,t1,t2,f11,f12,wc,vc1,vc2,vxc
  integer       :: i

#ifdef __TIMER_SUB__
    call timer_sta(783)
#endif
  CO2   = (0.75d0/PAI)**C13
  WX0   =  3*(((9*PAI)/4)**C13)/(2*PAI)
  C213 = 2**C13 - 1
  if(xctype ==  'mjw    ') then
! --*   moruzzi-janak-williams; Phys.Rev.12(1975)1257.  
     CPX=0.0450d0
     RP=21.0d0
  else if(xctype == 'bh     ') then                                    
! --*   von barth-hedin; J.Phys.C:Solid State Phys.5(1972)1629.  
     CPX=0.0504d0
     RP=30.0d0
  else if(xctype == 'gl     ') then                                    
! --*   gunnarsson-lundqvist; Phys.Rev.B13(1976)4274. 
     CPX=0.0666d0
     RP=11.4d0
  end if
#ifdef __TIMER_DO__
  call timer_sta(1019)
#endif

  if(ispin ==  2 .and. input_charge == Valence_plus_PC_Charge) then
     if(xctype ==  'mjw    ') then
        CFX=cp/2
        RF=RP*(2.d0**C43)
     else if(xctype ==  'bh     ') then                                    
        CFX=0.0254d0
        RF=75.0d0
     else if(xctype ==  'gl     ') then                                    
        CFX=0.0406d0
        RF=15.9d0
     end if

     C243   = 2*C213
     do i = 1, nfft_y
        rho    = chgrhr_l(i, UP) + chgrhr_l(i,DOWN)
        if(rho <= DELTA) then
           chgrhr_l(i,UP  ) = 0.D0
           chgrhr_l(i,DOWN) = 0.D0
           cycle
        end if
        ovn = 1.d0/rho
        rs     = CO2*ovn**C13
        if(rs <= DELTA) then
           chgrhr_l(i, UP  ) = 0.d0
           chgrhr_l(i, DOWN) = 0.d0
           cycle
        end if
        zeta   = (chgrhr_l(i,UP) - chgrhr_l(i,DOWN))*ovn
        wxp    = -WX0*0.5d0/rs
        f00 = ( (1+zeta)**C43 + (1-zeta)**C43 - 2 ) / C243
        wx  = wxp*(1+C213*f00)
        vx1 = C43*wxp*(1+zeta)**C13
        vx2 = C43*wxp*(1-zeta)**C13
        rsp = rs/RP
        rsf = rs/RF
        aap = dlog(1+1/rsp)                                      
        aaf = dlog(1+1/rsf)                                      
        wcp = - CPX * ((1+rsp**3)*aap - rsp**2 + rsp/2 - C13)
        wcf = - CFX * ((1+rsf**3)*aaf - rsf**2 + rsf/2 - C13)
        vcp = - CP * aap
        vcf = - CF * aaf

        t1  = vcf - vcp - C43*(wcf-wcp) 
        t2  = C43 * (wcf-wcp)

        f11= ( (1+zeta)**C13 -1 ) / C213
        f12= ( (1-zeta)**C13 -1 ) / C213
        wc=wcp + (wcf - wcp)*f00
        vc1=vcp + t1*f00 + t2*f11
        vc2=vcp + t1*f00 + t2*f12

        wc = wc*0.5d0
        vc1 = vc1*0.5d0
        vc2 = vc2*0.5d0

        chgrhr_l(i,UP  ) = vx1 + vc1
        chgrhr_l(i,DOWN) = vx2 + vc2

        vxc    = wx + wc
        exc = exc + vxc*rho*f2or1(i)
     end do
  else
     c243   = 2*C213
     do i = 1, nfft_y
        rho    = chgrhr_l(i, 1)
        if(rho <= DELTA) then
           chgrhr_l(i,1   ) = 0.D0
           cycle
        end if
        ovn = 1.d0/rho
        rs     = CO2*ovn**C13
        if(rs <= DELTA) then
           chgrhr_l(i, 1   ) = 0.d0
           cycle
        end if
        zeta   = 0.d0
        wxp    = -WX0*0.5d0/rs
        wx  = wxp
        vx1 = c43*wxp
        vx2 = c43*wxp

        rsp = rs/RP
        aap = dlog(1+1/rsp)                                      
        wcp = - CPX * ((1+rsp**3)*aap - rsp**2 + rsp/2 - C13)
        vcp = - CP * aap

        wc=wcp * 0.5d0
        vc1=vcp * 0.5d0

        chgrhr_l(i,1   ) = vx1 + vc1

        vxc    = wx + wc
        exc = exc + vxc*rho*f2or1(i)
     end do
  endif
#ifdef __TIMER_DO__
  call timer_end(1019)
#endif
#ifdef __TIMER_SUB__
    call timer_end(783)
#endif
end subroutine xcpotf_mjw_bh_gl_3D

!===============================================================================

!$$#endif

! ========= KT_add === 13.0A
! ==================================== KT_add ========================== 13.0A
subroutine ex_gga_library( nspin, ispin, ista_r, iend_r, chgrhr_l, grad_rho, &
     &                     wos, exc, dFx_drho, dFx_dgradrho, pot_type )
  use m_Const_Parameters,  only : DP,PAI
  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)  :: grad_rho(ista_r:iend_r,nspin)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)
  real(kind=DP),intent(out) :: exc
  real(kind=DP),intent(out) :: dFx_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(out) :: dFx_dgradrho(ista_r:iend_r,nspin)
  integer, intent(in) :: pot_type

!!  real(kind=DP), parameter :: ax = -0.7385588d0
  real(kind=DP), parameter :: ax = -0.7385587663820224d0 !! ax = -(3/4)*(3/PI)^(1/3)
  real(kind=DP), parameter :: thrd = 0.33333333333d0, thrd4 = 1.333333333333333d0
  real(kind=DP), parameter :: thpith = 3.0936677262801d0

! ----- parameters of enhanced factor --
  real(kind=DP), parameter :: mu_gel    = 0.1234567901234568d0   !  = 10.0 /81.0

  real(kind=DP), parameter :: mu_pbe    = 0.2195149727645171d0
  real(kind=DP), parameter :: mu_revpbe = 0.2195149727645171d0
  real(kind=DP), parameter :: mu_rpbe   = 0.2195149727645171d0
  real(kind=DP), parameter :: mu_wc     = 0.2195149727645171d0
  real(kind=DP), parameter :: mu_pbesol = 0.1234567901234568d0   !  = 10.0 /81.

  real(kind=DP), parameter :: mu_b86r   = 0.1234567901234568d0   !  = 10.0 /81.
  real(kind=DP), parameter :: mu_optpbe = 0.175519d0
  real(kind=DP), parameter :: mu_optb86b = 0.1234567901234568d0   !  = 10.0 /81.0
  real(kind=DP), parameter :: mu_c09    = 0.0617d0
  real(kind=DP), parameter :: mu_lvpw86r = 0.094344444444444444d0  ! = 0.8491 /9.0

  real(kind=DP), parameter :: kappa_pbe    = 0.804d0
  real(kind=DP), parameter :: kappa_revpbe = 1.245d0          ! by Koga-san
  real(kind=DP), parameter :: kappa_rpbe   = 0.804d0
  real(kind=DP), parameter :: kappa_wc     = 0.804d0
  real(kind=DP), parameter :: kappa_pbesol = 0.804d0
  real(kind=DP), parameter :: kappa_pbeint = 0.804d0

  real(kind=DP), parameter :: kappa_b86r   = 0.7114d0
  real(kind=DP), parameter :: kappa_optpbe = 1.04804d0
  real(kind=DP), parameter :: kappa_optb86b = 1.0d0
  real(kind=DP), parameter :: kappa_c09    = 1.245d0

! ---- others
  real(kind=DP), parameter :: coeff_WC = 0.0079325D0      ! ---- Wu and Cohen (2006)
  real(kind=DP), parameter :: alpha_c09 = 0.0483d0

  real(kind=DP), parameter :: s_low_htbs = 0.6d0, s_high_htbs = 2.6d0
!
  real(kind=DP), parameter :: a_pw86r = 0.1234567901234568d0   !  = 10.0 /81.0
  real(kind=DP), parameter :: b_pw86r = 17.33d0
  real(kind=DP), parameter :: c_pw86r = 0.163d0

  real(kind=DP), parameter :: alpha_lvpw86r = 0.02178d0
  real(kind=DP), parameter :: beta_lvpw86r = 1.15d0

  real(kind=DP), parameter :: a1_ev93 = 1.647127D0
  real(kind=DP), parameter :: a2_ev93 = 0.980118D0
  real(kind=DP), parameter :: a3_ev93 = 0.017399D0
  real(kind=DP), parameter :: b1_ev93 = 1.523671D0
  real(kind=DP), parameter :: b2_ev93 = 0.367229D0
  real(kind=DP), parameter :: b3_ev93 = 0.011282D0

! ----------------
  integer       :: is, i, pot_mode

  real(kind=DP) :: facw, d, dd, fk, s, fac, s2, mu_s2, f, ex, df_ds, &
       &           exd, exdd, exc0, excd, excdd, exc1
  real(kind=DP) :: ctmp1, ctmp2, ctmp3, ctmp4, ctmp5, ctmp6, x, dx_ds, s4, s6, df_dx
  real(kind=DP) :: y, dy_ds
  real(kind=DP) :: alpha_pbeint, mu_this, dmu_ds
!
  logical :: First = .true.
  real(kind=DP), save :: coeff_spline_htbs(0:5)

  if ( pot_type == 5 ) then
     if ( First ) then
        call init_spline_htbs( mu_wc, kappa_rpbe, kappa_wc, coeff_wc, &
             &                 s_low_htbs, s_high_htbs, coeff_spline_htbs )
        First = .false.
     endif
  endif

!---- Spin dependency

  facw = ispin
  exc  = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  do is = 1, ispin
     exc1 = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
     do i = ista_r, iend_r
        d  = facw * chgrhr_l(i, is)
        dd = facw * grad_rho(i, is)
        fk = (3.d0*PAI*PAI*d)**thrd
!!$        sk = dsqrt(4*fk/PAI)
        if(d > 1.d-05) then
           s = dd/(d*fk*2.d0)
        else
           s = 0.d0
        endif
!-------------------------------------
        fac = ax*d**thrd
        s2  = s*s
!
        pot_mode = pot_type
        if ( pot_type == 5 ) then
           if ( s <= s_low_htbs ) then
              pot_mode = 4
           else if ( s >= s_high_htbs ) then
              pot_mode = 3
           endif
        endif
!
        select case ( pot_mode )
        case (1)                        ! pbe
           x = mu_pbe *s2;   dx_ds = 2.0d0 *mu_pbe *s
           ctmp1 = kappa_pbe + x

           f = 1.0d0 +kappa_pbe *x /ctmp1
           df_dx = kappa_pbe**2 /ctmp1**2
           df_ds = dx_ds *df_dx

        case (2)                        ! revpbe
           x = mu_revpbe *s2;   dx_ds = 2.0d0 *mu_revpbe *s
           ctmp1 = kappa_revpbe + x

           f = 1.0d0 +kappa_revpbe *x /ctmp1
           df_dx = kappa_revpbe**2 /ctmp1**2
           df_ds = dx_ds *df_dx

        case (3)                        ! rpbe
           x = mu_rpbe *s2;   dx_ds = 2.0d0 *mu_rpbe *s
           ctmp1 = exp( -x/ kappa_rpbe )

           f = 1.0d0 +kappa_rpbe -kappa_rpbe *ctmp1
           df_dx = ctmp1
           df_ds = dx_ds *df_dx

        case (4)                        ! W. Cohen
           s4 = s2 *s2
           ctmp1 = exp( -s2 )
           ctmp2 = coeff_WC *s4

           x = mu_gel *s2 + ( mu_wc -mu_gel )*s2 *ctmp1 + log( 1.0d0 +ctmp2 )
           dx_ds = 2.0d0 *mu_gel *s + ( mu_wc -mu_gel ) *2.0d0 *s *ctmp1 *( 1.0d0 -s2 ) &
                &  +4.0d0 *coeff_WC *s2 *s /( 1.0d0 +ctmp2 )

           ctmp3 = kappa_wc +x

           f = 1.0d0 +kappa_wc *x / ctmp3
           df_dx = kappa_wc**2 /ctmp3**2           
           df_ds = dx_ds *df_dx

        case (5)
           ctmp1 = ( s -s_low_htbs )/( s_high_htbs -s_low_htbs )
           ctmp2 = ctmp1 *ctmp1
           ctmp3 = ctmp1 *ctmp2
           ctmp4 = ctmp1 *ctmp3
           ctmp5 = ctmp1 *ctmp4
           f = coeff_spline_htbs(0) +coeff_spline_htbs(1) *ctmp1 &
                &                   +coeff_spline_htbs(2) *ctmp2 &
                &                   +coeff_spline_htbs(3) *ctmp3 &
                &                   +coeff_spline_htbs(4) *ctmp4 &
                &                   +coeff_spline_htbs(5) *ctmp5
!
           df_ds = coeff_spline_htbs(1) + 2.0d0 *coeff_spline_htbs(2) *ctmp1 &
                &                       + 3.0d0 *coeff_spline_htbs(3) *ctmp2 &
                &                       + 4.0d0 *coeff_spline_htbs(4) *ctmp3 &
                &                       + 5.0d0 *coeff_spline_htbs(5) *ctmp4
           df_ds = df_ds / (s_high_htbs -s_low_htbs )

        case (6)                       ! pbesol
           x = mu_pbesol *s2;   dx_ds = 2.0d0 *mu_pbesol *s
           ctmp1 = kappa_pbesol + x

           f = 1.0d0 +kappa_pbesol *x /ctmp1
           df_dx = kappa_pbesol**2 /ctmp1**2
           df_ds = dx_ds *df_dx

        case (7)                       ! pbeint
           ctmp1 = mu_pbe - mu_gel

           alpha_pbeint = mu_gel**2 /kappa_pbeint /ctmp1
           ctmp2 = alpha_pbeint *s2
           ctmp3 = 1.0d0 +ctmp2

           mu_this = mu_gel +ctmp1 *ctmp2 /ctmp3
           dmu_ds = ctmp1 *alpha_pbeint *s  /ctmp3**2

           x = mu_this *s2;   dx_ds = 2.0d0 *mu_this *s + dmu_ds *s2

           ctmp4 = kappa_pbeint + x

           f = 1.0d0 +kappa_pbeint *x /ctmp4
           df_dx = kappa_pbeint**2 /ctmp4**2
           df_ds = dx_ds *df_dx

        case (11)                      ! B86r  I. Hamada
           x = mu_b86r *s2;   dx_ds = 2.0d0 *mu_b86r *s

           ctmp1 = 1.0d0 + x /kappa_b86r
           ctmp2 = ctmp1**(-4.0d0/5.0d0)
           ctmp3 = -0.8d0 *ctmp2 /ctmp1

           f = 1.0d0 + x *ctmp2
           df_dx = ctmp2 +ctmp3 *x /kappa_b86r
           df_ds = dx_ds *df_dx

        case (12)                      ! optpbe
           x = mu_optpbe *s2;   dx_ds = 2.0d0 *mu_optpbe *s
           ctmp1 = kappa_optpbe + x

           f = 1.0d0 +kappa_optpbe *x /ctmp1
           df_dx = kappa_optpbe**2 /ctmp1**2
           df_ds = dx_ds *df_dx

        case (13)                      ! optb86b
           x = mu_optb86b *s2;   dx_ds = 2.0d0 *mu_optb86b *s
           ctmp1 = 1.0d0 + x /kappa_optb86b
           ctmp2 = ctmp1**(-4.0d0/5.0d0)
           ctmp3 = -0.8d0 *ctmp2 /ctmp1

           f = 1.0d0 + x *ctmp2
           df_dx = ctmp2 +ctmp3 *x /kappa_optb86b
           df_ds = dx_ds *df_dx

        case (14)                      ! pw86r
           s4 = s2 *s2
           ctmp1 = a_pw86r
           ctmp2 = b_pw86r *s2
           ctmp3 = c_pw86r *s4

           ctmp4 = 1.0d0 +( 15.0d0 *ctmp1 +ctmp2 +ctmp3 ) *s2
           ctmp5 = 30.0d0 *ctmp1 +4.0d0 *ctmp2  +6.0d0 *ctmp3

           f = ctmp4 ** (1.0d0/15.0d0)
           df_ds = 1.0d0 /15.0d0 *f /ctmp4 * ctmp5 *s

        case (15)                      ! c09x
           x = mu_c09 *s2;  dx_ds = 2.0d0 *mu_c09 *s
           ctmp1 = alpha_c09 /mu_c09

           ctmp2 = exp( -ctmp1 *x )
           ctmp3 = exp( -ctmp1 *x /2.0d0 )

           ctmp4 = -ctmp1 *ctmp2
           ctmp5 = -ctmp1 *ctmp3 /2.0d0

           f = 1.0d0 + x *ctmp2 + kappa_c09 *( 1.0d0 -ctmp3 )
           df_dx = ctmp2 +x*ctmp4 -kappa_c09* ctmp5
           df_ds = dx_ds *df_dx

        case (16)                      ! lv-pw86r
           s4 = s2 *s2;  s6 = s4 *s2
           ctmp1 = 1.0d0 +15.d0 *a_pw86r *s2 +b_pw86r *s4 + c_pw86r *s6
           ctmp2 = ctmp1**(1.0d0/15.0d0)

           ctmp3 = 1.0d0/15.d0 /ctmp1 *ctmp2 *s &
                &  *( 30.0d0 *a_pw86r +4.0d0 *b_pw86r *s2 + 6.0d0 *c_pw86r *s4 )

           ctmp4 = 1.0d0 +alpha_lvpw86r *s6
           ctmp5 = beta_lvpw86r + alpha_lvpw86r *s6
           ctmp6 = 1.0d0 +mu_lvpw86r *s2

           f = ctmp6 /ctmp4 +alpha_lvpw86r *s6 /ctmp5 *ctmp2
           df_ds = s /ctmp4**2 *( -6.0d0 *alpha_lvpw86r *s4 *ctmp6 &
                &                 +2.0d0 *mu_lvpw86r *ctmp4 ) &
                &  +6.0d0 *alpha_lvpw86r *beta_lvpw86r *s4 *s /ctmp5**2 *ctmp2 &
                &  +alpha_lvpw86r *s6 /ctmp5 *ctmp3

        case (20)                    ! Engel Vosko (EV93)
           s4 = s2 *s2;  s6 = s4 *s2

           x = 1.0D0 +a1_ev93 *s2 +a2_ev93 *s4 +a3_ev93 *s6
           y = 1.0D0 +b1_ev93 *s2 +b2_ev93 *s4 +b3_ev93 *s6
           dx_ds = s *( 2.0D0 *a1_ev93 +4.0D0 *a2_ev93 *s2 +6.0D0 *a3_ev93 *s4 )
           dy_ds = s *( 2.0D0 *b1_ev93 +4.0D0 *b2_ev93 *s2 +6.0D0 *b3_ev93 *s4 )

           ctmp1 = y*dx_ds -x*dy_ds

           f = x /y
           df_ds = ctmp1 /y**2

        case default
           stop "xc functinal not supported "
        end select

        ex  = fac *f *d
        exd = thrd4 *fac* ( f -s *df_ds )
        exdd = ax *df_ds *0.5d0 /thpith
!------------------------------------------
        exc0 = ex / facw
        excd = exd
        dFx_drho(i, is) = excd
        excdd = exdd
! gradient of charge density 95/12/3 H.S.
        if(dabs(grad_rho(i, is)) > 1.d-9) then
           dFx_dgradrho(i, is) = excdd / grad_rho(i, is)
        else
           dFx_dgradrho(i, is) = 0.d0
        endif
! gradient of charge density 95/12/3 H.S.
        exc1 = exc1 + exc0*wos(i)
     end do
     exc = exc + exc1
  end do

end subroutine ex_gga_library

subroutine cr_gga_library( nspin, ispin, ista_r, iend_r, chgrhr_l, grad_trho, wos, &
     &                     exc, dF_drho, ecor, pot_type )
  use m_Const_Parameters,  only : PAI,DP
  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r, pot_type
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(inout) :: grad_trho(ista_r:iend_r)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)  
  real(kind=DP),intent(inout) :: exc
  real(kind=DP),intent(inout) :: dF_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(out),optional :: ecor

  real(kind=DP), parameter :: zeta_minimum    = 1.d-4
  real(kind=DP), parameter :: zeta_minimum2   = 1.d-6
  real(kind=DP), parameter :: density_minimum = 1.d-20
  real(kind=DP), parameter :: density_minimum2= 1.d-5

  real(kind=DP), parameter  :: a  = 0.0310907d0,    a1   = 0.21370d0
  real(kind=DP), parameter  :: b1 = 7.5957d0,       b2n  = 3.5876d0
  real(kind=DP), parameter  :: b3 = 1.6382d0,       b4   = 0.49294d0
  real(kind=DP), parameter  :: p  = 1.00d0,         p1   = p+1.d0

  real(kind=DP), parameter  :: ap  = 0.01554535d0,    a1p  = 0.20548d0
  real(kind=DP), parameter  :: b1p = 14.1189d0,     b2np = 6.1977d0
  real(kind=DP), parameter  :: b3p = 3.3662d0,      b4p  = 0.62517d0

  real(kind=DP), parameter  :: aq  = 0.0168869d0,    a1q  = 0.11125d0
  real(kind=DP), parameter  :: b1q = 10.3570d0,     b2nq = 3.6231d0
  real(kind=DP), parameter  :: b3q = 0.88026d0,     b4q  = 0.49671d0

  real(kind=DP), parameter  :: gamma = 0.03109069086965489503494086371273d0
!--------------------------

  real(kind=DP), parameter  :: thrd = 0.333333333333d0, sixth7 = 1.1666666666666666d0

  real(kind=DP), parameter  :: eta = 1.d-12
  real(kind=DP), parameter  :: sixthm = -0.16666666666666d0

! ----- parameters 
  real(kind=DP), parameter :: beta_pbe   = 0.06672455060314922d0
  real(kind=DP), parameter :: beta_pbesol = 0.046d0
  real(kind=DP), parameter :: beta_pbeint = 0.052d0

  integer       :: is,i
  real(kind=DP) :: facw,exc1,g,g3,facpon,d,dd,rs,fk,sk,t,q0 &
       &         , rs12,rs32,rsp,q1,q2,eu,q3,eurs,ecd,pon &
       &         , b,b2,t2,t4,t6,q4,q5,h0,h,q8,h0t,h0b,h0rs,ht,hrs &
       &         , ec1,ec1d,ec1dd,exc0,excd,excdd &
       &         , thrd2,thrd4,fzdd,zeta,onpzeta,onmzeta,fz,zetadxd &
       &         , q0p,q1p,q2p,q3p,q0q,q1q,q2q,q3q,fzd,onzt4,gzt,bzt,h0zt,euzt
  real(kind=DP) :: bet, delt

! ------
  select case ( pot_type )
  case (6)                           ! pbesol
     bet = beta_pbesol
  case (7)                           ! pbeint
     bet = beta_pbeint
  case default
     bet = beta_pbe
  end select

  delt = bet /gamma
! ------


  facw = ispin

!---- Spin dependency
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  if(present(ecor)) ecor = 0.d0
  do is = 1, ispin
     exc1 = 0.d0
     if ( ispin == 1 ) then
        g   = 1.d0
        g3  = g**3
!!$        g4  = g3*g
        facpon = -delt/(g3*bet)

#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
        do i = ista_r,iend_r ! MPI
           d  = facw*chgrhr_l(i, 1)
           if(d < density_minimum) cycle
! gradient of charge density 95/12/3 H.S.
           dd = facw* grad_trho(i)

           rs = (0.75d0/(PAI*d))**thrd
           fk = (3.d0*PAI*PAI*d)**thrd
           sk = dsqrt(4.d0*fk/PAI)
           if(d > density_minimum2) then
              t = dd/(d*sk*2.d0)
           else
              t = 0.d0
           endif

           q0 = -2.d0 *a*(1.d0 + a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2.d0 *a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log( 1.d0 + 1.d0/q1)
           eu = q0*q2
           q3 = a*(b1/rs12 +2.d0*b2n +3.d0*b3*rs12 +2.d0*b4*p1*rsp)
           eurs = -2.d0 *a*a1*q2 - q0*q3/(q1**2 + q1)
           ecd = eu-thrd*rs*eurs
           pon = facpon*eu
           b   = delt/(dexp(pon)-1.d0)
           b2  = b*b
           t2  = t*t

           t4  = t2*t2
           t6  = t4*t2
           q4  = 1.d0 + b*t2
           q5  = 1.d0 + b*t2+b2*t4
           h0  = g3*(bet/delt)*dlog(1d0+delt*q4*t2/q5)
           h   = h0
           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2.d0 *bet*t*( 1.d0 +2d0 *b*t2)/q8 * g3
           h0b = -bet*t6*( 2.d0 *b+b2*t2)/q8 * g3
           h0rs = h0b*b*eurs*(b+delt)/ bet / g3
           ht   = h0t
           hrs  = h0rs
           ec1  = d*h/facw
           ec1d = h-thrd*rs*hrs-sixth7*t*ht

           ec1dd = 0.5d0*ht/sk

           exc0 = eu*d/facw + ec1
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(dabs(grad_trho(i)) > 1.0d-9) then
              grad_trho(i) = excdd / grad_trho(i)
           else
              grad_trho(i) = 0.d0
           endif
! gradient of charge density 95/12/3 H.S.
!!$           exec1 = eu*d/facw
           exc1 = exc1 + exc0*wos(i)
        end do

     else if ( ispin ==  2 ) then
        thrd2 = thrd * 2.d0
        thrd4 = thrd * 4.d0
        fzdd = 8.d0 /(9.d0*(2.d0**thrd4 - 2.d0 ))

        do i = ista_r,iend_r
           d = chgrhr_l(i, 1) + chgrhr_l(i, ispin)
           if(d < density_minimum ) cycle
           zeta = ( chgrhr_l(i, 1) - chgrhr_l(i, 2) ) / d
           onpzeta = 2.d0 *chgrhr_l(i, 1) / d
           onmzeta = 2.d0 *chgrhr_l(i, 2) / d
           g = ( onpzeta**thrd2 + onmzeta**thrd2 )/2.d0
           if(dabs(zeta) < zeta_minimum ) then
              fz= 4.d0/9.d0 *zeta*zeta*(1.d0 + 5.d0/54.d0 *zeta*zeta &
                   &               *(1.d0 +44.d0/135.d0*zeta*zeta )) &
                   &       /(2.d0**thrd4 -2.d0)
           else
              fz = (onpzeta**thrd4 + onmzeta**thrd4 -2.d0) / (2.d0**thrd4 - 2.d0)
           end if
           g3  = g**3
!!$           g4  = g3*g
           facpon = -delt/(g3*bet)
           if(d < density_minimum) cycle
           dd = grad_trho(i)
           rs = (0.75d0/(PAI*d))**thrd
           fk = (3.d0*PAI*PAI*d)**thrd
           sk = dsqrt(4.d0*fk/PAI)

           if(d > density_minimum2) then
              t = dd/(d*sk*2.d0*g)
           else
              t = 0.d0
           endif

           q0 = -2.d0 *a*(1.d0+a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2.d0 *a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log( 1.d0 +1.d0/q1 )
           q3 = a*(b1/rs12 +2.d0*b2n +3.d0*b3*rs12 +2.d0*b4*p1*rsp)

           q0p = -2.d0 *ap*(1.d0+a1p*rs)
           q1p = 2.d0*ap*(b1p*rs12+b2np*rs+b3p*rs32+b4p*rs*rsp)
           q2p = log(1.d0 +1.d0/q1p)
           q3p = ap*(b1p/rs12 +2.d0*b2np +3.d0*b3p*rs12 +2.d0*b4p*p1*rsp)
! vwn 95/12/2 Y.M
           q0q = -2.d0*aq*(1.d0+a1q*rs)
           q1q =  2.d0*aq*(b1q*rs12+b2nq*rs+b3q*rs32+b4q*rs*rsp)
           q2q = log(1.d0 +1.d0/q1q)
           q3q = aq*(b1q/rs12 +2.d0*b2nq +3.d0*b3q*rs12 +2.d0*b4q*p1*rsp)
           if(dabs(zeta) < zeta_minimum) then
              fzd = 8.d0/9.d0 /( 2.d0**thrd4 -2.d0 ) &
                   &     *zeta *( 1.d0 + 5.d0/27.d0 *zeta*zeta &
                   &           *( 1.d0 +22.d0/45.d0 *zeta*zeta ))
           else
              fzd = 4.d0/3.d0 /( 2.d0**thrd4 -2.d0) &
                   &     *( onpzeta**thrd -onmzeta**thrd )
           end if
           onzt4= onmzeta*onpzeta *( 1.d0 + zeta*zeta )
           eu = q0*q2 + ( q0p * q2p - q0 * q2 ) * fz * zeta**4 &
                &             -   q0q * q2q * fz / fzdd * onzt4
           eurs = ( -2.d0*a*a1*q2 -q0*q3/(q1**2 +q1 )) * ( 1.d0 -fz*zeta**4 )&
                &+( -2.d0*ap*a1p*q2p -q0p*q3p/( q1p**2 +q1p )) *fz*zeta**4 &
                &-( -2.d0*aq*a1q*q2q -q0q*q3q/( q1q**2 +q1q )) *fz/fzdd*onzt4
           euzt =  -q0q*q2q /fzdd *( fzd*onzt4 -4.d0*fz*zeta**3 )&
                &        +( q0p*q2p -q0*q2 )*(fzd*zeta +4.d0*fz )*zeta**3 
! vwn 95/12/2 Y.M

           zetadxd = - 2.d0 * chgrhr_l(i, 3-is) * (-1.d0)**is / d
           ecd = eu-thrd*rs*eurs + euzt * zetadxd 

           pon = facpon*eu
           b   = delt/(dexp(pon)-1.d0)
           b2  = b*b
           t2  = t*t

           t4  = t2*t2
           t6  = t4*t2
           q4  = 1.d0 +b*t2
           q5  = 1.d0 +b*t2+b2*t4
           h0  = g3*(bet/delt)*dlog(1.d0+delt*q4*t2/q5)
           h   = h0

           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2.d0 *bet*t*(1.d0 +2.d0*b*t2)/q8 * g3
           h0b = -bet*t6*( 2.d0*b +b2*t2)/q8 * g3
           h0rs = h0b * b * eurs * (b+delt) / bet / g3
           ht   = h0t
           hrs  = h0rs

           if(dabs(zeta) < zeta_minimum) then
              gzt = -2.d0/9.d0*zeta *( 1.d0 +14.d0/27.d0 *zeta*zeta &
                   &             *( 1.d0 +13.d0/18.d0 *zeta*zeta ))
           else
              gzt = ( (onpzeta**2+eta)**sixthm - (onmzeta**2+eta)**sixthm)/3.d0
           end if
           bzt = b * ( b+delt) * ( euzt - 3.d0*eu*gzt/g ) / ( bet * g3 ) 
           h0zt = 3.d0 * gzt * h0 / g + h0b * bzt


           ec1  = d*h * 0.5d0

           ec1d = h-thrd*rs*hrs-sixth7*t*ht  + (h0zt-gzt*t*h0t/g) * zetadxd
           ec1dd = 0.5d0*ht/sk / g

10         continue

           exc0 = eu*d * 0.5d0 + ec1
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(is ==  2) then
              if(dabs(grad_trho(i)) > 1.0d-9) then
                 grad_trho(i) = excdd / grad_trho(i)
              else
                 grad_trho(i) = 0.d0
              endif
           endif
! gradient of charge density 95/12/3 H.S.
!!$           exec1 = eu*d * 0.5
           exc1 = exc1 + exc0*wos(i)
        end do
     end if
     exc = exc + exc1
     if(present(ecor)) ecor = ecor + exc1
  end do
end subroutine cr_gga_library

subroutine init_spline_htbs( mu, kappa_rpbe, kappa_wc, coeff_wc, &
     &                       s_low_htbs, s_high_htbs, coeff_spline )
  use m_Const_Parameters,  only : DP
  implicit none

  real(kind=DP), intent(in) :: mu, kappa_rpbe, kappa_wc, coeff_wc
  real(kind=DP), intent(in) :: s_low_htbs, s_high_htbs
  real(kind=DP), intent(out) :: coeff_spline(0:5)
!
  real(kind=DP) :: f_0, df_0, d2f_0, f_1, df_1, d2f_1
  real(kind=DP) :: delta_s, ctmp1, ctmp2, ctmp3

  call set_values_endpoint0( s_low_htbs,  f_0, df_0, d2f_0 )   ! WC06 at lower limit
  call set_values_endpoint1( s_high_htbs, f_1, df_1, d2f_1 )   ! RPBE at high limit

! scaling from s=(s1,s2) to y=(0, 1)   ! y = (s-s1)/(s2-s1)
!
  delta_s = s_high_htbs -s_low_htbs
  df_0 = df_0 *delta_s;     d2f_0 = d2f_0 *delta_s**2
  df_1 = df_1 *delta_s;     d2f_1 = d2f_1 *delta_s**2
!
  coeff_spline(0) = f_0
  coeff_spline(1) = df_0
  coeff_spline(2) = d2f_0 /2.0d0
!
  ctmp1 =   f_1 -coeff_spline(0) -coeff_spline(1) -coeff_spline(2)
  ctmp2 =  df_1 -coeff_spline(1) -2.0d0 *coeff_spline(2)
  ctmp3 = d2f_1 -2.0d0 *coeff_spline(2)
!
  coeff_spline(3) = ( 20.0d0 *ctmp1 -8.0d0 *ctmp2 + ctmp3 ) /2.0d0
  coeff_spline(4) = ( 4.0d0 *ctmp2 -ctmp3 -6.0d0 *coeff_spline(3) ) /4.0d0
  coeff_spline(5) = ctmp1 -coeff_spline(3) -coeff_spline(4)

contains

  subroutine set_values_endpoint0( s, f, df_ds, d2f_ds2 )
    real(kind=DP), intent(in) :: s
    real(kind=DP), intent(out) :: f, df_ds, d2f_ds2

    real(kind=DP), parameter :: mu_gel    = 0.1234567901234568d0   !  = 10.0 /81.0

    real(kind=DP) :: s2, s4, x, dx_ds, d2x_ds2, df_dx, d2f_dx2
    real(kind=DP) :: ctmp1, ctmp2, ctmp3

    s2 = s**2;  s4 = s2**2

    ctmp1 = exp( -s2 )
    ctmp2 = coeff_WC *s4

    x = mu_gel *s2 + ( mu -mu_gel )*s2 *ctmp1 + log( 1.0d0 +ctmp2 )
    dx_ds = 2.0d0 *mu_gel *s + ( mu -mu_gel ) *2.0d0 *s *ctmp1 *( 1.0d0 -s2 ) &
         &  +4.0d0 *coeff_WC *s2 *s /( 1.0d0 +ctmp2 )
    d2x_ds2 = 2.0d0 *mu_gel &
         &   + 2.0d0 *( mu -mu_gel ) *ctmp1 *( 1.0d0 -5.0d0 *s2 +2.0d0 *s4 ) &
         &   + 4.0d0 *coeff_WC *s2 *( 3.0d0 -ctmp2 ) /( 1.0d0 +ctmp2 )**2

    ctmp3 = kappa_wc +x

    f = 1.0d0 +kappa_wc *x /ctmp3
    df_dx = kappa_wc**2 /ctmp3**2
    d2f_dx2 = -2.0d0 *df_dx /ctmp3

    df_ds = dx_ds * df_dx
    d2f_ds2 = d2x_ds2 *df_dx +dx_ds**2 *d2f_dx2

  end subroutine set_values_endpoint0

  subroutine set_values_endpoint1( s, f, df_ds, d2f_ds2 )
    real(kind=DP), intent(in) :: s
    real(kind=DP), intent(out) :: f, df_ds, d2f_ds2

    real(kind=DP) :: s2, x, dx_ds, d2x_ds2
    real(kind=DP) :: ctmp1

    s2 = s**2

    x = mu *s2;   dx_ds = 2.0d0 *mu *s;   d2x_ds2 = 2.0d0 *mu
    ctmp1 = exp( -x/ kappa_rpbe )

    f = 1.0d0 +kappa_rpbe -kappa_rpbe *ctmp1
    df_ds = dx_ds *ctmp1
    d2f_ds2 = ctmp1 * ( d2x_ds2 -dx_ds**2 /kappa_rpbe )

  end subroutine set_values_endpoint1

end subroutine init_spline_htbs
! ===================== 13.0A

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 593 $)
!
!  SUBROUINE: Finalization_of_mpi
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!      Further modification by T. Yamasaki and M. Saito,   Feb-May. 2004
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
subroutine Finalization_of_mpi
! $Id: Finalization_of_mpi.F90 593 2019-06-20 03:47:31Z jkoga $
  use m_Parallelization, only :       m_Parallel_end_mpi
  use m_PlaneWaveBasisSet, only :     m_pwBS_dealloc_ngpt_igfp_gr &
       &                            , m_pwBS_dealloc_ylm_l
  use m_Ionic_System, only :          m_IS_dealloc_zfm3_3D
  use m_PseudoPotential, only :       m_PP_dealloc_psc_qitg_rhpcg &
         &                            , m_PP_dealloc_paw,flg_paw
#ifndef PARAMSET
  use m_Charge_Density,       only : m_CD_dealloc_chgq
  use m_Electronic_Structure, only : m_ES_dealloc_vlhxc, m_ES_dealloc_vlhxcQ &
                                   , m_ES_dealloc_Dhub
  use m_ES_WF_by_SDorCG,      only : m_ESsd_dealloc_dzajn2, m_ESsd_dealloc_zaj_old
  use m_PAW_ChargeDensity,    only : m_PAWCD_dealloc
  use m_XC_Potential,         only : m_XC_dealloc_vxc_3D
#endif
#ifdef _POSITRON_
  use m_epc_potential,        only : m_epc_dealloc, m_epc_dealloc_vlhxc_p
  use m_Positron_Wave_Functions,only:m_pWF_deallocate_pzaj_etc
#endif

! ======== KT_add =============== 2013/10/31
  use m_Control_Parameters,   only : noncol, SpinOrbit_Mode
  use m_Const_Parameters,     only : Neglected, BuiltIn, ByPawPot, ZeffApprox, &
       &                             ByProjector, ReadFromPP, ON
  use m_SpinOrbit_Potential,  only : m_SO_dealloc_Dsoc, m_SO_dealloc_Mat_SOC_Strenth
! =============================== 2013/10/31


  use m_Control_Parameters,  only : sw_local_approx_trans_moment, sw_corelevel_spectrum
  use m_CLS_dipquad,         only : m_CLS_dealloc_dipquad, m_CLS_dealloc_transmom_ek

  implicit none

  call m_pwBS_dealloc_ngpt_igfp_gr()
  call m_IS_dealloc_zfm3_3D()
  call m_PP_dealloc_psc_qitg_rhpcg()
  if(flg_paw) then
     call m_PP_dealloc_paw()
     call m_PAWCD_dealloc()
  end if
#ifndef PARAMSET
  call m_pwBS_dealloc_ylm_l()
  call m_CD_dealloc_chgq()
  call m_ESsd_dealloc_dzajn2()
  call m_ESsd_dealloc_zaj_old()
  call m_ES_dealloc_vlhxc()
  call m_ES_dealloc_vlhxcQ()
  call m_XC_dealloc_vxc_3D()
#endif
#ifdef _POSITRON_
  call m_epc_dealloc()
  call m_epc_dealloc_vlhxc_p
  call m_pWF_deallocate_pzaj_etc()
#endif
  call m_ES_dealloc_Dhub()

! ==== KT_add ============== 2013/10/31
  if ( noncol ) then
     if ( SpinOrbit_Mode == ByPawPot .or. SpinOrbit_Mode == ZeffApprox &
          &                          .or. SpinOrbit_Mode == ReadFromPP ) then
        call m_SO_dealloc_Mat_SOC_strenth
        call m_SO_dealloc_Dsoc
     endif
     if ( SpinOrbit_Mode == ByProjector ) then
        call m_SO_dealloc_Dsoc
     endif
  endif
! ========================== 2013/10/31


  if ( sw_corelevel_spectrum == ON .and. sw_local_approx_trans_moment == ON ) then
     call m_CLS_dealloc_dipquad
     call m_CLS_dealloc_transmom_ek
  endif

  call m_Parallel_end_mpi           ! MPI
end subroutine Finalization_of_mpi

subroutine mpi_stop(nf)
  integer, intent(in) :: nf
  include 'mpif.h'             ! MPI
  integer :: ierror
  integer :: errorcode

  errorcode = 1000
  write(nf,*) ' ','',''
  call flush(nf)
  call mpi_abort(mpi_comm_world,errorcode,ierror)
  call mpi_finalize(ierror)
  stop
end subroutine mpi_stop

!!$#ifdef DEBUG_ERRORS
subroutine phase_error(ierrNO, nfout, nf, filename, line, modulefile)
!!$#else
!!$subroutine phase_error(ierrNO, nfout, nf, filename)
!!$#endif
  use m_Control_Parameters, only : ipri
  use m_ErrorMessages
  use m_Parallelization,    only : mpi_comm_group
  implicit none
  integer, intent(in) :: ierrNO,nfout,nf
  character(len=*), intent(in)          :: filename
!!$#ifdef DEBUG_ERRORS
  integer, intent(in),optional            :: line
  character(len=*), intent(in),optional   :: modulefile
!!$#endif

!!$  include 'mpif.h'             ! MPI

  character(len=255) :: I_name
  integer :: ierror, len_filename, i

  ierror = 0
  if(ipri>=1) then
     len_filename = min(255,len(trim(filename))) !ASMS
     do i = 1, len_filename
        I_name(i:i) = filename(i:i)
     end do
     do i = len_filename + 1 , 255 !ASMS
        I_name(i:i) = " "          !ASMS
     end do                        !ASMS

     if(ierrNO == F_POT_FILE_NOT_EXIST) then
        write(nfout,'("#### ERROR(",i4,"): No F_POT(",i3,") (=",a,")")') &
             & ierrNO, nf, trim(filename) !ASMS
     else if(ierrNO == FILE_NOT_EXIST) then
        write(nfout,'("#### ERROR(", i4, "): File (",a &
             & ,") assigned to a file no",i4," does not exist.")') &
             & ierrNO, trim(filename),nf !ASMS
     else if(ierrNO == F_ZAJ_FILE_NOT_EXIST) then    ! 1204
        write(nfout,'("#### ERROR(", i4, "):",a)') &
             & ierrNO, msg_1204_error
     else if(ierrNO == F_CHGT_FILE_NOT_EXIST) then   ! 1205
        write(nfout,'("#### ERROR(", i4, "):",a)') &
             & ierrNO, msg_1205_error
     else if(ierrNO == ERROR_IN_INPUTFILE_OPENING) then ! 1211
        write(nfout,'("#### ERROR(", i4, "):",a,a)') &
             & ierrNO, msg_1211_error, trim(filename) !ASMS
     else if(ierrNO == F_CHGT_FILE_NOT_EXIST_EK) then   ! 1212
        write(nfout,'("#### ERROR(",i4,"): F_CHGT(file no",i3,") does not exist. ",a)') &
             & ierrNO, nf, msg_1212_error
     end if
  end if

#ifdef DEBUG_ERRORS
  if(present(line)) then
     if(present(modulefile)) then
        write(nfout,'(a,i8,a)') ' PHASE experienced an error at the line ' &
             & , line, ' of source file '//trim(adjustl(modulefile))
     end if
  end if
#endif
  call flush(nfout)
!  stop ' after flush'
  call mpi_abort(mpi_comm_group,261,ierror)
  call mpi_finalize(ierror)
end subroutine phase_error

subroutine phase_error_wo_filename(ierrNO, nfout, nf, line, modulefile)

  use m_Control_Parameters, only : ipri
  use m_Parallelization,    only : mpi_comm_group
  use m_ErrorMessages

  integer, intent(in) :: ierrNO,nfout
  integer, intent(in),optional :: nf
  integer, intent(in),optional :: line
  character(len=*), intent(in),optional ::modulefile

  include 'mpif.h'             ! MPI

  logical :: I_opened
  character(len=255) :: I_name
  integer :: ierror

  ierror = 0

  if(ipri>=1) then
!!$     write(nfout,'("#### ERROR(",i4,")")') ierrNo
     if(ierrNO == EOF_REACHED) then
        if(present(nf)) then
           inquire(unit=nf, OPENED=I_opened, NAME=I_name)
           if(I_opened) then
              write(nfout,'("#### ERROR(",i4,"): EOF_reached. File No = " &
                   & ,i4,", File Name = ",a)') ierrNO, nf, trim(adjustl(I_name))
           else
              write(nfout,'("#### ERROR(",i4,"): EOF_reached. File No = " &
                   & ,i4)') ierrNO, nf
           end if
        else
           write(nfout,'("#### ERROR(",i4,"): EOF_reached. But, File No is not given.")') &
                & ierrNO
        end if
     else if(ierrNO == FORMAT_ERROR) then
        if(present(nf)) then
           inquire(unit=nf, OPENED=I_opened, NAME=I_name)
           if(I_opened) then
              write(nfout,'("#### ERROR(",i4,"): ",a," File No = ",i4," File Name = ",a)') &
                   &                     ierrNO, msg_format_error, nf, trim(adjustl(I_name))
           else
              write(nfout,'("#### ERROR(",i4,"): ",a," File No = ",i4)') &
                   &                     ierrNO, msg_format_error, nf
           end if
        else
           write(nfout,'("#### ERROR(",i4,"): ",a," But, File No is unknown.")') &
                &                     ierrNO, msg_format_error
        end if
     else if(ierrNO == CPP_DEFINE_ERROR_1) then
        write(nfout,'("#### ERROR(",i4,"): ",a)') ierrNO,msg_6100_error
        write(nfout,'("                      (",a,")")') msg_6101_error
     else
        write(nfout,'("#### ERROR(",i4,"):msg")') ierrNO
     end if
#ifdef DEBUG_ERRORS
     if(present(line)) then
        if(present(modulefile)) then
           write(nfout,'(a,i8,a)') ' PHASE aborted at the line ' &
                & , line, ' of source file '//trim(adjustl(modulefile))
        end if
     end if
#endif
  end if
  call flush(nfout)
!!$  if(mode>0) then
     call mpi_abort(mpi_comm_group,261,ierror)
     write(nfout,'(" ierror = ",i8)') ierror
!!$  end if
  call flush(nfout)
  call mpi_finalize(ierror)
  stop
end subroutine phase_error_wo_filename

subroutine phase_execution_error(ierrNO)
  use m_Control_Parameters, only : ipri
  use m_Parallelization,    only : mpi_comm_group, mype
  use m_Files,              only : nfout 
  use m_ErrorMessages

  implicit none
  integer, intent(in) :: ierrNO
!!$  include 'mpif.h'             ! MPI

  if(ipri>=1 .and. mype == 0) then
     write(nfout,*)  ! BLANK LINE
     select case (ierrNO)
     case (CONT_FILES_NOT_EXIST)      ! 1209
        write(nfout,'("###ERROR(",i4,") file(s) for continuation do not exist.")') &
             & CONT_FILES_NOT_EXIST
     case (FILENAMES_FORMAT_ERROR)      ! 1209
        write(nfout,'("###ERROR(",i4,") format error in file_names.data.")') &
             & FILENAMES_FORMAT_ERROR
     case (FILENAMES_FORMAT_ERROR_NEB)  ! 1210
        write(nfout,'("###ERROR(",i4,") format error in file_names.data. (nebfiles)")') &
             & FILENAMES_FORMAT_ERROR_NEB
     case (INVALID_CHARGE_MIXING)       ! 1302
        write(nfout,'("###ERROR(",i4,") charge-mixing in the wavefunction_solver block does not exist.")') &
             & INVALID_CHARGE_MIXING
     case (INVALID_ATOMIC_NUMBER)       ! 1401
        write(nfout,'("###ERROR(",i4,") The atomic-number is inconsistent with the pseudopotential file.")') &
             & INVALID_ATOMIC_NUMBER
     case (PARALLELIZATION_INVALID_2D)  ! 2101
        write(nfout,'("###ERROR(",i4,") Number of parallel process (npes) must be ne*nk.")')  &
             & PARALLELIZATION_INVALID_2D
     case (PARALLELIZATION_INVALID_3D)  ! 2102
        continue
     case (PARALLELIZATION_INVALID_NK)  ! 2103
        write(nfout,'("###ERROR(",i4,") Number of kpoint-parallelization is greater than number of kpoints(kv3).")') &
             & PARALLELIZATION_INVALID_NK
     case (PARALLELIZATION_INVALID_NE)  ! 2104
        write(nfout,'("###ERROR(",i4,") Number of band-parallelization is greater than number of bands(neg).")') &
             & PARALLELIZATION_INVALID_NE
     end select
  end if
  call flush(nfout)
  call mpi_abort(mpi_comm_group,275,ierrNO)
  call mpi_finalize(ierrNO)
end subroutine phase_execution_error

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 590 $)
!
!  MODULE: m_IterationNumbers
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
! *************************************************************
! 
module m_IterationNumbers
!     (m_Iter)
! $Id: m_IterationNumbers.F90 590 2018-11-06 04:20:58Z jkoga $
  use m_Const_Parameters, only : len_tag_iteration, tag_iteration &
       &                       , len_tag_iters_and_nk, tag_iters_and_nk &
       &                       , EK_CONVERGED, COORDINATE_CONTINUATION
  use m_Parallelization, only  : mpi_comm_group,mype,npes,ierr,nrank_k
  implicit none

  integer :: iteration = 0            ! #total iteration
  integer :: first_iteration_of_this_job = 0
  integer :: iteration_ionic = 1      ! #timestep for MD of ions
  integer :: iteration_scdft = 1
  integer :: iteration_scdft_initial = 1
  logical :: iteration_scdft_initial_is_set = .false.
  integer :: iteration_electronic = 0 ! #iteration for electronic states convergence
  integer :: iteration_rmm_start  = 0 ! #iteration where rmm starts in iteration_electonic
  integer :: iteration_for_cmix   = 0 ! #iteration for charge mixing.
  !      This is almost same with iteration_electronic.

  integer :: iteration_unit_cell  = 1 ! #iteration for the unit cell, when unit cell optimization is enabled

  integer :: iteration_uramp = 1 ! #iteration for the U-ramping method, when the U-ramping method is enabled

  !      Unique difference is that this value is reset when the job starts to run.
  integer :: nk_in_the_process    = 0 ! #kpoint calculating. This is effective only
  !                                     when ekmode (in m_Control_Parameters) is ON.
  integer :: nk_converged         = 0
  integer :: nkgroup              = 0
  integer :: first_kpoint_in_this_job = 0
  integer :: first_iteration_electronic = 0

  integer :: iteration_positron_wf = 0

  integer :: iteration_stress_correction = 1

  integer, parameter :: len_str = 132
  character(len=len_str) :: str

  include 'mpif.h'
contains

  subroutine m_Iter_reset_iter_ionic()
     iteration_ionic = 1
  end subroutine m_Iter_reset_iter_ionic

  subroutine m_Iter_reset_iter_scdft()
    iteration_scdft = 1
  end subroutine m_Iter_reset_iter_scdft

  subroutine m_Iter_reset_iter_electronic(nfout)
    integer, intent(in) :: nfout
    iteration_electronic = 0
    first_iteration_electronic = iteration_electronic
    if(mype == 0) then
       write(nfout,'(" iteration_electronic is rest 0")')
    end if
  end subroutine m_Iter_reset_iter_electronic

  subroutine m_Iter_wd_iteration_numbers(nfcntn)
    integer, intent(in) :: nfcntn
    logical :: unitcell_can_change,Uramping,isSCDFT
    if(mype==0) then
       write(nfcntn,*) tag_iteration
       if(.not.unitcell_can_change())then
          if (Uramping()) then
            write(nfcntn,'(4i10)') iteration, iteration_uramp,iteration_ionic, iteration_electronic
          else if (isSCDFT()) then
            write(nfcntn,'(4i10)') iteration, iteration_scdft,iteration_ionic, iteration_electronic
          else
            write(nfcntn,'(3i10)') iteration, iteration_ionic, iteration_electronic
          endif
       else
          write(nfcntn,'(4i10)') iteration, iteration_unit_cell, iteration_ionic, iteration_electronic
       endif
    endif
  end subroutine m_Iter_wd_iteration_numbers

  subroutine m_Iter_wd_iteration_numbers_b(nf,F_partitioned)
    integer, intent(in) :: nf
    logical, intent(in) :: F_partitioned
    call mpi_barrier(mpi_comm_group,ierr)
    if(F_partitioned) then
       if(mype == 0) then
          write(nf,*) iteration, iteration_ionic, iteration_electronic
       end if
    else
       write(nf,*) iteration, iteration_ionic, iteration_electronic
    end if
  end subroutine m_Iter_wd_iteration_numbers_b

  subroutine m_Iter_rd_iteration_numbers(nfcntn,icond)
    integer, intent(in) :: nfcntn
    integer, intent(in) :: icond
    logical             :: EOF_reach, tag_is_found
    logical :: unitcell_can_change,Uramping,isSCDFT

    if(mype==0) then
       call rewind_to_tag0(nfcntn,len_tag_iteration,tag_iteration &
            &, EOF_reach, tag_is_found, str,len_str)
       if(.not.tag_is_found) then
          stop ' tag_iteration is not found'
       else
          if(.not.unitcell_can_change())then
             if(Uramping()) then
               read(nfcntn,*) iteration, iteration_uramp,iteration_ionic, iteration_electronic
             else if (isSCDFT())then
               read(nfcntn,*) iteration, iteration_scdft,iteration_ionic, iteration_electronic
             else
               read(nfcntn,*) iteration, iteration_ionic, iteration_electronic
             endif
          else
             read(nfcntn,*) iteration, iteration_unit_cell, iteration_ionic, iteration_electronic
          endif
!          if(icond==COORDINATE_CONTINUATION.and.iteration_electronic>0) then
!             iteration=iteration-iteration_electronic
!             iteration_electronic=0
!          endif
       endif
    endif
    if(npes > 1) then
       call mpi_bcast(iteration,1 &
            & ,mpi_integer,0,mpi_comm_group,ierr)
       call mpi_bcast(iteration_ionic,1 &
            & ,mpi_integer,0,mpi_comm_group,ierr)
       call mpi_bcast(iteration_electronic,1 &
            & ,mpi_integer,0,mpi_comm_group,ierr)
       if(unitcell_can_change()) call mpi_bcast(iteration_unit_cell,1 &
            & ,mpi_integer,0,mpi_comm_group,ierr)
       if(Uramping()) call mpi_bcast(iteration_uramp,1 &
            & ,mpi_integer,0,mpi_comm_group,ierr)
       if(isSCDFT()) call mpi_bcast(iteration_scdft,1 &
            & ,mpi_integer,0,mpi_comm_group,ierr)
    end if
    first_iteration_of_this_job = iteration
!!$    iteration_ionic =  iteration_ionic + 1
  end subroutine m_Iter_rd_iteration_numbers

!!$  subroutine m_Iter_rd_iters_and_nk(icon,nfcntn,nspin)
  subroutine m_Iter_rd_iters_and_nk(nfcntn,nspin)
    integer, intent(in) :: nfcntn, nspin
    logical             :: EOF_reach, tag_is_found

!!$    write(6,'(" !! iconvergence = ",i6)') icon
!!$    if(icon < EK_CONVERGED) then
       if(mype==0) then
          call rewind_to_tag0(nfcntn,len_tag_iters_and_nk,tag_iters_and_nk &
               &, EOF_reach, tag_is_found, str,len_str)
          if(.not.tag_is_found) then
             stop ' tag_iters_and_nk is not found'
          else
             read(nfcntn,*) iteration, iteration_electronic, nk_in_the_process
          endif
       endif
       if(npes > 1) then
          call mpi_bcast(iteration,           1,mpi_integer,0,mpi_comm_group,ierr)
          call mpi_bcast(iteration_electronic,1,mpi_integer,0,mpi_comm_group,ierr)
          call mpi_bcast(nk_in_the_process,   1,mpi_integer,0,mpi_comm_group,ierr)
       end if
!!$    else
!!$       iteration = 1; iteration_electronic = 1; nk_in_the_process = 1
!!$    end if
    if(mype==0) then
         write(6,'(" !! iteration, iteration_electronic, nk_in_the_process = ",3i6)')&
         & iteration, iteration_electronic, nk_in_the_process
    end if
    first_iteration_of_this_job = iteration
    first_iteration_electronic  = iteration_electronic
    first_kpoint_in_this_job    = nk_in_the_process
    nk_converged                = first_kpoint_in_this_job - 1
    iteration_electronic = iteration_electronic - 1
    nk_in_the_process    = nk_in_the_process - nspin*nrank_k
!!$    iteration_ionic =  iteration_ionic + 1
  end subroutine m_Iter_rd_iters_and_nk

  subroutine m_Iter_wd_iters_and_nk(nfcntn)
    integer, intent(in) :: nfcntn
    if(mype==0) then
       write(nfcntn,*) tag_iters_and_nk
       write(nfcntn,'(3i10)') iteration, iteration_electronic, nk_in_the_process
    end if
  end subroutine m_Iter_wd_iters_and_nk

  subroutine m_Iter_set_converged_nk(nspin)
    integer, intent(in) :: nspin
    nk_converged = nk_in_the_process + nspin-1
  end subroutine m_Iter_set_converged_nk

  subroutine m_Iter_nk_incre(incre)
    integer, intent(in) :: incre
    integer :: aincre
    if(incre == 2 .and. nk_in_the_process == 0) then
       aincre = 1
    else
       aincre = incre
    end if
    nk_in_the_process = nk_in_the_process + aincre
  end subroutine m_Iter_nk_incre

  subroutine m_Iter_nk_incre2(incre,kv3_ek)
    integer, intent(in) :: incre,kv3_ek
    integer :: aincre
    if(nk_in_the_process == 0) then
       aincre = 1
    else
       aincre = nrank_k*incre
    end if
    nk_in_the_process = nk_in_the_process + aincre
    if(nk_in_the_process > kv3_ek+1) nk_in_the_process = kv3_ek + 1
    nkgroup = nkgroup+1
  end subroutine m_Iter_nk_incre2

  subroutine m_Iter_nkgroup_incre()
    nkgroup=nkgroup+1
  end subroutine m_Iter_nkgroup_incre

  subroutine m_Iter_wd_nk(nfout)
    integer, intent(in) :: nfout
    if(mype==0) then
       write(nfout,*)
       write(nfout,'(" ------------------------")')
       write(nfout,'(" nk_in_the_process = ",i6)') nk_in_the_process
    end if
  end subroutine m_Iter_wd_nk

  subroutine m_Iter_wd_nk2(nfout,kv3)
    integer, intent(in) :: nfout,kv3
    if(mype==0) then
       write(nfout,*)
       write(nfout,'(" ------------------------")')
       write(nfout,'(" nk_in_the_process = ",i6, " nk in the k_point_group = ",i6)') &
            & nk_in_the_process, nk_in_the_process+kv3-1
       write(nfout,'(" nkgroup = ",i6)') nkgroup
    end if
  end subroutine m_Iter_wd_nk2

  subroutine m_Iter_mdIterN_increment()
    iteration_ionic   = iteration_ionic + 1
    if(mype==0) then
       write(6,*) ' ! iteration_ionic = ', iteration_ionic
    end if
  end subroutine m_Iter_mdIterN_increment

  subroutine m_Iter_scdftIterN_increment()
    iteration_scdft  = iteration_scdft + 1
    if(mype==0) then
       write(6,*) ' ! iteration_scdft = ', iteration_scdft
    end if
  end subroutine m_Iter_scdftIterN_increment

  subroutine m_Iter_unitcell_increment()
    iteration_unit_cell = iteration_unit_cell + 1
  end subroutine m_Iter_unitcell_increment

  subroutine m_Iter_stress_correction_incre()
    iteration_stress_correction = iteration_stress_correction + 1
  end subroutine m_Iter_stress_correction_incre

  subroutine m_Iter_uramp_increment()
    iteration_uramp = iteration_uramp + 1
  end subroutine m_Iter_uramp_increment

  subroutine m_Iter_electronic_reset()
    iteration_electronic = 0
    iteration_for_cmix   = 0
  end subroutine m_Iter_electronic_reset
  
  subroutine m_Iter_cmix_reset()
    iteration_for_cmix  = 0
  end subroutine m_Iter_cmix_reset

  subroutine m_Iter_electronic_set()
    iteration_electronic = first_iteration_electronic
  end subroutine m_Iter_electronic_set

!!$  subroutine m_Iter_nkgroup_set(kv3)
!!$    integer, intent(in) :: kv3
!!$    nkgroup = (nk_in_the_process-1)/kv3
!!$  end subroutine m_Iter_nkgroup_set

  subroutine m_Iter_wd_electronic(nfout)
    integer, intent(in) :: nfout
    if(mype==0) then
       write(nfout,'(" iteration_electronic = ",i6)') iteration_electronic
    end if
  end subroutine m_Iter_wd_electronic

  subroutine m_Iter_initialize
    iteration = 0
  end subroutine m_Iter_initialize

  subroutine m_Iter_electronic_incre
    iteration_electronic = iteration_electronic + 1
    iteration_for_cmix   = iteration_for_cmix   + 1
  end subroutine m_Iter_electronic_incre

  subroutine m_Iter_total_increment
    iteration = iteration + 1
  end subroutine m_Iter_total_increment

  subroutine m_Iter_set_rmm_start
    iteration_rmm_start = iteration_electronic
  end subroutine m_Iter_set_rmm_start

  subroutine m_Iter_positron_incre()
    iteration_positron_wf = iteration_positron_wf + 1
  end subroutine m_Iter_positron_incre

  subroutine m_Iter_positron_set()
    iteration_positron_wf = 0
  end subroutine m_Iter_positron_set

end module m_IterationNumbers

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 570 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a collection of subroutines called in the main program.
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.  
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

!--------------------------------------------------------
!!
!!!           Copy Wfns etc . 
!!
!---------------------------------------------------------
subroutine Copy_Wfn_etc_To_WorkArray( nq )
  use m_LinearResponse_tools,  only : Copy_Zaj_To, Copy_MapZ_To, &
       &                              Copy_NBase_To, Copy_IGf_To, &
       &                              Copy_Iba_To, Copy_Occups_To, &
       &                              Copy_HardPart_To, Copy_EigenVals_To
  use m_LinearResponse_tools,  only : wfn_k, wfn_kmq, map_z_k, map_z_kmq, &
       &                              nbase_k, nbase_kmq, igf_k, igf_kmq, &
       &                              iba_k, iba_kmq, occup_k, occup_kmq, &
       &                              fsval_k, fsval_kmq, &
       &                              eko_k, eko_kmq
  use m_LinearResponse_Control,  only : nrd_efermi, sw_LongWaveLimit
  use m_Const_Parameters,       only : ON, OFF

  use m_PseudoPotential,        only : modnrm
  use m_Const_Parameters,       only : EXECUT  
  use m_Timing,                     only : tstatc0_begin, tstatc0_end

  implicit none
! ----------------------------------------------------
  integer, intent(in)         ::    nq
  integer :: id_sname = -1
! ---------------------------------- start ------------
  call tstatc0_begin('Copy_Wfn_etc_To_WorkArray ', id_sname)
!
  if ( sw_LongWaveLimit == OFF ) then
     if ( nq == 0 ) then
        call Copy_Zaj_To( wfn_k );     call Copy_MapZ_To( map_z_k )
        call Copy_NBase_To( nbase_k ); call Copy_IGf_To( igf_k )
        call Copy_Iba_To( iba_k )
        if ( nrd_efermi==1 )  call Copy_Occups_To( occup_k )
        if ( modnrm==EXECUT ) call Copy_HardPart_To( fsval_k )
     else
        call Copy_Zaj_To( wfn_kmq );     call Copy_MapZ_To( map_z_kmq )
        call Copy_NBase_To( nbase_kmq ); call Copy_IGf_To( igf_kmq )
        call Copy_Iba_To( iba_kmq )
        if ( nrd_efermi==1 ) call Copy_Occups_To( occup_kmq )
        if ( modnrm==EXECUT ) call Copy_HardPart_To( fsval_kmq )
     endif
  else
     if ( nq == 0 ) then
        call Copy_Zaj_To( wfn_k );     call Copy_MapZ_To( map_z_k )
        call Copy_NBase_To( nbase_k ); call Copy_IGf_To( igf_k )
        call Copy_Iba_To( iba_k )
        if ( nrd_efermi==1 ) then
           call Copy_EigenVals_To( eko_k, occup_k )
        else
           call Copy_EigenVals_To( eko_k )
        endif
        if ( modnrm==EXECUT ) call Copy_HardPart_To( fsval_k )
     endif
  endif
  
  call tstatc0_end(id_sname)
  
end subroutine Copy_Wfn_etc_To_WorkArray

!--------------------------------------------------------
!!
!!!   Alloc and Dealloc subroutines
!!
!---------------------------------------------------------
subroutine Alloc_WorkArray_LR1
  use m_LinearResponse_tools,   only : m_LR_alloc_Array_WFns, &
       &                               m_LR_alloc_Array_MapFns,&
       &                               m_LR_alloc_Array_EigenVals, &
       &                               m_LR_alloc_Array_Occups, &
       &                               m_LR_alloc_Array_CorePart
  use m_LinearResponse_Control, only : nrd_efermi
  use m_PseudoPotential,        only : modnrm
  use m_Const_Parameters,       only : EXECUT

  implicit none

  call m_LR_alloc_Array_WFns
  call m_LR_alloc_Array_MapFns
  call m_LR_alloc_Array_EigenVals
  if ( nrd_efermi==1 ) call m_LR_alloc_Array_Occups
  if ( modnrm==EXECUT ) call m_LR_alloc_Array_CorePart
end subroutine Alloc_WorkArray_LR1

subroutine Alloc_WorkArray_LR2
  use m_LinearResponse_Density,   only : m_LR_alloc_Array_Occups_ek, &
       &                               m_LR_alloc_Array_Densities

  implicit none

  call m_LR_alloc_Array_Occups_ek
  call m_LR_alloc_Array_Densities
end subroutine Alloc_WorkArray_LR2

subroutine Free_WorkArray_LR1
  use m_LinearResponse_tools,   only : m_LR_dealloc_Array_WFns, &
       &                               m_LR_dealloc_Array_MapFns,&
       &                               m_LR_dealloc_Array_EigenVals, &
       &                               m_LR_dealloc_Array_Occups, &
       &                               m_LR_dealloc_Array_CorePart
  use m_LinearResponse_Control, only : nrd_efermi
  use m_PseudoPotential,        only : modnrm
  use m_Const_Parameters,       only : EXECUT

  implicit none

  call m_LR_dealloc_Array_WFns
  call m_LR_dealloc_Array_MapFns
  call m_LR_dealloc_Array_EigenVals
  if ( nrd_efermi==1 ) call m_LR_dealloc_Array_Occups
  if ( modnrm==EXECUT ) call m_LR_dealloc_Array_CorePart
  
end subroutine Free_WorkArray_LR1

subroutine Free_WorkArray_LR2
  use m_LinearResponse_Density,   only : m_LR_dealloc_Array_Occups_ek, &
       &                               m_LR_dealloc_Array_Densities

  implicit none
  call m_LR_dealloc_Array_Occups_ek
  call m_LR_dealloc_Array_Densities
end subroutine Free_WorkArray_LR2

!--------------------------------------------------------
!!
!!!   Generate and Delete Q point
!!
!---------------------------------------------------------
subroutine Gen_q_points
  use m_Control_Parameters,       only : Num_q_Points
  use m_LinearResponse_Control,   only : sw_tddft, vqxyz
  use m_LinearResponse_Qpt,       only : q_points_in_BUCS_CARTS

  if ( sw_tddft==1 ) then
     Num_q_Points = 1;
     allocate( vqxyz( Num_q_Points, 3, 2 ) )
     Call q_points_in_BUCS_CARTS
  endif
end subroutine Gen_q_points

subroutine Del_q_points
  use m_LinearResponse_Control,   only : vqxyz
  if ( allocated( vqxyz ) ) Deallocate( vqxyz )
end subroutine Del_q_points

!--------------------------------------------------------
!!
!!!     Initialization and Finalization 
!!
!---------------------------------------------------------
subroutine Initialization_LR
  use m_LinearResponse_Qpt,     only : m_LR_alloc_Vecs_q_plus_G, &
       &                               m_LR_set_Vecs_q_plus_G
  use m_LinearResponse_Qpt,      only : m_LR_alloc_Array_FTQVals, &
       &                                m_LR_calc_FTQ_times_Ylm
  use m_PseudoPotential,         only : modnrm
  use m_Const_Parameters,        only : EXECUT

  use m_Files,                   only : nfout
  use m_LinearResponse_Density,  only : set_ppc_data, &
       &                                Alloc_ptrans, &
       &                                nppcorr, check_PP, &
       &                                Alloc_PP_local_type, &
       &                                Alloc_PP_norm_type, &
       &                                set_ppc_data_it

  use m_Const_Parameters,        only : ON
  use m_LinearResponse_Control,  only : nrd_efermi, sw_LongWaveLimit
  use m_LinearResponse_Qpt,  only : ftqval

! 
  use m_LinearResponse_Control,  only : nmax_G_LR
  use m_PlaneWaveBasisSet,     only : kg0

  implicit none
! ---------------------------- start ----------------
  if ( nrd_efermi==1 ) call Restore_FermiEnergy
  call set_UVSOR_mode_TO( ON )
! 
  if ( nmax_G_LR > kg0 ) nmax_G_LR = kg0
!
  if ( modnrm == EXECUT ) then
     call m_LR_alloc_Array_FTQvals
     call m_LR_calc_FTQ_times_Ylm
  endif
! 
  if ( sw_LongWaveLimit==1 ) then
     call set_nppcorr_to( 2 ) 
     call Alloc_ptrans
!     if ( nppcorr>0 ) call set_ppc_data(nfout)
     if ( nppcorr>0 ) call set_ppc_data_it(nfout)
     call Alloc_PP_norm_type
     call Alloc_PP_local_type
     call check_PP(nfout)
  endif
end subroutine Initialization_LR
   
subroutine Finalization_LR
  use m_LinearResponse_Qpt,  only : m_LR_dealloc_Vecs_q_plus_G, &
       &                            m_LR_dealloc_Array_FTQVals, &
       &                            m_LR_dealloc_Qitg
  use m_PseudoPotential,         only : modnrm
  use m_Const_Parameters,        only : EXECUT
  use m_LinearResponse_Density,  only : Dealloc_Ptrans_Nppc_ilocal_etc, &
       &                                dealloc_PP_local_type, &
       &                                dealloc_PP_norm_type
  use m_LinearResponse_Control,  only : sw_LongWaveLimit
  implicit none
! ------------------------ start ----------------
  call m_LR_dealloc_Vecs_q_plus_G
  if ( modnrm == EXECUT ) then
     call m_LR_dealloc_Qitg
     call m_LR_dealloc_Array_FTQvals
  endif
  if ( sw_LongWaveLimit==1 ) then
     call Dealloc_Ptrans_Nppc_ilocal_etc
     call Dealloc_PP_norm_type
     call Dealloc_PP_local_type
  endif
end subroutine Finalization_LR


subroutine Backup_FermiEnergy
  use m_Electronic_Structure,     only : efermi
  use m_LinearResponse_Control,   only : efermi_backup

  implicit none

  efermi_backup = efermi

end subroutine Backup_FermiEnergy

subroutine Restore_FermiEnergy
  use m_Electronic_Structure,     only : efermi
  use m_LinearResponse_Control,   only : efermi_backup

  implicit none

  efermi = efermi_backup

end subroutine Restore_FermiEnergy

subroutine Set_UVSOR_mode_TO( mode )
  use m_Control_Parameters,       only : uvsormode

  implicit none
  integer, intent(in)  :: mode
  uvsormode = mode

end subroutine Set_UVSOR_mode_TO

subroutine set_nppcorr_to( value )
  use m_LinearResponse_Density, only : nppcorr
  implicit none

  integer, intent(in) :: value
  nppcorr = value

end subroutine set_nppcorr_to

!--------------------------------------------------------
!!
!!!    InputData_Analysis for Linear Response
!!
!--------------------------------------------------------
subroutine InputData_Analysis_LR
  
  use m_Files,                    only : m_Files_reopen_nfinp, nfout
  use m_LinearResponse_Control,   only : m_CtrlP_rd_LinearResponse, &
       &                                 efermi_backup, e_low, e_high, e_step, &
       &                                 nstep, nrd_efermi
  use m_Electronic_Structure,     only : efermi

  implicit none

  call m_Files_reopen_nfinp(1)
  call m_CtrlP_rd_LinearResponse(nfout)
  call m_Files_reopen_nfinp(2)
  call Setup_LinearResponse( nfout, e_low, e_high, e_step, nstep, nrd_efermi, efermi )
  call Backup_FermiEnergy

end subroutine InputData_Analysis_LR

subroutine Setup_LinearResponse( nfout, e_low, e_high, e_step, nstep,  nrd_efermi, efermi )
  use m_Control_Parameters,  only : printable, way_ksample
  use m_Const_Parameters,    only : DP, MESH
  use m_LinearResponse_Control, only : e, nistep, scissor
  use m_LinearResponse_Control, only : way_BZintegral, LORENTZIAN_B, GAUSSIAN_B, &
       &                               L_TETRAHEDRON, width, tetra_eps, eta

  implicit none

  integer, intent(in)     :: nfout
  integer, intent(inout)  :: nrd_efermi
  integer, intent(out)    :: nstep
  
  real(DP), intent(in)    :: efermi
  real(DP), intent(inout) :: e_low, e_high, e_step
  !
  integer                 :: i     
  real(DP)                :: e_range
! --------- fermi level ------------
  if(printable) write(nfout,'(1x,"!* nrd_efermi = ",i3)') nrd_efermi
  if(nrd_efermi==0) then
     if(printable) write(nfout,'(1x,"!* efermi is calculated")')
  else
     if(printable) write(nfout,'(1x,"!* efermi = ",f10.5," read from the input file")') efermi
  end if
  ! -------- -- energy range --
  call allocate_energy_range_matrix
  ! ------------ BZ Intelration --
  call BZ_integration_option  
  ! ----------- band gap correction --
  call scissor_operator_option
  
contains 
  
  subroutine allocate_energy_range_matrix
    
    integer i
    !
    if ( e_step <= 0.0d0 ) then
       e_step = 0.002d0
       if(printable) write(nfout,'(1x,"!* default photon energy step of ",f10.5," is used")') e_step
    end if
    ! set default e_low and e_high if necessary
    if ( e_low <= 0.0d0 .and. e_high <= 0.0d0 ) then
       e_low=0.0d0;   e_high=2.0d0
       if ( printable ) then
          write(nfout,'(1x,"!* lowest and highest energy is 0.0d0")')
          write(nfout,'(1x,"!* default lowest energy of ",f10.5," is used ")') e_low
          write(nfout,'(1x,"!* default highest energy of ",f10.5," is used")') e_high
       end if
    end if
    ! set e array
    e_range = ( e_high-e_low ) / e_step
    nstep = int( e_range ) + 1
    
    allocate( e(nstep) ); e = 0.0d0
       
    e(1) = e_low
    if (nstep.gt.1 ) then
       ! 2007.12.10
       do i=2, nstep
          e(i)=e(1)+e_step*(i-1)
       end do
       !         do i=2, nstep
       !            e(i)=e(i-1)+e_step
       !         end do
       ! 2007.10.12
    end if
    if (printable) write(nfout,'(1x,"!* energy range = ",f12.5," -",f12.5,1x,"au",3x," step = ",f12.5,1x,"au")') &
    & e_low,e_high, e_step
  end subroutine allocate_energy_range_matrix
  
  subroutine BZ_integration_option
    if (printable) &
         & write(nfout,'(1x,"!* way_BZintegral = ",i3)') way_BZintegral
    
    if ( printable ) then
       write(nfout,*) '!* eta = ', eta
       write(nfout,*) '!* width = ', width
    endif
    
    if (way_BZintegral==L_TETRAHEDRON) then
       ! ------------------------------------------------------------
       write(*,*) ' Not supported '
       stop
       ! ------------------------------------------------------------
       ! check mesh type
       if (way_ksample/=MESH) then
          if(printable) then
             write(nfout,'(1x,"!* linear tetrahedron cannot be used for way_ksample = ",i3)') way_ksample
             write(nfout,'(1x,"!* parabolic broadning is used instead ")')
          end if
          way_BZintegral = LORENTZIAN_B
          call set_default_width
       else
          ! check tetra_eps
          if(printable) &
               &  write(nfout,'(1x,"!* Brillouin zone integration method = linear tetrahedron")')
          if(tetra_eps > 0.0d0) then
             if(printable) write(nfout,'(1x,"!* tetra_eps = ",e12.5," hartree")') tetra_eps
          else
             tetra_eps = 1.0d-4
             if(printable) write(nfout,'(1x,"!* tetra_eps =<0.0d0 is read ; tetra_eps =1.0d-4 hartree is set")')
          end if
          ! check nistep
          if(nistep >= 1) then
             if(nistep > nstep) then
                nistep = nstep
                if(printable) then
                   write(nfout,'(1x,"!* nistep = ",i4," is larger than nstep = ",i4)') nistep, nstep
                   write(nfout,'(1x,"!* nistep = ",i4," is set as default.")') nstep
                end if
             else
                if(printable) write(nfout,'(1x,"!* nistep = ",i4)') nistep
             end if
          else
             if(nistep < 1) then
                nistep = nstep
                if(printable) then
                   write(nfout,'(1x,"!* nistep = ",i4," is set as default.")') nstep
                end if
             end if
          end if
       end if
    end if
    
    if (way_BZintegral/=L_TETRAHEDRON) then
       if (printable) then
          if (way_BZintegral==GAUSSIAN_B) then
             write(nfout,'(1x,"!* Brillouin zone integration method = gaussian broadning")')
             if ( width<=0.0d0 ) then
                call set_default_width
             else
                if(printable) &
                     & write(nfout,'(1x,"!* smearing width = ",f10.5)') width
             end if
          end if
          if (way_BZintegral==LORENTZIAN_B) &
               & write(nfout,'(1x,"!* Brillouin zone integration method = Lorentzian broadning")')
       end if
    end if
    
    !!       if(printable) then
    !!          write(nfout,'(1x,"!* spin = ",i3)') spin
    !!          if(spin/=BOTH) then
    !!             if(spin==MAJOR) write(nfout,'(1x,"!* integration for major spin")')
    !!             if(spin==MINOR) write(nfout,'(1x,"!* integration for minor spin")')
    !!          end if
    !!       end if
  end subroutine BZ_integration_option
  
  subroutine set_default_width
    width=0.01837451d0
    if(printable) &
         & write(nfout,'(1x,"!* default smearing width of 0.01837451 Hartree (=0.5eV) is set")')
  end subroutine set_default_width
  
  subroutine scissor_operator_option
    if(scissor/=0.0d0 .and. printable) then
       write(nfout,'(1x,"!* scissor operator = ", f10.5," Hartree ")') scissor
    end if
  end subroutine scissor_operator_option
  
end subroutine Setup_LinearResponse

!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 570 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a module for setting control parameters for the LR-TDDFT .
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.  
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

module m_LinearResponse_Control

  use m_Electronic_Structure,       only : efermi
  use m_Control_Parameters,         only : ipriinputfile, printable, uvsormode
 
  use m_Const_parameters,           only : DP, SP, BUCS, ON, OFF,CARTS, & 
       &              PAI4, PAI2, PAI, FMAXVALLEN, LOWER, BOHR, &
       &              MESH

  use m_Files,                      only : nfout, m_Files_reopen_nfinp
  use m_Kpoints,                    only : way_ksample

  use m_Control_Parameters,          only : sw_LinearResponse

  Implicit None
  include 'mpif.h'
  
! -----------  General ------------------------
  integer                ::         iprilrspectr = 1         !     OFF=0, ON=1
  integer, parameter     ::         OPTICS=0,  PACS=1, EELS=2, IXSS=3
  integer                ::         spectrum_type = OPTICS
! ------------ momentum transfer -------
  real(kind=DP)          ::         vec_q(3), norm_q
  real(kind=DP)          ::         min_norm_q = 1.0D-3
! -----------  TDDFT -------------------------
  integer                ::         sw_tddft  = OFF
  integer                ::         sw_LongWaveLimit  = ON
! ------------ Solver --------
  integer, parameter     ::         DYSON = 0,  BS = 1     
  integer                ::         tddft_eqn_type = DYSON        ! default
! --
  integer                ::         sw_NODA = OFF       ! approximatin in BS eq.
! ------------ Coulomb Kernel ---------
  integer                ::         sw_NLF    = OFF
! <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< EXPERIMENTAL <<<<<<<<<<<<<<<<<
  integer                ::         sw_Coulomb_screening = OFF      ! default
  integer                ::         sw_Fxc_enhanced  = OFF      ! default
  Real(kind=DP)          ::         rcut_yukawa      = 1.0 / Bohr
! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
! ----------- XC Kernel ---------
  integer, parameter     ::         RPA = 0, ALDA_G = 1,  LRC = 2, ALDA_R = 11
  integer                ::         xc_kernel_type = RPA     ! default
  real(kind=DP)          ::         LRC_alpha = 1.0
  real(kind=DP)          ::         LRC_beta  = 1.0
! <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< EXPERIMENTAL <<<<<<<<<<<<<<<<<
  Real(kind=DP)          ::         fxc_enhanced_facotr = 1.0
! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
! ------------ Expansion ----------
  integer                ::         nmax_G_LR = 100        ! default
! ------------ BZ ---------------------
  integer, parameter     ::         LORENTZIAN_B=1,  GAUSSIAN_B=2, L_TETRAHEDRON=3
  integer                ::         way_BZintegral = LORENTZIAN_B
!
  real(kind=DP)          ::         eta = 1.0E-4    ! in hartree unit
!
  integer                ::         nistep, nstep
  real(kind=DP)          ::         width, deltaq, tetra_eps
  real(kind=DP)          ::         scissor = 0.0D0
! ------------- Energy range -------------
  real(kind=DP)          ::         e_low, e_high, e_step
! ------------- Fermi ----------------
  integer                ::         nrd_efermi = 0
  real(kind=DP)          ::         efermi_backup

! ----------------------- Arrays to be allocated -----------
  Real(kind=DP),    allocatable     :: vqxyz( :,:,: )
  real(kind=DP),    allocatable     :: e(:)
!
  integer                ::         ipriqpt = 0
! ---------------------------------------------------------
contains

  subroutine m_CtrlP_rd_LinearResponse( nfout )
    integer, intent(in) :: nfout
! ------------------------------ General ----------------------
    character(len("spectrum")), parameter  ::  tag_spectrum       = "spectrum"
    character(len("LongWaveLimit")),  parameter  ::  tag_longwave  = "LongWaveLimit"
! --
    character(len("type")),     parameter  ::  tag_spectrum_type  = "type"
    character(len("optics")),   parameter  ::  tag_optics         = "optics" 
    character(len("PACS")),     parameter  ::  tag_PACS           = "PACS" 
    character(len("EELS")),     parameter  ::  tag_EELS           = "EELS" 
    character(len("IXSS")),     parameter  ::  tag_IXSS           = "IXSS" 
! ------------------------------- Momentum Transfer ----------
    character(len("momentum_transfer")), parameter  ::  tag_momentum = "momentum_transfer"
    character(len("deltaq")),   parameter  ::  tag_deltaq   = "deltaq"
    character(len("nx")),       parameter  ::  tag_nx       = "nx"
    character(len("ny")),       parameter  ::  tag_ny       = "ny"
    character(len("nz")),       parameter  ::  tag_nz       = "nz"
! ---------------------------------- TDDFT --------------------
    character(len("tddft")),    parameter  ::  tag_tddft    = "tddft"
    character(len("sw_tddft")), parameter  ::  tag_sw_tddft    = "sw_tddft"
! ----------------------------------- Solver ----------------
    character(len("solver")),   parameter  ::  tag_solver  = "solver"
    character(len("equation")),   parameter  ::  tag_equation  = "equation"
    character(len("DYSON")),    parameter  ::  tag_DYSON   = "DYSON"
    character(len("BS")),       parameter  ::  tag_BS      = "BS"
    character(len("sw_NODA")),  parameter  ::  tag_sw_NODA   = "sw_NODA"
! ----------------------------------- Coulomb Kernel -----------
    character(len("Coulomb_Kernel")),parameter  ::  tag_CoulombKernel = "Coulomb_Kernel"
    character(len("sw_NLF")),   parameter  ::  tag_sw_NLF   = "sw_NLF"
! <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< experimenal <<<<<<<<<
    character(len("sw_Coulomb_screening")), parameter :: tag_sw_Coulomb_screening &
         &                                   = "sw_Coulomb_screening"
    character(len("screening_length")),  parameter  ::  tag_screening_length &
         &                                   = "screening_length"
! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
! ---------------------------------- XC Kernel --------------------
    character(len("XC_Kernel")),parameter  ::  tag_XCKernel = "XC_Kernel"
    character(len("kernel_type")), parameter  ::  tag_kernel_type = "kernel_type"
    character(len("RPA")),      parameter  ::  tag_RPA      = "RPA"
    character(len("ALDA-G")),   parameter  ::  tag_ALDA_G   = "ALDA-G"
    character(len("ALDA-R")),   parameter  ::  tag_ALDA_R   = "ALDA-R"
    character(len("LRC")),      parameter  ::  tag_LRC      = "LRC"
    character(len("LRC_alpha")),parameter  ::  tag_LRC_alpha = "LRC_alpha"
    character(len("LRC_beta")), parameter  ::  tag_LRC_beta  = "LRC_beta"
! <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< experimenal <<<<<<<<<
    character(len("sw_Fxc_enhanced")), parameter :: tag_sw_Fxc_enhanced &
         &                                   = "sw_Fxc_enhanced"
! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
! -------------------------------- Expansion --------------
    character(len("Expansion")),parameter  ::  tag_expansion = "expansion"
    character(len("NumGVec")),  parameter  ::  tag_num_GVec  = "NumGvec"
! ----------------------------------- energy -------------------
    character(len("energy")),   parameter  ::  tag_energy   = "energy"
    character(len("low")),      parameter  ::  tag_low      = "low"
    character(len("high")),     parameter  ::  tag_high     = "high"
    character(len("step")),     parameter  ::  tag_step     = "step"
! --------------------------------- BZ integration ------------
    character(len("BZ_integration")), parameter :: tag_BZ_integration = "BZ_integration"
    character(len("method")), parameter         :: tag_method = "method"
!
    character(len("lorentzian")), parameter     :: tag_lorentzian = "lorentzian"
    character(len("l")), parameter              :: tag_l = "l"
!
    character(len("gaussian")), parameter       :: tag_gaussian = "gaussian"
    character(len("g")), parameter              :: tag_g = "g"
    character(len("width")), parameter          :: tag_width = "width"
! ----------------------------- --- not supported ----------------
    character(len("tetrahedron")), parameter    :: tag_tetrahedron = "tetrahedron"
    character(len("t"))                         :: tag_t = "t"
    character(len("nistep")), parameter         :: tag_nistep = "nistep"
    character(len("spin")),  parameter          :: tag_spin  = "spin"
    character(len("both")),  parameter          :: tag_both  = "both"
    character(len("tetra_eps")),parameter       :: tag_tetra_eps = "tetra_eps"
! ------------------------------ band gap correction ----------
    character(len("band_gap_correction")), parameter   ::  tag_band_gap_correction = "band_gap_correction"
    character(len("scissor_operator")), parameter      ::  tag_scissor  = "scissor_operator"
! ----------------------------------- Fermi --------------------
    character(len("on")), parameter              ::  tag_on  = "on"
    character(len("off")), parameter             ::  tag_off = "off"
    character(len("fermi_energy")), parameter    ::  tag_fermi_energy = "fermi_energy"
    character(len("read_efermi")), parameter     ::  tag_read_efermi = "read_efermi"
    character(len("efermi")),parameter           ::  tag_efermi = "efermi"
! --

    character( len=FMAXVALLEN ) :: rstr
    integer :: iret, f_selectBlock, f_selectParentBlock, f_selectTop
    integer :: f_getStringValue, f_getRealValue, f_getIntValue
    real(kind=DP) :: dret
    
! ---------------------------------------------------------------------
! ----------------------------------------- start ---------------------
! ---------------------------------------------------------------------
    iret = f_selectTop()
    if ( ipriinputfile >= 2 .and. printable ) then
       write(nfout,'(" !*  tag_spectrum")')
    endif
    if ( f_selectBlock( tag_spectrum ) == 0 ) then
       sw_LinearResponse = ON
       call Set_Spectrum_Type
       call Set_switch_LongWaveLimit
! ----- momentum transfer
       if ( f_selectBlock( tag_momentum ) == 0 ) then
          call Set_Momentum_Transfer(1)
          iret = f_selectParentBlock()
       else
          call Set_Momentum_Transfer(0)
       endif
! ---- tddft --
       if ( f_selectBlock( tag_tddft ) == 0 ) then
          call Set_switch_TDDFT
          if ( f_selectBlock( tag_solver ) == 0 ) then
             call set_Equation_type
             call Set_switch_NODA
             iret = f_selectParentBlock()
          endif
! ---------------------------- Coulomb Kernel --------
          if ( f_selectBlock( tag_CoulombKernel ) == 0 ) then
             call Set_switch_NLF
! <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< experimental <<<<<<<<<<<<<<<<<
             call set_switch_Coulomb_screening
             call Set_screening_length(1)
! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
             iret = f_selectParentBlock()
          endif
! ---------------------------- XC Kernel --------------
          if ( f_selectBlock( tag_XCKernel ) == 0 ) then
             call Set_XCKernel_Type
! <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< experimental <<<<<<<<<<<<<<<<<
             call set_switch_Fxc_enhanced
! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
             iret = f_selectParentBlock()
          endif
          call Limitation_Equation_Type
! ------------------------------ G-expansion ----------
          if ( f_selectBlock( tag_expansion ) == 0 ) then
             call Set_Num_GVectors(1)
             iret = f_selectParentBlock()
          else
             call Set_Num_GVectors(0)
          endif
          iret = f_selectParentBlock()
       endif
! ------------- Fermi -----------
       if ( f_selectBlock( tag_fermi_energy ) == 0 ) then
          if( f_getStringValue( tag_read_efermi, rstr, LOWER) == 0) then
             call set_efermi(rstr)
          endif
          iret = f_selectParentBlock()
       else
          call Set_FermiLevel_Later
       end if
! --- Energy --
       if ( f_selectBlock( tag_energy ) == 0 ) then
          call set_energy_range
          iret = f_selectParentBlock()
       end if
! --- BZ Integral
       if (f_selectBlock(tag_BZ_integration) == 0 ) then
          call Set_BZ_Integration_Type
          iret = f_selectParentBlock()
       end if
! --- read band gap correction option
       if ( f_selectBlock(tag_band_gap_correction) == 0 ) then
          call set_band_gap_correction
          iret = f_selectParentBlock()
       end if
       write(nfout,*) '***********************************************'
! --- 
    else
       stop ' tag_spectrum is not given in the input file <<CtrlP_rd_spectrum>> '
    end if
    
  contains

!----------------------------------------------------------------
!!
!!!               Spectrum type
!!
!----------------------------------------------------------------
    subroutine Set_Spectrum_Type
      logical :: tf

      write(nfout,*) '*************************** Spectrum ***********'

      if ( f_getStringValue( tag_spectrum_type, rstr, LOWER ) == 0 ) then
         call strncmp0( tag_optics, trim(rstr), tf )
         if(tf) then
            spectrum_type = OPTICS;   goto 1001
         end if
         call strncmp0( tag_PACS, trim(rstr), tf )
         if(tf) then
            spectrum_type = PACS;      goto 1001
         end if
         call strncmp0( tag_EELS, trim(rstr), tf )
         if(tf) then
            spectrum_type = EELS;      goto 1001
         end if
         call strncmp0( tag_IXSS, trim(rstr), tf )
         if(tf) then
            spectrum_type = IXSS;      goto 1001
         end if
         if ( printable ) call Comment_Spectrum_Type( 1 )

1001     continue
         if ( printable ) call Comment_Spectrum_Type( 0 )
      else
         call Comment_Spectrum_Type( -1 )
      endif
    end subroutine Set_Spectrum_Type

    subroutine Comment_Spectrum_Type( icode )
      integer, intent(in) :: icode

      select case( icode )
      case(0)
         write(nfout,'("!* Spectrum type = ",i3)') spectrum_type
         write(nfout,*) "!* ------ 0:Optics; 1:PACS, 2:EELS, 3:IXSS -- "
      case (-1)
         write(nfout,'(1x,"!* tag_spectrum_type is not found")')
         write(nfout,'(1x,"!* spectrum_type is set to OPTICS")')
      case (1)
         write(nfout,'(1x,"!* incorrect words for spectrum_type")')
         write(nfout,'(1x,"!* spectrum type is set to OPTICS")')
      end select

    end subroutine Comment_Spectrum_Type
    
!----------------------------------------------------------------
!!
!!!               LongWaveLimit
!!
!----------------------------------------------------------------
    subroutine Set_switch_LongWaveLimit
      logical :: tf

      if ( f_getStringValue( tag_longwave, rstr, LOWER ) == 0 ) then
         call strncmp0( tag_off, trim(rstr), tf )
         if (tf) then
            sw_LongWaveLimit = OFF; goto 1002
         endif
         call strncmp0( tag_on, trim(rstr), tf )
         if (tf) then
            sw_LongWaveLimit = ON; goto 1002
         endif
         if ( printable ) Call Comment_sw_LongWaveLimit(1)

1002     continue
         if ( printable ) Call Comment_sw_LongWaveLimit(0)
      else
         if ( printable ) Call Comment_sw_LongWaveLimit(-1)
      endif
    end subroutine Set_switch_LongWaveLimit

    subroutine Comment_sw_LongWaveLimit( icode )
      integer, intent(in) :: icode

      select case( icode )
      case(0)
         if ( sw_LongWaveLimit == ON ) then
            write(nfout,'(1x,"!*         LongWaveLimit set ON")')
         else
            write(nfout,'(1x,"!*         LongWaveLimit is set OFF")')
         endif
      case(-1)
         write(nfout,'(1x,"!* tag_longwave is not found")')
         write(nfout,'(1x,"!* LongWaveLimit is set ON as default")')
      case(1)
         write(nfout,'(1x,"!* incorrect words for LongWaveLimit")')
         write(nfout,'(1x,"!* LongWaveLimit is set ON as default")')
      end select

    end subroutine Comment_sw_LongWaveLimit

!----------------------------------------------------------------
!!
!!!               Momentum transfer
!!
!----------------------------------------------------------------
    subroutine Set_Momentum_Transfer( itype )
      integer :: itype
      real(kind=DP) c1
      integer :: f_getRealValue

      select case ( itype )
      case (0)
         vec_q = 0.0d0; vec_q(3) = min_norm_q;
         vec_q = vec_q *Bohr
         call Comment_MomentumTransfer( 0 )
      case (1)
         if ( f_getRealValue( tag_deltaq, dret," " ) == 0 ) norm_q = dret
         if ( f_getRealValue( tag_nx, dret," " ) == 0 ) vec_q(1) = dret
         if ( f_getRealValue( tag_ny, dret," " ) == 0 ) vec_q(2) = dret
         if ( f_getRealValue( tag_nz, dret," " ) == 0 ) vec_q(3) = dret
         
         if ( vec_q(1)**2 +vec_q(2)**2 +vec_q(3)**2 == 0.0d0 ) vec_q = 0.0d0

!      if ( qnorm < qnorm_min .or. sw_LongWaveLimit==ON ) qnorm = qnorm_min
         if ( sw_LongWaveLimit==ON ) norm_q = min_norm_q
! --
         call Comment_MomentumTransfer( 1 )
         norm_q = norm_q *Bohr
         c1 = sqrt( vec_q(1)**2 + vec_q(2)**2 + vec_q(3)**2 )
         vec_q = norm_q * vec_q / c1
      end select

    end subroutine Set_Momentum_Transfer

    subroutine Comment_MomentumTransfer( icode )
      integer, intent(in) :: icode

      select case( icode )
      case(0)
         write(nfout,'(1x,"!* momentum transfer is set to a default value  ",F12.5," Angstrom^(-1)")') min_norm_q
         write(nfout,'(1x,"!*         Direction = ",3F12.5)') 0, 0, 1.0
      case (1)
         write(nfout,'(1x,"!* momentum transfer = ",F12.5," Angstrom^(-1)")') norm_q
         write(nfout,'(1x,"!*         Direction = ",3F12.5)') vec_q(1), vec_q(2), vec_q(3)
      end select
      
    end subroutine Comment_MomentumTransfer
    
!----------------------------------------------------------------
!!
!!!               TDDFT
!!
!----------------------------------------------------------------
    subroutine set_switch_TDDFT
      logical :: tf

      if ( f_getStringValue( tag_sw_tddft, rstr, LOWER ) == 0 ) then
         call strncmp0( tag_off, trim(rstr), tf )
         if (tf) then
            sw_tddft = OFF; goto 1003
         endif
         call strncmp0( tag_on, trim(rstr), tf )
         if (tf) then
            sw_tddft = ON; goto 1003
         endif
         if ( printable ) Call Comment_sw_tddft(1)
1003     continue
         if ( printable ) Call Comment_sw_tddft(0)
      else
         if ( printable ) Call Comment_sw_tddft(-1)
      endif
    end subroutine set_switch_TDDFT

    subroutine Comment_sw_tddft( icode )
      integer, intent(in) :: icode

      select case(icode)
      case(0)
         if ( sw_tddft == ON ) then
            write(nfout,*) "!* sw_tddft is set to ON"
         else
            write(nfout,*) "!* sw_tddft is set to OFF"
         endif
      case(-1)
         write(nfout,'(1x,"!* tag_sw_tddft is not found")')
         write(nfout,'(1x,"!* sw_tddft is set OFF as default")')
      case(1)
         write(nfout,'(1x,"!* incorrect words for sw_tddft")')
         write(nfout,'(1x,"!* sw_tddft is set OFF as default")')
      end select
    end subroutine Comment_sw_tddft

!----------------------------------------------------------------
!!
!!!               Solver       ( Dyson or BS )
!!
!----------------------------------------------------------------
    subroutine Set_Equation_Type
      logical :: tf

      if ( f_getStringValue( tag_equation, rstr, LOWER ) == 0 ) then
         call strncmp0( tag_DYSON, trim(rstr), tf )
         if(tf) then
            tddft_eqn_type  = DYSON;   goto 1006
         end if
         call strncmp0( tag_BS, trim(rstr), tf )
         if(tf) then
            tddft_eqn_type = BS;   goto 1006
         end if

         call Comment_Equation_Type(1)
!
1006     continue
         call Comment_Equation_Type(0)
      else
         call Comment_Equation_Type(-1)
      endif
    end subroutine Set_Equation_Type

    subroutine Comment_Equation_Type( icode )
      integer, intent(in) :: icode

      select case(icode)
      case(0)
         write(nfout,'("!* TDDFT Solver = ",i3)') tddft_eqn_type
         write(nfout,'(1x,"!*         DYSON_like : 0,  BS_like : 1  ")')
      case(-1)
         write(nfout,'(1x,"!* tag_equation is not found")')
         write(nfout,'(1x,"!* tddft_eqn_type is set to DYSON_like")')
      case (1)
         write(nfout,'(1x,"!* incorrect words for tag_solver")')
         write(nfout,'(1x,"!* tddft_eqn_type is set to DYSON_like")')
      end select
    end subroutine Comment_Equation_Type

    subroutine Limitation_Equation_Type
      if ( tddft_eqn_type == BS ) then
         if ( xc_kernel_type /= ALDA_R .and. xc_kernel_type /= RPA ) then
            write(nfout,'(1x,"!** BS_Like equation is supported with xc_kernel = ALDA_R/RPA")')
            stop
         endif
      endif
    end subroutine Limitation_Equation_Type

    subroutine Set_switch_NODA           ! Neglect Off-Diagonal Approximation
      logical :: tf

      if ( tddft_eqn_type /= BS ) return

      if ( f_getStringValue( tag_sw_NODA, rstr, LOWER ) == 0 ) then
         call strncmp0( tag_off, trim(rstr), tf )
         if (tf) then
            sw_NODA = OFF; goto 1011
         endif
         call strncmp0( tag_on, trim(rstr), tf )
         if (tf) then
            sw_NODA = ON; goto 1011
         endif
         if ( printable ) Call Comment_sw_NODA(1)
1011     continue
         if ( printable ) Call Comment_sw_NODA(0)
      else
         if ( printable ) Call Comment_sw_NODA(-1)
      endif
    end subroutine Set_switch_NODA

    subroutine Comment_sw_NODA( icode )
      integer, intent(in) :: icode

      select case(icode)
      case(0)
         if ( sw_NODA == ON ) then
            write(nfout,*) "!* sw_NODA is set to ON"
         else
            write(nfout,*) "!* sw_NODA is set to OFF"
         endif
      case(-1)
         write(nfout,'(1x,"!* tag_sw_NODA is not found")')
         write(nfout,'(1x,"!* sw_NODA is set OFF as default")')
      case(1)
         write(nfout,'(1x,"!* incorrect words for sw_NODA")')
         write(nfout,'(1x,"!* sw_NODA is set OFF as default")')
      end select
    end subroutine Comment_sw_NODA

!----------------------------------------------------------------
!!
!!!              Coulomb Kernel
!!
!----------------------------------------------------------------
    subroutine Set_switch_NLF
      logical :: tf

      if ( f_getStringValue( tag_sw_NLF, rstr, LOWER ) == 0 ) then
         call strncmp0( tag_off, trim(rstr), tf )
         if (tf) then
            sw_NLF = OFF; goto 1004
         endif
         call strncmp0( tag_on, trim(rstr), tf )
         if (tf) then
            sw_NLF = ON; goto 1004
         endif
         if ( printable ) Call Comment_sw_NLF(1)
1004     continue
         if ( printable ) Call Comment_sw_NLF(0)
      else
         if ( printable ) Call Comment_sw_NLF(-1)
      endif
    end subroutine Set_switch_NLF

    subroutine Comment_sw_NLF( icode )
      integer, intent(in) :: icode

      select case(icode)
      case(0)
         if ( sw_NLF == ON ) then
            write(nfout,*) "!* sw_NLF is set to ON"
         else
            write(nfout,*) "!* sw_NLF is set to OFF"
         endif
      case(-1)
         write(nfout,'(1x,"!* tag_sw_NLF is not found")')
         write(nfout,'(1x,"!* sw_NLF is set OFF as default")')
      case(1)
         write(nfout,'(1x,"!* incorrect words for sw_NLF")')
         write(nfout,'(1x,"!* sw_NLF is set OFF as default")')
      end select
    end subroutine Comment_sw_NLF

! <<<<<<<<<<<<<<<<<<<<<<<<<<<<<< EXPERIMENTAL <<<<<<<<<<<<<<<<<<<<<<<
    subroutine Set_switch_Coulomb_Screening
      logical :: tf

      if ( f_getStringValue( tag_sw_Coulomb_screening, rstr, LOWER ) == 0 ) then
         call strncmp0( tag_off, trim(rstr), tf )
         if (tf) then
            sw_Coulomb_screening = OFF; goto 1012
         endif
         call strncmp0( tag_on, trim(rstr), tf )
         if (tf) then
            sw_Coulomb_screening = ON; goto 1012
         endif
         if ( printable ) Call Comment_sw_Coulomb_Screening(1)
1012     continue
         if ( printable ) Call Comment_sw_Coulomb_Screening(0)
      else
         if ( printable ) Call Comment_sw_Coulomb_Screening(-1)
      endif
    end subroutine Set_switch_Coulomb_Screening

    subroutine Comment_sw_Coulomb_Screening( icode )
      integer, intent(in) :: icode
      
      select case(icode)
      case(0)
         if ( sw_Coulomb_Screening == ON ) then
            write(nfout,*) "!* sw_Coulomb_Screening is set to ON"
         else
            write(nfout,*) "!* sw_Coulomb_Screening is set to OFF"
         endif
      case(-1)
         write(nfout,'(1x,"!* tag_sw_Coulomb_Screening is not found")')
         write(nfout,'(1x,"!* sw_Coulomb_Screening is set OFF as default")')
      case(1)
         write(nfout,'(1x,"!* incorrect words for sw_Coulomb_Screeing")')
         write(nfout,'(1x,"!* sw_Coulomb_Screening is set OFF as default")')
      end select
    end subroutine Comment_sw_Coulomb_Screening

    subroutine Set_screening_length( icode )
      integer, intent(in) :: icode
      integer :: f_getRealValue

      if ( sw_Coulomb_Screening == OFF ) return

      select case(icode)
      case(0)
         call Comment_screening_length(-2)
      case(1)
         if ( f_getRealValue( tag_screening_length, dret, "" ) == 0 ) then
            rcut_yukawa = dret
            call Comment_screening_length(0)
         else
            call Comment_screening_length(-1)
         endif
      end select

    end subroutine Set_screening_length

    subroutine Comment_screening_length( icode )
      integer, intent(in) :: icode
      
      select case(icode)
      case(0)
         write(nfout,*) "!* The screening lengh is set to ", rcut_yukawa, " bohr"
      case(-1)
         write(nfout,*) "!* tag_screening_length is not found"
         write(nfout,*) "!* The screening length is set to a default value ", rcut_yukawa
      case(-2)
         write(nfout,*) "!* tag_screening_length is not found"
         write(nfout,*) "!* The screening length is set to a default value ", rcut_yukawa
      end select
    end subroutine Comment_screening_length

! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

!----------------------------------------------------------------
!!
!!!              Exchange correlatio Kernel
!!
!----------------------------------------------------------------
    subroutine Set_XCKernel_Type
      logical :: tf

      if ( f_getStringValue( tag_kernel_type, rstr, LOWER ) == 0 ) then
         call strncmp0( tag_RPA, trim(rstr), tf )
         if(tf) then
            xc_kernel_type = RPA;   goto 1005
         end if
         call strncmp0( tag_ALDA_G, trim(rstr), tf )
         if(tf) then
            xc_kernel_type = ALDA_G;      goto 1005
         end if
         call strncmp0( tag_ALDA_R, trim(rstr), tf )
         if(tf) then
            xc_kernel_type = ALDA_R;      goto 1005
         end if
         call strncmp0( tag_LRC, trim(rstr), tf )
         if(tf) then
            xc_kernel_type = LRC;      goto 1005
         end if

         call Comment_XCKernel_Type(1)
!
1005     continue
         call Comment_XCKernel_Type(0)
         if ( xc_kernel_type == LRC ) call Set_XCKernel_Param_LRC
      else
         call Comment_XCKernel_Type(-1)
      endif
    end subroutine Set_XCKernel_Type

    subroutine Comment_XCKernel_Type( icode )
      integer, intent(in) :: icode

      select case(icode)
      case(0)
         write(nfout,'(" !* XC Kernel type = ",i3)') xc_kernel_type
         write(nfout,'(1x,"!*         RPA : 0,  ALDA-G : 1, LRC : 2  ")')
         write(nfout,'(1x,"!*                   ALAD-R :11  ")')
      case(-1)
         write(nfout,'(1x,"!* tag_xc_kernel is not found")')
         write(nfout,'(1x,"!* xc_kernel_type is set to RPA")')
      case (1)
         write(nfout,'(1x,"!* incorrect words for xc_kernel")')
         write(nfout,'(1x,"!* xc_kernel_type is set to RPA")')
      end select
    end subroutine Comment_XCKernel_Type

    subroutine Set_XCKernel_Param_LRC
      integer :: f_getRealValue

      if ( f_getRealValue( tag_LRC_alpha, dret,"" ) == 0 ) then
         LRC_alpha = dret
         call Comment_XCKernel_LRC(0)
      else
         call Comment_XCKernel_LRC(20)
      endif
    end subroutine Set_XCKernel_Param_LRC

    subroutine Comment_XCKernel_LRC( icode )
      integer, intent(in) :: icode
      
      select case(icode)
      case(0)
         write(nfout,*) "!* LRC_alpha is set to", LRC_alpha         
      case(20)
         write(nfout,*) "!* tag_LRC_alpha is not found"
         write(nfout,*) "!* The parameter LRC_alpha is set to a dafault value", LRC_alpha
      end select
    end subroutine Comment_XCKernel_LRC

! <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< EXPERIMENTAL <<<<<<<<<<<<<<<<<<<<<<
    subroutine Set_switch_Fxc_enhanced
      logical :: tf

      if ( f_getStringValue( tag_sw_Fxc_enhanced, rstr, LOWER ) == 0 ) then
         call strncmp0( tag_off, trim(rstr), tf )
         if (tf) then
            sw_Fxc_enhanced = OFF; goto 1015
         endif
         call strncmp0( tag_on, trim(rstr), tf )
         if (tf) then
            sw_Fxc_enhanced = ON; goto 1015
         endif
         if ( printable ) Call Comment_sw_Fxc_enhanced(1)
1015     continue
         if ( printable ) Call Comment_sw_Fxc_enhanced(0)
      else
         if ( printable ) Call Comment_sw_Fxc_enhanced(-1)
      endif
    end subroutine Set_switch_Fxc_enhanced

    subroutine Comment_sw_Fxc_enhanced( icode )
      integer, intent(in) :: icode
      
      select case(icode)
      case(0)
         if ( sw_Fxc_enhanced == ON ) then
            write(nfout,*) "!* sw_Fxc_enhanced is set to ON"
         else
            write(nfout,*) "!* sw_Fxc_enhanced is set to OFF"
         endif
      case(-1)
         write(nfout,'(1x,"!* tag_sw_Fxc_enhanced is not found")')
         write(nfout,'(1x,"!* sw_Fxc_enhanced set OFF as default")')
      case(1)
         write(nfout,'(1x,"!* incorrect words for sw_Fxc_enhanced")')
         write(nfout,'(1x,"!* sw_Fxc_enhanced set OFF as default")')
      end select
    end subroutine Comment_sw_Fxc_enhanced
    
! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

!----------------------------------------------------------------
!!
!!!              G-expansion
!!
!----------------------------------------------------------------
    subroutine Set_Num_GVectors( icode )
      integer, intent(in) :: icode
      integer :: f_getIntValue

      select case(icode)
      case(0)
         call Comment_GVecTruncated(-2)
      case(1)
         if ( f_getIntValue( tag_Num_GVec, iret ) == 0 ) then
            nmax_G_LR = iret
            call Comment_GVecTruncated(0)
         else
            call Comment_GVecTruncated(-1)
         endif
      end select

    end subroutine Set_Num_GVectors

    subroutine Comment_GVecTruncated( icode )
      integer, intent(in) :: icode
      
      select case(icode)
      case(0)
         write(nfout,*) "!* The number of G-Vector is limited to ", nmax_G_LR
         write(nfout,*) "!* This value may be changed later, depending on kgp"
      case(-1)
         write(nfout,*) "!* tag_Num_GVec is not found"
         write(nfout,*) "!* The number of G-Vector is set to a default value ", nmax_G_LR
      case(-2)
         write(nfout,*) "!* tag_trunctated is not found"
         write(nfout,*) "!* The number of G-Vector is set to a default value ", nmax_G_LR
      end select
    end subroutine Comment_GVecTruncated

!----------------------------------------------------------------
!!
!!!               Fermi ????????????
!!
!----------------------------------------------------------------
    subroutine Set_FermiLevel_Later
      write(nfout,*) "!* Fermi energy is set later"
    end subroutine Set_FermiLevel_Later

! ------------------------------------------------------------------
!!
!!! ---------------  Fermi, Range, BZ, Scissor  ----------------
!!
! ------------------------------------------------------------------

    subroutine set_efermi(rstr)
      character(len=FMAXVALLEN),intent(in) :: rstr

      integer :: f_getRealValue
      logical :: tf

      call strncmp0(tag_off, trim(rstr), tf)
      if(tf) then
         nrd_efermi=0;  goto 1001
      end if
      call strncmp0(tag_on, trim(rstr), tf)
      if(tf) then
         nrd_efermi=1
         if( f_getRealValue( tag_efermi, dret,'hartree') == 0) efermi=dret
         goto 1001
      end if
1001  if ( printable ) then
         write(nfout,'(1x,"!* nrd_efermi = ",i3)') nrd_efermi
         write(nfout,'(1x,"!*     Fermi level is set to ",f15.8)') efermi
      endif
      
    end subroutine set_efermi
      
    subroutine set_energy_range
      integer :: f_getRealValue
      if( f_getRealValue( tag_low, dret, 'hartree') == 0)  e_low=dret
      if( f_getRealValue( tag_high, dret,'hartree') == 0) e_high=dret
      if( f_getRealValue( tag_step, dret,'hartree') == 0) e_step=dret
      !       write(*,*) 'e_low = ', e_low, e_high, e_step
    end subroutine set_energy_range

    subroutine Set_BZ_Integration_Type
      integer :: f_getRealValue, f_getIntValue

      if ( f_getStringValue( tag_method, rstr, LOWER) == 0 ) call set_integration_method(rstr)
      if ( way_BZintegral == LORENTZIAN_B ) then
         if( f_getRealValue( tag_width, dret, 'hartree' ) == 0) then
            if ( dret > 0.0 ) then 
               eta = dret
            endif
         endif
      end if
      if ( way_BZintegral == GAUSSIAN_B ) then
         if( f_getRealValue( tag_width, dret, 'hartree' ) == 0) width = dret
      end if
      if ( way_BZintegral==L_TETRAHEDRON ) then
         if( f_getIntValue( tag_nistep, iret) == 0) nistep=iret
         if( f_getRealValue( tag_tetra_eps, dret, 'hartree' ) == 0) tetra_eps=dret
      end if
    end subroutine Set_BZ_Integration_Type

    subroutine set_integration_method(rstr)
      character(len=FMAXVALLEN),intent(in) :: rstr
      logical :: tf
      way_BZintegral = LORENTZIAN_B
      
      call strncmp0(tag_lorentzian, trim(rstr), tf)
      if(tf) then
         way_BZintegral = LORENTZIAN_B
         goto 1001
      end if
      call strncmp0(tag_l, trim(rstr), tf)
      if(tf) then
         way_BZintegral = L_TETRAHEDRON
         goto 1001
      end if
!
      call strncmp0(tag_gaussian,trim(rstr),tf)
      if(tf) then
         way_BZintegral = GAUSSIAN_B
         goto 1001
      end if
      call strncmp0(tag_g,trim(rstr),tf)
      if(tf) then
         way_BZintegral = GAUSSIAN_B
         goto 1001
      end if

      call strncmp0(tag_tetrahedron, trim(rstr), tf)
      if(tf) then
         way_BZintegral = L_TETRAHEDRON
         goto 1001
      end if
      call strncmp0(tag_t, trim(rstr), tf)
      if(tf) then
         way_BZintegral = L_TETRAHEDRON
         goto 1001
      end if
      
      stop ' ! tag for BZ_integration method is invalid <<m_CtrlP_rd_LinearResponse>>'
1001  continue
      if ( ipriinputfile >= 2 .and. printable) then
         write(nfout,'(" !* Brillouin zone integration  method = ",a10)') trim(rstr)
      endif
      
    end subroutine set_integration_method

    subroutine set_band_gap_correction
      integer f_getRealValue
      if( f_getRealValue( tag_scissor, dret, 'hartree') == 0) then
         scissor=dret
      else
         scissor=0.0d0
      end if
    end subroutine set_band_gap_correction
    
   end subroutine m_CtrlP_rd_LinearResponse
   

 end module m_LinearResponse_Control

      SUBROUTINE PDLAED0( N, D, E, Q, IQ, JQ, DESCQ, WORK, IWORK, INFO )
*
*  -- ScaLAPACK auxiliary routine (version 1.7) --
*     University of Tennessee, Knoxville, Oak Ridge National Laboratory,
*     and University of California, Berkeley.
*     December 31, 1998
*
*     .. Scalar Arguments ..
      INTEGER            INFO, IQ, JQ, N
*     ..
*     .. Array Arguments ..
      INTEGER            DESCQ( * ), IWORK( * )
      DOUBLE PRECISION   D( * ), E( * ), Q( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  PDLAED0 computes all eigenvalues and corresponding eigenvectors of a
*  symmetric tridiagonal matrix using the divide and conquer method.
*
*
*  Arguments
*  =========
*
*  N       (global input) INTEGER
*          The order of the tridiagonal matrix T.  N >= 0.
*
*  D       (global input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, the diagonal elements of the tridiagonal matrix.
*          On exit, if INFO = 0, the eigenvalues in descending order.
*
*  E       (global input/output) DOUBLE PRECISION array, dimension (N-1)
*          On entry, the subdiagonal elements of the tridiagonal matrix.
*          On exit, E has been destroyed.
*
*  Q       (local output) DOUBLE PRECISION array,
*          global dimension (N, N),
*          local dimension ( LLD_Q, LOCc(JQ+N-1))
*          Q  contains the orthonormal eigenvectors of the symmetric
*          tridiagonal matrix.
*          On output, Q is distributed across the P processes in block
*          cyclic format.
*
*  IQ      (global input) INTEGER
*          Q's global row index, which points to the beginning of the
*          submatrix which is to be operated on.
*
*  JQ      (global input) INTEGER
*          Q's global column index, which points to the beginning of
*          the submatrix which is to be operated on.
*
*  DESCQ   (global and local input) INTEGER array of dimension DLEN_.
*          The array descriptor for the distributed matrix Z.
*
*
*  WORK    (local workspace ) DOUBLE PRECISION array, dimension (LWORK)
*          LWORK = 6*N + 2*NP*NQ, with
*          NP = NUMROC( N, MB_Q, MYROW, IQROW, NPROW )
*          NQ = NUMROC( N, NB_Q, MYCOL, IQCOL, NPCOL )
*          IQROW = INDXG2P( IQ, NB_Q, MYROW, RSRC_Q, NPROW )
*          IQCOL = INDXG2P( JQ, MB_Q, MYCOL, CSRC_Q, NPCOL )
*
*  IWORK   (local workspace/output) INTEGER array, dimension (LIWORK)
*          LIWORK = 2 + 7*N + 8*NPCOL
*
*  INFO    (global output) INTEGER
*          = 0:  successful exit
*          < 0:  If the i-th argument is an array and the j-entry had
*                an illegal value, then INFO = -(i*100+j), if the i-th
*                argument is a scalar and had an illegal value, then
*                INFO = -i.
*          > 0:  The algorithm failed to compute the INFO/(N+1) th
*                eigenvalue while working on the submatrix lying in
*                global rows and columns mod(INFO,N+1).
*
*  =====================================================================
*
*     .. Parameters ..
*
      INTEGER            BLOCK_CYCLIC_2D, DLEN_, DTYPE_, CTXT_, M_, N_,
     $                   MB_, NB_, RSRC_, CSRC_, LLD_
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1,
     $                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, ID, IDCOL, IDROW, IID, IINFO, IIQ, IM1, IM2,
     $                   IPQ, IQCOL, IQROW, J, JJD, JJQ, LDQ, MATSIZ,
     $                   MYCOL, MYROW, N1, NB, NBL, NBL1, NPCOL, NPROW,
     $                   SUBPBS, TSUBPBS
*     ..
*     .. External Subroutines ..
      EXTERNAL           BLACS_GRIDINFO, DGEBR2D, DGEBS2D, DGERV2D,
     $                   DGESD2D, DSTEQR, INFOG2L, PDLAED1, PXERBLA
*     ..
*     .. External Functions ..
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MIN
*     ..
*     .. Executable Statements ..
*
*       This is just to keep ftnchek and toolpack/1 happy
      IF( BLOCK_CYCLIC_2D*CSRC_*CTXT_*DLEN_*DTYPE_*LLD_*MB_*M_*NB_*N_*
     $    RSRC_.LT.0 )RETURN
*
*     Test the input parameters.
*
      CALL BLACS_GRIDINFO( DESCQ( CTXT_ ), NPROW, NPCOL, MYROW, MYCOL )
      INFO = 0
      IF( DESCQ( NB_ ).GT.N .OR. N.LT.2 )
     $   INFO = -1
      IF( INFO.NE.0 ) THEN
         CALL PXERBLA( DESCQ( CTXT_ ), 'PDLAED0', -INFO )
         RETURN
      END IF
*
      NB = DESCQ( NB_ )
      LDQ = DESCQ( LLD_ )
      CALL INFOG2L( IQ, JQ, DESCQ, NPROW, NPCOL, MYROW, MYCOL, IIQ, JJQ,
     $              IQROW, IQCOL )
*
*     Determine the size and placement of the submatrices, and save in
*     the leading elements of IWORK.
*
      TSUBPBS = ( N-1 ) / NB + 1
      IWORK( 1 ) = TSUBPBS
      SUBPBS = 1
   10 CONTINUE
      IF( IWORK( SUBPBS ).GT.1 ) THEN
         DO 20 J = SUBPBS, 1, -1
            IWORK( 2*J ) = ( IWORK( J )+1 ) / 2
            IWORK( 2*J-1 ) = IWORK( J ) / 2
   20    CONTINUE
         SUBPBS = 2*SUBPBS
         GO TO 10
      END IF
      DO 30 J = 2, SUBPBS
         IWORK( J ) = IWORK( J ) + IWORK( J-1 )
   30 CONTINUE
*
*     Divide the matrix into TSUBPBS submatrices of size at most NB
*     using rank-1 modifications (cuts).
*
      DO 40 I = NB + 1, N, NB
         IM1 = I - 1
         D( IM1 ) = D( IM1 ) - ABS( E( IM1 ) )
         D( I ) = D( I ) - ABS( E( IM1 ) )
   40 CONTINUE
*
*     Solve each submatrix eigenproblem at the bottom of the divide and
*     conquer tree. D is the same on each process.
*
      DO 50 ID = 1, N, NB
         CALL INFOG2L( IQ-1+ID, JQ-1+ID, DESCQ, NPROW, NPCOL, MYROW,
     $                 MYCOL, IID, JJD, IDROW, IDCOL )
         MATSIZ = MIN( NB, N-ID+1 )
         IF( MYROW.EQ.IDROW .AND. MYCOL.EQ.IDCOL ) THEN
            IPQ = IID + ( JJD-1 )*LDQ
            CALL DSTEQR( 'I', MATSIZ, D( ID ), E( ID ), Q( IPQ ), LDQ,
     $                   WORK, INFO )
            IF( INFO.NE.0 ) THEN
               CALL PXERBLA( DESCQ( CTXT_ ), 'DSTEQR', -INFO )
               RETURN
            END IF
            IF( MYROW.NE.IQROW .OR. MYCOL.NE.IQCOL ) THEN
               CALL DGESD2D( DESCQ( CTXT_ ), MATSIZ, 1, D( ID ), MATSIZ,
     $                       IQROW, IQCOL )
            END IF
         ELSE IF( MYROW.EQ.IQROW .AND. MYCOL.EQ.IQCOL ) THEN
            CALL DGERV2D( DESCQ( CTXT_ ), MATSIZ, 1, D( ID ), MATSIZ,
     $                    IDROW, IDCOL )
         END IF
   50 CONTINUE
*
      IF( MYROW.EQ.IQROW .AND. MYCOL.EQ.IQCOL ) THEN
         CALL DGEBS2D( DESCQ( CTXT_ ), 'A', ' ', N, 1, D, N )
      ELSE
         CALL DGEBR2D( DESCQ( CTXT_ ), 'A', ' ', N, 1, D, N, IQROW,
     $                 IQCOL )
      END IF
*
*     Successively merge eigensystems of adjacent submatrices
*     into eigensystem for the corresponding larger matrix.
*
*     while ( SUBPBS > 1 )
*
   60 CONTINUE
      IF( SUBPBS.GT.1 ) THEN
         IM2 = SUBPBS - 2
         DO 80 I = 0, IM2, 2
            IF( I.EQ.0 ) THEN
               NBL = IWORK( 2 )
               NBL1 = IWORK( 1 )
               IF( NBL1.EQ.0 )
     $            GO TO 70
               ID = 1
               MATSIZ = MIN( N, NBL*NB )
               N1 = NBL1*NB
            ELSE
               NBL = IWORK( I+2 ) - IWORK( I )
               NBL1 = NBL / 2
               IF( NBL1.EQ.0 )
     $            GO TO 70
               ID = IWORK( I )*NB + 1
               MATSIZ = MIN( NB*NBL, N-ID+1 )
               N1 = NBL1*NB
            END IF
*
*     Merge lower order eigensystems (of size N1 and MATSIZ - N1)
*     into an eigensystem of size MATSIZ.
*
            CALL PDLAED1( MATSIZ, N1, D( ID ), ID, Q, IQ, JQ, DESCQ,
     $                    E( ID+N1-1 ), WORK, IWORK( SUBPBS+1 ), IINFO )
            IF( IINFO.NE.0 ) THEN
               INFO = IINFO*( N+1 ) + ID
            END IF
*
   70       CONTINUE
            IWORK( I / 2+1 ) = IWORK( I+2 )
   80    CONTINUE
         SUBPBS = SUBPBS / 2
*
         GO TO 60
      END IF
*
*     end while
*
   90 CONTINUE
      RETURN
*
*     End of PDLAED0
*
      END

!#define VDWDF_PAW_BEFORE_2017

!#define DEBUG_PAW3D
#define _TIME_DETAIL_
#ifdef NEC_TIMER
#  define START_TIMER(a) call start_timer(a)
#  define STOP_TIMER(a)  call stop_timer(a)
#else
#  define START_TIMER(a)
#  define STOP_TIMER(a)
#endif
!=======================================================================
!
!  SOFTWARE NAME : PHASE ($Revision: 583 $)
!
!  MODULE: m_PAW_XC_Potential
!
!  AUTHOR(S): T. Yamasaki, T. Yamamoto and T. Ohno November/2009
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!#========================================================================
!
! Bug fix:  2016/10/13
!    *Antiferromagnetic calculation
!        The variable flg_done is neglected for the moment
!        because the skipping mechanism does not work properly in some cases.
! ----------------------
!
! The operations previously coded in betwen "#ifdef PAW3D" and #endif" are
!   activated by T. Yamasaki. 2020/01/23
!   Vxc_ae_k and vxc_ps_k are completely replaced with partitioned
!  arrays of vxc_ae_k_3D and vxc_ps_k_3D, and "#ifdef PAW3D" and paired 
! "#endif" are removed.
!
!#========================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_PAW_XC_Potential
  use m_Const_Parameters,     only : DP,GGA,Valence_plus_PC_Charge &
       &                            ,VXC_AND_EXC,PAI4,PAI2, EXC_ONLY, DELTA10 &
       &                            ,SphericalHarmonicsExpansion
  use m_Control_Parameters,   only : nspin,xctype,len_xctype,printable,ipripp,iprixc &
       &                           , paw_density_gradient, af &
       &                           , noncol, ndim_magmom    ! == added by K. Tagami == 11.0

  use m_Parallelization,      only : mpi_comm_group, npes,  nrank_g, myrank_g &
       &                           , nrank_natm,  myrank_natm, myrank_nrc &
       &                           , mpi_natm_world, mpi_nrc_world &
       &                           , is_natm, ie_natm, ista_natm, iend_natm, ne_natm, ista_nrc, iend_nrc &
       &                           , paw_no_work_to_do, paw_last_rank_on_nrc, mpi_ke_world, mpi_chg_world
                                                 ! == For nrc decomposion. by takto 2012/12/07 ==

! ============================= added by K. Tagami =========== 11.0
  use m_Ionic_System,         only : ntyp,natm,ityp,iwei, magmom_local_now
  use m_Crystal_Structure,    only :  level_of_projection_paw_charge
! ============================================================ 11.0

  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_PseudoPotential,      only : mmesh,radr_paw &
       &                            ,m_PP_find_maximum_l &
       &                            ,dion_vxc,ipaw &
       &                            ,ilmt &
       &                            ,nltpw,iltpw,lppw,tppw,index_lmt2lt &
       &                            ,il2p,isph,dl2p,iqitg &
       &                            ,wf_mnrc,psirpw,phirpw,qrspspw,xh   !!$ , ia2ia_symmtry_op
  use m_XC_Potential,         only : check_of_xctype

#ifdef NEC_TIMER
  use nec_timer
#endif

! use z_interface_3D,           only : decomp_vxc_ae_k_r_3D  ! == DEBUG by tkato 2011/10/01 ==
  use m_PAW_ChargeDensity, only : ntheta,nphi,omg_wght &
       &                         ,m_PAWCD_set_ae_cd &
       &                         ,m_PAWCD_set_ps_cd &
       &                         ,m_PAWCD_set_ae_der_cd &
       &                         ,m_PAWCD_set_ps_der_cd &
       &                         ,m_PAWCD_set_ae_cd_sym &
       &                         ,m_PAWCD_set_ps_cd_sym &
       &                         ,m_PAWCD_set_ae_der_cd_sym &
       &                         ,m_PAWCD_set_ps_der_cd_sym &
       &                         ,m_PAWCD_set_cr2_isph2_mmt2 &
       &                         ,m_PAWCD_ae_cd_sphex2_nonclA &
       &                         ,m_PAWCD_ps_cd_sphex2_nonclA &
       &                         ,m_PAWCD_set_ae_cd_sphex2 &    ! == For nrc decomposion. by takto 2012/12/05 ==
       &                         ,m_PAWCD_set_ps_cd_sphex2 &    ! == For nrc decomposion. by takto 2012/12/05 ==
       &                         ,m_PAWCD_set_sq_der_cd_sdphex2 & ! == For nrc decomposion. by takto 2012/12/05 ==
       &                         ,ylm, dylm_dth,dylm_dph, cos_theta &
       &                         ,paw_cr2, paw_isph2, paw_mmt2, paw_dnr &
       &                         ,surface_integral_method

  implicit none
  include 'mpif.h'
  private
    
  real(DP),allocatable,dimension(:,:,:,:):: vxc_ae_k_3D
  real(DP),allocatable,dimension(:,:,:,:):: vxc_ps_k_3D

  real(DP),allocatable,dimension(:,:)  :: vxc_ae_m_ps
  real(DP)                             :: exc_ae,exc_ps,texc
  integer                              :: msph
    
  real(DP),allocatable,dimension(:,:)       :: grad_nae,grad_nps
  real(DP),allocatable,dimension(:)         :: grad_tnae,grad_tnps
  real(DP),allocatable,dimension(:)         :: dgrad_tnae_dr,dgrad_tnps_dr
  real(DP),allocatable,dimension(:,:)       :: dF_dnae,dF_dgradnae,dF_dgradnae_dr
  real(DP),allocatable,dimension(:,:)       :: dF_dnps,dF_dgradnps,dF_dgradnps_dr
  real(DP),allocatable,dimension(:)         :: wos
    
  real(DP),allocatable,dimension(:,:)       :: nae,nps
  real(DP),allocatable,dimension(:,:)       :: dnae_dr,dnae_dth,dnae_dph
  real(DP),allocatable,dimension(:,:)       :: dnps_dr,dnps_dth,dnps_dph
  real(DP),allocatable,dimension(:,:)       :: ddnae_ddr
  real(DP),allocatable,dimension(:,:)       :: ddnps_ddr
    
! ***** New member for spherical harmonics expansion *****
    
  real(DP),allocatable,dimension(:,:,:)     :: nae_sph,nps_sph
  real(DP),allocatable,dimension(:,:,:)     :: dnae_dr_sph,dnps_dr_sph
  real(DP),allocatable,dimension(:,:,:)     :: ddnae_ddr_sph,ddnps_ddr_sph
  real(DP),allocatable,dimension(:,:,:)     :: grad_nae2_sph,grad_nps2_sph
  real(DP),allocatable,dimension(:,:)       :: grad_tnae2_sph,grad_tnps2_sph
  real(DP),allocatable,dimension(:)         :: exc_ae_field,exc_ps_field
  real(DP),allocatable,dimension(:,:)       :: dFx_dnnae,dFx_dnnps
  real(DP),allocatable,dimension(:,:)       :: dFx_dngae,dFx_dngps
  real(DP),allocatable,dimension(:,:)       :: dFx_dggae,dFx_dggps
  real(DP),allocatable,dimension(:,:)       :: dFx_dnnnae,dFx_dnnnps
  real(DP),allocatable,dimension(:,:)       :: dFx_dnngae,dFx_dnngps
  real(DP),allocatable,dimension(:,:)       :: dFx_dnggae,dFx_dnggps
  real(DP),allocatable,dimension(:,:)       :: dFx_dgggae,dFx_dgggps
  real(DP),allocatable,dimension(:)         :: dF_dgradtnae,dF_dgradtnps
  real(DP),allocatable,dimension(:)         :: dFc_daa_ae,dFc_daa_ps
  real(DP),allocatable,dimension(:)         :: dFc_dbb_ae,dFc_dbb_ps
  real(DP),allocatable,dimension(:)         :: dFc_dgg_ae,dFc_dgg_ps
  real(DP),allocatable,dimension(:)         :: dFc_dab_ae,dFc_dab_ps
  real(DP),allocatable,dimension(:)         :: dFc_dag_ae,dFc_dag_ps
  real(DP),allocatable,dimension(:)         :: dFc_dbg_ae,dFc_dbg_ps
  real(DP),allocatable,dimension(:)         :: dFc_daaa_ae,dFc_daaa_ps
  real(DP),allocatable,dimension(:)         :: dFc_dbbb_ae,dFc_dbbb_ps
  real(DP),allocatable,dimension(:)         :: dFc_dggg_ae,dFc_dggg_ps
  real(DP),allocatable,dimension(:)         :: dFc_daab_ae,dFc_daab_ps
  real(DP),allocatable,dimension(:)         :: dFc_daag_ae,dFc_daag_ps
  real(DP),allocatable,dimension(:)         :: dFc_dabb_ae,dFc_dabb_ps
  real(DP),allocatable,dimension(:)         :: dFc_dbbg_ae,dFc_dbbg_ps
  real(DP),allocatable,dimension(:)         :: dFc_dagg_ae,dFc_dagg_ps
  real(DP),allocatable,dimension(:)         :: dFc_dbgg_ae,dFc_dbgg_ps
  real(DP),allocatable,dimension(:)         :: dFc_dabg_ae,dFc_dabg_ps
  real(DP),allocatable,dimension(:,:)       :: nana_ae_sph,nana_ps_sph
  real(DP),allocatable,dimension(:,:)       :: nbnb_ae_sph,nbnb_ps_sph
  real(DP),allocatable,dimension(:,:)       :: gaga_ae_sph,gaga_ps_sph
  real(DP),allocatable,dimension(:,:)       :: gbgb_ae_sph,gbgb_ps_sph
  real(DP),allocatable,dimension(:,:)       :: gg_ae_sph,gg_ps_sph
  real(DP),allocatable,dimension(:,:)       :: nanb_ae_sph,nanb_ps_sph
  real(DP),allocatable,dimension(:,:)       :: naga_ae_sph,naga_ps_sph
  real(DP),allocatable,dimension(:,:)       :: nbgb_ae_sph,nbgb_ps_sph
  real(DP),allocatable,dimension(:,:)       :: nag_ae_sph,nag_ps_sph
  real(DP),allocatable,dimension(:,:)       :: nbg_ae_sph,nbg_ps_sph
    
  real(DP),allocatable,dimension(:,:)       :: dFxcdna_ae_sph,dFxcdna_ps_sph
  real(DP),allocatable,dimension(:,:)       :: dFxcdnb_ae_sph,dFxcdnb_ps_sph
  real(DP),allocatable,dimension(:,:)       :: dFxdgaovrga_ae_sph,dFxdgaovrga_ps_sph
  real(DP),allocatable,dimension(:,:)       :: dFxdgbovrgb_ae_sph,dFxdgbovrgb_ps_sph
  real(DP),allocatable,dimension(:,:)       :: dFcdgovrg_ae_sph,dFcdgovrg_ps_sph
    
  real(DP),allocatable,dimension(:)         :: dFadga_ae,   dFadga_ps
  real(DP),allocatable,dimension(:)         :: dFadg_ae,    dFadg_ps
  real(DP),allocatable,dimension(:)         :: dFadgaga_ae, dFadgaga_ps
  real(DP),allocatable,dimension(:)         :: dFadgg_ae,   dFadgg_ps
  real(DP),allocatable,dimension(:)         :: dFadnaga_ae, dFadnaga_ps
  real(DP),allocatable,dimension(:)         :: dFadnag_ae,  dFadnag_ps
    
  real(DP),allocatable,dimension(:)         :: dFbdgb_ae,   dFbdgb_ps
  real(DP),allocatable,dimension(:)         :: dFbdg_ae,    dFbdg_ps
  real(DP),allocatable,dimension(:)         :: dFbdgbgb_ae, dFbdgbgb_ps
  real(DP),allocatable,dimension(:)         :: dFbdgg_ae,   dFbdgg_ps
  real(DP),allocatable,dimension(:)         :: dFbdnbgb_ae, dFbdnbgb_ps
  real(DP),allocatable,dimension(:)         :: dFbdnbg_ae,  dFbdnbg_ps
  real(DP),allocatable,dimension(:)         :: dFbdag_ae,   dFbdag_ps
    
  real(DP),allocatable,dimension(:)         :: dGadna_ae,   dGadna_ps
  real(DP),allocatable,dimension(:)         :: dGadga_ae,   dGadga_ps
  real(DP),allocatable,dimension(:)         :: dGadnana_ae, dGadnana_ps
  real(DP),allocatable,dimension(:)         :: dGadnaga_ae, dGadnaga_ps
  real(DP),allocatable,dimension(:)         :: dGadgaga_ae, dGadgaga_ps

  real(DP),allocatable,dimension(:)         :: dGbdnb_ae,   dGbdnb_ps
  real(DP),allocatable,dimension(:)         :: dGbdgb_ae,   dGbdgb_ps
  real(DP),allocatable,dimension(:)         :: dGbdnbnb_ae, dGbdnbnb_ps
  real(DP),allocatable,dimension(:)         :: dGbdnbgb_ae, dGbdnbgb_ps
  real(DP),allocatable,dimension(:)         :: dGbdgbgb_ae, dGbdgbgb_ps
    
  real(DP),allocatable,dimension(:)         :: dGdna_ae,    dGdna_ps
  real(DP),allocatable,dimension(:)         :: dGdnb_ae,    dGdnb_ps
  real(DP),allocatable,dimension(:)         :: dGdg_ae,     dGdg_ps
  real(DP),allocatable,dimension(:)         :: dGdnana_ae,  dGdnana_ps
  real(DP),allocatable,dimension(:)         :: dGdnbnb_ae,  dGdnbnb_ps
  real(DP),allocatable,dimension(:)         :: dGdgg_ae,    dGdgg_ps
  real(DP),allocatable,dimension(:)         :: dGdnanb_ae,  dGdnanb_ps
  real(DP),allocatable,dimension(:)         :: dGdnag_ae,   dGdnag_ps
  real(DP),allocatable,dimension(:)         :: dGdnbg_ae,   dGdnbg_ps
    
  logical,allocatable,dimension(:)         :: flg_done
  
  integer,allocatable,dimension(:)         :: irs

! ========================================= added by K. Tagami ================= 11.0
  real(DP), allocatable,dimension(:,:,:) :: magmom_local_ae
  real(DP), allocatable,dimension(:,:,:) :: magmom_local_ps
  real(DP), allocatable,dimension(:,:) :: magmom_local_wk

  real(DP), allocatable,dimension(:,:,:,:) :: rho_rad_ae
  real(DP), allocatable,dimension(:,:,:,:) :: rho_rad_ps
  real(DP), allocatable,dimension(:,:,:) :: rho_rad_wk
! ============================================================================== 11.0

  public:: m_PAW_XC_cal_potential
  public:: m_PAW_XC_alloc_vxc
  public:: m_PAW_XC_get_dion_vxc
  public:: exc_ae,exc_ps,msph
    
  public:: m_PAW_XC_cal_potential_sphex2
  public:: m_PAW_XC_dealloc_vxc

  public:: m_PAW_XC_allocation
  public:: m_PAW_XC_deallocation

  public :: vxc_ae_k_3D, vxc_ps_k_3D ! =- added by K. Tagami =============== 11.0

contains

  subroutine m_PAW_XC_alloc_vxc
    integer:: n
    call m_PP_find_maximum_l(n)
    n=(n-1)+(n-1)+1
    msph=n**2
    if(.not.allocated(vxc_ae_m_ps)) allocate(vxc_ae_m_ps(nspin,natm))
    vxc_ae_m_ps=0.d0

    return
  end subroutine m_PAW_XC_alloc_vxc

  subroutine m_PAW_XC_dealloc_vxc
    if (allocated(vxc_ae_m_ps)) deallocate(vxc_ae_m_ps)
! ===================================== added by K. Tagami ================ 11.0
    if ( noncol ) then
       if ( allocated(magmom_local_ae) ) deallocate( magmom_local_ae )
       if ( allocated(magmom_local_ps) ) deallocate( magmom_local_ps )
       if ( allocated(rho_rad_ae) )      deallocate( rho_rad_ae )
       if ( allocated(rho_rad_ps) )      deallocate( rho_rad_ps )
!
       if ( allocated(magmom_local_wk) ) deallocate( magmom_local_wk )
       if ( allocated(rho_rad_wk) ) deallocate( rho_rad_wk )
    endif
! ========================================================================= 11.0

  end subroutine m_PAW_XC_dealloc_vxc

  subroutine paw_xc_allocate
    allocate(nae(ista_nrc:iend_nrc,nspin));nae=0
    allocate(nps(ista_nrc:iend_nrc,nspin));nps=0
    allocate(wos(ista_nrc:iend_nrc));wos=0.d0
    if(check_of_xctype()==GGA) then
       allocate(grad_nae(ista_nrc:iend_nrc,nspin));grad_nae=0
       allocate(grad_tnae(ista_nrc:iend_nrc));grad_tnae=0
       allocate(dgrad_tnae_dr(ista_nrc:iend_nrc));dgrad_tnae_dr=0
       allocate(dF_dnae(ista_nrc:iend_nrc,nspin));dF_dnae=0
       allocate(dF_dgradnae(ista_nrc:iend_nrc,nspin));dF_dgradnae=0
       allocate(dF_dgradnae_dr(ista_nrc:iend_nrc,nspin));dF_dgradnae_dr=0
       allocate(grad_nps(ista_nrc:iend_nrc,nspin));grad_nps=0
       allocate(grad_tnps(ista_nrc:iend_nrc));grad_tnps=0
       allocate(dgrad_tnps_dr(ista_nrc:iend_nrc));dgrad_tnps_dr=0
       allocate(dF_dnps(ista_nrc:iend_nrc,nspin));dF_dnps=0
       allocate(dF_dgradnps(ista_nrc:iend_nrc,nspin));dF_dgradnps=0
       allocate(dF_dgradnps_dr(ista_nrc:iend_nrc,nspin));dF_dgradnps_dr=0
       allocate(dnae_dr(ista_nrc:iend_nrc,nspin));dnae_dr=0
       allocate(dnae_dth(ista_nrc:iend_nrc,nspin));dnae_dth=0
       allocate(dnae_dph(ista_nrc:iend_nrc,nspin));dnae_dph=0
       allocate(ddnae_ddr(ista_nrc:iend_nrc,nspin));ddnae_ddr=0
       allocate(dnps_dr(ista_nrc:iend_nrc,nspin));dnps_dr=0
       allocate(dnps_dth(ista_nrc:iend_nrc,nspin));dnps_dth=0
       allocate(dnps_dph(ista_nrc:iend_nrc,nspin));dnps_dph=0
       allocate(ddnps_ddr(ista_nrc:iend_nrc,nspin));ddnps_ddr=0
    end if
    return
  end subroutine paw_xc_allocate
    
  subroutine paw_xc_deallocate
    deallocate(nae)
    deallocate(nps)
    deallocate(wos)
    if(check_of_xctype()==GGA) then
       deallocate(grad_nae)
       deallocate(grad_tnae)
       deallocate(dF_dnae)
       deallocate(dF_dgradnae)
       deallocate(grad_nps)
       deallocate(grad_tnps)
       deallocate(dF_dnps)
       deallocate(dF_dgradnps)
       deallocate(dnae_dr)
       deallocate(dnae_dth)
       deallocate(dnae_dph)
       deallocate(ddnae_ddr)
       deallocate(dnps_dr)
       deallocate(dnps_dth)
       deallocate(dnps_dph)
       deallocate(ddnps_ddr)
       deallocate(dgrad_tnae_dr)
       deallocate(dgrad_tnps_dr)
       deallocate(dF_dgradnae_dr)
       deallocate(dF_dgradnps_dr)
    end if
    return
  end subroutine paw_xc_deallocate

  subroutine m_PAW_XC_allocation(nfout)
    integer :: nfout
    allocate(vxc_ae_k_3D(ista_nrc:iend_nrc,nspin,msph,ne_natm))
    allocate(vxc_ps_k_3D(ista_nrc:iend_nrc,nspin,msph,ne_natm))
    vxc_ae_k_3D=0.d0
    vxc_ps_k_3D=0.d0
  end subroutine m_PAW_XC_allocation

  subroutine m_PAW_XC_deallocation(nfout)
    integer :: nfout
    deallocate(vxc_ae_k_3D)
    deallocate(vxc_ps_k_3D)
  end subroutine m_PAW_XC_deallocation

  subroutine m_PAW_XC_cal_potential(nfout,vflag,flg_symmetry)
    integer,intent(in):: nfout,vflag
    logical,intent(in):: flg_symmetry
        
    integer,parameter :: PRINTLEVEL = 2
#ifdef _TIME_DETAIL_
    integer :: id_sname2 = -1, id_sname3=-1, id_sname4=-1,id_sname5=-1, ierr
#endif
    integer:: ia,it,ith,iph,iord, ia_add
    integer:: ir,is,nsph, ier
    integer:: nrc, tmpind
    real(DP):: costh,sinth,phi,dvec(3), radr, dylmt, dylmp
    real(DP):: dtnae_dr,dtnae_dth,dtnae_dph,ddtnae_ddr
    real(DP):: dtnps_dr,dtnps_dth,dtnps_dph,ddtnps_ddr ! h
    real(DP),allocatable, dimension(:,:) :: wost ! wost(mmesh,ntyp)
    real(kind=DP), allocatable, dimension(:,:) :: tae,tps ! === For nrc decomposion. by T. Yamasaki 2020/02/24 ===
    integer :: dnr
    integer :: id_sname = -1
!!$#if 0
!!$    real(kind=DP), allocatable, dimension(:,:) :: nae_g, dnae_dr_g, ddnae_ddr_g
!!$#endif

    call tstatc0_begin('m_PAW_XC_cal_potential',id_sname,level=1)
START_TIMER('m_PAW_XC_cal_potential')

    call paw_xc_allocate
    iord = paw_density_gradient%order

    exc_ae=0.d0
    exc_ps=0.d0

    vxc_ae_k_3D=0.d0 ! == For nrc decomposion. by takto 2012/12/05 ==
    vxc_ps_k_3D=0.d0 ! == For nrc decomposion. by takto 2012/12/05 ==

    allocate(wost(mmesh,ntyp));wost=0.d0
    do it = 1, ntyp
       nrc = wf_mnrc(it)
       call set_weight_exp(ier,1,nrc,radr_paw(:,it),wost(:,it))
       do ir=1, nrc
          wost(ir,it) = wost(ir,it)*radr_paw(ir,it)**2
       end do
    end do
       
    if(iprixc >= PRINTLEVEL) then
       write(nfout,'(" ista_natm = ",i4," iend_natm = ",i4)') ista_natm, iend_natm
       write(nfout,'(" ntheta, nphi = ",2i8)') ntheta, nphi
    end if
    do ia = ista_natm, iend_natm   !     do ia=ista_atm_ke,iend_atm_ke
       ia_add = ia - ista_natm + 1
           
       it=ityp(ia)
       if(ipaw(it)/=1) cycle

       nrc = wf_mnrc(it)
       wos = 0.d0
       wos(ista_nrc:min(nrc,iend_nrc)) = wost(ista_nrc:min(nrc,iend_nrc),it)*iwei(ia)

       do ith=1,ntheta
          if(iprixc >= PRINTLEVEL) write(nfout,'(" ith = ",i4)') ith
          if(flg_symmetry) then
             costh=cos_theta(ith)
             sinth=sqrt(1.d0-costh**2)
          else
             sinth=sqrt(1.d0-cos_theta(ith)**2)
          end if
          do iph=1,nphi
!                    if(it .ne. ityp(ia)) cycle
#ifdef _TIME_DETAIL_
             call tstatc0_begin('m_PAW_XC_cal_pot(former)',id_sname4)
#endif
!!$             tmpind = (ith-1)*nphi+iph
!!$             if (mod(tmpind,nrank_g) /= myrank_g) cycle
             if(flg_symmetry) then
                phi=PAI2/dble(nphi)*dble(iph-1)
                dvec(1)=sinth*cos(phi)
                dvec(2)=sinth*sin(phi)
                dvec(3)=costh
                call m_PAWCD_set_ae_cd_sym( dvec,ia,nspin,nrc,nae,ista_nrc,iend_nrc)
                call m_PAWCD_set_ps_cd_sym( dvec,ia,nspin,nrc,nps,ista_nrc,iend_nrc)
             else
                call m_PAWCD_set_ae_cd(ith,iph,ia,nspin,nrc,nae,ista_nrc,iend_nrc)
                call m_PAWCD_set_ps_cd(ith,iph,ia,nspin,nrc,nps,ista_nrc,iend_nrc)
             end if
#ifdef _TIME_DETAIL_
             call tstatc0_end(id_sname4)
             call tstatc0_begin('m_PAW_XC_cal_pot(ggaxcp_paw)',id_sname3)
#endif
             if(check_of_xctype()==GGA) then 
                call ggaxcp_paw()          ! --> texc,dF_dnae,dF_dgradnae,dF_dnps,dF_dgradnps
             else
                call xcpotf_paw(nrc,nspin,ith,Valence_plus_PC_Charge) 
             end if
#ifdef _TIME_DETAIL_
             call tstatc0_end(id_sname3)
#endif
             if(iprixc >= PRINTLEVEL)  write(nfout,'(" iph/nphi = ",i4,"/",i4 &
                  &              ," , exc_ae, exc_ps = ",2d20.8 )') iph,nphi,exc_ae, exc_ps

             if(vflag /= VXC_AND_EXC) cycle
!!$             if(vflag == VXC_AND_EXC) then
             if(check_of_xctype()==GGA) then
#ifdef _TIME_DETAIL_
                call tstatc0_begin('m_PAW_XC_cal_pot(latter)',id_sname2)
#endif

                dnr = 1
                allocate(tae(ista_nrc-6*dnr:iend_nrc+6*dnr,nspin))   ! == For nrc decomposion. by T. Yamasaki 2020/02/24 ==
                call boundary_exchange_dim2(tae, DF_dgradnae, dnr, nspin)
                allocate(tps(ista_nrc-6*dnr:iend_nrc+6*dnr,nspin)) 
                call boundary_exchange_dim2(tps, DF_dgradnps, dnr, nspin)
                
                do is=1,nspin
                   call calc_diff_exp2_3D(1,iord,nrc,dnr,xh(it),radr_paw(:,it),tae(:,is),dF_dgradnae_dr(:,is) &
                        &    ,ista_nrc,iend_nrc)
                   call calc_diff_exp2_3D(1,iord,nrc,dnr,xh(it),radr_paw(:,it),tps(:,is),dF_dgradnps_dr(:,is) &
                        &    ,ista_nrc,iend_nrc)
                end do

                deallocate(tae)
                allocate(tae(ista_nrc-6*dnr:iend_nrc+6*dnr,1))   ! == For nrc decomposion. by T. Yamasaki 2020/02/24 ==
                call boundary_exchange_dim2(tae, grad_tnae, dnr, 1)
                deallocate(tps)
                allocate(tps(ista_nrc-6*dnr:iend_nrc+6*dnr,1)) 
                call boundary_exchange_dim2(tps, grad_tnps, dnr, 1)
                call calc_diff_exp2_3D(1,iord,nrc,dnr,xh(it),radr_paw(:,it),tae(:,1),dgrad_tnae_dr,ista_nrc,iend_nrc)
                call calc_diff_exp2_3D(1,iord,nrc,dnr,xh(it),radr_paw(:,it),tps(:,1),dgrad_tnps_dr,ista_nrc,iend_nrc)
                deallocate(tae,tps)
#ifdef _TIME_DETAIL_
                call tstatc0_end(id_sname2)
                call tstatc0_begin('latter2 ',id_sname5)
#endif
                do nsph=1,msph
                   dylmt = dylm_dth(ith,iph,nsph)
                   dylmp = dylm_dph(ith,iph,nsph)
                   do is=1,nspin
                      do ir=ista_nrc,iend_nrc  !    do ir=1,nrc
                         
                         if(nspin==2) then
                            dtnae_dr = dnae_dr(ir,1) + dnae_dr(ir,2)
                            ddtnae_ddr = ddnae_ddr(ir,1) + ddnae_ddr(ir,2)
                            dtnae_dth = dnae_dth(ir,1) + dnae_dth(ir,2)
                            dtnae_dph = dnae_dph(ir,1) + dnae_dph(ir,2)
                            dtnps_dr = dnps_dr(ir,1) + dnps_dr(ir,2)
                            ddtnps_ddr = ddnps_ddr(ir,1) + ddnps_ddr(ir,2)
                            dtnps_dth = dnps_dth(ir,1) + dnps_dth(ir,2)
                            dtnps_dph = dnps_dph(ir,1) + dnps_dph(ir,2)
                         else
                            dtnae_dr = dnae_dr(ir,1)
                            ddtnae_ddr = ddnae_ddr(ir,1)
                            dtnae_dth = dnae_dth(ir,1)
                            dtnae_dph = dnae_dph(ir,1)
                            dtnps_dr = dnps_dr(ir,1)
                            ddtnps_ddr = ddnps_ddr(ir,1)
                            dtnps_dth = dnps_dth(ir,1)
                            dtnps_dph = dnps_dph(ir,1)

                         end if
                         radr = radr_paw(ir,it)
                         vxc_ae_k_3D(ir,is,nsph,ia_add) =  vxc_ae_k_3D(ir,is,nsph,ia_add) &
                              &  + ( ylm(ith,iph,nsph) &
                              &     * (dF_dnae(ir,is) - dF_dgradnae_dr(ir,is)*dnae_dr(ir,is) &
                              &        - dF_dgradnae(ir,is) * (ddnae_ddr(ir,is) + 2.d0/radr*dnae_dr(ir,is)) &
                              &       - dgrad_tnae_dr(ir) * dtnae_dr &
                              &        - grad_tnae(ir) * (ddtnae_ddr + 2.d0/radr*dtnae_dr) ) &
                              &    + dF_dgradnae(ir,is) &
                              &     * (dylmt*dnae_dth(ir,is) + dylmp*dnae_dph(ir,is)/sinth) /radr &
                              &    + grad_tnae(ir) * (dylmt*dtnae_dth + dylmp*dtnae_dph/sinth) /radr &
                              &    ) * omg_wght(ith)
                         vxc_ps_k_3D(ir,is,nsph,ia_add) =  vxc_ps_k_3D(ir,is,nsph,ia_add) &
                              &  + ( ylm(ith,iph,nsph) &
                              &     * (dF_dnps(ir,is) - dF_dgradnps_dr(ir,is)*dnps_dr(ir,is) &
                              &        - dF_dgradnps(ir,is) * (ddnps_ddr(ir,is) + 2.d0/radr*dnps_dr(ir,is)) &
                              &       - dgrad_tnps_dr(ir) * dtnps_dr &
                              &        - grad_tnps(ir) * (ddtnps_ddr + 2.d0/radr*dtnps_dr) ) &
                              &    + dF_dgradnps(ir,is) &
                              &        * (dylmt*dnps_dth(ir,is) + dylmp*dnps_dph(ir,is)/sinth)/ radr &
                              &    + grad_tnps(ir)* (  dylmt*dtnps_dth + dylmp*dtnps_dph/sinth)/ radr &
                              &    ) * omg_wght(ith)
                      end do
                   end do
                end do
#ifdef _TIME_DETAIL_
                call tstatc0_end(id_sname5)
#endif
             else

                do nsph=1,msph
                   do is=1,nspin
                      do ir=1,nrc
                         vxc_ae_k_3D(ir,is,nsph,ia_add) = vxc_ae_k_3D(ir,is,nsph,ia_add) &
                              & + nae(ir,is) * ylm(ith,iph,nsph) * omg_wght(ith)
                         vxc_ps_k_3D(ir,is,nsph,ia_add) = vxc_ps_k_3D(ir,is,nsph,ia_add) &
                              & + nps(ir,is) * ylm(ith,iph,nsph) * omg_wght(ith)
                      end do
                   end do
                end do
             end if
          end do
       end do
    end do
   
    exc_ae=exc_ae*PAI4
    exc_ps=exc_ps*PAI4
    vxc_ae_k_3D=vxc_ae_k_3D*PAI4
    vxc_ps_k_3D=vxc_ps_k_3D*PAI4

    if(iprixc >= PRINTLEVEL) then
       write(nfout,'(" exc_ae, exc_ps = ",2d20.8 )') exc_ae, exc_ps
    end if
    if(nrank_g>1) then
!!$       call mpi_allreduce(MPI_IN_PLACE,exc_ae,1,mpi_double_precision,mpi_sum,mpi_nrc_world,ier)
!!$       call mpi_allreduce(MPI_IN_PLACE,exc_ps,1,mpi_double_precision,mpi_sum,mpi_nrc_world,ier)
!!$#if 0
!!$       call mpi_allreduce(MPI_IN_PLACE,exc_ae,1,mpi_double_precision,mpi_sum,mpi_nrc_world,ier)
!!$#else
       call mpi_allreduce(MPI_IN_PLACE,exc_ae,1,mpi_double_precision,mpi_sum,mpi_comm_group,ier)
!!$#endif
       call mpi_allreduce(MPI_IN_PLACE,exc_ps,1,mpi_double_precision,mpi_sum,mpi_comm_group,ier)
    end if

    if(iprixc >= PRINTLEVEL) then
       write(nfout,'(" exc_ae, exc_ps = ",2d20.8 )') exc_ae, exc_ps
       write(nfout,'(" vxc_ae_k_3D(",i4,":",i4,",1,1,1) = ",6f12.4)') &
            & ista_nrc, ista_nrc+5,(vxc_ae_k_3D(ir,1,1,1),ir=ista_nrc,ista_nrc+5)
       write(nfout,'(" vxc_ps_k_3D(",i4,":",i4,",1,1,1) = ",6f12.4)') &
            & ista_nrc, ista_nrc+5,(vxc_ps_k_3D(ir,1,1,1),ir=ista_nrc,ista_nrc+5)
    end if

    deallocate(wost)
    call paw_xc_deallocate
        
STOP_TIMER('m_PAW_XC_cal_potential')
    call tstatc0_end(id_sname)
  contains

    subroutine ggaxcp0_paw
      integer :: id_sname = -1
      real(kind=DP) :: ecor
!!$#if 0
!!$      real(kind=DP), allocatable, dimension(:,:) :: dF_dnae_g, dF_dgradnae_g,grad_nae_g
!!$      real(kind=DP), allocatable, dimension(:) :: wos_g, grad_tnae_g
!!$      integer :: ier
!!$#endif      
      integer :: i,j
      call tstatc0_begin('ggaxcp0_paw ',id_sname)
!integer:: i
      grad_tnae = 0.d0
      grad_nae = 0.d0
      dF_dnae = 0.d0
      dF_dgradnae = 0.d0
      grad_tnps = 0.d0
      grad_nps = 0.d0
      dF_dnps = 0.d0
      dF_dgradnps = 0.d0
      dnae_dr = 0.d0
      dnae_dth = 0.d0
      dnae_dph = 0.d0
      ddnae_ddr = 0.d0
      dnps_dr = 0.d0
      dnps_dth = 0.d0
      dnps_dph = 0.d0
      ddnps_ddr = 0.d0
               
      if(xctype == 'ldapw91' .or. xctype == 'ldapbe '.or. xctype == 'vdwdf' ) then
         grad_nae=0.d0;grad_tnae=0.d0
         grad_nps=0.d0;grad_tnps=0.d0
      else
         call abs_grad_rho_up_down_total_paw_3D
      end if
        
      if(xctype == 'ggapw91' .or. xctype == 'ldapw91') then
         call ex_ggapw91(nspin,nspin,ista_nrc,iend_nrc,nae,grad_nae,wos,texc,dF_dnae,dF_dgradnae,nrc)
         call cr_ggapw91(nspin,nspin,ista_nrc,iend_nrc,nae,grad_tnae,wos,texc,dF_dnae,nrc)
         exc_ae=exc_ae+texc*omg_wght(ith)
         call ex_ggapw91(nspin,nspin,ista_nrc,iend_nrc,nps,grad_nps,wos,texc,dF_dnps,dF_dgradnps,nrc)
         call cr_ggapw91(nspin,nspin,ista_nrc,iend_nrc,nps,grad_tnps,wos,texc,dF_dnps,nrc)
         exc_ps=exc_ps+texc*omg_wght(ith)
      else if(xctype == 'ggapbe ' .or. xctype == 'ldapbe '.or. xctype == 'vdwdf') then
!!$#if 0
!!$         allocate(wos_g(nrc));wos_g = 0.d0
!!$         allocate(grad_nae_g(nrc,nspin)); grad_nae_g = 0.d0
!!$         allocate(grad_tnae_g(nrc)); grad_tnae_g = 0.d0
!!$         do i = ista_nrc, min(nrc,iend_nrc)
!!$            wos_g(i) = wos(i)
!!$            grad_tnae_g(i) = grad_tnae(i)
!!$         end do
!!$         do j = 1,nspin
!!$            do i = ista_nrc, min(nrc,iend_nrc)
!!$               grad_nae_g(i,j) = grad_nae(i,j)
!!$            end do
!!$         end do
!!$         call mpi_allreduce(MPI_IN_PLACE,wos_g,nrc,mpi_double_precision,mpi_sum,mpi_natm_world,ier)
!!$         call mpi_allreduce(MPI_IN_PLACE,grad_tnae_g,nrc,mpi_double_precision,mpi_sum,mpi_natm_world,ier)
!!$         call mpi_allreduce(MPI_IN_PLACE,grad_nae_g,nrc*nspin,mpi_double_precision,mpi_sum,mpi_natm_world,ier)
!!$         allocate(dF_dnae_g(1:nrc,nspin))
!!$         allocate(dF_dgradnae_g(1:nrc,nspin))
!!$         call ex_ggapbe (nspin,nspin,1,nrc,nae_g(1:nrc,1:nspin),grad_nae_g, wos_g,texc,dF_dnae_g,dF_dgradnae_g,.false.) 
!!$         call cr_ggapbe (nspin,nspin,1,nrc,nae_g(1:nrc,1:nspin),grad_tnae_g,wos_g,texc,dF_dnae_g,ecor)
!!$         do j = 1, nspin
!!$            do i = ista_nrc, min(nrc,iend_nrc)
!!$               dF_dnae(i,j) = dF_dnae_g(i,j)
!!$               dF_dgradnae(i,j) = dF_dgradnae_g(i,j)
!!$            end do
!!$         end do
!!$         deallocate(dF_dgradnae_g,dF_dnae_g)
!!$         deallocate(grad_tnae_g,grad_nae_g,wos_g)
!!$#else
!!$         grad_nae = 0.d0
         call ex_ggapbe (nspin,nspin,ista_nrc,iend_nrc,nae,grad_nae,wos,texc,dF_dnae,dF_dgradnae,.false.,nrc) 
         call cr_ggapbe (nspin,nspin,ista_nrc,iend_nrc,nae,grad_tnae,wos,texc,dF_dnae,ecor,nrc)
!!$#endif
         exc_ae=exc_ae+texc*omg_wght(ith)
         call ex_ggapbe (nspin,nspin,ista_nrc,iend_nrc,nps,grad_nps,wos,texc,dF_dnps,dF_dgradnps,.false.,nrc)
         call cr_ggapbe (nspin,nspin,ista_nrc,iend_nrc,nps,grad_tnps,wos,texc,dF_dnps,ecor,nrc)
         exc_ps=exc_ps+texc*omg_wght(ith)
      else if(xctype == 'katopbe' .or. xctype == 'ggapbek') then
         call ex_ggapbe (nspin,nspin,ista_nrc,iend_nrc,nae,grad_nae,wos,texc,dF_dnae,dF_dgradnae,.false.,nrc)
         call cr_ggapbe (nspin,nspin,ista_nrc,iend_nrc,nae,grad_tnae,wos,texc,dF_dnae,ecor,nrc)
         exc_ae=exc_ae+texc*omg_wght(ith)
         call ex_ggapbe (nspin,nspin,ista_nrc,iend_nrc,nps,grad_nps,wos,texc,dF_dnps,dF_dgradnps,.false.,nrc)
         call cr_ggapbe (nspin,nspin,ista_nrc,iend_nrc,nps,grad_tnps,wos,texc,dF_dnps,ecor,nrc)
         exc_ps=exc_ps+texc*omg_wght(ith)
      else if(xctype == 'ggabp  ') then
         call xclda(nspin,nspin,ista_nrc,iend_nrc,nae,wos,texc,dF_dnae,nrc)
         call ggabek(nspin,nspin,ista_nrc,iend_nrc,nae,grad_nae,wos,texc,dF_dnae,dF_dgradnae,nrc)
         call ggaprd(nspin,nspin,ista_nrc,iend_nrc,nae,grad_nae,wos,texc,dF_dnae,dF_dgradnae,nrc)
         exc_ae=exc_ae+texc*omg_wght(ith)
         call xclda(nspin,nspin,ista_nrc,iend_nrc,nps,wos,texc,dF_dnps,nrc)
         call ggabek(nspin,nspin,ista_nrc,iend_nrc,nps,grad_nps,wos,texc,dF_dnps,dF_dgradnps,nrc)
         call ggaprd(nspin,nspin,ista_nrc,iend_nrc,nps,grad_nps,wos,texc,dF_dnps,dF_dgradnps,nrc)
         exc_ps=exc_ps+texc*omg_wght(ith)
      else
         write(nfout,'(" xctype = ",a7)') xctype
         stop ' xctype is not set properly (ggaxcp0_paw)'
      end if
             !   dF/d|rho(r)| (=vxc) --> dF_drho
             !   dFx/d|grad(rho(r))| --> dF_dgradrho
             !   dFc/d|grad(rho(r))| --> grad_trho
      
      call tstatc0_end(id_sname)
    end subroutine ggaxcp0_paw

    subroutine ggaxcp_paw
      call ggaxcp0_paw
        
      return
    end subroutine ggaxcp_paw
    
    subroutine abs_grad_rho_up_down_total_paw_3D
      integer:: ir,is,iord,dnr
      real(kind=DP), allocatable, dimension(:,:) :: tmp ! === For nrc decomposion. by T. Yamasaki 2020/02/24 ===
      integer       :: id_sname = -1,ier, i, isdiff
!!$#if 0
!!$      real(kind=DP), allocatable, dimension(:,:) :: t_d_dr, t_dd_ddr 
!!$#endif

      call tstatc0_begin('abs_grad_rho_up_down_total_paw_3D ',id_sname)
!!$#if 0
!!$      write(nfout,'(" -- abs_grad_rho_up_down_total_paw_3D, nrc = ",i4," --")') nrc
!!$      call flush(nfout)
!!$
!!$      if(.not.allocated(nae_g)) allocate(nae_g(mmesh,nspin)); nae_g = 0.d0
!!$      if(.not.allocated(dnae_dr_g)) allocate(dnae_dr_g(mmesh,nspin)); dnae_dr_g = 0.d0
!!$      if(.not.allocated(ddnae_ddr_g)) allocate(ddnae_ddr_g(mmesh,nspin)); ddnae_ddr_g = 0.d0
!!$      do is=1,nspin
!!$         do i = max(1,ista_nrc),min(mmesh,iend_nrc)
!!$            nae_g(i,is) = nae(i,is)
!!$         end do
!!$      end do
!!$      call mpi_allreduce(MPI_IN_PLACE,nae_g,mmesh*nspin,mpi_double_precision,mpi_sum,mpi_natm_world,ier)
!!$      iord = paw_density_gradient%order
!!$! ------ for AE CD -------
!!$      if(vflag == VXC_AND_EXC) then
!!$         do is=1,nspin
!!$            call calc_diff_exp2(2,iord,nrc,xh(it),radr_paw(:,it), &
!!$                 & nae_g(:,is), dnae_dr_g(:,is), ddnae_ddr_g(:,is))  ! nae(:,is), dnae_dr(:,is), ddnae_ddr(:,is))
!!$         end do
!!$      else
!!$         do is=1,nspin
!!$            call calc_diff_exp2(1,iord,nrc,xh(it),radr_paw(:,it), &
!!$                 & nae_g(:,is), dnae_dr_g(:,is), ddnae_ddr_g(:,is))  ! nae(:,is), dnae_dr(:,is), ddnae_ddr(:,is))
!!$         end do
!!$      end if
!!$      dnae_dr(ista_nrc:iend_nrc,1:nspin) = dnae_dr_g(ista_nrc:iend_nrc,1:nspin)
!!$      ddnae_ddr(ista_nrc:iend_nrc,1:nspin) = ddnae_ddr_g(ista_nrc:iend_nrc,1:nspin)
!!$
!!!!$      deallocate(tmp)
!!!!$      deallocate(t_d_dr)
!!!!$      deallocate(t_dd_ddr)
!!$#else
      dnr = 1
      allocate(tmp(ista_nrc-6*dnr:iend_nrc+6*dnr,nspin))   ! == For nrc decomposion. by T. Yamasaki 2020/02/24 ==
      call boundary_exchange_dim2(tmp, nae, dnr, nspin) ! nae -> tmp


      iord = paw_density_gradient%order
! ------ for AE CD -------
      isdiff = 1
      if(vflag == VXC_AND_EXC) isdiff = 2
      do is=1,nspin
         call calc_diff_exp2_3D(isdiff,iord,nrc,dnr,xh(it),radr_paw(:,it),tmp(:,is) &
              &             ,dnae_dr(:,is),ista_nrc,iend_nrc, ddnae_ddr(:,is))
      end do
!!$#endif

      if(flg_symmetry) then
         call m_PAWCD_set_ae_der_cd_sym(dvec,ith,iph,ia,nspin,nrc,dnae_dth,dnae_dph,ista_nrc,iend_nrc)
      else
         call m_PAWCD_set_ae_der_cd(ith,iph,ia,nspin,nrc, dnae_dth,dnae_dph,ista_nrc,iend_nrc)
      end if

!!$      dnae_dth = 0d0; dnae_dph = 0.d0
      if(iprixc >= PRINTLEVEL) then
         write(nfout,'(" size of dnae_dth = [",i8,":",i8,",",i8,":",i8,"]")') &
              &                              lbound(dnae_dth,1),ubound(dnae_dth,1) &
              &                             ,lbound(dnae_dth,2),ubound(dnae_dth,2)
         write(nfout,'(" dvec = ",3f8.4)') dvec(1),dvec(2),dvec(3)
         write(nfout,'(" --- dnae_dth --- ir=[",i4,":",i4,"]")') ista_nrc,ista_nrc+11
         write(nfout,'(6f16.8)') (dnae_dth(ir,1), ir=ista_nrc,ista_nrc+11)
         write(nfout,'(6f16.8)') (dnae_dth(ir,2), ir=ista_nrc,ista_nrc+11)
         write(nfout,'(" --- dnae_dph ---")')
         write(nfout,'(6f16.8)') (dnae_dph(ir,1), ir=ista_nrc,ista_nrc+11)
         write(nfout,'(6f16.8)') (dnae_dph(ir,2), ir=ista_nrc,ista_nrc+11)
      end if
      do is=1,nspin
         do ir=ista_nrc,min(nrc,iend_nrc)
            grad_nae(ir,is) = dsqrt(  dnae_dr(ir,is)*dnae_dr(ir,is) &
                 &                  + dnae_dth(ir,is)*dnae_dth(ir,is) &
                 &                  + dnae_dph(ir,is)*dnae_dph(ir,is))
         end do
      end do
      if(nspin==2) then
         do ir=ista_nrc,min(nrc,iend_nrc)
            grad_tnae(ir) = dsqrt(  (dnae_dr(ir,1)+dnae_dr(ir,2))**2 &
                 &                + (dnae_dth(ir,1)+dnae_dth(ir,2))**2 &
                 &                + (dnae_dph(ir,1)+dnae_dph(ir,2))**2)
         end do
      else
         grad_tnae(:)=grad_nae(:,1)
      end if
        
!!$#if 0
!!$      allocate(tmp(mmesh,nspin)); tmp = 0.d0
!!$      allocate(t_d_dr(mmesh,nspin)); t_d_dr = 0.d0
!!$      allocate(t_dd_ddr(mmesh,nspin)); t_dd_ddr = 0.d0
!!$      do is=1,nspin
!!$         tmp(ista_nrc:iend_nrc,is) = nps(ista_nrc:iend_nrc,is)
!!$      end do
!!$      call mpi_allreduce(MPI_IN_PLACE,tmp,mmesh*nspin,mpi_double_precision,mpi_sum,mpi_natm_world,ier)
!!$      iord = paw_density_gradient%order
!!$! ------ for PS CD -------
!!$      if(vflag == VXC_AND_EXC) then
!!$         do is=1,nspin
!!$            call calc_diff_exp2(2,iord,nrc,xh(it),radr_paw(:,it), &
!!$                 & tmp(:,is), t_d_dr(:,is), t_dd_ddr(:,is))  ! nae(:,is), dnae_dr(:,is), ddnae_ddr(:,is))
!!$         end do
!!$      else
!!$         do is=1,nspin
!!$            call calc_diff_exp2(1,iord,nrc,xh(it),radr_paw(:,it), &
!!$                 & tmp(:,is), t_d_dr(:,is), t_dd_ddr(:,is))  ! nae(:,is), dnae_dr(:,is), ddnae_ddr(:,is))
!!$         end do
!!$      end if
!!$      dnps_dr(ista_nrc:iend_nrc,1:nspin) = t_d_dr(ista_nrc:iend_nrc,1:nspin)
!!$      ddnps_ddr(ista_nrc:iend_nrc,1:nspin) = t_dd_ddr(ista_nrc:iend_nrc,1:nspin)
!!$
!!$      deallocate(tmp)
!!$      deallocate(t_d_dr)
!!$      deallocate(t_dd_ddr)
!!$#else
! ------ for PS CD -------
      dnr = 1
      if(.not.allocated(tmp)) &
           & allocate(tmp(ista_nrc-6*dnr:iend_nrc+6*dnr,nspin))   ! == For nrc decomposion. by T. Yamasaki 2020/02/24 ==
      call boundary_exchange_dim2(tmp, nps, dnr, nspin) ! nps -> tmp

      isdiff = 1
      if(vflag == VXC_AND_EXC) isdiff = 2
      do is=1,nspin
         call calc_diff_exp2_3D(isdiff,iord,nrc,dnr,xh(it),radr_paw(:,it), tmp(:,is) &
              &             ,dnps_dr(:,is),ista_nrc,iend_nrc,ddnps_ddr(:,is))
      end do
      deallocate(tmp)
!!$#endif
      if(flg_symmetry) then
         call m_PAWCD_set_ps_der_cd_sym(dvec,ith,iph,ia,nspin,nrc,dnps_dth,dnps_dph,ista_nrc,iend_nrc)
      else
         call m_PAWCD_set_ps_der_cd(ith,iph,ia,nspin,nrc,dnps_dth,dnps_dph,ista_nrc,iend_nrc)
      end if
      do is=1,nspin
         do ir=ista_nrc,min(nrc,iend_nrc)   !!$         do ir=1,nrc
            grad_nps(ir,is)=dsqrt( dnps_dr(ir,is)*dnps_dr(ir,is)  &
                 &               + dnps_dth(ir,is)*dnps_dth(ir,is) &
                 &               + dnps_dph(ir,is)*dnps_dph(ir,is) )
         end do
      end do
      if(nspin==2) then
         do ir=ista_nrc,min(nrc,iend_nrc)   !!$         do ir=1,nrc
            grad_tnps(ir)=dsqrt(  (dnps_dr(ir,1)+dnps_dr(ir,2))**2 &
                 &              + (dnps_dth(ir,1)+dnps_dth(ir,2))**2 &
                 &              + (dnps_dph(ir,1)+dnps_dph(ir,2))**2 )
         end do
      else
         grad_tnps(:)=grad_nps(:,1)  !!$       grad_tnps(1:nrc)=grad_nps(1:nrc,1)
      end if

      call tstatc0_end(id_sname)

    end subroutine abs_grad_rho_up_down_total_paw_3D
        
  end subroutine m_PAW_XC_cal_potential
    
! === For nrc decomposion. by takto 2012/12/05 =================================
  subroutine paw_xc_sphex_allocate_3D
    allocate(nae_sph(ista_nrc:iend_nrc,nspin,25))  ;nae_sph=0.d0
    allocate(nps_sph(ista_nrc:iend_nrc,nspin,25))  ;nps_sph=0.d0
    allocate(wos(ista_nrc:iend_nrc));wos=0.d0
    allocate(irs(ista_nrc:iend_nrc));irs=0
    allocate(exc_ae_field(ista_nrc:iend_nrc))      ;exc_ae_field=0.d0
    allocate(exc_ps_field(ista_nrc:iend_nrc))      ;exc_ps_field=0.d0
        
    allocate(nana_ae_sph(ista_nrc:iend_nrc,25))    ;nana_ae_sph=0.d0 
    allocate(nana_ps_sph(ista_nrc:iend_nrc,25))    ;nana_ps_sph=0.d0
        
    allocate(dFxcdna_ae_sph(ista_nrc:iend_nrc,25)) ;dFxcdna_ae_sph=0.d0
    allocate(dFxcdna_ps_sph(ista_nrc:iend_nrc,25)) ;dFxcdna_ps_sph=0.d0
        
    allocate(nanb_ae_sph(ista_nrc:iend_nrc,25))    ;nanb_ae_sph=0.d0
    allocate(nanb_ps_sph(ista_nrc:iend_nrc,25))    ;nanb_ps_sph=0.d0
    
    if(nspin.eq.2) then
       allocate(nbnb_ae_sph(ista_nrc:iend_nrc,25))    ;nbnb_ae_sph=0.d0
       allocate(nbnb_ps_sph(ista_nrc:iend_nrc,25))    ;nbnb_ps_sph=0.d0
       allocate(dFxcdnb_ae_sph(ista_nrc:iend_nrc,25)) ;dFxcdnb_ae_sph=0.d0
       allocate(dFxcdnb_ps_sph(ista_nrc:iend_nrc,25)) ;dFxcdnb_ps_sph=0.d0
    end if
        
    if(check_of_xctype()==GGA) then
       allocate(grad_nae2_sph(ista_nrc:iend_nrc,nspin,25))        ;grad_nae2_sph=0.d0
       allocate(grad_tnae2_sph(ista_nrc:iend_nrc,25))             ;grad_tnae2_sph=0.d0
       allocate(grad_nps2_sph(ista_nrc:iend_nrc,nspin,25))        ;grad_nps2_sph=0.d0
       allocate(grad_tnps2_sph(ista_nrc:iend_nrc,25))             ;grad_tnps2_sph=0.d0
       allocate(dnae_dr_sph(ista_nrc:iend_nrc,nspin,25))          ;dnae_dr_sph=0.d0
       allocate(ddnae_ddr_sph(ista_nrc:iend_nrc,nspin,25))        ;ddnae_ddr_sph=0.d0
       allocate(dnps_dr_sph(ista_nrc:iend_nrc,nspin,25))          ;dnps_dr_sph=0.d0
       allocate(ddnps_ddr_sph(ista_nrc:iend_nrc,nspin,25))        ;ddnps_ddr_sph=0.d0
       allocate(grad_nae(ista_nrc:iend_nrc,nspin))                ;grad_nae=0.d0
       allocate(grad_tnae(ista_nrc:iend_nrc))                     ;grad_tnae=0.d0
       allocate(grad_nps(ista_nrc:iend_nrc,nspin))                ;grad_nps=0.d0
       allocate(grad_tnps(ista_nrc:iend_nrc))                     ;grad_tnps=0.d0
       allocate(dF_dnae(ista_nrc:iend_nrc,nspin))                 ;dF_dnae=0.d0
       allocate(dF_dgradnae(ista_nrc:iend_nrc,nspin))             ;dF_dgradnae=0.d0
       allocate(dF_dnps(ista_nrc:iend_nrc,nspin))                 ;dF_dnps=0.d0
       allocate(dF_dgradnps(ista_nrc:iend_nrc,nspin))             ;dF_dgradnps=0.d0
       allocate(dFx_dnnae(ista_nrc:iend_nrc,nspin))               ;dFx_dnnae=0.d0
       allocate(dFx_dngae(ista_nrc:iend_nrc,nspin))               ;dFx_dngae=0.d0
       allocate(dFx_dggae(ista_nrc:iend_nrc,nspin))               ;dFx_dggae=0.d0
       allocate(dFx_dnnnae(ista_nrc:iend_nrc,nspin))              ;dFx_dnnnae=0.d0
       allocate(dFx_dnngae(ista_nrc:iend_nrc,nspin))              ;dFx_dnngae=0.d0
       allocate(dFx_dnggae(ista_nrc:iend_nrc,nspin))              ;dFx_dnggae=0.d0
       allocate(dFx_dgggae(ista_nrc:iend_nrc,nspin))              ;dFx_dgggae=0.d0
       allocate(dFx_dnnps(ista_nrc:iend_nrc,nspin))               ;dFx_dnnps=0.d0
       allocate(dFx_dngps(ista_nrc:iend_nrc,nspin))               ;dFx_dngps=0.d0
       allocate(dFx_dggps(ista_nrc:iend_nrc,nspin))               ;dFx_dggps=0.d0
       allocate(dFx_dnnnps(ista_nrc:iend_nrc,nspin))              ;dFx_dnnnps=0.d0
       allocate(dFx_dnngps(ista_nrc:iend_nrc,nspin))              ;dFx_dnngps=0.d0
       allocate(dFx_dnggps(ista_nrc:iend_nrc,nspin))              ;dFx_dnggps=0.d0
       allocate(dFx_dgggps(ista_nrc:iend_nrc,nspin))              ;dFx_dgggps=0.d0
            
       allocate(dF_dgradtnae(ista_nrc:iend_nrc))                  ;dF_dgradtnae=0.d0
       allocate(dFc_daa_ae(ista_nrc:iend_nrc))                    ;dFc_daa_ae=0.d0
       allocate(dFc_dbb_ae(ista_nrc:iend_nrc))                    ;dFc_dbb_ae=0.d0
       allocate(dFc_dgg_ae(ista_nrc:iend_nrc))                    ;dFc_dgg_ae=0.d0
       allocate(dFc_dab_ae(ista_nrc:iend_nrc))                    ;dFc_dab_ae=0.d0
       allocate(dFc_dag_ae(ista_nrc:iend_nrc))                    ;dFc_dag_ae=0.d0
       allocate(dFc_dbg_ae(ista_nrc:iend_nrc))                    ;dFc_dbg_ae=0.d0
       allocate(dFc_daaa_ae(ista_nrc:iend_nrc))                   ;dFc_daaa_ae=0.d0
       allocate(dFc_dbbb_ae(ista_nrc:iend_nrc))                   ;dFc_dbbb_ae=0.d0
       allocate(dFc_dggg_ae(ista_nrc:iend_nrc))                   ;dFc_dggg_ae=0.d0
       allocate(dFc_daab_ae(ista_nrc:iend_nrc))                   ;dFc_daab_ae=0.d0
       allocate(dFc_daag_ae(ista_nrc:iend_nrc))                   ;dFc_daag_ae=0.d0
       allocate(dFc_dabb_ae(ista_nrc:iend_nrc))                   ;dFc_dabb_ae=0.d0
       allocate(dFc_dbbg_ae(ista_nrc:iend_nrc))                   ;dFc_dbbg_ae=0.d0
       allocate(dFc_dagg_ae(ista_nrc:iend_nrc))                   ;dFc_dagg_ae=0.d0
       allocate(dFc_dbgg_ae(ista_nrc:iend_nrc))                   ;dFc_dbgg_ae=0.d0
       allocate(dFc_dabg_ae(ista_nrc:iend_nrc))                   ;dFc_dabg_ae=0.d0
            
       allocate(dF_dgradtnps(ista_nrc:iend_nrc))                  ;dF_dgradtnps=0.d0
       allocate(dFc_daa_ps(ista_nrc:iend_nrc))                    ;dFc_daa_ps=0.d0
       allocate(dFc_dbb_ps(ista_nrc:iend_nrc))                    ;dFc_dbb_ps=0.d0
       allocate(dFc_dgg_ps(ista_nrc:iend_nrc))                    ;dFc_dgg_ps=0.d0
       allocate(dFc_dab_ps(ista_nrc:iend_nrc))                    ;dFc_dab_ps=0.d0
       allocate(dFc_dag_ps(ista_nrc:iend_nrc))                    ;dFc_dag_ps=0.d0
       allocate(dFc_dbg_ps(ista_nrc:iend_nrc))                    ;dFc_dbg_ps=0.d0
       allocate(dFc_daaa_ps(ista_nrc:iend_nrc))                   ;dFc_daaa_ps=0.d0
       allocate(dFc_dbbb_ps(ista_nrc:iend_nrc))                   ;dFc_dbbb_ps=0.d0
       allocate(dFc_dggg_ps(ista_nrc:iend_nrc))                   ;dFc_dggg_ps=0.d0
       allocate(dFc_daab_ps(ista_nrc:iend_nrc))                   ;dFc_daab_ps=0.d0
       allocate(dFc_daag_ps(ista_nrc:iend_nrc))                   ;dFc_daag_ps=0.d0
       allocate(dFc_dabb_ps(ista_nrc:iend_nrc))                   ;dFc_dabb_ps=0.d0
       allocate(dFc_dbbg_ps(ista_nrc:iend_nrc))                   ;dFc_dbbg_ps=0.d0
       allocate(dFc_dagg_ps(ista_nrc:iend_nrc))                   ;dFc_dagg_ps=0.d0
       allocate(dFc_dbgg_ps(ista_nrc:iend_nrc))                   ;dFc_dbgg_ps=0.d0
       allocate(dFc_dabg_ps(ista_nrc:iend_nrc))                   ;dFc_dabg_ps=0.d0
            
       allocate(gaga_ae_sph(ista_nrc:iend_nrc,25))                ;gaga_ae_sph=0.d0
       allocate(naga_ae_sph(ista_nrc:iend_nrc,25))                ;naga_ae_sph=0.d0
       allocate(gg_ae_sph(ista_nrc:iend_nrc,25))                  ;gg_ae_sph=0.d0
       allocate(nag_ae_sph(ista_nrc:iend_nrc,25))                 ;nag_ae_sph=0.d0
            
       allocate(gaga_ps_sph(ista_nrc:iend_nrc,25))                ;gaga_ps_sph=0.d0
       allocate(naga_ps_sph(ista_nrc:iend_nrc,25))                ;naga_ps_sph=0.d0 
       allocate(gg_ps_sph(ista_nrc:iend_nrc,25))                  ;gg_ps_sph=0.d0
       allocate(nag_ps_sph(ista_nrc:iend_nrc,25))                 ;nag_ps_sph=0.d0
            
       allocate(dFxdgaovrga_ae_sph(ista_nrc:iend_nrc,25))         ;dFxdgaovrga_ae_sph=0.d0
       allocate(dFxdgaovrga_ps_sph(ista_nrc:iend_nrc,25))         ;dFxdgaovrga_ps_sph=0.d0
       allocate(dFcdgovrg_ae_sph(ista_nrc:iend_nrc,25))           ;dFcdgovrg_ae_sph=0.d0
       allocate(dFcdgovrg_ps_sph(ista_nrc:iend_nrc,25))           ;dFcdgovrg_ps_sph=0.d0
            
       allocate(dFadga_ae(ista_nrc:iend_nrc))                     ;dFadga_ae=0.d0
       allocate(dFadga_ps(ista_nrc:iend_nrc))                     ;dFadga_ps=0.d0
       allocate(dFadg_ae(ista_nrc:iend_nrc))                      ;dFadg_ae=0.d0
       allocate(dFadg_ps(ista_nrc:iend_nrc))                      ;dFadg_ps=0.d0
       allocate(dFadgaga_ae(ista_nrc:iend_nrc))                   ;dFadgaga_ae=0.d0
       allocate(dFadgaga_ps(ista_nrc:iend_nrc))                   ;dFadgaga_ps=0.d0
       allocate(dFadgg_ae(ista_nrc:iend_nrc))                     ;dFadgg_ae=0.d0
       allocate(dFadgg_ps(ista_nrc:iend_nrc))                     ;dFadgg_ps=0.d0
       allocate(dFadnaga_ae(ista_nrc:iend_nrc))                   ;dFadnaga_ae=0.d0
       allocate(dFadnaga_ps(ista_nrc:iend_nrc))                   ;dFadnaga_ps=0.d0
       allocate(dFadnag_ae(ista_nrc:iend_nrc))                    ;dFadnag_ae=0.d0
       allocate(dFadnag_ps(ista_nrc:iend_nrc))                    ;dFadnag_ps=0.d0
            
       allocate(dGadna_ae(ista_nrc:iend_nrc))                     ;dGadna_ae=0.d0
       allocate(dGadna_ps(ista_nrc:iend_nrc))                     ;dGadna_ps=0.d0
       allocate(dGadga_ae(ista_nrc:iend_nrc))                     ;dGadga_ae=0.d0
       allocate(dGadga_ps(ista_nrc:iend_nrc))                     ;dGadga_ps=0.d0
       allocate(dGadnana_ae(ista_nrc:iend_nrc))                   ;dGadnana_ae=0.d0
       allocate(dGadnana_ps(ista_nrc:iend_nrc))                   ;dGadnana_ps=0.d0
       allocate(dGadnaga_ae(ista_nrc:iend_nrc))                   ;dGadnaga_ae=0.d0
       allocate(dGadnaga_ps(ista_nrc:iend_nrc))                   ;dGadnaga_ps=0.d0
       allocate(dGadgaga_ae(ista_nrc:iend_nrc))                   ;dGadgaga_ae=0.d0
       allocate(dGadgaga_ps(ista_nrc:iend_nrc))                   ;dGadgaga_ps=0.d0
            
       allocate(dGdna_ae(ista_nrc:iend_nrc))                      ;dGdna_ae=0.d0
       allocate(dGdna_ps(ista_nrc:iend_nrc))                      ;dGdna_ps=0.d0
       allocate(dGdg_ae(ista_nrc:iend_nrc))                       ;dGdg_ae=0.d0
       allocate(dGdg_ps(ista_nrc:iend_nrc))                       ;dGdg_ps=0.d0
       allocate(dGdnana_ae(ista_nrc:iend_nrc))                    ;dGdnana_ae=0.d0
       allocate(dGdnana_ps(ista_nrc:iend_nrc))                    ;dGdnana_ps=0.d0
       allocate(dGdgg_ae(ista_nrc:iend_nrc))                      ;dGdgg_ae=0.d0
       allocate(dGdgg_ps(ista_nrc:iend_nrc))                      ;dGdgg_ps=0.d0
       allocate(dGdnag_ae(ista_nrc:iend_nrc))                     ;dGdnag_ae=0.d0
       allocate(dGdnag_ps(ista_nrc:iend_nrc))                     ;dGdnag_ps=0.d0
            
       if(nspin.eq.2) then
          allocate(gbgb_ae_sph(ista_nrc:iend_nrc,25))            ;gbgb_ae_sph=0.d0
          allocate(nbgb_ae_sph(ista_nrc:iend_nrc,25))            ;nbgb_ae_sph=0.d0
          allocate(nbg_ae_sph(ista_nrc:iend_nrc,25))             ;nbg_ae_sph=0.d0
                
          allocate(gbgb_ps_sph(ista_nrc:iend_nrc,25))            ;gbgb_ps_sph=0.d0  
          allocate(nbgb_ps_sph(ista_nrc:iend_nrc,25))            ;nbgb_ps_sph=0.d0
          allocate(nbg_ps_sph(ista_nrc:iend_nrc,25))             ;nbg_ps_sph=0.d0
                
          allocate(dFxdgbovrgb_ae_sph(ista_nrc:iend_nrc,25))     ;dFxdgbovrgb_ae_sph=0.d0
          allocate(dFxdgbovrgb_ps_sph(ista_nrc:iend_nrc,25))     ;dFxdgbovrgb_ps_sph=0.d0
                
          allocate(dFbdgb_ae(ista_nrc:iend_nrc))                 ;dFbdgb_ae=0.d0
          allocate(dFbdgb_ps(ista_nrc:iend_nrc))                 ;dFbdgb_ps=0.d0
          allocate(dFbdg_ae(ista_nrc:iend_nrc))                  ;dFbdg_ae=0.d0
          allocate(dFbdg_ps(ista_nrc:iend_nrc))                  ;dFbdg_ps=0.d0
          allocate(dFbdgbgb_ae(ista_nrc:iend_nrc))               ;dFbdgbgb_ae=0.d0
          allocate(dFbdgbgb_ps(ista_nrc:iend_nrc))               ;dFbdgbgb_ps=0.d0
          allocate(dFbdgg_ae(ista_nrc:iend_nrc))                 ;dFbdgg_ae=0.d0
          allocate(dFbdgg_ps(ista_nrc:iend_nrc))                 ;dFbdgg_ps=0.d0
          allocate(dFbdnbgb_ae(ista_nrc:iend_nrc))               ;dFbdnbgb_ae=0.d0
          allocate(dFbdnbgb_ps(ista_nrc:iend_nrc))               ;dFbdnbgb_ps=0.d0
          allocate(dFbdnbg_ae(ista_nrc:iend_nrc))                ;dFbdnbg_ae=0.d0
          allocate(dFbdnbg_ps(ista_nrc:iend_nrc))                ;dFbdnbg_ps=0.d0
          allocate(dFbdag_ae(ista_nrc:iend_nrc))                 ;dFbdag_ae=0.d0
          allocate(dFbdag_ps(ista_nrc:iend_nrc))                 ;dFbdag_ps=0.d0
                
          allocate(dGbdnb_ae(ista_nrc:iend_nrc))                 ;dGbdnb_ae=0.d0
          allocate(dGbdnb_ps(ista_nrc:iend_nrc))                 ;dGbdnb_ps=0.d0
          allocate(dGbdgb_ae(ista_nrc:iend_nrc))                 ;dGbdgb_ae=0.d0
          allocate(dGbdgb_ps(ista_nrc:iend_nrc))                 ;dGbdgb_ps=0.d0
          allocate(dGbdnbnb_ae(ista_nrc:iend_nrc))               ;dGbdnbnb_ae=0.d0
          allocate(dGbdnbnb_ps(ista_nrc:iend_nrc))               ;dGbdnbnb_ps=0.d0
          allocate(dGbdnbgb_ae(ista_nrc:iend_nrc))               ;dGbdnbgb_ae=0.d0
          allocate(dGbdnbgb_ps(ista_nrc:iend_nrc))               ;dGbdnbgb_ps=0.d0
          allocate(dGbdgbgb_ae(ista_nrc:iend_nrc))               ;dGbdgbgb_ae=0.d0
          allocate(dGbdgbgb_ps(ista_nrc:iend_nrc))               ;dGbdgbgb_ps=0.d0
                
          allocate(dGdnb_ae(ista_nrc:iend_nrc))                  ;dGdnb_ae=0.d0
          allocate(dGdnb_ps(ista_nrc:iend_nrc))                  ;dGdnb_ps=0.d0
          allocate(dGdnbnb_ae(ista_nrc:iend_nrc))                ;dGdnbnb_ae=0.d0
          allocate(dGdnbnb_ps(ista_nrc:iend_nrc))                ;dGdnbnb_ps=0.d0
          allocate(dGdnanb_ae(ista_nrc:iend_nrc))                ;dGdnanb_ae=0.d0
          allocate(dGdnanb_ps(ista_nrc:iend_nrc))                ;dGdnanb_ps=0.d0
          allocate(dGdnbg_ae(ista_nrc:iend_nrc))                 ;dGdnbg_ae=0.d0
          allocate(dGdnbg_ps(ista_nrc:iend_nrc))                 ;dGdnbg_ps=0.d0
                
       end if
            

!            allocate(dF_dnae(mmesh,nspin))
!            allocate(dF_dgradnae(mmesh,nspin))
!            allocate(dF_dgradnae_dr(mmesh,nspin))
!            allocate(dgrad_tnps_dr(mmesh))
!            allocate(dF_dnps(mmesh,nspin))
!            allocate(dF_dgradnps(mmesh,nspin))
!            allocate(dF_dgradnps_dr(mmesh,nspin))
!            allocate(dnae_dr(mmesh,nspin))
!            allocate(dnae_dth(mmesh,nspin))
!            allocate(dnae_dph(mmesh,nspin))
!            allocate(ddnae_ddr(mmesh,nspin))
!            allocate(dnps_dr(mmesh,nspin))
!            allocate(dnps_dth(mmesh,nspin))
!            allocate(dnps_dph(mmesh,nspin))
!            allocate(ddnps_ddr(mmesh,nspin))
!            allocate(dgrad_tnae_dr(mmesh))
    end if
        
    if(af /= 0) then
       allocate(flg_done(natm))
       flg_done=.false.
    end if
    return
  end subroutine paw_xc_sphex_allocate_3D
! ==============================================================================
    
  subroutine paw_xc_sphex_deallocate
    deallocate(nae_sph)
    deallocate(nps_sph)
    deallocate(wos)
    deallocate(irs)
    deallocate(exc_ae_field)
    deallocate(exc_ps_field)
        
    deallocate(nana_ae_sph)
    deallocate(nana_ps_sph)
    
    deallocate(dFxcdna_ae_sph)
    deallocate(dFxcdna_ps_sph)
    
    deallocate(nanb_ae_sph)
    deallocate(nanb_ps_sph)
    
    if(nspin.eq.2) then
       deallocate(nbnb_ae_sph)
       deallocate(nbnb_ps_sph)
       deallocate(dFxcdnb_ae_sph)
       deallocate(dFxcdnb_ps_sph)
    end if
        
    if(check_of_xctype()==GGA) then
       deallocate(grad_nae2_sph)
       deallocate(grad_tnae2_sph)
       deallocate(grad_nps2_sph)
       deallocate(grad_tnps2_sph)
       deallocate(dnae_dr_sph)
       deallocate(ddnae_ddr_sph)
       deallocate(dnps_dr_sph)
       deallocate(ddnps_ddr_sph)
       deallocate(grad_nae)
       deallocate(grad_tnae)
       deallocate(grad_nps)
       deallocate(grad_tnps)
       deallocate(dF_dnae)
       deallocate(dF_dgradnae)
       deallocate(dF_dnps)
       deallocate(dF_dgradnps)
       deallocate(dFx_dnnae)
       deallocate(dFx_dngae)
       deallocate(dFx_dggae)
       deallocate(dFx_dnnnae)
       deallocate(dFx_dnngae)
       deallocate(dFx_dnggae)
       deallocate(dFx_dgggae)
       deallocate(dFx_dnnps)
       deallocate(dFx_dngps)
       deallocate(dFx_dggps)
       deallocate(dFx_dnnnps)
       deallocate(dFx_dnngps)
       deallocate(dFx_dnggps)
       deallocate(dFx_dgggps)
            
       deallocate(dF_dgradtnae)
       deallocate(dFc_daa_ae)
       deallocate(dFc_dbb_ae)
       deallocate(dFc_dgg_ae)
       deallocate(dFc_dab_ae)
       deallocate(dFc_dag_ae)
       deallocate(dFc_dbg_ae)
       deallocate(dFc_daaa_ae)
       deallocate(dFc_dbbb_ae)
       deallocate(dFc_dggg_ae)
       deallocate(dFc_daab_ae)
       deallocate(dFc_daag_ae)
       deallocate(dFc_dabb_ae)
       deallocate(dFc_dbbg_ae)
       deallocate(dFc_dagg_ae)
       deallocate(dFc_dbgg_ae)
       deallocate(dFc_dabg_ae)
            
       deallocate(dF_dgradtnps)
       deallocate(dFc_daa_ps)
       deallocate(dFc_dbb_ps)
       deallocate(dFc_dgg_ps)
       deallocate(dFc_dab_ps)
       deallocate(dFc_dag_ps)
       deallocate(dFc_dbg_ps)
       deallocate(dFc_daaa_ps)
       deallocate(dFc_dbbb_ps)
       deallocate(dFc_dggg_ps)
       deallocate(dFc_daab_ps)
       deallocate(dFc_daag_ps)
       deallocate(dFc_dabb_ps)
       deallocate(dFc_dbbg_ps)
       deallocate(dFc_dagg_ps)
       deallocate(dFc_dbgg_ps)
       deallocate(dFc_dabg_ps)
            
       deallocate(gaga_ae_sph)
       deallocate(naga_ae_sph)
       deallocate(gg_ae_sph)
       deallocate(nag_ae_sph)
            
       deallocate(gaga_ps_sph)
       deallocate(naga_ps_sph)  
       deallocate(gg_ps_sph)
       deallocate(nag_ps_sph)
            
       deallocate(dFxdgaovrga_ae_sph)
       deallocate(dFxdgaovrga_ps_sph)
       deallocate(dFcdgovrg_ae_sph)
       deallocate(dFcdgovrg_ps_sph)
            
       deallocate(dFadga_ae)
       deallocate(dFadga_ps)
       deallocate(dFadg_ae)
       deallocate(dFadg_ps)
       deallocate(dFadgaga_ae)
       deallocate(dFadgaga_ps)
       deallocate(dFadgg_ae)
       deallocate(dFadgg_ps)
       deallocate(dFadnaga_ae)
       deallocate(dFadnaga_ps)
       deallocate(dFadnag_ae)
       deallocate(dFadnag_ps)
            
       deallocate(dGadna_ae)
       deallocate(dGadna_ps)
       deallocate(dGadga_ae)
       deallocate(dGadga_ps)
       deallocate(dGadnana_ae)
       deallocate(dGadnana_ps)
       deallocate(dGadnaga_ae)
       deallocate(dGadnaga_ps)
       deallocate(dGadgaga_ae)
       deallocate(dGadgaga_ps)
            
       deallocate(dGdna_ae)
       deallocate(dGdna_ps)
       deallocate(dGdg_ae)
       deallocate(dGdg_ps)
       deallocate(dGdnana_ae)
       deallocate(dGdnana_ps)
       deallocate(dGdgg_ae)
       deallocate(dGdgg_ps)
       deallocate(dGdnag_ae)
       deallocate(dGdnag_ps)
            
       if(nspin.eq.2) then
          deallocate(gbgb_ae_sph)
          deallocate(nbgb_ae_sph)
          deallocate(nbg_ae_sph)
                
          deallocate(gbgb_ps_sph) 
          deallocate(nbgb_ps_sph)
          deallocate(nbg_ps_sph)
                
          deallocate(dFxdgbovrgb_ae_sph)
          deallocate(dFxdgbovrgb_ps_sph)
                
          deallocate(dFbdgb_ae)
          deallocate(dFbdgb_ps)
          deallocate(dFbdg_ae)
          deallocate(dFbdg_ps)
          deallocate(dFbdgbgb_ae)
          deallocate(dFbdgbgb_ps)
          deallocate(dFbdgg_ae)
          deallocate(dFbdgg_ps)
          deallocate(dFbdnbgb_ae)
          deallocate(dFbdnbgb_ps)
          deallocate(dFbdnbg_ae)
          deallocate(dFbdnbg_ps)
          deallocate(dFbdag_ae)
          deallocate(dFbdag_ps)
                
          deallocate(dGbdnb_ae)
          deallocate(dGbdnb_ps)
          deallocate(dGbdgb_ae)
          deallocate(dGbdgb_ps)
          deallocate(dGbdnbnb_ae)
          deallocate(dGbdnbnb_ps)
          deallocate(dGbdnbgb_ae)
          deallocate(dGbdnbgb_ps)
          deallocate(dGbdgbgb_ae)
          deallocate(dGbdgbgb_ps)
                
          deallocate(dGdnb_ae)
          deallocate(dGdnb_ps)
          deallocate(dGdnbnb_ae)
          deallocate(dGdnbnb_ps)
          deallocate(dGdnanb_ae)
          deallocate(dGdnanb_ps)
          deallocate(dGdnbg_ae)
          deallocate(dGdnbg_ps)
                
       end if
            
    end if
    if(af /= 0) deallocate(flg_done)
    return
  end subroutine paw_xc_sphex_deallocate

! === For nrc decomposion. by takto 2012/12/05 =================================
  subroutine mult_sphex_element3_3D(nrc,dnr,mode  &
       &                           ,n1,num_isph1,isph1 &
       &                           ,n2,num_isph2,isph2 &
       &                           ,n3,num_isph3,isph3, ist,ien)
    integer,intent(in):: nrc,dnr,mode
    integer,intent(in):: num_isph1,isph1(25)
    integer,intent(in):: num_isph2,isph2(25)
    real(DP),intent(in):: n1(ista_nrc:iend_nrc,25),n2(ista_nrc:iend_nrc,25)
    real(DP),intent(out):: n3(ista_nrc:iend_nrc,25)
    integer,intent(out):: num_isph3,isph3(25)
    integer, intent(in) :: ist, ien
    
    integer:: ir,isp,isp1,isp2,n ! msphmx3
    integer:: nsp,nsp1,nsp2
    real(DP):: fac,cijk
    logical:: flg_isp(25)
        
    n3=0.d0
    flg_isp=.false.
!        do isp=2,msphmx
    do nsp=2,num_isph1
       isp=isph1(nsp)
       do ir=ist,ien,dnr
          n3(ir,1)=n3(ir,1) + n1(ir,isp)*n2(ir,isp)
       end do
    end do
        
    do ir=ist,ien,dnr
       n3(ir,1)=n3(ir,1)/PAI4
    end do
        
    if(mode.eq.0) return
        
    flg_isp(1)=.true.
        
!!$    msphmx3=0
!        do isp1=2,msphmx                                            ! sphset3 
    do nsp1=2,num_isph1
       isp1=isph1(nsp1)
!            do isp2=isp1,min(16,msphmx)                             ! sphset2
!            do isp2=isp1,msphmx                                     ! sphset3
       do nsp2=nsp1,num_isph2
          isp2=isph2(nsp2)
          fac=1.d0;if(isp1.eq.isp2) fac=0.5d0
          do n=1,paw_mmt2(isp1,isp2)
             isp=paw_isph2(isp1,isp2,n)
             if(isp.eq.1) cycle
!!$             if(isp.gt.msphmx3) msphmx3=isp
             flg_isp(isp)=.true.
             cijk=paw_cr2(isp1,isp2,n)

             do ir=ist,ien,dnr
                n3(ir,isp)=n3(ir,isp) + &
                     fac*(n1(ir,isp1)*n2(ir,isp2)+n1(ir,isp2)*n2(ir,isp1))*cijk
             end do
          end do
       end do
    end do
    num_isph3=0
    isph3=0
    do isp=1,25
       if(flg_isp(isp)) then
          num_isph3=num_isph3+1
          isph3(num_isph3)=isp
       end if
    end do
    return
    
  end subroutine mult_sphex_element3_3D

! ==============================================================================
  subroutine m_PAW_XC_cal_potential_sphex2(nfout,vflag)
    integer,intent(in):: nfout,vflag
        
    integer:: ia,it
    integer:: ir,is,nsph,ksph
!integer:: i
    integer:: ier,mode
    integer:: nrc,msphmx_chg,msphmx_grd
    real(DP):: iga_ae,iga_ps,igb_ae,igb_ps,ig_ae,ig_ps
    real(DP):: sum1,sum2,sum3,sum4,sum5,sum6,sq4pi,zz
    integer:: nrc0,dnr
    integer:: num_isph_chg,num_isph_grd
    integer:: isph_chg(25),isph_grd(25)
    integer:: num_isph_n_n,isph_n_n(25)
    integer:: num_isph_n_g,isph_n_g(25)
    integer:: num_isph_g_g,isph_g_g(25)
    integer:: num_isph_nnn,isph_nnn(25)
    integer:: num_isph_ngg,isph_ngg(25)
    integer:: num_isph_ggg,isph_ggg(25)
    integer:: num_isph_all,isph_all(25)
    integer:: num_isph_2tm,isph_2tm(25)
        
    integer, parameter :: PRINTLEVEL = 2
    integer, parameter :: DEBUGPRINTLEVEL = 3
    integer        :: id_sname = -1
    integer :: ista,iend

    integer :: ia_add, ierr, nelt
! === For nrc decomposion. by takto 2012/12/07 =================================
    real(DP), allocatable, dimension(:,:) :: tmp0, tmp1, tmp2, tmp3, tmp4, tmp5
    integer :: ist, ien
! ==============================================================================

START_TIMER('m_PAW_XC_cal_potential_sphex2')
    call tstatc0_begin('m_PAW_XC_cal_potential_sphex2 ',id_sname,level=1)
        
    call paw_xc_sphex_allocate_3D   ! == For nrc decomposion. by takto 2012/12/05 ==

! =========================== added by K. Tagami ======================== 11.0
    if ( noncol ) then
       magmom_local_now = 0.0d0
!
       if ( allocated(magmom_local_ae) ) magmom_local_ae = 0.0d0
       if ( allocated(magmom_local_ps) ) magmom_local_ps = 0.0d0
       if ( allocated(magmom_local_wk) ) magmom_local_wk = 0.0d0

       if ( allocated(rho_rad_ae) ) rho_rad_ae = 0.0d0
       if ( allocated(rho_rad_ps) ) rho_rad_ps = 0.0d0
       if ( allocated(rho_rad_wk) ) rho_rad_wk = 0.0d0

    endif
! ======================================================================= 11.0
        
    exc_ae=0.d0;   exc_ps=0.d0
        
    vxc_ae_k_3D=0.d0 ! == For nrc decomposion. by takto 2012/12/05 ==
    vxc_ps_k_3D=0.d0 ! == For nrc decomposion. by takto 2012/12/05 ==

! === For nrc decomposion. by takto 2012/12/07 =================================
    if(paw_no_work_to_do) goto 999 ! This proc. has no nrc elements!
! ==============================================================================

    do ia = ista_natm, iend_natm
       ia_add = ia - ista_natm + 1
       if(af /= 0) then
          if(flg_done(ia)) cycle
       end if

       it=ityp(ia)
       if(ipaw(it)/=1 .or. &
            & surface_integral_method(it).ne.SphericalHarmonicsExpansion) cycle
!!$                 & surface_integral_method(it).ne."SphericalHarmonicsExpansion") cycle
       dnr=paw_dnr(it)
! === For nrc decomposion. by takto 2012/12/05 =================================
       if(dnr.gt.1) then
          nrc0=wf_mnrc(it)
          nrc=1+int((nrc0-1)/dnr)*dnr
!                zz = (radr_paw(nrc0,it)-radr_paw(nrc,it))/ &
!                        (radr_paw(nrc+dnr,it)-radr_paw(nrc,it))
!                zz = log(radr_paw(nrc0,it)/radr_paw(nrc,it))/ &
!                        log(radr_paw(nrc+dnr,it)/radr_paw(nrc,it))
          zz = dble(nrc0-nrc)/dble(dnr)
          nrc=nrc+2*dnr
       else
          nrc=wf_mnrc(it)
       end if
       ist = (ista_nrc+dnr-2)/dnr
       ist = dnr*ist+1
       ien = min(iend_nrc, nrc)
       if(dnr.gt.1) then
          call set_weight_exp3_3D(ier,1,nrc,dnr,radr_paw(1,it),zz,wos & ! == For nrc decomposion. by takto 2012/12/05 ==
               &                 ,ista_nrc,iend_nrc,ist,ien)
       else
          call set_weight_exp_3D(ier,1,nrc,radr_paw(1,it),wos,ista_nrc,iend_nrc,ist,ien)
       end if

       do ir=ist,ien,dnr    ! == For nrc decomposion. by takto 2012/12/05 ==
          wos(ir)=wos(ir)*radr_paw(ir,it)**2
       end do
       wos=wos*iwei(ia)
!!$       msphmx_chg=0
! ============================= modified by K. Tagami ================ 11.0

       if ( noncol ) then

          select case(level_of_projection_paw_charge)
          case (1)
             call m_PAWCD_ae_cd_sphex2_nonclA(ia,nspin,nrc,dnr,nae_sph,msphmx_chg,num_isph_chg,isph_chg,wos &
                  &                          ,1,magmom_local_wk, rho_rad_wk,ista_nrc,iend_nrc,ist )
          case (2)
             call m_PAWCD_ae_cd_sphex2_nonclA(ia,nspin,nrc,dnr,nae_sph,msphmx_chg,num_isph_chg,isph_chg,wos &
                  &                          ,2,magmom_local_ae(ia,:,:), rho_rad_wk,ista_nrc,iend_nrc,ist )
          case (3)
             call m_PAWCD_ae_cd_sphex2_nonclA(ia,nspin,nrc,dnr,nae_sph,msphmx_chg,num_isph_chg,isph_chg,wos &
                  &   ,3,magmom_local_ae(ia,:,:), rho_rad_ae(ia,ista_nrc:iend_nrc,:,:),ista_nrc,iend_nrc,ist)
          end select

       else
! === For nrc decomposion. by takto 2012/12/05 =================================
          call m_PAWCD_set_ae_cd_sphex2( ia, nspin, nrc, dnr, msph, nae_sph, msphmx_chg &
               &                       , num_isph_chg, isph_chg, ista_nrc,iend_nrc,ist )
! ==============================================================================
       endif
! ====================================================================== 11.0

       if(iprixc >= PRINTLEVEL) write(nfout,'(" num_isph_chg = ",i8)') num_isph_chg

! ============================= modified by K. Tagami ================ 11.0
       if ( noncol ) then

          select case(level_of_projection_paw_charge)
          case (1)
             call m_PAWCD_ps_cd_sphex2_nonclA( ia,nspin,nrc,dnr,nps_sph,msphmx_chg,num_isph_chg,isph_chg,wos &
                  &                          , 1,magmom_local_wk, rho_rad_wk,ista_nrc,iend_nrc,ist)
             magmom_local_now(ia,1:3) = magmom_local_wk(1:3,1)
          case (2)
             call m_PAWCD_ps_cd_sphex2_nonclA( ia,nspin,nrc,dnr,nps_sph,msphmx_chg,num_isph_chg,isph_chg,wos &
                  &                          , 2,magmom_local_ps(ia,:,:), rho_rad_wk,ista_nrc,iend_nrc,ist)
          case (3)
             call m_PAWCD_ps_cd_sphex2_nonclA( ia,nspin,nrc,dnr,nps_sph,msphmx_chg,num_isph_chg,isph_chg,wos &
                  &   , 3,magmom_local_ps(ia,:,:), rho_rad_ps(ia,ista_nrc:iend_nrc,:,:),ista_nrc,iend_nrc,ist)
          end select

       else
! === For nrc decomposion. by takto 2012/12/05 =================================
          call m_PAWCD_set_ps_cd_sphex2( ia, nspin, nrc, dnr, msph, nps_sph, msphmx_chg & 
               &     , num_isph_chg, isph_chg, ista_nrc, iend_nrc, ist) 
! ==============================================================================
       endif
! ====================================================================== 11.0

       if(iprixc >= PRINTLEVEL) write(nfout,'(" num_isph_chg = ",i8)') num_isph_chg

       if(check_of_xctype()==GGA) then 
          call ggaxcp_paw_sphex2_3D()  ! == For nrc decomposion. by takto 2012/12/05 ==
       else
!                call xcpotf_paw(nrc,nspin,ith,Valence_plus_PC_Charge) 
       end if
                        
       if(vflag == EXC_ONLY) then
          mode=0
       else if(vflag == VXC_AND_EXC) then
          mode=1
       end if
                    
! === For nrc decomposion. by takto 2012/12/05 =================================
       call set_sphex_elements2_3D(nrc,dnr,mode &
            &              ,num_isph_chg,isph_chg, num_isph_grd,isph_grd &
            &              ,num_isph_n_n,isph_n_n, num_isph_n_g,isph_n_g &
            &              ,num_isph_g_g,isph_g_g, ist,ien)
       
       do ir=ist,ien,dnr
! ==============================================================================
          sum1 = exc_ae_field(ir) &
               &  + 0.5d0*(dFx_dnnae(ir,1)+dFc_daa_ae(ir))*nana_ae_sph(ir,1)
          sum2 = exc_ps_field(ir) &
               &  + 0.5d0*(dFx_dnnps(ir,1)+dFc_daa_ps(ir))*nana_ps_sph(ir,1)
          if(nspin.eq.2) then
             sum1 = sum1  &
                  &  +  0.5d0*(dFx_dnnae(ir,2) + dFc_dbb_ae(ir)) * nbnb_ae_sph(ir,1)  &
                  &                            +  dFc_dab_ae(ir) * nanb_ae_sph(ir,1)   
             sum2 = sum2  &
                  &  +  0.5d0*(dFx_dnnps(ir,2) + dFc_dbb_ps(ir)) * nbnb_ps_sph(ir,1)  &
                  &                            +  dFc_dab_ps(ir) * nanb_ps_sph(ir,1)
          end if

! ==== ASMS === 2017/11/08
!                if(check_of_xctype()==GGA .and. xctype /= 'ldapw91' &
!                     &                    .and. xctype /= 'ldapbe ' &
!                     &                    .and. xctype /= 'vdwdf') then
          if(check_of_xctype()==GGA .and. xctype /= 'ldapw91' &
                     &                    .and. xctype /= 'ldapbe ' ) then
! ==== ASMS === 2017/11/08

             if(dabs(grad_nae(ir,1)) < DELTA10) cycle
             if(dabs(grad_tnae(ir)) < DELTA10) cycle
             if(dabs(grad_nps(ir,1)) < DELTA10) cycle
             if(dabs(grad_tnps(ir)) < DELTA10) cycle

             sum1 = sum1  &
                  &  + 0.125d0*(dFx_dggae(ir,1)-dF_dgradnae(ir,1)/grad_nae(ir,1)) &
                  &                   /grad_nae(ir,1)/grad_nae(ir,1)*gaga_ae_sph(ir,1)  &
                  &  + 0.5d0*dFx_dngae(ir,1)/grad_nae(ir,1)*naga_ae_sph(ir,1)  &
                  &  + 0.125d0*(dFc_dgg_ae(ir)-dF_dgradtnae(ir)/grad_tnae(ir)) &
                  &                  /grad_tnae(ir)/grad_tnae(ir)*gg_ae_sph(ir,1)  &
                  &  + 0.5d0*dFc_dag_ae(ir)/grad_tnae(ir)*nag_ae_sph(ir,1)
                        
             sum2 = sum2  &
                  &  + 0.125d0*(dFx_dggps(ir,1)-dF_dgradnps(ir,1)/grad_nps(ir,1)) &
                  &                  /grad_nps(ir,1)/grad_nps(ir,1)*gaga_ps_sph(ir,1)  &
                  &  + 0.5d0*dFx_dngps(ir,1)/grad_nps(ir,1)*naga_ps_sph(ir,1)  &
                  &  + 0.125d0*(dFc_dgg_ps(ir)-dF_dgradtnps(ir)/grad_tnps(ir)) &
                  &                  /grad_tnps(ir)/grad_tnps(ir)*gg_ps_sph(ir,1) &
                  &  + 0.5d0*dFc_dag_ps(ir)/grad_tnps(ir)*nag_ps_sph(ir,1)
             if(nspin.eq.2) then
                if(dabs(grad_nae(ir,2)) < DELTA10) cycle
                if(dabs(grad_nps(ir,2)) < DELTA10) cycle
                sum1 = sum1  &
                     &  +  0.125d0*(dFx_dggae(ir,2)-dF_dgradnae(ir,2)/grad_nae(ir,2)) &
                     &                 /grad_nae(ir,2)/grad_nae(ir,2)*gbgb_ae_sph(ir,1)  &
                     &  +  0.5d0*dFx_dngae(ir,2)/grad_nae(ir,2)*nbgb_ae_sph(ir,1) &
                     &  +  0.5d0*dFc_dbg_ae(ir)/grad_tnae(ir)*nbg_ae_sph(ir,1)
                sum2 = sum2  &
                     &  +  0.125d0*(dFx_dggps(ir,2)-dF_dgradnps(ir,2)/grad_nps(ir,2)) &
                     &                 /grad_nps(ir,2)/grad_nps(ir,2)*gbgb_ps_sph(ir,1)  &
                     &  +  0.5d0*dFx_dngps(ir,2)/grad_nps(ir,2)*nbgb_ps_sph(ir,1)  &
                     &  +  0.5d0*dFc_dbg_ps(ir)/grad_tnps(ir)*nbg_ps_sph(ir,1)
             end if
          end if
          exc_ae = exc_ae + sum1*wos(ir)
          exc_ps = exc_ps + sum2*wos(ir)
       end do

#ifdef DEBUG_PAW3D            
       write(nfout,'(" ia, ist,ien = ",3i8," exc_ae, exc_ps = ",2f20.8)') ia, ist,ien,exc_ae, exc_ps
#endif
!            exc_ae=exc_ae*PAI4*dble(af+1)
!            exc_ps=exc_ps*PAI4*dble(af+1)
        
       if(vflag == VXC_AND_EXC) then
            
! ==== ASMS === 2017/11/08
!                if(check_of_xctype()==GGA   .and. xctype /= 'ldapw91' &
!                                            .and. xctype /= 'ldapbe ' &
!                                            .and. xctype /= 'vdwdf' ) then
          if(check_of_xctype()==GGA .and. xctype /= 'ldapw91' .and. xctype /= 'ldapbe ' )  then
! ==== ASMS === 2017/11/08

             do ir=ist,ien,dnr  ! == For nrc decomposion. by takto 2012/12/05 ==
                iga_ae = 0.d0
                if(dabs(grad_nae(ir,1)) > 1.d-9) iga_ae = 1.d0/grad_nae(ir,1)

                ig_ae = 0.d0
                if(dabs(grad_tnae(ir)) > 1.d-9)  ig_ae = 1.d0/grad_tnae(ir)

                iga_ps = 0.d0
                if(dabs(grad_nps(ir,1)) > 1.d-9) iga_ps = 1.d0/grad_nps(ir,1)

                ig_ps = 0.d0
                if(dabs(grad_tnps(ir)) > 1.d-9)  ig_ps = 1.d0/grad_tnps(ir)

                dFadga_ae(ir)   = 0.5d0*dFx_dngae(ir,1)*iga_ae
                dFadga_ps(ir)   = 0.5d0*dFx_dngps(ir,1)*iga_ps
                dFadg_ae(ir)    = 0.5d0*dFc_dag_ae(ir)*ig_ae
                dFadg_ps(ir)    = 0.5d0*dFc_dag_ps(ir)*ig_ps
                dFadgaga_ae(ir) = 0.25d0*(dFx_dnggae(ir,1) - dFx_dngae(ir,1)*iga_ae)*iga_ae**2
                dFadgaga_ps(ir) = 0.25d0*(dFx_dnggps(ir,1) - dFx_dngps(ir,1)*iga_ps)*iga_ps**2
                dFadgg_ae(ir)   = 0.25d0*(dFc_dagg_ae(ir) - dFc_dag_ae(ir)*ig_ae)*ig_ae**2
                dFadgg_ps(ir)   = 0.25d0*(dFc_dagg_ps(ir) - dFc_dag_ps(ir)*ig_ps)*ig_ps**2
                dFadnaga_ae(ir) = 0.5d0*dFx_dnngae(ir,1)*iga_ae
                dFadnaga_ps(ir) = 0.5d0*dFx_dnngps(ir,1)*iga_ps
                dFadnag_ae(ir)  = 0.5d0*dFc_daag_ae(ir)*ig_ae
                dFadnag_ps(ir)  = 0.5d0*dFc_daag_ps(ir)*ig_ps
                        
                dGadna_ae(ir)   = dFx_dngae(ir,1)*iga_ae
                dGadna_ps(ir)   = dFx_dngps(ir,1)*iga_ps
                dGadga_ae(ir)   = 0.5d0*(dFx_dggae(ir,1) - dF_dgradnae(ir,1)*iga_ae)*iga_ae**2
                dGadga_ps(ir)   = 0.5d0*(dFx_dggps(ir,1) - dF_dgradnps(ir,1)*iga_ps)*iga_ps**2
                dGadnana_ae(ir) = dFx_dnngae(ir,1)*iga_ae
                dGadnana_ps(ir) = dFx_dnngps(ir,1)*iga_ps
                dGadnaga_ae(ir) = 0.5d0*(dFx_dnggae(ir,1) - dFx_dngae(ir,1)*iga_ae)*iga_ae**2
                dGadnaga_ps(ir) = 0.5d0*(dFx_dnggps(ir,1) - dFx_dngps(ir,1)*iga_ps)*iga_ps**2
                dGadgaga_ae(ir) = 0.25d0*(dFx_dgggae(ir,1) &
                     &                              - 3.d0*dFx_dggae(ir,1)*iga_ae &
                     &                              + 3.d0*dF_dgradnae(ir,1)*iga_ae**2)*iga_ae**3
                dGadgaga_ps(ir) = 0.25d0*(dFx_dgggps(ir,1) &
                     &                              - 3.d0*dFx_dggps(ir,1)*iga_ps &
                     &                              + 3.d0*dF_dgradnps(ir,1)*iga_ps**2)*iga_ps**3
                                                    
                dGdna_ae(ir)    = dFc_dag_ae(ir)*ig_ae
                dGdna_ps(ir)    = dFc_dag_ps(ir)*ig_ps
                dGdg_ae(ir)     = 0.5d0*(dFc_dgg_ae(ir) - dF_dgradtnae(ir)*ig_ae)*ig_ae**2
                dGdg_ps(ir)     = 0.5d0*(dFc_dgg_ps(ir) - dF_dgradtnps(ir)*ig_ps)*ig_ps**2
                dGdnana_ae(ir)  = dFc_daag_ae(ir)*ig_ae
                dGdnana_ps(ir)  = dFc_daag_ps(ir)*ig_ps
                dGdgg_ae(ir)    = 0.25d0*(dFc_dggg_ae(ir) &
                     &                            - 3.d0*dFc_dgg_ae(ir)*ig_ae &
                     &                            + 3.d0*dF_dgradtnae(ir)*ig_ae**2)*ig_ae**3
                dGdgg_ps(ir)    = 0.25d0*(dFc_dggg_ps(ir) &
                     &                            - 3.d0*dFc_dgg_ps(ir)*ig_ps &
                     &                            + 3.d0*dF_dgradtnps(ir)*ig_ps**2)*ig_ps**3
                dGdnag_ae(ir)   = 0.5d0*(dFc_dagg_ae(ir) - dFc_dag_ae(ir)*ig_ae)*ig_ae**2
                dGdnag_ps(ir)   = 0.5d0*(dFc_dagg_ps(ir) - dFc_dag_ps(ir)*ig_ps)*ig_ps**2
                        
                if(nspin.eq.2) then

                   igb_ae=0.d0
                   if(dabs(grad_nae(ir,2)) > 1.d-9) igb_ae=1.d0/grad_nae(ir,2)

                   igb_ps=0.d0
                   if(dabs(grad_nps(ir,2)) > 1.d-9) igb_ps=1.d0/grad_nps(ir,2)

                   dFbdgb_ae(ir)   = 0.5d0*dFx_dngae(ir,2)*igb_ae
                   dFbdgb_ps(ir)   = 0.5d0*dFx_dngps(ir,2)*igb_ps
                   dFbdg_ae(ir)    = 0.5d0*dFc_dbg_ae(ir)*ig_ae
                   dFbdg_ps(ir)    = 0.5d0*dFc_dbg_ps(ir)*ig_ps
                   dFbdgbgb_ae(ir) = 0.25d0*(dFx_dnggae(ir,2) - dFx_dngae(ir,2)*igb_ae)*igb_ae**2
                   dFbdgbgb_ps(ir) = 0.25d0*(dFx_dnggps(ir,2) - dFx_dngps(ir,2)*igb_ps)*igb_ps**2
                   dFbdgg_ae(ir)   = 0.25d0*(dFc_dbgg_ae(ir) - dFc_dbg_ae(ir)*ig_ae)*ig_ae**2
                   dFbdgg_ps(ir)   = 0.25d0*(dFc_dbgg_ps(ir) - dFc_dbg_ps(ir)*ig_ps)*ig_ps**2
                   dFbdnbgb_ae(ir) = 0.5d0*dFx_dnngae(ir,2)*igb_ae
                   dFbdnbgb_ps(ir) = 0.5d0*dFx_dnngps(ir,2)*igb_ps
                   dFbdnbg_ae(ir)  = 0.5d0*dFc_dbbg_ae(ir)*ig_ae
                   dFbdnbg_ps(ir)  = 0.5d0*dFc_dbbg_ps(ir)*ig_ps
                   dFbdag_ae(ir)   = 0.5d0*dFc_dabg_ae(ir)*ig_ae
                   dFbdag_ps(ir)   = 0.5d0*dFc_dabg_ps(ir)*ig_ps
                            
                   dGbdnb_ae(ir)   = dFx_dngae(ir,2)*igb_ae
                   dGbdnb_ps(ir)   = dFx_dngps(ir,2)*igb_ps
                   dGbdgb_ae(ir)   = 0.5d0*(dFx_dggae(ir,2) - dF_dgradnae(ir,2)*igb_ae)*igb_ae**2
                   dGbdgb_ps(ir)   = 0.5d0*(dFx_dggps(ir,2) - dF_dgradnps(ir,2)*igb_ps)*igb_ps**2
                   dGbdnbnb_ae(ir) = dFx_dnngae(ir,2)*igb_ae
                   dGbdnbnb_ps(ir) = dFx_dnngps(ir,2)*igb_ps
                   dGbdnbgb_ae(ir) = 0.5d0*(dFx_dnggae(ir,2) - dFx_dngae(ir,2)*igb_ae)*igb_ae**2
                   dGbdnbgb_ps(ir) = 0.5d0*(dFx_dnggps(ir,2) - dFx_dngps(ir,2)*igb_ps)*igb_ps**2
                   dGbdgbgb_ae(ir) = 0.25d0*(dFx_dgggae(ir,2) &
                        &                           - 3.d0*dFx_dggae(ir,2)*igb_ae &
                        &                           + 3.d0*dF_dgradnae(ir,2)*igb_ae**2)*igb_ae**3
                   dGbdgbgb_ps(ir) = 0.25d0*(dFx_dgggps(ir,2) &
                        &                           - 3.d0*dFx_dggps(ir,2)*igb_ps &
                        &                           + 3.d0*dF_dgradnps(ir,2)*igb_ps**2)*igb_ps**3
                                        
                   dGdnb_ae(ir)    = dFc_dbg_ae(ir)*ig_ae
                   dGdnb_ps(ir)    = dFc_dbg_ps(ir)*ig_ps
                   dGdnbnb_ae(ir)  = dFc_dbbg_ae(ir)*ig_ae
                   dGdnbnb_ps(ir)  = dFc_dbbg_ps(ir)*ig_ps
                   dGdnanb_ae(ir)  = dFc_dabg_ae(ir)*ig_ae
                   dGdnanb_ps(ir)  = dFc_dabg_ps(ir)*ig_ps
                   dGdnbg_ae(ir)   = 0.5d0*(dFc_dbgg_ae(ir) - dFc_dbg_ae(ir)*ig_ae)*ig_ae**2
                   dGdnbg_ps(ir)   = 0.5d0*(dFc_dbgg_ps(ir) - dFc_dbg_ps(ir)*ig_ps)*ig_ps**2
                        
                end if
                    
             end do
          end if
            
!                dFxcdna_ae_sph=0.d0
!                dFxcdna_ps_sph=0.d0
!                dFxcdnb_ae_sph=0.d0
!                dFxcdnb_ps_sph=0.d0
! ==== ASMS === 2017/11/08
!                if(check_of_xctype()==GGA   .and. xctype /= 'ldapw91' &
!                                            .and. xctype /= 'ldapbe ' &
!                                            .and. xctype /= 'vdwdf' ) then
          if(check_of_xctype()==GGA  .and. xctype /= 'ldapw91' .and. xctype /= 'ldapbe ' ) then
! ==== ASMS === 2017/11/08
             num_isph_2tm=num_isph_g_g
             isph_2tm=isph_g_g
          else
             num_isph_2tm=num_isph_n_n
             isph_2tm=isph_n_n
          end if
            

          do ir=ist,ien,dnr ! == For nrc decomposion. by takto 2012/12/05 ==
!                    do nsph=1,msphmx_grd
!                    do ksph=1,num_isph_g_g
!                        nsph=isph_g_g(ksph)
             do ksph=1,num_isph_2tm
                nsph=isph_2tm(ksph)
                sum1 = 0.5d0*(dFx_dnnnae(ir,1) + dFc_daaa_ae(ir))*nana_ae_sph(ir,nsph)
                sum2 = 0.5d0*(dFx_dnnnps(ir,1) + dFc_daaa_ps(ir))*nana_ps_sph(ir,nsph)
                if(nspin.eq.2) then
                   sum1 = sum1 + &
                        &     0.5d0*dFc_dabb_ae(ir)*nbnb_ae_sph(ir,nsph) + &
                        &     dFc_daab_ae(ir)*nanb_ae_sph(ir,nsph)
                   sum2 = sum2 + &
                        &     0.5d0*dFc_dabb_ps(ir)*nbnb_ps_sph(ir,nsph) + &
                        &     dFc_daab_ps(ir)*nanb_ps_sph(ir,nsph)
                                
                   sum3 = 0.5d0*(dFx_dnnnae(ir,2) + dFc_dbbb_ae(ir))*nbnb_ae_sph(ir,nsph) + &
                        &     0.5d0*dFc_daab_ae(ir)*nana_ae_sph(ir,nsph) + &
                        &     dFc_dabb_ae(ir)*nanb_ae_sph(ir,nsph)
                   sum4 = 0.5d0*(dFx_dnnnps(ir,2) + dFc_dbbb_ps(ir))*nbnb_ps_sph(ir,nsph) + &
                        &     0.5d0*dFc_daab_ps(ir)*nana_ps_sph(ir,nsph) + &
                        &     dFc_dabb_ps(ir)*nanb_ps_sph(ir,nsph)
                end if
                        
! ==== ASMS === 2017/11/08
!                        if(check_of_xctype()==GGA   .and. xctype /= 'ldapw91' &
!                                                    .and. xctype /= 'ldapbe ' &
!                                                    .and. xctype /= 'vdwdf' ) then
                if(check_of_xctype()==GGA  .and. xctype /= 'ldapw91' .and. xctype /= 'ldapbe ') then
! ==== ASMS === 2017/11/08
                   sum1 = sum1 + &
                        &   0.5d0*dFadgaga_ae(ir)*gaga_ae_sph(ir,nsph) + &
                        &   0.5d0*dFadgg_ae(ir)*gg_ae_sph(ir,nsph) + &
                        &   dFadnaga_ae(ir)*naga_ae_sph(ir,nsph) + &
                        &   dFadnag_ae(ir)*nag_ae_sph(ir,nsph)
                   sum2 = sum2 + &
                        &   0.5d0*dFadgaga_ps(ir)*gaga_ps_sph(ir,nsph) + &
                        &   0.5d0*dFadgg_ps(ir)*gg_ps_sph(ir,nsph) + &
                        &   dFadnaga_ps(ir)*naga_ps_sph(ir,nsph) + &
                        &   dFadnag_ps(ir)*nag_ps_sph(ir,nsph)
                                
                   if(nspin.eq.2) then
                      sum1 = sum1 + dFbdag_ae(ir)*nbg_ae_sph(ir,nsph)
                      sum2 = sum2 + dFbdag_ps(ir)*nbg_ps_sph(ir,nsph)
                                
                      sum3 = sum3 + &
                           &  0.5d0*dFbdgbgb_ae(ir)*gbgb_ae_sph(ir,nsph) + &
                           &  0.5d0*dFbdgg_ae(ir)*gg_ae_sph(ir,nsph) + &
                           &  dFbdnbgb_ae(ir)*nbgb_ae_sph(ir,nsph) + &
                           &  dFbdnbg_ae(ir)*nbg_ae_sph(ir,nsph) + &
                           &  dFbdag_ae(ir)*nag_ae_sph(ir,nsph)
                      sum4 = sum4 + &
                           &  0.5d0*dFbdgbgb_ps(ir)*gbgb_ps_sph(ir,nsph) + &
                           &  0.5d0*dFbdgg_ps(ir)*gg_ps_sph(ir,nsph) + &
                           &  dFbdnbgb_ps(ir)*nbgb_ps_sph(ir,nsph) + &
                           &  dFbdnbg_ps(ir)*nbg_ps_sph(ir,nsph) + &
                           &  dFbdag_ps(ir)*nag_ps_sph(ir,nsph)
                   end if
                end if
                        
                if(nsph.eq.1) then
                   dFxcdna_ae_sph(ir,nsph) = dF_dnae(ir,1) + sum1 
                   dFxcdna_ps_sph(ir,nsph) = dF_dnps(ir,1) + sum2
                else
                   dFxcdna_ae_sph(ir,nsph) = (dFx_dnnae(ir,1)+dFc_daa_ae(ir))* &
                        &                     nae_sph(ir,1,nsph) + &
                        &                     dFadga_ae(ir)*grad_nae2_sph(ir,1,nsph) + &
                        &                     dFadg_ae(ir)*grad_tnae2_sph(ir,nsph) + &
                        &                     sum1
                   dFxcdna_ps_sph(ir,nsph) = (dFx_dnnps(ir,1)+dFc_daa_ps(ir))* &
                        &                     nps_sph(ir,1,nsph) + &
                        &                     dFadga_ps(ir)*grad_nps2_sph(ir,1,nsph) + &
                        &                     dFadg_ps(ir)*grad_tnps2_sph(ir,nsph) + &
                        &                     sum2
                end if
                        
                if(nspin.eq.2) then
                   if(nsph.eq.1) then
                      dFxcdnb_ae_sph(ir,nsph) = dF_dnae(ir,2) + sum3
                      dFxcdnb_ps_sph(ir,nsph) = dF_dnps(ir,2) + sum4
                   else
                      dFxcdna_ae_sph(ir,nsph) = dFxcdna_ae_sph(ir,nsph) + &
                           &                    dFc_dab_ae(ir)*nae_sph(ir,2,nsph)
                      dFxcdna_ps_sph(ir,nsph) = dFxcdna_ps_sph(ir,nsph) + &
                           &                    dFc_dab_ps(ir)*nps_sph(ir,2,nsph)
                                
                      dFxcdnb_ae_sph(ir,nsph) = (dFx_dnnae(ir,2)+dFc_dbb_ae(ir))* &
                           &                     nae_sph(ir,2,nsph) + &
                           &                     dFbdgb_ae(ir)*grad_nae2_sph(ir,2,nsph) + &
                           &                     dFbdg_ae(ir)*grad_tnae2_sph(ir,nsph) + &
                           &                     dFc_dab_ae(ir)*nae_sph(ir,1,nsph) + &
                           &                     sum3
                      dFxcdnb_ps_sph(ir,nsph) = (dFx_dnnps(ir,2)+dFc_dbb_ps(ir))* &
                           &                     nps_sph(ir,2,nsph) + &
                           &                     dFbdgb_ps(ir)*grad_nps2_sph(ir,2,nsph) + &
                           &                     dFbdg_ps(ir)*grad_tnps2_sph(ir,nsph) + &
                           &                     dFc_dab_ps(ir)*nps_sph(ir,1,nsph) + &
                           &                     sum4
                   end if
                end if
                        
             end do
          end do
            
!                dFxdgaovrga_ae_sph=0.d0
!                dFxdgaovrga_ps_sph=0.d0
!                dFcdgovrg_ae_sph=0.d0
!                dFcdgovrg_ps_sph=0.d0
                
          do ir=ist,ien,dnr ! == For nrc decomposion. by takto 2012/12/05 ===

!                    do nsph=1,msphmx_grd
!                    do ksph=1,num_isph_g_g
!                        nsph=isph_g_g(ksph)
             do ksph=1,num_isph_2tm
                nsph=isph_2tm(ksph)                
                sum1 = 0.5d0*dGadnana_ae(ir)*nana_ae_sph(ir,nsph)
                sum2 = 0.5d0*dGadnana_ps(ir)*nana_ps_sph(ir,nsph)
                sum3 = 0.5d0*dGdnana_ae(ir)*nana_ae_sph(ir,nsph)
                sum4 = 0.5d0*dGdnana_ps(ir)*nana_ps_sph(ir,nsph)
                
                if(nspin.eq.2) then
                   sum3 = sum3 + &
                        &   0.5d0*dGdnbnb_ae(ir)*nbnb_ae_sph(ir,nsph) + &
                        &   dGdnanb_ae(ir)*nanb_ae_sph(ir,nsph)
                   sum4 = sum4 + &
                        &   0.5d0*dGdnbnb_ps(ir)*nbnb_ps_sph(ir,nsph) + &
                        &   dGdnanb_ps(ir)*nanb_ps_sph(ir,nsph)
                   sum5 = 0.5d0*dGbdnbnb_ae(ir)*nbnb_ae_sph(ir,nsph)
                   sum6 = 0.5d0*dGbdnbnb_ps(ir)*nbnb_ps_sph(ir,nsph)
                end if
                        
! ==== ASMS === 2017/11/08
!                        if(check_of_xctype()==GGA   .and. xctype /= 'ldapw91' &
!                                                    .and. xctype /= 'ldapbe ' &
!                                                    .and. xctype /= 'vdwdf' ) then
                if(check_of_xctype()==GGA  .and. xctype /= 'ldapw91' &
                     &                     .and. xctype /= 'ldapbe ') then
! ==== ASMS === 2017/11/08
                   sum1 = sum1 + &
                        &   0.5d0*dGadgaga_ae(ir)*gaga_ae_sph(ir,nsph) + &
                        &   dGadnaga_ae(ir)*naga_ae_sph(ir,nsph) 
                   sum2 = sum2 + &
                        &   0.5d0*dGadgaga_ps(ir)*gaga_ps_sph(ir,nsph) + &
                        &   dGadnaga_ps(ir)*naga_ps_sph(ir,nsph) 
                   sum3 = sum3 + &
                        &   0.5d0*dGdgg_ae(ir)*gg_ae_sph(ir,nsph) + &
                        &   dGdnag_ae(ir)*nag_ae_sph(ir,nsph)
                   sum4 = sum4 + &
                        &   0.5d0*dGdgg_ps(ir)*gg_ps_sph(ir,nsph) + &
                        &   dGdnag_ps(ir)*nag_ps_sph(ir,nsph)
                   if(nspin.eq.2) then
                      sum3 = sum3 + dGdnbg_ae(ir)*nbg_ae_sph(ir,nsph)
                      sum4 = sum4 + dGdnbg_ps(ir)*nbg_ps_sph(ir,nsph)
                      sum5 = sum5 + 0.5d0*dGbdgbgb_ae(ir)*gbgb_ae_sph(ir,nsph) &
                           &      +       dGbdnbgb_ae(ir)*nbgb_ae_sph(ir,nsph)
                      sum6 = sum6 + 0.5d0*dGbdgbgb_ps(ir)*gbgb_ps_sph(ir,nsph) &
                           &      +       dGbdnbgb_ps(ir)*nbgb_ps_sph(ir,nsph)  
                   end if
                   
                end if
                        
                if(nsph.eq.1) then
                   dFxdgaovrga_ae_sph(ir,nsph) = sum1
                   if(dabs(grad_nae(ir,1)) > 1.d-9) &
                        & dFxdgaovrga_ae_sph(ir,nsph) = dF_dgradnae(ir,1)/grad_nae(ir,1) + sum1

                   dFxdgaovrga_ps_sph(ir,nsph) = sum2
                   if(dabs(grad_nps(ir,1)) > 1.d-9) &
                        &  dFxdgaovrga_ps_sph(ir,nsph) = dF_dgradnps(ir,1)/grad_nps(ir,1) + sum2

                   dFcdgovrg_ae_sph(ir,nsph) = sum3
                   if(dabs(grad_tnae(ir)) > 1.d-9) &
                        &  dFcdgovrg_ae_sph(ir,nsph) = dF_dgradtnae(ir)/grad_tnae(ir) + sum3

                   dFcdgovrg_ps_sph(ir,nsph) = sum4
                   if(dabs(grad_tnps(ir)) > 1.d-9) &
                        &  dFcdgovrg_ps_sph(ir,nsph) = dF_dgradtnps(ir)/grad_tnps(ir) + sum4

                else
                   dFxdgaovrga_ae_sph(ir,nsph) = dGadna_ae(ir)*nae_sph(ir,1,nsph) &
                        &                      + dGadga_ae(ir)*grad_nae2_sph(ir,1,nsph) + sum1
                   dFxdgaovrga_ps_sph(ir,nsph) = dGadna_ps(ir)*nps_sph(ir,1,nsph)  &
                        &                      + dGadga_ps(ir)*grad_nps2_sph(ir,1,nsph)  + sum2
                   dFcdgovrg_ae_sph(ir,nsph) = dGdna_ae(ir)*nae_sph(ir,1,nsph)  &
                        &                      + dGdg_ae(ir)*grad_tnae2_sph(ir,nsph)   + sum3
                   dFcdgovrg_ps_sph(ir,nsph) = dGdna_ps(ir)*nps_sph(ir,1,nsph)  &
                        &                      + dGdg_ps(ir)*grad_tnps2_sph(ir,nsph)   + sum4
                end if
                        
                if(nspin.eq.2) then
                   if(nsph.eq.1) then
                      dFxdgbovrgb_ae_sph(ir,nsph) = sum5
                      if(dabs(grad_nae(ir,2)) > 1.d-9) &
                           & dFxdgbovrgb_ae_sph(ir,nsph) = dF_dgradnae(ir,2)/grad_nae(ir,2) + sum5

                      dFxdgbovrgb_ps_sph(ir,nsph) = sum6
                      if(dabs(grad_nps(ir,2)) > 1.d-9) &
                           dFxdgbovrgb_ps_sph(ir,nsph) = dF_dgradnps(ir,2)/grad_nps(ir,2) + sum6
                   else
                      dFxdgbovrgb_ae_sph(ir,nsph) = dGbdnb_ae(ir)*nae_sph(ir,2,nsph) &
                           &                      + dGbdgb_ae(ir)*grad_nae2_sph(ir,2,nsph) + sum5
                      dFxdgbovrgb_ps_sph(ir,nsph) = dGbdnb_ps(ir)*nps_sph(ir,2,nsph) &
                           &                      + dGbdgb_ps(ir)*grad_nps2_sph(ir,2,nsph) + sum6
                      dFcdgovrg_ae_sph(ir,nsph)   = dFcdgovrg_ae_sph(ir,nsph) &
                           &                      + dGdnb_ae(ir)*nae_sph(ir,2,nsph)
                      dFcdgovrg_ps_sph(ir,nsph)   = dFcdgovrg_ps_sph(ir,nsph) &
                           &                      + dGdnb_ps(ir)*nps_sph(ir,2,nsph)
                   end if
                end if
                    
             end do
          end do
                
          nana_ae_sph=0.d0
          nana_ps_sph=0.d0
          nag_ae_sph=0.d0
          nag_ps_sph=0.d0
          naga_ae_sph=0.d0
          naga_ps_sph=0.d0
          gg_ae_sph=0.d0
          gg_ps_sph=0.d0
          nanb_ae_sph=0.d0
          nanb_ps_sph=0.d0
          gaga_ae_sph=0.d0
          gaga_ps_sph=0.d0
          if(nspin.eq.2) then
             nbnb_ae_sph=0.d0
             nbnb_ps_sph=0.d0
             nbg_ae_sph=0.d0
             nbg_ps_sph=0.d0
             nbgb_ae_sph=0.d0
             nbgb_ps_sph=0.d0
          end if
               
!                do nsph=1,msphmx_grd
!                do ksph=1,num_isph_g_g
!                    nsph=isph_g_g(ksph)
! === For nrc decomposion. by takto 2012/12/07 =================================
          allocate(tmp0(ista_nrc-6*dnr:iend_nrc+6*dnr,25))
          allocate(tmp1(ista_nrc-6*dnr:iend_nrc+6*dnr,25))
          allocate(tmp2(ista_nrc-6*dnr:iend_nrc+6*dnr,25))
          allocate(tmp3(ista_nrc-6*dnr:iend_nrc+6*dnr,25))
          call boundary_exchange_dim2(tmp0, dFxdgaovrga_ae_sph, dnr, 25)
          call boundary_exchange_dim2(tmp1, dFxdgaovrga_ps_sph, dnr, 25)
          call boundary_exchange_dim2(tmp2, dFcdgovrg_ae_sph,   dnr, 25)
          call boundary_exchange_dim2(tmp3, dFcdgovrg_ps_sph,   dnr, 25)
          if(nspin.eq.2) then
             allocate(tmp4(ista_nrc-6*dnr:iend_nrc+6*dnr,25))
             allocate(tmp5(ista_nrc-6*dnr:iend_nrc+6*dnr,25))
             call boundary_exchange_dim2(tmp4, dFxdgbovrgb_ae_sph, dnr, 25)
             call boundary_exchange_dim2(tmp5, dFxdgbovrgb_ps_sph, dnr, 25)
          end if
! ==============================================================================
          do ksph=1,num_isph_2tm
             nsph=isph_2tm(ksph)
             call calc_diff_exp3_3D(ier,3,nrc,dnr,radr_paw(1,it),tmp0(ista_nrc-6*dnr,nsph) & 
                  &                ,nana_ae_sph(ista_nrc,nsph),  ista_nrc, iend_nrc, ist, ien)
             call calc_diff_exp3_3D(ier,3,nrc,dnr,radr_paw(1,it),tmp1(ista_nrc-6*dnr,nsph) &
                  &                ,nana_ps_sph(ista_nrc,nsph),  ista_nrc, iend_nrc, ist, ien)
             call calc_diff_exp3_3D(ier,3,nrc,dnr,radr_paw(1,it),tmp2(ista_nrc-6*dnr,nsph) &
                  &                ,gg_ae_sph(ista_nrc,nsph),    ista_nrc, iend_nrc, ist, ien)
             call calc_diff_exp3_3D(ier,3,nrc,dnr,radr_paw(1,it),tmp3(ista_nrc-6*dnr,nsph) &
                  &                ,gg_ps_sph(ista_nrc,nsph),    ista_nrc, iend_nrc, ist, ien)
          end do
                
          if(nspin.eq.2) then
             do ksph=1,num_isph_2tm
                nsph=isph_2tm(ksph)
                call calc_diff_exp3_3D(ier,3,nrc,dnr,radr_paw(1,it), tmp4(ista_nrc-6*dnr,nsph) &
                     &                ,nbnb_ae_sph(ista_nrc,nsph),   ista_nrc, iend_nrc, ist, ien)
                call calc_diff_exp3_3D(ier,3,nrc,dnr,radr_paw(1,it), tmp5(ista_nrc-6*dnr,nsph)  &
                     &                ,nbnb_ps_sph(ista_nrc,nsph),   ista_nrc, iend_nrc, ist, ien)
             end do
          end if
! === For nrc decomposion. by takto 2012/12/07 =================================
          deallocate(tmp0)
          deallocate(tmp1)
          deallocate(tmp2)
          deallocate(tmp3)
          if(nspin.eq.2) then
             deallocate(tmp4)
             deallocate(tmp5)
          end if
! ==============================================================================
               
          call mult_sphex_element_full3(dnr,1,dnae_dr_sph(:,1,1:25),num_isph_chg,isph_chg(1:25) &
               &                       ,nana_ae_sph,          num_isph_n_n,isph_n_n(1:25) &
               &                       ,nag_ae_sph ,          num_isph_nnn,isph_nnn(1:25),ist,ien)
          call mult_sphex_element_full3(dnr,1,dnps_dr_sph(:,1,1:25),num_isph_chg,isph_chg(1:25) &
               &                       ,nana_ps_sph,          num_isph_n_n,isph_n_n(1:25) &
               &                       ,nag_ps_sph ,          num_isph_nnn,isph_nnn(1:25),ist,ien)
          if(nspin.eq.1) then
             call mult_sphex_element_full3(dnr,1,dnae_dr_sph(:,1,1:25),num_isph_chg,isph_chg(1:25) & 
                  &                       ,gg_ae_sph,            num_isph_g_g,isph_g_g(1:25) &
                  &                       ,nanb_ae_sph ,         num_isph_ngg,isph_ngg(1:25),ist,ien)
             call mult_sphex_element_full3(dnr,1,dnps_dr_sph(:,1,1:25),num_isph_chg,isph_chg(1:25) &
                  &                       ,gg_ps_sph,            num_isph_g_g,isph_g_g(1:25) &
                  &                       ,nanb_ps_sph,          num_isph_ngg,isph_ngg(1:25),ist,ien)
          else
             call mult_sphex_element_full3(dnr,1,dnae_dr_sph(:,2,1:25),num_isph_chg,isph_chg(1:25) &
                  &                       ,nbnb_ae_sph,          num_isph_n_n,isph_n_n(1:25) &
                  &                       ,nbg_ae_sph,           num_isph_nnn,isph_nnn(1:25),ist,ien)
             call mult_sphex_element_full3(dnr,1,dnps_dr_sph(:,2,1:25),num_isph_chg,isph_chg(1:25) &
                  &                       ,nbnb_ps_sph,          num_isph_n_n,isph_n_n(1:25) &
                  &                       ,nbg_ps_sph,           num_isph_nnn,isph_nnn(1:25),ist,ien)
             call mult_sphex_element_full3(dnr,1,dnae_dr_sph(:,1,1:25) + dnae_dr_sph(:,2,1:25) &
                  &                       ,num_isph_chg,isph_chg(1:25) &
                  &                       ,gg_ae_sph,            num_isph_g_g,isph_g_g(1:25) &
                  &                       ,nanb_ae_sph,          num_isph_ngg,isph_ngg(1:25),ist,ien)
             call mult_sphex_element_full3(dnr,1,dnps_dr_sph(:,1,1:25) + dnps_dr_sph(:,2,1:25) &
                  &                       ,num_isph_chg,isph_chg(1:25) &
                  &                       ,gg_ps_sph,            num_isph_g_g,isph_g_g(1:25) &
                  &                       ,nanb_ps_sph,          num_isph_ngg,isph_ngg(1:25),ist,ien)
          end if
! ==============================================================================
                
          nana_ae_sph=0.d0
          nana_ps_sph=0.d0
!                do nsph=1,msphmx_grd
          do ksph=1,num_isph_chg
             nsph=isph_chg(ksph)
! === For nrc decomposion. by takto 2012/12/05 =================================
             do ir=ist,ien,dnr
                nana_ae_sph(ir,nsph) = ddnae_ddr_sph(ir,1,nsph) &
                     &                 + 2.d0*dnae_dr_sph(ir,1,nsph)/radr_paw(ir,it)
                nana_ps_sph(ir,nsph) = ddnps_ddr_sph(ir,1,nsph) &
                     &                 + 2.d0*dnps_dr_sph(ir,1,nsph)/radr_paw(ir,it)
             end do
          end do
                
          gg_ae_sph=0.d0
          gg_ps_sph=0.d0
! === Debug by Intel "-check all" option! by T.Kato 2011/03/01 =================
          if(nspin.eq.2) then

             nbnb_ae_sph=0.d0
             nbnb_ps_sph=0.d0

          endif

          if(nspin.eq.1) then
!                    do nsph=1,msphmx_grd
             do ksph=1,num_isph_chg
                nsph=isph_chg(ksph)
                do ir=ist,ien,dnr ! === For nrc decomposion. by takto 2012/12/05 ===
                   gg_ae_sph(ir,nsph) = ddnae_ddr_sph(ir,1,nsph) + &
                        &                2.d0*dnae_dr_sph(ir,1,nsph)/radr_paw(ir,it)
                   gg_ps_sph(ir,nsph) = ddnps_ddr_sph(ir,1,nsph) + &
                        &                2.d0*dnps_dr_sph(ir,1,nsph)/radr_paw(ir,it)
                end do
             end do
          else
!                    do nsph=1,msphmx_grd
             do ksph=1,num_isph_chg
                nsph=isph_chg(ksph)
                do ir=ist,ien,dnr ! === For nrc decomposion. by takto 2012/12/05 ===
                   nbnb_ae_sph(ir,nsph) = ddnae_ddr_sph(ir,2,nsph) + &
                        &                       2.d0*dnae_dr_sph(ir,2,nsph)/radr_paw(ir,it)
                   nbnb_ps_sph(ir,nsph) = ddnps_ddr_sph(ir,2,nsph) + &
                        &                       2.d0*dnps_dr_sph(ir,2,nsph)/radr_paw(ir,it)
                end do
             end do
             do ksph=1,num_isph_chg
                nsph=isph_chg(ksph)

                do ir=ist,ien,dnr ! === For nrc decomposion. by takto 2012/12/05 ===
                   gg_ae_sph(ir,nsph) = ddnae_ddr_sph(ir,1,nsph) + ddnae_ddr_sph(ir,2,nsph) &
                        &                + 2.d0*(dnae_dr_sph(ir,1,nsph)+dnae_dr_sph(ir,2,nsph)) &
                        &                    /radr_paw(ir,it)
                   gg_ps_sph(ir,nsph) = ddnps_ddr_sph(ir,1,nsph) + ddnps_ddr_sph(ir,2,nsph) &
                        &                + 2.d0*(dnps_dr_sph(ir,1,nsph)+dnps_dr_sph(ir,2,nsph)) &
                        &                    /radr_paw(ir,it)
                end do
             end do
          end if
                
! === For nrc decomposion. by takto 2012/12/05 =================================
          call mult_sphex_element_full3(dnr,1,nana_ae_sph,       num_isph_chg,isph_chg(1:25) &
               &                       ,dFxdgaovrga_ae_sph,num_isph_g_g,isph_g_g(1:25) &
               &                       ,naga_ae_sph,       num_isph_ngg,isph_ngg(1:25),ist,ien)
          call mult_sphex_element_full3(dnr,1,nana_ps_sph,       num_isph_chg,isph_chg(1:25) &
               &                       ,dFxdgaovrga_ps_sph,num_isph_g_g,isph_g_g(1:25) &
               &                       ,naga_ps_sph,       num_isph_ngg,isph_ngg(1:25),ist,ien)
          call mult_sphex_element_full3(dnr,1,gg_ae_sph,         num_isph_chg,isph_chg(1:25) &
               &                       ,dFcdgovrg_ae_sph,  num_isph_g_g,isph_g_g(1:25) &
               &                       ,gaga_ae_sph,       num_isph_ngg,isph_ngg(1:25),ist,ien)
          call mult_sphex_element_full3(dnr,1,gg_ps_sph,         num_isph_chg,isph_chg(1:25) &
               &                       ,dFcdgovrg_ps_sph,  num_isph_g_g,isph_g_g(1:25) &
               &                       ,gaga_ps_sph,       num_isph_ngg,isph_ngg(1:25),ist,ien)
          if(nspin.eq.2) then
             call mult_sphex_element_full3(dnr,1,nbnb_ae_sph,       num_isph_chg,isph_chg(1:25) &
                  &                       ,dFxdgbovrgb_ae_sph,num_isph_g_g,isph_g_g(1:25) &
                  &                       ,nbgb_ae_sph,       num_isph_ngg,isph_ngg(1:25),ist,ien)
             call mult_sphex_element_full3(dnr,1,nbnb_ps_sph,       num_isph_chg,isph_chg(1:25) &
                  &                       ,dFxdgbovrgb_ps_sph,num_isph_g_g,isph_g_g(1:25) &
                  &                       ,nbgb_ps_sph,       num_isph_ngg,isph_ngg(1:25),ist,ien)
          end if
                
! === For nrc decomposion. by takto 2012/12/05 =================================
          call get_paw_sphex_integral3(nrc,dnr,radr_paw(1,it)           &
               &                      ,dFxdgaovrga_ae_sph, num_isph_g_g, isph_g_g(1:25),  nae_sph(:,1,1:25) &
               &                      ,nana_ae_sph, num_isph_ggg, isph_ggg(1:25),  ist,ien)
          call get_paw_sphex_integral3(nrc,dnr,radr_paw(1,it)           &
               &                      ,dFxdgaovrga_ps_sph, num_isph_g_g, isph_g_g(1:25),  nps_sph(:,1,1:25) &
               &                      ,nana_ps_sph, num_isph_ggg, isph_ggg(1:25),  ist,ien)
          if(nspin.eq.1) then
             call get_paw_sphex_integral3(nrc,dnr,radr_paw(1,it)           &
                  &                      ,dFcdgovrg_ae_sph, num_isph_g_g, isph_g_g(1:25),  nae_sph(:,1,1:25) &
                  &                      ,gg_ae_sph, num_isph_ggg, isph_ggg(1:25),  ist,ien)
             call get_paw_sphex_integral3(nrc,dnr,radr_paw(1,it)           &
                  &                      ,dFcdgovrg_ps_sph, num_isph_g_g, isph_g_g(1:25),  nps_sph(:,1,1:25) &
                  &                      ,gg_ps_sph, num_isph_ggg, isph_ggg(1:25),  ist,ien)
          else
             call get_paw_sphex_integral3(nrc,dnr,radr_paw(1,it)           &
                  &                      ,dFxdgbovrgb_ae_sph, num_isph_g_g, isph_g_g(1:25),  nae_sph(:,2,1:25) &
                  &                      ,nbnb_ae_sph, num_isph_ggg, isph_ggg(1:25),  ist,ien)
             call get_paw_sphex_integral3(nrc,dnr,radr_paw(1,it)           &
                  &                      ,dFxdgbovrgb_ps_sph,num_isph_g_g,isph_g_g(1:25), nps_sph(:,2,1:25) &
                  &                      ,nbnb_ps_sph,  num_isph_ggg,isph_ggg(1:25),   ist,ien)
             call get_paw_sphex_integral3(nrc,dnr,radr_paw(1,it)                  &
                  &                      ,dFcdgovrg_ae_sph, num_isph_g_g, isph_g_g(1:25) &
                  &                      ,(nae_sph(:,1,1:25)+nae_sph(:,2,1:25)) &
                  &                      ,gg_ae_sph, num_isph_ggg, isph_ggg(1:25),  ist,ien)
             call get_paw_sphex_integral3(nrc,dnr,radr_paw(1,it)                  &
                  &                      ,dFcdgovrg_ps_sph, num_isph_g_g, isph_g_g(1:25) &
                  &                      ,(nps_sph(:,1,1:25)+nps_sph(:,2,1:25)) &
                  &                      ,gg_ps_sph, num_isph_ggg, isph_ggg(1:25),  ist,ien)
          end if

                
          call merge_isph_flgs(num_isph_n_n,isph_n_n &
               &              ,num_isph_n_g,isph_n_g &
               &              ,num_isph_g_g,isph_g_g &
               &              ,num_isph_nnn,isph_nnn &
               &              ,num_isph_ngg,isph_ngg &
               &              ,num_isph_ggg,isph_ggg &
               &              ,num_isph_all,isph_all)
                                
          sq4pi=sqrt(PAI4)
                
! === For nrc decomposion. by takto 2012/12/05 =================================
          do ksph=1,num_isph_all
             nsph=isph_all(ksph)
             if(nsph.gt.msph) cycle
             do ir=ist,ien,dnr
                vxc_ae_k_3D(ir,1,nsph,ia_add) = dFxcdna_ae_sph(ir,nsph) &
                     &  - nag_ae_sph(ir,nsph) - naga_ae_sph(ir,nsph) &
                     &  + nana_ae_sph(ir,nsph) - nanb_ae_sph(ir,nsph) &
                     &  - gaga_ae_sph(ir,nsph) + gg_ae_sph(ir,nsph)  
                vxc_ps_k_3D(ir,1,nsph,ia_add) = dFxcdna_ps_sph(ir,nsph) &
                     &  - nag_ps_sph(ir,nsph) - naga_ps_sph(ir,nsph) &
                     &  + nana_ps_sph(ir,nsph) - nanb_ps_sph(ir,nsph) &
                     &  - gaga_ps_sph(ir,nsph) + gg_ps_sph(ir,nsph) 
             end do
          end do

          if(nspin.eq.2) then
             do ksph=1,num_isph_all
                nsph=isph_all(ksph)
                if(nsph.gt.msph) cycle
                do ir=ist,ien,dnr
                   vxc_ae_k_3D(ir,2,nsph,ia_add) = dFxcdnb_ae_sph(ir,nsph) &
                        & - nbg_ae_sph(ir,nsph) - nbgb_ae_sph(ir,nsph) &
                        & + nbnb_ae_sph(ir,nsph) - nanb_ae_sph(ir,nsph) &
                        & - gaga_ae_sph(ir,nsph) + gg_ae_sph(ir,nsph)  
                   vxc_ps_k_3D(ir,2,nsph,ia_add)  = dFxcdnb_ps_sph(ir,nsph) &
                        & - nbg_ps_sph(ir,nsph) - nbgb_ps_sph(ir,nsph) &
                        & + nbnb_ps_sph(ir,nsph) - nanb_ps_sph(ir,nsph) &
                        & - gaga_ps_sph(ir,nsph) + gg_ps_sph(ir,nsph)  
                end do
             end do
          end if
                
          do ir=ist,ien,dnr
             vxc_ae_k_3D(ir,1,1,ia_add)= vxc_ae_k_3D(ir,1,1,ia_add)*sq4pi
             vxc_ps_k_3D(ir,1,1,ia_add)= vxc_ps_k_3D(ir,1,1,ia_add)*sq4pi
          end do

          if(nspin.eq.2) then
             do ir=ist,ien,dnr
                vxc_ae_k_3D(ir,2,1,ia_add)= vxc_ae_k_3D(ir,2,1,ia_add)*sq4pi
                vxc_ps_k_3D(ir,2,1,ia_add)= vxc_ps_k_3D(ir,2,1,ia_add)*sq4pi
             end do
          end if

       end if
            
    end do
! === For nrc decomposion. by takto 2012/12/07 =================================
999 continue ! This proc. has no nrc elements!
! ==============================================================================

    if(npes>1) then
       call mpi_allreduce(MPI_IN_PLACE,exc_ae,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)
       call mpi_allreduce(MPI_IN_PLACE,exc_ps,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)
!!$       call mpi_allreduce(MPI_IN_PLACE,exc_ae,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
!!$       call mpi_allreduce(MPI_IN_PLACE,exc_ps,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
    end if

!!$        call decomp_vxc_ae_k_r_3D(vxc_ae_k,vxc_ae_k_3D,mmesh,msph,natm)
!!$        call decomp_vxc_ae_k_r_3D(vxc_ps_k,vxc_ps_k_3D,mmesh,msph,natm)
   
!ASMS        exc_ae=exc_ae*PAI4*dble(af+1)
!ASMS        exc_ps=exc_ps*PAI4*dble(af+1)
    exc_ae=exc_ae*PAI4 !ASMS
    exc_ps=exc_ps*PAI4 !ASMS

    if(iprixc >= PRINTLEVEL) then
       write(nfout,'(" exc_ae, exc_ps = ",2d20.8, " dnr = ",i8)') exc_ae, exc_ps,dnr
       write(nfout,'(" vxc_ae_k_3D(",i4,":",i4,",1,1,1) = ",6f12.4)') &
            & ista_nrc, ista_nrc+5,(vxc_ae_k_3D(ir,1,1,1),ir=ista_nrc,ista_nrc+5)
       write(nfout,'(" vxc_ps_k_3D(",i4,":",i4,",1,1,1) = ",6f12.4)') &
            & ista_nrc, ista_nrc+5,(vxc_ps_k_3D(ir,1,1,1),ir=ista_nrc,ista_nrc+5)
    end if

    call paw_xc_sphex_deallocate

! ============================== added by K. Tagami ======================== 11.0
! === DEBUG by tkato 2012/11/30 ================================================
    if(noncol) then
       if ( npes > 1 .and. af==0) then

          select case(level_of_projection_paw_charge)
          case (1)
             call mpi_allreduce(MPI_IN_PLACE,magmom_local_now,natm*3*1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr )
          case (2)
             nelt = natm*3*msph
             call mpi_allreduce(MPI_IN_PLACE,magmom_local_ae, nelt, mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
             call mpi_allreduce(MPI_IN_PLACE,magmom_local_ps, nelt, mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
             magmom_local_now(:,1:3) = magmom_local_ps(:,1:3,1)
             
          case (3)
             nelt = natm*3*msph
             call mpi_allreduce(MPI_IN_PLACE,magmom_local_ae, nelt, mpi_double_precision,mpi_sum,mpi_comm_group,ierr )
             call mpi_allreduce(MPI_IN_PLACE,magmom_local_ps, nelt, mpi_double_precision,mpi_sum,mpi_comm_group,ierr )

             nelt = natm*mmesh*ndim_magmom*msph
             call mpi_allreduce(MPI_IN_PLACE,rho_rad_ae, nelt, mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
             call mpi_allreduce(MPI_IN_PLACE,rho_rad_ps, nelt, mpi_double_precision,mpi_sum,mpi_comm_group,ierr)

             magmom_local_now(:,1:3) = magmom_local_ps(:,1:3,1)
          end select

       endif
! === DEBUG by tkato 2012/11/30 ================================================
    end if
! ==============================================================================
! ========================================================================= 11.0
        
STOP_TIMER('m_PAW_XC_cal_potential_sphex2')
    call tstatc0_end(id_sname)
        
  contains

! === For nrc decomposion. by takto 2012/12/05 =================================

    subroutine ggaxcp_paw_sphex2_3D
      grad_tnae2_sph = 0.d0
      grad_nae2_sph = 0.d0
      grad_tnps2_sph = 0.d0
      grad_nps2_sph = 0.d0
      dF_dnae = 0.d0
      dF_dgradnae = 0.d0
      dF_dnps = 0.d0
      dF_dgradnps = 0.d0

      if(xctype == 'ldapw91' .or. xctype == 'ldapbe '.or. xctype == 'vdwdf' ) then
         grad_nae2_sph=0.d0;grad_tnae2_sph=0.d0
         grad_nps2_sph=0.d0;grad_tnps2_sph=0.d0
         grad_nae=0.d0;grad_tnae=0.d0
         grad_nps=0.d0;grad_tnps=0.d0
         call m_PAWCD_set_cr2_isph2_mmt2()
         msphmx_grd=0
         num_isph_grd=0
      else
         call abs_grad_rho_ud_paw_sphex2_3D
      end if

      if(xctype == 'ggapw91' .or. xctype == 'ldapw91') then
         call ex_ggapw91_paw_drv2_3D(nrc,dnr,nspin &
              &      , nae_sph(ista_nrc,1,1), grad_nae, exc_ae_field &
              &      , dF_dnae, dF_dgradnae, dFx_dnnae, dFx_dngae, dFx_dggae &
              &      , dFx_dnnnae, dFx_dnngae, dFx_dnggae, dFx_dgggae  &
              &      , ista_nrc, iend_nrc, ist, ien)
         call cr_ggapw91_paw_drv2_3D(nrc,dnr,nspin &
              &      , nae_sph(ista_nrc,1,1), grad_tnae, exc_ae_field   &
              &      , dF_dnae, dF_dgradtnae &
              &      , dFc_daa_ae, dFc_dbb_ae, dFc_dgg_ae &
              &      , dFc_dab_ae, dFc_dag_ae, dFc_dbg_ae &
              &      , dFc_daaa_ae, dFc_dbbb_ae, dFc_dggg_ae &
              &      , dFc_daab_ae, dFc_daag_ae, dFc_dabb_ae &
              &      , dFc_dbbg_ae, dFc_dagg_ae, dFc_dbgg_ae, dFc_dabg_ae &
              &      , ista_nrc, iend_nrc, ist, ien)
         call ex_ggapw91_paw_drv2_3D(nrc,dnr,nspin  &
              &      , nps_sph(ista_nrc,1,1), grad_nps, exc_ps_field  &
              &      , dF_dnps, dF_dgradnps, dFx_dnnps, dFx_dngps, dFx_dggps     &
              &      , dFx_dnnnps, dFx_dnngps, dFx_dnggps, dFx_dgggps &
              &      , ista_nrc, iend_nrc, ist, ien)
         call cr_ggapw91_paw_drv2_3D(nrc,dnr,nspin    &
              &      , nps_sph(ista_nrc,1,1), grad_tnps, exc_ps_field &
              &      , dF_dnps, dF_dgradtnps &
              &      , dFc_daa_ps, dFc_dbb_ps, dFc_dgg_ps  &
              &      , dFc_dab_ps, dFc_dag_ps, dFc_dbg_ps  &
              &      , dFc_daaa_ps, dFc_dbbb_ps, dFc_dggg_ps &
              &      , dFc_daab_ps, dFc_daag_ps, dFc_dabb_ps &
              &      , dFc_dbbg_ps, dFc_dagg_ps, dFc_dbgg_ps, dFc_dabg_ps  &
              &      , ista_nrc, iend_nrc, ist, ien)
      else if(xctype == 'ggapbe ' .or. xctype == 'ldapbe ' .or. xctype == 'vdwdf') then
         call ex_ggapbe_paw_drv2_3D(nrc,dnr,nspin &
              &      , nae_sph(ista_nrc,1,1), grad_nae, exc_ae_field  &
              &      , dF_dnae, dF_dgradnae, dFx_dnnae, dFx_dngae, dFx_dggae  &
              &      , dFx_dnnnae, dFx_dnngae, dFx_dnggae, dFx_dgggae &
              &      , ista_nrc, iend_nrc, ist, ien)
         if(iprixc >= DEBUGPRINTLEVEL) call wd_exc_etc(20)

         call cr_ggapbe_paw_drv2_3D(nrc,dnr,nspin &
              &      , nae_sph(ista_nrc,1,1), grad_tnae, exc_ae_field &
              &      , dF_dnae, dF_dgradtnae &
              &      , dFc_daa_ae, dFc_dbb_ae, dFc_dgg_ae  &
              &      , dFc_dab_ae, dFc_dag_ae, dFc_dbg_ae  &
              &      , dFc_daaa_ae, dFc_dbbb_ae, dFc_dggg_ae  &
              &      , dFc_daab_ae, dFc_daag_ae, dFc_dabb_ae  &
              &      , dFc_dbbg_ae, dFc_dagg_ae, dFc_dbgg_ae, dFc_dabg_ae  &
              &      , ista_nrc, iend_nrc, ist, ien)
         if(iprixc >= DEBUGPRINTLEVEL) call wd_grad_etc(20)

         call ex_ggapbe_paw_drv2_3D(nrc,dnr,nspin     &
              &   , nps_sph(ista_nrc,1,1), grad_nps, exc_ps_field  &
              &   , dF_dnps, dF_dgradnps , dFx_dnnps, dFx_dngps, dFx_dggps                &
              &   , dFx_dnnnps, dFx_dnngps, dFx_dnggps, dFx_dgggps &
              &   , ista_nrc, iend_nrc, ist, ien)
         if(iprixc >= DEBUGPRINTLEVEL) call wd_exc_ps_etc(20)

         call cr_ggapbe_paw_drv2_3D(nrc,dnr,nspin     &
              &      , nps_sph(ista_nrc,1,1), grad_tnps, exc_ps_field   &
              &      , dF_dnps, dF_dgradtnps          &
              &      , dFc_daa_ps, dFc_dbb_ps, dFc_dgg_ps  &
              &      , dFc_dab_ps, dFc_dag_ps, dFc_dbg_ps  &
              &      , dFc_daaa_ps,dFc_dbbb_ps,dFc_dggg_ps &
              &      , dFc_daab_ps,dFc_daag_ps,dFc_dabb_ps &
              &      , dFc_dbbg_ps,dFc_dagg_ps,dFc_dbgg_ps, dFc_dabg_ps  &
              &      , ista_nrc, iend_nrc, ist, ien)
         if(iprixc >= DEBUGPRINTLEVEL) call wd_exc_ps_etc2(20)

      else if(xctype == 'katopbe' .or. xctype == 'ggapbek') then
      else if(xctype == 'ggabp  ') then
      else
         write(nfout,'(" xctype = ",a7)') xctype
         stop ' xctype is not set properly (ggaxcp_paw_sphex)'
      end if
                 !   dF/d|rho(r)| (=vxc) --> dF_drho
                 !   dFx/d|grad(rho(r))| --> dF_dgradrho
                 !   dFc/d|grad(rho(r))| --> grad_trho
    end subroutine ggaxcp_paw_sphex2_3D

    subroutine wd_grad_etc(nelm)
!   ---- 2020.01.23 T. Yamasaki --
      integer, intent(in) :: nelm
      integer :: ij
      ij = nelm
      if(iend_nrc-ista_nrc+1<2*ij) ij = (iend_nrc-ista_nrc+1)/2
      if(ij == 0) ij = 1

      write(nfout,'(" -- grad_tnae(",i6,":",i6,") --")') ista_nrc,ista_nrc+ij-1
      write(nfout,'(8d16.4)') grad_tnae(ista_nrc:ista_nrc+ij-1)
      write(nfout,'(" -- grad_tnae(",i6,":",i6,") --")') iend_nrc-ij+1,iend_nrc
      write(nfout,'(8d16.4)') grad_tnae(iend_nrc-ij+1:iend_nrc)
      write(nfout,'(" -- dFc_dbg_ae(",i6,":",i6,") --")') ista_nrc,ista_nrc+ij-1
      write(nfout,'(8d16.4)') dFc_dbg_ae(ista_nrc:ista_nrc+ij-1)
      write(nfout,'(" -- dFc_dbg_ae(",i6,":",i6,") --")') iend_nrc-ij+1,iend_nrc
      write(nfout,'(8d16.4)') dFc_dbg_ae(iend_nrc-ij+1:iend_nrc)
    end subroutine wd_grad_etc

    subroutine wd_dnae_dr_sph(nelm)
!   ---- 2020.01.23 T. Yamasaki --
      integer, intent(in) :: nelm
      integer :: ij, is
      ij = nelm
      if(iend_nrc-ista_nrc+1<2*ij) ij = (iend_nrc-ista_nrc+1)/2
      if(ij == 0) ij = 1

      do is = 1, nspin
         write(nfout,'(" -- dnae_dr_sph(",i6,":",i6,",",i2,",1) --")') ista_nrc,ista_nrc+ij-1,is
         write(nfout,'(8d16.4)') dnae_dr_sph(ista_nrc:ista_nrc+ij-1,is,1)
         write(nfout,'(" -- dnae_dr_sph(",i6,":",i6,",",i2,",1) --")') iend_nrc-ij+1,iend_nrc,is
         write(nfout,'(8d16.4)') dnae_dr_sph(iend_nrc-ij+1:iend_nrc,is,1)
      end do
    end subroutine wd_dnae_dr_sph

    subroutine wd_dnps_dr_sph_etc(nelm)
!   ---- 2020.01.23 T. Yamasaki --
      integer, intent(in) :: nelm
      integer :: ij, is
      ij = nelm
      if(iend_nrc-ista_nrc+1<2*ij) ij = (iend_nrc-ista_nrc+1)/2
      if(ij == 0) ij = 1

      do is = 1, nspin
         write(nfout,'(" -- dnps_dr_sph(",i6,":",i6,",",i2,",1) --")') ista_nrc,ista_nrc+ij-1,is
         write(nfout,'(8d16.4)') dnps_dr_sph(ista_nrc:ista_nrc+ij-1,is,1)
         write(nfout,'(" -- dnps_dr_sph(",i6,":",i6,",",i2,",1) --")') iend_nrc-ij+1,iend_nrc,is
         write(nfout,'(8d16.4)') dnps_dr_sph(iend_nrc-ij+1:iend_nrc,is,1)
      end do
      write(nfout,'(" -- grad_tnps2_sph(",i6,":",i6,",1) --")') ista_nrc,ista_nrc+ij-1
      write(nfout,'(8d16.4)') grad_tnps2_sph(ista_nrc:ista_nrc+ij-1,1)
      write(nfout,'(" -- grad_tnps2_sph(",i6,":",i6,",1) --")') iend_nrc-ij+1,iend_nrc
      write(nfout,'(8d16.4)') grad_tnps2_sph(iend_nrc-ij+1:iend_nrc,1)
    end subroutine wd_dnps_dr_sph_etc

    subroutine wd_exc_etc(nelm)
!   ---- 2020.01.23 T. Yamasaki --
      integer, intent(in) :: nelm
      integer :: ij, is
      ij = nelm
      if(iend_nrc-ista_nrc+1<2*ij) ij = (iend_nrc-ista_nrc+1)/2
      if(ij == 0) ij = 1

      write(nfout,'(" ia = ", i8)') ia
      write(nfout,'(" -- exc_ae_field(",i6,":",i6,") -- ")') ista_nrc,ista_nrc+ij-1
      write(nfout,'(8d16.4)') exc_ae_field(ista_nrc:ista_nrc+ij-1)
      write(nfout,'(" -- exc_ae_field(",i6,":",i6,") -- ")') iend_nrc-ij+1,iend_nrc
      write(nfout,'(8d16.4)') exc_ae_field(iend_nrc-ij+1:iend_nrc)

      do is = 1, nspin
         write(nfout,'(" -- nae_sph(",i6,":",i6,",",i2,",1) -- ")') ista_nrc,ista_nrc+ij-1,is
         write(nfout,'(8d16.4)') nae_sph(ista_nrc:ista_nrc+ij-1, is, 1)
         write(nfout,'(" -- nae_sph(",i6,":",i6,",",i2,",1) -- ")') iend_nrc-ij+1,iend_nrc,is
         write(nfout,'(8d16.4)') nae_sph(iend_nrc-ij+1:iend_nrc, is, 1)
      end do

      do is = 1, nspin
         write(nfout,'(" -- dFx_dggae(",i6,":",i6,",",i2,") --")') ista_nrc,ista_nrc+ij-1,is
         write(nfout,'(8d16.4)') dFx_dggae(ista_nrc:ista_nrc+ij-1,is)
         write(nfout,'(" -- dFx_dggae(",i6,":",i6,",",i2,") --")') iend_nrc-ij+1,iend_nrc,is
         write(nfout,'(8d16.4)') dFx_dggae(iend_nrc-ij+1:iend_nrc,is)
      end do
    end subroutine wd_exc_etc

    subroutine wd_exc_ps_etc(nelm)
!   ---- 2020.01.23 T. Yamasaki --
      integer, intent(in) :: nelm
      integer :: ij, is
      ij = nelm
      if(iend_nrc-ista_nrc+1<2*ij) ij = (iend_nrc-ista_nrc+1)/2
      if(ij == 0) ij = 1

      write(nfout,'(" -- exc_ps_field(",i6,":",i6,") -- ")') ista_nrc,ista_nrc+ij-1
      write(nfout,'(8d16.4)') exc_ps_field(ista_nrc:ista_nrc+ij-1)
      write(nfout,'(" -- exc_ps_field(",i6,":",i6,") -- ")') iend_nrc-ij+1,iend_nrc
      write(nfout,'(8d16.4)') exc_ps_field(iend_nrc-ij+1:iend_nrc)

      do is = 1, nspin
         write(nfout,'(" -- dFx_dggps(",i6,":",i6,",",i2,") --")') ista_nrc,ista_nrc+ij-1,is
         write(nfout,'(8d16.4)') dFx_dggps(ista_nrc:ista_nrc+ij-1,is)
         write(nfout,'(" -- dFx_dggps(",i6,":",i6,",",i2,") --")') iend_nrc-ij+1,iend_nrc,is
         write(nfout,'(8d16.4)') dFx_dggps(iend_nrc-ij+1:iend_nrc,is)
      end do
    end subroutine wd_exc_ps_etc

    subroutine wd_exc_ps_etc2(nelm)
!   ---- 2020.01.23 T. Yamasaki --
      integer, intent(in) :: nelm
      integer :: ij, is
      ij = nelm
      if(iend_nrc-ista_nrc+1<2*ij) ij = (iend_nrc-ista_nrc+1)/2
      if(ij == 0) ij = 1

      write(nfout,'(" -- exc_ps_field(",i6,":",i6,") -- ")') ista_nrc,ista_nrc+ij-1
      write(nfout,'(8d16.4)') exc_ps_field(ista_nrc:ista_nrc+ij-1)
      write(nfout,'(" -- exc_ps_field(",i6,":",i6,") -- ")') iend_nrc-ij+1,iend_nrc
      write(nfout,'(8d16.4)') exc_ps_field(iend_nrc-ij+1:iend_nrc)

      write(nfout,'(" -- grad_tnps(",i6,":",i6,") --")') ista_nrc,ista_nrc+ij-1
      write(nfout,'(8d16.4)') grad_tnps(ista_nrc:ista_nrc+ij-1)
      write(nfout,'(" -- grad_tnps(",i6,":",i6,") --")') iend_nrc-ij+1,iend_nrc
      write(nfout,'(8d16.4)') grad_tnps(iend_nrc-ij+1:iend_nrc)

      write(nfout,'(" -- dFc_dbg_ps(",i6,":",i6,") --")') ista_nrc,ista_nrc+ij-1
      write(nfout,'(8d16.4)') dFc_dbg_ps(ista_nrc:ista_nrc+ij-1)
      write(nfout,'(" -- dFc_dbg_ps(",i6,":",i6,") --")') iend_nrc-ij+1,iend_nrc
      write(nfout,'(8d16.4)') dFc_dbg_ps(iend_nrc-ij+1:iend_nrc)
    end subroutine wd_exc_ps_etc2

    subroutine abs_grad_rho_ud_paw_sphex2_3D ! == For nrc decomposion. by takto 2012/12/05 ====
      integer:: ir,is,ier,isp,nsp

      real(DP), allocatable, dimension(:,:,:) :: tmp ! === For nrc decomposion. by takto 2012/12/07 ===
            
      dnae_dr_sph = 0.0d0

      allocate(tmp(ista_nrc-6*dnr:iend_nrc+6*dnr,nspin,25))     ! == For nrc decomposion. by takto 2012/12/07 ==
      call boundary_exchange_dim3(tmp, nae_sph, dnr, nspin, 25) ! == For nrc decomposion ==

    ! ------ for AE CD -------
      if(vflag == VXC_AND_EXC) then
         do nsp=1,num_isph_chg
            isp=isph_chg(nsp)
            do is=1,nspin
               call calc_ddiff_exp3_3D(ier,3,nrc,dnr,radr_paw(:,it)   &
                    &  , tmp(ista_nrc-6*dnr,is,isp), dnae_dr_sph(ista_nrc,is,isp)  &
                    &  , ddnae_ddr_sph(ista_nrc,is,isp), ista_nrc, iend_nrc, ist, ien)
            end do
         end do
      else
         do nsp=1,num_isph_chg
            isp=isph_chg(nsp)
            do is=1,nspin
               call calc_diff_exp3_3D(ier,3,nrc,dnr,radr_paw(1,it) &
                    &  , tmp(ista_nrc-6*dnr,is,isp),  dnae_dr_sph(ista_nrc,is,isp) &
                    &  , ista_nrc, iend_nrc, ist, ien)
            end do
         end do
      end if

      deallocate(tmp) ! === For nrc decomposion. by takto 2012/12/07 ===

      call m_PAWCD_set_sq_der_cd_sdphex2(ia,nspin,nrc,dnr &
           &   , num_isph_chg,isph_chg, nae_sph, dnae_dr_sph &
           &   , grad_nae2_sph, grad_tnae2_sph      &
           &   , msphmx_grd,num_isph_grd,isph_grd,ista_nrc,iend_nrc,ist)
      if(iprixc >= DEBUGPRINTLEVEL) call wd_dnae_dr_sph(20)

      do is=1,nspin
         do ir=ist,ien,dnr
            grad_nae(ir,is)=sqrt(grad_nae2_sph(ir,is,1))
         end do
      end do
      do ir=ist,ien,dnr
         grad_tnae(ir)=sqrt(grad_tnae2_sph(ir,1))
      end do

      dnps_dr_sph = 0.0d0

      allocate(tmp(ista_nrc-6*dnr:iend_nrc+6*dnr,nspin,25))     ! == For nrc decomposion. by takto 2012/12/07 ==
      call boundary_exchange_dim3(tmp, nps_sph, dnr, nspin, 25) ! == For nrc decomposion. ==

    !    ! ------ for PS CD -------
      if(vflag == VXC_AND_EXC) then
         do nsp=1,num_isph_chg
            isp=isph_chg(nsp)
            do is=1,nspin
               call calc_ddiff_exp3_3D(ier,3,nrc,dnr,radr_paw(:,it)   &
                    &      , tmp(ista_nrc-6*dnr,is,isp)    &
                    &      , dnps_dr_sph(ista_nrc,is,isp), ddnps_ddr_sph(ista_nrc,is,isp) & ! -> dnps_dr_sph, ddnps_ddr_sph
                    &      , ista_nrc, iend_nrc, ist, ien)
            end do
         end do
      else
         do nsp=1,num_isph_chg
            isp=isph_chg(nsp)
            do is=1,nspin
               call calc_diff_exp3_3D(ier,3,nrc,dnr,radr_paw(:,it) &
                    &      , tmp(ista_nrc-6*dnr,is,isp)   &
                    &      , dnps_dr_sph(ista_nrc,is,isp) &
                    &      , ista_nrc, iend_nrc, ist, ien)
            end do
         end do
      end if

      deallocate(tmp) ! == For nrc decomposion ==

      call m_PAWCD_set_sq_der_cd_sdphex2(ia,nspin,nrc,dnr &
           &     , num_isph_chg,isph_chg, nps_sph             &
           &     , dnps_dr_sph, grad_nps2_sph &
           &     , grad_tnps2_sph, msphmx_grd &
           &     , num_isph_grd,isph_grd,ista_nrc,iend_nrc,ist)

      if(iprixc >= DEBUGPRINTLEVEL) call wd_dnps_dr_sph_etc(20)

      do is=1,nspin
         do ir=ist,ien,dnr
            grad_nps(ir,is)=sqrt(grad_nps2_sph(ir,is,1))
         end do
      end do
      do ir=ist,ien,dnr
         grad_tnps(ir)=sqrt(grad_tnps2_sph(ir,1))
      end do

      return
    end subroutine abs_grad_rho_ud_paw_sphex2_3D
  end subroutine m_PAW_XC_cal_potential_sphex2

  subroutine set_sphex_elements2_3D(nrc,dnr,mode & ! === For nrc decomposion. by takto 2012/12/05 ===
       &             ,num_isph_chg,isph_chg &
       &             ,num_isph_grd,isph_grd &
       &             ,num_isph_n_n,isph_n_n &
       &             ,num_isph_n_g,isph_n_g &
       &             ,num_isph_g_g,isph_g_g,ist,ien)
    integer,intent(in):: nrc,dnr,mode
    integer,intent(in):: num_isph_chg,isph_chg(25)
    integer,intent(in):: num_isph_grd,isph_grd(25)
    integer,intent(out):: num_isph_n_n,isph_n_n(25)
    integer,intent(out):: num_isph_n_g,isph_n_g(25)
    integer,intent(out):: num_isph_g_g,isph_g_g(25)
    integer,intent(in):: ist, ien
        
    call mult_sphex_element3_3D(nrc,dnr,mode                           &
         &                     ,nae_sph(:,1,1:25), num_isph_chg, isph_chg(1:25) &
         &                     ,nae_sph(:,1,1:25), num_isph_chg,isph_chg(1:25) &
         &                     ,nana_ae_sph,       num_isph_n_n,isph_n_n(1:25),ist,ien)
    call mult_sphex_element3_3D(nrc,dnr,mode                           &
         &                     ,nps_sph(:,1,1:25), num_isph_chg,isph_chg(1:25) &
         &                     ,nps_sph(:,1,1:25), num_isph_chg,isph_chg(1:25) &
         &                     ,nana_ps_sph,       num_isph_n_n,isph_n_n(1:25),ist,ien)
    if(nspin.eq.2) then
       call mult_sphex_element3_3D(nrc,dnr,mode                           &
            &                     ,nae_sph(:,2,1:25), num_isph_chg,isph_chg(1:25) &
            &                     ,nae_sph(:,2,1:25), num_isph_chg,isph_chg(1:25) &
            &                     ,nbnb_ae_sph,       num_isph_n_n,isph_n_n(1:25),ist,ien)
       call mult_sphex_element3_3D(nrc,dnr,mode                           &
            &                     ,nae_sph(:,1,1:25), num_isph_chg,isph_chg(1:25) &
            &                     ,nae_sph(:,2,1:25), num_isph_chg,isph_chg(1:25) &
            &                     ,nanb_ae_sph,       num_isph_n_n,isph_n_n(1:25),ist,ien)
       call mult_sphex_element3_3D(nrc,dnr,mode                           &
            &                     ,nps_sph(:,2,1:25), num_isph_chg,isph_chg(1:25) &
            &                     ,nps_sph(:,2,1:25), num_isph_chg,isph_chg(1:25) &
            &                     ,nbnb_ps_sph,       num_isph_n_n,isph_n_n(1:25),ist,ien)
       call mult_sphex_element3_3D(nrc,dnr,mode                           &
            &                     ,nps_sph(:,1,1:25), num_isph_chg,isph_chg(1:25) &
            &                     ,nps_sph(:,2,1:25), num_isph_chg,isph_chg(1:25) &
            &                     ,nanb_ps_sph,       num_isph_n_n,isph_n_n(1:25),ist,ien)
    end if
              
    if(check_of_xctype()==GGA) then 
       call mult_sphex_element3_3D(nrc,dnr,mode                           &
            &                     ,grad_nae2_sph(:,1,1:25), num_isph_grd,isph_grd(1:25) &
            &                     ,grad_nae2_sph(:,1,1:25), num_isph_grd,isph_grd(1:25) &
            &                     ,gaga_ae_sph,             num_isph_g_g,isph_g_g(1:25),ist,ien)
       call mult_sphex_element3_3D(nrc,dnr,mode                           &
            &                     ,nae_sph(:,1,1:25),       num_isph_chg,isph_chg(1:25) &
            &                     ,grad_nae2_sph(:,1,1:25), num_isph_grd,isph_grd(1:25) &
            &                     ,naga_ae_sph,             num_isph_n_g,isph_n_g(1:25),ist,ien)
       call mult_sphex_element3_3D(nrc,dnr,mode                           &
            &                     ,grad_tnae2_sph,          num_isph_grd,isph_grd(1:25) &
            &                     ,grad_tnae2_sph,          num_isph_grd,isph_grd(1:25) &
            &                     ,gg_ae_sph,               num_isph_g_g,isph_g_g(1:25),ist,ien)
       call mult_sphex_element3_3D(nrc,dnr,mode                           &
            &                     ,nae_sph(:,1,1:25),       num_isph_chg,isph_chg(1:25) &
            &                     ,grad_tnae2_sph,          num_isph_grd,isph_grd(1:25) &
            &                     ,nag_ae_sph,              num_isph_n_g,isph_n_g(1:25),ist,ien)
       call mult_sphex_element3_3D(nrc,dnr,mode                           &
            &                     ,grad_nps2_sph(:,1,1:25), num_isph_grd,isph_grd(1:25) &
            &                     ,grad_nps2_sph(:,1,1:25), num_isph_grd,isph_grd(1:25) &
            &                     ,gaga_ps_sph ,            num_isph_g_g,isph_g_g(1:25),ist,ien)
       call mult_sphex_element3_3D(nrc,dnr,mode                           &
            &                     ,nps_sph(:,1,1:25),       num_isph_chg,isph_chg(1:25) &
            &                     ,grad_nps2_sph(:,1,1:25), num_isph_grd,isph_grd(1:25) &
            &                     ,naga_ps_sph ,            num_isph_n_g,isph_n_g(1:25),ist,ien)
       call mult_sphex_element3_3D(nrc,dnr,mode                           &
            &                     ,grad_tnps2_sph,          num_isph_grd,isph_grd(1:25) &
            &                     ,grad_tnps2_sph,          num_isph_grd,isph_grd(1:25) &
            &                     ,gg_ps_sph,               num_isph_g_g,isph_g_g(1:25),ist,ien)
       call mult_sphex_element3_3D(nrc,dnr,mode                           &
            &                     ,nps_sph(:,1,1:25),       num_isph_chg,isph_chg(1:25) &
            &                     ,grad_tnps2_sph,          num_isph_grd,isph_grd(1:25) &
            &                     ,nag_ps_sph,              num_isph_n_g,isph_n_g(1:25),ist,ien)
       if(nspin.eq.2) then 
          call mult_sphex_element3_3D(nrc,dnr,mode                           &
               &                     ,grad_nae2_sph(:,2,1:25),  num_isph_grd,isph_grd(1:25) &
               &                     ,grad_nae2_sph(:,2,1:25),  num_isph_grd,isph_grd(1:25) &
               &                     ,gbgb_ae_sph,              num_isph_g_g,isph_g_g(1:25),ist,ien)
          call mult_sphex_element3_3D(nrc,dnr,mode                           &
               &                     ,nae_sph(:,2,1:25)      ,  num_isph_chg,isph_chg(1:25) &
               &                     ,grad_nae2_sph(:,2,1:25),  num_isph_grd,isph_grd(1:25) &
               &                     ,nbgb_ae_sph,              num_isph_n_g,isph_n_g(1:25),ist,ien)
          call mult_sphex_element3_3D(nrc,dnr,mode                           &
               &                     ,nae_sph(:,2,1:25),        num_isph_chg,isph_chg(1:25) &
               &                     ,grad_tnae2_sph,           num_isph_grd,isph_grd(1:25) &
               &                     ,nbg_ae_sph,               num_isph_n_g,isph_n_g(1:25),ist,ien)
          call mult_sphex_element3_3D(nrc,dnr,mode                           &
               &                     ,grad_nps2_sph(:,2,1:25),  num_isph_grd,isph_grd(1:25) &
               &                     ,grad_nps2_sph(:,2,1:25),  num_isph_grd,isph_grd(1:25) &
               &                     ,gbgb_ps_sph,              num_isph_g_g,isph_g_g(1:25),ist,ien)
          call mult_sphex_element3_3D(nrc,dnr,mode                           &
               &                     ,nps_sph(:,2,1:25),        num_isph_chg,isph_chg(1:25) &
               &                     ,grad_nps2_sph(:,2,1:25),  num_isph_grd,isph_grd(1:25) &
               &                     ,nbgb_ps_sph,              num_isph_n_g,isph_n_g(1:25),ist,ien)
          call mult_sphex_element3_3D(nrc,dnr,mode                           &
               &                     ,nps_sph(:,2,1:25),        num_isph_chg,isph_chg(1:25) &
               &                     ,grad_tnps2_sph,           num_isph_grd,isph_grd(1:25) &
               &                     ,nbg_ps_sph,               num_isph_n_g,isph_n_g(1:25),ist,ien)
          
       end if
    end if
    return
    
  end subroutine set_sphex_elements2_3D


! === For nrc decomposion. by takto 2012/12/05 =================================
  subroutine mult_sphex_element_full3(dnr,mode  &
       &                                  ,n1,num_isph1,isph1 &
       &                                  ,n2,num_isph2,isph2 &
       &                                  ,n3,num_isph3,isph3 &
       &                                  ,ist,ien)
    integer,intent(in):: dnr,mode
    integer,intent(in):: num_isph1,isph1(25)
    integer,intent(in):: num_isph2,isph2(25)
    real(DP),intent(in):: n1(ista_nrc:iend_nrc,25),n2(ista_nrc:iend_nrc,25)
    real(DP),intent(out):: n3(ista_nrc:iend_nrc,25)
    integer,intent(out):: num_isph3,isph3(25)
    integer,intent(in) :: ist,ien
        
    integer:: ir,isp,isp1,isp2,n
    integer:: nsp,nsp1,nsp2
    real(DP):: fac, cijk
    logical:: flg_isp(25)
        
    n3=0.d0
!        do isp=2,msphmx
    do nsp=2,num_isph1
       isp=isph1(nsp)
       do ir=ist,ien,dnr
          n3(ir,1)=n3(ir,1) + n1(ir,isp)*n2(ir,isp)
       end do
    end do
    do ir=ist,ien,dnr
       n3(ir,1)=n3(ir,1)/PAI4+n1(ir,1)*n2(ir,1)
    end do
        
    if(mode.eq.0) return
        
    flg_isp=.false.
    flg_isp(1)=.true.
        
!!$        msphmx3=0
!        do isp1=2,min(16,msphmx)                                    ! sphset2
!        do isp1=2,msphmx                                            ! sphset3
    do nsp1=2,num_isph1
       isp1=isph1(nsp1)
!            do isp2=isp1,min(16,msphmx)                             ! sphset2
!            do isp2=isp1,msphmx                                     ! sphset3
       do nsp2=nsp1,num_isph2
          isp2=isph2(nsp2)
          fac=1.d0;if(isp1.eq.isp2) fac=0.5d0
          do n=1,paw_mmt2(isp1,isp2)
             isp=paw_isph2(isp1,isp2,n)
             if(isp.eq.1) cycle
!!$                    if(isp.gt.msphmx3) msphmx3=isp
             flg_isp(isp)=.true.
             cijk=paw_cr2(isp1,isp2,n)
             do ir=ist,ien,dnr
                n3(ir,isp)=n3(ir,isp) + &
                     fac*(n1(ir,isp1)*n2(ir,isp2)+n1(ir,isp2)*n2(ir,isp1))*cijk
             end do
          end do
       end do
    end do
!        do isp=2,msphmx
    do nsp=2,num_isph1
       isp=isph1(nsp)
       do ir=ist,ien,dnr
          n3(ir,isp)=n3(ir,isp) + n1(ir,1)*n2(ir,isp) + n1(ir,isp)*n2(ir,1)
       end do
    end do
        
    num_isph3=0
    isph3=0
    do isp=1,25
       if(flg_isp(isp)) then
          num_isph3=num_isph3+1
          isph3(num_isph3)=isp
       end if
    end do
        
    return
    
  end subroutine mult_sphex_element_full3
! ==============================================================================

! === For nrc decomposion. by takto 2012/12/05 =================================

  subroutine get_paw_sphex_integral3(nrc,dnr,rd  &
       &                               ,n1,num_isph1,isph1 &
       &                               ,n2 &
       &                               ,n3,num_isph3,isph3,ist,ien)
    integer,intent(in):: nrc,dnr
    integer,intent(in):: num_isph1,isph1(25)
!!$        integer,intent(in):: num_isph2,isph2(25)
    real(DP),intent(in):: n1(ista_nrc:iend_nrc,25),n2(ista_nrc:iend_nrc,25),rd(nrc)
    real(DP),intent(out):: n3(ista_nrc:iend_nrc,25)
    integer,intent(out):: num_isph3,isph3(25)
    integer,intent(in) :: ist,ien
        
    integer:: isp,isp1,isp2,n,ir
    integer:: nsp,nsp1,nsp2
    real(DP):: dl,dl1,dl2,fac,cijk
    integer,allocatable,dimension(:):: il3
    logical:: flg_isp(25)
    
    allocate(il3(25));call substitute_il3(25,il3)
        
    n3=0.d0
    flg_isp=.false.
!        do isp1=2,min(16,msphmx)                                        ! sphset2    
!        do isp1=2,msphmx                                                ! sphset3   
    do nsp1=2,num_isph1
       isp1=isph1(nsp1)             
       dl1=dble(il3(isp1))
       dl1=dl1*(dl1+1.d0)
!            do isp2=isp1,min(16,msphmx)                                 ! sphset2
!            do isp2=isp1,msphmx                                         ! sphset3
!!$            do nsp2=nsp1,num_isph2
       do nsp2=nsp1,num_isph1
!!$                isp2=isph2(nsp2)
          isp2=isph1(nsp2)
          dl2=dble(il3(isp2))
          dl2=dl2*(dl2+1.d0)
          fac=0.5d0;if(isp1.eq.isp2) fac=0.25d0
!                fac=0.5d0
          do n=1,paw_mmt2(isp1,isp2)
             isp=paw_isph2(isp1,isp2,n)
             if(isp.eq.1) cycle
!!$                    if(isp.gt.msphmx3) msphmx3=isp
             flg_isp(isp)=.true.
             cijk=paw_cr2(isp1,isp2,n)
             dl=dble(il3(isp))
             dl=dl*(dl+1.d0)
                    
             do ir=ist,ien,dnr
                n3(ir,isp) = n3(ir,isp) + fac*(  n1(ir,isp1)*n2(ir,isp2)*(dl2+dl-dl1)  &
                     &                         + n1(ir,isp2)*n2(ir,isp1)*(dl1+dl-dl2) ) * cijk
             end do
                    
          end do
       end do
    end do
        
    num_isph3=0
    isph3=0
    do isp=1,25
       if(flg_isp(isp)) then
          num_isph3=num_isph3+1
          isph3(num_isph3)=isp
       end if
    end do
        
    do isp=2,25
       dl=dble(il3(isp))
       dl=dl*(dl+1.d0)
       do ir=ist,ien,dnr
          n3(ir,isp)=(dl*n1(ir,1)*n2(ir,isp)+n3(ir,isp))/rd(ir)/rd(ir)
       end do
    end do
    return

  end subroutine get_paw_sphex_integral3

! ==============================================================================
  subroutine merge_isph_flgs(n1,isph1,n2,isph2,n3,isph3 &
       &                    ,n4,isph4,n5,isph5,n6,isph6,n7,isph7)
    integer,intent(in):: n1,isph1(25)
    integer,intent(in):: n2,isph2(25)
    integer,intent(in):: n3,isph3(25)
    integer,intent(in):: n4,isph4(25)
    integer,intent(in):: n5,isph5(25)
    integer,intent(in):: n6,isph6(25)
    integer,intent(out):: n7,isph7(25)
        
    integer:: nsp
    logical:: flg(25)
        
    flg=.false.
    do nsp=1,n1
       flg(isph1(nsp))=.true.
    end do
    do nsp=1,n2
       flg(isph2(nsp))=.true.
    end do
    do nsp=1,n3
       flg(isph3(nsp))=.true.
    end do
    do nsp=1,n4
       flg(isph4(nsp))=.true.
    end do
    do nsp=1,n5
       flg(isph5(nsp))=.true.
    end do
    do nsp=1,n6
       flg(isph6(nsp))=.true.
    end do
    n7=0
    isph7=0
    do nsp=1,25
       if(flg(nsp)) then
          n7=n7+1
          isph7(n7)=nsp
       end if
    end do
    return
  end subroutine merge_isph_flgs
    
  subroutine xcpotf_paw(nrc,ispin,ith,input_charge)    
    integer, intent(in) :: nrc,ispin,ith,input_charge

! #1) 1994/11/08 by T.Yamasaki
!    Coding for the case of xctype='PERZUN ' and  'XALPHA ' are done.
! #2) Spin-polarization is introduced by T. Yamasaki at 15th Dec. 1994
! #3) f77 -> f90     4th April 1999  by T. Yamasaki 

    real(kind=DP) :: DELTA
    data DELTA/1.d-40/

    if(xctype == 'wign   '.or. xctype == 'wigner ')then
       call xcpotf_wigner(ispin,1,nrc,input_charge,DELTA &
            &            ,nae(1:nrc,1:ispin),wos(1:nrc),texc)
       exc_ae=exc_ae+texc*omg_wght(ith)
       call xcpotf_wigner(ispin,1,nrc,input_charge,DELTA &
            &            ,nps(1:nrc,1:ispin),wos(1:nrc),texc)
       exc_ps=exc_ps+texc*omg_wght(ith)
    else if(  xctype ==  'pzold  ') then
       call xcpotf_pzold(ispin,1,nrc,input_charge,DELTA &
            &           ,nae(1:nrc,1:nspin),wos(1:nrc),texc)
       exc_ae=exc_ae+texc*omg_wght(ith)
       call xcpotf_pzold(ispin,1,nrc,input_charge,DELTA &
            &           ,nps(1:nrc,1:nspin),wos(1:nrc),texc)
       exc_ps=exc_ps+texc*omg_wght(ith)
    else if(  xctype ==  'xalfa  ') then
       call xcpotf_xalfa(ispin,1,nrc,input_charge,DELTA &
            &           ,nae(1:nrc,1:nspin),wos(1:nrc),texc)
       exc_ae=exc_ae+texc*omg_wght(ith)
       call xcpotf_xalfa(ispin,1,nrc,input_charge,DELTA &
            &           ,nps(1:nrc,1:nspin),wos(1:nrc),texc)
       exc_ps=exc_ps+texc*omg_wght(ith)
    else if(  xctype == 'perzun '.or. xctype == 'pz     ') then
       call xcpotf_pz(ispin,1,nrc,input_charge,DELTA &
            &           ,nae(1:nrc,1:nspin),wos(1:nrc),texc)
       exc_ae=exc_ae+texc*omg_wght(ith)
       call xcpotf_pz(ispin,1,nrc,input_charge,DELTA &
            &           ,nps(1:nrc,1:nspin),wos(1:nrc),texc)
       exc_ps=exc_ps+texc*omg_wght(ith)
    else if(  xctype == 'vwn    ') then
       call xcpotf_vwn(ispin,1,nrc,input_charge,DELTA &
            &           ,nae(1:nrc,1:nspin),wos(1:nrc),texc)
       exc_ae=exc_ae+texc*omg_wght(ith)
       call xcpotf_vwn(ispin,1,nrc,input_charge,DELTA &
            &           ,nps(1:nrc,1:nspin),wos(1:nrc),texc)
       exc_ps=exc_ps+texc*omg_wght(ith)
    else if(  xctype=='mjw    '.or. xctype=='bh     ' .or.xctype=='gl     ') then
       call xcpotf_mjw_bh_gl(len_xctype,xctype,ispin,1,nrc,input_charge,DELTA &
            &               ,nae(1:nrc,1:nspin),wos(1:nrc),texc)
       exc_ae=exc_ae+texc*omg_wght(ith)
       call xcpotf_mjw_bh_gl(len_xctype,xctype,ispin,1,nrc,input_charge,DELTA &
            &               ,nps(1:nrc,1:nspin),wos(1:nrc),texc)
       exc_ps=exc_ps+texc*omg_wght(ith)
    else
       write(*,'(" xctype = ",a7)') xctype
       stop ' xctype is not set properly (xcpotf_paw)'
    endif
                        ! all xcpotf_* subroutines are in -(b_XC_Potential) ->chgrhr_l,exc

  end subroutine xcpotf_paw
    
  subroutine m_PAW_XC_get_dion_vxc(nfout)
    integer,intent(in):: nfout
    integer:: ia,it,lmt1,lmt2,is
    integer:: n,ilm3,l3,iiqitg
    integer:: ilt1,ilt2,il1,il2,ilk1, ja
    real(DP):: fac,sum
    real(DP),allocatable,dimension(:,:,:,:,:):: pipjvxc_k
        
    allocate(pipjvxc_k(nltpw,nltpw,msph,nspin,natm))
    pipjvxc_k=0.d0

    if(af /= 0) allocate(flg_done(natm))
 
    call cnstrct_of_PiPjVxc_k2(nltpw,msph,natm,nspin,pipjvxc_k) !!$  call cnstrct_of_PiPjVxc_k()

    if(af /= 0) flg_done=.false.
        
    do ia=1,natm
! === DEBUG by tkato 2011/10/01 ================================================
!           if(af /= 0 .and. flg_done(ia)) cycle
       if(af /= 0) then
          if(flg_done(ia)) then
             cycle
          endif
       endif
! ==============================================================================
       it=ityp(ia)
       if(ipaw(it)/=1) then
          dion_vxc(:,:,:,ia)=0.d0
          cycle
       end if
            
       do lmt1=1,ilmt(it)
          ilt1=index_lmt2lt(lmt1,it)
          do lmt2=lmt1,ilmt(it)
             ilt2=index_lmt2lt(lmt2,it)
             do is=1,nspin
                sum=0.d0
                do n=1,il2p(lmt1,lmt2,it)
                   ilm3 = isph(lmt1,lmt2,n,it)
                   sum = sum &
                        &  + dl2p(lmt1,lmt2,n,it) * pipjvxc_k(ilt1,ilt2,ilm3,is,ia)
                end do
                dion_vxc(lmt1,lmt2,is,ia)=sum
             end do
          end do
       end do

!ASMS            if(af /= 0) then
!ASMS                ja=ia2ia_symmtry_op(ia,nopr+af)
!ASMS                dion_vxc(:,:,2,ja)=dion_vxc(:,:,1,ia)
!ASMS                dion_vxc(:,:,1,ja)=dion_vxc(:,:,2,ia)
!ASMS                flg_done(ja)=.true.
!ASMS            end if

    end do
        
    if(ipripp>=2.and.printable)then
       write(nfout,*)
       write(nfout,*) ' -- dion_vxc ---'
       do ia=1,natm
          it=ityp(ia)
          if(ipaw(it)/=1) cycle
          do is=1,nspin
             write(nfout,'(a,i2,a,i2,a)') '(ia,is)=(',ia,',',is,')'
             do lmt1 = 1, ilmt(it)
                write(nfout,'(i3,15f12.9/15f12.9)') lmt1 &
                     &               ,(dion_vxc(lmt1,lmt2,is,ia),lmt2 = 1, ilmt(it))
             end do
          end do
       end do
    end if
        
    deallocate(pipjvxc_k)
    if(af /= 0) deallocate(flg_done)

    return
  end subroutine m_PAW_XC_get_dion_vxc

    
! ============================= added by K. Tagami ============== 11.0

  subroutine cnstrct_of_PiPjVxc_k2(n,m,na,ns,mat)
    integer,intent(in):: n,m,na,ns
    real(DP),intent(out):: mat(n,n,m,ns,na)
        
    integer:: ia,it,is,ksph,nrc,ier,ir,dnr,nrc0
    integer:: ilt1,ilt2,il1,il2,it1,it2,ilk
    integer:: iiqitg
    integer:: ist,ien, ia_add, ip, ierr
    real(DP):: wos(mmesh),sum,zz
    real(DP),allocatable,dimension(:,:,:,:) :: matb

    mat = 0.d0
    allocate(matb(n,n,m,ns))
    do ia = ista_natm, iend_natm  !      do ia=1,natm
       ia_add = ia - ista_natm + 1

       do it=1,ntyp
          if(ityp(ia)/=it) cycle
          if(ipaw(it)/=1) then
             mat(:,:,:,:,ia)=0.d0
             cycle
          end if

! **** set dnr from input ****
          dnr=paw_dnr(it)            
          if(dnr.gt.1) then
             nrc0=wf_mnrc(it)
             nrc=1+int((nrc0-1)/dnr)*dnr
!                    zz = (radr_paw(nrc0,it)-radr_paw(nrc,it))/ &
!                            (radr_paw(nrc+dnr,it)-radr_paw(nrc,it))
!                    zz = log(radr_paw(nrc0,it)/radr_paw(nrc,it))/ &
!                        log(radr_paw(nrc+dnr,it)/radr_paw(nrc,it))
             zz = dble(nrc0-nrc)/dble(dnr)
             nrc=nrc+2*dnr                                                  ! 3rd interpolation
             call set_weight_exp3(ier,1,nrc,dnr,radr_paw(:,it),zz,wos)      !  3rd
          else
             nrc=wf_mnrc(it)
             call set_weight_exp(ier,1,nrc,radr_paw(:,it),wos)
          end if

          ist = (ista_nrc+dnr-2)/dnr
          ist = dnr*ist+1
          ien = min(iend_nrc, nrc)
    
#ifdef DEBUG_PAW3D
          write(6,'(" <<cnstrct_of_PiPjVxc_k2>> ia = ",i8)') ia
#endif
          do ilt1=1,iltpw(it)
             il1=lppw(ilt1,it)
             it1=tppw(ilt1,it)
             do ilt2=ilt1,iltpw(it)
                il2=lppw(ilt2,it)
                it2=tppw(ilt2,it)
                do ilk=abs(il1-il2),il1+il2-2,2
                   if(ilk > 4) cycle
                   iiqitg=iqitg(il1,it1,il2,it2,ilk+1,it)
                   if(iiqitg==0) then
                   end if
                   do ksph=ilk**2+1,ilk**2+2*ilk+1
                      do is=1,nspin
                         sum=0.d0
                         do ir=ist,ien,dnr   !!$   do ir=ista_nrc,iend_nrc
                            sum=sum &
                                 & + ( psirpw(ir,il1,it1,it)*psirpw(ir,il2,it2,it)* vxc_ae_k_3D(ir,is,ksph,ia_add) &
                                 &    - (phirpw(ir,il1,it1,it)*phirpw(ir,il2,it2,it)+ &
                                 &                             qrspspw(ir,iiqitg))*vxc_ps_k_3D(ir,is,ksph,ia_add) &
                                 &    ) * wos(ir)
                         end do
!!$                             call mpi_allreduce(MPI_IN_PLACE,sum,1,mpi_double_precision,mpi_sum,mpi_natm_world,ierr)
!!$                             mat(ilt1,ilt2,ksph,is,ia)=sum
                         matb(ilt1,ilt2,ksph,is)=sum
                      end do
                   end do
                end do
             end do
          end do
       end do
       call mpi_allreduce(MPI_IN_PLACE,matb,n*n*m*ns,mpi_double_precision,mpi_sum,mpi_natm_world,ierr)
       mat(:,:,:,:,ia) = matb(:,:,:,:)
    end do

    ip = 0
    do ia = 1, natm
       do ir = 0,nrank_natm-1
          if(is_natm(ir)<=ia .and. ia <=ie_natm(ir)) then
             ip = ir
             if(ip == myrank_natm) matb(:,:,:,:) = mat(:,:,:,:,ia)
             cycle
          end if
       end do
       call mpi_bcast(matb,n*n*m*ns,mpi_double_precision,ip,mpi_nrc_world,ierr)
       mat(:,:,:,:,ia) = matb(:,:,:,:)
    end do

    deallocate(matb)
    
    return
  end subroutine cnstrct_of_PiPjVxc_k2

  subroutine boundary_exchange_dim2(array_out, array_in, dn, dim2) ! === For nrc decomposion. by takto 2012/12/07 ====
    implicit none
    include 'mpif.h'
    integer, intent(in) :: dn, dim2
    real(kind=DP), intent(in)  :: array_in (ista_nrc     :iend_nrc,     dim2)
    real(kind=DP), intent(out) :: array_out(ista_nrc-6*dn:iend_nrc+6*dn,dim2)
    integer :: pn, pp, stat(MPI_STATUS_SIZE)

    integer :: i, srcount, ierr
    real(kind=DP), allocatable, dimension(:,:) :: sendbuf, recvbuf

    pn = myrank_nrc - 1
    pp = myrank_nrc + 1
    if(pn == -1)        pn = MPI_PROC_NULL
! if(pp == nrank_nrc) pp = MPI_PROC_NULL
    if(paw_last_rank_on_nrc) pp = MPI_PROC_NULL

    srcount = 6*dn*dim2

    allocate(sendbuf(6*dn,dim2))
    allocate(recvbuf(6*dn,dim2))

    array_out(ista_nrc:iend_nrc,:) = array_in(ista_nrc:iend_nrc,:)

    do i = 1, dim2
       sendbuf(1:6*dn,i) = array_in(iend_nrc-6*dn+1:iend_nrc,i)
    end do
    call MPI_Sendrecv(sendbuf, srcount, MPI_DOUBLE_PRECISION, pp, 1 &
         &          , recvbuf, srcount, MPI_DOUBLE_PRECISION, pn, 1 &
         &          , mpi_natm_world, stat, ierr)
    do i = 1, dim2
       array_out(ista_nrc-6*dn:ista_nrc-1,i) = recvbuf(1:6*dn,i)
    end do

    do i = 1, dim2
       sendbuf(1:6*dn,i) = array_in(ista_nrc:ista_nrc+6*dn-1,i)
    end do
    call MPI_Sendrecv(sendbuf, srcount, MPI_DOUBLE_PRECISION, pn, 1 &
         &          , recvbuf, srcount, MPI_DOUBLE_PRECISION, pp, 1 &
         &          , mpi_natm_world, stat, ierr)
    do i = 1, dim2
       array_out(iend_nrc+1:iend_nrc+6*dn,i) = recvbuf(1:6*dn,i)
    end do

    deallocate(sendbuf)
    deallocate(recvbuf)

    return
  end subroutine boundary_exchange_dim2

  subroutine boundary_exchange_dim3(array_out, array_in, dn, dim2, dim3)
    implicit none
    include 'mpif.h'
    integer, intent(in) :: dn, dim2, dim3
    real(kind=DP), intent(in)  :: array_in (ista_nrc     :iend_nrc,     dim2,dim3)
    real(kind=DP), intent(out) :: array_out(ista_nrc-6*dn:iend_nrc+6*dn,dim2,dim3)
    integer :: pn, pp, stat(MPI_STATUS_SIZE)

    integer :: i, j, srcount, ierr
    real(kind=DP), allocatable, dimension(:,:,:) :: sendbuf, recvbuf

    pn = myrank_nrc - 1
    pp = myrank_nrc + 1
    if(pn == -1)        pn = MPI_PROC_NULL
! if(pp == nrank_nrc) pp = MPI_PROC_NULL
    if(paw_last_rank_on_nrc) pp = MPI_PROC_NULL

    srcount = 6*dn*dim2*dim3

    allocate(sendbuf(6*dn,dim2,dim3))
    allocate(recvbuf(6*dn,dim2,dim3))

    array_out(ista_nrc:iend_nrc,:,:) = array_in(ista_nrc:iend_nrc,:,:)

    do j = 1, dim3
       do i = 1, dim2
          sendbuf(1:6*dn,i,j) = array_in(iend_nrc-6*dn+1:iend_nrc,i,j)
       end do
    end do
    call MPI_Sendrecv(sendbuf, srcount, MPI_DOUBLE_PRECISION, pp, 1 &
         &          , recvbuf, srcount, MPI_DOUBLE_PRECISION, pn, 1 &
         &          , mpi_natm_world, stat, ierr)
    do j = 1, dim3
       do i = 1, dim2
          array_out(ista_nrc-6*dn:ista_nrc-1,i,j) = recvbuf(1:6*dn,i,j)
       end do
    end do

    do j = 1, dim3
       do i = 1, dim2
          sendbuf(1:6*dn,i,j) = array_in(ista_nrc:ista_nrc+6*dn-1,i,j)
       end do
    end do
    call MPI_Sendrecv(sendbuf, srcount, MPI_DOUBLE_PRECISION, pn, 1 &
         &          , recvbuf, srcount, MPI_DOUBLE_PRECISION, pp, 1 &
         &          , mpi_natm_world, stat, ierr)
    do j = 1, dim3
       do i = 1, dim2
          array_out(iend_nrc+1:iend_nrc+6*dn,i,j) = recvbuf(1:6*dn,i,j)
       end do
    end do

    deallocate(sendbuf)
    deallocate(recvbuf)

    return
  end subroutine boundary_exchange_dim3

end module m_PAW_XC_Potential

      subroutine tred1_load(a, w, nm,
     &              d_t,
     &              u_x, u_y, v_x, v_y, nv,
     &              m0, i_base, i_block)

      implicit NONE

      integer, intent(in)    ::  nm, nv, m0, i_base, i_block
      real(8), intent(inout) ::  a(1:nm,*)
      real(8), intent(out)   ::  w(1:nm,*)
      real(8), intent(out)   ::  u_x(1:nv,*), u_y(1:nv,*)
      real(8), intent(out)   ::  v_x(1:nv,*), v_y(1:nv,*)
      real(8), intent(out)   ::  d_t(*)

      integer                ::  x_pos, x_owner_nod
      integer                ::  y_pos, y_owner_nod
      integer                ::  i_1, i_2, i_3, i_4
      integer                ::  j_1, j_2, j_3, j_4
      integer                ::  k_1, k_2, k_3, k_4
      integer                ::  i, j, L
      real(8) :: s

      include 'trd.h'
      include 'param.h'


      i_2 = loop_c_start(i_base+1,  y_nnod,y_inod)
      i_3 = loop_c_end  (i_base+m0, y_nnod,y_inod)
      j_2 = loop_c_start(1,         x_nnod,x_inod)
      j_3 = loop_c_end  (i_base+m0, x_nnod,x_inod)

      do i_1=i_2,i_3
         j = loop_c_l2g_depth(i_1, y_nnod,y_inod)
         do j_1=j_2,j_3
            w(j_1,j-i_base) = a(j_1,i_1)
         end do! j_1
      end do! i_1

      if ( diag_0 > 0 ) then
         i_2 = diag_0
         i_3 = loop_c_end  (i_base+m0-1, y_nnod,y_inod)
         i_4 = x_nnod/n_common
         if ( y_nnod == x_nnod ) then
!DIR$ IVDEP
!DIR$ VECTOR ALWAYS
            do i_1=i_2,i_3,i_4
               d_t(i_1)   = a(i_1,i_1)
               a(i_1,i_1) = ZERO
            end do! i_1
         else
            do i_1=i_2,i_3,i_4
               j   = loop_c_l2g_depth(i_1, y_nnod,y_inod)
               j_1 = loop_c_g2l_depth(j,   x_nnod,x_inod)
               d_t(i_1)   = a(j_1,i_1)
               a(j_1,i_1) = ZERO
            end do! i_1
         end if
      end if

      i = i_base+m0
      L = i - 2
      y_pos  = loop_c_g2l_depth(i, y_nnod,y_inod)
      x_pos  = loop_c_g2l_depth(i, x_nnod,x_inod)

      k_2 = m0
      k_3 = MAX(1, 3*(2-i_block))
      do k_1=1,k_2
         do j_1=1,x_pos
            u_x(j_1,k_1) = ZERO
            v_x(j_1,k_1) = ZERO
         end do! j_1
         do j_1=1,y_pos
            u_y(j_1,k_1) = ZERO
            v_y(j_1,k_1) = ZERO
         end do! j_1
      end do! k_1

      return
      end subroutine tred1_load


      subroutine tred1_store(a, w, nm,
     &              d_t,
     &              m0, i_base)

      integer, intent(in)    ::  nm, m0, i_base
      real(8), intent(out)   ::  a(1:nm,*)
      real(8), intent(in)    ::  w(1:nm,*), d_t(*)

      integer                ::  i_1, i_2, i_3, i_4
      integer                ::  j_1, j_2, j_3, j_4

      include 'trd.h'
      include 'param.h'


      i_2 = loop_c_start(i_base+1,  y_nnod,y_inod)
      i_3 = loop_c_end  (i_base+m0, y_nnod,y_inod)
      do i_1=i_2,i_3
         j   = loop_c_l2g_depth(i_1, y_nnod,y_inod)
         j_3 = loop_c_end  (j, x_nnod,x_inod)
         do j_1=1,j_3
            a(j_1,i_1) = w(j_1,j-i_base)
         end do! j_1
      end do! i_1

      if ( diag_0 > 0 ) then
         i_2 = diag_0
         i_3 = loop_c_end  (i_base, y_nnod,y_inod)
         i_4 = x_nnod/n_common
         if ( y_nnod == x_nnod ) then
            do i_1=i_2,i_3,i_4
               j_1 = i_1
               a(j_1,i_1) = d_t(i_1)
            end do! i_1
         else
            do i_1=i_2,i_3,i_4
!              j   = loop_c_l2g_depth(i_1, y_nnod,y_inod)
!              j_1 = loop_c_g2l_depth(j,   x_nnod,x_inod)
               j   = (i_1-1)*y_nnod+y_inod
               j_1 = (j-1)/x_nnod+1
               a(j_1,i_1) = d_t(i_1)
            end do! i_1
         end if
      end if

      return
      end subroutine tred1_store

#define POST3D
!=======================================================================
!
!  PROGRAM  PHASE/0 2019.02 ($Rev: 593 $)
!
!  MAIN PROGRAM: PHASE
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!  $Id: mdmain.F90 593 2019-06-20 03:47:31Z jkoga $
!
#ifdef FJ_TIMER
#  define __TIMER_FJ_START_w_BARRIER(str,a)  call mpi_barrier(str,ierr); call timer_sta(a)
#  define __TIMER_FJ_START(a)                call timer_sta(a)
#  define __TIMER_FJ_STOP(a)                 call timer_end(a)
#else
#  define __TIMER_FJ_START_w_BARRIER(str,a)
#  define __TIMER_FJ_START(a)
#  define __TIMER_FJ_STOP(a)
#endif
#ifdef __TIMER__
#  define __TIMER_START_w_BARRIER(str,a)  call mpi_barrier(str,ierr) ;   call timer_sta(a)
#  define __TIMER_START(a)                call timer_sta(a)
#  define __TIMER_STOP(a)                 call timer_end(a)
#else
#  define __TIMER_START_w_BARRIER(str,a)
#  define __TIMER_START(a)
#  define __TIMER_STOP(a)
#endif
!
program PHASE

  use m_Files,                only : nfout
  use m_Ionic_System,         only : natm
  use m_PseudoPotential,      only : mmesh
  use m_Parallelization,      only : m_Parallel_init_mpi_paw_3D

  use m_Const_Parameters,    only : DRIVER_NEB,DRIVER_CONSTRAINT,DRIVER_MTD,DRIVER_SC_DFT
  use m_Parallelization,     only : mpi_comm_group

! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
use mod_timer
use m_Parallelization, only  : mype
#endif
! === TIMERTIMERTIMER ==========================================================

  implicit none
  logical  :: ChargeDensity_is_Converged, TotalEnergy_is_Divergent
  logical  :: Already_Converged, Already_Converged2
  logical  :: Positron_bulk, Positron_defect, Structure_is_fixed
  logical  :: Hubbard_model
  logical  :: Forces_are_Converged, Ending_Time, Force_errors_are_tolerable,UnitCell_Converged
  logical  :: from_Initialize
  logical  :: InUeffRamping
!!$  logical  :: ChargeDensity_is_Fixed
   interface
     subroutine Initialization(init_mpi)
       integer, intent(in), optional :: init_mpi
     end subroutine Initialization
   end interface
#ifdef NEC_ITER_REG
  integer  :: count_for_ftrace
#endif

  integer :: ispin, ik, iksnl, ierR

  integer :: initmpi
  logical :: confpara
  integer :: driver
  logical :: uconv,ending_t,force_conv
  logical :: initialization_required
  
#ifdef NEC_ITER_REG
     count_for_ftrace = 0
     call FTRACE_REGION_BEGIN("INITIAL")
#endif

  confpara = Resolve_Config_Parallel()
  initmpi=1
  if(confpara) initmpi=0

  do

  ending_t = .false.
                                                  __TIMER_START(17)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,21)
!  call Initialization(init_mpi=1)
  call Initialization(initmpi)
                                                  __TIMER_FJ_STOP(21)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,22)
  call InputData_Analysis
  write(6,'(" InputData_Analysis")')
  call flush(6)
!!$
!!$  call PseudoPotential_Construction
!!$  write(6,'(" PseudoPotential_Construction")')
!!$  call flush(6)

  driver   = Resolve_Driver()

  if(ekmode()) then
    call Initialization_set_ekmode_ON()
  endif

  if (driver==DRIVER_NEB)then
#ifndef DISABLE_CONSTRAINTS
      call do_neb()
  else if (driver==DRIVER_CONSTRAINT) then
      call constrained_dynamics()
  else if (driver==DRIVER_MTD) then
      call meta_dynamics()
#endif
  else
  outer_loop:do

!  if(driver==DRIVER_SC_DFT .and. .not.Initial_SCDFTLoop()) then
!     call InputData_Analysis()
!     if(ekmode()) call Initialization_set_ekmode_ON()
!  end if
                                                  __TIMER_FJ_STOP(22)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,23)
  call Preparation                   ! Basis set, symmetry check etc.
                                                  __TIMER_FJ_STOP(23)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,24)
  if(ekmode()) call Preparation_for_mpi_ek()
  if(initialization_required()) then
    call Preparation_for_mpi(1)        ! mpi
  endif
                                                  __TIMER_FJ_STOP(24)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,25)
  call PseudoPotential_Construction
  write(6,'(" PseudoPotential_Constuction 2")')
  call flush(6)

                                                  __TIMER_FJ_STOP(25)
  call  m_Parallel_init_mpi_paw_3D(nfout,natm,mmesh)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,26)
#ifdef ENABLE_ESM_PACK
  if(initialization_required())then
    call Preparation_for_ESM
  endif
#endif

  call Ewald_and_Structure_Factor
  write(6,'(" Ewald_and_Structure_Factor")')
  call flush(6)
                                                  __TIMER_FJ_STOP(26)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,27)
  call Initial_Electronic_Structure
  write(6,'(" Initial_Electronic_Structure")')
  call flush(6)
                                                  __TIMER_FJ_STOP(27)
                                                  __TIMER_STOP(17)

!!  from_Initialize = .false.
!$$  from_Initialize = .true.
!$$  if(from_Initialize) call Para3d_Entry()
 
  if(ChargeDensity_is_Fixed() .and. One_by_one_in_each_rank_k()) then ! icond=2, 3
     call ekcal()  ! contained here
     exit outer_loop
  else
     call Initial_MD_Condition
#ifdef NEC_ITER_REG
     call FTRACE_REGION_END("INITIAL")
#endif

     force_conv = Already_Converged()
     if(.not.force_conv) then
#ifdef NEC_ITER_REG
        call FTRACE_REGION_BEGIN("SOLVE-FIRST")
#endif
        StressLoop: do
           AtomicConfiguration: do
              ChargeDensity:    do

#ifdef NEC_ITER_REG
                 count_for_ftrace = count_for_ftrace + 1
                 if(count_for_ftrace .eq. 2) then
                    call FTRACE_REGION_END("SOLVE-FIRST")
                    call FTRACE_REGION_BEGIN("SOLVE-CORE")
                 end if
#endif
                 call IterationNumber_Setting

! ============================ added by K. Tagami ============- 5.0
                 call Renewal_of_Chg_Ctrl_Param
! ============================================================ 5.0
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,16)
!!$                 call ReadCheckPointData_if_needed
                 call Renewal_of_WaveFunctions
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,11)
                 call ChargeDensity_Construction(1)
                 call ChargeDensity_Mixing
                                                  __TIMER_STOP(11)
                 ending_t = Ending_Time()
                 if(ending_t)                      exit outer_loop
                 if(TotalEnergy_is_Divergent())    exit outer_loop
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,11)
                                                  
                 call Renewal_of_Potential
                                                  __TIMER_STOP(11)
                 if(Hubbard_model()) then
                    call Renewal_of_Hubbard_Potential
                 end if
!!$                 call WriteCheckPointData  ! if necessary
                 if(ChargeDensity_is_Converged()) then
                                                  __TIMER_STOP(16)
                    exit ChargeDensity
                 end if
                                                  __TIMER_STOP(16)
              enddo ChargeDensity

!$$!              call PARA_3Dto2D()     !!!!!!!!!! 3D $B"*(B 2D !!!!!!!!!!

              if(Structure_is_fixed()) then
                  force_conv = .true.
                  exit StressLoop
              end if
!$$!              call PARA_2Dto3D()     !!!!!!!!!! 3D $B"*(B 2D !!!!!!!!!!
              call Forces
!$$!              call PARA_3Dto2D()     !!!!!!!!!! 3D $B"*(B 2D !!!!!!!!!!
              force_conv = Forces_are_Converged()
              if(force_conv) then
                 if ( epsilon_post_scf() ) call Epsilon_PostScf
                 exit AtomicConfiguration
              endif
              if(Force_errors_are_tolerable()) then
                 call Postprocessing_during_MD()
                 call Move_Ions
!$$!              call PARA_2Dto3D()     !!!!!!!!!! 3D $B"*(B 2D !!!!!!!!!!
!$$!              call PARA_3Dto2D()     !!!!!!!!!! 3D $B"*(B 2D !!!!!!!!!!
                 call MDIterationNumber_Setting
                 call Ewald_and_Structure_Factor
              end if
              if(BreakMD(force_conv))then
                 exit AtomicConfiguration
              endif
           enddo AtomicConfiguration
           if(driver==DRIVER_SC_DFT) exit StressLoop
           call Stress
           exit StressLoop
        end do StressLoop

!$$!        call PARA_3Dto2D()     !!!!!!!!!! 3D $B"*(B 2D !!!!!!!!!!


#ifdef NEC_ITER_REG
        if(count_for_ftrace .eq. 1) then
           call FTRACE_REGION_END("SOLVE-FIRST")
        else
           call FTRACE_REGION_END("SOLVE-CORE")
        end if
#endif
     end if
     if (InUeffRamping().and. .not.ending_t)then
        call MDiterationNumber_Setting3()
        if(.not.ending_t) call Array_Deallocate()
     else if (driver == DRIVER_SC_DFT.and. .not.ending_t) then
! * T.Hamada 2016.1.8 + T. Yamasaki 2016.02.21
        write(6,'(" driver = DRIVER_SC_DFT")')
        call flush(6)
        call Epsilon_Paramset
        call Epsilon_Postscf
        call setalpha_exx()
! * T.Hamada 2015.1.8
        if(Break_SC_DFT()) exit outer_loop
!!$! * T.Hamada 2015.11.4
        call SCDFTIterationNumber_Setting
        call Set_Icond
        call WriteDownData_onto_Files(.false.)
        if(.not.ending_t) call Array_Deallocate()
     else
!!$#ifdef POST3D
!!$        if(.not.InUeffRamping()) call Postprocessing(.false.)
!!$#endif
        exit outer_loop
     endif

  end if

  enddo outer_loop

  call MDiterationNumber_Setting_pre()
  uconv = UnitCell_Converged(force_conv)
  if(.not.uconv.and..not.ending_t)then
     call MDIterationNumber_Setting2()
     call WriteDownData_onto_Files(.false.)
  else
     if(ChargeDensity_is_Fixed() .and. One_by_one_in_each_rank_k()) then ! icond=2, 3
        !call Postprocessing(.false.)
        !call WriteDownData_onto_Files_ek()
     else
#ifdef POST3D
       if(uconv) call Postprocessing(.false.)
#endif
!!$        if(driver/=DRIVER_SC_DFT) then
!!$!BRANCH_P ORG_Parallel
!!$! * T.Hamada 2016.1.8
!!$           call Epsilon_Paramset
!!$           call Epsilon_Postscf
!!$        end if
!!$! * T.Hamada 2015.1.8
!!$!BRANCH_P_END ORG_Parallel
        if ( uconv .and. epsilon_post_proc() ) call Epsilon_PostScf
        call rttddft_main
        call WriteDownData_onto_Files(ending_t.or.uconv)
        if(uconv) exit
     end if
  endif

#ifdef NEC_ITER_REG
     call FTRACE_REGION_BEGIN("FINAL")
#endif

!$$!        call PARA_2Dto3D()
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,39)
  if(.not.ending_t) then
     call Array_Deallocate()
     call Continuation_Mode()
  endif

  endif

  if (ending_t .or. OneShot()) exit

  enddo

  if(driver/=DRIVER_NEB) call Finalization_of_mpi           ! mpi
#ifdef NEC_ITER_REG
  call FTRACE_REGION_END("FINAL")
#endif
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call print_timer(mype)
#endif
! === TIMERTIMERTIMER ==========================================================
contains

  subroutine ekcal()
    use m_Epsilon_ek, only : sw_epsilon
    use m_Const_Parameters, only : ON
    logical :: AllKpoints_are_Calculated2,AllKpoints_are_Calculated, Already_Converged_for_Kgroup
    logical :: EigenValues_are_Converged, AllKpoints_are_Converged, Already_Converged
    integer :: nk
    logical :: all_conv = .true.
    nk = 0
    if(sw_epsilon == ON) then
      call Initialization_Epsilon(0)        ! Epsilon
      call Shift_Kpoint
    endif
    KPOINT_GROUP: do
       call KpointNumber_Setting2()
       if(AllKpoints_are_Converged()) exit KPOINT_GROUP
       call Preparation_ek()
       call Preparation_for_mpi_ek
       call epsmain_reallocate()
       if(sw_epsilon==ON)then
          call PseudoPotential_ek_Epsilon
       else
          call PseudoPotential_ek
       endif
       call Initial_WaveFunctions_ek
       if(.not.Already_Converged_for_kgroup()) then
          all_conv = .false.
          SolveWaveFunctions: do
             if(Ending_Time())                 exit KPOINT_GROUP
             call IterationNumber_Setting()
             call Renewal_of_WaveFunctions()
             if(EigenValues_are_Converged()) then
                if(sw_epsilon==ON)then
                   call Transition_moment_Epsilon                           ! Epsilon
                   call Dealloc_Radr_and_Wos_Epsilon                        ! Epsilon
                endif
                exit SolveWaveFunctions
             endif
          enddo SolveWaveFunctions
!!$          call Postprocessing_k()
          if(AllKpoints_are_Calculated2(nk)) then
             all_conv = .true.
             exit KPOINT_GROUP
          endif
       else
          exit KPOINT_GROUP
       end if
    enddo KPOINT_GROUP
    call Postprocessing(.false.)
    if(all_conv.and.sw_epsilon==ON) then
      call Reset_Kpoint                                                   ! Epsilon
      call Prep_for_Calc_Epsilon                                          ! Epsilon
      call Calc_Epsilon                                                   ! Epsilon
      call Calc_Nonlinear_optics                                          ! Epsilon
      call WriteDownData_onto_Files_Eps                                   ! Epsilon
    end if
    call WriteDownData_onto_Files_ek()
  end subroutine ekcal

  logical function ChargeDensity_is_Fixed()
    use m_Control_Parameters, only : icond
    use m_Const_Parameters,   only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION
    if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
       ChargeDensity_is_Fixed = .true.
    else
       ChargeDensity_is_Fixed = .false.
    end if
  end function ChargeDensity_is_Fixed

  logical function One_by_one_in_each_rank_k()
    use m_Control_Parameters, only : fixed_charge_k_parallel
    use m_Const_Parameters,   only : ONE_BY_ONE
    if(fixed_charge_k_parallel == ONE_BY_ONE) then
       One_by_one_in_each_rank_k = .true.
    else
       One_by_one_in_each_rank_k = .false.
    end if
  end function One_by_one_in_each_rank_k

#ifdef PARA3D
!!$  subroutine Para3d_Entry()
!!$    if (allocated(vlhxc_l))    deallocate(vlhxc_l)
!!$    if (allocated(chgq_l))     deallocate(chgq_l)
!!$    if (allocated(chgqo_l))    deallocate(chgqo_l)
!!$    if(istress == ON .or. sw_fine_STM_simulation == ON) then
!!$       if (allocated(chgsoft)) deallocate(chgsoft)
!!$    end if
!!$    if (allocated(vxc_l))      deallocate(vxc_l)
!!$    if (allocated(vxcpc_l))    deallocate(vxcpc_l)
!!$    if (allocated(snl))        deallocate(snl)
!!$    if (allocated(eko_l))      deallocate(eko_l)
!!$    if (allocated(zaj_l))      deallocate(zaj_l)
!!$    if (allocated(fsr_l))      deallocate(fsr_l)
!!$    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
!!$       if (allocated(fsi_l))   deallocate(fsi_l)
!!$    end if
!!$    if (allocated(occup_l))    deallocate(occup_l)
!!$    if (allocated(zfm3_l))     deallocate(zfm3_l)
!!$    if (allocated(gr_l))       deallocate(gr_l)
!!$    if (allocated(psc_l))      deallocate(psc_l)
!!$    if (allocated(qitg_l))     deallocate(qitg_l)
!!$    if (allocated(rhpcg_l))    deallocate(rhpcg_l)
!!$    if(istress==ON) then
!!$       if (allocated(psc_diff_l))      deallocate(psc_diff_l)
!!$       if (allocated(qitg_diff_l))     deallocate(qitg_diff_l)
!!$       if (allocated(rhpcg_diff_l))    deallocate(rhpcg_diff_l)
!!$    endif
!!$    if (allocated(ngpt_l))     deallocate(ngpt_l)
!!$    if (allocated(igfp_l))    deallocate(igfp_l)
!!$  end subroutine Para3d_Entry
!!$
!!$  subroutine PARA_2Dto3D()
!!$    !                timer_fj sta 37
!!$
!!$    allocate(vlhxc_l_3D(ista_kngp_3D:iend_kngp_3D,kimg,nspin));             vlhxc_l_3D = 0.0d0
!!$    do ispin = 1, nspin, (af+1)
!!$       call decomp_vlhxc_l_3D(vlhxc_l,vlhxc_l_3D,ispin)
!!$    end do
!!$    deallocate(vlhxc_l)
!!$
!!$    allocate(chgq_l_3D(ista_kngp_3D:iend_kngp_3D,kimg,nspin));              chgq_l_3D = 0.d0
!!$    do ispin = 1, nspin, (af+1)
!!$       call decomp_vlhxc_l_3D(chgq_l,chgq_l_3D,ispin)
!!$    end do
!!$    deallocate(chgq_l)
!!$
!!$    allocate(chgqo_l_3D(ista_kngp_3D:iend_kngp_3D,kimg,nspin));             chgqo_l_3D = 0.d0
!!$    do ispin = 1, nspin, (af+1)
!!$       call decomp_vlhxc_l_3D(chgqo_l,chgqo_l_3D,ispin)
!!$    end do
!!$    deallocate(chgqo_l)
!!$
!!$    if(istress == ON .or. sw_fine_STM_simulation == ON) then
!!$       allocate(chgsoft_3D(ista_kngp_3D:iend_kngp_3D,kimg,nspin));          chgsoft_3D = 0.0d0
!!$       do ispin = 1, nspin, (af+1)
!!$          call decomp_vlhxc_l_3D(chgsoft,chgsoft_3D,ispin)
!!$       end do
!!$       deallocate(chgsoft)
!!$    end if
!!$
!!$    allocate(vxc_l_3D(ista_kngp_3D:iend_kngp_3D,kimg,nspin));               vxc_l_3D = 0.d0
!!$    do ispin = 1, nspin, (af+1)
!!$       call decomp_vlhxc_l_3D(vxc_l,vxc_l_3D,ispin)
!!$    end do
!!$    deallocate(vxc_l)
!!$
!!$    allocate(vxcpc_l_3D(ista_kngp_3D:iend_kngp_3D,kimg));                   vxcpc_l_3D = 0.d0
!!$    deallocate(vxcpc_l)
!!$
!!$    allocate(snl_l_3D(maxval(np_g1k_3D),nlmtt,ista_snl:iend_snl));          snl_l_3D = 0.d0
!!$    do ispin = 1, nspin, (af+1)
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$              call decomp_snl_l_3D_2(snl,snl_l_3D,ik)
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(snl)
!!$
!!$    allocate(eko_l_3D(np_e_3D,ista_k_3D:iend_k_3D));                        eko_l_3D = 0.d0
!!$    do ispin = 1, nspin, (af+1)
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$              call decomp_eko_l_3D_2(eko_l,eko_l_3D,ik,nrvf_ordr,'sort')
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(eko_l)
!!$
!!$    allocate(zaj_l_3D(maxval(np_g1k_3D),np_e_3D,ista_k_3D:iend_k_3D,kimg)); zaj_l_3D = 0.0d0
!!$    do ispin = 1, nspin, (af+1)
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$              call decomp_zaj_l_3D_ik(zaj_l,zaj_l_3D,ik,nrvf_ordr,"sort")
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(zaj_l)
!!$
!!$    allocate(fsr_l_3D(np_e_3D,np_fs_3D,ista_k_3D:iend_k_3D));               fsr_l_3D = 0.0d0
!!$    do ispin = 1, nspin, (af+1)
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$              call decomp_fsr_l_3D_ik(fsr_l,fsr_l_3D,ik,nrvf_ordr,'sort')
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(fsr_l)
!!$
!!$    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
!!$       allocate(fsi_l_3D(np_e_3D,np_fs_3D,ista_k_3D:iend_k_3D));            fsi_l_3D = 0.d0
!!$       do ispin = 1, nspin, (af+1)
!!$          do ik = ispin, kv3-nspin+ispin, nspin
!!$             if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$                call decomp_fsr_l_3D_ik(fsi_l,fsi_l_3D,ik,nrvf_ordr,'sort')
!!$             end if
!!$          end do
!!$       end do
!!$       deallocate(fsi_l)
!!$    end if
!!$
!!$    allocate(occup_l_3D(np_e_3D,ista_k_3D:iend_k_3D));                      occup_l_3D = 0.d0
!!$    do ispin = 1, nspin, (af+1)
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$              call decomp_occup_l_3D(occup_l,occup_l_3D,ik,nrvf_ordr,'sort')
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(occup_l)
!!$
!!$    allocate(zfm3_l_3D(ista_kngp_3D:iend_kngp_3D,ntyp,kimg));               zfm3_l_3D = 0.d0
!!$    call decomp_zfm3_l_3D(zfm3_l,zfm3_l_3D)
!!$    deallocate(zfm3_l)
!!$
!!$    allocate(gr_l_3D(ista_kngp_3D:iend_kngp_3D));                           gr_l_3D =0.0d0
!!$    call decomp_gr_l_3D(gr_l,gr_l_3D)
!!$    deallocate(gr_l)
!!$
!!$    allocate(psc_l_3D(ista_kngp_3D:iend_kngp_3D,ntyp));                     psc_l_3D =0.0d0
!!$    call decomp_psc_l_3D(psc_l,psc_l_3D)
!!$    deallocate(psc_l)
!!$
!!$    allocate(qitg_l_3D(ista_kngp_3D:iend_kngp_3D,nqitg));                   qitg_l_3D =0.0d0
!!$    call decomp_qitg_l_3D(qitg_l,qitg_l_3D,nqitg)
!!$    deallocate(qitg_l)
!!$
!!$    allocate(rhpcg_l_3D(ista_kngp_3D:iend_kngp_3D,ntpcc));                  rhpcg_l_3D =0.0d0
!!$    call decomp_qitg_l_3D(rhpcg_l,rhpcg_l_3D,ntpcc)
!!$    deallocate(rhpcg_l)
!!$
!!$    if(istress==ON) then
!!$       allocate(psc_diff_l_3D(ista_kngp_3D:iend_kngp_3D,ntyp));              psc_diff_l_3D =0.0d0
!!$       call decomp_psc_l_3D(psc_diff_l,psc_diff_l_3D)
!!$       deallocate(psc_diff_l)
!!$
!!$       allocate(qitg_diff_l_3D(ista_kngp_3D:iend_kngp_3D,nqitg));            qitg_diff_l_3D =0.0d0
!!$       call decomp_qitg_l_3D(qitg_diff_l,qitg_diff_l_3D,nqitg)
!!$       deallocate(qitg_diff_l)
!!$
!!$       allocate(rhpcg_diff_l_3D(ista_kngp_3D:iend_kngp_3D,ntpcc));           rhpcg_diff_l_3D =0.0d0
!!$       call decomp_qitg_l_3D(rhpcg_diff_l,rhpcg_diff_l_3D,ntpcc)
!!$       deallocate(rhpcg_diff_l)
!!$    endif
!!$
!!$    allocate(ngpt_l_3D(ista_kngp_3D:iend_kngp_3D,nopr+af));         ngpt_l_3D =0.0d0
!!$    call decomp_ngpt_l_3D(ngpt_l,ngpt_l_3D,nopr+af)
!!$    deallocate(ngpt_l)
!!$
!!$    allocate(igfp_l_3D(ista_kngp_3D:iend_kngp_3D));                 igfp_l_3D =0.0d0
!!$    call decomp_igfp_l_3D(igfp_l,igfp_l_3D)
!!$    deallocate(igfp_l)
!!$
!!$   if(initial_chg == from_PSEUDOPOTENTIAL_FILE) then
!!$      allocate(rhvg_l_3D(ista_kngp_3D:iend_kngp_3D,ntyp));                     rhvg_l_3D =0.0d0
!!$      call decomp_psc_l_3D(rhvg_l,rhvg_l_3D)
!!$      deallocate(rhvg_l)
!!$   endif
!!$
!!$   if(sw_positron == BULK .or. sw_positron == DEFECT) then
!!$      allocate(rhcg_l_3D(ista_kngp_3D:iend_kngp_3D,ntyp));                     rhcg_l_3D =0.0d0
!!$      allocate(rhceg_l_3D(ista_kngp_3D:iend_kngp_3D,ntyp));                    rhceg_l_3D =0.0d0
!!$      allocate(rhchg_l_3D(ista_kngp_3D:iend_kngp_3D,ntyp));                    rhchg_l_3D =0.0d0
!!$      call decomp_psc_l_3D(rhcg_l,rhcg_l_3D)
!!$      call decomp_psc_l_3D(rhceg_l,rhceg_l_3D)
!!$      call decomp_psc_l_3D(rhchg_l,rhchg_l_3D)
!!$      deallocate(rhcg_l)
!!$      deallocate(rhceg_l)
!!$      deallocate(rhchg_l)
!!$   endif
!!$
!!$   !                    timer_fj end 37
!!$  end subroutine PARA_2Dto3D
!!$
!!$  subroutine PARA_3Dto2D()
!!$    !                   timer_fj sta 38
!!$
!!$    allocate(vlhxc_l(ista_kngp:iend_kngp,kimg,nspin)); vlhxc_l = 0.0d0
!!$    do ispin = 1, nspin, af + 1
!!$       call decomp_vlhxc_l_r_3D(vlhxc_l,vlhxc_l_3D,ispin)
!!$    end do
!!$    deallocate(vlhxc_l_3D)
!!$
!!$    allocate(chgq_l(ista_kngp:iend_kngp,kimg,nspin)); chgq_l = 0.d0
!!$    do ispin = 1, nspin, af + 1
!!$       call decomp_vlhxc_l_r_3D(chgq_l,chgq_l_3D,ispin)
!!$    end do
!!$    deallocate(chgq_l_3D)
!!$
!!$    allocate(chgqo_l(ista_kngp:iend_kngp,kimg,nspin)); chgqo_l = 0.d0
!!$    do ispin = 1, nspin, af + 1
!!$       call decomp_vlhxc_l_r_3D(chgqo_l,chgqo_l_3D,ispin)
!!$    end do
!!$    deallocate(chgqo_l_3D)
!!$
!!$    if(istress == ON .or. sw_fine_STM_simulation == ON) then
!!$       allocate(chgsoft(ista_kngp:iend_kngp,kimg,nspin)) ; chgsoft = 0.0d0
!!$       do ispin = 1, nspin, af + 1
!!$          call decomp_vlhxc_l_r_3D(chgsoft,chgsoft_3D,ispin)
!!$       end do
!!$       deallocate(chgsoft_3D)
!!$    end if
!!$
!!$    allocate(vxc_l(ista_kngp:iend_kngp,kimg,nspin)); vxc_l = 0.d0
!!$    do ispin = 1, nspin, af + 1
!!$       call decomp_vlhxc_l_r_3D(vxc_l,vxc_l_3D,ispin)
!!$    end do
!!$    deallocate(vxc_l_3D)
!!$
!!$    allocate(vxcpc_l(ista_kngp:iend_kngp,kimg)); vxcpc_l = 0.d0
!!$    deallocate(vxcpc_l_3D)
!!$
!!$    allocate(snl(kg1,nlmtt,ista_snl:iend_snl)); snl = 0.d0
!!$    call decomp_snl_l_r_3D(snl_l_3D,snl)
!!$    deallocate(snl_l_3D)
!!$
!!$    allocate(eko_l(np_e,ista_k:iend_k));                   eko_l = 0.d0
!!$    do ispin = 1, nspin, af + 1
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$             call decomp_eko_l_r_3D_2(eko_l,eko_l_3D,ik,neordr,'sort')
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(eko_l_3D)
!!$
!!$    allocate(zaj_l(kg1,np_e,ista_k:iend_k,kimg));          zaj_l = 0.0d0
!!$    do ispin = 1, nspin, af + 1
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$             call decomp_zaj_l_r_3D_ik(zaj_l,zaj_l_3D,ik,neordr,"sort")
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(zaj_l_3D)
!!$
!!$    allocate(fsr_l(np_e,nlmta,ista_k:iend_k));             fsr_l = 0.0d0
!!$    do ispin = 1, nspin, af + 1
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$             call decomp_fsr_l_r_3D_ik(fsr_l,fsr_l_3D,ik,neordr,"sort",0)
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(fsr_l_3D)
!!$
!!$    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
!!$       allocate(fsi_l(np_e,nlmta,ista_k:iend_k));          fsi_l = 0.d0
!!$       do ispin = 1, nspin, af + 1
!!$          do ik = ispin, kv3-nspin+ispin, nspin
!!$             if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$                call decomp_fsr_l_r_3D_ik(fsi_l,fsi_l_3D,ik,neordr,"sort",0)
!!$             end if
!!$          end do
!!$       end do
!!$       deallocate(fsi_l_3D)
!!$    end if
!!$
!!$    allocate(occup_l(np_e,ista_k:iend_k));                 occup_l = 0.d0
!!$    do ispin = 1, nspin, af + 1
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$             iksnl = (ik-1)/nspin + 1
!!$             call decomp_occup_l_r_3D(occup_l,occup_l_3D,ik,neordr,'sort')
!!$          end if
!!$       end do
!!$    end do
!!$    deallocate(occup_l_3D)
!!$
!!$    allocate(zfm3_l(ista_kngp:iend_kngp,ntyp,kimg));       zfm3_l = 0.d0
!!$    call decomp_zfm3_l_r_3D(zfm3_l,zfm3_l_3D)
!!$    deallocate(zfm3_l_3D)
!!$
!!$    allocate(gr_l(ista_kngp:iend_kngp));                   gr_l =0.0d0
!!$    call decomp_gr_l_r_3D(gr_l,gr_l_3D)
!!$    deallocate(gr_l_3D)
!!$
!!$    allocate(psc_l(ista_kngp:iend_kngp,ntyp));             psc_l =0.0d0
!!$    call decomp_psc_l_r_3D(psc_l,psc_l_3D)
!!$    deallocate(psc_l_3D)
!!$
!!$    allocate(qitg_l(ista_kngp:iend_kngp,nqitg));           qitg_l =0.0d0
!!$    call decomp_qitg_l_r_3D(qitg_l,qitg_l_3D,nqitg)
!!$    deallocate(qitg_l_3D)
!!$
!!$    allocate(rhpcg_l(ista_kngp:iend_kngp,ntpcc));          rhpcg_l =0.0d0
!!$    call decomp_qitg_l_r_3D(rhpcg_l,rhpcg_l_3D,ntpcc)
!!$    deallocate(rhpcg_l_3D)
!!$
!!$    if(istress==ON) then
!!$       allocate(psc_diff_l(ista_kngp:iend_kngp,ntyp));             psc_diff_l =0.0d0
!!$       call decomp_psc_l_r_3D(psc_diff_l,psc_diff_l_3D)
!!$       deallocate(psc_diff_l_3D)
!!$
!!$       allocate(qitg_diff_l(ista_kngp:iend_kngp,nqitg));           qitg_diff_l =0.0d0
!!$       call decomp_qitg_l_r_3D(qitg_diff_l,qitg_diff_l_3D,nqitg)
!!$       deallocate(qitg_diff_l_3D)
!!$
!!$       allocate(rhpcg_diff_l(ista_kngp:iend_kngp,ntpcc));          rhpcg_diff_l =0.0d0
!!$       call decomp_qitg_l_r_3D(rhpcg_diff_l,rhpcg_diff_l_3D,ntpcc)
!!$       deallocate(rhpcg_diff_l_3D)
!!$    endif
!!$
!!$    allocate(ngpt_l(ista_kngp:iend_kngp,nopr+af));         ngpt_l =0.0d0
!!$    call decomp_ngpt_l_r_3D(ngpt_l,ngpt_l_3D,nopr+af)
!!$    deallocate(ngpt_l_3D)
!!$
!!$    allocate(igfp_l(ista_kngp:iend_kngp));                 igfp_l =0.0d0
!!$    call decomp_igfp_l_r_3D(igfp_l,igfp_l_3D)
!!$    deallocate(igfp_l_3D)
!!$
!!$   if(initial_chg == from_PSEUDOPOTENTIAL_FILE) then
!!$      allocate(rhvg_l(ista_kngp:iend_kngp,ntyp));                     rhvg_l =0.0d0
!!$      call decomp_psc_l_r_3D(rhvg_l,rhvg_l_3D)
!!$      deallocate(rhvg_l_3D)
!!$   endif
!!$
!!$   if(sw_positron == BULK .or. sw_positron == DEFECT) then
!!$      allocate(rhcg_l(ista_kngp:iend_kngp,ntyp));                     rhcg_l =0.0d0
!!$      allocate(rhceg_l(ista_kngp:iend_kngp,ntyp));                    rhceg_l =0.0d0
!!$      allocate(rhchg_l(ista_kngp:iend_kngp,ntyp));                    rhchg_l =0.0d0
!!$      call decomp_psc_l_r_3D(rhcg_l,rhcg_l_3D)
!!$      call decomp_psc_l_r_3D(rhceg_l,rhceg_l_3D)
!!$      call decomp_psc_l_r_3D(rhchg_l,rhchg_l_3D)
!!$      deallocate(rhcg_l_3D)
!!$      deallocate(rhceg_l_3D)
!!$      deallocate(rhchg_l_3D)
!!$   endif
!!$
!!$   !                timer_fj end 38
!!$  end subroutine PARA_3Dto2D
!!$
!!$  subroutine output_zaj()
!!$   integer::ispin, ik
!!$
!!$    if (.not. allocated(zaj_l)) then
!!$       allocate(zaj_l(kg1,np_e,ista_k:iend_k,kimg))
!!$    end if
!!$    zaj_l = 0.0d0
!!$
!!$    do ispin = 1, nspin, af + 1
!!$       do ik = ispin, kv3-nspin+ispin, nspin
!!$          if(map_k_3D(ik) == myrank_k_3D) then           ! MPI
!!$             call decomp_zaj_l_r_3D_ik(zaj_l,zaj_l_3D,ik,neordr,"sort")
!!$          end if
!!$       end do
!!$    end do
!!$
!!$    call dump_zaj(zaj_l)
!!$
!!$    deallocate(zaj_l)
!!$
!!$  endsubroutine output_zaj
#endif

  subroutine Continuation_Mode()
    use m_Const_Parameters,   only : COORDINATE_CONTINUATION,ON,OFF
    use m_Control_Parameters, only : icond, sw_optimize_lattice,sw_rebuild_pws
    implicit none
    logical :: unitcell_can_change
    if(unitcell_can_change() .and. sw_rebuild_pws==OFF) return
    icond = COORDINATE_CONTINUATION
  end subroutine continuation_mode

  logical function BreakMD(conv)
    use m_IterationNumbers, only : iteration_ionic
    use m_Ionic_System, only : addition_frequency,m_IS_natm_can_change
    implicit none
    logical, intent(in) :: conv
    if(.not.m_IS_natm_can_change())then
       BreakMD = conv
       return
    endif
    BreakMD = mod(iteration_ionic,addition_frequency)==0
  end function BreakMD

  logical function Break_SC_DFT()
    use m_IterationNumbers, only : iteration, first_iteration_of_this_job, iteration_scdft
    use m_Control_Parameters, only : delta_epsilon, max_scdft_iteration, epsilon0, epsilon0_previous
    if(iteration-first_iteration_of_this_job <= 0 .or. iteration_scdft<=1) then
       Break_SC_DFT = .false.
    else
       if(dabs(epsilon0 - epsilon0_previous) < max(0.0, delta_epsilon)) then
          Break_SC_DFT = .true.
       else
          if(iteration_scdft > max_scdft_iteration) then
             Break_SC_DFT = .true.
          else
             Break_SC_DFT = .false.
          end if
       end if
    end if
    write(6,'(" Break_SC_DFT = ",L3)') Break_SC_DFT
    call flush(6)
  end function Break_SC_DFT

  logical function Initial_SCDFTLoop()
    use m_IterationNumbers, only : iteration_scdft, iteration_scdft_initial
    Initial_SCDFTLoop = .true.
    if(Iteration_scdft > Iteration_scdft_initial) Initial_SCDFTLoop = .false.
!!$    if(mype==0) then
       write(6,*) ' ! Iteration_scdft, iteration_scdft_initial = ', iteration_scdft,iteration_scdft_initial
       write(6,*) ' I Initial_SCDFTLoop = ',Initial_SCDFTLoop
       call flush(6)
!!$    end if
  end function Initial_SCDFTLoop

  subroutine setalpha_exx()
    use m_Control_Parameters, only : m_CtrlP_set_alpha_exx, epsilon0
    use m_Files,              only : nfout
    use m_Const_Parameters,   only : DP
    real(kind=DP) :: alpha
    alpha = 1.d0/epsilon0
    call m_CtrlP_set_alpha_exx(nfout,alpha)
  end subroutine setalpha_exx

  logical function OneShot()
    use m_Ionic_System, only : m_IS_natm_can_change
    use m_Control_Parameters, only : sw_optimize_lattice
    use m_Const_Parameters, only : OFF
    implicit none
    logical :: unitcell_can_change
    OneShot = .not.m_IS_natm_can_change()
    if(OneShot) then
        OneShot = .not.unitcell_can_change()
    endif
  end function OneShot

! === KT_add ==== 13.1R
  logical function epsilon_post_scf()
    use m_Const_Parameters,   only : ON, OFF
    use m_Epsilon_ek,  only : sw_epsilon, m_Eps_chkif_sw_epsilon
    use m_Control_Parameters, only : sw_phonon, sw_phonon_with_epsilon, &
         &                           sw_calc_dielectric_tensor, sw_excitation

    implicit none
    logical, save :: First = .true.

    epsilon_post_scf = .false.

    if ( First ) then
       call m_Eps_chkif_sw_epsilon;        First = .false.
    endif
    if ( sw_epsilon == OFF .and. sw_excitation == OFF ) return

    if ( sw_phonon == ON ) then
       if ( sw_phonon_with_epsilon == ON .and. sw_calc_dielectric_tensor == ON ) then
          epsilon_post_scf = .true.
       endif
    else
!       epsilon_post_scf = .true.
       epsilon_post_scf = .false.
    endif

  end function epsilon_post_scf

  logical function epsilon_post_proc()
    use m_Const_Parameters,   only : ON, OFF
    use m_Epsilon_ek,  only : sw_epsilon, m_Eps_chkif_sw_epsilon
    use m_Control_Parameters, only : sw_phonon, sw_phonon_with_epsilon, &
         &                           sw_calc_dielectric_tensor, sw_excitation

    implicit none
    logical, save :: First = .true.

    epsilon_post_proc = .false.

    if ( First ) then
       call m_Eps_chkif_sw_epsilon;        First = .false.
    endif
    if ( sw_epsilon == OFF .and. sw_excitation == OFF ) return

    if ( sw_phonon == ON ) then
       epsilon_post_proc = .false.
    else
       epsilon_post_proc = .true.
    endif

  end function epsilon_post_proc
! =============== 13.1R

  integer function Resolve_Driver()
    use m_Control_Parameters, only : driver
    Resolve_Driver = driver
  end function Resolve_Driver

  logical function ekmode()
    use m_Control_Parameters, only : icond,fixed_charge_k_parallel
    use m_Const_Parameters, only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION,ONE_BY_ONE
    implicit none
    ekmode = .false.
    if((icond==FIXED_CHARGE.or.icond==FIXED_CHARGE_CONTINUATION) .and. &
    &  fixed_charge_k_parallel .eq. ONE_BY_ONE) then
       ekmode = .true.
    endif
  end function ekmode

  logical function Resolve_Config_Parallel()
    use m_Parallelization, only : m_Parallel_resolve_conf_para
    implicit none
    Resolve_Config_Parallel = m_Parallel_resolve_conf_para()
  end function Resolve_Config_Parallel

  subroutine Postprocessing_during_MD()
    use m_IterationNumbers, only : iteration_ionic
    use m_Control_Parameters, only : postproc_frequency
    if(postproc_frequency<=0) return
    if(mod(iteration_ionic,postproc_frequency)==0)then
       call Postprocessing(.true.)
    endif
  end subroutine Postprocessing_during_MD

   subroutine Set_Icond
     use m_Const_Parameters,   only : INITIAL
     use m_Control_Parameters, only : m_CtrlP_set_icond
     call m_CtrlP_set_icond(INITIAL)
   end subroutine Set_Icond

end program PHASE

  subroutine Array_Deallocate()
     use m_Const_Parameters, only : OFF, ON, DRIVER_URAMP, DRIVER_SC_DFT, DRIVER_NEB
     use m_Control_Parameters, only : m_CtrlP_dealloc,sw_rebuild_pws,m_CtrlP_set_init_status
     use m_Crystal_Structure, only : m_CS_dealloc
     use m_Ionic_System, only : m_IS_dealloc
     use m_PlaneWaveBasisSet, only : m_pwBS_dealloc
     use m_Parallelization, only : m_Parallel_dealloc,m_Parallel_dealloc_mpi_nlmta,m_Parallel_dealloc_mpi_elec &
    &                            , m_Parallel_dealloc_mpi_nval,m_Parallel_dealloc_mpi_fft_box &
    &                            , m_Parallel_dealloc_mpi_kngp_B,m_Parallel_fft_onto_wf_dealloc_3D &
    &                            , m_Parallel_dealloc_mpi_paw_3D, m_Parallel_dealloc_mpi_exx
     use m_Kpoints, only : m_Kp_dealloc, kv3
     use m_Force, only : m_Force_dealloc
     use m_Charge_Density, only : m_CD_dealloc
     use m_XC_Potential, only : m_XC_dealloc_vxc_3D
     use m_PseudoPotential, only : m_PP_dealloc, flg_paw
     use m_NonLocal_Potential, only : m_NLP_dealloc
     use m_Electronic_Structure, only : m_ES_dealloc
     use m_ES_WF_by_SDorCG, only : m_ESsd_dealloc
     use m_PAW_ChargeDensity, only : m_PAW_dealloc
     use m_PAW_XC_Potential, only : m_PAW_XC_dealloc_vxc
     use m_ES_wf_extrpl, only : m_ES_wf_extrpl_dealloc

! ===== KT_add ============== 13.0AS
     use m_Control_Parameters,  only : num_projectors, sw_hubbard
     use m_Orbital_Population,only: m_OP_dealloc
     use m_Electronic_Structure,  only : m_ES_dealloc_Dhub
! ============================13.0AS

! ======== KT_add ============= 2013/10/31
     use m_Control_Parameters, only: noncol, SpinOrbit_Mode, driver
     use m_Const_Parameters,   only: Neglected, BuiltIn, ByPawPot, ZeffApprox, &
          &                          ByProjector, ReadFromPP
     use m_SpinOrbit_Potential,only: m_SO_dealloc_Dsoc, m_SO_dealloc_Mat_SOC_Strenth
! ============================= 2013/10/31

! ========= KT_add ========= 13.0U2
  use m_Control_Parameters,   only : sw_modified_TFW_functional
  use m_ThomasFermiW_Potential,  only : m_TFW_dealloc_ChgDensityBasisFn
! ========================== 13.0U2

! ====== KT_add === 2014/08/01
  use m_Orbital_QuantumNum, only : m_OP_Qnum_dealloc_array
! ================= 2014/08/01

  use m_Ldos, only : m_Ldos_dealloc

#ifdef FFTW3
  use m_FFT, only : m_FFT_finalize
#endif
  use m_Parallelization, only : m_Parallel_cp_g1k

     implicit none

     if (sw_rebuild_pws==OFF .or. driver == DRIVER_URAMP .or. driver == DRIVER_SC_DFT ) then
        call m_PP_dealloc()
        call m_NLP_dealloc()
        call m_Parallel_dealloc_mpi_nlmta()
        call m_Parallel_dealloc_mpi_exx()
        call m_Kp_dealloc
        call m_Parallel_dealloc_mpi_paw_3D()
!        call m_ES_dealloc
!        call m_ESsd_dealloc
        return
     endif

     call m_CtrlP_dealloc
     call m_ES_dealloc
     call m_pwBS_dealloc
     call m_Parallel_cp_g1k(kv3)
     call m_Parallel_dealloc
     call m_Parallel_dealloc_mpi_elec
     call m_Parallel_dealloc_mpi_fft_box
     call m_Parallel_dealloc_mpi_nval
     call m_Parallel_fft_onto_wf_dealloc_3D
     call m_Parallel_dealloc_mpi_kngp_B
     call m_CS_dealloc
     call m_IS_dealloc
  !call m_Parallel_dealloc_mpi_elec
     call m_Kp_dealloc
     call m_PP_dealloc
     call m_CD_dealloc
     call m_Force_dealloc
     call m_NLP_dealloc
     call m_ESsd_dealloc
     call m_XC_dealloc_vxc_3D
     call m_PAW_dealloc
     if(flg_paw) then
         call m_PAW_XC_dealloc_vxc
     endif

! ==== KT_add ============== 2013/10/31
     if ( noncol ) then
        if ( SpinOrbit_Mode == ByPawPot .or. SpinOrbit_Mode == ZeffApprox &
             &                          .or. SpinOrbit_Mode == ReadFromPP ) then
           call m_SO_dealloc_Mat_SOC_strenth
           call m_SO_dealloc_Dsoc
        endif
        if ( SpinOrbit_Mode == ByProjector ) then
           call m_SO_dealloc_Dsoc
        endif
     endif
! ====================== 2013/10/31

! ====== KT_add ======== 13.0U2
     if ( sw_modified_TFW_functional /= OFF ) then
        call m_TFW_dealloc_ChgDensityBasisFn
     end if
! ====================== 13.0U2

! ====== KT_add =========== 13.0AS
     if (num_projectors>0)  call m_OP_dealloc
     if (sw_hubbard == ON) call m_ES_dealloc_Dhub
! ========================= 13.0AS

! ==== KT_add ==== 2014/08/01
     call m_OP_Qnum_dealloc_array
! ================ 2014/08/01

     call m_ES_wf_extrpl_dealloc()
     call m_Ldos_dealloc()
     call m_ES_wf_extrpl_dealloc()
#ifdef FFTW3
     call m_FFT_finalize()
#endif
     call m_CtrlP_set_init_status(.true.)
   end subroutine Array_Deallocate
